import typing

class VarParameter:
    """
    Helper class to provide passing method parameter "by address".
    """
    def __init__(self) -> None:
        pass

    @property
    def Value(self) -> Any:
        """
        Value of the passed parameter.
        """
        pass

    @Value.setter
    def Value(self, _value: Any) -> None:
        """
        Value of the passed parameter.
        """
        pass


class TGIS_3DPathType:
    pass

class TGIS_3DPathType:
    """
    Interpolation method for a 3D path.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DPathType
    """

    @property
    def Linear(
      self
    ) -> TGIS_3DPathType: 
        """
        Linear interpolation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DPathType.Linear
        """
        pass

    @property
    def CubicSplines(
      self
    ) -> TGIS_3DPathType: 
        """
        Cubic splines interpolation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DPathType.CubicSplines
        """
        pass

class TGIS_3DFlyOver( TObject ):
    """
    Implementation of the "fly over" functionality for 3D view.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.Create_void
        """
        pass

    def AddCamera(
      self,
      _cam: TGIS_3DCamera
    ) -> None: 
        """
        Adds a camera to the animation path.

        Args:
            _cam: camera to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.AddCamera_TGIS_3DCamera
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Removes all the cameras.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.Clear_void
        """
        pass

    def DeleteCamera(
      self,
      _idx: int
    ) -> None: 
        """
        Deletes camera at a given index.

        Args:
            _idx: index of the camera

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.DeleteCamera_Integer
        """
        pass

    def GrabCamera(
      self
    ) -> None: 
        """
        Records the current view/camera of the attached 3D viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.GrabCamera_void
        """
        pass

    def LoadFromFile(
      self,
      _path: str
    ) -> None: 
        """
        Loads the settings and cameras from an XML file.

        Args:
            _path: path to the file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.LoadFromFile_String
        """
        pass

    def LoadFromLayer(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Loads the cameras from a vector layer.

        Args:
            _layer: source layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.LoadFromLayer_TGIS_LayerVector
        """
        pass

    def MoveCamera(
      self,
      _from: int,
      _to: int
    ) -> None: 
        """
        Moves a camera in the order.

        Args:
            _from: current index of the camera
            _to: destination index of the camera

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.MoveCamera_Integer_Integer
        """
        pass

    def MoveCameraDown(
      self,
      _idx: int
    ) -> None: 
        """
        Moves a camera one position down in the order.

        Args:
            _idx: index of the camera

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.MoveCameraDown_Integer
        """
        pass

    def MoveCameraUp(
      self,
      _idx: int
    ) -> None: 
        """
        Moves a camera one position up in the order.

        Args:
            _idx: index of the camera

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.MoveCameraUp_Integer
        """
        pass

    def MoveToCamera(
      self,
      _idx: int
    ) -> None: 
        """
        Sets the view to the specified camera.

        Args:
            _idx: index of the camera

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.MoveToCamera_Integer
        """
        pass

    def MoveToStart(
      self
    ) -> None: 
        """
        Sets the view to the first camera (the camera from which the animation path starts).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.MoveToStart_void
        """
        pass

    def Pause(
      self
    ) -> None: 
        """
        Pauses the animation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.Pause_void
        """
        pass

    def PreparePath(
      self
    ) -> None: 
        """
        Prepares the animation path using the current active cameras.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.PreparePath_void
        """
        pass

    def Reset(
      self
    ) -> None: 
        """
        Resets the animation (must be paused).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.Reset_void
        """
        pass

    def Restart(
      self
    ) -> None: 
        """
        Restarts the animation (must be paused).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.Restart_void
        """
        pass

    def SaveToFile(
      self,
      _path: str
    ) -> None: 
        """
        Saves the settings and cameras to an XML file.

        Args:
            _path: path to the file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.SaveToFile_String
        """
        pass

    def SaveToLayer(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Saves the cameras to a vector layer.

        Args:
            _layer: destination layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.SaveToLayer_TGIS_LayerVector
        """
        pass

    def Start(
      self
    ) -> None: 
        """
        Starts the animation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.Start_void
        """
        pass

    def Stop(
      self
    ) -> None: 
        """
        Stops the animation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.Stop_void
        """
        pass

    @property
    def AutoSpeed(
      self
    ) -> bool: 
        """
        Animation speed; 1.0 is default, set to less than 1.0 to slow down and greater than 
        1.0 to speed up.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.AutoSpeed
        """
        pass

    @AutoSpeed.setter
    def AutoSpeed(
      self,
      _value: bool
    ) -> None: 
        """
        Animation speed; 1.0 is default, set to less than 1.0 to slow down and greater than 
        1.0 to speed up.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.AutoSpeed
        """
        pass

    
    def Camera(
      self,
      _idx: int
    ) -> TGIS_3DCamera: 
        """
        Access to the Active property of a camera.

        Args:
            _idx: index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.Camera
        """
        pass

    
    def CameraActive(
      self,
      _idx: int
    ) -> bool: 
        """
        Access to the Active property of a camera.

        Args:
            _idx: index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.CameraActive
        """
        pass

    
    def CameraActive(
      self,
      _idx: int,
      _value: bool
    ) -> None: 
        """
        Access to the Active property of a camera.

        Args:
            _idx: index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.CameraActive
        """
        pass

    
    def CameraName(
      self,
      _idx: int
    ) -> str: 
        """
        Access to the Name property of a camera.

        Args:
            _idx: index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.CameraName
        """
        pass

    
    def CameraName(
      self,
      _idx: int,
      _value: str
    ) -> None: 
        """
        Access to the Name property of a camera.

        Args:
            _idx: index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.CameraName
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Camera count.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.Count
        """
        pass

    @property
    def FPS(
      self
    ) -> int: 
        """
        Target FPS (frames per second).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.FPS
        """
        pass

    @FPS.setter
    def FPS(
      self,
      _value: int
    ) -> None: 
        """
        Target FPS (frames per second).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.FPS
        """
        pass

    @property
    def Looped(
      self
    ) -> bool: 
        """
        True if the animation should loop.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.Looped
        """
        pass

    @Looped.setter
    def Looped(
      self,
      _value: bool
    ) -> None: 
        """
        True if the animation should loop.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.Looped
        """
        pass

    @property
    def PathType(
      self
    ) -> TGIS_3DPathType: 
        """
        Interpolation method used to prepare the animation path.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.PathType
        """
        pass

    @PathType.setter
    def PathType(
      self,
      _value: TGIS_3DPathType
    ) -> None: 
        """
        Interpolation method used to prepare the animation path.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.PathType
        """
        pass

    @property
    def Running(
      self
    ) -> bool: 
        """
        True if the animation is running.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.Running
        """
        pass

    @property
    def SpeedFactor(
      self
    ) -> float: 
        """
        Animation speed; 1.0 is default, set to less than 1.0 to slow down and greater than 
        1.0 to speed up.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.SpeedFactor
        """
        pass

    @SpeedFactor.setter
    def SpeedFactor(
      self,
      _value: float
    ) -> None: 
        """
        Animation speed; 1.0 is default, set to less than 1.0 to slow down and greater than 
        1.0 to speed up.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.SpeedFactor
        """
        pass

    @property
    def TimeSpan(
      self
    ) -> float: 
        """
        Timespan of the animation (in seconds).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.TimeSpan
        """
        pass

    @TimeSpan.setter
    def TimeSpan(
      self,
      _value: float
    ) -> None: 
        """
        Timespan of the animation (in seconds).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.TimeSpan
        """
        pass

    @property
    def Viewer(
      self
    ) -> IGIS_Viewer: 
        """
        Attached 3D viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.Viewer
        """
        pass

    @Viewer.setter
    def Viewer(
      self,
      _value: IGIS_Viewer
    ) -> None: 
        """
        Attached 3D viewer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.Viewer
        """
        pass

    @property
    def ViewerWnd(
      self
    ) -> IGIS_ViewerWnd: 
        """
        Attached 3D viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.ViewerWnd
        """
        pass

    @ViewerWnd.setter
    def ViewerWnd(
      self,
      _value: IGIS_ViewerWnd
    ) -> None: 
        """
        Attached 3D viewer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.ViewerWnd
        """
        pass

    @property
    def FinishedEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.FinishedEvent
        """
        pass

    @FinishedEvent.setter
    def FinishedEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DFlyOver.FinishedEvent
        """
        pass

class TGIS_AddressMatching( TObject ):
    """
    Class supports address matching according to defined formulas.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AddressMatching
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructs instance, initializes internal data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AddressMatching.Create_void
        """
        pass

    def Match(
      self,
      _str: str,
      _results: VarParameter
    ) -> int: 
        """
        Matches given address string and address formulas.

        Args:
            _str: address string
            _results: list containing all found matches; every string is a single match in form 
              of ''fieldld1=value1#13#10field2=value2#13#10...''; if the reference equals nil, 
              the object will be created ; the value (in/out) is passed as TGIS_ObjectList in _results.Value 
              property

        Returns:
            Number of found matches (or 0 if nothing).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AddressMatching.Match_String_TGIS_ObjectList
        """
        pass

    @property
    def FormulasString(
      self
    ) -> str: 
        """
        Field for formulas string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AddressMatching.FormulasString
        """
        pass

    @FormulasString.setter
    def FormulasString(
      self,
      _value: str
    ) -> None: 
        """
        Field for formulas string.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AddressMatching.FormulasString
        """
        pass

class TGIS_AggregatorAbstract( TGIS_DynamicAggregatorAbstract ):
    """
    Extension of base class TGIS_DynamicAggregatorAbstract for TGIS_LayerVector.DynamicAggregator 
    implementation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorAbstract
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a processor instance.

        Args:
            _layer: layer on which processor is constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorAbstract.Create_TGIS_LayerVector
        """
        pass

class TGIS_AggregatorClusteringAbstract( TGIS_AggregatorAbstract ):
    """
    Base class for dynamic clustering.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorClusteringAbstract
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a processor instance.

        Args:
            _layer: layer on which processor is constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorClusteringAbstract.Create_TGIS_LayerVector
        """
        pass

class TGIS_AggregatorClusteringMovingAverage( TGIS_AggregatorClusteringAbstract ):
    """
    This class implements the clustering method using a moving average technique. This 
    smart method creates clusters in non-grid positions.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorClusteringMovingAverage
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a processor instance.

        Args:
            _layer: layer on which processor is constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorClusteringMovingAverage.Create_TGIS_LayerVector
        """
        pass

class TGIS_AggregatorClusteringHexagonalGridAbstract( TGIS_AggregatorClusteringAbstract ):
    """
    Base class for dynamic clustering using hexagonal grid.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorClusteringHexagonalGridAbstract
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a processor instance.

        Args:
            _layer: layer on which processor is constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorClusteringHexagonalGridAbstract.Create_TGIS_LayerVector
        """
        pass

class TGIS_AggregatorClusteringHexagonalGridFlat( TGIS_AggregatorClusteringHexagonalGridAbstract ):
    """
    This class implements the clustering method using a flat-topped hexagonal grid.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorClusteringHexagonalGridFlat
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a processor instance.

        Args:
            _layer: layer on which processor is constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorClusteringHexagonalGridFlat.Create_TGIS_LayerVector
        """
        pass

class TGIS_AggregatorClusteringHexagonalGridPointy( TGIS_AggregatorClusteringHexagonalGridAbstract ):
    """
    This class implements the clustering method using a pointy-topped hexagonal grid.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorClusteringHexagonalGridPointy
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a processor instance.

        Args:
            _layer: layer on which processor is constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorClusteringHexagonalGridPointy.Create_TGIS_LayerVector
        """
        pass

class TGIS_AggregatorClusteringSquareGrid( TGIS_AggregatorClusteringAbstract ):
    """
    This class implements the clustering method using a square grid.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorClusteringSquareGrid
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a processor instance.

        Args:
            _layer: layer on which processor is constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorClusteringSquareGrid.Create_TGIS_LayerVector
        """
        pass

class TGIS_AggregatorShapeReduction( TGIS_AggregatorClusteringAbstract ):
    """
    This class implements the aggregation method based on shape reduction. This method 
    is designed to work with dense point data.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorShapeReduction
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a processor instance.

        Args:
            _layer: layer on which processor is constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorShapeReduction.Create_TGIS_LayerVector
        """
        pass

class TGIS_AggregatorBinningAbstract( TGIS_AggregatorAbstract ):
    """
    Base class for dynamic binning.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorBinningAbstract
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a processor instance.

        Args:
            _layer: layer on which processor is constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorBinningAbstract.Create_TGIS_LayerVector
        """
        pass

class TGIS_AggregatorBinningSquare( TGIS_AggregatorBinningAbstract ):
    """
    This class implements the binning method using a square grid.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorBinningSquare
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a processor instance.

        Args:
            _layer: layer on which processor is constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorBinningSquare.Create_TGIS_LayerVector
        """
        pass

class TGIS_AggregatorBinningHexagonAbstract( TGIS_AggregatorBinningAbstract ):
    """
    Base class for dynamic binning using hexagonal grid.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorBinningHexagonAbstract
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a processor instance.

        Args:
            _layer: layer on which processor is constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorBinningHexagonAbstract.Create_TGIS_LayerVector
        """
        pass

class TGIS_AggregatorBinningHexagonFlat( TGIS_AggregatorBinningHexagonAbstract ):
    """
    This class implements the binning method using a flat-topped hexagonal grid.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorBinningHexagonFlat
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a processor instance.

        Args:
            _layer: layer on which processor is constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorBinningHexagonFlat.Create_TGIS_LayerVector
        """
        pass

class TGIS_AggregatorBinningHexagonPointy( TGIS_AggregatorBinningHexagonAbstract ):
    """
    This class implements the binning method using a pointy-topped hexagonal grid.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorBinningHexagonPointy
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a processor instance.

        Args:
            _layer: layer on which processor is constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorBinningHexagonPointy.Create_TGIS_LayerVector
        """
        pass

class TGIS_AggregatorNames:
    """
    Represents a collection of dynamic aggregator names. This class provides a list of 
    names to be used with TGIS_DynamicAggregatorFactory.CreateInstance method.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorNames
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorNames.Create_void
        """
        pass

    @property
    def BinningHexagonFlat(
      self
    ) -> str: 
        """
        Hexagonal binning method with flat-top hexagons. Groups data points into hexagonal 
        bins with flat sides at the top and bottom.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorNames.BinningHexagonFlat
        """
        pass

    @property
    def BinningHexagonPointy(
      self
    ) -> str: 
        """
        Hexagonal binning method with pointy-top hexagons. Groups data points into hexagonal 
        bins with a vertex pointing upward.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorNames.BinningHexagonPointy
        """
        pass

    @property
    def BinningSquare(
      self
    ) -> str: 
        """
        Square binning method Aggregates data points into a uniform grid of square bins.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorNames.BinningSquare
        """
        pass

    @property
    def ClusteringHexagonalGridFlat(
      self
    ) -> str: 
        """
        Clustering using a flat-top hexagonal grid. Applies clustering within a structured 
        grid of hexagons oriented with flat sides at the top and bottom.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorNames.ClusteringHexagonalGridFlat
        """
        pass

    @property
    def ClusteringHexagonalGridPointy(
      self
    ) -> str: 
        """
        Clustering using a pointy-top hexagonal grid. Applies clustering within a structured 
        grid of hexagons oriented with a vertex pointing upward.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorNames.ClusteringHexagonalGridPointy
        """
        pass

    @property
    def ClusteringMovingAverage(
      self
    ) -> str: 
        """
        Moving average clustering method. Uses a moving average approach to group nearby 
        data points dynamically.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorNames.ClusteringMovingAverage
        """
        pass

    @property
    def ClusteringSquareGrid(
      self
    ) -> str: 
        """
        Clustering using a square grid. Clusters data points within a structured grid of 
        square cells.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorNames.ClusteringSquareGrid
        """
        pass

    @property
    def ShapeReduction(
      self
    ) -> str: 
        """
        Dynamic point reduction method Dynamically reduces the number of displayed points 
        on the map while preserving the overall spatial distribution and visual clarity.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AggregatorNames.ShapeReduction
        """
        pass

class TGIS_EditorSnapType:
    pass

class TGIS_EditorSnapType:
    """
    Editor snap type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorSnapType
    """

    @property
    def Point(
      self
    ) -> TGIS_EditorSnapType: 
        """
        Snap to the position of the nearest vertex within the set distance tolerance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorSnapType.Point
        """
        pass

    @property
    def Line(
      self
    ) -> TGIS_EditorSnapType: 
        """
        Snap to a line segment or polygon edge (closest position).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorSnapType.Line
        """
        pass

    @property
    def Custom(
      self
    ) -> TGIS_EditorSnapType: 
        """
        Custom snap to user defined point from event.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorSnapType.Custom
        """
        pass

    @property
    def PointOverLine(
      self
    ) -> TGIS_EditorSnapType: 
        """
        Prefer snap to a vertex over the nearest shape intersection, a line segment or polygon 
        edge.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorSnapType.PointOverLine
        """
        pass

    @property
    def EndPoint(
      self
    ) -> TGIS_EditorSnapType: 
        """
        Snap to the first or last vertex of a line or polygon shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorSnapType.EndPoint
        """
        pass

    @property
    def Midpoint(
      self
    ) -> TGIS_EditorSnapType: 
        """
        Snap to a line or polygon edge at the midpoint position between any two sequential 
        vertices forming the line or edge.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorSnapType.Midpoint
        """
        pass

    @property
    def Perpendicular(
      self
    ) -> TGIS_EditorSnapType: 
        """
        Snap to the point on a nearby line segment or polygon edge that results in a perpendicular 
        (90 degree) line drawn from the previously drawn point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorSnapType.Perpendicular
        """
        pass

    @property
    def GridPoint(
      self
    ) -> TGIS_EditorSnapType: 
        """
        Snap to grid points defined by grid spacing.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorSnapType.GridPoint
        """
        pass

class TGIS_EditorSnapResultType:
    pass

class TGIS_EditorSnapResultType:
    """
    Editor snap result type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorSnapResultType
    """

    @property
    def Vertex(
      self
    ) -> TGIS_EditorSnapResultType: 
        """
        Snap to vertex.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorSnapResultType.Vertex
        """
        pass

    @property
    def Edge(
      self
    ) -> TGIS_EditorSnapResultType: 
        """
        Snap to edge or segment.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorSnapResultType.Edge
        """
        pass

    @property
    def Intersection(
      self
    ) -> TGIS_EditorSnapResultType: 
        """
        Snap to intersection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorSnapResultType.Intersection
        """
        pass

    @property
    def Midpoint(
      self
    ) -> TGIS_EditorSnapResultType: 
        """
        Snap to midpoint.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorSnapResultType.Midpoint
        """
        pass

class TGIS_EditorOperation:
    pass

class TGIS_EditorOperation:
    """
    Editor operations.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorOperation
    """

    @property
    def Locate(
      self
    ) -> TGIS_EditorOperation: 
        """
        Active point changed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorOperation.Locate
        """
        pass

    @property
    def Add(
      self
    ) -> TGIS_EditorOperation: 
        """
        Add new point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorOperation.Add
        """
        pass

    @property
    def Move(
      self
    ) -> TGIS_EditorOperation: 
        """
        Move a point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorOperation.Move
        """
        pass

    @property
    def Delete(
      self
    ) -> TGIS_EditorOperation: 
        """
        Delete a point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorOperation.Delete
        """
        pass

class TGIS_EditorMode:
    pass

class TGIS_EditorMode:
    """
    Editor vertex adding mode.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorMode
    """

    @property
    def Default(
      self
    ) -> TGIS_EditorMode: 
        """
        Editing behavior will be controlled by MouseBegin() _nearest parameter. Usually TGIS_EditorMode.NearestPoint, 
        but after pressing CTRL same as TGIS_EditorMode.AfterActivePoint.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorMode.Default
        """
        pass

    @property
    def Reversed(
      self
    ) -> TGIS_EditorMode: 
        """
        Editing will be opposite to default. Usually TGIS_EditorMode.AfterActivePoint, but 
        after pressing CTRL same as TGIS_EditorMode.NearestPoint.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorMode.Reversed
        """
        pass

    @property
    def NearestPoint(
      self
    ) -> TGIS_EditorMode: 
        """
        Added vertex modifies the nearest line segment or polygon edge.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorMode.NearestPoint
        """
        pass

    @property
    def AfterActivePoint(
      self
    ) -> TGIS_EditorMode: 
        """
        A new vertex is added sequentially (by vertex number) after the last active vertex.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorMode.AfterActivePoint
        """
        pass

class TGIS_EditorModeEx:
    pass

class TGIS_EditorModeEx:
    """
    For internal use of TGIS_Editor. Basic editor modes.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorModeEx
    """

    @property
    def Normal(
      self
    ) -> TGIS_EditorModeEx: 
        """
        A new point will be added on mouse up.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorModeEx.Normal
        """
        pass

    @property
    def Extended(
      self
    ) -> TGIS_EditorModeEx: 
        """
        For advanced edit modes, where a new point will not be added on mouse up.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorModeEx.Extended
        """
        pass

class TGIS_FieldInfoList:
    """
    List of TGIS_FieldInfo objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfoList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_FieldInfo:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_FieldInfo
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfoList.Create_void
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfoList.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> TGIS_FieldInfo: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfoList.Item
        """
        pass

class TGIS_PointList:
    """
    List of TGIS_Point objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_Point:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_Point
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointList.Create_void
        """
        pass

    def Add(
      self,
      _item: TGIS_Point
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointList.Add_TGIS_Point
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointList.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointList.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointList.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> TGIS_Point: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointList.Item
        """
        pass

class TGIS_Point3DList:
    """
    List of TGIS_Point3D objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3DList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_Point3D:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_Point3D
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3DList.Create_void
        """
        pass

    def Add(
      self,
      _item: TGIS_Point3D
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3DList.Add_TGIS_Point3D
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3DList.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3DList.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3DList.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> TGIS_Point3D: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3DList.Item
        """
        pass

class TGIS_VariantList:
    """
    List of Variant objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> Variant:
        pass

    def __setitem__(
      self,
      index : int,
      value : Variant
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantList.Create_void
        """
        pass

    def Add(
      self,
      _item: Variant
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantList.Add_Variant
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantList.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantList.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantList.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> Variant: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantList.Item
        """
        pass

class TGIS_ThreadClass( TObject ):
    """
    A simple class with encapsulate basic critical section locking mechanism.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ThreadClass
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create thread class object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ThreadClass.Create_void
        """
        pass

    def LockThread(
      self
    ) -> None: 
        """
        Locks the thread.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ThreadClass.LockThread_void
        """
        pass

    def UnlockThread(
      self
    ) -> None: 
        """
        Unlocks the thread.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ThreadClass.UnlockThread_void
        """
        pass

class TGIS_PasswordList( TGIS_ThreadClass ):
    """
    List for storing passwords.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PasswordList
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PasswordList.Create_void
        """
        pass

    def Add(
      self,
      _name: str,
      _key: str,
      _value: str
    ) -> None: 
        """
        Add new password.

        Args:
            _name: name of the item; for layers password use layer name
            _key: key; for layers use password keys; for example for SQL layer each password 
              can contain to keys: ''username'' and ''password''; meaning of key can be layer specific;
            _value: value of the name.key

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PasswordList.Add_String_String_String
        """
        pass

    def Check(
      self,
      _name: str,
      _key: str,
      _value: str
    ) -> bool: 
        """
        Check password.

        Args:
            _name: name of the item; for layers password use layer name
            _key: key; for layers use password keys; for example for SQL layer each password 
              can contain to keys: ''username'' and ''password''; meaning of key can be layer specific;
            _value: value of the name.key pair

        Returns:
            True if _value match the password name.key pair

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PasswordList.Check_String_String_String
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear list - delete all passwords.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PasswordList.Clear_void
        """
        pass

    def Get(
      self,
      _name: str,
      _key: str
    ) -> str: 
        """
        Get password.

        Args:
            _name: name of the item; for layers password use layer name
            _key: key; for layers use password keys; for example for SQL layer each password 
              can contain to keys: ''username'' and ''password''; meaning of key can be layer specific;

        Returns:
            value of the name.key pair

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PasswordList.Get_String_String
        """
        pass

    def Merge(
      self,
      _lst: TGIS_PasswordList
    ) -> None: 
        """
        Merge with values form provided list.

        Args:
            _lst: list with values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PasswordList.Merge_TGIS_PasswordList
        """
        pass

class TGIS_AliasList( TGIS_ThreadClass ):
    """
    List for aliases.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AliasList
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AliasList.Create_void
        """
        pass

    def Add(
      self,
      _alias: str,
      _value: str
    ) -> None: 
        """
        Add new alias.

        Args:
            _alias: name of the alias (case insensitive)
            _value: value of the alias

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AliasList.Add_String_String
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear list - delete all aliases.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AliasList.Clear_void
        """
        pass

    def Get(
      self,
      _alias: str
    ) -> str: 
        """
        Get alias.

        Args:
            _alias: name of the alias (case insensitive)

        Returns:
            value of the alias

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AliasList.Get_String
        """
        pass

    def Resolve(
      self,
      _string: str
    ) -> str: 
        """
        Resolve alias.

        Args:
            _string: String in a form of ''text &lt;#ALIAS1#&gt; text &lt;&lt;#ALIAS2#&gt; text''

        Returns:
            string with all aliases resolved/expanded

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AliasList.Resolve_String
        """
        pass

class TGIS_ThreadStorage( TObject ):
    """
    Thread storage. Use this class to store any thread related classes. Class will be 
    free upon application terminate or upon exception at undetermined time.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ThreadStorage
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a thread storage object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ThreadStorage.Create_void
        """
        pass

    @property
    def GisAliasList(
      self
    ) -> TGIS_AliasList: 
        """
        List of aliases.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ThreadStorage.GisAliasList
        """
        pass

    @property
    def ThreadId(
      self
    ) -> int: 
        """
        Thread id.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ThreadStorage.ThreadId
        """
        pass

class TGIS_Tokenizer( TObject ):
    """
    A simple tokenizer for parameters line splitting.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tokenizer
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create tokenizer object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tokenizer.Create_void
        """
        pass

    def CurrentToken(
      self
    ) -> str: 
        """
        Get a token at current Result list position.

        Returns:
            token value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tokenizer.CurrentToken_void
        """
        pass

    def Eof(
      self
    ) -> bool: 
        """
        Is a token on the last Result list position.

        Returns:
            True if a token is the last one

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tokenizer.Eof_void
        """
        pass

    @overload
    def Execute(
      self,
      _str: str,
      _delims: str
    ) -> None: 
        """
        Do tokenizing.

        Args:
            _str: String to be tokenized
            _delims: string with delimiters

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tokenizer.Execute_String_String
        """
        pass

    @overload
    def Execute(
      self,
      _str: str,
      _delims: str,
      _quotes: bool
    ) -> None: 
        """
        Do tokenizing.

        Args:
            _str: String to be tokenized
            _delims: string with delimiters
            _quotes: if true, then delimiter will be active only after a quote

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tokenizer.Execute_String_String_Boolean
        """
        pass

    @overload
    def ExecuteEx(
      self,
      _str: str
    ) -> None: 
        """
        Do tokenizing of simple stream like "aaaa","aaaa",123,"aaaa".

        Args:
            _str: String to be tokenized

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tokenizer.ExecuteEx_String
        """
        pass

    @overload
    def ExecuteEx(
      self,
      _str: str,
      _delim: char
    ) -> None: 
        """
        Do tokenizing of simple stream like "aaaa","aaaa",123,"aaaa".

        Args:
            _str: String to be tokenized
            _delim: delimiter char (like period)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tokenizer.ExecuteEx_String_Char
        """
        pass

    @overload
    def ExecuteEx(
      self,
      _str: str,
      _delim: char,
      _quote: char
    ) -> None: 
        """
        Do tokenizing of simple stream like "aaaa","aaaa",123,"aaaa".

        Args:
            _str: String to be tokenized
            _delim: delimiter char (like period)
            _quote: quote char (like quotes)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tokenizer.ExecuteEx_String_Char_Char
        """
        pass

    def MoveFirst(
      self
    ) -> None: 
        """
        Move to the first token of Result list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tokenizer.MoveFirst_void
        """
        pass

    def MoveNext(
      self
    ) -> None: 
        """
        Move to the next token of Result list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tokenizer.MoveNext_void
        """
        pass

    @property
    def CurrentIndex(
      self
    ) -> int: 
        """
        Current index value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tokenizer.CurrentIndex
        """
        pass

    @CurrentIndex.setter
    def CurrentIndex(
      self,
      _value: int
    ) -> None: 
        """
        Current index value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tokenizer.CurrentIndex
        """
        pass

    @property
    def Result(
      self
    ) -> TGIS_Strings: 
        """
        String list on which each element represent each token.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tokenizer.Result
        """
        pass

class EGIS_Exception( Exception ):
    """
    Exception class for all GIS_Viewer exceptions.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.EGIS_Exception
    """

class EGIS_PaintException( EGIS_Exception ):
    """
    Exception class for GIS_Viewer paint exceptions.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.EGIS_PaintException
    """

class TGIS_FieldInfo( TObject ):
    """
    Field structure information.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Create_void
        """
        pass

    @property
    def Binary(
      self
    ) -> int: 
        """
        Binary width for TAB/DAT files.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Binary
        """
        pass

    @Binary.setter
    def Binary(
      self,
      _value: int
    ) -> None: 
        """
        Binary width for TAB/DAT files.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Binary
        """
        pass

    @property
    def Decimal(
      self
    ) -> int: 
        """
        Decimal as represented in saved version.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Decimal
        """
        pass

    @Decimal.setter
    def Decimal(
      self,
      _value: int
    ) -> None: 
        """
        Decimal as represented in saved version.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Decimal
        """
        pass

    @property
    def Deleted(
      self
    ) -> bool: 
        """
        If True file must be deleted on save.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Deleted
        """
        pass

    @Deleted.setter
    def Deleted(
      self,
      _value: bool
    ) -> None: 
        """
        If True file must be deleted on save.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Deleted
        """
        pass

    @property
    def ExportName(
      self
    ) -> str: 
        """
        Field used in exporting.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.ExportName
        """
        pass

    @ExportName.setter
    def ExportName(
      self,
      _value: str
    ) -> None: 
        """
        Field used in exporting.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.ExportName
        """
        pass

    @property
    def FieldType(
      self
    ) -> TGIS_FieldType: 
        """
        Type of field.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.FieldType
        """
        pass

    @FieldType.setter
    def FieldType(
      self,
      _value: TGIS_FieldType
    ) -> None: 
        """
        Type of field.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.FieldType
        """
        pass

    @property
    def FileFormat(
      self
    ) -> bool: 
        """
        If True, then field is specific to file format and should not be visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.FileFormat
        """
        pass

    @FileFormat.setter
    def FileFormat(
      self,
      _value: bool
    ) -> None: 
        """
        If True, then field is specific to file format and should not be visible.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.FileFormat
        """
        pass

    @property
    def Flags(
      self
    ) -> typing.Sequence[TGIS_FieldFlags]: 
        """
        Set of cumulative field flags.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Flags
        """
        pass

    @property
    def Hidden(
      self
    ) -> bool: 
        """
        If True, then field will not be visible in controls.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Hidden
        """
        pass

    @Hidden.setter
    def Hidden(
      self,
      _value: bool
    ) -> None: 
        """
        If True, then field will not be visible in controls.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Hidden
        """
        pass

    @property
    def IsUID(
      self
    ) -> bool: 
        """
        If True, then field is used as GIS_UID and will be exported.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.IsUID
        """
        pass

    @IsUID.setter
    def IsUID(
      self,
      _value: bool
    ) -> None: 
        """
        If True, then field is used as GIS_UID and will be exported.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.IsUID
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Name as represented in saved version.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Name
        """
        pass

    @Name.setter
    def Name(
      self,
      _value: str
    ) -> None: 
        """
        Name as represented in saved version.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Name
        """
        pass

    @property
    def NewDecimal(
      self
    ) -> int: 
        """
        New decimal size of field.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.NewDecimal
        """
        pass

    @NewDecimal.setter
    def NewDecimal(
      self,
      _value: int
    ) -> None: 
        """
        New decimal size of field.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.NewDecimal
        """
        pass

    @property
    def NewName(
      self
    ) -> str: 
        """
        New name of field.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.NewName
        """
        pass

    @NewName.setter
    def NewName(
      self,
      _value: str
    ) -> None: 
        """
        New name of field.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.NewName
        """
        pass

    @property
    def NewWidth(
      self
    ) -> int: 
        """
        New width of field.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.NewWidth
        """
        pass

    @NewWidth.setter
    def NewWidth(
      self,
      _value: int
    ) -> None: 
        """
        New width of field.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.NewWidth
        """
        pass

    @property
    def ReadOnly(
      self
    ) -> bool: 
        """
        If True, then value of the field can not be modified.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.ReadOnly
        """
        pass

    @ReadOnly.setter
    def ReadOnly(
      self,
      _value: bool
    ) -> None: 
        """
        If True, then value of the field can not be modified.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.ReadOnly
        """
        pass

    @property
    def Rules(
      self
    ) -> TObject: 
        """
        Field rules.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Rules
        """
        pass

    @Rules.setter
    def Rules(
      self,
      _value: TObject
    ) -> None: 
        """
        Field rules.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Rules
        """
        pass

    @property
    def Saved(
      self
    ) -> bool: 
        """
        if True the field exist in disk based image; valid only for real disk based layer 
        like TGIS_LayerSHP, TGIS_LayerSHP etc. Layers like TGIS_Layer_DXF and TGIS_LayerMIF 
        are first imported into memory, value of Saved will always be false

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Saved
        """
        pass

    @Saved.setter
    def Saved(
      self,
      _value: bool
    ) -> None: 
        """
        if True the field exist in disk based image; valid only for real disk based layer 
        like TGIS_LayerSHP, TGIS_LayerSHP etc. Layers like TGIS_Layer_DXF and TGIS_LayerMIF 
        are first imported into memory, value of Saved will always be false

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Saved
        """
        pass

    @property
    def Temporary(
      self
    ) -> bool: 
        """
        If True, then field is temporary (not stored in a file).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Temporary
        """
        pass

    @Temporary.setter
    def Temporary(
      self,
      _value: bool
    ) -> None: 
        """
        If True, then field is temporary (not stored in a file).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Temporary
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        Width as represented in saved version.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Width
        """
        pass

    @Width.setter
    def Width(
      self,
      _value: int
    ) -> None: 
        """
        Width as represented in saved version.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldInfo.Width
        """
        pass

class TGIS_Textures:
    """
    Class managing a list of texture coordinates.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Textures
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Textures.Create_void
        """
        pass

    def Assign(
      self,
      _textures: TGIS_Textures
    ) -> None: 
        """
        Assign textures array.

        Args:
            _textures: list to assign

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Textures.Assign_TGIS_Textures
        """
        pass

    def GetPartSize(
      self,
      _part: int
    ) -> int: 
        """
        Get part size.

        Args:
            _part: number of part

        Returns:
            part size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Textures.GetPartSize_Integer
        """
        pass

    def GetTextureCoord(
      self,
      _part: int,
      _index: int
    ) -> float: 
        """
        Get texture coordinate.

        Args:
            _part: part number
            _index: index

        Returns:
            coordinate.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Textures.GetTextureCoord_Integer_Integer
        """
        pass

    def Resize(
      self,
      _numParts: int,
      _numTextures: int,
      _numDimension: int
    ) -> None: 
        """
        Resize array of textures.

        Args:
            _numParts: number of parts
            _numTextures: number of textures
            _numDimension: number of dimensions

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Textures.Resize_Integer_Integer_Integer
        """
        pass

    def SetPartOffset(
      self,
      _part: int,
      _offset: int
    ) -> None: 
        """
        Set a part offset.

        Args:
            _part: part number
            _offset: new offset

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Textures.SetPartOffset_Integer_Integer
        """
        pass

    def SetTextureCoord(
      self,
      _index: int,
      _texture: float
    ) -> None: 
        """
        Set texture coordinate.

        Args:
            _index: index
            _texture: texture coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Textures.SetTextureCoord_Integer_Single
        """
        pass

    @property
    def NumParts(
      self
    ) -> int: 
        """
        Number of coordinate parts. Should be equal to number of shape parts.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Textures.NumParts
        """
        pass

    @property
    def TextureDimension(
      self
    ) -> int: 
        """
        Texture coordinates dimension.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Textures.TextureDimension
        """
        pass

class TGIS_Materials:
    """
    Class managing a list of texture materials.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Materials
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Materials.Create_void
        """
        pass

    def Assign(
      self,
      _materials: TGIS_Materials
    ) -> None: 
        """
        Assign materials array.

        Args:
            _materials: list to be assigned

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Materials.Assign_TGIS_Materials
        """
        pass

    def Resize(
      self,
      _numMaterials: int
    ) -> None: 
        """
        Resize materials array.

        Args:
            _numMaterials: new size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Materials.Resize_Integer
        """
        pass

    @property
    def CompressionType(
      self
    ) -> TGIS_CompressionType: 
        """
        Compression type of materials.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Materials.CompressionType
        """
        pass

    @CompressionType.setter
    def CompressionType(
      self,
      _value: TGIS_CompressionType
    ) -> None: 
        """
        Compression type of materials.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Materials.CompressionType
        """
        pass

    
    def Material(
      self,
      _index: int
    ) -> TGIS_Material: 
        """
        Material array. Each position represents the material id.

        Args:
            _index: material index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Materials.Material
        """
        pass

    
    def Material(
      self,
      _index: int,
      _value: TGIS_Material
    ) -> None: 
        """
        Material array. Each position represents the material id.

        Args:
            _index: material index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Materials.Material
        """
        pass

    @property
    def NumMaterials(
      self
    ) -> int: 
        """
        Number of materials.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Materials.NumMaterials
        """
        pass

class TGIS_Normals:
    """
    Class managing a list of normal vectors.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Normals
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Normals.Create_void
        """
        pass

    def Assign(
      self,
      _normals: TGIS_Normals
    ) -> None: 
        """
        Assign normals array.

        Args:
            _normals: list to be assigned

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Normals.Assign_TGIS_Normals
        """
        pass

    def Resize(
      self,
      _size: int
    ) -> None: 
        """
        Resize normals array.

        Args:
            _size: new size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Normals.Resize_Integer
        """
        pass

    
    def Normal(
      self,
      _index: int
    ) -> TGIS_SingleVector: 
        """
        Normal array. Each position represent a normal found at each point.

        Args:
            _index: normal array index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Normals.Normal
        """
        pass

    
    def Normal(
      self,
      _index: int,
      _value: TGIS_SingleVector
    ) -> None: 
        """
        Normal array. Each position represent a normal found at each point.

        Args:
            _index: normal array index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Normals.Normal
        """
        pass

    @property
    def NumNormals(
      self
    ) -> int: 
        """
        Number of normals. Should be equal to number of shape points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Normals.NumNormals
        """
        pass

class TGIS_VertexColors:
    """
    Class managing a list of Vertex Color .

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VertexColors
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VertexColors.Create_void
        """
        pass

    def Assign(
      self,
      _vertexColors: TGIS_VertexColors
    ) -> None: 
        """
        Assign vertex Colors array.

        Args:
            _vertexColors: list to assign

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VertexColors.Assign_TGIS_VertexColors
        """
        pass

    def GetPartSize(
      self,
      _part: int
    ) -> int: 
        """
        Get part size.

        Args:
            _part: number of part

        Returns:
            part size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VertexColors.GetPartSize_Integer
        """
        pass

    def GetVertexColor(
      self,
      _part: int,
      _index: int
    ) -> int: 
        """
        Get vertex color.

        Args:
            _part: part number
            _index: index

        Returns:
            color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VertexColors.GetVertexColor_Integer_Integer
        """
        pass

    def Resize(
      self,
      _numParts: int,
      _numColors: int
    ) -> None: 
        """
        Resize array of Vertex Colors.

        Args:
            _numParts: number of parts
            _numColors: number of Vertex Colors

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VertexColors.Resize_Integer_Integer
        """
        pass

    def SetPartOffset(
      self,
      _part: int,
      _offset: int
    ) -> None: 
        """
        Set a part offset.

        Args:
            _part: part number
            _offset: new offset

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VertexColors.SetPartOffset_Integer_Integer
        """
        pass

    def SetVertexColor(
      self,
      _index: int,
      _color: int
    ) -> None: 
        """
        Set vertex color.

        Args:
            _index: index
            _color: vertex color

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VertexColors.SetVertexColor_Integer_Cardinal
        """
        pass

    @property
    def NumParts(
      self
    ) -> int: 
        """
        Number of color parts. Should be equal to number of shape parts.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VertexColors.NumParts
        """
        pass

class TGIS_PartDescriptors:
    """
    Class managing a list of Part Descriptors.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptors
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptors.Create_void
        """
        pass

    def Assign(
      self,
      _descriptor: TGIS_PartDescriptors
    ) -> None: 
        """
        Assign part descriptors array.

        Args:
            _descriptor: list to be assigned

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptors.Assign_TGIS_PartDescriptors
        """
        pass

    def Resize(
      self,
      _size: int
    ) -> None: 
        """
        Resize part descriptors array.

        Args:
            _size: new size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptors.Resize_Integer
        """
        pass

    @property
    def NumPartDescriptors(
      self
    ) -> int: 
        """
        Number of part descriptors.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptors.NumPartDescriptors
        """
        pass

    
    def PartDescriptor(
      self,
      _index: int
    ) -> TGIS_PartDescriptor: 
        """
        Part descriptor array. Should be equal to number of shape parts.

        Args:
            _index: part descriptor array index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptors.PartDescriptor
        """
        pass

    
    def PartDescriptor(
      self,
      _index: int,
      _value: TGIS_PartDescriptor
    ) -> None: 
        """
        Part descriptor array. Should be equal to number of shape parts.

        Args:
            _index: part descriptor array index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptors.PartDescriptor
        """
        pass

class TGIS_EditorStyle( TPersistent ):
    """
    Editor style.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorStyle
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorStyle.Create_void
        """
        pass

    @property
    def BrushColor(
      self
    ) -> TGIS_Color: 
        """
        Brush color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorStyle.BrushColor
        """
        pass

    @BrushColor.setter
    def BrushColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Brush color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorStyle.BrushColor
        """
        pass

    @property
    def BrushStyle(
      self
    ) -> TGIS_BrushStyle: 
        """
        Brush style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorStyle.BrushStyle
        """
        pass

    @BrushStyle.setter
    def BrushStyle(
      self,
      _value: TGIS_BrushStyle
    ) -> None: 
        """
        Brush style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorStyle.BrushStyle
        """
        pass

    @property
    def PenColor(
      self
    ) -> TGIS_Color: 
        """
        Pen color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorStyle.PenColor
        """
        pass

    @PenColor.setter
    def PenColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Pen color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorStyle.PenColor
        """
        pass

    @property
    def PenStyle(
      self
    ) -> TGIS_PenStyle: 
        """
        Pen style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorStyle.PenStyle
        """
        pass

    @PenStyle.setter
    def PenStyle(
      self,
      _value: TGIS_PenStyle
    ) -> None: 
        """
        Pen style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorStyle.PenStyle
        """
        pass

    @property
    def PenWidth(
      self
    ) -> int: 
        """
        Pen width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorStyle.PenWidth
        """
        pass

    @PenWidth.setter
    def PenWidth(
      self,
      _value: int
    ) -> None: 
        """
        Pen width.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorStyle.PenWidth
        """
        pass

class TGIS_EditorEditingPointsStyle( TPersistent ):
    """
    Editor editing points style.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEditingPointsStyle
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEditingPointsStyle.Create_void
        """
        pass

    @property
    def ActivePoints(
      self
    ) -> TGIS_EditorStyle: 
        """
        Style of active points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEditingPointsStyle.ActivePoints
        """
        pass

    @ActivePoints.setter
    def ActivePoints(
      self,
      _value: TGIS_EditorStyle
    ) -> None: 
        """
        Style of active points.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEditingPointsStyle.ActivePoints
        """
        pass

    @property
    def InactivePoints(
      self
    ) -> TGIS_EditorStyle: 
        """
        Style of inactive points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEditingPointsStyle.InactivePoints
        """
        pass

    @InactivePoints.setter
    def InactivePoints(
      self,
      _value: TGIS_EditorStyle
    ) -> None: 
        """
        Style of inactive points.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEditingPointsStyle.InactivePoints
        """
        pass

    @property
    def Points3D(
      self
    ) -> TGIS_EditorStyle: 
        """
        Style of points 3D.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEditingPointsStyle.Points3D
        """
        pass

    @Points3D.setter
    def Points3D(
      self,
      _value: TGIS_EditorStyle
    ) -> None: 
        """
        Style of points 3D.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEditingPointsStyle.Points3D
        """
        pass

    @property
    def PointsBackground(
      self
    ) -> TGIS_Color: 
        """
        Background color for points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEditingPointsStyle.PointsBackground
        """
        pass

    @PointsBackground.setter
    def PointsBackground(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Background color for points.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEditingPointsStyle.PointsBackground
        """
        pass

    @property
    def PointsFont(
      self
    ) -> TGIS_Font: 
        """
        Font for points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEditingPointsStyle.PointsFont
        """
        pass

    @PointsFont.setter
    def PointsFont(
      self,
      _value: TGIS_Font
    ) -> None: 
        """
        Font for points.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEditingPointsStyle.PointsFont
        """
        pass

    @property
    def SelectedPoints(
      self
    ) -> TGIS_EditorStyle: 
        """
        Style of selected points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEditingPointsStyle.SelectedPoints
        """
        pass

    @SelectedPoints.setter
    def SelectedPoints(
      self,
      _value: TGIS_EditorStyle
    ) -> None: 
        """
        Style of selected points.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEditingPointsStyle.SelectedPoints
        """
        pass

    @property
    def SnappingPoints(
      self
    ) -> TGIS_EditorStyle: 
        """
        Style of tracking points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEditingPointsStyle.SnappingPoints
        """
        pass

    @SnappingPoints.setter
    def SnappingPoints(
      self,
      _value: TGIS_EditorStyle
    ) -> None: 
        """
        Style of tracking points.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEditingPointsStyle.SnappingPoints
        """
        pass

class TGIS_EditorEdgeLengthsStyle( TPersistent ):
    """
    Editor editing edge lengths style.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEdgeLengthsStyle
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEdgeLengthsStyle.Create_void
        """
        pass

    @property
    def Background(
      self
    ) -> TGIS_EditorStyle: 
        """
        Style of edge lengths background.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEdgeLengthsStyle.Background
        """
        pass

    @Background.setter
    def Background(
      self,
      _value: TGIS_EditorStyle
    ) -> None: 
        """
        Style of edge lengths background.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEdgeLengthsStyle.Background
        """
        pass

    @property
    def FollowEdgeAngle(
      self
    ) -> bool: 
        """
        If true, edge length text will follow an edge angle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEdgeLengthsStyle.FollowEdgeAngle
        """
        pass

    @FollowEdgeAngle.setter
    def FollowEdgeAngle(
      self,
      _value: bool
    ) -> None: 
        """
        If true, edge length text will follow an edge angle.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEdgeLengthsStyle.FollowEdgeAngle
        """
        pass

    @property
    def Font(
      self
    ) -> TGIS_Font: 
        """
        Font for lengths.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEdgeLengthsStyle.Font
        """
        pass

    @Font.setter
    def Font(
      self,
      _value: TGIS_Font
    ) -> None: 
        """
        Font for lengths.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEdgeLengthsStyle.Font
        """
        pass

    @property
    def UnitsEPSG(
      self
    ) -> int: 
        """
        Units EPSG code for edges lengths output. If set to 0 then automatic Matric or Imperial 
        system will be used based on location.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEdgeLengthsStyle.UnitsEPSG
        """
        pass

    @UnitsEPSG.setter
    def UnitsEPSG(
      self,
      _value: int
    ) -> None: 
        """
        Units EPSG code for edges lengths output. If set to 0 then automatic Matric or Imperial 
        system will be used based on location.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorEdgeLengthsStyle.UnitsEPSG
        """
        pass

class TGIS_EnvironmentInfo:
    """
    Structure for determining basic environment information.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EnvironmentInfo
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EnvironmentInfo.Create_void
        """
        pass

    @property
    def DirSep(
      self
    ) -> char: 
        """
        Directory separator char

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EnvironmentInfo.DirSep
        """
        pass

    @property
    def Is32(
      self
    ) -> bool: 
        """
        Is 32-bit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EnvironmentInfo.Is32
        """
        pass

    @property
    def Is64(
      self
    ) -> bool: 
        """
        Is 64-bit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EnvironmentInfo.Is64
        """
        pass

    @property
    def IsARM32(
      self
    ) -> bool: 
        """
        Is ARM 32-bit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EnvironmentInfo.IsARM32
        """
        pass

    @property
    def IsARM64(
      self
    ) -> bool: 
        """
        Is ARM 64-bit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EnvironmentInfo.IsARM64
        """
        pass

    @property
    def IsJava(
      self
    ) -> bool: 
        """
        Is Java

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EnvironmentInfo.IsJava
        """
        pass

    @property
    def IsMac(
      self
    ) -> bool: 
        """
        Is Mac

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EnvironmentInfo.IsMac
        """
        pass

    @property
    def IsMono(
      self
    ) -> bool: 
        """
        Is Mono

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EnvironmentInfo.IsMono
        """
        pass

    @property
    def IsMsNET(
      self
    ) -> bool: 
        """
        Is MsNET

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EnvironmentInfo.IsMsNET
        """
        pass

    @property
    def IsNative(
      self
    ) -> bool: 
        """
        Is Native

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EnvironmentInfo.IsNative
        """
        pass

    @property
    def IsNET(
      self
    ) -> bool: 
        """
        Is NET

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EnvironmentInfo.IsNET
        """
        pass

    @property
    def IsUnix(
      self
    ) -> bool: 
        """
        Is Unix

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EnvironmentInfo.IsUnix
        """
        pass

    @property
    def IsWindows(
      self
    ) -> bool: 
        """
        Is Windows

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EnvironmentInfo.IsWindows
        """
        pass

class TGIS_ProxySettings( TObject ):
    """
    Global proxy settings class.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProxySettings
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProxySettings.Create_void
        """
        pass

    def CanUseProxy(
      self,
      _url: str
    ) -> bool: 
        """
        Check using NoProxyFilter if proxy can be set for an url.

        Args:
            _url: url to check

        Returns:
            True if proxy can be set

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProxySettings.CanUseProxy_String
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear all settings.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProxySettings.Clear_void
        """
        pass

    @property
    def Domain(
      self
    ) -> str: 
        """
        Domain to be used with the proxy

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProxySettings.Domain
        """
        pass

    @Domain.setter
    def Domain(
      self,
      _value: str
    ) -> None: 
        """
        Domain to be used with the proxy

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProxySettings.Domain
        """
        pass

    @property
    def NoProxyFilter(
      self
    ) -> TGIS_StringList: 
        """
        List of hosts for which proxy parameters will not be set

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProxySettings.NoProxyFilter
        """
        pass

    @property
    def Pass(
      self
    ) -> str: 
        """
        Password needed to be authenticated to the proxy

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProxySettings.Pass
        """
        pass

    @Pass.setter
    def Pass(
      self,
      _value: str
    ) -> None: 
        """
        Password needed to be authenticated to the proxy

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProxySettings.Pass
        """
        pass

    @property
    def Port(
      self
    ) -> int: 
        """
        Port used to communicate to the proxy

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProxySettings.Port
        """
        pass

    @Port.setter
    def Port(
      self,
      _value: int
    ) -> None: 
        """
        Port used to communicate to the proxy

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProxySettings.Port
        """
        pass

    @property
    def Server(
      self
    ) -> str: 
        """
        Host to be used as a proxy

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProxySettings.Server
        """
        pass

    @Server.setter
    def Server(
      self,
      _value: str
    ) -> None: 
        """
        Host to be used as a proxy

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProxySettings.Server
        """
        pass

    @property
    def User(
      self
    ) -> str: 
        """
        UserName needed to be authenticated to the proxy

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProxySettings.User
        """
        pass

    @User.setter
    def User(
      self,
      _value: str
    ) -> None: 
        """
        UserName needed to be authenticated to the proxy

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProxySettings.User
        """
        pass

class TGIS_ColorRampList( TGIS_ThreadClass ):
    """
    List object for color ramps.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_GradientMap:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_GradientMap
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampList.Create_void
        """
        pass

    def Add(
      self,
      _ramp: TGIS_GradientMap
    ) -> None: 
        """
        Adds a new ramp to the list.

        Args:
            _ramp: ramp definition

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampList.Add_TGIS_GradientMap
        """
        pass

    def ByName(
      self,
      _name: str
    ) -> TGIS_GradientMap: 
        """
        Gets a color ramp by name.

        Args:
            _name: name of a ramp

        Returns:
            array of ramp map

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampList.ByName_String
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clears list - deletes all ramps.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampList.Clear_void
        """
        pass

    def Init(
      self
    ) -> None: 
        """
        Initializes list from internal definition. Current ramps will be cleared.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampList.Init_void
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Gets the ramp list count.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampList.Count
        """
        pass

    
    def Items(
      self,
      _index: int
    ) -> TGIS_GradientMap: 
        """
        Gets a ramp by index.

        Args:
            _index: index of a ramp

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampList.Items
        """
        pass

class TGIS_BusyEventManager( TObject ):
    """
    Class useful for progress implementation in single or multistage algorithms.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager
    """

    @overload
    def __init__(
      self,
      _sender: TObject
    ) -> None: 
        """
        Creates an instance.

        Args:
            _sender: the reference to the parent object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.Create_TObject
        """
        pass

    def EndEvent(
      self
    ) -> bool: 
        """
        Ends the currently executed stage.

        Returns:
            True if an abort request was set inside message handler; False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.EndEvent_void
        """
        pass

    @overload
    def PushEvent(
      self
    ) -> bool: 
        """
        Increments process position for current stage and raises busy event smartly.

        Returns:
            True if an abort request was set inside message handler; False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.PushEvent_void
        """
        pass

    @overload
    def PushEvent(
      self,
      _name: str
    ) -> bool: 
        """
        Increments process position for current stage, updates name, and raises busy event 
        smartly.

        Args:
            _name: the name of the event stage can be changed during the operation

        Returns:
            True if an abort request was set inside message handler; False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.PushEvent_String
        """
        pass

    def StartEvent(
      self,
      _name: str,
      _end_val: int,
      _sender: TObject
    ) -> bool: 
        """
        Creates a new event stage and sets the maximum position for it.

        Args:
            _name: the name of a new event stage
            _end_val: the end value of a new event stage
            _sender: the reference to the parent object

        Returns:
            True if an abort request was set inside message handler; False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.StartEvent_String_Int64_TObject
        """
        pass

    @property
    def Aborted(
      self
    ) -> bool: 
        """
        Indicates whether an abort was requested.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.Aborted
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Returns the number of stages.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.Count
        """
        pass

    
    def EndValue(
      self,
      _stage: int
    ) -> int: 
        """
        The real upper limit of the process position at specified stage.

        Args:
            _stage: the index of a stage

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.EndValue
        """
        pass

    
    def EstimatedTimeLeft(
      self,
      _stage: int
    ) -> int: 
        """
        Estimated remaining time of the process at specified stage.

        Args:
            _stage: the index of a stage

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.EstimatedTimeLeft
        """
        pass

    
    def Max(
      self,
      _stage: int
    ) -> int: 
        """
        The normalized upper limit of the process position at the specified stage.

        Args:
            _stage: the index of a stage

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.Max
        """
        pass

    
    def Name(
      self,
      _stage: int
    ) -> str: 
        """
        Name of the process at the specified stage.

        Args:
            _stage: the index of a stage

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.Name
        """
        pass

    
    def Position(
      self,
      _stage: int
    ) -> int: 
        """
        Current position of the process at the specified stage.

        Args:
            _stage: the index of a stage

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.Position
        """
        pass

    
    def Sender(
      self,
      _stage: int
    ) -> TObject: 
        """
        The reference to the parent object.

        Args:
            _stage: the index of a stage

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.Sender
        """
        pass

    @property
    def UseProgressThreshold(
      self
    ) -> bool: 
        """
        If True, busy events are raised according to a time trigger (default). If False, 
        busy events are raised at every PushEvent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.UseProgressThreshold
        """
        pass

    @UseProgressThreshold.setter
    def UseProgressThreshold(
      self,
      _value: bool
    ) -> None: 
        """
        If True, busy events are raised according to a time trigger (default). If False, 
        busy events are raised at every PushEvent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.UseProgressThreshold
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BusyEventManager.BusyEvent
        """
        pass

class TGIS_ClassificationRenderType:
    pass

class TGIS_ClassificationRenderType:
    """
    Enumeration of visual properties which can be set for the classification process. 
    Available only for vector layers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationRenderType
    """

    @property
    def Color(
      self
    ) -> TGIS_ClassificationRenderType: 
        """
        Color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationRenderType.Color
        """
        pass

    @property
    def Size(
      self
    ) -> TGIS_ClassificationRenderType: 
        """
        Size for markers, width for lines; not available for polygons.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationRenderType.Size
        """
        pass

    @property
    def OutlineWidth(
      self
    ) -> TGIS_ClassificationRenderType: 
        """
        Outline width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationRenderType.OutlineWidth
        """
        pass

    @property
    def OutlineColor(
      self
    ) -> TGIS_ClassificationRenderType: 
        """
        Outline color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationRenderType.OutlineColor
        """
        pass

class TGIS_ClassificationMethod:
    pass

class TGIS_ClassificationMethod:
    """
    Enumeration of classification methods.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationMethod
    """

    @property
    def DefinedInterval(
      self
    ) -> TGIS_ClassificationMethod: 
        """
        The interval between class breaks is defined by the user through the Interval property. 
        Number of classes is determined automatically and can be gotten from the NumClasses 
        property.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationMethod.DefinedInterval
        """
        pass

    @property
    def EqualInterval(
      self
    ) -> TGIS_ClassificationMethod: 
        """
        The range of attribute values is partitioned into equal-sized subranges by defining 
        the number of classes through the NumClasses property.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationMethod.EqualInterval
        """
        pass

    @property
    def GeometricalInterval(
      self
    ) -> TGIS_ClassificationMethod: 
        """
        Class breaks are based on class intervals that have a geometrical series. User specifies 
        the number of class intervals through the NumClasses property.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationMethod.GeometricalInterval
        """
        pass

    @property
    def KMeans(
      self
    ) -> TGIS_ClassificationMethod: 
        """
        Class breaks are determined using the K-Means Clustering Algorithm. All values from 
        an attribute are divided into N=NumClasses clusters so the within-cluster sum of 
        squares is minimized.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationMethod.KMeans
        """
        pass

    @property
    def KMeansSpatial(
      self
    ) -> TGIS_ClassificationMethod: 
        """
        K-Means algorithm is used to partition data into N=NumClasses spatial clusters based 
        on objects centroids. Available only for vector layers. New field named ''KMEANS_ID'' 
        will be added or updated if it exists.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationMethod.KMeansSpatial
        """
        pass

    @property
    def NaturalBreaks(
      self
    ) -> TGIS_ClassificationMethod: 
        """
        Class breaks are determined using the Fisher''s Exact Optimization algorithm. Dataset 
        is divided into N=NumClasses clusters so that the between-cluster sum of squares 
        is maximized. This is default method.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationMethod.NaturalBreaks
        """
        pass

    @property
    def Quantile(
      self
    ) -> TGIS_ClassificationMethod: 
        """
        Class intervals are created to have an equal number of observations. Number of classes 
        can be defined through the NumClasses property. This method is also known as Equal 
        Count.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationMethod.Quantile
        """
        pass

    @property
    def Quartile(
      self
    ) -> TGIS_ClassificationMethod: 
        """
        Quantile method is applied with fixed property NumClasses=4. This method creates 
        class breaks at the first, second, and third quartiles i.e. at 25-th, 50-th, and 
        75-th percentiles respectively.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationMethod.Quartile
        """
        pass

    @property
    def StandardDeviation(
      self
    ) -> TGIS_ClassificationMethod: 
        """
        Class breaks are set above and below the mean of the attribute values at intervals, 
        for example at 1, 1/2, 1/3, or 1/4 standard deviations until all the data values 
        are contained within these ranges. Interval is specified through the Interval property. 
        This method produces even number of classes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationMethod.StandardDeviation
        """
        pass

    @property
    def StandardDeviationWithCentral(
      self
    ) -> TGIS_ClassificationMethod: 
        """
        Same as StandardDeviation but class breaks are shifted by a half of the interval 
        to get central class in range [Mean-Interval/2..Mean+Interval/2]. For example, if 
        Interval equals 1 Std Dev, central class is limited by breaks -0.5 Std Dev and 0.5 
        Std Dev. This method produces odd number of classes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationMethod.StandardDeviationWithCentral
        """
        pass

    @property
    def Unique(
      self
    ) -> TGIS_ClassificationMethod: 
        """
        Class breaks are set for unique values. Number of classes can be limited through 
        the NumClasses property.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationMethod.Unique
        """
        pass

    @property
    def Manual(
      self
    ) -> TGIS_ClassificationMethod: 
        """
        Class breaks are set manually by the user through the AddClassBreak method. This 
        method is used when classes are meaningful.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationMethod.Manual
        """
        pass

class TGIS_ClassificationAbstract( TObject ):
    """
    General class that enables performing advanced data classification in the process 
    of creating choropleth (thematic) maps. Must be derived.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.Create_void
        """
        pass

    def AddClassBreak(
      self,
      _breakValue: float
    ) -> None: 
        """
        Adds a new class break.

        Args:
            _breakValue: A value of the new class break.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.AddClassBreak_Double
        """
        pass

    @overload
    def Classify(
      self
    ) -> bool: 
        """
        Performs the classification.

        Returns:
            True if classification is successful, False otherwise (e.g. if layer''s statistics 
            are not calculated or are out-of-date).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.Classify_void
        """
        pass

    @overload
    def Classify(
      self,
      _params: TGIS_ParamsList
    ) -> bool: 
        """
        Performs the classification and applies to defined ParamsList.

        Args:
            _params: ParamsList to apply a classification style

        Returns:
            True if classification is successful, False otherwise (e.g. if layer''s statistics 
            are not calculated or are out-of-date).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.Classify_TGIS_ParamsList
        """
        pass

    def EstimateNumClasses(
      self
    ) -> None: 
        """
        Performs the pre-classification and sets NumClasses property. Only works for methods 
        with an unknown number of classes at the start, such as: DefinedInterval, StandardDeviation, 
        StandardDeviationWithCentral, and Unique.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.EstimateNumClasses_void
        """
        pass

    def MustCalculateStatistics(
      self
    ) -> bool: 
        """
        If True, statistics from layer assigned to classification need to be calculated.

        Returns:
            True if layer''s statistics need to be calculated; False otherwise.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.MustCalculateStatistics_void
        """
        pass

    
    def ClassBreaks(
      self,
      _index: int
    ) -> Variant: 
        """
        Computed class breaks. Available after completing the classification.

        Args:
            _index: position in the list; from 0 to NumClasses

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.ClassBreaks
        """
        pass

    @property
    def ColorRamp(
      self
    ) -> TGIS_ColorMapArray: 
        """
        The color ramp that is used to assign colors for class breaks; none by default If 
        not provided, StartColor and EndColor will be used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.ColorRamp
        """
        pass

    @ColorRamp.setter
    def ColorRamp(
      self,
      _value: TGIS_ColorMapArray
    ) -> None: 
        """
        The color ramp that is used to assign colors for class breaks; none by default If 
        not provided, StartColor and EndColor will be used.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.ColorRamp
        """
        pass

    @property
    def ColorRampName(
      self
    ) -> str: 
        """
        The name of the built-in color ramp that is used to assign colors for class breaks; 
        empty by default. If not provided, ColorRamp property will be used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.ColorRampName
        """
        pass

    @ColorRampName.setter
    def ColorRampName(
      self,
      _value: str
    ) -> None: 
        """
        The name of the built-in color ramp that is used to assign colors for class breaks; 
        empty by default. If not provided, ColorRamp property will be used.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.ColorRampName
        """
        pass

    @property
    def EndColor(
      self
    ) -> TGIS_Color: 
        """
        Ending color used to generate ramp for class breaks; Black by default.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.EndColor
        """
        pass

    @EndColor.setter
    def EndColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Ending color used to generate ramp for class breaks; Black by default.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.EndColor
        """
        pass

    @property
    def ForceStatisticsCalculation(
      self
    ) -> bool: 
        """
        Forces the calculation of layer statistics; True by default.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.ForceStatisticsCalculation
        """
        pass

    @ForceStatisticsCalculation.setter
    def ForceStatisticsCalculation(
      self,
      _value: bool
    ) -> None: 
        """
        Forces the calculation of layer statistics; True by default.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.ForceStatisticsCalculation
        """
        pass

    @property
    def Interval(
      self
    ) -> float: 
        """
        Class interval size; default value is 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.Interval
        """
        pass

    @Interval.setter
    def Interval(
      self,
      _value: float
    ) -> None: 
        """
        Class interval size; default value is 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.Interval
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_Layer: 
        """
        Layer assigned to object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.Layer
        """
        pass

    @property
    def Method(
      self
    ) -> TGIS_ClassificationMethod: 
        """
        Classification method; NaturalBreaks by default.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.Method
        """
        pass

    @Method.setter
    def Method(
      self,
      _value: TGIS_ClassificationMethod
    ) -> None: 
        """
        Classification method; NaturalBreaks by default.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.Method
        """
        pass

    @property
    def NumClasses(
      self
    ) -> int: 
        """
        Number of classes; default is 5, max is 30.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.NumClasses
        """
        pass

    @NumClasses.setter
    def NumClasses(
      self,
      _value: int
    ) -> None: 
        """
        Number of classes; default is 5, max is 30.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.NumClasses
        """
        pass

    @property
    def ShowLegend(
      self
    ) -> bool: 
        """
        If True, features will be shown in legend panel; True by default.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.ShowLegend
        """
        pass

    @ShowLegend.setter
    def ShowLegend(
      self,
      _value: bool
    ) -> None: 
        """
        If True, features will be shown in legend panel; True by default.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.ShowLegend
        """
        pass

    @property
    def StartColor(
      self
    ) -> TGIS_Color: 
        """
        Starting color used to generate ramp for class breaks; White by default.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.StartColor
        """
        pass

    @StartColor.setter
    def StartColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Starting color used to generate ramp for class breaks; White by default.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.StartColor
        """
        pass

    @property
    def Target(
      self
    ) -> str: 
        """
        Indicates the data to be used for classification; empty by default.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.Target
        """
        pass

    @Target.setter
    def Target(
      self,
      _value: str
    ) -> None: 
        """
        Indicates the data to be used for classification; empty by default.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationAbstract.Target
        """
        pass

class TGIS_ClassificationVector( TGIS_ClassificationAbstract ):
    """
    Class that enables performing advanced vector data classification in the process 
    of creating choropleth (thematic) maps.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationVector
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationVector.Create_TGIS_LayerVector
        """
        pass

    @property
    def ClassIdField(
      self
    ) -> str: 
        """
        If not empty, the attribute field of the specified name will be populated with the 
        class id values. Empty by default. Ignored for ''KMeansSpatial'' method.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationVector.ClassIdField
        """
        pass

    @ClassIdField.setter
    def ClassIdField(
      self,
      _value: str
    ) -> None: 
        """
        If not empty, the attribute field of the specified name will be populated with the 
        class id values. Empty by default. Ignored for ''KMeansSpatial'' method.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationVector.ClassIdField
        """
        pass

    @property
    def EndSize(
      self
    ) -> int: 
        """
        Ending size or width for generating Params section; default value is 480.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationVector.EndSize
        """
        pass

    @EndSize.setter
    def EndSize(
      self,
      _value: int
    ) -> None: 
        """
        Ending size or width for generating Params section; default value is 480.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationVector.EndSize
        """
        pass

    @property
    def Field(
      self
    ) -> str: 
        """
        Numeric field with values to be used in classification. For ''KMeansSpatial'' method, 
        property is ignored.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationVector.Field
        """
        pass

    @Field.setter
    def Field(
      self,
      _value: str
    ) -> None: 
        """
        Numeric field with values to be used in classification. For ''KMeansSpatial'' method, 
        property is ignored.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationVector.Field
        """
        pass

    @property
    def RenderType(
      self
    ) -> TGIS_ClassificationRenderType: 
        """
        Visual property which will be affected during classification; Color by default.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationVector.RenderType
        """
        pass

    @RenderType.setter
    def RenderType(
      self,
      _value: TGIS_ClassificationRenderType
    ) -> None: 
        """
        Visual property which will be affected during classification; Color by default.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationVector.RenderType
        """
        pass

    @property
    def ShapeType(
      self
    ) -> TGIS_ShapeType: 
        """
        Defines which visual parameter will be used for classification: Marker for Points, 
        Line for Arcs, Area for Polygons. TGIS_ShapeType.Unknown by default - the layer DefaultShapeType 
        will be used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationVector.ShapeType
        """
        pass

    @ShapeType.setter
    def ShapeType(
      self,
      _value: TGIS_ShapeType
    ) -> None: 
        """
        Defines which visual parameter will be used for classification: Marker for Points, 
        Line for Arcs, Area for Polygons. TGIS_ShapeType.Unknown by default - the layer DefaultShapeType 
        will be used.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationVector.ShapeType
        """
        pass

    @property
    def StartSize(
      self
    ) -> int: 
        """
        Starting size or width for generating Params section; default value is 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationVector.StartSize
        """
        pass

    @StartSize.setter
    def StartSize(
      self,
      _value: int
    ) -> None: 
        """
        Starting size or width for generating Params section; default value is 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationVector.StartSize
        """
        pass

class TGIS_ClassificationPixel( TGIS_ClassificationAbstract ):
    """
    Class that enables performing advanced pixel data classification in the process of 
    creating choropleth (thematic) maps.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationPixel
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerPixel
    ) -> None: 
        """
        Creates an object. Always related to the layer.

        Args:
            _layer: layer to be classified

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationPixel.Create_TGIS_LayerPixel
        """
        pass

    @property
    def Band(
      self
    ) -> str: 
        """
        Band from which values are used in classification.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationPixel.Band
        """
        pass

    @Band.setter
    def Band(
      self,
      _value: str
    ) -> None: 
        """
        Band from which values are used in classification.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationPixel.Band
        """
        pass

class TGIS_ClassificationFactory:
    """
    Class for creating classification objects depending on the layer''s type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationFactory
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationFactory.Create_void
        """
        pass

    @classmethod
    def CreateClassifier(
      cls,
      _layer: TGIS_Layer
    ) -> TGIS_ClassificationAbstract: 
        """
        Creates an object that inherits from TGIS_ClassificationAbstract class based on the 
        layer''s type.

        Args:
            _layer: layer to be assigned to classifier

        Returns:
            new instance of class that inherits from TGIS_ClassificationAbstract class or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ClassificationFactory.CreateClassifier_TGIS_Layer
        """
        pass

class TGIS_Reclassification( TObject ):
    """
    A class that allows reclassification of grid layer values.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Reclassification
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Initializes a new instance of the TGIS_Reclassification class.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Reclassification.Create_void
        """
        pass

    @overload
    def AddReclassRange(
      self,
      _startValue: float,
      _endValue: float,
      _newValue: float,
      _color: TGIS_Color
    ) -> None: 
        """
        Adds a new reclassification range definition.

        Args:
            _startValue: lower bounds of the range (inclusive)
            _endValue: upper bounds of the range (exclusive)
            _newValue: new value to be assigned to the range of input values
            _color: altitude zone color for the new value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Reclassification.AddReclassRange_Single_Single_Single_TGIS_Color
        """
        pass

    @overload
    def AddReclassRange(
      self,
      _startValue: float,
      _endValue: float,
      _newValue: float
    ) -> None: 
        """
        Adds a new reclassification range definition.

        Args:
            _startValue: lower bounds of the range (inclusive)
            _endValue: upper bounds of the range (exclusive)
            _newValue: new value to be assigned to the range of input values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Reclassification.AddReclassRange_Single_Single_Single
        """
        pass

    @overload
    def AddReclassValue(
      self,
      _oldValue: float,
      _newValue: float,
      _color: TGIS_Color
    ) -> None: 
        """
        Adds a new reclassification value definition.

        Args:
            _oldValue: value from the source layer to be reclassified
            _newValue: new value to be assigned to the input value
            _color: altitude zone color for the new value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Reclassification.AddReclassValue_Single_Single_TGIS_Color
        """
        pass

    @overload
    def AddReclassValue(
      self,
      _oldValue: float,
      _newValue: float
    ) -> None: 
        """
        Adds a new reclassification value definition.

        Args:
            _oldValue: value from the source layer to be reclassified
            _newValue: new value to be assigned to the input value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Reclassification.AddReclassValue_Single_Single
        """
        pass

    def ClearReclassDefinitions(
      self
    ) -> None: 
        """
        Clears all reclassification definitions (ranges & values).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Reclassification.ClearReclassDefinitions_void
        """
        pass

    def Generate(
      self,
      _source: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _destination: TGIS_LayerPixel,
      _useAltitudeMapZones: bool
    ) -> None: 
        """
        Fiils the _destination grid layer with reclassified values.

        Args:
            _source: input grid layer
            _extent: extent to be reclassified
            _destination: output reclassified grid layer
            _useAltitudeMapZones: use altitude zones instead of reclass ranges and reclass values; 
              indicates whether the reclassification is based on reclass definitions (this is the 
              default), or definitions from TGIS_LayerPixel.Params.Pixel.AltitudeMapZones property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Reclassification.Generate_TGIS_LayerPixel_TGIS_Extent_TGIS_LayerPixel_Boolean
        """
        pass

    @property
    def ReclassNoDataValue(
      self
    ) -> float: 
        """
        The new value to be assigned to the input NoData value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Reclassification.ReclassNoDataValue
        """
        pass

    @ReclassNoDataValue.setter
    def ReclassNoDataValue(
      self,
      _value: float
    ) -> None: 
        """
        The new value to be assigned to the input NoData value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Reclassification.ReclassNoDataValue
        """
        pass

    @property
    def UseNoDataForMissingValues(
      self
    ) -> bool: 
        """
        Indicates whether cell values outside the defined ranges are reclassified to NoData 
        (true by default), or remain intact (false).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Reclassification.UseNoDataForMissingValues
        """
        pass

    @UseNoDataForMissingValues.setter
    def UseNoDataForMissingValues(
      self,
      _value: bool
    ) -> None: 
        """
        Indicates whether cell values outside the defined ranges are reclassified to NoData 
        (true by default), or remain intact (false).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Reclassification.UseNoDataForMissingValues
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Reclassification.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Reclassification.BusyEvent
        """
        pass

class TGIS_Config( TGIS_ConfigAbstract ):
    """
    Encapsulation of layer configuration file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config
    """

    @overload
    def __init__(
      self,
      _layer: TObject,
      _path: str
    ) -> None: 
        """
        Create instance.

        Args:
            _layer: pointer to layer object
            _path: full path to project configuration file; can be empty; if so then only layer 
              dependent files are to be used

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.Create_TObject_String
        """
        pass

    def AbsolutePath(
      self,
      _path: str
    ) -> str: 
        """
        Computes absolute path for path relative to configuration file.

        Args:
            _path: relative path

        Returns:
            absolute path

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.AbsolutePath_String
        """
        pass

    def AddSubLayer(
      self,
      _layer: TObject,
      _layerno: int,
      _sublayer: int
    ) -> None: 
        """
        Add sublayer to config file.

        Args:
            _layer: sublayer handle
            _layerno: layer index
            _sublayer: sublayer index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.AddSubLayer_TObject_Integer_Integer
        """
        pass

    def BuildProject(
      self,
      _viewer: IGIS_Viewer
    ) -> None: 
        """
        Build project file based on current project and list of layers attached to the Viewer.

        Args:
            _viewer: viewer for which project will be constructed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.BuildProject_IGIS_Viewer
        """
        pass

    def ClearActiveSection(
      self
    ) -> None: 
        """
        Delete elements related to the current section.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ClearActiveSection_void
        """
        pass

    def ClearGroups(
      self
    ) -> None: 
        """
        Delete group sections related to the selected group.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ClearGroups_void
        """
        pass

    def ClearSave(
      self
    ) -> None: 
        """
        Clear MustSave flag.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ClearSave_void
        """
        pass

    def ClearSections(
      self
    ) -> None: 
        """
        Delete sections related to the selected layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ClearSections_void
        """
        pass

    def ClearSubSections(
      self
    ) -> None: 
        """
        Delete subsections related to the selected layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ClearSubSections_void
        """
        pass

    def GetStrings(
      self,
      _list: TGIS_Strings
    ) -> None: 
        """
        Parse and fill list with values.

        Args:
            _list: list to fill

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.GetStrings_TGIS_Strings
        """
        pass

    def Lock(
      self
    ) -> None: 
        """
        Lock configuration file. If config file has been locked by Lock() then upon calling 
        Unlock() a real value of MustSave will be evaluated. Without Lock..Unlock value of 
        MustSave will be set based on a any write request regardless if write really modified 
        the configuration file or not.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.Lock_void
        """
        pass

    def Read3DLayerType(
      self,
      _name: str,
      _default: TGIS_3DLayerType
    ) -> TGIS_3DLayerType: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.Read3DLayerType_String_TGIS_3DLayerType
        """
        pass

    def ReadAlignment(
      self,
      _name: str,
      _default: TGIS_LabelAlignment
    ) -> TGIS_LabelAlignment: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadAlignment_String_TGIS_LabelAlignment
        """
        pass

    def ReadBasement(
      self,
      _name: str,
      _default: TGIS_3DBasementType
    ) -> TGIS_3DBasementType: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadBasement_String_TGIS_3DBasementType
        """
        pass

    def ReadBitmap(
      self,
      _name: str,
      _default: TGIS_Bitmap
    ) -> TGIS_Bitmap: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadBitmap_String_TGIS_Bitmap
        """
        pass

    def ReadBoolean(
      self,
      _name: str,
      _default: bool
    ) -> bool: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadBoolean_String_Boolean
        """
        pass

    def ReadChart(
      self,
      _name: str,
      _default: TGIS_ChartStyle
    ) -> TGIS_ChartStyle: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadChart_String_TGIS_ChartStyle
        """
        pass

    def ReadColor(
      self,
      _name: str,
      _default: TGIS_Color
    ) -> TGIS_Color: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadColor_String_TGIS_Color
        """
        pass

    def ReadColorInterpolationMode(
      self,
      _name: str,
      _default: TGIS_ColorInterpolationMode
    ) -> TGIS_ColorInterpolationMode: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadColorInterpolationMode_String_TGIS_ColorInterpolationMode
        """
        pass

    def ReadColorRamp(
      self,
      _name: str,
      _default: TGIS_ColorMapArray
    ) -> TGIS_ColorMapArray: 
        """
        Read color ramp parameter given by _name. If Parameter do not exist or are invalid 
        then _default value will be used.

        Args:
            _name: name of the parameter
            _default: default value of the parameter

        Returns:
            loaded color ramp

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadColorRamp_String_TGIS_ColorMapArray
        """
        pass

    def ReadCustomData(
      self,
      _name: str,
      _list: TGIS_Strings
    ) -> None: 
        """
        Read custom configuration parameters.

        Args:
            _name: name of custom section
            _list: list of parameters in a form of "name=value"

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadCustomData_String_TGIS_Strings
        """
        pass

    def ReadDormant(
      self,
      _name: str,
      _default: TGIS_LayerDormantMode
    ) -> TGIS_LayerDormantMode: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadDormant_String_TGIS_LayerDormantMode
        """
        pass

    def ReadFloat(
      self,
      _name: str,
      _default: float
    ) -> float: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadFloat_String_Double
        """
        pass

    def ReadFontStyle(
      self,
      _name: str,
      _default: typing.Sequence[TGIS_FontStyle]
    ) -> typing.Sequence[TGIS_FontStyle]: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadFontStyle_String_TGIS_FontStyles
        """
        pass

    def ReadGround(
      self,
      _name: str,
      _default: TGIS_3DGroundType
    ) -> TGIS_3DGroundType: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadGround_String_TGIS_3DGroundType
        """
        pass

    def ReadHierarchyGroups(
      self
    ) -> TObject: 
        """
        Read hierarchy groups to config.

        Returns:
            list of lines or nodes

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadHierarchyGroups_void
        """
        pass

    def ReadInteger(
      self,
      _name: str,
      _default: int
    ) -> int: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadInteger_String_Integer
        """
        pass

    def ReadInterpretation(
      self,
      _name: str,
      _default: TGIS_LayerPixelInterpretation
    ) -> TGIS_LayerPixelInterpretation: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadInterpretation_String_TGIS_LayerPixelInterpretation
        """
        pass

    def ReadMarker(
      self,
      _name: str,
      _default: TGIS_MarkerStyle
    ) -> TGIS_MarkerStyle: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadMarker_String_TGIS_MarkerStyle
        """
        pass

    def ReadNormalized(
      self,
      _name: str,
      _default: TGIS_3DNormalizationType
    ) -> TGIS_3DNormalizationType: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadNormalized_String_TGIS_3DNormalizationType
        """
        pass

    def ReadOffsetPosition(
      self,
      _name: str,
      _default: TGIS_OffsetPosition
    ) -> TGIS_OffsetPosition: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadOffsetPosition_String_TGIS_OffsetPosition
        """
        pass

    def ReadPattern(
      self,
      _name: str,
      _default: TGIS_BrushStyle
    ) -> TGIS_BrushStyle: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadPattern_String_TGIS_BrushStyle
        """
        pass

    def ReadPen(
      self,
      _name: str,
      _default: TGIS_PenStyle
    ) -> TGIS_PenStyle: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadPen_String_TGIS_PenStyle
        """
        pass

    def ReadPosition(
      self,
      _name: str,
      _default: typing.Sequence[TGIS_LabelPosition]
    ) -> typing.Sequence[TGIS_LabelPosition]: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadPosition_String_TGIS_LabelPositions
        """
        pass

    def ReadSectionValues(
      self,
      _name: str,
      _list: TGIS_Strings
    ) -> None: 
        """
        Read section values into a list.

        Args:
            _name: section name
            _list: list to fill

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadSectionValues_String_TGIS_Strings
        """
        pass

    def ReadString(
      self,
      _name: str,
      _default: str
    ) -> str: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadString_String_String
        """
        pass

    def ReadSymbol(
      self,
      _name: str,
      _default: TGIS_SymbolAbstract
    ) -> TGIS_SymbolAbstract: 
        """
        Read parameters given by _name. If Parameters do not exist or are invalid, then _default 
        value will be used.

        Args:
            _name: name of value
            _default: default value

        Returns:
            parameter value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadSymbol_String_TGIS_SymbolAbstract
        """
        pass

    def ReadZone(
      self,
      _name: str,
      _list: TGIS_StringList
    ) -> None: 
        """
        Read parameters given by zone _name. If Parameters do not exist or are invalid then 
        empty list will be returned.

        Args:
            _name: name of value
            _list: parameters in internal format

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ReadZone_String_TGIS_StringList
        """
        pass

    def RelativePath(
      self,
      _path: str
    ) -> str: 
        """
        Computes path relative to configuration file.

        Args:
            _path: path to be relative

        Returns:
            relative path

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.RelativePath_String
        """
        pass

    def Reread(
      self
    ) -> None: 
        """
        Reread configuration file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.Reread_void
        """
        pass

    def Save(
      self
    ) -> None: 
        """
        Save backup copy of configuration file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.Save_void
        """
        pass

    def SetGroup(
      self,
      _layer: TObject
    ) -> None: 
        """
        Select layer on which the operation will be performed. It is important for project 
        files. Thanks this it is possible to recognize which entry corespondents to which 
        layer.

        Args:
            _layer: layer on which the operation will be performed; it is nil then operation 
              will be performed on main entry ([TatukGIS] section)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.SetGroup_TObject
        """
        pass

    def SetGroupSection(
      self,
      _index: int
    ) -> bool: 
        """
        Select the group section on which the operation will be performed.

        Args:
            _index: group section number; 0 means default section (first entry)

        Returns:
            True if group section exists

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.SetGroupSection_Integer
        """
        pass

    def SetLayer(
      self,
      _layer: TObject
    ) -> None: 
        """
        Select layer on which the operation will be performed. It is important for project 
        files. Thanks this it is possible to recognize which entry corespondents to which 
        layer.

        Args:
            _layer: layer on which the operation will be performed; it is nil then operation 
              will be performed on main entry ([TatukGIS] section)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.SetLayer_TObject
        """
        pass

    def SetSection(
      self,
      _index: int,
      _force: bool
    ) -> bool: 
        """
        Select the section on which the operation will be performed.

        Args:
            _index: section number; 0 means default section (first entry)
            _force: if True, then a section will be created if not exist

        Returns:
            True if section exists

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.SetSection_Integer_Boolean
        """
        pass

    def SetStrings(
      self,
      _list: TGIS_Strings
    ) -> None: 
        """
        Read and parse values from list.

        Args:
            _list: string list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.SetStrings_TGIS_Strings
        """
        pass

    def SetSubLayer(
      self,
      _layer: TObject
    ) -> None: 
        """
        Select sublayer on which the operation will be performed. It is important for project 
        files. Thanks this it is possible to recognize which entry corespondents to which 
        layer.

        Args:
            _layer: layer on which the operation will be performed; it is nil then operation 
              will be performed on main entry ([TatukGIS] section)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.SetSubLayer_TObject
        """
        pass

    def SetSubSection(
      self,
      _index: int,
      _force: bool
    ) -> bool: 
        """
        Select the subsection on which the operation will be performed.

        Args:
            _index: subsection number; 0 means default section (first entry)
            _force: if True, then a subsection will be created if not exist

        Returns:
            True if subsection exists

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.SetSubSection_Integer_Boolean
        """
        pass

    def Unlock(
      self
    ) -> None: 
        """
        Unlock configuration file. If config file has been locked by Lock() then upon calling 
        Unlock() a real value of MustSave will be evaluated. Without Lock..Unlock value of 
        MustSave will be set based on a any write request regardless if write really modified 
        the configuration file or not.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.Unlock_void
        """
        pass

    def Write3DLayerType(
      self,
      _name: str,
      _value: TGIS_3DLayerType,
      _default: TGIS_3DLayerType
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.Write3DLayerType_String_TGIS_3DLayerType_TGIS_3DLayerType
        """
        pass

    def WriteAlignment(
      self,
      _name: str,
      _value: TGIS_LabelAlignment,
      _default: TGIS_LabelAlignment
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteAlignment_String_TGIS_LabelAlignment_TGIS_LabelAlignment
        """
        pass

    def WriteBasement(
      self,
      _name: str,
      _value: TGIS_3DBasementType,
      _default: TGIS_3DBasementType
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteBasement_String_TGIS_3DBasementType_TGIS_3DBasementType
        """
        pass

    def WriteBitmap(
      self,
      _name: str,
      _value: TGIS_Bitmap,
      _default: TGIS_Bitmap
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteBitmap_String_TGIS_Bitmap_TGIS_Bitmap
        """
        pass

    def WriteBoolean(
      self,
      _name: str,
      _value: bool,
      _default: bool
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteBoolean_String_Boolean_Boolean
        """
        pass

    def WriteChart(
      self,
      _name: str,
      _value: TGIS_ChartStyle,
      _default: TGIS_ChartStyle
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteChart_String_TGIS_ChartStyle_TGIS_ChartStyle
        """
        pass

    def WriteColor(
      self,
      _name: str,
      _value: TGIS_Color,
      _default: TGIS_Color
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteColor_String_TGIS_Color_TGIS_Color
        """
        pass

    def WriteColorInterpolationMode(
      self,
      _name: str,
      _value: TGIS_ColorInterpolationMode,
      _default: TGIS_ColorInterpolationMode
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteColorInterpolationMode_String_TGIS_ColorInterpolationMode_TGIS_ColorInterpolationMode
        """
        pass

    def WriteColorRamp(
      self,
      _name: str,
      _ramp: TGIS_ColorMapArray,
      _default: TGIS_ColorMapArray
    ) -> None: 
        """
        Write color ramp parameter given by _name. If Parameter do not exist or are invalid, 
        then _default value will be used.

        Args:
            _name: name of the parameter
            _ramp: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteColorRamp_String_TGIS_ColorMapArray_TGIS_ColorMapArray
        """
        pass

    def WriteCustomData(
      self,
      _name: str,
      _list: TGIS_Strings
    ) -> None: 
        """
        Write custom configuration parameters.

        Args:
            _name: name of custom section
            _list: list of parameters in a form of "name=value"

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteCustomData_String_TGIS_Strings
        """
        pass

    def WriteDormant(
      self,
      _name: str,
      _value: TGIS_LayerDormantMode,
      _default: TGIS_LayerDormantMode
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteDormant_String_TGIS_LayerDormantMode_TGIS_LayerDormantMode
        """
        pass

    def WriteFloat(
      self,
      _name: str,
      _value: float,
      _default: float
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteFloat_String_Double_Double
        """
        pass

    def WriteFontStyle(
      self,
      _name: str,
      _value: typing.Sequence[TGIS_FontStyle],
      _default: typing.Sequence[TGIS_FontStyle]
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteFontStyle_String_TGIS_FontStyles_TGIS_FontStyles
        """
        pass

    def WriteGround(
      self,
      _name: str,
      _value: TGIS_3DGroundType,
      _default: TGIS_3DGroundType
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteGround_String_TGIS_3DGroundType_TGIS_3DGroundType
        """
        pass

    def WriteHierarchyGroups(
      self,
      _viewer: IGIS_Viewer
    ) -> None: 
        """
        Write hierarchy groups to config.

        Args:
            _viewer: viewer for which project will be constructed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteHierarchyGroups_IGIS_Viewer
        """
        pass

    def WriteInteger(
      self,
      _name: str,
      _value: int,
      _default: int
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteInteger_String_Integer_Integer
        """
        pass

    def WriteInterpretation(
      self,
      _name: str,
      _value: TGIS_LayerPixelInterpretation,
      _default: TGIS_LayerPixelInterpretation
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteInterpretation_String_TGIS_LayerPixelInterpretation_TGIS_LayerPixelInterpretation
        """
        pass

    def WriteMarker(
      self,
      _name: str,
      _value: TGIS_MarkerStyle,
      _default: TGIS_MarkerStyle
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteMarker_String_TGIS_MarkerStyle_TGIS_MarkerStyle
        """
        pass

    def WriteNormalized(
      self,
      _name: str,
      _value: TGIS_3DNormalizationType,
      _default: TGIS_3DNormalizationType
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteNormalized_String_TGIS_3DNormalizationType_TGIS_3DNormalizationType
        """
        pass

    def WriteOffsetPosition(
      self,
      _name: str,
      _value: TGIS_OffsetPosition,
      _default: TGIS_OffsetPosition
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteOffsetPosition_String_TGIS_OffsetPosition_TGIS_OffsetPosition
        """
        pass

    def WritePattern(
      self,
      _name: str,
      _value: TGIS_BrushStyle,
      _default: TGIS_BrushStyle
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WritePattern_String_TGIS_BrushStyle_TGIS_BrushStyle
        """
        pass

    def WritePen(
      self,
      _name: str,
      _value: TGIS_PenStyle,
      _default: TGIS_PenStyle
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WritePen_String_TGIS_PenStyle_TGIS_PenStyle
        """
        pass

    def WritePosition(
      self,
      _name: str,
      _value: typing.Sequence[TGIS_LabelPosition],
      _default: typing.Sequence[TGIS_LabelPosition]
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WritePosition_String_TGIS_LabelPositions_TGIS_LabelPositions
        """
        pass

    def WriteString(
      self,
      _name: str,
      _value: str,
      _default: str
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteString_String_String_String
        """
        pass

    def WriteStyle(
      self,
      _name: str,
      _value: str,
      _default: str
    ) -> None: 
        """
        Write parameters given by _name. File based parameters will be saved as relative 
        to config path.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteStyle_String_String_String
        """
        pass

    def WriteSymbol(
      self,
      _name: str,
      _value: TGIS_SymbolAbstract,
      _default: TGIS_SymbolAbstract
    ) -> None: 
        """
        Write parameters given by _name.

        Args:
            _name: name of value
            _value: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteSymbol_String_TGIS_SymbolAbstract_TGIS_SymbolAbstract
        """
        pass

    def WriteZone(
      self,
      _name: str,
      _list: TGIS_StringList,
      _default: TGIS_StringList
    ) -> None: 
        """
        Write parameters given by zone _name.

        Args:
            _name: name of value
            _list: value of the parameter
            _default: default value of the parameter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteZone_String_TGIS_StringList_TGIS_StringList
        """
        pass

    @property
    def ConfigFormat(
      self
    ) -> TGIS_ConfigFormat: 
        """
        Internal format of config.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.ConfigFormat
        """
        pass

    @property
    def FileName(
      self
    ) -> str: 
        """
        Name of configuration file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.FileName
        """
        pass

    @property
    def IsProject(
      self
    ) -> bool: 
        """
        True if config file is a project.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.IsProject
        """
        pass

    @property
    def IsShapeStyle(
      self
    ) -> bool: 
        """
        True if config is for shape style embedding.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.IsShapeStyle
        """
        pass

    @property
    def MustSave(
      self
    ) -> bool: 
        """
        True if config file was changed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.MustSave
        """
        pass

    
    def PrjLayerConfig(
      self,
      _index: int
    ) -> str: 
        """
        Config file name (without extension) at a given index in a project file.

        Args:
            _index: index of layer

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.PrjLayerConfig
        """
        pass

    
    def PrjLayerName(
      self,
      _index: int
    ) -> str: 
        """
        Name of layer at a given index in a project file.

        Args:
            _index: index of layer

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.PrjLayerName
        """
        pass

    
    def PrjLayerPath(
      self,
      _index: int
    ) -> str: 
        """
        Path of layer at a given index in a project file.

        Args:
            _index: index of layer

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.PrjLayerPath
        """
        pass

    @property
    def PrjLayersCount(
      self
    ) -> int: 
        """
        Returns the number of layers defined in project config file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.PrjLayersCount
        """
        pass

    @property
    def Section(
      self
    ) -> str: 
        """
        By assigning this value you are overriding default TGIS_Config behavior. The read/write 
        will be performed based on provide section.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.Section
        """
        pass

    @Section.setter
    def Section(
      self,
      _value: str
    ) -> None: 
        """
        By assigning this value you are overriding default TGIS_Config behavior. The read/write 
        will be performed based on provide section.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.Section
        """
        pass

    @property
    def UseRelativePath(
      self
    ) -> bool: 
        """
        If True (default) all paths will be save as relative to a config file localization.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.UseRelativePath
        """
        pass

    @UseRelativePath.setter
    def UseRelativePath(
      self,
      _value: bool
    ) -> None: 
        """
        If True (default) all paths will be save as relative to a config file localization.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.UseRelativePath
        """
        pass

    @property
    def Version(
      self
    ) -> int: 
        """
        Config version number

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.Version
        """
        pass

    @property
    def WriteFull(
      self
    ) -> bool: 
        """
        If True (default) then all config keys will be saved, otherwise only changed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteFull
        """
        pass

    @WriteFull.setter
    def WriteFull(
      self,
      _value: bool
    ) -> None: 
        """
        If True (default) then all config keys will be saved, otherwise only changed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Config.WriteFull
        """
        pass

class TGIS_ConfigFactory:
    """
    Encapsulation of configuration file factory.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigFactory
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigFactory.Create_void
        """
        pass

    @classmethod
    def CreateConfig(
      cls,
      _layer: TObject,
      _path: str
    ) -> TGIS_Config: 
        """
        Create a config instance based on a path extension.

        Args:
            _layer: pointer to layer object
            _path: full path to project configuration file; can be empty; if so then only layer 
              dependent files are to be used

        Returns:
            new config instance

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigFactory.CreateConfig_TObject_String
        """
        pass

    @classmethod
    def IsProject(
      cls,
      _path: str
    ) -> bool: 
        """
        Check if a config is a project.

        Args:
            _path: full path to project configuration file; can be empty; if so then only layer 
              dependent files are to be used

        Returns:
            new config instance

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigFactory.IsProject_String
        """
        pass

class TGIS_ConfigIni( TGIS_Config ):
    """
    Encapsulation of layer configuration file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigIni
    """

    @overload
    def __init__(
      self,
      _layer: TObject,
      _path: str
    ) -> None: 
        """
        Create instance.

        Args:
            _layer: pointer to layer object
            _path: full path to project configuration file; can be empty; if so then only layer 
              dependent files are to be used

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigIni.Create_TObject_String
        """
        pass

    @property
    def IniObj(
      self
    ) -> TGIS_IniFile: 
        """
        Underlying ini file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigIni.IniObj
        """
        pass

class TGIS_ConfigProjectIni( TGIS_ConfigIni ):
    """
    Encapsulation of project configuration file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigProjectIni
    """

class TGIS_ConfigShapeStyle( TGIS_ConfigIni ):
    """
    Encapsulation of shape level style.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigShapeStyle
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigShapeStyle.Create_void
        """
        pass

    @property
    def Text(
      self
    ) -> str: 
        """
        Style content.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigShapeStyle.Text
        """
        pass

    @Text.setter
    def Text(
      self,
      _value: str
    ) -> None: 
        """
        Style content.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigShapeStyle.Text
        """
        pass

class TGIS_ConfigXml( TGIS_Config ):
    """
    Encapsulation of layer configuration file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigXml
    """

    @overload
    def __init__(
      self,
      _layer: TObject,
      _path: str
    ) -> None: 
        """
        Create instance.

        Args:
            _layer: pointer to layer object
            _path: full path to project configuration file; can be empty; if so then only layer 
              dependent files are to be used

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigXml.Create_TObject_String
        """
        pass

class TGIS_ConfigProjectXml( TGIS_ConfigXml ):
    """
    Encapsulation of project configuration file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigProjectXml
    """

class TGIS_ContourGeneratorMode:
    pass

class TGIS_ContourGeneratorMode:
    """
    Specifies output type for contouring process.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGeneratorMode
    """

    @property
    def Polylines(
      self
    ) -> TGIS_ContourGeneratorMode: 
        """
        Plain polylines like the contouring algorithm provide.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGeneratorMode.Polylines
        """
        pass

    @property
    def ClosedPolylines(
      self
    ) -> TGIS_ContourGeneratorMode: 
        """
        Force polylines'' closure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGeneratorMode.ClosedPolylines
        """
        pass

    @property
    def OverlappingPolygons(
      self
    ) -> TGIS_ContourGeneratorMode: 
        """
        Overlapping polygon shells where the lower limit value increase by ContourInterval 
        from ContourBase and upper equals maximum value of the source grid; for example 0..100, 
        10..100, 20..100, etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGeneratorMode.OverlappingPolygons
        """
        pass

    @property
    def Polygons(
      self
    ) -> TGIS_ContourGeneratorMode: 
        """
        Non-overlapping polygon bands with range of lower and upper limit equals ContourInterval; 
        for example 0..10, 10..20, 20..30, etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGeneratorMode.Polygons
        """
        pass

class TGIS_ContourGenerator( TObject ):
    """
    Implementation of the contour (isohypse) generation algorithm for grid/DEM layers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.Create_void
        """
        pass

    @overload
    def CalculateInterval(
      self,
      _src: TGIS_LayerPixel
    ) -> None: 
        """
        Calculates ContourInterval for default 20 levels and sets ContourBase to the lowest 
        value of the source layer.

        Args:
            _src: source grid layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.CalculateInterval_TGIS_LayerPixel
        """
        pass

    @overload
    def CalculateInterval(
      self,
      _src: TGIS_LayerPixel,
      _cnt: int
    ) -> None: 
        """
        Calculates ContourInterval for the given number of levels and sets ContourBase to 
        the lowest value of the source layer.

        Args:
            _src: source grid layer
            _cnt: number of levels

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.CalculateInterval_TGIS_LayerPixel_Integer
        """
        pass

    @overload
    def Generate(
      self,
      _src: TGIS_LayerPixel,
      _dst: TGIS_LayerVector,
      _dstfld: str
    ) -> bool: 
        """
        Creates vector contours from a raster grid layer.

        Args:
            _src: source grid layer
            _dst: destination vector layer, must have the same CS as the source layer
            _dstfld: if not empty the attribute field of the specified name will be populated 
              with the elevation values of the contours

        Returns:
            True if the process was completed successfully; False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.Generate_TGIS_LayerPixel_TGIS_LayerVector_String
        """
        pass

    @overload
    def Generate(
      self,
      _src: TGIS_LayerPixel,
      _dst: TGIS_LayerVector,
      _dstfld: str,
      _dstfld_interval: str
    ) -> bool: 
        """
        Creates vector contours from a raster grid layer.

        Args:
            _src: source grid layer
            _dst: destination vector layer, must have the same CS as the source layer
            _dstfld: if not empty the field of the specified name will be populated with the 
              elevation values of the contours
            _dstfld_interval: if not empty the field of the specified name will be populated 
              with the contours'' intervals; only for polygonal contours

        Returns:
            True if the process was completed successfully; False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.Generate_TGIS_LayerPixel_TGIS_LayerVector_String_String
        """
        pass

    @property
    def ContourBase(
      self
    ) -> float: 
        """
        The "base" relative to which contour intervals are applied. To generate 10m contours 
        at 5, 15, 25, ... the ContourBase would be 5.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.ContourBase
        """
        pass

    @ContourBase.setter
    def ContourBase(
      self,
      _value: float
    ) -> None: 
        """
        The "base" relative to which contour intervals are applied. To generate 10m contours 
        at 5, 15, 25, ... the ContourBase would be 5.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.ContourBase
        """
        pass

    @property
    def ContourInterval(
      self
    ) -> float: 
        """
        The elevation interval between generated contours.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.ContourInterval
        """
        pass

    @ContourInterval.setter
    def ContourInterval(
      self,
      _value: float
    ) -> None: 
        """
        The elevation interval between generated contours.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.ContourInterval
        """
        pass

    @property
    def CustomNoData(
      self
    ) -> bool: 
        """
        If True the NoDataValue will be used as nodata value; default is False

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.CustomNoData
        """
        pass

    @CustomNoData.setter
    def CustomNoData(
      self,
      _value: bool
    ) -> None: 
        """
        If True the NoDataValue will be used as nodata value; default is False

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.CustomNoData
        """
        pass

    @property
    def FixedLevelCount(
      self
    ) -> int: 
        """
        The number of elements in FixedLevels property.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.FixedLevelCount
        """
        pass

    @property
    def FixedLevels(
      self
    ) -> TGIS_DoubleArray: 
        """
        The list of fixed levels at which contours should be generated. If not empty then 
        ContourInterval and ContourBase are ignored.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.FixedLevels
        """
        pass

    @FixedLevels.setter
    def FixedLevels(
      self,
      _value: TGIS_DoubleArray
    ) -> None: 
        """
        The list of fixed levels at which contours should be generated. If not empty then 
        ContourInterval and ContourBase are ignored.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.FixedLevels
        """
        pass

    @property
    def MinSize(
      self
    ) -> float: 
        """
        Minimum dimension in meters for generated features; Minimum length for polylines, 
        minimum area for polygons.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.MinSize
        """
        pass

    @MinSize.setter
    def MinSize(
      self,
      _value: float
    ) -> None: 
        """
        Minimum dimension in meters for generated features; Minimum length for polylines, 
        minimum area for polygons.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.MinSize
        """
        pass

    @property
    def Mode(
      self
    ) -> TGIS_ContourGeneratorMode: 
        """
        Type of contour generator output; default is Polylines.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.Mode
        """
        pass

    @Mode.setter
    def Mode(
      self,
      _value: TGIS_ContourGeneratorMode
    ) -> None: 
        """
        Type of contour generator output; default is Polylines.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.Mode
        """
        pass

    @property
    def NoDataValue(
      self
    ) -> float: 
        """
        The value to use as a NoData value. A pixel value which should be ignored in generating 
        contours; default is -9999

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.NoDataValue
        """
        pass

    @NoDataValue.setter
    def NoDataValue(
      self,
      _value: float
    ) -> None: 
        """
        The value to use as a NoData value. A pixel value which should be ignored in generating 
        contours; default is -9999

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.NoDataValue
        """
        pass

    @property
    def Smoothen(
      self
    ) -> bool: 
        """
        If True then the generated contours will be smoothened. Use carefully when creating 
        polygon output because it may produce invalid geometry.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.Smoothen
        """
        pass

    @Smoothen.setter
    def Smoothen(
      self,
      _value: bool
    ) -> None: 
        """
        If True then the generated contours will be smoothened. Use carefully when creating 
        polygon output because it may produce invalid geometry.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.Smoothen
        """
        pass

    @property
    def SmoothFactor(
      self
    ) -> int: 
        """
        Smooth factor. Default value is 5.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.SmoothFactor
        """
        pass

    @SmoothFactor.setter
    def SmoothFactor(
      self,
      _value: int
    ) -> None: 
        """
        Smooth factor. Default value is 5.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.SmoothFactor
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContourGenerator.BusyEvent
        """
        pass

class TGIS_CSUnitsType:
    pass

class TGIS_CSUnitsType:
    """
    Type of units.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnitsType
    """

    @property
    def Linear(
      self
    ) -> TGIS_CSUnitsType: 
        """
        Linear units like meters, miles.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnitsType.Linear
        """
        pass

    @property
    def Angular(
      self
    ) -> TGIS_CSUnitsType: 
        """
        Angular units like radians, degrees.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnitsType.Angular
        """
        pass

    @property
    def Areal(
      self
    ) -> TGIS_CSUnitsType: 
        """
        Areal units like hectares, ares.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnitsType.Areal
        """
        pass

    @property
    def Auto(
      self
    ) -> TGIS_CSUnitsType: 
        """
        Autoselect units like metric or US.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnitsType.Auto
        """
        pass

class TGIS_CSAbstract( TObject ):
    """
    Base class for any WKT units

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstract.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the unit
            _wkt: WKT name for the unit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstract.Create_Integer_String
        """
        pass

    def Assign(
      self,
      _source: TObject
    ) -> None: 
        """
        Copy content of the provided object into a current object

        Args:
            _source: object form which content will be copied

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstract.Assign_TObject
        """
        pass

    def MarkDeprecated(
      self,
      _deprecated: bool
    ) -> None: 
        """
        Set object depreciation state.

        Args:
            _deprecated: if true

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstract.MarkDeprecated_Boolean
        """
        pass

    @property
    def Deprecated(
      self
    ) -> bool: 
        """
        If true, then object is deprecated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstract.Deprecated
        """
        pass

    @property
    def Description(
      self
    ) -> str: 
        """
        Additional description.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstract.Description
        """
        pass

    @property
    def DescriptionEx(
      self
    ) -> str: 
        """
        Descriptive name; for internal use of TGIS_CSAbstractListHelper.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstract.DescriptionEx
        """
        pass

    @DescriptionEx.setter
    def DescriptionEx(
      self,
      _value: str
    ) -> None: 
        """
        Descriptive name; for internal use of TGIS_CSAbstractListHelper.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstract.DescriptionEx
        """
        pass

    @property
    def EPSG(
      self
    ) -> int: 
        """
        EPSG code.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstract.EPSG
        """
        pass

    @property
    def FriendlyName(
      self
    ) -> str: 
        """
        Friendly name constructed based on WKT (without underscores) and EPSG.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstract.FriendlyName
        """
        pass

    @property
    def MasterEPSG(
      self
    ) -> int: 
        """
        EPSG code of the object for which current object is an alias.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstract.MasterEPSG
        """
        pass

    @property
    def WKT(
      self
    ) -> str: 
        """
        WKT name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstract.WKT
        """
        pass

class TGIS_CSAbstractListEnumerator( TObject ):
    """
    Enumerator for TGIS_CSAbstractList.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractListEnumerator
    """

    @overload
    def __init__(
      self,
      _list: TGIS_CSAbstractList
    ) -> None: 
        """
        Create an instance.

        Args:
            _list: list handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractListEnumerator.Create_TGIS_CSAbstractList
        """
        pass

    def GetCurrent(
      self
    ) -> TGIS_CSAbstract: 
        """
        Property Current access function.

        Returns:
            Shape itself or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractListEnumerator.GetCurrent_void
        """
        pass

    def MoveNext(
      self
    ) -> bool: 
        """
        Move next.

        Returns:
            If false then there is no more objects.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractListEnumerator.MoveNext_void
        """
        pass

    def Reset(
      self
    ) -> None: 
        """
        Reset enumerator.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractListEnumerator.Reset_void
        """
        pass

    @property
    def Current(
      self
    ) -> TGIS_CSAbstract: 
        """
        Current enumerator value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractListEnumerator.Current
        """
        pass

class TGIS_CSAbstractList( TGIS_ThreadClass ):
    """
    Base class for any WKT unit list

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractList
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractList.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _lst: TGIS_CSAbstractList
    ) -> None: 
        """
        Create an instance and attach it to existing global list.

        Args:
            _lst: pointer to existing global list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractList.Create_TGIS_CSAbstractList
        """
        pass

    @overload
    def __init__(
      self,
      _lst: TGIS_CSAbstractList,
      _unique_id: bool,
      _unique_wkt: bool
    ) -> None: 
        """
        Create an instance and attach it to existing global list.

        Args:
            _lst: pointer to existing global list
            _unique_id: if true the exception will be raised if object ID is not unique
            _unique_wkt: if true the exception will be raised if object WKT is not unique

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractList.Create_TGIS_CSAbstractList_Boolean_Boolean
        """
        pass

    def Add(
      self,
      _obj: TGIS_CSAbstract
    ) -> TGIS_CSAbstract: 
        """
        Add new item into the list.

        Args:
            _obj: object to be added

        Returns:
            Object itself.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractList.Add_TGIS_CSAbstract
        """
        pass

    def AddAlias(
      self,
      _epsg: int,
      _wkt: str,
      _master: int
    ) -> None: 
        """
        Add new item being alias to an existing one.

        Args:
            _epsg: EPSG code for the unit
            _wkt: WKT name for the unit
            _master: code of the master item

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractList.AddAlias_Integer_String_Integer
        """
        pass

    def Alias(
      self,
      _epsg: int,
      _master: int
    ) -> None: 
        """
        Define alias between two items.

        Args:
            _epsg: code of the object which is an alias for the master object.
            _master: code of the master item

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractList.Alias_Integer_Integer
        """
        pass

    def ByEPSG(
      self,
      _epsg: int
    ) -> TGIS_CSAbstract: 
        """
        Find object on the list based on EPSG code.

        Args:
            _epsg: EPSG code

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractList.ByEPSG_Integer
        """
        pass

    def ByWKT(
      self,
      _wkt: str
    ) -> TGIS_CSAbstract: 
        """
        Find object on the list based on WKT string.

        Args:
            _wkt: WKT name

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractList.ByWKT_String
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list. Delete all objects.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractList.Clear_void
        """
        pass

    def Count(
      self
    ) -> int: 
        """
        Number of items on the list.

        Returns:
            Number of items on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractList.Count_void
        """
        pass

    def Fix(
      self,
      _obj: TGIS_CSAbstract
    ) -> TGIS_CSAbstract: 
        """
        Fix item by substituting existing item based on EPSG code.

        Args:
            _obj: matching object to be fixed

        Returns:
            Fixed object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractList.Fix_TGIS_CSAbstract
        """
        pass

    def GetEnumerator(
      self
    ) -> TGIS_CSAbstractListEnumerator: 
        """
        Get enumerator.

        Returns:
            Enumerator object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractList.GetEnumerator_void
        """
        pass

    def Init(
      self
    ) -> None: 
        """
        Initialize list form definition. Call this if you want to reconstruct list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractList.Init_void
        """
        pass

    
    def WKTObject(
      self,
      _idx: int
    ) -> TGIS_CSAbstract: 
        """
        Default property for retrieving list element.

        Args:
            _idx: position on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAbstractList.WKTObject
        """
        pass

class TGIS_CSUnits( TGIS_CSAbstract ):
    """
    Unit of measurement (linear, angular or areal)

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnits
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnits.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _subunits: int
    ) -> None: 
        """
        Create an instance of automatic units

        Args:
            _epsg: EPSG code for the unit
            _wkt: WKT name for the unit
            _subunits: list of units in a set ordered by factor; if contains areal units then 
              order should be by squared factor of all units except areas

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnits.Create_Integer_String_arrayInteger
        """
        pass

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _symbol: str,
      _type: TGIS_CSUnitsType,
      _factor: float
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the unit
            _wkt: WKT name for the unit
            _symbol: units symbol like ''km'', ''m''
            _type: angular, linear or areal units
            _factor: factor between unit and basic unit (meter or radians); for example factor 
              for kilometer is 1000.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnits.Create_Integer_String_String_TGIS_CSUnitsType_Double
        """
        pass

    def AsAngular(
      self,
      _value: float,
      _prec: bool
    ) -> str: 
        """
        Convert units as annular to string representation with proper units symbol.

        Args:
            _value: units in base metric
            _prec: if true then fixed decimal digits will be presented; if false then only significant 
              digits (no trailing zeros) will be presented

        Returns:
            Units converted to string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnits.AsAngular_Double_Boolean
        """
        pass

    def AsAreal(
      self,
      _value: float,
      _prec: bool,
      _format: str
    ) -> str: 
        """
        Convert units as areal to string representation with proper units symbol.

        Args:
            _value: units in base metric
            _prec: if true then fixed decimal digits will be presented; if false then only significant 
              digits (no trailing zeros) will be presented
            _format: hint of how to present linear symbols: for example by providing ''sq. %s'' 
              linear symbols will be presented as ''1 sq. km''

        Returns:
            Units converted to string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnits.AsAreal_Double_Boolean_String
        """
        pass

    def AsLinear(
      self,
      _value: float,
      _prec: bool
    ) -> str: 
        """
        Convert units as linear to string representation with proper units symbol.

        Args:
            _value: units in base metric
            _prec: if true then fixed decimal digits will be presented; if false then only significant 
              digits (no trailing zeros) will be presented

        Returns:
            Units converted to string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnits.AsLinear_Double_Boolean
        """
        pass

    def AutoSelect(
      self,
      _areal: bool,
      _value: VarParameter
    ) -> TGIS_CSUnits: 
        """
        Returned the most appropriate sub unit for selected value.

        Args:
            _areal: if true select areal units, if false select linear.
            _value: units in base metric; the value (in/out) is passed as float in _value.Value 
              property

        Returns:
            Units converted to string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnits.AutoSelect_Boolean_Double
        """
        pass

    def FromBase(
      self,
      _value: float
    ) -> float: 
        """
        Convert value provided in basic unit (meter or radians) into the value represented 
        by current unit. Basic units are meter, radian, square meter

        Args:
            _value: value to be converted

        Returns:
            Value converted to current units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnits.FromBase_Double
        """
        pass

    def FromUnits(
      self,
      _units: TGIS_CSUnits,
      _value: float
    ) -> float: 
        """
        Convert value provided in current unit into basic unit (meter or radians) .

        Args:
            _units: desired units system to be converted to
            _value: value to be converted

        Returns:
            Value converted to current units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnits.FromUnits_TGIS_CSUnits_Double
        """
        pass

    def ToBase(
      self,
      _value: float
    ) -> float: 
        """
        Convert value provided in current unit into basic unit (meter or radians) . Basic 
        units are meter, radian, square meter

        Args:
            _value: value to be converted

        Returns:
            Value converted to base units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnits.ToBase_Double
        """
        pass

    def ToUnits(
      self,
      _units: TGIS_CSUnits,
      _value: float
    ) -> float: 
        """
        Convert value provided in basic unit (meter or radians) into the value represented 
        by current unit.

        Args:
            _units: desired units system to be converted to
            _value: value to be converted

        Returns:
            Value converted to defined units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnits.ToUnits_TGIS_CSUnits_Double
        """
        pass

    @property
    def Factor(
      self
    ) -> float: 
        """
        Factor between unit and basic unit (meter or radians); for example factor for kilometer 
        is 1000.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnits.Factor
        """
        pass

    @property
    def Symbol(
      self
    ) -> str: 
        """
        Symbolic name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnits.Symbol
        """
        pass

    @property
    def UnitsType(
      self
    ) -> TGIS_CSUnitsType: 
        """
        Type of units: angular, linear, areal.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnits.UnitsType
        """
        pass

class TGIS_CSPrimeMeridian( TGIS_CSAbstract ):
    """
    Prime meridians.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSPrimeMeridian
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _longitude: float
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the unit
            _wkt: WKT name for the unit
            _longitude: Longitude of prime meridian (in radians)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSPrimeMeridian.Create_Integer_String_Double
        """
        pass

    @property
    def Longitude(
      self
    ) -> float: 
        """
        Longitude of prime meridian (in radians).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSPrimeMeridian.Longitude
        """
        pass

class TGIS_CSEllipsoid( TGIS_CSAbstract ):
    """
    An ellipsoid item.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _semi_major: float,
      _inv_flattering: float
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the ellipsoid
            _wkt: WKT name for the ellipsoid
            _semi_major: semi major axis
            _inv_flattering: inverse flattering; 0 for spheroid

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid.Create_Integer_String_Double_Double
        """
        pass

    def Distance(
      self,
      _ptg_a: TGIS_Point,
      _ptg_b: TGIS_Point
    ) -> float: 
        """
        Calculates distance over Great Circle

        Args:
            _ptg_a: start point; longitude &amp; latitude must be expressed in radians
            _ptg_b: end point; longitude &amp; latitude must be expressed in radians

        Returns:
            Computed distance in meters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid.Distance_TGIS_Point_TGIS_Point
        """
        pass

    def ToGeocentric(
      self,
      _coords: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Convert coordinates from geodetic mode to ellipsoid base (geocentric).

        Args:
            _coords: coordinates in geodetic space (radians)

        Returns:
            Converted coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid.ToGeocentric_TGIS_Point3D
        """
        pass

    def ToGeocentric_Ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Convert point from geodetic to geocentric system.

        Args:
            _ptg: point in geodetic system; the value (in/out) is passed as TGIS_Point3D in _ptg.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid.ToGeocentric_Ref_TGIS_Point3D
        """
        pass

    def ToGeodetic(
      self,
      _coords: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Convert coordinates from an ellipsoid base (geocentric) to geodetic mode.

        Args:
            _coords: coordinates in geocentric space (meters)

        Returns:
            Converted coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid.ToGeodetic_TGIS_Point3D
        """
        pass

    def ToGeodetic_Ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Convert point from geocentric to geodetic system.

        Args:
            _ptg: point in geocentric system; the value (in/out) is passed as TGIS_Point3D in 
              _ptg.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid.ToGeodetic_Ref_TGIS_Point3D
        """
        pass

    @property
    def EcntrMajor(
      self
    ) -> float: 
        """
        Eccentricity squared. Pre-calculated for optimization purposes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid.EcntrMajor
        """
        pass

    @property
    def EcntrMajorSqrt(
      self
    ) -> float: 
        """
        Eccentricity sqrt. Pre-calculated for optimization purposes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid.EcntrMajorSqrt
        """
        pass

    @property
    def EcntrMinor(
      self
    ) -> float: 
        """
        Second eccentricity squared. Pre-calculated for optimization purposes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid.EcntrMinor
        """
        pass

    @property
    def EcntrMinorSqrt(
      self
    ) -> float: 
        """
        Eccentricity sqrt. Pre-calculated for optimization purposes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid.EcntrMinorSqrt
        """
        pass

    @property
    def Flattering(
      self
    ) -> float: 
        """
        Flattering. Equal 0 for spheroid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid.Flattering
        """
        pass

    @property
    def InverseFlattering(
      self
    ) -> float: 
        """
        Inverse Flattering. Equal 0 for spheroid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid.InverseFlattering
        """
        pass

    @property
    def SemiMajor(
      self
    ) -> float: 
        """
        Semimajor axis.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid.SemiMajor
        """
        pass

    @property
    def SemiMajorSq(
      self
    ) -> float: 
        """
        Square of semimajor axis. Pre-calculated for optimization purposes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid.SemiMajorSq
        """
        pass

    @property
    def SemiMinor(
      self
    ) -> float: 
        """
        Semiminor axis.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid.SemiMinor
        """
        pass

    @property
    def SemiMinorSq(
      self
    ) -> float: 
        """
        Square of semiminor axis. Pre-calculated for optimization purposes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoid.SemiMinorSq
        """
        pass

class TGIS_CSArea( TGIS_CSAbstract ):
    """
    Area name.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSArea
    """

    @property
    def Bounds(
      self
    ) -> TGIS_Extent: 
        """
        Area validity bounds.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSArea.Bounds
        """
        pass

class TGIS_CSDatum( TGIS_CSAbstract ):
    """
    A datum type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatum
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _transform: int
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the unit
            _wkt: WKT name for the unit
            _ellipsoid: EPSG code for ellipsoid
            _transform: EPSG code of default coordinate operation

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatum.Create_Integer_String_Integer_Integer
        """
        pass

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _transform: int,
      _fallback: int
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the unit
            _wkt: WKT name for the unit
            _ellipsoid: EPSG code for ellipsoid
            _transform: EPSG code of default coordinate operation
            _fallback: EPSG code of fallback coordinate operation (used only for grid-shift if 
              grid-shift file can not be used)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatum.Create_Integer_String_Integer_Integer_Integer
        """
        pass

    def FromWGS(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        This function shifts a geodetic coordinate relative to WGS84 into a geodetic coordinate 
        relative to a self-datum .

        Args:
            _ptg: given coordinates

        Returns:
            Converted coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatum.FromWGS_TGIS_Point
        """
        pass

    def FromWGS3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        This function shifts a geodetic coordinate relative to WGS84 into a geodetic coordinate 
        relative to a self-datum .

        Args:
            _ptg: given coordinates

        Returns:
            Converted coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatum.FromWGS3D_TGIS_Point3D
        """
        pass

    def FromWGS3D_Ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        This function shifts a geodetic coordinate relative to WGS84 into a geodetic coordinate 
        relative to a self-datum.

        Args:
            _ptg: coordinates to be shifted; the value (in/out) is passed as TGIS_Point3D in 
              _ptg.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatum.FromWGS3D_Ref_TGIS_Point3D
        """
        pass

    def ToWGS(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        This function shifts a geodetic coordinate relative to a self-datum into a geodetic 
        coordinate relative to WGS84.

        Args:
            _ptg: given coordinates

        Returns:
            Converted coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatum.ToWGS_TGIS_Point
        """
        pass

    def ToWGS3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        This function shifts a geodetic coordinate relative to a self-datum into a geodetic 
        coordinate relative to WGS84.

        Args:
            _ptg: given coordinates

        Returns:
            Converted coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatum.ToWGS3D_TGIS_Point3D
        """
        pass

    def ToWGS3D_Ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        This function shifts a geodetic coordinate relative to a self-datum into a geodetic 
        coordinate relative to WGS84.

        Args:
            _ptg: coordinates to be shifted; the value (in/out) is passed as TGIS_Point3D in 
              _ptg.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatum.ToWGS3D_Ref_TGIS_Point3D
        """
        pass

    @property
    def Ellipsoid(
      self
    ) -> TGIS_CSEllipsoid: 
        """
        Ellipsoid object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatum.Ellipsoid
        """
        pass

    @property
    def Fallback(
      self
    ) -> int: 
        """
        Fallback Coordinate Transformation object. Used if main grid shift based transformation 
        is not available.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatum.Fallback
        """
        pass

    @property
    def Transform(
      self
    ) -> TGIS_CSTransformAbstract: 
        """
        Default Coordinate Transformation object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatum.Transform
        """
        pass

class TGIS_CSTransformAbstract( TGIS_CSAbstract ):
    """
    A datum transformation type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _number: int,
      _area: int,
      _a: float,
      _b: float,
      _c: float,
      _d: float,
      _e: float,
      _f: float,
      _g: float,
      _h: float,
      _i: float,
      _j: float
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the transformation
            _wkt: WKT name for the transformation
            _ellipsoid: EPSG code for the ellipsoid
            _number: serial number of transformation for current datum
            _area: EPSG area code
            _a: For Methods 9603, 9606, 9607, 9636: X delta of geocentric shift expressed in 
              meters; For Methods 9618, 9119: latitude shift expressed in radians;
            _b: For Methods 9603, 9606, 9607, 9636: Y delta of geocentric shift expressed in 
              meters; For Methods 9618, 9119: longitude shift expressed in radians;
            _c: For Methods 9603, 9606, 9607, 9636: Z delta of geocentric shift expressed in 
              meters; For Method 9618: gravity height over the ellipsoid height; For Method 9619: 
              unused;
            _d: For Methods 9603, 9606, 9607, 9636: X rotation of geocentric expressed in radians; 
              For Methods 9603, 9618, 9619: unused;
            _e: For Methods 9603, 9606, 9607, 9636: Y rotation of geocentric expressed in radians; 
              For Methods 9603, 9618, 9619: unused;
            _f: For Methods 9603, 9606, 9607, 9636: Z rotation of geocentric expressed in radians; 
              For Methods 9603, 9618, 9619: unused;
            _g: For Methods 9603, 9606, 9607, 9636: scaled correction of geocentric relative 
              to 1; For Methods 9603, 9618: unused;
            _h: For Method 9636: X reference point in Cartesian system expressed in meters; For 
              Methods 9603, 9606, 9607, 9618, 9619: unused;
            _i: For Method 9636: Y reference point in Cartesian system expressed in meters; For 
              Methods 9603, 9606, 9607, 9618, 9619: unused;
            _j: For Method 9636: X reference point in Cartesian system expressed in meters; For 
              Methods 9603, 9606, 9607, 9618, 9619: unused;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.Create_Integer_String_Integer_Integer_Integer_CE7A92037E8B9828D27AC8ED00DFB0EB
        """
        pass

    def FromWGS(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        This function shifts a geodetic coordinate (in meters) relative to WGS84 to a geodetic 
        coordinate (in meters) relative to Datum.

        Args:
            _ptg: given coordinates

        Returns:
            Converted coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.FromWGS_TGIS_Point
        """
        pass

    def FromWGS3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        This function shifts a geodetic coordinate relative to WGS84 into a geodetic coordinate 
        relative to Datum. Conversion will be done by WGS-&gt;Geocentric-&gt;Coordinates- 
        pipeline.

        Args:
            _ptg: given coordinates

        Returns:
            Converted coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.FromWGS3D_TGIS_Point3D
        """
        pass

    def FromWGS3D_Ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        This method shifts a geodetic coordinate relative to WGS84 into a geodetic coordinate 
        relative to Datum.

        Args:
            _ptg: coordinates to be shifted; the value (in/out) is passed as TGIS_Point3D in 
              _ptg.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.FromWGS3D_Ref_TGIS_Point3D
        """
        pass

    def ToWGS(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        This function shifts a geodetic coordinate (in meters) relative to Datum into a geodetic 
        coordinate (in meters) relative to WGS84.

        Args:
            _ptg: given coordinates

        Returns:
            Converted coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.ToWGS_TGIS_Point
        """
        pass

    def ToWGS3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        This function shifts a geodetic coordinate relative to Datum into a geodetic coordinate 
        relative to WGS84. Conversion will be done by Coordinates-&gt;Geocentric-&gt;WGS 
        pipeline.

        Args:
            _ptg: given coordinates

        Returns:
            Converted coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.ToWGS3D_TGIS_Point3D
        """
        pass

    def ToWGS3D_Ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        This method shifts a geodetic coordinate relative to Datum into a geodetic coordinate 
        relative to WGS84.

        Args:
            _ptg: coordinates to be shifted; the value (in/out) is passed as TGIS_Point3D in 
              _ptg.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.ToWGS3D_Ref_TGIS_Point3D
        """
        pass

    @property
    def A(
      self
    ) -> float: 
        """
        For Methods 9603, 9606, 9607, 9636: X delta of geocentric shift expressed in meters; 
        For Methods 9618, 9119: latitude shift expressed in radians;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.A
        """
        pass

    @property
    def AreaEPSG(
      self
    ) -> int: 
        """
        Area EPSG code.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.AreaEPSG
        """
        pass

    @property
    def B(
      self
    ) -> float: 
        """
        For Methods 9603, 9606, 9607, 9636: Y delta of geocentric shift expressed in meters; 
        For Methods 9618, 9119: longitude shift expressed in radians;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.B
        """
        pass

    @property
    def C(
      self
    ) -> float: 
        """
        For Methods 9603, 9606, 9607, 9636: Z delta of geocentric shift expressed in meters; 
        For Method 9618: gravity height over the ellipsoid height; For Method 9619: unused;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.C
        """
        pass

    @property
    def D(
      self
    ) -> float: 
        """
        For Methods 9603, 9606, 9607, 9636: X rotation of geocentric expressed in radians; 
        For Methods 9603, 9618, 9619: unused;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.D
        """
        pass

    @property
    def E(
      self
    ) -> float: 
        """
        For Methods 9603, 9606, 9607, 9636: Y rotation of geocentric expressed in radians; 
        For Methods 9603, 9618, 9619: unused;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.E
        """
        pass

    @property
    def EllipsoidEPSG(
      self
    ) -> int: 
        """
        Ellipsoid object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.EllipsoidEPSG
        """
        pass

    @property
    def F(
      self
    ) -> float: 
        """
        For Methods 9603, 9606, 9607, 9636: Z rotation of geocentric expressed in radians; 
        For Methods 9603, 9618, 9619: unused;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.F
        """
        pass

    @property
    def G(
      self
    ) -> float: 
        """
        For Methods 9603, 9606, 9607, 9636: scaled correction of geocentric relative to 1; 
        For Methods 9603, 9618: unused;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.G
        """
        pass

    @property
    def GridShift(
      self
    ) -> str: 
        """
        For Method 9613 and 91615: Grid Shift file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.GridShift
        """
        pass

    @property
    def H(
      self
    ) -> float: 
        """
        For Method 9636: X reference point in Cartesian system expressed in meters; For Methods 
        9603, 9606, 9607, 9618, 9619: unused;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.H
        """
        pass

    @property
    def I(
      self
    ) -> float: 
        """
        For Method 9636: Y reference point in Cartesian system expressed in meters; For Methods 
        9603, 9606, 9607, 9618, 9619: unused;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.I
        """
        pass

    @property
    def J(
      self
    ) -> float: 
        """
        For Method 9636: X reference point in Cartesian system expressed in meters; For Methods 
        9603, 9606, 9607, 9618, 9619: unused;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.J
        """
        pass

    @property
    def Method(
      self
    ) -> int: 
        """
        Method EPSG code.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.Method
        """
        pass

    @property
    def Number(
      self
    ) -> int: 
        """
        Serial number of transformation for current datum.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformAbstract.Number
        """
        pass

class TGIS_CSTransformGeocentricTranslations( TGIS_CSTransformAbstract ):
    """
    A datum transformation type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformGeocentricTranslations
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _number: int,
      _area: int,
      _a: float,
      _b: float,
      _c: float,
      _d: float,
      _e: float,
      _f: float,
      _g: float,
      _h: float,
      _i: float,
      _j: float
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the transformation
            _wkt: WKT name for the transformation
            _ellipsoid: EPSG code for the ellipsoid
            _number: serial number of transformation for current datum
            _area: EPSG area code
            _a: X delta of geocentric shift expressed in meters
            _b: Y delta of geocentric shift expressed in meters
            _c: Z delta of geocentric shift expressed in meters
            _d: unused
            _e: unused
            _f: unused
            _g: unused
            _h: unused
            _i: unused
            _j: unused

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformGeocentricTranslations.Create_Integer_String_Integer_Integer_Integer_CE7A92037E8B9828D27AC8ED00DFB0EB
        """
        pass

class TGIS_CSTransformPositionVector7Params( TGIS_CSTransformAbstract ):
    """
    A datum transformation type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformPositionVector7Params
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _number: int,
      _area: int,
      _a: float,
      _b: float,
      _c: float,
      _d: float,
      _e: float,
      _f: float,
      _g: float,
      _h: float,
      _i: float,
      _j: float
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the transformation
            _wkt: WKT name for the transformation
            _ellipsoid: EPSG code for the ellipsoid
            _number: serial number of transformation for current datum
            _area: EPSG area code
            _a: X delta of geocentric shift expressed in meters
            _b: Y delta of geocentric shift expressed in meters
            _c: Z delta of geocentric shift expressed in meters
            _d: X rotation of geocentric expressed in radians
            _e: Y rotation of geocentric expressed in radians
            _f: Z rotation of geocentric expressed in radians
            _g: scaled correction of geocentric relative to 1
            _h: unused
            _i: unused
            _j: unused

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformPositionVector7Params.Create_Integer_String_Integer_Integer_Integer_CE7A92037E8B9828D27AC8ED00DFB0EB
        """
        pass

class TGIS_CSTransformCoordinateFrameRotation( TGIS_CSTransformAbstract ):
    """
    A datum transformation type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformCoordinateFrameRotation
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _number: int,
      _area: int,
      _a: float,
      _b: float,
      _c: float,
      _d: float,
      _e: float,
      _f: float,
      _g: float,
      _h: float,
      _i: float,
      _j: float
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the transformation
            _wkt: WKT name for the transformation
            _ellipsoid: EPSG code for the ellipsoid
            _number: serial number of transformation for current datum
            _area: EPSG area code
            _a: X delta of geocentric shift expressed in meters
            _b: Y delta of geocentric shift expressed in meters
            _c: Z delta of geocentric shift expressed in meters
            _d: X rotation of geocentric expressed in radians
            _e: Y rotation of geocentric expressed in radians
            _f: Z rotation of geocentric expressed in radians
            _g: scaled correction of geocentric relative to 1
            _h: unused
            _i: unused
            _j: unused

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformCoordinateFrameRotation.Create_Integer_String_Integer_Integer_Integer_CE7A92037E8B9828D27AC8ED00DFB0EB
        """
        pass

class TGIS_CSTransformGeographicalAndHighOffsets( TGIS_CSTransformAbstract ):
    """
    A datum transformation type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformGeographicalAndHighOffsets
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _number: int,
      _area: int,
      _a: float,
      _b: float,
      _c: float,
      _d: float,
      _e: float,
      _f: float,
      _g: float,
      _h: float,
      _i: float,
      _j: float
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the transformation
            _wkt: WKT name for the transformation
            _ellipsoid: EPSG code for the ellipsoid
            _number: serial number of transformation for current datum
            _area: EPSG area code
            _a: latitude shift expressed in radians
            _b: longitude shift expressed in radians
            _c: gravity height over the ellipsoid height
            _d: unused
            _e: unused
            _f: unused
            _g: unused
            _h: unused
            _i: unused
            _j: unused

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformGeographicalAndHighOffsets.Create_Integer_String_Integer_Integer_Integer_CE7A92037E8B9828D27AC8ED00DFB0EB
        """
        pass

class TGIS_CSTransformGeographicalOffsets( TGIS_CSTransformAbstract ):
    """
    A datum transformation type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformGeographicalOffsets
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _number: int,
      _area: int,
      _a: float,
      _b: float,
      _c: float,
      _d: float,
      _e: float,
      _f: float,
      _g: float,
      _h: float,
      _i: float,
      _j: float
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the transformation
            _wkt: WKT name for the transformation
            _ellipsoid: EPSG code for the ellipsoid
            _number: serial number of transformation for current datum
            _area: EPSG area code
            _a: latitude shift expressed in radians
            _b: longitude shift expressed in radians
            _c: unused
            _d: unused
            _e: unused
            _f: unused
            _g: unused
            _h: unused
            _i: unused
            _j: unused

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformGeographicalOffsets.Create_Integer_String_Integer_Integer_Integer_CE7A92037E8B9828D27AC8ED00DFB0EB
        """
        pass

class TGIS_CSTransformMolodenskiBadekas( TGIS_CSTransformAbstract ):
    """
    A datum transformation type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformMolodenskiBadekas
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _number: int,
      _area: int,
      _a: float,
      _b: float,
      _c: float,
      _d: float,
      _e: float,
      _f: float,
      _g: float,
      _h: float,
      _i: float,
      _j: float
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the transformation
            _wkt: WKT name for the transformation
            _ellipsoid: EPSG code for the ellipsoid
            _number: serial number of transformation for current datum
            _area: EPSG area code
            _a: X delta of geocentric shift expressed in meters
            _b: Y delta of geocentric shift expressed in meters
            _c: Z delta of geocentric shift expressed in meters
            _d: X rotation of geocentric expressed in radians
            _e: Y rotation of geocentric expressed in radians
            _f: Z rotation of geocentric expressed in radians
            _g: scaled correction of geocentric relative to 1
            _h: X reference point in Cartesian system expressed in meters
            _i: Y reference point in Cartesian system expressed in meters
            _j: Z reference point in Cartesian system expressed in meters

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformMolodenskiBadekas.Create_Integer_String_Integer_Integer_Integer_CE7A92037E8B9828D27AC8ED00DFB0EB
        """
        pass

class TGIS_CSTransformGridShift( TGIS_CSTransformAbstract ):
    """
    A datum transformation type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformGridShift
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _number: int,
      _area: int,
      _grid_files: str
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the transformation
            _wkt: WKT name for the transformation
            _ellipsoid: EPSG code for the ellipsoid
            _number: serial number of transformation for current datum
            _area: EPSG area code
            _grid_files: list of supported grid files separated by coma

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformGridShift.Create_Integer_String_Integer_Integer_Integer_String
        """
        pass

    @property
    def Fallback(
      self
    ) -> int: 
        """
        Fallback Coordinate Transformation object. Used if main grid shift based transformation 
        is not available.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformGridShift.Fallback
        """
        pass

    @Fallback.setter
    def Fallback(
      self,
      _value: int
    ) -> None: 
        """
        Fallback Coordinate Transformation object. Used if main grid shift based transformation 
        is not available.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformGridShift.Fallback
        """
        pass

class TGIS_CSTransformNadcon( TGIS_CSTransformGridShift ):
    """
    A datum transformation type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformNadcon
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _number: int,
      _area: int,
      _grid_files: str
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformNadcon.Create_Integer_String_Integer_Integer_Integer_String
        """
        pass

class TGIS_CSTransformNTV2( TGIS_CSTransformGridShift ):
    """
    A datum transformation type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformNTV2
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _number: int,
      _area: int,
      _grid_files: str
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformNTV2.Create_Integer_String_Integer_Integer_Integer_String
        """
        pass

class TGIS_CSUnitsList( TGIS_CSAbstractList ):
    """
    List of units.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnitsList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_CSUnits:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_CSUnits
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnitsList.Create_void
        """
        pass

    def Add(
      self,
      _epsg: int,
      _wkt: str,
      _symbol: str,
      _type: TGIS_CSUnitsType,
      _factor: float
    ) -> TGIS_CSUnits: 
        """
        Add a new item into the list.

        Args:
            _epsg: EPSG code for the unit; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the unit
            _symbol: units symbol like ''km'', ''m''
            _type: angular, linear or areal units
            _factor: factor between unit and basic unit (meter or radians); for example factor 
              for kilometer is 1000.

        Returns:
            Newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnitsList.Add_Integer_String_String_TGIS_CSUnitsType_Double
        """
        pass

    def AddAuto(
      self,
      _epsg: int,
      _wkt: str,
      _subunits: int
    ) -> TGIS_CSUnits: 
        """
        Add a new item into the list.

        Args:
            _epsg: EPSG code for the unit; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the unit
            _subunits: list of units in a set ordered by factor; if contains areal units then 
              order should be by squared factor of all units except areas

        Returns:
            Newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnitsList.AddAuto_Integer_String_arrayInteger
        """
        pass

    def ByEPSG(
      self,
      _epsg: int
    ) -> TGIS_CSUnits: 
        """
        Find object on the list based on EPSG code.

        Args:
            _epsg: EPSG code

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnitsList.ByEPSG_Integer
        """
        pass

    def ByWKT(
      self,
      _wkt: str
    ) -> TGIS_CSUnits: 
        """
        Find object on the list based on WKT string.

        Args:
            _wkt: WKT name

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnitsList.ByWKT_String
        """
        pass

    def Fix(
      self,
      _epsg: int,
      _wkt: str,
      _symbol: str,
      _type: TGIS_CSUnitsType,
      _factor: float
    ) -> TGIS_CSUnits: 
        """
        Fix item by substituting exiting item based on EPSG code.

        Args:
            _epsg: EPSG code for the unit; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the unit
            _symbol: units symbol like ''km'', ''m''
            _type: angular, linear or areal units
            _factor: factor between unit and basic unit (meter or radians); for example factor 
              for kilometer is 1000.

        Returns:
            Fixed object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnitsList.Fix_Integer_String_String_TGIS_CSUnitsType_Double
        """
        pass

    def Prepare(
      self,
      _epsg: int,
      _wkt: str,
      _symbol: str,
      _type: TGIS_CSUnitsType,
      _factor: float
    ) -> TGIS_CSUnits: 
        """
        Prepare a TGIS_CSUnits object. If the matching object does not exists then will be 
        added to the list and returned. If the object can be found then it will be returned 
        form the list.

        Args:
            _epsg: EPSG code for the unit; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the unit
            _symbol: units symbol like ''km'', ''m''
            _type: angular, linear or areal units
            _factor: factor between unit and basic unit (meter or radians); for example factor 
              for kilometer is 1000.

        Returns:
            Newly created / Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnitsList.Prepare_Integer_String_String_TGIS_CSUnitsType_Double
        """
        pass

    
    def Units(
      self,
      _idx: int
    ) -> TGIS_CSUnits: 
        """
        Default property for retrieving unit.

        Args:
            _idx: position on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnitsList.Units
        """
        pass

class TGIS_CSPrimeMeridianList( TGIS_CSAbstractList ):
    """
    List of prime meridians.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSPrimeMeridianList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_CSPrimeMeridian:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_CSPrimeMeridian
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSPrimeMeridianList.Create_void
        """
        pass

    def Add(
      self,
      _epsg: int,
      _wkt: str,
      _longitude: float
    ) -> TGIS_CSPrimeMeridian: 
        """
        Add new item into the list.

        Args:
            _epsg: EPSG code for the prime meridian; if 0 then EPSG will be assigned from user 
              defined, temporary pool
            _wkt: WKT name for the prime meridian
            _longitude: longitude of prime meridian (in radians)

        Returns:
            Newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSPrimeMeridianList.Add_Integer_String_Double
        """
        pass

    def ByEPSG(
      self,
      _epsg: int
    ) -> TGIS_CSPrimeMeridian: 
        """
        Find object on the list based on EPSG code.

        Args:
            _epsg: EPSG code

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSPrimeMeridianList.ByEPSG_Integer
        """
        pass

    def ByWKT(
      self,
      _wkt: str
    ) -> TGIS_CSPrimeMeridian: 
        """
        Find object on the list based on WKT string.

        Args:
            _wkt: WKT name

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSPrimeMeridianList.ByWKT_String
        """
        pass

    def Fix(
      self,
      _epsg: int,
      _wkt: str,
      _longitude: float
    ) -> TGIS_CSPrimeMeridian: 
        """
        Fix item by substituting exiting item based on EPSG code.

        Args:
            _epsg: EPSG code for the prime meridian; if 0 then EPSG will be assigned from user 
              defined, temporary pool
            _wkt: WKT name for the prime meridian
            _longitude: longitude of prime meridian (in radians)

        Returns:
            Fixed object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSPrimeMeridianList.Fix_Integer_String_Double
        """
        pass

    def Prepare(
      self,
      _epsg: int,
      _wkt: str,
      _longitude: float
    ) -> TGIS_CSPrimeMeridian: 
        """
        Prepare a projected Coordinate System object. If the matching object does not exists 
        then will be added to the list and returned. If the object can be found then it will 
        be returned form the list.

        Args:
            _epsg: EPSG code for the Prime Meridian; if 0 then EPSG will be assigned from user 
              defined, temporary pool
            _wkt: WKT name for the Prime Meridian
            _longitude: Longitude of Prime Meridian in radians; relative to Greenwich

        Returns:
            Newly created / Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSPrimeMeridianList.Prepare_Integer_String_Double
        """
        pass

    
    def PrimeMeridian(
      self,
      _idx: int
    ) -> TGIS_CSPrimeMeridian: 
        """
        Default property for retrieving Prime Meridian.

        Args:
            _idx: position on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSPrimeMeridianList.PrimeMeridian
        """
        pass

class TGIS_CSEllipsoidList( TGIS_CSAbstractList ):
    """
    List of ellipsoids.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoidList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_CSEllipsoid:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_CSEllipsoid
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoidList.Create_void
        """
        pass

    def Add(
      self,
      _epsg: int,
      _wkt: str,
      _semi_major: float,
      _inv_flattering: float
    ) -> TGIS_CSEllipsoid: 
        """
        Add new item into the list.

        Args:
            _epsg: EPSG code for the ellipsoid; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the ellipsoid
            _semi_major: semi major axis
            _inv_flattering: inverse flattering; 0 for spheroid

        Returns:
            Newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoidList.Add_Integer_String_Double_Double
        """
        pass

    def ByEPSG(
      self,
      _epsg: int
    ) -> TGIS_CSEllipsoid: 
        """
        Find object on the list based on EPSG code.

        Args:
            _epsg: EPSG code

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoidList.ByEPSG_Integer
        """
        pass

    def ByWKT(
      self,
      _wkt: str
    ) -> TGIS_CSEllipsoid: 
        """
        Find object on the list based on WKT string.

        Args:
            _wkt: WKT name

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoidList.ByWKT_String
        """
        pass

    def Fix(
      self,
      _epsg: int,
      _wkt: str,
      _semi_major: float,
      _inv_flattering: float
    ) -> TGIS_CSEllipsoid: 
        """
        Fix item by substituting exiting item based on EPSG code.

        Args:
            _epsg: EPSG code for the ellipsoid; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the ellipsoid
            _semi_major: semi major axis
            _inv_flattering: inverse flattering; 0 for spheroid

        Returns:
            Fixed object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoidList.Fix_Integer_String_Double_Double
        """
        pass

    def Prepare(
      self,
      _epsg: int,
      _wkt: str,
      _semi_major: float,
      _inv_flattering: float
    ) -> TGIS_CSEllipsoid: 
        """
        Prepare a TGIS_CSEllipsoid object. If the matching object does not exists then will 
        be added to the list and returned. If the object can be found then it will be returned 
        form the list.

        Args:
            _epsg: EPSG code for the ellipsoid; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the ellipsoid
            _semi_major: semi major axis
            _inv_flattering: inverse flattering; 0 for spheroid

        Returns:
            Newly created / Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoidList.Prepare_Integer_String_Double_Double
        """
        pass

    
    def Ellipsoid(
      self,
      _idx: int
    ) -> TGIS_CSEllipsoid: 
        """
        Default property for retrieving Ellipsoid.

        Args:
            _idx: position on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSEllipsoidList.Ellipsoid
        """
        pass

class TGIS_CSAreaList( TGIS_CSAbstractList ):
    """
    List of datum area. Datum area is a text representing geographic area for which datum 
    is valid. List is always sorted based on geographical region string.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAreaList
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAreaList.Create_void
        """
        pass

    @overload
    def Add(
      self,
      _epsg: int,
      _name: str
    ) -> TGIS_CSArea: 
        """
        Add new item into the list.

        Args:
            _epsg: EPSG code for the area name; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _name: area name

        Returns:
            Newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAreaList.Add_Integer_String
        """
        pass

    @overload
    def Add(
      self,
      _epsg: int,
      _name: str,
      _xmin: float,
      _ymin: float,
      _xmax: float,
      _ymax: float
    ) -> TGIS_CSArea: 
        """
        Add new item into the list.

        Args:
            _epsg: EPSG code for the area name; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _name: area bounds
            _xmin: area bounds
            _ymin: area bounds
            _xmax: area bounds
            _ymax: area bounds

        Returns:
            Newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAreaList.Add_Integer_String_Double_Double_Double_Double
        """
        pass

    def ByEPSG(
      self,
      _epsg: int
    ) -> TGIS_CSArea: 
        """
        Find object on the list based on EPSG code.

        Args:
            _epsg: EPSG code

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAreaList.ByEPSG_Integer
        """
        pass

    def ByWKT(
      self,
      _wkt: str
    ) -> TGIS_CSArea: 
        """
        Find object on the list based on WKT string.

        Args:
            _wkt: WKT name

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAreaList.ByWKT_String
        """
        pass

    def Fix(
      self,
      _epsg: int,
      _name: str
    ) -> TGIS_CSArea: 
        """
        Fix item by substituting exiting item based on EPSG code.

        Args:
            _epsg: EPSG code for the area name; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _name: area name

        Returns:
            Fixed object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSAreaList.Fix_Integer_String
        """
        pass

class TGIS_CSDatumList( TGIS_CSAbstractList ):
    """
    List of all datums.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatumList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_CSDatum:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_CSDatum
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatumList.Create_void
        """
        pass

    @overload
    def Add(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _transform: int
    ) -> TGIS_CSDatum: 
        """
        Add new item into the list.

        Args:
            _epsg: EPSG code for the datum; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the datum
            _ellipsoid: EPSG code for ellipsoid
            _transform: EPSG code of default coordinate operation

        Returns:
            Newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatumList.Add_Integer_String_Integer_Integer
        """
        pass

    @overload
    def Add(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _transform: int,
      _fallback: int
    ) -> TGIS_CSDatum: 
        """
        Add new item into the list.

        Args:
            _epsg: EPSG code for the datum; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the datum
            _ellipsoid: EPSG code for ellipsoid
            _transform: EPSG code of default coordinate operation
            _fallback: EPSG code of fallback coordinate operation (used only for grid-shift if 
              grid-shift file can not be used)

        Returns:
            Newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatumList.Add_Integer_String_Integer_Integer_Integer
        """
        pass

    def ByEPSG(
      self,
      _epsg: int
    ) -> TGIS_CSDatum: 
        """
        Find object on the list based on EPSG code.

        Args:
            _epsg: EPSG code

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatumList.ByEPSG_Integer
        """
        pass

    def ByWKT(
      self,
      _wkt: str
    ) -> TGIS_CSDatum: 
        """
        Find object on the list based on WKT string.

        Args:
            _wkt: WKT name

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatumList.ByWKT_String
        """
        pass

    @overload
    def Fix(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _transform: int
    ) -> TGIS_CSDatum: 
        """
        Fix item by substituting exiting item based on EPSG code.

        Args:
            _epsg: EPSG code for the datum; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the datum
            _ellipsoid: EPSG code for ellipsoid
            _transform: EPSG code of default coordinate operation

        Returns:
            Fixed object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatumList.Fix_Integer_String_Integer_Integer
        """
        pass

    @overload
    def Fix(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _transform: int,
      _fallback: int
    ) -> TGIS_CSDatum: 
        """
        Fix item by substituting exiting item based on EPSG code.

        Args:
            _epsg: EPSG code for the datum; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the datum
            _ellipsoid: EPSG code for ellipsoid
            _transform: EPSG code of default coordinate operation
            _fallback: EPSG code of fallback coordinate operation (used only for grid-shift if 
              grid-shift file can not be used)

        Returns:
            Fixed object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatumList.Fix_Integer_String_Integer_Integer_Integer
        """
        pass

    def Prepare(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _transform: int
    ) -> TGIS_CSDatum: 
        """
        Prepare a TGIS_CSDatum object. If the matching object does not exists then will be 
        added to the list and returned. If the object can be found then it will be returned 
        form the list.

        Args:
            _epsg: EPSG code for the datum; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the datum
            _ellipsoid: EPSG code for ellipsoid
            _transform: EPSG code of default coordinate operation if value is -1 then first matching 
              object will be found

        Returns:
            Newly created / Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatumList.Prepare_Integer_String_Integer_Integer
        """
        pass

    def PrepareEx(
      self,
      _epsg: int,
      _wkt: str,
      _ellipsoid: int,
      _method: int,
      _area: int,
      _a: float,
      _b: float,
      _c: float,
      _d: float,
      _e: float,
      _f: float,
      _g: float,
      _h: float,
      _i: float,
      _j: float
    ) -> TGIS_CSDatum: 
        """
        Prepare a TGIS_CSDatum object. If the matching object does not exists then will be 
        added to the list and returned. If the object can be found then it will be returned 
        form the list.

        Args:
            _epsg: EPSG code for the datum; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the datum
            _ellipsoid: EPSG code for ellipsoid
            _method: EPSG code for transformation method
            _area: EPSG area code
            _a: For Methods 9603, 9606, 9607, 9636: X delta of geocentric shift expressed in 
              meters; For Methods 9618, 9119: latitude shift expressed in radians;
            _b: For Methods 9603, 9606, 9607, 9636: Y delta of geocentric shift expressed in 
              meters; For Methods 9618, 9119: longitude shift expressed in radians;
            _c: For Methods 9603, 9606, 9607, 9636: Z delta of geocentric shift expressed in 
              meters; For Method 9618: gravity height over the ellipsoid height; For Method 9619: 
              unused;
            _d: For Methods 9603, 9606, 9607, 9636: X rotation of geocentric expressed in radians; 
              For Methods 9603, 9618, 9619: unused;
            _e: For Methods 9603, 9606, 9607, 9636: Y rotation of geocentric expressed in radians; 
              For Methods 9603, 9618, 9619: unused;
            _f: For Methods 9603, 9606, 9607, 9636: Z rotation of geocentric expressed in radians; 
              For Methods 9603, 9618, 9619: unused;
            _g: For Methods 9603, 9606, 9607, 9636: scaled correction of geocentric relative 
              to 1; For Methods 9603, 9618: unused;
            _h: For Method 9636: X reference point in Cartesian system expressed in meters; For 
              Methods 9603, 9606, 9607, 9618, 9619: unused;
            _i: For Method 9636: Y reference point in Cartesian system expressed in meters; For 
              Methods 9603, 9606, 9607, 9618, 9619: unused;
            _j: For Method 9636: X reference point in Cartesian system expressed in meters; For 
              Methods 9603, 9606, 9607, 9618, 9619: unused;

        Returns:
            Newly created / Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatumList.PrepareEx_Integer_String_Integer_Integer_Integer_CE7A92037E8B9828D27AC8ED00DFB0EB
        """
        pass

    
    def Datum(
      self,
      _idx: int
    ) -> TGIS_CSDatum: 
        """
        Default property for retrieving Datum.

        Args:
            _idx: position on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSDatumList.Datum
        """
        pass

class TGIS_CSTransformList( TGIS_CSAbstractList ):
    """
    List of all datum transformations.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_CSTransformAbstract:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_CSTransformAbstract
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformList.Create_void
        """
        pass

    @overload
    def Add(
      self,
      _epsg: int,
      _wkt: str,
      _method: int,
      _ellipsoid: int,
      _number: int,
      _area: int,
      _a: float,
      _b: float,
      _c: float,
      _d: float,
      _e: float,
      _f: float,
      _g: float,
      _h: float,
      _i: float,
      _j: float
    ) -> TGIS_CSTransformAbstract: 
        """
        Add new item into the list.

        Args:
            _epsg: EPSG code for the transformation; if 0 then EPSG will be assigned from user 
              defined, temporary pool
            _wkt: wkt name for transformation
            _method: EPSG code for method
            _ellipsoid: EPSG code for the ellipsoid
            _number: serial number of transformation for current datum
            _area: EPSG area code
            _a: For Methods 9603, 9606, 9607, 9636: X delta of geocentric shift expressed in 
              meters; For Methods 9618, 9119: latitude shift expressed in radians;
            _b: For Methods 9603, 9606, 9607, 9636: Y delta of geocentric shift expressed in 
              meters; For Methods 9618, 9119: longitude shift expressed in radians;
            _c: For Methods 9603, 9606, 9607, 9636: Z delta of geocentric shift expressed in 
              meters; For Method 9618: gravity height over the ellipsoid height; For Method 9619: 
              unused;
            _d: For Methods 9603, 9606, 9607, 9636: X rotation of geocentric expressed in radians; 
              For Methods 9603, 9618, 9619: unused;
            _e: For Methods 9603, 9606, 9607, 9636: Y rotation of geocentric expressed in radians; 
              For Methods 9603, 9618, 9619: unused;
            _f: For Methods 9603, 9606, 9607, 9636: Z rotation of geocentric expressed in radians; 
              For Methods 9603, 9618, 9619: unused;
            _g: For Methods 9603, 9606, 9607, 9636: scaled correction of geocentric relative 
              to 1; For Methods 9603, 9618: unused;
            _h: For Method 9636: X reference point in Cartesian system expressed in meters; For 
              Methods 9603, 9606, 9607, 9618, 9619: unused;
            _i: For Method 9636: Y reference point in Cartesian system expressed in meters; For 
              Methods 9603, 9606, 9607, 9618, 9619: unused;
            _j: For Method 9636: X reference point in Cartesian system expressed in meters; For 
              Methods 9603, 9606, 9607, 9618, 9619: unused;

        Returns:
            Newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformList.Add_Integer_String_Integer_Integer_Integer_780B7E4F979E54FF5BEAE4794FCF6D07
        """
        pass

    @overload
    def Add(
      self,
      _epsg: int,
      _wkt: str,
      _method: int,
      _ellipsoid: int,
      _number: int,
      _area: int,
      _grid_files: str
    ) -> TGIS_CSTransformAbstract: 
        """
        Add new item into the list.

        Args:
            _epsg: EPSG code for the transformation; if 0 then EPSG will be assigned from user 
              defined, temporary pool
            _wkt: wkt name for transformation
            _method: EPSG code for method
            _ellipsoid: EPSG code for the ellipsoid
            _number: serial number of transformation for current datum
            _area: EPSG area code
            _grid_files: list of supported grid files separated by coma

        Returns:
            Newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformList.Add_Integer_String_Integer_Integer_Integer_Integer_String
        """
        pass

    def ByEPSG(
      self,
      _epsg: int
    ) -> TGIS_CSTransformAbstract: 
        """
        Find object on the list based on EPSG code.

        Args:
            _epsg: EPSG code

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformList.ByEPSG_Integer
        """
        pass

    def ByWKT(
      self,
      _wkt: str
    ) -> TGIS_CSTransformAbstract: 
        """
        Find object on the list based on WKT string.

        Args:
            _wkt: WKT name

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformList.ByWKT_String
        """
        pass

    def Fix(
      self,
      _epsg: int,
      _wkt: str,
      _method: int,
      _ellipsoid: int,
      _number: int,
      _area: int,
      _a: float,
      _b: float,
      _c: float,
      _d: float,
      _e: float,
      _f: float,
      _g: float,
      _h: float,
      _i: float,
      _j: float
    ) -> TGIS_CSTransformAbstract: 
        """
        Fix item by substituting exiting item based on EPSG code.

        Args:
            _epsg: EPSG code for the transformation; if 0 then EPSG will be assigned from user 
              defined, temporary pool
            _wkt: wkt name for transformation
            _method: EPSG code for method
            _ellipsoid: EPSG code for the ellipsoid
            _number: serial number of transformation for current datum
            _area: EPSG area code
            _a: For Methods 9603, 9606, 9607, 9636: X delta of geocentric shift expressed in 
              meters; For Methods 9618, 9119: latitude shift expressed in radians;
            _b: For Methods 9603, 9606, 9607, 9636: Y delta of geocentric shift expressed in 
              meters; For Methods 9618, 9119: longitude shift expressed in radians;
            _c: For Methods 9603, 9606, 9607, 9636: Z delta of geocentric shift expressed in 
              meters; For Method 9618: gravity height over the ellipsoid height; For Method 9619: 
              unused;
            _d: For Methods 9603, 9606, 9607, 9636: X rotation of geocentric expressed in radians; 
              For Methods 9603, 9618, 9619: unused;
            _e: For Methods 9603, 9606, 9607, 9636: Y rotation of geocentric expressed in radians; 
              For Methods 9603, 9618, 9619: unused;
            _f: For Methods 9603, 9606, 9607, 9636: Z rotation of geocentric expressed in radians; 
              For Methods 9603, 9618, 9619: unused;
            _g: For Methods 9603, 9606, 9607, 9636: scaled correction of geocentric relative 
              to 1; For Methods 9603, 9618: unused;
            _h: For Method 9636: X reference point in Cartesian system expressed in meters; For 
              Methods 9603, 9606, 9607, 9618, 9619: unused;
            _i: For Method 9636: Y reference point in Cartesian system expressed in meters; For 
              Methods 9603, 9606, 9607, 9618, 9619: unused;
            _j: For Method 9636: X reference point in Cartesian system expressed in meters; For 
              Methods 9603, 9606, 9607, 9618, 9619: unused;

        Returns:
            Fixed object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformList.Fix_Integer_String_Integer_Integer_Integer_780B7E4F979E54FF5BEAE4794FCF6D07
        """
        pass

    def Prepare(
      self,
      _epsg: int,
      _wkt: str,
      _method: int,
      _ellipsoid: int,
      _number: int,
      _area: int,
      _a: float,
      _b: float,
      _c: float,
      _d: float,
      _e: float,
      _f: float,
      _g: float,
      _h: float,
      _i: float,
      _j: float
    ) -> TGIS_CSTransformAbstract: 
        """
        Prepare a TGIS_CSTransformAbstract object. If the matching object does not exists 
        then will be added to the list and returned. If the object can be found then it will 
        be returned form the list.

        Args:
            _epsg: EPSG code for the transformation; if 0 then EPSG will be assigned from user 
              defined, temporary pool
            _wkt: wkt name for transformation
            _method: EPSG code for method
            _ellipsoid: EPSG code for the ellipsoid
            _number: serial number of transformation for current datum
            _area: EPSG area code
            _a: For Methods 9603, 9606, 9607, 9636: X delta of geocentric shift expressed in 
              meters; For Methods 9618, 9119: latitude shift expressed in radians;
            _b: For Methods 9603, 9606, 9607, 9636: Y delta of geocentric shift expressed in 
              meters; For Methods 9618, 9119: longitude shift expressed in radians;
            _c: For Methods 9603, 9606, 9607, 9636: Z delta of geocentric shift expressed in 
              meters; For Method 9618: gravity height over the ellipsoid height; For Method 9619: 
              unused;
            _d: For Methods 9603, 9606, 9607, 9636: X rotation of geocentric expressed in radians; 
              For Methods 9603, 9618, 9619: unused;
            _e: For Methods 9603, 9606, 9607, 9636: Y rotation of geocentric expressed in radians; 
              For Methods 9603, 9618, 9619: unused;
            _f: For Methods 9603, 9606, 9607, 9636: Z rotation of geocentric expressed in radians; 
              For Methods 9603, 9618, 9619: unused;
            _g: For Methods 9603, 9606, 9607, 9636: scaled correction of geocentric relative 
              to 1; For Methods 9603, 9618: unused;
            _h: For Method 9636: X reference point in Cartesian system expressed in meters; For 
              Methods 9603, 9606, 9607, 9618, 9619: unused;
            _i: For Method 9636: Y reference point in Cartesian system expressed in meters; For 
              Methods 9603, 9606, 9607, 9618, 9619: unused;
            _j: For Method 9636: X reference point in Cartesian system expressed in meters; For 
              Methods 9603, 9606, 9607, 9618, 9619: unused;

        Returns:
            Newly created / Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformList.Prepare_Integer_String_Integer_Integer_Integer_780B7E4F979E54FF5BEAE4794FCF6D07
        """
        pass

    
    def Transform(
      self,
      _idx: int
    ) -> TGIS_CSTransformAbstract: 
        """
        Default property for retrieving Transformation.

        Args:
            _idx: position on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSTransformList.Transform
        """
        pass

class TGIS_CSFactoryEsri:
    """
    Class to create Coordinate System Object from ESRI like projection file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSFactoryEsri
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSFactoryEsri.Create_void
        """
        pass

    def BuildCsFromFile(
      self,
      _file: str
    ) -> TGIS_CSCoordinateSystem: 
        """
        Construct CS form ESRI like projection file.

        Args:
            _file: path to the file

        Returns:
            Constructed/Found coordinate system or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSFactoryEsri.BuildCsFromFile_String
        """
        pass

class TGIS_CSFactory:
    """
    Class to create Coordinate System Object from WKT or EPSG codes.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSFactory
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSFactory.Create_void
        """
        pass

    def Authority(
      self,
      _wkt: str
    ) -> str: 
        """
        Find definition matching provided authority string.

        Args:
            _wkt: authority name string like EPSG number or CRS name

        Returns:
            Found definition or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSFactory.Authority_String
        """
        pass

    def ByEPSG(
      self,
      _epsg: int
    ) -> TGIS_CSCoordinateSystem: 
        """
        Find definition matching provided EPSG number.

        Args:
            _epsg: EPSG code to be found

        Returns:
            Found definition or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSFactory.ByEPSG_Integer
        """
        pass

    def ByWKT(
      self,
      _wkt: str
    ) -> TGIS_CSCoordinateSystem: 
        """
        Create (or find existing) definition from provided WKT string.

        Args:
            _wkt: WKT string; full WKT or just a name of entity like ''GRS_1980''

        Returns:
            Found definition, newly created one or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSFactory.ByWKT_String
        """
        pass

    def ByWKTFile(
      self,
      _path: str
    ) -> TGIS_CSCoordinateSystem: 
        """
        Create (or find existing) definition from provided file with WKT (like .prj file).

        Args:
            _path: path to file with WKT string

        Returns:
            Found definition, newly created one or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSFactory.ByWKTFile_String
        """
        pass

class TGIS_CSMapinfoProjectionsMap( TGIS_CSAbstractList ):
    """
    Map MapInfo projections to build to projections.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSMapinfoProjectionsMap
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSMapinfoProjectionsMap.Create_void
        """
        pass

class TGIS_CSMapinfoDatumsMap( TGIS_CSAbstractList ):
    """
    Map MapInfo datums to build to datums.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSMapinfoDatumsMap
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSMapinfoDatumsMap.Create_void
        """
        pass

class TGIS_CSMapinfoUnitsMap( TGIS_CSAbstractList ):
    """
    Map MapInfo units (as literal) to build to units.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSMapinfoUnitsMap
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSMapinfoUnitsMap.Create_void
        """
        pass

class TGIS_CSMapinfoUnits2Map( TGIS_CSAbstractList ):
    """
    Map MapInfo units (as id) to build to units.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSMapinfoUnits2Map
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSMapinfoUnits2Map.Create_void
        """
        pass

class TGIS_CSMapinfoEllipsoidMap( TGIS_CSAbstractList ):
    """
    Map MapInfo units (as id) to build to units.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSMapinfoEllipsoidMap
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSMapinfoEllipsoidMap.Create_void
        """
        pass

class TGIS_CSFactoryMapInfo:
    """
    Class to create Coordinate System Object or extract identifiers and parameters from 
    Mapinfo data.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSFactoryMapInfo
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSFactoryMapInfo.Create_void
        """
        pass

    @overload
    def BuildCs(
      self,
      _projId: int,
      _datumId: int,
      _ellipsoidId: int,
      _unitsId: str,
      _params: TGIS_DoubleArray,
      _paramsEx: TGIS_DoubleArray
    ) -> TGIS_CSCoordinateSystem: 
        """
        Build a coordinate system based on parameters.

        Args:
            _projId: projection identifier (or -1 if can not be interpreted)
            _datumId: datum identifier (or -1 if can not be interpreted)
            _ellipsoidId: ellipsoid identifier (or -1 if can not be interpreted)
            _unitsId: units identifier (or -1 if can not be interpreted)
            _params: array of projection parameters; should have 6 elements
            _paramsEx: array of datum parameters; should have 8 or 3 elements

        Returns:
            Newly created/Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSFactoryMapInfo.BuildCs_Integer_Integer_Integer_String_TGIS_DoubleArray_TGIS_DoubleArray
        """
        pass

    @overload
    def BuildCs(
      self,
      _projection: str
    ) -> TGIS_CSCoordinateSystem: 
        """
        Build a coordinate system based on parameters.

        Args:
            _projection: projection identifier

        Returns:
            Newly created/Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSFactoryMapInfo.BuildCs_String
        """
        pass

    def CsToText(
      self,
      _cs: TGIS_CSCoordinateSystem
    ) -> str: 
        """
        Utility function which parse coordinate system and returns Mapinfo string as defined 
        by MIF specification.

        Args:
            _cs: coordinate system to be interpreted

        Returns:
            CS as MapInfo string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSFactoryMapInfo.CsToText_TGIS_CSCoordinateSystem
        """
        pass

    def ParseCs(
      self,
      _cs: TGIS_CSCoordinateSystem,
      _projId: VarParameter,
      _datumId: VarParameter,
      _unitsId: VarParameter,
      _ellipsoidId: VarParameter,
      _params: VarParameter,
      _paramsEx: VarParameter
    ) -> None: 
        """
        Utility function which parse coordinate system and returns Mapinfo identifiers and 
        parameters.

        Args:
            _cs: coordinate system to be interpreted
            _projId: projection identifier (or 0 if can not be interpreted); the value (in/out) 
              is passed as int in _projId.Value property
            _datumId: datum identifier (or 0 if can not be interpreted); the value (in/out) is 
              passed as int in _datumId.Value property
            _unitsId: units identifier (or 0 if can not be interpreted); the value (in/out) is 
              passed as int in _unitsId.Value property
            _ellipsoidId: ellipsoid identifier (or 0 if can not be interpreted); the value (in/out) 
              is passed as int in _ellipsoidId.Value property
            _params: array of projection parameters; array will be allocated by the procedure; 
              the value (in/out) is passed as TGIS_DoubleArray in _params.Value property
            _paramsEx: array of datum parameters; array will be allocated by the procedure; the 
              value (in/out) is passed as TGIS_DoubleArray in _paramsEx.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSFactoryMapInfo.ParseCs_TGIS_CSCoordinateSystem_Integer_Integer_Integer_Integer_TGIS_DoubleArray_TGIS_DoubleArray
        """
        pass

class TGIS_CSProjParameter:
    pass

class TGIS_CSProjParameter:
    """
    Possible projection parameters.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter
    """

    @property
    def CentralMeridian(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Central Meridian. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.CentralMeridian
        """
        pass

    @property
    def LatitudeOfOrigin(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Origin latitude. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.LatitudeOfOrigin
        """
        pass

    @property
    def FalseEasting(
      self
    ) -> TGIS_CSProjParameter: 
        """
        False shift in meters. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.FalseEasting
        """
        pass

    @property
    def FalseNorthing(
      self
    ) -> TGIS_CSProjParameter: 
        """
        False shift in meters. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.FalseNorthing
        """
        pass

    @property
    def StandardParallel_1(
      self
    ) -> TGIS_CSProjParameter: 
        """
        First Pseudo Standard parallel. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.StandardParallel_1
        """
        pass

    @property
    def StandardParallel_2(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Second Standard parallel. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.StandardParallel_2
        """
        pass

    @property
    def PseudoStandardParallel_1(
      self
    ) -> TGIS_CSProjParameter: 
        """
        First Pseudo Standard parallel. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.PseudoStandardParallel_1
        """
        pass

    @property
    def Zone(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Zone. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.Zone
        """
        pass

    @property
    def ScaleFactor(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Scale factor. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.ScaleFactor
        """
        pass

    @property
    def LongitudeOfCenter(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Center Longitude. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.LongitudeOfCenter
        """
        pass

    @property
    def LatitudeOfCenter(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Center Latitude. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.LatitudeOfCenter
        """
        pass

    @property
    def Azimuth(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Azimuth angle. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.Azimuth
        """
        pass

    @property
    def LongitudeOfPoint_1(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Longitude of the first point. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.LongitudeOfPoint_1
        """
        pass

    @property
    def LatitudeOfPoint_1(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Latitude of the first point. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.LatitudeOfPoint_1
        """
        pass

    @property
    def LongitudeOfPoint_2(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Longitude of the second point. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.LongitudeOfPoint_2
        """
        pass

    @property
    def LatitudeOfPoint_2(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Latitude of the second point. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.LatitudeOfPoint_2
        """
        pass

    @property
    def XScale(
      self
    ) -> TGIS_CSProjParameter: 
        """
        X Scale. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.XScale
        """
        pass

    @property
    def YScale(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Y Scale. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.YScale
        """
        pass

    @property
    def XYPlaneRotation(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Plane rotation. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.XYPlaneRotation
        """
        pass

    @property
    def Custom1(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Custom1. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.Custom1
        """
        pass

    @property
    def Custom2(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Custom2. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.Custom2
        """
        pass

    @property
    def Custom3(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Custom3. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.Custom3
        """
        pass

    @property
    def Custom4(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Custom4. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.Custom4
        """
        pass

    @property
    def Custom5(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Custom5. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.Custom5
        """
        pass

    @property
    def Custom6(
      self
    ) -> TGIS_CSProjParameter: 
        """
        Custom6. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameter.Custom6
        """
        pass

class TGIS_CSProjType:
    pass

class TGIS_CSProjType:
    """
    Projection type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjType
    """

    @property
    def Miscellaneous(
      self
    ) -> TGIS_CSProjType: 
        """
        Miscellaneous projection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjType.Miscellaneous
        """
        pass

    @property
    def Grid(
      self
    ) -> TGIS_CSProjType: 
        """
        Grid projection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjType.Grid
        """
        pass

    @property
    def Azimuthal(
      self
    ) -> TGIS_CSProjType: 
        """
        Azimuthal projection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjType.Azimuthal
        """
        pass

    @property
    def AzimuthalModified(
      self
    ) -> TGIS_CSProjType: 
        """
        Modified azimuthal projection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjType.AzimuthalModified
        """
        pass

    @property
    def Pseudoazimuthal(
      self
    ) -> TGIS_CSProjType: 
        """
        Psuedoazimuthal projection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjType.Pseudoazimuthal
        """
        pass

    @property
    def Conical(
      self
    ) -> TGIS_CSProjType: 
        """
        Conical projection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjType.Conical
        """
        pass

    @property
    def PseudoConical(
      self
    ) -> TGIS_CSProjType: 
        """
        Pseudoconical projection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjType.PseudoConical
        """
        pass

    @property
    def Cylindrical(
      self
    ) -> TGIS_CSProjType: 
        """
        Cylindrical projection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjType.Cylindrical
        """
        pass

    @property
    def CylindricalModified(
      self
    ) -> TGIS_CSProjType: 
        """
        Modified cylindrical projection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjType.CylindricalModified
        """
        pass

    @property
    def CylindricalOblique(
      self
    ) -> TGIS_CSProjType: 
        """
        Oblique cylindrical projection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjType.CylindricalOblique
        """
        pass

    @property
    def CylindricalTransverse(
      self
    ) -> TGIS_CSProjType: 
        """
        Transverse cylindrical projection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjType.CylindricalTransverse
        """
        pass

    @property
    def Pseudocylindrical(
      self
    ) -> TGIS_CSProjType: 
        """
        Pseudocylindrical projection

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjType.Pseudocylindrical
        """
        pass

class TGIS_CSProjAbstract( TGIS_CSAbstract ):
    """
    Class which encapsulates projection.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Create_Integer_String
        """
        pass

    def CreateCopy(
      self
    ) -> TGIS_CSProjAbstract: 
        """
        Create a copy of the object.

        Returns:
            Newly created copy of object..

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.CreateCopy_void
        """
        pass

    def Project(
      self,
      _coords: TGIS_Point
    ) -> TGIS_Point: 
        """
        This function projects geodetic (latitude and longitude) coordinates into projected 
        (easting and northing) coordinates, according to the current ellipsoid and projection 
        parameters.

        Args:
            _coords: coordinates to be projected (in radians)

        Returns:
            converted coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Project_TGIS_Point
        """
        pass

    def Project3D(
      self,
      _coords: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        This function projects geodetic (latitude and longitude) coordinates into projected 
        (easting and northing) coordinates, according to the current ellipsoid and projection 
        parameters.

        Args:
            _coords: coordinates to be projected (in radians)

        Returns:
            converted coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Project3D_TGIS_Point3D
        """
        pass

    def Project3D_Ref(
      self,
      _coords: VarParameter
    ) -> None: 
        """
        This function projects geodetic (latitude and longitude) coordinates into projected 
        (easting and northing in most cases) coordinates, according to the current ellipsoid 
        and projection parameters.

        Args:
            _coords: geodetic coordinates (in radians); the value (in/out) is passed as TGIS_Point3D 
              in _coords.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Project3D_Ref_TGIS_Point3D
        """
        pass

    def Unproject(
      self,
      _coords: TGIS_Point
    ) -> TGIS_Point: 
        """
        This function unprojects the projected (easting and northing) coordinates into unprojected 
        geodetic (latitude and longitude) coordinates, according to the current ellipsoid 
        and projection parameters.

        Args:
            _coords: coordinates to be unprojected (in meters)

        Returns:
            converted coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Unproject_TGIS_Point
        """
        pass

    def Unproject3D(
      self,
      _coords: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        This function unprojects the projected (easting and northing) coordinates into unprojected 
        geodetic (latitude and longitude) coordinates, according to the current ellipsoid 
        and projection parameters.

        Args:
            _coords: coordinates to be unprojected (in meters)

        Returns:
            converted coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Unproject3D_TGIS_Point3D
        """
        pass

    def Unproject3D_Ref(
      self,
      _coords: VarParameter
    ) -> None: 
        """
        This function unprojects the projected (easting and northing in most cases) coordinates 
        into unprojected geodetic (latitude and longitude) coordinates, according to the 
        current ellipsoid and projection parameters.

        Args:
            _coords: projected coordinates (in meters); the value (in/out) is passed as TGIS_Point3D 
              in _coords.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Unproject3D_Ref_TGIS_Point3D
        """
        pass

    @property
    def Azimuth(
      self
    ) -> float: 
        """
        Azimuth angle. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Azimuth
        """
        pass

    @Azimuth.setter
    def Azimuth(
      self,
      _value: float
    ) -> None: 
        """
        Azimuth angle. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Azimuth
        """
        pass

    @property
    def CentralMeridian(
      self
    ) -> float: 
        """
        Central Meridian. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.CentralMeridian
        """
        pass

    @CentralMeridian.setter
    def CentralMeridian(
      self,
      _value: float
    ) -> None: 
        """
        Central Meridian. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.CentralMeridian
        """
        pass

    @property
    def Custom1(
      self
    ) -> float: 
        """
        Custom1. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom1
        """
        pass

    @Custom1.setter
    def Custom1(
      self,
      _value: float
    ) -> None: 
        """
        Custom1. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom1
        """
        pass

    @property
    def Custom1Name(
      self
    ) -> str: 
        """
        Custom1Name. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom1Name
        """
        pass

    @property
    def Custom2(
      self
    ) -> float: 
        """
        Custom2. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom2
        """
        pass

    @Custom2.setter
    def Custom2(
      self,
      _value: float
    ) -> None: 
        """
        Custom2. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom2
        """
        pass

    @property
    def Custom2Name(
      self
    ) -> str: 
        """
        Custom2Name. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom2Name
        """
        pass

    @property
    def Custom3(
      self
    ) -> float: 
        """
        Custom3. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom3
        """
        pass

    @Custom3.setter
    def Custom3(
      self,
      _value: float
    ) -> None: 
        """
        Custom3. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom3
        """
        pass

    @property
    def Custom3Name(
      self
    ) -> str: 
        """
        Custom3Name. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom3Name
        """
        pass

    @property
    def Custom4(
      self
    ) -> float: 
        """
        Custom4. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom4
        """
        pass

    @Custom4.setter
    def Custom4(
      self,
      _value: float
    ) -> None: 
        """
        Custom4. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom4
        """
        pass

    @property
    def Custom4Name(
      self
    ) -> str: 
        """
        Custom4Name. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom4Name
        """
        pass

    @property
    def Custom5(
      self
    ) -> float: 
        """
        Custom5. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom5
        """
        pass

    @Custom5.setter
    def Custom5(
      self,
      _value: float
    ) -> None: 
        """
        Custom5. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom5
        """
        pass

    @property
    def Custom5Name(
      self
    ) -> str: 
        """
        Custom5Name. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom5Name
        """
        pass

    @property
    def Custom6(
      self
    ) -> float: 
        """
        Custom6. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom6
        """
        pass

    @Custom6.setter
    def Custom6(
      self,
      _value: float
    ) -> None: 
        """
        Custom6. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom6
        """
        pass

    @property
    def Custom6Name(
      self
    ) -> str: 
        """
        Custom6Name. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Custom6Name
        """
        pass

    @property
    def Datum(
      self
    ) -> TGIS_CSDatum: 
        """
        Current Datum.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Datum
        """
        pass

    @Datum.setter
    def Datum(
      self,
      _value: TGIS_CSDatum
    ) -> None: 
        """
        Current Datum.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Datum
        """
        pass

    @property
    def Description(
      self
    ) -> str: 
        """
        Additional projection description. Optional - exits only for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Description
        """
        pass

    @property
    def Ellipsoid(
      self
    ) -> TGIS_CSEllipsoid: 
        """
        Current Ellipsoid. Can be changed only by the changing the Datum to a new one.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Ellipsoid
        """
        pass

    @property
    def Error(
      self
    ) -> int: 
        """
        Error number.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Error
        """
        pass

    @property
    def FalseEasting(
      self
    ) -> float: 
        """
        False shift in meters. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.FalseEasting
        """
        pass

    @FalseEasting.setter
    def FalseEasting(
      self,
      _value: float
    ) -> None: 
        """
        False shift in meters. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.FalseEasting
        """
        pass

    @property
    def FalseNorthing(
      self
    ) -> float: 
        """
        False shift in meters. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.FalseNorthing
        """
        pass

    @FalseNorthing.setter
    def FalseNorthing(
      self,
      _value: float
    ) -> None: 
        """
        False shift in meters. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.FalseNorthing
        """
        pass

    @property
    def IsEllipsoid(
      self
    ) -> bool: 
        """
        Does the projection work on ellipsoid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.IsEllipsoid
        """
        pass

    @property
    def IsGrid(
      self
    ) -> bool: 
        """
        Does the projection is grid based.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.IsGrid
        """
        pass

    @property
    def IsPureCylindrical(
      self
    ) -> bool: 
        """
        Is result of projection pure cylindicial (graticules are parallel).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.IsPureCylindrical
        """
        pass

    @property
    def IsRevertible(
      self
    ) -> bool: 
        """
        Is projection revertible (so data can be projected and unprojected).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.IsRevertible
        """
        pass

    @property
    def IsSpheroid(
      self
    ) -> bool: 
        """
        Does the projection work on sphenoid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.IsSpheroid
        """
        pass

    @property
    def IsStandard(
      self
    ) -> bool: 
        """
        Does the projection is standard (not IsGrid, not IsXYZ and IsRevertible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.IsStandard
        """
        pass

    @property
    def IsXYZ(
      self
    ) -> bool: 
        """
        Does the projection is XYZ based.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.IsXYZ
        """
        pass

    @property
    def LatitudeOfCenter(
      self
    ) -> float: 
        """
        Center Latitude. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.LatitudeOfCenter
        """
        pass

    @LatitudeOfCenter.setter
    def LatitudeOfCenter(
      self,
      _value: float
    ) -> None: 
        """
        Center Latitude. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.LatitudeOfCenter
        """
        pass

    @property
    def LatitudeOfOrigin(
      self
    ) -> float: 
        """
        Origin latitude. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.LatitudeOfOrigin
        """
        pass

    @LatitudeOfOrigin.setter
    def LatitudeOfOrigin(
      self,
      _value: float
    ) -> None: 
        """
        Origin latitude. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.LatitudeOfOrigin
        """
        pass

    @property
    def LatitudeOfPoint_1(
      self
    ) -> float: 
        """
        Latitude of the first point. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.LatitudeOfPoint_1
        """
        pass

    @LatitudeOfPoint_1.setter
    def LatitudeOfPoint_1(
      self,
      _value: float
    ) -> None: 
        """
        Latitude of the first point. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.LatitudeOfPoint_1
        """
        pass

    @property
    def LatitudeOfPoint_2(
      self
    ) -> float: 
        """
        Latitude of the second point. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.LatitudeOfPoint_2
        """
        pass

    @LatitudeOfPoint_2.setter
    def LatitudeOfPoint_2(
      self,
      _value: float
    ) -> None: 
        """
        Latitude of the second point. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.LatitudeOfPoint_2
        """
        pass

    @property
    def LongitudeOfCenter(
      self
    ) -> float: 
        """
        Center Longitude. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.LongitudeOfCenter
        """
        pass

    @LongitudeOfCenter.setter
    def LongitudeOfCenter(
      self,
      _value: float
    ) -> None: 
        """
        Center Longitude. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.LongitudeOfCenter
        """
        pass

    @property
    def LongitudeOfPoint_1(
      self
    ) -> float: 
        """
        Longitude of the first point. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.LongitudeOfPoint_1
        """
        pass

    @LongitudeOfPoint_1.setter
    def LongitudeOfPoint_1(
      self,
      _value: float
    ) -> None: 
        """
        Longitude of the first point. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.LongitudeOfPoint_1
        """
        pass

    @property
    def LongitudeOfPoint_2(
      self
    ) -> float: 
        """
        Longitude of the second point. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.LongitudeOfPoint_2
        """
        pass

    @LongitudeOfPoint_2.setter
    def LongitudeOfPoint_2(
      self,
      _value: float
    ) -> None: 
        """
        Longitude of the second point. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.LongitudeOfPoint_2
        """
        pass

    @property
    def Parameters(
      self
    ) -> TGIS_CSProjParameters: 
        """
        All projection parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Parameters
        """
        pass

    @Parameters.setter
    def Parameters(
      self,
      _value: TGIS_CSProjParameters
    ) -> None: 
        """
        All projection parameters.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Parameters
        """
        pass

    @property
    def ParametersSet(
      self
    ) -> typing.Sequence[TGIS_CSProjParameter]: 
        """
        Set of supported parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.ParametersSet
        """
        pass

    @property
    def PseudoStandardParallel_1(
      self
    ) -> float: 
        """
        First Pseudo Standard parallel. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.PseudoStandardParallel_1
        """
        pass

    @PseudoStandardParallel_1.setter
    def PseudoStandardParallel_1(
      self,
      _value: float
    ) -> None: 
        """
        First Pseudo Standard parallel. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.PseudoStandardParallel_1
        """
        pass

    @property
    def ScaleFactor(
      self
    ) -> float: 
        """
        Scale factor. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.ScaleFactor
        """
        pass

    @ScaleFactor.setter
    def ScaleFactor(
      self,
      _value: float
    ) -> None: 
        """
        Scale factor. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.ScaleFactor
        """
        pass

    @property
    def StandardParallel_1(
      self
    ) -> float: 
        """
        First Standard parallel. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.StandardParallel_1
        """
        pass

    @StandardParallel_1.setter
    def StandardParallel_1(
      self,
      _value: float
    ) -> None: 
        """
        First Standard parallel. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.StandardParallel_1
        """
        pass

    @property
    def StandardParallel_2(
      self
    ) -> float: 
        """
        Second Standard parallel. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.StandardParallel_2
        """
        pass

    @StandardParallel_2.setter
    def StandardParallel_2(
      self,
      _value: float
    ) -> None: 
        """
        Second Standard parallel. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.StandardParallel_2
        """
        pass

    @property
    def ValidityExtentWGS(
      self
    ) -> TGIS_Extent: 
        """
        Validity extent of the projection (in radians). Projection should give reasonable 
        results within validity extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.ValidityExtentWGS
        """
        pass

    @property
    def ValidityOriginWGS(
      self
    ) -> TGIS_Point: 
        """
        Origin of the validity extent of the projection (in radians). Should be within the 
        ValidityExtent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.ValidityOriginWGS
        """
        pass

    @property
    def XScale(
      self
    ) -> float: 
        """
        X Scale. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.XScale
        """
        pass

    @XScale.setter
    def XScale(
      self,
      _value: float
    ) -> None: 
        """
        X Scale. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.XScale
        """
        pass

    @property
    def XYPlaneRotation(
      self
    ) -> float: 
        """
        XY Scale. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.XYPlaneRotation
        """
        pass

    @XYPlaneRotation.setter
    def XYPlaneRotation(
      self,
      _value: float
    ) -> None: 
        """
        XY Scale. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.XYPlaneRotation
        """
        pass

    @property
    def YScale(
      self
    ) -> float: 
        """
        Y Scale. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.YScale
        """
        pass

    @YScale.setter
    def YScale(
      self,
      _value: float
    ) -> None: 
        """
        Y Scale. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.YScale
        """
        pass

    @property
    def Zone(
      self
    ) -> int: 
        """
        Zone. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Zone
        """
        pass

    @Zone.setter
    def Zone(
      self,
      _value: int
    ) -> None: 
        """
        Zone. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAbstract.Zone
        """
        pass

class TGIS_CSProjAlbers( TGIS_CSProjAbstract ):
    """
    Projection Albers Equal Area.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Albers Equal Area Conic projection coordinates (easting and northing 
    in meters) defined by two standard parallels.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAlbers
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAlbers.Create_Integer_String
        """
        pass

class TGIS_CSProjLambert( TGIS_CSProjAlbers ):
    """
    Projection Lambert Equal Area.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Lambert Equal Area Conic projection coordinates (easting and northing 
    in meters) defined by standard parallel.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLambert
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLambert.Create_Integer_String
        """
        pass

class TGIS_CSProjAzimuthalEquidistant( TGIS_CSProjAbstract ):
    """
    Projection Azimuthal Equal Area.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Azimuthal Equidistant projection coordinates (easting and northing 
    in meters) defined by standard parallel.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAzimuthalEquidistant
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAzimuthalEquidistant.Create_Integer_String
        """
        pass

class TGIS_CSProjAiry( TGIS_CSProjAbstract ):
    """
    Projection Airy.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Airy projection coordinates (easting and northing in meters) defined 
    by standard parallel.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAiry
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAiry.Create_Integer_String
        """
        pass

class TGIS_CSProjAitof( TGIS_CSProjAbstract ):
    """
    Projection Aitof.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Aitof projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAitof
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAitof.Create_Integer_String
        """
        pass

class TGIS_CSProjWinkelTripel( TGIS_CSProjAitof ):
    """
    Projection Winkel Tripel.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Winkel Tripel projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWinkelTripel
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWinkelTripel.Create_Integer_String
        """
        pass

class TGIS_CSProjAugust( TGIS_CSProjAbstract ):
    """
    Projection August.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and August projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAugust
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjAugust.Create_Integer_String
        """
        pass

class TGIS_CSProjBonne( TGIS_CSProjAbstract ):
    """
    Projection Bonne.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Bonne projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjBonne
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjBonne.Create_Integer_String
        """
        pass

class TGIS_CSProjBonneSouthOriented( TGIS_CSProjBonne ):
    """
    Projection Bonne South Oriented.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Bonne South Oriented projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjBonneSouthOriented
    """

class TGIS_CSProjWerner( TGIS_CSProjBonne ):
    """
    Projection Werner.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Werner projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWerner
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWerner.Create_Integer_String
        """
        pass

class TGIS_CSProjCassini( TGIS_CSProjAbstract ):
    """
    Projection Cassini.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Cassini projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjCassini
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjCassini.Create_Integer_String
        """
        pass

class TGIS_CSProjCentralCylindrical( TGIS_CSProjAbstract ):
    """
    Projection Central Cylindrical.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Central Cylindrical projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjCentralCylindrical
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjCentralCylindrical.Create_Integer_String
        """
        pass

class TGIS_CSProjEqualAreaCylindrical( TGIS_CSProjAbstract ):
    """
    Projection Equal Area Cylindrical.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Equal Area Cylindrical projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEqualAreaCylindrical
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEqualAreaCylindrical.Create_Integer_String
        """
        pass

class TGIS_CSProjBehrmann( TGIS_CSProjEqualAreaCylindrical ):
    """
    Projection Behrmann.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Behrmann projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjBehrmann
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjBehrmann.Create_Integer_String
        """
        pass

class TGIS_CSProjGallOrthographic( TGIS_CSProjEqualAreaCylindrical ):
    """
    Projection Gall Orthographic.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Gall Orthographic projection coordinates (easting and northing in 
    meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGallOrthographic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGallOrthographic.Create_Integer_String
        """
        pass

class TGIS_CSProjEckert_I( TGIS_CSProjAbstract ):
    """
    Projection Eckert I.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Ecket I projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEckert_I
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEckert_I.Create_Integer_String
        """
        pass

class TGIS_CSProjEckert_II( TGIS_CSProjAbstract ):
    """
    Projection Eckert II.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Eckert II projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEckert_II
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEckert_II.Create_Integer_String
        """
        pass

class TGIS_CSProjEckert_III( TGIS_CSProjAbstract ):
    """
    Projection Eckert III.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Ecket III projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEckert_III
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEckert_III.Create_Integer_String
        """
        pass

class TGIS_CSProjPutnins_P1( TGIS_CSProjEckert_III ):
    """
    Projection Putnins P1.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Putnins P1 projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P1
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P1.Create_Integer_String
        """
        pass

class TGIS_CSProjWagner_VI( TGIS_CSProjEckert_III ):
    """
    Projection Wagner VI.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Wagner VI projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWagner_VI
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWagner_VI.Create_Integer_String
        """
        pass

class TGIS_CSProjKavraisky_VII( TGIS_CSProjEckert_III ):
    """
    Projection Kavraisky VII.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Kavraisky VII projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjKavraisky_VII
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjKavraisky_VII.Create_Integer_String
        """
        pass

class TGIS_CSProjEckert_IV( TGIS_CSProjAbstract ):
    """
    Projection Eckert IV.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Ecket IV projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEckert_IV
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEckert_IV.Create_Integer_String
        """
        pass

class TGIS_CSProjEckert_V( TGIS_CSProjAbstract ):
    """
    Projection Eckert V.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Ecket V projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEckert_V
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEckert_V.Create_Integer_String
        """
        pass

class TGIS_CSProjPlateCarree( TGIS_CSProjAbstract ):
    """
    Projection Plate Carree (Equidistant Cylindrical).
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Plate Carree projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPlateCarree
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPlateCarree.Create_Integer_String
        """
        pass

class TGIS_CSProjEquidistantConic( TGIS_CSProjAbstract ):
    """
    Projection Equidistant Conic.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Equidistant Conic projection coordinates (easting and northing in 
    meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEquidistantConic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEquidistantConic.Create_Integer_String
        """
        pass

class TGIS_CSProjSinusoidal( TGIS_CSProjAbstract ):
    """
    Projection Sinusoidal (Sanson-Flamsteed).
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Sinusoidal projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjSinusoidal
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjSinusoidal.Create_Integer_String
        """
        pass

class TGIS_CSProjEckert_VI( TGIS_CSProjSinusoidal ):
    """
    Projection Eckert VI.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Eckert VI projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEckert_VI
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEckert_VI.Create_Integer_String
        """
        pass

class TGIS_CSProjFlatPolarSinusoidal( TGIS_CSProjSinusoidal ):
    """
    Projection Flat-Polar Sinusoidal (McBryde-Thomas Flat-Polar Sinusoidal).
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Flat-Polar Sinusoidal projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjFlatPolarSinusoidal
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjFlatPolarSinusoidal.Create_Integer_String
        """
        pass

class TGIS_CSProjGnomic( TGIS_CSProjAbstract ):
    """
    Projection Gnomic.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Gnomic projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGnomic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGnomic.Create_Integer_String
        """
        pass

class TGIS_CSProjLambertAzimuthalEqualArea( TGIS_CSProjAbstract ):
    """
    Projection Lambert Azimuthal Equal Area.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Lambert Azimuthal Equal Area projection coordinates (easting and 
    northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLambertAzimuthalEqualArea
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLambertAzimuthalEqualArea.Create_Integer_String
        """
        pass

class TGIS_CSProjLarrivee( TGIS_CSProjAbstract ):
    """
    Projection Larrivee.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Larrivee projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLarrivee
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLarrivee.Create_Integer_String
        """
        pass

class TGIS_CSProjLambertConformalConic( TGIS_CSProjAbstract ):
    """
    Projection Lambert Conformal Conic.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Lambert Conformal Conic projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLambertConformalConic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLambertConformalConic.Create_Integer_String
        """
        pass

class TGIS_CSProjLambertConformalConic_1SP( TGIS_CSProjLambertConformalConic ):
    """
    Projection Lambert Conformal Conic 1SP.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Lambert Conformal Conic projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLambertConformalConic_1SP
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLambertConformalConic_1SP.Create_Integer_String
        """
        pass

class TGIS_CSProjLambertConformalConicWestOriented( TGIS_CSProjLambertConformalConic_1SP ):
    """
    Projection Lambert Conformal Conic West Oriented.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Lambert Conformal Conic West Oriented projection coordinates (easting 
    and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLambertConformalConicWestOriented
    """

class TGIS_CSProjLoximuthal( TGIS_CSProjAbstract ):
    """
    Projection Loximuthal.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Loximuthal projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLoximuthal
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLoximuthal.Create_Integer_String
        """
        pass

class TGIS_CSProjMercator( TGIS_CSProjAbstract ):
    """
    Projection Mercator.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Mercator projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMercator
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMercator.Create_Integer_String
        """
        pass

class TGIS_CSProjMercator_1SP_Spherical( TGIS_CSProjMercator ):
    """
    Projection Mercator.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Mercator projection coordinates (easting and northing in meters). 
    This version is a EPSG_1024 mutation of Mercator projection for pure spherical transformations 
    like "Google Mercator"

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMercator_1SP_Spherical
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMercator_1SP_Spherical.Create_Integer_String
        """
        pass

class TGIS_CSProjMillerCylindrical( TGIS_CSProjAbstract ):
    """
    Projection Miller Cylindrical.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Miller projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMillerCylindrical
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMillerCylindrical.Create_Integer_String
        """
        pass

class TGIS_CSProjMillerOblatedStereographic( TGIS_CSProjAbstract ):
    """
    Projection Miller Oblated Stereographic.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Miller Oblated Stereographic projection coordinates (easting and 
    northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMillerOblatedStereographic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMillerOblatedStereographic.Create_Integer_String
        """
        pass

class TGIS_CSProjLeeOblatedStereographic( TGIS_CSProjMillerOblatedStereographic ):
    """
    Projection Lee Oblated Stereographic.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Miller Oblated Stereographic projection coordinates (easting and 
    northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLeeOblatedStereographic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLeeOblatedStereographic.Create_Integer_String
        """
        pass

class TGIS_CSProjGS48( TGIS_CSProjMillerOblatedStereographic ):
    """
    Projection GS48 (Modified Stererographics of 48 U.S).
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and GS48 projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGS48
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGS48.Create_Integer_String
        """
        pass

class TGIS_CSProjGS50( TGIS_CSProjMillerOblatedStereographic ):
    """
    Projection GS50 (Modified Stererographics of 50 U.S).
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and GS50. projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGS50
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGS50.Create_Integer_String
        """
        pass

class TGIS_CSProjModifiedStererographicsForAlaska( TGIS_CSProjMillerOblatedStereographic ):
    """
    Projection Modified Stererographics of Alaska.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Modified Stererographics For Alaska . projection coordinates (easting 
    and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjModifiedStererographicsForAlaska
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjModifiedStererographicsForAlaska.Create_Integer_String
        """
        pass

class TGIS_CSProjMollweide( TGIS_CSProjAbstract ):
    """
    Projection Mollweide.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Mollweide projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMollweide
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMollweide.Create_Integer_String
        """
        pass

class TGIS_CSProjWagner_IV( TGIS_CSProjMollweide ):
    """
    Projection Wagner IV.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Wagner IV projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWagner_IV
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWagner_IV.Create_Integer_String
        """
        pass

class TGIS_CSProjWagner_V( TGIS_CSProjMollweide ):
    """
    Projection Wagner V.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Wagner V projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWagner_V
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWagner_V.Create_Integer_String
        """
        pass

class TGIS_CSProjNewZealandMapGrid( TGIS_CSProjAbstract ):
    """
    New Zealand Map Grid. This component provides conversions between geodetic coordinates 
    (latitude and longitude in radians) and New Zealand Map Grid projection coordinates 
    (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjNewZealandMapGrid
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjNewZealandMapGrid.Create_Integer_String
        """
        pass

class TGIS_CSProjHotineObliqueMercatorTwoPoint( TGIS_CSProjAbstract ):
    """
    Projection Hotine Oblique Mercator Two Point.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Hotine Oblique Mercator Two Point projection coordinates (easting 
    and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjHotineObliqueMercatorTwoPoint
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjHotineObliqueMercatorTwoPoint.Create_Integer_String
        """
        pass

class TGIS_CSProjHotineObliqueMercator( TGIS_CSProjAbstract ):
    """
    Projection Hotine Oblique Mercator Azimuth.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Hotine Oblique Mercator projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjHotineObliqueMercator
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjHotineObliqueMercator.Create_Integer_String
        """
        pass

class TGIS_CSProjHotineObliqueMercatorAzimuthNaturalOrigin( TGIS_CSProjAbstract ):
    """
    Projection Hotine Oblique Mercator Azimuth Natural Origin.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Hotine Oblique Mercator Azimuth Natural Origin projection coordinates 
    (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjHotineObliqueMercatorAzimuthNaturalOrigin
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjHotineObliqueMercatorAzimuthNaturalOrigin.Create_Integer_String
        """
        pass

class TGIS_CSProjHotineObliqueMercatorAzimuthCenter( TGIS_CSProjHotineObliqueMercatorAzimuthNaturalOrigin ):
    """
    Projection Hotine Oblique Mercator Azimuth Center.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Hotine Oblique Mercator Azimuth Center projection coordinates (easting 
    and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjHotineObliqueMercatorAzimuthCenter
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjHotineObliqueMercatorAzimuthCenter.Create_Integer_String
        """
        pass

class TGIS_CSProjEuler( TGIS_CSProjAbstract ):
    """
    Projection Euler.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Euler projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEuler
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEuler.Create_Integer_String
        """
        pass

class TGIS_CSProjTissot( TGIS_CSProjEuler ):
    """
    Projection Tissot.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Tissot projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjTissot
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjTissot.Create_Integer_String
        """
        pass

class TGIS_CSProjMurdoch_I( TGIS_CSProjEuler ):
    """
    Projection Murdoch I.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Murdoch I projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMurdoch_I
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMurdoch_I.Create_Integer_String
        """
        pass

class TGIS_CSProjMurdoch_II( TGIS_CSProjEuler ):
    """
    Projection Murdoch II.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Murdoch II projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMurdoch_II
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMurdoch_II.Create_Integer_String
        """
        pass

class TGIS_CSProjMurdoch_III( TGIS_CSProjEuler ):
    """
    Projection Murdoch III.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Murdoch III projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMurdoch_III
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMurdoch_III.Create_Integer_String
        """
        pass

class TGIS_CSProjVitkovsky_I( TGIS_CSProjEuler ):
    """
    Projection Vitkovsky I.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Vitkovsky I projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjVitkovsky_I
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjVitkovsky_I.Create_Integer_String
        """
        pass

class TGIS_CSProjPerspectiveConic( TGIS_CSProjEuler ):
    """
    Projection Perspective Conic.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Perspective Conic projection coordinates (easting and northing in 
    meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPerspectiveConic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPerspectiveConic.Create_Integer_String
        """
        pass

class TGIS_CSProjStereographic( TGIS_CSProjAbstract ):
    """
    Projection Stereographic.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Stereographic projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjStereographic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjStereographic.Create_Integer_String
        """
        pass

class TGIS_CSProjPolarStereographic( TGIS_CSProjStereographic ):
    """
    Projection Polar Stereographic.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Polar Stereographic projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPolarStereographic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPolarStereographic.Create_Integer_String
        """
        pass

class TGIS_CSProjPolarStereographic_B( TGIS_CSProjStereographic ):
    """
    Projection Polar Stereographic B.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Polar Stereographic projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPolarStereographic_B
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPolarStereographic_B.Create_Integer_String
        """
        pass

class TGIS_CSProjPolarStereographic_C( TGIS_CSProjStereographic ):
    """
    Projection Polar Stereographic C.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Polar Stereographic projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPolarStereographic_C
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPolarStereographic_C.Create_Integer_String
        """
        pass

class TGIS_CSProjUniversalPolarStereographic( TGIS_CSProjStereographic ):
    """
    Projection Universal Polar Stereographic.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Universal Polar Stereographic projection coordinates (easting and 
    northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjUniversalPolarStereographic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjUniversalPolarStereographic.Create_Integer_String
        """
        pass

class TGIS_CSProjObliqueStereographic( TGIS_CSProjAbstract ):
    """
    Oblique Stereographic aka Double Stereographic
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Oblique stereographic projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjObliqueStereographic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjObliqueStereographic.Create_Integer_String
        """
        pass

class TGIS_CSProjOrthographic( TGIS_CSProjAbstract ):
    """
    Projection Orthographic.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Orthographic projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjOrthographic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjOrthographic.Create_Integer_String
        """
        pass

class TGIS_CSProjPolyconicAmerican( TGIS_CSProjAbstract ):
    """
    Projection Polyconic (American).
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Polyconic (American) projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPolyconicAmerican
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPolyconicAmerican.Create_Integer_String
        """
        pass

class TGIS_CSProjRobinson( TGIS_CSProjAbstract ):
    """
    Projection Robinson.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Robinson projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjRobinson
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjRobinson.Create_Integer_String
        """
        pass

class TGIS_CSProjSwissObliqueMercator( TGIS_CSProjAbstract ):
    """
    Projection Swiss Oblique Mercator.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Swiss Oblique Mercator projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjSwissObliqueMercator
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjSwissObliqueMercator.Create_Integer_String
        """
        pass

class TGIS_CSProjTransverseMercatorOld( TGIS_CSProjAbstract ):
    """
    Projection Transverse Mercator - old definition.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Transverse Mercator projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjTransverseMercatorOld
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjTransverseMercatorOld.Create_Integer_String
        """
        pass

class TGIS_CSProjTransverseMercator( TGIS_CSProjAbstract ):
    """
    Projection Transverse Mercator.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Transverse Mercator projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjTransverseMercator
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjTransverseMercator.Create_Integer_String
        """
        pass

class TGIS_CSProjTransverseMercatorSouthOriented( TGIS_CSProjTransverseMercator ):
    """
    Projection Transverse Mercator South Oriented.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Transverse Mercator South Oriented projection coordinates (easting 
    and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjTransverseMercatorSouthOriented
    """

class TGIS_CSProjUniversalTransverseMercator( TGIS_CSProjTransverseMercator ):
    """
    Projection Universal Transverse Mercator (UTM).
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Universal Transverse Mercator projection coordinates (easting and 
    northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjUniversalTransverseMercator
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjUniversalTransverseMercator.Create_Integer_String
        """
        pass

class TGIS_CSProjEquidistantTwoPoint( TGIS_CSProjAbstract ):
    """
    Projection Equidistant Two Point.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Equidistant Two Point projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEquidistantTwoPoint
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjEquidistantTwoPoint.Create_Integer_String
        """
        pass

class TGIS_CSProjVanDerGrinten_I( TGIS_CSProjAbstract ):
    """
    Projection van der Grinten (I).
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and van der Grinten (I) projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjVanDerGrinten_I
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjVanDerGrinten_I.Create_Integer_String
        """
        pass

class TGIS_CSProjVanDerGrinten_II( TGIS_CSProjAbstract ):
    """
    Projection van der Grinten II.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and van der Grinten II projection coordinates (easting and northing in 
    meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjVanDerGrinten_II
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjVanDerGrinten_II.Create_Integer_String
        """
        pass

class TGIS_CSProjVanDerGrinten_III( TGIS_CSProjVanDerGrinten_II ):
    """
    Projection van der Grinten III.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and van der Grinten III projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjVanDerGrinten_III
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjVanDerGrinten_III.Create_Integer_String
        """
        pass

class TGIS_CSProjVanDerGrinten_IV( TGIS_CSProjAbstract ):
    """
    Projection van der Grinten IV.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and van der Grinten IV projection coordinates (easting and northing in 
    meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjVanDerGrinten_IV
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjVanDerGrinten_IV.Create_Integer_String
        """
        pass

class TGIS_CSProjWagner_II( TGIS_CSProjAbstract ):
    """
    Projection Wagner II.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Wagner II projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWagner_II
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWagner_II.Create_Integer_String
        """
        pass

class TGIS_CSProjWagner_III( TGIS_CSProjAbstract ):
    """
    Projection Wagner III.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Wagner III projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWagner_III
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWagner_III.Create_Integer_String
        """
        pass

class TGIS_CSProjWagner_VII( TGIS_CSProjAbstract ):
    """
    Projection Wagner VII.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Wagner VII projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWagner_VII
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWagner_VII.Create_Integer_String
        """
        pass

class TGIS_CSProjWinkel_I( TGIS_CSProjAbstract ):
    """
    Projection Winkel I.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Winkel I projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWinkel_I
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWinkel_I.Create_Integer_String
        """
        pass

class TGIS_CSProjWinkel_II( TGIS_CSProjAbstract ):
    """
    Projection Winkel II.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Winkel_II projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWinkel_II
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWinkel_II.Create_Integer_String
        """
        pass

class TGIS_CSProjObliqueCylindricalEqualAreaAzimuth( TGIS_CSProjAbstract ):
    """
    Projection Oblique Cylindrical Equal Area (Azimuth).
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Oblique Cylindrical Equal Area projection coordinates (easting and 
    northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjObliqueCylindricalEqualAreaAzimuth
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjObliqueCylindricalEqualAreaAzimuth.Create_Integer_String
        """
        pass

class TGIS_CSProjObliqueCylindricalEqualAreaTwoPoint( TGIS_CSProjObliqueCylindricalEqualAreaAzimuth ):
    """
    Projection Oblique Cylindrical Equal Area (Two Point).
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Oblique Cylindrical Equal Area projection coordinates (easting and 
    northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjObliqueCylindricalEqualAreaTwoPoint
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjObliqueCylindricalEqualAreaTwoPoint.Create_Integer_String
        """
        pass

class TGIS_CSProjOblatedEqualArea( TGIS_CSProjAbstract ):
    """
    Projection Oblated Equal Area.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Oblated Equal Area projection coordinates (easting and northing in 
    meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjOblatedEqualArea
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjOblatedEqualArea.Create_Integer_String
        """
        pass

class TGIS_CSProjKrovak( TGIS_CSProjAbstract ):
    """
    Projection Krovak.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Krovak projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjKrovak
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjKrovak.Create_Integer_String
        """
        pass

class TGIS_CSProjKrovakNorthOriented( TGIS_CSProjKrovak ):
    """
    Projection Krovak North Oriented.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Krovak North Oriented projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjKrovakNorthOriented
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjKrovakNorthOriented.Create_Integer_String
        """
        pass

class TGIS_CSProjKrovakModified( TGIS_CSProjKrovak ):
    """
    Projection Krovak Modified.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Krovak Modified projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjKrovakModified
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjKrovakModified.Create_Integer_String
        """
        pass

class TGIS_CSProjKrovakModifiedNorthOriented( TGIS_CSProjKrovakModified ):
    """
    Projection Krovak Modified North Oriented.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Krovak Modified North Oriented projection coordinates (easting and 
    northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjKrovakModifiedNorthOriented
    """

class TGIS_CSProjBaconGlobular( TGIS_CSProjAbstract ):
    """
    Projection Bacon Globular.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Bacon Globular projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjBaconGlobular
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjBaconGlobular.Create_Integer_String
        """
        pass

class TGIS_CSProjApianGlobular_I( TGIS_CSProjBaconGlobular ):
    """
    Apian Globular I This component provides conversions between geodetic coordinates 
    (latitude and longitude in radians) and Apian Globular I projection coordinates (easting 
    and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjApianGlobular_I
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjApianGlobular_I.Create_Integer_String
        """
        pass

class TGIS_CSProjOrteliusOval( TGIS_CSProjBaconGlobular ):
    """
    Projection Ortelius Oval.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Ortelius Oval projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjOrteliusOval
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjOrteliusOval.Create_Integer_String
        """
        pass

class TGIS_CSProjBipolarConic( TGIS_CSProjAbstract ):
    """
    Projection Bipolar conic of western hemisphere.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Bipolar conic of western hemisphere projection coordinates (easting 
    and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjBipolarConic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjBipolarConic.Create_Integer_String
        """
        pass

class TGIS_CSProjBoggsEumorphic( TGIS_CSProjAbstract ):
    """
    Projection Boggs Eumorphic.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Boggs Eumorphic projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjBoggsEumorphic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjBoggsEumorphic.Create_Integer_String
        """
        pass

class TGIS_CSProjCollignon( TGIS_CSProjAbstract ):
    """
    Projection Collignon Pseudocylindrical.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Collignon projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjCollignon
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjCollignon.Create_Integer_String
        """
        pass

class TGIS_CSProjCrasterParabolic( TGIS_CSProjAbstract ):
    """
    Projection Parabolic Craster.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Parabolic Craster projection coordinates (easting and northing in 
    meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjCrasterParabolic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjCrasterParabolic.Create_Integer_String
        """
        pass

class TGIS_CSProjFahey( TGIS_CSProjAbstract ):
    """
    Projection Fahey.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Fahey projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjFahey
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjFahey.Create_Integer_String
        """
        pass

class TGIS_CSProjFoucautSinusoidal( TGIS_CSProjAbstract ):
    """
    Projection Foucaut Sinusoidal.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Foucaut Sinusoidal projection coordinates (easting and northing in 
    meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjFoucautSinusoidal
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjFoucautSinusoidal.Create_Integer_String
        """
        pass

class TGIS_CSProjGinsburg_VIII( TGIS_CSProjAbstract ):
    """
    Projection Ginsburg VIII (TsNIIGAiK).
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Ginsburg VIII projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGinsburg_VIII
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGinsburg_VIII.Create_Integer_String
        """
        pass

class TGIS_CSProjGallStereographic( TGIS_CSProjAbstract ):
    """
    Projection Gall Stereographic.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Gall Stereographic projection coordinates (easting and northing in 
    meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGallStereographic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGallStereographic.Create_Integer_String
        """
        pass

class TGIS_CSProjLagrange( TGIS_CSProjAbstract ):
    """
    Projection Lagrange.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Lagrange projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLagrange
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLagrange.Create_Integer_String
        """
        pass

class TGIS_CSProjHammer( TGIS_CSProjAbstract ):
    """
    Projection Hammer &amp; Eckert-Greifendorff.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Hammer &amp; Eckert-Greifendorff projection coordinates (easting 
    and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjHammer
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjHammer.Create_Integer_String
        """
        pass

class TGIS_CSProjHatano( TGIS_CSProjAbstract ):
    """
    Projection Hatano Asymmetrical Equal Area.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Hatano Asymmetrical Equal Area projection coordinates (easting and 
    northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjHatano
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjHatano.Create_Integer_String
        """
        pass

class TGIS_CSProjLaskowski( TGIS_CSProjAbstract ):
    """
    Projection Laskowski.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Laskowski projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLaskowski
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLaskowski.Create_Integer_String
        """
        pass

class TGIS_CSProjFlatPolarQuartic( TGIS_CSProjAbstract ):
    """
    Projection Flat-Polar Quartic (McBryde-Thomas Flat-Polar Quartic).
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and McBryde-Thomas Flat-Polar Quartic projection coordinates (easting 
    and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjFlatPolarQuartic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjFlatPolarQuartic.Create_Integer_String
        """
        pass

class TGIS_CSProjFlatPolarParabolic( TGIS_CSProjAbstract ):
    """
    Projection Flat-Polar Parabolic (McBryde-Thomas Flat-Polar Parabolic).
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and McBryde-Thomas Flat-Polar Parabolic projection coordinates (easting 
    and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjFlatPolarParabolic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjFlatPolarParabolic.Create_Integer_String
        """
        pass

class TGIS_CSProjFlatPolarSine2( TGIS_CSProjAbstract ):
    """
    Projection McBryde-Thomas Flat-Polar Sine (No. 2).
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and McBryde-Thomas Flat-Polar Sine projection coordinates (easting and 
    northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjFlatPolarSine2
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjFlatPolarSine2.Create_Integer_String
        """
        pass

class TGIS_CSProjPutnins_P2( TGIS_CSProjAbstract ):
    """
    Projection Putnins P2.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Putnins P2 projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P2
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P2.Create_Integer_String
        """
        pass

class TGIS_CSProjPutnins_P3( TGIS_CSProjAbstract ):
    """
    Projection Putnins P3.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Putnins P3 projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P3
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P3.Create_Integer_String
        """
        pass

class TGIS_CSProjPutnins_P3p( TGIS_CSProjPutnins_P3 ):
    """
    Projection Putnins P3''.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Putnins P3'' projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P3p
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P3p.Create_Integer_String
        """
        pass

class TGIS_CSProjPutnins_P4p( TGIS_CSProjAbstract ):
    """
    Projection Putnins P4''.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Putnins P4'' projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P4p
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P4p.Create_Integer_String
        """
        pass

class TGIS_CSProjWerenskiold_I( TGIS_CSProjPutnins_P4p ):
    """
    Projection Werenskiold I.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Werenskiold_I projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWerenskiold_I
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWerenskiold_I.Create_Integer_String
        """
        pass

class TGIS_CSProjPutnins_P5( TGIS_CSProjAbstract ):
    """
    Projection Putnins P5.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Putnins P5 projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P5
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P5.Create_Integer_String
        """
        pass

class TGIS_CSProjPutnins_P5p( TGIS_CSProjPutnins_P5 ):
    """
    Projection Putnins P5''.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Putnins P5'' projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P5p
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P5p.Create_Integer_String
        """
        pass

class TGIS_CSProjPutnins_P6( TGIS_CSProjAbstract ):
    """
    Projection Putnins P6.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and PutninsP6 projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P6
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P6.Create_Integer_String
        """
        pass

class TGIS_CSProjPutnins_P6p( TGIS_CSProjPutnins_P6 ):
    """
    Projection Putnins P6''.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Putnins P6'' projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P6p
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjPutnins_P6p.Create_Integer_String
        """
        pass

class TGIS_CSProjRectangularPolyconic( TGIS_CSProjAbstract ):
    """
    Projection Rectangular Polyconic.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Rectangular Polyconic projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjRectangularPolyconic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjRectangularPolyconic.Create_Integer_String
        """
        pass

class TGIS_CSProjKavraisky_V( TGIS_CSProjAbstract ):
    """
    Projection Kavraisky V.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and KavraiskyV projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjKavraisky_V
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjKavraisky_V.Create_Integer_String
        """
        pass

class TGIS_CSProjQuarticAuthalic( TGIS_CSProjKavraisky_V ):
    """
    Projection Quartic Authalic.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Quartic Authalic projection coordinates (easting and northing in 
    meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjQuarticAuthalic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjQuarticAuthalic.Create_Integer_String
        """
        pass

class TGIS_CSProjFlatPolarSine1( TGIS_CSProjKavraisky_V ):
    """
    Projection McBryde-Thomas Flat-Polar Sine (No. 1).
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and McBryde-Thomas Flat Polar Sine (No. 1) projection coordinates (easting 
    and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjFlatPolarSine1
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjFlatPolarSine1.Create_Integer_String
        """
        pass

class TGIS_CSProjFoucautPseudocylindrical( TGIS_CSProjKavraisky_V ):
    """
    Projection Prepetit Foucaut Pseudocylindrical.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Prepetit Foucaut projection coordinates (easting and northing in 
    meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjFoucautPseudocylindrical
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjFoucautPseudocylindrical.Create_Integer_String
        """
        pass

class TGIS_CSProjTransverseCentralCylindrical( TGIS_CSProjAbstract ):
    """
    Projection Transverse Central Cylindrical.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Transverse Central Cylindrical projection coordinates (easting and 
    northing in meters).=

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjTransverseCentralCylindrical
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjTransverseCentralCylindrical.Create_Integer_String
        """
        pass

class TGIS_CSProjTransverseCylindricalEqualArea( TGIS_CSProjAbstract ):
    """
    Projection Transverse Cylindrical Equal Area.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Transverse Cylindrical Equal Area projection coordinates (easting 
    and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjTransverseCylindricalEqualArea
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjTransverseCylindricalEqualArea.Create_Integer_String
        """
        pass

class TGIS_CSProjUrmaev_V( TGIS_CSProjAbstract ):
    """
    Projection Urmaev V.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Urmaev V projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjUrmaev_V
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjUrmaev_V.Create_Integer_String
        """
        pass

class TGIS_CSProjUrmaevFlatPolarSinusoidal( TGIS_CSProjAbstract ):
    """
    Projection Urmaev Flat-Polar Sinusoidal.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Urmaev Flat-Polar Sinusoidal projection coordinates (easting and 
    northing in meters) defined by two standard parallels.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjUrmaevFlatPolarSinusoidal
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjUrmaevFlatPolarSinusoidal.Create_Integer_String
        """
        pass

class TGIS_CSProjWagner_I( TGIS_CSProjUrmaevFlatPolarSinusoidal ):
    """
    Projection Wagner I.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Urmaev Wagner I projection coordinates (easting and northing in meters) 
    defined by two standard parallels.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWagner_I
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjWagner_I.Create_Integer_String
        """
        pass

class TGIS_CSProjNell( TGIS_CSProjAbstract ):
    """
    Projection Nell.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Nell projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjNell
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjNell.Create_Integer_String
        """
        pass

class TGIS_CSProjNellHammer( TGIS_CSProjAbstract ):
    """
    Projection Nell-Hammer.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Nell-Hammer projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjNellHammer
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjNellHammer.Create_Integer_String
        """
        pass

class TGIS_CSProjNicolosiGlobular( TGIS_CSProjAbstract ):
    """
    Projection Nicolosi Globular.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Nicolosi Globular projection coordinates (easting and northing in 
    meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjNicolosiGlobular
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjNicolosiGlobular.Create_Integer_String
        """
        pass

class TGIS_CSProjGoodeHomolosine( TGIS_CSProjAbstract ):
    """
    Projection Goode Homolosine.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Goode Homolosine projection coordinates (easting and northing in 
    meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGoodeHomolosine
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGoodeHomolosine.Create_Integer_String
        """
        pass

class TGIS_CSProjInternationalMapWorldPolyconic( TGIS_CSProjAbstract ):
    """
    Projection International Map of the World Polyconic.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and International Map of the World Polyconic projection coordinates (easting 
    and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjInternationalMapWorldPolyconic
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjInternationalMapWorldPolyconic.Create_Integer_String
        """
        pass

class TGIS_CSProjChamberlinTrimetric( TGIS_CSProjAbstract ):
    """
    Projection Chamberlin Trimetric.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Chamberlin Trimetric projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric.Create_Integer_String
        """
        pass

class TGIS_CSProjLabordeMadagaskar( TGIS_CSProjAbstract ):
    """
    Projection Laborde Special for Madagaskar.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Laborde projection coordinates (easting and northing in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLabordeMadagaskar
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLabordeMadagaskar.Create_Integer_String
        """
        pass

class TGIS_CSProjLandsat( TGIS_CSProjAbstract ):
    """
    Projection Space Oblique Mercator for Landsat
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and Space oblique for LANDSAT projection coordinates (easting and northing 
    in meters).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLandsat
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjLandsat.Create_Integer_String
        """
        pass

class TGIS_CSProjGridAbstract( TGIS_CSProjAbstract ):
    """
    Base class for string grids systems.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and MGRS coordinates string.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGridAbstract
    """

    @overload
    def ProjectedTxt(
      self,
      _coords: TGIS_Point
    ) -> str: 
        """
        This function projects geodetic (latitude and longitude) coordinates into projected 
        (string) coordinates, according to the current ellipsoid and projection parameters. 
        Default precision is 5.

        Args:
            _coords: geodetic coordinates (in radians)

        Returns:
            converted coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGridAbstract.ProjectedTxt_TGIS_Point
        """
        pass

    @overload
    def ProjectedTxt(
      self,
      _coords: TGIS_Point,
      _prec: int
    ) -> str: 
        """
        This function projects geodetic (latitude and longitude) coordinates into projected 
        (string) coordinates, according to the current ellipsoid and projection parameters.

        Args:
            _coords: geodetic coordinates (in radians)
            _prec: precision (0..5); 5 is default

        Returns:
            converted coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGridAbstract.ProjectedTxt_TGIS_Point_Integer
        """
        pass

    def UnprojectedTxt(
      self,
      _coords: str
    ) -> TGIS_Point: 
        """
        This function unprojects the projected (string) coordinates into unprojected geodetic 
        (latitude and longitude) coordinates, according to the current ellipsoid and projection 
        parameters.

        Args:
            _coords: string coordinate

        Returns:
            converted coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGridAbstract.UnprojectedTxt_String
        """
        pass

class TGIS_CSProjMGRS( TGIS_CSProjGridAbstract ):
    """
    Projection Military Reference Grid System (MGRS).
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and MGRS coordinates string.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMGRS
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMGRS.Create_Integer_String
        """
        pass

    @overload
    def ProjectedTxt(
      self,
      _coords: TGIS_Point
    ) -> str: 
        """
        This function projects geodetic (latitude and longitude) coordinates into projected 
        (string) coordinates, according to the current ellipsoid and projection parameters. 
        Default precision is 5.

        Args:
            _coords: geodetic coordinates (in radians)

        Returns:
            converted coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMGRS.ProjectedTxt_TGIS_Point
        """
        pass

    @overload
    def ProjectedTxt(
      self,
      _coords: TGIS_Point,
      _prec: int
    ) -> str: 
        """
        This function projects geodetic (latitude and longitude) coordinates into projected 
        (string) coordinates, according to the current ellipsoid and projection parameters.

        Args:
            _coords: geodetic coordinates (in radians)
            _prec: precision (0..5); 5 is default

        Returns:
            converted coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjMGRS.ProjectedTxt_TGIS_Point_Integer
        """
        pass

class TGIS_CSProjF16GRS( TGIS_CSProjMGRS ):
    """
    Projection F-16 Grid Reference System.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and F16GRS coordinates string.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjF16GRS
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjF16GRS.Create_Integer_String
        """
        pass

    @overload
    def ProjectedTxt(
      self,
      _coords: TGIS_Point
    ) -> str: 
        """
        This function projects geodetic (latitude and longitude) coordinates into projected 
        (string) coordinates, according to the current ellipsoid and projection parameters. 
        Default precision is 5.

        Args:
            _coords: geodetic coordinates (in radians)

        Returns:
            converted coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjF16GRS.ProjectedTxt_TGIS_Point
        """
        pass

    @overload
    def ProjectedTxt(
      self,
      _coords: TGIS_Point,
      _prec: int
    ) -> str: 
        """
        This function projects geodetic (latitude and longitude) coordinates into projected 
        (string) coordinates, according to the current ellipsoid and projection parameters.

        Args:
            _coords: geodetic coordinates (in radians)
            _prec: precision (0..5); 5 is default

        Returns:
            converted coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjF16GRS.ProjectedTxt_TGIS_Point_Integer
        """
        pass

class TGIS_CSProjGEOREF( TGIS_CSProjGridAbstract ):
    """
    Projection GEOREF.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and GEOREF string.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGEOREF
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGEOREF.Create_Integer_String
        """
        pass

    @overload
    def ProjectedTxt(
      self,
      _coords: TGIS_Point
    ) -> str: 
        """
        This function projects geodetic (latitude and longitude) coordinates into projected 
        (string) coordinates, according to the current ellipsoid and projection parameters. 
        Default precision is 5.

        Args:
            _coords: geodetic coordinates (in radians)

        Returns:
            converted coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGEOREF.ProjectedTxt_TGIS_Point
        """
        pass

    @overload
    def ProjectedTxt(
      self,
      _coords: TGIS_Point,
      _prec: int
    ) -> str: 
        """
        This function projects geodetic (latitude and longitude) coordinates into projected 
        (string) coordinates, according to the current ellipsoid and projection parameters.

        Args:
            _coords: geodetic coordinates (in radians)
            _prec: precision (0..5); 5 is default

        Returns:
            converted coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGEOREF.ProjectedTxt_TGIS_Point_Integer
        """
        pass

class TGIS_CSProjGeocentric( TGIS_CSProjAbstract ):
    """
    Projection Geocentric.
    
    This component provides conversions between geodetic coordinates (latitude and longitude 
    in radians) and geocentric coordinate (XYZ).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGeocentric
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str
    ) -> None: 
        """
        Creates an instance of the projection object and sets the default datum to WGS84.

        Args:
            _epsg: 
            _wkt: 

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjGeocentric.Create_Integer_String
        """
        pass

class TGIS_CSProjList( TGIS_CSAbstractList ):
    """
    List of all projections.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_CSProjAbstract:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_CSProjAbstract
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjList.Create_void
        """
        pass

    def Add(
      self,
      _prj: TGIS_CSProjAbstract,
      _master: int
    ) -> None: 
        """
        Add new item into the list.

        Args:
            _prj: projection object
            _master: if &gt; 0 then EPSG code of the master item (for creating alias)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjList.Add_TGIS_CSProjAbstract_Integer
        """
        pass

    def ByEPSG(
      self,
      _epsg: int
    ) -> TGIS_CSProjAbstract: 
        """
        Find object on the list based on EPSG code.

        Args:
            _epsg: EPSG code

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjList.ByEPSG_Integer
        """
        pass

    def ByWKT(
      self,
      _wkt: str
    ) -> TGIS_CSProjAbstract: 
        """
        Find object on the list based on WKT string.

        Args:
            _wkt: WKT name

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjList.ByWKT_String
        """
        pass

    
    def Projection(
      self,
      _idx: int
    ) -> TGIS_CSProjAbstract: 
        """
        Default property for retrieving Projection.

        Args:
            _idx: position on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjList.Projection
        """
        pass

class TGIS_CSProjParameters:
    """
    Projection parameters.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Create_void
        """
        pass

    @property
    def CentralMeridian(
      self
    ) -> float: 
        """
        Central Meridian. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.CentralMeridian
        """
        pass

    @CentralMeridian.setter
    def CentralMeridian(
      self,
      _value: float
    ) -> None: 
        """
        Central Meridian. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.CentralMeridian
        """
        pass

    @property
    def LatitudeOfOrigin(
      self
    ) -> float: 
        """
        Origin latitude. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.LatitudeOfOrigin
        """
        pass

    @LatitudeOfOrigin.setter
    def LatitudeOfOrigin(
      self,
      _value: float
    ) -> None: 
        """
        Origin latitude. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.LatitudeOfOrigin
        """
        pass

    @property
    def FalseEasting(
      self
    ) -> float: 
        """
        False shift in meters. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.FalseEasting
        """
        pass

    @FalseEasting.setter
    def FalseEasting(
      self,
      _value: float
    ) -> None: 
        """
        False shift in meters. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.FalseEasting
        """
        pass

    @property
    def FalseNorthing(
      self
    ) -> float: 
        """
        False shift in meters. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.FalseNorthing
        """
        pass

    @FalseNorthing.setter
    def FalseNorthing(
      self,
      _value: float
    ) -> None: 
        """
        False shift in meters. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.FalseNorthing
        """
        pass

    @property
    def StandardParallel_1(
      self
    ) -> float: 
        """
        First Pseudo Standard parallel. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.StandardParallel_1
        """
        pass

    @StandardParallel_1.setter
    def StandardParallel_1(
      self,
      _value: float
    ) -> None: 
        """
        First Pseudo Standard parallel. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.StandardParallel_1
        """
        pass

    @property
    def StandardParallel_2(
      self
    ) -> float: 
        """
        Second Standard parallel. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.StandardParallel_2
        """
        pass

    @StandardParallel_2.setter
    def StandardParallel_2(
      self,
      _value: float
    ) -> None: 
        """
        Second Standard parallel. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.StandardParallel_2
        """
        pass

    @property
    def PseudoStandardParallel_1(
      self
    ) -> float: 
        """
        First Pseudo Standard parallel. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.PseudoStandardParallel_1
        """
        pass

    @PseudoStandardParallel_1.setter
    def PseudoStandardParallel_1(
      self,
      _value: float
    ) -> None: 
        """
        First Pseudo Standard parallel. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.PseudoStandardParallel_1
        """
        pass

    @property
    def Zone(
      self
    ) -> int: 
        """
        Zone. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Zone
        """
        pass

    @Zone.setter
    def Zone(
      self,
      _value: int
    ) -> None: 
        """
        Zone. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Zone
        """
        pass

    @property
    def ScaleFactor(
      self
    ) -> float: 
        """
        Scale factor. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.ScaleFactor
        """
        pass

    @ScaleFactor.setter
    def ScaleFactor(
      self,
      _value: float
    ) -> None: 
        """
        Scale factor. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.ScaleFactor
        """
        pass

    @property
    def LongitudeOfCenter(
      self
    ) -> float: 
        """
        Center Longitude. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.LongitudeOfCenter
        """
        pass

    @LongitudeOfCenter.setter
    def LongitudeOfCenter(
      self,
      _value: float
    ) -> None: 
        """
        Center Longitude. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.LongitudeOfCenter
        """
        pass

    @property
    def LatitudeOfCenter(
      self
    ) -> float: 
        """
        Center Latitude. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.LatitudeOfCenter
        """
        pass

    @LatitudeOfCenter.setter
    def LatitudeOfCenter(
      self,
      _value: float
    ) -> None: 
        """
        Center Latitude. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.LatitudeOfCenter
        """
        pass

    @property
    def Azimuth(
      self
    ) -> float: 
        """
        Azimuth angle. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Azimuth
        """
        pass

    @Azimuth.setter
    def Azimuth(
      self,
      _value: float
    ) -> None: 
        """
        Azimuth angle. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Azimuth
        """
        pass

    @property
    def LongitudeOfPoint_1(
      self
    ) -> float: 
        """
        Longitude of the first point. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.LongitudeOfPoint_1
        """
        pass

    @LongitudeOfPoint_1.setter
    def LongitudeOfPoint_1(
      self,
      _value: float
    ) -> None: 
        """
        Longitude of the first point. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.LongitudeOfPoint_1
        """
        pass

    @property
    def LatitudeOfPoint_1(
      self
    ) -> float: 
        """
        Latitude of the first point. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.LatitudeOfPoint_1
        """
        pass

    @LatitudeOfPoint_1.setter
    def LatitudeOfPoint_1(
      self,
      _value: float
    ) -> None: 
        """
        Latitude of the first point. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.LatitudeOfPoint_1
        """
        pass

    @property
    def LongitudeOfPoint_2(
      self
    ) -> float: 
        """
        Longitude of the second point. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.LongitudeOfPoint_2
        """
        pass

    @LongitudeOfPoint_2.setter
    def LongitudeOfPoint_2(
      self,
      _value: float
    ) -> None: 
        """
        Longitude of the second point. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.LongitudeOfPoint_2
        """
        pass

    @property
    def LatitudeOfPoint_2(
      self
    ) -> float: 
        """
        Latitude of the second point. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.LatitudeOfPoint_2
        """
        pass

    @LatitudeOfPoint_2.setter
    def LatitudeOfPoint_2(
      self,
      _value: float
    ) -> None: 
        """
        Latitude of the second point. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.LatitudeOfPoint_2
        """
        pass

    @property
    def XScale(
      self
    ) -> float: 
        """
        X Scale. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.XScale
        """
        pass

    @XScale.setter
    def XScale(
      self,
      _value: float
    ) -> None: 
        """
        X Scale. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.XScale
        """
        pass

    @property
    def YScale(
      self
    ) -> float: 
        """
        Y Scale. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.YScale
        """
        pass

    @YScale.setter
    def YScale(
      self,
      _value: float
    ) -> None: 
        """
        Y Scale. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.YScale
        """
        pass

    @property
    def XYPlaneRotation(
      self
    ) -> float: 
        """
        Plane rotation. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.XYPlaneRotation
        """
        pass

    @XYPlaneRotation.setter
    def XYPlaneRotation(
      self,
      _value: float
    ) -> None: 
        """
        Plane rotation. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.XYPlaneRotation
        """
        pass

    @property
    def Custom1(
      self
    ) -> float: 
        """
        Custom1. Valid and specifiv for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom1
        """
        pass

    @Custom1.setter
    def Custom1(
      self,
      _value: float
    ) -> None: 
        """
        Custom1. Valid and specifiv for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom1
        """
        pass

    @property
    def Custom1Name(
      self
    ) -> str: 
        """
        Custom1Name. Valid and specifiv for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom1Name
        """
        pass

    @Custom1Name.setter
    def Custom1Name(
      self,
      _value: str
    ) -> None: 
        """
        Custom1Name. Valid and specifiv for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom1Name
        """
        pass

    @property
    def Custom2(
      self
    ) -> float: 
        """
        Custom2. Valid and specifiv for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom2
        """
        pass

    @Custom2.setter
    def Custom2(
      self,
      _value: float
    ) -> None: 
        """
        Custom2. Valid and specifiv for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom2
        """
        pass

    @property
    def Custom2Name(
      self
    ) -> str: 
        """
        Custom2Name. Valid and specifiv for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom2Name
        """
        pass

    @Custom2Name.setter
    def Custom2Name(
      self,
      _value: str
    ) -> None: 
        """
        Custom2Name. Valid and specifiv for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom2Name
        """
        pass

    @property
    def Custom3(
      self
    ) -> float: 
        """
        Custom3. Valid and specifiv for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom3
        """
        pass

    @Custom3.setter
    def Custom3(
      self,
      _value: float
    ) -> None: 
        """
        Custom3. Valid and specifiv for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom3
        """
        pass

    @property
    def Custom3Name(
      self
    ) -> str: 
        """
        Custom3Name. Valid and specifiv for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom3Name
        """
        pass

    @Custom3Name.setter
    def Custom3Name(
      self,
      _value: str
    ) -> None: 
        """
        Custom3Name. Valid and specifiv for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom3Name
        """
        pass

    @property
    def Custom4(
      self
    ) -> float: 
        """
        Custom4. Valid and specifiv for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom4
        """
        pass

    @Custom4.setter
    def Custom4(
      self,
      _value: float
    ) -> None: 
        """
        Custom4. Valid and specifiv for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom4
        """
        pass

    @property
    def Custom4Name(
      self
    ) -> str: 
        """
        Custom4Name. Valid and specifiv for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom4Name
        """
        pass

    @Custom4Name.setter
    def Custom4Name(
      self,
      _value: str
    ) -> None: 
        """
        Custom4Name. Valid and specifiv for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom4Name
        """
        pass

    @property
    def Custom5(
      self
    ) -> float: 
        """
        Custom5. Valid and specifiv for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom5
        """
        pass

    @Custom5.setter
    def Custom5(
      self,
      _value: float
    ) -> None: 
        """
        Custom5. Valid and specifiv for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom5
        """
        pass

    @property
    def Custom5Name(
      self
    ) -> str: 
        """
        Custom5Name. Valid and specifiv for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom5Name
        """
        pass

    @Custom5Name.setter
    def Custom5Name(
      self,
      _value: str
    ) -> None: 
        """
        Custom5Name. Valid and specifiv for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom5Name
        """
        pass

    @property
    def Custom6(
      self
    ) -> float: 
        """
        Custom6. Valid and specifiv for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom6
        """
        pass

    @Custom6.setter
    def Custom6(
      self,
      _value: float
    ) -> None: 
        """
        Custom6. Valid and specifiv for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom6
        """
        pass

    @property
    def Custom6Name(
      self
    ) -> str: 
        """
        Custom6Name. Valid and specifiv for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom6Name
        """
        pass

    @Custom6Name.setter
    def Custom6Name(
      self,
      _value: str
    ) -> None: 
        """
        Custom6Name. Valid and specifiv for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParameters.Custom6Name
        """
        pass

class TGIS_CSProjParametersInternal:
    """
    Projection parameters. Memory optimized version.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Create_void
        """
        pass

    @property
    def All(
      self
    ) -> TGIS_CSProjParameters: 
        """
        Full record of parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.All
        """
        pass

    @All.setter
    def All(
      self,
      _value: TGIS_CSProjParameters
    ) -> None: 
        """
        Full record of parameters.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.All
        """
        pass

    @property
    def Azimuth(
      self
    ) -> float: 
        """
        Azimuth angle. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Azimuth
        """
        pass

    @Azimuth.setter
    def Azimuth(
      self,
      _value: float
    ) -> None: 
        """
        Azimuth angle. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Azimuth
        """
        pass

    @property
    def CentralMeridian(
      self
    ) -> float: 
        """
        Central Meridian. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.CentralMeridian
        """
        pass

    @CentralMeridian.setter
    def CentralMeridian(
      self,
      _value: float
    ) -> None: 
        """
        Central Meridian. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.CentralMeridian
        """
        pass

    @property
    def Custom1(
      self
    ) -> float: 
        """
        Custom1. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom1
        """
        pass

    @Custom1.setter
    def Custom1(
      self,
      _value: float
    ) -> None: 
        """
        Custom1. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom1
        """
        pass

    @property
    def Custom1Name(
      self
    ) -> str: 
        """
        Custom1Name. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom1Name
        """
        pass

    @Custom1Name.setter
    def Custom1Name(
      self,
      _value: str
    ) -> None: 
        """
        Custom1Name. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom1Name
        """
        pass

    @property
    def Custom2(
      self
    ) -> float: 
        """
        Custom2. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom2
        """
        pass

    @Custom2.setter
    def Custom2(
      self,
      _value: float
    ) -> None: 
        """
        Custom2. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom2
        """
        pass

    @property
    def Custom2Name(
      self
    ) -> str: 
        """
        Custom2Name. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom2Name
        """
        pass

    @Custom2Name.setter
    def Custom2Name(
      self,
      _value: str
    ) -> None: 
        """
        Custom2Name. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom2Name
        """
        pass

    @property
    def Custom3(
      self
    ) -> float: 
        """
        Custom3. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom3
        """
        pass

    @Custom3.setter
    def Custom3(
      self,
      _value: float
    ) -> None: 
        """
        Custom3. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom3
        """
        pass

    @property
    def Custom3Name(
      self
    ) -> str: 
        """
        Custom3Name. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom3Name
        """
        pass

    @Custom3Name.setter
    def Custom3Name(
      self,
      _value: str
    ) -> None: 
        """
        Custom3Name. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom3Name
        """
        pass

    @property
    def Custom4(
      self
    ) -> float: 
        """
        Custom4. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom4
        """
        pass

    @Custom4.setter
    def Custom4(
      self,
      _value: float
    ) -> None: 
        """
        Custom4. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom4
        """
        pass

    @property
    def Custom4Name(
      self
    ) -> str: 
        """
        Custom4Name. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom4Name
        """
        pass

    @Custom4Name.setter
    def Custom4Name(
      self,
      _value: str
    ) -> None: 
        """
        Custom4Name. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom4Name
        """
        pass

    @property
    def Custom5(
      self
    ) -> float: 
        """
        Custom5. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom5
        """
        pass

    @Custom5.setter
    def Custom5(
      self,
      _value: float
    ) -> None: 
        """
        Custom5. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom5
        """
        pass

    @property
    def Custom5Name(
      self
    ) -> str: 
        """
        Custom1Name. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom5Name
        """
        pass

    @Custom5Name.setter
    def Custom5Name(
      self,
      _value: str
    ) -> None: 
        """
        Custom1Name. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom5Name
        """
        pass

    @property
    def Custom6(
      self
    ) -> float: 
        """
        Custom6. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom6
        """
        pass

    @Custom6.setter
    def Custom6(
      self,
      _value: float
    ) -> None: 
        """
        Custom6. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom6
        """
        pass

    @property
    def Custom6Name(
      self
    ) -> str: 
        """
        Custom6Name. Valid and specific for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom6Name
        """
        pass

    @Custom6Name.setter
    def Custom6Name(
      self,
      _value: str
    ) -> None: 
        """
        Custom6Name. Valid and specific for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Custom6Name
        """
        pass

    @property
    def FalseEasting(
      self
    ) -> float: 
        """
        False shift in meters. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.FalseEasting
        """
        pass

    @FalseEasting.setter
    def FalseEasting(
      self,
      _value: float
    ) -> None: 
        """
        False shift in meters. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.FalseEasting
        """
        pass

    @property
    def FalseNorthing(
      self
    ) -> float: 
        """
        False shift in meters. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.FalseNorthing
        """
        pass

    @FalseNorthing.setter
    def FalseNorthing(
      self,
      _value: float
    ) -> None: 
        """
        False shift in meters. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.FalseNorthing
        """
        pass

    @property
    def LatitudeOfCenter(
      self
    ) -> float: 
        """
        Center Latitude. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.LatitudeOfCenter
        """
        pass

    @LatitudeOfCenter.setter
    def LatitudeOfCenter(
      self,
      _value: float
    ) -> None: 
        """
        Center Latitude. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.LatitudeOfCenter
        """
        pass

    @property
    def LatitudeOfOrigin(
      self
    ) -> float: 
        """
        Origin latitude. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.LatitudeOfOrigin
        """
        pass

    @LatitudeOfOrigin.setter
    def LatitudeOfOrigin(
      self,
      _value: float
    ) -> None: 
        """
        Origin latitude. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.LatitudeOfOrigin
        """
        pass

    @property
    def LatitudeOfPoint_1(
      self
    ) -> float: 
        """
        Latitude of the first point. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.LatitudeOfPoint_1
        """
        pass

    @LatitudeOfPoint_1.setter
    def LatitudeOfPoint_1(
      self,
      _value: float
    ) -> None: 
        """
        Latitude of the first point. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.LatitudeOfPoint_1
        """
        pass

    @property
    def LatitudeOfPoint_2(
      self
    ) -> float: 
        """
        Latitude of the second point. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.LatitudeOfPoint_2
        """
        pass

    @LatitudeOfPoint_2.setter
    def LatitudeOfPoint_2(
      self,
      _value: float
    ) -> None: 
        """
        Latitude of the second point. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.LatitudeOfPoint_2
        """
        pass

    @property
    def LongitudeOfCenter(
      self
    ) -> float: 
        """
        Center Longitude. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.LongitudeOfCenter
        """
        pass

    @LongitudeOfCenter.setter
    def LongitudeOfCenter(
      self,
      _value: float
    ) -> None: 
        """
        Center Longitude. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.LongitudeOfCenter
        """
        pass

    @property
    def LongitudeOfPoint_1(
      self
    ) -> float: 
        """
        Longitude of the first point. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.LongitudeOfPoint_1
        """
        pass

    @LongitudeOfPoint_1.setter
    def LongitudeOfPoint_1(
      self,
      _value: float
    ) -> None: 
        """
        Longitude of the first point. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.LongitudeOfPoint_1
        """
        pass

    @property
    def LongitudeOfPoint_2(
      self
    ) -> float: 
        """
        Longitude of the second point. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.LongitudeOfPoint_2
        """
        pass

    @LongitudeOfPoint_2.setter
    def LongitudeOfPoint_2(
      self,
      _value: float
    ) -> None: 
        """
        Longitude of the second point. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.LongitudeOfPoint_2
        """
        pass

    @property
    def PseudoStandardParallel_1(
      self
    ) -> float: 
        """
        First Pseudo Standard parallel. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.PseudoStandardParallel_1
        """
        pass

    @PseudoStandardParallel_1.setter
    def PseudoStandardParallel_1(
      self,
      _value: float
    ) -> None: 
        """
        First Pseudo Standard parallel. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.PseudoStandardParallel_1
        """
        pass

    @property
    def ScaleFactor(
      self
    ) -> float: 
        """
        Scale factor. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.ScaleFactor
        """
        pass

    @ScaleFactor.setter
    def ScaleFactor(
      self,
      _value: float
    ) -> None: 
        """
        Scale factor. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.ScaleFactor
        """
        pass

    @property
    def StandardParallel_1(
      self
    ) -> float: 
        """
        First Standard parallel. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.StandardParallel_1
        """
        pass

    @StandardParallel_1.setter
    def StandardParallel_1(
      self,
      _value: float
    ) -> None: 
        """
        First Standard parallel. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.StandardParallel_1
        """
        pass

    @property
    def StandardParallel_2(
      self
    ) -> float: 
        """
        Second Standard parallel. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.StandardParallel_2
        """
        pass

    @StandardParallel_2.setter
    def StandardParallel_2(
      self,
      _value: float
    ) -> None: 
        """
        Second Standard parallel. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.StandardParallel_2
        """
        pass

    @property
    def XScale(
      self
    ) -> float: 
        """
        X Scale. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.XScale
        """
        pass

    @XScale.setter
    def XScale(
      self,
      _value: float
    ) -> None: 
        """
        X Scale. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.XScale
        """
        pass

    @property
    def XYPlaneRotation(
      self
    ) -> float: 
        """
        XY Rotation. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.XYPlaneRotation
        """
        pass

    @XYPlaneRotation.setter
    def XYPlaneRotation(
      self,
      _value: float
    ) -> None: 
        """
        XY Rotation. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.XYPlaneRotation
        """
        pass

    @property
    def YScale(
      self
    ) -> float: 
        """
        Y Scale. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.YScale
        """
        pass

    @YScale.setter
    def YScale(
      self,
      _value: float
    ) -> None: 
        """
        Y Scale. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.YScale
        """
        pass

    @property
    def Zone(
      self
    ) -> int: 
        """
        Zone. Valid for selected projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Zone
        """
        pass

    @Zone.setter
    def Zone(
      self,
      _value: int
    ) -> None: 
        """
        Zone. Valid for selected projections.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjParametersInternal.Zone
        """
        pass

class TGIS_CSProjChamberlinTrimetric_Record1:
    """
    Helper record for Chamberlin Trimetric.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.Create_void
        """
        pass

    @property
    def phi(
      self
    ) -> float: 
        """
        Internal projection value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.phi
        """
        pass

    @phi.setter
    def phi(
      self,
      _value: float
    ) -> None: 
        """
        Internal projection value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.phi
        """
        pass

    @property
    def lam(
      self
    ) -> float: 
        """
        Internal projection value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.lam
        """
        pass

    @lam.setter
    def lam(
      self,
      _value: float
    ) -> None: 
        """
        Internal projection value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.lam
        """
        pass

    @property
    def cosphi(
      self
    ) -> float: 
        """
        Internal projection value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.cosphi
        """
        pass

    @cosphi.setter
    def cosphi(
      self,
      _value: float
    ) -> None: 
        """
        Internal projection value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.cosphi
        """
        pass

    @property
    def sinphi(
      self
    ) -> float: 
        """
        Internal projection value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.sinphi
        """
        pass

    @sinphi.setter
    def sinphi(
      self,
      _value: float
    ) -> None: 
        """
        Internal projection value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.sinphi
        """
        pass

    @property
    def v_r(
      self
    ) -> float: 
        """
        Internal projection value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.v_r
        """
        pass

    @v_r.setter
    def v_r(
      self,
      _value: float
    ) -> None: 
        """
        Internal projection value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.v_r
        """
        pass

    @property
    def v_az(
      self
    ) -> float: 
        """
        Internal projection value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.v_az
        """
        pass

    @v_az.setter
    def v_az(
      self,
      _value: float
    ) -> None: 
        """
        Internal projection value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.v_az
        """
        pass

    @property
    def p_x(
      self
    ) -> float: 
        """
        Internal projection value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.p_x
        """
        pass

    @p_x.setter
    def p_x(
      self,
      _value: float
    ) -> None: 
        """
        Internal projection value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.p_x
        """
        pass

    @property
    def p_y(
      self
    ) -> float: 
        """
        Internal projection value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.p_y
        """
        pass

    @p_y.setter
    def p_y(
      self,
      _value: float
    ) -> None: 
        """
        Internal projection value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjChamberlinTrimetric_Record1.p_y
        """
        pass

class TGIS_CSCoordinateSystem( TGIS_CSAbstract ):
    """
    A Coordinate system. Provides methods to convert between different coordinate systems.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem
    """

    def BoundingPolygon(
      self,
      _cs: TGIS_CSCoordinateSystem
    ) -> TObject: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.BoundingPolygon_TGIS_CSCoordinateSystem
        """
        pass

    def CanConvert(
      self,
      _cs: TGIS_CSCoordinateSystem
    ) -> bool: 
        """
        Test if provided coordinate should and can be transformed to/from the current one.

        Args:
            _cs: coordinate system to be tested

        Returns:
            True if system cam be converted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.CanConvert_TGIS_CSCoordinateSystem
        """
        pass

    def CanConvertEx(
      self,
      _cs: TGIS_CSCoordinateSystem
    ) -> bool: 
        """
        Test if provided coordinate can be transformed to/from the current one.

        Args:
            _cs: coordinate system to be tested

        Returns:
            True if system cam be converted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.CanConvertEx_TGIS_CSCoordinateSystem
        """
        pass

    def Distance(
      self,
      _from: TGIS_Point,
      _to: TGIS_Point
    ) -> float: 
        """
        Calculates ellipsoidal distance (expressed in meters) based on current Coordinate 
        System.

        Args:
            _from: first coordinate
            _to: first coordinate

        Returns:
            distance value or -1 if distance can not be computed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.Distance_TGIS_Point_TGIS_Point
        """
        pass

    def DistanceFromCS(
      self,
      _from_cs: TGIS_CSCoordinateSystem,
      _from: TGIS_Point,
      _to_cs: TGIS_CSCoordinateSystem,
      _to: TGIS_Point
    ) -> float: 
        """
        Calculates ellipsoidal distance (expressed in meters) based on current coordinate 
        system.

        Args:
            _from_cs: coordinate system of the first coordinate
            _from: first coordinate
            _to_cs: coordinate system of the first coordinate
            _to: first coordinate

        Returns:
            distance value or -1 if distance can not be computed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.DistanceFromCS_TGIS_CSCoordinateSystem_TGIS_Point_TGIS_CSCoordinateSystem_TGIS_Point
        """
        pass

    def ExtentFromCS(
      self,
      _cs: TGIS_CSCoordinateSystem,
      _extent: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Convert provided extent from the provided coordinate system into the current coordinate 
        system.

        Args:
            _cs: source coordinate system to be converted from
            _extent: extent to be converted

        Returns:
            Converted coordinates. If value of any member is &gt;= 1e30 that means that conversion 
            can not be done.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.ExtentFromCS_TGIS_CSCoordinateSystem_TGIS_Extent
        """
        pass

    def ExtentFromWGS(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Convert provided extent from the WGS84 expressed in radians into the current coordinate 
        system.

        Args:
            _extent: extent to be converted

        Returns:
            Converted coordinates. If value of any member is &gt;= 1e30 that means that conversion 
            can not be done.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.ExtentFromWGS_TGIS_Extent
        """
        pass

    def ExtentToCS(
      self,
      _cs: TGIS_CSCoordinateSystem,
      _extent: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Convert provided extent to the current coordinate system into the provided coordinate 
        system

        Args:
            _cs: desired coordinate system to be converted to
            _extent: extent to be converted

        Returns:
            Converted coordinates. If value of any member is &gt;= 1e30 that means that conversion 
            can not be done.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.ExtentToCS_TGIS_CSCoordinateSystem_TGIS_Extent
        """
        pass

    def ExtentToWGS(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Convert provided extent from the current coordinate system into WGS84 expressed in 
        radians.

        Args:
            _extent: extent to be converted

        Returns:
            Converted coordinates. If value of any member is &gt;= 1e30 that means that conversion 
            can not be done.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.ExtentToWGS_TGIS_Extent
        """
        pass

    def FromCS(
      self,
      _cs: TGIS_CSCoordinateSystem,
      _coords: TGIS_Point
    ) -> TGIS_Point: 
        """
        Convert provided coordinate from the provided coordinate system into the current 
        coordinate system.

        Args:
            _cs: source coordinate system to be converted from
            _coords: point to be converted

        Returns:
            Converted coordinates. If value of any member is &gt;= 1e30 that means that conversion 
            can not be done.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.FromCS_TGIS_CSCoordinateSystem_TGIS_Point
        """
        pass

    def FromCS3D(
      self,
      _cs: TGIS_CSCoordinateSystem,
      _coords: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Convert provided 3D coordinate from the provided coordinate system into the current 
        coordinate system.

        Args:
            _cs: source coordinate system to be converted from
            _coords: point to be converted

        Returns:
            Converted coordinates. If value of any member is &gt;= 1e30 that means that conversion 
            can not be done.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.FromCS3D_TGIS_CSCoordinateSystem_TGIS_Point3D
        """
        pass

    def FromGeocs(
      self,
      _coords: TGIS_Point
    ) -> TGIS_Point: 
        """
        Convert provided coordinate from the current coordinate system into WGS84 expressed 
        in radians.

        Args:
            _coords: point to be converted

        Returns:
            Converted coordinates. If value of any member is &gt;= 1e30 that means that conversion 
            can not be done.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.FromGeocs_TGIS_Point
        """
        pass

    def FromGeocs3D(
      self,
      _coords: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Convert provided 3D coordinate from WGS84 expressed in radians into the current coordinate 
        system.

        Args:
            _coords: point to be converted

        Returns:
            Converted coordinates. If value of any member is &gt;= 1e30 that means that conversion 
            can not be done.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.FromGeocs3D_TGIS_Point3D
        """
        pass

    def FromWGS(
      self,
      _coords: TGIS_Point
    ) -> TGIS_Point: 
        """
        Convert provided coordinate from the WGS84 expressed in radians into the current 
        coordinate system.

        Args:
            _coords: point to converted

        Returns:
            Converted coordinates. If value of any member is &gt;= 1e30 that means that conversion 
            can not be done.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.FromWGS_TGIS_Point
        """
        pass

    def FromWGS3D(
      self,
      _coords: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Convert provided 3D coordinate from the WGS84 expressed in radians into the current 
        coordinate system.

        Args:
            _coords: point to be converted

        Returns:
            Converted coordinates. If value of any member is &gt;= 1e30 that means that conversion 
            can not be done.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.FromWGS3D_TGIS_Point3D
        """
        pass

    def FromWGS3D_Ref(
      self,
      _coords: VarParameter
    ) -> None: 
        """
        Convert provided 3D coordinate from the WGS84 expressed in radians into the current 
        coordinate system.

        Args:
            _coords: point to be converted; the value (in/out) is passed as TGIS_Point3D in _coords.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.FromWGS3D_Ref_TGIS_Point3D
        """
        pass

    def IsSame(
      self,
      _cs: TGIS_CSCoordinateSystem
    ) -> bool: 
        """
        Test if provided coordinate system is same as the current one.

        Args:
            _cs: coordinate system to be tested

        Returns:
            True if is systems are same.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.IsSame_TGIS_CSCoordinateSystem
        """
        pass

    def SaveAsPrettyWKTFile(
      self,
      _path: str
    ) -> None: 
        """
        Save the current coordinate system to a WKT file (like .PRJ) file. Saved file will 
        be formatted to a multiline, human readable format.
        
        See also: SaveAsWKTFile.

        Args:
            _path: path (including file name ) of the file to be saved

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.SaveAsPrettyWKTFile_String
        """
        pass

    def SaveAsWKTFile(
      self,
      _path: str
    ) -> None: 
        """
        Save the current coordinate system to a WKT file (like .PRJ) file.
        
        See also: SaveAsPrettyWKTFile.

        Args:
            _path: path (including file name ) of the file to be saved

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.SaveAsWKTFile_String
        """
        pass

    def ToCS(
      self,
      _cs: TGIS_CSCoordinateSystem,
      _coords: TGIS_Point
    ) -> TGIS_Point: 
        """
        Convert provided 3D coordinate from the current coordinate system into the provided 
        coordinate system

        Args:
            _cs: desired coordinate system to be converted to
            _coords: point to be converted

        Returns:
            Converted coordinates. If value of any member is &gt;= 1e30 that means that conversion 
            can not be done.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.ToCS_TGIS_CSCoordinateSystem_TGIS_Point
        """
        pass

    def ToCS3D(
      self,
      _cs: TGIS_CSCoordinateSystem,
      _coords: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Convert provided 3D coordinate from the current coordinate system into the provided 
        coordinate system

        Args:
            _cs: desired coordinate system to be converted to
            _coords: point to be converted

        Returns:
            Converted coordinates. If value of any member is &gt;= 1e30 that means that conversion 
            can not be done.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.ToCS3D_TGIS_CSCoordinateSystem_TGIS_Point3D
        """
        pass

    def ToGeocs(
      self,
      _coords: TGIS_Point
    ) -> TGIS_Point: 
        """
        Convert provided coordinate from the current coordinate system into GEOGCS (Geographic 
        coordinate system).

        Args:
            _coords: point to be converted

        Returns:
            Converted coordinates. If value of any member is &gt;= 1e30 that means that conversion 
            can not be done.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.ToGeocs_TGIS_Point
        """
        pass

    def ToGeocs3D(
      self,
      _coords: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Convert provided 3D coordinate from the current coordinate system into GEOGCS (Geographic 
        coordinate system).

        Args:
            _coords: point to be converted

        Returns:
            Converted coordinates. If value of any member is &gt;= 1e30 that means that conversion 
            can not be done.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.ToGeocs3D_TGIS_Point3D
        """
        pass

    def ToWGS(
      self,
      _coords: TGIS_Point
    ) -> TGIS_Point: 
        """
        Convert provided coordinate from the current coordinate system into WGS84 expressed 
        in radians.

        Args:
            _coords: point to be converted

        Returns:
            Converted coordinates. If value of any member is &gt;= 1e30 that means that conversion 
            can not be done.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.ToWGS_TGIS_Point
        """
        pass

    def ToWGS3D(
      self,
      _coords: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Convert provided 3D coordinate from the current coordinate system into WGS84 expressed 
        in radians.

        Args:
            _coords: point to be converted

        Returns:
            Converted coordinates. If value of any member is &gt;= 1e30 that means that conversion 
            can not be done.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.ToWGS3D_TGIS_Point3D
        """
        pass

    def ToWGS3D_Ref(
      self,
      _coords: VarParameter
    ) -> None: 
        """
        Convert provided 3D coordinate from the current coordinate system into WGS84 expressed 
        in radians.

        Args:
            _coords: point to be converted; the value (in/out) is passed as TGIS_Point3D in _coords.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.ToWGS3D_Ref_TGIS_Point3D
        """
        pass

    @property
    def AreaEPSG(
      self
    ) -> int: 
        """
        Area code.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.AreaEPSG
        """
        pass

    @property
    def Error(
      self
    ) -> int: 
        """
        Error code of the last method

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.Error
        """
        pass

    @property
    def FullWKT(
      self
    ) -> str: 
        """
        WKT string with current coordinate system. See also: PrettyWKT.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.FullWKT
        """
        pass

    @property
    def IgnoreVertCS(
      self
    ) -> bool: 
        """
        If true then VertCS will not be applied upon reprojection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.IgnoreVertCS
        """
        pass

    @IgnoreVertCS.setter
    def IgnoreVertCS(
      self,
      _value: bool
    ) -> None: 
        """
        If true then VertCS will not be applied upon reprojection.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.IgnoreVertCS
        """
        pass

    @property
    def PrettyWKT(
      self
    ) -> str: 
        """
        WKT string with current coordinate system formatted to a multiline, human readable 
        format. See also: FullWKT.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.PrettyWKT
        """
        pass

    @property
    def ReversedCoordinates(
      self
    ) -> bool: 
        """
        Coordinates are in reversed order. That means not Longitude-Latitude but Latitude-Longitude 
        or not Easting-Northing but Northing-Easting. This is only a hint to be used upon 
        interpreting specific formats like GML.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.ReversedCoordinates
        """
        pass

    @ReversedCoordinates.setter
    def ReversedCoordinates(
      self,
      _value: bool
    ) -> None: 
        """
        Coordinates are in reversed order. That means not Longitude-Latitude but Latitude-Longitude 
        or not Easting-Northing but Northing-Easting. This is only a hint to be used upon 
        interpreting specific formats like GML.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.ReversedCoordinates
        """
        pass

    @property
    def ValidityExtent(
      self
    ) -> TGIS_Extent: 
        """
        Validity extent of the Coordinate System (in CS units). For projected system it represent 
        a common area of Projection Validity zones and Coordinate System embedded validity.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.ValidityExtent
        """
        pass

    @property
    def ValidityExtentWGS(
      self
    ) -> TGIS_Extent: 
        """
        Validity extent of the Coordinate System (in radians). For projected system it represent 
        a common area of Projection Validity zones and Coordinate System embedded validity.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSCoordinateSystem.ValidityExtentWGS
        """
        pass

class TGIS_CSGeographicCoordinateSystem( TGIS_CSCoordinateSystem ):
    """
    A Geographic Coordinate system.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSGeographicCoordinateSystem
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _datum: int,
      _prime_meridian: int,
      _units: int
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the GCS
            _wkt: WKT name for the GCS
            _datum: EPSG code for the datum
            _prime_meridian: EPSG code for the prime meridian
            _units: EPSG code for the unit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSGeographicCoordinateSystem.Create_Integer_String_Integer_Integer_Integer
        """
        pass

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _datum: int,
      _prime_meridian: int,
      _units: int,
      _reversed: bool,
      _area: int
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the GCS
            _wkt: WKT name for the GCS
            _datum: EPSG code for the datum
            _prime_meridian: EPSG code for the prime meridian
            _units: EPSG code for the unit
            _reversed: True if coordinates are not in Easting-Northing order
            _area: EPSG code for the area of validity

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSGeographicCoordinateSystem.Create_Integer_String_Integer_Integer_Integer_Boolean_Integer
        """
        pass

    @property
    def Datum(
      self
    ) -> TGIS_CSDatum: 
        """
        Datum object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSGeographicCoordinateSystem.Datum
        """
        pass

    @property
    def PrimeMeridian(
      self
    ) -> TGIS_CSPrimeMeridian: 
        """
        Prime Meridian object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSGeographicCoordinateSystem.PrimeMeridian
        """
        pass

    @property
    def Units(
      self
    ) -> TGIS_CSUnits: 
        """
        Unit object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSGeographicCoordinateSystem.Units
        """
        pass

class TGIS_CSProjectedCoordinateSystem( TGIS_CSCoordinateSystem ):
    """
    A Projected Coordinate system.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystem
    """

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _geogcs: int,
      _units: int,
      _projection: int,
      _parameters: TGIS_CSProjParameters
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the PCS
            _wkt: WKT name for the PCS
            _geogcs: EPSG code for the GCS
            _units: EPSG code for the units
            _projection: EPSG code for the projection
            _parameters: projection parameters

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystem.Create_Integer_String_Integer_Integer_Integer_TGIS_CSProjParameters
        """
        pass

    @overload
    def __init__(
      self,
      _epsg: int,
      _wkt: str,
      _geogcs: int,
      _units: int,
      _projection: int,
      _parameters: TGIS_CSProjParameters,
      _reversed: bool,
      _area: int
    ) -> None: 
        """
        Create an instance.

        Args:
            _epsg: EPSG code for the PCS
            _wkt: WKT name for the PCS
            _geogcs: EPSG code for the GCS
            _units: EPSG code for the units
            _projection: EPSG code for the projection
            _parameters: projection parameters
            _reversed: True if coordinates are not in Easting-Northing order
            _area: EPSG code for the area of validity

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystem.Create_Integer_String_Integer_Integer_Integer_TGIS_CSProjParameters_Boolean_Integer
        """
        pass

    @property
    def Geocs(
      self
    ) -> TGIS_CSGeographicCoordinateSystem: 
        """
        Geographic Coordinate System object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystem.Geocs
        """
        pass

    @property
    def Projection(
      self
    ) -> TGIS_CSProjAbstract: 
        """
        Projection object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystem.Projection
        """
        pass

    @property
    def ProjectionEPSG(
      self
    ) -> int: 
        """
        Projection code.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystem.ProjectionEPSG
        """
        pass

    @property
    def ProjectionParams(
      self
    ) -> TGIS_CSProjParametersInternal: 
        """
        Projection parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystem.ProjectionParams
        """
        pass

    @property
    def ProjectionParamsSet(
      self
    ) -> typing.Sequence[TGIS_CSProjParameter]: 
        """
        Projection supported parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystem.ProjectionParamsSet
        """
        pass

    @property
    def Units(
      self
    ) -> TGIS_CSUnits: 
        """
        Unit object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystem.Units
        """
        pass

class TGIS_CSUnknownCoordinateSystem( TGIS_CSCoordinateSystem ):
    """
    An Unknown Projected Coordinate system. This is not a real coordinate system. This 
    class is only to used a mark a any Coordinate System reference in a code as "undefined".

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSUnknownCoordinateSystem
    """

class TGIS_CSGeographicCoordinateSystemList( TGIS_CSAbstractList ):
    """
    List of all Geographic Coordinate Systems.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSGeographicCoordinateSystemList
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSGeographicCoordinateSystemList.Create_void
        """
        pass

    @overload
    def Add(
      self,
      _epsg: int,
      _wkt: str,
      _datum: int,
      _prime_meridian: int,
      _units: int
    ) -> TGIS_CSGeographicCoordinateSystem: 
        """
        Add new item into the list.

        Args:
            _epsg: EPSG code for the GCS; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the GCS
            _datum: EPSG code for the datum
            _prime_meridian: EPSG code for the prime meridian
            _units: EPSG code for the unit

        Returns:
            Newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSGeographicCoordinateSystemList.Add_Integer_String_Integer_Integer_Integer
        """
        pass

    @overload
    def Add(
      self,
      _epsg: int,
      _wkt: str,
      _datum: int,
      _prime_meridian: int,
      _units: int,
      _reversed: bool,
      _area: int
    ) -> TGIS_CSGeographicCoordinateSystem: 
        """
        Add new item into the list.

        Args:
            _epsg: EPSG code for the GCS; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the GCS
            _datum: EPSG code for the datum
            _prime_meridian: EPSG code for the prime meridian
            _units: EPSG code for the unit
            _reversed: True if coordinates are not in Easting-Northing order
            _area: EPSG code for the area of validity

        Returns:
            Newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSGeographicCoordinateSystemList.Add_Integer_String_Integer_Integer_Integer_Boolean_Integer
        """
        pass

    def ByEPSG(
      self,
      _epsg: int
    ) -> TGIS_CSGeographicCoordinateSystem: 
        """
        Find object on the list based on EPSG code.

        Args:
            _epsg: EPSG code

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSGeographicCoordinateSystemList.ByEPSG_Integer
        """
        pass

    def ByWKT(
      self,
      _wkt: str
    ) -> TGIS_CSGeographicCoordinateSystem: 
        """
        Find object on the list based on WKT string.

        Args:
            _wkt: WKT name

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSGeographicCoordinateSystemList.ByWKT_String
        """
        pass

    def Fix(
      self,
      _epsg: int,
      _wkt: str,
      _datum: int,
      _prime_meridian: int,
      _units: int,
      _reversed: bool,
      _area: int
    ) -> TGIS_CSGeographicCoordinateSystem: 
        """
        Fix item by substituting exiting item based on EPSG code.

        Args:
            _epsg: EPSG code for the GCS; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the GCS
            _datum: EPSG code for the datum
            _prime_meridian: EPSG code for the prime meridian
            _units: EPSG code for the unit
            _reversed: True if coordinates are not in Easting-Northing order
            _area: EPSG code for the area of validity

        Returns:
            Newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSGeographicCoordinateSystemList.Fix_Integer_String_Integer_Integer_Integer_Boolean_Integer
        """
        pass

    @overload
    def Prepare(
      self,
      _epsg: int,
      _wkt: str,
      _datum: int,
      _prime_meridian: int,
      _units: int
    ) -> TGIS_CSGeographicCoordinateSystem: 
        """
        Prepare a TGIS_CSGeographicCoordinateSystem object. If the matching object does not 
        exists then will be added to the list and returned. If the object can be found then 
        it will be returned from the list.

        Args:
            _epsg: EPSG code for the GCS; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the GCS
            _datum: EPSG code for the datum
            _prime_meridian: EPSG code for the prime meridian
            _units: EPSG code for the unit

        Returns:
            Found or newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSGeographicCoordinateSystemList.Prepare_Integer_String_Integer_Integer_Integer
        """
        pass

    @overload
    def Prepare(
      self,
      _epsg: int,
      _wkt: str,
      _datum: int,
      _prime_meridian: int,
      _units: int,
      _reversed: bool,
      _area: int
    ) -> TGIS_CSGeographicCoordinateSystem: 
        """
        Prepare a TGIS_CSGeographicCoordinateSystem object. If the matching object does not 
        exists then will be added to the list and returned. If the object can be found then 
        it will be returned from the list.

        Args:
            _epsg: EPSG code for the GCS; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the GCS
            _datum: EPSG code for the datum
            _prime_meridian: EPSG code for the prime meridian
            _units: EPSG code for the unit
            _reversed: True if coordinates are not in Easting-Northing order
            _area: EPSG code for the area of validity

        Returns:
            Found or newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSGeographicCoordinateSystemList.Prepare_Integer_String_Integer_Integer_Integer_Boolean_Integer
        """
        pass

class TGIS_CSProjectedCoordinateSystemList( TGIS_CSAbstractList ):
    """
    List of all Projected Coordinate Systems.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystemList
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystemList.Create_void
        """
        pass

    @overload
    def Add(
      self,
      _epsg: int,
      _wkt: str,
      _geogcs: int,
      _units: int,
      _projection: int,
      _parameters: TGIS_CSProjParameters
    ) -> TGIS_CSProjectedCoordinateSystem: 
        """
        Add new item into the list.

        Args:
            _epsg: EPSG code for the PCS
            _wkt: WKT name for the PCS
            _geogcs: EPSG code for the GCS
            _units: EPSG code for units
            _projection: EPSG code for the projection
            _parameters: projection parameters

        Returns:
            Newly created object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystemList.Add_Integer_String_Integer_Integer_Integer_TGIS_CSProjParameters
        """
        pass

    @overload
    def Add(
      self,
      _epsg: int,
      _wkt: str,
      _geogcs: int,
      _units: int,
      _projection: int,
      _parameters: TGIS_CSProjParameters,
      _reversed: bool,
      _area: int
    ) -> TGIS_CSProjectedCoordinateSystem: 
        """
        Add new item into the list.

        Args:
            _epsg: EPSG code for the PCS
            _wkt: WKT name for the PCS
            _geogcs: EPSG code for the GCS
            _units: EPSG code for units
            _projection: EPSG code for the projection
            _parameters: projection parameters
            _reversed: True if coordinates are not in Easting-Northing order
            _area: EPSG code for the area of validity

        Returns:
            Newly created object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystemList.Add_Integer_String_Integer_Integer_Integer_TGIS_CSProjParameters_Boolean_Integer
        """
        pass

    def ByEPSG(
      self,
      _epsg: int
    ) -> TGIS_CSProjectedCoordinateSystem: 
        """
        Find object on the list based on EPSG code.

        Args:
            _epsg: EPSG code

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystemList.ByEPSG_Integer
        """
        pass

    def ByWKT(
      self,
      _wkt: str
    ) -> TGIS_CSProjectedCoordinateSystem: 
        """
        Find object on the list based on WKT string.

        Args:
            _wkt: WKT name

        Returns:
            Found object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystemList.ByWKT_String
        """
        pass

    def DefaultParams(
      self,
      _proj_epsg: int
    ) -> TGIS_CSProjParameters: 
        """
        Return clear (initialized) projection parameters (to be used by Prepare command)

        Args:
            _proj_epsg: EPSG code for projection

        Returns:
            Default parameters for selected projection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystemList.DefaultParams_Integer
        """
        pass

    def DefaultParamsForUTM(
      self,
      _zone: int
    ) -> TGIS_CSProjParameters: 
        """
        Return initialized Transverse Mercator projection parameters for Universal TransverseMercator 
        zone. (to be used by Prepare command)

        Args:
            _zone: UTM zone; negative values represent south hemisphere zone

        Returns:
            Transverse Mercator object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystemList.DefaultParamsForUTM_Integer
        """
        pass

    def EmptyParams(
      self
    ) -> TGIS_CSProjParameters: 
        """
        Return clear (initialized) projection parameters (to be used by Prepare command)

        Returns:
            Emptied parameters .

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystemList.EmptyParams_void
        """
        pass

    def Fix(
      self,
      _epsg: int,
      _wkt: str,
      _geogcs: int,
      _units: int,
      _projection: int,
      _parameters: TGIS_CSProjParameters,
      _reversed: bool,
      _area: int
    ) -> TGIS_CSProjectedCoordinateSystem: 
        """
        Fix item by substituting exiting item based on EPSG code.

        Args:
            _epsg: EPSG code for the GCS; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the PCS
            _geogcs: EPSG code for the GCS
            _units: EPSG code for units
            _projection: EPSG code for the projection
            _parameters: projection parameters
            _reversed: True if coordinates are not in Easting-Northing order
            _area: EPSG code for the area of validity

        Returns:
            Newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystemList.Fix_Integer_String_Integer_Integer_Integer_TGIS_CSProjParameters_Boolean_Integer
        """
        pass

    @overload
    def Prepare(
      self,
      _epsg: int,
      _wkt: str,
      _geogcs: int,
      _units: int,
      _projection: int,
      _parameters: TGIS_CSProjParameters
    ) -> TGIS_CSProjectedCoordinateSystem: 
        """
        Prepare a TGIS_CSProjectedCoordinateSystem object. If the matching object does not 
        exists then will be added to the list and returned. If the object can be found then 
        it will be returned from the list.

        Args:
            _epsg: EPSG code for the GCS; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the PCS
            _geogcs: EPSG code for the GCS
            _units: EPSG code for units
            _projection: EPSG code for the projection
            _parameters: projection parameters

        Returns:
            Newly created object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystemList.Prepare_Integer_String_Integer_Integer_Integer_TGIS_CSProjParameters
        """
        pass

    @overload
    def Prepare(
      self,
      _epsg: int,
      _wkt: str,
      _geogcs: int,
      _units: int,
      _projection: int,
      _parameters: TGIS_CSProjParameters,
      _reversed: bool,
      _area: int
    ) -> TGIS_CSProjectedCoordinateSystem: 
        """
        Prepare a TGIS_CSProjectedCoordinateSystem object. If the matching object does not 
        exists then will be added to the list and returned. If the object can be found then 
        it will be returned from the list.

        Args:
            _epsg: EPSG code for the GCS; if 0 then EPSG will be assigned from user defined, 
              temporary pool
            _wkt: WKT name for the PCS
            _geogcs: EPSG code for the GCS
            _units: EPSG code for units
            _projection: EPSG code for the projection
            _parameters: projection parameters
            _reversed: True if coordinates are not in Easting-Northing order
            _area: EPSG code for the area of validity

        Returns:
            Newly created object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CSProjectedCoordinateSystemList.Prepare_Integer_String_Integer_Integer_Integer_TGIS_CSProjParameters_Boolean_Integer
        """
        pass

class TGIS_CUDADeviceInfo( TObject ):
    """
    Provides information about a CUDA device.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDADeviceInfo
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDADeviceInfo.Create_void
        """
        pass

    @property
    def APIVersion(
      self
    ) -> int: 
        """
        API version of the context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDADeviceInfo.APIVersion
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Device name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDADeviceInfo.Name
        """
        pass

    @property
    def TotalMemory(
      self
    ) -> NativeUInt: 
        """
        Total memory available on the device.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDADeviceInfo.TotalMemory
        """
        pass

class TGIS_CUDAEngine( TObject ):
    """
    Provides the means to initialize and enable the CUDA computing engine.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAEngine
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAEngine.Create_void
        """
        pass

    @property
    def Available(
      self
    ) -> bool: 
        """
        True if CUDA is available; calling this property attempts to initialize CUDA.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAEngine.Available
        """
        pass

    @property
    def DeviceCount(
      self
    ) -> int: 
        """
        Number of CUDA devices.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAEngine.DeviceCount
        """
        pass

    
    def Devices(
      self,
      _idx: int
    ) -> TGIS_CUDADeviceInfo: 
        """
        List of CUDA devices.

        Args:
            _idx: index of the device

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAEngine.Devices
        """
        pass

    @property
    def DriverVersion(
      self
    ) -> int: 
        """
        CUDA driver version.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAEngine.DriverVersion
        """
        pass

    @property
    def Enabled(
      self
    ) -> bool: 
        """
        Specifies if CUDA should be used whenever possible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAEngine.Enabled
        """
        pass

    @Enabled.setter
    def Enabled(
      self,
      _value: bool
    ) -> None: 
        """
        Specifies if CUDA should be used whenever possible.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAEngine.Enabled
        """
        pass

    @property
    def Initialized(
      self
    ) -> bool: 
        """
        True if CUDA is initialized.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAEngine.Initialized
        """
        pass

class TGIS_CUDAProgram( TObject ):
    """
    Provides the means to execute a CUDA program.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.Create_void
        """
        pass

    def CheckArgument(
      self,
      _idx: int
    ) -> bool: 
        """
        Checks if an argument of the active kernel has been propertly set.

        Args:
            _idx: index of the argument

        Returns:
            True if the argument has been properly set

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.CheckArgument_Integer
        """
        pass

    def EnqueueKernel(
      self,
      _kernel: str
    ) -> bool: 
        """
        Enqueues a kernel for execution and sets it as the active kernel.

        Args:
            _kernel: name of the kernel function

        Returns:
            True if the kernel was successfully enqueued

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.EnqueueKernel_String
        """
        pass

    def Execute(
      self
    ) -> bool: 
        """
        Executes the CUDA program.

        Returns:
            True if the program has finished successfully

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.Execute_void
        """
        pass

    def LoadFromFile(
      self,
      _path: str,
      _kernel: str
    ) -> bool: 
        """
        Loads a CUDA program (cubin, PTX or fatbin image) from a text file and enqueues a 
        kernel for execution.

        Args:
            _path: path to the file
            _kernel: name of the kernel function

        Returns:
            True if the program was successfully loaded

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.LoadFromFile_String_String
        """
        pass

    def LoadFromString(
      self,
      _source: str,
      _kernel: str
    ) -> bool: 
        """
        Loads a CUDA program from a string (cubin, PTX or fatbin image) and enqueues a kernel 
        for execution.

        Args:
            _source: source of the program
            _kernel: name of the kernel function

        Returns:
            True if the program was successfully loaded

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.LoadFromString_String_String
        """
        pass

    def ReadArgument(
      self,
      _idx: int,
      _size: int,
      _data: Pointer
    ) -> bool: 
        """
        Reads an argument of the active kernel.

        Args:
            _idx: index of the argument
            _size: size of the argument (in bytes)
            _data: buffer to be filled

        Returns:
            True if the argument has been successfully read

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.ReadArgument_Integer_Integer_Pointer
        """
        pass

    def SetArgument(
      self,
      _idx: int,
      _size: int,
      _data: Pointer
    ) -> bool: 
        """
        Sets an argument of the active kernel.

        Args:
            _idx: index of the argument
            _size: size of the argument (in bytes)
            _data: data of the argument

        Returns:
            True if the argument has been properly set

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.SetArgument_Integer_Integer_Pointer
        """
        pass

    def ShareArgument(
      self,
      _idx: int,
      _keridx: int,
      _argidx: int
    ) -> bool: 
        """
        Sets a argument of the active kernel with a argument already set for another kernel.

        Args:
            _idx: index of the argument
            _keridx: index of the owner kernel
            _argidx: index of the owner kernel argument

        Returns:
            True if the argument has been properly set

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.ShareArgument_Integer_Integer_Integer
        """
        pass

    
    def BlockDimensions(
      self,
      _idx: int
    ) -> NativeUInt: 
        """
        Block dimensions of the active kernel.

        Args:
            _idx: index of the block dimension

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.BlockDimensions
        """
        pass

    
    def BlockDimensions(
      self,
      _idx: int,
      _value: NativeUInt
    ) -> None: 
        """
        Block dimensions of the active kernel.

        Args:
            _idx: index of the block dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.BlockDimensions
        """
        pass

    @property
    def ErrorCode(
      self
    ) -> int: 
        """
        Last error code returned by the CUDA engine.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.ErrorCode
        """
        pass

    @property
    def ErrorName(
      self
    ) -> str: 
        """
        String representation of the last error returned by the CUDA engine.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.ErrorName
        """
        pass

    @property
    def ErrorString(
      self
    ) -> str: 
        """
        String description of the last error returned by the CUDA engine.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.ErrorString
        """
        pass

    
    def GridDimensions(
      self,
      _idx: int
    ) -> NativeUInt: 
        """
        Grid dimensions of the active kernel.

        Args:
            _idx: index of the grid dimension

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.GridDimensions
        """
        pass

    
    def GridDimensions(
      self,
      _idx: int,
      _value: NativeUInt
    ) -> None: 
        """
        Grid dimensions of the active kernel.

        Args:
            _idx: index of the grid dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.GridDimensions
        """
        pass

    @property
    def KernelCount(
      self
    ) -> int: 
        """
        Number of enqueued kernels of the CUDA program.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.KernelCount
        """
        pass

    @property
    def KernelIndex(
      self
    ) -> int: 
        """
        Index of the active kernel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.KernelIndex
        """
        pass

    @KernelIndex.setter
    def KernelIndex(
      self,
      _value: int
    ) -> None: 
        """
        Index of the active kernel.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.KernelIndex
        """
        pass

    @property
    def KernelName(
      self
    ) -> str: 
        """
        Name of the active kernel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CUDAProgram.KernelName
        """
        pass

class TGIS_DataSet( TDataSet, IGIS_Subscribe ):
    """
    Dataset providing data from the TGIS_LayerVector.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet
    """

    @overload
    def __init__(
      self,
      _owner: TComponent
    ) -> None: 
        """
        Create dataset.

        Args:
            _owner: component owner

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.Create_TComponent
        """
        pass

    def GotoShape(
      self,
      _uid: TGIS_Uid
    ) -> bool: 
        """
        Go to record and make it active based on shape UID.

        Args:
            _uid: uid of shape to be found

        Returns:
            True if record found.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.GotoShape_TGIS_Uid
        """
        pass

    @overload
    def Open(
      self,
      _layer: TGIS_LayerVector,
      _extent: TGIS_Extent,
      _query: str,
      _shape: TGIS_Shape,
      _de9im: str,
      _skipDeleted: bool,
      _maxRecords: int
    ) -> None: 
        """
        Open the database which meets extent and query. Will use RTree if available.

        Args:
            _layer: source layer for the dataset
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space
            _query: query which must be matched by item; closely mimics SQL WHERE clause; for 
              examples you can use ''AGE &gt;= 18''; empty (default) means that no items will match.
            _shape: if not nil, then only shapes matched dm9 matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _skipDeleted: set a skip deleted treatment; by default deleted items will be ignored
            _maxRecords: maximum number of records to be returned; default is -1 which means 
              no limit; 0 means that only structure will be filled

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.Open_TGIS_LayerVector_TGIS_Extent_String_TGIS_Shape_String_Boolean_Integer
        """
        pass

    @overload
    def Open(
      self,
      _layer: TGIS_LayerVector,
      _extent: TGIS_Extent
    ) -> None: 
        """
        Open the database which meets extent and query. Will use RTree if available.

        Args:
            _layer: source layer for the dataset
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.Open_TGIS_LayerVector_TGIS_Extent
        """
        pass

    def SubscribedEvent(
      self,
      _sender: TObject,
      _event: int,
      _context: TObject
    ) -> None: 
        """
        Subscriber notification event.

        Args:
            _sender: sender object
            _event: event identifier
            _context: context object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.SubscribedEvent_TObject_Integer_TObject
        """
        pass

    @property
    def ActiveShape(
      self
    ) -> TGIS_Shape: 
        """
        Current shape of the dataset (shape based on ActiveRecord) or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.ActiveShape
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_LayerVector: 
        """
        Current layer of the dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.Layer
        """
        pass

    @property
    def ReadOnly(
      self
    ) -> bool: 
        """
        If true, displayed fields will be read only.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.ReadOnly
        """
        pass

    @ReadOnly.setter
    def ReadOnly(
      self,
      _value: bool
    ) -> None: 
        """
        If true, displayed fields will be read only.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.ReadOnly
        """
        pass

    @property
    def ShowInternalFields(
      self
    ) -> bool: 
        """
        Show or hide internal layer fields.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.ShowInternalFields
        """
        pass

    @ShowInternalFields.setter
    def ShowInternalFields(
      self,
      _value: bool
    ) -> None: 
        """
        Show or hide internal layer fields.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.ShowInternalFields
        """
        pass

    @property
    def ShowVirtualFields(
      self
    ) -> bool: 
        """
        Show or hide virtual layer fields.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.ShowVirtualFields
        """
        pass

    @ShowVirtualFields.setter
    def ShowVirtualFields(
      self,
      _value: bool
    ) -> None: 
        """
        Show or hide virtual layer fields.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.ShowVirtualFields
        """
        pass

    @property
    def VirtualFields(
      self
    ) -> typing.Sequence[TGIS_VirtualField]: 
        """
        The set of virtual fields that are displayed when ShowVirtualFields property is active.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.VirtualFields
        """
        pass

    @VirtualFields.setter
    def VirtualFields(
      self,
      _value: typing.Sequence[TGIS_VirtualField]
    ) -> None: 
        """
        The set of virtual fields that are displayed when ShowVirtualFields property is active.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.VirtualFields
        """
        pass

    @property
    def OnBusy(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        OnBusy event. Will be fired regularly during long-drawn operations. If end value 
        will be zero, the meaning is: long-drawn with unknown end time. Close long-drawn 
        operation by calling with parameters (-1,-1).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.OnBusy
        """
        pass

    @OnBusy.setter
    def OnBusy(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        OnBusy event. Will be fired regularly during long-drawn operations. If end value 
        will be zero, the meaning is: long-drawn with unknown end time. Close long-drawn 
        operation by calling with parameters (-1,-1).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DataSet.OnBusy
        """
        pass

class TGIS_DemSlopeMode:
    pass

class TGIS_DemSlopeMode:
    """
    Degrees or Percent slope mode.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemSlopeMode
    """

    @property
    def Percent(
      self
    ) -> TGIS_DemSlopeMode: 
        """
        expressed as percentage.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemSlopeMode.Percent
        """
        pass

    @property
    def Degrees(
      self
    ) -> TGIS_DemSlopeMode: 
        """
        expressed as degrees.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemSlopeMode.Degrees
        """
        pass

class TGIS_DemTotalCurvatureMode:
    pass

class TGIS_DemTotalCurvatureMode:
    """
    Total Curvature Modes.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemTotalCurvatureMode
    """

    @property
    def Profile(
      self
    ) -> TGIS_DemTotalCurvatureMode: 
        """
        parallel to the slope

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemTotalCurvatureMode.Profile
        """
        pass

    @property
    def Plan(
      self
    ) -> TGIS_DemTotalCurvatureMode: 
        """
        perpendicular to the direction of the maximum slope

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemTotalCurvatureMode.Plan
        """
        pass

class TGIS_DemOperation:
    """
    Basic operation definition to run on dem.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperation
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperation.Create_void
        """
        pass

    def Description(
      self
    ) -> str: 
        """
        Get operation description.

        Returns:
            text.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperation.Description_void
        """
        pass

    def Prepare(
      self
    ) -> None: 
        """
        Prepare operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperation.Prepare_void
        """
        pass

    def Run(
      self
    ) -> float: 
        """
        Run operation.

        Returns:
            Calculated value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperation.Run_void
        """
        pass

class TGIS_DemOperationSlope( TGIS_DemOperation ):
    """
    Generate a slope map from elevation raster.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationSlope
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationSlope.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _mode: TGIS_DemSlopeMode,
      _scale: float
    ) -> None: 
        """
        Constructor.

        Args:
            _mode: Slope mode
            _scale: Ratio of vertical units to horizontal.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationSlope.Create_TGIS_DemSlopeMode_Double
        """
        pass

class TGIS_DemOperationSlopeHydro( TGIS_DemOperation ):
    """
    Generate a hydrological slope map from elevation raster.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationSlopeHydro
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationSlopeHydro.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _mode: TGIS_DemSlopeMode,
      _scale: float
    ) -> None: 
        """
        Constructor.

        Args:
            _mode: Slope mode
            _scale: Ratio of vertical units to horizontal.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationSlopeHydro.Create_TGIS_DemSlopeMode_Double
        """
        pass

class TGIS_DemOperationHillShade( TGIS_DemOperation ):
    """
    Generate a shaded relief map from elevation raster.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationHillShade
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationHillShade.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _zfactor: float,
      _azimuth: float,
      _altitude: float,
      _combined: bool
    ) -> None: 
        """
        Constructor.

        Args:
            _zfactor: vertical exaggeration used to pre-multiply the elevations
            _azimuth: azimuth of the light, in degrees
            _altitude: altitude of the light, in degrees
            _combined: a combination of slope and oblique shading

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationHillShade.Create_Double_Double_Double_Boolean
        """
        pass

class TGIS_DemOperationAspect( TGIS_DemOperation ):
    """
    Generate an aspect map from elevation raster.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationAspect
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationAspect.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _angleAsAzimuth: bool
    ) -> None: 
        """
        Constructor.

        Args:
            _angleAsAzimuth: return trigonometric angle instead of azimuth

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationAspect.Create_Boolean
        """
        pass

class TGIS_DemOperationTRI( TGIS_DemOperation ):
    """
    Generate a Terrain Ruggedness Index map from elevation raster.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationTRI
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationTRI.Create_void
        """
        pass

class TGIS_DemOperationTPI( TGIS_DemOperation ):
    """
    Generate a Topographic Position Index map from elevation raster.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationTPI
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationTPI.Create_void
        """
        pass

class TGIS_DemOperationRoughness( TGIS_DemOperation ):
    """
    Generate a roughness map from elevation raster.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationRoughness
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationRoughness.Create_void
        """
        pass

class TGIS_DemOperationTotalCurvature( TGIS_DemOperation ):
    """
    Generate a total curvature map from elevation raster.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationTotalCurvature
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationTotalCurvature.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _mode: TGIS_DemTotalCurvatureMode
    ) -> None: 
        """
        Constructor.

        Args:
            _mode: curvature mode

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationTotalCurvature.Create_TGIS_DemTotalCurvatureMode
        """
        pass

class TGIS_DemOperationMatrixGain( TGIS_DemOperation ):
    """
    Generate a matrix gained map from elevation raster.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationMatrixGain
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationMatrixGain.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _matrix: TGIS_Matrix3x3,
      _gainFactor: float
    ) -> None: 
        """
        Constructor.

        Args:
            _matrix: gain matrix
            _gainFactor: gain factor

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationMatrixGain.Create_TGIS_Matrix3x3_Double
        """
        pass

class TGIS_DemOperationFlowDir( TGIS_DemOperation ):
    """
    Generate a flow directions map from elevation raster.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationFlowDir
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemOperationFlowDir.Create_void
        """
        pass

class TGIS_DemGenerator( TObject ):
    """
    Fast DEM operations on a 3x3 pixel window.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemGenerator
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemGenerator.Create_void
        """
        pass

    def Process(
      self,
      _input: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _output: TGIS_LayerPixel,
      _operation: TGIS_DemOperation,
      _onbusy: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        Process dem operation.

        Args:
            _input: source layer
            _extent: extent to process
            _output: destination layer
            _operation: operation to process
            _onbusy: Busy event; the value is a callback to a method with parameters defined 
              by TGIS_BusyEvent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DemGenerator.Process_TGIS_LayerPixel_TGIS_Extent_TGIS_LayerPixel_TGIS_DemOperation_TGIS_BusyEvent
        """
        pass

class TGIS_EditorAction:
    pass

class TGIS_EditorAction:
    """
    For internal use of TGIS_Editor. Basic mode editing operations.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorAction
    """

    @property
    def Add(
      self
    ) -> TGIS_EditorAction: 
        """
        Point will be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorAction.Add
        """
        pass

    @property
    def Move(
      self
    ) -> TGIS_EditorAction: 
        """
        Point will be moved.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorAction.Move
        """
        pass

    @property
    def Delete(
      self
    ) -> TGIS_EditorAction: 
        """
        Point will be deleted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorAction.Delete
        """
        pass

    @property
    def Locate(
      self
    ) -> TGIS_EditorAction: 
        """
        Point will be located as current.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorAction.Locate
        """
        pass

    @property
    def Group(
      self
    ) -> TGIS_EditorAction: 
        """
        custom edit modes will be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorAction.Group
        """
        pass

class TGIS_Editor( TObject, IGIS_Editor ):
    """
    Editor encapsulation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor
    """

    @overload
    def __init__(
      self,
      _viewer: TObject
    ) -> None: 
        """
        Create an instance of editor inside TGIS_Viewer.

        Args:
            _viewer: TGIS_Viewer in which editor must be created

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.Create_TObject
        """
        pass

    def AddPoint(
      self,
      _ptg: TGIS_Point3D
    ) -> None: 
        """
        Add a new point.

        Args:
            _ptg: point to be added; expected Viewer coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.AddPoint_TGIS_Point3D
        """
        pass

    def AddPointEx(
      self,
      _ptg: TGIS_Point3D
    ) -> None: 
        """
        Add a new point for a group.

        Args:
            _ptg: point to be added; expected Viewer coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.AddPointEx_TGIS_Point3D
        """
        pass

    def AddSnapLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> int: 
        """
        Add a snap-to layer to the list.

        Args:
            _layer: layer to snap

        Returns:
            index of added layer on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.AddSnapLayer_TGIS_LayerAbstract
        """
        pass

    def ChangeWinding(
      self
    ) -> None: 
        """
        Change winding of the current part. Valid and important only for polygons. Thanks 
        to this, the whole inside polygon can be transparent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.ChangeWinding_void
        """
        pass

    def ClearSnapLayers(
      self
    ) -> None: 
        """
        Clear the list of snap-to layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.ClearSnapLayers_void
        """
        pass

    def CreatePart(
      self,
      _ptg: TGIS_Point3D
    ) -> None: 
        """
        Create and activate the editing procedure for a new part for the current shape.

        Args:
            _ptg: "starting" point of a new part to be created; expected Viewer coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.CreatePart_TGIS_Point3D
        """
        pass

    @overload
    def CreateShape(
      self,
      _layer: TGIS_LayerAbstract,
      _ptg: TGIS_Point,
      _type: TGIS_ShapeType
    ) -> None: 
        """
        Create and activate editing of a new shape.

        Args:
            _layer: TGIS_Layer which will own new shape
            _ptg: "starting" of a new shape to be created; expected Viewer coordinate system
            _type: type of shape to be created; it must be type supported by layer; if TGIS_ShapeType.Unknown 
              then shape of default type will be created

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.CreateShape_TGIS_LayerAbstract_TGIS_Point_TGIS_ShapeType
        """
        pass

    @overload
    def CreateShape(
      self,
      _layer: TGIS_LayerAbstract,
      _ptg: TGIS_Point3D,
      _type: TGIS_ShapeType
    ) -> None: 
        """
        Create and activate editing of a new shape.

        Args:
            _layer: TGIS_Layer which will own new shape
            _ptg: "starting" 3D of a new shape to be created; expected Viewer coordinate system
            _type: type of shape to be created; it must be type supported by layer; if TGIS_DimensionType.Unknown 
              then shape of default type will be created

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.CreateShape_TGIS_LayerAbstract_TGIS_Point3D_TGIS_ShapeType
        """
        pass

    @overload
    def CreateShape(
      self,
      _layer: TGIS_LayerAbstract,
      _ptg: TGIS_Point3D,
      _type: TGIS_ShapeType,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create and activate editing of a new shape.

        Args:
            _layer: TGIS_Layer which will own new shape
            _ptg: "starting" 3D of a new shape to be created; expected Viewer coordinate system
            _type: type of shape to be created; it must be type supported by layer; if TGIS_ShapeType.Unknown 
              then shape of default type will be created
            _dim: dimension of shape to be created; it must be type supported by layer; if TGIS_ShapeType.Unknown 
              then shape of default dimension will be created

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.CreateShape_TGIS_LayerAbstract_TGIS_Point3D_TGIS_ShapeType_TGIS_DimensionType
        """
        pass

    def DeletePart(
      self
    ) -> None: 
        """
        Delete current part from shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.DeletePart_void
        """
        pass

    def DeletePoint(
      self,
      _pos: int
    ) -> None: 
        """
        Delete a point from the current part of the currently edited shape.

        Args:
            _pos: the point which will be deleted; points are counted from 1;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.DeletePoint_Integer
        """
        pass

    def DeletePointEx(
      self,
      _pos: int
    ) -> None: 
        """
        Delete a point from the current part of the currently edited shape.

        Args:
            _pos: the point which will be deleted; points are counted from 0;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.DeletePointEx_Integer
        """
        pass

    def DeleteShape(
      self
    ) -> None: 
        """
        Delete currently edited shape and end editing.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.DeleteShape_void
        """
        pass

    def EditShape(
      self,
      _shp: TGIS_ShapeAbstract,
      _part: int
    ) -> None: 
        """
        Starts editing of a shape given by _shp. Only the part given by _part will be in 
        edit mode.

        Args:
            _shp: shape to be edited
            _part: part in _shape to be edited

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.EditShape_TGIS_ShapeAbstract_Integer
        """
        pass

    def EndEdit(
      self
    ) -> None: 
        """
        End editing of the shape given by EditShape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.EndEdit_void
        """
        pass

    def FindSnapLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> bool: 
        """
        Find a snap layer on the list.

        Args:
            _layer: layer to snap

        Returns:
            True if layer is on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.FindSnapLayer_TGIS_LayerAbstract
        """
        pass

    def FindSnapPoint(
      self,
      _pt: TPoint,
      _ptg: VarParameter,
      _snapType: VarParameter
    ) -> bool: 
        """
        Find a snap point based on a snap type from snap-to layers.

        Args:
            _pt: Mouse position
            _ptg: found snap point coordinates; the value (in/out) is passed as TGIS_Point in 
              _ptg.Value property
            _snapType: found type of snap point (vertex, edge, intersection, midpoint ); the 
              value (in/out) is passed as TGIS_EditorSnapResultType in _snapType.Value property

        Returns:
            True if any snap point was found

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.FindSnapPoint_TPoint_TGIS_Point_TGIS_EditorSnapResultType
        """
        pass

    def InsertPoint(
      self,
      _pos: int,
      _ptg: TGIS_Point3D
    ) -> None: 
        """
        Insert a point to the current part of the currently edited shape.

        Args:
            _pos: where point must be inserted; points are counted from 0
            _ptg: point to be inserted; expected Viewer coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.InsertPoint_Integer_TGIS_Point3D
        """
        pass

    def InsertPointEx(
      self,
      _pos: int,
      _ptg: TGIS_Point3D
    ) -> None: 
        """
        Insert a point to the current part of the currently edited shape for a group.

        Args:
            _pos: where point must be inserted; points are counted from 0
            _ptg: point to be inserted; expected Viewer coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.InsertPointEx_Integer_TGIS_Point3D
        """
        pass

    def MouseBegin(
      self,
      _pt: TPoint,
      _nearest: bool
    ) -> None: 
        """
        Start the editing of a point at the location given by _pt.

        Args:
            _pt: start point defined in screen coordinates
            _nearest: if true, then nearest insertion point will be chosen; could be overwritten 
              by Mode property.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.MouseBegin_TPoint_Boolean
        """
        pass

    def MouseEnd(
      self,
      _pt: TPoint
    ) -> None: 
        """
        End of point movement, deletion, or addition.

        Args:
            _pt: new location of point /in screen coordinates/

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.MouseEnd_TPoint
        """
        pass

    def MouseMove(
      self,
      _pt: TPoint
    ) -> None: 
        """
        Continuing of point movement, deletion, or addition.

        Args:
            _pt: new location of point /in screen coordinates/

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.MouseMove_TPoint
        """
        pass

    def MovePoint(
      self,
      _pos: int,
      _ptg: TGIS_Point3D
    ) -> None: 
        """
        Move a point of the current part of the currently edited shape to a new location.

        Args:
            _pos: which point will be moved; points are counted from 1
            _ptg: new location; expected Viewer coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.MovePoint_Integer_TGIS_Point3D
        """
        pass

    def MovePointEx(
      self,
      _pos: int,
      _ptg: TGIS_Point3D
    ) -> None: 
        """
        Move a point of the current part of the currently edited shape to a new location.

        Args:
            _pos: which point will be moved; points are counted from 0
            _ptg: new location; expected Viewer coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.MovePointEx_Integer_TGIS_Point3D
        """
        pass

    def Redo(
      self
    ) -> None: 
        """
        Redo the previous action. This applies only to changes performed on a single part.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.Redo_void
        """
        pass

    def RefreshShape(
      self
    ) -> None: 
        """
        Store the editing buffer back into the shape. Perform screen redraw.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.RefreshShape_void
        """
        pass

    def RemoveSnapLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Remove a snap layer from the list.

        Args:
            _layer: layer to snap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.RemoveSnapLayer_TGIS_LayerAbstract
        """
        pass

    def RevertShape(
      self
    ) -> None: 
        """
        Revert currently edited shape to a saved version.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.RevertShape_void
        """
        pass

    def Undo(
      self
    ) -> None: 
        """
        Undo the last action. This applies only to changes performed on a single part.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.Undo_void
        """
        pass

    @property
    def BlockSnapping(
      self
    ) -> bool: 
        """
        If True, block snapping operations during adding points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.BlockSnapping
        """
        pass

    @BlockSnapping.setter
    def BlockSnapping(
      self,
      _value: bool
    ) -> None: 
        """
        If True, block snapping operations during adding points.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.BlockSnapping
        """
        pass

    @property
    def CanRedo(
      self
    ) -> bool: 
        """
        If True, redo buffer is not empty.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.CanRedo
        """
        pass

    @property
    def CanUndo(
      self
    ) -> bool: 
        """
        If True, undo buffer is not empty.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.CanUndo
        """
        pass

    @property
    def CurrentShape(
      self
    ) -> TGIS_ShapeAbstract: 
        """
        Currently edited shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.CurrentShape
        """
        pass

    @property
    def EditingEdgeLengthsStyle(
      self
    ) -> TGIS_EditorEdgeLengthsStyle: 
        """
        Edges lengths style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.EditingEdgeLengthsStyle
        """
        pass

    @EditingEdgeLengthsStyle.setter
    def EditingEdgeLengthsStyle(
      self,
      _value: TGIS_EditorEdgeLengthsStyle
    ) -> None: 
        """
        Edges lengths style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.EditingEdgeLengthsStyle
        """
        pass

    @property
    def EditingLinesStyle(
      self
    ) -> TGIS_EditorStyle: 
        """
        Editing lines style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.EditingLinesStyle
        """
        pass

    @EditingLinesStyle.setter
    def EditingLinesStyle(
      self,
      _value: TGIS_EditorStyle
    ) -> None: 
        """
        Editing lines style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.EditingLinesStyle
        """
        pass

    @property
    def EditingPointsStyle(
      self
    ) -> TGIS_EditorEditingPointsStyle: 
        """
        Editing points style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.EditingPointsStyle
        """
        pass

    @EditingPointsStyle.setter
    def EditingPointsStyle(
      self,
      _value: TGIS_EditorEditingPointsStyle
    ) -> None: 
        """
        Editing points style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.EditingPointsStyle
        """
        pass

    @property
    def EditorMode(
      self
    ) -> TGIS_EditorModeEx: 
        """
        Determines how new vertices are created relative to existing vertices.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.EditorMode
        """
        pass

    @EditorMode.setter
    def EditorMode(
      self,
      _value: TGIS_EditorModeEx
    ) -> None: 
        """
        Determines how new vertices are created relative to existing vertices.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.EditorMode
        """
        pass

    @property
    def InEdit(
      self
    ) -> bool: 
        """
        If True, editing is active.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.InEdit
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_LayerAbstract: 
        """
        Layer that holds the shape being currently edited.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.Layer
        """
        pass

    @property
    def MinMove(
      self
    ) -> int: 
        """
        Minimal mouse movement to perform a change.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.MinMove
        """
        pass

    @MinMove.setter
    def MinMove(
      self,
      _value: int
    ) -> None: 
        """
        Minimal mouse movement to perform a change.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.MinMove
        """
        pass

    @property
    def Mode(
      self
    ) -> TGIS_EditorMode: 
        """
        Mode of edition. Will control how _nearest parameter of the MouseBegin() behaves 
        and therefore will control editing behavior in TGIS_ViewerWnd.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.Mode
        """
        pass

    @Mode.setter
    def Mode(
      self,
      _value: TGIS_EditorMode
    ) -> None: 
        """
        Mode of edition. Will control how _nearest parameter of the MouseBegin() behaves 
        and therefore will control editing behavior in TGIS_ViewerWnd.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.Mode
        """
        pass

    @property
    def MustRedraw(
      self
    ) -> bool: 
        """
        True if editor should be redraw. State should be canceled after successful rendering.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.MustRedraw
        """
        pass

    @MustRedraw.setter
    def MustRedraw(
      self,
      _value: bool
    ) -> None: 
        """
        True if editor should be redraw. State should be canceled after successful rendering.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.MustRedraw
        """
        pass

    @property
    def Part(
      self
    ) -> int: 
        """
        Part number of currently edited shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.Part
        """
        pass

    
    def Point(
      self,
      _pos: int
    ) -> TGIS_Point3D: 
        """
        Access to individual points in a part. Points are counted from 0 to PointCount.

        Args:
            _pos: index of a point

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.Point
        """
        pass

    
    def Point(
      self,
      _pos: int,
      _value: TGIS_Point3D
    ) -> None: 
        """
        Access to individual points in a part. Points are counted from 0 to PointCount.

        Args:
            _pos: index of a point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.Point
        """
        pass

    @property
    def PointCount(
      self
    ) -> int: 
        """
        Number of points in the current part of the currently edited shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.PointCount
        """
        pass

    @property
    def PointerMode(
      self
    ) -> TGIS_PointerMode: 
        """
        Pointer mode ( mouse, touch or pen ).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.PointerMode
        """
        pass

    @PointerMode.setter
    def PointerMode(
      self,
      _value: TGIS_PointerMode
    ) -> None: 
        """
        Pointer mode ( mouse, touch or pen ).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.PointerMode
        """
        pass

    @property
    def PointPos(
      self
    ) -> int: 
        """
        Position of the currently edited point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.PointPos
        """
        pass

    @PointPos.setter
    def PointPos(
      self,
      _value: int
    ) -> None: 
        """
        Position of the currently edited point.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.PointPos
        """
        pass

    @property
    def SelectTolerance(
      self
    ) -> int: 
        """
        Distance tolerance of vertices selection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SelectTolerance
        """
        pass

    @SelectTolerance.setter
    def SelectTolerance(
      self,
      _value: int
    ) -> None: 
        """
        Distance tolerance of vertices selection.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SelectTolerance
        """
        pass

    @property
    def SelectTolerancePen(
      self
    ) -> int: 
        """
        Distance tolerance of vertices selection upon pen gesture.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SelectTolerancePen
        """
        pass

    @SelectTolerancePen.setter
    def SelectTolerancePen(
      self,
      _value: int
    ) -> None: 
        """
        Distance tolerance of vertices selection upon pen gesture.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SelectTolerancePen
        """
        pass

    @property
    def SelectToleranceTouch(
      self
    ) -> int: 
        """
        Distance tolerance of vertices selection upon touch gesture.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SelectToleranceTouch
        """
        pass

    @SelectToleranceTouch.setter
    def SelectToleranceTouch(
      self,
      _value: int
    ) -> None: 
        """
        Distance tolerance of vertices selection upon touch gesture.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SelectToleranceTouch
        """
        pass

    @property
    def ShowDraggingTrack(
      self
    ) -> bool: 
        """
        Show dragging track upon point move.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.ShowDraggingTrack
        """
        pass

    @ShowDraggingTrack.setter
    def ShowDraggingTrack(
      self,
      _value: bool
    ) -> None: 
        """
        Show dragging track upon point move.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.ShowDraggingTrack
        """
        pass

    @property
    def ShowEdgesLengths(
      self
    ) -> bool: 
        """
        If True, show edges lengths from vertex to vertex.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.ShowEdgesLengths
        """
        pass

    @ShowEdgesLengths.setter
    def ShowEdgesLengths(
      self,
      _value: bool
    ) -> None: 
        """
        If True, show edges lengths from vertex to vertex.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.ShowEdgesLengths
        """
        pass

    @property
    def ShowPoints3D(
      self
    ) -> bool: 
        """
        If True, show the Z coordinates for the vertices.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.ShowPoints3D
        """
        pass

    @ShowPoints3D.setter
    def ShowPoints3D(
      self,
      _value: bool
    ) -> None: 
        """
        If True, show the Z coordinates for the vertices.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.ShowPoints3D
        """
        pass

    @property
    def ShowPointsNumbers(
      self
    ) -> bool: 
        """
        If True, show the vertex numbers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.ShowPointsNumbers
        """
        pass

    @ShowPointsNumbers.setter
    def ShowPointsNumbers(
      self,
      _value: bool
    ) -> None: 
        """
        If True, show the vertex numbers.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.ShowPointsNumbers
        """
        pass

    @property
    def ShowTracking(
      self
    ) -> bool: 
        """
        If True, show vertices to trace from a shape in the snap-to layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.ShowTracking
        """
        pass

    @ShowTracking.setter
    def ShowTracking(
      self,
      _value: bool
    ) -> None: 
        """
        If True, show vertices to trace from a shape in the snap-to layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.ShowTracking
        """
        pass

    @property
    def SnapGridSpacing(
      self
    ) -> float: 
        """
        The spacing of the grid to which points will be snapped.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SnapGridSpacing
        """
        pass

    @SnapGridSpacing.setter
    def SnapGridSpacing(
      self,
      _value: float
    ) -> None: 
        """
        The spacing of the grid to which points will be snapped.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SnapGridSpacing
        """
        pass

    @property
    def SnapLayer(
      self
    ) -> TGIS_LayerAbstract: 
        """
        Layer containing geometry to which edited points will be snapped. After editing start 
        /see: EditShape/ will always be the same as the edited shape layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SnapLayer
        """
        pass

    @SnapLayer.setter
    def SnapLayer(
      self,
      _value: TGIS_LayerAbstract
    ) -> None: 
        """
        Layer containing geometry to which edited points will be snapped. After editing start 
        /see: EditShape/ will always be the same as the edited shape layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SnapLayer
        """
        pass

    @property
    def SnapMargin(
      self
    ) -> int: 
        """
        The distance tolerance from the snap-to feature for a snap to occur.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SnapMargin
        """
        pass

    @SnapMargin.setter
    def SnapMargin(
      self,
      _value: int
    ) -> None: 
        """
        The distance tolerance from the snap-to feature for a snap to occur.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SnapMargin
        """
        pass

    @property
    def SnapToIntersection(
      self
    ) -> bool: 
        """
        If True, enable snap to the point of intersections between shapes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SnapToIntersection
        """
        pass

    @SnapToIntersection.setter
    def SnapToIntersection(
      self,
      _value: bool
    ) -> None: 
        """
        If True, enable snap to the point of intersections between shapes.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SnapToIntersection
        """
        pass

    @property
    def SnapType(
      self
    ) -> TGIS_EditorSnapType: 
        """
        Snap type - how to snap to a vertex or segment.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SnapType
        """
        pass

    @SnapType.setter
    def SnapType(
      self,
      _value: TGIS_EditorSnapType
    ) -> None: 
        """
        Snap type - how to snap to a vertex or segment.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SnapType
        """
        pass

    @property
    def Uid(
      self
    ) -> TGIS_Uid: 
        """
        Uid of currently edited shape or -1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.Uid
        """
        pass

    @property
    def Viewer(
      self
    ) -> TObject: 
        """
        Viewer on which editor has been created.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.Viewer
        """
        pass

    @property
    def ViewerEnabled(
      self
    ) -> bool: 
        """
        Set to true if Editor Mode is enabled in a TGIS_ViewerWnd.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.ViewerEnabled
        """
        pass

    @ViewerEnabled.setter
    def ViewerEnabled(
      self,
      _value: bool
    ) -> None: 
        """
        Set to true if Editor Mode is enabled in a TGIS_ViewerWnd.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.ViewerEnabled
        """
        pass

    @property
    def PointChangeEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Point3D, TGIS_EditorOperation, TGIS_Point3D], None]: 
        """
        Event to notify a point change.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.PointChangeEvent
        """
        pass

    @PointChangeEvent.setter
    def PointChangeEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Point3D, TGIS_EditorOperation, TGIS_Point3D], None]
    ) -> None: 
        """
        Event to notify a point change.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.PointChangeEvent
        """
        pass

    @property
    def PointEditingEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Point3D, TPoint], None]: 
        """
        Event to notify editing a point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.PointEditingEvent
        """
        pass

    @PointEditingEvent.setter
    def PointEditingEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Point3D, TPoint], None]
    ) -> None: 
        """
        Event to notify editing a point.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.PointEditingEvent
        """
        pass

    @property
    def SnapPointEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Point3D, Double, TGIS_Point3D, Double], None]: 
        """
        Event to call a custom snap routine.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SnapPointEvent
        """
        pass

    @SnapPointEvent.setter
    def SnapPointEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Point3D, Double, TGIS_Point3D, Double], None]
    ) -> None: 
        """
        Event to call a custom snap routine.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Editor.SnapPointEvent
        """
        pass

class TGIS_EditorPartState:
    """
    For internal use of TGIS_Editor. Status of part editing.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPartState
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPartState.Create_void
        """
        pass

    @property
    def MustCreate(
      self
    ) -> bool: 
        """
        True if new part must be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPartState.MustCreate
        """
        pass

    @MustCreate.setter
    def MustCreate(
      self,
      _value: bool
    ) -> None: 
        """
        True if new part must be added.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPartState.MustCreate
        """
        pass

    @property
    def MustDelete(
      self
    ) -> bool: 
        """
        True if part must be deleted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPartState.MustDelete
        """
        pass

    @MustDelete.setter
    def MustDelete(
      self,
      _value: bool
    ) -> None: 
        """
        True if part must be deleted.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPartState.MustDelete
        """
        pass

    @property
    def PointToAdd(
      self
    ) -> TGIS_Point3D: 
        """
        Point added to a newly created part.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPartState.PointToAdd
        """
        pass

    @PointToAdd.setter
    def PointToAdd(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        Point added to a newly created part.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPartState.PointToAdd
        """
        pass

class TGIS_EditorPointState:
    """
    For internal use of TGIS_Editor. Status of point editing.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.Create_void
        """
        pass

    @property
    def Buf(
      self
    ) -> TGIS_Point3DArray: 
        """
        Buffer for editing - all points in part.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.Buf
        """
        pass

    @Buf.setter
    def Buf(
      self,
      _value: TGIS_Point3DArray
    ) -> None: 
        """
        Buffer for editing - all points in part.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.Buf
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of points in buffer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.Count
        """
        pass

    @Count.setter
    def Count(
      self,
      _value: int
    ) -> None: 
        """
        Number of points in buffer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.Count
        """
        pass

    @property
    def Pos(
      self
    ) -> int: 
        """
        Position of points in buffer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.Pos
        """
        pass

    @Pos.setter
    def Pos(
      self,
      _value: int
    ) -> None: 
        """
        Position of points in buffer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.Pos
        """
        pass

    @property
    def Action(
      self
    ) -> TGIS_EditorAction: 
        """
        Action to be performed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.Action
        """
        pass

    @Action.setter
    def Action(
      self,
      _value: TGIS_EditorAction
    ) -> None: 
        """
        Action to be performed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.Action
        """
        pass

    @property
    def MustDeleteOrMove(
      self
    ) -> bool: 
        """
        If True point must be deleted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.MustDeleteOrMove
        """
        pass

    @MustDeleteOrMove.setter
    def MustDeleteOrMove(
      self,
      _value: bool
    ) -> None: 
        """
        If True point must be deleted.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.MustDeleteOrMove
        """
        pass

    @property
    def Point(
      self
    ) -> TGIS_Point3D: 
        """
        New position of point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.Point
        """
        pass

    @Point.setter
    def Point(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        New position of point.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.Point
        """
        pass

    @property
    def MouseStart(
      self
    ) -> TPoint: 
        """
        Start mouse position - to track minimal movements.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.MouseStart
        """
        pass

    @MouseStart.setter
    def MouseStart(
      self,
      _value: TPoint
    ) -> None: 
        """
        Start mouse position - to track minimal movements.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.MouseStart
        """
        pass

    @property
    def WasMouseBegin(
      self
    ) -> bool: 
        """
        Switched on MouseBegin/MouseEnd.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.WasMouseBegin
        """
        pass

    @WasMouseBegin.setter
    def WasMouseBegin(
      self,
      _value: bool
    ) -> None: 
        """
        Switched on MouseBegin/MouseEnd.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorPointState.WasMouseBegin
        """
        pass

class TGIS_EditorToolArcMode:
    pass

class TGIS_EditorToolArcMode:
    """
    Modes of arc tool.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolArcMode
    """

    @property
    def AmStartEndSecond(
      self
    ) -> TGIS_EditorToolArcMode: 
        """
        Start, end, second point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolArcMode.AmStartEndSecond
        """
        pass

    @property
    def AmStartSecondEnd(
      self
    ) -> TGIS_EditorToolArcMode: 
        """
        Start, second, end point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolArcMode.AmStartSecondEnd
        """
        pass

    @property
    def AmStartCenterEnd(
      self
    ) -> TGIS_EditorToolArcMode: 
        """
        Start, center, end point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolArcMode.AmStartCenterEnd
        """
        pass

    @property
    def AmStartCenterAngle(
      self
    ) -> TGIS_EditorToolArcMode: 
        """
        Start, center point, angle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolArcMode.AmStartCenterAngle
        """
        pass

    @property
    def AmStartCenterChord(
      self
    ) -> TGIS_EditorToolArcMode: 
        """
        Start, center point, chord

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolArcMode.AmStartCenterChord
        """
        pass

    @property
    def AmStartEndAngle(
      self
    ) -> TGIS_EditorToolArcMode: 
        """
        Start, end point, angle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolArcMode.AmStartEndAngle
        """
        pass

    @property
    def AmStartEndRadius(
      self
    ) -> TGIS_EditorToolArcMode: 
        """
        Start, end point, radius

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolArcMode.AmStartEndRadius
        """
        pass

    @property
    def AmCenterStartEnd(
      self
    ) -> TGIS_EditorToolArcMode: 
        """
        Center, start, end point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolArcMode.AmCenterStartEnd
        """
        pass

    @property
    def AmCenterStartAngle(
      self
    ) -> TGIS_EditorToolArcMode: 
        """
        Center, start point, angle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolArcMode.AmCenterStartAngle
        """
        pass

    @property
    def AmCenterStartChord(
      self
    ) -> TGIS_EditorToolArcMode: 
        """
        Center, start point, chord

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolArcMode.AmCenterStartChord
        """
        pass

class TGIS_EditorToolLockedParams:
    """
    Keeps locked parameters for the editor helper.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolLockedParams
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolLockedParams.Create_void
        """
        pass

    def LockAngle(
      self,
      _value: float
    ) -> None: 
        """
        Lock Angle parameter.

        Args:
            _value: lock value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolLockedParams.LockAngle_Double
        """
        pass

    def LockDistance(
      self,
      _value: float
    ) -> None: 
        """
        Lock Distance parameter.

        Args:
            _value: lock value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolLockedParams.LockDistance_Double
        """
        pass

    def LockRelativeAngle(
      self,
      _value: bool
    ) -> None: 
        """
        Lock RelativeAngle parameter.

        Args:
            _value: lock value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolLockedParams.LockRelativeAngle_Boolean
        """
        pass

    @property
    def Angle(
      self
    ) -> float: 
        """
        Angle parameter.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolLockedParams.Angle
        """
        pass

    @Angle.setter
    def Angle(
      self,
      _value: float
    ) -> None: 
        """
        Angle parameter.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolLockedParams.Angle
        """
        pass

    @property
    def Distance(
      self
    ) -> float: 
        """
        Distance parameter.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolLockedParams.Distance
        """
        pass

    @Distance.setter
    def Distance(
      self,
      _value: float
    ) -> None: 
        """
        Distance parameter.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolLockedParams.Distance
        """
        pass

    @property
    def RelativeAngle(
      self
    ) -> bool: 
        """
        Relative Angle parameter.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolLockedParams.RelativeAngle
        """
        pass

    @RelativeAngle.setter
    def RelativeAngle(
      self,
      _value: bool
    ) -> None: 
        """
        Relative Angle parameter.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolLockedParams.RelativeAngle
        """
        pass

class TGIS_EditorToolAbstract:
    """
    Base editor tool class.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Class constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.Create_void
        """
        pass

    def DoCanvasPaint(
      self
    ) -> None: 
        """
        Handle canvas paint.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.DoCanvasPaint_void
        """
        pass

    def DoMouseDown(
      self,
      _pt: TPoint
    ) -> None: 
        """
        Handle mouse down event.

        Args:
            _pt: point position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.DoMouseDown_TPoint
        """
        pass

    def DoMouseMove(
      self,
      _pt: TPoint
    ) -> None: 
        """
        Handle mouse move event.

        Args:
            _pt: point position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.DoMouseMove_TPoint
        """
        pass

    def DoMouseUp(
      self,
      _pt: TPoint
    ) -> None: 
        """
        Handle mouse up event.

        Args:
            _pt: point position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.DoMouseUp_TPoint
        """
        pass

    @property
    def Editor(
      self
    ) -> IGIS_Editor: 
        """
        Editor handle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.Editor
        """
        pass

    @Editor.setter
    def Editor(
      self,
      _value: IGIS_Editor
    ) -> None: 
        """
        Editor handle.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.Editor
        """
        pass

    @property
    def LastPoint(
      self
    ) -> TGIS_Point: 
        """
        Last point created by tool.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.LastPoint
        """
        pass

    @LastPoint.setter
    def LastPoint(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Last point created by tool.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.LastPoint
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_Layer: 
        """
        Layer handle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.Layer
        """
        pass

    @Layer.setter
    def Layer(
      self,
      _value: TGIS_Layer
    ) -> None: 
        """
        Layer handle.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.Layer
        """
        pass

    @property
    def LockedParams(
      self
    ) -> TGIS_EditorToolLockedParams: 
        """
        Handle to locked parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.LockedParams
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Tool name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.Name
        """
        pass

    @property
    def Parent(
      self
    ) -> TObject: 
        """
        Parent handle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.Parent
        """
        pass

    @Parent.setter
    def Parent(
      self,
      _value: TObject
    ) -> None: 
        """
        Parent handle.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.Parent
        """
        pass

    @property
    def Renderer(
      self
    ) -> TGIS_RendererAbstract: 
        """
        Renderer handle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.Renderer
        """
        pass

    @Renderer.setter
    def Renderer(
      self,
      _value: TGIS_RendererAbstract
    ) -> None: 
        """
        Renderer handle.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolAbstract.Renderer
        """
        pass

class TGIS_EditorHelper:
    """
    Helper for drawing extra content on canvas during editing.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper
    """

    @overload
    def __init__(
      self,
      _viewer: IGIS_Viewer
    ) -> None: 
        """
        Class constructor.

        Args:
            _viewer: viewer handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.Create_IGIS_Viewer
        """
        pass

    def DoCanvasPaint(
      self
    ) -> None: 
        """
        Paint on canvas.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.DoCanvasPaint_void
        """
        pass

    def DoEndEdit(
      self
    ) -> None: 
        """
        End editing operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.DoEndEdit_void
        """
        pass

    def DoMouseDown(
      self,
      _pt: TPoint
    ) -> None: 
        """
        Handle mouse down event.

        Args:
            _pt: point position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.DoMouseDown_TPoint
        """
        pass

    def DoMouseMove(
      self,
      _pt: TPoint
    ) -> None: 
        """
        Handle mouse move event.

        Args:
            _pt: point position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.DoMouseMove_TPoint
        """
        pass

    def DoMouseUp(
      self,
      _pt: TPoint
    ) -> None: 
        """
        Handle mouse up event.

        Args:
            _pt: point position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.DoMouseUp_TPoint
        """
        pass

    def DoRedo(
      self
    ) -> None: 
        """
        Redo last action.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.DoRedo_void
        """
        pass

    def DoStartEdit(
      self
    ) -> None: 
        """
        Start editing operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.DoStartEdit_void
        """
        pass

    def DoUndo(
      self
    ) -> None: 
        """
        Undo last action.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.DoUndo_void
        """
        pass

    @property
    def CtrlPressed(
      self
    ) -> bool: 
        """
        True, if ctrl key is pressed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.CtrlPressed
        """
        pass

    @CtrlPressed.setter
    def CtrlPressed(
      self,
      _value: bool
    ) -> None: 
        """
        True, if ctrl key is pressed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.CtrlPressed
        """
        pass

    @property
    def DrawingTool(
      self
    ) -> TGIS_EditorToolAbstract: 
        """
        Drawing tool handle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.DrawingTool
        """
        pass

    @DrawingTool.setter
    def DrawingTool(
      self,
      _value: TGIS_EditorToolAbstract
    ) -> None: 
        """
        Drawing tool handle.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.DrawingTool
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_Layer: 
        """
        Layer handle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.Layer
        """
        pass

    @Layer.setter
    def Layer(
      self,
      _value: TGIS_Layer
    ) -> None: 
        """
        Layer handle.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.Layer
        """
        pass

    @property
    def PolarAngle(
      self
    ) -> float: 
        """
        Angle for polar snap tracing

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.PolarAngle
        """
        pass

    @PolarAngle.setter
    def PolarAngle(
      self,
      _value: float
    ) -> None: 
        """
        Angle for polar snap tracing

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.PolarAngle
        """
        pass

    @property
    def PolarSnapTracing(
      self
    ) -> bool: 
        """
        If True, polar snap tracing is enabled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.PolarSnapTracing
        """
        pass

    @PolarSnapTracing.setter
    def PolarSnapTracing(
      self,
      _value: bool
    ) -> None: 
        """
        If True, polar snap tracing is enabled.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.PolarSnapTracing
        """
        pass

    @property
    def Renderer(
      self
    ) -> TGIS_RendererAbstract: 
        """
        Renderer handle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.Renderer
        """
        pass

    @Renderer.setter
    def Renderer(
      self,
      _value: TGIS_RendererAbstract
    ) -> None: 
        """
        Renderer handle.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.Renderer
        """
        pass

    @property
    def ShiftPressed(
      self
    ) -> bool: 
        """
        True, if shift key is pressed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.ShiftPressed
        """
        pass

    @ShiftPressed.setter
    def ShiftPressed(
      self,
      _value: bool
    ) -> None: 
        """
        True, if shift key is pressed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.ShiftPressed
        """
        pass

    @property
    def SnapTracing(
      self
    ) -> bool: 
        """
        If True, snap tracing is enabled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.SnapTracing
        """
        pass

    @SnapTracing.setter
    def SnapTracing(
      self,
      _value: bool
    ) -> None: 
        """
        If True, snap tracing is enabled.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.SnapTracing
        """
        pass

    @property
    def UpdatingEditor(
      self
    ) -> bool: 
        """
        True, if a tool is updating Editor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.UpdatingEditor
        """
        pass

    @UpdatingEditor.setter
    def UpdatingEditor(
      self,
      _value: bool
    ) -> None: 
        """
        True, if a tool is updating Editor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.UpdatingEditor
        """
        pass

    @property
    def Viewer(
      self
    ) -> IGIS_Viewer: 
        """
        Viewer handle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.Viewer
        """
        pass

    @property
    def NotifyAction(
      self
    ) -> typing.Callable[[String], None]: 
        """
        Event to notify about action.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.NotifyAction
        """
        pass

    @NotifyAction.setter
    def NotifyAction(
      self,
      _value: typing.Callable[[String], None]
    ) -> None: 
        """
        Event to notify about action.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.NotifyAction
        """
        pass

    @property
    def NotifyChanges(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Event to notify about changes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.NotifyChanges
        """
        pass

    @NotifyChanges.setter
    def NotifyChanges(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Event to notify about changes.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.NotifyChanges
        """
        pass

    @property
    def SnapPointEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Point3D, Double, TGIS_Point3D, Double], None]: 
        """
        Event to call a custom snap routine.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.SnapPointEvent
        """
        pass

    @SnapPointEvent.setter
    def SnapPointEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Point3D, Double, TGIS_Point3D, Double], None]
    ) -> None: 
        """
        Event to call a custom snap routine.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorHelper.SnapPointEvent
        """
        pass

class TGIS_EditorToolCircle( TGIS_EditorToolAbstract ):
    """
    Tool for building circle (center, radius).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolCircle
    """

class TGIS_EditorToolCircle3P( TGIS_EditorToolAbstract ):
    """
    Tool for building circle based on three points.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolCircle3P
    """

class TGIS_EditorToolCircle2P( TGIS_EditorToolAbstract ):
    """
    Tool for building circle based on three points.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolCircle2P
    """

class TGIS_EditorToolLine( TGIS_EditorToolAbstract ):
    """
    Tool for building line.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolLine
    """

class TGIS_EditorToolRectangle( TGIS_EditorToolAbstract ):
    """
    Tool for building rectangle.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolRectangle
    """

class TGIS_EditorToolRectangle90( TGIS_EditorToolAbstract ):
    """
    Tool for building rectangle rotated 90 deg.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolRectangle90
    """

class TGIS_EditorToolArc( TGIS_EditorToolAbstract ):
    """
    Tool for building arc using different modes.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolArc
    """

    @property
    def Mode(
      self
    ) -> TGIS_EditorToolArcMode: 
        """
        Mode used to build arc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolArc.Mode
        """
        pass

    @Mode.setter
    def Mode(
      self,
      _value: TGIS_EditorToolArcMode
    ) -> None: 
        """
        Mode used to build arc.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_EditorToolArc.Mode
        """
        pass

class TGIS_FieldValueCheckMode:
    pass

class TGIS_FieldValueCheckMode:
    """
    Behavior of value checks.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckMode
    """

    @property
    def AfterEdit(
      self
    ) -> TGIS_FieldValueCheckMode: 
        """
        Value should be checked after editing.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckMode.AfterEdit
        """
        pass

    @property
    def OnEdit(
      self
    ) -> TGIS_FieldValueCheckMode: 
        """
        Value should be checked upon any changed (any key entered).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckMode.OnEdit
        """
        pass

    @property
    def Both(
      self
    ) -> TGIS_FieldValueCheckMode: 
        """
        Value should be checked in both cases.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckMode.Both
        """
        pass

class TGIS_FieldValueCheckFormula:
    pass

class TGIS_FieldValueCheckFormula:
    """
    Type of formula checks.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula
    """

    @property
    def Required(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is required.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.Required
        """
        pass

    @property
    def Regex(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is check against regular expression.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.Regex
        """
        pass

    @property
    def Expression(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is checked against formula (like math expression) or callback function.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.Expression
        """
        pass

    @property
    def StringEQ(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is equal to string, case sensitive.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.StringEQ
        """
        pass

    @property
    def StringNE(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is not equal to string, case sensitive.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.StringNE
        """
        pass

    @property
    def StringLT(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is less the string, case sensitive.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.StringLT
        """
        pass

    @property
    def StringLE(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is less equal then string, case sensitive.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.StringLE
        """
        pass

    @property
    def StringGT(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is great then string, case sensitive.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.StringGT
        """
        pass

    @property
    def StringGE(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is great equal then string, case sensitive.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.StringGE
        """
        pass

    @property
    def StringIn(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is one of provided strings, case sensitive; NOT SUPPORTED YET.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.StringIn
        """
        pass

    @property
    def TextEQ(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is equal to text, case insensitive.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.TextEQ
        """
        pass

    @property
    def TextNE(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is not equal to text, case insensitive.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.TextNE
        """
        pass

    @property
    def TextLT(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is less the text, case insensitive.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.TextLT
        """
        pass

    @property
    def TextLE(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is less equal then text, case insensitive.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.TextLE
        """
        pass

    @property
    def TextGT(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is great then text, case insensitive.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.TextGT
        """
        pass

    @property
    def TextGE(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is great equal then text, case insensitive.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.TextGE
        """
        pass

    @property
    def TextIn(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is one of provided text, case insensitive; NOT SUPPORTED YET.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.TextIn
        """
        pass

    @property
    def NumberRequired(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Proper number required.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.NumberRequired
        """
        pass

    @property
    def NumberEQ(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is equal to number.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.NumberEQ
        """
        pass

    @property
    def NumberNE(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is not equal to number.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.NumberNE
        """
        pass

    @property
    def NumberLT(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is less then the number.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.NumberLT
        """
        pass

    @property
    def NumberLE(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is less equal then the number.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.NumberLE
        """
        pass

    @property
    def NumberGT(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is great then the number.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.NumberGT
        """
        pass

    @property
    def NumberGE(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is great equal then the number.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.NumberGE
        """
        pass

    @property
    def DateRequired(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Proper date required; NOT SUPPORTED YET.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.DateRequired
        """
        pass

    @property
    def DateEQ(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is equal to date; NOT SUPPORTED YET.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.DateEQ
        """
        pass

    @property
    def DateNE(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is not equal to date; NOT SUPPORTED YET.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.DateNE
        """
        pass

    @property
    def DateLT(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is not equal to date; NOT SUPPORTED YET.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.DateLT
        """
        pass

    @property
    def DateLE(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is less equal then the date; NOT SUPPORTED YET.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.DateLE
        """
        pass

    @property
    def DateGT(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is great then the date; NOT SUPPORTED YET.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.DateGT
        """
        pass

    @property
    def DateGE(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Value is is great equal then the date; NOT SUPPORTED YET.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckFormula.DateGE
        """
        pass

class TGIS_FieldValuesMode:
    pass

class TGIS_FieldValuesMode:
    """
    Hint of how filed should be represented upon editing.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValuesMode
    """

    @property
    def SelectList(
      self
    ) -> TGIS_FieldValuesMode: 
        """
        Represent as drop-down list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValuesMode.SelectList
        """
        pass

    @property
    def MultiLine(
      self
    ) -> TGIS_FieldValuesMode: 
        """
        Represent as multi-line edit box.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValuesMode.MultiLine
        """
        pass

    @property
    def Edit(
      self
    ) -> TGIS_FieldValuesMode: 
        """
        Represent as standard edit box.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValuesMode.Edit
        """
        pass

    @property
    def Hidden(
      self
    ) -> TGIS_FieldValuesMode: 
        """
        Hide an attribute.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValuesMode.Hidden
        """
        pass

class TGIS_FieldValueCheckList:
    """
    List of TGIS_FieldValueCheckList objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_FieldValueCheck:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_FieldValueCheck
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckList.Create_void
        """
        pass

    def Add(
      self,
      _item: TGIS_FieldValueCheck
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckList.Add_TGIS_FieldValueCheck
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckList.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckList.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckList.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> TGIS_FieldValueCheck: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheckList.Item
        """
        pass

class TGIS_FieldValueAliasList:
    """
    List of TGIS_FieldValueAlias objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueAliasList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_FieldValueAlias:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_FieldValueAlias
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueAliasList.Create_void
        """
        pass

    def Add(
      self,
      _item: TGIS_FieldValueAlias
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueAliasList.Add_TGIS_FieldValueAlias
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueAliasList.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueAliasList.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueAliasList.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> TGIS_FieldValueAlias: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueAliasList.Item
        """
        pass

class TGIS_FieldValueAlias:
    """
    Alias value representation. For situations where data attributes value should be 
    presented on a screen differently. Aliases are always presented as strings.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueAlias
    """

    @overload
    def __init__(
      self,
      _alias: str,
      _value: str
    ) -> None: 
        """
        Create a single alias.

        Args:
            _alias: value to be aliased
            _value: value of the alias

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueAlias.Create_String_String
        """
        pass

    @property
    def Alias(
      self
    ) -> str: 
        """
        Alias to attribute values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueAlias.Alias
        """
        pass

    @property
    def Value(
      self
    ) -> str: 
        """
        Attribute value which should be aliased by Alias.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueAlias.Value
        """
        pass

class TGIS_FieldValueAliases:
    """
    List of aliases. See also TGIS_FieldValueAlias.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueAliases
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create aliases list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueAliases.Create_void
        """
        pass

    def ResolveGet(
      self,
      _value: str
    ) -> str: 
        """
        Resolve value in a meaning of reading it from a layer. Value will be substituted 
        with alias

        Args:
            _value: value form a layer

        Returns:
            value to be presented to a user

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueAliases.ResolveGet_String
        """
        pass

    def ResolveSet(
      self,
      _value: Variant
    ) -> Variant: 
        """
        Resolve value in a meaning of saving it to a layer. Alias will be resolved to a corresponding 
        field value.

        Args:
            _value: value to be check

        Returns:
            value to be saved to a layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueAliases.ResolveSet_Variant
        """
        pass

    @property
    def Aliases(
      self
    ) -> TGIS_FieldValueAliasList: 
        """
        List of all aliases.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueAliases.Aliases
        """
        pass

class TGIS_FieldValueCheck:
    """
    Value check representation. For situations where entered data must be check against 
    provided formula

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheck
    """

    @overload
    def __init__(
      self,
      _mode: TGIS_FieldValueCheckMode,
      _formula: TGIS_FieldValueCheckFormula,
      _content: str,
      _message: str
    ) -> None: 
        """
        Create a single value check.

        Args:
            _mode: mode of check
            _formula: formula of check
            _content: formula content
            _message: message to be provided upon error

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheck.Create_TGIS_FieldValueCheckMode_TGIS_FieldValueCheckFormula_String_String
        """
        pass

    @overload
    def __init__(
      self,
      _mode: TGIS_FieldValueCheckMode,
      _formula: TGIS_FieldValueCheckFormula,
      _callback: typing.Callable[[String], bool],
      _message: str
    ) -> None: 
        """
        Create a single value check.

        Args:
            _mode: mode of check
            _formula: formula of check
            _callback: callback function to check value; the value is a callback to a method 
              with parameters defined by TGIS_FieldValueCheckEvent
            _message: message to be provided upon error

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheck.Create_TGIS_FieldValueCheckMode_TGIS_FieldValueCheckFormula_TGIS_FieldValueCheckEvent_String
        """
        pass

    def Check(
      self,
      _value: Variant,
      _mode: TGIS_FieldValueCheckMode,
      _msg: VarParameter
    ) -> bool: 
        """
        Check a value against formula.

        Args:
            _value: value to be check
            _mode: mode of check
            _msg: string with optional error message; the value (in/out) is passed as str in 
              _msg.Value property

        Returns:
            False if _value does not fulfill requirements

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheck.Check_Variant_TGIS_FieldValueCheckMode_String
        """
        pass

    @property
    def Content(
      self
    ) -> str: 
        """
        Formula content.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheck.Content
        """
        pass

    @property
    def Formula(
      self
    ) -> TGIS_FieldValueCheckFormula: 
        """
        Formula of check.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheck.Formula
        """
        pass

    @property
    def Message(
      self
    ) -> str: 
        """
        Message to be provided upon error.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheck.Message
        """
        pass

    @property
    def Mode(
      self
    ) -> TGIS_FieldValueCheckMode: 
        """
        Mode of check.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueCheck.Mode
        """
        pass

class TGIS_FieldValueChecks:
    """
    List of checks. See also TGIS_FieldValueCheck.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueChecks
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create value check list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueChecks.Create_void
        """
        pass

    def Check(
      self,
      _value: Variant,
      _mode: TGIS_FieldValueCheckMode,
      _msg: VarParameter
    ) -> bool: 
        """
        Check a value against whole list.

        Args:
            _value: value to be check
            _mode: mode of check
            _msg: string with optional error message; the value (in/out) is passed as str in 
              _msg.Value property

        Returns:
            False if _value does not fulfill requirements

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueChecks.Check_Variant_TGIS_FieldValueCheckMode_String
        """
        pass

    @property
    def Checks(
      self
    ) -> TGIS_FieldValueCheckList: 
        """
        List of all checks. Order is important. Checks are always verify form first to last 
        until first problem occurs.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValueChecks.Checks
        """
        pass

class TGIS_FieldValues:
    """
    List of allowed values for a list.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValues
    """

    @overload
    def __init__(
      self,
      _mode: TGIS_FieldValuesMode,
      _defaultvalue: str
    ) -> None: 
        """
        Create values list.

        Args:
            _mode: mode of presentation
            _defaultvalue: default filed value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValues.Create_TGIS_FieldValuesMode_String
        """
        pass

    @property
    def DefaultValue(
      self
    ) -> Variant: 
        """
        Default new value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValues.DefaultValue
        """
        pass

    @DefaultValue.setter
    def DefaultValue(
      self,
      _value: Variant
    ) -> None: 
        """
        Default new value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValues.DefaultValue
        """
        pass

    @property
    def Items(
      self
    ) -> TGIS_ListOfStrings: 
        """
        Allowed values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValues.Items
        """
        pass

    @property
    def Mode(
      self
    ) -> TGIS_FieldValuesMode: 
        """
        Mode of presentation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValues.Mode
        """
        pass

    @Mode.setter
    def Mode(
      self,
      _value: TGIS_FieldValuesMode
    ) -> None: 
        """
        Mode of presentation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldValues.Mode
        """
        pass

class TGIS_FieldRule:
    """
    Class responsible for complete rule based editing of the attribute field.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRule
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRule.Create_void
        """
        pass

    def Check(
      self,
      _setvalue: Variant,
      _mode: TGIS_FieldValueCheckMode,
      _msg: VarParameter
    ) -> bool: 
        """
        Check value against all formulas.

        Args:
            _setvalue: value to be check
            _mode: mode of check
            _msg: optional error message; the value (in/out) is passed as str in _msg.Value property

        Returns:
            False if _value does not fulfill requirements

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRule.Check_Variant_TGIS_FieldValueCheckMode_String
        """
        pass

    def ResolveGet(
      self,
      _value: Variant,
      _fld: TObject
    ) -> Variant: 
        """
        Resolve value in a meaning of reading it form a layer. Value will be substituted 
        with alias

        Args:
            _value: value form a layer
            _fld: Field definition

        Returns:
            value to be presented to a user

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRule.ResolveGet_Variant_TObject
        """
        pass

    def ResolveSet(
      self,
      _setvalue: Variant,
      _retvalue: VarParameter,
      _msg: VarParameter
    ) -> bool: 
        """
        Resolve value in a meaning of saving it to a layer. Alias will be resolved to a corresponding 
        field value and field will be verified against formulas.

        Args:
            _setvalue: value to be check
            _retvalue: value to be saved to a layer; the value (in/out) is passed as Variant 
              in _retvalue.Value property
            _msg: optional error message; the value (in/out) is passed as str in _msg.Value property

        Returns:
            False if _value does not fulfill requirements

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRule.ResolveSet_Variant_Variant_String
        """
        pass

    @property
    def Caption(
      self
    ) -> str: 
        """
        Field caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRule.Caption
        """
        pass

    @Caption.setter
    def Caption(
      self,
      _value: str
    ) -> None: 
        """
        Field caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRule.Caption
        """
        pass

    @property
    def LongName(
      self
    ) -> str: 
        """
        Field long name (w/o taking care of file format limits).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRule.LongName
        """
        pass

    @property
    def Modified(
      self
    ) -> bool: 
        """
        True if rules were modified.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRule.Modified
        """
        pass

    @Modified.setter
    def Modified(
      self,
      _value: bool
    ) -> None: 
        """
        True if rules were modified.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRule.Modified
        """
        pass

    @property
    def ValueAliases(
      self
    ) -> TGIS_FieldValueAliases: 
        """
        List of all filed aliases.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRule.ValueAliases
        """
        pass

    @property
    def ValueChecks(
      self
    ) -> TGIS_FieldValueChecks: 
        """
        List of all checks associated the the filed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRule.ValueChecks
        """
        pass

    @property
    def ValueFormat(
      self
    ) -> str: 
        """
        Value format specifier like in printf.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRule.ValueFormat
        """
        pass

    @ValueFormat.setter
    def ValueFormat(
      self,
      _value: str
    ) -> None: 
        """
        Value format specifier like in printf.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRule.ValueFormat
        """
        pass

    @property
    def Values(
      self
    ) -> TGIS_FieldValues: 
        """
        List of all allowed values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRule.Values
        """
        pass

class TGIS_FieldRulesOperations:
    """
    Contains methods for saving and loading fieldrules.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRulesOperations
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRulesOperations.Create_void
        """
        pass

    def ParseFldx(
      self,
      _path: str,
      _parent: TObject
    ) -> bool: 
        """
        Parse .fldx file and read all information into _parent layer

        Args:
            _path: path to a .fldx file
            _parent: parent layer

        Returns:
            True if .fldx file properly interpreted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRulesOperations.ParseFldx_String_TObject
        """
        pass

    def SaveFldx(
      self,
      _path: str,
      _parent: TObject
    ) -> None: 
        """
        Save filed rules into .fldx file

        Args:
            _path: path to a .fldx file
            _parent: parent layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldRulesOperations.SaveFldx_String_TObject
        """
        pass

class TGIS_WFSFeature( TObject ):
    """
    Feature class implementation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.Create_void
        """
        pass

    def IncreaseDataCount(
      self,
      _count: int
    ) -> None: 
        """
        Increment data counter.

        Args:
            _count: number to increase data counter

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.IncreaseDataCount_Integer
        """
        pass

    def IsDataReady(
      self
    ) -> bool: 
        """
        Are feature data fetched and ready to use.

        Returns:
            True if data were fetched.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.IsDataReady_void
        """
        pass

    def IsDataValid(
      self
    ) -> bool: 
        """
        True, if feature data are valid or False if any error occurred.

        Returns:
            True if data are valid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.IsDataValid_void
        """
        pass

    def NextDataPage(
      self,
      _offset: int
    ) -> None: 
        """
        Set next page range.

        Args:
            _offset: offset to increase start index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.NextDataPage_Integer
        """
        pass

    def ResetDataPage(
      self
    ) -> None: 
        """
        Reset current data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.ResetDataPage_void
        """
        pass

    def ResetState(
      self
    ) -> None: 
        """
        Reset current state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.ResetState_void
        """
        pass

    @property
    def Data(
      self
    ) -> TStream: 
        """
        Feature data

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.Data
        """
        pass

    @Data.setter
    def Data(
      self,
      _value: TStream
    ) -> None: 
        """
        Feature data

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.Data
        """
        pass

    @property
    def DefaultSRS(
      self
    ) -> str: 
        """
        Feature default SRS

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.DefaultSRS
        """
        pass

    @DefaultSRS.setter
    def DefaultSRS(
      self,
      _value: str
    ) -> None: 
        """
        Feature default SRS

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.DefaultSRS
        """
        pass

    @property
    def Description(
      self
    ) -> str: 
        """
        Feature description

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.Description
        """
        pass

    @Description.setter
    def Description(
      self,
      _value: str
    ) -> None: 
        """
        Feature description

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.Description
        """
        pass

    @property
    def ExDescription(
      self
    ) -> str: 
        """
        Feature extra description

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.ExDescription
        """
        pass

    @ExDescription.setter
    def ExDescription(
      self,
      _value: str
    ) -> None: 
        """
        Feature extra description

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.ExDescription
        """
        pass

    @property
    def ExtentOrder(
      self
    ) -> str: 
        """
        Feature extent axis order

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.ExtentOrder
        """
        pass

    @ExtentOrder.setter
    def ExtentOrder(
      self,
      _value: str
    ) -> None: 
        """
        Feature extent axis order

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.ExtentOrder
        """
        pass

    @property
    def HTTPStatus(
      self
    ) -> int: 
        """
        HTTP Status

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.HTTPStatus
        """
        pass

    @HTTPStatus.setter
    def HTTPStatus(
      self,
      _value: int
    ) -> None: 
        """
        HTTP Status

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.HTTPStatus
        """
        pass

    @property
    def Keywords(
      self
    ) -> str: 
        """
        Feature keywords

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.Keywords
        """
        pass

    @Keywords.setter
    def Keywords(
      self,
      _value: str
    ) -> None: 
        """
        Feature keywords

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.Keywords
        """
        pass

    @property
    def LastExtent(
      self
    ) -> TGIS_Extent: 
        """
        Feature last bounding box

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.LastExtent
        """
        pass

    @LastExtent.setter
    def LastExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Feature last bounding box

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.LastExtent
        """
        pass

    @property
    def LastUrl(
      self
    ) -> str: 
        """
        Feature last url

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.LastUrl
        """
        pass

    @LastUrl.setter
    def LastUrl(
      self,
      _value: str
    ) -> None: 
        """
        Feature last url

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.LastUrl
        """
        pass

    @property
    def MetadataUrl(
      self
    ) -> str: 
        """
        Feature metadata url

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.MetadataUrl
        """
        pass

    @MetadataUrl.setter
    def MetadataUrl(
      self,
      _value: str
    ) -> None: 
        """
        Feature metadata url

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.MetadataUrl
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Feature name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.Name
        """
        pass

    @Name.setter
    def Name(
      self,
      _value: str
    ) -> None: 
        """
        Feature name

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.Name
        """
        pass

    @property
    def NamespaceUrl(
      self
    ) -> str: 
        """
        Namespace url

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.NamespaceUrl
        """
        pass

    @NamespaceUrl.setter
    def NamespaceUrl(
      self,
      _value: str
    ) -> None: 
        """
        Namespace url

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.NamespaceUrl
        """
        pass

    @property
    def OtherSRS(
      self
    ) -> TGIS_StringList: 
        """
        Feature alternative SRS list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.OtherSRS
        """
        pass

    @OtherSRS.setter
    def OtherSRS(
      self,
      _value: TGIS_StringList
    ) -> None: 
        """
        Feature alternative SRS list

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.OtherSRS
        """
        pass

    @property
    def Title(
      self
    ) -> str: 
        """
        Feature title

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.Title
        """
        pass

    @Title.setter
    def Title(
      self,
      _value: str
    ) -> None: 
        """
        Feature title

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.Title
        """
        pass

    @property
    def WGS84BBox(
      self
    ) -> TGIS_Extent: 
        """
        Feature bounding box in WGS84

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.WGS84BBox
        """
        pass

    @WGS84BBox.setter
    def WGS84BBox(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Feature bounding box in WGS84

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.WGS84BBox
        """
        pass

    @property
    def ReadCount(
      self
    ) -> int: 
        """
        Total read data counter.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.ReadCount
        """
        pass

    @property
    def StartIndex(
      self
    ) -> int: 
        """
        Start index of data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_WFSFeature.StartIndex
        """
        pass

class TGIS_FileWFS( TObject ):
    """
    Encapsulation of a WFS provider.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance for pure file analizing.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _vwr: IGIS_Viewer,
      _layer: TObject
    ) -> None: 
        """
        Create an instance to open a layer.

        Args:
            _vwr: viewer handle
            _layer: layer handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.Create_IGIS_Viewer_TObject
        """
        pass

    def DescribeFeatureType(
      self,
      _name: str
    ) -> TStream: 
        """
        Describe feature type from schema.

        Args:
            _name: layer name

        Returns:
            data stream with schema

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.DescribeFeatureType_String
        """
        pass

    def GetCommonExtent(
      self,
      _epsg: int
    ) -> TGIS_Extent: 
        """
        Get common extent.

        Args:
            _epsg: requested epsg code

        Returns:
            new extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.GetCommonExtent_Integer
        """
        pass

    def GetCommonSRS(
      self
    ) -> str: 
        """
        Get common epsg code.

        Returns:
            SRS code

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.GetCommonSRS_void
        """
        pass

    def GetFeatureData(
      self,
      _feature: TGIS_WFSFeature,
      _extent: TGIS_Extent
    ) -> bool: 
        """
        Get feature data.

        Args:
            _feature: feature object
            _extent: range of data

        Returns:
            True if data is fetched

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.GetFeatureData_TGIS_WFSFeature_TGIS_Extent
        """
        pass

    def GetLayerData(
      self,
      _name: str,
      _extent: TGIS_Extent,
      _epsg: int
    ) -> TStream: 
        """
        Get layer data.

        Args:
            _name: layer name
            _extent: extent to load the data from
            _epsg: destination epsg

        Returns:
            data stream

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.GetLayerData_String_TGIS_Extent_Integer
        """
        pass

    def GetLayerDataUrl(
      self,
      _name: str,
      _extent: TGIS_Extent,
      _epsg: int
    ) -> str: 
        """
        Get layer data.

        Args:
            _name: layer name
            _extent: extent to load the data from
            _epsg: destination epsg

        Returns:
            data stream

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.GetLayerDataUrl_String_TGIS_Extent_Integer
        """
        pass

    def GetLayerExtent(
      self,
      _name: str,
      _epsg: int
    ) -> TGIS_Extent: 
        """
        Get layer extent.

        Args:
            _name: layer name
            _epsg: requested epsg code

        Returns:
            new extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.GetLayerExtent_String_Integer
        """
        pass

    def IsAxisReversed(
      self
    ) -> bool: 
        """
        Compute from Coordinate System and URL parameters AxisOrderIgnored and AxisOrderReveres 
        a final axis order reversal (other then Easting-Norting).

        Returns:
            True axis order should be reversed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.IsAxisReversed_void
        """
        pass

    def Load(
      self,
      _path: str
    ) -> None: 
        """
        Load capabilities from the server path.

        Args:
            _path: server path

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.Load_String
        """
        pass

    def MakeUrl(
      self,
      _query: str,
      _path: str
    ) -> str: 
        """
        Build url from a path and a query parameters.

        Args:
            _query: query text
            _path: path text

        Returns:
            new url

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.MakeUrl_String_String
        """
        pass

    def VerifySRS(
      self,
      _srs: str
    ) -> bool: 
        """
        Test if srs is supported.

        Args:
            _srs: srs name

        Returns:
            True if supported.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.VerifySRS_String
        """
        pass

    @property
    def DataFormats(
      self
    ) -> TGIS_StringList: 
        """
        Data formats list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.DataFormats
        """
        pass

    @property
    def Error(
      self
    ) -> str: 
        """
        Error message.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.Error
        """
        pass

    
    def Feature(
      self,
      _indexOrName: Variant
    ) -> TGIS_WFSFeature: 
        """
        Feature list.

        Args:
            _indexOrName: index or name of feature

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.Feature
        """
        pass

    @property
    def FeaturesCount(
      self
    ) -> int: 
        """
        Number of features.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.FeaturesCount
        """
        pass

    @property
    def Metadata(
      self
    ) -> TGIS_StringList: 
        """
        Metadata list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.Metadata
        """
        pass

    @property
    def PageSize(
      self
    ) -> int: 
        """
        Page size used for data fetching.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.PageSize
        """
        pass

    @PageSize.setter
    def PageSize(
      self,
      _value: int
    ) -> None: 
        """
        Page size used for data fetching.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.PageSize
        """
        pass

    @property
    def PagingEnabled(
      self
    ) -> bool: 
        """
        Is paging enabled for data fetching.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.PagingEnabled
        """
        pass

    @PagingEnabled.setter
    def PagingEnabled(
      self,
      _value: bool
    ) -> None: 
        """
        Is paging enabled for data fetching.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.PagingEnabled
        """
        pass

    @property
    def Path(
      self
    ) -> str: 
        """
        Path url.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.Path
        """
        pass

    @property
    def PredefinedBox(
      self
    ) -> TGIS_Extent: 
        """
        Predefined bounding box.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.PredefinedBox
        """
        pass

    @property
    def PredefinedLayers(
      self
    ) -> TGIS_StringList: 
        """
        Predefined layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.PredefinedLayers
        """
        pass

    @property
    def PredefinedSRS(
      self
    ) -> str: 
        """
        Predefined SRS.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.PredefinedSRS
        """
        pass

    @property
    def ProxyUrl(
      self
    ) -> str: 
        """
        Proxy URL as for ESRI proxy.ashx.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.ProxyUrl
        """
        pass

    @ProxyUrl.setter
    def ProxyUrl(
      self,
      _value: str
    ) -> None: 
        """
        Proxy URL as for ESRI proxy.ashx.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.ProxyUrl
        """
        pass

    @property
    def QueryStructure(
      self
    ) -> bool: 
        """
        If true, use options for fast query structure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.QueryStructure
        """
        pass

    @QueryStructure.setter
    def QueryStructure(
      self,
      _value: bool
    ) -> None: 
        """
        If true, use options for fast query structure.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.QueryStructure
        """
        pass

    @property
    def ServiceInfo(
      self
    ) -> TGIS_StringList: 
        """
        Service info list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.ServiceInfo
        """
        pass

    @property
    def TimeOut(
      self
    ) -> int: 
        """
        Connection timeout.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.TimeOut
        """
        pass

    @TimeOut.setter
    def TimeOut(
      self,
      _value: int
    ) -> None: 
        """
        Connection timeout.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.TimeOut
        """
        pass

    @property
    def UserAgent(
      self
    ) -> str: 
        """
        Proxy URL as for ESRI proxy.ashx.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.UserAgent
        """
        pass

    @UserAgent.setter
    def UserAgent(
      self,
      _value: str
    ) -> None: 
        """
        Proxy URL as for ESRI proxy.ashx.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.UserAgent
        """
        pass

    @property
    def Version(
      self
    ) -> str: 
        """
        Predefined version.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.Version
        """
        pass

    @property
    def PasswordEvent(
      self
    ) -> typing.Callable[[TObject, String], str]: 
        """
        Password event.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.PasswordEvent
        """
        pass

    @PasswordEvent.setter
    def PasswordEvent(
      self,
      _value: typing.Callable[[TObject, String], str]
    ) -> None: 
        """
        Password event.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileWFS.PasswordEvent
        """
        pass

class TGIS_FourierTransform( TObject ):
    """
    Encapsulation of one- and two-dimensional Discrete and Fast Fourier Transform (DFT 
    and FFT) for a real-valued signal. FFT uses the Cooley-Tukey radix-2 algorithm.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.Create_void
        """
        pass

    def Invert(
      self
    ) -> TGIS_SingleArray: 
        """
        Inverts the one-dimensonal Fourier transform.

        Returns:
            reconstructed signal as an array of single-precision values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.Invert_void
        """
        pass

    def Invert2D(
      self
    ) -> TGIS_GridArray: 
        """
        Inverts the two-dimensonal Fourier transform.

        Returns:
            reconstructed signal as a two-dimensional array of single-precision values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.Invert2D_void
        """
        pass

    @overload
    def RunDiscrete(
      self,
      _signal: TGIS_SingleArray
    ) -> None: 
        """
        Computes the one-dimensonal Fourier transform of the provided real-valued signal 
        using the discrete algorithm (DFT).

        Args:
            _signal: signal as an array of single-precision values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.RunDiscrete_TGIS_SingleArray
        """
        pass

    @overload
    def RunDiscrete(
      self,
      _signal: TGIS_SingleArray,
      _start: int,
      _end: int
    ) -> None: 
        """
        Computes the one-dimensonal Fourier transform of the provided real-valued signal 
        using the discrete algorithm (DFT).

        Args:
            _signal: signal as an array of single-precision values
            _start: start index of the signal window
            _end: end index of the signal window

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.RunDiscrete_TGIS_SingleArray_Integer_Integer
        """
        pass

    @overload
    def RunDiscrete2D(
      self,
      _signal: TGIS_GridArray
    ) -> None: 
        """
        Computes the two-dimensonal Fourier transform of the provided real-valued signal 
        using the discrete algorithm (DFT).

        Args:
            _signal: signal as a two-dimensional array of single-precision values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.RunDiscrete2D_TGIS_GridArray
        """
        pass

    @overload
    def RunDiscrete2D(
      self,
      _signal: TGIS_GridArray,
      _bounds: TRect
    ) -> None: 
        """
        Computes the two-dimensonal Fourier transform of the provided real-valued signal 
        using the discrete algorithm (DFT).

        Args:
            _signal: signal as a two-dimensional array of single-precision values
            _bounds: index bounds of the signal window

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.RunDiscrete2D_TGIS_GridArray_TRect
        """
        pass

    @overload
    def RunFast(
      self,
      _signal: TGIS_SingleArray
    ) -> None: 
        """
        Computes the one-dimensonal Fourier transform of the provided real-valued signal 
        using the fast algorithm (FFT).

        Args:
            _signal: signal as an array of single-precision values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.RunFast_TGIS_SingleArray
        """
        pass

    @overload
    def RunFast(
      self,
      _signal: TGIS_SingleArray,
      _start: int,
      _end: int
    ) -> None: 
        """
        Computes the one-dimensonal Fourier transform of the provided real-valued signal 
        using the fast algorithm (FFT).

        Args:
            _signal: signal as an array of single-precision values
            _start: start index of the signal window
            _end: end index of the signal window

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.RunFast_TGIS_SingleArray_Integer_Integer
        """
        pass

    @overload
    def RunFast2D(
      self,
      _signal: TGIS_GridArray
    ) -> None: 
        """
        Computes the two-dimensonal Fourier transform of the provided real-valued signal 
        using the fast algorithm (FFT).

        Args:
            _signal: signal as a two-dimensional array of single-precision values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.RunFast2D_TGIS_GridArray
        """
        pass

    @overload
    def RunFast2D(
      self,
      _signal: TGIS_GridArray,
      _bounds: TRect
    ) -> None: 
        """
        Computes the two-dimensonal Fourier transform of the provided real-valued signal 
        using the fast algorithm (FFT).

        Args:
            _signal: signal as a two-dimensional array of single-precision values
            _bounds: index bounds of the signal window

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.RunFast2D_TGIS_GridArray_TRect
        """
        pass

    
    def Argument(
      self,
      _i: int
    ) -> float: 
        """
        Argument of the one-dimensional Fourier transform.

        Args:
            _i: index of the transform value

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.Argument
        """
        pass

    
    def Argument2D(
      self,
      _y: int,
      _x: int
    ) -> float: 
        """
        Argument of the two-dimensional Fourier transform.

        Args:
            _y: row index of the transform value
            _x: column index of the transform value

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.Argument2D
        """
        pass

    @property
    def Imaginary(
      self
    ) -> TGIS_SingleArray: 
        """
        Imaginary part of the one-dimensional Fourier transform.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.Imaginary
        """
        pass

    @property
    def Imaginary2D(
      self
    ) -> TGIS_GridArray: 
        """
        Imaginary part of the two-dimensional Fourier transform.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.Imaginary2D
        """
        pass

    
    def Modulus(
      self,
      _i: int
    ) -> float: 
        """
        Modulus of the one-dimensional Fourier transform.

        Args:
            _i: index of the transform value

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.Modulus
        """
        pass

    
    def Modulus2D(
      self,
      _y: int,
      _x: int
    ) -> float: 
        """
        Modulus of the two-dimensional Fourier transform.

        Args:
            _y: row index of the transform value
            _x: column index of the transform value

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.Modulus2D
        """
        pass

    @property
    def Real(
      self
    ) -> TGIS_SingleArray: 
        """
        Real part of the one-dimensional Fourier transform.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.Real
        """
        pass

    @property
    def Real2D(
      self
    ) -> TGIS_GridArray: 
        """
        Real part of the two-dimensional Fourier transform.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.Real2D
        """
        pass

    @property
    def Shifted(
      self
    ) -> bool: 
        """
        If True then the transform is shifted by half the size so that the low frequencies 
        are in the middle instead of the corners; does not have any effect after the transform 
        has been computed; default is True.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.Shifted
        """
        pass

    @Shifted.setter
    def Shifted(
      self,
      _value: bool
    ) -> None: 
        """
        If True then the transform is shifted by half the size so that the low frequencies 
        are in the middle instead of the corners; does not have any effect after the transform 
        has been computed; default is True.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.Shifted
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FourierTransform.BusyEvent
        """
        pass

class TGIS_Geocoding( TObject ):
    """
    Class encapsulates Geocoding support.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Construct instance. This is a constructor for layers with shapes of type TGIS_ShapeType.Arc.

        Args:
            _layer: vector layer on which geocoding will be performed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.Create_TGIS_LayerVector
        """
        pass

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector,
      _shpType: TGIS_ShapeType
    ) -> None: 
        """
        Construct instance.

        Args:
            _layer: vector layer on which geocoding will be performed
            _shpType: type of analyzed shapes

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.Create_TGIS_LayerVector_TGIS_ShapeType
        """
        pass

    def AddPoint(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _shape: TGIS_ShapeArc
    ) -> bool: 
        """
        Add a new node connection point to the network

        Args:
            _ptg: location of connection point
            _prec: precision; point not close enough will be ignored
            _shape: if null then closest shape on the layer associated to the geocoder will be 
              used; if not null then connection will be added to this shape

        Returns:
            True if the operation succeeded

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.AddPoint_TGIS_Point_Double_TGIS_ShapeArc
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear any results from geocoding.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.Clear_void
        """
        pass

    @overload
    def LoadFormulas(
      self,
      _languageFileName: str,
      _fmtFileName: str
    ) -> None: 
        """
        Sets address formulas definition and other settings used by geocoding and reverse 
        geocoding.

        Args:
            _languageFileName: name of an INI file with address formulas for a country
            _fmtFileName: name of an INI file with more detailed address formulas definition

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.LoadFormulas_String_String
        """
        pass

    @overload
    def LoadFormulas(
      self,
      _languageFileName: str,
      _fmtFileName: str,
      _customDefinition: str
    ) -> None: 
        """
        Sets address formulas definition and other settings used by geocoding and reverse 
        geocoding.

        Args:
            _languageFileName: name of an INI file with address formulas for a country
            _fmtFileName: name of an INI file with more detailed address formulas definition
            _customDefinition: additional modification in form of the INI file contents

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.LoadFormulas_String_String_String
        """
        pass

    def Match(
      self,
      _addr: str,
      _resolvedAddresses: VarParameter,
      _resolvedAddresses2: VarParameter
    ) -> bool: 
        """
        Parses given address line.
        
        Finds matches according to defined address formulas. Intersections should be entered 
        as "addressPointA &amp; addressPointB".

        Args:
            _addr: address line
            _resolvedAddresses: list containing all found matches; every element is a single 
              match in the form of string list: ''field1=value1'' ''field2=value2'' ''...''; if 
              the reference equals nil, the object will be created ; the value (in/out) is passed 
              as TGIS_ObjectList in _resolvedAddresses.Value property
            _resolvedAddresses2: list containing all found matches for the second street (if 
              present); every element is a single match in the form of string list: ''field1=value1'' 
              ''field2=value2'' ''...''; if the reference equals nil, the object will be created 
              ; the value (in/out) is passed as TGIS_ObjectList in _resolvedAddresses2.Value property

        Returns:
            True if match was found

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.Match_String_TGIS_ObjectList_TGIS_ObjectList
        """
        pass

    @overload
    def Parse(
      self,
      _addr: str
    ) -> int: 
        """
        Parse an address line. See the overloaded version of the method.

        Args:
            _addr: address line in the form of: "streetA &amp; streetB" (intersections) or "street 
              1111xxx" (address matching); street name can be in any case, and can consist of only 
              the first few characters; for street addresses only the first part of a number (built 
              from digits) will be used; if the street name contains a number at the tail (that 
              is part of the street name, not the street number), you can use the character code 
              255 as a non-breaking space placed between the text part of the street name and the 
              numeric part of the street name (not placed between the street name ending with the 
              number and the street number)

        Returns:
            number of points or intersections found

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.Parse_String
        """
        pass

    @overload
    def Parse(
      self,
      _addr: str,
      _firstMatch: bool,
      _addToLayer: bool
    ) -> int: 
        """
        Parse an address line. Resolve address point(s), or intersection(s).
        
        Resolved intersections or addresses will be stored in properties: Uid, UidEx and 
        Point.

        Args:
            _addr: address line in the form of: "streetA &amp; streetB" (intersections) or "street 
              1111xxx" (address matching); street name can be in any case, and can consist of only 
              the first few characters; for street addresses only the first part of a number (built 
              from digits) will be used; if the street name contains a number at the tail (that 
              is part of the street name, not the street number), you can use the character code 
              255 as a non-breaking space placed between the text part of the street name and the 
              numeric part of the street name (not placed between the street name ending with the 
              number and the street number)
            _firstMatch: if True, then only first matching address will be found; if not then 
              first 256 results will be returned
            _addToLayer: if True, then parsed address will be added to the LayerGeocoded; street 
              will be split at the address to allow proper routing

        Returns:
            number of points or intersections found

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.Parse_String_Boolean_Boolean
        """
        pass

    @overload
    def ParseEx(
      self,
      _addr: str,
      _firstMatch: bool,
      _extendedScope: bool,
      _addToLayer: bool
    ) -> int: 
        """
        Parses given address line.
        
        Resolves address point(s), or intersection(s). Address points in the address line 
        according to defined address formulas. (see TGIS_AddressMatching for more information 
        about address formulas).

        Args:
            _addr: address line
            _firstMatch: if True, then only first matching address will be found; if not then 
              first 256 results will be returned
            _extendedScope: if True, then street- and city names in found matches are treated 
              as initial strings of the names, otherwise as exact names
            _addToLayer: if True, then parsed address will be added to the LayerGeocoded; street 
              will be split at the address to allow proper routing

        Returns:
            number of points or intersections found

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.ParseEx_String_Boolean_Boolean_Boolean
        """
        pass

    @overload
    def ParseEx(
      self,
      _resolvedAddresses: TGIS_ObjectList,
      _resolvedAddresses2: TGIS_ObjectList,
      _firstMatch: bool,
      _extendedScope: bool,
      _addToLayer: bool
    ) -> int: 
        """
        Finds address point(s), or intersection(s) according to given matches.
        
        Intersections can be resolved only for shapes of type TGIS_ShapeType.Arc.

        Args:
            _resolvedAddresses: list containing all found matches; every string is a single match 
              in form of ''fieldld1=value1#13#10field2=value2#13#10...''; if the reference equals 
              nil, the object will be created ;
            _resolvedAddresses2: list containing all found matches for the second street (if 
              present); every string is a single match in form of ''fieldld1=value1#13#10field2=value2#13#10...''; 
              if the reference equals nil, the object will be created ;
            _firstMatch: if True, then only first matching address will be found
            _extendedScope: if True, then street- and city names in found matches are treated 
              as initial strings of the names, otherwise as exact names
            _addToLayer: if True, then parsed address will be added to the LayerGeocoded; street 
              will be split at the address to allow proper routing

        Returns:
            number of points or intersections found

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.ParseEx_TGIS_ObjectList_TGIS_ObjectList_Boolean_Boolean_Boolean
        """
        pass

    @overload
    def ReverseGeocode(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _shp: VarParameter,
      _address: VarParameter
    ) -> float: 
        """
        Returns the closest address to the given point. See the overloaded version of the 
        method.

        Args:
            _ptg: given point
            _prec: precision /not a longer distance than/;
            _shp: returned shape object; the value (in/out) is passed as TGIS_Shape in _shp.Value 
              property
            _address: returned address string created according to the address formulas definition; 
              the value (in/out) is passed as str in _address.Value property

        Returns:
            distance to the nearest address

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.ReverseGeocode_TGIS_Point_Double_TGIS_Shape_String
        """
        pass

    @overload
    def ReverseGeocode(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _shp: VarParameter,
      _address: VarParameter,
      _additionalQuery: str
    ) -> float: 
        """
        Returns the closest address to the given point.
        
        Only TGIS_ShapeType.Arc or TGIS_ShapeType.Point can be analyzed.

        Args:
            _ptg: given point
            _prec: precision /not a longer distance than/;
            _shp: returned shape object; the value (in/out) is passed as TGIS_Shape in _shp.Value 
              property
            _address: returned address string created according to the address formulas definition; 
              the value (in/out) is passed as str in _address.Value property
            _additionalQuery: query that can more precisely define geocoded shapes ( is assembled 
              with ReverseRestrictQuery )

        Returns:
            distance to the nearest address

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.ReverseGeocode_TGIS_Point_Double_TGIS_Shape_String_String
        """
        pass

    @property
    def CityName(
      self
    ) -> str: 
        """
        Field for the city name.
        
        Used to indicate the city name field that can be searched with like-operator. It 
        must be a name taken from address formulas definition. Default value is ''CITYNAME''. 
        Used only with address formulas mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.CityName
        """
        pass

    @CityName.setter
    def CityName(
      self,
      _value: str
    ) -> None: 
        """
        Field for the city name.
        
        Used to indicate the city name field that can be searched with like-operator. It 
        must be a name taken from address formulas definition. Default value is ''CITYNAME''. 
        Used only with address formulas mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.CityName
        """
        pass

    @property
    def FormulasString(
      self
    ) -> str: 
        """
        String in form of an INI file contents with address formulas definition.
        
        Writing sets address formulas ( cancels all previous settings ). Reading makes current 
        settings available.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.FormulasString
        """
        pass

    @FormulasString.setter
    def FormulasString(
      self,
      _value: str
    ) -> None: 
        """
        String in form of an INI file contents with address formulas definition.
        
        Writing sets address formulas ( cancels all previous settings ). Reading makes current 
        settings available.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.FormulasString
        """
        pass

    @property
    def HouseNumber(
      self
    ) -> str: 
        """
        Field for the house number
        
        Used to indicate the house number field that is processed in special way. It must 
        be a name taken from address formulas definition. Default value is ''HOUSENUMBER''. 
        Used only with address formulas mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.HouseNumber
        """
        pass

    @HouseNumber.setter
    def HouseNumber(
      self,
      _value: str
    ) -> None: 
        """
        Field for the house number
        
        Used to indicate the house number field that is processed in special way. It must 
        be a name taken from address formulas definition. Default value is ''HOUSENUMBER''. 
        Used only with address formulas mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.HouseNumber
        """
        pass

    @property
    def LayerGeocoded(
      self
    ) -> TGIS_LayerVector: 
        """
        Layer with geocoded address.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.LayerGeocoded
        """
        pass

    @property
    def LFrom(
      self
    ) -> str: 
        """
        Field name for the starting number on the left side of the street.
        
        Default is ''LFROM''. Used only with old style functionality.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.LFrom
        """
        pass

    @LFrom.setter
    def LFrom(
      self,
      _value: str
    ) -> None: 
        """
        Field name for the starting number on the left side of the street.
        
        Default is ''LFROM''. Used only with old style functionality.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.LFrom
        """
        pass

    @property
    def LTo(
      self
    ) -> str: 
        """
        Field name for the ending number on the left side of the street. Default is ''LTO''. 
        Used only with old style functionality.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.LTo
        """
        pass

    @LTo.setter
    def LTo(
      self,
      _value: str
    ) -> None: 
        """
        Field name for the ending number on the left side of the street. Default is ''LTO''. 
        Used only with old style functionality.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.LTo
        """
        pass

    @property
    def Offset(
      self
    ) -> float: 
        """
        Offset describes the size of the space between street and address point.
        
        For address at the end of the street at least 1.5*Offset will be used. The value 
        is in the layer units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.Offset
        """
        pass

    @Offset.setter
    def Offset(
      self,
      _value: float
    ) -> None: 
        """
        Offset describes the size of the space between street and address point.
        
        For address at the end of the street at least 1.5*Offset will be used. The value 
        is in the layer units.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.Offset
        """
        pass

    @property
    def OSMGeocoding(
      self
    ) -> bool: 
        """
        If true the local geocoding resource is ignored and the requests are send to the 
        TatukGIS online geocoding service.
        
        Internally uses the TGIS_OSMGeocoding class.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.OSMGeocoding
        """
        pass

    @OSMGeocoding.setter
    def OSMGeocoding(
      self,
      _value: bool
    ) -> None: 
        """
        If true the local geocoding resource is ignored and the requests are send to the 
        TatukGIS online geocoding service.
        
        Internally uses the TGIS_OSMGeocoding class.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.OSMGeocoding
        """
        pass

    
    def Point(
      self,
      _idx: int
    ) -> TGIS_Point: 
        """
        List of address points. Only for finding addresses.

        Args:
            _idx: index of the value within the list of results

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.Point
        """
        pass

    
    def Query(
      self,
      _idx: int
    ) -> str: 
        """
        String with processed query.
        
        Query will be reformatted to the form defined at the formulas definition in the section 
        called OUTPUT. The second street of crossroads will be added after the ''&amp;'' 
        sign.

        Args:
            _idx: index of value within the list of results

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.Query
        """
        pass

    
    def QueryEx(
      self,
      _idx: int
    ) -> str: 
        """
        String with process query.
        
        Query will be represented in a decomposed form (featurename1=featurevalue1;featurename2=featurevalue2;..). 
        For crossroads parameters for the second street will be added after the ''&amp;'' 
        sign.

        Args:
            _idx: index of the value within the list of results

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.QueryEx
        """
        pass

    @property
    def ReverseRestrictQuery(
      self
    ) -> str: 
        """
        String with a query defined for reverse geocoding at the address formulas definition. 
        It can be assembly with an additional query passed as a parameter to the ReverseGeocode 
        method.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.ReverseRestrictQuery
        """
        pass

    @property
    def RFrom(
      self
    ) -> str: 
        """
        Field name for the starting number on the right side of the street. Default is ''RFROM''. 
        Used only with old style functionality.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.RFrom
        """
        pass

    @RFrom.setter
    def RFrom(
      self,
      _value: str
    ) -> None: 
        """
        Field name for the starting number on the right side of the street. Default is ''RFROM''. 
        Used only with old style functionality.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.RFrom
        """
        pass

    @property
    def RoadName(
      self
    ) -> str: 
        """
        Field for the feature name. Default is ''NAME''.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.RoadName
        """
        pass

    @RoadName.setter
    def RoadName(
      self,
      _value: str
    ) -> None: 
        """
        Field for the feature name. Default is ''NAME''.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.RoadName
        """
        pass

    @property
    def RTo(
      self
    ) -> str: 
        """
        Field name for the ending number on the right side of the street. Default is ''RTO''. 
        Used only with old style functionality.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.RTo
        """
        pass

    @RTo.setter
    def RTo(
      self,
      _value: str
    ) -> None: 
        """
        Field name for the ending number on the right side of the street. Default is ''RTO''. 
        Used only with old style functionality.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.RTo
        """
        pass

    @property
    def StreetName(
      self
    ) -> str: 
        """
        Field for the street name.
        
        Used to indicate the street name field that can be searched with like-operator. It 
        must be a name taken from address formulas definition. Default value is ''STREETNAME''. 
        Used only with address formulas mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.StreetName
        """
        pass

    @StreetName.setter
    def StreetName(
      self,
      _value: str
    ) -> None: 
        """
        Field for the street name.
        
        Used to indicate the street name field that can be searched with like-operator. It 
        must be a name taken from address formulas definition. Default value is ''STREETNAME''. 
        Used only with address formulas mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.StreetName
        """
        pass

    
    def Uid(
      self,
      _idx: int
    ) -> TGIS_Uid: 
        """
        List of resolved streets Uids.

        Args:
            _idx: index of the value within the list of results

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.Uid
        """
        pass

    
    def UidEx(
      self,
      _idx: int
    ) -> TGIS_Uid: 
        """
        List of resolved street Uids. Only for crossings - Uid for a second street on an 
        intersection.

        Args:
            _idx: index of the value within the list of results

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.UidEx
        """
        pass

    @property
    def UniqueName(
      self
    ) -> str: 
        """
        Field for a name of a special key indicating a unique street identifier. Default 
        is ''UNIQUENAME''. Used only with address formulas

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.UniqueName
        """
        pass

    @UniqueName.setter
    def UniqueName(
      self,
      _value: str
    ) -> None: 
        """
        Field for a name of a special key indicating a unique street identifier. Default 
        is ''UNIQUENAME''. Used only with address formulas

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.UniqueName
        """
        pass

    @property
    def AddressEvent(
      self
    ) -> typing.Callable[[String, String], bool]: 
        """
        Event which will be fired on each found address.
        
        It must be used when an algorithm of checking the house number is more heuristic 
        and can not be only a simply data base query.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.AddressEvent
        """
        pass

    @AddressEvent.setter
    def AddressEvent(
      self,
      _value: typing.Callable[[String, String], bool]
    ) -> None: 
        """
        Event which will be fired on each found address.
        
        It must be used when an algorithm of checking the house number is more heuristic 
        and can not be only a simply data base query.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Geocoding.AddressEvent
        """
        pass

class TGIS_GeometryFactory:
    """
    Factory for converting different formats into a shape and reverse.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.Create_void
        """
        pass

    @classmethod
    def GisArcFrom3Points(
      cls,
      _ptg1: TGIS_Point,
      _ptg2: TGIS_Point,
      _ptg3: TGIS_Point,
      _center: VarParameter,
      _radius: VarParameter,
      _start: VarParameter,
      _stop: VarParameter
    ) -> bool: 
        """
        Calculate arc based on any three points from the circle outline.

        Args:
            _ptg1: first provided point
            _ptg2: second provided point
            _ptg3: third provided point
            _center: center of the calculated string; the value (in/out) is passed as TGIS_Point 
              in _center.Value property
            _radius: radius of the calculated string; the value (in/out) is passed as float in 
              _radius.Value property
            _start: start angle for pie; the value (in/out) is passed as float in _start.Value 
              property
            _stop: stop angle for pie; the value (in/out) is passed as float in _stop.Value property

        Returns:
            True if can build an arc from 3 points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisArcFrom3Points_TGIS_Point_TGIS_Point_TGIS_Point_TGIS_Point_Double_Double_Double
        """
        pass

    @classmethod
    def GisArcFrom3Points3D(
      cls,
      _ptg1: TGIS_Point3D,
      _ptg2: TGIS_Point3D,
      _ptg3: TGIS_Point3D,
      _center: VarParameter,
      _radius: VarParameter,
      _start: VarParameter,
      _stop: VarParameter
    ) -> bool: 
        """
        Calculate arc based on any three 3D points from the circle outline.

        Args:
            _ptg1: first provided point
            _ptg2: second provided point
            _ptg3: third provided point
            _center: center of the calculated string; the value (in/out) is passed as TGIS_Point3D 
              in _center.Value property
            _radius: radius of the calculated string; the value (in/out) is passed as float in 
              _radius.Value property
            _start: start angle for pie; the value (in/out) is passed as float in _start.Value 
              property
            _stop: stop angle for pie; the value (in/out) is passed as float in _stop.Value property

        Returns:
            True if can build an arc from 3 points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisArcFrom3Points3D_TGIS_Point3D_TGIS_Point3D_TGIS_Point3D_TGIS_Point3D_Double_Double_Double
        """
        pass

    @classmethod
    def GisBuildShapeFromEdges(
      cls,
      _edges: TGIS_ObjectList,
      _shapeType: TGIS_ShapeType,
      _tolerance: float,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector,
      _fixShape: bool
    ) -> TGIS_Shape: 
        """
        Build a polygon from a list of non complex edges.

        Args:
            _edges: list of non complex edges of TGIS_ShapeArc type
            _shapeType: output shape type, TGIS_ShapeType.Arc or TGIS_ShapeType.Polygon
            _tolerance: tolerance into which two arcs are close enough to be joined
            _source: If not nil, then the base shape will be based on this shape. Otherwise _ptr, 
              _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: True if pointer is mapped to the file
            _uid: Unique identifier for shape.
            _layer: Reference to the layer on which the shape will be created.
            _fixShape: if True, the newly created shape will be fixed using TGIS_Topology.FixShape

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisBuildShapeFromEdges_TGIS_ObjectList_TGIS_ShapeType_Double_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector_Boolean
        """
        pass

    @classmethod
    def GisCircleFrom3Points(
      cls,
      _ptg1: TGIS_Point,
      _ptg2: TGIS_Point,
      _ptg3: TGIS_Point,
      _center: VarParameter,
      _radius: VarParameter,
      _start: VarParameter,
      _stop: VarParameter
    ) -> bool: 
        """
        Calculate circle based on any three points from the circle outline.

        Args:
            _ptg1: first provided point
            _ptg2: second provided point
            _ptg3: third provided point
            _center: center of the calculated string; the value (in/out) is passed as TGIS_Point 
              in _center.Value property
            _radius: radius of the calculated string; the value (in/out) is passed as float in 
              _radius.Value property
            _start: start angle for pie (currently always 0); the value (in/out) is passed as 
              float in _start.Value property
            _stop: stop angle for pie (currently always 2Pi); the value (in/out) is passed as 
              float in _stop.Value property

        Returns:
            True if can build a circle from 3 points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCircleFrom3Points_TGIS_Point_TGIS_Point_TGIS_Point_TGIS_Point_Double_Double_Double
        """
        pass

    @classmethod
    def GisCircleFrom3Points3D(
      cls,
      _ptg1: TGIS_Point3D,
      _ptg2: TGIS_Point3D,
      _ptg3: TGIS_Point3D,
      _center: VarParameter,
      _radius: VarParameter,
      _start: VarParameter,
      _stop: VarParameter
    ) -> bool: 
        """
        Calculate circle based on any three 3D points from the circle outline.

        Args:
            _ptg1: first provided point
            _ptg2: second provided point
            _ptg3: third provided point
            _center: center of the calculated string; the value (in/out) is passed as TGIS_Point3D 
              in _center.Value property
            _radius: radius of the calculated string; the value (in/out) is passed as float in 
              _radius.Value property
            _start: start angle for pie (currently always 0); the value (in/out) is passed as 
              float in _start.Value property
            _stop: stop angle for pie (currently always 2Pi); the value (in/out) is passed as 
              float in _stop.Value property

        Returns:
            True if can build a circle from 3 points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCircleFrom3Points3D_TGIS_Point3D_TGIS_Point3D_TGIS_Point3D_TGIS_Point3D_Double_Double_Double
        """
        pass

    @classmethod
    def GisCreateReprojectedShape(
      cls,
      _shp: TGIS_Shape,
      _src_cs: TGIS_CSCoordinateSystem,
      _dst_cs: TGIS_CSCoordinateSystem
    ) -> TGIS_Shape: 
        """
        Create a reprojected shape.

        Args:
            _shp: source shape to reproject
            _src_cs: source coordinate system
            _dst_cs: destination coordinate system

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateReprojectedShape_TGIS_Shape_TGIS_CSCoordinateSystem_TGIS_CSCoordinateSystem
        """
        pass

    @overload
    @classmethod
    def GisCreateShapeFromEWKB(
      cls,
      _ewkb: OleVariant
    ) -> TGIS_Shape: 
        """
        Create the shape geometry into an Extended Well Known Binary (EWKB) representation 
        of the geometry with SRID metadata.

        Args:
            _ewkb: EWKB array

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateShapeFromEWKB_OleVariant
        """
        pass

    @overload
    @classmethod
    def GisCreateShapeFromEWKB(
      cls,
      _ewkb: OleVariant,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector
    ) -> TGIS_Shape: 
        """
        Create the shape geometry from an Extended Well Known Binary (EWKB) representation 
        of the geometry with SRID metadata.

        Args:
            _ewkb: EWKB array
            _source: If not nil, then the base shape will be based on this shape. Otherwise _ptr, 
              _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: True if pointer is mapped to the file
            _uid: Unique identifier for shape.
            _layer: Reference to the layer on which the shape will be created.

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateShapeFromEWKB_OleVariant_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector
        """
        pass

    @overload
    @classmethod
    def GisCreateShapeFromEWKB(
      cls,
      _ewkb: Pointer,
      _size: int
    ) -> TGIS_Shape: 
        """
        Create the shape geometry from an Extended Well Known Binary (EWKB) representation 
        of the geometry with SRID metadata.

        Args:
            _ewkb: EWKB array
            _size: buffer size

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateShapeFromEWKB_Pointer_Integer
        """
        pass

    @overload
    @classmethod
    def GisCreateShapeFromEWKT(
      cls,
      _ewkt: str
    ) -> TGIS_Shape: 
        """
        Create the shape from a Well Known Text (WKT) or an Extended Well Known Text (EWKT) 
        representation of the geometry with SRID metadata.

        Args:
            _ewkt: EWKT text

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateShapeFromEWKT_String
        """
        pass

    @overload
    @classmethod
    def GisCreateShapeFromEWKT(
      cls,
      _ewkt: str,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector
    ) -> TGIS_Shape: 
        """
        Create the shape geometry from a Well Known Text (WKT) or an Extended Well Known 
        Text (EWKT) representation of the geometry with SRID metadata.

        Args:
            _ewkt: EWKT text
            _source: If not nil, then the base shape will be based on this shape. Otherwise _ptr, 
              _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: True if pointer is mapped to the file
            _uid: Unique identifier for shape.
            _layer: Reference to the layer on which the shape will be created.

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateShapeFromEWKT_String_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector
        """
        pass

    @overload
    @classmethod
    def GisCreateShapeFromGDO(
      cls,
      _gdo: OleVariant
    ) -> TGIS_Shape: 
        """
        Create the shape from GeoMedia Database Object (GDO).

        Args:
            _gdo: GDO array

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateShapeFromGDO_OleVariant
        """
        pass

    @overload
    @classmethod
    def GisCreateShapeFromGDO(
      cls,
      _gdo: OleVariant,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector
    ) -> TGIS_Shape: 
        """
        Create the shape from GeoMedia Database Object (GDO).

        Args:
            _gdo: GDO array
            _source: If not nil, then the base shape will be based on this shape. Otherwise _ptr, 
              _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: True if pointer is mapped to the file
            _uid: Unique identifier for shape.
            _layer: Reference to the layer on which the shape will be created.

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateShapeFromGDO_OleVariant_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector
        """
        pass

    @overload
    @classmethod
    def GisCreateShapeFromGML(
      cls,
      _gml: str
    ) -> TGIS_Shape: 
        """
        Create the shape from GML.

        Args:
            _gml: GML text

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateShapeFromGML_String
        """
        pass

    @overload
    @classmethod
    def GisCreateShapeFromGML(
      cls,
      _gml: str,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector
    ) -> TGIS_Shape: 
        """
        Create the shape from GML.

        Args:
            _gml: GML text
            _source: If not nil, then the base shape will be based on this shape. Otherwise _ptr, 
              _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: True if pointer is mapped to the file
            _uid: Unique identifier for shape.
            _layer: Reference to the layer on which the shape will be created.

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateShapeFromGML_String_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector
        """
        pass

    @overload
    @classmethod
    def GisCreateShapeFromJSON(
      cls,
      _json: str
    ) -> TGIS_Shape: 
        """
        Create the shape from JSON.

        Args:
            _json: JSON text

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateShapeFromJSON_String
        """
        pass

    @overload
    @classmethod
    def GisCreateShapeFromJSON(
      cls,
      _json: str,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector
    ) -> TGIS_Shape: 
        """
        Create the shape from GeoJSON.

        Args:
            _json: JSON text
            _source: If not nil, then the base shape will be based on this shape. Otherwise _ptr, 
              _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: True if pointer is mapped to the file
            _uid: Unique identifier for shape.
            _layer: Reference to the layer on which the shape will be created.

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateShapeFromJSON_String_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector
        """
        pass

    @overload
    @classmethod
    def GisCreateShapeFromWKB(
      cls,
      _wkb: OleVariant
    ) -> TGIS_Shape: 
        """
        Create the shape from Well Known Binary (WKB).

        Args:
            _wkb: WKB array

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateShapeFromWKB_OleVariant
        """
        pass

    @overload
    @classmethod
    def GisCreateShapeFromWKB(
      cls,
      _wkb: OleVariant,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector
    ) -> TGIS_Shape: 
        """
        Create the shape from Well Known Binary (WKB).

        Args:
            _wkb: WKB array
            _source: If not nil, then the base shape will be based on this shape. Otherwise _ptr, 
              _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: True if pointer is mapped to the file
            _uid: Unique identifier for shape.
            _layer: Reference to the layer on which the shape will be created.

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateShapeFromWKB_OleVariant_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector
        """
        pass

    @overload
    @classmethod
    def GisCreateShapeFromWKB(
      cls,
      _wkb: Pointer,
      _size: int
    ) -> TGIS_Shape: 
        """
        Create the shape from Well Known Binary (WKB).

        Args:
            _wkb: WKB array
            _size: buffer size

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateShapeFromWKB_Pointer_Integer
        """
        pass

    @overload
    @classmethod
    def GisCreateShapeFromWKT(
      cls,
      _wkt: str
    ) -> TGIS_Shape: 
        """
        Create the shape from a Well Known Text (WKT).

        Args:
            _wkt: WKT text

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateShapeFromWKT_String
        """
        pass

    @overload
    @classmethod
    def GisCreateShapeFromWKT(
      cls,
      _wkt: str,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector
    ) -> TGIS_Shape: 
        """
        Create the shape from a Well Known Text (WKT).

        Args:
            _wkt: WKT text
            _source: If not nil, then the base shape will be based on this shape. Otherwise _ptr, 
              _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: True if pointer is mapped to the file
            _uid: Unique identifier for shape.
            _layer: Reference to the layer on which the shape will be created.

        Returns:
            A new shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisCreateShapeFromWKT_String_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector
        """
        pass

    @overload
    @classmethod
    def GisExportArcToEWKB(
      cls,
      _shp: TGIS_Shape,
      _srid: int,
      _multi: bool,
      _ewkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an Extended Well Known Binary (EWKB) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier
            _multi: force multi geometry structure (multiline envelope)
            _ewkb: exported EWKB array; the value (in/out) is passed as OleVariant in _ewkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportArcToEWKB_TGIS_Shape_Integer_Boolean_OleVariant
        """
        pass

    @overload
    @classmethod
    def GisExportArcToEWKB(
      cls,
      _shp: TGIS_Shape,
      _srid: int,
      _ewkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an Extended Well Known Binary (EWKB) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier
            _ewkb: exported EWKB array; the value (in/out) is passed as OleVariant in _ewkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportArcToEWKB_TGIS_Shape_Integer_OleVariant
        """
        pass

    @overload
    @classmethod
    def GisExportArcToEWKB(
      cls,
      _shp: TGIS_Shape,
      _ewkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an Extended Well Known Binary (EWKB) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _ewkb: exported EWKB array; the value (in/out) is passed as OleVariant in _ewkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportArcToEWKB_TGIS_Shape_OleVariant
        """
        pass

    @overload
    @classmethod
    def GisExportArcToEWKT(
      cls,
      _shp: TGIS_Shape,
      _srid: int,
      _ver: int
    ) -> str: 
        """
        Export the Shape geometry into an Extended Well Known Text (EWKT) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier
            _ver: version of EWKT format

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportArcToEWKT_TGIS_Shape_Integer_Integer
        """
        pass

    @overload
    @classmethod
    def GisExportArcToEWKT(
      cls,
      _shp: TGIS_Shape,
      _srid: int
    ) -> str: 
        """
        Export the Shape geometry into an Extended Well Known Text (EWKT) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportArcToEWKT_TGIS_Shape_Integer
        """
        pass

    @overload
    @classmethod
    def GisExportArcToEWKT(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into an Extended Well Known Text (EWKT) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportArcToEWKT_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportArcToGDO(
      cls,
      _shp: TGIS_Shape,
      _gdo: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a GeoMedia Database Object (GDO).

        Args:
            _shp: shape to export
            _gdo: exported GDO array; the value (in/out) is passed as OleVariant in _gdo.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportArcToGDO_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportArcToGML(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GML.

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportArcToGML_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportArcToJSON(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GeoJSON.

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportArcToJSON_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportArcToVAR(
      cls,
      _shp: TGIS_Shape,
      _var: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an internal SHP format.

        Args:
            _shp: shape to export
            _var: exported VAR array; the value (in/out) is passed as OleVariant in _var.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportArcToVAR_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportArcToWKB(
      cls,
      _shp: TGIS_Shape,
      _wkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a Well Known Binary (WKB).

        Args:
            _shp: shape to export
            _wkb: exported WKB array; the value (in/out) is passed as OleVariant in _wkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportArcToWKB_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportArcToWKT(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a Well Known Text (WKT).

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportArcToWKT_TGIS_Shape
        """
        pass

    @overload
    @classmethod
    def GisExportComplexToEWKB(
      cls,
      _shp: TGIS_Shape,
      _srid: int,
      _ewkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an Extended Well Known Binary (EWKB) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier
            _ewkb: exported EWKB array; the value (in/out) is passed as OleVariant in _ewkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportComplexToEWKB_TGIS_Shape_Integer_OleVariant
        """
        pass

    @overload
    @classmethod
    def GisExportComplexToEWKB(
      cls,
      _shp: TGIS_Shape,
      _ewkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an Extended Well Known Binary (EWKB) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _ewkb: exported EWKB array; the value (in/out) is passed as OleVariant in _ewkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportComplexToEWKB_TGIS_Shape_OleVariant
        """
        pass

    @overload
    @classmethod
    def GisExportComplexToEWKT(
      cls,
      _shp: TGIS_Shape,
      _srid: int,
      _ver: int
    ) -> str: 
        """
        Export the Shape geometry into an Extended Well Known Text (EWKT) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier
            _ver: version of EWKT format

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportComplexToEWKT_TGIS_Shape_Integer_Integer
        """
        pass

    @overload
    @classmethod
    def GisExportComplexToEWKT(
      cls,
      _shp: TGIS_Shape,
      _srid: int
    ) -> str: 
        """
        Export the Shape geometry into an Extended Well Known Text (EWKT) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportComplexToEWKT_TGIS_Shape_Integer
        """
        pass

    @overload
    @classmethod
    def GisExportComplexToEWKT(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into an Extended Well Known Text (EWKT) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportComplexToEWKT_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportComplexToGDO(
      cls,
      _shp: TGIS_Shape,
      _gdo: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a GeoMedia Database Object (GDO).

        Args:
            _shp: shape to export
            _gdo: exported GDO array; the value (in/out) is passed as OleVariant in _gdo.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportComplexToGDO_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportComplexToGML(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GML.

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportComplexToGML_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportComplexToJSON(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GeoJSON.

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportComplexToJSON_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportComplexToVAR(
      cls,
      _shp: TGIS_Shape,
      _var: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an internal SHP format.

        Args:
            _shp: shape to export
            _var: exported VAR array; the value (in/out) is passed as OleVariant in _var.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportComplexToVAR_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportComplexToWKB(
      cls,
      _shp: TGIS_Shape,
      _wkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a Well Known Binary (WKB).

        Args:
            _shp: shape to export
            _wkb: exported WKB array; the value (in/out) is passed as OleVariant in _wkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportComplexToWKB_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportComplexToWKT(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a Well Known Text (WKT).

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportComplexToWKT_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportGeometry2Hex(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into variant geometry. For PostgeSQL ODBC driver purposes

        Args:
            _shp: exported Shape

        Returns:
            A hex text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportGeometry2Hex_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportGeometryToShapeEx(
      cls,
      _shp: TGIS_Shape,
      _gdb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry to Shape extended format used in PGDB and FileGDB.

        Args:
            _shp: exported Shape
            _gdb: exported VAR array; the value (in/out) is passed as OleVariant in _gdb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportGeometryToShapeEx_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportMultiPatchToVAR(
      cls,
      _shp: TGIS_Shape,
      _var: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an internal SHP format.

        Args:
            _shp: shape to export
            _var: exported VAR array; the value (in/out) is passed as OleVariant in _var.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportMultiPatchToVAR_TGIS_Shape_OleVariant
        """
        pass

    @overload
    @classmethod
    def GisExportMultiPointToEWKB(
      cls,
      _shp: TGIS_Shape,
      _srid: int,
      _ewkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an Extended Well Known Binary (EWKB) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier
            _ewkb: exported EWKB array; the value (in/out) is passed as OleVariant in _ewkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportMultiPointToEWKB_TGIS_Shape_Integer_OleVariant
        """
        pass

    @overload
    @classmethod
    def GisExportMultiPointToEWKB(
      cls,
      _shp: TGIS_Shape,
      _ewkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an Extended Well Known Binary (EWKB) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _ewkb: exported EWKB array; the value (in/out) is passed as OleVariant in _ewkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportMultiPointToEWKB_TGIS_Shape_OleVariant
        """
        pass

    @overload
    @classmethod
    def GisExportMultiPointToEWKT(
      cls,
      _shp: TGIS_Shape,
      _srid: int,
      _ver: int
    ) -> str: 
        """
        Export the Shape geometry into an Extended Well Known Text (EWKT) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier
            _ver: version of EWKT format

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportMultiPointToEWKT_TGIS_Shape_Integer_Integer
        """
        pass

    @overload
    @classmethod
    def GisExportMultiPointToEWKT(
      cls,
      _shp: TGIS_Shape,
      _srid: int
    ) -> str: 
        """
        Export the Shape geometry into an Extended Well Known Text (EWKT) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportMultiPointToEWKT_TGIS_Shape_Integer
        """
        pass

    @overload
    @classmethod
    def GisExportMultiPointToEWKT(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into an Extended Well Known Text (EWKT) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportMultiPointToEWKT_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportMultiPointToGDO(
      cls,
      _shp: TGIS_Shape,
      _gdo: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a GeoMedia Database Object (GDO).

        Args:
            _shp: shape to export
            _gdo: exported GDO array; the value (in/out) is passed as OleVariant in _gdo.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportMultiPointToGDO_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportMultiPointToGML(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GML.

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportMultiPointToGML_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportMultiPointToJSON(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GeoJSON

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportMultiPointToJSON_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportMultiPointToVAR(
      cls,
      _shp: TGIS_Shape,
      _var: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an internal SHP format.

        Args:
            _shp: shape to export
            _var: exported VAR array; the value (in/out) is passed as OleVariant in _var.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportMultiPointToVAR_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportMultiPointToWKB(
      cls,
      _shp: TGIS_Shape,
      _wkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a Well Known Binary (WKB).

        Args:
            _shp: shape to export
            _wkb: exported WKB array; the value (in/out) is passed as OleVariant in _wkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportMultiPointToWKB_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportMultiPointToWKT(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a Well Known Text (WKT).

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportMultiPointToWKT_TGIS_Shape
        """
        pass

    @overload
    @classmethod
    def GisExportPointToEWKB(
      cls,
      _shp: TGIS_Shape,
      _srid: int,
      _ewkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an Extended Well Known Binary (EWKB) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier
            _ewkb: exported EWKB array; the value (in/out) is passed as OleVariant in _ewkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPointToEWKB_TGIS_Shape_Integer_OleVariant
        """
        pass

    @overload
    @classmethod
    def GisExportPointToEWKB(
      cls,
      _shp: TGIS_Shape,
      _ewkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an Extended Well Known Binary (EWKB) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _ewkb: exported EWKB array; the value (in/out) is passed as OleVariant in _ewkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPointToEWKB_TGIS_Shape_OleVariant
        """
        pass

    @overload
    @classmethod
    def GisExportPointToEWKT(
      cls,
      _shp: TGIS_Shape,
      _srid: int,
      _ver: int
    ) -> str: 
        """
        Export the Shape geometry into an Extended Well Known Text (EWKT) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier
            _ver: version of EWKT format

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPointToEWKT_TGIS_Shape_Integer_Integer
        """
        pass

    @overload
    @classmethod
    def GisExportPointToEWKT(
      cls,
      _shp: TGIS_Shape,
      _srid: int
    ) -> str: 
        """
        Export the Shape geometry into an Extended Well Known Text (EWKT) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPointToEWKT_TGIS_Shape_Integer
        """
        pass

    @overload
    @classmethod
    def GisExportPointToEWKT(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into an Extended Well Known Text (EWKT) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPointToEWKT_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportPointToGDO(
      cls,
      _shp: TGIS_Shape,
      _gdo: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a GeoMedia Database Object (GDO).

        Args:
            _shp: shape to export
            _gdo: exported GDO array; the value (in/out) is passed as OleVariant in _gdo.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPointToGDO_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportPointToGML(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GML.

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPointToGML_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportPointToJSON(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GeoJSON.

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPointToJSON_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportPointToVAR(
      cls,
      _shp: TGIS_Shape,
      _var: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an internal SHP format.

        Args:
            _shp: shape to export
            _var: exported VAR array; the value (in/out) is passed as OleVariant in _var.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPointToVAR_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportPointToWKB(
      cls,
      _shp: TGIS_Shape,
      _wkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a Well Known Binary (WKB).

        Args:
            _shp: shape to export
            _wkb: exported WKB array; the value (in/out) is passed as OleVariant in _wkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPointToWKB_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportPointToWKT(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a Well Known Text (WKT).

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPointToWKT_TGIS_Shape
        """
        pass

    @overload
    @classmethod
    def GisExportPolygonToEWKB(
      cls,
      _shp: TGIS_Shape,
      _srid: int,
      _multi: bool,
      _ewkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an Extended Well Known Binary (EWKB) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier
            _multi: force multi geometry structure (multipolygon envelope)
            _ewkb: exported EWKB array; the value (in/out) is passed as OleVariant in _ewkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPolygonToEWKB_TGIS_Shape_Integer_Boolean_OleVariant
        """
        pass

    @overload
    @classmethod
    def GisExportPolygonToEWKB(
      cls,
      _shp: TGIS_Shape,
      _srid: int,
      _ewkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an Extended Well Known Binary (EWKB) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier
            _ewkb: exported EWKB array; the value (in/out) is passed as OleVariant in _ewkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPolygonToEWKB_TGIS_Shape_Integer_OleVariant
        """
        pass

    @overload
    @classmethod
    def GisExportPolygonToEWKB(
      cls,
      _shp: TGIS_Shape,
      _ewkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an Extended Well Known Binary (EWKB) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _ewkb: exported EWKB array; the value (in/out) is passed as OleVariant in _ewkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPolygonToEWKB_TGIS_Shape_OleVariant
        """
        pass

    @overload
    @classmethod
    def GisExportPolygonToEWKT(
      cls,
      _shp: TGIS_Shape,
      _srid: int,
      _ver: int
    ) -> str: 
        """
        Export the Shape geometry into an Extended Well Known Text (EWKT) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier
            _ver: version of EWKT format

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPolygonToEWKT_TGIS_Shape_Integer_Integer
        """
        pass

    @overload
    @classmethod
    def GisExportPolygonToEWKT(
      cls,
      _shp: TGIS_Shape,
      _srid: int
    ) -> str: 
        """
        Export the Shape geometry into an Extended Well Known Text (EWKT) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export
            _srid: spatial referencing system identifier

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPolygonToEWKT_TGIS_Shape_Integer
        """
        pass

    @overload
    @classmethod
    def GisExportPolygonToEWKT(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into an Extended Well Known Text (EWKT) representation 
        of the geometry with SRID metadata.

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPolygonToEWKT_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportPolygonToGDO(
      cls,
      _shp: TGIS_Shape,
      _gdo: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a GeoMedia Database Object (GDO).

        Args:
            _shp: shape to export
            _gdo: exported GDO array; the value (in/out) is passed as OleVariant in _gdo.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPolygonToGDO_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportPolygonToGML(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GML.

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPolygonToGML_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportPolygonToJSON(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GeoJSON.

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPolygonToJSON_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportPolygonToVAR(
      cls,
      _shp: TGIS_Shape,
      _var: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an internal SHP format.

        Args:
            _shp: shape to export
            _var: exported VAR array; the value (in/out) is passed as OleVariant in _var.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPolygonToVAR_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportPolygonToWKB(
      cls,
      _shp: TGIS_Shape,
      _wkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a Well Known Binary (WKB).

        Args:
            _shp: shape to export
            _wkb: exported WKB array; the value (in/out) is passed as OleVariant in _wkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPolygonToWKB_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportPolygonToWKT(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a Well Known Text (WKT).

        Args:
            _shp: shape to export

        Returns:
            A text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportPolygonToWKT_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportWKB2Hex(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a Well Known Binary (WKB).

        Args:
            _shp: exported Shape

        Returns:
            A hex text representation of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisExportWKB2Hex_TGIS_Shape
        """
        pass

    @classmethod
    def GisPolygonPartsStatus(
      cls,
      _shp: TGIS_Shape,
      _parts: VarParameter,
      _winding: VarParameter
    ) -> bool: 
        """
        Check polygon parts to verify main part, islands, holes and if it is a single polygon 
        or multipolygon shape.

        Args:
            _shp: shape instance
            _parts: array of parts, will be allocated and filled with status value : 0 for main 
              part or island, 1 for hole; the value (in/out) is passed as TGIS_IntegerArray in 
              _parts.Value property
            _winding: array of windings, will be allocated and filled with status value : -1 
              for counter-clockwise, 1 for clockwise orientation; the value (in/out) is passed 
              as TGIS_IntegerArray in _winding.Value property

        Returns:
            True if shape is multipolygon, False if polygon.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactory.GisPolygonPartsStatus_TGIS_Shape_TGIS_IntegerArray_TGIS_IntegerArray
        """
        pass

class TGIS_SdoGeometry:
    """
    SDO geometry encapsulation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.Create_void
        """
        pass

    @property
    def Coords(
      self
    ) -> TGIS_DoubleArray: 
        """
        Coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.Coords
        """
        pass

    @Coords.setter
    def Coords(
      self,
      _value: TGIS_DoubleArray
    ) -> None: 
        """
        Coordinates.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.Coords
        """
        pass

    @property
    def CoordsLen(
      self
    ) -> int: 
        """
        Coordinates length.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.CoordsLen
        """
        pass

    @CoordsLen.setter
    def CoordsLen(
      self,
      _value: int
    ) -> None: 
        """
        Coordinates length.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.CoordsLen
        """
        pass

    @property
    def ElemInfo(
      self
    ) -> TGIS_IntegerArray: 
        """
        Element information.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.ElemInfo
        """
        pass

    @ElemInfo.setter
    def ElemInfo(
      self,
      _value: TGIS_IntegerArray
    ) -> None: 
        """
        Element information.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.ElemInfo
        """
        pass

    @property
    def ElemInfoLen(
      self
    ) -> int: 
        """
        Element information length.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.ElemInfoLen
        """
        pass

    @ElemInfoLen.setter
    def ElemInfoLen(
      self,
      _value: int
    ) -> None: 
        """
        Element information length.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.ElemInfoLen
        """
        pass

    @property
    def GType(
      self
    ) -> int: 
        """
        Geometry type identifier.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.GType
        """
        pass

    @GType.setter
    def GType(
      self,
      _value: int
    ) -> None: 
        """
        Geometry type identifier.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.GType
        """
        pass

    @property
    def HasPoint(
      self
    ) -> bool: 
        """
        True if has attachment point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.HasPoint
        """
        pass

    @HasPoint.setter
    def HasPoint(
      self,
      _value: bool
    ) -> None: 
        """
        True if has attachment point.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.HasPoint
        """
        pass

    @property
    def Point(
      self
    ) -> TGIS_Point3D: 
        """
        Attachment point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.Point
        """
        pass

    @Point.setter
    def Point(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        Attachment point.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.Point
        """
        pass

    @property
    def Srid(
      self
    ) -> int: 
        """
        Source identifier.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.Srid
        """
        pass

    @Srid.setter
    def Srid(
      self,
      _value: int
    ) -> None: 
        """
        Source identifier.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SdoGeometry.Srid
        """
        pass

class TGIS_GeometryFactoryEnt:
    """
    Factory for converting different formats into a shape and reverse.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactoryEnt
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactoryEnt.Create_void
        """
        pass

    def GisBuildShapeFromSdo(
      self,
      _shp: TGIS_Shape,
      _sdo: TGIS_SdoGeometry
    ) -> None: 
        """
        Create the shape from Oracle SDO parsed data.

        Args:
            _shp: shape to be constructed
            _sdo: SDO structure handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactoryEnt.GisBuildShapeFromSdo_TGIS_Shape_TGIS_SdoGeometry
        """
        pass

    def GisCreateShapeFromSqlGeography(
      self,
      _buf: Pointer,
      _size: int
    ) -> TGIS_Shape: 
        """
        Create the shape from MsSQL SQLGeography serialized data.

        Args:
            _buf: buffer array
            _size: buffer size

        Returns:
            new shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactoryEnt.GisCreateShapeFromSqlGeography_Pointer_Integer
        """
        pass

    def GisCreateShapeFromSqlGeometry(
      self,
      _buf: Pointer,
      _size: int
    ) -> TGIS_Shape: 
        """
        Create the shape from MsSQL geometry/geography serialized data.

        Args:
            _buf: buffer array
            _size: buffer size

        Returns:
            new shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactoryEnt.GisCreateShapeFromSqlGeometry_Pointer_Integer
        """
        pass

    def GisExportShapeToSqlGeography(
      self,
      _shp: TGIS_Shape,
      _srid: int,
      _mso: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a MsSQL SQLGeography serialized data.

        Args:
            _shp: shape to export
            _srid: source ID
            _mso: exported MsSQL SQLGeography serialized data; the value (in/out) is passed as 
              OleVariant in _mso.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactoryEnt.GisExportShapeToSqlGeography_TGIS_Shape_Integer_OleVariant
        """
        pass

    def GisExportShapeToSqlGeometry(
      self,
      _shp: TGIS_Shape,
      _srid: int,
      _mso: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a MsSql SqlGeometry serialized data.

        Args:
            _shp: shape to export
            _srid: source ID
            _mso: exported MsSQL SQLGeography serialized data; the value (in/out) is passed as 
              OleVariant in _mso.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GeometryFactoryEnt.GisExportShapeToSqlGeometry_TGIS_Shape_Integer_OleVariant
        """
        pass

class TGIS_GraticuleMode:
    pass

class TGIS_GraticuleMode:
    """
    Graticule mode

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleMode
    """

    @property
    def LatLon(
      self
    ) -> TGIS_GraticuleMode: 
        """
        Standard graticule lines.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleMode.LatLon
        """
        pass

class TGIS_GraticuleLabelPosition:
    pass

class TGIS_GraticuleLabelPosition:
    """
    Graticule position against graticule line.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabelPosition
    """

    @property
    def Left(
      self
    ) -> TGIS_GraticuleLabelPosition: 
        """
        A label is located on a left of a graticule line (or above depends on graticule line 
        orientation).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabelPosition.Left
        """
        pass

    @property
    def Right(
      self
    ) -> TGIS_GraticuleLabelPosition: 
        """
        A label is located in on a the right of a graticule line (or below depends on graticule 
        line orientation).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabelPosition.Right
        """
        pass

    @property
    def Middle(
      self
    ) -> TGIS_GraticuleLabelPosition: 
        """
        A label is located in the middle of a graticule line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabelPosition.Middle
        """
        pass

class TGIS_GraticuleLabelOrientation:
    pass

class TGIS_GraticuleLabelOrientation:
    """
    Graticule line label orientation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabelOrientation
    """

    @property
    def Vertical(
      self
    ) -> TGIS_GraticuleLabelOrientation: 
        """
        Labels will always be vertical.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabelOrientation.Vertical
        """
        pass

    @property
    def Horizontal(
      self
    ) -> TGIS_GraticuleLabelOrientation: 
        """
        Labels will always be horizontal.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabelOrientation.Horizontal
        """
        pass

    @property
    def Follow(
      self
    ) -> TGIS_GraticuleLabelOrientation: 
        """
        Labels will follow graticule lines orientation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabelOrientation.Follow
        """
        pass

class TGIS_GraticuleLabel( TObject ):
    """
    Object defining graticule labels presentation. A part of TGIS_Graticule.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabel
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabel.Create_void
        """
        pass

    @property
    def Enabled(
      self
    ) -> bool: 
        """
        True if labels are visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabel.Enabled
        """
        pass

    @property
    def Font(
      self
    ) -> TGIS_Font: 
        """
        Labels font.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabel.Font
        """
        pass

    @property
    def Orientation(
      self
    ) -> TGIS_GraticuleLabelOrientation: 
        """
        Labels orientation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabel.Orientation
        """
        pass

    @Orientation.setter
    def Orientation(
      self,
      _value: TGIS_GraticuleLabelOrientation
    ) -> None: 
        """
        Labels orientation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabel.Orientation
        """
        pass

    @property
    def Position(
      self
    ) -> TGIS_GraticuleLabelPosition: 
        """
        Labels position.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabel.Position
        """
        pass

    @Position.setter
    def Position(
      self,
      _value: TGIS_GraticuleLabelPosition
    ) -> None: 
        """
        Labels position.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabel.Position
        """
        pass

    @property
    def ShadowColor(
      self
    ) -> TGIS_Color: 
        """
        Labels shadow color. If different than TGIS_Color.None then the shadow will be visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleLabel.ShadowColor
        """
        pass

class TGIS_GraticuleStyle( TObject ):
    """
    Object defining graticule lines presentation. A part of TGIS_Graticule.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleStyle
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleStyle.Create_void
        """
        pass

    @property
    def Enabled(
      self
    ) -> bool: 
        """
        True if labels are visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleStyle.Enabled
        """
        pass

    @property
    def LabelA(
      self
    ) -> TGIS_GraticuleLabel: 
        """
        Label styles for left/top labels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleStyle.LabelA
        """
        pass

    @property
    def LabelB(
      self
    ) -> TGIS_GraticuleLabel: 
        """
        Label styles for bottom/right labels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleStyle.LabelB
        """
        pass

    @property
    def LabelM(
      self
    ) -> TGIS_GraticuleLabel: 
        """
        Label styles for middle labels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleStyle.LabelM
        """
        pass

    @property
    def Pen(
      self
    ) -> TGIS_Pen: 
        """
        Pen style for graticule lines.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleStyle.Pen
        """
        pass

    @property
    def Step(
      self
    ) -> float: 
        """
        Defines how how many graticules line are visible. Positive number is a step expressed 
        in actual number (radians for graticules line, map units for other). Negative numbers 
        defines how many graticules line should be visible. Default is -4.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleStyle.Step
        """
        pass

    @Step.setter
    def Step(
      self,
      _value: float
    ) -> None: 
        """
        Defines how how many graticules line are visible. Positive number is a step expressed 
        in actual number (radians for graticules line, map units for other). Negative numbers 
        defines how many graticules line should be visible. Default is -4.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleStyle.Step
        """
        pass

class TGIS_Graticule( TObject ):
    """
    Object which defines graticules behavior.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Graticule
    """

    @overload
    def __init__(
      self,
      _viewer: TGIS_Viewer
    ) -> None: 
        """
        Create an instance

        Args:
            _viewer: Viewer context

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Graticule.Create_TGIS_Viewer
        """
        pass

    @property
    def Enabled(
      self
    ) -> bool: 
        """
        If true than Graticules are enabled ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Graticule.Enabled
        """
        pass

    @Enabled.setter
    def Enabled(
      self,
      _value: bool
    ) -> None: 
        """
        If true than Graticules are enabled ;

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Graticule.Enabled
        """
        pass

    @property
    def HorizontalStyle(
      self
    ) -> TGIS_GraticuleStyle: 
        """
        Styles for horizontal lines.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Graticule.HorizontalStyle
        """
        pass

    @property
    def Mode(
      self
    ) -> TGIS_GraticuleMode: 
        """
        Mode of operations/ Default is LatLon.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Graticule.Mode
        """
        pass

    @Mode.setter
    def Mode(
      self,
      _value: TGIS_GraticuleMode
    ) -> None: 
        """
        Mode of operations/ Default is LatLon.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Graticule.Mode
        """
        pass

    @property
    def VerticalStyle(
      self
    ) -> TGIS_GraticuleStyle: 
        """
        Styles for vertical lines.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Graticule.VerticalStyle
        """
        pass

class TGIS_GraticuleHelper( TGIS_Graticule ):
    """
    Helper for drawing graticule.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleHelper
    """

    @overload
    def __init__(
      self,
      _viewer: TGIS_Viewer
    ) -> None: 
        """
        Create an instance

        Args:
            _viewer: Viewer context

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleHelper.Create_TGIS_Viewer
        """
        pass

    @overload
    def Draw(
      self,
      _renderer: TGIS_RendererAbstract,
      _width: int,
      _height: int,
      _originalRect: TRectF,
      _newRect: TRectF,
      _actualExtent: TGIS_Extent
    ) -> None: 
        """
        Draw graticules.

        Args:
            _renderer: renderer object to be used
            _width: window width
            _height: window height
            _originalRect: original size before any kind of zooming and dragging
            _newRect: size reflects actual zooming and dragging
            _actualExtent: extent reflects actual zooming and dragging

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleHelper.Draw_TGIS_RendererAbstract_Integer_Integer_TRectF_TRectF_TGIS_Extent
        """
        pass

    @overload
    def Draw(
      self,
      _renderer: TGIS_RendererAbstract,
      _width: int,
      _height: int,
      _actualExtent: TGIS_Extent
    ) -> None: 
        """
        Draw graticules.

        Args:
            _renderer: renderer object to be used
            _width: window width
            _height: window height
            _actualExtent: extent reflects actual zooming and dragging

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GraticuleHelper.Draw_TGIS_RendererAbstract_Integer_Integer_TGIS_Extent
        """
        pass

class TGIS_HierarchyGroup( TObject, IGIS_HierarchyGroup ):
    """
    Hierarchy group class.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup
    """

    @overload
    def __init__(
      self,
      _name: str
    ) -> None: 
        """
        Constructor.

        Args:
            _name: group name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.Create_String
        """
        pass

    def AddGroup(
      self,
      _group: IGIS_HierarchyGroup
    ) -> None: 
        """
        Add a sub group to the group list.

        Args:
            _group: existing group handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.AddGroup_IGIS_HierarchyGroup
        """
        pass

    def AddLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Add a layer to the group.

        Args:
            _layer: layer handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.AddLayer_TGIS_LayerAbstract
        """
        pass

    def ClearGroups(
      self
    ) -> None: 
        """
        Delete all sub groups.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.ClearGroups_void
        """
        pass

    def CreateGroup(
      self,
      _name: str
    ) -> IGIS_HierarchyGroup: 
        """
        Create a new sub group for this group .

        Args:
            _name: group name (must be unique)

        Returns:
            group

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.CreateGroup_String
        """
        pass

    def DeleteGroup(
      self,
      _name: str
    ) -> None: 
        """
        Delete a group from the group list.

        Args:
            _name: group name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.DeleteGroup_String
        """
        pass

    def DeleteLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Delete a layer from a group.

        Args:
            _layer: layer handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.DeleteLayer_TGIS_LayerAbstract
        """
        pass

    def InsertGroup(
      self,
      _group: IGIS_HierarchyGroup,
      _index: int
    ) -> None: 
        """
        Insert a sub group to the group list at insert index.

        Args:
            _group: existing group handle
            _index: insert index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.InsertGroup_IGIS_HierarchyGroup_Integer
        """
        pass

    def InsertLayer(
      self,
      _layer: TGIS_LayerAbstract,
      _index: int
    ) -> None: 
        """
        Insert a layer to the group as index position.

        Args:
            _layer: layer handle
            _index: insert index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.InsertLayer_TGIS_LayerAbstract_Integer
        """
        pass

    def RemoveGroup(
      self,
      _group: IGIS_HierarchyGroup
    ) -> None: 
        """
        Remove a group from the group list.

        Args:
            _group: existing group handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.RemoveGroup_IGIS_HierarchyGroup
        """
        pass

    @property
    def Active(
      self
    ) -> bool: 
        """
        Is group active.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.Active
        """
        pass

    @Active.setter
    def Active(
      self,
      _value: bool
    ) -> None: 
        """
        Is group active.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.Active
        """
        pass

    @property
    def Caption(
      self
    ) -> str: 
        """
        Group caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.Caption
        """
        pass

    @Caption.setter
    def Caption(
      self,
      _value: str
    ) -> None: 
        """
        Group caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.Caption
        """
        pass

    @property
    def Collapsed(
      self
    ) -> bool: 
        """
        Is group collapsed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.Collapsed
        """
        pass

    @Collapsed.setter
    def Collapsed(
      self,
      _value: bool
    ) -> None: 
        """
        Is group collapsed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.Collapsed
        """
        pass

    
    def Groups(
      self,
      _indexOrName: OleVariant
    ) -> IGIS_HierarchyGroup: 
        """
        Get group by name.

        Args:
            _indexOrName: group index or name

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.Groups
        """
        pass

    @property
    def GroupsCount(
      self
    ) -> int: 
        """
        Groups count.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.GroupsCount
        """
        pass

    @property
    def IsModified(
      self
    ) -> bool: 
        """
        Is group modified.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.IsModified
        """
        pass

    
    def Layers(
      self,
      _index: int
    ) -> TGIS_LayerAbstract: 
        """
        Get layer by index.

        Args:
            _index: group index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.Layers
        """
        pass

    @property
    def LayersCount(
      self
    ) -> int: 
        """
        Layers count.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.LayersCount
        """
        pass

    @property
    def Manager(
      self
    ) -> IGIS_HierarchyManager: 
        """
        Handle to hierarchy manager.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.Manager
        """
        pass

    @Manager.setter
    def Manager(
      self,
      _value: IGIS_HierarchyManager
    ) -> None: 
        """
        Handle to hierarchy manager.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.Manager
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Group name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.Name
        """
        pass

    @property
    def ParentGroup(
      self
    ) -> IGIS_HierarchyGroup: 
        """
        Parent group.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.ParentGroup
        """
        pass

    @ParentGroup.setter
    def ParentGroup(
      self,
      _value: IGIS_HierarchyGroup
    ) -> None: 
        """
        Parent group.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyGroup.ParentGroup
        """
        pass

class TGIS_HierarchyManager( TObject, IGIS_HierarchyManager ):
    """
    Hierarchy manager class.
    
    The hierarchy data contain a hierarchy list and additional hierarchy groups that 
    are saved in a project file under [TatukGIS Hierarchy] and [TatukGIS GroupN] sections.
    
    The hierarchy list section has a format like:

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager
    """

    @overload
    def __init__(
      self,
      _viewer: IGIS_Viewer
    ) -> None: 
        """
        Constructor.

        Args:
            _viewer: viewer handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.Create_IGIS_Viewer
        """
        pass

    def AddGroup(
      self,
      _group: IGIS_HierarchyGroup
    ) -> None: 
        """
        Add existing group to another group.

        Args:
            _group: group handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.AddGroup_IGIS_HierarchyGroup
        """
        pass

    def AddLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Add a layer to groups.

        Args:
            _layer: layer handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.AddLayer_TGIS_LayerAbstract
        """
        pass

    def AddOtherLayers(
      self
    ) -> None: 
        """
        Add layers from the viewer (not used in the hierarchy list) to the hierarchy.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.AddOtherLayers_void
        """
        pass

    def ClearGroups(
      self
    ) -> None: 
        """
        Delete all groups.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.ClearGroups_void
        """
        pass

    def CreateGroup(
      self,
      _name: str
    ) -> IGIS_HierarchyGroup: 
        """
        Create a group.

        Args:
            _name: group name

        Returns:
            group

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.CreateGroup_String
        """
        pass

    def DeleteGroup(
      self,
      _name: str
    ) -> None: 
        """
        Delete group with sub groups.

        Args:
            _name: group name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.DeleteGroup_String
        """
        pass

    def DeleteLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Delete layer from groups.

        Args:
            _layer: layer handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.DeleteLayer_TGIS_LayerAbstract
        """
        pass

    def GetGroups(
      self
    ) -> str: 
        """
        Get aliases list.

        Returns:
            groups text

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.GetGroups_void
        """
        pass

    def GetHierarchy(
      self,
      _format: TGIS_ConfigFormat
    ) -> str: 
        """
        Get hierarchy list.

        Args:
            _format: config format

        Returns:
            hierarchy text

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.GetHierarchy_TGIS_ConfigFormat
        """
        pass

    def InsertGroup(
      self,
      _group: IGIS_HierarchyGroup,
      _index: int
    ) -> None: 
        """
        Add existing group to another group at indexed position.

        Args:
            _group: group handle
            _index: insert position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.InsertGroup_IGIS_HierarchyGroup_Integer
        """
        pass

    def InsertLayer(
      self,
      _layer: TGIS_LayerAbstract,
      _index: int
    ) -> None: 
        """
        Add a layer to groups.

        Args:
            _layer: layer handle
            _index: insert index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.InsertLayer_TGIS_LayerAbstract_Integer
        """
        pass

    def LoadHierarchy(
      self,
      _config: TGIS_ConfigAbstract
    ) -> None: 
        """
        Load hierarchy from config.

        Args:
            _config: config handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.LoadHierarchy_TGIS_ConfigAbstract
        """
        pass

    def MoveGroup(
      self,
      _source: str,
      _target: str
    ) -> None: 
        """
        Move group to another group.

        Args:
            _source: source group name
            _target: target group name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.MoveGroup_String_String
        """
        pass

    def MoveGroupEx(
      self,
      _source: str,
      _target: str,
      _index: int
    ) -> None: 
        """
        Move group to another group.

        Args:
            _source: source group name
            _target: target group name
            _index: insert position; if -1 then will be added as last

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.MoveGroupEx_String_String_Integer
        """
        pass

    def MoveLayer(
      self,
      _from: str,
      _to: str,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Move a layer from a group to another.

        Args:
            _from: source group name
            _to: destination group name
            _layer: layer handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.MoveLayer_String_String_TGIS_LayerAbstract
        """
        pass

    @overload
    def ParseHierarchy(
      self,
      _hierarchy: str
    ) -> None: 
        """
        Parse hierarchy list and build groups with layers.

        Args:
            _hierarchy: string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.ParseHierarchy_String
        """
        pass

    @overload
    def ParseHierarchy(
      self,
      _hierarchy: TGIS_StringList,
      _format: TGIS_ConfigFormat
    ) -> None: 
        """
        Parse hierarchy list and build groups with layers.

        Args:
            _hierarchy: string list
            _format: hierarchy format

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.ParseHierarchy_TStrings_TGIS_ConfigFormat
        """
        pass

    
    def Groups(
      self,
      _indexOrName: OleVariant
    ) -> IGIS_HierarchyGroup: 
        """
        Get group by name.

        Args:
            _indexOrName: group index or name

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.Groups
        """
        pass

    @property
    def GroupsCount(
      self
    ) -> int: 
        """
        Groups count.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.GroupsCount
        """
        pass

    @property
    def IsModified(
      self
    ) -> bool: 
        """
        Is hierarchy modified.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.IsModified
        """
        pass

    @IsModified.setter
    def IsModified(
      self,
      _value: bool
    ) -> None: 
        """
        Is hierarchy modified.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HierarchyManager.IsModified
        """
        pass

class TGIS_Hillshade( TObject ):
    """
    Hillshade generator for digital terrain models.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.Create_void
        """
        pass

    @overload
    def Generate(
      self,
      _dem: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _hillshade: TGIS_LayerPixel,
      _zfactor: float,
      _azimuth: float,
      _altitude: float
    ) -> None: 
        """
        Generates hillshade based on a terrain model.

        Args:
            _dem: terrain model as a grid layer; if the layer has no CS then it is assumed that 
              the extent is expressed in meters
            _extent: extent to be processed
            _hillshade: output hillshade as a grid layer; this layer must have the same extent, 
              CS, and resolution as _dem
            _zfactor: factor used to amplify or weaken the hillshade effect
            _azimuth: direction of the light source in degrees
            _altitude: angular altitude of the light source in degrees

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.Generate_TGIS_LayerPixel_TGIS_Extent_TGIS_LayerPixel_Double_Double_Double
        """
        pass

    @overload
    def Generate(
      self
    ) -> None: 
        """
        Generates hillshade based on a terrain model.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.Generate_void
        """
        pass

    @property
    def Altitude(
      self
    ) -> float: 
        """
        Angular altitude of the light source in degrees; default value is 45 degrees.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.Altitude
        """
        pass

    @Altitude.setter
    def Altitude(
      self,
      _value: float
    ) -> None: 
        """
        Angular altitude of the light source in degrees; default value is 45 degrees.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.Altitude
        """
        pass

    @property
    def Azimuth(
      self
    ) -> float: 
        """
        Direction of the light source in degrees; default value is 315 degrees (northwest).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.Azimuth
        """
        pass

    @Azimuth.setter
    def Azimuth(
      self,
      _value: float
    ) -> None: 
        """
        Direction of the light source in degrees; default value is 315 degrees (northwest).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.Azimuth
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Extent: 
        """
        Extent to be processed (in source layer units).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.Extent
        """
        pass

    @Extent.setter
    def Extent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Extent to be processed (in source layer units).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.Extent
        """
        pass

    @property
    def OutputLayer(
      self
    ) -> TGIS_LayerPixel: 
        """
        Output hillshade as a grid layer; this layer must have the same extent, CS, and resolution 
        as the source layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.OutputLayer
        """
        pass

    @OutputLayer.setter
    def OutputLayer(
      self,
      _value: TGIS_LayerPixel
    ) -> None: 
        """
        Output hillshade as a grid layer; this layer must have the same extent, CS, and resolution 
        as the source layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.OutputLayer
        """
        pass

    @property
    def SourceLayer(
      self
    ) -> TGIS_LayerPixel: 
        """
        Terrain model as a grid layer; if the layer has no CS then it is assumed that the 
        extent is expressed in meters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.SourceLayer
        """
        pass

    @SourceLayer.setter
    def SourceLayer(
      self,
      _value: TGIS_LayerPixel
    ) -> None: 
        """
        Terrain model as a grid layer; if the layer has no CS then it is assumed that the 
        extent is expressed in meters.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.SourceLayer
        """
        pass

    @property
    def ZFactor(
      self
    ) -> float: 
        """
        Factor used to amplify (value &gt; 1) or weaken (0 &lt; value &lt; 1) the hillshade 
        effect; default value is 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.ZFactor
        """
        pass

    @ZFactor.setter
    def ZFactor(
      self,
      _value: float
    ) -> None: 
        """
        Factor used to amplify (value &gt; 1) or weaken (0 &lt; value &lt; 1) the hillshade 
        effect; default value is 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.ZFactor
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hillshade.BusyEvent
        """
        pass

class TGIS_HtmlLabel( TObject ):
    """
    Formatted HTML label.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HtmlLabel
    """

    @overload
    def __init__(
      self,
      _renderer: TGIS_RendererAbstract,
      _text: str,
      _align: TGIS_LabelAlignment,
      _width: int,
      _height: int
    ) -> None: 
        """
        Create an instance of an object.

        Args:
            _renderer: canvas object on which label should be drawn
            _text: HTML text of the label
            _align: label alignment
            _width: maximum label width
            _height: maximum label height

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HtmlLabel.Create_TGIS_RendererAbstract_String_TGIS_LabelAlignment_Integer_Integer
        """
        pass

    def Draw(
      self,
      _rect: TRect,
      _angle: float,
      _origin: TPoint,
      _shadow_width: int,
      _shadow_color: TGIS_Color
    ) -> None: 
        """
        Perform label drawing.

        Args:
            _rect: bounding rectangle of the label
            _angle: rotation angle in radians
            _origin: origin point
            _shadow_width: shadow width
            _shadow_color: shadow color

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HtmlLabel.Draw_TRect_Double_TPoint_Integer_TGIS_Color
        """
        pass

    @property
    def BoundingBox(
      self
    ) -> TRect: 
        """
        Box within which text could be placed. Will never be bigger then then box with width 
        and hight provided in a constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HtmlLabel.BoundingBox
        """
        pass

class TGIS_HydrologyStreamOrderMethod:
    pass

class TGIS_HydrologyStreamOrderMethod:
    """
    Specifies stream ordering methods.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HydrologyStreamOrderMethod
    """

    @property
    def Hack(
      self
    ) -> TGIS_HydrologyStreamOrderMethod: 
        """
        It is a classic stream order with a bottom-up hierarchy that allocates the first 
        order to the river with its mouth at the sea or DEM border (the main stem). Its tributaries 
        are given a number one greater than that of the river or stream into which they discharge.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HydrologyStreamOrderMethod.Hack
        """
        pass

    @property
    def Shreve(
      self
    ) -> TGIS_HydrologyStreamOrderMethod: 
        """
        This ordering method gives the outermost tributaries the first order and at a confluence 
        the two orders are added together.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HydrologyStreamOrderMethod.Shreve
        """
        pass

    @property
    def Strahler(
      self
    ) -> TGIS_HydrologyStreamOrderMethod: 
        """
        It is a top-down method where rivers of the first order are the outermost tributaries. 
        If two streams of the same order merge, the resulting stream is given a number that 
        is one higher. If two rivers with different stream orders merge, the resulting stream 
        is given the higher of the two numbers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HydrologyStreamOrderMethod.Strahler
        """
        pass

    @property
    def Topological(
      self
    ) -> TGIS_HydrologyStreamOrderMethod: 
        """
        This bottom-up method of ordering calculates the topological distance of every stream 
        from the outlet.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HydrologyStreamOrderMethod.Topological
        """
        pass

class TGIS_Hydrology( TObject ):
    """
    A class containing the most commonly used hydrological tools.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hydrology
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance of a TGIS_Hydrology class.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hydrology.Create_void
        """
        pass

    def Basin(
      self,
      _flowDir: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _basins: TGIS_LayerPixel,
      _threshold: int
    ) -> None: 
        """
        Generates a basin grid from a flow direction grid.

        Args:
            _flowDir: an input flow direction grid
            _extent: an extent to be processed
            _basins: the output grid layer
            _threshold: use this property to limit basins with a small number of cells; default 
              parameter is 0

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hydrology.Basin_TGIS_LayerPixel_TGIS_Extent_TGIS_LayerPixel_Integer
        """
        pass

    def Fill(
      self,
      _dem: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _hydroDem: TGIS_LayerPixel,
      _applySlope: bool
    ) -> None: 
        """
        Generates the hydrologically conditioned DEM.

        Args:
            _dem: an input DEM
            _extent: an extent to be processed
            _hydroDem: the output grid layer
            _applySlope: if True, algorithm applies a slight slope to ensure the drainage of 
              water for each cell; if False, sinks are flooded and form flat areas; default parameter 
              is True

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hydrology.Fill_TGIS_LayerPixel_TGIS_Extent_TGIS_LayerPixel_Boolean
        """
        pass

    def FlowAccumulation(
      self,
      _flowDir: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _flowAcc: TGIS_LayerPixel
    ) -> None: 
        """
        Generates a flow accumulation grid from a flow direction grid.

        Args:
            _flowDir: an input flow direction grid
            _extent: an extent to be processed
            _flowAcc: the output grid layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hydrology.FlowAccumulation_TGIS_LayerPixel_TGIS_Extent_TGIS_LayerPixel
        """
        pass

    def FlowDirection(
      self,
      _dem: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _flowDir: TGIS_LayerPixel,
      _resolveFlat: bool
    ) -> None: 
        """
        Generates a flow direction grid from a DEM.

        Args:
            _dem: an input DEM
            _extent: an extent to be processed
            _flowDir: the output grid layer
            _resolveFlat: if True, the ResolveFlat tool is performed for remaining cells within 
              flat areas, where the dominant direction can not be determined; if False, above mentioned 
              cells have encoded the direction by summing direction codes of neighbors with the 
              drop value equals 0; default parameter is False

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hydrology.FlowDirection_TGIS_LayerPixel_TGIS_Extent_TGIS_LayerPixel_Boolean
        """
        pass

    def ResolveFlat(
      self,
      _dem: TGIS_LayerPixel,
      _flowDir: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _alteredDem: TGIS_LayerPixel
    ) -> None: 
        """
        Resolves flat areas in a DEM.

        Args:
            _dem: an input DEM
            _flowDir: a flow direction grid
            _extent: an extent to be processed
            _alteredDem: the optional output grid layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hydrology.ResolveFlat_TGIS_LayerPixel_TGIS_LayerPixel_TGIS_Extent_TGIS_LayerPixel
        """
        pass

    def Sink(
      self,
      _dem: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _sinks: TGIS_LayerPixel
    ) -> None: 
        """
        Generates the grid with pit cells and cells for which the flow direction can not 
        be determined.

        Args:
            _dem: an input DEM
            _extent: an extent to be processed
            _sinks: the output grid layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hydrology.Sink_TGIS_LayerPixel_TGIS_Extent_TGIS_LayerPixel
        """
        pass

    def StreamOrder(
      self,
      _flowDir: TGIS_LayerPixel,
      _flowAcc: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _streams: TGIS_LayerPixel,
      _method: TGIS_HydrologyStreamOrderMethod,
      _threshold: int
    ) -> None: 
        """
        Generates a stream order grid from a flow direction and flow accumulation grids and 
        a specified method.

        Args:
            _flowDir: an input flow direction grid
            _flowAcc: an input flow accumulation grid
            _extent: an extent to be processed
            _streams: the output grid layer
            _method: stream ordering method; default parameter is Strahler
            _threshold: use this property to limit processed cells from the flow accumulation 
              grid; default parameter is -1, which means the recommended value for this tool is 
              automatically assigned

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hydrology.StreamOrder_TGIS_LayerPixel_TGIS_LayerPixel_TGIS_Extent_TGIS_LayerPixel_TGIS_HydrologyStreamOrderMethod_Integer
        """
        pass

    def StreamToPolyline(
      self,
      _flowDir: TGIS_LayerPixel,
      _streamsPix: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _streamsVec: TGIS_LayerVector,
      _orderField: str,
      _threshold: int
    ) -> None: 
        """
        Converts a stream network to polylines.

        Args:
            _flowDir: an input flow direction grid
            _streamsPix: an input grid representing a stream network
            _extent: an extent to be processed
            _streamsVec: the output vector layer
            _orderField: an optional numerical field from _streamsVec to populate stream network 
              value (flow accumulation, or stream order value from grid); default parameter is 
              empty string, this means that no attribute information is transferred to vector layer
            _threshold: use this property to limit processed cells from stream network; default 
              parameter is 0

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hydrology.StreamToPolyline_TGIS_LayerPixel_TGIS_LayerPixel_TGIS_Extent_TGIS_LayerVector_String_Integer
        """
        pass

    @overload
    def Watershed(
      self,
      _flowDir: TGIS_LayerPixel,
      _outlets: TGIS_LayerVector,
      _field: str,
      _extent: TGIS_Extent,
      _watershed: TGIS_LayerPixel
    ) -> None: 
        """
        Generates a watershed grid from a flow direction grid and vector layer with pour 
        points.

        Args:
            _flowDir: an input flow direction grid
            _outlets: an input vector layer with pour points
            _field: a numerical field from _outlets to use in ordering watersheds; if empty GIS_UID 
              is used
            _extent: an extent to be processed
            _watershed: the output grid layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hydrology.Watershed_TGIS_LayerPixel_TGIS_LayerVector_String_TGIS_Extent_TGIS_LayerPixel
        """
        pass

    @overload
    def Watershed(
      self,
      _flowDir: TGIS_LayerPixel,
      _outlets: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _watershed: TGIS_LayerPixel
    ) -> None: 
        """
        Generates a watershed grid from a flow direction grid and grid layer with pour points.

        Args:
            _flowDir: an input flow direction grid
            _outlets: an input vector layer with pour points;
            _extent: an extent to be processed
            _watershed: the output grid layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hydrology.Watershed_TGIS_LayerPixel_TGIS_LayerPixel_TGIS_Extent_TGIS_LayerPixel
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hydrology.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Hydrology.BusyEvent
        """
        pass

class TGIS_ImportProject:
    """
    Class for importing MapView &amp; MapInfo projects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ImportProject
    """

    @overload
    def __init__(
      self,
      _viewer: TGIS_Viewer
    ) -> None: 
        """
        Construct an instance based on provided viewer object.

        Args:
            _viewer: viewer which will be associated with this object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ImportProject.Create_TGIS_Viewer
        """
        pass

    def Import(
      self,
      _path: str
    ) -> None: 
        """
        Import project from ArcView 3.x and MapInfo 6.x projects.

        Args:
            _path: project file to be opened

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ImportProject.Import_String
        """
        pass

    def IsSupported(
      self,
      _path: str
    ) -> bool: 
        """
        Checks if the provided file is supported by TGIS_ImportProject class.

        Args:
            _path: path to the file

        Returns:
            True if supported

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ImportProject.IsSupported_String
        """
        pass

    @property
    def TemporaryDir(
      self
    ) -> str: 
        """
        Temporary directory used to import a project. If not empty, should be deleted upon 
        closing a viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ImportProject.TemporaryDir
        """
        pass

class TGIS_IniFile( TCustomIniFile ):
    """
    Encapsulation of configuration file reader.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IniFile
    """

    @overload
    def __init__(
      self,
      _fileName: str
    ) -> None: 
        """
        Create an instance on provided file.

        Args:
            _fileName: file name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IniFile.Create_String
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IniFile.Clear_void
        """
        pass

    def GetStrings(
      self,
      _list: TGIS_Strings
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IniFile.GetStrings_TGIS_Strings
        """
        pass

    def SetStrings(
      self,
      _list: TGIS_Strings
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IniFile.SetStrings_TGIS_Strings
        """
        pass

    def TestSection(
      self,
      _section: str
    ) -> bool: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IniFile.TestSection_String
        """
        pass

class IGIS_Subscribe:
    """
    Subscriber mechanism interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Subscribe
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Subscribe.Create_void
        """
        pass

    def SubscribedEvent(
      self,
      _sender: TObject,
      _event: int,
      _context: TObject
    ) -> None: 
        """
        Subscriber notification event.

        Args:
            _sender: sender object
            _event: event identifier
            _context: context object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Subscribe.SubscribedEvent_TObject_Integer_TObject
        """
        pass

class IGIS_Editor:
    """
    Common API for shape visual editor.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.Create_void
        """
        pass

    def AddPoint(
      self,
      _ptg: TGIS_Point3D
    ) -> None: 
        """
        Add a new point.

        Args:
            _ptg: point to be added; expected Viewer coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.AddPoint_TGIS_Point3D
        """
        pass

    def AddPointEx(
      self,
      _ptg: TGIS_Point3D
    ) -> None: 
        """
        Add a new point for a group.

        Args:
            _ptg: point to be added; expected Viewer coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.AddPointEx_TGIS_Point3D
        """
        pass

    def AddSnapLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> int: 
        """
        Add a snap-to layer to the list.

        Args:
            _layer: layer to snap

        Returns:
            index of added layer on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.AddSnapLayer_TGIS_LayerAbstract
        """
        pass

    def ChangeWinding(
      self
    ) -> None: 
        """
        Change winding of the current part. Valid and important only for polygons. Thanks 
        to this, the whole inside polygon can be transparent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.ChangeWinding_void
        """
        pass

    def ClearSnapLayers(
      self
    ) -> None: 
        """
        Clear the list of snap-to layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.ClearSnapLayers_void
        """
        pass

    def CreatePart(
      self,
      _ptg: TGIS_Point3D
    ) -> None: 
        """
        Create and activate the editing procedure for a new part for the current shape.

        Args:
            _ptg: "starting" point of a new part to be created; expected Viewer coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.CreatePart_TGIS_Point3D
        """
        pass

    @overload
    def CreateShape(
      self,
      _layer: TGIS_LayerAbstract,
      _ptg: TGIS_Point,
      _type: TGIS_ShapeType
    ) -> None: 
        """
        Create and activate editing of a new shape.

        Args:
            _layer: TGIS_Layer which will own new shape
            _ptg: "starting" of a new shape to be created; expected Viewer coordinate system
            _type: type of shape to be created; it must be type supported by layer; if TGIS_ShapeType.Unknown 
              then shape of default type will be created

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.CreateShape_TGIS_LayerAbstract_TGIS_Point_TGIS_ShapeType
        """
        pass

    @overload
    def CreateShape(
      self,
      _layer: TGIS_LayerAbstract,
      _ptg: TGIS_Point3D,
      _type: TGIS_ShapeType
    ) -> None: 
        """
        Create and activate editing of a new shape.

        Args:
            _layer: TGIS_Layer which will own new shape
            _ptg: "starting" 3D of a new shape to be created; expected Viewer coordinate system
            _type: type of shape to be created; it must be type supported by layer; if TGIS_DimensionType.Unknown 
              then shape of default type will be created

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.CreateShape_TGIS_LayerAbstract_TGIS_Point3D_TGIS_ShapeType
        """
        pass

    @overload
    def CreateShape(
      self,
      _layer: TGIS_LayerAbstract,
      _ptg: TGIS_Point3D,
      _type: TGIS_ShapeType,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create and activate editing of a new shape.

        Args:
            _layer: TGIS_Layer which will own new shape
            _ptg: "starting" 3D of a new shape to be created; expected Viewer coordinate system
            _type: type of shape to be created; it must be type supported by layer; if TGIS_ShapeType.Unknown 
              then shape of default type will be created
            _dim: dimension of shape to be created; it must be type supported by layer; if TGIS_ShapeType.Unknown 
              then shape of default dimension will be created

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.CreateShape_TGIS_LayerAbstract_TGIS_Point3D_TGIS_ShapeType_TGIS_DimensionType
        """
        pass

    def DeletePart(
      self
    ) -> None: 
        """
        Delete current part from shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.DeletePart_void
        """
        pass

    def DeletePoint(
      self,
      _pos: int
    ) -> None: 
        """
        Delete a point from the current part of the currently edited shape.

        Args:
            _pos: the point which will be deleted; points are counted from 1;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.DeletePoint_Integer
        """
        pass

    def DeletePointEx(
      self,
      _pos: int
    ) -> None: 
        """
        Delete a point from the current part of the currently edited shape.

        Args:
            _pos: the point which will be deleted; points are counted from 0;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.DeletePointEx_Integer
        """
        pass

    def DeleteShape(
      self
    ) -> None: 
        """
        Delete currently edited shape and end editing.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.DeleteShape_void
        """
        pass

    def EditShape(
      self,
      _shp: TGIS_ShapeAbstract,
      _part: int
    ) -> None: 
        """
        Starts editing of a shape given by _shp. Only the part given by _part will be in 
        edit mode.

        Args:
            _shp: shape to be edited
            _part: part in _shape to be edited

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.EditShape_TGIS_ShapeAbstract_Integer
        """
        pass

    def EndEdit(
      self
    ) -> None: 
        """
        End editing of the shape given by EditShape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.EndEdit_void
        """
        pass

    def FindSnapLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> bool: 
        """
        Find a snap layer on the list.

        Args:
            _layer: layer to snap

        Returns:
            True if layer is on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.FindSnapLayer_TGIS_LayerAbstract
        """
        pass

    def FindSnapPoint(
      self,
      _pt: TPoint,
      _ptg: VarParameter,
      _snapType: VarParameter
    ) -> bool: 
        """
        Find a snap point based on a snap type from snap-to layers.

        Args:
            _pt: Mouse position
            _ptg: found snap point coordinates; the value (in/out) is passed as TGIS_Point in 
              _ptg.Value property
            _snapType: found type of snap point (vertex, edge, intersection, midpoint ); the 
              value (in/out) is passed as TGIS_EditorSnapResultType in _snapType.Value property

        Returns:
            True if any snap point was found

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.FindSnapPoint_TPoint_TGIS_Point_TGIS_EditorSnapResultType
        """
        pass

    def InsertPoint(
      self,
      _pos: int,
      _ptg: TGIS_Point3D
    ) -> None: 
        """
        Insert a point to the current part of the currently edited shape.

        Args:
            _pos: where point must be inserted; points are counted from 0
            _ptg: point to be inserted; expected Viewer coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.InsertPoint_Integer_TGIS_Point3D
        """
        pass

    def InsertPointEx(
      self,
      _pos: int,
      _ptg: TGIS_Point3D
    ) -> None: 
        """
        Insert a point to the current part of the currently edited shape for a group.

        Args:
            _pos: where point must be inserted; points are counted from 0
            _ptg: point to be inserted; expected Viewer coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.InsertPointEx_Integer_TGIS_Point3D
        """
        pass

    def MouseBegin(
      self,
      _pt: TPoint,
      _nearest: bool
    ) -> None: 
        """
        Start the editing of a point at the location given by _pt.

        Args:
            _pt: start point defined in screen coordinates
            _nearest: if true, then nearest insertion point will be chosen; could be overwritten 
              by Mode property.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.MouseBegin_TPoint_Boolean
        """
        pass

    def MouseEnd(
      self,
      _pt: TPoint
    ) -> None: 
        """
        End of point movement, deletion, or addition.

        Args:
            _pt: new location of point /in screen coordinates/

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.MouseEnd_TPoint
        """
        pass

    def MouseMove(
      self,
      _pt: TPoint
    ) -> None: 
        """
        Continuing of point movement, deletion, or addition.

        Args:
            _pt: new location of point /in screen coordinates/

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.MouseMove_TPoint
        """
        pass

    def MovePoint(
      self,
      _pos: int,
      _ptg: TGIS_Point3D
    ) -> None: 
        """
        Move a point of the current part of the currently edited shape to a new location.

        Args:
            _pos: which point will be moved; points are counted from 1
            _ptg: new location; expected Viewer coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.MovePoint_Integer_TGIS_Point3D
        """
        pass

    def MovePointEx(
      self,
      _pos: int,
      _ptg: TGIS_Point3D
    ) -> None: 
        """
        Move a point of the current part of the currently edited shape to a new location.

        Args:
            _pos: which point will be moved; points are counted from 0
            _ptg: new location; expected Viewer coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.MovePointEx_Integer_TGIS_Point3D
        """
        pass

    def Redo(
      self
    ) -> None: 
        """
        Redo the previous action. This applies only to changes performed on a single part.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.Redo_void
        """
        pass

    def RefreshShape(
      self
    ) -> None: 
        """
        Store the editing buffer back into the shape. Perform screen redraw.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.RefreshShape_void
        """
        pass

    def RemoveSnapLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Remove a snap layer from the list.

        Args:
            _layer: layer to snap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.RemoveSnapLayer_TGIS_LayerAbstract
        """
        pass

    def RevertShape(
      self
    ) -> None: 
        """
        Revert currently edited shape to a saved version.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.RevertShape_void
        """
        pass

    def Undo(
      self
    ) -> None: 
        """
        Undo the last action. This applies only to changes performed on a single part.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.Undo_void
        """
        pass

    @property
    def BlockSnapping(
      self
    ) -> bool: 
        """
        If True, block snapping operations during adding points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.BlockSnapping
        """
        pass

    @BlockSnapping.setter
    def BlockSnapping(
      self,
      _value: bool
    ) -> None: 
        """
        If True, block snapping operations during adding points.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.BlockSnapping
        """
        pass

    @property
    def CanRedo(
      self
    ) -> bool: 
        """
        If True, redo buffer is not empty.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.CanRedo
        """
        pass

    @property
    def CanUndo(
      self
    ) -> bool: 
        """
        If True, undo buffer is not empty.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.CanUndo
        """
        pass

    @property
    def CurrentShape(
      self
    ) -> TGIS_ShapeAbstract: 
        """
        Currently edited shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.CurrentShape
        """
        pass

    @property
    def EditingEdgeLengthsStyle(
      self
    ) -> TGIS_EditorEdgeLengthsStyle: 
        """
        Edges lengths style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.EditingEdgeLengthsStyle
        """
        pass

    @EditingEdgeLengthsStyle.setter
    def EditingEdgeLengthsStyle(
      self,
      _value: TGIS_EditorEdgeLengthsStyle
    ) -> None: 
        """
        Edges lengths style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.EditingEdgeLengthsStyle
        """
        pass

    @property
    def EditingLinesStyle(
      self
    ) -> TGIS_EditorStyle: 
        """
        Editing lines style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.EditingLinesStyle
        """
        pass

    @EditingLinesStyle.setter
    def EditingLinesStyle(
      self,
      _value: TGIS_EditorStyle
    ) -> None: 
        """
        Editing lines style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.EditingLinesStyle
        """
        pass

    @property
    def EditingPointsStyle(
      self
    ) -> TGIS_EditorEditingPointsStyle: 
        """
        Editing points style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.EditingPointsStyle
        """
        pass

    @EditingPointsStyle.setter
    def EditingPointsStyle(
      self,
      _value: TGIS_EditorEditingPointsStyle
    ) -> None: 
        """
        Editing points style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.EditingPointsStyle
        """
        pass

    @property
    def EditorMode(
      self
    ) -> TGIS_EditorModeEx: 
        """
        Determines how new vertices are created relative to existing vertices.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.EditorMode
        """
        pass

    @EditorMode.setter
    def EditorMode(
      self,
      _value: TGIS_EditorModeEx
    ) -> None: 
        """
        Determines how new vertices are created relative to existing vertices.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.EditorMode
        """
        pass

    @property
    def InEdit(
      self
    ) -> bool: 
        """
        If True, editing is active.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.InEdit
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_LayerAbstract: 
        """
        Layer that holds the shape being currently edited.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.Layer
        """
        pass

    @property
    def MinMove(
      self
    ) -> int: 
        """
        Minimal mouse movement to perform a change.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.MinMove
        """
        pass

    @MinMove.setter
    def MinMove(
      self,
      _value: int
    ) -> None: 
        """
        Minimal mouse movement to perform a change.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.MinMove
        """
        pass

    @property
    def Mode(
      self
    ) -> TGIS_EditorMode: 
        """
        Mode of edition. Will control how _nearest parameter of the MouseBegin() behaves 
        and therefore will control editing behavior in TGIS_ViewerWnd.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.Mode
        """
        pass

    @Mode.setter
    def Mode(
      self,
      _value: TGIS_EditorMode
    ) -> None: 
        """
        Mode of edition. Will control how _nearest parameter of the MouseBegin() behaves 
        and therefore will control editing behavior in TGIS_ViewerWnd.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.Mode
        """
        pass

    @property
    def MustRedraw(
      self
    ) -> bool: 
        """
        True if editor should be redraw. State should be canceled after successful rendering.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.MustRedraw
        """
        pass

    @MustRedraw.setter
    def MustRedraw(
      self,
      _value: bool
    ) -> None: 
        """
        True if editor should be redraw. State should be canceled after successful rendering.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.MustRedraw
        """
        pass

    @property
    def Part(
      self
    ) -> int: 
        """
        Part number of currently edited shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.Part
        """
        pass

    
    def Point(
      self,
      _pos: int
    ) -> TGIS_Point3D: 
        """
        Access to individual points in a part.

        Args:
            _pos: index of individual point on a shape; points are counted from 0 to PointCount.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.Point
        """
        pass

    
    def Point(
      self,
      _pos: int,
      _value: TGIS_Point3D
    ) -> None: 
        """
        Access to individual points in a part.

        Args:
            _pos: index of individual point on a shape; points are counted from 0 to PointCount.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.Point
        """
        pass

    @property
    def PointCount(
      self
    ) -> int: 
        """
        Number of points in the current part of the currently edited shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.PointCount
        """
        pass

    @property
    def PointerMode(
      self
    ) -> TGIS_PointerMode: 
        """
        Pointer mode ( mouse, touch or pen ).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.PointerMode
        """
        pass

    @PointerMode.setter
    def PointerMode(
      self,
      _value: TGIS_PointerMode
    ) -> None: 
        """
        Pointer mode ( mouse, touch or pen ).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.PointerMode
        """
        pass

    @property
    def PointPos(
      self
    ) -> int: 
        """
        Position of the currently edited point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.PointPos
        """
        pass

    @PointPos.setter
    def PointPos(
      self,
      _value: int
    ) -> None: 
        """
        Position of the currently edited point.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.PointPos
        """
        pass

    @property
    def SelectTolerance(
      self
    ) -> int: 
        """
        Distance tolerance of vertices selection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.SelectTolerance
        """
        pass

    @SelectTolerance.setter
    def SelectTolerance(
      self,
      _value: int
    ) -> None: 
        """
        Distance tolerance of vertices selection.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.SelectTolerance
        """
        pass

    @property
    def SelectTolerancePen(
      self
    ) -> int: 
        """
        Distance tolerance of vertices selection upon pen gesture.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.SelectTolerancePen
        """
        pass

    @SelectTolerancePen.setter
    def SelectTolerancePen(
      self,
      _value: int
    ) -> None: 
        """
        Distance tolerance of vertices selection upon pen gesture.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.SelectTolerancePen
        """
        pass

    @property
    def SelectToleranceTouch(
      self
    ) -> int: 
        """
        Distance tolerance of vertices selection upon touch gesture.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.SelectToleranceTouch
        """
        pass

    @SelectToleranceTouch.setter
    def SelectToleranceTouch(
      self,
      _value: int
    ) -> None: 
        """
        Distance tolerance of vertices selection upon touch gesture.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.SelectToleranceTouch
        """
        pass

    @property
    def ShowDraggingTrack(
      self
    ) -> bool: 
        """
        If True, show dragging track when moving a vertex to a new position.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.ShowDraggingTrack
        """
        pass

    @ShowDraggingTrack.setter
    def ShowDraggingTrack(
      self,
      _value: bool
    ) -> None: 
        """
        If True, show dragging track when moving a vertex to a new position.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.ShowDraggingTrack
        """
        pass

    @property
    def ShowEdgesLengths(
      self
    ) -> bool: 
        """
        If True, show edges lengths from vertex to vertex.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.ShowEdgesLengths
        """
        pass

    @ShowEdgesLengths.setter
    def ShowEdgesLengths(
      self,
      _value: bool
    ) -> None: 
        """
        If True, show edges lengths from vertex to vertex.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.ShowEdgesLengths
        """
        pass

    @property
    def ShowPoints3D(
      self
    ) -> bool: 
        """
        If True, show the Z coordinates for the vertices.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.ShowPoints3D
        """
        pass

    @ShowPoints3D.setter
    def ShowPoints3D(
      self,
      _value: bool
    ) -> None: 
        """
        If True, show the Z coordinates for the vertices.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.ShowPoints3D
        """
        pass

    @property
    def ShowPointsNumbers(
      self
    ) -> bool: 
        """
        If True, show the vertex numbers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.ShowPointsNumbers
        """
        pass

    @ShowPointsNumbers.setter
    def ShowPointsNumbers(
      self,
      _value: bool
    ) -> None: 
        """
        If True, show the vertex numbers.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.ShowPointsNumbers
        """
        pass

    @property
    def ShowTracking(
      self
    ) -> bool: 
        """
        If True, show vertices to trace from a shape in the snap-to layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.ShowTracking
        """
        pass

    @ShowTracking.setter
    def ShowTracking(
      self,
      _value: bool
    ) -> None: 
        """
        If True, show vertices to trace from a shape in the snap-to layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.ShowTracking
        """
        pass

    @property
    def SnapGridSpacing(
      self
    ) -> float: 
        """
        The spacing of the grid to which points will be snapped.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.SnapGridSpacing
        """
        pass

    @SnapGridSpacing.setter
    def SnapGridSpacing(
      self,
      _value: float
    ) -> None: 
        """
        The spacing of the grid to which points will be snapped.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.SnapGridSpacing
        """
        pass

    @property
    def SnapLayer(
      self
    ) -> TGIS_LayerAbstract: 
        """
        Layer containing geometry to which edited points will be snapped. After editing start 
        /see: EditShape/ will always be the same as the edited shape layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.SnapLayer
        """
        pass

    @SnapLayer.setter
    def SnapLayer(
      self,
      _value: TGIS_LayerAbstract
    ) -> None: 
        """
        Layer containing geometry to which edited points will be snapped. After editing start 
        /see: EditShape/ will always be the same as the edited shape layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.SnapLayer
        """
        pass

    @property
    def SnapMargin(
      self
    ) -> int: 
        """
        The distance tolerance from the snap-to feature for a snap to occur.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.SnapMargin
        """
        pass

    @SnapMargin.setter
    def SnapMargin(
      self,
      _value: int
    ) -> None: 
        """
        The distance tolerance from the snap-to feature for a snap to occur.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.SnapMargin
        """
        pass

    @property
    def SnapToIntersection(
      self
    ) -> bool: 
        """
        If True, enable snap to the point of intersections between shapes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.SnapToIntersection
        """
        pass

    @SnapToIntersection.setter
    def SnapToIntersection(
      self,
      _value: bool
    ) -> None: 
        """
        If True, enable snap to the point of intersections between shapes.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.SnapToIntersection
        """
        pass

    @property
    def SnapType(
      self
    ) -> TGIS_EditorSnapType: 
        """
        Snap type - how to snap to a vertex or segment.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.SnapType
        """
        pass

    @SnapType.setter
    def SnapType(
      self,
      _value: TGIS_EditorSnapType
    ) -> None: 
        """
        Snap type - how to snap to a vertex or segment.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.SnapType
        """
        pass

    @property
    def Uid(
      self
    ) -> TGIS_Uid: 
        """
        Uid of currently edited shape or -1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.Uid
        """
        pass

    @property
    def Viewer(
      self
    ) -> TObject: 
        """
        Viewer on which editor has been created.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.Viewer
        """
        pass

    @property
    def ViewerEnabled(
      self
    ) -> bool: 
        """
        Set to true if Editor Mode is enabled in a TGIS_ViewerWnd.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.ViewerEnabled
        """
        pass

    @ViewerEnabled.setter
    def ViewerEnabled(
      self,
      _value: bool
    ) -> None: 
        """
        Set to true if Editor Mode is enabled in a TGIS_ViewerWnd.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Editor.ViewerEnabled
        """
        pass

class IGIS_HierarchyGroup( IInterface ):
    """
    Hierarchy group class.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.Create_void
        """
        pass

    def AddGroup(
      self,
      _group: IGIS_HierarchyGroup
    ) -> None: 
        """
        Add a sub group to the group list.

        Args:
            _group: existing group handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.AddGroup_IGIS_HierarchyGroup
        """
        pass

    def AddLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Add a layer to the group.

        Args:
            _layer: layer handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.AddLayer_TGIS_LayerAbstract
        """
        pass

    def ClearGroups(
      self
    ) -> None: 
        """
        Delete all sub groups.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.ClearGroups_void
        """
        pass

    def CreateGroup(
      self,
      _name: str
    ) -> IGIS_HierarchyGroup: 
        """
        Create a new sub group for this group .

        Args:
            _name: group name (must be unique)

        Returns:
            group

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.CreateGroup_String
        """
        pass

    def DeleteGroup(
      self,
      _name: str
    ) -> None: 
        """
        Delete a group from the group list.

        Args:
            _name: group name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.DeleteGroup_String
        """
        pass

    def DeleteLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Delete a layer from a group.

        Args:
            _layer: layer handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.DeleteLayer_TGIS_LayerAbstract
        """
        pass

    def InsertGroup(
      self,
      _group: IGIS_HierarchyGroup,
      _index: int
    ) -> None: 
        """
        Insert a sub group to the group list at insert index.

        Args:
            _group: existing group handle
            _index: insert index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.InsertGroup_IGIS_HierarchyGroup_Integer
        """
        pass

    def InsertLayer(
      self,
      _layer: TGIS_LayerAbstract,
      _index: int
    ) -> None: 
        """
        Insert a layer to the group as index position.

        Args:
            _layer: layer handle
            _index: insert index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.InsertLayer_TGIS_LayerAbstract_Integer
        """
        pass

    def RemoveGroup(
      self,
      _group: IGIS_HierarchyGroup
    ) -> None: 
        """
        Remove a group from the group list.

        Args:
            _group: existing group handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.RemoveGroup_IGIS_HierarchyGroup
        """
        pass

    @property
    def Active(
      self
    ) -> bool: 
        """
        Is group active.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.Active
        """
        pass

    @Active.setter
    def Active(
      self,
      _value: bool
    ) -> None: 
        """
        Is group active.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.Active
        """
        pass

    @property
    def Caption(
      self
    ) -> str: 
        """
        Group caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.Caption
        """
        pass

    @Caption.setter
    def Caption(
      self,
      _value: str
    ) -> None: 
        """
        Group caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.Caption
        """
        pass

    @property
    def Collapsed(
      self
    ) -> bool: 
        """
        Is group collapsed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.Collapsed
        """
        pass

    @Collapsed.setter
    def Collapsed(
      self,
      _value: bool
    ) -> None: 
        """
        Is group collapsed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.Collapsed
        """
        pass

    
    def Groups(
      self,
      _indexOrName: OleVariant
    ) -> IGIS_HierarchyGroup: 
        """
        Get group by name.

        Args:
            _indexOrName: group index or name

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.Groups
        """
        pass

    @property
    def GroupsCount(
      self
    ) -> int: 
        """
        Groups count.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.GroupsCount
        """
        pass

    @property
    def IsModified(
      self
    ) -> bool: 
        """
        Is group modified.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.IsModified
        """
        pass

    
    def Layers(
      self,
      _index: int
    ) -> TGIS_LayerAbstract: 
        """
        Get layer by index.

        Args:
            _index: group index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.Layers
        """
        pass

    @property
    def LayersCount(
      self
    ) -> int: 
        """
        Layers count.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.LayersCount
        """
        pass

    @property
    def Manager(
      self
    ) -> IGIS_HierarchyManager: 
        """
        Handle to hierarchy manager.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.Manager
        """
        pass

    @Manager.setter
    def Manager(
      self,
      _value: IGIS_HierarchyManager
    ) -> None: 
        """
        Handle to hierarchy manager.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.Manager
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Group name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.Name
        """
        pass

    @property
    def ParentGroup(
      self
    ) -> IGIS_HierarchyGroup: 
        """
        Parent group.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.ParentGroup
        """
        pass

    @ParentGroup.setter
    def ParentGroup(
      self,
      _value: IGIS_HierarchyGroup
    ) -> None: 
        """
        Parent group.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyGroup.ParentGroup
        """
        pass

class IGIS_HierarchyManager( IInterface ):
    """
    Hierarchy manager class.
    
    The hierarchy data contain a hierarchy list and additional hierarchy groups that 
    are saved in a project file under [TatukGIS Hierarchy] and [TatukGIS GroupN] sections.
    
    The hierarchy list section has a format like:

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.Create_void
        """
        pass

    def AddGroup(
      self,
      _group: IGIS_HierarchyGroup
    ) -> None: 
        """
        Add existing group to another group.

        Args:
            _group: group handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.AddGroup_IGIS_HierarchyGroup
        """
        pass

    def AddLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Add a layer to groups.

        Args:
            _layer: layer handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.AddLayer_TGIS_LayerAbstract
        """
        pass

    def AddOtherLayers(
      self
    ) -> None: 
        """
        Add layers from the viewer (not used in the hierarchy list) to the hierarchy.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.AddOtherLayers_void
        """
        pass

    def ClearGroups(
      self
    ) -> None: 
        """
        Delete all groups.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.ClearGroups_void
        """
        pass

    def CreateGroup(
      self,
      _name: str
    ) -> IGIS_HierarchyGroup: 
        """
        Create a group.

        Args:
            _name: group name

        Returns:
            group

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.CreateGroup_String
        """
        pass

    def DeleteGroup(
      self,
      _name: str
    ) -> None: 
        """
        Delete group with sub groups.

        Args:
            _name: group name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.DeleteGroup_String
        """
        pass

    def DeleteLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Delete layer from groups.

        Args:
            _layer: layer handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.DeleteLayer_TGIS_LayerAbstract
        """
        pass

    def GetGroups(
      self
    ) -> str: 
        """
        Get aliases list.

        Returns:
            groups text

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.GetGroups_void
        """
        pass

    def GetHierarchy(
      self,
      _format: TGIS_ConfigFormat
    ) -> str: 
        """
        Get hierarchy list.

        Args:
            _format: config format

        Returns:
            hierarchy text

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.GetHierarchy_TGIS_ConfigFormat
        """
        pass

    def InsertGroup(
      self,
      _group: IGIS_HierarchyGroup,
      _index: int
    ) -> None: 
        """
        Add existing group to another group at indexed position.

        Args:
            _group: group handle
            _index: insert position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.InsertGroup_IGIS_HierarchyGroup_Integer
        """
        pass

    def InsertLayer(
      self,
      _layer: TGIS_LayerAbstract,
      _index: int
    ) -> None: 
        """
        Add a layer to groups.

        Args:
            _layer: layer handle
            _index: insert index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.InsertLayer_TGIS_LayerAbstract_Integer
        """
        pass

    def LoadHierarchy(
      self,
      _config: TGIS_ConfigAbstract
    ) -> None: 
        """
        Load hierarchy from config.

        Args:
            _config: config handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.LoadHierarchy_TGIS_ConfigAbstract
        """
        pass

    def MoveGroup(
      self,
      _source: str,
      _target: str
    ) -> None: 
        """
        Move group to another group.

        Args:
            _source: source group name
            _target: target group name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.MoveGroup_String_String
        """
        pass

    def MoveGroupEx(
      self,
      _source: str,
      _target: str,
      _index: int
    ) -> None: 
        """
        Move group to another group.

        Args:
            _source: source group name
            _target: target group name
            _index: insert position; if -1 then will be added as last

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.MoveGroupEx_String_String_Integer
        """
        pass

    def MoveLayer(
      self,
      _from: str,
      _to: str,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Move a layer from a group to another.

        Args:
            _from: source group name
            _to: destination group name
            _layer: layer handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.MoveLayer_String_String_TGIS_LayerAbstract
        """
        pass

    @overload
    def ParseHierarchy(
      self,
      _hierarchy: str
    ) -> None: 
        """
        Parse hierarchy list and build groups with layers.

        Args:
            _hierarchy: string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.ParseHierarchy_String
        """
        pass

    @overload
    def ParseHierarchy(
      self,
      _hierarchy: TGIS_StringList,
      _format: TGIS_ConfigFormat
    ) -> None: 
        """
        Parse hierarchy list and build groups with layers.

        Args:
            _hierarchy: string list
            _format: hierarchy format

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.ParseHierarchy_TStrings_TGIS_ConfigFormat
        """
        pass

    
    def Groups(
      self,
      _indexOrName: OleVariant
    ) -> IGIS_HierarchyGroup: 
        """
        Get group by name.

        Args:
            _indexOrName: group index or name

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.Groups
        """
        pass

    @property
    def GroupsCount(
      self
    ) -> int: 
        """
        Groups count.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.GroupsCount
        """
        pass

    @property
    def IsModified(
      self
    ) -> bool: 
        """
        Is hierarchy modified.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.IsModified
        """
        pass

    @IsModified.setter
    def IsModified(
      self,
      _value: bool
    ) -> None: 
        """
        Is hierarchy modified.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_HierarchyManager.IsModified
        """
        pass

class IGIS_Viewer( IInterface ):
    """
    Common API for viewer operations. To be shared across platforms.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Create_void
        """
        pass

    def Add(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Add a layer to the Viewer.

        Args:
            _layer: layer to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Add_TGIS_LayerAbstract
        """
        pass

    def AddHierarchy(
      self
    ) -> None: 
        """
        Read hierarchy and build groups with layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.AddHierarchy_void
        """
        pass

    def AttachLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> IGIS_Viewer: 
        """
        Attach layer to the viewer by re-parenting.

        Args:
            _layer: layer to be attached

        Returns:
            Previous parent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.AttachLayer_TGIS_LayerAbstract
        """
        pass

    def BeginPaintInternal(
      self
    ) -> None: 
        """
        Notify viewer about entering of a paint mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.BeginPaintInternal_void
        """
        pass

    def BusyPrepare(
      self,
      _sender: TObject,
      _text: str
    ) -> None: 
        """
        Prepare BusyEvent for long-term operation.

        Args:
            _sender: component which is causing long-term operations
            _text: text to appear in a BusyText property; predefined GIS_BUSY_NOEVENTS and GIS_BUSY_NOHOURGLASS 
              could be used to define "silent" busy state; in such state BusyEvent will not be 
              called and, in a case of GIS_BUSY_NOHOURGLASS, hourglass will not be displayed and 
              check for interrupt as well.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.BusyPrepare_TObject_String
        """
        pass

    def BusyRelease(
      self,
      _sender: TObject
    ) -> None: 
        """
        Release Busy state.

        Args:
            _sender: component which is causing long-term operations

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.BusyRelease_TObject
        """
        pass

    def BusyShake(
      self,
      _sender: TObject,
      _pos: int,
      _end: int,
      _abort: VarParameter
    ) -> None: 
        """
        Shake Busy state.

        Args:
            _sender: component which is causing long-term operations
            _pos: current progress
            _end: maximal progress value
            _abort: if set to True inside message handler then an abort request.; the value (in/out) 
              is passed as bool in _abort.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.BusyShake_TObject_Int64_Int64_Boolean
        """
        pass

    def CenterViewport(
      self,
      _ptg: TGIS_Point
    ) -> None: 
        """
        Set viewport to the vale when _ptg will be visible on the center of the screen. Same 
        as property Center

        Args:
            _ptg: coordinates in map units

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.CenterViewport_TGIS_Point
        """
        pass

    def ChangeHash(
      self
    ) -> int: 
        """
        Change hash. Uses to verify if order of layers, params, etc. has been modified. Used 
        mainly by TGIS_ControlLegend.

        Returns:
            Calculated hash value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ChangeHash_void
        """
        pass

    def Close(
      self
    ) -> None: 
        """
        Close a project.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Close_void
        """
        pass

    def Delete(
      self,
      _name: str
    ) -> None: 
        """
        Delete the layer identified by a name.

        Args:
            _name: name of layer to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Delete_String
        """
        pass

    def Draw(
      self,
      _renderer: TObject,
      _mode: TGIS_DrawMode
    ) -> None: 
        """
        Draw all layers on a current renderer.

        Args:
            _renderer: renderer context
            _mode: drawing mode: which set of layers should be rendered

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Draw_TObject_TGIS_DrawMode
        """
        pass

    def EndPaintInternal(
      self
    ) -> None: 
        """
        Notify viewer about leaving of a paint mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.EndPaintInternal_void
        """
        pass

    def FullExtent(
      self
    ) -> None: 
        """
        Calculate the screen origin, zoom, and viewport to place the whole map in the window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.FullExtent_void
        """
        pass

    def FullExtentZoom(
      self
    ) -> float: 
        """
        Calculates a zoom which places the whole map inside the window

        Returns:
            Zoom value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.FullExtentZoom_void
        """
        pass

    def Get(
      self,
      _name: str
    ) -> TGIS_LayerAbstract: 
        """
        Retrieve the layer identified by a name. Sublayer or compund layers can be found 
        by do notation like ''name.sublyer''

        Args:
            _name: name of layer to be found

        Returns:
            Found layer or nil if not found.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Get_String
        """
        pass

    def GetGrid(
      self,
      _extent: TGIS_Extent,
      _grid: TGIS_GridArray
    ) -> bool: 
        """
        Fills provided _grid array with values defined by _extent. If extent is not fully 
        covered by the gird layers then values outside the layers scope will be left untouched.

        Args:
            _extent: extent of the _grid
            _grid: allocated array (with/height ratio of the _grid should be the same as width/height 
              ration of the _extent)

        Returns:
            True if success.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.GetGrid_TGIS_Extent_TGIS_GridArray
        """
        pass

    def GetRenderContext(
      self
    ) -> TObject: 
        """
        Return current context object.

        Returns:
            Current renderer context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.GetRenderContext_void
        """
        pass

    def HourglassActive(
      self
    ) -> bool: 
        """
        Test is hourglass is active.

        Returns:
            True is Hourglass is visible and Interrupt can be called.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.HourglassActive_void
        """
        pass

    def HourglassPrepare(
      self
    ) -> None: 
        """
        Prepare Hourglass cursor for timely operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.HourglassPrepare_void
        """
        pass

    def HourglassRelease(
      self
    ) -> None: 
        """
        Release Hourglass.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.HourglassRelease_void
        """
        pass

    def HourglassRestart(
      self
    ) -> None: 
        """
        Restart hourglass timing used for progressive updates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.HourglassRestart_void
        """
        pass

    def HourglassShake(
      self
    ) -> bool: 
        """
        Shake Hourglass.

        Returns:
            If True then current operation should be interrupted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.HourglassShake_void
        """
        pass

    def Interrupt(
      self
    ) -> None: 
        """
        Will terminate timely operation as soon as possible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Interrupt_void
        """
        pass

    def Interrupted(
      self
    ) -> bool: 
        """
        Test if any pending operation must be aborted.

        Returns:
            True is if any lengy;lu operation must be aborted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Interrupted_void
        """
        pass

    def InvalidateBasemap(
      self
    ) -> None: 
        """
        Invalidate only basemap layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.InvalidateBasemap_void
        """
        pass

    def InvalidateEditor(
      self,
      _final: bool
    ) -> None: 
        """
        Invalidate editor. To mark viewer after editor change to redraw state.

        Args:
            _final: True if map must updated at the end of editing process; otherwise a normal 
              "shallow" screen refresh to be performed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.InvalidateEditor_Boolean
        """
        pass

    @overload
    def InvalidateExtent(
      self,
      _extent: TGIS_Extent
    ) -> None: 
        """
        Invalidate an extent for full map redraw

        Args:
            _extent: extent to redraw

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.InvalidateExtent_TGIS_Extent
        """
        pass

    @overload
    def InvalidateExtent(
      self,
      _extent: TGIS_Extent,
      _deep: bool
    ) -> None: 
        """
        Invalidate an extent.

        Args:
            _extent: extent to redraw
            _deep: True if whole map must marked for update; if False then only shallow repaint 
              will be issued (only topmost layers)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.InvalidateExtent_TGIS_Extent_Boolean
        """
        pass

    def InvalidateSelection(
      self
    ) -> None: 
        """
        Invalidate selection. To mark viewer after selection change to redraw state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.InvalidateSelection_void
        """
        pass

    def InvalidateTopmost(
      self
    ) -> None: 
        """
        Invalidate only topmost layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.InvalidateTopmost_void
        """
        pass

    def InvalidateWholeMap(
      self
    ) -> None: 
        """
        Invalidate whole map. All layers must be updated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.InvalidateWholeMap_void
        """
        pass

    @overload
    def Locate(
      self,
      _ptg: TGIS_Point,
      _prec: float
    ) -> TGIS_ShapeAbstract: 
        """
        Locate a shape that is near _ptg, but is closer than _prec distance.

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in map units

        Returns:
            Located shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Locate_TGIS_Point_Double
        """
        pass

    @overload
    def Locate(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _visible: bool
    ) -> TGIS_ShapeAbstract: 
        """
        Locate a shape that is near _ptg, but is closer than _prec distance.

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in map units
            _visible: if true the only visible shapes will be evaluated; shapes turned of by 
              query of hidden will be ignored

        Returns:
            Located shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Locate_TGIS_Point_Double_Boolean
        """
        pass

    @overload
    def Locate(
      self,
      _pt: TPoint,
      _prec: int
    ) -> TGIS_ShapeAbstract: 
        """
        Locate a shape that is near _pt, but is closer than _prec distance.

        Args:
            _pt: reference point /searching point/ in pixels
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in pixels

        Returns:
            Located shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Locate_TPoint_Integer
        """
        pass

    def LocateEx(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _visible: bool
    ) -> TGIS_ShapeAbstractList: 
        """
        Locate shapes on layers that are near _ptg, but closer than _prec distance. Still 
        only the best one candidate is chosen from each layer.

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in map units
            _visible: if true the only visible shapes will be evaluated; shapes turned of by 
              query of hidden will be ignored

        Returns:
            Allocated list of shapes from all viewer layers

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.LocateEx_TGIS_Point_Double_Boolean
        """
        pass

    def Lock(
      self
    ) -> None: 
        """
        Lock viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Lock_void
        """
        pass

    def MapToScreen(
      self,
      _ptg: TGIS_Point
    ) -> TPoint: 
        """
        Converts point coordinates from map related to screen related.

        Args:
            _ptg: coordinate in map units

        Returns:
            Map coordinates converted to screen coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.MapToScreen_TGIS_Point
        """
        pass

    def MapToScreen3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TPoint: 
        """
        Converts 3D point coordinates from map related to screen related.

        Args:
            _ptg: coordinate in map units

        Returns:
            Map coordinates converted to screen coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.MapToScreen3D_TGIS_Point3D
        """
        pass

    def MapToScreenEx(
      self,
      _pt: TGIS_Point
    ) -> TGIS_Point: 
        """
        Converts point coordinates from map related to screen related, but result will be 
        in TGIS_Point.

        Args:
            _pt: coordinate in map units

        Returns:
            map coordinates converted to screen coordinates

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.MapToScreenEx_TGIS_Point
        """
        pass

    def MapToScreenRect(
      self,
      _rct: TGIS_Extent
    ) -> TRect: 
        """
        Converts rectangle coordinates from map related to screen related.

        Args:
            _rct: coordinate in map units

        Returns:
            Calculated screen rectangle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.MapToScreenRect_TGIS_Extent
        """
        pass

    def MarkModified(
      self
    ) -> None: 
        """
        Mark viewer upon some modifications.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.MarkModified_void
        """
        pass

    def MoveViewport(
      self,
      _dx: VarParameter,
      _dy: VarParameter
    ) -> None: 
        """
        Move the screen origin of the map by delta values.

        Args:
            _dx: x delta in pixels; the value (in/out) is passed as int in _dx.Value property
            _dy: y delta in pixels; the value (in/out) is passed as int in _dy.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.MoveViewport_Integer_Integer
        """
        pass

    def MoveViewportEx(
      self,
      _dx: VarParameter,
      _dy: VarParameter
    ) -> None: 
        """
        Move the screen origin of the map by delta values.

        Args:
            _dx: x delta in map units; the value (in/out) is passed as float in _dx.Value property
            _dy: y delta in map units; the value (in/out) is passed as float in _dy.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.MoveViewportEx_Double_Double
        """
        pass

    def MustSave(
      self
    ) -> bool: 
        """
        Check if any layer or the project file was modified by editing.

        Returns:
            True if project should be saved.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.MustSave_void
        """
        pass

    def NotifySubscribers(
      self,
      _event: int,
      _context: TObject
    ) -> None: 
        """
        Send notification to subscribers.

        Args:
            _event: event identifying number
            _context: control context; what is expected depends on _event; it can be canvas, 
              control itself.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.NotifySubscribers_Integer_TObject
        """
        pass

    @overload
    def Open(
      self,
      _path: str
    ) -> None: 
        """
        Open project.

        Args:
            _path: project path (or layer)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Open_String
        """
        pass

    @overload
    def Open(
      self,
      _path: str,
      _strict: bool
    ) -> None: 
        """
        Open project.

        Args:
            _path: project path (or layer)
            _strict: if False then non existing layers will be ignored (only while opening project 
              files); default is True ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Open_String_Boolean
        """
        pass

    @overload
    def OpenEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str
    ) -> None: 
        """
        Open project file from the memory.

        Args:
            _configFile: project file
            _path: project path (or layer)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.OpenEx_TGIS_ConfigAbstract_String
        """
        pass

    @overload
    def OpenEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str,
      _strict: bool
    ) -> None: 
        """
        Open project file from the memory.

        Args:
            _configFile: project file
            _path: project path (or layer)
            _strict: if False then non existing layers will be ignored (only while opening project 
              files); default is True ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.OpenEx_TGIS_ConfigAbstract_String_Boolean
        """
        pass

    def PixelsToTwips(
      self,
      _size: int
    ) -> int: 
        """
        Convert size from device dependent pixels to device independent Twips (1/1440 inch). 
        Used to make map device independent.

        Args:
            _size: size in pixels; absolute value will be taken

        Returns:
            Size in twips.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.PixelsToTwips_Integer
        """
        pass

    def RaiseBusyEvent(
      self,
      _sender: TObject,
      _pos: int,
      _end: int,
      _abort: VarParameter
    ) -> None: 
        """
        Fire Busy event of a viewer.

        Args:
            _sender: component which is causing long-term operations
            _pos: current progress
            _end: maximal progress value
            _abort: if set to True inside message handler then an abort request.; the value (in/out) 
              is passed as bool in _abort.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RaiseBusyEvent_TObject_Int64_Int64_Boolean
        """
        pass

    def RaiseHelpEvent(
      self,
      _sender: TObject,
      _name: str
    ) -> None: 
        """
        Fire Busy event of a viewer.

        Args:
            _sender: component asking for help
            _name: help context

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RaiseHelpEvent_TObject_String
        """
        pass

    def ReadConfig(
      self
    ) -> None: 
        """
        Read all configuration data from project.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ReadConfig_void
        """
        pass

    def RecalcExtent(
      self
    ) -> None: 
        """
        Calculates a common extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RecalcExtent_void
        """
        pass

    def ReParent(
      self,
      _parent: IGIS_ViewerParent
    ) -> IGIS_ViewerParent: 
        """
        Set a new parent for the viewer.

        Args:
            _parent: new parent object

        Returns:
            Previous parent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ReParent_IGIS_ViewerParent
        """
        pass

    def Reposition(
      self
    ) -> None: 
        """
        Reposition the map within the component window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Reposition_void
        """
        pass

    def RereadConfig(
      self
    ) -> None: 
        """
        Reread all configuration data from project and layer configuration files.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RereadConfig_void
        """
        pass

    def RestorePaintState(
      self,
      _state: VarParameter
    ) -> None: 
        """
        Restore and free the current paint state.

        Args:
            _state: paint state to be restored; the value (in/out) is passed as TObject in _state.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RestorePaintState_TObject
        """
        pass

    def RevertAll(
      self
    ) -> None: 
        """
        Revert all layers to a file-based original.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RevertAll_void
        """
        pass

    def RotatedExtent(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Compute extent (encompassing area of the extent) after the viewer rotation.

        Args:
            _extent: extent to be rotated

        Returns:
            Rotated extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RotatedExtent_TGIS_Extent
        """
        pass

    def RotatedPoint(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        Compute position of the point after the viewer rotation.

        Args:
            _ptg: point in to be rotated

        Returns:
            Rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RotatedPoint_TGIS_Point
        """
        pass

    def RotatedPoint3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Compute position of the 3D point after the viewer rotation.

        Args:
            _ptg: point to be rotated

        Returns:
            Rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RotatedPoint3D_TGIS_Point3D
        """
        pass

    def RotatedPoint3D_ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Compute position of the 3D point after the viewer rotation.

        Args:
            _ptg: point to be rotated; the value (in/out) is passed as TGIS_Point3D in _ptg.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RotatedPoint3D_ref_TGIS_Point3D
        """
        pass

    def SaveAll(
      self
    ) -> None: 
        """
        Save all layers (parameters and data)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SaveAll_void
        """
        pass

    def SaveData(
      self
    ) -> None: 
        """
        Save all changes to the data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SaveData_void
        """
        pass

    @overload
    def SaveProject(
      self
    ) -> None: 
        """
        Save current project.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SaveProject_void
        """
        pass

    @overload
    def SaveProject(
      self,
      _relativepath: bool
    ) -> None: 
        """
        Save current project.

        Args:
            _relativepath: if True (default) then project will be saved using paths relative 
              to project file location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SaveProject_Boolean
        """
        pass

    @overload
    def SaveProjectAs(
      self,
      _path: str
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SaveProjectAs_String
        """
        pass

    @overload
    def SaveProjectAs(
      self,
      _path: str,
      _relativepath: bool
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension
            _relativepath: if True (default) then project will be saved using paths relative 
              to project file location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SaveProjectAs_String_Boolean
        """
        pass

    @overload
    def SaveProjectAsEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _configFile: existing project file
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SaveProjectAsEx_TGIS_ConfigAbstract_String
        """
        pass

    @overload
    def SaveProjectAsEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str,
      _relativepath: bool
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _configFile: existing project file
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension
            _relativepath: if True (default) then project will be saved using paths relative 
              to project file location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SaveProjectAsEx_TGIS_ConfigAbstract_String_Boolean
        """
        pass

    def ScreenToMap(
      self,
      _pt: TPoint
    ) -> TGIS_Point: 
        """
        Converts point coordinates from screen related to map related.

        Args:
            _pt: coordinate in screen units

        Returns:
            Screen coordinates converted to map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ScreenToMap_TPoint
        """
        pass

    def ScreenToMap3D(
      self,
      _pt: TPoint
    ) -> TGIS_Point3D: 
        """
        Converts point coordinates from screen related to map related.

        Args:
            _pt: coordinate in screen units

        Returns:
            Screen coordinates converted to map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ScreenToMap3D_TPoint
        """
        pass

    def ScreenToMapEx(
      self,
      _pt: TGIS_Point
    ) -> TGIS_Point: 
        """
        Converts point coordinates from screen related to map related, but source will be 
        in TGIS_Point.

        Args:
            _pt: coordinate in screen units

        Returns:
            screen coordinates converted to map coordinates

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ScreenToMapEx_TGIS_Point
        """
        pass

    def ScreenToMapRect(
      self,
      _rct: TRect
    ) -> TGIS_Extent: 
        """
        Converts rectangle coordinates from screen related to map related.

        Args:
            _rct: coordinate in screen units

        Returns:
            Calculated extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ScreenToMapRect_TRect
        """
        pass

    def SetCSByEPSG(
      self,
      _epsg: int
    ) -> None: 
        """
        Setup Coordinate System to a coordinate system provided by EPSG code.

        Args:
            _epsg: EPSG code

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SetCSByEPSG_Integer
        """
        pass

    def SetCSByWKT(
      self,
      _wkt: str
    ) -> None: 
        """
        Setup Coordinate System to a coordinate system provided by WKT string (GEOGCS or 
        PROJCS). If provided WKT string is empty then coordinate system will be turn off.

        Args:
            _wkt: WKT string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SetCSByWKT_String
        """
        pass

    def SetCSByWKTFile(
      self,
      _path: str
    ) -> None: 
        """
        Setup Coordinate System to a coordinate system provided by file which contains WKT 
        string (GEOGCS or PROJCS). If file does not exist or provided WKT string is empty 
        then coordinate system will be turned off.

        Args:
            _path: path with WKT string (for example shapefile .PRJ)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SetCSByWKTFile_String
        """
        pass

    def SetViewport(
      self,
      _x: VarParameter,
      _y: VarParameter
    ) -> None: 
        """
        Set viewport to a given position.

        Args:
            _x: x coordinate; the value (in/out) is passed as float in _x.Value property
            _y: y coordinate; the value (in/out) is passed as float in _y.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SetViewport_Double_Double
        """
        pass

    def StorePaintState(
      self
    ) -> TObject: 
        """
        Store the current paint state.

        Returns:
            Stored paint state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.StorePaintState_void
        """
        pass

    def Subscribe(
      self,
      _control: IGIS_Subscribe
    ) -> None: 
        """
        Add provided control to the notification subscription list.

        Args:
            _control: - control which should become a subscriber

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Subscribe_IGIS_Subscribe
        """
        pass

    def SynchronizePaint(
      self,
      _interrupt: bool
    ) -> bool: 
        """
        Wait for pending paint operation to be finalized.

        Args:
            _interrupt: interrupts any pending operation

        Returns:
            True if operation were synchronized; False if synchronization is not possible and 
            current operation should not continue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SynchronizePaint_Boolean
        """
        pass

    def TwipsToPixels(
      self,
      _size: int
    ) -> int: 
        """
        Convert the size from to device independent Twips (1/1440 inch) to device dependent 
        pixels. Used to make map device independent.

        Args:
            _size: size in twips; if negative then treated as pixels

        Returns:
            Size in twips.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.TwipsToPixels_Integer
        """
        pass

    def TwipsToPoints(
      self,
      _size: int
    ) -> int: 
        """
        Convert the size from to device independent Twips (1/1440 inch) to device points. 
        Used for advanced font sizing.

        Args:
            _size: size in twips; if negative then treated as pixels

        Returns:
            Size in points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.TwipsToPoints_Integer
        """
        pass

    @overload
    def Unlock(
      self
    ) -> None: 
        """
        Unlock viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Unlock_void
        """
        pass

    @overload
    def Unlock(
      self,
      _redraw: bool
    ) -> None: 
        """
        Unlock the viewer but do not redraw

        Args:
            _redraw: If true then map should be redraw upon unlock; if false then redraw should 
              be issued.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Unlock_Boolean
        """
        pass

    def UnrotatedExtent(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Compute original extent of the rotated extent.

        Args:
            _extent: rotated extent

        Returns:
            Original un-rotated extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.UnrotatedExtent_TGIS_Extent
        """
        pass

    def UnrotatedPoint(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        Compute original position of the rotated point.

        Args:
            _ptg: rotated point

        Returns:
            Original un-rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.UnrotatedPoint_TGIS_Point
        """
        pass

    def UnrotatedPoint3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Compute original position of the rotated 3D point.

        Args:
            _ptg: rotated point

        Returns:
            Original un-rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.UnrotatedPoint3D_TGIS_Point3D
        """
        pass

    def UnrotatedPoint3D_ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Compute original position of the rotated 3D point.

        Args:
            _ptg: rotated point; the value (in/out) is passed as TGIS_Point3D in _ptg.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.UnrotatedPoint3D_ref_TGIS_Point3D
        """
        pass

    def UnSubscribe(
      self,
      _control: IGIS_Subscribe
    ) -> None: 
        """
        Remove provided control from the notification subscription list.

        Args:
            _control: control which subscription should be canceled

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.UnSubscribe_IGIS_Subscribe
        """
        pass

    def WaitForBackgroundProcesses(
      self
    ) -> None: 
        """
        Wait for any pending background processes that must be finalized before app can continue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.WaitForBackgroundProcesses_void
        """
        pass

    def WaitForNotBusy(
      self,
      _sender: TObject,
      _proc: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Call _proc when viewer will fully end painting procees.

        Args:
            _sender: sender object
            _proc: procedure to be executed; the value is a callback to a method with parameters 
              defined by TGIS_WaitForNotBusyProc

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.WaitForNotBusy_TObject_TGIS_WaitForNotBusyProc
        """
        pass

    def WriteConfig(
      self
    ) -> None: 
        """
        Write all configuration data to the project or layer ini file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.WriteConfig_void
        """
        pass

    @property
    def AutoStyle(
      self
    ) -> bool: 
        """
        If True, layers added to the viewer will have a unique style applied; Default is 
        False.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.AutoStyle
        """
        pass

    @AutoStyle.setter
    def AutoStyle(
      self,
      _value: bool
    ) -> None: 
        """
        If True, layers added to the viewer will have a unique style applied; Default is 
        False.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.AutoStyle
        """
        pass

    @property
    def BigExtent(
      self
    ) -> TGIS_Extent: 
        """
        Map extent. Encompassing the collective extents of all layers and a border defined 
        by BigExtentMargin. Is depending on current scale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.BigExtent
        """
        pass

    @property
    def BigExtentMargin(
      self
    ) -> int: 
        """
        Map extent margin.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.BigExtentMargin
        """
        pass

    @BigExtentMargin.setter
    def BigExtentMargin(
      self,
      _value: int
    ) -> None: 
        """
        Map extent margin.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.BigExtentMargin
        """
        pass

    @property
    def BusyLevel(
      self
    ) -> int: 
        """
        Level of current busy state. If 1 then most significant busy is active; if 2 then 
        subsequent etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.BusyLevel
        """
        pass

    @property
    def BusyText(
      self
    ) -> str: 
        """
        Text related to current busy state. Text could be set upon BusyPrepare() call. If 
        IsBusy is not true then text will be an empty string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.BusyText
        """
        pass

    @property
    def Center(
      self
    ) -> TGIS_Point: 
        """
        Center the screen based on given point. Useful for "Center on Click". See property 
        CenterPtg.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Center
        """
        pass

    @Center.setter
    def Center(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Center the screen based on given point. Useful for "Center on Click". See property 
        CenterPtg.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Center
        """
        pass

    @property
    def CenterPtg(
      self
    ) -> TGIS_Point: 
        """
        Point on which Viewer will be centered during Zoom. Will not modify the Viewport. 
        Will set up the point without re centering the screen. See property Center.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.CenterPtg
        """
        pass

    @CenterPtg.setter
    def CenterPtg(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Point on which Viewer will be centered during Zoom. Will not modify the Viewport. 
        Will set up the point without re centering the screen. See property Center.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.CenterPtg
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Background color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Background color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Color
        """
        pass

    @property
    def Copyright(
      self
    ) -> str: 
        """
        Legal notice and product version.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Copyright
        """
        pass

    @property
    def CS(
      self
    ) -> TGIS_CSCoordinateSystem: 
        """
        Coordinate System assigned to the viewer. If set to nil the Coordinate System will 
        be turned off. Default is turned off.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.CS
        """
        pass

    @CS.setter
    def CS(
      self,
      _value: TGIS_CSCoordinateSystem
    ) -> None: 
        """
        Coordinate System assigned to the viewer. If set to nil the Coordinate System will 
        be turned off. Default is turned off.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.CS
        """
        pass

    @property
    def CustomData(
      self
    ) -> TGIS_StringList: 
        """
        List of custom, user-defined data. List is save/restored witch config/project files.
        
        List is in a form of "name=value".

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.CustomData
        """
        pass

    @property
    def CustomPPI(
      self
    ) -> int: 
        """
        Custom resolution in pixels-per-inch. If &lt;&gt; 0 then used instead of SystemPPI

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.CustomPPI
        """
        pass

    @CustomPPI.setter
    def CustomPPI(
      self,
      _value: int
    ) -> None: 
        """
        Custom resolution in pixels-per-inch. If &lt;&gt; 0 then used instead of SystemPPI

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.CustomPPI
        """
        pass

    @property
    def DelayedUpdate(
      self
    ) -> int: 
        """
        Delayed update threshold in milliseconds. If &gt;0 then map will be updated after 
        a while allowing for example subsequent draw operation before full map redraw. Default 
        value is 700.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.DelayedUpdate
        """
        pass

    @DelayedUpdate.setter
    def DelayedUpdate(
      self,
      _value: int
    ) -> None: 
        """
        Delayed update threshold in milliseconds. If &gt;0 then map will be updated after 
        a while allowing for example subsequent draw operation before full map redraw. Default 
        value is 700.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.DelayedUpdate
        """
        pass

    @property
    def Editor(
      self
    ) -> IGIS_Editor: 
        """
        Editor context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Editor
        """
        pass

    @Editor.setter
    def Editor(
      self,
      _value: IGIS_Editor
    ) -> None: 
        """
        Editor context.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Editor
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Extent: 
        """
        Map extent. Encompassing the collective extents of all layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Extent
        """
        pass

    @property
    def FileCopyrights(
      self
    ) -> str: 
        """
        List Copyrights

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.FileCopyrights
        """
        pass

    @property
    def FontScale(
      self
    ) -> int: 
        """
        Font magnifying factor in percents. To make fonts more readable without changing 
        PPI.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.FontScale
        """
        pass

    @FontScale.setter
    def FontScale(
      self,
      _value: int
    ) -> None: 
        """
        Font magnifying factor in percents. To make fonts more readable without changing 
        PPI.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.FontScale
        """
        pass

    @property
    def FullDrawExtent(
      self
    ) -> TGIS_Extent: 
        """
        Extent of full current/last drawing area including margin and w/o tiling.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.FullDrawExtent
        """
        pass

    @property
    def Hierarchy(
      self
    ) -> IGIS_HierarchyManager: 
        """
        Hierarchy list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Hierarchy
        """
        pass

    @property
    def IncrementalPaint(
      self
    ) -> bool: 
        """
        Is partial drawing to screen done in incremental mode?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.IncrementalPaint
        """
        pass

    @IncrementalPaint.setter
    def IncrementalPaint(
      self,
      _value: bool
    ) -> None: 
        """
        Is partial drawing to screen done in incremental mode?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.IncrementalPaint
        """
        pass

    @property
    def InPaint(
      self
    ) -> bool: 
        """
        True if Viewer is busy in Paint procedure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.InPaint
        """
        pass

    @property
    def IsBusy(
      self
    ) -> bool: 
        """
        True if Viewer is busy.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.IsBusy
        """
        pass

    @property
    def IsEmpty(
      self
    ) -> bool: 
        """
        True if Viewer is empty (no layers).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.IsEmpty
        """
        pass

    @property
    def IsLocked(
      self
    ) -> bool: 
        """
        True if Viewer is in locked state Lock.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.IsLocked
        """
        pass

    @property
    def IsTopmost(
      self
    ) -> bool: 
        """
        True if Viewer has a topmost layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.IsTopmost
        """
        pass

    @property
    def Items(
      self
    ) -> TGIS_LayerAbstractList: 
        """
        All layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Items
        """
        pass

    @property
    def KeepScale(
      self
    ) -> bool: 
        """
        True if a viewer should maintain scale upon resize.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.KeepScale
        """
        pass

    @KeepScale.setter
    def KeepScale(
      self,
      _value: bool
    ) -> None: 
        """
        True if a viewer should maintain scale upon resize.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.KeepScale
        """
        pass

    @property
    def LabelsReg(
      self
    ) -> TGIS_LabelsAreaAbstract: 
        """
        Labels position allocator object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.LabelsReg
        """
        pass

    @property
    def Level(
      self
    ) -> float: 
        """
        Sets and gets zoom level for a viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Level
        """
        pass

    @Level.setter
    def Level(
      self,
      _value: float
    ) -> None: 
        """
        Sets and gets zoom level for a viewer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Level
        """
        pass

    @property
    def MasterViewer(
      self
    ) -> IGIS_Viewer: 
        """
        Master Viewer reference. To be used only by TiledPaint.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.MasterViewer
        """
        pass

    @MasterViewer.setter
    def MasterViewer(
      self,
      _value: IGIS_Viewer
    ) -> None: 
        """
        Master Viewer reference. To be used only by TiledPaint.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.MasterViewer
        """
        pass

    @property
    def MultiUserMode(
      self
    ) -> TGIS_MultiUser: 
        """
        Multiuser mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.MultiUserMode
        """
        pass

    @MultiUserMode.setter
    def MultiUserMode(
      self,
      _value: TGIS_MultiUser
    ) -> None: 
        """
        Multiuser mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.MultiUserMode
        """
        pass

    @property
    def OverlappedExtentMargin(
      self
    ) -> int: 
        """
        Overlapped extent margin (in pixels).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.OverlappedExtentMargin
        """
        pass

    @OverlappedExtentMargin.setter
    def OverlappedExtentMargin(
      self,
      _value: int
    ) -> None: 
        """
        Overlapped extent margin (in pixels).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.OverlappedExtentMargin
        """
        pass

    @property
    def PPI(
      self
    ) -> int: 
        """
        Rendering resolution in pixels-per-inch. Returns SystemPPI value or CustomPPI (if 
        &lt;&gt; 0) multiplied by ControlCanvasScale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.PPI
        """
        pass

    @property
    def ProgressiveUpdate(
      self
    ) -> int: 
        """
        Progressive update threshold in milliseconds. If &gt;0 then map will be updated on 
        a time consuming updates every provided period. Default value is 2500.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ProgressiveUpdate
        """
        pass

    @ProgressiveUpdate.setter
    def ProgressiveUpdate(
      self,
      _value: int
    ) -> None: 
        """
        Progressive update threshold in milliseconds. If &gt;0 then map will be updated on 
        a time consuming updates every provided period. Default value is 2500.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ProgressiveUpdate
        """
        pass

    @property
    def ProjectFile(
      self
    ) -> TGIS_ConfigAbstract: 
        """
        Project file itself as opened in Open procedure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ProjectFile
        """
        pass

    @ProjectFile.setter
    def ProjectFile(
      self,
      _value: TGIS_ConfigAbstract
    ) -> None: 
        """
        Project file itself as opened in Open procedure.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ProjectFile
        """
        pass

    @property
    def ProjectName(
      self
    ) -> str: 
        """
        Project file name as opened in Open procedure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ProjectName
        """
        pass

    @property
    def RestrictedDrag(
      self
    ) -> bool: 
        """
        If true, then you can not drag outside the map Extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RestrictedDrag
        """
        pass

    @RestrictedDrag.setter
    def RestrictedDrag(
      self,
      _value: bool
    ) -> None: 
        """
        If true, then you can not drag outside the map Extent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RestrictedDrag
        """
        pass

    @property
    def RestrictedExtent(
      self
    ) -> TGIS_Extent: 
        """
        Restricted Map extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RestrictedExtent
        """
        pass

    @RestrictedExtent.setter
    def RestrictedExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Restricted Map extent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RestrictedExtent
        """
        pass

    @property
    def RotationAngle(
      self
    ) -> float: 
        """
        Angle of viewer rotation in radians.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RotationAngle
        """
        pass

    @RotationAngle.setter
    def RotationAngle(
      self,
      _value: float
    ) -> None: 
        """
        Angle of viewer rotation in radians.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RotationAngle
        """
        pass

    @property
    def RotationPoint(
      self
    ) -> TGIS_Point: 
        """
        Point of viewer rotation in map units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RotationPoint
        """
        pass

    @RotationPoint.setter
    def RotationPoint(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Point of viewer rotation in map units.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.RotationPoint
        """
        pass

    @property
    def Scale(
      self
    ) -> float: 
        """
        Setting up and reading the scale factor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Scale
        """
        pass

    @Scale.setter
    def Scale(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the scale factor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Scale
        """
        pass

    @property
    def ScaleAsFloat(
      self
    ) -> float: 
        """
        Setting up and reading the scale factor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ScaleAsFloat
        """
        pass

    @ScaleAsFloat.setter
    def ScaleAsFloat(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the scale factor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ScaleAsFloat
        """
        pass

    @property
    def ScaleAsText(
      self
    ) -> str: 
        """
        Setting up and reading the scale factor as text in format ''1:10000''.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ScaleAsText
        """
        pass

    @ScaleAsText.setter
    def ScaleAsText(
      self,
      _value: str
    ) -> None: 
        """
        Setting up and reading the scale factor as text in format ''1:10000''.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ScaleAsText
        """
        pass

    @property
    def SelectionGisColor(
      self
    ) -> TGIS_Color: 
        """
        Color used for selecting object. See also SelectionTransparency.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SelectionGisColor
        """
        pass

    @SelectionGisColor.setter
    def SelectionGisColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Color used for selecting object. See also SelectionTransparency.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SelectionGisColor
        """
        pass

    @property
    def SelectionOutlineOnly(
      self
    ) -> bool: 
        """
        If true then polygons will be marked only with outline not a full fill.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SelectionOutlineOnly
        """
        pass

    @SelectionOutlineOnly.setter
    def SelectionOutlineOnly(
      self,
      _value: bool
    ) -> None: 
        """
        If true then polygons will be marked only with outline not a full fill.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SelectionOutlineOnly
        """
        pass

    @property
    def SelectionTransparency(
      self
    ) -> int: 
        """
        Transparency value for selection; if 100 SelectionGisColor will not be transparent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SelectionTransparency
        """
        pass

    @SelectionTransparency.setter
    def SelectionTransparency(
      self,
      _value: int
    ) -> None: 
        """
        Transparency value for selection; if 100 SelectionGisColor will not be transparent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SelectionTransparency
        """
        pass

    @property
    def SelectionWidth(
      self
    ) -> int: 
        """
        Outline width of selection area (&gt;0 in twips, &lt;0 in pixels).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SelectionWidth
        """
        pass

    @SelectionWidth.setter
    def SelectionWidth(
      self,
      _value: int
    ) -> None: 
        """
        Outline width of selection area (&gt;0 in twips, &lt;0 in pixels).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SelectionWidth
        """
        pass

    @property
    def SystemPPI(
      self
    ) -> int: 
        """
        System resolution in pixels-per-inch.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.SystemPPI
        """
        pass

    @property
    def TemporaryScaleInternal(
      self
    ) -> float: 
        """
        Used to force rendering in a different scale then actual.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.TemporaryScaleInternal
        """
        pass

    @TemporaryScaleInternal.setter
    def TemporaryScaleInternal(
      self,
      _value: float
    ) -> None: 
        """
        Used to force rendering in a different scale then actual.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.TemporaryScaleInternal
        """
        pass

    @property
    def TemporaryVisibleExtent(
      self
    ) -> TGIS_Extent: 
        """
        Used to force rendering labels while drawing with tiles.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.TemporaryVisibleExtent
        """
        pass

    @TemporaryVisibleExtent.setter
    def TemporaryVisibleExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Used to force rendering labels while drawing with tiles.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.TemporaryVisibleExtent
        """
        pass

    @property
    def TiledPaint(
      self
    ) -> bool: 
        """
        Is partial drawing to screen done in tiled mode?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.TiledPaint
        """
        pass

    @TiledPaint.setter
    def TiledPaint(
      self,
      _value: bool
    ) -> None: 
        """
        Is partial drawing to screen done in tiled mode?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.TiledPaint
        """
        pass

    @property
    def UponDestroy(
      self
    ) -> bool: 
        """
        True if viewer is upon destruction so some operations (like screen updates) should 
        not be performed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.UponDestroy
        """
        pass

    @property
    def UseAnimations(
      self
    ) -> bool: 
        """
        True if animation upon zooming are allowed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.UseAnimations
        """
        pass

    @UseAnimations.setter
    def UseAnimations(
      self,
      _value: bool
    ) -> None: 
        """
        True if animation upon zooming are allowed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.UseAnimations
        """
        pass

    @property
    def UseRTree(
      self
    ) -> bool: 
        """
        True if RTree will be used by default upon creation of any layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.UseRTree
        """
        pass

    @UseRTree.setter
    def UseRTree(
      self,
      _value: bool
    ) -> None: 
        """
        True if RTree will be used by default upon creation of any layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.UseRTree
        """
        pass

    @property
    def ViewerParent(
      self
    ) -> IGIS_ViewerParent: 
        """
        Parent for the current IGIS_Viewer object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ViewerParent
        """
        pass

    @property
    def ViewerParentRoot(
      self
    ) -> IGIS_ViewerParent: 
        """
        Parent for the current IGIS_Viewer object. If object is reparented then root parent 
        object will be returned.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ViewerParentRoot
        """
        pass

    @property
    def Viewport(
      self
    ) -> TGIS_Point: 
        """
        Setting an upper left corner position of the components window within the map.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Viewport
        """
        pass

    @Viewport.setter
    def Viewport(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Setting an upper left corner position of the components window within the map.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Viewport
        """
        pass

    @property
    def VisibleExtent(
      self
    ) -> TGIS_Extent: 
        """
        Extent of the map that is visible in the window. On setting an optimal zoom will 
        be calculated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.VisibleExtent
        """
        pass

    @VisibleExtent.setter
    def VisibleExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Extent of the map that is visible in the window. On setting an optimal zoom will 
        be calculated.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.VisibleExtent
        """
        pass

    @property
    def Zoom(
      self
    ) -> float: 
        """
        Setting up and reading the related zoom factor. If one map unit = one pixel, then 
        Zoom = 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Zoom
        """
        pass

    @Zoom.setter
    def Zoom(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the related zoom factor. If one map unit = one pixel, then 
        Zoom = 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.Zoom
        """
        pass

    @property
    def ZoomEx(
      self
    ) -> float: 
        """
        Setting up and reading the absolute zoom factor. If one map unit = one twips, then 
        Zoom = 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ZoomEx
        """
        pass

    @ZoomEx.setter
    def ZoomEx(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the absolute zoom factor. If one map unit = one twips, then 
        Zoom = 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer.ZoomEx
        """
        pass

class IGIS_ViewerParent:
    """
    Common API for viewer parent operations. To be shared across platforms.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.Create_void
        """
        pass

    def ControlAutoCenterViewport(
      self,
      _dx: float,
      _dy: float
    ) -> None: 
        """
        Move the screen origin of the map by delta values.

        Args:
            _dx: x delta
            _dy: y delta

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlAutoCenterViewport_Double_Double
        """
        pass

    def ControlCanvasHeight(
      self
    ) -> int: 
        """
        Get canvas height.

        Returns:
            height.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlCanvasHeight_void
        """
        pass

    def ControlCanvasScale(
      self
    ) -> float: 
        """
        Get canvas scale.

        Returns:
            scale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlCanvasScale_void
        """
        pass

    def ControlCanvasWidth(
      self
    ) -> int: 
        """
        Get canvas width.

        Returns:
            width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlCanvasWidth_void
        """
        pass

    def ControlClose(
      self
    ) -> None: 
        """
        Notify control that is map is going to be closed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlClose_void
        """
        pass

    @overload
    def ControlDrawTexture(
      self,
      _bmp: TObject,
      _extent: TGIS_Extent,
      _ppi: int
    ) -> None: 
        """
        Draw texture.

        Args:
            _bmp: bitmap
            _extent: extent
            _ppi: PPI value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlDrawTexture_TObject_TGIS_Extent_Integer
        """
        pass

    @overload
    def ControlDrawTexture(
      self,
      _bmp: TObject,
      _layer: TGIS_LayerAbstract,
      _extent: TGIS_Extent,
      _ppi: int
    ) -> None: 
        """
        Draw texture.

        Args:
            _bmp: bitmap
            _layer: layer to be drawn; if nil then all non 3d layers will be rendered
            _extent: extent
            _ppi: PPI value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlDrawTexture_TObject_TGIS_LayerAbstract_TGIS_Extent_Integer
        """
        pass

    def ControlExtentChanged(
      self
    ) -> None: 
        """
        Notify control that is map extent was changed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlExtentChanged_void
        """
        pass

    def ControlFlash(
      self,
      _times: int,
      _delay: int
    ) -> None: 
        """
        Do flash.

        Args:
            _times: how many times
            _delay: delay between each flash

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlFlash_Integer_Integer
        """
        pass

    def ControlHourglassHide(
      self
    ) -> None: 
        """
        Do Hourglass hide.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlHourglassHide_void
        """
        pass

    def ControlHourglassShake(
      self
    ) -> bool: 
        """
        Do Hourglass shake.

        Returns:
            True if shake was made.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlHourglassShake_void
        """
        pass

    def ControlHourglassShow(
      self
    ) -> None: 
        """
        Do Hourglass show.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlHourglassShow_void
        """
        pass

    def ControlPPI(
      self
    ) -> int: 
        """
        Get current PPI.

        Returns:
            PPI value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlPPI_void
        """
        pass

    def ControlProcessMessages(
      self
    ) -> None: 
        """
        Do process messages.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlProcessMessages_void
        """
        pass

    def ControlRaiseEditorChangeEvent(
      self,
      _sender: TObject
    ) -> None: 
        """
        Raise event on editor change.

        Args:
            _sender: sender object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlRaiseEditorChangeEvent_TObject
        """
        pass

    def ControlRenderer(
      self
    ) -> TObject: 
        """
        Get renderer instance.

        Returns:
            renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlRenderer_void
        """
        pass

    def ControlRepaint(
      self
    ) -> None: 
        """
        Repaint control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlRepaint_void
        """
        pass

    def ControlSet3DMode(
      self,
      _mode: TGIS_Viewer3DMode
    ) -> None: 
        """
        Set current 3D mode.

        Args:
            _mode: 3D mode

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlSet3DMode_TGIS_Viewer3DMode
        """
        pass

    def ControlSystemPPI(
      self
    ) -> int: 
        """
        Get system PPI.

        Returns:
            PPI value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlSystemPPI_void
        """
        pass

    def ControlUpdateBasemap(
      self
    ) -> None: 
        """
        Update basemap.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlUpdateBasemap_void
        """
        pass

    def ControlUpdateEditor(
      self,
      _final: bool
    ) -> None: 
        """
        Update the editor.

        Args:
            _final: Is this final update

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlUpdateEditor_Boolean
        """
        pass

    def ControlUpdateProgressive(
      self
    ) -> None: 
        """
        Progressive update.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlUpdateProgressive_void
        """
        pass

    def ControlUpdateSelection(
      self
    ) -> None: 
        """
        Update Selection layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlUpdateSelection_void
        """
        pass

    def ControlUpdateSynchronize(
      self,
      _interrupt: bool
    ) -> bool: 
        """
        Wait for pending paint operation to be finalized.

        Args:
            _interrupt: interrupt any pending operation

        Returns:
            True if operation were synchronized; False if synchronization is not possible and 
            current operation should not continue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlUpdateSynchronize_Boolean
        """
        pass

    def ControlUpdateTopmost(
      self
    ) -> None: 
        """
        Update Topmost layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlUpdateTopmost_void
        """
        pass

    def ControlUpdateWholeMap(
      self
    ) -> None: 
        """
        Update whole map.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.ControlUpdateWholeMap_void
        """
        pass

    def GetViewer(
      self
    ) -> TObject: 
        """
        Get internal viewer handle.

        Returns:
            current viewer object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.GetViewer_void
        """
        pass

    def SetViewer(
      self,
      _viewer: TObject
    ) -> TObject: 
        """
        Set internal viewer handle.

        Args:
            _viewer: new viewer object

        Returns:
            old viewer object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerParent.SetViewer_TObject
        """
        pass

class IGIS_ViewerWnd:
    """
    Common API for windows viewers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerWnd
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerWnd.Create_void
        """
        pass

    @overload
    def Print(
      self
    ) -> None: 
        """
        Print the current viewer content using the default printer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerWnd.Print_void
        """
        pass

    @overload
    def Print(
      self,
      _printer: IGIS_Printer
    ) -> None: 
        """
        Print the current viewer content using the given printer.

        Args:
            _printer: printer object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerWnd.Print_IGIS_Printer
        """
        pass

    @overload
    def PrintBmp(
      self,
      _bmp: VarParameter
    ) -> None: 
        """
        Print the current content on a bitmap. Print area will match the current VisibleExtent 
        of the control.

        Args:
            _bmp: bitmap on which the drawing will be performed; the value (in/out) is passed 
              as TGIS_Bitmap in _bmp.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerWnd.PrintBmp_TGIS_Bitmap
        """
        pass

    @overload
    def PrintBmp(
      self,
      _bmp: VarParameter,
      _full: bool
    ) -> None: 
        """
        Print the current content on a bitmap. Print area will match the current VisibleExtent 
        of the control.

        Args:
            _bmp: bitmap on which the drawing will be performed; the value (in/out) is passed 
              as TGIS_Bitmap in _bmp.Value property
            _full: if yes, all paint events are triggered

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerWnd.PrintBmp_TGIS_Bitmap_Boolean
        """
        pass

    def ZoomBy(
      self,
      _zm: float,
      _x: int,
      _y: int
    ) -> None: 
        """
        Zoom the viewer.

        Args:
            _zm: zoom value
            _x: center point x coordinate
            _y: center point y coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerWnd.ZoomBy_Double_Integer_Integer
        """
        pass

    @property
    def View3D(
      self
    ) -> bool: 
        """
        True if viewer is in 3D mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerWnd.View3D
        """
        pass

    @View3D.setter
    def View3D(
      self,
      _value: bool
    ) -> None: 
        """
        True if viewer is in 3D mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerWnd.View3D
        """
        pass

    @property
    def Viewer3D(
      self
    ) -> IGIS_Viewer3D: 
        """
        Viewer 3D object. Nil if 3D mode is off.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerWnd.Viewer3D
        """
        pass

    @Viewer3D.setter
    def Viewer3D(
      self,
      _value: IGIS_Viewer3D
    ) -> None: 
        """
        Viewer 3D object. Nil if 3D mode is off.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerWnd.Viewer3D
        """
        pass

class IGIS_ViewerBmp:
    """
    Common API for bitmap viewers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.Create_void
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear a bitmap and prepare background color and picture.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.Clear_void
        """
        pass

    def Draw(
      self
    ) -> None: 
        """
        Draw a current extent on a bitmap.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.Draw_void
        """
        pass

    def ScrollDn(
      self
    ) -> None: 
        """
        Do scrolling down.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.ScrollDn_void
        """
        pass

    def ScrollLeft(
      self
    ) -> None: 
        """
        Do scrolling left.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.ScrollLeft_void
        """
        pass

    def ScrollPgDn(
      self
    ) -> None: 
        """
        Do scrolling page down.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.ScrollPgDn_void
        """
        pass

    def ScrollPgLeft(
      self
    ) -> None: 
        """
        Do scrolling page left.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.ScrollPgLeft_void
        """
        pass

    def ScrollPgRight(
      self
    ) -> None: 
        """
        Do scrolling page right.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.ScrollPgRight_void
        """
        pass

    def ScrollPgUp(
      self
    ) -> None: 
        """
        Do scrolling page up.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.ScrollPgUp_void
        """
        pass

    def ScrollRight(
      self
    ) -> None: 
        """
        Do scrolling right.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.ScrollRight_void
        """
        pass

    def ScrollUp(
      self
    ) -> None: 
        """
        Do scrolling up.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.ScrollUp_void
        """
        pass

    def SetSize(
      self,
      _width: int,
      _height: int
    ) -> None: 
        """
        Set bitmap new size.

        Args:
            _width: bitmap width
            _height: bitmap height

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.SetSize_Integer_Integer
        """
        pass

    def ZoomIn(
      self
    ) -> None: 
        """
        Zoom in slightly.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.ZoomIn_void
        """
        pass

    def ZoomOut(
      self
    ) -> None: 
        """
        Zoom out slightly.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.ZoomOut_void
        """
        pass

    @property
    def Bitmap(
      self
    ) -> TObject: 
        """
        Underlying bitmap as a native, platform dependent object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.Bitmap
        """
        pass

    @property
    def GIS_Bitmap(
      self
    ) -> TGIS_Bitmap: 
        """
        Underlying bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.GIS_Bitmap
        """
        pass

    @property
    def Height(
      self
    ) -> int: 
        """
        Underlying bitmap height.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.Height
        """
        pass

    @property
    def TileRect(
      self
    ) -> TRect: 
        """
        Location of the bitmap over the entire rendered area (in pixels).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.TileRect
        """
        pass

    @TileRect.setter
    def TileRect(
      self,
      _value: TRect
    ) -> None: 
        """
        Location of the bitmap over the entire rendered area (in pixels).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.TileRect
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        Underlying bitmap width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_ViewerBmp.Width
        """
        pass

class IGIS_PrintableControl:
    """
    Common API for printing control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PrintableControl
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PrintableControl.Create_void
        """
        pass

    def CreateCopy(
      self
    ) -> IGIS_PrintableControl: 
        """
        Prepare a copy of the control for printing. It prevents for making changes to the 
        original control during printing.

        Returns:
            created copy object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PrintableControl.CreateCopy_void
        """
        pass

    def FreeCopy(
      self,
      _control: IGIS_PrintableControl
    ) -> None: 
        """
        Release the copy of the control.

        Args:
            _control: copy to free

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PrintableControl.FreeCopy_IGIS_PrintableControl
        """
        pass

    def PrintBmp(
      self,
      _bitmap: TGIS_Bitmap
    ) -> None: 
        """
        Print the control on the given bitmap.

        Args:
            _bitmap: bitmap to print on

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PrintableControl.PrintBmp_TGIS_Bitmap
        """
        pass

    @property
    def InternalName(
      self
    ) -> str: 
        """
        Used for internal use of TatukGIS.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PrintableControl.InternalName
        """
        pass

    @InternalName.setter
    def InternalName(
      self,
      _value: str
    ) -> None: 
        """
        Used for internal use of TatukGIS.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PrintableControl.InternalName
        """
        pass

class IGIS_Printer:
    """
    Common API for printer control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Printer
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Printer.Create_void
        """
        pass

class IGIS_Viewer3D:
    """
    Common API for 3D viewing operations.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.Create_void
        """
        pass

    def ControlRepaint(
      self
    ) -> None: 
        """
        Issue control repainting action (shallow refresh).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ControlRepaint_void
        """
        pass

    def DoGesture(
      self,
      _dragdx: short,
      _dragdy: short,
      _zoomxpos: short,
      _zoomypos: short,
      _zoomdistance: float,
      _camerapositiondx: short,
      _camerapositiondy: short,
      _paramex: float
    ) -> None: 
        """
        Do gesture.

        Args:
            _dragdx: change of x coordinate for dragging
            _dragdy: change of y coordinate for dragging
            _zoomxpos: x coordinate of zoom center position
            _zoomypos: y coordinate of zoom center position
            _zoomdistance: zoom distance; if set to 1 then nothing is done
            _camerapositiondx: change of x coordinate for camera position mode
            _camerapositiondy: change of y coordinate for camera position mode
            _paramex: not used

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DoGesture_SmallInt_SmallInt_SmallInt_SmallInt_Double_SmallInt_SmallInt_Double
        """
        pass

    def DoMouseDown(
      self,
      _xpos: short,
      _ypos: short
    ) -> None: 
        """
        Perform interactive action on mouse message defined by current Mode.

        Args:
            _xpos: x mouse position
            _ypos: y mouse position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DoMouseDown_SmallInt_SmallInt
        """
        pass

    def DoMouseMove(
      self,
      _xpos: short,
      _ypos: short
    ) -> None: 
        """
        Perform interactive action on mouse message defined by current Mode.

        Args:
            _xpos: x mouse position
            _ypos: y mouse position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DoMouseMove_SmallInt_SmallInt
        """
        pass

    def DoMouseUp(
      self
    ) -> None: 
        """
        Perform interactive action on mouse message defined by current Mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DoMouseUp_void
        """
        pass

    def Drag(
      self,
      _delta: TGIS_Point3D
    ) -> None: 
        """
        Drag scene left, right, forward or backward by delta in map units

        Args:
            _delta: delta values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.Drag_TGIS_Point3D
        """
        pass

    def DragEx(
      self,
      _delta: TGIS_Point3D
    ) -> None: 
        """
        Drag scene left, right, forward+up or backward+down by delta in map units

        Args:
            _delta: delta values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DragEx_TGIS_Point3D
        """
        pass

    def Draw(
      self
    ) -> None: 
        """
        Draw scene

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.Draw_void
        """
        pass

    def FullExtent(
      self
    ) -> None: 
        """
        Set view to initial state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.FullExtent_void
        """
        pass

    def GestureBegin(
      self
    ) -> None: 
        """
        Start gesture.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.GestureBegin_void
        """
        pass

    def GestureEnd(
      self
    ) -> None: 
        """
        Finish gesture.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.GestureEnd_void
        """
        pass

    def GetDemLevelAtReferencePointer(
      self
    ) -> float: 
        """
        Get height where reference pointer crosses DEM

        Returns:
            Height in vertical units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.GetDemLevelAtReferencePointer_void
        """
        pass

    def GetFps(
      self
    ) -> int: 
        """
        Get rendering speed in frames-per-second

        Returns:
            Frame per seconds.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.GetFps_void
        """
        pass

    def InitialRedraw(
      self,
      _extent: TGIS_Extent,
      _initdraw: bool
    ) -> bool: 
        """
        Construct an instance of 3D Viewer

        Args:
            _extent: extent restriction (all objects outside will be cut off)
            _initdraw: draw initial view if True, do not draw if False

        Returns:
            True if success

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.InitialRedraw_TGIS_Extent_Boolean
        """
        pass

    def Locate(
      self,
      _pt: TPoint,
      _prec: int
    ) -> TGIS_ShapeAbstract: 
        """
        Select object in 3D (as in 2D mode)

        Args:
            _pt: screen coordinate
            _prec: precision in pixels (must be &gt;= 0)

        Returns:
            Shape itself or nil,

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.Locate_TPoint_Integer
        """
        pass

    def Locate3D(
      self,
      _pt: TPoint,
      _prec: int,
      _layer: VarParameter,
      _ptg: VarParameter,
      _shp: VarParameter,
      _part: VarParameter
    ) -> bool: 
        """
        Select object in 3D

        Args:
            _pt: screen coordinate
            _prec: precision in pixels (must be &gt;= 0)
            _layer: input : layer to be searched, if nil all layers will be searched output : 
              layer contained located object, if nil no object located; the value (in/out) is passed 
              as TGIS_LayerAbstract in _layer.Value property
            _ptg: hitting point; the value (in/out) is passed as TGIS_Point3D in _ptg.Value property
            _shp: located shape or nil; the value (in/out) is passed as TGIS_ShapeAbstract in 
              _shp.Value property
            _part: located shape part number; the value (in/out) is passed as int in _part.Value 
              property

        Returns:
            True if shape was found

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.Locate3D_TPoint_Integer_TGIS_LayerAbstract_TGIS_Point3D_TGIS_ShapeAbstract_Integer
        """
        pass

    def Lock(
      self
    ) -> None: 
        """
        Stop rendering and wait for GeneralUnlock Must be paired with Unlock.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.Lock_void
        """
        pass

    def LockUpdates(
      self
    ) -> None: 
        """
        Prepare navigate operation - for example set draft mode. Must be paired with UnlockUpdates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.LockUpdates_void
        """
        pass

    def MarkShape(
      self,
      _layer: TGIS_LayerAbstract,
      _shpid: int,
      _part: int,
      _color: TGIS_Color,
      _update: bool
    ) -> None: 
        """
        Mark shape with color

        Args:
            _layer: layer contained shape
            _shpid: shape to be marked
            _part: shape part to be marked, -1 if entire shape
            _color: color used to mark shape
            _update: if True redraw scene after mark, do not redraw if False

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.MarkShape_TGIS_LayerAbstract_Integer_Integer_TGIS_Color_Boolean
        """
        pass

    def Move(
      self,
      _delta: TGIS_Point3D
    ) -> None: 
        """
        Move scene along XY axis by delta values expressed in map units

        Args:
            _delta: delta values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.Move_TGIS_Point3D
        """
        pass

    def PrintBegin(
      self,
      _width: int,
      _height: int
    ) -> TPoint: 
        """
        Get size of tile used while tiling.

        Args:
            _width: output bitmap width
            _height: output bitmap height

        Returns:
            Tile size to be used as a param in PrintTile method

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.PrintBegin_Integer_Integer
        """
        pass

    def PrintBmp(
      self,
      _rect: TRect,
      _bmp: TGIS_Bitmap
    ) -> None: 
        """
        Dump required screen rectangle to a bitmap

        Args:
            _rect: required screen rectangle to be returned as TGIS_Bitmap
            _bmp: 32 bits TBitmap returned as a result

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.PrintBmp_TRect_TGIS_Bitmap
        """
        pass

    def PrintEnd(
      self
    ) -> None: 
        """
        Close printing using tiles.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.PrintEnd_void
        """
        pass

    def PrintTile(
      self,
      _bmp: TGIS_Bitmap,
      _offsetx: int,
      _offsety: int
    ) -> None: 
        """
        Dump visible screen rectangle to a bitmap

        Args:
            _bmp: 32 bits TBitmap filled with tile data
            _offsetx: offset in x direction (in pixels)
            _offsety: offset in x direction (in pixels)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.PrintTile_TGIS_Bitmap_Integer_Integer
        """
        pass

    def RayIntersectDem(
      self,
      _orig: TGIS_Point3D,
      _dir: TGIS_Point3D,
      _ptg: VarParameter
    ) -> bool: 
        """
        Get intersection point between a ray and a DEM

        Args:
            _orig: ray origin coordinates in map units
            _dir: ray direction
            _ptg: intersection point between a ray and a DEM if Result = True; the value (in/out) 
              is passed as TGIS_Point3D in _ptg.Value property

        Returns:
            True if ray intersects DEM, False if not

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.RayIntersectDem_TGIS_Point3D_TGIS_Point3D_TGIS_Point3D
        """
        pass

    def ResetView(
      self
    ) -> None: 
        """
        Set view to initial state (like FullExtent in 2D).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ResetView_void
        """
        pass

    def Rotate(
      self,
      _delta: TGIS_Point3D
    ) -> None: 
        """
        Rotate view by delta values expressed in radians

        Args:
            _delta: delta values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.Rotate_TGIS_Point3D
        """
        pass

    def ScreenToMap(
      self,
      _pt: TPoint
    ) -> TGIS_Point: 
        """
        Get the mouse position on ReferenceLevel in map units

        Args:
            _pt: screen pixel position

        Returns:
            screen coordinates converted to map coordinates

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ScreenToMap_TPoint
        """
        pass

    def ScreenToMap3D(
      self,
      _pt: TPoint
    ) -> TGIS_Point3D: 
        """
        Get map coordinates of screen pixel

        Args:
            _pt: screen pixel position

        Returns:
            screen coordinates converted to map coordinates

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ScreenToMap3D_TPoint
        """
        pass

    def StoreMousePos(
      self,
      _value: TPoint
    ) -> None: 
        """
        Mouse position (necessary in ZoomMode only)

        Args:
            _value: last mouseDown position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.StoreMousePos_TPoint
        """
        pass

    def Unlock(
      self
    ) -> None: 
        """
        Cancels GeneralLock, continue rendering Must be paired with Lock.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.Unlock_void
        """
        pass

    def UnlockUpdates(
      self
    ) -> None: 
        """
        Finalize navigate operation. Must be paired with LockUpdates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.UnlockUpdates_void
        """
        pass

    def UnMarkShape(
      self,
      _layer: TGIS_LayerAbstract,
      _shpid: int,
      _update: bool
    ) -> None: 
        """
        Cancel previously marked shape with color

        Args:
            _layer: layer contained shape
            _shpid: shape to be unmarked
            _update: if True redraw scene after mark, do not redraw if False

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.UnMarkShape_TGIS_LayerAbstract_Integer_Boolean
        """
        pass

    def UpdateAllSelectedObjects(
      self
    ) -> None: 
        """
        Redraw all selected objects.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.UpdateAllSelectedObjects_void
        """
        pass

    def UpdateTopmost(
      self
    ) -> None: 
        """
        Issue control update action (topmost refresh).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.UpdateTopmost_void
        """
        pass

    def UpdateWholeMap(
      self
    ) -> None: 
        """
        Issue control update action (deep refresh).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.UpdateWholeMap_void
        """
        pass

    def ZoomBy(
      self,
      _value: float,
      _x: int,
      _y: int
    ) -> None: 
        """
        Zoom view by factor (screen center if AdvNavigation = False, mouse position if AdvNavigation 
        = True.

        Args:
            _value: zoom multiplier to multiply current zoom value
            _x: center point x coordinate
            _y: center point y coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ZoomBy_Double_Integer_Integer
        """
        pass

    @property
    def AdvNavigation(
      self
    ) -> bool: 
        """
        Standard / AdvanceNavigation switch if True mouse location become a rotation point 
        if False screen center is a rotation point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.AdvNavigation
        """
        pass

    @AdvNavigation.setter
    def AdvNavigation(
      self,
      _value: bool
    ) -> None: 
        """
        Standard / AdvanceNavigation switch if True mouse location become a rotation point 
        if False screen center is a rotation point

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.AdvNavigation
        """
        pass

    @property
    def AllowDemTransparency(
      self
    ) -> bool: 
        """
        Get AllowDemTransparency status. True allows DEM to be transparent, False will follow 
        DEM layer property settings

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.AllowDemTransparency
        """
        pass

    @AllowDemTransparency.setter
    def AllowDemTransparency(
      self,
      _value: bool
    ) -> None: 
        """
        Get AllowDemTransparency status. True allows DEM to be transparent, False will follow 
        DEM layer property settings

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.AllowDemTransparency
        """
        pass

    @property
    def BasePlane(
      self
    ) -> TGIS_Viewer3DBasePlane: 
        """
        BasePlane parameters, active, level &amp; colors

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.BasePlane
        """
        pass

    @BasePlane.setter
    def BasePlane(
      self,
      _value: TGIS_Viewer3DBasePlane
    ) -> None: 
        """
        BasePlane parameters, active, level &amp; colors

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.BasePlane
        """
        pass

    @property
    def CameraPosition(
      self
    ) -> TGIS_Point3D: 
        """
        Camera position in radians; Changes of CameraPosition settings change CameraRotation 
        settings; Camera always points to the central point of the visible area; * X height 
        of the camera above horizon, range 0 - Pi/2 rad; * Y azimuth to the camera from natural 
        north, range 0 - 2Pi rad; * Z distance to the camera in map units; * M optional parameter, 
        for future use.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.CameraPosition
        """
        pass

    @CameraPosition.setter
    def CameraPosition(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        Camera position in radians; Changes of CameraPosition settings change CameraRotation 
        settings; Camera always points to the central point of the visible area; * X height 
        of the camera above horizon, range 0 - Pi/2 rad; * Y azimuth to the camera from natural 
        north, range 0 - 2Pi rad; * Z distance to the camera in map units; * M optional parameter, 
        for future use.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.CameraPosition
        """
        pass

    @property
    def CameraPositionEx(
      self
    ) -> TGIS_Point3D: 
        """
        Camera position in XYZ in map units Changes of CameraPositionEx settings do not change 
        CameraRotation settings; * X x coordinate; * Y y coordinate; * Z z coordinate; * 
        M optional parameter, for future use.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.CameraPositionEx
        """
        pass

    @CameraPositionEx.setter
    def CameraPositionEx(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        Camera position in XYZ in map units Changes of CameraPositionEx settings do not change 
        CameraRotation settings; * X x coordinate; * Y y coordinate; * Z z coordinate; * 
        M optional parameter, for future use.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.CameraPositionEx
        """
        pass

    @property
    def CameraRotation(
      self
    ) -> TGIS_Point3D: 
        """
        Camera rotation in radians; * X x rotation, vertical , range +- Pi/2 rad; * Y y rotation, 
        inclination, range +- Pi/2 rad; * Z z rotation, horizontal , range 0 - 2Pi rad; * 
        M camera focal length in millimeters, range 20 - 500 mm (default 50).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.CameraRotation
        """
        pass

    @CameraRotation.setter
    def CameraRotation(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        Camera rotation in radians; * X x rotation, vertical , range +- Pi/2 rad; * Y y rotation, 
        inclination, range +- Pi/2 rad; * Z z rotation, horizontal , range 0 - 2Pi rad; * 
        M camera focal length in millimeters, range 20 - 500 mm (default 50).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.CameraRotation
        """
        pass

    @property
    def CutAbove(
      self
    ) -> float: 
        """
        Set CutAbove value for DEM cells with z &gt; CutAbove

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.CutAbove
        """
        pass

    @CutAbove.setter
    def CutAbove(
      self,
      _value: float
    ) -> None: 
        """
        Set CutAbove value for DEM cells with z &gt; CutAbove

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.CutAbove
        """
        pass

    @property
    def CutBelow(
      self
    ) -> float: 
        """
        Set CutBelow value for DEM cells with z &lt; CutBelow

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.CutBelow
        """
        pass

    @CutBelow.setter
    def CutBelow(
      self,
      _value: float
    ) -> None: 
        """
        Set CutBelow value for DEM cells with z &lt; CutBelow

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.CutBelow
        """
        pass

    @property
    def DemCachedSize(
      self
    ) -> TGIS_Viewer3DDemCacheSize: 
        """
        Grid size used to display regular DEMs &amp; IMAGEs

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DemCachedSize
        """
        pass

    @DemCachedSize.setter
    def DemCachedSize(
      self,
      _value: TGIS_Viewer3DDemCacheSize
    ) -> None: 
        """
        Grid size used to display regular DEMs &amp; IMAGEs

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DemCachedSize
        """
        pass

    @property
    def DemDetailExtentFactor(
      self
    ) -> float: 
        """
        Extent in which DEM is displayed in max LevelOfDetail (must be &gt;= 0.5, 1 means 
        screen width).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DemDetailExtentFactor
        """
        pass

    @DemDetailExtentFactor.setter
    def DemDetailExtentFactor(
      self,
      _value: float
    ) -> None: 
        """
        Extent in which DEM is displayed in max LevelOfDetail (must be &gt;= 0.5, 1 means 
        screen width).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DemDetailExtentFactor
        """
        pass

    @property
    def DemDraftExtentFactor(
      self
    ) -> float: 
        """
        Extent in which DEM is displayed in lower LevelOfDetail (must be &gt;= 1.0, 4 means 
        4 times screen width).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DemDraftExtentFactor
        """
        pass

    @DemDraftExtentFactor.setter
    def DemDraftExtentFactor(
      self,
      _value: float
    ) -> None: 
        """
        Extent in which DEM is displayed in lower LevelOfDetail (must be &gt;= 1.0, 4 means 
        4 times screen width).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DemDraftExtentFactor
        """
        pass

    @property
    def DemGridSize(
      self
    ) -> int: 
        """
        Current grid size setting.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DemGridSize
        """
        pass

    @property
    def DemIsolineColor(
      self
    ) -> TGIS_Color: 
        """
        Isoline color

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DemIsolineColor
        """
        pass

    @DemIsolineColor.setter
    def DemIsolineColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Isoline color

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DemIsolineColor
        """
        pass

    @property
    def DemIsolineGap(
      self
    ) -> float: 
        """
        Isoline gap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DemIsolineGap
        """
        pass

    @DemIsolineGap.setter
    def DemIsolineGap(
      self,
      _value: float
    ) -> None: 
        """
        Isoline gap

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DemIsolineGap
        """
        pass

    @property
    def DemWalls(
      self
    ) -> TGIS_Viewer3DDemWall: 
        """
        DEM wall types

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DemWalls
        """
        pass

    @DemWalls.setter
    def DemWalls(
      self,
      _value: TGIS_Viewer3DDemWall
    ) -> None: 
        """
        DEM wall types

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.DemWalls
        """
        pass

    @property
    def EdgesColor(
      self
    ) -> TGIS_Color: 
        """
        Vector edges color

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.EdgesColor
        """
        pass

    @EdgesColor.setter
    def EdgesColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Vector edges color

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.EdgesColor
        """
        pass

    @property
    def ErrorMessage(
      self
    ) -> str: 
        """
        Get error message String.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ErrorMessage
        """
        pass

    @property
    def FastMode(
      self
    ) -> bool: 
        """
        Block scene redrawing when set to True, immediately redraws scene when set to False

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.FastMode
        """
        pass

    @FastMode.setter
    def FastMode(
      self,
      _value: bool
    ) -> None: 
        """
        Block scene redrawing when set to True, immediately redraws scene when set to False

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.FastMode
        """
        pass

    @property
    def Flood(
      self
    ) -> TGIS_Viewer3DFlood: 
        """
        Flood parameters, active, level &amp; color, transparency

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.Flood
        """
        pass

    @Flood.setter
    def Flood(
      self,
      _value: TGIS_Viewer3DFlood
    ) -> None: 
        """
        Flood parameters, active, level &amp; color, transparency

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.Flood
        """
        pass

    @property
    def HideLabelsUponNavigation(
      self
    ) -> bool: 
        """
        Labels not drawn during scene navigation etc. Default is off what means display labels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.HideLabelsUponNavigation
        """
        pass

    @HideLabelsUponNavigation.setter
    def HideLabelsUponNavigation(
      self,
      _value: bool
    ) -> None: 
        """
        Labels not drawn during scene navigation etc. Default is off what means display labels.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.HideLabelsUponNavigation
        """
        pass

    @property
    def IgnoreAbove(
      self
    ) -> float: 
        """
        Set noDataValue for DEM cells with z &gt; IgnoreAbove value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.IgnoreAbove
        """
        pass

    @IgnoreAbove.setter
    def IgnoreAbove(
      self,
      _value: float
    ) -> None: 
        """
        Set noDataValue for DEM cells with z &gt; IgnoreAbove value

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.IgnoreAbove
        """
        pass

    @property
    def IgnoreBelow(
      self
    ) -> float: 
        """
        Set noDataValue for DEM cells with z &lt; IgnoreBelow value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.IgnoreBelow
        """
        pass

    @IgnoreBelow.setter
    def IgnoreBelow(
      self,
      _value: float
    ) -> None: 
        """
        Set noDataValue for DEM cells with z &lt; IgnoreBelow value

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.IgnoreBelow
        """
        pass

    @property
    def IgnoreEllipsoidHeight(
      self
    ) -> bool: 
        """
        If set to True, differences in Z value caused by different ellipsoids will be ignored

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.IgnoreEllipsoidHeight
        """
        pass

    @IgnoreEllipsoidHeight.setter
    def IgnoreEllipsoidHeight(
      self,
      _value: bool
    ) -> None: 
        """
        If set to True, differences in Z value caused by different ellipsoids will be ignored

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.IgnoreEllipsoidHeight
        """
        pass

    @property
    def IsBusy(
      self
    ) -> bool: 
        """
        Flag. If True, Viewer is busy in painting.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.IsBusy
        """
        pass

    @property
    def KeepSunCamera(
      self
    ) -> bool: 
        """
        Check for keeping sun and camera positions relative.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.KeepSunCamera
        """
        pass

    @KeepSunCamera.setter
    def KeepSunCamera(
      self,
      _value: bool
    ) -> None: 
        """
        Check for keeping sun and camera positions relative.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.KeepSunCamera
        """
        pass

    @property
    def LightVector(
      self
    ) -> bool: 
        """
        Revers Light normal Vector

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.LightVector
        """
        pass

    @LightVector.setter
    def LightVector(
      self,
      _value: bool
    ) -> None: 
        """
        Revers Light normal Vector

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.LightVector
        """
        pass

    @property
    def Mode(
      self
    ) -> TGIS_Viewer3DMode: 
        """
        Viewer3D mode working mode (camera mode, sun, zoom, select ...).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.Mode
        """
        pass

    @Mode.setter
    def Mode(
      self,
      _value: TGIS_Viewer3DMode
    ) -> None: 
        """
        Viewer3D mode working mode (camera mode, sun, zoom, select ...).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.Mode
        """
        pass

    @property
    def OrthoView(
      self
    ) -> bool: 
        """
        Orthogonal View switch, if, True camera looks orthogonally, camera can be moved only 
        in XY plane, zoom is allowed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.OrthoView
        """
        pass

    @OrthoView.setter
    def OrthoView(
      self,
      _value: bool
    ) -> None: 
        """
        Orthogonal View switch, if, True camera looks orthogonally, camera can be moved only 
        in XY plane, zoom is allowed

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.OrthoView
        """
        pass

    @property
    def PixelSize(
      self
    ) -> TGIS_Point: 
        """
        Get the pixel size (xsize &amp; ysize) at reference point in map units

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.PixelSize
        """
        pass

    @property
    def ReferencePoint(
      self
    ) -> TGIS_Point3D: 
        """
        ReferencePoint in map units, usually screen center. Use ReferencePointMode/ReferencePointOffsetZ 
        properties to set.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ReferencePoint
        """
        pass

    @ReferencePoint.setter
    def ReferencePoint(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        ReferencePoint in map units, usually screen center. Use ReferencePointMode/ReferencePointOffsetZ 
        properties to set.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ReferencePoint
        """
        pass

    @property
    def ReferencePointMode(
      self
    ) -> TGIS_Viewer3DReferenceMode: 
        """
        Set reference (rotation) point to one of GIS_3DReferencePoint type: Base, Zero, OnDem, 
        Lowest, Highest, FlyOnDem

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ReferencePointMode
        """
        pass

    @ReferencePointMode.setter
    def ReferencePointMode(
      self,
      _value: TGIS_Viewer3DReferenceMode
    ) -> None: 
        """
        Set reference (rotation) point to one of GIS_3DReferencePoint type: Base, Zero, OnDem, 
        Lowest, Highest, FlyOnDem

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ReferencePointMode
        """
        pass

    @property
    def ReferencePointOffsetZ(
      self
    ) -> float: 
        """
        Set reference (rotation) point Z value offset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ReferencePointOffsetZ
        """
        pass

    @ReferencePointOffsetZ.setter
    def ReferencePointOffsetZ(
      self,
      _value: float
    ) -> None: 
        """
        Set reference (rotation) point Z value offset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ReferencePointOffsetZ
        """
        pass

    @property
    def Scale(
      self
    ) -> float: 
        """
        Setting up and reading the 3D scale factor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.Scale
        """
        pass

    @Scale.setter
    def Scale(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the 3D scale factor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.Scale
        """
        pass

    @property
    def ScaleAsText(
      self
    ) -> str: 
        """
        Setting up and reading the 3D scale factor as text in format ''1:10000''.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ScaleAsText
        """
        pass

    @ScaleAsText.setter
    def ScaleAsText(
      self,
      _value: str
    ) -> None: 
        """
        Setting up and reading the 3D scale factor as text in format ''1:10000''.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ScaleAsText
        """
        pass

    @property
    def ScaleM(
      self
    ) -> float: 
        """
        M scaling; default is 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ScaleM
        """
        pass

    @ScaleM.setter
    def ScaleM(
      self,
      _value: float
    ) -> None: 
        """
        M scaling; default is 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ScaleM
        """
        pass

    @property
    def ScaleZ(
      self
    ) -> float: 
        """
        Z scaling; default is 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ScaleZ
        """
        pass

    @ScaleZ.setter
    def ScaleZ(
      self,
      _value: float
    ) -> None: 
        """
        Z scaling; default is 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ScaleZ
        """
        pass

    @property
    def ShadowsLevel(
      self
    ) -> int: 
        """
        Shadows level; 0..100; 0-deep shadows, 100-light shadows

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ShadowsLevel
        """
        pass

    @ShadowsLevel.setter
    def ShadowsLevel(
      self,
      _value: int
    ) -> None: 
        """
        Shadows level; 0..100; 0-deep shadows, 100-light shadows

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ShadowsLevel
        """
        pass

    @property
    def ShowDemTexture(
      self
    ) -> bool: 
        """
        Turn Texture on/off. Default is on

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ShowDemTexture
        """
        pass

    @ShowDemTexture.setter
    def ShowDemTexture(
      self,
      _value: bool
    ) -> None: 
        """
        Turn Texture on/off. Default is on

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ShowDemTexture
        """
        pass

    @property
    def ShowLabels(
      self
    ) -> bool: 
        """
        Labels mode on/off. Default is on what means display labels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ShowLabels
        """
        pass

    @ShowLabels.setter
    def ShowLabels(
      self,
      _value: bool
    ) -> None: 
        """
        Labels mode on/off. Default is on what means display labels.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ShowLabels
        """
        pass

    @property
    def ShowLights(
      self
    ) -> bool: 
        """
        Turn Lights on/off. Default is off (what means perfectly diffused light). On means 
        that scene lights like sun etc are turned on.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ShowLights
        """
        pass

    @ShowLights.setter
    def ShowLights(
      self,
      _value: bool
    ) -> None: 
        """
        Turn Lights on/off. Default is off (what means perfectly diffused light). On means 
        that scene lights like sun etc are turned on.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ShowLights
        """
        pass

    @property
    def ShowReferencePoint(
      self
    ) -> bool: 
        """
        Turn ReferencePoint drawing on/off. Default is on (what means that ReferencePoint 
        is drawn). ReferencePoint is an arrow pointing from ReferencePoint to a "natural" 
        north.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ShowReferencePoint
        """
        pass

    @ShowReferencePoint.setter
    def ShowReferencePoint(
      self,
      _value: bool
    ) -> None: 
        """
        Turn ReferencePoint drawing on/off. Default is on (what means that ReferencePoint 
        is drawn). ReferencePoint is an arrow pointing from ReferencePoint to a "natural" 
        north.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ShowReferencePoint
        """
        pass

    @property
    def ShowVectorEdges(
      self
    ) -> bool: 
        """
        Turn VectorEdges drawing on/off. Default is on when Lights are off (what means that 
        VectorEdges are drawn). When Lights are on default setting for VectorEdges is off.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ShowVectorEdges
        """
        pass

    @ShowVectorEdges.setter
    def ShowVectorEdges(
      self,
      _value: bool
    ) -> None: 
        """
        Turn VectorEdges drawing on/off. Default is on when Lights are off (what means that 
        VectorEdges are drawn). When Lights are on default setting for VectorEdges is off.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ShowVectorEdges
        """
        pass

    @property
    def ShowWireframe(
      self
    ) -> bool: 
        """
        Wire frame mode on/off. Default is off what means solid models.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ShowWireframe
        """
        pass

    @ShowWireframe.setter
    def ShowWireframe(
      self,
      _value: bool
    ) -> None: 
        """
        Wire frame mode on/off. Default is off what means solid models.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ShowWireframe
        """
        pass

    @property
    def SunPosition(
      self
    ) -> TGIS_Point: 
        """
        Sun position in radian; natural north * X height of the sun above horizon, range 
        +- Pi/2 rad; initial Pi/4 (45 deg) * Y azimuth to the sun from natural north, range 
        0 - 2Pi rad; initial 3Pi/4 (225 deg)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.SunPosition
        """
        pass

    @SunPosition.setter
    def SunPosition(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Sun position in radian; natural north * X height of the sun above horizon, range 
        +- Pi/2 rad; initial Pi/4 (45 deg) * Y azimuth to the sun from natural north, range 
        0 - 2Pi rad; initial 3Pi/4 (225 deg)

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.SunPosition
        """
        pass

    @property
    def TransparencyPriority(
      self
    ) -> TGIS_Viewer3DTransparencyPriority: 
        """
        Transparency priority. Order of DEM/vector rendering. Types of transparency priority 
        in case that both DEM &amp; vector are transparent (default is Auto)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.TransparencyPriority
        """
        pass

    @TransparencyPriority.setter
    def TransparencyPriority(
      self,
      _value: TGIS_Viewer3DTransparencyPriority
    ) -> None: 
        """
        Transparency priority. Order of DEM/vector rendering. Types of transparency priority 
        in case that both DEM &amp; vector are transparent (default is Auto)

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.TransparencyPriority
        """
        pass

    @property
    def UniverseColor(
      self
    ) -> TGIS_Color: 
        """
        3D viewer color of area which exceeds map extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.UniverseColor
        """
        pass

    @UniverseColor.setter
    def UniverseColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        3D viewer color of area which exceeds map extent

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.UniverseColor
        """
        pass

    @property
    def VectorExtentFactor(
      self
    ) -> float: 
        """
        Extent from which vector is displayed (must be &gt;= 1.0, 2 means 2 times screen 
        width).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.VectorExtentFactor
        """
        pass

    @VectorExtentFactor.setter
    def VectorExtentFactor(
      self,
      _value: float
    ) -> None: 
        """
        Extent from which vector is displayed (must be &gt;= 1.0, 2 means 2 times screen 
        width).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.VectorExtentFactor
        """
        pass

    @property
    def VectorSimplification(
      self
    ) -> bool: 
        """
        Enable/disable vector simplification process.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.VectorSimplification
        """
        pass

    @VectorSimplification.setter
    def VectorSimplification(
      self,
      _value: bool
    ) -> None: 
        """
        Enable/disable vector simplification process.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.VectorSimplification
        """
        pass

    @property
    def VectorSmartSize(
      self
    ) -> int: 
        """
        Shape size in pixels, less or equal will not be displayed ( must be &gt;= 0 )

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.VectorSmartSize
        """
        pass

    @VectorSmartSize.setter
    def VectorSmartSize(
      self,
      _value: int
    ) -> None: 
        """
        Shape size in pixels, less or equal will not be displayed ( must be &gt;= 0 )

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.VectorSmartSize
        """
        pass

    @property
    def ViewRestriction(
      self
    ) -> TGIS_Viewer3DViewRestriction: 
        """
        Current 3D view restrictions.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ViewRestriction
        """
        pass

    @ViewRestriction.setter
    def ViewRestriction(
      self,
      _value: TGIS_Viewer3DViewRestriction
    ) -> None: 
        """
        Current 3D view restrictions.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.ViewRestriction
        """
        pass

    @property
    def VisibleExtent(
      self
    ) -> TGIS_Extent: 
        """
        Get/set 2D extent visible in 3D window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.VisibleExtent
        """
        pass

    @VisibleExtent.setter
    def VisibleExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Get/set 2D extent visible in 3D window.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.VisibleExtent
        """
        pass

    @property
    def VisibleExtent3D(
      self
    ) -> TGIS_Extent3D: 
        """
        Get 3D extent visible in 3D window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.VisibleExtent3D
        """
        pass

    @WallsColor.setter
    def WallsColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        DEM wall color

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.WallsColor
        """
        pass

    @property
    def Zoom(
      self
    ) -> float: 
        """
        Get 3D zoom, same as TGIS_Viewer.Zoom

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_Viewer3D.Zoom
        """
        pass

class TGIS_ConfigFormat:
    pass

class TGIS_ConfigFormat:
    """
    Types of config format.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigFormat
    """

    @property
    def Unknown(
      self
    ) -> TGIS_ConfigFormat: 
        """
        Unknown format.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigFormat.Unknown
        """
        pass

    @property
    def Ini(
      self
    ) -> TGIS_ConfigFormat: 
        """
        Configuration save as Ini file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigFormat.Ini
        """
        pass

    @property
    def Xml(
      self
    ) -> TGIS_ConfigFormat: 
        """
        Configuration save as Xml file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigFormat.Xml
        """
        pass

class TGIS_LayerAbstractList:
    """
    List of TGIS_Layer objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerAbstractList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_LayerAbstract:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_LayerAbstract
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerAbstractList.Create_void
        """
        pass

    def Add(
      self,
      _item: TGIS_LayerAbstract
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerAbstractList.Add_TGIS_LayerAbstract
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerAbstractList.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerAbstractList.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerAbstractList.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> TGIS_LayerAbstract: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerAbstractList.Item
        """
        pass

class TGIS_ShapeAbstractList:
    """
    List of TGIS_ShapeAbstract objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeAbstractList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_ShapeAbstract:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_ShapeAbstract
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeAbstractList.Create_void
        """
        pass

    def Add(
      self,
      _item: TGIS_ShapeAbstract
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeAbstractList.Add_TGIS_ShapeAbstract
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeAbstractList.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeAbstractList.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeAbstractList.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> TGIS_ShapeAbstract: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeAbstractList.Item
        """
        pass

class TGIS_ConfigAbstract( TObject ):
    """
    Stub parent for TGIS_Config.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ConfigAbstract.Create_void
        """
        pass

class TGIS_LayerAbstract( TObject ):
    """
    Stub parent for TGIS_Layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerAbstract.Create_void
        """
        pass

class TGIS_ShapeAbstract( TObject ):
    """
    Stub parent for TGIS_Shape.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeAbstract.Create_void
        """
        pass

class TGIS_LabelsAreaAbstract( TObject ):
    """
    Stub parent for TGIS_LabelsArea.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelsAreaAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelsAreaAbstract.Create_void
        """
        pass

    def AddDuplicated(
      self,
      _label: str
    ) -> None: 
        """
        Add a given label to a duplicated list.

        Args:
            _label: label text to added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelsAreaAbstract.AddDuplicated_String
        """
        pass

    def Allocate(
      self,
      _rect: TGIS_Extent,
      _layer: int,
      _uid: TGIS_Uid,
      _tolerance: float
    ) -> bool: 
        """
        Reserve extent for label in Label Area Allocator. This operation avoids overlapping.

        Args:
            _rect: extent to be reserved;
            _layer: layer to which label belongs
            _uid: Uid of shape related with label
            _tolerance: tolerance of label placement in device pixels; generally should be expressed 
              like 1.5/GIS.Zoom

        Returns:
            True if place for label was found and has been allocated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelsAreaAbstract.Allocate_TGIS_Extent_Integer_TGIS_Uid_Double
        """
        pass

    def AllocateEx(
      self,
      _ptgA: TGIS_Point,
      _ptgB: TGIS_Point,
      _ptgC: TGIS_Point,
      _ptgD: TGIS_Point,
      _layer: int,
      _uid: TGIS_Uid,
      _tolerance: float
    ) -> bool: 
        """
        Reserve extent for a 4 node polygon in the Label Area Allocator. This operation avoids 
        overlapping.

        Args:
            _ptgA: point of polygon
            _ptgB: point of polygon
            _ptgC: point of polygon
            _ptgD: point of polygon
            _layer: layer to which label belongs
            _uid: Uid of shape related with label
            _tolerance: tolerance of label placement in device pixels; generally should be expressed 
              like 1.5/GIS.Zoom

        Returns:
            True if place for label was found and has been allocated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelsAreaAbstract.AllocateEx_TGIS_Point_TGIS_Point_TGIS_Point_TGIS_Point_Integer_TGIS_Uid_Double
        """
        pass

    def FindShape(
      self,
      _ptg: TGIS_Point,
      _layer: int,
      _uid: VarParameter
    ) -> bool: 
        """
        Find a shape uid related with label close to a point.

        Args:
            _ptg: point
            _layer: layer to which label belongs
            _uid: Uid of shape related with label; the value (in/out) is passed as TGIS_Uid in 
              _uid.Value property

        Returns:
            Found shape or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelsAreaAbstract.FindShape_TGIS_Point_Integer_TGIS_Uid
        """
        pass

    def IsAny(
      self,
      _layer: int,
      _uid: TGIS_Uid
    ) -> bool: 
        """
        Check if there is any label for particular shape already allocated.

        Args:
            _layer: layer to which label belongs
            _uid: Uid of shape related with label

        Returns:
            True if label is allocated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelsAreaAbstract.IsAny_Integer_TGIS_Uid
        """
        pass

    def IsDuplicated(
      self,
      _label: str
    ) -> bool: 
        """
        Test if a given label was already allocated.

        Args:
            _label: label to be tested

        Returns:
            True if item already exist on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelsAreaAbstract.IsDuplicated_String
        """
        pass

    def Reset(
      self
    ) -> None: 
        """
        Free all reserved areas.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelsAreaAbstract.Reset_void
        """
        pass

class TGIS_ViewerRef:
    """
    IGIS_Viewer reference, used to avoid calling on _AddRef, _Release upon every

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerRef
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerRef.Create_void
        """
        pass

    @property
    def Ref(
      self
    ) -> IGIS_Viewer: 
        """
        Referenced viewer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerRef.Ref
        """
        pass

    @Ref.setter
    def Ref(
      self,
      _value: IGIS_Viewer
    ) -> None: 
        """
        Referenced viewer

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerRef.Ref
        """
        pass

class TGIS_VectorToGridCoordinate:
    pass

class TGIS_VectorToGridCoordinate:
    """
    Specifies coordinate used as data input for interpolation process.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VectorToGridCoordinate
    """

    @property
    def None_(
      self
    ) -> TGIS_VectorToGridCoordinate: 
        """
        Forces value of 1.0; for the purpose of concentration maps.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VectorToGridCoordinate.None
        """
        pass

    @property
    def Z(
      self
    ) -> TGIS_VectorToGridCoordinate: 
        """
        The Z coordinate.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VectorToGridCoordinate.Z
        """
        pass

    @property
    def M(
      self
    ) -> TGIS_VectorToGridCoordinate: 
        """
        The M coordinate.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VectorToGridCoordinate.M
        """
        pass

    @property
    def ZM(
      self
    ) -> TGIS_VectorToGridCoordinate: 
        """
        The sum of the Z and the M coordinate.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VectorToGridCoordinate.ZM
        """
        pass

class TGIS_PointCloudAssignment:
    pass

class TGIS_PointCloudAssignment:
    """
    Specifies cell assignment method for point cloud to grid conversion.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudAssignment
    """

    @property
    def Count(
      self
    ) -> TGIS_PointCloudAssignment: 
        """
        Number of points in cell.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudAssignment.Count
        """
        pass

    @property
    def First(
      self
    ) -> TGIS_PointCloudAssignment: 
        """
        First value found in cell.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudAssignment.First
        """
        pass

    @property
    def Last(
      self
    ) -> TGIS_PointCloudAssignment: 
        """
        Last value found in cell.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudAssignment.Last
        """
        pass

    @property
    def Min(
      self
    ) -> TGIS_PointCloudAssignment: 
        """
        Minimum value found in cell.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudAssignment.Min
        """
        pass

    @property
    def Max(
      self
    ) -> TGIS_PointCloudAssignment: 
        """
        Maximum value found in cell.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudAssignment.Max
        """
        pass

    @property
    def Mean(
      self
    ) -> TGIS_PointCloudAssignment: 
        """
        Mean value comoputed from points within cell;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudAssignment.Mean
        """
        pass

    @property
    def Range(
      self
    ) -> TGIS_PointCloudAssignment: 
        """
        Range of point values in cell.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudAssignment.Range
        """
        pass

    @property
    def IDW(
      self
    ) -> TGIS_PointCloudAssignment: 
        """
        Uses Inverse Distance Weighted interpolation for points within cell.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudAssignment.IDW
        """
        pass

    @property
    def NearestNeighbor(
      self
    ) -> TGIS_PointCloudAssignment: 
        """
        Value from the nearest point to cell center.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudAssignment.NearestNeighbor
        """
        pass

class TGIS_PointCloudFormula:
    pass

class TGIS_PointCloudFormula:
    """
    Specifies cell assignment method for NoData filling.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudFormula
    """

    @property
    def DefaultValue(
      self
    ) -> TGIS_PointCloudFormula: 
        """
        For each grid cell with NoData, DefaultValue will be assigned.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudFormula.DefaultValue
        """
        pass

    @property
    def Mean(
      self
    ) -> TGIS_PointCloudFormula: 
        """
        Computes mean value from grid cells within search window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudFormula.Mean
        """
        pass

    @property
    def IDW(
      self
    ) -> TGIS_PointCloudFormula: 
        """
        Uses Inverse Distance Weighted interpolation for grid cells within search window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudFormula.IDW
        """
        pass

    @property
    def NearestNeighbor(
      self
    ) -> TGIS_PointCloudFormula: 
        """
        Searches for nearest grid cell within search window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudFormula.NearestNeighbor
        """
        pass

    @property
    def Triangulation(
      self
    ) -> TGIS_PointCloudFormula: 
        """
        Uses Triangulation interpolation to determine value for empty grid cells. WindowSize 
        parameter is omitted. It takes longer to execute. Recommended for data with local 
        holes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudFormula.Triangulation
        """
        pass

class TGIS_InterpolatedPath( TObject ):
    """
    Base class for methods for path interpolation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.Create_void
        """
        pass

    def AddPoint(
      self,
      _pt: TGIS_Point3D
    ) -> bool: 
        """
        Adds an interpolation point.

        Args:
            _pt: point to be added

        Returns:
            True if AllowDuplicates is True and the previous point is identical

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.AddPoint_TGIS_Point3D
        """
        pass

    def Calculate(
      self,
      _t: float
    ) -> TGIS_Point3D: 
        """
        Interpolates a point.

        Args:
            _t: argument of the parametrization; should be between 0 and Span

        Returns:
            interpolated point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.Calculate_Double
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clears the list of points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.Clear_void
        """
        pass

    @overload
    def Close(
      self
    ) -> None: 
        """
        Indicates that all the interpolation points were added and prepares the interpolation 
        function; no changes can be made after Close.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.Close_void
        """
        pass

    @overload
    def Close(
      self,
      _sync: TGIS_InterpolatedPath
    ) -> None: 
        """
        Indicates that all the interpolation points were added and prepares the interpolation 
        function; no changes can be made after Close.

        Args:
            _sync: path to synchronize with

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.Close_TGIS_InterpolatedPath
        """
        pass

    def DeleteLast(
      self
    ) -> None: 
        """
        Deletes the last added point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.DeleteLast_void
        """
        pass

    def GetIntervals(
      self,
      _list: VarParameter,
      _len: VarParameter
    ) -> None: 
        """
        Gets the intervals and the total length of the path.

        Args:
            _list: list of intervals; the value (in/out) is passed as TGIS_ListOfDoubles in _list.Value 
              property
            _len: total length; the value (in/out) is passed as float in _len.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.GetIntervals_TGIS_ListOfDoubles_Double
        """
        pass

    def NextPoint(
      self,
      _t: float
    ) -> int: 
        """
        Returns the index of the next interpolation point for an argument of the parametrization.

        Args:
            _t: argument of the parametrization; should be between 0 and Span

        Returns:
            index of the next interpolation point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.NextPoint_Double
        """
        pass

    @property
    def AllowDuplicates(
      self
    ) -> bool: 
        """
        Allow subsequent points to be identical.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.AllowDuplicates
        """
        pass

    @AllowDuplicates.setter
    def AllowDuplicates(
      self,
      _value: bool
    ) -> None: 
        """
        Allow subsequent points to be identical.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.AllowDuplicates
        """
        pass

    @property
    def Closed(
      self
    ) -> bool: 
        """
        If True then interpolation was performed and no more points can be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.Closed
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        The total number of sample points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.Count
        """
        pass

    @property
    def EqualizeIntervals(
      self
    ) -> bool: 
        """
        True if the distances between the sample points should be equal.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.EqualizeIntervals
        """
        pass

    @EqualizeIntervals.setter
    def EqualizeIntervals(
      self,
      _value: bool
    ) -> None: 
        """
        True if the distances between the sample points should be equal.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.EqualizeIntervals
        """
        pass

    @property
    def LastInterval(
      self
    ) -> float: 
        """
        The last interval.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.LastInterval
        """
        pass

    @LastInterval.setter
    def LastInterval(
      self,
      _value: float
    ) -> None: 
        """
        The last interval.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.LastInterval
        """
        pass

    @property
    def LevelIntervals(
      self
    ) -> bool: 
        """
        True if the distances between the sample points should optimized (leveled).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.LevelIntervals
        """
        pass

    @LevelIntervals.setter
    def LevelIntervals(
      self,
      _value: bool
    ) -> None: 
        """
        True if the distances between the sample points should optimized (leveled).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.LevelIntervals
        """
        pass

    @property
    def Looped(
      self
    ) -> bool: 
        """
        True if the path should be a loop (closed path).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.Looped
        """
        pass

    @Looped.setter
    def Looped(
      self,
      _value: bool
    ) -> None: 
        """
        True if the path should be a loop (closed path).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.Looped
        """
        pass

    @property
    def Rotation(
      self
    ) -> bool: 
        """
        True if the sample points represent rotation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.Rotation
        """
        pass

    @Rotation.setter
    def Rotation(
      self,
      _value: bool
    ) -> None: 
        """
        True if the sample points represent rotation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.Rotation
        """
        pass

    @property
    def Span(
      self
    ) -> float: 
        """
        The span of parametrization argument.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.Span
        """
        pass

    @Span.setter
    def Span(
      self,
      _value: float
    ) -> None: 
        """
        The span of parametrization argument.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.Span
        """
        pass

    @property
    def Tolerance(
      self
    ) -> float: 
        """
        Minimum distance between sample points to be treated as separate points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.Tolerance
        """
        pass

    @Tolerance.setter
    def Tolerance(
      self,
      _value: float
    ) -> None: 
        """
        Minimum distance between sample points to be treated as separate points.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolatedPath.Tolerance
        """
        pass

class TGIS_LinearPath( TGIS_InterpolatedPath ):
    """
    Implementation of linear interpolation for path generation in 3D.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LinearPath
    """

class TGIS_CubicSplines( TGIS_InterpolatedPath ):
    """
    Implementation of cubic splines for path generation in 3D.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CubicSplines
    """

class TGIS_VectorToGridAbstract( TObject ):
    """
    Abstract class for all classes which implement grid generation from vector data.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VectorToGridAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VectorToGridAbstract.Create_void
        """
        pass

    def Generate(
      self,
      _src: TGIS_LayerVector,
      _srcext: TGIS_Extent,
      _srcfld: str,
      _dst: TGIS_LayerPixel,
      _dstext: TGIS_Extent
    ) -> None: 
        """
        Populates a pixel (grid) layer with values resulting from computations based on the 
        set of sample points from the vector layer.

        Args:
            _src: source layer which contains the sample points
            _srcext: extent of interest on the source layer
            _srcfld: the name of the numeric field which contains the values to be used for interpolation; 
              if empty then the coordinate defined by the Coordinate property will be used for 
              interpolation
            _dst: destination grid layer
            _dstext: extent on the destination layer to be populated with interpolated data

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VectorToGridAbstract.Generate_TGIS_LayerVector_TGIS_Extent_String_TGIS_LayerPixel_TGIS_Extent
        """
        pass

    @property
    def Coordinate(
      self
    ) -> TGIS_VectorToGridCoordinate: 
        """
        Defines which coordinate is taken as interpolation value if the interpolation is 
        not based on an attribute field; default is Z.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VectorToGridAbstract.Coordinate
        """
        pass

    @Coordinate.setter
    def Coordinate(
      self,
      _value: TGIS_VectorToGridCoordinate
    ) -> None: 
        """
        Defines which coordinate is taken as interpolation value if the interpolation is 
        not based on an attribute field; default is Z.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VectorToGridAbstract.Coordinate
        """
        pass

    @property
    def DefaultValue(
      self
    ) -> float: 
        """
        If UseDefaultValue is true, then this value will be set for each grid cell for which 
        the interpolated value cannot be computed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VectorToGridAbstract.DefaultValue
        """
        pass

    @DefaultValue.setter
    def DefaultValue(
      self,
      _value: float
    ) -> None: 
        """
        If UseDefaultValue is true, then this value will be set for each grid cell for which 
        the interpolated value cannot be computed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VectorToGridAbstract.DefaultValue
        """
        pass

    @property
    def UseDefaultValue(
      self
    ) -> bool: 
        """
        If true, then each grid cell for which the interpolated value cannot be computed 
        will be set to DefaultValue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VectorToGridAbstract.UseDefaultValue
        """
        pass

    @UseDefaultValue.setter
    def UseDefaultValue(
      self,
      _value: bool
    ) -> None: 
        """
        If true, then each grid cell for which the interpolated value cannot be computed 
        will be set to DefaultValue.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VectorToGridAbstract.UseDefaultValue
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VectorToGridAbstract.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VectorToGridAbstract.BusyEvent
        """
        pass

class TGIS_ShapeListStub( TObject ):
    """
    Abstract stub class for internal implementation of structured shape list used in 
    vector-to-grid computations.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeListStub
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeListStub.Create_void
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of points in the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeListStub.Count
        """
        pass

    
    def Point(
      self,
      _idx: int
    ) -> TGIS_Point: 
        """
        Access to a specific shape.

        Args:
            _idx: index of the shape in the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeListStub.Point
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> float: 
        """
        Access to a sample value of a specific shape.

        Args:
            _idx: index of the shape in the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeListStub.Value
        """
        pass

class TGIS_SemivarianceAbstract( TObject ):
    """
    Abstract class for all semivariance models.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceAbstract.Create_void
        """
        pass

    def Calculate(
      self,
      _dist: float
    ) -> float: 
        """
        Calculates the value of semivariance for a given distance.

        Args:
            _dist: distance between the sample and the data point

        Returns:
            value of semivariance for a given distance

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceAbstract.Calculate_Double
        """
        pass

    def Prepare(
      self,
      _list: TGIS_ShapeListStub
    ) -> bool: 
        """
        If necessary, performs preliminary computations; is called before Calculate for each 
        point set.

        Args:
            _list: list of shapes necessary to perform computations

        Returns:
            True if the computations succeeded; False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceAbstract.Prepare_TGIS_ShapeListStub
        """
        pass

    @property
    def Nugget(
      self
    ) -> float: 
        """
        The nugget of semivariance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceAbstract.Nugget
        """
        pass

    @Nugget.setter
    def Nugget(
      self,
      _value: float
    ) -> None: 
        """
        The nugget of semivariance.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceAbstract.Nugget
        """
        pass

class TGIS_SemivariancePowerLaw( TGIS_SemivarianceAbstract ):
    """
    Represents the power-law semivariance model.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivariancePowerLaw
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivariancePowerLaw.Create_void
        """
        pass

    @property
    def Exponent(
      self
    ) -> float: 
        """
        Power-law exponent; should be greater than or equal to 1 and less than 2; default 
        is 1.5.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivariancePowerLaw.Exponent
        """
        pass

    @Exponent.setter
    def Exponent(
      self,
      _value: float
    ) -> None: 
        """
        Power-law exponent; should be greater than or equal to 1 and less than 2; default 
        is 1.5.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivariancePowerLaw.Exponent
        """
        pass

class TGIS_SemivarianceWithRange( TGIS_SemivarianceAbstract ):
    """
    Abstract class for all semivariance models with range.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceWithRange
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceWithRange.Create_void
        """
        pass

    @property
    def Range(
      self
    ) -> float: 
        """
        Range of the semivariance formula.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceWithRange.Range
        """
        pass

    @Range.setter
    def Range(
      self,
      _value: float
    ) -> None: 
        """
        Range of the semivariance formula.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceWithRange.Range
        """
        pass

class TGIS_SemivarianceExponential( TGIS_SemivarianceWithRange ):
    """
    Represents the exponential semivariance model.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceExponential
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceExponential.Create_void
        """
        pass

class TGIS_SemivarianceGaussian( TGIS_SemivarianceWithRange ):
    """
    Represents the gaussian semivariance model.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceGaussian
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceGaussian.Create_void
        """
        pass

class TGIS_SemivarianceWithSill( TGIS_SemivarianceWithRange ):
    """
    Abstract class for all semivariance models with range and sill.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceWithSill
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceWithSill.Create_void
        """
        pass

    @property
    def Sill(
      self
    ) -> float: 
        """
        The sill of semivariance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceWithSill.Sill
        """
        pass

    @Sill.setter
    def Sill(
      self,
      _value: float
    ) -> None: 
        """
        The sill of semivariance.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceWithSill.Sill
        """
        pass

class TGIS_SemivarianceSpherical( TGIS_SemivarianceWithSill ):
    """
    Represents the spherical semivariance model.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceSpherical
    """

class TGIS_SemivarianceCircular( TGIS_SemivarianceWithSill ):
    """
    Represents the circular semivariance model.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceCircular
    """

class TGIS_SemivarianceLinear( TGIS_SemivarianceWithSill ):
    """
    Represents the linear semivariance model.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SemivarianceLinear
    """

class TGIS_InterpolationKriging( TGIS_VectorToGridAbstract ):
    """
    Implementation of the ordinary Kriging interpolation method.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationKriging
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationKriging.Create_void
        """
        pass

    @property
    def MaxPoints(
      self
    ) -> int: 
        """
        The maximum number of input data points used to interpolate at each grid cell; default 
        is 4.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationKriging.MaxPoints
        """
        pass

    @MaxPoints.setter
    def MaxPoints(
      self,
      _value: int
    ) -> None: 
        """
        The maximum number of input data points used to interpolate at each grid cell; default 
        is 4.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationKriging.MaxPoints
        """
        pass

    @property
    def MinPoints(
      self
    ) -> int: 
        """
        The minimum number of input data points used to interpolate at each grid cell; default 
        is 4.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationKriging.MinPoints
        """
        pass

    @MinPoints.setter
    def MinPoints(
      self,
      _value: int
    ) -> None: 
        """
        The minimum number of input data points used to interpolate at each grid cell; default 
        is 4.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationKriging.MinPoints
        """
        pass

    @property
    def Radius(
      self
    ) -> float: 
        """
        Defines the distance of search for input data points for a grid cell. Only the data 
        points within the distance may be taken to interpolate the value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationKriging.Radius
        """
        pass

    @Radius.setter
    def Radius(
      self,
      _value: float
    ) -> None: 
        """
        Defines the distance of search for input data points for a grid cell. Only the data 
        points within the distance may be taken to interpolate the value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationKriging.Radius
        """
        pass

    @property
    def Semivariance(
      self
    ) -> TGIS_SemivarianceAbstract: 
        """
        Model used for the semivariance calculation; default is power-law.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationKriging.Semivariance
        """
        pass

    @Semivariance.setter
    def Semivariance(
      self,
      _value: TGIS_SemivarianceAbstract
    ) -> None: 
        """
        Model used for the semivariance calculation; default is power-law.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationKriging.Semivariance
        """
        pass

    @property
    def Windowed(
      self
    ) -> bool: 
        """
        If True then the windowed version of the algorithm is used; false by default.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationKriging.Windowed
        """
        pass

    @Windowed.setter
    def Windowed(
      self,
      _value: bool
    ) -> None: 
        """
        If True then the windowed version of the algorithm is used; false by default.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationKriging.Windowed
        """
        pass

class TGIS_InterpolationIDW( TGIS_VectorToGridAbstract ):
    """
    Implementation of the Inverse Distance Weighting (IDW) interpolation method.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationIDW
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationIDW.Create_void
        """
        pass

    @property
    def Exponent(
      self
    ) -> float: 
        """
        Exponent in the formula for weight calculation; default value is 2.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationIDW.Exponent
        """
        pass

    @Exponent.setter
    def Exponent(
      self,
      _value: float
    ) -> None: 
        """
        Exponent in the formula for weight calculation; default value is 2.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationIDW.Exponent
        """
        pass

    @property
    def Radius(
      self
    ) -> float: 
        """
        Applies only to the windowed method (Windowed = True). Defines the distance of search 
        for input data points for a grid cell. Only the data points within the distance may 
        be taken to interpolate the value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationIDW.Radius
        """
        pass

    @Radius.setter
    def Radius(
      self,
      _value: float
    ) -> None: 
        """
        Applies only to the windowed method (Windowed = True). Defines the distance of search 
        for input data points for a grid cell. Only the data points within the distance may 
        be taken to interpolate the value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationIDW.Radius
        """
        pass

    @property
    def Windowed(
      self
    ) -> bool: 
        """
        If True then the windowed version of the algorithm is used; true by default.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationIDW.Windowed
        """
        pass

    @Windowed.setter
    def Windowed(
      self,
      _value: bool
    ) -> None: 
        """
        If True then the windowed version of the algorithm is used; true by default.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationIDW.Windowed
        """
        pass

class TGIS_GaussianHeatmap( TGIS_VectorToGridAbstract ):
    """
    Fast heatmap generator, creates superposition of normal (Gaussian) distribution for 
    each data point.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GaussianHeatmap
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GaussianHeatmap.Create_void
        """
        pass

    def EstimateRadius(
      self,
      _src: TGIS_LayerVector,
      _srcext: TGIS_Extent,
      _dst: TGIS_LayerPixel
    ) -> None: 
        """
        Calculates a "good choice" of the 3-sigma ("radius") of the Gaussian distribution. 
        Overwrites the Radius property value.

        Args:
            _src: source layer which contains the sample points
            _srcext: extent of interest on the source layer
            _dst: destination grid layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GaussianHeatmap.EstimateRadius_TGIS_LayerVector_TGIS_Extent_TGIS_LayerPixel
        """
        pass

    @property
    def Radius(
      self
    ) -> float: 
        """
        3-sigma ("radius") of the Gaussian distribution.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GaussianHeatmap.Radius
        """
        pass

    @Radius.setter
    def Radius(
      self,
      _value: float
    ) -> None: 
        """
        3-sigma ("radius") of the Gaussian distribution.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GaussianHeatmap.Radius
        """
        pass

class TGIS_InterpolationSplines( TGIS_VectorToGridAbstract ):
    """
    Implementation of the Completely Regularized Splines (CRS) interpolation method.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationSplines
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationSplines.Create_void
        """
        pass

    @property
    def MaxPoints(
      self
    ) -> int: 
        """
        The maximum number of input data points used to interpolate at each grid cell; default 
        is 4.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationSplines.MaxPoints
        """
        pass

    @MaxPoints.setter
    def MaxPoints(
      self,
      _value: int
    ) -> None: 
        """
        The maximum number of input data points used to interpolate at each grid cell; default 
        is 4.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationSplines.MaxPoints
        """
        pass

    @property
    def MinPoints(
      self
    ) -> int: 
        """
        The minimum number of input data points used to interpolate at each grid cell; default 
        is 4.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationSplines.MinPoints
        """
        pass

    @MinPoints.setter
    def MinPoints(
      self,
      _value: int
    ) -> None: 
        """
        The minimum number of input data points used to interpolate at each grid cell; default 
        is 4.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationSplines.MinPoints
        """
        pass

    @property
    def Radius(
      self
    ) -> float: 
        """
        Applies only to the windowed method (Windowed = True). Defines the distance of search 
        for input data points for a grid cell. Only the data points within the distance may 
        be taken to interpolate the value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationSplines.Radius
        """
        pass

    @Radius.setter
    def Radius(
      self,
      _value: float
    ) -> None: 
        """
        Applies only to the windowed method (Windowed = True). Defines the distance of search 
        for input data points for a grid cell. Only the data points within the distance may 
        be taken to interpolate the value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationSplines.Radius
        """
        pass

    @property
    def Tension(
      self
    ) -> float: 
        """
        The tension (smoothing) factor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationSplines.Tension
        """
        pass

    @Tension.setter
    def Tension(
      self,
      _value: float
    ) -> None: 
        """
        The tension (smoothing) factor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationSplines.Tension
        """
        pass

    @property
    def Windowed(
      self
    ) -> bool: 
        """
        If True then the windowed version of the algorithm is used; true by default.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationSplines.Windowed
        """
        pass

    @Windowed.setter
    def Windowed(
      self,
      _value: bool
    ) -> None: 
        """
        If True then the windowed version of the algorithm is used; true by default.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationSplines.Windowed
        """
        pass

class TGIS_TinToGrid( TObject ):
    """
    Provides the means to convert a Triangulated Irregular Network (TIN) vector layer 
    to a digital elevation model (grid layer). The algorithm is a simplified Inverse 
    Distance Weighting (IDW) interpolation method.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TinToGrid
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TinToGrid.Create_void
        """
        pass

    @overload
    def Generate(
      self,
      _src: TGIS_LayerVector,
      _dst: TGIS_LayerPixel
    ) -> bool: 
        """
        Generates a grid layer based on a Triangulated Irregular Network (TIN) layer.

        Args:
            _src: source TIN layer
            _dst: destination grid layer; this layer must have the same CS and extent as _src

        Returns:
            True if the operation was completed successfully; False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TinToGrid.Generate_TGIS_LayerVector_TGIS_LayerPixel
        """
        pass

    @overload
    def Generate(
      self
    ) -> bool: 
        """
        Generates a grid layer based on a Triangulated Irregular Network (TIN) layer.

        Returns:
            True if the operation was completed successfully; False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TinToGrid.Generate_void
        """
        pass

    @property
    def Exponent(
      self
    ) -> float: 
        """
        Exponent in the formula for weight calculation; default value is 2.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TinToGrid.Exponent
        """
        pass

    @Exponent.setter
    def Exponent(
      self,
      _value: float
    ) -> None: 
        """
        Exponent in the formula for weight calculation; default value is 2.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TinToGrid.Exponent
        """
        pass

    @property
    def OutputLayer(
      self
    ) -> TGIS_LayerPixel: 
        """
        Destination grid layer; this layer must have the same CS and extent as the source 
        layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TinToGrid.OutputLayer
        """
        pass

    @OutputLayer.setter
    def OutputLayer(
      self,
      _value: TGIS_LayerPixel
    ) -> None: 
        """
        Destination grid layer; this layer must have the same CS and extent as the source 
        layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TinToGrid.OutputLayer
        """
        pass

    @property
    def SourceLayer(
      self
    ) -> TGIS_LayerVector: 
        """
        Source layer, Triangulated Irregular Network (TIN).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TinToGrid.SourceLayer
        """
        pass

    @SourceLayer.setter
    def SourceLayer(
      self,
      _value: TGIS_LayerVector
    ) -> None: 
        """
        Source layer, Triangulated Irregular Network (TIN).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TinToGrid.SourceLayer
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TinToGrid.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TinToGrid.BusyEvent
        """
        pass

class TGIS_PointCloudToGrid( TGIS_VectorToGridAbstract ):
    """
    Provides the means to convert a point cloud vector layer such as LIDAR to a digital 
    elevation model (grid layer).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudToGrid
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudToGrid.Create_void
        """
        pass

    @overload
    def Generate(
      self,
      _src: TGIS_LayerVector,
      _srcext: TGIS_Extent,
      _srcfld: str,
      _dst: TGIS_LayerPixel,
      _dstext: TGIS_Extent
    ) -> None: 
        """
        Populates a pixel (grid) layer with values resulting from computations based on the 
        set of sample points from the vector layer.

        Args:
            _src: source layer which contains the sample points
            _srcext: extent of interest on the source layer
            _srcfld: the name of the numeric field which contains the values to be used for interpolation; 
              if empty then the coordinate defined by the Coordinate property will be used for 
              interpolation
            _dst: destination grid layer
            _dstext: extent on the destination layer to be populated with interpolated data

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudToGrid.Generate_TGIS_LayerVector_TGIS_Extent_String_TGIS_LayerPixel_TGIS_Extent
        """
        pass

    @overload
    def Generate(
      self,
      _src: TGIS_LayerVector,
      _dst: TGIS_LayerPixel
    ) -> None: 
        """
        Generates a grid layer based on a vector layer with point cloud. All points within 
        source layer extent will be processed. Gridding cell size same as destination layer''s 
        pixel size. Coordinate property is omitted and elevation will be assigned from Z 
        coordinates.

        Args:
            _src: source layer, point cloud such as LIDAR; must be 3D
            _dst: destination grid layer; this layer must have the same CS as the source layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudToGrid.Generate_TGIS_LayerVector_TGIS_LayerPixel
        """
        pass

    @property
    def Assignment(
      self
    ) -> TGIS_PointCloudAssignment: 
        """
        Defines method of assigning point values within each pixel; default is Mean.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudToGrid.Assignment
        """
        pass

    @Assignment.setter
    def Assignment(
      self,
      _value: TGIS_PointCloudAssignment
    ) -> None: 
        """
        Defines method of assigning point values within each pixel; default is Mean.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudToGrid.Assignment
        """
        pass

    @property
    def DefaultValueFormula(
      self
    ) -> TGIS_PointCloudFormula: 
        """
        Defines cell assignment method for NoData filling; default is DefaultValue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudToGrid.DefaultValueFormula
        """
        pass

    @DefaultValueFormula.setter
    def DefaultValueFormula(
      self,
      _value: TGIS_PointCloudFormula
    ) -> None: 
        """
        Defines cell assignment method for NoData filling; default is DefaultValue.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudToGrid.DefaultValueFormula
        """
        pass

    @property
    def Exponent(
      self
    ) -> float: 
        """
        Exponent in the formula for weight calculation; default value is 2.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudToGrid.Exponent
        """
        pass

    @Exponent.setter
    def Exponent(
      self,
      _value: float
    ) -> None: 
        """
        Exponent in the formula for weight calculation; default value is 2.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudToGrid.Exponent
        """
        pass

    @property
    def WindowSize(
      self
    ) -> int: 
        """
        Defines window size for filling NoData process; odd value required, even values will 
        be rounded up; default value is 3.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudToGrid.WindowSize
        """
        pass

    @WindowSize.setter
    def WindowSize(
      self,
      _value: int
    ) -> None: 
        """
        Defines window size for filling NoData process; odd value required, even values will 
        be rounded up; default value is 3.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointCloudToGrid.WindowSize
        """
        pass

class TGIS_IsochroneMap( TObject ):
    """
    Network analysis tool for creating isochrone maps - for a given point finds the network 
    area reachable within a given maximum network traversing cost.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IsochroneMap
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IsochroneMap.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _viewer: IGIS_Viewer
    ) -> None: 
        """
        Creates an instance.

        Args:
            _viewer: viewer object (for updating progress)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IsochroneMap.Create_IGIS_Viewer
        """
        pass

    def Generate(
      self,
      _src: TGIS_LayerVector,
      _spath: TGIS_ShortestPath,
      _dst: TGIS_LayerVector,
      _type: TGIS_ShapeType,
      _start: TGIS_Point,
      _cost: float,
      _intrvl: float
    ) -> bool: 
        """
        Finds the network area reachable within a given cost and outputs the result to the 
        destination layer as shape(s).

        Args:
            _src: source layer which contains the network
            _spath: shortest path object for the source layer
            _dst: destination layer
            _type: output shape type
            _start: starting point; if not a network node then the nearest network node will 
              be used as the starting point
            _cost: maximum cost of traversing the network
            _intrvl: cost interval; only the first node which exceeds each interval will be added 
              to the output

        Returns:
            True if the operation went successful

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IsochroneMap.Generate_TGIS_LayerVector_TGIS_ShortestPath_TGIS_LayerVector_TGIS_ShapeType_TGIS_Point_Double_Double
        """
        pass

    @property
    def OutputCostFieldName(
      self
    ) -> str: 
        """
        Specifies the name of the attribute field which will be added to the destination 
        layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IsochroneMap.OutputCostFieldName
        """
        pass

    @OutputCostFieldName.setter
    def OutputCostFieldName(
      self,
      _value: str
    ) -> None: 
        """
        Specifies the name of the attribute field which will be added to the destination 
        layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IsochroneMap.OutputCostFieldName
        """
        pass

class TGIS_ExtentUid:
    """
    Like TRect, but based on doubles instead of integers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ExtentUid
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ExtentUid.Create_void
        """
        pass

class TGIS_LabelsArea( TGIS_LabelsAreaAbstract ):
    """
    Label area allocator.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelsArea
    """

    @overload
    def __init__(
      self,
      _viewer: Pointer
    ) -> None: 
        """
        Construct label renderer.

        Args:
            _viewer: address of viewer object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelsArea.Create_Pointer
        """
        pass

class TGIS_LayerTiledMode:
    pass

class TGIS_LayerTiledMode:
    """
    State of Tiled mode rendering

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTiledMode
    """

    @property
    def None_(
      self
    ) -> TGIS_LayerTiledMode: 
        """
        No-tiled drawing

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTiledMode.None
        """
        pass

    @property
    def Tiles(
      self
    ) -> TGIS_LayerTiledMode: 
        """
        Drawing tiles connet.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTiledMode.Tiles
        """
        pass

    @property
    def Complete(
      self
    ) -> TGIS_LayerTiledMode: 
        """
        Drawing complete conent like labels, selections etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTiledMode.Complete
        """
        pass

class TGIS_Layer( TGIS_LayerAbstract ):
    """
    General layer class. Must be derived to provide file access.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Create_void
        """
        pass

    def Alive(
      self
    ) -> None: 
        """
        Makes a layer non-dormant. Reallocates files, memory, etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Alive_void
        """
        pass

    @overload
    def ApplyAutoStyle(
      self
    ) -> bool: 
        """
        Applies auto-styling to the layer.

        Returns:
            True if the application was successful.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ApplyAutoStyle_void
        """
        pass

    @overload
    def ApplyAutoStyle(
      self,
      _forceAutoStyle: bool
    ) -> bool: 
        """
        Applies auto-styling to the layer.

        Args:
            _forceAutoStyle: if True, forces auto-styling despite modified Params

        Returns:
            True if the application was successful.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ApplyAutoStyle_Boolean
        """
        pass

    def ApplyCuttingPolygon(
      self,
      _wkt: str
    ) -> None: 
        """
        Sets a cutting polygon for a layer.

        Args:
            _wkt: WKT representation of a polygon

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ApplyCuttingPolygon_String
        """
        pass

    def ChangeHash(
      self
    ) -> int: 
        """
        Changes the hash for the purpose of verifying layer''s modifications.

        Returns:
            True if item already exists on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ChangeHash_void
        """
        pass

    def ClearModified(
      self
    ) -> None: 
        """
        Sets IsModified flag to false for a layer and its sublayers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ClearModified_void
        """
        pass

    def Dormant(
      self
    ) -> None: 
        """
        Makes a layer dormant. Reduces memory consumption etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Dormant_void
        """
        pass

    def DormantGain(
      self
    ) -> int: 
        """
        Calculates the approximate gain (in Megabytes) which can be achieved by releasing 
        memory by calling Dormant method.

        Returns:
            Value in Megabytes

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.DormantGain_void
        """
        pass

    def Draw(
      self
    ) -> bool: 
        """
        Draws a layer.

        Returns:
            True if draw was performed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Draw_void
        """
        pass

    def DrawEx(
      self,
      _extent: TGIS_Extent
    ) -> bool: 
        """
        Draws a layer within a defined extent.

        Args:
            _extent: extent to be drawn

        Returns:
            True if draw was performed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.DrawEx_TGIS_Extent
        """
        pass

    def DrawFlash(
      self
    ) -> None: 
        """
        Draws a flash.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.DrawFlash_void
        """
        pass

    def DrawSelected(
      self
    ) -> bool: 
        """
        Draws only the selected item(s) on layer.

        Returns:
            True if draw was performed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.DrawSelected_void
        """
        pass

    def DrawSelectedEx(
      self,
      _extent: TGIS_Extent
    ) -> bool: 
        """
        Draws only the selected item(s) on layer that are within a defined extent.

        Args:
            _extent: extent to be drawn

        Returns:
            True if draw was performed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.DrawSelectedEx_TGIS_Extent
        """
        pass

    def GetAvailableLayers(
      self
    ) -> TGIS_LayerInfoList: 
        """
        Gets a list of layers available in storage.

        Returns:
            list of layers available in storage

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.GetAvailableLayers_void
        """
        pass

    def GetSubLayer(
      self,
      _name: str
    ) -> TGIS_LayerAbstract: 
        """
        Retrieve the layer identified by a name. Sublayer or compund layers can be found 
        by do notation like ''name.sublyer''

        Args:
            _name: name of layer to be found

        Returns:
            Found layer or nil if not found.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.GetSubLayer_String
        """
        pass

    def HourglassShake(
      self
    ) -> bool: 
        """
        Notifies of busy state using an hourglass.

        Returns:
            True if current operation can be interrupted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.HourglassShake_void
        """
        pass

    def IsGrid(
      self
    ) -> bool: 
        """
        Checks if the layer type is grid.

        Returns:
            True if the layer type is grid

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.IsGrid_void
        """
        pass

    def IsPixel(
      self
    ) -> bool: 
        """
        Checks if the layer type is pixel.

        Returns:
            True if the layer type is pixel

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.IsPixel_void
        """
        pass

    def IsSupported(
      self,
      _operation: TGIS_OperationType
    ) -> bool: 
        """
        Checks if the operation is supported by the layer.

        Args:
            _operation: operation

        Returns:
            True if the operation is supported by the layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.IsSupported_TGIS_OperationType
        """
        pass

    def IsVector(
      self
    ) -> bool: 
        """
        Checks if the layer type is vector.

        Returns:
            True if the layer type is vector

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.IsVector_void
        """
        pass

    def IsVector3D(
      self
    ) -> bool: 
        """
        Checks if the layer type is vector 3D.

        Returns:
            True if the layer type is vector 3D

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.IsVector3D_void
        """
        pass

    def IsVisible(
      self,
      _extent: TGIS_Extent
    ) -> bool: 
        """
        Checks if the layer is visible in a defined extent and current params.

        Args:
            _extent: extent to be checked

        Returns:
            True if the layer is visible

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.IsVisible_TGIS_Extent
        """
        pass

    def Lock(
      self
    ) -> None: 
        """
        Locks layer in burst-mode operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Lock_void
        """
        pass

    def Move(
      self,
      _step: int
    ) -> None: 
        """
        Moves a layer up or down in the viewer zorder list.

        Args:
            _step: how many steps and in which direction a layer must be moved; negative values 
              mean movement to the front.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Move_Integer
        """
        pass

    def MoveEx(
      self,
      _step: int
    ) -> None: 
        """
        Moves a layer up or down in the viewer zorder list (only visible layers). This procedure 
        takes into account only visible layers; invisible layers (HideFromLegend=True) located 
        after current layer will be moved together. If current layer is not visible, then 
        the nearest visible (but previous on the Items list) layer will be used as an anchor.

        Args:
            _step: how many steps and in which direction a layer must be moved; negative values 
              mean movement to the front.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.MoveEx_Integer
        """
        pass

    def MustCalculateStatistics(
      self
    ) -> bool: 
        """
        Verifies if all statistics required to properly render the layer are available.

        Returns:
            True if some statistics must be computed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.MustCalculateStatistics_void
        """
        pass

    def MustReproject(
      self
    ) -> int: 
        """
        Checks if the layer must be reprojected.

        Returns:
            True if the layer has to be reprojected

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.MustReproject_void
        """
        pass

    def MustSave(
      self
    ) -> bool: 
        """
        Checks if the layer was modified by editing.

        Returns:
            True if layer was modified.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.MustSave_void
        """
        pass

    def Open(
      self
    ) -> None: 
        """
        Opens the layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Open_void
        """
        pass

    def Paint(
      self
    ) -> bool: 
        """
        Draws the layer or fires PaintLayer event (if defined).

        Returns:
            True if draw was performed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Paint_void
        """
        pass

    def Prepare(
      self
    ) -> None: 
        """
        Opens the layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Prepare_void
        """
        pass

    def PreRecognize(
      self,
      _path: str,
      _new_path: VarParameter
    ) -> bool: 
        """
        Checks if the layer can read the file.

        Args:
            _path: file path to open
            _new_path: new path extracted from the file to open; the value (in/out) is passed 
              as str in _new_path.Value property

        Returns:
            True if the layer can read the file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.PreRecognize_String_String
        """
        pass

    def Project(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        Applies a projection on the single point.

        Args:
            _ptg: point to be projected

        Returns:
            point with applied projection

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Project_TGIS_Point
        """
        pass

    def Project3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Applies a projection on the single point in 3D.

        Args:
            _ptg: point to be projected

        Returns:
            3D point with applied projection

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Project3D_TGIS_Point3D
        """
        pass

    def Project3D_Ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Applies a projection on the single point in 3D.

        Args:
            _ptg: point to be unprojected; the value (in/out) is passed as TGIS_Point3D in _ptg.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Project3D_Ref_TGIS_Point3D
        """
        pass

    def ProjectExtent(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Applies a projection on the extent.

        Args:
            _extent: extent to be projected

        Returns:
            projected extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ProjectExtent_TGIS_Extent
        """
        pass

    def Project_Ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Applies a projection on the single point.

        Args:
            _ptg: point to be projected; the value (in/out) is passed as TGIS_Point in _ptg.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Project_Ref_TGIS_Point
        """
        pass

    def RaiseBusyEvent(
      self,
      _sender: TObject,
      _pos: int,
      _end: int
    ) -> bool: 
        """
        Fires Busy event of the layer.

        Args:
            _sender: component which is causing long-term operations
            _pos: current progress
            _end: maximal progress value

        Returns:
            True if aborted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.RaiseBusyEvent_TObject_Int64_Int64
        """
        pass

    def RaiseBusyPrepare(
      self,
      _sender: TObject,
      _text: str
    ) -> None: 
        """
        Fires BusyPrepare method of the assigned viewer.

        Args:
            _sender: component which is causing long-term operations
            _text: text to appear in a BusyText property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.RaiseBusyPrepare_TObject_String
        """
        pass

    def RaiseBusyRelease(
      self,
      _sender: TObject
    ) -> None: 
        """
        Fires BusyRelease method of the assigned viewer.

        Args:
            _sender: component which is causing long-term operations

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.RaiseBusyRelease_TObject
        """
        pass

    def RaiseBusyShake(
      self,
      _sender: TObject,
      _pos: int,
      _end: int
    ) -> bool: 
        """
        Fires BusyShake method of the assigned viewer.

        Args:
            _sender: component which is causing long-term operations
            _pos: current progress
            _end: maximal progress value

        Returns:
            True if aborted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.RaiseBusyShake_TObject_Int64_Int64
        """
        pass

    def ReadConfig(
      self
    ) -> None: 
        """
        Reads the layer configuration files.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ReadConfig_void
        """
        pass

    def ReadConfigParam(
      self,
      _name: str
    ) -> str: 
        """
        Reads the layer configuration parameters.

        Args:
            _name: parameter name

        Returns:
            config name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ReadConfigParam_String
        """
        pass

    def RecalcExtent(
      self
    ) -> None: 
        """
        Recalculates extent based on real shapes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.RecalcExtent_void
        """
        pass

    def RecalcProjectedExtent(
      self
    ) -> None: 
        """
        Recalculates a projected extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.RecalcProjectedExtent_void
        """
        pass

    def ReOpen(
      self
    ) -> None: 
        """
        Reopens the layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ReOpen_void
        """
        pass

    def RereadConfig(
      self
    ) -> None: 
        """
        Rereads the layer configuration files. Screen will be invalidated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.RereadConfig_void
        """
        pass

    def RevertAll(
      self
    ) -> None: 
        """
        Reverts layer to its original content.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.RevertAll_void
        """
        pass

    def RootLayer(
      self
    ) -> TGIS_Layer: 
        """
        Returns the absolute parent layer.

        Returns:
            parent layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.RootLayer_void
        """
        pass

    def SaveAll(
      self
    ) -> None: 
        """
        Saves layer and destroys mirrored items.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.SaveAll_void
        """
        pass

    def SaveData(
      self
    ) -> None: 
        """
        Saves layer and destroys mirrored items. See also TGIS_Layer.SaveAll.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.SaveData_void
        """
        pass

    def SetCSByEPSG(
      self,
      _epsg: int
    ) -> None: 
        """
        Sets up Coordinate System to a coordinate system provided by a EPSG code.

        Args:
            _epsg: EPSG code

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.SetCSByEPSG_Integer
        """
        pass

    def SetCSByWKT(
      self,
      _wkt: str
    ) -> None: 
        """
        Sets up Coordinate System to a coordinate system provided by a WKT string (GEOGCS 
        or PROJCS). If provided WKT string is empty then coordinate system will be turned 
        off.

        Args:
            _wkt: WKT string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.SetCSByWKT_String
        """
        pass

    def SetCSByWKTFile(
      self,
      _path: str
    ) -> None: 
        """
        Sets up Coordinate System to a coordinate system provided by a file which contains 
        a WKT string (GEOGCS or PROJCS). If file does not exist or provided WKT string is 
        empty then coordinate system will be turned off.

        Args:
            _path: path with WKT string (for example shapefile .PRJ)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.SetCSByWKTFile_String
        """
        pass

    def Unlock(
      self
    ) -> None: 
        """
        Unlocks layer from burst-mode operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Unlock_void
        """
        pass

    def Unproject(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        Applies reverse projection (recovers from the projection) on the single point.

        Args:
            _ptg: point to be unprojected

        Returns:
            unprojected point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Unproject_TGIS_Point
        """
        pass

    def Unproject3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Applies reverse projection (recovers from the projection) on the singlepoint in 3D.

        Args:
            _ptg: point to be unprojected

        Returns:
            unprojected 3D point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Unproject3D_TGIS_Point3D
        """
        pass

    def Unproject3D_Ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Applies reverse projection (recovers from the projection) on the single point in 
        3D.

        Args:
            _ptg: point to be unprojected; the value (in/out) is passed as TGIS_Point3D in _ptg.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Unproject3D_Ref_TGIS_Point3D
        """
        pass

    def UnprojectExtent(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Applies reverse projection (recovers from the projection) on the extent.

        Args:
            _extent: extent to be unprojected

        Returns:
            unprojected extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.UnprojectExtent_TGIS_Extent
        """
        pass

    def Unproject_Ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Applies reverse projection (recover from projection) on the single point.

        Args:
            _ptg: point to be projected; the value (in/out) is passed as TGIS_Point in _ptg.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Unproject_Ref_TGIS_Point
        """
        pass

    def ViewerReParent(
      self,
      _viewer: TGIS_ViewerRef
    ) -> TGIS_ViewerRef: 
        """
        Sets viewer for the layer and its sublayers.

        Args:
            _viewer: viewer to set

        Returns:
            Previous viewer parent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ViewerReParent_TGIS_ViewerRef
        """
        pass

    def WriteConfig(
      self
    ) -> None: 
        """
        Writes layer configuration files.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.WriteConfig_void
        """
        pass

    @property
    def Active(
      self
    ) -> bool: 
        """
        Checks if the layer is active? Active means layer is visible and an object can be 
        localized on the layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Active
        """
        pass

    @Active.setter
    def Active(
      self,
      _value: bool
    ) -> None: 
        """
        Checks if the layer is active? Active means layer is visible and an object can be 
        localized on the layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Active
        """
        pass

    @property
    def Addition(
      self
    ) -> int: 
        """
        Additional value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Addition
        """
        pass

    @Addition.setter
    def Addition(
      self,
      _value: int
    ) -> None: 
        """
        Additional value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Addition
        """
        pass

    @property
    def Age(
      self
    ) -> TDateTime: 
        """
        Age of the layer (since its creation).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Age
        """
        pass

    @property
    def Basemap(
      self
    ) -> bool: 
        """
        True if the layer must be interpreted as basemap (for background painting). Is important 
        only for bottom most layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Basemap
        """
        pass

    @Basemap.setter
    def Basemap(
      self,
      _value: bool
    ) -> None: 
        """
        True if the layer must be interpreted as basemap (for background painting). Is important 
        only for bottom most layers.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Basemap
        """
        pass

    @property
    def BasemapDraw(
      self
    ) -> bool: 
        """
        If True, the layer at the moment is drawn inside a basemap thread.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.BasemapDraw
        """
        pass

    @BasemapDraw.setter
    def BasemapDraw(
      self,
      _value: bool
    ) -> None: 
        """
        If True, the layer at the moment is drawn inside a basemap thread.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.BasemapDraw
        """
        pass

    @property
    def CachedPaint(
      self
    ) -> bool: 
        """
        False if layer must be painted directly (bypassing cache). Important only for topmost 
        layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.CachedPaint
        """
        pass

    @CachedPaint.setter
    def CachedPaint(
      self,
      _value: bool
    ) -> None: 
        """
        False if layer must be painted directly (bypassing cache). Important only for topmost 
        layers.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.CachedPaint
        """
        pass

    @property
    def Caption(
      self
    ) -> str: 
        """
        Caption of layer; if not filed directly then will be filed with Name when adding 
        to the Viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Caption
        """
        pass

    @Caption.setter
    def Caption(
      self,
      _value: str
    ) -> None: 
        """
        Caption of layer; if not filed directly then will be filed with Name when adding 
        to the Viewer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Caption
        """
        pass

    @property
    def CodePage(
      self
    ) -> int: 
        """
        Code Page in which text has been stored. If 0 then viewer (if attached) or system 
        default code page will be used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.CodePage
        """
        pass

    @CodePage.setter
    def CodePage(
      self,
      _value: int
    ) -> None: 
        """
        Code Page in which text has been stored. If 0 then viewer (if attached) or system 
        default code page will be used.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.CodePage
        """
        pass

    @property
    def Collapsed(
      self
    ) -> bool: 
        """
        Checks if the layer is collapsed? Collapsed means only the layer''s title will be 
        visible inside the legend.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Collapsed
        """
        pass

    @Collapsed.setter
    def Collapsed(
      self,
      _value: bool
    ) -> None: 
        """
        Checks if the layer is collapsed? Collapsed means only the layer''s title will be 
        visible inside the legend.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Collapsed
        """
        pass

    @property
    def Comments(
      self
    ) -> str: 
        """
        Additional user comments.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Comments
        """
        pass

    @Comments.setter
    def Comments(
      self,
      _value: str
    ) -> None: 
        """
        Additional user comments.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Comments
        """
        pass

    @property
    def ConfigFile(
      self
    ) -> TGIS_ConfigAbstract: 
        """
        Configuration file handle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ConfigFile
        """
        pass

    @property
    def ConfigName(
      self
    ) -> str: 
        """
        Configuration file name. If not filled directly, then will be filled with the Path

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ConfigName
        """
        pass

    @ConfigName.setter
    def ConfigName(
      self,
      _value: str
    ) -> None: 
        """
        Configuration file name. If not filled directly, then will be filled with the Path

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ConfigName
        """
        pass

    @property
    def CS(
      self
    ) -> TGIS_CSCoordinateSystem: 
        """
        Coordinate System that is assigned to the layer. If set to nil, the Coordinate System 
        will be turned off.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.CS
        """
        pass

    @CS.setter
    def CS(
      self,
      _value: TGIS_CSCoordinateSystem
    ) -> None: 
        """
        Coordinate System that is assigned to the layer. If set to nil, the Coordinate System 
        will be turned off.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.CS
        """
        pass

    @property
    def CustomData(
      self
    ) -> TGIS_StringList: 
        """
        List of custom, user-defined data. List is saved/restored with config/project files.
        
        List is in a form of "name=value".

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.CustomData
        """
        pass

    @property
    def DirectMode(
      self
    ) -> bool: 
        """
        True if the layer is direct-mode (bypassing cache).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.DirectMode
        """
        pass

    @property
    def DormantMode(
      self
    ) -> TGIS_LayerDormantMode: 
        """
        Dormant mode for the layer. Use: gisLayerDormantOff to turn off to conserve memory, 
        gisLayerDormantStandard to do standard memory management, and gisLayerDormantAgressive 
        to free as much memory as possible (can slow down operations).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.DormantMode
        """
        pass

    @DormantMode.setter
    def DormantMode(
      self,
      _value: TGIS_LayerDormantMode
    ) -> None: 
        """
        Dormant mode for the layer. Use: gisLayerDormantOff to turn off to conserve memory, 
        gisLayerDormantStandard to do standard memory management, and gisLayerDormantAgressive 
        to free as much memory as possible (can slow down operations).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.DormantMode
        """
        pass

    @property
    def Driver(
      self
    ) -> str: 
        """
        The layer''s driver name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Driver
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Extent: 
        """
        Extent of the layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Extent
        """
        pass

    @Extent.setter
    def Extent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Extent of the layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Extent
        """
        pass

    @property
    def Extent3D(
      self
    ) -> TGIS_Extent3D: 
        """
        Three-dimensional extent of the layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Extent3D
        """
        pass

    @Extent3D.setter
    def Extent3D(
      self,
      _value: TGIS_Extent3D
    ) -> None: 
        """
        Three-dimensional extent of the layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Extent3D
        """
        pass

    @property
    def FileCopyrights(
      self
    ) -> str: 
        """
        Copyright information about the layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.FileCopyrights
        """
        pass

    @property
    def FileInfo(
      self
    ) -> str: 
        """
        Additional textual information about the layer such as compression, number of pixels, 
        copyright, etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.FileInfo
        """
        pass

    @property
    def HideFromLegend(
      self
    ) -> bool: 
        """
        False if the layer should not be visible in legend.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.HideFromLegend
        """
        pass

    @HideFromLegend.setter
    def HideFromLegend(
      self,
      _value: bool
    ) -> None: 
        """
        False if the layer should not be visible in legend.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.HideFromLegend
        """
        pass

    @property
    def InPaint(
      self
    ) -> bool: 
        """
        True if the layer upon paint process.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.InPaint
        """
        pass

    @property
    def IsExportable(
      self
    ) -> bool: 
        """
        True if the layer is exportable. Layer is exportable if it can be saved to a disk 
        representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.IsExportable
        """
        pass

    @property
    def IsLocked(
      self
    ) -> bool: 
        """
        True if the layer is in locked state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.IsLocked
        """
        pass

    @property
    def IsOpened(
      self
    ) -> bool: 
        """
        True if the layer is opened and is ready for operations.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.IsOpened
        """
        pass

    @property
    def IsPersistent(
      self
    ) -> bool: 
        """
        True if the layer is persistent. The layer is persistent if it can be loaded automatically 
        by a project file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.IsPersistent
        """
        pass

    @property
    def IsReadOnly(
      self
    ) -> bool: 
        """
        True if the layer is read-only.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.IsReadOnly
        """
        pass

    @property
    def IsTopmost(
      self
    ) -> bool: 
        """
        True if the layer can be interpreted as the topmost (trackable) layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.IsTopmost
        """
        pass

    @property
    def Layer3D(
      self
    ) -> TGIS_3DLayerType: 
        """
        Mode of 3D operations

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Layer3D
        """
        pass

    @Layer3D.setter
    def Layer3D(
      self,
      _value: TGIS_3DLayerType
    ) -> None: 
        """
        Mode of 3D operations

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Layer3D
        """
        pass

    @property
    def MaxTileSize(
      self
    ) -> TPoint: 
        """
        Maximum allowed tile size for the layer. Default is no limit and is represented by 
        GIS_MAX_INTEGER value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.MaxTileSize
        """
        pass

    @property
    def MultiUserMode(
      self
    ) -> TGIS_MultiUser: 
        """
        Type of multiuser mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.MultiUserMode
        """
        pass

    @MultiUserMode.setter
    def MultiUserMode(
      self,
      _value: TGIS_MultiUser
    ) -> None: 
        """
        Type of multiuser mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.MultiUserMode
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Name of layer; if not filled directly, then will be filled with Path when added to 
        the viewer. Name must be unique.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Name
        """
        pass

    @Name.setter
    def Name(
      self,
      _value: str
    ) -> None: 
        """
        Name of layer; if not filled directly, then will be filled with Path when added to 
        the viewer. Name must be unique.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Name
        """
        pass

    @property
    def Params(
      self
    ) -> TGIS_ParamsSection: 
        """
        Parameters (colors, fills, etc.) object. These parameters are as selected in ParamsList 
        property. Changing this parameter also changes the selected parameter object in ParamsList.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Params
        """
        pass

    @Params.setter
    def Params(
      self,
      _value: TGIS_ParamsSection
    ) -> None: 
        """
        Parameters (colors, fills, etc.) object. These parameters are as selected in ParamsList 
        property. Changing this parameter also changes the selected parameter object in ParamsList.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Params
        """
        pass

    @property
    def ParamsList(
      self
    ) -> TGIS_ParamsList: 
        """
        List of all parameter sections attached to the current layer. A section describes 
        parameters and its zone of activity (minimum zoom of visibility, etc.).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ParamsList
        """
        pass

    @property
    def ParentLayer(
      self
    ) -> TGIS_Layer: 
        """
        Parent layer of a sub layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ParentLayer
        """
        pass

    @ParentLayer.setter
    def ParentLayer(
      self,
      _value: TGIS_Layer
    ) -> None: 
        """
        Parent layer of a sub layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ParentLayer
        """
        pass

    @property
    def Path(
      self
    ) -> str: 
        """
        Path to file holding the layer''s data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Path
        """
        pass

    @Path.setter
    def Path(
      self,
      _value: str
    ) -> None: 
        """
        Path to file holding the layer''s data.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Path
        """
        pass

    @property
    def PathWithDriver(
      self
    ) -> str: 
        """
        Path to file with the layer''s data extended with driver name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.PathWithDriver
        """
        pass

    @property
    def ProjectedExtent(
      self
    ) -> TGIS_Extent: 
        """
        Extent of the layer in projected units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ProjectedExtent
        """
        pass

    @ProjectedExtent.setter
    def ProjectedExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Extent of the layer in projected units.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ProjectedExtent
        """
        pass

    @property
    def Renderer(
      self
    ) -> TObject: 
        """
        Handle to a renderer used for drawing shapes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Renderer
        """
        pass

    @Renderer.setter
    def Renderer(
      self,
      _value: TObject
    ) -> None: 
        """
        Handle to a renderer used for drawing shapes.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Renderer
        """
        pass

    @property
    def Statistics(
      self
    ) -> TGIS_StatisticsAbstract: 
        """
        Layer statistics engine

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Statistics
        """
        pass

    @Statistics.setter
    def Statistics(
      self,
      _value: TGIS_StatisticsAbstract
    ) -> None: 
        """
        Layer statistics engine

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Statistics
        """
        pass

    @property
    def Stream(
      self
    ) -> TStream: 
        """
        Reference to a potential layer underlying the stream. Some layers like (TGIS_LayerJPG) 
        can read the data from the stream instead of from the file provided by the Path.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Stream
        """
        pass

    @Stream.setter
    def Stream(
      self,
      _value: TStream
    ) -> None: 
        """
        Reference to a potential layer underlying the stream. Some layers like (TGIS_LayerJPG) 
        can read the data from the stream instead of from the file provided by the Path.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Stream
        """
        pass

    @property
    def SubLayers(
      self
    ) -> TGIS_LayerAbstractList: 
        """
        List of sublayers belonging to the layer. Used for internal presentation of fake 
        layers in some formats on the legend.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.SubLayers
        """
        pass

    @SubLayers.setter
    def SubLayers(
      self,
      _value: TGIS_LayerAbstractList
    ) -> None: 
        """
        List of sublayers belonging to the layer. Used for internal presentation of fake 
        layers in some formats on the legend.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.SubLayers
        """
        pass

    @property
    def SubType(
      self
    ) -> typing.Sequence[TGIS_LayerSubType]: 
        """
        Type of sublayer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.SubType
        """
        pass

    @property
    def SupportsAutoStyle(
      self
    ) -> bool: 
        """
        Indicates whether the layer supports auto styling.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.SupportsAutoStyle
        """
        pass

    @SupportsAutoStyle.setter
    def SupportsAutoStyle(
      self,
      _value: bool
    ) -> None: 
        """
        Indicates whether the layer supports auto styling.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.SupportsAutoStyle
        """
        pass

    @property
    def SupportsTiledPaint(
      self
    ) -> bool: 
        """
        Indicates whether the layer supports tiled paint.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.SupportsTiledPaint
        """
        pass

    @property
    def Tag(
      self
    ) -> int: 
        """
        Tag has no predefined meaning. The Tag property is provided for the convenience of 
        storing additional integer value or pointer information for special needs in an application.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Tag
        """
        pass

    @Tag.setter
    def Tag(
      self,
      _value: int
    ) -> None: 
        """
        Tag has no predefined meaning. The Tag property is provided for the convenience of 
        storing additional integer value or pointer information for special needs in an application.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Tag
        """
        pass

    @property
    def TagInternal(
      self
    ) -> int: 
        """
        TagInternal has no predefined meaning. The TagInternal property is for storing additional 
        values or information for internal use by TatukGIS. Please do not use this property 
        on your own!

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.TagInternal
        """
        pass

    @TagInternal.setter
    def TagInternal(
      self,
      _value: int
    ) -> None: 
        """
        TagInternal has no predefined meaning. The TagInternal property is for storing additional 
        values or information for internal use by TatukGIS. Please do not use this property 
        on your own!

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.TagInternal
        """
        pass

    @property
    def TagPointer(
      self
    ) -> Pointer: 
        """
        TagPointer has no predefined meaning. The TagPointer property is provided for the 
        convenience of storing additional pointer information for special needs in an application.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.TagPointer
        """
        pass

    @TagPointer.setter
    def TagPointer(
      self,
      _value: Pointer
    ) -> None: 
        """
        TagPointer has no predefined meaning. The TagPointer property is provided for the 
        convenience of storing additional pointer information for special needs in an application.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.TagPointer
        """
        pass

    @property
    def TiledDrawMode(
      self
    ) -> TGIS_LayerTiledMode: 
        """
        If True, the layer at the moment is drawn by tiler.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.TiledDrawMode
        """
        pass

    @TiledDrawMode.setter
    def TiledDrawMode(
      self,
      _value: TGIS_LayerTiledMode
    ) -> None: 
        """
        If True, the layer at the moment is drawn by tiler.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.TiledDrawMode
        """
        pass

    @property
    def Transform(
      self
    ) -> TGIS_Transform: 
        """
        Custom transformation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Transform
        """
        pass

    @Transform.setter
    def Transform(
      self,
      _value: TGIS_Transform
    ) -> None: 
        """
        Custom transformation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Transform
        """
        pass

    @property
    def Transparency(
      self
    ) -> int: 
        """
        Transparency value for the layer (0..100).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Transparency
        """
        pass

    @Transparency.setter
    def Transparency(
      self,
      _value: int
    ) -> None: 
        """
        Transparency value for the layer (0..100).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Transparency
        """
        pass

    @property
    def UnSupportedOperations(
      self
    ) -> typing.Sequence[TGIS_OperationType]: 
        """
        Set of operations not supported by the layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.UnSupportedOperations
        """
        pass

    @UnSupportedOperations.setter
    def UnSupportedOperations(
      self,
      _value: typing.Sequence[TGIS_OperationType]
    ) -> None: 
        """
        Set of operations not supported by the layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.UnSupportedOperations
        """
        pass

    @property
    def UseConfig(
      self
    ) -> bool: 
        """
        True if config file is active.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.UseConfig
        """
        pass

    @UseConfig.setter
    def UseConfig(
      self,
      _value: bool
    ) -> None: 
        """
        True if config file is active.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.UseConfig
        """
        pass

    @property
    def UserObject(
      self
    ) -> TObject: 
        """
        UserObject can be used to associate with the layer a user-defined object. Such object 
        will be destroyed automatically upon layer destroy. Attaching a new object to this 
        property will destroy existing one.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.UserObject
        """
        pass

    @UserObject.setter
    def UserObject(
      self,
      _value: TObject
    ) -> None: 
        """
        UserObject can be used to associate with the layer a user-defined object. Such object 
        will be destroyed automatically upon layer destroy. Attaching a new object to this 
        property will destroy existing one.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.UserObject
        """
        pass

    @property
    def Viewer(
      self
    ) -> TGIS_ViewerRef: 
        """
        Reference to a viewer object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Viewer
        """
        pass

    @Viewer.setter
    def Viewer(
      self,
      _value: TGIS_ViewerRef
    ) -> None: 
        """
        Reference to a viewer object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.Viewer
        """
        pass

    @property
    def ZOrder(
      self
    ) -> int: 
        """
        Layer''s position relative to other layers. For the topmost layers, ZOrder=0. If 
        the Layer is not attached to the viewer, then ZOrderEx=-1. To set layer as bottommost 
        layer - regardless of the number of layers - assign any huge value, like 999999.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ZOrder
        """
        pass

    @ZOrder.setter
    def ZOrder(
      self,
      _value: int
    ) -> None: 
        """
        Layer''s position relative to other layers. For the topmost layers, ZOrder=0. If 
        the Layer is not attached to the viewer, then ZOrderEx=-1. To set layer as bottommost 
        layer - regardless of the number of layers - assign any huge value, like 999999.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ZOrder
        """
        pass

    @property
    def ZOrderEx(
      self
    ) -> int: 
        """
        Layer position relative to other visible layers. For topmost layers ZOrderEx=0. If 
        the Layer was not attached to the viewer then ZOrderEx=-1. To set layer as bottommost 
        layer - regardless of the number of layers - assign any huge value, like 999999.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ZOrderEx
        """
        pass

    @ZOrderEx.setter
    def ZOrderEx(
      self,
      _value: int
    ) -> None: 
        """
        Layer position relative to other visible layers. For topmost layers ZOrderEx=0. If 
        the Layer was not attached to the viewer then ZOrderEx=-1. To set layer as bottommost 
        layer - regardless of the number of layers - assign any huge value, like 999999.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ZOrderEx
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.BusyEvent
        """
        pass

    @property
    def PaintLayerEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Layer], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.PaintLayerEvent
        """
        pass

    @PaintLayerEvent.setter
    def PaintLayerEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Layer], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.PaintLayerEvent
        """
        pass

    @property
    def PasswordEvent(
      self
    ) -> typing.Callable[[TObject, String], str]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.PasswordEvent
        """
        pass

    @PasswordEvent.setter
    def PasswordEvent(
      self,
      _value: typing.Callable[[TObject, String], str]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.PasswordEvent
        """
        pass

    @property
    def ReadEvent(
      self
    ) -> typing.Callable[[TObject, LongInt, Pointer, Integer], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ReadEvent
        """
        pass

    @ReadEvent.setter
    def ReadEvent(
      self,
      _value: typing.Callable[[TObject, LongInt, Pointer, Integer], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.ReadEvent
        """
        pass

    @property
    def WriteEvent(
      self
    ) -> typing.Callable[[TObject, LongInt, Pointer, Integer], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.WriteEvent
        """
        pass

    @WriteEvent.setter
    def WriteEvent(
      self,
      _value: typing.Callable[[TObject, LongInt, Pointer, Integer], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Layer.WriteEvent
        """
        pass

class TGIS_LayerGroup( TGIS_Layer ):
    """
    General group layer class.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGroup
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGroup.Create_void
        """
        pass

class TGIS_LayerADF( TGIS_LayerPixel ):
    """
    Encapsulation of an Arcinfo Float(Binary) Grid layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerADF
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerADF.Create_void
        """
        pass

class TGIS_LayerBIL( TGIS_LayerPixel ):
    """
    Encapsulation of BIL (SPOT) layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerBIL
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerBIL.Create_void
        """
        pass

class TGIS_LayerBMP( TGIS_LayerPixel ):
    """
    Encapsulation of bitmap layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerBMP
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerBMP.Create_void
        """
        pass

class TGIS_LayerBT( TGIS_LayerPixel ):
    """
    Encapsulation of Binary Terrian Grid layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerBT
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerBT.Create_void
        """
        pass

class TGIS_LayerCADRG( TGIS_LayerPixel ):
    """
    Encapsulation of CADRG layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCADRG
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCADRG.Create_void
        """
        pass

    def DoReload(
      self
    ) -> None: 
        """
        Rebuilds Layer working on data base.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCADRG.DoReload_void
        """
        pass

    @property
    def ReadFrameEvent(
      self
    ) -> TGIS_FileCADRG_ReadFrameEvent: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCADRG.ReadFrameEvent
        """
        pass

    @ReadFrameEvent.setter
    def ReadFrameEvent(
      self,
      _value: TGIS_FileCADRG_ReadFrameEvent
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCADRG.ReadFrameEvent
        """
        pass

class TGIS_LayerCompoundAbstract( TGIS_Layer ):
    """
    General compound layer class is a container for other layers. Used to manage sublayers 
    and their behavior like drawing, properties, etc.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCompoundAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCompoundAbstract.Create_void
        """
        pass

    def Add(
      self,
      _layer: TGIS_Layer
    ) -> None: 
        """
        Add a layer to the list.

        Args:
            _layer: layer to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCompoundAbstract.Add_TGIS_Layer
        """
        pass

    def Get(
      self,
      _name: str
    ) -> TGIS_Layer: 
        """
        Retrieve the layer identified by a name.

        Args:
            _name: name of layer found

        Returns:
            found layer or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCompoundAbstract.Get_String
        """
        pass

    
    def Layer(
      self,
      _idx: int
    ) -> TGIS_Layer: 
        """
        All sub layers.

        Args:
            _idx: index of a sublayer

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCompoundAbstract.Layer
        """
        pass

    @property
    def LayersCount(
      self
    ) -> int: 
        """
        Sub layers count.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCompoundAbstract.LayersCount
        """
        pass

class TGIS_LayerCompoundVector( TGIS_LayerCompoundAbstract ):
    """
    Vector compound layer class.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCompoundVector
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCompoundVector.Create_void
        """
        pass

    @overload
    def LocateEx(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _uid: int,
      _dist: VarParameter,
      _part: VarParameter,
      _proj: VarParameter,
      _visible: bool
    ) -> TGIS_Shape: 
        """
        Locate a shape (more precise).

        Args:
            _ptg: reference point /searching point/ in a layer;
            _prec: precision /not a longer distance than/;
            _uid: Uid of reference shape or -1; thanks to this, is possible to find nearest shape, 
              excluding shape given by _uid.
            _dist: reached distance between _pt and shape in Result; the value (in/out) is passed 
              as float in _dist.Value property
            _part: number of the part closest to a given point; the value (in/out) is passed 
              as int in _part.Value property
            _proj: point projected to the nearest element of a shape; the value (in/out) is passed 
              as TGIS_Point in _proj.Value property
            _visible: if true the only visible shapes will be evaluated;

        Returns:
            found shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCompoundVector.LocateEx_TGIS_Point_Double_Integer_Double_Integer_TGIS_Point_Boolean
        """
        pass

    @overload
    def LocateEx(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _uid: int,
      _dist: VarParameter,
      _part: VarParameter,
      _proj: VarParameter,
      _dist_prefer: VarParameter,
      _visible: bool
    ) -> TGIS_Shape: 
        """
        Locate a shape (more precise).

        Args:
            _ptg: reference point /searching point/ in a layer;
            _prec: precision /not a longer distance than/;
            _uid: Uid of reference shape or -1; thanks to this, is possible to find nearest shape, 
              excluding shape given by _uid.
            _dist: reached distance between _pt and shape in Result; the value (in/out) is passed 
              as float in _dist.Value property
            _part: number of the part closest to a given point; the value (in/out) is passed 
              as int in _part.Value property
            _proj: point projected to the nearest element of a shape; the value (in/out) is passed 
              as TGIS_Point in _proj.Value property
            _dist_prefer: preferred distance (including shape type priority : points over lines 
              and polygons); the value (in/out) is passed as float in _dist_prefer.Value property
            _visible: if true the only visible shapes will be evaluated;

        Returns:
            found shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCompoundVector.LocateEx_TGIS_Point_Double_Integer_Double_Integer_TGIS_Point_Double_Boolean
        """
        pass

class TGIS_LayerCompoundPixel( TGIS_LayerCompoundAbstract ):
    """
    Pixel compound layer class.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCompoundPixel
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCompoundPixel.Create_void
        """
        pass

    def Locate(
      self,
      _ptg: TGIS_Point,
      _rgbMapped: VarParameter,
      _nativesVals: VarParameter,
      _transparency: VarParameter
    ) -> bool: 
        """
        If given point is located in image area, return true and set variables:

        Args:
            _ptg: reference point
            _rgbMapped: color in _ptg point after mapping (the same as _nativesVals if no mapping, 
              in this case _rgbMapped.Blue = Byte(_nativesVals[0] and so on).; the value (in/out) 
              is passed as TGIS_RGBTriple in _rgbMapped.Value property
            _nativesVals: dynamic array of double with original values in _ptg point (R, G, B), 
              Length(_nativesVals) is equal of bands number (=1 for float (single) pixels otherwise 
              min = 3 for 24 bits per pixel /native format DK/ ); the value (in/out) is passed 
              as TGIS_DoubleArray in _nativesVals.Value property
            _transparency: return True if point is transparent; the value (in/out) is passed 
              as bool in _transparency.Value property

        Returns:
            True if the point is located in image area

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCompoundPixel.Locate_TGIS_Point_TGIS_RGBTriple_TGIS_DoubleArray_Boolean
        """
        pass

class TGIS_LayerCSV( TGIS_LayerVector ):
    """
    Layer which can read a CSV text file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCSV
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCSV.Create_void
        """
        pass

    @property
    def AutoRecognize(
      self
    ) -> bool: 
        """
        If true then DecimalPoint and Separator will be auto recognized upon reading the 
        file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCSV.AutoRecognize
        """
        pass

    @AutoRecognize.setter
    def AutoRecognize(
      self,
      _value: bool
    ) -> None: 
        """
        If true then DecimalPoint and Separator will be auto recognized upon reading the 
        file.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCSV.AutoRecognize
        """
        pass

    @property
    def DecimalPoint(
      self
    ) -> char: 
        """
        Decimal point symbol. Default is comma.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCSV.DecimalPoint
        """
        pass

    @DecimalPoint.setter
    def DecimalPoint(
      self,
      _value: char
    ) -> None: 
        """
        Decimal point symbol. Default is comma.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCSV.DecimalPoint
        """
        pass

    @property
    def Separator(
      self
    ) -> char: 
        """
        Column separator. Default is comma.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCSV.Separator
        """
        pass

    @Separator.setter
    def Separator(
      self,
      _value: char
    ) -> None: 
        """
        Column separator. Default is comma.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerCSV.Separator
        """
        pass

class TGIS_LayerDEM( TGIS_LayerPixel ):
    """
    Encapsulation of an USGS DEM Ascii Grid layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDEM
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDEM.Create_void
        """
        pass

class TGIS_LayerDGN( TGIS_LayerVector ):
    """
    Layer that can read DGN file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDGN
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDGN.Create_void
        """
        pass

class TGIS_LayerDLG( TGIS_LayerVector ):
    """
    Layer which can read &amp; write a DLG (Digital Line Graphs) file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDLG
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDLG.Create_void
        """
        pass

class TGIS_LayerDTED( TGIS_LayerPixel ):
    """
    Encapsulation of Binary Terrian Grid layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDTED
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDTED.Create_void
        """
        pass

class TGIS_LayerDWG( TGIS_LayerVector ):
    """
    Layer which can read AutoCAD DWG file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDWG
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDWG.Create_void
        """
        pass

    @property
    def ExtendedDataEvent(
      self
    ) -> typing.Callable[[TObject, String, TGIS_Shape, TStringList], None]: 
        """
        Extended entity definition data event (DXF code 1001).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDWG.ExtendedDataEvent
        """
        pass

    @ExtendedDataEvent.setter
    def ExtendedDataEvent(
      self,
      _value: typing.Callable[[TObject, String, TGIS_Shape, TStringList], None]
    ) -> None: 
        """
        Extended entity definition data event (DXF code 1001).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDWG.ExtendedDataEvent
        """
        pass

class TGIS_LayerDXF( TGIS_LayerVector ):
    """
    Layer that can read DXF file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDXF
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDXF.Create_void
        """
        pass

    @property
    def ForceExtent(
      self
    ) -> bool: 
        """
        Force layer extent - cut shapes outside layer extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDXF.ForceExtent
        """
        pass

    @ForceExtent.setter
    def ForceExtent(
      self,
      _value: bool
    ) -> None: 
        """
        Force layer extent - cut shapes outside layer extent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDXF.ForceExtent
        """
        pass

    @property
    def Layers(
      self
    ) -> TGIS_StringList: 
        """
        List of all found layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDXF.Layers
        """
        pass

    
    def LayerVisibility(
      self,
      _name: str
    ) -> bool: 
        """
        Set layer visibility by name.

        Args:
            _name: layer name

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDXF.LayerVisibility
        """
        pass

    
    def LayerVisibility(
      self,
      _name: str,
      _value: bool
    ) -> None: 
        """
        Set layer visibility by name.

        Args:
            _name: layer name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDXF.LayerVisibility
        """
        pass

    @property
    def ExtendedDataEvent(
      self
    ) -> typing.Callable[[TObject, String, TGIS_Shape, TStringList], None]: 
        """
        Extended entity definition data event (DXF code 1001).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDXF.ExtendedDataEvent
        """
        pass

    @ExtendedDataEvent.setter
    def ExtendedDataEvent(
      self,
      _value: typing.Callable[[TObject, String, TGIS_Shape, TStringList], None]
    ) -> None: 
        """
        Extended entity definition data event (DXF code 1001).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDXF.ExtendedDataEvent
        """
        pass

class TGIS_LayerE00( TGIS_LayerVector ):
    """
    Layer that can read E00 file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerE00
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerE00.Create_void
        """
        pass

    @property
    def ShapeType(
      self
    ) -> TGIS_ShapeType: 
        """
        Accepted shape types.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerE00.ShapeType
        """
        pass

    @ShapeType.setter
    def ShapeType(
      self,
      _value: TGIS_ShapeType
    ) -> None: 
        """
        Accepted shape types.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerE00.ShapeType
        """
        pass

class TGIS_LayerFLT( TGIS_LayerPixel ):
    """
    Encapsulation of an Arcinfo Float(Binary) Grid layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerFLT
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerFLT.Create_void
        """
        pass

class TGIS_LayerGDF( TGIS_LayerVector ):
    """
    Layer that can read GDF file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGDF
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGDF.Create_void
        """
        pass

    
    def AttributeNameByType(
      self,
      _name: str
    ) -> str: 
        """
        Get attribute by type.

        Args:
            _name: attribute name

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGDF.AttributeNameByType
        """
        pass

    @property
    def AttributeNames(
      self
    ) -> TGIS_StringList: 
        """
        List of attributes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGDF.AttributeNames
        """
        pass

class TGIS_LayerGeoraster( TGIS_LayerPixelSqlAbstract ):
    """
    Encapsulation of Oracle Georaster access layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGeoraster
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGeoraster.Create_void
        """
        pass

    def DrawEx2(
      self,
      _extent: TGIS_Extent
    ) -> bool: 
        """
        Shortcut to inherited DrawEx method; see TGIS_LayerPixel.DrawEx.

        Args:
            _extent: extent to be drawn

        Returns:
            True, if something is drawn

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGeoraster.DrawEx2_TGIS_Extent
        """
        pass

    @property
    def SQLPath(
      self
    ) -> str: 
        """
        Connect string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGeoraster.SQLPath
        """
        pass

    @SQLPath.setter
    def SQLPath(
      self,
      _value: str
    ) -> None: 
        """
        Connect string.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGeoraster.SQLPath
        """
        pass

    @property
    def WhereFilter(
      self
    ) -> str: 
        """
        Where filter.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGeoraster.WhereFilter
        """
        pass

    @WhereFilter.setter
    def WhereFilter(
      self,
      _value: str
    ) -> None: 
        """
        Where filter.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGeoraster.WhereFilter
        """
        pass

class TGIS_LayerGeorasterOci( TGIS_LayerGeoraster ):
    """
    Encapsulation of Oracle Georaster access layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGeorasterOci
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGeorasterOci.Create_void
        """
        pass

class TGIS_LayerGIF( TGIS_LayerPixel ):
    """
    Encapsulation of GIF layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGIF
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGIF.Create_void
        """
        pass

class TGIS_LayerGML( TGIS_LayerVector ):
    """
    Encapsulation of a GML Layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.Create_void
        """
        pass

    def AddFromStream(
      self
    ) -> int: 
        """
        Open a data from the Stream keeping the current layer state. Used internally by WFS 
        layer for data paging.

        Returns:
            number of shappes create from a data

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.AddFromStream_void
        """
        pass

    def ParseSchemaStream(
      self,
      _stream: TStream
    ) -> None: 
        """
        Parse schema from stream. Used internally by WFS layer for describing feature type.

        Args:
            _stream: stream to parse

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.ParseSchemaStream_TStream
        """
        pass

    @property
    def AfterAddingMemberFilter(
      self
    ) -> TGIS_Strings: 
        """
        Filters list for AfterAddingMember event - fires event only if element name is on 
        filter list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.AfterAddingMemberFilter
        """
        pass

    @AfterAddingMemberFilter.setter
    def AfterAddingMemberFilter(
      self,
      _value: TGIS_Strings
    ) -> None: 
        """
        Filters list for AfterAddingMember event - fires event only if element name is on 
        filter list.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.AfterAddingMemberFilter
        """
        pass

    @property
    def AxisOrderReversed(
      self
    ) -> bool: 
        """
        If true, then reverse coordinates of axis.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.AxisOrderReversed
        """
        pass

    @AxisOrderReversed.setter
    def AxisOrderReversed(
      self,
      _value: bool
    ) -> None: 
        """
        If true, then reverse coordinates of axis.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.AxisOrderReversed
        """
        pass

    @property
    def FlattenXML(
      self
    ) -> bool: 
        """
        If true, nested attributes names will be concatenated with _ separator.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.FlattenXML
        """
        pass

    @FlattenXML.setter
    def FlattenXML(
      self,
      _value: bool
    ) -> None: 
        """
        If true, nested attributes names will be concatenated with _ separator.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.FlattenXML
        """
        pass

    @property
    def InverseXY(
      self
    ) -> bool: 
        """
        Use AxisOrderReversed instead.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.InverseXY
        """
        pass

    @InverseXY.setter
    def InverseXY(
      self,
      _value: bool
    ) -> None: 
        """
        Use AxisOrderReversed instead.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.InverseXY
        """
        pass

    @property
    def SaveFields(
      self
    ) -> bool: 
        """
        If true, import saves object fields &amp; properties.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.SaveFields
        """
        pass

    @SaveFields.setter
    def SaveFields(
      self,
      _value: bool
    ) -> None: 
        """
        If true, import saves object fields &amp; properties.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.SaveFields
        """
        pass

    @property
    def UseLongCoord(
      self
    ) -> bool: 
        """
        If true, long coordinates format will be used, otherwise short \&lt;x\&gt;\&lt;y\&gt;.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.UseLongCoord
        """
        pass

    @UseLongCoord.setter
    def UseLongCoord(
      self,
      _value: bool
    ) -> None: 
        """
        If true, long coordinates format will be used, otherwise short \&lt;x\&gt;\&lt;y\&gt;.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.UseLongCoord
        """
        pass

    @property
    def UseOldStyleCoord(
      self
    ) -> bool: 
        """
        If true, gml 2.1 coordinates format will be used (\&lt;coordinates\&gt;), otherwise 
        3.1 \&lt;posList\&gt;.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.UseOldStyleCoord
        """
        pass

    @UseOldStyleCoord.setter
    def UseOldStyleCoord(
      self,
      _value: bool
    ) -> None: 
        """
        If true, gml 2.1 coordinates format will be used (\&lt;coordinates\&gt;), otherwise 
        3.1 \&lt;posList\&gt;.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.UseOldStyleCoord
        """
        pass

    @property
    def AfterAddingMemberEvent(
      self
    ) -> TGIS_AfterAddingMemberEvent: 
        """
        Event fired After Adding Member - for data not connected with graphics. Uses AfterAddingMemberFilter 
        list to set filter event firing.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.AfterAddingMemberEvent
        """
        pass

    @AfterAddingMemberEvent.setter
    def AfterAddingMemberEvent(
      self,
      _value: TGIS_AfterAddingMemberEvent
    ) -> None: 
        """
        Event fired After Adding Member - for data not connected with graphics. Uses AfterAddingMemberFilter 
        list to set filter event firing.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGML.AfterAddingMemberEvent
        """
        pass

class TGIS_LayerGPXDataType:
    pass

class TGIS_LayerGPXDataType:
    """
    GPX internal data types.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGPXDataType
    """

    @property
    def WPT(
      self
    ) -> TGIS_LayerGPXDataType: 
        """
        Waypoint.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGPXDataType.WPT
        """
        pass

    @property
    def RTE(
      self
    ) -> TGIS_LayerGPXDataType: 
        """
        Route (one segment).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGPXDataType.RTE
        """
        pass

    @property
    def TRK(
      self
    ) -> TGIS_LayerGPXDataType: 
        """
        Track (multi-segment).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGPXDataType.TRK
        """
        pass

class TGIS_LayerGPX( TGIS_LayerVector ):
    """
    Encapsulation of a GPX Layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGPX
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGPX.Create_void
        """
        pass

    @property
    def AdditionalWayPoints(
      self
    ) -> bool: 
        """
        If True, additional points built on waypoints from tracks and routes will be added 
        to layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGPX.AdditionalWayPoints
        """
        pass

    @AdditionalWayPoints.setter
    def AdditionalWayPoints(
      self,
      _value: bool
    ) -> None: 
        """
        If True, additional points built on waypoints from tracks and routes will be added 
        to layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGPX.AdditionalWayPoints
        """
        pass

    @property
    def DataType(
      self
    ) -> typing.Sequence[TGIS_LayerGPXDataType]: 
        """
        Data type to read and parse from file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGPX.DataType
        """
        pass

    @DataType.setter
    def DataType(
      self,
      _value: typing.Sequence[TGIS_LayerGPXDataType]
    ) -> None: 
        """
        Data type to read and parse from file.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGPX.DataType
        """
        pass

class TGIS_LayerGRD( TGIS_LayerPixel ):
    """
    Encapsulation of an Arcinfo ASCII Grid, Surfer ASCII Grid, Surfer 6 binary Grid and 
    Surfer 7 binary Grid

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGRD
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGRD.Create_void
        """
        pass

class TGIS_LayerGSHHS( TGIS_LayerVector ):
    """
    Layer which can read a GSHHS file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGSHHS
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGSHHS.Create_void
        """
        pass

    @property
    def Level(
      self
    ) -> int: 
        """
        Data level to read. Can be 1 land, 2 lake, 3 island in lake, 4 pond in island in 
        lake.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGSHHS.Level
        """
        pass

    @Level.setter
    def Level(
      self,
      _value: int
    ) -> None: 
        """
        Data level to read. Can be 1 land, 2 lake, 3 island in lake, 4 pond in island in 
        lake.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerGSHHS.Level
        """
        pass

class TGIS_LayerIMG( TGIS_LayerPixel ):
    """
    Encapsulation of IMG (ERDAS IMAGINE) layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerIMG
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerIMG.Create_void
        """
        pass

class TGIS_LayerJPG( TGIS_LayerPixel ):
    """
    Encapsulation of a JPEG layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerJPG
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerJPG.Create_void
        """
        pass

class TGIS_LayerJSON( TGIS_LayerVector ):
    """
    Layer which can read a JSON text file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerJSON
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerJSON.Create_void
        """
        pass

class TGIS_LayerKML( TGIS_LayerVector ):
    """
    Encapsulation of the KML vector Layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerKML
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerKML.Create_void
        """
        pass

    @property
    def Extrude(
      self
    ) -> bool: 
        """
        Allows vertical extrusion of two-dimensional features to form three-dimensional objects.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerKML.Extrude
        """
        pass

    @Extrude.setter
    def Extrude(
      self,
      _value: bool
    ) -> None: 
        """
        Allows vertical extrusion of two-dimensional features to form three-dimensional objects.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerKML.Extrude
        """
        pass

    @property
    def LookAt(
      self
    ) -> bool: 
        """
        Defines the observation coordinates or eye point of the placemark.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerKML.LookAt
        """
        pass

    @LookAt.setter
    def LookAt(
      self,
      _value: bool
    ) -> None: 
        """
        Defines the observation coordinates or eye point of the placemark.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerKML.LookAt
        """
        pass

    @property
    def NameField(
      self
    ) -> str: 
        """
        Field name used to set KML name values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerKML.NameField
        """
        pass

    @NameField.setter
    def NameField(
      self,
      _value: str
    ) -> None: 
        """
        Field name used to set KML name values.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerKML.NameField
        """
        pass

    @property
    def PreserveZ(
      self
    ) -> bool: 
        """
        Preserve Z coordinate from imported shapes to avoid reprojection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerKML.PreserveZ
        """
        pass

    @PreserveZ.setter
    def PreserveZ(
      self,
      _value: bool
    ) -> None: 
        """
        Preserve Z coordinate from imported shapes to avoid reprojection.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerKML.PreserveZ
        """
        pass

    @property
    def Tessellate(
      self
    ) -> bool: 
        """
        Use tessellation to allow lines and paths to follow the terrain.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerKML.Tessellate
        """
        pass

    @Tessellate.setter
    def Tessellate(
      self,
      _value: bool
    ) -> None: 
        """
        Use tessellation to allow lines and paths to follow the terrain.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerKML.Tessellate
        """
        pass

class TGIS_LayerLandXML( TGIS_LayerVector ):
    """
    Encapsulation of a LandXML Layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerLandXML
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerLandXML.Create_void
        """
        pass

    @property
    def ExportType(
      self
    ) -> str: 
        """
        Name of export type for a shape geometry. Use to force conversion to other types 
        than default (D) :Point - CgPoints (D)
        
        Arc - Alignments (D), Contours or PlanFeatures
        
        Polygon - Parcels (D)
        
        MultiPatch - TIN Surface (D) or Parcels

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerLandXML.ExportType
        """
        pass

    @ExportType.setter
    def ExportType(
      self,
      _value: str
    ) -> None: 
        """
        Name of export type for a shape geometry. Use to force conversion to other types 
        than default (D) :Point - CgPoints (D)
        
        Arc - Alignments (D), Contours or PlanFeatures
        
        Polygon - Parcels (D)
        
        MultiPatch - TIN Surface (D) or Parcels

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerLandXML.ExportType
        """
        pass

class TGIS_LayerLAS( TGIS_LayerVector ):
    """
    Layer that can read LAS file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerLAS
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerLAS.Create_void
        """
        pass

class TGIS_LayerMIF( TGIS_LayerVector ):
    """
    Layer which can read a MIF/MID file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerMIF
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerMIF.Create_void
        """
        pass

    @property
    def PathMID(
      self
    ) -> str: 
        """
        Path to MID file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerMIF.PathMID
        """
        pass

    @property
    def PathMIF(
      self
    ) -> str: 
        """
        Path to MIF file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerMIF.PathMIF
        """
        pass

class TGIS_LayerMVT( TGIS_LayerCompoundVector ):
    """
    Encapsulation of MVT layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerMVT
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerMVT.Create_void
        """
        pass

    @property
    def Georeferenced(
      self
    ) -> bool: 
        """
        If True, geometry coordinates will be based on WebMercator (EPSG:3857).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerMVT.Georeferenced
        """
        pass

    @Georeferenced.setter
    def Georeferenced(
      self,
      _value: bool
    ) -> None: 
        """
        If True, geometry coordinates will be based on WebMercator (EPSG:3857).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerMVT.Georeferenced
        """
        pass

    @property
    def LayerFilter(
      self
    ) -> str: 
        """
        Filter a dataset by layer name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerMVT.LayerFilter
        """
        pass

    @LayerFilter.setter
    def LayerFilter(
      self,
      _value: str
    ) -> None: 
        """
        Filter a dataset by layer name.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerMVT.LayerFilter
        """
        pass

class TGIS_LayerOSM( TGIS_LayerCompoundVector ):
    """
    Encapsulation of a OSM Layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerOSM
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerOSM.Create_void
        """
        pass

    @property
    def AdditionalNodes(
      self
    ) -> bool: 
        """
        If True, additional points built on standalone nodes will be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerOSM.AdditionalNodes
        """
        pass

    @AdditionalNodes.setter
    def AdditionalNodes(
      self,
      _value: bool
    ) -> None: 
        """
        If True, additional points built on standalone nodes will be added.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerOSM.AdditionalNodes
        """
        pass

class TGIS_OSMImporter( TObject ):
    """
    Encapsulation of OSM importer class.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMImporter
    """

    @overload
    def __init__(
      self,
      _viewer: IGIS_Viewer
    ) -> None: 
        """
        Constructor.

        Args:
            _viewer: viewer handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMImporter.Create_IGIS_Viewer
        """
        pass

    def ExportOsmLines(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Export lines from osm layers.

        Args:
            _layer: destination layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMImporter.ExportOsmLines_TGIS_LayerVector
        """
        pass

    def ExportOsmPoints(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Export points from osm layers.

        Args:
            _layer: destination layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMImporter.ExportOsmPoints_TGIS_LayerVector
        """
        pass

    def ExportOsmPolygons(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Export polygons from osm layers.

        Args:
            _layer: destination layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMImporter.ExportOsmPolygons_TGIS_LayerVector
        """
        pass

    def ImportOSMFile(
      self,
      _file: str
    ) -> None: 
        """
        Import osm file into a database structure.

        Args:
            _file: file path

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMImporter.ImportOSMFile_String
        """
        pass

    @property
    def ImportLogEvent(
      self
    ) -> typing.Callable[[String], None]: 
        """
        Will be fired upon any progress to trace import.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMImporter.ImportLogEvent
        """
        pass

    @ImportLogEvent.setter
    def ImportLogEvent(
      self,
      _value: typing.Callable[[String], None]
    ) -> None: 
        """
        Will be fired upon any progress to trace import.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMImporter.ImportLogEvent
        """
        pass

class TGIS_PixelBandSet:
    pass

class TGIS_PixelBandSet:
    """
    Definition of how layer should be interpreted

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandSet
    """

    @property
    def Unknown(
      self
    ) -> TGIS_PixelBandSet: 
        """
        Unknown definition.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandSet.Unknown
        """
        pass

    @property
    def Rgb(
      self
    ) -> TGIS_PixelBandSet: 
        """
        Interpret layer as color RGB image.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandSet.Rgb
        """
        pass

    @property
    def Argb(
      self
    ) -> TGIS_PixelBandSet: 
        """
        Interpret layer as color ARGB image.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandSet.Argb
        """
        pass

    @property
    def Greyscale(
      self
    ) -> TGIS_PixelBandSet: 
        """
        Interpret layer as greyscale image.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandSet.Greyscale
        """
        pass

    @property
    def Negative(
      self
    ) -> TGIS_PixelBandSet: 
        """
        Interpret layer as greyscale image with reverted luminance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandSet.Negative
        """
        pass

    @property
    def Dem(
      self
    ) -> TGIS_PixelBandSet: 
        """
        Interpret layer as grid (digital elevation model).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandSet.Dem
        """
        pass

class TGIS_PixelBandContent:
    pass

class TGIS_PixelBandContent:
    """
    Definition of the meaning of a particular band.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandContent
    """

    @property
    def Unknown(
      self
    ) -> TGIS_PixelBandContent: 
        """
        Unknown definition.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandContent.Unknown
        """
        pass

    @property
    def Alpha(
      self
    ) -> TGIS_PixelBandContent: 
        """
        Band is an alpha channel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandContent.Alpha
        """
        pass

    @property
    def Red(
      self
    ) -> TGIS_PixelBandContent: 
        """
        Band is a red channel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandContent.Red
        """
        pass

    @property
    def Green(
      self
    ) -> TGIS_PixelBandContent: 
        """
        Band is a green channel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandContent.Green
        """
        pass

    @property
    def Blue(
      self
    ) -> TGIS_PixelBandContent: 
        """
        Band is a blue channel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandContent.Blue
        """
        pass

    @property
    def Photo(
      self
    ) -> TGIS_PixelBandContent: 
        """
        Band is an other kind of a photo channel (like infrared).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandContent.Photo
        """
        pass

    @property
    def Dem(
      self
    ) -> TGIS_PixelBandContent: 
        """
        Band is grid / digital elevation model.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandContent.Dem
        """
        pass

class TGIS_PixelBandCoding:
    pass

class TGIS_PixelBandCoding:
    """
    Definition of how particular band is stored.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandCoding
    """

    @property
    def Unknown(
      self
    ) -> TGIS_PixelBandCoding: 
        """
        Band is an other kind of a photo channel (like infrared).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandCoding.Unknown
        """
        pass

    @property
    def Palette(
      self
    ) -> TGIS_PixelBandCoding: 
        """
        Band is stored as palette.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandCoding.Palette
        """
        pass

    @property
    def Integer(
      self
    ) -> TGIS_PixelBandCoding: 
        """
        Band is stored as signed integer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandCoding.Integer
        """
        pass

    @property
    def Cardinal(
      self
    ) -> TGIS_PixelBandCoding: 
        """
        Band is stored as unsigned integer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandCoding.Cardinal
        """
        pass

    @property
    def Float(
      self
    ) -> TGIS_PixelBandCoding: 
        """
        Band is stored as float.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandCoding.Float
        """
        pass

class TGIS_PixelBandList:
    """
    List of TGIS_PixelBand objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_PixelBand:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_PixelBand
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandList.Create_void
        """
        pass

    def Add(
      self,
      _item: TGIS_PixelBand
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandList.Add_TGIS_PixelBand
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandList.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandList.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandList.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> TGIS_PixelBand: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandList.Item
        """
        pass

class TGIS_LayerPixelLock( TObject ):
    """
    Structure of locked image area.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _parent: TGIS_LayerPixel
    ) -> None: 
        """
        Constructor.

        Args:
            _parent: the owner of the lock

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.Create_TGIS_LayerPixel
        """
        pass

    def AsArray(
      self
    ) -> numpy.array: 
        """
        Returns currect lock scope as NumPy array.

        Returns:
            Numpy array

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.AsArray_void
        """
        pass

    def BitmapPos(
      self,
      _x: int,
      _y: int
    ) -> int: 
        """
        Convert x and y image pixel location to position in Bitmap array

        Args:
            _x: image column
            _y: image raw

        Returns:
            calculated position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.BitmapPos_Integer_Integer
        """
        pass

    def FromArray(
      self,
      _array: numpy.array
    ) -> None: 
        """
        Fill current lock scope Returns with NumPy array content.

        Args:
            _array: NumPy array

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.FromArray_numpy.array
        """
        pass

    def MapToRaster(
      self,
      _ptg: TGIS_Point,
      _cs: TGIS_CSCoordinateSystem
    ) -> TPoint: 
        """
        Convert map coordinates to a pixel location within locked buffer

        Args:
            _ptg: point to be converted
            _cs: coordinate system of _ptg; if nil that coordinate system same as layer coordinate 
              system

        Returns:
            calculated point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.MapToRaster_TGIS_Point_TGIS_CSCoordinateSystem
        """
        pass

    def MapToRasterRect(
      self,
      _ext: TGIS_Extent,
      _cs: TGIS_CSCoordinateSystem
    ) -> TRect: 
        """
        Convert map coordinates to a pixel location within locked buffer

        Args:
            _ext: extent to be converted
            _cs: coordinate system of _ext; if nil that coordinate system same as layer coordinate 
              system

        Returns:
            calculated extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.MapToRasterRect_TGIS_Extent_TGIS_CSCoordinateSystem
        """
        pass

    def RasterToMap(
      self,
      _pt: TPoint,
      _cs: TGIS_CSCoordinateSystem
    ) -> TGIS_Point: 
        """
        Convert locked buffer location to map coordinates

        Args:
            _pt: location to be converted
            _cs: coordinate system of returned value; if nil that coordinate system same as layer 
              coordinate system

        Returns:
            calculated point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.RasterToMap_TPoint_TGIS_CSCoordinateSystem
        """
        pass

    def RasterToMapRect(
      self,
      _rct: TRect,
      _cs: TGIS_CSCoordinateSystem
    ) -> TGIS_Extent: 
        """
        Convert locked buffer location to map coordinates

        Args:
            _rct: location to be converted
            _cs: coordinate system of returned value; if nil that coordinate system same as layer 
              coordinate system

        Returns:
            calculated extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.RasterToMapRect_TRect_TGIS_CSCoordinateSystem
        """
        pass

    @property
    def Band(
      self
    ) -> TGIS_GridArray: 
        """
        Locked band buffer. If band has not ben locked then null.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.Band
        """
        pass

    @property
    def BandNo(
      self
    ) -> int: 
        """
        Locked band number.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.BandNo
        """
        pass

    @property
    def Bitmap(
      self
    ) -> TGIS_Pixels: 
        """
        Locked bitmap buffer. Null if locked area is grid type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.Bitmap
        """
        pass

    @property
    def Bounds(
      self
    ) -> TRect: 
        """
        Bounds of locked buffer. For in-memory layer bounds are not necessary 0 based!

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.Bounds
        """
        pass

    @property
    def CS(
      self
    ) -> TGIS_CSCoordinateSystem: 
        """
        Coordinate system of locked area.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.CS
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Extent: 
        """
        Locked extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.Extent
        """
        pass

    @property
    def Grid(
      self
    ) -> TGIS_GridArray: 
        """
        Locked grid buffer. Null if locked area is bitmap type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.Grid
        """
        pass

    @property
    def IsTiled(
      self
    ) -> bool: 
        """
        If true then locked area represents a tile.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.IsTiled
        """
        pass

    @property
    def Parent(
      self
    ) -> TGIS_LayerPixel: 
        """
        The reference to the parent object. Pixel layer to which the lock object belongs.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.Parent
        """
        pass

    @property
    def PixelSize(
      self
    ) -> TGIS_Point: 
        """
        Pixels size of locked buffer in locked CS units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.PixelSize
        """
        pass

    @property
    def TileInfo(
      self
    ) -> TGIS_Tile: 
        """
        Additional information about tile if locked area is a tile.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.TileInfo
        """
        pass

    @property
    def Writable(
      self
    ) -> bool: 
        """
        If true then area is locked in read/write mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelLock.Writable
        """
        pass

class TGIS_PixelItem:
    """
    Pixel value used mainly in iterators.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelItem
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelItem.Create_void
        """
        pass

    @property
    def Bands(
      self
    ) -> TGIS_SingleArray: 
        """
        Values of individual bands. Meaningful only for Loop() constructed on specific or 
        all bands.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelItem.Bands
        """
        pass

    @Bands.setter
    def Bands(
      self,
      _value: TGIS_SingleArray
    ) -> None: 
        """
        Values of individual bands. Meaningful only for Loop() constructed on specific or 
        all bands.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelItem.Bands
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Color value of the pixel. Meaningful only for bitmap based layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelItem.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Color value of the pixel. Meaningful only for bitmap based layers.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelItem.Color
        """
        pass

    @property
    def Value(
      self
    ) -> float: 
        """
        Value of the pixel. Meaningful only for grid layers and Loop().

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelItem.Value
        """
        pass

    @Value.setter
    def Value(
      self,
      _value: float
    ) -> None: 
        """
        Value of the pixel. Meaningful only for grid layers and Loop().

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelItem.Value
        """
        pass

    @property
    def Center(
      self
    ) -> TGIS_Point: 
        """
        Coordinates of the center of the pixel in layer coordinate system.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelItem.Center
        """
        pass

    @property
    def Distance(
      self
    ) -> float: 
        """
        Distance of pixel along line. Valid only if looped on TGIS_ShapeArc features.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelItem.Distance
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Extent: 
        """
        Extent of the pixel in layer coordinate system.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelItem.Extent
        """
        pass

    @property
    def Writable(
      self
    ) -> bool: 
        """
        If true then pixel is in a writable mode (changes will be posted back after leaving 
        loop)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelItem.Writable
        """
        pass

class TGIS_PixelBand( TObject ):
    """
    Complete definition of a band.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBand
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBand.Create_void
        """
        pass

    @property
    def Coding(
      self
    ) -> TGIS_PixelBandCoding: 
        """
        Coding method of a band.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBand.Coding
        """
        pass

    @property
    def Content(
      self
    ) -> TGIS_PixelBandContent: 
        """
        Content type of a band.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBand.Content
        """
        pass

    @property
    def SkipAfter(
      self
    ) -> int: 
        """
        How many pixels should be ignored at the tail tail of a band.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBand.SkipAfter
        """
        pass

    @property
    def SkipBefore(
      self
    ) -> int: 
        """
        How many pixels should be ignored at the beginning tail of a band.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBand.SkipBefore
        """
        pass

    @property
    def ValidBits(
      self
    ) -> int: 
        """
        How many pixels should be treated as a band value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBand.ValidBits
        """
        pass

class TGIS_PixelBandsDefinition( TObject ):
    """
    Complete definition of all bands of a layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandsDefinition
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandsDefinition.Create_void
        """
        pass

    def AddBand(
      self,
      _content: TGIS_PixelBandContent,
      _coding: TGIS_PixelBandCoding,
      _skip_before: int,
      _valid_bits: int,
      _skip_after: int
    ) -> None: 
        """
        Add a band definition.

        Args:
            _content: Content type of a band.
            _coding: Coding method of a band.
            _skip_before: How many pixels should be ignored at the beginning tail of a band.
            _valid_bits: How many pixels should be trated as a band value.
            _skip_after: How many pixels should be ignored at the tail tail of a band.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandsDefinition.AddBand_TGIS_PixelBandContent_TGIS_PixelBandCoding_Cardinal_Cardinal_Cardinal
        """
        pass

    def ClearBands(
      self
    ) -> None: 
        """
        Clear all band definitions.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandsDefinition.ClearBands_void
        """
        pass

    def FromString(
      self,
      _value: str
    ) -> None: 
        """
        Convert a string representation to a band definition.

        Args:
            _value: string represtantion of band definition

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandsDefinition.FromString_String
        """
        pass

    def SetBandSet(
      self,
      _fileinfo: str,
      _bandset: TGIS_PixelBandSet,
      _band1: int,
      _band2: int,
      _band3: int,
      _band4: int
    ) -> None: 
        """
        Set band use.

        Args:
            _fileinfo: unique value for a file producer like camera producer + camera model
            _bandset: band interpretation
            _band1: first band; should be &gt; 0;
            _band2: second band; Is &gt; 0 only if _bandset=Rgb or Argb
            _band3: third band. Is &gt; 0 only if _bandset=Rgb or Argb
            _band4: third band. Is &gt; 0 only if _bandset=Argb

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandsDefinition.SetBandSet_String_TGIS_PixelBandSet_Cardinal_Cardinal_Cardinal_Cardinal
        """
        pass

    def ToString(
      self
    ) -> str: 
        """
        Convert a band definition to a string representation.

        Returns:
            String representation of band definition.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandsDefinition.ToString_void
        """
        pass

    @property
    def Band1(
      self
    ) -> int: 
        """
        First band. Should be &gt; 0;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandsDefinition.Band1
        """
        pass

    @property
    def Band2(
      self
    ) -> int: 
        """
        Second band of BandSet. Is &gt; 0 only if Bandset=Rgb or Argb

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandsDefinition.Band2
        """
        pass

    @property
    def Band3(
      self
    ) -> int: 
        """
        Third band of BandSet. Is &gt; 0 only if Bandset=Rgb or Argb

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandsDefinition.Band3
        """
        pass

    @property
    def Band4(
      self
    ) -> int: 
        """
        Fourth band of BandSet. Is &gt; 0 only if Bandset=Argb

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandsDefinition.Band4
        """
        pass

    @property
    def Bands(
      self
    ) -> TGIS_PixelBandList: 
        """
        Definitions of all bands.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandsDefinition.Bands
        """
        pass

    @property
    def BandSet(
      self
    ) -> TGIS_PixelBandSet: 
        """
        How bands should be interpreted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandsDefinition.BandSet
        """
        pass

    @property
    def FileInfo(
      self
    ) -> str: 
        """
        File producer info (like camera manufacture).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelBandsDefinition.FileInfo
        """
        pass

class TGIS_LayerPixel( TGIS_Layer ):
    """
    Encapsulation of a common image layer - abstract class.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Create_void
        """
        pass

    @overload
    def ApplyAntialiasSettings(
      self,
      _antialias: bool
    ) -> None: 
        """
        Applies antialias settings used in scaling operations.

        Args:
            _antialias: If True, antialias will be active

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.ApplyAntialiasSettings_Boolean
        """
        pass

    @overload
    def ApplyAntialiasSettings(
      self,
      _antialias: bool,
      _antialiasFilter: TGIS_ScalingFilter
    ) -> None: 
        """
        Applies antialias settings used in scaling operations.

        Args:
            _antialias: If True, antialias will be active
            _antialiasFilter: scaling filtering type

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.ApplyAntialiasSettings_Boolean_TGIS_ScalingFilter
        """
        pass

    def AssignedParentLayerInternal(
      self,
      _parent: TGIS_LayerPixel
    ) -> None: 
        """
        Assigns a parent layer. To be used only in layers like WMTS.

        Args:
            _parent: parent layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.AssignedParentLayerInternal_TGIS_LayerPixel
        """
        pass

    @overload
    def Build(
      self,
      _path: str,
      _cs: TGIS_CSCoordinateSystem,
      _ext: TGIS_Extent,
      _width: int,
      _height: int
    ) -> None: 
        """
        Builds an image layer.

        Args:
            _path: path to a layer; if empty then layer in-memory
            _cs: Coordinate system of the layer
            _ext: extent of the layer expresses in Coordinate System units (_cs)
            _width: width in pixels
            _height: height in pixels; if 0 then is calculated according to _width and proportions 
              of _ext

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Build_String_TGIS_CSCoordinateSystem_TGIS_Extent_Integer_Integer
        """
        pass

    @overload
    def Build(
      self,
      _path: str,
      _grid: bool,
      _cs: TGIS_CSCoordinateSystem,
      _ext: TGIS_Extent,
      _width: int,
      _height: int,
      _subformat: TGIS_LayerPixelSubFormat
    ) -> None: 
        """
        Builds a layer.

        Args:
            _path: path to a layer; if empty then layer in-memory
            _grid: if true then layer will be treated as grid a image layer will be created otherwise
            _cs: Coordinate system of the layer
            _ext: extent of the layer expresses in Coordinate System units (_cs)
            _width: width in pixels
            _height: height in pixels; if 0 then is calculated according to _width and proportions 
              of _ext
            _subformat: details specification of layer format like compression etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Build_String_Boolean_TGIS_CSCoordinateSystem_TGIS_Extent_Integer_Integer_TGIS_LayerPixelSubFormat
        """
        pass

    @overload
    def Build(
      self,
      _grid: bool,
      _cs: TGIS_CSCoordinateSystem,
      _ext: TGIS_Extent,
      _width: int,
      _height: int
    ) -> None: 
        """
        Builds an in-memory layer.

        Args:
            _grid: if true then layer will be treated as grid a image layer will be created otherwise
            _cs: Coordinate system of the layer
            _ext: extent of the layer expresses in Coordinate System units (_cs)
            _width: width in pixels
            _height: height in pixels; if 0 then is calculated according to _width and proportions 
              of _ext

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Build_Boolean_TGIS_CSCoordinateSystem_TGIS_Extent_Integer_Integer
        """
        pass

    @overload
    def Build(
      self,
      _path: str,
      _grid: bool,
      _cs: TGIS_CSCoordinateSystem,
      _ext: TGIS_Extent,
      _pixelsize: float,
      _subformat: TGIS_LayerPixelSubFormat
    ) -> None: 
        """
        Builds a layer.

        Args:
            _path: path to a layer; if empty then layer in-memory
            _grid: if true then layer will be treated as grid a image layer will be created otherwise
            _cs: Coordinate system of the layer
            _ext: extent of the layer expresses in Coordinate System units (_cs)
            _pixelsize: pixel layer resolution in Coordinate System units
            _subformat: details specification of layer format like compression etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Build_String_Boolean_TGIS_CSCoordinateSystem_TGIS_Extent_Double_TGIS_LayerPixelSubFormat
        """
        pass

    @overload
    def Build(
      self,
      _path: str,
      _cs: TGIS_CSCoordinateSystem,
      _ext: TGIS_Extent,
      _pixelsize: float
    ) -> None: 
        """
        Builds an image layer.

        Args:
            _path: path to a layer; if empty then layer in-memory
            _cs: Coordinate system of the layer
            _ext: extent of the layer expresses in Coordinate System units (_cs)
            _pixelsize: pixel layer resolution in Coordinate System units

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Build_String_TGIS_CSCoordinateSystem_TGIS_Extent_Double
        """
        pass

    @overload
    def Build(
      self,
      _grid: bool,
      _cs: TGIS_CSCoordinateSystem,
      _ext: TGIS_Extent,
      _pixelsize: float
    ) -> None: 
        """
        Builds an in-memory layer.

        Args:
            _grid: if true then layer will be treated as grid a image layer will be created otherwise
            _cs: Coordinate system of the layer
            _ext: extent of the layer expresses in Coordinate System units (_cs)
            _pixelsize: pixel layer resolution in Coordinate System units

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Build_Boolean_TGIS_CSCoordinateSystem_TGIS_Extent_Double
        """
        pass

    def ExportLayer(
      self,
      _layer: TGIS_LayerPixel,
      _extent: TGIS_Extent
    ) -> None: 
        """
        Export layer.

        Args:
            _layer: layer to be exported to
            _extent: starting extent of layer - can''t be zero sized

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.ExportLayer_TGIS_LayerPixel_TGIS_Extent
        """
        pass

    def FinalizeWrite(
      self
    ) -> None: 
        """
        Performs any operation required to safely finalize write operation, such as building 
        quad trees for TGIS_FilePixelStore.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.FinalizeWrite_void
        """
        pass

    @overload
    def GenerateRamp(
      self,
      _startColor: TGIS_Color,
      _middleColor: TGIS_Color,
      _endColor: TGIS_Color,
      _minValue: float,
      _midValue: float,
      _maxValue: float,
      _useMiddle: bool,
      _rampInterval: float,
      _legendInterval: float,
      _params: TGIS_ParamsSectionPixel,
      _clearMapZones: bool,
      _colorSpace: TGIS_ColorInterpolationMode
    ) -> None: 
        """
        Generates a grid ramp.

        Args:
            _startColor: start color
            _middleColor: middle color
            _endColor: end color
            _minValue: minimum value
            _midValue: middle value
            _maxValue: maximum value
            _useMiddle: If True, a middle value will be used
            _rampInterval: ramp interval
            _legendInterval: legend interval
            _params: parameters to be altered, if nil then a layer parameters will be altered
            _clearMapZones: if True, zones list will be cleared before adding a ramp
            _colorSpace: color space for color interpolation

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.GenerateRamp_TGIS_Color_TGIS_Color_TGIS_Color_Double_Double_519205E514FBE37A57E4AA425ADB249B
        """
        pass

    @overload
    def GenerateRamp(
      self,
      _startColor: TGIS_Color,
      _middleColor: TGIS_Color,
      _endColor: TGIS_Color,
      _minValue: float,
      _midValue: float,
      _maxValue: float,
      _useMiddle: bool,
      _rampInterval: float,
      _legendInterval: float,
      _params: TGIS_ParamsSectionPixel,
      _clearMapZones: bool
    ) -> None: 
        """
        Generates a grid ramp.

        Args:
            _startColor: start color
            _middleColor: middle color
            _endColor: end color
            _minValue: minimum value
            _midValue: middle value
            _maxValue: maximum value
            _useMiddle: If True, a middle value will be used
            _rampInterval: ramp interval
            _legendInterval: legend interval
            _params: parameters to be altered, if nil then a layer parameters will be altered
            _clearMapZones: if True, zones list will be cleared before adding a ramp

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.GenerateRamp_TGIS_Color_TGIS_Color_TGIS_Color_Double_Double_53D50DB0D3D136EB97EC8B43B05BD560
        """
        pass

    @overload
    def GenerateRampEx(
      self,
      _minValue: float,
      _maxValue: float,
      _colorMap: TGIS_ColorMapArray,
      _params: TGIS_ParamsSectionPixel,
      _cInterpMode: TGIS_ColorInterpolationMode
    ) -> None: 
        """
        Generates a grid ramp from a mapped color array.

        Args:
            _minValue: minimum value
            _maxValue: maximum value
            _colorMap: mapped color array
            _params: parameters to be altered, if nil then a layer parameters will be altered
            _cInterpMode: color space for color interpolation

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.GenerateRampEx_Double_Double_TGIS_ColorMapArray_TGIS_ParamsSectionPixel_TGIS_ColorInterpolationMode
        """
        pass

    @overload
    def GenerateRampEx(
      self,
      _minValue: float,
      _maxValue: float,
      _colorMap: TGIS_ColorMapArray,
      _params: TGIS_ParamsSectionPixel
    ) -> None: 
        """
        Generates a grid ramp from a mapped color array.

        Args:
            _minValue: minimum value
            _maxValue: maximum value
            _colorMap: mapped color array
            _params: parameters to be altered, if nil then a layer parameters will be altered

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.GenerateRampEx_Double_Double_TGIS_ColorMapArray_TGIS_ParamsSectionPixel
        """
        pass

    def GetAltitudeMapZone(
      self,
      _zoneIndex: int
    ) -> TGIS_AltitudeZone: 
        """
        Gets an altitude zone map definition.

        Args:
            _zoneIndex: zone index

        Returns:
            Desired altitude map zone.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.GetAltitudeMapZone_Integer
        """
        pass

    def GetBitmap(
      self,
      _extent: TGIS_Extent,
      _bitmap: TGIS_Pixels,
      _width: int,
      _height: int
    ) -> bool: 
        """
        Fills provided _bitmap array with values defined by _extent. If the current layer 
        does not fully cover the _extent then values outside the layer scope should be left 
        untouched.

        Args:
            _extent: extent of the _bitmap
            _bitmap: allocated array (width/height ratio of the _bitmap should be the same as 
              width/height ration of the _extent)
            _width: width of the _bitmap
            _height: height of the _bitmap

        Returns:
            True if success

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.GetBitmap_TGIS_Extent_TGIS_Pixels_Integer_Integer
        """
        pass

    def GetColorRamp(
      self,
      _val: float
    ) -> TGIS_Color: 
        """
        Calculates default color ramp RGB values.

        Args:
            _val: grid value for which color will be calculated

        Returns:
            calculated color

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.GetColorRamp_Single
        """
        pass

    def GetGrid(
      self,
      _extent: TGIS_Extent,
      _grid: TGIS_GridArray
    ) -> bool: 
        """
        Fills provided _grid array with values defined by _extent. If the current layer does 
        not fully cover the _extent then values outside the layer scope should be left untouched.

        Args:
            _extent: extent of the _grid
            _grid: allocated array (width/height ratio of the _grid should be the same as width/height 
              ration of the _extent)

        Returns:
            True if success

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.GetGrid_TGIS_Extent_TGIS_GridArray
        """
        pass

    def GetRawBitmap(
      self,
      _extent: TGIS_Extent,
      _bitmap: TGIS_Pixels,
      _width: int,
      _height: int
    ) -> bool: 
        """
        Fills provided _bitmap array with values defined by _extent. If the current layer 
        does not fully cover the _extent then values outside the layer scope should be left 
        untouched.

        Args:
            _extent: extent of the _bitmap
            _bitmap: allocated array (width/height ratio of the _bitmap should be the same as 
              width/height ration of the _extent)
            _width: width of the _bitmap
            _height: height of the _bitmap

        Returns:
            True if success

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.GetRawBitmap_TGIS_Extent_TGIS_Pixels_Integer_Integer
        """
        pass

    @overload
    def ImportLayer(
      self,
      _layer: TGIS_LayerPixel,
      _extent: TGIS_Extent
    ) -> None: 
        """
        Imports layer from an existing pixel layer. Use this method to import a layer. To 
        do this, simply create a new layer, choose a layer to import from and use ImportLayer 
        method of with proper parameters.

        Args:
            _layer: layer to be exported to
            _extent: extent to be exported

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.ImportLayer_TGIS_LayerPixel_TGIS_Extent
        """
        pass

    @overload
    def ImportLayer(
      self,
      _layer: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _cs: TGIS_CSCoordinateSystem,
      _width: int,
      _height: int
    ) -> None: 
        """
        Imports layer from an existing pixel layer. Use this method to import a layer. To 
        do this, simply create a new layer, choose a layer to import from and use ImportLayer 
        method of with proper parameters.

        Args:
            _layer: layer to be exported from
            _extent: extent to be exported
            _cs: coordinate system to be exported
            _width: bit width of a layer; if 0 then _height will be used as to calculate
            _height: bit height of a layer; if 0 then _width will be used as to calculate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.ImportLayer_TGIS_LayerPixel_TGIS_Extent_TGIS_CSCoordinateSystem_Cardinal_Cardinal
        """
        pass

    @overload
    def ImportLayer(
      self,
      _layer: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _cs: TGIS_CSCoordinateSystem,
      _width: int,
      _height: int,
      _subformat: TGIS_LayerPixelSubFormat
    ) -> None: 
        """
        Imports layer from an existing pixel layer. Use this method to import a layer. To 
        do this, simply create a new layer, choose a layer to import from and use ImportLayer 
        method of with proper parameters.

        Args:
            _layer: layer to be exported from
            _extent: extent to be exported in _cs coordinate system
            _cs: coordinate system to be exported in
            _width: bit width of a layer; if 0 then _height will be used as to calculate
            _height: bit height of a layer; if 0 then _width will be used as to calculate
            _subformat: Pixel file capabilities.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.ImportLayer_TGIS_LayerPixel_TGIS_Extent_TGIS_CSCoordinateSystem_Cardinal_Cardinal_TGIS_LayerPixelSubFormat
        """
        pass

    def InitializeWrite(
      self
    ) -> None: 
        """
        Performs any operation required to safely initialize write operation, such as batch 
        operations for TGIS_FilePixelStore.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.InitializeWrite_void
        """
        pass

    def Locate(
      self,
      _ptg: TGIS_Point,
      _rgbMapped: VarParameter,
      _nativesVals: VarParameter,
      _transparency: VarParameter
    ) -> bool: 
        """
        If a given point is located in the image area, returns true and sets variables.

        Args:
            _ptg: reference point /searching point/; if the layer has been attached to the Viewer 
              then expected _ptg units are in a Viewer coordinate space; otherwise expected _ptg 
              units are in a Layer coordinate space
            _rgbMapped: color in _ptg point after mapping (the same as _nativesVals if no mapping, 
              in this case _rgbMapped and $FF = Byte(_nativesVals[0] and so on).; the value (in/out) 
              is passed as TGIS_Color in _rgbMapped.Value property
            _nativesVals: dynamic array of double with original values in _ptg point (for example 
              R, G, B), Length(_nativesVals) is equal to number of bands; the value (in/out) is 
              passed as TGIS_DoubleArray in _nativesVals.Value property
            _transparency: set on True if point is transparent; the value (in/out) is passed 
              as bool in _transparency.Value property

        Returns:
            True if success

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Locate_TGIS_Point_TGIS_Color_TGIS_DoubleArray_Boolean
        """
        pass

    def LocateEx(
      self,
      _ptg: TGIS_Point,
      _rgbMapped: VarParameter,
      _nativesVals: VarParameter,
      _transparency: VarParameter,
      _pixelsize: float
    ) -> bool: 
        """
        If a given point is located in the image area, returns true and sets variables.

        Args:
            _ptg: reference point /searching point/; if the layer has been attached to the Viewer 
              then expected _ptg units are in a Viewer coordinate space; otherwise expected _ptg 
              units are in a Layer coordinate space
            _rgbMapped: color in _ptg point after mapping (the same as _nativesVals if no mapping, 
              in this case _rgbMapped and $FF = Byte(_nativesVals[0] and so on).; the value (in/out) 
              is passed as TGIS_Color in _rgbMapped.Value property
            _nativesVals: dynamic array of double with original values in _ptg point (for example 
              R, G, B), Length(_nativesVals) is equal to number of bands; the value (in/out) is 
              passed as TGIS_DoubleArray in _nativesVals.Value property
            _transparency: set on True if point is transparent; the value (in/out) is passed 
              as bool in _transparency.Value property
            _pixelsize: requested size of image pixel; by providing 0 an actual viewer scale 
              should be used to calculate am optimal pixel size; &gt;0 - pixel size is expressed 
              in map units; &lt;0 - pixels is expressed in layer units

        Returns:
            True if success

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.LocateEx_TGIS_Point_TGIS_Color_TGIS_DoubleArray_Boolean_Double
        """
        pass

    def LockEstimate(
      self,
      _ext: TGIS_Extent,
      _cs: TGIS_CSCoordinateSystem,
      _pixelsize: float
    ) -> int: 
        """
        Estimates memory size for pixel layer to be update.

        Args:
            _ext: area to be locked; if bigger then layer extent then will be truncated to layer 
              extent
            _cs: coordinate system of _cs; if nil then same as layer CS
            _pixelsize: minimum requested size of image pixel; by providing 0 a maximum possible 
              resolution will be used;

        Returns:
            estimated size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.LockEstimate_TGIS_Extent_TGIS_CSCoordinateSystem_Double
        """
        pass

    @overload
    def LockPixels(
      self,
      _ext: TGIS_Extent,
      _cs: TGIS_CSCoordinateSystem,
      _writable: bool
    ) -> TGIS_LayerPixelLock: 
        """
        Locks a fragment of the pixel layer for updating.

        Args:
            _ext: area to be locked; if bigger then layer extent then will be truncated to layer 
              extent
            _cs: coordinate system of _cs; if nil then same as layer CS
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_LayerPixelLock.Writable will be set accordingly

        Returns:
            locked area

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.LockPixels_TGIS_Extent_TGIS_CSCoordinateSystem_Boolean
        """
        pass

    @overload
    def LockPixels(
      self,
      _ext: TGIS_Extent,
      _cs: TGIS_CSCoordinateSystem,
      _pixelsize: float,
      _writable: bool
    ) -> TGIS_LayerPixelLock: 
        """
        Locks a fragment of the pixel layer for updating.

        Args:
            _ext: area to be locked; if bigger then layer extent then will be truncated to layer 
              extent
            _cs: coordinate system of _cs; if nil then same as layer CS
            _pixelsize: minimum requested size of image pixel; by providing 0 a maximum possible 
              resolution will be used, which is also a fastest method if a layer is full in-memory 
              because in such situation a pointer to existing memory will be used
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_LayerPixelLock.Writable will be set accordingly

        Returns:
            locked area

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.LockPixels_TGIS_Extent_TGIS_CSCoordinateSystem_Double_Boolean
        """
        pass

    @overload
    def LockPixels(
      self,
      _rct: TRect,
      _writable: bool
    ) -> TGIS_LayerPixelLock: 
        """
        Locks a fragment of the pixel layer for updating.

        Args:
            _rct: rectangle on raster to be locked; if bigger then raster size then will be truncated
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_LayerPixelLock.Writable will be set accordingly

        Returns:
            locked area

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.LockPixels_TRect_Boolean
        """
        pass

    @overload
    def LockPixels(
      self,
      _ext: TGIS_Extent,
      _cs: TGIS_CSCoordinateSystem,
      _pixelsize: float,
      _band: int,
      _writable: bool
    ) -> TGIS_LayerPixelLock: 
        """
        Locks a fragment of the pixel layer for updating.

        Args:
            _ext: area to be locked; if bigger then layer extent then will be truncated to layer 
              extent
            _cs: coordinate system of _cs; if nil then same as layer CS
            _pixelsize: minimum requested size of image pixel; by providing 0 a maximum possible 
              resolution will be used, which is also a fastest method if a layer is full in-memory 
              because in such situation a pointer to existing memory will be used
            _band: specific band to be locked
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_LayerPixelLock.Writable will be set accordingly

        Returns:
            locked area

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.LockPixels_TGIS_Extent_TGIS_CSCoordinateSystem_Double_Integer_Boolean
        """
        pass

    @overload
    def LockPixels(
      self,
      _ext: TGIS_Extent,
      _cs: TGIS_CSCoordinateSystem,
      _band: int,
      _writable: bool
    ) -> TGIS_LayerPixelLock: 
        """
        Locks a fragment of the pixel layer for updating.

        Args:
            _ext: area to be locked; if bigger then layer extent then will be truncated to layer 
              extent
            _cs: coordinate system of _cs; if nil then same as layer CS
            _band: specific band to be locked
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_LayerPixelLock.Writable will be set accordingly

        Returns:
            locked area

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.LockPixels_TGIS_Extent_TGIS_CSCoordinateSystem_Integer_Boolean
        """
        pass

    @overload
    def LockPixels(
      self,
      _rct: TRect,
      _band: int,
      _writable: bool
    ) -> TGIS_LayerPixelLock: 
        """
        Locks a fragment of the pixel layer for updating.

        Args:
            _rct: rectangle on raster to be locked; if bigger then raster size then will be truncated
            _band: specific band to be locked
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_LayerPixelLock.Writable will be set accordingly

        Returns:
            locked area

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.LockPixels_TRect_Integer_Boolean
        """
        pass

    @overload
    def LockPixels(
      self,
      _rct: TRect,
      _ext: TGIS_Extent,
      _tilelevel: int,
      _tilerow: int,
      _tilecolumn: int,
      _writable: bool
    ) -> TGIS_LayerPixelLock: 
        """
        Locks a fragment of the pixel layer for updating.

        Args:
            _rct: rectangle on raster to be locked; if bigger then raster size then will be truncated
            _ext: area to be locked; if bigger then layer extent then will be truncated to layer 
              extent
            _tilelevel: tile level
            _tilerow: tile row
            _tilecolumn: tile column
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_LayerPixelLock.Writable will be set accordingly

        Returns:
            locked area

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.LockPixels_TRect_TGIS_Extent_Integer_Integer_Integer_Boolean
        """
        pass

    @overload
    def Loop(
      self,
      _extent: TGIS_Extent,
      _pixelsize: float,
      _fatpixel: bool,
      _shape: TGIS_Shape,
      _de9im: str,
      _writable: bool
    ) -> TGIS_LayerPixelEnumeratorFactory: 
        """
        Prepares enumerator to iterate the layer.

        Args:
            _extent: extent of items to be found; expected _extent units are in the Layer coordinate 
              space
            _pixelsize: minimum requested size of image pixel; by providing 0, the maximum possible 
              resolution will be used, which is also the fastest method if a layer is fully in-memory 
              because, in such situation, a pointer to existing memory is used
            _fatpixel: if false then pixel will be treated as point; if true then pixels will 
              be treated as small polygon, which is much slower but provides some more advanced 
              DE-9IM testing possibilities
            _shape: if not nil, then only pixels matching _de9im matrix with be found;
            _de9im: DE-9IM matrix of comparison
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_PixelItem.Writable will be set accordingly

        Returns:
            Pixel item returned row by row, column by column.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Loop_TGIS_Extent_Double_Boolean_TGIS_Shape_String_Boolean
        """
        pass

    @overload
    def Loop(
      self,
      _extent: TGIS_Extent,
      _pixelsize: float,
      _fatpixel: bool,
      _shape: TGIS_Shape,
      _de9im: str,
      _band: int,
      _writable: bool
    ) -> TGIS_LayerPixelEnumeratorFactory: 
        """
        Prepares enumerator to iterate the layer.

        Args:
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space
            _pixelsize: minimum requested size of image pixel; by providing 0 a maximum possible 
              resolution will be used, which is also a fastest method if a layer is full in-memory 
              because in such situation a pointer to existing memory will be used
            _fatpixel: if false then pixel will be treated as point; if true then pixels will 
              be treated as small polygon, which is much slower but provides some more advanced 
              DE-9IM testing possibilities
            _shape: if not nil, then only pixels matching _de9im matrix with be found;
            _de9im: DE-9IM matrix of comparison
            _band: band specificatio
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_PixelItem.Writable will be set accordingly

        Returns:
            Pixel item returned row by row, column by column.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Loop_TGIS_Extent_Double_Boolean_TGIS_Shape_String_Integer_Boolean
        """
        pass

    @overload
    def Loop(
      self,
      _extent: TGIS_Extent,
      _pixelsize: float,
      _shape: TGIS_Shape,
      _de9im: str,
      _writable: bool
    ) -> TGIS_LayerPixelEnumeratorFactory: 
        """
        Prepares enumerator to iterate the layer (pixels are treated as points).

        Args:
            _extent: extent of items to be found; expected _extent units are in the Layer coordinate 
              space
            _pixelsize: minimum requested size of image pixel; by providing 0, the maximum possible 
              resolution will be used, which is also the fastest method if a layer is fully in-memory 
              because, in such situation, a pointer to existing memory is used
            _shape: if not nil, then only pixels matching _de9im matrix with be found;
            _de9im: DE-9IM matrix of comparison
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_PixelItem.Writable will be set accordingly

        Returns:
            Pixel item returned row by row, column by column.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Loop_TGIS_Extent_Double_TGIS_Shape_String_Boolean
        """
        pass

    @overload
    def Loop(
      self,
      _extent: TGIS_Extent,
      _pixelsize: float,
      _shape: TGIS_Shape,
      _de9im: str,
      _band: int,
      _writable: bool
    ) -> TGIS_LayerPixelEnumeratorFactory: 
        """
        Prepares enumerator to iterate the layer (pixels are treated as points).

        Args:
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space
            _pixelsize: minimum requested size of image pixel; by providing 0 a maximum possible 
              resolution will be used, which is also a fastest method if a layer is full in-memory 
              because in such situation a pointer to existing memory will be used
            _shape: if not nil, then only pixels matching _de9im matrix with be found;
            _de9im: DE-9IM matrix of comparison
            _band: band specificatio
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_PixelItem.Writable will be set accordingly

        Returns:
            Pixel item returned row by row, column by column.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Loop_TGIS_Extent_Double_TGIS_Shape_String_Integer_Boolean
        """
        pass

    @overload
    def Loop(
      self,
      _pixelsize: float,
      _shape: TGIS_Shape,
      _writable: bool
    ) -> TGIS_LayerPixelEnumeratorFactory: 
        """
        Prepares enumerator to iterate the layer through the linear shape. Lines are interpreted 
        as-line-flow for terrain profile like analysis. Pixels are treated as points.

        Args:
            _pixelsize: minimum requested size of image pixel; by providing 0 a maximum possible 
              resolution will be used, which is also a fastest method if a layer is full in-memory 
              because in such situation a pointer to existing memory will be used
            _shape: if not nil, then only pixels within the shape will be found
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_PixelItem.Writable will be set accordingly

        Returns:
            Pixel item returned row by row, column by column with the except

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Loop_Double_TGIS_Shape_Boolean
        """
        pass

    @overload
    def Loop(
      self,
      _pixelsize: float,
      _shape: TGIS_Shape,
      _band: int,
      _writable: bool
    ) -> TGIS_LayerPixelEnumeratorFactory: 
        """
        Prepares enumerator to iterate the layer through the linear shape. Lines are interpreted 
        as-line-flow for terrain profile like analysis. Pixels are treated as points.

        Args:
            _pixelsize: minimum requested size of image pixel; by providing 0, the maximum possible 
              resolution will be used, which is also the fastest method if a layer is fully in-memory 
              because, in such situation, a pointer to existing memory is used
            _shape: if not nil, then only pixels within the shape will be found
            _band: band specificatio
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_PixelItem.Writable will be set accordingly

        Returns:
            Pixel item returned row by row, column by column with the except

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Loop_Double_TGIS_Shape_Integer_Boolean
        """
        pass

    @overload
    def Loop(
      self,
      _extent: TGIS_Extent,
      _pixelsize: float,
      _writable: bool
    ) -> TGIS_LayerPixelEnumeratorFactory: 
        """
        Prepares enumerator to iterate the layer (pixels are treated as points).

        Args:
            _extent: extent of items to be found; expected _extent units are in the Layer coordinate 
              space
            _pixelsize: minimum requested size of image pixel; by providing 0, the maximum possible 
              resolution will be used, which is also the fastest method if a layer is fully in-memory 
              because, in such situation, a pointer to existing memory is used
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_PixelItem.Writable will be set accordingly

        Returns:
            Pixel item returned row by row, column by column.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Loop_TGIS_Extent_Double_Boolean
        """
        pass

    @overload
    def Loop(
      self,
      _extent: TGIS_Extent,
      _pixelsize: float,
      _band: int,
      _writable: bool
    ) -> TGIS_LayerPixelEnumeratorFactory: 
        """
        Prepares enumerator to iterate the layer (pixels are treated as points).

        Args:
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space
            _pixelsize: minimum requested size of image pixel; by providing 0 a maximum possible 
              resolution will be used, which is also a fastest method if a layer is full in-memory 
              because in such situation a pointer to existing memory will be used
            _band: band specificatio
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_PixelItem.Writable will be set accordingly

        Returns:
            Pixel item returned row by row, column by column.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Loop_TGIS_Extent_Double_Integer_Boolean
        """
        pass

    def MapColorValue(
      self,
      _params: TGIS_ParamsSectionPixel,
      _color: TGIS_Color
    ) -> TGIS_Color: 
        """
        Maps color value to pixel color.

        Args:
            _params: corresponding pixel parameters
            _color: value

        Returns:
            mapped color

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.MapColorValue_TGIS_ParamsSectionPixel_TGIS_Color
        """
        pass

    def MapGridValue(
      self,
      _params: TGIS_ParamsSectionPixel,
      _val: float
    ) -> TGIS_Color: 
        """
        Maps grid value to pixel color.

        Args:
            _params: corresponding pixel parameters
            _val: value

        Returns:
            pixel color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.MapGridValue_TGIS_ParamsSectionPixel_Single
        """
        pass

    def MapToRaster(
      self,
      _ptg: TGIS_Point,
      _cs: TGIS_CSCoordinateSystem
    ) -> TPoint: 
        """
        Converts map coordinates to raster pixel location.

        Args:
            _ptg: point to be converted
            _cs: coordinate system of _ptg; if nil that coordinate system same as layer coordinate 
              system

        Returns:
            calculated location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.MapToRaster_TGIS_Point_TGIS_CSCoordinateSystem
        """
        pass

    def MapToRasterRect(
      self,
      _ext: TGIS_Extent,
      _cs: TGIS_CSCoordinateSystem
    ) -> TRect: 
        """
        Converts map extent to raster rectangle.

        Args:
            _ext: extent to be converted
            _cs: coordinate system of _ext; if nil that coordinate system same as layer coordinate 
              system

        Returns:
            calculated rectangle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.MapToRasterRect_TGIS_Extent_TGIS_CSCoordinateSystem
        """
        pass

    def MergeLayer(
      self,
      _layer: TGIS_LayerPixel,
      _extent: TGIS_Extent
    ) -> None: 
        """
        Merge layer to an existing layer. Use this method to merge a layer. To do this, simply 
        create a new layer, choose a layer to merge from and use MergeLayer method of with 
        proper parameters.

        Args:
            _layer: layer to be merged from
            _extent: extent to be merged

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.MergeLayer_TGIS_LayerPixel_TGIS_Extent
        """
        pass

    def PutGrid(
      self,
      _extent: TGIS_Extent,
      _grid: TGIS_GridArray
    ) -> bool: 
        """
        Puts _grid array into layer at the place defined by _extent. If the current layer 
        does not fully cover the _extent then values outside the layer scope should be left 
        untouched.

        Args:
            _extent: extent of the _grid
            _grid: array (with/height ratio of the _grid should be the same as width/height ration 
              of the _extent)

        Returns:
            True if success

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.PutGrid_TGIS_Extent_TGIS_GridArray
        """
        pass

    def RasterToMap(
      self,
      _pt: TPoint,
      _cs: TGIS_CSCoordinateSystem
    ) -> TGIS_Point: 
        """
        Converts raster pixel location to map coordinates

        Args:
            _pt: location to be converted
            _cs: coordinate system of returned value; if nil that coordinate system same as layer 
              coordinate system

        Returns:
            calculated location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.RasterToMap_TPoint_TGIS_CSCoordinateSystem
        """
        pass

    def RasterToMapRect(
      self,
      _rct: TRect,
      _cs: TGIS_CSCoordinateSystem
    ) -> TGIS_Extent: 
        """
        Convert raster rectangle to map extent

        Args:
            _rct: rectangle to be converted
            _cs: coordinate system of returned value; if nil that coordinate system same as layer 
              coordinate system

        Returns:
            map extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.RasterToMapRect_TRect_TGIS_CSCoordinateSystem
        """
        pass

    def ReadGridLine(
      self,
      _buffer: VarParameter,
      _line: int,
      _left: int,
      _count: int
    ) -> int: 
        """
        Reads a specific line of the grid into the preallocated buffer.

        Args:
            _buffer: predefined buffer of singles; the value (in/out) is passed as TGIS_SingleArray 
              in _buffer.Value property
            _line: number of grid line to be read
            _left: left margin (columns to skip)
            _count: number of columns to be read

        Returns:
            number of read values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.ReadGridLine_TGIS_SingleArray_Integer_Integer_Integer
        """
        pass

    def Recalculate(
      self
    ) -> None: 
        """
        Recalculates layer MinZ and MaxZ values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Recalculate_void
        """
        pass

    @overload
    def ScaleGrid(
      self,
      _srcGrid: TGIS_GridArray,
      _dstGrid: TGIS_GridArray,
      _lstart: int,
      _tstart: int
    ) -> None: 
        """
        Scales grid array using a linear filter by default.

        Args:
            _srcGrid: source grid array
            _dstGrid: destination grid array
            _lstart: for zoom in - omitted left part
            _tstart: for zoom in - omitted top part

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.ScaleGrid_TGIS_GridArray_TGIS_GridArray_Integer_Integer
        """
        pass

    @overload
    def ScaleGrid(
      self,
      _srcGrid: TGIS_GridArray,
      _dstGrid: TGIS_GridArray,
      _lstart: int,
      _tstart: int,
      _filtering: TGIS_ScalingFilter
    ) -> None: 
        """
        Scales grid array using defined filtering.

        Args:
            _srcGrid: source grid array
            _dstGrid: destination grid array
            _lstart: for zoom in - omitted left part
            _tstart: for zoom in - omitted top part
            _filtering: scaling resampling (filtering) method

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.ScaleGrid_TGIS_GridArray_TGIS_GridArray_Integer_Integer_TGIS_ScalingFilter
        """
        pass

    def SetCurrentFileScale(
      self,
      _dwidth: float,
      _swidth: float
    ) -> None: 
        """
        Sets internal file scales - (1.0, 1.0) is always possible

        Args:
            _dwidth: source width
            _swidth: destination width

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.SetCurrentFileScale_Double_Double
        """
        pass

    def SetWorld(
      self,
      _a: float,
      _d: float,
      _b: float,
      _e: float,
      _c: float,
      _f: float
    ) -> None: 
        """
        Sets world parameters (equivalent to worldfile).

        Args:
            _a: pixel size in the x-direction in map units/pixel
            _d: rotation about y-axis
            _b: rotation about x-axis
            _e: pixel size in the y-direction in map units, almost always negative
            _c: x-coordinate of the center of the upper left pixel
            _f: y-coordinate of the center of the upper left pixel

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.SetWorld_Double_Double_Double_Double_Double_Double
        """
        pass

    def UnlockPixels(
      self,
      _lock: TGIS_LayerPixelLock
    ) -> None: 
        """
        UnLocks a fragment. Populate changes to the layer.

        Args:
            _lock: lock obtained upon LockPixels() call

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.UnlockPixels_TGIS_LayerPixelLock
        """
        pass

    @property
    def AltitudeMapZonesCount(
      self
    ) -> int: 
        """
        Number of altitude map zones.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.AltitudeMapZonesCount
        """
        pass

    @property
    def Antialias(
      self
    ) -> bool: 
        """
        Antialias scaling (for some layers only like PNG and JPG).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Antialias
        """
        pass

    @property
    def AntialiasFilter(
      self
    ) -> TGIS_ScalingFilter: 
        """
        Scaling filter (like Linear, Lanczos) to be used for scaling images and grids.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.AntialiasFilter
        """
        pass

    @property
    def BandsCount(
      self
    ) -> int: 
        """
        Number of bands in a file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.BandsCount
        """
        pass

    @property
    def BitHeight(
      self
    ) -> int: 
        """
        Height of the layer in pixels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.BitHeight
        """
        pass

    @property
    def BitWidth(
      self
    ) -> int: 
        """
        Width of the layer in pixels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.BitWidth
        """
        pass

    @property
    def Capabilities(
      self
    ) -> TGIS_LayerPixelSubFormatList: 
        """
        Pixel sub-format list that is available for write operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Capabilities
        """
        pass

    @property
    def CellHeight(
      self
    ) -> int: 
        """
        Height of a cell in pixels. It is the same as BitHeight for BMP, TIFF etc. It is 
        different than BitHeight for PixelStore and any other tiled formats.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.CellHeight
        """
        pass

    @property
    def CellWidth(
      self
    ) -> int: 
        """
        Width of a cell in pixels. It is the same as BitWidth for BMP, TIFF etc. It is different 
        than BitWidth for PixelStore and any other tiled formats.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.CellWidth
        """
        pass

    @property
    def CurrentPage(
      self
    ) -> int: 
        """
        Current page of multipage file. Example is a multipage TIFF.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.CurrentPage
        """
        pass

    @property
    def CuttingPolygon(
      self
    ) -> TGIS_ShapePolygon: 
        """
        Cutting polygon that defines an input image''s valid area.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.CuttingPolygon
        """
        pass

    @CuttingPolygon.setter
    def CuttingPolygon(
      self,
      _value: TGIS_ShapePolygon
    ) -> None: 
        """
        Cutting polygon that defines an input image''s valid area.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.CuttingPolygon
        """
        pass

    @property
    def DefaultSubFormat(
      self
    ) -> TGIS_LayerPixelSubFormat: 
        """
        Default subformat information.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.DefaultSubFormat
        """
        pass

    @property
    def ExtentPixelAdjustment(
      self
    ) -> bool: 
        """
        Modify draw extent calcualtion t be perforemd on mid pixel rather then on border.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.ExtentPixelAdjustment
        """
        pass

    @ExtentPixelAdjustment.setter
    def ExtentPixelAdjustment(
      self,
      _value: bool
    ) -> None: 
        """
        Modify draw extent calcualtion t be perforemd on mid pixel rather then on border.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.ExtentPixelAdjustment
        """
        pass

    @property
    def ForcedBandsDefinition(
      self
    ) -> str: 
        """
        Forced interpretation of bands in a layer. Supported only selected layers (mainly 
        TIFF).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.ForcedBandsDefinition
        """
        pass

    @ForcedBandsDefinition.setter
    def ForcedBandsDefinition(
      self,
      _value: str
    ) -> None: 
        """
        Forced interpretation of bands in a layer. Supported only selected layers (mainly 
        TIFF).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.ForcedBandsDefinition
        """
        pass

    @property
    def GridBand(
      self
    ) -> int: 
        """
        Grid band number. Allows selection which band will be used as for grid values channel. 
        Bands are numbered starting from 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.GridBand
        """
        pass

    @property
    def Interpretation(
      self
    ) -> TGIS_LayerPixelInterpretation: 
        """
        The way the layer is interpreted: the default is as a grid, or as an image.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Interpretation
        """
        pass

    @Interpretation.setter
    def Interpretation(
      self,
      _value: TGIS_LayerPixelInterpretation
    ) -> None: 
        """
        The way the layer is interpreted: the default is as a grid, or as an image.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Interpretation
        """
        pass

    @property
    def IsGridImage(
      self
    ) -> bool: 
        """
        True if image is a grid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.IsGridImage
        """
        pass

    @IsGridImage.setter
    def IsGridImage(
      self,
      _value: bool
    ) -> None: 
        """
        True if image is a grid.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.IsGridImage
        """
        pass

    @property
    def IsNativeGridImage(
      self
    ) -> bool: 
        """
        True if image is a native grid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.IsNativeGridImage
        """
        pass

    @property
    def IsTiled(
      self
    ) -> bool: 
        """
        True if layer is tiled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.IsTiled
        """
        pass

    @property
    def MaxHeight(
      self
    ) -> float: 
        """
        Maximum elevation value of the grid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.MaxHeight
        """
        pass

    @MaxHeight.setter
    def MaxHeight(
      self,
      _value: float
    ) -> None: 
        """
        Maximum elevation value of the grid.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.MaxHeight
        """
        pass

    @property
    def MaxHeightThreshold(
      self
    ) -> float: 
        """
        Maximum threshold of the grid elevation values to display.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.MaxHeightThreshold
        """
        pass

    @property
    def MinHeight(
      self
    ) -> float: 
        """
        Minimum elevation value of the grid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.MinHeight
        """
        pass

    @MinHeight.setter
    def MinHeight(
      self,
      _value: float
    ) -> None: 
        """
        Minimum elevation value of the grid.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.MinHeight
        """
        pass

    @property
    def MinHeightThreshold(
      self
    ) -> float: 
        """
        Minimum threshold of the grid elevation values to display.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.MinHeightThreshold
        """
        pass

    @property
    def NoDataColor(
      self
    ) -> TGIS_Color: 
        """
        Color property to define default color to be used to fill "empty" area upon PixelExportManager.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.NoDataColor
        """
        pass

    @NoDataColor.setter
    def NoDataColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Color property to define default color to be used to fill "empty" area upon PixelExportManager.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.NoDataColor
        """
        pass

    @property
    def NoDataValue(
      self
    ) -> float: 
        """
        Grid NoData value. Allows to specify the value which will be used to discover no-assigned-data 
        areas on a grid. By providing 32768 default (embed into the file) value be used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.NoDataValue
        """
        pass

    @property
    def PageCount(
      self
    ) -> int: 
        """
        Number of pages in an image file. Example is a multipage TIFF.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.PageCount
        """
        pass

    @property
    def Params(
      self
    ) -> TGIS_ParamsSectionPixel: 
        """
        Returns parameters for pixel layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Params
        """
        pass

    @Params.setter
    def Params(
      self,
      _value: TGIS_ParamsSectionPixel
    ) -> None: 
        """
        Returns parameters for pixel layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Params
        """
        pass

    @property
    def PathTAB(
      self
    ) -> str: 
        """
        Path to a TAB referencing file. If not exist then should be empty.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.PathTAB
        """
        pass

    @PathTAB.setter
    def PathTAB(
      self,
      _value: str
    ) -> None: 
        """
        Path to a TAB referencing file. If not exist then should be empty.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.PathTAB
        """
        pass

    @property
    def Progressive(
      self
    ) -> bool: 
        """
        If true (default), then layer can be drawn as progressive.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Progressive
        """
        pass

    @Progressive.setter
    def Progressive(
      self,
      _value: bool
    ) -> None: 
        """
        If true (default), then layer can be drawn as progressive.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.Progressive
        """
        pass

    @property
    def SubFormat(
      self
    ) -> TGIS_LayerPixelSubFormat: 
        """
        Current sub-format information.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.SubFormat
        """
        pass

    @property
    def GridOperationEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Extent, TGIS_GridArray, TGIS_GridArray, Integer, Integer, Single, Single], bool]: 
        """
        Grid operation event. Attach to manipulate grid data before display.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.GridOperationEvent
        """
        pass

    @GridOperationEvent.setter
    def GridOperationEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Extent, TGIS_GridArray, TGIS_GridArray, Integer, Integer, Single, Single], bool]
    ) -> None: 
        """
        Grid operation event. Attach to manipulate grid data before display.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.GridOperationEvent
        """
        pass

    @property
    def PixelOperationEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Extent, TGIS_Pixels, TGIS_Pixels, Integer, Integer], bool]: 
        """
        Pixel operation event. Attach to manipulate pixel (ARGB) data before display.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.PixelOperationEvent
        """
        pass

    @PixelOperationEvent.setter
    def PixelOperationEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Extent, TGIS_Pixels, TGIS_Pixels, Integer, Integer], bool]
    ) -> None: 
        """
        Pixel operation event. Attach to manipulate pixel (ARGB) data before display.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixel.PixelOperationEvent
        """
        pass

class TGIS_LayerPixelEnumerator( TObject ):
    """
    Layer enumerator.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelEnumerator
    """

    def __iter__(
      self
    ) -> TGIS_LayerPixelEnumerator:
        pass

    def __next__(
      self
    ) -> TGIS_PixelItem:
        pass

    @overload
    def __init__(
      self,
      _lp: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _pixelsize: float,
      _fatpixel: bool,
      _shape: TGIS_Shape,
      _de9im: str,
      _writable: bool
    ) -> None: 
        """
        Create an enumerator instance.

        Args:
            _lp: pixel layer handle
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space
            _pixelsize: minimum requested size of image pixel; by providing 0 a maximum possible 
              resolution will be used, which is also a fastest method if a layer is full in-memory 
              because in such situation a pointer to existing memory will be used
            _fatpixel: if false then pixel will be treated as point; if true then pixels will 
              be treated as small polygon, which is much slower but provides some more advanced 
              DE-9IM testing possibilities
            _shape: if not nil, then only shapes matched dm9 matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_PixelItem.Writable will be set accordingly

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelEnumerator.Create_TGIS_LayerPixel_TGIS_Extent_Double_Boolean_TGIS_Shape_String_Boolean
        """
        pass

    @overload
    def __init__(
      self,
      _factory: TGIS_LayerPixelEnumeratorFactory,
      _lp: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _pixelsize: float,
      _fatpixel: bool,
      _shape: TGIS_Shape,
      _de9im: str,
      _writable: bool
    ) -> None: 
        """
        Create an enumerator instance.

        Args:
            _factory: reference to factory object which creates this enumerator
            _lp: pixel layer handle
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space
            _pixelsize: minimum requested size of image pixel; by providing 0 a maximum possible 
              resolution will be used, which is also a fastest method if a layer is full in-memory 
              because in such situation a pointer to existing memory will be used
            _fatpixel: if false then pixel will be treated as point; if true then pixels will 
              be treated as small polygon, which is much slower but provides some more advanced 
              DE-9IM testing possibilities
            _shape: if not nil, then only shapes matched dm9 matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_PixelItem.Writable will be set accordingly

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelEnumerator.Create_TGIS_LayerPixelEnumeratorFactory_TGIS_LayerPixel_TGIS_Extent_Double_Boolean_TGIS_Shape_String_Boolean
        """
        pass

    @overload
    def __init__(
      self,
      _factory: TGIS_LayerPixelEnumeratorFactory,
      _lp: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _pixelsize: float,
      _fatpixel: bool,
      _shape: TGIS_Shape,
      _de9im: str,
      _band: int,
      _writable: bool
    ) -> None: 
        """
        Create an enumerator instance.

        Args:
            _factory: reference to factory object which creates this enumerator
            _lp: pixel layer handle
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space
            _pixelsize: minimum requested size of image pixel; by providing 0 a maximum possible 
              resolution will be used, which is also a fastest method if a layer is full in-memory 
              because in such situation a pointer to existing memory will be used
            _fatpixel: if false then pixel will be treated as point; if true then pixels will 
              be treated as small polygon, which is much slower but provides some more advanced 
              DE-9IM testing possibilities
            _shape: if not nil, then only shapes matched dm9 matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _band: band specificatio
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_PixelItem.Writable will be set accordingly

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelEnumerator.Create_TGIS_LayerPixelEnumeratorFactory_TGIS_LayerPixel_TGIS_Extent_Double_Boolean_TGIS_Shape_String_Integer_Boolean
        """
        pass

    def GetCurrent(
      self
    ) -> TGIS_PixelItem: 
        """
        Get current enumerator value.

        Returns:
            Shape itself or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelEnumerator.GetCurrent_void
        """
        pass

    def MoveNext(
      self
    ) -> bool: 
        """
        Move to next record

        Returns:
            If false then there is no more shapes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelEnumerator.MoveNext_void
        """
        pass

    def Reset(
      self
    ) -> None: 
        """
        Reset enumerator.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelEnumerator.Reset_void
        """
        pass

    @property
    def Current(
      self
    ) -> TGIS_PixelItem: 
        """
        Current enumerator value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelEnumerator.Current
        """
        pass

class TGIS_LayerPixelEnumeratorFactory:
    """
    Factory class for TGIS_LayerPixelEnumerator.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelEnumeratorFactory
    """

    def __iter__(
      self
    ) -> TGIS_LayerPixelEnumerator:
        pass

    def __next__(
      self
    ) -> TGIS_PixelItem:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelEnumeratorFactory.Create_void
        """
        pass

    def GetEnumerator(
      self
    ) -> TGIS_LayerPixelEnumerator: 
        """
        Get constructed enumerator.

        Returns:
            Enumerator object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelEnumeratorFactory.GetEnumerator_void
        """
        pass

    @overload
    def SetUp(
      self,
      _lp: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _pixelsize: float,
      _fatpixel: bool,
      _shape: TGIS_Shape,
      _de9im: str,
      _writable: bool
    ) -> None: 
        """
        Prepare enumerator.

        Args:
            _lp: pixel layer handle
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space
            _pixelsize: minimum requested size of image pixel; by providing 0 a maximum possible 
              resolution will be used, which is also a fastest method if a layer is full in-memory 
              because in such situation a pointer to existing memory will be used
            _fatpixel: if false then pixel will be treated as point; if true then pixels will 
              be treated as small polygon, which is much slower but provides some more advanced 
              DE-9IM testing possibilities
            _shape: if not nil, then only shapes matched dm9 matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_PixelItem.Writable will be set accordingly

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelEnumeratorFactory.SetUp_TGIS_LayerPixel_TGIS_Extent_Double_Boolean_TGIS_Shape_String_Boolean
        """
        pass

    @overload
    def SetUp(
      self,
      _lp: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _pixelsize: float,
      _fatpixel: bool,
      _shape: TGIS_Shape,
      _de9im: str,
      _band: int,
      _writable: bool
    ) -> None: 
        """
        Prepare enumerator.

        Args:
            _lp: pixel layer handle
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space
            _pixelsize: minimum requested size of image pixel; by providing 0 a maximum possible 
              resolution will be used, which is also a fastest method if a layer is full in-memory 
              because in such situation a pointer to existing memory will be used
            _fatpixel: if false then pixel will be treated as point; if true then pixels will 
              be treated as small polygon, which is much slower but provides some more advanced 
              DE-9IM testing possibilities
            _shape: if not nil, then only shapes matched dm9 matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _band: band specificatio
            _writable: if true than layer will post back any changes in locked area; if write 
              is not possible then TGIS_PixelItem.Writable will be set accordingly

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelEnumeratorFactory.SetUp_TGIS_LayerPixel_TGIS_Extent_Double_Boolean_TGIS_Shape_String_Integer_Boolean
        """
        pass

class TGIS_Zone:
    """
    Zone from 0 to 255 definition.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Zone
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Zone.Create_void
        """
        pass

    @property
    def Start(
      self
    ) -> int: 
        """
        Starting value of zone.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Zone.Start
        """
        pass

    @Start.setter
    def Start(
      self,
      _value: int
    ) -> None: 
        """
        Starting value of zone.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Zone.Start
        """
        pass

    @property
    def Stop(
      self
    ) -> int: 
        """
        Ending value of zone.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Zone.Stop
        """
        pass

    @Stop.setter
    def Stop(
      self,
      _value: int
    ) -> None: 
        """
        Ending value of zone.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Zone.Stop
        """
        pass

class TGIS_MapZone:
    """
    Zone mapping. Y - new values for X zone.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MapZone
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MapZone.Create_void
        """
        pass

    @property
    def X(
      self
    ) -> TGIS_Zone: 
        """
        Old zone.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MapZone.X
        """
        pass

    @X.setter
    def X(
      self,
      _value: TGIS_Zone
    ) -> None: 
        """
        Old zone.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MapZone.X
        """
        pass

    @property
    def Y(
      self
    ) -> TGIS_Zone: 
        """
        New zone.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MapZone.Y
        """
        pass

    @Y.setter
    def Y(
      self,
      _value: TGIS_Zone
    ) -> None: 
        """
        New zone.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MapZone.Y
        """
        pass

class TGIS_AltitudeZone:
    """
    Array of mapping between altitude and color.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AltitudeZone
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AltitudeZone.Create_void
        """
        pass

    @property
    def MinVal(
      self
    ) -> float: 
        """
        Lower value of the zone.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AltitudeZone.MinVal
        """
        pass

    @MinVal.setter
    def MinVal(
      self,
      _value: float
    ) -> None: 
        """
        Lower value of the zone.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AltitudeZone.MinVal
        """
        pass

    @property
    def MaxVal(
      self
    ) -> float: 
        """
        Upper value of the zone.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AltitudeZone.MaxVal
        """
        pass

    @MaxVal.setter
    def MaxVal(
      self,
      _value: float
    ) -> None: 
        """
        Upper value of the zone.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AltitudeZone.MaxVal
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Color of the zone.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AltitudeZone.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Color of the zone.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AltitudeZone.Color
        """
        pass

    @property
    def Legend(
      self
    ) -> str: 
        """
        Legend of the zone.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AltitudeZone.Legend
        """
        pass

    @Legend.setter
    def Legend(
      self,
      _value: str
    ) -> None: 
        """
        Legend of the zone.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_AltitudeZone.Legend
        """
        pass

class TGIS_Tile:
    """
    Structure of tile information.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tile
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tile.Create_void
        """
        pass

    @property
    def Level(
      self
    ) -> int: 
        """
        Tile level.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tile.Level
        """
        pass

    @Level.setter
    def Level(
      self,
      _value: int
    ) -> None: 
        """
        Tile level.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tile.Level
        """
        pass

    @property
    def Column(
      self
    ) -> int: 
        """
        Tile column.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tile.Column
        """
        pass

    @Column.setter
    def Column(
      self,
      _value: int
    ) -> None: 
        """
        Tile column.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tile.Column
        """
        pass

    @property
    def Row(
      self
    ) -> int: 
        """
        Tile row.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tile.Row
        """
        pass

    @Row.setter
    def Row(
      self,
      _value: int
    ) -> None: 
        """
        Tile row.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Tile.Row
        """
        pass

class TGIS_LayerPixelTile:
    """
    Structure of pixel tile.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelTile
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelTile.Create_void
        """
        pass

    @property
    def Rect(
      self
    ) -> TRect: 
        """
        Location in all image.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelTile.Rect
        """
        pass

    @Rect.setter
    def Rect(
      self,
      _value: TRect
    ) -> None: 
        """
        Location in all image.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelTile.Rect
        """
        pass

    @property
    def Order(
      self
    ) -> int: 
        """
        Data orientation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelTile.Order
        """
        pass

    @Order.setter
    def Order(
      self,
      _value: int
    ) -> None: 
        """
        Data orientation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelTile.Order
        """
        pass

class TGIS_LayerPixelSqlAbstract( TGIS_LayerPixel ):
    """
    SQL-based pixel layer class encapsulation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract.Create_void
        """
        pass

    def ExecuteSQL(
      self,
      _sql: str
    ) -> bool: 
        """
        Execute custom SQL statement.

        Args:
            _sql: SQL String

        Returns:
            True if succeeded

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract.ExecuteSQL_String
        """
        pass

    def ResetDataset(
      self
    ) -> None: 
        """
        Reset the layer dataset to ensure the current database context upon next drawing 
        (e.g to notify changes when a record was deleted manually in the table).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract.ResetDataset_void
        """
        pass

    @property
    def SQLCommands(
      self
    ) -> TGIS_StringList: 
        """
        SQL Commands used for database operations.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract.SQLCommands
        """
        pass

    @property
    def SQLDialectList(
      self
    ) -> TGIS_StringList: 
        """
        Dialect list in a form "token=replacement". Will be changed after each change of 
        SQLDialect property.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract.SQLDialectList
        """
        pass

    
    def SQLParameter(
      self,
      _name: str
    ) -> str: 
        """
        Connection parameters.

        Args:
            _name: parameter name

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract.SQLParameter
        """
        pass

    
    def SQLParameter(
      self,
      _name: str,
      _value: str
    ) -> None: 
        """
        Connection parameters.

        Args:
            _name: parameter name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract.SQLParameter
        """
        pass

    @property
    def SQLParametersEx(
      self
    ) -> TGIS_StringList: 
        """
        List of additional connection parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract.SQLParametersEx
        """
        pass

    @property
    def Table(
      self
    ) -> str: 
        """
        SQL table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract.Table
        """
        pass

    @Table.setter
    def Table(
      self,
      _value: str
    ) -> None: 
        """
        SQL table.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract.Table
        """
        pass

    @property
    def AfterDialectChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Will be fired after SQLDialect change. By changing SQLCommandList inside handler 
        for this event you will be able to modify commands dynamically.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract.AfterDialectChangeEvent
        """
        pass

    @AfterDialectChangeEvent.setter
    def AfterDialectChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Will be fired after SQLDialect change. By changing SQLCommandList inside handler 
        for this event you will be able to modify commands dynamically.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract.AfterDialectChangeEvent
        """
        pass

    @property
    def BeforeDialectChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Will be fired before every SQLDialect change. By changing SQLDialectList inside handler 
        for this event you will be able to modify dialect dynamically.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract.BeforeDialectChangeEvent
        """
        pass

    @BeforeDialectChangeEvent.setter
    def BeforeDialectChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Will be fired before every SQLDialect change. By changing SQLDialectList inside handler 
        for this event you will be able to modify dialect dynamically.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract.BeforeDialectChangeEvent
        """
        pass

    @property
    def SQLExecuteEvent(
      self
    ) -> typing.Callable[[String], None]: 
        """
        Will be fired upon any sql execution to trace sql statements.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract.SQLExecuteEvent
        """
        pass

    @SQLExecuteEvent.setter
    def SQLExecuteEvent(
      self,
      _value: typing.Callable[[String], None]
    ) -> None: 
        """
        Will be fired upon any sql execution to trace sql statements.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSqlAbstract.SQLExecuteEvent
        """
        pass

class TGIS_LayerPixelStoreAbstract( TGIS_LayerPixelSqlAbstract ):
    """
    Encapsulation of PixelStore layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelStoreAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelStoreAbstract.Create_void
        """
        pass

class TGIS_LayerPixelStoreFireDac( TGIS_LayerPixelStoreAbstract ):
    """
    Encapsulation of PixelStore layer via FireDAC.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelStoreFireDac
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelStoreFireDac.Create_void
        """
        pass

class TGIS_LayerPixelStoreLibpq( TGIS_LayerPixelStoreAbstract ):
    """
    Encapsulation of PixelStore layer via PostgreSQL client library libpq.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelStoreLibpq
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelStoreLibpq.Create_void
        """
        pass

class TGIS_LayerPixelStoreOci( TGIS_LayerPixelStoreAbstract ):
    """
    Encapsulation of PixelStore layer via Oci.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelStoreOci
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelStoreOci.Create_void
        """
        pass

class TGIS_LayerPixelStoreSqlite( TGIS_LayerPixelStoreAbstract ):
    """
    Encapsulation of PixelStore layer via Sqlite.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelStoreSqlite
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelStoreSqlite.Create_void
        """
        pass

class TGIS_LayerPixelUDF( TGIS_LayerPixel ):
    """
    Encapsulation of pixel UDF layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelUDF
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelUDF.Create_void
        """
        pass

    @property
    def GetLineEvent(
      self
    ) -> typing.Callable[[TBytes, Integer, Integer, Integer, Integer], int]: 
        """
        GetLine event. Fired upon prepared layer data reading.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelUDF.GetLineEvent
        """
        pass

    @GetLineEvent.setter
    def GetLineEvent(
      self,
      _value: typing.Callable[[TBytes, Integer, Integer, Integer, Integer], int]
    ) -> None: 
        """
        GetLine event. Fired upon prepared layer data reading.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelUDF.GetLineEvent
        """
        pass

    @property
    def GetNativeLineEvent(
      self
    ) -> typing.Callable[[TGIS_SingleArray, Integer, Integer, Integer], int]: 
        """
        GetNativeLine event. Fired upon real or grid layer data reading.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelUDF.GetNativeLineEvent
        """
        pass

    @GetNativeLineEvent.setter
    def GetNativeLineEvent(
      self,
      _value: typing.Callable[[TGIS_SingleArray, Integer, Integer, Integer], int]
    ) -> None: 
        """
        GetNativeLine event. Fired upon real or grid layer data reading.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelUDF.GetNativeLineEvent
        """
        pass

    @property
    def GetNativeValueEvent(
      self
    ) -> typing.Callable[[TPoint, TGIS_DoubleArray], bool]: 
        """
        GetNativeValue event. OnGetNativeValue event. Fired upon reading original grid value 
        of point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelUDF.GetNativeValueEvent
        """
        pass

    @GetNativeValueEvent.setter
    def GetNativeValueEvent(
      self,
      _value: typing.Callable[[TPoint, TGIS_DoubleArray], bool]
    ) -> None: 
        """
        GetNativeValue event. OnGetNativeValue event. Fired upon reading original grid value 
        of point.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelUDF.GetNativeValueEvent
        """
        pass

    @property
    def SetUpEvent(
      self
    ) -> typing.Callable[[Integer, Integer, Boolean, Single, Single, Single, TGIS_Extent], None]: 
        """
        SetUp event. Fired upon a layer initialization.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelUDF.SetUpEvent
        """
        pass

    @SetUpEvent.setter
    def SetUpEvent(
      self,
      _value: typing.Callable[[Integer, Integer, Boolean, Single, Single, Single, TGIS_Extent], None]
    ) -> None: 
        """
        SetUp event. Fired upon a layer initialization.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelUDF.SetUpEvent
        """
        pass

class TGIS_LayerPLY( TGIS_LayerVector ):
    """
    Layer which can read a PLY file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPLY
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPLY.Create_void
        """
        pass

class TGIS_LayerPNG( TGIS_LayerPixel ):
    """
    Encapsulation of a PNG layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPNG
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPNG.Create_void
        """
        pass

class TGIS_LayerProject( TGIS_Layer ):
    """
    General project layer class. Used to represent a project file as a single layer on 
    the legend.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerProject
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerProject.Create_void
        """
        pass

    def Add(
      self,
      _layer: TGIS_Layer
    ) -> None: 
        """
        Add sub layer to list.
        
        Add a layer to the Viewer.

        Args:
            _layer: layer to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerProject.Add_TGIS_Layer
        """
        pass

    def Delete(
      self,
      _name: str
    ) -> None: 
        """
        Delete sub layer from list.
        
        Delete the layer identified by a name.

        Args:
            _name: name of layer to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerProject.Delete_String
        """
        pass

    @overload
    def Get(
      self,
      _name: str
    ) -> TGIS_Layer: 
        """
        Get sub layer from list by name.
        
        Retrieve the layer identified by a name.

        Args:
            _name: name of layer found

        Returns:
            found layer or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerProject.Get_String
        """
        pass

    @overload
    def Get(
      self,
      _layer: TGIS_Layer
    ) -> TGIS_Layer: 
        """
        Get sub layer from list by handle.
        
        Retrieve the layer identified by a name.

        Args:
            _layer: name of layer found

        Returns:
            found layer or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerProject.Get_TGIS_Layer
        """
        pass

    @overload
    def LocateEx(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _uid: int,
      _dist: VarParameter,
      _part: VarParameter,
      _proj: VarParameter
    ) -> TGIS_Shape: 
        """
        Locate a shape (more precise).

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; point inside a polygon is always not 
              greater than _dist; if _prec is less then 0, then being outside/inside polygon means 
              the same
            _uid: Uid of reference shape or -1; thanks to this, is possible to find nearest shape, 
              excluding shape given by _uid.
            _dist: reached distance between _pt and shape in Result; for points inside the polygon 
              (if _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside 
              the polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; the value (in/out) is passed as 
              float in _dist.Value property
            _part: number of the part closest to a given point; the value (in/out) is passed 
              as int in _part.Value property
            _proj: point projected to the nearest element of a shape; the value (in/out) is passed 
              as TGIS_Point in _proj.Value property

        Returns:
            found shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerProject.LocateEx_TGIS_Point_Double_Integer_Double_Integer_TGIS_Point
        """
        pass

    @overload
    def LocateEx(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _uid: int,
      _dist: VarParameter,
      _part: VarParameter,
      _proj: VarParameter,
      _visible: bool
    ) -> TGIS_Shape: 
        """
        Locate a shape (more precise).

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; point inside a polygon is always not 
              greater than _dist; if _prec is less then 0, then being outside/inside polygon means 
              the same
            _uid: Uid of reference shape or -1; thanks to this, is possible to find nearest shape, 
              excluding shape given by _uid.
            _dist: reached distance between _pt and shape in Result; for points inside the polygon 
              (if _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside 
              the polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; the value (in/out) is passed as 
              float in _dist.Value property
            _part: number of the part closest to a given point; the value (in/out) is passed 
              as int in _part.Value property
            _proj: point projected to the nearest element of a shape; the value (in/out) is passed 
              as TGIS_Point in _proj.Value property
            _visible: if true the only visible shapes will be evaluated; shapes turned of by 
              query of hidden will be ignored

        Returns:
            found shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerProject.LocateEx_TGIS_Point_Double_Integer_Double_Integer_TGIS_Point_Boolean
        """
        pass

    @overload
    def LocateEx(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _uid: int,
      _dist: VarParameter,
      _part: VarParameter,
      _proj: VarParameter,
      _dist_prefer: VarParameter,
      _visible: bool
    ) -> TGIS_Shape: 
        """
        Locate a shape (more precise).

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; point inside a polygon is always not 
              greater than _dist; if _prec is less then 0, then being outside/inside polygon means 
              the same
            _uid: Uid of reference shape or -1; thanks to this, is possible to find nearest shape, 
              excluding shape given by _uid.
            _dist: reached distance between _pt and shape in Result; for points inside the polygon 
              (if _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside 
              the polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; the value (in/out) is passed as 
              float in _dist.Value property
            _part: number of the part closest to a given point; the value (in/out) is passed 
              as int in _part.Value property
            _proj: point projected to the nearest element of a shape; the value (in/out) is passed 
              as TGIS_Point in _proj.Value property
            _dist_prefer: preferred distance (including shape type priority : points over lines 
              and polygons); the value (in/out) is passed as float in _dist_prefer.Value property
            _visible: if true the only visible shapes will be evaluated; shapes turned of by 
              query of hidden will be ignored

        Returns:
            found shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerProject.LocateEx_TGIS_Point_Double_Integer_Double_Integer_TGIS_Point_Double_Boolean
        """
        pass

    @property
    def Hierarchy(
      self
    ) -> TGIS_Strings: 
        """
        Layer project hierarchy.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerProject.Hierarchy
        """
        pass

    @property
    def Items(
      self
    ) -> TGIS_LayerAbstractList: 
        """
        All sub layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerProject.Items
        """
        pass

class TGIS_LayerS57( TGIS_LayerCompoundVector ):
    """
    Encapsulation of S57 layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerS57
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerS57.Create_void
        """
        pass

    @property
    def LayerName(
      self
    ) -> str: 
        """
        S57 format layer name to load. Only shapes that belong to this layer will be created.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerS57.LayerName
        """
        pass

    @LayerName.setter
    def LayerName(
      self,
      _value: str
    ) -> None: 
        """
        S57 format layer name to load. Only shapes that belong to this layer will be created.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerS57.LayerName
        """
        pass

    @property
    def UseS57Draw(
      self
    ) -> bool: 
        """
        Use S52 style rendering.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerS57.UseS57Draw
        """
        pass

    @UseS57Draw.setter
    def UseS57Draw(
      self,
      _value: bool
    ) -> None: 
        """
        Use S52 style rendering.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerS57.UseS57Draw
        """
        pass

class TGIS_LayerSDTS_TVP( TGIS_LayerVector ):
    """
    Encapsulation of SDTS TVP layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSDTS_TVP
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSDTS_TVP.Create_void
        """
        pass

class TGIS_LayerSDTS_RPE( TGIS_LayerPixel ):
    """
    Encapsulation of SDTS RPE layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSDTS_RPE
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSDTS_RPE.Create_void
        """
        pass

class TGIS_LayerSGRD( TGIS_LayerPixel ):
    """
    Encapsulation of SAGA GIS Binary Grid layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSGRD
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSGRD.Create_void
        """
        pass

class TGIS_LayerSHP( TGIS_LayerVector ):
    """
    Layer that can read SHP file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSHP
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSHP.Create_void
        """
        pass

    @property
    def PathCPG(
      self
    ) -> str: 
        """
        Path to a CPG file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSHP.PathCPG
        """
        pass

    @property
    def PathDBF(
      self
    ) -> str: 
        """
        Path to a DBF file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSHP.PathDBF
        """
        pass

    @property
    def PathPRJ(
      self
    ) -> str: 
        """
        Path to a PRJ file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSHP.PathPRJ
        """
        pass

    @property
    def PathSHP(
      self
    ) -> str: 
        """
        Path to a SHP file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSHP.PathSHP
        """
        pass

    @property
    def PathSHX(
      self
    ) -> str: 
        """
        Path to a SHX file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSHP.PathSHX
        """
        pass

class TGIS_LayerSqlAbstract( TGIS_LayerVectorSqlAbstract ):
    """
    Encapsulation of abstract SQL layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAbstract.Create_void
        """
        pass

    def DisableLogging(
      self
    ) -> None: 
        """
        Disable tracing in existing layer logging mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAbstract.DisableLogging_void
        """
        pass

    def EnableLogging(
      self
    ) -> None: 
        """
        Enable tracing in existing layer logging mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAbstract.EnableLogging_void
        """
        pass

    def GetLogs(
      self
    ) -> TGIS_StringList: 
        """
        Get trace logs of a layer if available.

        Returns:
            trace logs

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAbstract.GetLogs_void
        """
        pass

    def ReStructure(
      self
    ) -> None: 
        """
        Reread fields list from the database.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAbstract.ReStructure_void
        """
        pass

    @property
    def TableFeatures(
      self
    ) -> str: 
        """
        Name of the features table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAbstract.TableFeatures
        """
        pass

    @property
    def TableGeometry(
      self
    ) -> str: 
        """
        Name of the geometry table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAbstract.TableGeometry
        """
        pass

    @property
    def TableIndex(
      self
    ) -> str: 
        """
        Name of the RTree index table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAbstract.TableIndex
        """
        pass

    @property
    def TableLog(
      self
    ) -> str: 
        """
        Name of the log table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAbstract.TableLog
        """
        pass

    @property
    def TableMaster(
      self
    ) -> str: 
        """
        Name of the master table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAbstract.TableMaster
        """
        pass

class TGIS_LayerSqlAnywhereAbstract( TGIS_LayerVectorSqlAbstract ):
    """
    Encapsulation of abstract Sybase SQL Anywhere Spatial SQL layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAnywhereAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAnywhereAbstract.Create_void
        """
        pass

    @property
    def TableConfig(
      self
    ) -> str: 
        """
        Name of the Layer (table) configuration : name, schema, catalog.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAnywhereAbstract.TableConfig
        """
        pass

    @property
    def TableFeatures(
      self
    ) -> str: 
        """
        Name of the features table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAnywhereAbstract.TableFeatures
        """
        pass

    @property
    def TableGeometry(
      self
    ) -> str: 
        """
        Name of the geometry table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAnywhereAbstract.TableGeometry
        """
        pass

    @property
    def TableMaster(
      self
    ) -> str: 
        """
        Name of the master table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlAnywhereAbstract.TableMaster
        """
        pass

class TGIS_LayerSqlDb2Abstract( TGIS_LayerVectorSqlAbstract ):
    """
    Encapsulation of abstract IBM DB2 Spatial Extender SQL layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlDb2Abstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlDb2Abstract.Create_void
        """
        pass

    @property
    def TableConfig(
      self
    ) -> str: 
        """
        Name of the Layer (table) configuration : name, schema, catalog.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlDb2Abstract.TableConfig
        """
        pass

    @property
    def TableFeatures(
      self
    ) -> str: 
        """
        Name of the features table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlDb2Abstract.TableFeatures
        """
        pass

    @property
    def TableGeometry(
      self
    ) -> str: 
        """
        Name of the geometry table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlDb2Abstract.TableGeometry
        """
        pass

    @property
    def TableMaster(
      self
    ) -> str: 
        """
        Name of the master table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlDb2Abstract.TableMaster
        """
        pass

class TGIS_LayerSqlDb2FireDac( TGIS_LayerSqlDb2Abstract ):
    """
    Layer that can read IBM DB2 Spatial Extender layer via FireDac.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlDb2FireDac
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlDb2FireDac.Create_void
        """
        pass

class TGIS_LayerSqlFireDac( TGIS_LayerSqlAbstract ):
    """
    Layer that can read SQL data via FireDac.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlFireDac
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlFireDac.Create_void
        """
        pass

class TGIS_LayerSqlGmAbstract( TGIS_LayerVectorSqlAbstract ):
    """
    Encapsulation of abstract GeoMedia SQL layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGmAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGmAbstract.Create_void
        """
        pass

    def ReStructure(
      self
    ) -> None: 
        """
        Reread fields list from the database.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGmAbstract.ReStructure_void
        """
        pass

class TGIS_LayerSqlGmFireDac( TGIS_LayerSqlGmAbstract ):
    """
    Encapsulation of GeoMedia SQL layer via FireDac (dbExpress).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGmFireDac
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGmFireDac.Create_void
        """
        pass

class TGIS_LayerSqlGmMsSpatialAbstract( TGIS_LayerVectorSqlAbstract ):
    """
    Encapsulation of abstract Geomedia SQL Server Native Spatial layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGmMsSpatialAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGmMsSpatialAbstract.Create_void
        """
        pass

    def ReStructure(
      self
    ) -> None: 
        """
        Reread fields list from the database.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGmMsSpatialAbstract.ReStructure_void
        """
        pass

class TGIS_LayerSqlGmSdoAbstract( TGIS_LayerVectorSqlAbstract ):
    """
    Encapsulation of Geomedia Oracle Object Model access layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGmSdoAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGmSdoAbstract.Create_void
        """
        pass

    @property
    def SchemaName(
      self
    ) -> str: 
        """
        Schema name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGmSdoAbstract.SchemaName
        """
        pass

    @property
    def TableName(
      self
    ) -> str: 
        """
        Table name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGmSdoAbstract.TableName
        """
        pass

    @property
    def UserName(
      self
    ) -> str: 
        """
        User name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGmSdoAbstract.UserName
        """
        pass

class TGIS_LayerSqlGmSdoOci( TGIS_LayerSqlGmSdoAbstract ):
    """
    Encapsulation of Geomedia Oracle Object Model access layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGmSdoOci
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGmSdoOci.Create_void
        """
        pass

class TGIS_LayerSqlGpkgAbstract( TGIS_LayerVectorSqlAbstract ):
    """
    Encapsulation of abstract GeoPackage SQL layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGpkgAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGpkgAbstract.Create_void
        """
        pass

    def ReStructure(
      self
    ) -> None: 
        """
        Reread fields list from the database.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGpkgAbstract.ReStructure_void
        """
        pass

    @property
    def TableGeometry(
      self
    ) -> str: 
        """
        Name of the geometry table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGpkgAbstract.TableGeometry
        """
        pass

    @property
    def TableIndex(
      self
    ) -> str: 
        """
        Name of the rtree index table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGpkgAbstract.TableIndex
        """
        pass

class TGIS_LayerSqlGpkgSqlite( TGIS_LayerSqlGpkgAbstract ):
    """
    Layer that can read GeoPackage via Sqlite.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGpkgSqlite
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlGpkgSqlite.Create_void
        """
        pass

class TGIS_LayerSqlIfxAbstract( TGIS_LayerVectorSqlAbstract ):
    """
    Encapsulation of abstract IBM Informix Spatial Data Blade SQL layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlIfxAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlIfxAbstract.Create_void
        """
        pass

    @property
    def TableConfig(
      self
    ) -> str: 
        """
        Name of the Layer (table) config : name, schema, catalog.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlIfxAbstract.TableConfig
        """
        pass

    @property
    def TableFeatures(
      self
    ) -> str: 
        """
        Name of the features table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlIfxAbstract.TableFeatures
        """
        pass

    @property
    def TableGeometry(
      self
    ) -> str: 
        """
        Name of the geometry table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlIfxAbstract.TableGeometry
        """
        pass

    @property
    def TableMaster(
      self
    ) -> str: 
        """
        Name of the master table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlIfxAbstract.TableMaster
        """
        pass

class TGIS_LayerSqlIfxFireDac( TGIS_LayerSqlIfxAbstract ):
    """
    Layer that can read IBM Informix Spatial Data Blade layer via FireDac.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlIfxFireDac
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlIfxFireDac.Create_void
        """
        pass

class TGIS_LayerSqlLibpq( TGIS_LayerSqlAbstract ):
    """
    Layer that can read SQL file via PostgreSQL client library libpq.dll.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlLibpq
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlLibpq.Create_void
        """
        pass

class TGIS_LayerSqlMsSpatialAbstract( TGIS_LayerVectorSqlAbstract ):
    """
    Layer that can read MSSQL 2008 and higher SQL Spatial data.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlMsSpatialAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlMsSpatialAbstract.Create_void
        """
        pass

    def ReStructure(
      self
    ) -> None: 
        """
        Reread fields list from the database.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlMsSpatialAbstract.ReStructure_void
        """
        pass

    @property
    def TableFeatures(
      self
    ) -> str: 
        """
        Name of the features table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlMsSpatialAbstract.TableFeatures
        """
        pass

    @property
    def TableGeometry(
      self
    ) -> str: 
        """
        Name of the geometry table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlMsSpatialAbstract.TableGeometry
        """
        pass

class TGIS_LayerSqlOci( TGIS_LayerSqlAbstract ):
    """
    Layer that can read SQL file via OCI.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlOci
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlOci.Create_void
        """
        pass

class TGIS_LayerSqlOgisAbstract( TGIS_LayerVectorSqlAbstract ):
    """
    Encapsulation of abstract OpenGIS SQL layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlOgisAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlOgisAbstract.Create_void
        """
        pass

    def ReStructure(
      self
    ) -> None: 
        """
        Reread fields list from the database.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlOgisAbstract.ReStructure_void
        """
        pass

    @property
    def TableFeatures(
      self
    ) -> str: 
        """
        Name of the features table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlOgisAbstract.TableFeatures
        """
        pass

    @property
    def TableGeometry(
      self
    ) -> str: 
        """
        Name of the geometry table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlOgisAbstract.TableGeometry
        """
        pass

    @property
    def TableMaster(
      self
    ) -> str: 
        """
        Name of the master table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlOgisAbstract.TableMaster
        """
        pass

class TGIS_LayerSqlOgisFireDac( TGIS_LayerSqlOgisAbstract ):
    """
    Layer that can read OpenGIS SQL data via FireDAC.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlOgisFireDac
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlOgisFireDac.Create_void
        """
        pass

class TGIS_LayerSqlOgisOci( TGIS_LayerSqlOgisAbstract ):
    """
    Layer that can read OpenGIS SQL file via Oci.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlOgisOci
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlOgisOci.Create_void
        """
        pass

class TGIS_LayerSqlOgisSqlite( TGIS_LayerSqlOgisAbstract ):
    """
    Layer that can read OpenGIS SQL file via Sqlite.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlOgisSqlite
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlOgisSqlite.Create_void
        """
        pass

class TGIS_LayerSqlPgdbAbstract( TGIS_LayerVectorSqlAbstract ):
    """
    Encapsulation of abstract ESRI Personal Geodatabase SQL layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlPgdbAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlPgdbAbstract.Create_void
        """
        pass

    @property
    def Dataset(
      self
    ) -> str: 
        """
        Name of the dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlPgdbAbstract.Dataset
        """
        pass

    @property
    def TableMaster(
      self
    ) -> str: 
        """
        Name of the master table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlPgdbAbstract.TableMaster
        """
        pass

class TGIS_LayerSqlPgdbFireDac( TGIS_LayerSqlPgdbAbstract ):
    """
    Layer that can read ESRI Personal Geodatabase SQL layer via FireDac.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlPgdbFireDac
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlPgdbFireDac.Create_void
        """
        pass

class TGIS_LayerSqlPgisAbstract( TGIS_LayerVectorSqlAbstract ):
    """
    Encapsulation of abstract PostGIS SQL layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlPgisAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlPgisAbstract.Create_void
        """
        pass

    @property
    def TableMaster(
      self
    ) -> str: 
        """
        Name of the master table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlPgisAbstract.TableMaster
        """
        pass

class TGIS_LayerSqlPgisFireDac( TGIS_LayerSqlPgisAbstract ):
    """
    Layer that can read PostGIS SQL layer via FireDac .

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlPgisFireDac
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlPgisFireDac.Create_void
        """
        pass

class TGIS_LayerSqlSdeAbstract( TGIS_LayerVectorSqlAbstract ):
    """
    Encapsulation of abstract ArcSDE SQL layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdeAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdeAbstract.Create_void
        """
        pass

    def RebuildSpatialIndex(
      self,
      _gridSize1: float,
      _gridSize2: float,
      _gridSize3: float
    ) -> None: 
        """
        Rebuild and recalculate spatial index on existing layer.

        Args:
            _gridSize1: size of first level grid
            _gridSize2: size of second level grid
            _gridSize3: size of third level grid

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdeAbstract.RebuildSpatialIndex_Double_Double_Double
        """
        pass

    @property
    def DatabaseSchema(
      self
    ) -> str: 
        """
        Name of the Database schema name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdeAbstract.DatabaseSchema
        """
        pass

    @property
    def Dataset(
      self
    ) -> str: 
        """
        Name of the dataset name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdeAbstract.Dataset
        """
        pass

    @property
    def TableFeatures(
      self
    ) -> str: 
        """
        Name of the features table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdeAbstract.TableFeatures
        """
        pass

    @property
    def TableGeometry(
      self
    ) -> str: 
        """
        Name of the geometry table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdeAbstract.TableGeometry
        """
        pass

    @property
    def TableIndex(
      self
    ) -> str: 
        """
        Name of the index table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdeAbstract.TableIndex
        """
        pass

    @property
    def TableMaster(
      self
    ) -> str: 
        """
        Name of the master table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdeAbstract.TableMaster
        """
        pass

class TGIS_LayerSqlSdeFireDac( TGIS_LayerSqlSdeAbstract ):
    """
    Layer that can read ArcSDE SQL layer via FireDac .

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdeFireDac
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdeFireDac.Create_void
        """
        pass

class TGIS_LayerSqlSdeOci( TGIS_LayerSqlSdeAbstract ):
    """
    Layer that can read ArcSDE SQL layer via Oci.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdeOci
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdeOci.Create_void
        """
        pass

class TGIS_LayerSqlSdoAbstract( TGIS_LayerVectorSqlAbstract ):
    """
    Encapsulation of Oracle Spatial access layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoAbstract.Create_void
        """
        pass

    @property
    def SchemaName(
      self
    ) -> str: 
        """
        Schema name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoAbstract.SchemaName
        """
        pass

    @property
    def TableName(
      self
    ) -> str: 
        """
        Table name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoAbstract.TableName
        """
        pass

    @property
    def UserName(
      self
    ) -> str: 
        """
        User name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoAbstract.UserName
        """
        pass

class TGIS_LayerSqlSdoOci( TGIS_LayerSqlSdoAbstract ):
    """
    Encapsulation of Oracle Spatial access layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoOci
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoOci.Create_void
        """
        pass

class TGIS_LayerSqlSdoPcAbstract( TGIS_LayerVectorSqlAbstract ):
    """
    Encapsulation of Oracle Spatial Point Cloud access layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoPcAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoPcAbstract.Create_void
        """
        pass

    @property
    def SchemaName(
      self
    ) -> str: 
        """
        Schema name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoPcAbstract.SchemaName
        """
        pass

    @property
    def TableName(
      self
    ) -> str: 
        """
        Table name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoPcAbstract.TableName
        """
        pass

    @property
    def UserName(
      self
    ) -> str: 
        """
        User name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoPcAbstract.UserName
        """
        pass

class TGIS_LayerSqlSdoPcOci( TGIS_LayerSqlSdoPcAbstract ):
    """
    Encapsulation of Oracle Spatial Point Cloud access layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoPcOci
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoPcOci.Create_void
        """
        pass

class TGIS_LayerSqlSdoTinAbstract( TGIS_LayerVectorSqlAbstract ):
    """
    Encapsulation of Oracle Spatial Tin access layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoTinAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoTinAbstract.Create_void
        """
        pass

    @property
    def SchemaName(
      self
    ) -> str: 
        """
        Schema name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoTinAbstract.SchemaName
        """
        pass

    @property
    def TableName(
      self
    ) -> str: 
        """
        Table name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoTinAbstract.TableName
        """
        pass

    @property
    def UserName(
      self
    ) -> str: 
        """
        User name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoTinAbstract.UserName
        """
        pass

class TGIS_LayerSqlSdoTinOci( TGIS_LayerSqlSdoTinAbstract ):
    """
    Encapsulation of Oracle Spatial Tin access layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoTinOci
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSdoTinOci.Create_void
        """
        pass

class TGIS_LayerSqlSqlite( TGIS_LayerSqlAbstract ):
    """
    Layer that can read SQL file via Sqlite.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSqlite
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSqlite.Create_void
        """
        pass

class TGIS_LayerSqlSwAbstract( TGIS_LayerVectorSqlAbstract ):
    """
    Encapsulation of abstract MapInfo SpatialWare SQL layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSwAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSwAbstract.Create_void
        """
        pass

    def ReStructure(
      self
    ) -> None: 
        """
        Reread fields list from the database.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSwAbstract.ReStructure_void
        """
        pass

class TGIS_LayerSqlSwFireDac( TGIS_LayerSqlSwAbstract ):
    """
    Encapsulation of MapInfo SpatialWare SQL layer via FireDac .

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSwFireDac
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSqlSwFireDac.Create_void
        """
        pass

class TGIS_LayerSRTM( TGIS_LayerPixel ):
    """
    Encapsulation of an Arcinfo Float(Binary) Grid layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSRTM
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSRTM.Create_void
        """
        pass

class TGIS_LayerSTL( TGIS_LayerVector ):
    """
    Encapsulation of the Standard Tessellation Language (STL) file format (stereolitography 
    CAD).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSTL
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSTL.Create_void
        """
        pass

    @property
    def SaveBinary(
      self
    ) -> bool: 
        """
        True if the file should be saved in the binary version.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSTL.SaveBinary
        """
        pass

    @SaveBinary.setter
    def SaveBinary(
      self,
      _value: bool
    ) -> None: 
        """
        True if the file should be saved in the binary version.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSTL.SaveBinary
        """
        pass

class TGIS_LayerSublayer( TGIS_Layer ):
    """
    Sublayer class represents a ''virtual'' views of the normal layer. Typical sub-layers 
    are named layers within TGIS_LayerWMS server connection.
    
    Sublayer offers only minimal set of native properties( Like Name, Caption) while 
    other calls will be forwarded to the parent layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSublayer
    """

class TGIS_LayerSublayerVector( TGIS_LayerVector ):
    """
    Sublayer vector class represents a ''virtual'' views of the normal layer. Sublayer 
    offers only minimal set of native properties( Like Name, Caption) while other calls 
    will be forwarded to the parent layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSublayerVector
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSublayerVector.Create_void
        """
        pass

    @property
    def UseParentParams(
      self
    ) -> bool: 
        """
        if true, Params from parent layer will be used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSublayerVector.UseParentParams
        """
        pass

    @UseParentParams.setter
    def UseParentParams(
      self,
      _value: bool
    ) -> None: 
        """
        if true, Params from parent layer will be used.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSublayerVector.UseParentParams
        """
        pass

class TGIS_LayerSublayerPixel( TGIS_LayerPixel ):
    """
    Sublayer pixel class represents a ''virtual'' views of the normal layer. Sublayer 
    offers only minimal set of native properties( Like Name, Caption) while other calls 
    will be forwarded to the parent layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSublayerPixel
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSublayerPixel.Create_void
        """
        pass

    @property
    def UseParentParams(
      self
    ) -> bool: 
        """
        if true, Params from parent layer will be used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSublayerPixel.UseParentParams
        """
        pass

    @UseParentParams.setter
    def UseParentParams(
      self,
      _value: bool
    ) -> None: 
        """
        if true, Params from parent layer will be used.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSublayerPixel.UseParentParams
        """
        pass

class TGIS_LayerTAB( TGIS_LayerVector ):
    """
    Layer that can read TAB file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTAB
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTAB.Create_void
        """
        pass

    def CloseFiles(
      self
    ) -> None: 
        """
        Close internal files.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTAB.CloseFiles_void
        """
        pass

    @property
    def PathDAT(
      self
    ) -> str: 
        """
        Path to a DAT file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTAB.PathDAT
        """
        pass

    @property
    def PathDBF(
      self
    ) -> str: 
        """
        Path to a DBF file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTAB.PathDBF
        """
        pass

    @property
    def PathID(
      self
    ) -> str: 
        """
        Path to a ID file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTAB.PathID
        """
        pass

    @property
    def PathMAP(
      self
    ) -> str: 
        """
        Path to a MAP file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTAB.PathMAP
        """
        pass

    @property
    def PathTAB(
      self
    ) -> str: 
        """
        Path to a TAB file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTAB.PathTAB
        """
        pass

class TGIS_LayerTIFF( TGIS_LayerPixel ):
    """
    Encapsulation of a TIFF layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTIFF
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTIFF.Create_void
        """
        pass

class TGIS_LayerTiger( TGIS_LayerVector ):
    """
    Layer that can read TIGER/Line 2000 (or later) files.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTiger
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTiger.Create_void
        """
        pass

    @property
    def ShapeType(
      self
    ) -> TGIS_ShapeType: 
        """
        Layer shape type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTiger.ShapeType
        """
        pass

    @ShapeType.setter
    def ShapeType(
      self,
      _value: TGIS_ShapeType
    ) -> None: 
        """
        Layer shape type.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerTiger.ShapeType
        """
        pass

class TGIS_ShapeList:
    """
    List of TGIS_Shape objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_Shape:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_Shape
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeList.Create_void
        """
        pass

    def Add(
      self,
      _item: TGIS_Shape
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeList.Add_TGIS_Shape
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeList.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeList.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeList.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> TGIS_Shape: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeList.Item
        """
        pass

class TGIS_LayerVector( TGIS_Layer ):
    """
    General layer class for vector layers. Must be derived to provide file access.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Create_void
        """
        pass

    def AddField(
      self,
      _name: str,
      _type: TGIS_FieldType,
      _width: int,
      _decimal: int
    ) -> None: 
        """
        Adds a new field.

        Args:
            _name: name of field to be added
            _type: type of field
            _width: width of field; not important for fields other then TGIS_FieldType.Number 
              or TGIS_FieldType.String;
            _decimal: decimal places; not important for fields other then TGIS_FieldType.Number;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.AddField_String_TGIS_FieldType_Integer_Integer
        """
        pass

    @overload
    def AddFieldInternal(
      self,
      _name: str,
      _type: TGIS_FieldType,
      _width: int,
      _decimal: int
    ) -> None: 
        """
        Adds new field; for internal use.

        Args:
            _name: name of field to be add
            _type: type of field
            _width: width of field
            _decimal: decimal places

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.AddFieldInternal_String_TGIS_FieldType_Integer_Integer
        """
        pass

    @overload
    def AddFieldInternal(
      self,
      _name: str,
      _type: TGIS_FieldType,
      _width: int,
      _decimal: int,
      _saved: bool,
      _binary: int
    ) -> None: 
        """
        Adds new field; for internal use.

        Args:
            _name: name of field to be add
            _type: type of field
            _width: width of field
            _decimal: decimal places
            _saved: True if field exist in an original file
            _binary: binary width (used only for TAB/DAT files)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.AddFieldInternal_String_TGIS_FieldType_Integer_Integer_Boolean_Integer
        """
        pass

    @overload
    def AddShape(
      self,
      _shape: TGIS_Shape
    ) -> TGIS_Shape: 
        """
        Adds a copy of shape and makes it editable.

        Args:
            _shape: shape to be added

        Returns:
            Created copy of shape or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.AddShape_TGIS_Shape
        """
        pass

    @overload
    def AddShape(
      self,
      _shape: TGIS_Shape,
      _copyfield: bool
    ) -> TGIS_Shape: 
        """
        Adds a copy of shape and makes it editable.

        Args:
            _shape: shape to be added
            _copyfield: if True, then all fields will be copied (and created if necessary). Default 
              value is False.

        Returns:
            Created copy of shape or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.AddShape_TGIS_Shape_Boolean
        """
        pass

    @overload
    def Build(
      self,
      _path: str,
      _extent: TGIS_Extent,
      _type: TGIS_ShapeType
    ) -> None: 
        """
        Builds a new layer - prepares storage.

        Args:
            _path: full path of layer to be built; a connection string for SQL base shapes;
            _extent: starting extent of layer - can''t be zero sized
            _type: shape type supported by a layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Build_String_TGIS_Extent_TGIS_ShapeType
        """
        pass

    @overload
    def Build(
      self,
      _path: str,
      _extent: TGIS_Extent,
      _type: TGIS_ShapeType,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Builds s new layer - prepare storage.

        Args:
            _path: full path of layer to be built; a connection string for SQL base shapes;
            _extent: starting extent of layer - can''t be zero sized
            _type: shape type supported by a layer
            _dim: dimension; for default layer dimension use TGIS_DimensionType.Unknown

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Build_String_TGIS_Extent_TGIS_ShapeType_TGIS_DimensionType
        """
        pass

    def CentroidScope(
      self,
      _query: str,
      _centroid: TGIS_Point
    ) -> TGIS_Point: 
        """
        Calculates a centroid for a scope.

        Args:
            _query: Query closely mimics the SQL WHERE clause
            _centroid: Current centroid - to be returned if not found

        Returns:
            Found centroid or untouched _centroid value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.CentroidScope_String_TGIS_Point
        """
        pass

    @overload
    def CreateShape(
      self,
      _type: TGIS_ShapeType
    ) -> TGIS_Shape: 
        """
        Creates a new shape and makes it editable.

        Args:
            _type: type of shape to be created; it must be a type supported by the layer; if 
              TGIS_ShapeType.Unknown, then the default shape type will be created

        Returns:
            Newly created shape or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.CreateShape_TGIS_ShapeType
        """
        pass

    @overload
    def CreateShape(
      self,
      _type: TGIS_ShapeType,
      _dim: TGIS_DimensionType
    ) -> TGIS_Shape: 
        """
        Creates a new shape and makes it editable

        Args:
            _type: type of shape to be created; it must be a type supported by the layer; if 
              TGIS_ShapeType.Unknown, then the default shape type will be created
            _dim: dimension; it must be a type supported by the layer

        Returns:
            Newly created shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.CreateShape_TGIS_ShapeType_TGIS_DimensionType
        """
        pass

    def Delete(
      self,
      _uid: TGIS_Uid
    ) -> None: 
        """
        Deletes a shape.

        Args:
            _uid: Uid of a shape to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Delete_TGIS_Uid
        """
        pass

    def DeleteField(
      self,
      _name: str
    ) -> None: 
        """
        Deletes a field.

        Args:
            _name: name of field to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.DeleteField_String
        """
        pass

    def Deselect(
      self,
      _uid: TGIS_Uid
    ) -> None: 
        """
        Clears selection of shape.

        Args:
            _uid: Uid of a shape to be deselected

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Deselect_TGIS_Uid
        """
        pass

    def DeselectAll(
      self
    ) -> None: 
        """
        Clears selection of all shapes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.DeselectAll_void
        """
        pass

    def DrawChart(
      self
    ) -> bool: 
        """
        Draws layer charts.

        Returns:
            True if something was drawn.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.DrawChart_void
        """
        pass

    def DrawLabel(
      self
    ) -> bool: 
        """
        Draws layer labels.

        Returns:
            True if something was drawn.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.DrawLabel_void
        """
        pass

    def DrawScope(
      self,
      _query: str,
      _style: str
    ) -> bool: 
        """
        Draws only shapes that meet a scope criterion.

        Args:
            _query: Query closely mimics the SQL WHERE clause
            _style: Name of the style to be used. If Empty, default style will be used.

        Returns:
            True if something was drawn.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.DrawScope_String_String
        """
        pass

    @overload
    def ExportLayer(
      self,
      _layer: TGIS_LayerVector,
      _extent: TGIS_Extent,
      _type: TGIS_ShapeType,
      _scope: str,
      _truncated: bool
    ) -> None: 
        """
        Exports the layer.

        Args:
            _layer: layer to be exported to
            _extent: starting extent of layer - can''t be zero sized
            _type: shape type supported by a layer; if gistypeUnknown is used then export will 
              try to recognize shape on its own;
            _scope: SQL query for which shape will be exported
            _truncated: if True, then all shapes will be truncated in _extent; if False, only 
              the shape visible in _extent will be exported ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ExportLayer_TGIS_LayerVector_TGIS_Extent_TGIS_ShapeType_String_Boolean
        """
        pass

    @overload
    def ExportLayer(
      self,
      _layer: TGIS_LayerVector,
      _extent: TGIS_Extent,
      _type: TGIS_ShapeType,
      _scope: str,
      _shape: TGIS_Shape,
      _de9im: str,
      _truncated: bool
    ) -> None: 
        """
        Exports layer.

        Args:
            _layer: layer to be exported to
            _extent: starting extent of layer - can''t be zero sized
            _type: shape type supported by a layer; if gistypeUnknown is used then export will 
              try to recognize shape on its own;
            _scope: SQL query for which shape will be exported
            _shape: if not nil, then only shapes matched _de9im matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _truncated: if True, then all shapes will be truncated in _extent; if False, only 
              the shape visible in _extent will be exported ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ExportLayer_TGIS_LayerVector_TGIS_Extent_TGIS_ShapeType_String_TGIS_Shape_String_Boolean
        """
        pass

    def ExportLayerEx(
      self,
      _layer: TGIS_LayerVector,
      _extent: TGIS_Extent,
      _type: TGIS_ShapeType,
      _scope: str,
      _shape: TGIS_Shape,
      _de9im: str,
      _truncated: bool
    ) -> None: 
        """
        Exports layer.

        Args:
            _layer: layer to be exported to
            _extent: starting extent of layer - can''t be zero sized
            _type: shape type supported by a layer; if gistypeUnknown is used then export will 
              try to recognize shape on its own;
            _scope: SQL query for which shape will be exported
            _shape: if not nil, then only shapes matched _de9im matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _truncated: if True, then all shapes will be truncated in _extent; if False, only 
              the shape visible in _extent will be exported ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ExportLayerEx_TGIS_LayerVector_TGIS_Extent_TGIS_ShapeType_String_TGIS_Shape_String_Boolean
        """
        pass

    def ExportStructureToFLD(
      self
    ) -> None: 
        """
        Exports fields structure to a fld file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ExportStructureToFLD_void
        """
        pass

    def FieldInfo(
      self,
      _id: int
    ) -> TGIS_FieldInfo: 
        """
        Returns pointer to GIS_FieldInfo structure.

        Args:
            _id: id of field to be returned

        Returns:
            Field description or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.FieldInfo_Integer
        """
        pass

    def FinalizeDirectWrite(
      self
    ) -> None: 
        """
        Finalizes direct writing into layer storage.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.FinalizeDirectWrite_void
        """
        pass

    def FinalizeRead(
      self
    ) -> None: 
        """
        Finalizes reading trying to close active queries.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.FinalizeRead_void
        """
        pass

    def FindField(
      self,
      _name: str
    ) -> int: 
        """
        Finds a field in the fields list.

        Args:
            _name: name of field to be found

        Returns:
            Field index (staring for 0) or -1 if not found.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.FindField_String
        """
        pass

    def FindFieldInternal(
      self,
      _name: str
    ) -> int: 
        """
        Finds a field in the fields list (for internal use).

        Args:
            _name: name of field to be found

        Returns:
            Field index (staring for 0) or -1 if not found.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.FindFieldInternal_String
        """
        pass

    @overload
    def FindFirst(
      self
    ) -> TGIS_Shape: 
        """
        Finds the first shape in layer. Will use RTree if available.

        Returns:
            Shape itself or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.FindFirst_void
        """
        pass

    @overload
    def FindFirst(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_Shape: 
        """
        Finds the first occurrence of an item which meets an extent. Will use RTree if available.

        Args:
            _extent: extent of items to be found; the layer has been attached to the Viewer then 
              expected _extent units are in a Viewer coordinate space; otherwise expected _extent 
              units are in a Layer coordinate space

        Returns:
            Shape itself or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.FindFirst_TGIS_Extent
        """
        pass

    @overload
    def FindFirst(
      self,
      _extent: TGIS_Extent,
      _query: str
    ) -> TGIS_Shape: 
        """
        Finds the first occurrence of an item which meets an extent and query. Will use RTree 
        if available.

        Args:
            _extent: extent of items to be found; the layer has been attached to the Viewer then 
              expected _extent units are in a Viewer coordinate space; otherwise expected _extent 
              units are in a Layer coordinate space
            _query: query which must be matched by item; closely mimics SQL WHERE clause; for 
              examples you can use ''AGE &gt;= 18''; empty (default) means that no items will match.

        Returns:
            Shape itself or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.FindFirst_TGIS_Extent_String
        """
        pass

    @overload
    def FindFirst(
      self,
      _extent: TGIS_Extent,
      _query: str,
      _shape: TGIS_Shape,
      _de9im: str
    ) -> TGIS_Shape: 
        """
        Finds the first occurrence of an item which meets an extent, query, and additional 
        parameters. Will use RTree if available.

        Args:
            _extent: extent of items to be found; the layer has been attached to the Viewer then 
              expected _extent units are in a Viewer coordinate space; otherwise expected _extent 
              units are in a Layer coordinate space
            _query: query which must be matched by item; closely mimics SQL WHERE clause; for 
              examples you can use ''AGE &gt;= 18''; empty (default) means that no items will match.
            _shape: if not nil, then only shapes matched _de9im matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison

        Returns:
            Shape itself or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.FindFirst_TGIS_Extent_String_TGIS_Shape_String
        """
        pass

    @overload
    def FindFirst(
      self,
      _extent: TGIS_Extent,
      _query: str,
      _shape: TGIS_Shape,
      _de9im: str,
      _skipDeleted: bool
    ) -> TGIS_Shape: 
        """
        Finds the first occurrence of an item which meets an extent, query, and additional 
        parameters. Will use RTree if available.

        Args:
            _extent: extent of items to be found; the layer has been attached to the Viewer then 
              expected _extent units are in a Viewer coordinate space; otherwise expected _extent 
              units are in a Layer coordinate space
            _query: query which must be matched by item; closely mimics SQL WHERE clause; for 
              examples you can use ''AGE &gt;= 18''; empty (default) means that no items will match.
            _shape: if not nil, then only shapes matched _de9im matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _skipDeleted: set a skip deleted treatment; by default deleted items will be ignored

        Returns:
            Shape itself or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.FindFirst_TGIS_Extent_String_TGIS_Shape_String_Boolean
        """
        pass

    def FindNext(
      self
    ) -> TGIS_Shape: 
        """
        Finds the next occurrence of an item defined in FindFirst. Method will use RTree 
        if available.

        Returns:
            Shape itself or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.FindNext_void
        """
        pass

    def FlashShape(
      self,
      _uid: TGIS_Uid,
      _times: int,
      _delay: int
    ) -> None: 
        """
        Flashes shape several times

        Args:
            _uid: uid of the shape to be flashed
            _times: the number of times the shape will flash (maximum is 20)
            _delay: delay time in msec. between each color change (maximum is 10000)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.FlashShape_TGIS_Uid_Integer_Integer
        """
        pass

    def ForEach(
      self,
      _extent: TGIS_Extent,
      _query: str,
      _shape: TGIS_Shape,
      _de9im: str,
      _skipDeleted: bool,
      _scale: float,
      _callback: typing.Callable[[TGIS_Shape, Boolean], None]
    ) -> bool: 
        """
        Fetches all shapes from the layer using callback function.

        Args:
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space
            _query: query which must be matched by item; closely mimics SQL WHERE clause; for 
              examples you can use ''AGE &gt;= 18''; empty (default) means that no items will match.
            _shape: if not nil, then only shapes matched _de9im matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _skipDeleted: set a skip deleted treatment; by default deleted items will be ignored
            _scale: required to properly prepare shape parameters according ParamsList section 
              visibility; meaningless if layer is not attached to the Viewer
            _callback: procedure to be called on each shape; the value is a callback to a method 
              with parameters defined by TGIS_ForEachShapeEvent

        Returns:
            True if all shapes are passed. False if operation was interrupted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ForEach_TGIS_Extent_String_TGIS_Shape_String_Boolean_Double_TGIS_ForEachShapeEvent
        """
        pass

    def GetField(
      self,
      _uid: TGIS_Uid,
      _name: str
    ) -> Variant: 
        """
        Gets a field value for a shape determined by its unique identity.

        Args:
            _uid: identity
            _name: field name

        Returns:
            Field value. If field value is Null then function will return default value. GetFieldEx 
            will return raw value instead.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.GetField_TGIS_Uid_String
        """
        pass

    def GetFieldEx(
      self,
      _uid: TGIS_Uid,
      _name: str
    ) -> Variant: 
        """
        Gets a field value for a shape determined by its unique identity.

        Args:
            _uid: identity
            _name: field name

        Returns:
            Field value. If field value is Null then function will return Null default value. 
            GetField will return a default value instead.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.GetFieldEx_TGIS_Uid_String
        """
        pass

    def GetLastUid(
      self
    ) -> TGIS_Uid: 
        """
        Gets the Uid of the last shape.

        Returns:
            0 if Uid not assigned (in fact, only for pixel layers) or Uid value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.GetLastUid_void
        """
        pass

    def GetNewUid(
      self
    ) -> TGIS_Uid: 
        """
        Gets the Uid for a new shape.

        Returns:
            0 if Uid not assigned (in fact, only for pixel layers) or Uid value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.GetNewUid_void
        """
        pass

    def GetSelectedCount(
      self
    ) -> int: 
        """
        Returns the quantity of selected shapes.

        Returns:
            Quantity of selected shapes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.GetSelectedCount_void
        """
        pass

    @overload
    def GetShape(
      self,
      _uid: TGIS_Uid
    ) -> TGIS_Shape: 
        """
        Gets a shape by its unique identifier on default cursor (0).

        Args:
            _uid: identifier /same as current record for SHP file/

        Returns:
            Shape itself or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.GetShape_TGIS_Uid
        """
        pass

    @overload
    def GetShape(
      self,
      _uid: TGIS_Uid,
      _cursor: int
    ) -> TGIS_Shape: 
        """
        Gets a shape by unique identifier.

        Args:
            _uid: identifier /same as current record for SHP file/
            _cursor: cursor allocated by cursorOpen()

        Returns:
            Shape itself or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.GetShape_TGIS_Uid_Integer
        """
        pass

    def GetUniqueFieldName(
      self,
      _name: str
    ) -> str: 
        """
        Suggests a unique field name.

        Args:
            _name: field name to be tested

        Returns:
            Original field name if not exists in a layer or a suggest replacement.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.GetUniqueFieldName_String
        """
        pass

    @overload
    def ImportLayer(
      self,
      _layer: TGIS_LayerVector,
      _extent: TGIS_Extent,
      _type: TGIS_ShapeType,
      _scope: str,
      _truncated: bool
    ) -> None: 
        """
        Imports a layer from an existing layer.

        Args:
            _layer: layer to be imported
            _extent: starting extent of layer - can''t be zero sized
            _type: shape type supported by a layer; if gistypeUnknown is used then import will 
              try to recognize shape on its own;
            _scope: SQL query for which shape will be imported
            _truncated: if True, then all shapes will be truncated in _extent; if False, only 
              the shape visible in _extent will be imported ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ImportLayer_TGIS_LayerVector_TGIS_Extent_TGIS_ShapeType_String_Boolean
        """
        pass

    @overload
    def ImportLayer(
      self,
      _layer: TGIS_LayerVector,
      _extent: TGIS_Extent,
      _type: TGIS_ShapeType,
      _scope: str,
      _shape: TGIS_Shape,
      _de9im: str,
      _truncated: bool
    ) -> None: 
        """
        Imports a layer from an existing layer.

        Args:
            _layer: layer to be imported
            _extent: starting extent of layer - can''t be zero sized
            _type: shape type supported by a layer; if gistypeUnknown is used then import will 
              try to recognize shape on its own;
            _scope: SQL query for which shape will be imported
            _shape: if not nil, then only shapes matched _de9im matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _truncated: if True, then all shapes will be truncated in _extent; if False, only 
              the shape visible in _extent will be imported ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ImportLayer_TGIS_LayerVector_TGIS_Extent_TGIS_ShapeType_String_TGIS_Shape_String_Boolean
        """
        pass

    def ImportLayerEx(
      self,
      _layer: TGIS_LayerVector,
      _extent: TGIS_Extent,
      _type: TGIS_ShapeType,
      _scope: str,
      _shape: TGIS_Shape,
      _de9im: str,
      _truncated: bool
    ) -> None: 
        """
        Imports a layer from an existing layer.

        Args:
            _layer: layer to be imported
            _extent: starting extent of layer - can''t be zero sized
            _type: shape type supported by a layer; if gistypeUnknown is used then import will 
              try to recognize shape on its own;
            _scope: SQL query for which shape will be imported
            _shape: if not nil, then only shapes matched _de9im matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _truncated: if True, then all shapes will be truncated in _extent; if False, only 
              the shape visible in _extent will be imported ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ImportLayerEx_TGIS_LayerVector_TGIS_Extent_TGIS_ShapeType_String_TGIS_Shape_String_Boolean
        """
        pass

    def ImportStructure(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Imports the field structure from another layer

        Args:
            _layer: layer to be imported

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ImportStructure_TGIS_LayerVector
        """
        pass

    def InitializeDirectWrite(
      self,
      _path: str,
      _extent: TGIS_Extent,
      _type: TGIS_ShapeType,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Builds a new layer - prepares storage for direct writing.

        Args:
            _path: full path of layer to be built; a connection string for SQL base shapes;
            _extent: starting extent of layer - can''t be zero sized
            _type: shape type supported by a layer
            _dim: dimension; for default layer dimension use TGIS_DimensionType.Unknown

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.InitializeDirectWrite_String_TGIS_Extent_TGIS_ShapeType_TGIS_DimensionType
        """
        pass

    def InvalidateScope(
      self,
      _query: str,
      _style: str
    ) -> None: 
        """
        Invalidates shapes in the scope.

        Args:
            _query: Query closely mimics the SQL WHERE clause
            _style: Name of style to be used. If Empty, default style will be used. Important 
              to correctly calculate shape sizes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.InvalidateScope_String_String
        """
        pass

    def InvalidateSelection(
      self
    ) -> None: 
        """
        Invalidates all selected shapes (but only to redraw the selection, not the shapes 
        themselves).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.InvalidateSelection_void
        """
        pass

    @overload
    def LegendInfo(
      self,
      _id: int,
      _params: TGIS_ParamsSectionVector
    ) -> None: 
        """
        Returns current parameters filled with the renderer styling.

        Args:
            _id: index of sub legend to be returned (number of legends are determined by RenderZones); 
              negative index indicates extended band (Ex).
            _params: params to be set (must be allocated)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.LegendInfo_Integer_TGIS_ParamsSectionVector
        """
        pass

    @overload
    def LegendInfo(
      self,
      _sectionIdx: int,
      _id: int,
      _params: TGIS_ParamsSectionVector
    ) -> bool: 
        """
        Returns parameters filled with the renderer styling.

        Args:
            _sectionIdx: index of parameters section to retrieve
            _id: index of sub legend to be returned (number of legends are determined by RenderZones); 
              negative index indicates extended band (Ex).
            _params: params to be set (must be allocated)

        Returns:
            True, if the data has been retrieved properly

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.LegendInfo_Integer_Integer_TGIS_ParamsSectionVector
        """
        pass

    @overload
    def Locate(
      self,
      _ptg: TGIS_Point,
      _prec: float
    ) -> TGIS_Shape: 
        """
        Locates a shape.

        Args:
            _ptg: reference point /searching point/; if the layer has been attached to the Viewer 
              then expected _ptg units are in a Viewer coordinate space; otherwise expected _ptg 
              units are in a Layer coordinate space
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons _prec units are calculated same way 
              as _ptg

        Returns:
            Found shape or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Locate_TGIS_Point_Double
        """
        pass

    @overload
    def Locate(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _visible: bool
    ) -> TGIS_Shape: 
        """
        Locates a shape.

        Args:
            _ptg: reference point /searching point/; if the layer has been attached to the Viewer 
              then expected _ptg units are in a Viewer coordinate space; otherwise expected _ptg 
              units are in a Layer coordinate space
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons _prec units are calculated same way 
              as _ptg
            _visible: if true the only visible shapes will be evaluated; shapes turned of by 
              query of hidden will be ignored

        Returns:
            Found shape or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Locate_TGIS_Point_Double_Boolean
        """
        pass

    @overload
    def LocateEx(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _uid: TGIS_Uid,
      _dist: VarParameter,
      _part: VarParameter,
      _proj: VarParameter
    ) -> TGIS_Shape: 
        """
        Locates a shape (more precise).

        Args:
            _ptg: reference point /searching point/ if the layer has been attached to the Viewer 
              then expected _ptg units are in a Viewer coordinate space; otherwise expected _ptg 
              units are in a Layer coordinate space
            _prec: precision /not a longer distance than/; point inside a polygon is always not 
              greater than _dist; if _prec is less then 0, then being outside/inside polygon means 
              the same _prec units are calculated same way as _ptg
            _uid: Uid of reference shape or -1; thanks to this, is possible to find nearest shape, 
              excluding shape given by _uid.
            _dist: reached distance between _pt and shape in Result; for points inside the polygon 
              (if _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside 
              the polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons _dist units are calculated same way 
              as _ptg; the value (in/out) is passed as float in _dist.Value property
            _part: number of the part closest to a given point; the value (in/out) is passed 
              as int in _part.Value property
            _proj: point projected to the nearest element of a shape; the value (in/out) is passed 
              as TGIS_Point in _proj.Value property

        Returns:
            Found shape or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.LocateEx_TGIS_Point_Double_TGIS_Uid_Double_Integer_TGIS_Point
        """
        pass

    @overload
    def LocateEx(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _uid: TGIS_Uid,
      _dist: VarParameter,
      _part: VarParameter,
      _proj: VarParameter,
      _visible: bool
    ) -> TGIS_Shape: 
        """
        Locates a shape (more precise).

        Args:
            _ptg: reference point /searching point/ in a layer; if the layer has been attached 
              to the Viewer then expected _ptg units are in a Viewer coordinate space; otherwise 
              expected _ptg units are in a Layer coordinate space
            _prec: precision /not a longer distance than/; point inside a polygon is always not 
              greater than _dist; if _prec is less then 0, then being outside/inside polygon means 
              the same; _prec units are calculated same way as _ptg
            _uid: Uid of reference shape or -1; thanks to this, is possible to find nearest shape, 
              excluding shape given by _uid.
            _dist: reached distance between _pt and shape in Result; for points inside the polygon 
              (if _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside 
              the polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons _dist units are calculated same way 
              as _ptg; the value (in/out) is passed as float in _dist.Value property
            _part: number of the part closest to a given point; the value (in/out) is passed 
              as int in _part.Value property
            _proj: point projected to the nearest element of a shape; the value (in/out) is passed 
              as TGIS_Point in _proj.Value property
            _visible: if true the only visible shapes will be evaluated; shapes turned of by 
              query of hidden will be ignored

        Returns:
            Found shape or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.LocateEx_TGIS_Point_Double_TGIS_Uid_Double_Integer_TGIS_Point_Boolean
        """
        pass

    @overload
    def LocateEx(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _uid: TGIS_Uid,
      _dist: VarParameter,
      _part: VarParameter,
      _proj: VarParameter,
      _dist_prefer: VarParameter,
      _visible: bool
    ) -> TGIS_Shape: 
        """
        Locates a shape (more precise).

        Args:
            _ptg: reference point /searching point/ in a layer; if the layer has been attached 
              to the Viewer then expected _ptg units are in a Viewer coordinate space; otherwise 
              expected _ptg units are in a Layer coordinate space
            _prec: precision /not a longer distance than/; point inside a polygon is always not 
              greater than _dist; if _prec is less then 0, then being outside/inside polygon means 
              the same; _prec units are calculated same way as _ptg
            _uid: Uid of reference shape or -1; thanks to this, is possible to find nearest shape, 
              excluding shape given by _uid.
            _dist: reached distance between _pt and shape in Result; for points inside the polygon 
              (if _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside 
              the polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons _dist units are calculated same way 
              as _ptg; the value (in/out) is passed as float in _dist.Value property
            _part: number of the part closest to a given point; the value (in/out) is passed 
              as int in _part.Value property
            _proj: point projected to the nearest element of a shape; the value (in/out) is passed 
              as TGIS_Point in _proj.Value property
            _dist_prefer: preferred distance (including shape type priority : points over lines 
              and polygons); the value (in/out) is passed as float in _dist_prefer.Value property
            _visible: if true the only visible shapes will be evaluated; shapes turned of by 
              query of hidden will be ignored

        Returns:
            Found shape or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.LocateEx_TGIS_Point_Double_TGIS_Uid_Double_Integer_TGIS_Point_Double_Boolean
        """
        pass

    @overload
    def Loop(
      self
    ) -> TGIS_LayerVectorEnumeratorFactory: 
        """
        Prepares enumerator (also known as iterator or cursor) to iterate the layer.

        Returns:
            Shape enumerator''

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Loop_void
        """
        pass

    @overload
    def Loop(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_LayerVectorEnumeratorFactory: 
        """
        Prepares enumerator (also known as iterator or cursor) to iterate the layer.

        Args:
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space

        Returns:
            Shape itself or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Loop_TGIS_Extent
        """
        pass

    @overload
    def Loop(
      self,
      _extent: TGIS_Extent,
      _query: str
    ) -> TGIS_LayerVectorEnumeratorFactory: 
        """
        Prepares enumerator (also known as iterator or cursor) to iterate the layer.

        Args:
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space
            _query: query which must be matched by item; closely mimics SQL WHERE clause; for 
              examples you can use ''AGE >= 18''; empty (default) means that no items will match.

        Returns:
            Shape itself or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Loop_TGIS_Extent_String
        """
        pass

    @overload
    def Loop(
      self,
      _extent: TGIS_Extent,
      _query: str,
      _shape: TGIS_Shape,
      _de9im: str
    ) -> TGIS_LayerVectorEnumeratorFactory: 
        """
        Prepares enumerator (also known as iterator or cursor) to iterate the layer.

        Args:
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space
            _query: query which must be matched by item; closely mimics SQL WHERE clause; for 
              examples you can use ''AGE >= 18''; empty (default) means that no items will match.
            _shape: if not nil, then only shapes matched _de9im matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison

        Returns:
            Shape itself or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Loop_TGIS_Extent_String_TGIS_Shape_String
        """
        pass

    @overload
    def Loop(
      self,
      _extent: TGIS_Extent,
      _query: str,
      _shape: TGIS_Shape,
      _de9im: str,
      _skipDeleted: bool
    ) -> TGIS_LayerVectorEnumeratorFactory: 
        """
        Prepares enumerator (also known as iterator or cursor) to iterate the layer.

        Args:
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space
            _query: query which must be matched by item; closely mimics SQL WHERE clause; for 
              examples you can use ''AGE >= 18''; empty (default) means that no items will match.
            _shape: if not nil, then only shapes matched _de9im matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _skipDeleted: set a skip deleted treatment; by default deleted items will be ignored

        Returns:
            Shape itself or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Loop_TGIS_Extent_String_TGIS_Shape_String_Boolean
        """
        pass

    @overload
    def MergeLayer(
      self,
      _layer: TGIS_LayerVector,
      _extent: TGIS_Extent,
      _type: TGIS_ShapeType,
      _scope: str,
      _truncated: bool,
      _restrict: bool
    ) -> None: 
        """
        Merges layer from an existing layer.

        Args:
            _layer: layer to be merged
            _extent: starting extent of layer - can''t be zero sized
            _type: shape type supported by a layer; if gistypeUnknown is used then import will 
              try to recognize shape on its own;
            _scope: SQL query for which shape will be imported
            _truncated: if True, then all shapes will be truncated in _extent; if False, only 
              the shape visible in _extent will be imported ;
            _restrict: if True, any field structure modification will raise error, otherwise 
              allow to resize fields

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.MergeLayer_TGIS_LayerVector_TGIS_Extent_TGIS_ShapeType_String_Boolean_Boolean
        """
        pass

    @overload
    def MergeLayer(
      self,
      _layer: TGIS_LayerVector,
      _extent: TGIS_Extent,
      _type: TGIS_ShapeType,
      _scope: str,
      _shape: TGIS_Shape,
      _de9im: str,
      _truncated: bool,
      _restrict: bool
    ) -> None: 
        """
        Merges layer with an existing layer.

        Args:
            _layer: layer to be imported
            _extent: starting extent of layer - can''t be zero sized
            _type: shape type supported by a layer; if gistypeUnknown is used then import will 
              try to recognize shape on its own;
            _scope: SQL query for which shape will be imported
            _shape: if not nil, then only shapes matched _de9im matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _truncated: if True, then all shapes will be truncated in _extent; if False, only 
              the shape visible in _extent will be imported ;
            _restrict: if True, any field structure modification will raise error, otherwise 
              allow to resize fields

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.MergeLayer_TGIS_LayerVector_TGIS_Extent_TGIS_ShapeType_String_TGIS_Shape_String_Boolean_Boolean
        """
        pass

    def MergeLayerEx(
      self,
      _layer: TGIS_LayerVector,
      _extent: TGIS_Extent,
      _type: TGIS_ShapeType,
      _scope: str,
      _shape: TGIS_Shape,
      _de9im: str,
      _truncated: bool,
      _restrict: bool
    ) -> None: 
        """
        Merges layer with an existing layer.

        Args:
            _layer: layer to be imported
            _extent: starting extent of layer - can''t be zero sized
            _type: shape type supported by a layer; if gistypeUnknown is used then import will 
              try to recognize shape on its own;
            _scope: SQL query for which shape will be imported
            _shape: if not nil, then only shapes matched _de9im matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _truncated: if True, then all shapes will be truncated in _extent; if False, only 
              the shape visible in _extent will be imported ;
            _restrict: if True, any field structure modification will raise error, otherwise 
              allow to resize fields

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.MergeLayerEx_TGIS_LayerVector_TGIS_Extent_TGIS_ShapeType_String_TGIS_Shape_String_Boolean_Boolean
        """
        pass

    @overload
    def MergeStructure(
      self,
      _layer: TGIS_LayerVector,
      _restrict: bool
    ) -> None: 
        """
        Merges the field structure from another layer.

        Args:
            _layer: layer to be imported
            _restrict: if True, any field structure modification will raise error, otherwise 
              allow to resize fields

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.MergeStructure_TGIS_LayerVector_Boolean
        """
        pass

    @overload
    def MergeStructure(
      self,
      _layer: TGIS_LayerVector,
      _restrict: bool,
      _useExportName: bool
    ) -> None: 
        """
        Merges the field structure from another layer.

        Args:
            _layer: layer to be imported
            _restrict: if True, any field structure modification will raise error, otherwise 
              allow to resize fields
            _useExportName: if True, field ExportName will be used, otherwise NewName

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.MergeStructure_TGIS_LayerVector_Boolean_Boolean
        """
        pass

    def ParamsAsDrawn(
      self,
      _shp: TGIS_Shape,
      _params: TGIS_ParamsSectionVector
    ) -> None: 
        """
        Gets a shape''s styling parameters that are used during drawing in the viewer, and 
        fills the _params parameter.

        Args:
            _shp: shape to evaluate when preparing params
            _params: params to be set (must be allocated)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ParamsAsDrawn_TGIS_Shape_TGIS_ParamsSectionVector
        """
        pass

    @overload
    def PrepareExportFieldNames(
      self,
      _maxwidth: int
    ) -> None: 
        """
        Prepares field names to export.

        Args:
            _maxwidth: max width of field; should be &gt;= 4

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.PrepareExportFieldNames_Integer
        """
        pass

    @overload
    def PrepareExportFieldNames(
      self,
      _maxwidth: int,
      _forced: bool
    ) -> None: 
        """
        Prepares field names to export.

        Args:
            _maxwidth: max width of field; should be &gt;= 4
            _forced: if _false (default) export names will be constructed for new fields; otherwise 
              saved fields will be ignored

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.PrepareExportFieldNames_Integer_Boolean
        """
        pass

    @overload
    def PrepareExportFieldNames(
      self,
      _maxwidth: int,
      _forced: bool,
      _useUpperCase: bool
    ) -> None: 
        """
        Prepares field names to export.

        Args:
            _maxwidth: max width of field; should be &gt;= 4
            _forced: if _false (default) export names will be constructed for new fields; otherwise 
              saved fields will be ignored
            _useUpperCase: convert field name to uppercase format

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.PrepareExportFieldNames_Integer_Boolean_Boolean
        """
        pass

    @overload
    def PrepareExportFieldNames(
      self,
      _maxwidth: int,
      _forced: bool,
      _useUpperCase: bool,
      _useStrictNames: bool
    ) -> None: 
        """
        Prepares field names to export.

        Args:
            _maxwidth: max width of field; should be &gt;= 4
            _forced: if _false (default) export names will be constructed for new fields; otherwise 
              saved fields will be ignored
            _useUpperCase: convert field name to uppercase format
            _useStrictNames: convert field name to canonical SQL format, without special characters

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.PrepareExportFieldNames_Integer_Boolean_Boolean_Boolean
        """
        pass

    def ReadFieldDefinition(
      self
    ) -> None: 
        """
        Parses the field definition file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ReadFieldDefinition_void
        """
        pass

    def ReadFieldRules(
      self
    ) -> None: 
        """
        Parses the field rules file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ReadFieldRules_void
        """
        pass

    def RenameField(
      self,
      _name: str,
      _newname: str,
      _width: int,
      _decimal: int
    ) -> None: 
        """
        Renames a field.

        Args:
            _name: name of field to be renamed
            _newname: new name
            _width: new width
            _decimal: new decimal position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.RenameField_String_String_Integer_Integer
        """
        pass

    def Revert(
      self,
      _uid: TGIS_Uid
    ) -> None: 
        """
        Reverts a shape to its original state.

        Args:
            _uid: Uid of a shape to be reverted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Revert_TGIS_Uid
        """
        pass

    def RevertShapes(
      self
    ) -> None: 
        """
        Reverts all shapes to their original state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.RevertShapes_void
        """
        pass

    def SaveFieldRules(
      self
    ) -> None: 
        """
        Save field rules file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.SaveFieldRules_void
        """
        pass

    def WriteShapeDirect(
      self,
      _shape: TGIS_Shape
    ) -> None: 
        """
        Writes a shape directly into storage.

        Args:
            _shape: shape to be saved

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.WriteShapeDirect_TGIS_Shape
        """
        pass

    @property
    def BlockRTree(
      self
    ) -> bool: 
        """
        If true, then Rtree for the layer cannot be enabled and UseRtree is ignored.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.BlockRTree
        """
        pass

    @BlockRTree.setter
    def BlockRTree(
      self,
      _value: bool
    ) -> None: 
        """
        If true, then Rtree for the layer cannot be enabled and UseRtree is ignored.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.BlockRTree
        """
        pass

    @property
    def DefaultDimension(
      self
    ) -> TGIS_DimensionType: 
        """
        Default shape dimension for the layer. Can be set only to one of SupportedDimension.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.DefaultDimension
        """
        pass

    @DefaultDimension.setter
    def DefaultDimension(
      self,
      _value: TGIS_DimensionType
    ) -> None: 
        """
        Default shape dimension for the layer. Can be set only to one of SupportedDimension.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.DefaultDimension
        """
        pass

    @property
    def DefaultShapeType(
      self
    ) -> TGIS_ShapeType: 
        """
        Default shape type for the layer. Can be set only to one of SupportedShapes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.DefaultShapeType
        """
        pass

    @DefaultShapeType.setter
    def DefaultShapeType(
      self,
      _value: TGIS_ShapeType
    ) -> None: 
        """
        Default shape type for the layer. Can be set only to one of SupportedShapes.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.DefaultShapeType
        """
        pass

    @property
    def DynamicAggregator(
      self
    ) -> TGIS_DynamicAggregatorAbstract: 
        """
        Aggregation processor is executed upon the drawing process. Typical use is to provide 
        dynamic binning or clustering.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.DynamicAggregator
        """
        pass

    @DynamicAggregator.setter
    def DynamicAggregator(
      self,
      _value: TGIS_DynamicAggregatorAbstract
    ) -> None: 
        """
        Aggregation processor is executed upon the drawing process. Typical use is to provide 
        dynamic binning or clustering.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.DynamicAggregator
        """
        pass

    @property
    def Fields(
      self
    ) -> TGIS_FieldInfoList: 
        """
        List of database field definitions.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Fields
        """
        pass

    @property
    def FieldsVirtual(
      self
    ) -> TGIS_FieldInfoList: 
        """
        List of virtual fields.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.FieldsVirtual
        """
        pass

    @property
    def IgnoreShapeParams(
      self
    ) -> bool: 
        """
        If True, then only layer level params will be used. Any color or style defined for 
        a particular shape will be ignored and substituted with color or style defined on 
        the layer level.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.IgnoreShapeParams
        """
        pass

    @IgnoreShapeParams.setter
    def IgnoreShapeParams(
      self,
      _value: bool
    ) -> None: 
        """
        If True, then only layer level params will be used. Any color or style defined for 
        a particular shape will be ignored and substituted with color or style defined on 
        the layer level.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.IgnoreShapeParams
        """
        pass

    @property
    def InMemoryRTree(
      self
    ) -> bool: 
        """
        True if RTree file will be created in-memory. Only used when opening the layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.InMemoryRTree
        """
        pass

    @InMemoryRTree.setter
    def InMemoryRTree(
      self,
      _value: bool
    ) -> None: 
        """
        True if RTree file will be created in-memory. Only used when opening the layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.InMemoryRTree
        """
        pass

    @property
    def Items(
      self
    ) -> TGIS_ShapeList: 
        """
        A list of all ghost items.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Items
        """
        pass

    @property
    def JoinCodePage(
      self
    ) -> int: 
        """
        Code page for JoinADO/JoinDB.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.JoinCodePage
        """
        pass

    @JoinCodePage.setter
    def JoinCodePage(
      self,
      _value: int
    ) -> None: 
        """
        Code page for JoinADO/JoinDB.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.JoinCodePage
        """
        pass

    @property
    def JoinDB(
      self
    ) -> TDataSet: 
        """
        DB Query to be joined.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.JoinDB
        """
        pass

    @JoinDB.setter
    def JoinDB(
      self,
      _value: TDataSet
    ) -> None: 
        """
        DB Query to be joined.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.JoinDB
        """
        pass

    @property
    def JoinDBAPI2(
      self
    ) -> cursor: 
        """
        DB-API 2.0 Cursor (e.g. SQLite cursor) to be joined.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.JoinDBAPI2
        """
        pass

    @JoinDBAPI2.setter
    def JoinDBAPI2(
      self,
      _value: cursor
    ) -> None: 
        """
        DB-API 2.0 Cursor (e.g. SQLite cursor) to be joined.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.JoinDBAPI2
        """
        pass

    @property
    def JoinForeign(
      self
    ) -> str: 
        """
        Field from Query to be joined. Field value must be the same type as JoinPrimary. 
        Query must be ordered by this value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.JoinForeign
        """
        pass

    @JoinForeign.setter
    def JoinForeign(
      self,
      _value: str
    ) -> None: 
        """
        Field from Query to be joined. Field value must be the same type as JoinPrimary. 
        Query must be ordered by this value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.JoinForeign
        """
        pass

    @property
    def JoinPrimary(
      self
    ) -> str: 
        """
        Field from feature table to be joined. Field value must be a unique and be the same 
        type as JoinForeign. Table must be ordered by this value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.JoinPrimary
        """
        pass

    @JoinPrimary.setter
    def JoinPrimary(
      self,
      _value: str
    ) -> None: 
        """
        Field from feature table to be joined. Field value must be a unique and be the same 
        type as JoinForeign. Table must be ordered by this value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.JoinPrimary
        """
        pass

    @property
    def LabelingMode(
      self
    ) -> int: 
        """
        Labeling mode metadata.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.LabelingMode
        """
        pass

    @property
    def MultipassRendering(
      self
    ) -> bool: 
        """
        Forces multipass rendering.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.MultipassRendering
        """
        pass

    @MultipassRendering.setter
    def MultipassRendering(
      self,
      _value: bool
    ) -> None: 
        """
        Forces multipass rendering.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.MultipassRendering
        """
        pass

    @property
    def Params(
      self
    ) -> TGIS_ParamsSectionVector: 
        """
        Returns parameters (colors, fills, etc.) object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Params
        """
        pass

    @Params.setter
    def Params(
      self,
      _value: TGIS_ParamsSectionVector
    ) -> None: 
        """
        Returns parameters (colors, fills, etc.) object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Params
        """
        pass

    @property
    def PathFLD(
      self
    ) -> str: 
        """
        Path to field definitions ini file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.PathFLD
        """
        pass

    @property
    def PathFLDX(
      self
    ) -> str: 
        """
        Path to field rules file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.PathFLDX
        """
        pass

    @property
    def PathRTree(
      self
    ) -> str: 
        """
        Path to RTree index.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.PathRTree
        """
        pass

    @property
    def Scope(
      self
    ) -> str: 
        """
        Scope zone.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Scope
        """
        pass

    @Scope.setter
    def Scope(
      self,
      _value: str
    ) -> None: 
        """
        Scope zone.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.Scope
        """
        pass

    @property
    def ScopeExtent(
      self
    ) -> TGIS_Extent: 
        """
        Scope extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ScopeExtent
        """
        pass

    @ScopeExtent.setter
    def ScopeExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Scope extent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ScopeExtent
        """
        pass

    @property
    def SelectedList(
      self
    ) -> TGIS_SelectedShapeList: 
        """
        List of uids of the selected shapes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.SelectedList
        """
        pass

    @property
    def SelectionGisColor(
      self
    ) -> TGIS_Color: 
        """
        Color used for selecting object. Set UseCustomSelectionStyle=True to apply.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.SelectionGisColor
        """
        pass

    @SelectionGisColor.setter
    def SelectionGisColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Color used for selecting object. Set UseCustomSelectionStyle=True to apply.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.SelectionGisColor
        """
        pass

    @property
    def SelectionOutlineOnly(
      self
    ) -> bool: 
        """
        If true then polygons will be marked only with outline not a full fill. Set UseCustomSelectionStyle=True 
        to apply.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.SelectionOutlineOnly
        """
        pass

    @SelectionOutlineOnly.setter
    def SelectionOutlineOnly(
      self,
      _value: bool
    ) -> None: 
        """
        If true then polygons will be marked only with outline not a full fill. Set UseCustomSelectionStyle=True 
        to apply.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.SelectionOutlineOnly
        """
        pass

    @property
    def SelectionWidth(
      self
    ) -> int: 
        """
        Outline width of selection area (&gt;0 in twips, &lt;0 in pixels). Set UseCustomSelectionStyle=True 
        to apply.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.SelectionWidth
        """
        pass

    @SelectionWidth.setter
    def SelectionWidth(
      self,
      _value: int
    ) -> None: 
        """
        Outline width of selection area (&gt;0 in twips, &lt;0 in pixels). Set UseCustomSelectionStyle=True 
        to apply.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.SelectionWidth
        """
        pass

    @property
    def SupportedDimensions(
      self
    ) -> typing.Sequence[TGIS_DimensionType]: 
        """
        Set of dimensions supported by a layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.SupportedDimensions
        """
        pass

    @SupportedDimensions.setter
    def SupportedDimensions(
      self,
      _value: typing.Sequence[TGIS_DimensionType]
    ) -> None: 
        """
        Set of dimensions supported by a layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.SupportedDimensions
        """
        pass

    @property
    def SupportedShapes(
      self
    ) -> typing.Sequence[TGIS_ShapeType]: 
        """
        Set of shapes supported by a layer. The meaning of this is shapes that can be created, 
        saved etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.SupportedShapes
        """
        pass

    @SupportedShapes.setter
    def SupportedShapes(
      self,
      _value: typing.Sequence[TGIS_ShapeType]
    ) -> None: 
        """
        Set of shapes supported by a layer. The meaning of this is shapes that can be created, 
        saved etc.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.SupportedShapes
        """
        pass

    @property
    def SupportedShapesAll(
      self
    ) -> typing.Sequence[TGIS_ShapeType]: 
        """
        Similar to SupportedShapesSet, but this lists also includes shape types added temporarily 
        by the aggregator.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.SupportedShapesAll
        """
        pass

    @property
    def SymbolingMode(
      self
    ) -> int: 
        """
        Symboling mode metadata.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.SymbolingMode
        """
        pass

    @property
    def UseLayerSelectionStyle(
      self
    ) -> bool: 
        """
        Controls whether the layer uses a custom selection style. If true, the viewer''s 
        selection properties will be overridden.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.UseLayerSelectionStyle
        """
        pass

    @UseLayerSelectionStyle.setter
    def UseLayerSelectionStyle(
      self,
      _value: bool
    ) -> None: 
        """
        Controls whether the layer uses a custom selection style. If true, the viewer''s 
        selection properties will be overridden.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.UseLayerSelectionStyle
        """
        pass

    @property
    def UseRTree(
      self
    ) -> bool: 
        """
        Sets the use of an index based on RTree structure. Setting to True will always rebuild 
        index for in-memory shapes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.UseRTree
        """
        pass

    @UseRTree.setter
    def UseRTree(
      self,
      _value: bool
    ) -> None: 
        """
        Sets the use of an index based on RTree structure. Setting to True will always rebuild 
        index for in-memory shapes.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.UseRTree
        """
        pass

    @property
    def UseShapeStyleField(
      self
    ) -> bool: 
        """
        If true than params style attribute field was defined.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.UseShapeStyleField
        """
        pass

    @UseShapeStyleField.setter
    def UseShapeStyleField(
      self,
      _value: bool
    ) -> None: 
        """
        If true than params style attribute field was defined.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.UseShapeStyleField
        """
        pass

    @property
    def CursorAfterFetchEvent(
      self
    ) -> typing.Callable[[TObject, Integer], None]: 
        """
        CursorAfterFetch event. This will be fired after data is fetched in CursorFirst method.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.CursorAfterFetchEvent
        """
        pass

    @CursorAfterFetchEvent.setter
    def CursorAfterFetchEvent(
      self,
      _value: typing.Callable[[TObject, Integer], None]
    ) -> None: 
        """
        CursorAfterFetch event. This will be fired after data is fetched in CursorFirst method.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.CursorAfterFetchEvent
        """
        pass

    @property
    def CursorBeforeFetchEvent(
      self
    ) -> typing.Callable[[TObject, Integer], None]: 
        """
        CursorBeforeFetch event. Will be fired before data fetch in CursorFirst method.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.CursorBeforeFetchEvent
        """
        pass

    @CursorBeforeFetchEvent.setter
    def CursorBeforeFetchEvent(
      self,
      _value: typing.Callable[[TObject, Integer], None]
    ) -> None: 
        """
        CursorBeforeFetch event. Will be fired before data fetch in CursorFirst method.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.CursorBeforeFetchEvent
        """
        pass

    @property
    def CursorCloseEvent(
      self
    ) -> typing.Callable[[TObject, Integer], None]: 
        """
        CursorClose event. Will be fired upon cursor close.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.CursorCloseEvent
        """
        pass

    @CursorCloseEvent.setter
    def CursorCloseEvent(
      self,
      _value: typing.Callable[[TObject, Integer], None]
    ) -> None: 
        """
        CursorClose event. Will be fired upon cursor close.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.CursorCloseEvent
        """
        pass

    @property
    def CursorInterruptEvent(
      self
    ) -> typing.Callable[[TObject, Integer], None]: 
        """
        OnCursorInterrupt event. Will be fired after interrupting reading.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.CursorInterruptEvent
        """
        pass

    @CursorInterruptEvent.setter
    def CursorInterruptEvent(
      self,
      _value: typing.Callable[[TObject, Integer], None]
    ) -> None: 
        """
        OnCursorInterrupt event. Will be fired after interrupting reading.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.CursorInterruptEvent
        """
        pass

    @property
    def CursorOpenEvent(
      self
    ) -> typing.Callable[[TObject, Integer], None]: 
        """
        CursorOpen event. Will be fired upon cursor open.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.CursorOpenEvent
        """
        pass

    @CursorOpenEvent.setter
    def CursorOpenEvent(
      self,
      _value: typing.Callable[[TObject, Integer], None]
    ) -> None: 
        """
        CursorOpen event. Will be fired upon cursor open.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.CursorOpenEvent
        """
        pass

    @property
    def CursorShapeFetchEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Shape], None]: 
        """
        CursorShapeFetch event. Will be fired after shape fetch.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.CursorShapeFetchEvent
        """
        pass

    @CursorShapeFetchEvent.setter
    def CursorShapeFetchEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Shape], None]
    ) -> None: 
        """
        CursorShapeFetch event. Will be fired after shape fetch.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.CursorShapeFetchEvent
        """
        pass

    @property
    def LabelPosEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Shape, TGIS_LabelPosition, TPoint, TRect], None]: 
        """
        LabelPos event.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.LabelPosEvent
        """
        pass

    @LabelPosEvent.setter
    def LabelPosEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Shape, TGIS_LabelPosition, TPoint, TRect], None]
    ) -> None: 
        """
        LabelPos event.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.LabelPosEvent
        """
        pass

    @property
    def PaintShapeChartEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Shape], None]: 
        """
        PaintShapeChart event.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.PaintShapeChartEvent
        """
        pass

    @PaintShapeChartEvent.setter
    def PaintShapeChartEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Shape], None]
    ) -> None: 
        """
        PaintShapeChart event.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.PaintShapeChartEvent
        """
        pass

    @property
    def PaintShapeEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Shape], None]: 
        """
        PaintShape event.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.PaintShapeEvent
        """
        pass

    @PaintShapeEvent.setter
    def PaintShapeEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Shape], None]
    ) -> None: 
        """
        PaintShape event.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.PaintShapeEvent
        """
        pass

    @property
    def PaintShapeLabelEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Shape], None]: 
        """
        PaintShapeLabel event.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.PaintShapeLabelEvent
        """
        pass

    @PaintShapeLabelEvent.setter
    def PaintShapeLabelEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Shape], None]
    ) -> None: 
        """
        PaintShapeLabel event.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.PaintShapeLabelEvent
        """
        pass

    @property
    def ShapeFieldChangeEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Shape, Integer], None]: 
        """
        ShapeFieldChange event. Will be fired after a shape field change.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ShapeFieldChangeEvent
        """
        pass

    @ShapeFieldChangeEvent.setter
    def ShapeFieldChangeEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Shape, Integer], None]
    ) -> None: 
        """
        ShapeFieldChange event. Will be fired after a shape field change.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ShapeFieldChangeEvent
        """
        pass

    @property
    def ShapeGeometryChangeEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Shape], None]: 
        """
        ShapeGeometryChange event. Will be fired after a shape geometry change.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ShapeGeometryChangeEvent
        """
        pass

    @ShapeGeometryChangeEvent.setter
    def ShapeGeometryChangeEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Shape], None]
    ) -> None: 
        """
        ShapeGeometryChange event. Will be fired after a shape geometry change.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVector.ShapeGeometryChangeEvent
        """
        pass

class TGIS_LayerVectorEnumerator( TObject ):
    """
    Vector layer enumerator.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorEnumerator
    """

    def __iter__(
      self
    ) -> TGIS_LayerVectorEnumerator:
        pass

    def __next__(
      self
    ) -> TGIS_Shape:
        pass

    @overload
    def __init__(
      self,
      _lv: TGIS_LayerVector,
      _extent: TGIS_Extent,
      _query: str,
      _shape: TGIS_Shape,
      _de9im: str,
      _skipDeleted: bool
    ) -> None: 
        """
        Create an enumerator instance.

        Args:
            _lv: vector layer handle
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space
            _query: query which must be matched by item; closely mimics SQL WHERE clause; for 
              examples you can use ''AGE &gt;= 18''; empty (default) means that no items will match.
            _shape: if not nil, then only shapes matched _de9im matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _skipDeleted: set a skip deleted treatment

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorEnumerator.Create_TGIS_LayerVector_TGIS_Extent_String_TGIS_Shape_String_Boolean
        """
        pass

    @overload
    def __init__(
      self,
      _factory: TGIS_LayerVectorEnumeratorFactory,
      _lv: TGIS_LayerVector,
      _extent: TGIS_Extent,
      _query: str,
      _shape: TGIS_Shape,
      _de9im: str,
      _skipDeleted: bool
    ) -> None: 
        """
        Create an enumerator instance.

        Args:
            _factory: reference to factory object which create this enumerator
            _lv: vector layer handle
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space
            _query: query which must be matched by item; closely mimics SQL WHERE clause; for 
              examples you can use ''AGE &gt;= 18''; empty (default) means that no items will match.
            _shape: if not nil, then only shapes matched _de9im matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _skipDeleted: set a skip deleted treatment

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorEnumerator.Create_TGIS_LayerVectorEnumeratorFactory_TGIS_LayerVector_TGIS_Extent_String_TGIS_Shape_String_Boolean
        """
        pass

    def BindField(
      self,
      _name: str
    ) -> int: 
        """
        Obtain a bind number for a given field name.

        Args:
            _name: field name

        Returns:
            Bind field id staring form 0 or -1 if not found.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorEnumerator.BindField_String
        """
        pass

    def GetCurrent(
      self
    ) -> TGIS_Shape: 
        """
        Get current enumerator value.

        Returns:
            Shape itself or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorEnumerator.GetCurrent_void
        """
        pass

    def GetField(
      self,
      _field: int
    ) -> Variant: 
        """
        Get field value for a shape given by unique identity.

        Args:
            _field: field bind number

        Returns:
            Field value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorEnumerator.GetField_Integer
        """
        pass

    def MoveNext(
      self
    ) -> bool: 
        """
        Move to next record

        Returns:
            If false then there is no more shapes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorEnumerator.MoveNext_void
        """
        pass

    def Reset(
      self
    ) -> None: 
        """
        Reset enumerator.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorEnumerator.Reset_void
        """
        pass

    @property
    def Current(
      self
    ) -> TGIS_Shape: 
        """
        Current enumerator value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorEnumerator.Current
        """
        pass

    @property
    def Cursor(
      self
    ) -> int: 
        """
        Current cursor index.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorEnumerator.Cursor
        """
        pass

class TGIS_LayerVectorEnumeratorFactory:
    """
    Factory class for TGIS_LayerVectorEnumerator.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorEnumeratorFactory
    """

    def __iter__(
      self
    ) -> TGIS_LayerVectorEnumerator:
        pass

    def __next__(
      self
    ) -> TGIS_Shape:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorEnumeratorFactory.Create_void
        """
        pass

    def GetEnumerator(
      self
    ) -> TGIS_LayerVectorEnumerator: 
        """
        Get constructed enumerator.

        Returns:
            Enumerator object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorEnumeratorFactory.GetEnumerator_void
        """
        pass

    def SetUp(
      self,
      _lv: TGIS_LayerVector,
      _extent: TGIS_Extent,
      _query: str,
      _shape: TGIS_Shape,
      _de9im: str,
      _skipDeleted: bool
    ) -> None: 
        """
        Prepare enumerator.

        Args:
            _lv: vector layer handle
            _extent: extent of items to be found; expected _extent units are in a Layer coordinate 
              space
            _query: query which must be matched by item; closely mimics SQL WHERE clause; for 
              examples you can use ''AGE &gt;= 18''; empty (default) means that no items will match.
            _shape: if not nil, then only shapes matched _de9im matrix with _shape will be found
            _de9im: DE-9IM matrix of comparison
            _skipDeleted: set a skip deleted treatment

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorEnumeratorFactory.SetUp_TGIS_LayerVector_TGIS_Extent_String_TGIS_Shape_String_Boolean
        """
        pass

class TGIS_SelectedShapeList( TObject ):
    """
    List of all shapes.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SelectedShapeList
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SelectedShapeList.Create_void
        """
        pass

    def Add(
      self,
      _key: TGIS_Uid
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _key: UID of a shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SelectedShapeList.Add_TGIS_Uid
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SelectedShapeList.Clear_void
        """
        pass

    def ContainsKey(
      self,
      _key: TGIS_Uid
    ) -> bool: 
        """
        Test if UID is already in dictionary.

        Args:
            _key: UID of a shape

        Returns:
            True if item already exists.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SelectedShapeList.ContainsKey_TGIS_Uid
        """
        pass

    def Remove(
      self,
      _key: TGIS_Uid
    ) -> None: 
        """
        Remove an item from the dictionary.

        Args:
            _key: UID of an item to be removed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SelectedShapeList.Remove_TGIS_Uid
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SelectedShapeList.Count
        """
        pass

    
    def Items(
      self,
      _index: int
    ) -> TGIS_Uid: 
        """
        Uid of shape.

        Args:
            _index: position in the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SelectedShapeList.Items
        """
        pass

class TGIS_LayerVectorMergeHelper( TGIS_LayerVector ):
    """
    Helper for merging the data into an existing layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorMergeHelper
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorMergeHelper.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector,
      _threshold: int
    ) -> None: 
        """
        Constructor.

        Args:
            _layer: existing layer handle
            _threshold: number of shapes that will be saved upon commit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorMergeHelper.Create_TGIS_LayerVector_Integer
        """
        pass

    def Commit(
      self
    ) -> None: 
        """
        Commit data to a destination layer. The data write occurs if number of shapes is 
        greater than used threshold.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorMergeHelper.Commit_void
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_LayerVector: 
        """
        attached layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorMergeHelper.Layer
        """
        pass

    @property
    def Threshold(
      self
    ) -> int: 
        """
        number of shapes that will be saved upon commit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorMergeHelper.Threshold
        """
        pass

class TGIS_LayerVectorDirectWriteHelper:
    """
    Helper for direct writing into a layer storage.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorDirectWriteHelper
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Constructor.

        Args:
            _layer: existing layer handle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorDirectWriteHelper.Create_TGIS_LayerVector
        """
        pass

    def AddShape(
      self,
      _shape: TGIS_Shape
    ) -> None: 
        """
        Adds a new shape to a storage.

        Args:
            _shape: shape to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorDirectWriteHelper.AddShape_TGIS_Shape
        """
        pass

    def Build(
      self,
      _path: str,
      _extent: TGIS_Extent,
      _type: TGIS_ShapeType,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Builds new layer - prepares storage for direct writing.

        Args:
            _path: full path of layer to be built; a connection string for SQL base shapes;
            _extent: starting extent of layer - can''t be zero sized
            _type: shape type supported by a layer
            _dim: dimension; for default layer dimension use TGIS_DimensionType.Unknown

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorDirectWriteHelper.Build_String_TGIS_Extent_TGIS_ShapeType_TGIS_DimensionType
        """
        pass

    def Close(
      self
    ) -> None: 
        """
        Finalizes direct writing into a layer storage.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorDirectWriteHelper.Close_void
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_LayerVector: 
        """
        Attached layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorDirectWriteHelper.Layer
        """
        pass

class TGIS_DynamicAggregatorAbstract( TObject ):
    """
    Base class for TGIS_LayerVector.DynamicAggregator implementation. Purpose of this 
    class is to dynamically add and hide shapes upon drawing process. Sample use is dynamic 
    binning or clustering.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a processor instance.

        Args:
            _layer: layer on which processor is constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.Create_TGIS_LayerVector
        """
        pass

    @overload
    def AddShape(
      self,
      _shape: TGIS_Shape,
      _attr: TObject
    ) -> None: 
        """
        Adds a new shape to be drawn

        Args:
            _shape: shape to be added be drawn
            _attr: optional shape attribute object to associate with _shape.TagPointer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.AddShape_TGIS_Shape_TObject
        """
        pass

    @overload
    def AddShape(
      self,
      _shape: TGIS_Shape,
      _value: Variant,
      _uids: TGIS_UidArray
    ) -> None: 
        """
        Adds a new shape to be drawn

        Args:
            _shape: shape to be added be drawn
            _value: aggregated value like number of aggregated shapes etc.
            _uids: list of shapes uid which shape aggregates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.AddShape_TGIS_Shape_Variant_TGIS_UidArray
        """
        pass

    def Copy(
      self,
      _layer: TGIS_LayerVector
    ) -> TGIS_DynamicAggregatorAbstract: 
        """
        Creates a copy of the dynamic aggregator.

        Args:
            _layer: layer to be associated with aggregator instance; if nil, Self.Layer will 
              be used

        Returns:
            A copy of the dynamic aggregator.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.Copy_TGIS_LayerVector
        """
        pass

    def HideShape(
      self,
      _uid: TGIS_Uid
    ) -> None: 
        """
        Hide a shape against being drawn.

        Args:
            _uid: UID of shape to be hidden

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.HideShape_TGIS_Uid
        """
        pass

    def Prepare(
      self,
      _extent: TGIS_Extent,
      _query: str
    ) -> None: 
        """
        Prepares dynamic shapes. Implementation of this method should call HideShape() and 
        AddShape() methods.

        Args:
            _extent: extent for which layer should be looped
            _query: optional filter (e.g. scope value)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.Prepare_TGIS_Extent_String
        """
        pass

    def SetUp(
      self
    ) -> None: 
        """
        Perform internal aggregator setup. Called upon assigning object to the DynamicAggregator 
        property.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.SetUp_void
        """
        pass

    @property
    def Caption(
      self
    ) -> str: 
        """
        User friendly name (translated).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.Caption
        """
        pass

    @property
    def IsPreparing(
      self
    ) -> bool: 
        """
        True if aggregator is executing Prepare().

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.IsPreparing
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_LayerVector: 
        """
        Layer on which the processor is constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.Layer
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Unique aggregator name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.Name
        """
        pass

    @property
    def Radius(
      self
    ) -> int: 
        """
        A radius within which shapes will be aggregated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.Radius
        """
        pass

    @Radius.setter
    def Radius(
      self,
      _value: int
    ) -> None: 
        """
        A radius within which shapes will be aggregated.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.Radius
        """
        pass

    @property
    def RadiusAsText(
      self
    ) -> str: 
        """
        A radius within which shapes will be aggregated expressed in human readable form, 
        like ''10pt'', ''3in''.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.RadiusAsText
        """
        pass

    @RadiusAsText.setter
    def RadiusAsText(
      self,
      _value: str
    ) -> None: 
        """
        A radius within which shapes will be aggregated expressed in human readable form, 
        like ''10pt'', ''3in''.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.RadiusAsText
        """
        pass

    @property
    def Threshold(
      self
    ) -> int: 
        """
        Minimum number of shapes to form an aggregator.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.Threshold
        """
        pass

    @Threshold.setter
    def Threshold(
      self,
      _value: int
    ) -> None: 
        """
        Minimum number of shapes to form an aggregator.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorAbstract.Threshold
        """
        pass

class TGIS_DynamicAggregatorValue:
    """
    Aggregated value to be stored in shape TagPointer property.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorValue
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorValue.Create_void
        """
        pass

    @property
    def Uids(
      self
    ) -> TGIS_UidArray: 
        """
        List of shapes uid which shape aggregates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorValue.Uids
        """
        pass

    @Uids.setter
    def Uids(
      self,
      _value: TGIS_UidArray
    ) -> None: 
        """
        List of shapes uid which shape aggregates.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorValue.Uids
        """
        pass

    @property
    def Value(
      self
    ) -> Variant: 
        """
        Aggregated value like number of aggregated shapes etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorValue.Value
        """
        pass

    @Value.setter
    def Value(
      self,
      _value: Variant
    ) -> None: 
        """
        Aggregated value like number of aggregated shapes etc.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorValue.Value
        """
        pass

class TGIS_DynamicAggregatorFactory:
    """
    Factory to manage registration and initialization of aggregators.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorFactory
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorFactory.Create_void
        """
        pass

    def CreateInstance(
      self,
      _name: str,
      _layer: TGIS_LayerVector
    ) -> TGIS_DynamicAggregatorAbstract: 
        """
        Create an instance of aggregator.

        Args:
            _name: unique aggregator name
            _layer: layer to be associated with aggregator instance

        Returns:
            Newly created instance or nil, if name not found

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorFactory.CreateInstance_String_TGIS_LayerVector
        """
        pass

    @property
    def Names(
      self
    ) -> TGIS_StringList: 
        """
        List off all names of registered aggregators.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DynamicAggregatorFactory.Names
        """
        pass

class TGIS_Shape( TGIS_ShapeAbstract ):
    """
    Generic shape class. This class keeps all functionality of a shape.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a shape instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _dim: Dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Create_TGIS_DimensionType
        """
        pass

    @overload
    def __init__(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _source: If not nil then base shape will be based on this shape. Otherwise _prt, 
              _mapped, _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: Id _ptr from mapped file or from memory.
            _uid: Unique identity for shape.
            _layer: Reference to the layer on which shape will be created.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Create_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector
        """
        pass

    @overload
    def __init__(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _source: If not nil then base shape will be based on this shape. Otherwise _prt, 
              _mapped, _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: Id _ptr from mapped file or from memory.
            _uid: Unique identity for shape.
            _layer: Reference to the layer on which shape will be created.
            _dim: Dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Create_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector_TGIS_DimensionType
        """
        pass

    def AddPart(
      self
    ) -> None: 
        """
        Add next part to the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.AddPart_void
        """
        pass

    def AddPoint(
      self,
      _ptg: TGIS_Point
    ) -> None: 
        """
        Add a point to the last part of the shape.

        Args:
            _ptg: point to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.AddPoint_TGIS_Point
        """
        pass

    def AddPoint3D(
      self,
      _ptg: TGIS_Point3D
    ) -> None: 
        """
        Add a point to the last part of the shape in 3D.

        Args:
            _ptg: point to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.AddPoint3D_TGIS_Point3D
        """
        pass

    @overload
    def AddPointBearing(
      self,
      _bearing: float,
      _distance: float
    ) -> bool: 
        """
        Add a point to the last part of the shape.

        Args:
            _bearing: bearing in radians
            _distance: distance in map units

        Returns:
            True, then function succeed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.AddPointBearing_Double_Double
        """
        pass

    @overload
    def AddPointBearing(
      self,
      _bearing: float,
      _distance: float,
      _compass: bool
    ) -> bool: 
        """
        Add a point to the last part of the shape.

        Args:
            _bearing: bearing in radians
            _distance: distance in map units
            _compass: if True, then bearing is North oriented

        Returns:
            True, then function succeed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.AddPointBearing_Double_Double_Boolean
        """
        pass

    def AddToIndex(
      self
    ) -> None: 
        """
        Add shape to the RTree index (if the index exists).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.AddToIndex_void
        """
        pass

    def AddToLayer(
      self
    ) -> TGIS_Shape: 
        """
        Add a copy of the shape to a layer using new UID.

        Returns:
            Pointer to the editable version of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.AddToLayer_void
        """
        pass

    def AppendGeometry(
      self,
      _shape: TGIS_Shape
    ) -> None: 
        """
        Append geometry.

        Args:
            _shape: shape with geometry to append

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.AppendGeometry_TGIS_Shape
        """
        pass

    def Area(
      self
    ) -> float: 
        """
        Calculate the area of a shape.

        Returns:
            Area in map units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Area_void
        """
        pass

    def AreaCS(
      self
    ) -> float: 
        """
        Calculate the area of a shape.

        Returns:
            Area in meters (or -1 if map units if CS is not defined).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.AreaCS_void
        """
        pass

    def AsArc(
      self
    ) -> TGIS_ShapeArc: 
        """
        Return current shape as a TGIS_ShapeArc.

        Returns:
            Newly created shape object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.AsArc_void
        """
        pass

    def AsMultiPoint(
      self
    ) -> TGIS_ShapeMultiPoint: 
        """
        Return current shape as a TGIS_ShapeMultiPoint.

        Returns:
            Newly created shape object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.AsMultiPoint_void
        """
        pass

    def AsPoint(
      self
    ) -> TGIS_ShapePoint: 
        """
        Return current shape as a TGIS_ShapePoint.

        Returns:
            Newly created shape object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.AsPoint_void
        """
        pass

    def AsPolygon(
      self
    ) -> TGIS_ShapePolygon: 
        """
        Return current shape as a TGIS_ShapePolygon

        Returns:
            Newly created shape object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.AsPolygon_void
        """
        pass

    def Assign(
      self,
      _source: TGIS_Shape
    ) -> None: 
        """
        Assign values from a given shape.

        Args:
            _source: Given shape. Must be same shape as current object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Assign_TGIS_Shape
        """
        pass

    def Centroid(
      self
    ) -> TGIS_Point: 
        """
        Calculate the central point of a shape.

        Returns:
            Point location.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Centroid_void
        """
        pass

    def ChangeWinding(
      self,
      _part: int
    ) -> None: 
        """
        Change winding of a shape part.

        Args:
            _part: part index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ChangeWinding_Integer
        """
        pass

    @overload
    def Combine(
      self,
      _shape: TGIS_Shape,
      _operation: TGIS_TopologyCombineType
    ) -> TGIS_Shape: 
        """
        Compute a new shape from self and shape provided, based on a given operation.

        Args:
            _shape: shape to combine with
            _operation: operation code; what kind of operation should be perform between (current 
              shape) and (_shape)

        Returns:
            Newly created shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Combine_TGIS_Shape_TGIS_TopologyCombineType
        """
        pass

    @overload
    def Combine(
      self,
      _shape: TGIS_Shape,
      _operation: TGIS_TopologyCombineType,
      _returnnewobj: bool
    ) -> TGIS_Shape: 
        """
        Compute a new shape from self and shape provided, based on a given operation.

        Args:
            _shape: shape to combine with
            _operation: operation code; what kind of operation should be perform between (current 
              shape) and (_shape)
            _returnnewobj: if True, then result will be returned in a newly created object; if 
              False, then self object will be returned

        Returns:
            If _returnnewobj=True, then returns newly created shape. Otherwise returns modified 
            or unmodified self object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Combine_TGIS_Shape_TGIS_TopologyCombineType_Boolean
        """
        pass

    def Contains(
      self,
      _shape: TGIS_Shape
    ) -> bool: 
        """
        Tests contains relationship for given shape

        Args:
            _shape: given shape

        Returns:
            True if relation is true.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Contains_TGIS_Shape
        """
        pass

    def CopyFields(
      self,
      _shape: TGIS_Shape
    ) -> None: 
        """
        Copy fields structure.

        Args:
            _shape: shape with fields to copy

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.CopyFields_TGIS_Shape
        """
        pass

    def CopyGeometry(
      self,
      _shape: TGIS_Shape
    ) -> None: 
        """
        Copy geometry.

        Args:
            _shape: shape with geometry to copy

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.CopyGeometry_TGIS_Shape
        """
        pass

    def CreateCopy(
      self
    ) -> TGIS_Shape: 
        """
        Create a copy of the current shape.

        Returns:
            Newly created copy of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.CreateCopy_void
        """
        pass

    def CreateCopyCS(
      self,
      _cs: TGIS_CSCoordinateSystem
    ) -> TGIS_Shape: 
        """
        Create a copy of the current shape reprojected form the layer coordinate system into 
        a provided coordinate system. If shape is not a member of the layer, then simply 
        a shape copy will be returned.

        Args:
            _cs: desired coordinate system to be converted to

        Returns:
            A a reprojected shape (new copy).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.CreateCopyCS_TGIS_CSCoordinateSystem
        """
        pass

    def CreateFromEWKB(
      self,
      _ewkb: OleVariant
    ) -> TGIS_Shape: 
        """
        Create the Shape geometry into an Extended Well-Known Binary (EWKB) representation 
        of the geometry with SRID meta data. (see www.postgis.org).

        Args:
            _ewkb: EWKB array

        Returns:
            Newly constructed object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.CreateFromEWKB_OleVariant
        """
        pass

    def CreateFromEWKT(
      self,
      _ewkt: str
    ) -> TGIS_Shape: 
        """
        Create the shape geometry from an Extended Well-Known Text (EWKT) representation 
        of the geometry with SRID meta data. (see www.postgis.org).

        Args:
            _ewkt: EWKT text

        Returns:
            Newly created shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.CreateFromEWKT_String
        """
        pass

    def CreateFromGDO(
      self,
      _gdo: OleVariant
    ) -> TGIS_Shape: 
        """
        Create the shape from GeoMedia Database Object (GDO).

        Args:
            _gdo: GDO array

        Returns:
            Newly created shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.CreateFromGDO_OleVariant
        """
        pass

    def CreateFromGML(
      self,
      _gml: str
    ) -> TGIS_Shape: 
        """
        Create the shape from GML.

        Args:
            _gml: GML text

        Returns:
            Newly created shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.CreateFromGML_String
        """
        pass

    def CreateFromJSON(
      self,
      _json: str
    ) -> TGIS_Shape: 
        """
        Create the shape from JSON.

        Args:
            _json: JSON text

        Returns:
            Newly created shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.CreateFromJSON_String
        """
        pass

    def CreateFromWKB(
      self,
      _wkb: OleVariant
    ) -> TGIS_Shape: 
        """
        Create the shape from Well Known Binary (see: www.opengis.org).

        Args:
            _wkb: WKB array

        Returns:
            Newly constructed object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.CreateFromWKB_OleVariant
        """
        pass

    def CreateFromWKT(
      self,
      _wkt: str
    ) -> TGIS_Shape: 
        """
        Create the shape from a Well Known Text (see: www.opengis.org).

        Args:
            _wkt: WKT text

        Returns:
            Newly constructed object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.CreateFromWKT_String
        """
        pass

    def Cross(
      self,
      _shape: TGIS_Shape
    ) -> bool: 
        """
        Tests cross relationship for self and given shape

        Args:
            _shape: given shape

        Returns:
            True if relation is true.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Cross_TGIS_Shape
        """
        pass

    def Delete(
      self
    ) -> None: 
        """
        Delete shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Delete_void
        """
        pass

    @overload
    def Difference(
      self,
      _shape: TGIS_Shape
    ) -> TGIS_Shape: 
        """
        Compute a difference with shape provided.

        Args:
            _shape: shape to compute difference with

        Returns:
            Newly created shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Difference_TGIS_Shape
        """
        pass

    @overload
    def Difference(
      self,
      _shape: TGIS_Shape,
      _returnnewobj: bool
    ) -> TGIS_Shape: 
        """
        Compute a difference with shape provided.

        Args:
            _shape: shape to compute difference with
            _returnnewobj: if True, then result will be returned in a newly created object; if 
              False, then self object will be returned

        Returns:
            If _returnnewobj=True, then returns newly created shape. Otherwise returns modified 
            or unmodified self object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Difference_TGIS_Shape_Boolean
        """
        pass

    def Disjoint(
      self,
      _shape: TGIS_Shape
    ) -> bool: 
        """
        Tests disjoint relationship for self and given shape

        Args:
            _shape: given shape

        Returns:
            True if relation is true.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Disjoint_TGIS_Shape
        """
        pass

    def Distance(
      self,
      _ptg: TGIS_Point,
      _prec: float
    ) -> float: 
        """
        Calculate planar distance between a point and the shape.

        Args:
            _ptg: reference point
            _prec: precision /not longer distance than/; point inside the polygon is always not 
              greater then _prec; if _prec less than 0, then being outside/inside polygon means 
              the same;

        Returns:
            Distance between shapes in map units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Distance_TGIS_Point_Double
        """
        pass

    def Distance2Part(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _part: int,
      _proj: VarParameter
    ) -> float: 
        """
        Calculate the linear distance between a point and a part in the current shape..

        Args:
            _ptg: reference point
            _prec: precision /not longer distance than/; point inside polygon is always not greater 
              than _prec; if _prec less then 0 then being outside/inside polygon means the same;
            _part: part number to which the distance will be computed
            _proj: point projected to a nearest element of the shape; the value (in/out) is passed 
              as TGIS_Point in _proj.Value property

        Returns:
            Distance in map units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Distance2Part_TGIS_Point_Double_Integer_TGIS_Point
        """
        pass

    def Distance2PartCS(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _part: int,
      _proj: VarParameter
    ) -> float: 
        """
        Calculate the WGS84 distance between a point and a part in the current shape.

        Args:
            _ptg: reference point
            _prec: precision /not longer distance than/; point inside polygon is always not greater 
              than _prec; if _prec less then 0 then being outside/inside polygon means the same;
            _part: part number to which the distance will be computed
            _proj: point projected to a nearest element of the shape; the value (in/out) is passed 
              as TGIS_Point in _proj.Value property

        Returns:
            Distance in meters (if CS of layers are known).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Distance2PartCS_TGIS_Point_Double_Integer_TGIS_Point
        """
        pass

    @overload
    def Distance2Shape(
      self,
      _shp: TGIS_Shape
    ) -> float: 
        """
        Calculate planar distance between two shapes.

        Args:
            _shp: reference shape

        Returns:
            Distance in map units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Distance2Shape_TGIS_Shape
        """
        pass

    @overload
    def Distance2Shape(
      self,
      _shp: TGIS_Shape,
      _line: VarParameter
    ) -> float: 
        """
        Calculate planar distance between two shapes.

        Args:
            _shp: reference shape
            _line: shortest line between shapes; the value (in/out) is passed as TGIS_Line in 
              _line.Value property

        Returns:
            Distance in map units and shortest line between shapes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Distance2Shape_TGIS_Shape_TGIS_Line
        """
        pass

    def Distance2ShapeCS(
      self,
      _shp: TGIS_Shape
    ) -> float: 
        """
        Calculate WGS84 distance between two shapes.

        Args:
            _shp: reference shape

        Returns:
            Distance in meters (or -1 if map units if CS is not defined).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Distance2ShapeCS_TGIS_Shape
        """
        pass

    def DistanceCS(
      self,
      _ptg: TGIS_Point,
      _prec: float
    ) -> float: 
        """
        Calculate WGS84 distance between a point and the shape.

        Args:
            _ptg: reference point
            _prec: precision /not longer distance than/; point inside the polygon is always not 
              greater then _prec; if _prec less than 0, then being outside/inside polygon means 
              the same;

        Returns:
            Distance between shapes in meters (if CS of layers are known).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.DistanceCS_TGIS_Point_Double
        """
        pass

    @overload
    def Draw(
      self,
      _mode: TGIS_RendererMultipassMode
    ) -> None: 
        """
        Draw shape.

        Args:
            _mode: outline drawing mode; valid only for lines; used to drawing nice line junctions 
              in multipass mode;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Draw_TGIS_RendererMultipassMode
        """
        pass

    @overload
    def Draw(
      self
    ) -> None: 
        """
        Draw shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Draw_void
        """
        pass

    def DrawChart(
      self
    ) -> None: 
        """
        Draw chart immediately.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.DrawChart_void
        """
        pass

    @overload
    def DrawLabel(
      self
    ) -> None: 
        """
        DrawLabel immediately.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.DrawLabel_void
        """
        pass

    @overload
    def DrawLabel(
      self,
      _points: VarParameter
    ) -> None: 
        """
        DrawLabel immediately returning points delimiting label area.

        Args:
            _points: list of points delimiting label area; the value (in/out) is passed as TGIS_DrawBuf 
              in _points.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.DrawLabel_TGIS_DrawBuf
        """
        pass

    def DrawTrackingPoints(
      self
    ) -> None: 
        """
        Draw tracking points of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.DrawTrackingPoints_void
        """
        pass

    def Equality(
      self,
      _shape: TGIS_Shape
    ) -> bool: 
        """
        Tests equality relationship for self and given shape

        Args:
            _shape: given shape

        Returns:
            True if relation is true.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Equality_TGIS_Shape
        """
        pass

    def ExportToEWKB(
      self,
      _ewkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an Extended Well-Known Binary (EWKB) representation 
        of the geometry with SRID meta data. (see www.postgis.org). Spatial referencing identifier 
        SRID can be provided by TGIS_Shape.SetSRID See TGIS_ShapePolygon.ExportToEWKB for 
        example.

        Args:
            _ewkb: exported EWKB array; the value (in/out) is passed as OleVariant in _ewkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ExportToEWKB_OleVariant
        """
        pass

    def ExportToEWKT(
      self
    ) -> str: 
        """
        Export the Shape geometry into an Extended Well-Known Text (EWKT) representation 
        of the geometry with SRID meta data. (see www.postgis.org).

        Returns:
            Exported EWKT text.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ExportToEWKT_void
        """
        pass

    def ExportToGDO(
      self,
      _gdo: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a GeoMedia Database Object (GDO). See TGIS_ShapePolygon.ExportToWKB 
        for example.

        Args:
            _gdo: exported GDO array; the value (in/out) is passed as OleVariant in _gdo.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ExportToGDO_OleVariant
        """
        pass

    def ExportToGML(
      self
    ) -> str: 
        """
        Export the Shape geometry into a GML (see www.opengis.org).

        Returns:
            Exported GML text.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ExportToGML_void
        """
        pass

    def ExportToJSON(
      self
    ) -> str: 
        """
        Export the Shape geometry into a GeoJSON (see www.geojson.org).

        Returns:
            Exported JSON text.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ExportToJSON_void
        """
        pass

    def ExportToVAR(
      self,
      _var: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an internal SHP format.

        Args:
            _var: exported VAR array; the value (in/out) is passed as OleVariant in _var.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ExportToVAR_OleVariant
        """
        pass

    def ExportToWKB(
      self,
      _wkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a Well Known Binary (see www.opengis.org). See TGIS_ShapePolygon.ExportToWKB 
        for example.

        Args:
            _wkb: exported WKB array; the value (in/out) is passed as OleVariant in _wkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ExportToWKB_OleVariant
        """
        pass

    def ExportToWKT(
      self
    ) -> str: 
        """
        Export the Shape geometry into a Well Known Text (see www.opengis.org).

        Returns:
            Exported WKT text.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ExportToWKT_void
        """
        pass

    @overload
    def Flash(
      self
    ) -> None: 
        """
        Flash shape on screen with default parameters (_times equals 4 and _delay equals 
        100).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Flash_void
        """
        pass

    @overload
    def Flash(
      self,
      _times: int,
      _delay: int
    ) -> None: 
        """
        Flash shape on screen. Just another visual effect to sign a shape

        Args:
            _times: the number of times the shape will flash (maximum is 20)
            _delay: delay time in msec. between each color change (maximum is 10000)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Flash_Integer_Integer
        """
        pass

    def GetAngle(
      self,
      _reverse: bool
    ) -> float: 
        """
        Compute angle of first/last element of the shape in radians related to north, east 
        winding.

        Args:
            _reverse: if True, then end will be treated as start

        Returns:
            Angle in radians.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetAngle_Boolean
        """
        pass

    def GetCrossings(
      self,
      _shape: TGIS_Shape
    ) -> TGIS_PointList: 
        """
        Get all crossing points between the current shape and another given shape.

        Args:
            _shape: shape to test with

        Returns:
            List of crossing points or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetCrossings_TGIS_Shape
        """
        pass

    def GetCrossings3D(
      self,
      _shape: TGIS_Shape
    ) -> TGIS_Point3DList: 
        """
        Get all crossing points between the current shape and another given shape.

        Args:
            _shape: shape to test with

        Returns:
            List of crossing points or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetCrossings3D_TGIS_Shape
        """
        pass

    def GetField(
      self,
      _name: str
    ) -> Variant: 
        """
        Retrieving data from associated data table.

        Args:
            _name: field name

        Returns:
            Field value. If field value is Null then function will return default value. GetFieldEx 
            will return raw value instead.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetField_String
        """
        pass

    @overload
    def GetFieldEx(
      self,
      _name: str
    ) -> Variant: 
        """
        Retrieving data from associated data table.

        Args:
            _name: field name

        Returns:
            Field value. If field value is Null then function will return Null default value. 
            GetField will return a default value instead.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetFieldEx_String
        """
        pass

    @overload
    def GetFieldEx(
      self,
      _name: str,
      _cursor: int
    ) -> Variant: 
        """
        Retrieving data from associated data table.

        Args:
            _name: field name
            _cursor: cursor index

        Returns:
            Field value. If field value is Null then function will return Null default value. 
            GetField will return a default value instead.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetFieldEx_String_Integer
        """
        pass

    @overload
    def GetFieldEx(
      self,
      _name: str,
      _rule: bool
    ) -> Variant: 
        """
        Retrieving data from associated data table.

        Args:
            _name: field name
            _rule: True if filed rule should be expanded (like alias matching)

        Returns:
            Field value. If field value is Null then function will return Null default value. 
            GetField will return a default value instead.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetFieldEx_String_Boolean
        """
        pass

    @overload
    def GetFieldEx(
      self,
      _name: str,
      _cursor: int,
      _rule: bool
    ) -> Variant: 
        """
        Retrieving data from associated data table.

        Args:
            _name: field name
            _cursor: cursor index
            _rule: True if filed rule should be expanded (like alias matching)

        Returns:
            Field value. If field value is Null then function will return Null default value. 
            GetField will return a default value instead.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetFieldEx_String_Integer_Boolean
        """
        pass

    def GetFirstPoint(
      self
    ) -> TGIS_Point: 
        """
        Retrieve the first point from the first segment of geometry.

        Returns:
            First point in a geometry.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetFirstPoint_void
        """
        pass

    def GetFirstPoint3D(
      self
    ) -> TGIS_Point3D: 
        """
        Retrieve the first point from the first segment of geometry in 3D.

        Returns:
            First point in a geometry.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetFirstPoint3D_void
        """
        pass

    @overload
    def GetIntersection(
      self,
      _extent: TGIS_Extent,
      _draft: bool
    ) -> TGIS_Shape: 
        """
        Cut the shape in a defined extent.

        Args:
            _extent: extent to be cut with
            _draft: if true, then operation will be perform much faster; resulting shape may 
              be topologically improper; used mainly for internal drawing purposes

        Returns:
            Normalized shape (a new copy).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetIntersection_TGIS_Extent_Boolean
        """
        pass

    @overload
    def GetIntersection(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_Shape: 
        """
        Cut the shape in a defined extent.

        Args:
            _extent: extent to be cut with

        Returns:
            Normalized shape (a new copy).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetIntersection_TGIS_Extent
        """
        pass

    def GetLabel(
      self
    ) -> str: 
        """
        Return label content (including expanded field values) etc. Label can contain HTML 
        markup. To obtain label value without any formatting markers use GetLabelPlain.

        Returns:
            Text with possible formatting etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetLabel_void
        """
        pass

    def GetLabelPlain(
      self,
      _all_lines: bool
    ) -> str: 
        """
        Return label content (including expanded field values) etc. Label will be cleared 
        from any HTML markup etc. To obtain label value with formatting markers use GetLabel.

        Args:
            _all_lines: if false, then only first line from multi line label will be returned

        Returns:
            Cleared text.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetLabelPlain_Boolean
        """
        pass

    def GetLastPoint(
      self
    ) -> TGIS_Point: 
        """
        Retrieve the last point from the last segment of geometry.

        Returns:
            Last point in a geometry.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetLastPoint_void
        """
        pass

    def GetLastPoint3D(
      self
    ) -> TGIS_Point3D: 
        """
        Retrieve the last point from the last segment of geometry in 3D.

        Returns:
            Last point in a geometry.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetLastPoint3D_void
        """
        pass

    def GetNumParts(
      self
    ) -> int: 
        """
        Retrieve the number of parts in a geometry.

        Returns:
            Number of parts in a geometry.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetNumParts_void
        """
        pass

    def GetNumPoints(
      self
    ) -> int: 
        """
        Retrieve a count of the points in a geometry.

        Returns:
            Number of points in a geometry.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetNumPoints_void
        """
        pass

    def GetPartSize(
      self,
      _part: int
    ) -> int: 
        """
        Calculates the count of points in a given part

        Args:
            _part: part number

        Returns:
            Number of points in a part.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetPartSize_Integer
        """
        pass

    def GetPartType(
      self,
      _part: int
    ) -> TGIS_PartType: 
        """
        Get the type of a part.

        Args:
            _part: part number

        Returns:
            Type of the part.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetPartType_Integer
        """
        pass

    def GetPoint(
      self,
      _part: int,
      _pos: int
    ) -> TGIS_Point: 
        """
        Retrieve a point from a point segment of geometry.

        Args:
            _part: part number
            _pos: point number

        Returns:
            Point from shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetPoint_Integer_Integer
        """
        pass

    def GetPoint3D(
      self,
      _part: int,
      _pos: int
    ) -> TGIS_Point3D: 
        """
        Retrieve a point from a point segment of geometry in 3D.

        Args:
            _part: part number
            _pos: point number

        Returns:
            Point from shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetPoint3D_Integer_Integer
        """
        pass

    def GetPoint3DEx(
      self,
      _part: int,
      _pos: int,
      _x: VarParameter,
      _y: VarParameter,
      _z: VarParameter,
      _m: VarParameter
    ) -> None: 
        """
        Retrieve a point coordinates from a shape segment.

        Args:
            _part: part number
            _pos: point number
            _x: x coordinate; the value (in/out) is passed as float in _x.Value property
            _y: y coordinate; the value (in/out) is passed as float in _y.Value property
            _z: z coordinate; the value (in/out) is passed as float in _z.Value property
            _m: m coordinate; the value (in/out) is passed as float in _m.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetPoint3DEx_Integer_Integer_Double_Double_Double_Double
        """
        pass

    def GetPointEx(
      self,
      _part: int,
      _pos: int,
      _x: VarParameter,
      _y: VarParameter
    ) -> None: 
        """
        Retrieve a point coordinates from a shape segment.

        Args:
            _part: part number
            _pos: point number
            _x: x coordinate; the value (in/out) is passed as float in _x.Value property
            _y: y coordinate; the value (in/out) is passed as float in _y.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetPointEx_Integer_Integer_Double_Double
        """
        pass

    def GetSnapPoint(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _dist: VarParameter
    ) -> TGIS_Point: 
        """
        Retrieving a snap point.

        Args:
            _ptg: point for which we are seeking a snap point ;
            _prec: snapping precision; only points closer to _ptg then _prec can be found ;
            _dist: achieved precision; the value (in/out) is passed as float in _dist.Value property

        Returns:
            Found snap point. If such point cannot be localized then same as _ptg.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetSnapPoint_TGIS_Point_Double_Double
        """
        pass

    def GetSnapPoint3D(
      self,
      _ptg: TGIS_Point3D,
      _prec: float,
      _dist: VarParameter
    ) -> TGIS_Point3D: 
        """
        Retrieving a snap point in 3D.

        Args:
            _ptg: point for which we are seeking a snap point ;
            _prec: snapping precision; only points closer to _ptg then _prec can be found ;
            _dist: achieved precision; the value (in/out) is passed as float in _dist.Value property

        Returns:
            Found snap point. If such point cannot be localized then same as _ptg.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GetSnapPoint3D_TGIS_Point3D_Double_Double
        """
        pass

    def ImportFromEWKB(
      self,
      _ewkb: VarParameter
    ) -> None: 
        """
        Import the Extended Well-Known Binary (EWKB) representation of the geometry with 
        SRID meta data into the current shape (see www.postgis.org).

        Args:
            _ewkb: EWKB array; the value (in/out) is passed as OleVariant in _ewkb.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ImportFromEWKB_OleVariant
        """
        pass

    def ImportFromEWKT(
      self,
      _ewkt: str
    ) -> None: 
        """
        Import the Extended Well-Known Binary (EWKB) representation of the geometry with 
        SRID meta data into the current shape (see www.postgis.org).

        Args:
            _ewkt: EWKT text

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ImportFromEWKT_String
        """
        pass

    def ImportFromGDO(
      self,
      _gdo: VarParameter
    ) -> None: 
        """
        Import the GeoMedia Database Object (GDO) into the current shape.

        Args:
            _gdo: GDO array; the value (in/out) is passed as OleVariant in _gdo.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ImportFromGDO_OleVariant
        """
        pass

    def ImportFromGML(
      self,
      _gml: str
    ) -> None: 
        """
        Import the GML into the current shape.

        Args:
            _gml: GML text

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ImportFromGML_String
        """
        pass

    def ImportFromJSON(
      self,
      _json: str
    ) -> None: 
        """
        Import the JSON into the current shape.

        Args:
            _json: JSON text

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ImportFromJSON_String
        """
        pass

    def ImportFromVAR(
      self,
      _var: VarParameter
    ) -> None: 
        """
        Import the Variant geometry.

        Args:
            _var: imported Variant array; the value (in/out) is passed as OleVariant in _var.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ImportFromVAR_OleVariant
        """
        pass

    def ImportFromWKB(
      self,
      _wkb: VarParameter
    ) -> None: 
        """
        Import the Well Known Binary (see: www.opengis.org) into the current shape.

        Args:
            _wkb: WKB array; the value (in/out) is passed as OleVariant in _wkb.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ImportFromWKB_OleVariant
        """
        pass

    def ImportFromWKT(
      self,
      _wkt: str
    ) -> None: 
        """
        Import the Well Known Text (see www.opengis.org) into the current shape.

        Args:
            _wkt: WKT text

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ImportFromWKT_String
        """
        pass

    def Intersect(
      self,
      _shape: TGIS_Shape
    ) -> bool: 
        """
        Test intersect relationship for self and given shape

        Args:
            _shape: given shape

        Returns:
            True if relation is true.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Intersect_TGIS_Shape
        """
        pass

    @overload
    def Intersection(
      self,
      _shape: TGIS_Shape
    ) -> TGIS_Shape: 
        """
        Compute an intersection with shape provided.

        Args:
            _shape: shape to compute intersection with

        Returns:
            Newly created shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Intersection_TGIS_Shape
        """
        pass

    @overload
    def Intersection(
      self,
      _shape: TGIS_Shape,
      _returnnewobj: bool
    ) -> TGIS_Shape: 
        """
        Compute an intersection with shape provided.

        Args:
            _shape: shape to compute intersection with
            _returnnewobj: if True, then result will be returned in a newly created object; if 
              False, then self object will be returned

        Returns:
            If _returnnewobj=True, then returns newly created shape; otherwise returns modified 
            or unmodified self object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Intersection_TGIS_Shape_Boolean
        """
        pass

    def Invalidate(
      self
    ) -> None: 
        """
        Invalidate the area of a shape; whole cached output will be invalidated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Invalidate_void
        """
        pass

    def IsCommonPoint(
      self,
      _shape: TGIS_Shape
    ) -> bool: 
        """
        Test if the current shape has any common point with another given shape.

        Args:
            _shape: shape to test with

        Returns:
            True if relation is true.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsCommonPoint_TGIS_Shape
        """
        pass

    def IsFieldModified(
      self,
      _field: str
    ) -> bool: 
        """
        Test if shape field was modified.

        Args:
            _field: field name

        Returns:
            True if field has been modified.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsFieldModified_String
        """
        pass

    def IsFieldModifiedEx(
      self,
      _id: int
    ) -> bool: 
        """
        Test if shape field was modified.

        Args:
            _id: field index

        Returns:
            True if field has been modified.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsFieldModifiedEx_Integer
        """
        pass

    def IsInsideCircle(
      self,
      _center: TGIS_Point,
      _range: float,
      _itype: TGIS_InsideType
    ) -> bool: 
        """
        Test if the shape is inside a given circle.

        Args:
            _center: center of circle
            _range: circle range
            _itype: kind of test

        Returns:
            True if relation is true.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsInsideCircle_TGIS_Point_Double_TGIS_InsideType
        """
        pass

    def IsInsideExtent(
      self,
      _extent: TGIS_Extent,
      _itype: TGIS_InsideType
    ) -> bool: 
        """
        Test if the shape is inside a defined extent.

        Args:
            _extent: extent to be tested with
            _itype: kind of test

        Returns:
            True if shape is inside provided extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsInsideExtent_TGIS_Extent_TGIS_InsideType
        """
        pass

    def IsInsidePolygon(
      self,
      _shape: TGIS_ShapePolygon,
      _itype: TGIS_InsideType
    ) -> bool: 
        """
        Test if the shape is inside a given polygon.

        Args:
            _shape: polygon to test with
            _itype: kind of test

        Returns:
            True if relation is true.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsInsidePolygon_TGIS_ShapePolygon_TGIS_InsideType
        """
        pass

    @overload
    def Join(
      self,
      _shape: TGIS_Shape
    ) -> TGIS_Shape: 
        """
        Joins the current shape to another given shape (excluding TGIS_ShapePoint).

        Args:
            _shape: shape to join

        Returns:
            Returns newly created shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Join_TGIS_Shape
        """
        pass

    @overload
    def Join(
      self,
      _shape: TGIS_Shape,
      _returnnewobj: bool
    ) -> TGIS_Shape: 
        """
        Joins the current shape to another given shape (excluding TGIS_ShapePoint).

        Args:
            _shape: shape to join
            _returnnewobj: if True, then result will be returned in a newly created object; if 
              False, then self object will be returned

        Returns:
            If _returnnewobj=True, then returns newly created shape. Otherwise returns modified 
            or unmodified self object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Join_TGIS_Shape_Boolean
        """
        pass

    def Length(
      self
    ) -> float: 
        """
        Calculate the length of a shape.

        Returns:
            Length in map units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Length_void
        """
        pass

    def LengthCS(
      self
    ) -> float: 
        """
        Calculate the length of a shape.

        Returns:
            Length in meters (or -1 if map units if CS is not defined).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.LengthCS_void
        """
        pass

    def Lock(
      self,
      _lock: TGIS_Lock
    ) -> None: 
        """
        Lock a shape.

        Args:
            _lock: TGIS_Lock.None - unlocked; TGIS_Lock.Extent - extent locked; TGIS_Lock.Projection 
              - extent locked and projections turned off

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Lock_TGIS_Lock
        """
        pass

    def MakeEditable(
      self
    ) -> TGIS_Shape: 
        """
        Add the shape to edited items list.

        Returns:
            Pointer to the editable version of the shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.MakeEditable_void
        """
        pass

    def Overlap(
      self,
      _shape: TGIS_Shape
    ) -> bool: 
        """
        Tests overlap relationship for self and given shape

        Args:
            _shape: given shape

        Returns:
            True if relation is true.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Overlap_TGIS_Shape
        """
        pass

    def ParamsAsDrawn(
      self,
      _params: TGIS_ParamsSectionVector
    ) -> None: 
        """
        Get a shape styling parameters used during drawing on a viewer and fill _params parameter 
        with them.

        Args:
            _params: params to be set (must be allocated)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ParamsAsDrawn_TGIS_ParamsSectionVector
        """
        pass

    def PartLength(
      self,
      _part: int
    ) -> float: 
        """
        Calculate the length of a shape part.

        Args:
            _part: number of the part closest to a given point

        Returns:
            Part length in map units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PartLength_Integer
        """
        pass

    def PartLengthCS(
      self,
      _part: int
    ) -> float: 
        """
        Calculate the length of a shape part.

        Args:
            _part: number of the part closest to a given point

        Returns:
            Part length in meters (or -1 if map units if CS is not defined).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PartLengthCS_Integer
        """
        pass

    def PointOnShape(
      self
    ) -> TGIS_Point: 
        """
        Calculate the point which lies on the shape.

        Returns:
            Point location.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PointOnShape_void
        """
        pass

    def PrepareContourInternal(
      self,
      _size: int,
      _outline: bool,
      _pixels: VarParameter,
      _scale: VarParameter,
      _offset: VarParameter
    ) -> None: 
        """
        Prepare contour bitmap (for internal TGIS_Topology purposes).

        Args:
            _size: width and height of bitmap
            _outline: if true then contour for polygons will be drawn with outlines (borders)
            _pixels: newly allocated bitmap; the value (in/out) is passed as TGIS_Pixels in _pixels.Value 
              property
            _scale: shape size in pixels divided by the shape size in map units; the value (in/out) 
              is passed as float in _scale.Value property
            _offset: offset of shape within bitmap caused by map placement, margins etc.; the 
              value (in/out) is passed as TPoint in _offset.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PrepareContourInternal_Integer_Boolean_TGIS_Pixels_Double_TPoint
        """
        pass

    def PrepareExportShape(
      self,
      _cs: TGIS_CSCoordinateSystem,
      _extent: TGIS_Extent,
      _truncate: bool,
      _copyfield: bool
    ) -> TGIS_Shape: 
        """
        Prepare reprojected shape, truncated by extent and copy fields to the result.

        Args:
            _cs: coordinate system
            _extent: extent used to truncate shape (in a same space as _cs)
            _truncate: If True, the result shape will be truncated
            _copyfield: If True, the result shape will copy the source fields

        Returns:
            Shape prepared for export. If shape as not truncated not reprojected then is same 
            as shape itself; otherwise a new object is created.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PrepareExportShape_TGIS_CSCoordinateSystem_TGIS_Extent_Boolean_Boolean
        """
        pass

    @overload
    def Recreate(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Recreate an instance.

        Args:
            _source: If not nil, then the base shape will be based on this shape. Otherwise _ptr, 
              _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: True if pointer is mapped to the file
            _uid: Unique identifier for shape.
            _layer: Reference to the layer on which the shape will be created.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Recreate_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector
        """
        pass

    @overload
    def Recreate(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Recreate an instance.

        Args:
            _source: If not nil, then the base shape will be based on this shape. Otherwise _ptr, 
              _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: True if pointer is mapped to the file
            _uid: Unique identifier for shape.
            _layer: Reference to the layer on which the shape will be created.
            _dim: Dimension.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Recreate_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector_TGIS_DimensionType
        """
        pass

    def Relate(
      self,
      _shape: TGIS_Shape,
      _isectionMatrix: str
    ) -> bool: 
        """
        Checks nine-intersection matrix for self and given shape

        Args:
            _shape: given shape
            _isectionMatrix: intersection matrix

        Returns:
            True if conditions in matrix are true.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Relate_TGIS_Shape_String
        """
        pass

    def Reset(
      self
    ) -> None: 
        """
        Reset shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Reset_void
        """
        pass

    def ResetModified(
      self
    ) -> None: 
        """
        Reset IsModified flag.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ResetModified_void
        """
        pass

    @overload
    def Reverse(
      self
    ) -> TGIS_Shape: 
        """
        Reverse the order of parts.

        Returns:
            Newly created shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Reverse_void
        """
        pass

    @overload
    def Reverse(
      self,
      _returnnewobj: bool
    ) -> TGIS_Shape: 
        """
        Reverse the order of parts.

        Args:
            _returnnewobj: if True, then result will be returned in a newly created object; if 
              False, then self object will be returned

        Returns:
            If _returnnewobj=True, then returns newly created shape. otherwise returns modified 
            or unmodified self object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Reverse_Boolean
        """
        pass

    def RevertParams(
      self
    ) -> None: 
        """
        Revert params to the layer based parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.RevertParams_void
        """
        pass

    def SetField(
      self,
      _name: str,
      _val: Variant
    ) -> None: 
        """
        Set a new value for a field.

        Args:
            _name: field name
            _val: field value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.SetField_String_Variant
        """
        pass

    def SetFieldsDefaulRuleValue(
      self
    ) -> None: 
        """
        Set default values of fields based on field rules.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.SetFieldsDefaulRuleValue_void
        """
        pass

    def SetParamsInternal(
      self,
      _value: TGIS_ParamsSectionVector
    ) -> None: 
        """
        Prepare params.

        Args:
            _value: reference section

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.SetParamsInternal_TGIS_ParamsSectionVector
        """
        pass

    def SetPartType(
      self,
      _part: int,
      _type: TGIS_PartType
    ) -> None: 
        """
        Set the type of a part.

        Args:
            _part: part number
            _type: part type

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.SetPartType_Integer_TGIS_PartType
        """
        pass

    def SetPosition(
      self,
      _ptg: TGIS_Point,
      _layer: TGIS_LayerVector,
      _prec: float
    ) -> None: 
        """
        Move the whole shape.

        Args:
            _ptg: point to which we are moving ;
            _layer: snapping layer; if nil, a shape will not be snapped; just perfect for GPS 
              snap-to-road function
            _prec: snapping precision; only points closer to _ptg than _prec can be found ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.SetPosition_TGIS_Point_TGIS_LayerVector_Double
        """
        pass

    @overload
    def Simplify(
      self,
      _tolerance: float
    ) -> TGIS_Shape: 
        """
        Line generalization routine.

        Args:
            _tolerance: simplification tolerance

        Returns:
            Newly created shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Simplify_Double
        """
        pass

    @overload
    def Simplify(
      self,
      _tolerance: float,
      _returnnewobj: bool
    ) -> TGIS_Shape: 
        """
        Line generalization routine.

        Args:
            _tolerance: simplification tolerance
            _returnnewobj: if True, then result will be returned in a newly created object; if 
              False, then self object will be returned

        Returns:
            If _returnnewobj=True, then returns newly created shape. Otherwise returns modified 
            or unmodified self object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Simplify_Double_Boolean
        """
        pass

    @overload
    def Smooth(
      self,
      _factor: int
    ) -> TGIS_Shape: 
        """
        Smooth shape routine

        Args:
            _factor: smooth factor, number of points iterations - number of output points = number 
              of input point * _factor

        Returns:
            Newly created shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Smooth_Integer
        """
        pass

    @overload
    def Smooth(
      self,
      _factor: int,
      _returnnewobj: bool
    ) -> TGIS_Shape: 
        """
        Smooth shape routine

        Args:
            _factor: smooth factor, number of points iterations - number of output points = number 
              of input point * _factor
            _returnnewobj: if True, then result will be returned in a newly created object; if 
              False, then self object will be returned

        Returns:
            If _returnnewobj=True, then returns newly created shape. Otherwise returns modified 
            or unmodified self object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Smooth_Integer_Boolean
        """
        pass

    def Split(
      self
    ) -> TGIS_ShapeList: 
        """
        Splits a multipart shape into parts.

        Returns:
            Newly created list of parts.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Split_void
        """
        pass

    @overload
    def StrokeArc(
      self,
      _center: TGIS_Point3D,
      _radiusA: float,
      _radiusB: float,
      _start: float,
      _stop: float,
      _rotation: float
    ) -> None: 
        """
        Add to the current shape a series of points forming elliptical arc.

        Args:
            _center: center of arc
            _radiusA: first radius of ellipse
            _radiusB: second radius of ellipse
            _start: angle of a start position; for full ellipse set to 0
            _stop: angle of the end position; for full ellipse set to 2Pi
            _rotation: initial rotation; 0 means position GisPoint( _center.X + _radiusA, _center.Y 
              + 0 )

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.StrokeArc_TGIS_Point3D_Double_Double_Double_Double_Double
        """
        pass

    @overload
    def StrokeArc(
      self,
      _center: TGIS_Point3D,
      _radiusA: float,
      _radiusB: float,
      _start: float,
      _stop: float,
      _rotation: float,
      _segments: int
    ) -> None: 
        """
        Add to the current shape a series of points forming elliptical arc.

        Args:
            _center: center of arc
            _radiusA: first radius of ellipse
            _radiusB: second radius of ellipse
            _start: angle of a start position; for full ellipse set to 0
            _stop: angle of the end position; for full ellipse set to 2Pi
            _rotation: initial rotation; 0 means position GisPoint( _center.X + _radiusA, _center.Y 
              + 0 )
            _segments: maximum number of segments used to create full ellipse

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.StrokeArc_TGIS_Point3D_Double_Double_Double_Double_Double_Integer
        """
        pass

    @overload
    def SymmetricalDifference(
      self,
      _shape: TGIS_Shape
    ) -> TGIS_Shape: 
        """
        Compute a symmetrical difference with shape provided.

        Args:
            _shape: shape to compute symmetrical difference with

        Returns:
            Newly created shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.SymmetricalDifference_TGIS_Shape
        """
        pass

    @overload
    def SymmetricalDifference(
      self,
      _shape: TGIS_Shape,
      _returnnewobj: bool
    ) -> TGIS_Shape: 
        """
        Compute a symmetrical difference with shape provided.

        Args:
            _shape: shape to compute symmetrical difference with
            _returnnewobj: if True, then result will be returned in a newly created object; if 
              False, then self object will be returned

        Returns:
            If _returnnewobj=True, then returns newly created shape. Otherwise returns modified 
            or unmodified self object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.SymmetricalDifference_TGIS_Shape_Boolean
        """
        pass

    def Touch(
      self,
      _shape: TGIS_Shape
    ) -> bool: 
        """
        Tests touch relationship for self and given shape

        Args:
            _shape: given shape

        Returns:
            True if relation is true.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Touch_TGIS_Shape
        """
        pass

    @overload
    def Transform(
      self,
      _origin: TGIS_Point3D,
      _m11: float,
      _m12: float,
      _m13: float,
      _m21: float,
      _m22: float,
      _m23: float,
      _m31: float,
      _m32: float,
      _m33: float,
      _dx: float,
      _dy: float,
      _dz: float
    ) -> TGIS_Shape: 
        """
        Transform shape by provided matrix [_m11.._m33] and translation vector [_dx,_dy,-dz].

        Args:
            _origin: origin point of the transformation
            _m11: element [1,1] of the transformation matrix
            _m12: element [1,2] of the transformation matrix
            _m13: element [1,3] of the transformation matrix
            _m21: element [2,1] of the transformation matrix
            _m22: element [2,2] of the transformation matrix
            _m23: element [2,3] of the transformation matrix
            _m31: element [3,1] of the transformation matrix
            _m32: element [3,2] of the transformation matrix
            _m33: element [3,2] of the transformation matrix
            _dx: x translation element of translation vector
            _dy: y translation element of translation vector
            _dz: z translation element of translation vector

        Returns:
            Newly created transformed shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Transform_TGIS_Point3D_Double_Double_Double_Double_AC1C95414EE429C98C013CFE4BBCCBE4
        """
        pass

    @overload
    def Transform(
      self,
      _origin: TGIS_Point3D,
      _m11: float,
      _m12: float,
      _m13: float,
      _m21: float,
      _m22: float,
      _m23: float,
      _m31: float,
      _m32: float,
      _m33: float,
      _dx: float,
      _dy: float,
      _dz: float,
      _returnnewobj: bool
    ) -> TGIS_Shape: 
        """
        Transform shape by provided matrix [_m11.._m33] and translation vector [_dx,_dy,-dz].

        Args:
            _origin: origin point of the transformation
            _m11: element [1,1] of the transformation matrix
            _m12: element [1,2] of the transformation matrix
            _m13: element [1,3] of the transformation matrix
            _m21: element [2,1] of the transformation matrix
            _m22: element [2,2] of the transformation matrix
            _m23: element [2,3] of the transformation matrix
            _m31: element [3,1] of the transformation matrix
            _m32: element [3,2] of the transformation matrix
            _m33: element [3,2] of the transformation matrix
            _dx: x translation element of translation vector
            _dy: y translation element of translation vector
            _dz: z translation element of translation vector
            _returnnewobj: if True, then result will be returned in a newly created object; if 
              False, then self object will be returned

        Returns:
            If _returnnewobj=True, then returns newly created shape. Otherwise returns modified 
            or unmodified self object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Transform_TGIS_Point3D_Double_Double_Double_Double_2ABC090BB5B9D185A8B3471AC5CF0414
        """
        pass

    @overload
    def Union(
      self,
      _shape: TGIS_Shape
    ) -> TGIS_Shape: 
        """
        Compute an union with shape provided.

        Args:
            _shape: shape to compute union with

        Returns:
            Newly created shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Union_TGIS_Shape
        """
        pass

    @overload
    def Union(
      self,
      _shape: TGIS_Shape,
      _returnnewobj: bool
    ) -> TGIS_Shape: 
        """
        Compute an union with shape provided.

        Args:
            _shape: shape to compute union with
            _returnnewobj: if True, then result will be returned in a newly created object; if 
              False, then self object will be returned

        Returns:
            If _returnnewobj=True, then returns newly created shape; otherwise returns modified 
            or unmodified self object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Union_TGIS_Shape_Boolean
        """
        pass

    def Unlock(
      self
    ) -> None: 
        """
        Unlock a shape from burst-mode operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Unlock_void
        """
        pass

    def UpdateIndex(
      self
    ) -> None: 
        """
        Update shape to the RTree index (if the index exists).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.UpdateIndex_void
        """
        pass

    def UpdatePoint(
      self,
      _part: int,
      _pos: int,
      _ptg: TGIS_Point
    ) -> None: 
        """
        Update point value.

        Args:
            _part: part number
            _pos: point number
            _ptg: point to be set; in layer units

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.UpdatePoint_Integer_Integer_TGIS_Point
        """
        pass

    def UpdatePoint3D(
      self,
      _part: int,
      _pos: int,
      _ptg: TGIS_Point3D
    ) -> None: 
        """
        Update point value in 3D.

        Args:
            _part: part number
            _pos: point number
            _ptg: point to be set; in layer units

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.UpdatePoint3D_Integer_Integer_TGIS_Point3D
        """
        pass

    def Within(
      self,
      _shape: TGIS_Shape
    ) -> bool: 
        """
        Tests within relationship for self and given shape

        Args:
            _shape: given shape

        Returns:
            True if relation is true.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Within_TGIS_Shape
        """
        pass

    @property
    def Dimension(
      self
    ) -> TGIS_DimensionType: 
        """
        Shape dimension.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Dimension
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Extent: 
        """
        Get extent for current shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Extent
        """
        pass

    @property
    def Extent3D(
      self
    ) -> TGIS_Extent3D: 
        """
        Get extent 3D for current shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Extent3D
        """
        pass

    @property
    def FieldChanged(
      self
    ) -> bool: 
        """
        True if a shape field has changed. Valid only for editable shapes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.FieldChanged
        """
        pass

    @property
    def GeometryChanged(
      self
    ) -> bool: 
        """
        True if the shape geometry has changed. Valid only for editable shapes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GeometryChanged
        """
        pass

    @property
    def GeometrySize(
      self
    ) -> int: 
        """
        Size of geometry (number of bytes occupied by all parts &amp; points).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.GeometrySize
        """
        pass

    @property
    def IsDeleted(
      self
    ) -> bool: 
        """
        True if the Shape needs to be deleted. Deleted shape will still exist until the next 
        save, but will not be displayed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsDeleted
        """
        pass

    @IsDeleted.setter
    def IsDeleted(
      self,
      _value: bool
    ) -> None: 
        """
        True if the Shape needs to be deleted. Deleted shape will still exist until the next 
        save, but will not be displayed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsDeleted
        """
        pass

    @property
    def IsEditable(
      self
    ) -> bool: 
        """
        Is shape editable.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsEditable
        """
        pass

    @property
    def IsEmpty(
      self
    ) -> bool: 
        """
        Is shape empty.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsEmpty
        """
        pass

    @property
    def IsFixed(
      self
    ) -> bool: 
        """
        True if the Shape has checked and fixed winding.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsFixed
        """
        pass

    @IsFixed.setter
    def IsFixed(
      self,
      _value: bool
    ) -> None: 
        """
        True if the Shape has checked and fixed winding.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsFixed
        """
        pass

    @property
    def IsHidden(
      self
    ) -> bool: 
        """
        Is shape hidden. Treat it as turn On/Off.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsHidden
        """
        pass

    @IsHidden.setter
    def IsHidden(
      self,
      _value: bool
    ) -> None: 
        """
        Is shape hidden. Treat it as turn On/Off.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsHidden
        """
        pass

    @property
    def IsMapped(
      self
    ) -> bool: 
        """
        True if geometry not allocated, but mapped to the file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsMapped
        """
        pass

    @property
    def IsModified(
      self
    ) -> bool: 
        """
        Is shape modified.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsModified
        """
        pass

    @property
    def IsNewShape(
      self
    ) -> bool: 
        """
        Is shape a independent object or is a mirror of disk based shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsNewShape
        """
        pass

    @property
    def IsReverted(
      self
    ) -> bool: 
        """
        True if the Shape needs to be reverted to the version saved in file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsReverted
        """
        pass

    @property
    def IsSelected(
      self
    ) -> bool: 
        """
        Is shape selected.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsSelected
        """
        pass

    @IsSelected.setter
    def IsSelected(
      self,
      _value: bool
    ) -> None: 
        """
        Is shape selected.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.IsSelected
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_LayerVector: 
        """
        Reference to layer. Thanks to this, the shape will know the default colors etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Layer
        """
        pass

    @Layer.setter
    def Layer(
      self,
      _value: TGIS_LayerVector
    ) -> None: 
        """
        Reference to layer. Thanks to this, the shape will know the default colors etc.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Layer
        """
        pass

    @property
    def LocalParams(
      self
    ) -> bool: 
        """
        True if the shape has private parameters. You can allocate/deallocate local params 
        by set this value to True/False.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.LocalParams
        """
        pass

    @LocalParams.setter
    def LocalParams(
      self,
      _value: bool
    ) -> None: 
        """
        True if the shape has private parameters. You can allocate/deallocate local params 
        by set this value to True/False.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.LocalParams
        """
        pass

    @property
    def LockLevel(
      self
    ) -> TGIS_Lock: 
        """
        Mode of locking

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.LockLevel
        """
        pass

    @property
    def ManageRTree(
      self
    ) -> bool: 
        """
        True if the shape rtree index is managed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ManageRTree
        """
        pass

    @property
    def Params(
      self
    ) -> TGIS_ParamsSectionVector: 
        """
        Returns parameters (colors, fills etc) object. If object was not allocated then Layer 
        level parameters will be returned.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Params
        """
        pass

    @Params.setter
    def Params(
      self,
      _value: TGIS_ParamsSectionVector
    ) -> None: 
        """
        Returns parameters (colors, fills etc) object. If object was not allocated then Layer 
        level parameters will be returned.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Params
        """
        pass

    @property
    def ParentShape(
      self
    ) -> TGIS_Shape: 
        """
        Handle to parent shape. Used for complex shapes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ParentShape
        """
        pass

    @ParentShape.setter
    def ParentShape(
      self,
      _value: TGIS_Shape
    ) -> None: 
        """
        Handle to parent shape. Used for complex shapes.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ParentShape
        """
        pass

    @property
    def Parts(
      self
    ) -> Pointer: 
        """
        Internal storage of parts. Closely matches SHP representation for fast mapped file 
        purposes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Parts
        """
        pass

    @property
    def PartsSize(
      self
    ) -> int: 
        """
        Size of parts part of geometry.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PartsSize
        """
        pass

    @property
    def PartTypes(
      self
    ) -> Pointer: 
        """
        Internal storage of part types. Closely matches SHP representation for fast mapped 
        file purposes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PartTypes
        """
        pass

    @property
    def PartTypesSize(
      self
    ) -> int: 
        """
        Size of part types of geometry.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PartTypesSize
        """
        pass

    @property
    def Points(
      self
    ) -> Pointer: 
        """
        Internal storage of points. Closely matches SHP representation for fast mapped file 
        purposes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Points
        """
        pass

    @property
    def PointsM(
      self
    ) -> Pointer: 
        """
        Internal storage of points. Closely matches SHP representation for fast mapped file 
        purposes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PointsM
        """
        pass

    @property
    def PointsMMax(
      self
    ) -> float: 
        """
        Points M max value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PointsMMax
        """
        pass

    @property
    def PointsMMin(
      self
    ) -> float: 
        """
        Points M min value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PointsMMin
        """
        pass

    @property
    def PointsMSize(
      self
    ) -> int: 
        """
        Size of points M part of geometry.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PointsMSize
        """
        pass

    @property
    def PointsSize(
      self
    ) -> int: 
        """
        Size of points part of geometry.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PointsSize
        """
        pass

    @property
    def PointsZ(
      self
    ) -> Pointer: 
        """
        Internal storage of points. Closely matches SHP representation for fast mapped file 
        purposes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PointsZ
        """
        pass

    @property
    def PointsZMax(
      self
    ) -> float: 
        """
        Points Z max value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PointsZMax
        """
        pass

    @property
    def PointsZMin(
      self
    ) -> float: 
        """
        Points Z min value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PointsZMin
        """
        pass

    @property
    def PointsZSize(
      self
    ) -> int: 
        """
        Size of points Z part of geometry.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.PointsZSize
        """
        pass

    @property
    def ProjectedExtent(
      self
    ) -> TGIS_Extent: 
        """
        Get extent for current shape. Projected

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ProjectedExtent
        """
        pass

    @property
    def ShapeType(
      self
    ) -> TGIS_ShapeType: 
        """
        Get type of shape. Can be TGIS_ShapeType.Point, TGIS_ShapeType.MultiPoint etc. Important 
        because there can be more than one shape type in a layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.ShapeType
        """
        pass

    @property
    def SmartSize(
      self
    ) -> int: 
        """
        Get SmartSize of the shape. SmartSize is used to determine if the shape is big enough 
        to be visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.SmartSize
        """
        pass

    @property
    def Tag(
      self
    ) -> NativeInt: 
        """
        Tag has no predefined meaning. The Tag property is provided for the convenience of 
        storing additional integer values or pointer information for special needs in an 
        application.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Tag
        """
        pass

    @Tag.setter
    def Tag(
      self,
      _value: NativeInt
    ) -> None: 
        """
        Tag has no predefined meaning. The Tag property is provided for the convenience of 
        storing additional integer values or pointer information for special needs in an 
        application.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Tag
        """
        pass

    @property
    def TagInternal(
      self
    ) -> NativeInt: 
        """
        TagInternal has no predefined meaning. The TagInternal property is provided for the 
        convenience of storing additional for internal use of TatukGIS. Please do not use 
        this property on your own!.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.TagInternal
        """
        pass

    @TagInternal.setter
    def TagInternal(
      self,
      _value: NativeInt
    ) -> None: 
        """
        TagInternal has no predefined meaning. The TagInternal property is provided for the 
        convenience of storing additional for internal use of TatukGIS. Please do not use 
        this property on your own!.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.TagInternal
        """
        pass

    @property
    def TagPointer(
      self
    ) -> Pointer: 
        """
        TagPointer has no predefined meaning. The TagPointer property is provided for the 
        convenience of storing additional pointer information for special needs in an application.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.TagPointer
        """
        pass

    @TagPointer.setter
    def TagPointer(
      self,
      _value: Pointer
    ) -> None: 
        """
        TagPointer has no predefined meaning. The TagPointer property is provided for the 
        convenience of storing additional pointer information for special needs in an application.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.TagPointer
        """
        pass

    @property
    def Uid(
      self
    ) -> TGIS_Uid: 
        """
        Get unique identifier for current shape. Must be >= 0.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Uid
        """
        pass

    @property
    def Viewer(
      self
    ) -> TGIS_ViewerRef: 
        """
        Reference to the viewer. Thanks to this, the shape will know the visibility area 
        etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Shape.Viewer
        """
        pass

class TGIS_ShapePoint( TGIS_Shape ):
    """
    Encapsulation of single point shapes.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePoint
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a shape instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePoint.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _dim: Dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePoint.Create_TGIS_DimensionType
        """
        pass

    @overload
    def __init__(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _source: If not nil then base shape will be based on this shape. Otherwise _prt, 
              _mapped, _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: Id _ptr from mapped file or from memory.
            _uid: Unique identity for shape.
            _layer: Reference to the layer on which shape will be created.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePoint.Create_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector
        """
        pass

    @overload
    def __init__(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _source: If not nil then base shape will be based on this shape. Otherwise _prt, 
              _mapped, _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: Id _ptr from mapped file or from memory.
            _uid: Unique identity for shape.
            _layer: Reference to the layer on which shape will be created.
            _dim: Dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePoint.Create_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector_TGIS_DimensionType
        """
        pass

class TGIS_ShapeMultiPoint( TGIS_Shape ):
    """
    Encapsulation of multi-point shapes.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPoint
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a shape instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPoint.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _dim: Dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPoint.Create_TGIS_DimensionType
        """
        pass

    @overload
    def __init__(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _source: If not nil then base shape will be based on this shape. Otherwise _prt, 
              _mapped, _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: Id _ptr from mapped file or from memory.
            _uid: Unique identity for shape.
            _layer: Reference to the layer on which shape will be created.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPoint.Create_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector
        """
        pass

    @overload
    def __init__(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _source: If not nil then base shape will be based on this shape. Otherwise _prt, 
              _mapped, _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: Id _ptr from mapped file or from memory.
            _uid: Unique identity for shape.
            _layer: Reference to the layer on which shape will be created.
            _dim: Dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPoint.Create_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector_TGIS_DimensionType
        """
        pass

class TGIS_ShapeArc( TGIS_Shape ):
    """
    Encapsulation of lines.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeArc
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a shape instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeArc.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _dim: Dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeArc.Create_TGIS_DimensionType
        """
        pass

    @overload
    def __init__(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _source: If not nil then base shape will be based on this shape. Otherwise _prt, 
              _mapped, _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: Id _ptr from mapped file or from memory.
            _uid: Unique identity for shape.
            _layer: Reference to the layer on which shape will be created.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeArc.Create_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector
        """
        pass

    @overload
    def __init__(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _source: If not nil then base shape will be based on this shape. Otherwise _prt, 
              _mapped, _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: Id _ptr from mapped file or from memory.
            _uid: Unique identity for shape.
            _layer: Reference to the layer on which shape will be created.
            _dim: Dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeArc.Create_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector_TGIS_DimensionType
        """
        pass

    @overload
    def GetDistanceOnLine(
      self,
      _ptg: TGIS_Point,
      _side: VarParameter,
      _location: VarParameter,
      _distance: VarParameter
    ) -> float: 
        """
        Calculate a distance from the beginning of the line and the position of a the point 
        projected to the line.

        Args:
            _ptg: point to which position will be found
            _side: side of the line on which _ptg has been localized: -1 - left of the line; 
              0 - precisely on the line; 1 - right of the line; 2 - undefined; the value (in/out) 
              is passed as int in _side.Value property
            _location: location of _ptg related to line: -1 - before the start of the line; 0 
              - within the line; 1 - beyond the end of the line; the value (in/out) is passed as 
              int in _location.Value property
            _distance: distance (gap) between the shape and the point; the value (in/out) is 
              passed as float in _distance.Value property

        Returns:
            Perpendicular point location form the beginning on line. .

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeArc.GetDistanceOnLine_TGIS_Point_Integer_Integer_Double
        """
        pass

    @overload
    def GetDistanceOnLine(
      self,
      _ptg: TGIS_Point,
      _side: VarParameter,
      _location: VarParameter,
      _distance: VarParameter,
      _part: int
    ) -> float: 
        """
        Calculate a distance from the beginning of the line and the position of a the point 
        projected to the line.

        Args:
            _ptg: point to which position will be found
            _side: side of the line on which _ptg has been localized: -1 - left of the line; 
              0 - precisely on the line; 1 - right of the line; 2 - undefined; the value (in/out) 
              is passed as int in _side.Value property
            _location: location of _ptg related to line: -1 - before the start of the line; 0 
              - within the line; 1 - beyond the end of the line; the value (in/out) is passed as 
              int in _location.Value property
            _distance: distance (gap) between the shape and the point; the value (in/out) is 
              passed as float in _distance.Value property
            _part: part number on which calculation will be performed; if &lt; 0 then calculations 
              will be done on all parts

        Returns:
            Perpendicular point location form the beginning on line. .

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeArc.GetDistanceOnLine_TGIS_Point_Integer_Integer_Double_Integer
        """
        pass

    @overload
    def GetPointOnLine(
      self,
      _distance: float,
      _offset: float
    ) -> TGIS_Point: 
        """
        Calculate a point located at _distance from the beginning and moved out of line by 
        _offset.

        Args:
            _distance: distance from origin
            _offset: distance (left if negative) from line

        Returns:
            Point location.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeArc.GetPointOnLine_Double_Double
        """
        pass

    @overload
    def GetPointOnLine(
      self,
      _distance: float,
      _offset: float,
      _part: int
    ) -> TGIS_Point: 
        """
        Calculate a point located at _distance from the beginning and moved out of line by 
        _offset.

        Args:
            _distance: distance from origin
            _offset: distance (left if negative) from line
            _part: part number on which calculation will be performed; if &lt; 0 then calculations 
              will be done on all parts

        Returns:
            Point location.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeArc.GetPointOnLine_Double_Double_Integer
        """
        pass

    @overload
    def GetPointOnLine(
      self,
      _distance: float,
      _offset: float,
      _part: int,
      _canExceed: bool
    ) -> TGIS_Point: 
        """
        Calculate a point located at _distance from the beginning and moved out of line by 
        _offset.

        Args:
            _distance: distance from origin
            _offset: distance (left if negative) from line
            _part: part number on which calculation will be performed; if &lt; 0 then calculations 
              will be done on all parts
            _canExceed: if False, then the _distance will be limited to the length of the line; 
              otherwise the _distance will remain unchanged; True is the default option for other 
              overloads

        Returns:
            Point location.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeArc.GetPointOnLine_Double_Double_Integer_Boolean
        """
        pass

    @overload
    def GetSegment(
      self
    ) -> TGIS_ShapeArc: 
        """
        Extract the segment for the line based on _from _to distances.

        Returns:
            Newly created segment which is encompass whole shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeArc.GetSegment_void
        """
        pass

    @overload
    def GetSegment(
      self,
      _from: float,
      _to: float
    ) -> TGIS_ShapeArc: 
        """
        Extract the segment for the line based on _from _to distances.

        Args:
            _from: starting distance from origin
            _to: ending distance from origin

        Returns:
            Newly created segment or nil if segment is empty.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeArc.GetSegment_Double_Double
        """
        pass

    @overload
    def GetSegment(
      self,
      _from: float,
      _to: float,
      _part: int
    ) -> TGIS_ShapeArc: 
        """
        Extract the segment for the line based on _from _to distances.

        Args:
            _from: starting distance from origin
            _to: ending distance from origin
            _part: part number on which calculation will be performed; if &lt; 0 then calculations 
              will be done on all parts

        Returns:
            Newly created segment or nil if segment is empty.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeArc.GetSegment_Double_Double_Integer
        """
        pass

class TGIS_ShapePolygon( TGIS_Shape ):
    """
    Encapsulation of polygon shapes.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePolygon
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a shape instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePolygon.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _dim: Dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePolygon.Create_TGIS_DimensionType
        """
        pass

    @overload
    def __init__(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _source: If not nil then base shape will be based on this shape. Otherwise _prt, 
              _mapped, _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: Id _ptr from mapped file or from memory.
            _uid: Unique identity for shape.
            _layer: Reference to the layer on which shape will be created.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePolygon.Create_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector
        """
        pass

    @overload
    def __init__(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _source: If not nil then base shape will be based on this shape. Otherwise _prt, 
              _mapped, _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: Id _ptr from mapped file or from memory.
            _uid: Unique identity for shape.
            _layer: Reference to the layer on which shape will be created.
            _dim: Dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePolygon.Create_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector_TGIS_DimensionType
        """
        pass

    def BuildFromEdges(
      self,
      _edges: TGIS_ObjectList,
      _tolerance: float
    ) -> None: 
        """
        Builds a polygon from a list of non complex edges.

        Args:
            _edges: list of non complex edges of TGIS_ShapeArc type
            _tolerance: tolerance into which two arcs are close enough to be joined

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePolygon.BuildFromEdges_TGIS_ObjectList_Double
        """
        pass

    def Split(
      self,
      _keep_holes: bool
    ) -> TGIS_ShapeList: 
        """
        Splits a multipart polygon shape into parts.

        Args:
            _keep_holes: if True, polygons with holes are not split; if False, all parts are 
              split

        Returns:
            Newly created list of parts.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePolygon.Split_Boolean
        """
        pass

class TGIS_ShapeComplex( TGIS_Shape ):
    """
    Encapsulation of complex shapes.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeComplex
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a shape instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeComplex.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _dim: Dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeComplex.Create_TGIS_DimensionType
        """
        pass

    @overload
    def __init__(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _source: If not nil then base shape will be based on this shape. Otherwise _prt, 
              _mapped, _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: Id _ptr from mapped file or from memory.
            _uid: Unique identity for shape.
            _layer: Reference to the layer on which shape will be created.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeComplex.Create_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector
        """
        pass

    @overload
    def __init__(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _source: If not nil then base shape will be based on this shape. Otherwise _prt, 
              _mapped, _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: Id _ptr from mapped file or from memory.
            _uid: Unique identity for shape.
            _layer: Reference to the layer on which shape will be created.
            _dim: Dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeComplex.Create_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector_TGIS_DimensionType
        """
        pass

    def AddShape(
      self,
      _shp: TGIS_Shape
    ) -> None: 
        """
        Adds shape to complex list.

        Args:
            _shp: shape to add

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeComplex.AddShape_TGIS_Shape
        """
        pass

    def DeleteShape(
      self,
      _index: int
    ) -> None: 
        """
        Delete shape from complex list.

        Args:
            _index: shape index to delete

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeComplex.DeleteShape_Integer
        """
        pass

    def GetShape(
      self,
      _index: int
    ) -> TGIS_Shape: 
        """
        Gets a shape from complex list.

        Args:
            _index: shape index

        Returns:
            Found shape or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeComplex.GetShape_Integer
        """
        pass

    def Locate(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _visible: bool,
      _dist: VarParameter
    ) -> TGIS_Shape: 
        """
        Locate a shape that is near _pt, but is closer than _prec distance.

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons
            _visible: if true the only visible shapes will be evaluated; shapes turned of by 
              query of hidden will be ignored
            _dist: distance to found shape; the value (in/out) is passed as float in _dist.Value 
              property

        Returns:
            Found shape or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeComplex.Locate_TGIS_Point_Double_Boolean_Double
        """
        pass

    @property
    def ShapesCount(
      self
    ) -> int: 
        """
        Number of shapes in collection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeComplex.ShapesCount
        """
        pass

class TGIS_ShapeMultiPatch( TGIS_ShapePolygon ):
    """
    Encapsulation of MultiPatch shapes.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a shape instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _dim: Dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.Create_TGIS_DimensionType
        """
        pass

    @overload
    def __init__(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _source: If not nil then base shape will be based on this shape. Otherwise _prt, 
              _mapped, _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: Id _ptr from mapped file or from memory.
            _uid: Unique identity for shape.
            _layer: Reference to the layer on which shape will be created.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.Create_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector
        """
        pass

    @overload
    def __init__(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _source: If not nil then base shape will be based on this shape. Otherwise _prt, 
              _mapped, _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: Id _ptr from mapped file or from memory.
            _uid: Unique identity for shape.
            _layer: Reference to the layer on which shape will be created.
            _dim: Dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.Create_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector_TGIS_DimensionType
        """
        pass

    @overload
    def Recreate(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Recreate an instance.

        Args:
            _source: If not nil, then the base shape will be based on this shape. Otherwise _ptr, 
              _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: True if pointer is mapped to the file
            _uid: Unique identifier for shape.
            _layer: Reference to the layer on which the shape will be created.
            _dim: Dimension.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.Recreate_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector_TGIS_DimensionType
        """
        pass

    @overload
    def Recreate(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Recreate an instance.

        Args:
            _source: If not nil, then the base shape will be based on this shape. Otherwise _ptr, 
              _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: True if pointer is mapped to the file
            _uid: Unique identifier for shape.
            _layer: Reference to the layer on which the shape will be created.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.Recreate_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector
        """
        pass

    @property
    def HasMaterials(
      self
    ) -> bool: 
        """
        True is shape has materials.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.HasMaterials
        """
        pass

    @HasMaterials.setter
    def HasMaterials(
      self,
      _value: bool
    ) -> None: 
        """
        True is shape has materials.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.HasMaterials
        """
        pass

    @property
    def HasNormals(
      self
    ) -> bool: 
        """
        True is shape has normals

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.HasNormals
        """
        pass

    @HasNormals.setter
    def HasNormals(
      self,
      _value: bool
    ) -> None: 
        """
        True is shape has normals

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.HasNormals
        """
        pass

    @property
    def HasPartDescriptors(
      self
    ) -> bool: 
        """
        True is shape has parts descriptors

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.HasPartDescriptors
        """
        pass

    @HasPartDescriptors.setter
    def HasPartDescriptors(
      self,
      _value: bool
    ) -> None: 
        """
        True is shape has parts descriptors

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.HasPartDescriptors
        """
        pass

    @property
    def HasTextures(
      self
    ) -> bool: 
        """
        True is shape has textures specification.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.HasTextures
        """
        pass

    @HasTextures.setter
    def HasTextures(
      self,
      _value: bool
    ) -> None: 
        """
        True is shape has textures specification.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.HasTextures
        """
        pass

    @property
    def HasVertexColors(
      self
    ) -> bool: 
        """
        True is shape has normals

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.HasVertexColors
        """
        pass

    @HasVertexColors.setter
    def HasVertexColors(
      self,
      _value: bool
    ) -> None: 
        """
        True is shape has normals

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.HasVertexColors
        """
        pass

    @property
    def Materials(
      self
    ) -> TGIS_Materials: 
        """
        Materials for textures (bitmaps etc).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.Materials
        """
        pass

    @property
    def Normals(
      self
    ) -> TGIS_Normals: 
        """
        Normals for textures (lights related)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.Normals
        """
        pass

    @property
    def PartDescriptors(
      self
    ) -> TGIS_PartDescriptors: 
        """
        Part descriptors (fan, strip, ring etc.).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.PartDescriptors
        """
        pass

    @property
    def Textures(
      self
    ) -> TGIS_Textures: 
        """
        Textures specification for shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.Textures
        """
        pass

    @property
    def VertexColors(
      self
    ) -> TGIS_VertexColors: 
        """
        Vertex colors

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeMultiPatch.VertexColors
        """
        pass

class TGIS_LayerVectorSqlAbstract( TGIS_LayerVector ):
    """
    Class encapsulation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.Create_void
        """
        pass

    def AddToMasterTable(
      self,
      _layerName: str,
      _geometryColumn: str,
      _indexColumn: str,
      _storage: str,
      _geometryType: TGIS_ShapeType,
      _dim: TGIS_DimensionType,
      _srid: int,
      _extent: TGIS_Extent
    ) -> None: 
        """
        Add layer entry to master table.

        Args:
            _layerName: layer name
            _geometryColumn: geometry column name
            _indexColumn: index column name
            _storage: storage type
            _geometryType: geometry type
            _dim: dimension
            _srid: CS id
            _extent: layer extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.AddToMasterTable_String_String_String_String_TGIS_ShapeType_TGIS_DimensionType_Integer_TGIS_Extent
        """
        pass

    def ApplyStyle(
      self,
      _styleData: str
    ) -> None: 
        """
        Apply a style to the layer.

        Args:
            _styleData: style data

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.ApplyStyle_String
        """
        pass

    def CloseActiveDatasets(
      self
    ) -> None: 
        """
        Close all active datasets of a layer. This can help to unlock a database like Sqlite 
        that is being locked after calling a select statement.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.CloseActiveDatasets_void
        """
        pass

    def CloseConnection(
      self
    ) -> None: 
        """
        Close current connection and active queries.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.CloseConnection_void
        """
        pass

    def CreateMasterTable(
      self
    ) -> None: 
        """
        Create master table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.CreateMasterTable_void
        """
        pass

    def CreateProjectTable(
      self
    ) -> None: 
        """
        Create a table with projects.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.CreateProjectTable_void
        """
        pass

    def CreateStyleTable(
      self
    ) -> None: 
        """
        Create a table with layer styles.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.CreateStyleTable_void
        """
        pass

    def DeleteFromMasterTable(
      self
    ) -> None: 
        """
        Delete record from master table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.DeleteFromMasterTable_void
        """
        pass

    def DeleteLayer(
      self
    ) -> None: 
        """
        Delete a layer (tables, metadata) from database.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.DeleteLayer_void
        """
        pass

    def ExecuteSQL(
      self,
      _sql: str
    ) -> bool: 
        """
        Execute custom SQL statement.

        Args:
            _sql: SQL String

        Returns:
            True if succeeded

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.ExecuteSQL_String
        """
        pass

    def GetAvailableProjects(
      self
    ) -> TGIS_StringList: 
        """
        Get available projects from database.

        Returns:
            list of available projects

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.GetAvailableProjects_void
        """
        pass

    def GetAvailableStyles(
      self
    ) -> TGIS_StringList: 
        """
        Get available styles from database.

        Returns:
            list of available styles

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.GetAvailableStyles_void
        """
        pass

    def GetProject(
      self,
      _name: str,
      _tokens: TGIS_StringList
    ) -> TGIS_ConfigAbstract: 
        """
        Read project from database.

        Args:
            _name: project name
            _tokens: list of tokens "token=replacement" to be replaced in project

        Returns:
            Project handle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.GetProject_String_TStringList
        """
        pass

    def OpenConnection(
      self
    ) -> None: 
        """
        Reopen a connection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.OpenConnection_void
        """
        pass

    def ReadMasterTable(
      self,
      _layerName: str,
      _storage: str,
      _geometryColumn: VarParameter,
      _indexColumn: VarParameter,
      _geometryType: VarParameter,
      _dim: VarParameter,
      _srid: VarParameter,
      _extent: VarParameter
    ) -> bool: 
        """
        Read layer entry from master table.

        Args:
            _layerName: layer name
            _storage: storage type
            _geometryColumn: geometry column name; the value (in/out) is passed as str in _geometryColumn.Value 
              property
            _indexColumn: index column name; the value (in/out) is passed as str in _indexColumn.Value 
              property
            _geometryType: geometry type; the value (in/out) is passed as TGIS_ShapeType in _geometryType.Value 
              property
            _dim: dimension; the value (in/out) is passed as int in _dim.Value property
            _srid: CS id; the value (in/out) is passed as int in _srid.Value property
            _extent: layer extent; the value (in/out) is passed as TGIS_Extent in _extent.Value 
              property

        Returns:
            True if succeeded

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.ReadMasterTable_String_String_String_String_TGIS_ShapeType_Integer_Integer_TGIS_Extent
        """
        pass

    def ReadStyle(
      self,
      _name: str
    ) -> str: 
        """
        Read a style.

        Args:
            _name: style name

        Returns:
            style data

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.ReadStyle_String
        """
        pass

    def ResetDataset(
      self
    ) -> None: 
        """
        Reset the layer dataset to ensure the current database context upon next drawing 
        (e.g to notify changes when a record was deleted manually in the table).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.ResetDataset_void
        """
        pass

    def UpdateMasterTable(
      self,
      _layerName: str,
      _geometryType: TGIS_ShapeType,
      _dim: TGIS_DimensionType,
      _srid: int,
      _extent: TGIS_Extent
    ) -> None: 
        """
        Update a layer entry in master table.

        Args:
            _layerName: layer name
            _geometryType: geometry type
            _dim: dimension type
            _srid: CS identifier
            _extent: layer extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.UpdateMasterTable_String_TGIS_ShapeType_TGIS_DimensionType_Integer_TGIS_Extent
        """
        pass

    def WriteProject(
      self,
      _name: str,
      _desc: str,
      _project: str
    ) -> None: 
        """
        Write or update a project to database.

        Args:
            _name: project name
            _desc: project description
            _project: project data

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.WriteProject_String_String_String
        """
        pass

    def WriteStyle(
      self,
      _name: str,
      _desc: str,
      _style: str
    ) -> None: 
        """
        Write or update a style to database.

        Args:
            _name: style name
            _desc: style description
            _style: style data

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.WriteStyle_String_String_String
        """
        pass

    def WriteStyleEx(
      self,
      _name: str,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Write or update a style to database.

        Args:
            _name: style name
            _layer: destination layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.WriteStyleEx_String_TGIS_LayerVector
        """
        pass

    @property
    def ConnectionPoolId(
      self
    ) -> str: 
        """
        Connection pool id. Used to group shared connections per viewer or create new connection 
        when a layer is not attached to the viewer. User can switch to another shared connection 
        by closing current connection, assigning existing pool id and again opening the connection 
        (only if a layer is not attached to the viewer). A layer attached to a viewer always 
        gets the viewer pool id.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.ConnectionPoolId
        """
        pass

    @ConnectionPoolId.setter
    def ConnectionPoolId(
      self,
      _value: str
    ) -> None: 
        """
        Connection pool id. Used to group shared connections per viewer or create new connection 
        when a layer is not attached to the viewer. User can switch to another shared connection 
        by closing current connection, assigning existing pool id and again opening the connection 
        (only if a layer is not attached to the viewer). A layer attached to a viewer always 
        gets the viewer pool id.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.ConnectionPoolId
        """
        pass

    @property
    def MasterTable(
      self
    ) -> str: 
        """
        Name of the master table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.MasterTable
        """
        pass

    @property
    def SQLCommands(
      self
    ) -> TGIS_StringList: 
        """
        SQL Commands used for database operations.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.SQLCommands
        """
        pass

    @property
    def SQLDialectList(
      self
    ) -> TGIS_StringList: 
        """
        Dialect list in a form "token=replacement". Will be changed after each change of 
        SQLDialect property.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.SQLDialectList
        """
        pass

    
    def SQLParameter(
      self,
      _name: str
    ) -> str: 
        """
        Connection parameters.

        Args:
            _name: parameter name

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.SQLParameter
        """
        pass

    
    def SQLParameter(
      self,
      _name: str,
      _value: str
    ) -> None: 
        """
        Connection parameters.

        Args:
            _name: parameter name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.SQLParameter
        """
        pass

    @property
    def SQLParametersEx(
      self
    ) -> TGIS_StringList: 
        """
        List of additional connection parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.SQLParametersEx
        """
        pass

    @property
    def Table(
      self
    ) -> str: 
        """
        Name of the table (general).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.Table
        """
        pass

    @Table.setter
    def Table(
      self,
      _value: str
    ) -> None: 
        """
        Name of the table (general).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.Table
        """
        pass

    @property
    def UseMasterTable(
      self
    ) -> bool: 
        """
        If True, operations on the master table will be performed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.UseMasterTable
        """
        pass

    @property
    def ViewFeatures(
      self
    ) -> str: 
        """
        Name of the features view. If attached name is different then the default, then querying 
        will be done based on provided view. By providing empty String - default table name 
        will be restored. Updates will always be done on standard table.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.ViewFeatures
        """
        pass

    @ViewFeatures.setter
    def ViewFeatures(
      self,
      _value: str
    ) -> None: 
        """
        Name of the features view. If attached name is different then the default, then querying 
        will be done based on provided view. By providing empty String - default table name 
        will be restored. Updates will always be done on standard table.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.ViewFeatures
        """
        pass

    @property
    def AfterDialectChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Will be fired after SQLDialect change. By changing SQLCommandList inside handler 
        for this event you will be able to modify commands dynamically.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.AfterDialectChangeEvent
        """
        pass

    @AfterDialectChangeEvent.setter
    def AfterDialectChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Will be fired after SQLDialect change. By changing SQLCommandList inside handler 
        for this event you will be able to modify commands dynamically.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.AfterDialectChangeEvent
        """
        pass

    @property
    def BeforeDialectChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Will be fired before every SQLDialect change. By changing SQLDialectList inside handler 
        for this event you will be able to modify dialect dynamically.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.BeforeDialectChangeEvent
        """
        pass

    @BeforeDialectChangeEvent.setter
    def BeforeDialectChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Will be fired before every SQLDialect change. By changing SQLDialectList inside handler 
        for this event you will be able to modify dialect dynamically.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.BeforeDialectChangeEvent
        """
        pass

    @property
    def BeforeUidReserveEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Shape], None]: 
        """
        Event to be fired before uid reserve insert.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.BeforeUidReserveEvent
        """
        pass

    @BeforeUidReserveEvent.setter
    def BeforeUidReserveEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Shape], None]
    ) -> None: 
        """
        Event to be fired before uid reserve insert.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.BeforeUidReserveEvent
        """
        pass

    @property
    def SQLExecuteEvent(
      self
    ) -> typing.Callable[[String], None]: 
        """
        Will be fired upon any SQL execution to trace SQL statements.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.SQLExecuteEvent
        """
        pass

    @SQLExecuteEvent.setter
    def SQLExecuteEvent(
      self,
      _value: typing.Callable[[String], None]
    ) -> None: 
        """
        Will be fired upon any SQL execution to trace SQL statements.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorSqlAbstract.SQLExecuteEvent
        """
        pass

class TGIS_LayerVectorUDF( TGIS_LayerVector ):
    """
    Encapsulation of User Defined Vector layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.Create_void
        """
        pass

    @property
    def InMemory(
      self
    ) -> bool: 
        """
        If True, all shapes will be kept in memory, otherwise will disc-based.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.InMemory
        """
        pass

    @InMemory.setter
    def InMemory(
      self,
      _value: bool
    ) -> None: 
        """
        If True, all shapes will be kept in memory, otherwise will disc-based.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.InMemory
        """
        pass

    @property
    def GetLayerExtentEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Extent], None]: 
        """
        GetLayerExtent event. Fired to get layer extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.GetLayerExtentEvent
        """
        pass

    @GetLayerExtentEvent.setter
    def GetLayerExtentEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Extent], None]
    ) -> None: 
        """
        GetLayerExtent event. Fired to get layer extent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.GetLayerExtentEvent
        """
        pass

    @property
    def GetLayerLastShapeUidEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Uid], None]: 
        """
        GetLayerLastShapeUid event. Fired to get last layer shape uid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.GetLayerLastShapeUidEvent
        """
        pass

    @GetLayerLastShapeUidEvent.setter
    def GetLayerLastShapeUidEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Uid], None]
    ) -> None: 
        """
        GetLayerLastShapeUid event. Fired to get last layer shape uid.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.GetLayerLastShapeUidEvent
        """
        pass

    @property
    def GetLayerStructureEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Event fired to get layer structure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.GetLayerStructureEvent
        """
        pass

    @GetLayerStructureEvent.setter
    def GetLayerStructureEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Event fired to get layer structure.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.GetLayerStructureEvent
        """
        pass

    @property
    def GetShapeFieldEvent(
      self
    ) -> typing.Callable[[TObject, String, TGIS_Uid, Integer, Variant], None]: 
        """
        GetShapeField event. Fired to get shape field value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.GetShapeFieldEvent
        """
        pass

    @GetShapeFieldEvent.setter
    def GetShapeFieldEvent(
      self,
      _value: typing.Callable[[TObject, String, TGIS_Uid, Integer, Variant], None]
    ) -> None: 
        """
        GetShapeField event. Fired to get shape field value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.GetShapeFieldEvent
        """
        pass

    @property
    def GetShapeGeometryEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Uid, Boolean, Integer, TGIS_Shape], None]: 
        """
        GetShapeGeometry event. Fired to get layer shape geometry.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.GetShapeGeometryEvent
        """
        pass

    @GetShapeGeometryEvent.setter
    def GetShapeGeometryEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Uid, Boolean, Integer, TGIS_Shape], None]
    ) -> None: 
        """
        GetShapeGeometry event. Fired to get layer shape geometry.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.GetShapeGeometryEvent
        """
        pass

    @property
    def GetShapeObjectEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Uid, Integer, TGIS_Shape], None]: 
        """
        GetShape event. Fired to get layer shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.GetShapeObjectEvent
        """
        pass

    @GetShapeObjectEvent.setter
    def GetShapeObjectEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Uid, Integer, TGIS_Shape], None]
    ) -> None: 
        """
        GetShape event. Fired to get layer shape.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.GetShapeObjectEvent
        """
        pass

    @property
    def LayerEofEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Boolean], None]: 
        """
        LayerEof event. Fired to get layer eof.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.LayerEofEvent
        """
        pass

    @LayerEofEvent.setter
    def LayerEofEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Boolean], None]
    ) -> None: 
        """
        LayerEof event. Fired to get layer eof.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.LayerEofEvent
        """
        pass

    @property
    def LayerMoveFirstEvent(
      self
    ) -> typing.Callable[[TObject, Integer, TGIS_Extent, String, TGIS_Shape, String, Boolean], None]: 
        """
        LayerMoveFirst event. Fired when a layer executes MoveFirst.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.LayerMoveFirstEvent
        """
        pass

    @LayerMoveFirstEvent.setter
    def LayerMoveFirstEvent(
      self,
      _value: typing.Callable[[TObject, Integer, TGIS_Extent, String, TGIS_Shape, String, Boolean], None]
    ) -> None: 
        """
        LayerMoveFirst event. Fired when a layer executes MoveFirst.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.LayerMoveFirstEvent
        """
        pass

    @property
    def LayerMoveNextEvent(
      self
    ) -> typing.Callable[[TObject, Integer], None]: 
        """
        LayerMoveNext event. Fired when layer executes MoveNext.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.LayerMoveNextEvent
        """
        pass

    @LayerMoveNextEvent.setter
    def LayerMoveNextEvent(
      self,
      _value: typing.Callable[[TObject, Integer], None]
    ) -> None: 
        """
        LayerMoveNext event. Fired when layer executes MoveNext.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVectorUDF.LayerMoveNextEvent
        """
        pass

class TGIS_LayerVPF( TGIS_LayerCompoundVector ):
    """
    Layer that can read VPF dataset.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVPF
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVPF.Create_void
        """
        pass

    @property
    def Category(
      self
    ) -> str: 
        """
        Set a library category name to read.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVPF.Category
        """
        pass

    @property
    def Feature(
      self
    ) -> str: 
        """
        Set a category feature name to read.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVPF.Feature
        """
        pass

class TGIS_LayerWCS( TGIS_LayerPixel ):
    """
    Encapsulation of an OpenGIS WCS layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.Create_void
        """
        pass

    @property
    def ForcedCRS(
      self
    ) -> int: 
        """
        EPSG code that will be forced to use with WCS request. If 0 then first supported 
        SRS will be used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.ForcedCRS
        """
        pass

    @ForcedCRS.setter
    def ForcedCRS(
      self,
      _value: int
    ) -> None: 
        """
        EPSG code that will be forced to use with WCS request. If 0 then first supported 
        SRS will be used.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.ForcedCRS
        """
        pass

    @property
    def FoundCoverages(
      self
    ) -> TGIS_StringList: 
        """
        List of all found coverages names.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.FoundCoverages
        """
        pass

    @property
    def FoundCRS(
      self
    ) -> TGIS_StringList: 
        """
        List of all found SRS.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.FoundCRS
        """
        pass

    @property
    def FoundImageFormats(
      self
    ) -> TGIS_StringList: 
        """
        List of all found image formats.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.FoundImageFormats
        """
        pass

    @property
    def IgnoreInternalURI(
      self
    ) -> bool: 
        """
        Ignore internal URI for requests from Capabilities.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.IgnoreInternalURI
        """
        pass

    @IgnoreInternalURI.setter
    def IgnoreInternalURI(
      self,
      _value: bool
    ) -> None: 
        """
        Ignore internal URI for requests from Capabilities.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.IgnoreInternalURI
        """
        pass

    @property
    def LastUrl(
      self
    ) -> str: 
        """
        Last Url fetched by client.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.LastUrl
        """
        pass

    @property
    def PPI(
      self
    ) -> int: 
        """
        Resolution of requested image .

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.PPI
        """
        pass

    @PPI.setter
    def PPI(
      self,
      _value: int
    ) -> None: 
        """
        Resolution of requested image .

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.PPI
        """
        pass

    @property
    def ProxyUrl(
      self
    ) -> str: 
        """
        Proxy URL as for ESRI proxy.ashx.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.ProxyUrl
        """
        pass

    @ProxyUrl.setter
    def ProxyUrl(
      self,
      _value: str
    ) -> None: 
        """
        Proxy URL as for ESRI proxy.ashx.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.ProxyUrl
        """
        pass

    @property
    def ServiceVerion(
      self
    ) -> str: 
        """
        Service version.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.ServiceVerion
        """
        pass

    @property
    def TransmittedBytes(
      self
    ) -> int: 
        """
        Number of transmitted bytes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.TransmittedBytes
        """
        pass

    @property
    def UserAgent(
      self
    ) -> str: 
        """
        User Agent string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.UserAgent
        """
        pass

    @UserAgent.setter
    def UserAgent(
      self,
      _value: str
    ) -> None: 
        """
        User Agent string.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWCS.UserAgent
        """
        pass

class TGIS_LayerWebTiles( TGIS_LayerPixel ):
    """
    Encapsulation of tiled image layer (usually web tiles).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTiles
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTiles.Create_void
        """
        pass

    def CountTiles(
      self,
      _extent: TGIS_Extent,
      _startlevel: int,
      _endlevel: int
    ) -> int: 
        """
        Count all tiles covering provided levels and extent. Useful for estimating FechTiles() 
        cost.

        Args:
            _extent: extent for which tiles will be counted
            _startlevel: starting LOD level
            _endlevel: ending LOD level

        Returns:
            Number of tiles.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTiles.CountTiles_TGIS_Extent_Integer_Integer
        """
        pass

    def FetchTiles(
      self,
      _extent: TGIS_Extent,
      _startlevel: int,
      _endlevel: int
    ) -> int: 
        """
        Fetch number of tiles. Useful when ttkwp file set FileCache=True

        Args:
            _extent: extent for which tiles will be fetched
            _startlevel: starting LOD level
            _endlevel: ending LOD level

        Returns:
            Number of tiles that were not properly fetched.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTiles.FetchTiles_TGIS_Extent_Integer_Integer
        """
        pass

    
    def Lods(
      self,
      _index: int
    ) -> TGIS_LayerWebTileLod: 
        """
        List of LODs (Level of details).

        Args:
            _index: index of the LOD starting form 0

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTiles.Lods
        """
        pass

    @property
    def LodsCount(
      self
    ) -> int: 
        """
        Number of defined LODs (Level of details).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTiles.LodsCount
        """
        pass

    @property
    def ProxyUrl(
      self
    ) -> str: 
        """
        Proxy URL as for ESRI proxy.ashx.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTiles.ProxyUrl
        """
        pass

    @ProxyUrl.setter
    def ProxyUrl(
      self,
      _value: str
    ) -> None: 
        """
        Proxy URL as for ESRI proxy.ashx.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTiles.ProxyUrl
        """
        pass

    @property
    def Referer(
      self
    ) -> str: 
        """
        Referer string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTiles.Referer
        """
        pass

    @Referer.setter
    def Referer(
      self,
      _value: str
    ) -> None: 
        """
        Referer string.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTiles.Referer
        """
        pass

    @property
    def UserAgent(
      self
    ) -> str: 
        """
        User Agent string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTiles.UserAgent
        """
        pass

    @UserAgent.setter
    def UserAgent(
      self,
      _value: str
    ) -> None: 
        """
        User Agent string.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTiles.UserAgent
        """
        pass

    @property
    def OnUrlLog(
      self
    ) -> typing.Callable[[String], None]: 
        """
        Will be fired upon any url execution to trace image downloads.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTiles.OnUrlLog
        """
        pass

    @OnUrlLog.setter
    def OnUrlLog(
      self,
      _value: typing.Callable[[String], None]
    ) -> None: 
        """
        Will be fired upon any url execution to trace image downloads.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTiles.OnUrlLog
        """
        pass

class TGIS_LayerWebTileLod:
    """
    Level of details (LOD) specification.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTileLod
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTileLod.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _id: str,
      _resolution: float,
      _topleft: TGIS_Point,
      _tilesize: TPoint,
      _tilesrange: TRect
    ) -> None: 
        """
        Create an instance of LOD.

        Args:
            _id: level identifier
            _resolution: level resolution (extent divided by pixel width)
            _topleft: top-left origin of a level (coordinates of top-left tile corner)
            _tilesize: tile size of level in pixels
            _tilesrange: first/Last Row/Column of a tile

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTileLod.Create_String_Double_TGIS_Point_TPoint_TRect
        """
        pass

    @property
    def Id(
      self
    ) -> str: 
        """
        Level identifier.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTileLod.Id
        """
        pass

    @property
    def Resolution(
      self
    ) -> float: 
        """
        Level resolution (extent divided by pixel width).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTileLod.Resolution
        """
        pass

    @property
    def TileSize(
      self
    ) -> TPoint: 
        """
        Tile size of level in pixels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTileLod.TileSize
        """
        pass

    @property
    def TilesRange(
      self
    ) -> TRect: 
        """
        First/Last Row/Column of a tile.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTileLod.TilesRange
        """
        pass

    @property
    def TopLeft(
      self
    ) -> TGIS_Point: 
        """
        Top-left origin of a level (coordinates of top-left tile corner).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWebTileLod.TopLeft
        """
        pass

class TGIS_LayerWexBIM( TGIS_LayerVector ):
    """
    Encapsulation of WexBIM file format (IFC for web).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWexBIM
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWexBIM.Create_void
        """
        pass

    @property
    def Draw2D(
      self
    ) -> bool: 
        """
        If true, draw full model in 2D mode, otherwise draw the bounding box only.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWexBIM.Draw2D
        """
        pass

    @Draw2D.setter
    def Draw2D(
      self,
      _value: bool
    ) -> None: 
        """
        If true, draw full model in 2D mode, otherwise draw the bounding box only.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWexBIM.Draw2D
        """
        pass

    @property
    def OffsetExtent(
      self
    ) -> TGIS_Extent3D: 
        """
        Offset extent used to transform a model.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWexBIM.OffsetExtent
        """
        pass

    @OffsetExtent.setter
    def OffsetExtent(
      self,
      _value: TGIS_Extent3D
    ) -> None: 
        """
        Offset extent used to transform a model.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWexBIM.OffsetExtent
        """
        pass

class TGIS_LayerWFS( TGIS_LayerCompoundVector ):
    """
    Encapsulation of an OpenGIS WFS layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWFS
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWFS.Create_void
        """
        pass

    @property
    def FoundLayers(
      self
    ) -> TGIS_StringList: 
        """
        List of all found layers names.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWFS.FoundLayers
        """
        pass

    @property
    def ProxyUrl(
      self
    ) -> str: 
        """
        Proxy URL as for ESRI proxy.ashx.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWFS.ProxyUrl
        """
        pass

    @ProxyUrl.setter
    def ProxyUrl(
      self,
      _value: str
    ) -> None: 
        """
        Proxy URL as for ESRI proxy.ashx.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWFS.ProxyUrl
        """
        pass

    @property
    def UseLayers(
      self
    ) -> TGIS_StringList: 
        """
        List of layers to be used for render. If empty then

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWFS.UseLayers
        """
        pass

    @property
    def UserAgent(
      self
    ) -> str: 
        """
        User Agent string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWFS.UserAgent
        """
        pass

    @UserAgent.setter
    def UserAgent(
      self,
      _value: str
    ) -> None: 
        """
        User Agent string.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWFS.UserAgent
        """
        pass

class TGIS_LayerWMS( TGIS_LayerPixel ):
    """
    Encapsulation of an OpenGIS WMS layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.Create_void
        """
        pass

    def GetFeatureInfo(
      self,
      _point: TGIS_Point
    ) -> str: 
        """
        Get feature info.

        Args:
            _point: coordinate

        Returns:
            info text

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.GetFeatureInfo_TGIS_Point
        """
        pass

    def GetLegendImage(
      self,
      _layer: str
    ) -> TGIS_Bitmap: 
        """
        Get layer legend image.

        Args:
            _layer: layer name

        Returns:
            bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.GetLegendImage_String
        """
        pass

    @property
    def ForcedSRS(
      self
    ) -> int: 
        """
        EPSG code that will be forced to use with wms request. If 0 then first supported 
        SRS will be used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.ForcedSRS
        """
        pass

    @ForcedSRS.setter
    def ForcedSRS(
      self,
      _value: int
    ) -> None: 
        """
        EPSG code that will be forced to use with wms request. If 0 then first supported 
        SRS will be used.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.ForcedSRS
        """
        pass

    @property
    def FoundImageFormats(
      self
    ) -> TGIS_StringList: 
        """
        List of all found image formats.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.FoundImageFormats
        """
        pass

    @property
    def FoundLayers(
      self
    ) -> TGIS_StringList: 
        """
        List of all found layers names.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.FoundLayers
        """
        pass

    @property
    def FoundSRS(
      self
    ) -> TGIS_StringList: 
        """
        List of all found SRS.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.FoundSRS
        """
        pass

    @property
    def IgnoreInternalURI(
      self
    ) -> bool: 
        """
        Ignore internal URI for requests from Capabilities.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.IgnoreInternalURI
        """
        pass

    @IgnoreInternalURI.setter
    def IgnoreInternalURI(
      self,
      _value: bool
    ) -> None: 
        """
        Ignore internal URI for requests from Capabilities.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.IgnoreInternalURI
        """
        pass

    @property
    def LastUrl(
      self
    ) -> str: 
        """
        Last Url fetched by client.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.LastUrl
        """
        pass

    @property
    def PPI(
      self
    ) -> int: 
        """
        Resolution of requested image .

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.PPI
        """
        pass

    @PPI.setter
    def PPI(
      self,
      _value: int
    ) -> None: 
        """
        Resolution of requested image .

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.PPI
        """
        pass

    @property
    def ProxyUrl(
      self
    ) -> str: 
        """
        Proxy URL as for ESRI proxy.ashx.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.ProxyUrl
        """
        pass

    @ProxyUrl.setter
    def ProxyUrl(
      self,
      _value: str
    ) -> None: 
        """
        Proxy URL as for ESRI proxy.ashx.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.ProxyUrl
        """
        pass

    @property
    def ServiceVerion(
      self
    ) -> str: 
        """
        Service version.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.ServiceVerion
        """
        pass

    @property
    def TransmittedBytes(
      self
    ) -> int: 
        """
        Number of transmitted bytes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.TransmittedBytes
        """
        pass

    @property
    def UseLayers(
      self
    ) -> TGIS_StringList: 
        """
        List of layers to be used for render. If empty then default.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.UseLayers
        """
        pass

    @property
    def UserAgent(
      self
    ) -> str: 
        """
        User Agent string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.UserAgent
        """
        pass

    @UserAgent.setter
    def UserAgent(
      self,
      _value: str
    ) -> None: 
        """
        User Agent string.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMS.UserAgent
        """
        pass

class TGIS_LayerWMTS( TGIS_LayerWebTiles ):
    """
    Encapsulation of an OpenGIS WMTS layer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMTS
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a layer with default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMTS.Create_void
        """
        pass

    def GetFeatureInfo(
      self,
      _point: TGIS_Point
    ) -> str: 
        """
        Get feature info.

        Args:
            _point: coordinate

        Returns:
            info text

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerWMTS.GetFeatureInfo_TGIS_Point
        """
        pass

class TGIS_LayerXYZ( TGIS_LayerVector ):
    """
    Layer which can read a XYZ or ASC text file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerXYZ
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerXYZ.Create_void
        """
        pass

class TGIS_ControlLegendOption:
    pass

class TGIS_ControlLegendOption:
    """
    Options for TGIS_Legend.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendOption
    """

    @property
    def AllowMove(
      self
    ) -> TGIS_ControlLegendOption: 
        """
        Allows reordering of layers/groups .

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendOption.AllowMove
        """
        pass

    @property
    def AllowActive(
      self
    ) -> TGIS_ControlLegendOption: 
        """
        Allows changing of layer/group Active property (with check box).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendOption.AllowActive
        """
        pass

    @property
    def AllowExpand(
      self
    ) -> TGIS_ControlLegendOption: 
        """
        Allows expanding/collapsing of layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendOption.AllowExpand
        """
        pass

    @property
    def AllowParams(
      self
    ) -> TGIS_ControlLegendOption: 
        """
        Allows changing of layer parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendOption.AllowParams
        """
        pass

    @property
    def AllowSelect(
      self
    ) -> TGIS_ControlLegendOption: 
        """
        Allows selection of layers/groups.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendOption.AllowSelect
        """
        pass

    @property
    def ShowHiddenLayers(
      self
    ) -> TGIS_ControlLegendOption: 
        """
        Makes the legend display hidden layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendOption.ShowHiddenLayers
        """
        pass

    @property
    def ShowLayerFullPath(
      self
    ) -> TGIS_ControlLegendOption: 
        """
        Makes the legend display layer path instead of caption/name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendOption.ShowLayerFullPath
        """
        pass

    @property
    def ShowSubLayers(
      self
    ) -> TGIS_ControlLegendOption: 
        """
        Makes the legend display sublayers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendOption.ShowSubLayers
        """
        pass

    @property
    def AllowParamsVisible(
      self
    ) -> TGIS_ControlLegendOption: 
        """
        Allows changing of parameter sections Visible property (with check box).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendOption.AllowParamsVisible
        """
        pass

class TGIS_ControlLegendMode:
    pass

class TGIS_ControlLegendMode:
    """
    Modes for TGIS_Legend.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendMode
    """

    @property
    def Layers(
      self
    ) -> TGIS_ControlLegendMode: 
        """
        Mode in which the legend displays layers in the drawing order.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendMode.Layers
        """
        pass

    @property
    def Groups(
      self
    ) -> TGIS_ControlLegendMode: 
        """
        Mode in which the legend displays grouped layers as a tree view.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendMode.Groups
        """
        pass

class TGIS_ControlLegendDialogOptions( TPersistent ):
    """
    Dialog options.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendDialogOptions
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendDialogOptions.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _uniqueLimit: int,
      _uniqueSearchLimit: int
    ) -> None: 
        """
        Constructor.

        Args:
            _uniqueLimit: maximum number of unique values.
            _uniqueSearchLimit: maximum number of records searched for unique values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendDialogOptions.Create_Integer_Integer
        """
        pass

    @property
    def VectorWizardUniqueLimit(
      self
    ) -> int: 
        """
        Vector Wizard maximum number of unique values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendDialogOptions.VectorWizardUniqueLimit
        """
        pass

    @VectorWizardUniqueLimit.setter
    def VectorWizardUniqueLimit(
      self,
      _value: int
    ) -> None: 
        """
        Vector Wizard maximum number of unique values.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendDialogOptions.VectorWizardUniqueLimit
        """
        pass

    @property
    def VectorWizardUniqueSearchLimit(
      self
    ) -> int: 
        """
        Vector Wizard maximum number of records searched for unique values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendDialogOptions.VectorWizardUniqueSearchLimit
        """
        pass

    @VectorWizardUniqueSearchLimit.setter
    def VectorWizardUniqueSearchLimit(
      self,
      _value: int
    ) -> None: 
        """
        Vector Wizard maximum number of records searched for unique values.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegendDialogOptions.VectorWizardUniqueSearchLimit
        """
        pass

class TGIS_TreeList( TObject ):
    """
    List of the legend nodes (TGIS_TreeNode).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.Create_void
        """
        pass

    def Add(
      self,
      _node: TGIS_TreeNode
    ) -> None: 
        """
        Add a new node to the list.

        Args:
            _node: node to add

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.Add_TGIS_TreeNode
        """
        pass

    def AddChild(
      self,
      _node: TGIS_TreeNode,
      _name: str
    ) -> TGIS_TreeNode: 
        """
        Add a child node to the node.

        Args:
            _node: if assigned then a child new node of the _node is created if not assigned 
              then a new node is added to the list
            _name: text of the node

        Returns:
            added node

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.AddChild_TGIS_TreeNode_String
        """
        pass

    def AppendChild(
      self,
      _node: TGIS_TreeNode
    ) -> None: 
        """
        Append a node to the list.

        Args:
            _node: node to append

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.AppendChild_TGIS_TreeNode
        """
        pass

    def BeginUpdate(
      self
    ) -> None: 
        """
        Begin an update of the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.BeginUpdate_void
        """
        pass

    def Delete(
      self,
      _idx: int
    ) -> None: 
        """
        Delete a node from the list at a given position.

        Args:
            _idx: position to delete

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.Delete_Integer
        """
        pass

    def EndUpdate(
      self
    ) -> None: 
        """
        End an update of the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.EndUpdate_void
        """
        pass

    def IndexOf(
      self,
      _node: TGIS_TreeNode
    ) -> int: 
        """
        Return the index of a given node.

        Args:
            _node: node to find

        Returns:
            node index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.IndexOf_TGIS_TreeNode
        """
        pass

    def Insert(
      self,
      _idx: int,
      _node: TGIS_TreeNode
    ) -> None: 
        """
        Insert a new node in the list at a given position.

        Args:
            _idx: position to insert
            _node: node to insert

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.Insert_Integer_TGIS_TreeNode
        """
        pass

    def InsertChild(
      self,
      _idx: int,
      _node: TGIS_TreeNode
    ) -> None: 
        """
        Insert a node into the list.

        Args:
            _idx: location on the list where the node is inserted
            _node: node to insert

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.InsertChild_Integer_TGIS_TreeNode
        """
        pass

    def Move(
      self,
      _src: int,
      _dst: int
    ) -> None: 
        """
        Move a node from one position to another.

        Args:
            _src: source position
            _dst: destination position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.Move_Integer_Integer
        """
        pass

    def Remove(
      self,
      _node: TGIS_TreeNode
    ) -> None: 
        """
        Search the node in the list and delete it from the list.

        Args:
            _node: node to delete

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.Remove_TGIS_TreeNode
        """
        pass

    @property
    def ChangeSelected(
      self
    ) -> TGIS_TreeNode: 
        """
        Change selected node in multi select mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.ChangeSelected
        """
        pass

    @ChangeSelected.setter
    def ChangeSelected(
      self,
      _value: TGIS_TreeNode
    ) -> None: 
        """
        Change selected node in multi select mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.ChangeSelected
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Current number of nodes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.Count
        """
        pass

    
    def Items(
      self,
      _idx: int
    ) -> TGIS_TreeNode: 
        """
        List of nodes.

        Args:
            _idx: index of a node

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.Items
        """
        pass

    @property
    def Selected(
      self
    ) -> TGIS_TreeNode: 
        """
        Selected node in single select mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.Selected
        """
        pass

    @Selected.setter
    def Selected(
      self,
      _value: TGIS_TreeNode
    ) -> None: 
        """
        Selected node in single select mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.Selected
        """
        pass

    @property
    def SelectedEx(
      self
    ) -> TGIS_TreeNode: 
        """
        Selected node in multi select mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.SelectedEx
        """
        pass

    @SelectedEx.setter
    def SelectedEx(
      self,
      _value: TGIS_TreeNode
    ) -> None: 
        """
        Selected node in multi select mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeList.SelectedEx
        """
        pass

class TGIS_TreeNode( TObject ):
    """
    Node of the legend tree.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor, creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Create_void
        """
        pass

    def AddNode(
      self
    ) -> TGIS_TreeNode: 
        """
        Add a child node.

        Returns:
            added node

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.AddNode_void
        """
        pass

    def AppendNode(
      self,
      _node: TGIS_TreeNode,
      _pos: int
    ) -> None: 
        """
        Append the child node to the list.

        Args:
            _node: node to append
            _pos: location on the list where the node is inserted if -1 then the node is added 
              at the end of the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.AppendNode_TGIS_TreeNode_Integer
        """
        pass

    def Expand(
      self,
      _deep: bool
    ) -> None: 
        """
        Expand the node.

        Args:
            _deep: if true then all child nodes are expanded

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Expand_Boolean
        """
        pass

    def FindSelected(
      self
    ) -> TGIS_TreeNode: 
        """
        Find selected node from the list.

        Returns:
            selected node

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.FindSelected_void
        """
        pass

    def GetNextSibling(
      self
    ) -> TGIS_TreeNode: 
        """
        Return next sibling.

        Returns:
            sibling node

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.GetNextSibling_void
        """
        pass

    def GetPrevSibling(
      self
    ) -> TGIS_TreeNode: 
        """
        Return previous sibling.

        Returns:
            sibling node

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.GetPrevSibling_void
        """
        pass

    def Remove(
      self,
      _node: TGIS_TreeNode
    ) -> None: 
        """
        Remove the node from the list.

        Args:
            _node: node to remove

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Remove_TGIS_TreeNode
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Count of the nodes in the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Count
        """
        pass

    @property
    def Data(
      self
    ) -> TGIS_LegendItemData: 
        """
        Data connected to the node.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Data
        """
        pass

    @Data.setter
    def Data(
      self,
      _value: TGIS_LegendItemData
    ) -> None: 
        """
        Data connected to the node.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Data
        """
        pass

    @property
    def Expanded(
      self
    ) -> bool: 
        """
        Expanded or not.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Expanded
        """
        pass

    @Expanded.setter
    def Expanded(
      self,
      _value: bool
    ) -> None: 
        """
        Expanded or not.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Expanded
        """
        pass

    @property
    def Index(
      self
    ) -> int: 
        """
        Position of the node.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Index
        """
        pass

    
    def Items(
      self,
      _idx: int
    ) -> TGIS_TreeNode: 
        """
        List of the nodes.

        Args:
            _idx: index of a node

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Items
        """
        pass

    
    def Items(
      self,
      _idx: int,
      _value: TGIS_TreeNode
    ) -> None: 
        """
        List of the nodes.

        Args:
            _idx: index of a node

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Items
        """
        pass

    @property
    def Level(
      self
    ) -> int: 
        """
        Level in the tree of the nodes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Level
        """
        pass

    @property
    def Parent(
      self
    ) -> TGIS_TreeNode: 
        """
        Parent of the node.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Parent
        """
        pass

    @property
    def Selected(
      self
    ) -> bool: 
        """
        Selected node.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Selected
        """
        pass

    @Selected.setter
    def Selected(
      self,
      _value: bool
    ) -> None: 
        """
        Selected node.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Selected
        """
        pass

    @property
    def Text(
      self
    ) -> str: 
        """
        Text of the node.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Text
        """
        pass

    @Text.setter
    def Text(
      self,
      _value: str
    ) -> None: 
        """
        Text of the node.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TreeNode.Text
        """
        pass

class TGIS_LegendItemType:
    pass

class TGIS_LegendItemType:
    """
    FOR INTERNAL USE ONLY. Actual type of the legend item represented by TGIS_LegendItemData.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemType
    """

    @property
    def Empty(
      self
    ) -> TGIS_LegendItemType: 
        """
        Empty legend item (placeholder).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemType.Empty
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_LegendItemType: 
        """
        Legend item which represents a layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemType.Layer
        """
        pass

    @property
    def Group(
      self
    ) -> TGIS_LegendItemType: 
        """
        Legend item which represents a group.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemType.Group
        """
        pass

    @property
    def Params(
      self
    ) -> TGIS_LegendItemType: 
        """
        legend item which represents layer parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemType.Params
        """
        pass

class TGIS_LegendIconType:
    pass

class TGIS_LegendIconType:
    """
    The type of feature for which TGIS_LegendIconFactory prepares the icon.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconType
    """

    @property
    def Marker(
      self
    ) -> TGIS_LegendIconType: 
        """
        Icon which represents a point (marker).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconType.Marker
        """
        pass

    @property
    def Line(
      self
    ) -> TGIS_LegendIconType: 
        """
        Icon which represents a line (arc).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconType.Line
        """
        pass

    @property
    def Area(
      self
    ) -> TGIS_LegendIconType: 
        """
        Icon which represents a polygon (area).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconType.Area
        """
        pass

    @property
    def Label(
      self
    ) -> TGIS_LegendIconType: 
        """
        Icon which represents a label.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconType.Label
        """
        pass

    @property
    def Chart(
      self
    ) -> TGIS_LegendIconType: 
        """
        Icon which represents a chart.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconType.Chart
        """
        pass

class TGIS_LegendViewer:
    """
    FOR INTERNAL USE ONLY. Platform independent TGIS_ViewerBmp encapsulation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewer
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewer.Create_void
        """
        pass

    def Add(
      self,
      _layer: TGIS_Layer
    ) -> None: 
        """
        Adds a layer to the underlying TGIS_ViewerBmp.

        Args:
            _layer: the layer to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewer.Add_TGIS_Layer
        """
        pass

    def Draw(
      self
    ) -> None: 
        """
        Forces redraw on the underlying TGIS_ViewerBmp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewer.Draw_void
        """
        pass

    def PixelsToTwips(
      self,
      _size: int
    ) -> int: 
        """
        Converts pixels to twips.

        Args:
            _size: the value to be converted

        Returns:
            size in twips

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewer.PixelsToTwips_Integer
        """
        pass

    def TwipsToPixels(
      self,
      _size: int
    ) -> int: 
        """
        Converts twips to pixels.

        Args:
            _size: the value to be converted

        Returns:
            size in pixels

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewer.TwipsToPixels_Integer
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        The color of the underlying TGIS_ViewerBmp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewer.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        The color of the underlying TGIS_ViewerBmp.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewer.Color
        """
        pass

    @property
    def CustomPPI(
      self
    ) -> int: 
        """
        The PPI (pixels-per-inch) of the underlying TGIS_ViewerBmp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewer.CustomPPI
        """
        pass

    @CustomPPI.setter
    def CustomPPI(
      self,
      _value: int
    ) -> None: 
        """
        The PPI (pixels-per-inch) of the underlying TGIS_ViewerBmp.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewer.CustomPPI
        """
        pass

    @property
    def NativeBitmap(
      self
    ) -> TObject: 
        """
        The platform native bitmap of the underlying TGIS_ViewerBmp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewer.NativeBitmap
        """
        pass

    @property
    def Renderer(
      self
    ) -> TGIS_RendererAbstract: 
        """
        The renderer of the underlying TGIS_ViewerBmp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewer.Renderer
        """
        pass

    @Renderer.setter
    def Renderer(
      self,
      _value: TGIS_RendererAbstract
    ) -> None: 
        """
        The renderer of the underlying TGIS_ViewerBmp.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewer.Renderer
        """
        pass

    @property
    def VisibleExtent(
      self
    ) -> TGIS_Extent: 
        """
        The visible extent of the underlying TGIS_ViewerBmp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewer.VisibleExtent
        """
        pass

    @VisibleExtent.setter
    def VisibleExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        The visible extent of the underlying TGIS_ViewerBmp.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewer.VisibleExtent
        """
        pass

class TGIS_LegendViewerFactory:
    """
    FOR INTERNAL USE ONLY. Platform independent TGIS_LegendViewer creation utility.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewerFactory
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewerFactory.Create_void
        """
        pass

    def CreateLegendViewer(
      self,
      _width: int,
      _height: int
    ) -> TGIS_LegendViewer: 
        """
        Creates an instance of TGIS_LegendViewer.

        Args:
            _width: width of the viewer
            _height: height of the viewer

        Returns:
            handle to a newly created viewer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendViewerFactory.CreateLegendViewer_Integer_Integer
        """
        pass

class TGIS_LegendItemData:
    """
    FOR INTERNAL USE ONLY. Container for all the information necessary to construct a 
    legend item.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance that is to be associated with an empty (placeholder) legend item.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.Create_void
        """
        pass

    @property
    def IsMoving(
      self
    ) -> bool: 
        """
        Flag used to indicate that the legend item is being dragged.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.IsMoving
        """
        pass

    @IsMoving.setter
    def IsMoving(
      self,
      _value: bool
    ) -> None: 
        """
        Flag used to indicate that the legend item is being dragged.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.IsMoving
        """
        pass

    @property
    def NodeHeight(
      self
    ) -> int: 
        """
        Used to store the total height of the associated legend item (including subitems).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.NodeHeight
        """
        pass

    @NodeHeight.setter
    def NodeHeight(
      self,
      _value: int
    ) -> None: 
        """
        Used to store the total height of the associated legend item (including subitems).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.NodeHeight
        """
        pass

    @property
    def NodeLeft(
      self
    ) -> int: 
        """
        Used to store the left coordinate of the rectangle of the associated legend item 
        (including subitems).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.NodeLeft
        """
        pass

    @NodeLeft.setter
    def NodeLeft(
      self,
      _value: int
    ) -> None: 
        """
        Used to store the left coordinate of the rectangle of the associated legend item 
        (including subitems).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.NodeLeft
        """
        pass

    @property
    def NodeTop(
      self
    ) -> int: 
        """
        Used to store the top coordinate of the rectangle of the associated legend item (including 
        subitems).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.NodeTop
        """
        pass

    @NodeTop.setter
    def NodeTop(
      self,
      _value: int
    ) -> None: 
        """
        Used to store the top coordinate of the rectangle of the associated legend item (including 
        subitems).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.NodeTop
        """
        pass

    @property
    def NodeWidth(
      self
    ) -> int: 
        """
        Used to store the width of the rectangle of the associated legend item (including 
        subitems).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.NodeWidth
        """
        pass

    @NodeWidth.setter
    def NodeWidth(
      self,
      _value: int
    ) -> None: 
        """
        Used to store the width of the rectangle of the associated legend item (including 
        subitems).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.NodeWidth
        """
        pass

    @property
    def Caption(
      self
    ) -> str: 
        """
        Caption of data object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.Caption
        """
        pass

    @property
    def ChartLegend(
      self
    ) -> TGIS_ListOfStrings: 
        """
        List of chart legend labels which matches the ChartMap.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.ChartLegend
        """
        pass

    @property
    def ChartMap(
      self
    ) -> str: 
        """
        Simple map that indicates which chart colors are used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.ChartMap
        """
        pass

    @property
    def Checked(
      self
    ) -> bool: 
        """
        True if the associated legend item is checked/active.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.Checked
        """
        pass

    @Checked.setter
    def Checked(
      self,
      _value: bool
    ) -> None: 
        """
        True if the associated legend item is checked/active.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.Checked
        """
        pass

    @property
    def DataType(
      self
    ) -> TGIS_LegendItemType: 
        """
        Type of the associated object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.DataType
        """
        pass

    @property
    def FeatureCount(
      self
    ) -> int: 
        """
        Total number of different features contained within the legend item.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.FeatureCount
        """
        pass

    @property
    def Group(
      self
    ) -> TGIS_HierarchyGroup: 
        """
        Handle to the group object, valid if DataType = Group.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.Group
        """
        pass

    @property
    def IsSubLayer(
      self
    ) -> bool: 
        """
        True if the layer is a sublayer of another layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.IsSubLayer
        """
        pass

    @property
    def IsVector(
      self
    ) -> bool: 
        """
        True if the layer/parameter section is of vector type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.IsVector
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_Layer: 
        """
        Handle to the layer object, valid if DataType = Layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.Layer
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Name of data object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.Name
        """
        pass

    @property
    def Params(
      self
    ) -> TGIS_ParamsSection: 
        """
        Handle to the parameter section object, valid if DataType = Params.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.Params
        """
        pass

    @property
    def Render(
      self
    ) -> bool: 
        """
        True if at least one feature type is managed via the section renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.Render
        """
        pass

    @property
    def RenderArea(
      self
    ) -> bool: 
        """
        True if the area feature type is managed via the section renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.RenderArea
        """
        pass

    @property
    def RenderLabel(
      self
    ) -> bool: 
        """
        True if the label feature type is managed via the section renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.RenderLabel
        """
        pass

    @property
    def RenderLine(
      self
    ) -> bool: 
        """
        True if the line feature type is managed via the section renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.RenderLine
        """
        pass

    @property
    def RenderMarker(
      self
    ) -> bool: 
        """
        True if the marker feature type is managed via the section renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.RenderMarker
        """
        pass

    @property
    def RowCount(
      self
    ) -> int: 
        """
        Total number of rows of standard height necessary to construct the legend item.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendItemData.RowCount
        """
        pass

class TGIS_LegendIconFactory:
    """
    A utility class which prepares the feature icons that appear in the legend.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconFactory
    """

    @overload
    def __init__(
      self,
      _width: int,
      _compact: bool
    ) -> None: 
        """
        Constructor, creates an instance.

        Args:
            _width: width of the output icon
            _compact: if True, height=width/2, otherwise height=width

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconFactory.Create_Integer_Boolean
        """
        pass

    @overload
    def __init__(
      self,
      _width: int,
      _compact: bool,
      _style: TGIS_LegendIconStyle
    ) -> None: 
        """
        Constructor, creates an instance.

        Args:
            _width: width of the output icon
            _compact: if True, height=width/2, otherwise height=width
            _style: style of legend icons

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconFactory.Create_Integer_Boolean_TGIS_LegendIconStyle
        """
        pass

    def GetBitmap(
      self
    ) -> TGIS_Bitmap: 
        """
        Prepares and returns a native (platform specific) bitmap which represents the current 
        visual parameters and icon type.

        Returns:
            handle to a bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconFactory.GetBitmap_void
        """
        pass

    def SetColor(
      self,
      _color: TGIS_Color
    ) -> None: 
        """
        Sets the background color of the icon.

        Args:
            _color: background color

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconFactory.SetColor_TGIS_Color
        """
        pass

    def SetParams(
      self,
      _param: TGIS_ParamsSectionVector
    ) -> None: 
        """
        Sets the visual parameters using the provided parameter section.

        Args:
            _param: the parameter section

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconFactory.SetParams_TGIS_ParamsSectionVector
        """
        pass

    @overload
    def SetParamsRenderer(
      self,
      _layer: TGIS_LayerVector,
      _index: int
    ) -> None: 
        """
        Sets the visual parameters using the specified section renderer index.

        Args:
            _layer: the layer which contains the section renderer
            _index: the index of the section renderer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconFactory.SetParamsRenderer_TGIS_LayerVector_Integer
        """
        pass

    @overload
    def SetParamsRenderer(
      self,
      _layer: TGIS_LayerVector,
      _section: int,
      _index: int
    ) -> bool: 
        """
        Sets the visual parameters using the specified section renderer index.

        Args:
            _layer: the layer which contains the section renderer
            _section: the index of the parameters section
            _index: the index of the section renderer

        Returns:
            If False, it is not possible to get caurrent data

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconFactory.SetParamsRenderer_TGIS_LayerVector_Integer_Integer
        """
        pass

    @property
    def CustomPPI(
      self
    ) -> int: 
        """
        The PPI (pixels-per-inch) of the icon.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconFactory.CustomPPI
        """
        pass

    @CustomPPI.setter
    def CustomPPI(
      self,
      _value: int
    ) -> None: 
        """
        The PPI (pixels-per-inch) of the icon.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconFactory.CustomPPI
        """
        pass

    @property
    def IconType(
      self
    ) -> TGIS_LegendIconType: 
        """
        The type of feature that is to be represented by the icon.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconFactory.IconType
        """
        pass

    @IconType.setter
    def IconType(
      self,
      _value: TGIS_LegendIconType
    ) -> None: 
        """
        The type of feature that is to be represented by the icon.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconFactory.IconType
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_LayerVector: 
        """
        A template layer which is used to produce an icon of the current icon type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconFactory.Layer
        """
        pass

    @property
    def Renderer(
      self
    ) -> TGIS_RendererAbstract: 
        """
        The renderer of the underlying TGIS_ViewerBmp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconFactory.Renderer
        """
        pass

    @Renderer.setter
    def Renderer(
      self,
      _value: TGIS_RendererAbstract
    ) -> None: 
        """
        The renderer of the underlying TGIS_ViewerBmp.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconFactory.Renderer
        """
        pass

class TGIS_SymbolLibrarySVG( TObject ):
    """
    Class to access SVG Symbol Library.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLibrarySVG
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLibrarySVG.Create_void
        """
        pass

    def GetCaption(
      self,
      _name: str
    ) -> str: 
        """
        Get caption (user friendly name) of resource.

        Args:
            _name: _name of library item

        Returns:
            Symbol caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLibrarySVG.GetCaption_String
        """
        pass

    def GetCategories(
      self,
      _name: str
    ) -> str: 
        """
        Get categories of resource.

        Args:
            _name: name of the library item

        Returns:
            Categories separated by semicolons.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLibrarySVG.GetCategories_String
        """
        pass

    @overload
    def GetPreview(
      self,
      _name: str
    ) -> TGIS_Bitmap: 
        """
        Prepare a preview image for an item.

        Args:
            _name: name of the library item

        Returns:
            Bitmap with symbol previewed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLibrarySVG.GetPreview_String
        """
        pass

    @overload
    def GetPreview(
      self,
      _name: str,
      _ppi: int,
      _size: int
    ) -> TGIS_Bitmap: 
        """
        Prepare a preview image for an item.

        Args:
            _name: name of the library item
            _ppi: pixels per inch; used to calculate proper line sizes etc.
            _size: image size.

        Returns:
            Bitmap with symbol previewed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLibrarySVG.GetPreview_String_Integer_Integer
        """
        pass

    @overload
    def GetPreview(
      self,
      _name: str,
      _ppi: int,
      _size: int,
      _areacolor: TGIS_Color,
      _linecolor: TGIS_Color
    ) -> TGIS_Bitmap: 
        """
        Prepare a preview image for an item.

        Args:
            _name: name of the library item
            _ppi: pixels per inch; used to calculate proper line sizes etc.
            _size: image size.
            _areacolor: color for interiors
            _linecolor: color for lines and outlines

        Returns:
            Bitmap with symbol previewed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLibrarySVG.GetPreview_String_Integer_Integer_TGIS_Color_TGIS_Color
        """
        pass

    def Loop(
      self,
      _filter: str
    ) -> TGIS_StringList: 
        """
        Prepare list of all items within selected categories.

        Args:
            _filter: single category; if ''*'' then all symbols will be provided

        Returns:
            List with all symbols IDs matching filter.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLibrarySVG.Loop_String
        """
        pass

    @overload
    def OpenForBrowsing(
      self
    ) -> None: 
        """
        Open library for browsing purposes - fills Categories.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLibrarySVG.OpenForBrowsing_void
        """
        pass

    @overload
    def OpenForBrowsing(
      self,
      _category: str
    ) -> None: 
        """
        Open library for browsing purposes - fills Categories.

        Args:
            _category: if not empty then only symbols matching category will be available

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLibrarySVG.OpenForBrowsing_String
        """
        pass

    def Prepare(
      self,
      _name: str
    ) -> TGIS_SymbolSVG: 
        """
        Prepare symbol as a ready SVG object.

        Args:
            _name: Symbol name

        Returns:
            Symbol. Remember to release.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLibrarySVG.Prepare_String
        """
        pass

    def RegisterFileLibrary(
      self,
      _path: str
    ) -> None: 
        """
        Register file library.

        Args:
            _path: path to file library

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLibrarySVG.RegisterFileLibrary_String
        """
        pass

    def RegisterResourceLibrary(
      self,
      _name: str
    ) -> None: 
        """
        Register resource library library.

        Args:
            _name: library name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLibrarySVG.RegisterResourceLibrary_String
        """
        pass

    def SetCategories(
      self,
      _name: str,
      _categories: str
    ) -> None: 
        """
        Get categories of resource.

        Args:
            _name: name of the library item
            _categories: categories separated by semicolons

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLibrarySVG.SetCategories_String_String
        """
        pass

    @property
    def Categories(
      self
    ) -> TGIS_StringList: 
        """
        List of categories in the library.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLibrarySVG.Categories
        """
        pass

    @property
    def Handle(
      self
    ) -> TGIS_SymbolLibrarySVG: 
        """
        Global library object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLibrarySVG.Handle
        """
        pass

class TGIS_LineSymbolParser:
    """
    Utility for dealing with a string that is to become a TGIS_SymbolLineEx. Should be 
    used only in the context of the extended line symbology editor (TGIS_LineSymbolEditor).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LineSymbolParser
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LineSymbolParser.Create_void
        """
        pass

    def Compactify(
      self,
      _str: str
    ) -> str: 
        """
        Prepares a compact version of the symbol defining string.

        Args:
            _str: string to be compacted

        Returns:
            compacted version of the string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LineSymbolParser.Compactify_String
        """
        pass

    def Expand(
      self,
      _str: str
    ) -> str: 
        """
        Prepares an expanded version of the symbol defining string.

        Args:
            _str: string to be expanded

        Returns:
            compacted version of the string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LineSymbolParser.Expand_String
        """
        pass

    def IsClosed(
      self
    ) -> bool: 
        """
        Tells whether the symbol definition is properly closed after all the lines/parts 
        were parsed.

        Returns:
            True if the symbol is properly closed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LineSymbolParser.IsClosed_void
        """
        pass

    def Parse(
      self,
      _str: str,
      _err_s: VarParameter,
      _err_l: VarParameter
    ) -> bool: 
        """
        Performs a preliminary syntax check of the symbol defining string.

        Args:
            _str: string to be verified
            _err_s: starting index of the error; the value (in/out) is passed as int in _err_s.Value 
              property
            _err_l: character length of the error; the value (in/out) is passed as int in _err_l.Value 
              property

        Returns:
            True if the string is correct

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LineSymbolParser.Parse_String_Integer_Integer
        """
        pass

    def Reset(
      self
    ) -> None: 
        """
        Resets the parser state for parsing a new symbol definition.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LineSymbolParser.Reset_void
        """
        pass

class TGIS_PredefinedLineSymbolList:
    """
    List of predefined line symbols. Should be used only in the context of the extended 
    line symbology editor (TGIS_LineSymbolEditor).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PredefinedLineSymbolList
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PredefinedLineSymbolList.Create_void
        """
        pass

    def GetEnd(
      self,
      _idx: int
    ) -> str: 
        """
        Retrieves a symbol end element from the list.

        Args:
            _idx: index of the element

        Returns:
            symbol end element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PredefinedLineSymbolList.GetEnd_Integer
        """
        pass

    def GetLine(
      self,
      _idx: int
    ) -> str: 
        """
        Retrieves a symbol line element from the list.

        Args:
            _idx: index of the element

        Returns:
            symbol line element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PredefinedLineSymbolList.GetLine_Integer
        """
        pass

    def GetStart(
      self,
      _idx: int
    ) -> str: 
        """
        Retrieves a symbol start element from the list.

        Args:
            _idx: index of the element

        Returns:
            symbol start element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PredefinedLineSymbolList.GetStart_Integer
        """
        pass

    def PrepareSymbol(
      self,
      _start: int,
      _line: int,
      _end: int
    ) -> str: 
        """
        Prepares a line symbol as a combination of start, line and end elements of specific 
        indexes.

        Args:
            _start: index of the start element
            _line: index of the line element
            _end: index of the end element

        Returns:
            prepared symbol

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PredefinedLineSymbolList.PrepareSymbol_Integer_Integer_Integer
        """
        pass

    @property
    def EndCount(
      self
    ) -> int: 
        """
        Number of symbol end elements.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PredefinedLineSymbolList.EndCount
        """
        pass

    @property
    def LineCount(
      self
    ) -> int: 
        """
        Number of symbol line elements.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PredefinedLineSymbolList.LineCount
        """
        pass

    @property
    def StartCount(
      self
    ) -> int: 
        """
        Number of symbol start elements.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PredefinedLineSymbolList.StartCount
        """
        pass

class TGIS_LoggerType:
    pass

class TGIS_LoggerType:
    """
    Type of logged event

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LoggerType
    """

    @property
    def Error(
      self
    ) -> TGIS_LoggerType: 
        """
        log as an error

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LoggerType.Error
        """
        pass

    @property
    def Warning(
      self
    ) -> TGIS_LoggerType: 
        """
        log as a warning

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LoggerType.Warning
        """
        pass

    @property
    def Message(
      self
    ) -> TGIS_LoggerType: 
        """
        log as a simple message

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LoggerType.Message
        """
        pass

    @property
    def Trace(
      self
    ) -> TGIS_LoggerType: 
        """
        log as a trace

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LoggerType.Trace
        """
        pass

class TGIS_Logger:
    """
    Class responsible for logging. To be used for tracking program execution flow upon 
    debugging and in runtime environment.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Logger
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Logger.Create_void
        """
        pass

    def AsError(
      self,
      _title: str,
      _desc: str
    ) -> None: 
        """
        Log an error.

        Args:
            _title: title of event
            _desc: additional description

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Logger.AsError_String_String
        """
        pass

    def AsMessage(
      self,
      _title: str,
      _desc: str
    ) -> None: 
        """
        Log a message.

        Args:
            _title: title of event
            _desc: additional description

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Logger.AsMessage_String_String
        """
        pass

    def AsTrace(
      self,
      _title: str,
      _desc: str
    ) -> None: 
        """
        Log a trace.

        Args:
            _title: title of event
            _desc: additional description

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Logger.AsTrace_String_String
        """
        pass

    def AsWarning(
      self,
      _title: str,
      _desc: str
    ) -> None: 
        """
        Log a warning.

        Args:
            _title: title of event
            _desc: additional description

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Logger.AsWarning_String_String
        """
        pass

    @property
    def Active(
      self
    ) -> bool: 
        """
        True if logger is active.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Logger.Active
        """
        pass

    @Active.setter
    def Active(
      self,
      _value: bool
    ) -> None: 
        """
        True if logger is active.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Logger.Active
        """
        pass

    @property
    def Debug(
      self
    ) -> bool: 
        """
        True if app is running in a debug mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Logger.Debug
        """
        pass

    @property
    def Errors(
      self
    ) -> str: 
        """
        Get all errors as text.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Logger.Errors
        """
        pass

    @property
    def Path(
      self
    ) -> str: 
        """
        Path for logger file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Logger.Path
        """
        pass

    @Path.setter
    def Path(
      self,
      _value: str
    ) -> None: 
        """
        Path for logger file.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Logger.Path
        """
        pass

    @property
    def Warnings(
      self
    ) -> str: 
        """
        Get all warnings as text.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Logger.Warnings
        """
        pass

class TGIS_SquareMatrix:
    """
    Square matrix of double precision real numbers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _dim: int
    ) -> None: 
        """
        Creates an instance.

        Args:
            _dim: the dimension of the matrix

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Create_Integer
        """
        pass

    @overload
    def __init__(
      self,
      _mtr: TGIS_Matrix
    ) -> None: 
        """
        Creates an instance. If the source matrix is not square then it will be truncated 
        by the smaller dimension.

        Args:
            _mtr: the source data for matrix

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Create_TGIS_Matrix
        """
        pass

    @overload
    def Add3DTranslation(
      self,
      _trans: TGIS_Vector
    ) -> None: 
        """
        Adds translation to a 4D rotation-translation matrix; increases dimension to 4 if 
        smaller, does not change dimension if larger than 4.

        Args:
            _trans: translation vector; must be 3D or larger

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Add3DTranslation_TGIS_Vector
        """
        pass

    @overload
    def Add3DTranslation(
      self,
      _dx: float,
      _dy: float,
      _dz: float
    ) -> None: 
        """
        Adds translation to a 4D rotation-translation matrix; increases dimension to 4 if 
        smaller, does not change dimension if larger than 4.

        Args:
            _dx: translation along the X axis
            _dy: translation along the Y axis
            _dz: translation along the Z axis

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Add3DTranslation_Double_Double_Double
        """
        pass

    def Clone(
      self
    ) -> TGIS_SquareMatrix: 
        """
        Clones the matrix.

        Returns:
            The exact copy of the object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Clone_void
        """
        pass

    def Cofactor(
      self,
      _row: int,
      _col: int
    ) -> float: 
        """
        Computes the cofactor (minor) of the specified matrix element.

        Args:
            _row: the row index
            _col: the column index

        Returns:
            The cofactor of the matrix element.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Cofactor_Integer_Integer
        """
        pass

    def Determinant(
      self
    ) -> float: 
        """
        Computes the determinant of the matrix.

        Returns:
            The determinant of the matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Determinant_void
        """
        pass

    def Equal(
      self,
      _mtr: TGIS_SquareMatrix
    ) -> bool: 
        """
        Checks if the supplied matrix is equal to the current matrix.

        Args:
            _mtr: the matrix to be checked

        Returns:
            True if the matrices are equal.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Equal_TGIS_SquareMatrix
        """
        pass

    def Invert(
      self
    ) -> bool: 
        """
        Inverts the matrix.

        Returns:
            True if the inversion can be performed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Invert_void
        """
        pass

    def LUDecomposition(
      self,
      _lower: VarParameter,
      _upper: VarParameter
    ) -> bool: 
        """
        Computes the LU (Crout) decomposition of the matrix. Does not perform pivoting.

        Args:
            _lower: returns the "lower" matrix; the value (in/out) is passed as TGIS_SquareMatrix 
              in _lower.Value property
            _upper: returns the "upper" matrix; the value (in/out) is passed as TGIS_SquareMatrix 
              in _upper.Value property

        Returns:
            True if the LU decomposition can be performed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.LUDecomposition_TGIS_SquareMatrix_TGIS_SquareMatrix
        """
        pass

    def Make2DRotation(
      self,
      _angle: float,
      _cwise: bool
    ) -> None: 
        """
        Makes the 2D rotation matrix.

        Args:
            _angle: the angle of rotation
            _cwise: True for clockwise (Y to X); False for counterclockwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Make2DRotation_Double_Boolean
        """
        pass

    def Make3DRotationX(
      self,
      _angle: float,
      _cwise: bool
    ) -> None: 
        """
        Makes the 3D rotation matrix around the X axis; increases dimension to 3 if smaller, 
        does not change dimension if larger than 3.

        Args:
            _angle: the angle of rotation
            _cwise: True for clockwise (Z to Y); False for counterclockwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Make3DRotationX_Double_Boolean
        """
        pass

    def Make3DRotationY(
      self,
      _angle: float,
      _cwise: bool
    ) -> None: 
        """
        Makes the 3D rotation matrix around the Y axis; increases dimension to 3 if smaller, 
        does not change dimension if larger than 3.

        Args:
            _angle: the angle of rotation
            _cwise: True for clockwise (X to Z); False for counterclockwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Make3DRotationY_Double_Boolean
        """
        pass

    def Make3DRotationZ(
      self,
      _angle: float,
      _cwise: bool
    ) -> None: 
        """
        Makes a 3D rotation matrix around the Z axis; increases dimension to 3 if smaller, 
        does not change dimension if larger than 3.

        Args:
            _angle: the angle of rotation
            _cwise: True for clockwise (Y to X); False for counterclockwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Make3DRotationZ_Double_Boolean
        """
        pass

    def MakeIdentity(
      self
    ) -> None: 
        """
        Makes the identity matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.MakeIdentity_void
        """
        pass

    @overload
    def Multiply(
      self,
      _mtr: TGIS_SquareMatrix
    ) -> TGIS_SquareMatrix: 
        """
        Multiplies the supplied matrix by the current matrix.

        Args:
            _mtr: the matrix to be multiplied

        Returns:
            The result of multiplication.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Multiply_TGIS_SquareMatrix
        """
        pass

    @overload
    def Multiply(
      self,
      _vec: TGIS_Vector
    ) -> TGIS_Vector: 
        """
        Multiplies the supplied vector by the current matrix.

        Args:
            _vec: the vector to be multiplied

        Returns:
            The result of multiplication.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Multiply_TGIS_Vector
        """
        pass

    def MultiplyBy(
      self,
      _val: float
    ) -> None: 
        """
        Multiplies the matrix by a double precision real number.

        Args:
            _val: the value to multiply by

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.MultiplyBy_Double
        """
        pass

    def Solve(
      self,
      _vec: TGIS_Vector
    ) -> TGIS_Vector: 
        """
        Solves a system of linear equations of the form Matrix * unknown vector = known vector.

        Args:
            _vec: the known vector

        Returns:
            The solution of the linear problem.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Solve_TGIS_Vector
        """
        pass

    def Transpose(
      self
    ) -> None: 
        """
        Transposes the matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Transpose_void
        """
        pass

    @property
    def Dimension(
      self
    ) -> int: 
        """
        The dimension (number of rows/columns) of the matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Dimension
        """
        pass

    
    def Element(
      self,
      _row: int,
      _col: int
    ) -> float: 
        """
        The value of the matrix element.

        Args:
            _row: the row index
            _col: the column index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Element
        """
        pass

    
    def Element(
      self,
      _row: int,
      _col: int,
      _value: float
    ) -> None: 
        """
        The value of the matrix element.

        Args:
            _row: the row index
            _col: the column index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Element
        """
        pass

    
    def Row(
      self,
      _row: int
    ) -> TGIS_Vector: 
        """
        Gives access to the whole matrix row.

        Args:
            _row: the row index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Row
        """
        pass

    
    def Row(
      self,
      _row: int,
      _value: TGIS_Vector
    ) -> None: 
        """
        Gives access to the whole matrix row.

        Args:
            _row: the row index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SquareMatrix.Row
        """
        pass

class TGIS_Vector:
    """
    Vector of double precision real numbers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Vector
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> Double:
        pass

    def __setitem__(
      self,
      index : int,
      value : Double
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Vector.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Vector.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Vector.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> float: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Vector.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: float
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Vector.Value
        """
        pass

class TGIS_Matrix:
    """
    Matrix of double precision real numbers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Matrix
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_Vector:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_Vector
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Matrix.Create_void
        """
        pass

    def SetSize(
      self,
      _rows: int,
      _columns: int
    ) -> None: 
        """
        Set array size.

        Args:
            _rows: number of rows
            _columns: number of columns

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Matrix.SetSize_Integer_Integer
        """
        pass

    @property
    def Columns(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Matrix.Columns
        """
        pass

    @property
    def Rows(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Matrix.Rows
        """
        pass

    
    def Value(
      self,
      _row: int,
      _col: int
    ) -> float: 
        """
        Array element value.

        Args:
            _row: row index
            _col: raw index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Matrix.Value
        """
        pass

    
    def Value(
      self,
      _row: int,
      _col: int,
      _value: float
    ) -> None: 
        """
        Array element value.

        Args:
            _row: row index
            _col: raw index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Matrix.Value
        """
        pass

class TGIS_MVTStyler( TObject ):
    """
    Encapsulation of Mapbox Vector Tiles styler.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MVTStyler
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MVTStyler.Create_void
        """
        pass

    def BuildParams(
      self,
      _layer: TGIS_Layer,
      _level: int
    ) -> None: 
        """
        Build params for layer based on level.

        Args:
            _layer: layer handle
            _level: level of styling

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MVTStyler.BuildParams_TGIS_Layer_Integer
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear internal data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MVTStyler.Clear_void
        """
        pass

    def GetSprite(
      self,
      _name: str
    ) -> TGIS_SymbolAbstract: 
        """
        Get sprite symbol by name.

        Args:
            _name: name of symbol

        Returns:
            symbol if found

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MVTStyler.GetSprite_String
        """
        pass

    def ParseSprites(
      self,
      _path: str,
      _key: str
    ) -> None: 
        """
        Parse sprites resources.

        Args:
            _path: path to style data (url, path)
            _key: key for style access

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MVTStyler.ParseSprites_String_String
        """
        pass

    def ParseStyle(
      self,
      _path: str
    ) -> None: 
        """
        Parse style.

        Args:
            _path: path to style data (url, path)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MVTStyler.ParseStyle_String
        """
        pass

    def SortLayers(
      self,
      _layers: TGIS_LayerAbstractList
    ) -> None: 
        """
        Sort layers by style order.

        Args:
            _layers: list of layers

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MVTStyler.SortLayers_TGIS_LayerAbstractList
        """
        pass

    @property
    def BackgroundColor(
      self
    ) -> TGIS_Color: 
        """
        Style background color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MVTStyler.BackgroundColor
        """
        pass

    @property
    def PixelSizeFactor(
      self
    ) -> float: 
        """
        Pixel size factor. Affects width and size properties. Default is 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MVTStyler.PixelSizeFactor
        """
        pass

    @PixelSizeFactor.setter
    def PixelSizeFactor(
      self,
      _value: float
    ) -> None: 
        """
        Pixel size factor. Affects width and size properties. Default is 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MVTStyler.PixelSizeFactor
        """
        pass

    @property
    def SpritesUrl(
      self
    ) -> str: 
        """
        Url to sprites resource.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MVTStyler.SpritesUrl
        """
        pass

class TGIS_NetworkCandidate:
    pass

class TGIS_NetworkCandidate:
    """
    State of node in the list of candidates.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkCandidate
    """

    @property
    def Not(
      self
    ) -> TGIS_NetworkCandidate: 
        """
        Node is not in the list of candidates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkCandidate.Not
        """
        pass

    @property
    def New(
      self
    ) -> TGIS_NetworkCandidate: 
        """
        Node has been just added to the list of candidates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkCandidate.New
        """
        pass

    @property
    def Already(
      self
    ) -> TGIS_NetworkCandidate: 
        """
        Node is already in the list of candidates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkCandidate.Already
        """
        pass

class TGIS_NetworkStorageAbstract( TObject ):
    """
    Base class for network storage object. Storage object is responsible for physical 
    network storage.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkStorageAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkStorageAbstract.Create_void
        """
        pass

    def Commit(
      self
    ) -> None: 
        """
        Commit changes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkStorageAbstract.Commit_void
        """
        pass

    def Delete(
      self
    ) -> None: 
        """
        Delete network files (clears the network).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkStorageAbstract.Delete_void
        """
        pass

    def FindNode(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _level: byte
    ) -> int: 
        """
        Find closest node corresponding to provided location.

        Args:
            _ptg: location of the node
            _prec: precision of location in layer units
            _level: node level; if level = 127 then any level will be found

        Returns:
            number of nodes found

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkStorageAbstract.FindNode_TGIS_Point_Double_ShortInt
        """
        pass

    def ReadLink(
      self,
      _link: TGIS_NetworkLink
    ) -> None: 
        """
        Read link from the storage into the memory.

        Args:
            _link: link to be read with ObjectId filled to specify object to be read

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkStorageAbstract.ReadLink_TGIS_NetworkLink
        """
        pass

    def ReadNode(
      self,
      _node: TGIS_NetworkNode
    ) -> None: 
        """
        Read node from the storage into the memory.

        Args:
            _node: node to be read with ObjectId filled to specify object to be read

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkStorageAbstract.ReadNode_TGIS_NetworkNode
        """
        pass

    def SaveLink(
      self,
      _link: TGIS_NetworkLink
    ) -> None: 
        """
        Save link to the storage

        Args:
            _link: link to be saved

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkStorageAbstract.SaveLink_TGIS_NetworkLink
        """
        pass

    def SaveNode(
      self,
      _node: TGIS_NetworkNode
    ) -> None: 
        """
        Save node to the storage

        Args:
            _node: node to be saved

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkStorageAbstract.SaveNode_TGIS_NetworkNode
        """
        pass

    @property
    def Ready(
      self
    ) -> bool: 
        """
        True if the storage is ready.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkStorageAbstract.Ready
        """
        pass

class TGIS_NetworkFile( TGIS_NetworkStorageAbstract ):
    """
    Simple file based network storage.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkFile
    """

    @overload
    def __init__(
      self,
      _path: str,
      _write: bool
    ) -> None: 
        """
        Create an instance

        Args:
            _path: path for network storage (including file name)
            _write: if true then new files will be created; otherwise read-only mode

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkFile.Create_String_Boolean
        """
        pass

class TGIS_NetworkObjectList( TGIS_ObjectList ):
    """
    List of cached (in-memory) network objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkObjectList
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkObjectList.Create_void
        """
        pass

    def Add(
      self,
      _obj: TGIS_NetworkObject
    ) -> None: 
        """
        Add provided object to the list

        Args:
            _obj: object to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkObjectList.Add_TGIS_NetworkObject
        """
        pass

    def FindItem(
      self,
      _id: int,
      _ipos: VarParameter
    ) -> bool: 
        """
        Find item on the list.

        Args:
            _id: object id (ObjectId value)
            _ipos: found position; the value (in/out) is passed as int in _ipos.Value property

        Returns:
            True if the item was found

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkObjectList.FindItem_Cardinal_Integer
        """
        pass

    def Get(
      self,
      _id: int
    ) -> TGIS_NetworkObject: 
        """
        Get object by identifier.

        Args:
            _id: object id (ObjectId value)

        Returns:
            object with specified identifier

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkObjectList.Get_Cardinal
        """
        pass

class TGIS_NetworkObject( TObject ):
    """
    Base object for network operations.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkObject
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkObject.Create_void
        """
        pass

    @property
    def ObjectId(
      self
    ) -> int: 
        """
        Unique node identifier.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkObject.ObjectId
        """
        pass

    @ObjectId.setter
    def ObjectId(
      self,
      _value: int
    ) -> None: 
        """
        Unique node identifier.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkObject.ObjectId
        """
        pass

    @property
    def Parent(
      self
    ) -> TGIS_Network: 
        """
        Parent network.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkObject.Parent
        """
        pass

    @Parent.setter
    def Parent(
      self,
      _value: TGIS_Network
    ) -> None: 
        """
        Parent network.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkObject.Parent
        """
        pass

class TGIS_NetworkNode( TGIS_NetworkObject ):
    """
    Network node.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkNode
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkNode.Create_void
        """
        pass

    def CreateCopy(
      self
    ) -> TGIS_NetworkNode: 
        """
        Create a copy of the current object.

        Returns:
            the copy of the object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkNode.CreateCopy_void
        """
        pass

    def LinkAdd(
      self,
      _link: TGIS_NetworkLink
    ) -> None: 
        """
        Add a link to the list of associated links.

        Args:
            _link: link to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkNode.LinkAdd_TGIS_NetworkLink
        """
        pass

    @property
    def CurrentCost(
      self
    ) -> float: 
        """
        Best cost so far.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkNode.CurrentCost
        """
        pass

    @CurrentCost.setter
    def CurrentCost(
      self,
      _value: float
    ) -> None: 
        """
        Best cost so far.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkNode.CurrentCost
        """
        pass

    @property
    def CurrentLink(
      self
    ) -> int: 
        """
        Path tree link.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkNode.CurrentLink
        """
        pass

    @CurrentLink.setter
    def CurrentLink(
      self,
      _value: int
    ) -> None: 
        """
        Path tree link.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkNode.CurrentLink
        """
        pass

    @property
    def CurrentState(
      self
    ) -> TGIS_NetworkCandidate: 
        """
        Node state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkNode.CurrentState
        """
        pass

    @CurrentState.setter
    def CurrentState(
      self,
      _value: TGIS_NetworkCandidate
    ) -> None: 
        """
        Node state.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkNode.CurrentState
        """
        pass

    @property
    def HeuristicCost(
      self
    ) -> float: 
        """
        Best heuristic cost so far.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkNode.HeuristicCost
        """
        pass

    @HeuristicCost.setter
    def HeuristicCost(
      self,
      _value: float
    ) -> None: 
        """
        Best heuristic cost so far.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkNode.HeuristicCost
        """
        pass

    @property
    def Level(
      self
    ) -> byte: 
        """
        Node level.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkNode.Level
        """
        pass

    
    def Link(
      self,
      _index: int
    ) -> TGIS_NetworkLink: 
        """
        Access link from the list of associated links. Links list is counted from 0.

        Args:
            _index: index of the link

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkNode.Link
        """
        pass

    @property
    def LinkCount(
      self
    ) -> int: 
        """
        Number of links on the list of associated links.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkNode.LinkCount
        """
        pass

    @property
    def Pos(
      self
    ) -> TGIS_Point: 
        """
        Position of node.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkNode.Pos
        """
        pass

class TGIS_NetworkLink( TGIS_NetworkObject ):
    """
    Network Link.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkLink
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkLink.Create_void
        """
        pass

    @property
    def Cost(
      self
    ) -> float: 
        """
        Cost of the link.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkLink.Cost
        """
        pass

    @Cost.setter
    def Cost(
      self,
      _value: float
    ) -> None: 
        """
        Cost of the link.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkLink.Cost
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_LayerVector: 
        """
        Layer describing this link.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkLink.Layer
        """
        pass

    @Layer.setter
    def Layer(
      self,
      _value: TGIS_LayerVector
    ) -> None: 
        """
        Layer describing this link.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkLink.Layer
        """
        pass

    @property
    def LinkType(
      self
    ) -> int: 
        """
        Type of link (0..9).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkLink.LinkType
        """
        pass

    @LinkType.setter
    def LinkType(
      self,
      _value: int
    ) -> None: 
        """
        Type of link (0..9).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkLink.LinkType
        """
        pass

    @property
    def NodeA(
      self
    ) -> int: 
        """
        The endpoint.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkLink.NodeA
        """
        pass

    @NodeA.setter
    def NodeA(
      self,
      _value: int
    ) -> None: 
        """
        The endpoint.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkLink.NodeA
        """
        pass

    @property
    def NodeB(
      self
    ) -> int: 
        """
        The endpoint.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkLink.NodeB
        """
        pass

    @NodeB.setter
    def NodeB(
      self,
      _value: int
    ) -> None: 
        """
        The endpoint.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkLink.NodeB
        """
        pass

    @property
    def ReverseCost(
      self
    ) -> float: 
        """
        Reverse cost of the link.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkLink.ReverseCost
        """
        pass

    @ReverseCost.setter
    def ReverseCost(
      self,
      _value: float
    ) -> None: 
        """
        Reverse cost of the link.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkLink.ReverseCost
        """
        pass

    @property
    def ShapeUid(
      self
    ) -> int: 
        """
        Shape uid describing this link.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkLink.ShapeUid
        """
        pass

    @ShapeUid.setter
    def ShapeUid(
      self,
      _value: int
    ) -> None: 
        """
        Shape uid describing this link.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_NetworkLink.ShapeUid
        """
        pass

class TGIS_Network( TObject ):
    """
    Class for storing and retrieving network graph for TGIS_ShortestPathLink purposes 
    and other network analysis classes.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerVector,
      _forcedpath: str
    ) -> None: 
        """
        Create a new network on provided layer

        Args:
            _layer: layer on which network should be constructed
            _forcedpath: if empty then network will be saved in a default location (same as _layer.Path); 
              if set then define locations (path with file name like ''c:\tmp\myfile'' should be 
              provided)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.Create_TGIS_LayerVector_String
        """
        pass

    def AddNode(
      self,
      _ptg: TGIS_Point,
      _level: int
    ) -> TGIS_NetworkNode: 
        """
        Add a node at the specific location. If node at the specific location already exists, 
        then reference to existing node will be returned. Otherwise a new object will be 
        added.

        Args:
            _ptg: node localization
            _level: node level; if level = 127 then any level will be found

        Returns:
            handle to the added node

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.AddNode_TGIS_Point_Integer
        """
        pass

    def AddShape(
      self,
      _shp: TGIS_ShapeArc,
      _field: str
    ) -> None: 
        """
        Add new shape to the network. Adding will add a link, nodes etc.

        Args:
            _shp: shape to be added
            _field: if provided that field name contains link cost; if empty then _shp.LengthCS 
              will be used instead

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.AddShape_TGIS_ShapeArc_String
        """
        pass

    def Clean(
      self
    ) -> None: 
        """
        Clean the network to prepare it for next searching.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.Clean_void
        """
        pass

    def CleanDynamicLinks(
      self
    ) -> None: 
        """
        Clean all dynamic links like created by geocoder.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.CleanDynamicLinks_void
        """
        pass

    def Delete(
      self
    ) -> None: 
        """
        Delete saved network.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.Delete_void
        """
        pass

    @overload
    def FindNode(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _level: byte
    ) -> TGIS_NetworkNode: 
        """
        Find closest node corresponding to provided location.

        Args:
            _ptg: location of the node
            _prec: precision of location in layer units
            _level: node level; if level = 127 then any level will be found

        Returns:
            found node

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.FindNode_TGIS_Point_Double_ShortInt
        """
        pass

    @overload
    def FindNode(
      self,
      _ptg: TGIS_Point,
      _prec: float
    ) -> TGIS_NetworkNode: 
        """
        Find closest node corresponding to provided location regardless of the nide level.

        Args:
            _ptg: location of the node
            _prec: precision of location in layer units

        Returns:
            found node

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.FindNode_TGIS_Point_Double
        """
        pass

    def GetLink(
      self,
      _id: int
    ) -> TGIS_NetworkLink: 
        """
        Read from network (storage or memory) a link corresponding to provided ObjectId

        Args:
            _id: link id (ObjectId value)

        Returns:
            retrieved link

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.GetLink_Cardinal
        """
        pass

    def GetNode(
      self,
      _id: int
    ) -> TGIS_NetworkNode: 
        """
        Read from network (storage or memory) a node corresponding to provided ObjectId

        Args:
            _id: node id (ObjectId value)

        Returns:
            retrieved node

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.GetNode_Cardinal
        """
        pass

    def GetShape(
      self,
      _id: int
    ) -> TGIS_ShapeArc: 
        """
        Get shape object from the network corresponding to provided link identifier

        Args:
            _id: link id (ObjectId value)

        Returns:
            retrieved shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.GetShape_Cardinal
        """
        pass

    def Open(
      self
    ) -> None: 
        """
        Open network (must exists first

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.Open_void
        """
        pass

    def Serialize(
      self
    ) -> None: 
        """
        Save current network to the underlying storage

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.Serialize_void
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_LayerVector: 
        """
        Network base layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.Layer
        """
        pass

    @property
    def Ready(
      self
    ) -> bool: 
        """
        True if network is properly generated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.Ready
        """
        pass

    @property
    def LinkEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_ShapeArc, TGIS_NetworkLink], None]: 
        """
        Event fired upon calling AddShape procedure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.LinkEvent
        """
        pass

    @LinkEvent.setter
    def LinkEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_ShapeArc, TGIS_NetworkLink], None]
    ) -> None: 
        """
        Event fired upon calling AddShape procedure.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Network.LinkEvent
        """
        pass

class TGIS_OSMRoutingProfile:
    pass

class TGIS_OSMRoutingProfile:
    """
    Profiles of the TatukGIS online routong service.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMRoutingProfile
    """

    @property
    def Car(
      self
    ) -> TGIS_OSMRoutingProfile: 
        """
        Car profile.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMRoutingProfile.Car
        """
        pass

    @property
    def Bike(
      self
    ) -> TGIS_OSMRoutingProfile: 
        """
        Bike profile.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMRoutingProfile.Bike
        """
        pass

    @property
    def Foot(
      self
    ) -> TGIS_OSMRoutingProfile: 
        """
        Foot (pedestrian) profile.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMRoutingProfile.Foot
        """
        pass

class TGIS_OSMServiceAbstract( TObject ):
    """
    Base class for TatukGIS online service clients.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMServiceAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMServiceAbstract.Create_void
        """
        pass

    @property
    def Address(
      self
    ) -> str: 
        """
        Non-standard address of the service including port number (e.g. ''127.0.0.1:8888''). 
        If empty then the default address is used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMServiceAbstract.Address
        """
        pass

    @Address.setter
    def Address(
      self,
      _value: str
    ) -> None: 
        """
        Non-standard address of the service including port number (e.g. ''127.0.0.1:8888''). 
        If empty then the default address is used.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMServiceAbstract.Address
        """
        pass

    @property
    def Timeout(
      self
    ) -> int: 
        """
        Maximum waiting time for service response.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMServiceAbstract.Timeout
        """
        pass

    @Timeout.setter
    def Timeout(
      self,
      _value: int
    ) -> None: 
        """
        Maximum waiting time for service response.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMServiceAbstract.Timeout
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMServiceAbstract.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMServiceAbstract.BusyEvent
        """
        pass

class TGIS_OSMGeocoding( TGIS_OSMServiceAbstract ):
    """
    Class encapsulating access to the TatukGIS online geocoding service.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMGeocoding
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMGeocoding.Create_void
        """
        pass

    def Forward(
      self,
      _name: str
    ) -> TGIS_LayerVector: 
        """
        Sends forward geocoding request to the online service.

        Args:
            _name: address/location string

        Returns:
            Layer containing resolved locations.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMGeocoding.Forward_String
        """
        pass

    def ForwardPoint(
      self,
      _name: str
    ) -> TGIS_Point: 
        """
        Sends forward geocoding request to the online service.

        Args:
            _name: address/location string

        Returns:
            First match of resolved.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMGeocoding.ForwardPoint_String
        """
        pass

    def Reverse(
      self,
      _loc: TGIS_Point
    ) -> TGIS_LayerVector: 
        """
        Sends reverse geocoding request to the online service.

        Args:
            _loc: location as a point in WGS84 coordinates

        Returns:
            Layer containing resolved.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMGeocoding.Reverse_TGIS_Point
        """
        pass

    @property
    def BiasPoint(
      self
    ) -> TGIS_Point: 
        """
        Point in WGS84 coordinates used for location bias.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMGeocoding.BiasPoint
        """
        pass

    @BiasPoint.setter
    def BiasPoint(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Point in WGS84 coordinates used for location bias.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMGeocoding.BiasPoint
        """
        pass

    @property
    def Limit(
      self
    ) -> int: 
        """
        Limit of the number of results.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMGeocoding.Limit
        """
        pass

    @Limit.setter
    def Limit(
      self,
      _value: int
    ) -> None: 
        """
        Limit of the number of results.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMGeocoding.Limit
        """
        pass

    @property
    def RestrictedExtent(
      self
    ) -> TGIS_Extent: 
        """
        Extent in WGS84 coordinates used to limit results.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMGeocoding.RestrictedExtent
        """
        pass

    @RestrictedExtent.setter
    def RestrictedExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Extent in WGS84 coordinates used to limit results.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMGeocoding.RestrictedExtent
        """
        pass

class TGIS_OSMRouting( TGIS_OSMServiceAbstract ):
    """
    Class encapsulating access to the TatukGIS online routing service.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMRouting
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMRouting.Create_void
        """
        pass

    @overload
    def Route(
      self,
      _points: TGIS_PointList
    ) -> TGIS_LayerVector: 
        """
        Sends routing request to the online service.

        Args:
            _points: ordered list of start, intermediate and end points in WGS84 coordinates

        Returns:
            Layer containing found route.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMRouting.Route_TGIS_PointList
        """
        pass

    @overload
    def Route(
      self,
      _from: TGIS_Point,
      _to: TGIS_Point
    ) -> TGIS_LayerVector: 
        """
        Sends routing request to the online service.

        Args:
            _from: start point in WGS84 coordinates
            _to: end point in WGS84 coordinates

        Returns:
            Layer containing found route.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMRouting.Route_TGIS_Point_TGIS_Point
        """
        pass

    @overload
    def Route(
      self,
      _names: TGIS_StringList
    ) -> TGIS_LayerVector: 
        """
        Sends routing request to the online service.

        Args:
            _names: ordered list of start, intermediate and end locations as address/location 
              strings

        Returns:
            Layer containing found route.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMRouting.Route_TGIS_StringList
        """
        pass

    @overload
    def Route(
      self,
      _from: str,
      _to: str
    ) -> TGIS_LayerVector: 
        """
        Sends routing request to the online service.

        Args:
            _from: start location as an address/location string
            _to: end location as an address/location string

        Returns:
            Layer containing found route.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMRouting.Route_String_String
        """
        pass

    @property
    def Profile(
      self
    ) -> TGIS_OSMRoutingProfile: 
        """
        Routing profile (vehicle type).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMRouting.Profile
        """
        pass

    @Profile.setter
    def Profile(
      self,
      _value: TGIS_OSMRoutingProfile
    ) -> None: 
        """
        Routing profile (vehicle type).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMRouting.Profile
        """
        pass

class TGIS_OSMIsochrone( TGIS_OSMServiceAbstract ):
    """
    Class encapsulating access to the TatukGIS online isochrone service.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMIsochrone
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMIsochrone.Create_void
        """
        pass

    @overload
    def Isochrone(
      self,
      _point: TGIS_Point
    ) -> TGIS_LayerVector: 
        """
        Sends isochrone request to the online service.

        Args:
            _point: start point in WGS84 coordinates

        Returns:
            Layer containing found insochrone.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMIsochrone.Isochrone_TGIS_Point
        """
        pass

    @overload
    def Isochrone(
      self,
      _name: str
    ) -> TGIS_LayerVector: 
        """
        Sends isochrone request to the online service.

        Args:
            _name: start location as an address/location string

        Returns:
            Layer containing found insochrone.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMIsochrone.Isochrone_String
        """
        pass

    @property
    def Buckets(
      self
    ) -> int: 
        """
        Number of isochrone/isodinstance intervals.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMIsochrone.Buckets
        """
        pass

    @Buckets.setter
    def Buckets(
      self,
      _value: int
    ) -> None: 
        """
        Number of isochrone/isodinstance intervals.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMIsochrone.Buckets
        """
        pass

    @property
    def Profile(
      self
    ) -> TGIS_OSMRoutingProfile: 
        """
        Isochrone profile (vehicle type).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMIsochrone.Profile
        """
        pass

    @Profile.setter
    def Profile(
      self,
      _value: TGIS_OSMRoutingProfile
    ) -> None: 
        """
        Isochrone profile (vehicle type).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMIsochrone.Profile
        """
        pass

    @property
    def TimeLimit(
      self
    ) -> int: 
        """
        Isochrone time limit.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMIsochrone.TimeLimit
        """
        pass

    @TimeLimit.setter
    def TimeLimit(
      self,
      _value: int
    ) -> None: 
        """
        Isochrone time limit.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OSMIsochrone.TimeLimit
        """
        pass

class TGIS_ParamsUserObject( TObject ):
    """
    User object class encapsulation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsUserObject
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsUserObject.Create_void
        """
        pass

    def CreateCopy(
      self
    ) -> TGIS_ParamsUserObject: 
        """
        Create a copy of object.

        Returns:
            Constructed copy of the object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsUserObject.CreateCopy_void
        """
        pass

class TGIS_ParamsAbstract( TPersistent ):
    """
    Common parameters ancestor.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsAbstract.Create_void
        """
        pass

    def CreateCopy(
      self
    ) -> TGIS_ParamsAbstract: 
        """
        Make a copy of the object.

        Returns:
            Constructed copy of the object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsAbstract.CreateCopy_void
        """
        pass

    def IsModified(
      self
    ) -> bool: 
        """
        Indicates whether the initial serial was modified (Params was touched).

        Returns:
            True if modified.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsAbstract.IsModified_void
        """
        pass

    def LoadFromConfig(
      self,
      _cfg: TGIS_ConfigAbstract
    ) -> None: 
        """
        Load parameters from the configuration file.

        Args:
            _cfg: source configuration file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsAbstract.LoadFromConfig_TGIS_ConfigAbstract
        """
        pass

    def ResetSerial(
      self
    ) -> None: 
        """
        Reset serial numer conter.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsAbstract.ResetSerial_void
        """
        pass

    def SaveToConfig(
      self,
      _cfg: TGIS_ConfigAbstract
    ) -> None: 
        """
        Save parameters into the configuration file.

        Args:
            _cfg: destination configuration file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsAbstract.SaveToConfig_TGIS_ConfigAbstract
        """
        pass

    def Touch(
      self
    ) -> None: 
        """
        Touch the object by incrementing Serial number.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsAbstract.Touch_void
        """
        pass

    @property
    def Serial(
      self
    ) -> int: 
        """
        Serial number updated after any property change. Used to identify if object was changed. 
        Used by legend control for smart updates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsAbstract.Serial
        """
        pass

    @Serial.setter
    def Serial(
      self,
      _value: int
    ) -> None: 
        """
        Serial number updated after any property change. Used to identify if object was changed. 
        Used by legend control for smart updates.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsAbstract.Serial
        """
        pass

    @property
    def UserObject(
      self
    ) -> TGIS_ParamsUserObject: 
        """
        UserObject can be used to associate with Params a user-defined object. Such object 
        will be destroyed automatically upon layer destroy. Attaching a new object to this 
        property will destroy existing one.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsAbstract.UserObject
        """
        pass

    @UserObject.setter
    def UserObject(
      self,
      _value: TGIS_ParamsUserObject
    ) -> None: 
        """
        UserObject can be used to associate with Params a user-defined object. Such object 
        will be destroyed automatically upon layer destroy. Attaching a new object to this 
        property will destroy existing one.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsAbstract.UserObject
        """
        pass

class TGIS_ParamsSpecific( TGIS_ParamsAbstract ):
    """
    Common parameters ancestor for Layer.Params sub objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSpecific
    """

    def GetRoot(
      self
    ) -> TGIS_ParamsAbstract: 
        """
        Get root element from params list.

        Returns:
            Root element.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSpecific.GetRoot_void
        """
        pass

    def LoadFromStrings(
      self,
      _str: TGIS_StringList
    ) -> None: 
        """
        Load parameters from a list of strings.

        Args:
            _str: source list of strings

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSpecific.LoadFromStrings_TStrings
        """
        pass

    def SaveToStrings(
      self,
      _str: TGIS_StringList
    ) -> None: 
        """
        Save parameters into a list of strings.

        Args:
            _str: destination list of strings

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSpecific.SaveToStrings_TStrings
        """
        pass

    @property
    def Shape(
      self
    ) -> TObject: 
        """
        Shape associated with parameter (if any) belongs.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSpecific.Shape
        """
        pass

class TGIS_ParamsVector( TGIS_ParamsSpecific ):
    """
    Common parameters ancestor for vector layer parameters.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsVector
    """

class TGIS_ParamsRender( TGIS_ParamsVector ):
    """
    Parameters that are common for rendering.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.Create_void
        """
        pass

    @property
    def Chart(
      self
    ) -> str: 
        """
        Renderer Chart.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.Chart
        """
        pass

    @Chart.setter
    def Chart(
      self,
      _value: str
    ) -> None: 
        """
        Renderer Chart.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.Chart
        """
        pass

    @property
    def ColorDefault(
      self
    ) -> TGIS_Color: 
        """
        Default color for shapes which can''t be colorized by renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.ColorDefault
        """
        pass

    @ColorDefault.setter
    def ColorDefault(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Default color for shapes which can''t be colorized by renderer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.ColorDefault
        """
        pass

    @property
    def ColorDefaultAsText(
      self
    ) -> str: 
        """
        Color. Grouping as a text property all properties that affect Color presentation.Uses 
        AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.ColorDefaultAsText
        """
        pass

    @ColorDefaultAsText.setter
    def ColorDefaultAsText(
      self,
      _value: str
    ) -> None: 
        """
        Color. Grouping as a text property all properties that affect Color presentation.Uses 
        AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.ColorDefaultAsText
        """
        pass

    @property
    def ColorInterpolationMode(
      self
    ) -> TGIS_ColorInterpolationMode: 
        """
        A color space for a interpolation beetwen StartColor and EndColor

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.ColorInterpolationMode
        """
        pass

    @ColorInterpolationMode.setter
    def ColorInterpolationMode(
      self,
      _value: TGIS_ColorInterpolationMode
    ) -> None: 
        """
        A color space for a interpolation beetwen StartColor and EndColor

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.ColorInterpolationMode
        """
        pass

    @property
    def ColorRamp(
      self
    ) -> TGIS_ColorMapArray: 
        """
        A color ramp for coloring the shape by the renderer. If assigned, StartColor and 
        EndColor are ignored.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.ColorRamp
        """
        pass

    @ColorRamp.setter
    def ColorRamp(
      self,
      _value: TGIS_ColorMapArray
    ) -> None: 
        """
        A color ramp for coloring the shape by the renderer. If assigned, StartColor and 
        EndColor are ignored.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.ColorRamp
        """
        pass

    @property
    def EndColor(
      self
    ) -> TGIS_Color: 
        """
        An ending color for coloring the shape by the renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.EndColor
        """
        pass

    @EndColor.setter
    def EndColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        An ending color for coloring the shape by the renderer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.EndColor
        """
        pass

    @property
    def EndColorAsText(
      self
    ) -> str: 
        """
        An ending color for coloring the shape by the renderer. Grouping as a text property 
        all properties that affect StartColor presentation.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.EndColorAsText
        """
        pass

    @EndColorAsText.setter
    def EndColorAsText(
      self,
      _value: str
    ) -> None: 
        """
        An ending color for coloring the shape by the renderer. Grouping as a text property 
        all properties that affect StartColor presentation.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.EndColorAsText
        """
        pass

    @property
    def EndColorEx(
      self
    ) -> TGIS_Color: 
        """
        An ending color for coloring the shape by the renderer. An extended band.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.EndColorEx
        """
        pass

    @EndColorEx.setter
    def EndColorEx(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        An ending color for coloring the shape by the renderer. An extended band.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.EndColorEx
        """
        pass

    @property
    def EndColorExAsText(
      self
    ) -> str: 
        """
        An ending color for coloring the shape by the renderer. An extended band. Grouping 
        as a text property all properties that affect StartColor presentation.Uses AsText 
        parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.EndColorExAsText
        """
        pass

    @EndColorExAsText.setter
    def EndColorExAsText(
      self,
      _value: str
    ) -> None: 
        """
        An ending color for coloring the shape by the renderer. An extended band. Grouping 
        as a text property all properties that affect StartColor presentation.Uses AsText 
        parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.EndColorExAsText
        """
        pass

    @property
    def EndSize(
      self
    ) -> int: 
        """
        Ending size (in twips) for sizing by renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.EndSize
        """
        pass

    @EndSize.setter
    def EndSize(
      self,
      _value: int
    ) -> None: 
        """
        Ending size (in twips) for sizing by renderer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.EndSize
        """
        pass

    @property
    def EndSizeAsText(
      self
    ) -> str: 
        """
        EndSize. Grouping as a text property all properties that affect EndSize presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.EndSizeAsText
        """
        pass

    @EndSizeAsText.setter
    def EndSizeAsText(
      self,
      _value: str
    ) -> None: 
        """
        EndSize. Grouping as a text property all properties that affect EndSize presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.EndSizeAsText
        """
        pass

    @property
    def EndSizeEx(
      self
    ) -> int: 
        """
        Ending size (in twips) for sizing by renderer. Extended band.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.EndSizeEx
        """
        pass

    @EndSizeEx.setter
    def EndSizeEx(
      self,
      _value: int
    ) -> None: 
        """
        Ending size (in twips) for sizing by renderer. Extended band.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.EndSizeEx
        """
        pass

    @property
    def EndSizeExAsText(
      self
    ) -> str: 
        """
        EndSizeEx. Grouping as a text property all properties that affect EndSizeEx presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.EndSizeExAsText
        """
        pass

    @EndSizeExAsText.setter
    def EndSizeExAsText(
      self,
      _value: str
    ) -> None: 
        """
        EndSizeEx. Grouping as a text property all properties that affect EndSizeEx presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.EndSizeExAsText
        """
        pass

    @property
    def Expression(
      self
    ) -> str: 
        """
        Render Expression. Result must be numeric value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.Expression
        """
        pass

    @Expression.setter
    def Expression(
      self,
      _value: str
    ) -> None: 
        """
        Render Expression. Result must be numeric value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.Expression
        """
        pass

    @property
    def InterpolationBase(
      self
    ) -> float: 
        """
        Controls the way at which the interpolated values change. Possible values are real 
        numbers greater than zero.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.InterpolationBase
        """
        pass

    @InterpolationBase.setter
    def InterpolationBase(
      self,
      _value: float
    ) -> None: 
        """
        Controls the way at which the interpolated values change. Possible values are real 
        numbers greater than zero.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.InterpolationBase
        """
        pass

    @property
    def MaxVal(
      self
    ) -> float: 
        """
        Maximum expected value of RenderExpression.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.MaxVal
        """
        pass

    @MaxVal.setter
    def MaxVal(
      self,
      _value: float
    ) -> None: 
        """
        Maximum expected value of RenderExpression.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.MaxVal
        """
        pass

    @property
    def MaxValEx(
      self
    ) -> float: 
        """
        Maximum expected value of RenderExpression. An extended band.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.MaxValEx
        """
        pass

    @MaxValEx.setter
    def MaxValEx(
      self,
      _value: float
    ) -> None: 
        """
        Maximum expected value of RenderExpression. An extended band.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.MaxValEx
        """
        pass

    @property
    def MinVal(
      self
    ) -> float: 
        """
        Minimum expected value of RenderExpression.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.MinVal
        """
        pass

    @MinVal.setter
    def MinVal(
      self,
      _value: float
    ) -> None: 
        """
        Minimum expected value of RenderExpression.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.MinVal
        """
        pass

    @property
    def MinValEx(
      self
    ) -> float: 
        """
        Minimum expected value of RenderExpression. An extended band.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.MinValEx
        """
        pass

    @MinValEx.setter
    def MinValEx(
      self,
      _value: float
    ) -> None: 
        """
        Minimum expected value of RenderExpression. An extended band.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.MinValEx
        """
        pass

    @property
    def Round(
      self
    ) -> int: 
        """
        Number of digits to round a RenderExpression result.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.Round
        """
        pass

    @Round.setter
    def Round(
      self,
      _value: int
    ) -> None: 
        """
        Number of digits to round a RenderExpression result.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.Round
        """
        pass

    @property
    def SizeDefault(
      self
    ) -> int: 
        """
        Default size (in twips) for shapes which can''t be sized by renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.SizeDefault
        """
        pass

    @SizeDefault.setter
    def SizeDefault(
      self,
      _value: int
    ) -> None: 
        """
        Default size (in twips) for shapes which can''t be sized by renderer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.SizeDefault
        """
        pass

    @property
    def SizeDefaultAsText(
      self
    ) -> str: 
        """
        SymbolDefault. Grouping as a text property all properties that affect SizeDefault 
        presentation and represent sizes in a human readable form like ''10pt'', ''3in''.Uses 
        AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.SizeDefaultAsText
        """
        pass

    @SizeDefaultAsText.setter
    def SizeDefaultAsText(
      self,
      _value: str
    ) -> None: 
        """
        SymbolDefault. Grouping as a text property all properties that affect SizeDefault 
        presentation and represent sizes in a human readable form like ''10pt'', ''3in''.Uses 
        AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.SizeDefaultAsText
        """
        pass

    @property
    def StartColor(
      self
    ) -> TGIS_Color: 
        """
        A starting color for coloring the shape by the renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.StartColor
        """
        pass

    @StartColor.setter
    def StartColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        A starting color for coloring the shape by the renderer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.StartColor
        """
        pass

    @property
    def StartColorAsText(
      self
    ) -> str: 
        """
        A starting color for coloring the shape by the renderer. Grouping as a text property 
        all properties that affect StartColor presentation.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.StartColorAsText
        """
        pass

    @StartColorAsText.setter
    def StartColorAsText(
      self,
      _value: str
    ) -> None: 
        """
        A starting color for coloring the shape by the renderer. Grouping as a text property 
        all properties that affect StartColor presentation.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.StartColorAsText
        """
        pass

    @property
    def StartColorEx(
      self
    ) -> TGIS_Color: 
        """
        A starting color for coloring the shape by the renderer. An extended band.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.StartColorEx
        """
        pass

    @StartColorEx.setter
    def StartColorEx(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        A starting color for coloring the shape by the renderer. An extended band.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.StartColorEx
        """
        pass

    @property
    def StartColorExAsText(
      self
    ) -> str: 
        """
        A starting color for coloring the shape by the renderer. An extended band. Grouping 
        as a text property all properties that affect StartColor presentation.Uses AsText 
        parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.StartColorExAsText
        """
        pass

    @StartColorExAsText.setter
    def StartColorExAsText(
      self,
      _value: str
    ) -> None: 
        """
        A starting color for coloring the shape by the renderer. An extended band. Grouping 
        as a text property all properties that affect StartColor presentation.Uses AsText 
        parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.StartColorExAsText
        """
        pass

    @property
    def StartSize(
      self
    ) -> int: 
        """
        Starting size (in twips) for sizing by renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.StartSize
        """
        pass

    @StartSize.setter
    def StartSize(
      self,
      _value: int
    ) -> None: 
        """
        Starting size (in twips) for sizing by renderer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.StartSize
        """
        pass

    @property
    def StartSizeAsText(
      self
    ) -> str: 
        """
        StartSize. Grouping as a text property all properties that affect StartSize presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.StartSizeAsText
        """
        pass

    @StartSizeAsText.setter
    def StartSizeAsText(
      self,
      _value: str
    ) -> None: 
        """
        StartSize. Grouping as a text property all properties that affect StartSize presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.StartSizeAsText
        """
        pass

    @property
    def StartSizeEx(
      self
    ) -> int: 
        """
        Starting size (in twips) for sizing by renderer. Extended band.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.StartSizeEx
        """
        pass

    @StartSizeEx.setter
    def StartSizeEx(
      self,
      _value: int
    ) -> None: 
        """
        Starting size (in twips) for sizing by renderer. Extended band.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.StartSizeEx
        """
        pass

    @property
    def StartSizeExAsText(
      self
    ) -> str: 
        """
        StartSizeEx. Grouping as a text property all properties that affect StartSizeEx presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.StartSizeExAsText
        """
        pass

    @StartSizeExAsText.setter
    def StartSizeExAsText(
      self,
      _value: str
    ) -> None: 
        """
        StartSizeEx. Grouping as a text property all properties that affect StartSizeEx presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.StartSizeExAsText
        """
        pass

    @property
    def Zones(
      self
    ) -> int: 
        """
        Number of zones to be used while computing actual color or size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.Zones
        """
        pass

    @Zones.setter
    def Zones(
      self,
      _value: int
    ) -> None: 
        """
        Number of zones to be used while computing actual color or size.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.Zones
        """
        pass

    @property
    def ZonesEx(
      self
    ) -> int: 
        """
        Number of zones to be used while computing actual color or size. An extended band.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.ZonesEx
        """
        pass

    @ZonesEx.setter
    def ZonesEx(
      self,
      _value: int
    ) -> None: 
        """
        Number of zones to be used while computing actual color or size. An extended band.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsRender.ZonesEx
        """
        pass

class TGIS_ParamsPixel( TGIS_ParamsSpecific ):
    """
    Parameters that are common for pixel layers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Create_void
        """
        pass

    @property
    def AlphaBand(
      self
    ) -> int: 
        """
        Alpha band number. Allows selection which band will be used for alpha channel. Bands 
        are numbered starting from 1. By providing 0 default band will be used. By providing 
        -1 band will be turned off. For grayscale RedBand=GreenBand=BlueBand. If GridBand 
        is used then RedBand, GreenBand and BlueBand are unused.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.AlphaBand
        """
        pass

    @AlphaBand.setter
    def AlphaBand(
      self,
      _value: int
    ) -> None: 
        """
        Alpha band number. Allows selection which band will be used for alpha channel. Bands 
        are numbered starting from 1. By providing 0 default band will be used. By providing 
        -1 band will be turned off. For grayscale RedBand=GreenBand=BlueBand. If GridBand 
        is used then RedBand, GreenBand and BlueBand are unused.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.AlphaBand
        """
        pass

    @property
    def AltitudeMapZones(
      self
    ) -> TGIS_StringList: 
        """
        List of zones for mapping the altitude. Each entry consist of: "start_altitude,end_altitude, 
        color". e.g., "100.45,800.12,$FF0000" will map altitudes 100.45..800.12 to red.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.AltitudeMapZones
        """
        pass

    @property
    def Antialias(
      self
    ) -> bool: 
        """
        Antialias scaling.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Antialias
        """
        pass

    @Antialias.setter
    def Antialias(
      self,
      _value: bool
    ) -> None: 
        """
        Antialias scaling.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Antialias
        """
        pass

    @property
    def Blue(
      self
    ) -> int: 
        """
        Blue brightness +/- 100%.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Blue
        """
        pass

    @Blue.setter
    def Blue(
      self,
      _value: int
    ) -> None: 
        """
        Blue brightness +/- 100%.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Blue
        """
        pass

    @property
    def BlueBand(
      self
    ) -> int: 
        """
        Blue band number. Allows selection which band will be used for blue channel. Bands 
        are numbered starting from 1. By providing 0 default band will be used. By providing 
        -1 band will be turned off. For grayscale RedBand=GreenBand=BlueBand. If GridBand 
        is used then RedBand, GreenBand and BlueBand are unused.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.BlueBand
        """
        pass

    @BlueBand.setter
    def BlueBand(
      self,
      _value: int
    ) -> None: 
        """
        Blue band number. Allows selection which band will be used for blue channel. Bands 
        are numbered starting from 1. By providing 0 default band will be used. By providing 
        -1 band will be turned off. For grayscale RedBand=GreenBand=BlueBand. If GridBand 
        is used then RedBand, GreenBand and BlueBand are unused.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.BlueBand
        """
        pass

    @property
    def BlueMapZones(
      self
    ) -> TGIS_StringList: 
        """
        List of zones for mapping the blue channel. Each entry consist of: "start_value,end_value,start_value_mapped,end_value_mapped". 
        e.g., "0,255,64,127" will shrink the values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.BlueMapZones
        """
        pass

    @property
    def Brightness(
      self
    ) -> int: 
        """
        Brightness +/- 100%.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Brightness
        """
        pass

    @Brightness.setter
    def Brightness(
      self,
      _value: int
    ) -> None: 
        """
        Brightness +/- 100%.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Brightness
        """
        pass

    @property
    def ColorRamp(
      self
    ) -> TGIS_ColorMapArray: 
        """
        A color ramp for coloring grid values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.ColorRamp
        """
        pass

    @ColorRamp.setter
    def ColorRamp(
      self,
      _value: TGIS_ColorMapArray
    ) -> None: 
        """
        A color ramp for coloring grid values.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.ColorRamp
        """
        pass

    @property
    def Contrast(
      self
    ) -> int: 
        """
        Contrast +/- 100%.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Contrast
        """
        pass

    @Contrast.setter
    def Contrast(
      self,
      _value: int
    ) -> None: 
        """
        Contrast +/- 100%.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Contrast
        """
        pass

    @property
    def ContrastEnhanced(
      self
    ) -> bool: 
        """
        If True, then image has automatically enhanced contrast.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.ContrastEnhanced
        """
        pass

    @ContrastEnhanced.setter
    def ContrastEnhanced(
      self,
      _value: bool
    ) -> None: 
        """
        If True, then image has automatically enhanced contrast.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.ContrastEnhanced
        """
        pass

    @property
    def FullRGBMapZones(
      self
    ) -> TGIS_StringList: 
        """
        List of zones for mapping the full color (RGB). Each entry consist of: "start_color,end_color, 
        mapped_color". e.g., "$EFEFEF,$FFFFFF,$00FF00" will change white and White almost 
        to green.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.FullRGBMapZones
        """
        pass

    @property
    def GrayMapZones(
      self
    ) -> TGIS_StringList: 
        """
        List of zones for mapping in gray. Each entry consists of: "start_value,end_value,start_color,end_color". 
        e.g., "0,255,$000000,$0000FF" will make grayscale blue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.GrayMapZones
        """
        pass

    @property
    def GrayScale(
      self
    ) -> bool: 
        """
        If True, then image must be gray scaled; default is False.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.GrayScale
        """
        pass

    @GrayScale.setter
    def GrayScale(
      self,
      _value: bool
    ) -> None: 
        """
        If True, then image must be gray scaled; default is False.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.GrayScale
        """
        pass

    @property
    def Green(
      self
    ) -> int: 
        """
        Green brightness +/- 100%.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Green
        """
        pass

    @Green.setter
    def Green(
      self,
      _value: int
    ) -> None: 
        """
        Green brightness +/- 100%.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Green
        """
        pass

    @property
    def GreenBand(
      self
    ) -> int: 
        """
        Green band number. Allows selection which band will be used for green channel. Bands 
        are numbered starting from 1. By providing 0 default band will be used. By providing 
        -1 band will be turned off. For grayscale RedBand=GreenBand=BlueBand. If GridBand 
        is used then RedBand, GreenBand and BlueBand are unused.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.GreenBand
        """
        pass

    @GreenBand.setter
    def GreenBand(
      self,
      _value: int
    ) -> None: 
        """
        Green band number. Allows selection which band will be used for green channel. Bands 
        are numbered starting from 1. By providing 0 default band will be used. By providing 
        -1 band will be turned off. For grayscale RedBand=GreenBand=BlueBand. If GridBand 
        is used then RedBand, GreenBand and BlueBand are unused.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.GreenBand
        """
        pass

    @property
    def GreenMapZones(
      self
    ) -> TGIS_StringList: 
        """
        List of zones for mapping the green channel. Each entry consist of: "start_value,end_value,start_value_mapped,end_value_mapped". 
        e.g., "0,255,64,127" will shrink the values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.GreenMapZones
        """
        pass

    @property
    def GridBand(
      self
    ) -> int: 
        """
        Grid band number. Allows selection which band will be used for grids. Bands are numbered 
        starting from 1. By providing 0 default band will be used. By providing -1 band will 
        be turned off. If GridBand is used then RedBand, GreenBand and BlueBand are unused.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.GridBand
        """
        pass

    @GridBand.setter
    def GridBand(
      self,
      _value: int
    ) -> None: 
        """
        Grid band number. Allows selection which band will be used for grids. Bands are numbered 
        starting from 1. By providing 0 default band will be used. By providing -1 band will 
        be turned off. If GridBand is used then RedBand, GreenBand and BlueBand are unused.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.GridBand
        """
        pass

    @property
    def GridNoValue(
      self
    ) -> float: 
        """
        Grid "no-value". Allows to specify the value which will be used to discover no-assigned-data 
        areas on a grid. By providing GIS_GRID_NOVALUE (32768) default (embedded into the 
        file) value be used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.GridNoValue
        """
        pass

    @GridNoValue.setter
    def GridNoValue(
      self,
      _value: float
    ) -> None: 
        """
        Grid "no-value". Allows to specify the value which will be used to discover no-assigned-data 
        areas on a grid. By providing GIS_GRID_NOVALUE (32768) default (embedded into the 
        file) value be used.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.GridNoValue
        """
        pass

    @property
    def GridShadow(
      self
    ) -> bool: 
        """
        Grid shadow. If true then pseudo-shadow will be generated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.GridShadow
        """
        pass

    @GridShadow.setter
    def GridShadow(
      self,
      _value: bool
    ) -> None: 
        """
        Grid shadow. If true then pseudo-shadow will be generated.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.GridShadow
        """
        pass

    @property
    def GridShadowAngle(
      self
    ) -> float: 
        """
        Shadow angle used for grid shadowing.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.GridShadowAngle
        """
        pass

    @GridShadowAngle.setter
    def GridShadowAngle(
      self,
      _value: float
    ) -> None: 
        """
        Shadow angle used for grid shadowing.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.GridShadowAngle
        """
        pass

    @property
    def GridSmoothColors(
      self
    ) -> bool: 
        """
        Grid smooth colors. If true, each grid cell color will be interpolated from a color 
        ramp zones defined in AltitudeMapZones. The result will be continuous colors between 
        zones. Default value is false and discrete colors between zones.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.GridSmoothColors
        """
        pass

    @GridSmoothColors.setter
    def GridSmoothColors(
      self,
      _value: bool
    ) -> None: 
        """
        Grid smooth colors. If true, each grid cell color will be interpolated from a color 
        ramp zones defined in AltitudeMapZones. The result will be continuous colors between 
        zones. Default value is false and discrete colors between zones.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.GridSmoothColors
        """
        pass

    @property
    def Histogram(
      self
    ) -> bool: 
        """
        If True, then image must equalized by histogram; default is False.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Histogram
        """
        pass

    @Histogram.setter
    def Histogram(
      self,
      _value: bool
    ) -> None: 
        """
        If True, then image must equalized by histogram; default is False.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Histogram
        """
        pass

    @property
    def HistogramPath(
      self
    ) -> str: 
        """
        Name of read or saved histogram.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.HistogramPath
        """
        pass

    @HistogramPath.setter
    def HistogramPath(
      self,
      _value: str
    ) -> None: 
        """
        Name of read or saved histogram.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.HistogramPath
        """
        pass

    @property
    def Inversion(
      self
    ) -> bool: 
        """
        If True, then image must be inverted; default is False.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Inversion
        """
        pass

    @Inversion.setter
    def Inversion(
      self,
      _value: bool
    ) -> None: 
        """
        If True, then image must be inverted; default is False.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Inversion
        """
        pass

    @property
    def LegendImage(
      self
    ) -> TGIS_Bitmap: 
        """
        Image in legend component. First left-top pixel will be used as transparent color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.LegendImage
        """
        pass

    @LegendImage.setter
    def LegendImage(
      self,
      _value: TGIS_Bitmap
    ) -> None: 
        """
        Image in legend component. First left-top pixel will be used as transparent color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.LegendImage
        """
        pass

    @property
    def MaxHeightThreshold(
      self
    ) -> float: 
        """
        Maximum threshold of the grid elevation value to display.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.MaxHeightThreshold
        """
        pass

    @MaxHeightThreshold.setter
    def MaxHeightThreshold(
      self,
      _value: float
    ) -> None: 
        """
        Maximum threshold of the grid elevation value to display.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.MaxHeightThreshold
        """
        pass

    @property
    def MinHeightThreshold(
      self
    ) -> float: 
        """
        Minimum threshold of the grid elevation value to display.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.MinHeightThreshold
        """
        pass

    @MinHeightThreshold.setter
    def MinHeightThreshold(
      self,
      _value: float
    ) -> None: 
        """
        Minimum threshold of the grid elevation value to display.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.MinHeightThreshold
        """
        pass

    @property
    def Page(
      self
    ) -> int: 
        """
        Page number. Several file formats supports pages. For example TIFF supports pages. 
        Each page can represent different content or different resolutions of the same content. 
        Pages are numbered starting from 1. By providing 0 default page will be used (or 
        multiresolution content will be used if exists).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Page
        """
        pass

    @Page.setter
    def Page(
      self,
      _value: int
    ) -> None: 
        """
        Page number. Several file formats supports pages. For example TIFF supports pages. 
        Each page can represent different content or different resolutions of the same content. 
        Pages are numbered starting from 1. By providing 0 default page will be used (or 
        multiresolution content will be used if exists).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Page
        """
        pass

    @property
    def Red(
      self
    ) -> int: 
        """
        Red brightness +/- 100%.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Red
        """
        pass

    @Red.setter
    def Red(
      self,
      _value: int
    ) -> None: 
        """
        Red brightness +/- 100%.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.Red
        """
        pass

    @property
    def RedBand(
      self
    ) -> int: 
        """
        Red band number. Allows selection which band will be used for red channel. Bands 
        are numbered starting from 1. By providing 0 default channel will be used. By providing 
        -1 band will be turned off. For grayscale RedBand=GreenBand=BlueBand. If GridBand 
        is used then RedBand, GreenBand and BlueBand are unused.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.RedBand
        """
        pass

    @RedBand.setter
    def RedBand(
      self,
      _value: int
    ) -> None: 
        """
        Red band number. Allows selection which band will be used for red channel. Bands 
        are numbered starting from 1. By providing 0 default channel will be used. By providing 
        -1 band will be turned off. For grayscale RedBand=GreenBand=BlueBand. If GridBand 
        is used then RedBand, GreenBand and BlueBand are unused.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.RedBand
        """
        pass

    @property
    def RedMapZones(
      self
    ) -> TGIS_StringList: 
        """
        List of zones for mapping the red channel. Each entry consist of: "start_value,end_value,start_value_mapped,end_value_mapped". 
        e.g., "0,255,64,127" will shrink the values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.RedMapZones
        """
        pass

    @property
    def ShowLegend(
      self
    ) -> bool: 
        """
        Show feature in legend component?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.ShowLegend
        """
        pass

    @ShowLegend.setter
    def ShowLegend(
      self,
      _value: bool
    ) -> None: 
        """
        Show feature in legend component?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.ShowLegend
        """
        pass

    @property
    def TransparentZones(
      self
    ) -> TGIS_StringList: 
        """
        List of transparent zones. Each entry consist of: "start_color, end_color". E.g, 
        "$000000, $5F5f5f".

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsPixel.TransparentZones
        """
        pass

class TGIS_ParamsField( TObject ):
    """
    Parameters for reading properties from fields.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsField
    """

    @overload
    def __init__(
      self,
      _params: TGIS_ParamsAbstract
    ) -> None: 
        """
        Constructor.

        Args:
            _params: base parameters

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsField.Create_TGIS_ParamsAbstract
        """
        pass

    def Assign(
      self,
      _src: TGIS_ParamsField
    ) -> None: 
        """
        Assign value.

        Args:
            _src: source field

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsField.Assign_TGIS_ParamsField
        """
        pass

    def IsDifferent(
      self,
      _src: TGIS_ParamsField
    ) -> bool: 
        """
        Is field object different from another.

        Args:
            _src: field to compare

        Returns:
            False if objects are same.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsField.IsDifferent_TGIS_ParamsField
        """
        pass

    @property
    def Factor(
      self
    ) -> float: 
        """
        Factor to multiply field value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsField.Factor
        """
        pass

    @Factor.setter
    def Factor(
      self,
      _value: float
    ) -> None: 
        """
        Factor to multiply field value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsField.Factor
        """
        pass

    @property
    def Field(
      self
    ) -> str: 
        """
        Field name with values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsField.Field
        """
        pass

    @Field.setter
    def Field(
      self,
      _value: str
    ) -> None: 
        """
        Field name with values.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsField.Field
        """
        pass

    @property
    def Scalable(
      self
    ) -> bool: 
        """
        Is value scalable.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsField.Scalable
        """
        pass

    @Scalable.setter
    def Scalable(
      self,
      _value: bool
    ) -> None: 
        """
        Is value scalable.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsField.Scalable
        """
        pass

class TGIS_ParamsFeature( TGIS_ParamsVector ):
    """
    Parameters that are common for features like Lines, Areas, Markers, Labels.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.Create_void
        """
        pass

    def SizeHelper(
      self,
      _size: int,
      _factor: float
    ) -> int: 
        """
        Helper for safe scaling size feature even if feature is auto-scaled.

        Args:
            _size: value to be scaled
            _factor: scaled factor

        Returns:
            Scaled value. Information about auto-scale will persist as well as rendering markers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.SizeHelper_Integer_Double
        """
        pass

    @property
    def Bitmap(
      self
    ) -> TGIS_Bitmap: 
        """
        Interior bitmap. Assigning a new value will destroy the existing one and call Assign 
        for a new value on a newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.Bitmap
        """
        pass

    @Bitmap.setter
    def Bitmap(
      self,
      _value: TGIS_Bitmap
    ) -> None: 
        """
        Interior bitmap. Assigning a new value will destroy the existing one and call Assign 
        for a new value on a newly created object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.Bitmap
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Interior color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Interior color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.Color
        """
        pass

    @property
    def ColorAsText(
      self
    ) -> str: 
        """
        Color. Grouping as a text property all properties that affect Color presentation 
        like Color or ColorEx.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.ColorAsText
        """
        pass

    @ColorAsText.setter
    def ColorAsText(
      self,
      _value: str
    ) -> None: 
        """
        Color. Grouping as a text property all properties that affect Color presentation 
        like Color or ColorEx.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.ColorAsText
        """
        pass

    @property
    def OffsetPosition(
      self
    ) -> TGIS_OffsetPosition: 
        """
        Offset position to assign positive or negative sign for OffsetX and OffsetY.Uses 
        AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OffsetPosition
        """
        pass

    @OffsetPosition.setter
    def OffsetPosition(
      self,
      _value: TGIS_OffsetPosition
    ) -> None: 
        """
        Offset position to assign positive or negative sign for OffsetX and OffsetY.Uses 
        AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OffsetPosition
        """
        pass

    @property
    def OffsetX(
      self
    ) -> int: 
        """
        Offset for drawing a shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OffsetX
        """
        pass

    @OffsetX.setter
    def OffsetX(
      self,
      _value: int
    ) -> None: 
        """
        Offset for drawing a shape.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OffsetX
        """
        pass

    @property
    def OffsetXAsText(
      self
    ) -> str: 
        """
        Offset for drawing a shape. Grouping as a text property all properties that affect 
        Offset and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText 
        parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OffsetXAsText
        """
        pass

    @OffsetXAsText.setter
    def OffsetXAsText(
      self,
      _value: str
    ) -> None: 
        """
        Offset for drawing a shape. Grouping as a text property all properties that affect 
        Offset and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText 
        parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OffsetXAsText
        """
        pass

    @property
    def OffsetY(
      self
    ) -> int: 
        """
        Offset for drawing a shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OffsetY
        """
        pass

    @OffsetY.setter
    def OffsetY(
      self,
      _value: int
    ) -> None: 
        """
        Offset for drawing a shape.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OffsetY
        """
        pass

    @property
    def OffsetYAsText(
      self
    ) -> str: 
        """
        Offset for drawing a shape. Grouping as a text property all properties that affect 
        Offset and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText 
        parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OffsetYAsText
        """
        pass

    @OffsetYAsText.setter
    def OffsetYAsText(
      self,
      _value: str
    ) -> None: 
        """
        Offset for drawing a shape. Grouping as a text property all properties that affect 
        Offset and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText 
        parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OffsetYAsText
        """
        pass

    @property
    def OutlineBackcolor(
      self
    ) -> TGIS_Color: 
        """
        Outline backcolor; used for dash styles.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlineBackcolor
        """
        pass

    @OutlineBackcolor.setter
    def OutlineBackcolor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Outline backcolor; used for dash styles.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlineBackcolor
        """
        pass

    @property
    def OutlineBitmap(
      self
    ) -> TGIS_Bitmap: 
        """
        Outline bitmap. Assigning a new value will cause destroying existing one and calling 
        Assign for a new value on a newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlineBitmap
        """
        pass

    @OutlineBitmap.setter
    def OutlineBitmap(
      self,
      _value: TGIS_Bitmap
    ) -> None: 
        """
        Outline bitmap. Assigning a new value will cause destroying existing one and calling 
        Assign for a new value on a newly created object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlineBitmap
        """
        pass

    @property
    def OutlineColor(
      self
    ) -> TGIS_Color: 
        """
        Outline color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlineColor
        """
        pass

    @OutlineColor.setter
    def OutlineColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Outline color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlineColor
        """
        pass

    @property
    def OutlineColorAsText(
      self
    ) -> str: 
        """
        OutlineColor. Grouping as a text property all properties that affect Color presentation 
        like OutlineColor or OutlineColorEx.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlineColorAsText
        """
        pass

    @OutlineColorAsText.setter
    def OutlineColorAsText(
      self,
      _value: str
    ) -> None: 
        """
        OutlineColor. Grouping as a text property all properties that affect Color presentation 
        like OutlineColor or OutlineColorEx.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlineColorAsText
        """
        pass

    @property
    def OutlinePattern(
      self
    ) -> TGIS_BrushStyle: 
        """
        Outline pattern.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlinePattern
        """
        pass

    @OutlinePattern.setter
    def OutlinePattern(
      self,
      _value: TGIS_BrushStyle
    ) -> None: 
        """
        Outline pattern.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlinePattern
        """
        pass

    @property
    def OutlinePatternAsText(
      self
    ) -> str: 
        """
        Outline pattern. Grouping as a text property all properties that affect Pattern presentation 
        like OutlineSymbol, OutlineBitmap or OutlineStyle.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlinePatternAsText
        """
        pass

    @OutlinePatternAsText.setter
    def OutlinePatternAsText(
      self,
      _value: str
    ) -> None: 
        """
        Outline pattern. Grouping as a text property all properties that affect Pattern presentation 
        like OutlineSymbol, OutlineBitmap or OutlineStyle.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlinePatternAsText
        """
        pass

    @property
    def OutlineStyle(
      self
    ) -> TGIS_PenStyle: 
        """
        Outline style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlineStyle
        """
        pass

    @OutlineStyle.setter
    def OutlineStyle(
      self,
      _value: TGIS_PenStyle
    ) -> None: 
        """
        Outline style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlineStyle
        """
        pass

    @property
    def OutlineStyleAsText(
      self
    ) -> str: 
        """
        OutlineStyle. Grouping as a text property all properties that affect OutlineStyle 
        presentation like OutlineSymbol or OutlineStyle.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlineStyleAsText
        """
        pass

    @OutlineStyleAsText.setter
    def OutlineStyleAsText(
      self,
      _value: str
    ) -> None: 
        """
        OutlineStyle. Grouping as a text property all properties that affect OutlineStyle 
        presentation like OutlineSymbol or OutlineStyle.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlineStyleAsText
        """
        pass

    @property
    def OutlineWidth(
      self
    ) -> int: 
        """
        Outline width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlineWidth
        """
        pass

    @OutlineWidth.setter
    def OutlineWidth(
      self,
      _value: int
    ) -> None: 
        """
        Outline width.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlineWidth
        """
        pass

    @property
    def OutlineWidthAsText(
      self
    ) -> str: 
        """
        OutlineWidth. Grouping as a text property all properties that affect Width presentation 
        like OutlineWidth or OutlineWidthEx and represent sizes in a human readable form 
        like ''10pt'', ''3in''.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlineWidthAsText
        """
        pass

    @OutlineWidthAsText.setter
    def OutlineWidthAsText(
      self,
      _value: str
    ) -> None: 
        """
        OutlineWidth. Grouping as a text property all properties that affect Width presentation 
        like OutlineWidth or OutlineWidthEx and represent sizes in a human readable form 
        like ''10pt'', ''3in''.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.OutlineWidthAsText
        """
        pass

    @property
    def Pattern(
      self
    ) -> TGIS_BrushStyle: 
        """
        Interior pattern.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.Pattern
        """
        pass

    @Pattern.setter
    def Pattern(
      self,
      _value: TGIS_BrushStyle
    ) -> None: 
        """
        Interior pattern.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.Pattern
        """
        pass

    @property
    def PatternAsText(
      self
    ) -> str: 
        """
        Pattern. Grouping as a text property all properties that affect Outline presentation 
        like Symbol, Bitmap or Style.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.PatternAsText
        """
        pass

    @PatternAsText.setter
    def PatternAsText(
      self,
      _value: str
    ) -> None: 
        """
        Pattern. Grouping as a text property all properties that affect Outline presentation 
        like Symbol, Bitmap or Style.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.PatternAsText
        """
        pass

    @property
    def ShowLegend(
      self
    ) -> bool: 
        """
        Show feature in legend component?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.ShowLegend
        """
        pass

    @ShowLegend.setter
    def ShowLegend(
      self,
      _value: bool
    ) -> None: 
        """
        Show feature in legend component?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.ShowLegend
        """
        pass

    @property
    def SmartSize(
      self
    ) -> int: 
        """
        Default minimum bounding box size which is to be visible (&gt;0 in twips, &lt;0 in 
        pixels). If a shape in current zoom is smaller, then the shape will not be visible. 
        Used only if SmartSizeField is not set. The value is read from main section only.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.SmartSize
        """
        pass

    @SmartSize.setter
    def SmartSize(
      self,
      _value: int
    ) -> None: 
        """
        Default minimum bounding box size which is to be visible (&gt;0 in twips, &lt;0 in 
        pixels). If a shape in current zoom is smaller, then the shape will not be visible. 
        Used only if SmartSizeField is not set. The value is read from main section only.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.SmartSize
        """
        pass

    @property
    def SmartSizeAsText(
      self
    ) -> str: 
        """
        Smart Size. Grouping as a text property all properties that affect Smart Size presentation 
        like SmartSize or SmartSizeField and represent sizes in a human readable form like 
        ''10pt'', ''3in''.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.SmartSizeAsText
        """
        pass

    @SmartSizeAsText.setter
    def SmartSizeAsText(
      self,
      _value: str
    ) -> None: 
        """
        Smart Size. Grouping as a text property all properties that affect Smart Size presentation 
        like SmartSize or SmartSizeField and represent sizes in a human readable form like 
        ''10pt'', ''3in''.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsFeature.SmartSizeAsText
        """
        pass

class TGIS_ParamsLine( TGIS_ParamsFeature ):
    """
    Parameters that are common for Lines.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance with default values. Default: 1 twip width, black, no outline.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.Create_void
        """
        pass

    @property
    def Style(
      self
    ) -> TGIS_PenStyle: 
        """
        Interior style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.Style
        """
        pass

    @Style.setter
    def Style(
      self,
      _value: TGIS_PenStyle
    ) -> None: 
        """
        Interior style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.Style
        """
        pass

    @property
    def StyleAsText(
      self
    ) -> str: 
        """
        OutlineStyle. Grouping as a text property all properties that affect OutlineStyle 
        presentation like OutlineSymbol or OutlineStyle.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.StyleAsText
        """
        pass

    @StyleAsText.setter
    def StyleAsText(
      self,
      _value: str
    ) -> None: 
        """
        OutlineStyle. Grouping as a text property all properties that affect OutlineStyle 
        presentation like OutlineSymbol or OutlineStyle.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.StyleAsText
        """
        pass

    @property
    def Symbol(
      self
    ) -> TGIS_SymbolAbstract: 
        """
        Symbol used for drawing a line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.Symbol
        """
        pass

    @Symbol.setter
    def Symbol(
      self,
      _value: TGIS_SymbolAbstract
    ) -> None: 
        """
        Symbol used for drawing a line.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.Symbol
        """
        pass

    @property
    def SymbolGap(
      self
    ) -> int: 
        """
        Symbol gap (spacing) used for drawing a line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.SymbolGap
        """
        pass

    @SymbolGap.setter
    def SymbolGap(
      self,
      _value: int
    ) -> None: 
        """
        Symbol gap (spacing) used for drawing a line.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.SymbolGap
        """
        pass

    @property
    def SymbolGapAsText(
      self
    ) -> str: 
        """
        SymbolGap. Grouping as a text property all properties that affect SymbolGap presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.SymbolGapAsText
        """
        pass

    @SymbolGapAsText.setter
    def SymbolGapAsText(
      self,
      _value: str
    ) -> None: 
        """
        SymbolGap. Grouping as a text property all properties that affect SymbolGap presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.SymbolGapAsText
        """
        pass

    @property
    def SymbolRotate(
      self
    ) -> float: 
        """
        Symbol rotation, in radians, used for drawing a line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.SymbolRotate
        """
        pass

    @SymbolRotate.setter
    def SymbolRotate(
      self,
      _value: float
    ) -> None: 
        """
        Symbol rotation, in radians, used for drawing a line.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.SymbolRotate
        """
        pass

    @property
    def SymbolRotateAsText(
      self
    ) -> str: 
        """
        SymbolRotate. Grouping as a text property all properties that affect SymbolRotate 
        presentation like SymbolRotate or SymbolRotateEx and represent rotation in a human 
        readable form like ''45deg'', ''0.5rad''.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.SymbolRotateAsText
        """
        pass

    @SymbolRotateAsText.setter
    def SymbolRotateAsText(
      self,
      _value: str
    ) -> None: 
        """
        SymbolRotate. Grouping as a text property all properties that affect SymbolRotate 
        presentation like SymbolRotate or SymbolRotateEx and represent rotation in a human 
        readable form like ''45deg'', ''0.5rad''.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.SymbolRotateAsText
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        Interior width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.Width
        """
        pass

    @Width.setter
    def Width(
      self,
      _value: int
    ) -> None: 
        """
        Interior width.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.Width
        """
        pass

    @property
    def WidthAsText(
      self
    ) -> str: 
        """
        Width. Grouping as a text property all properties that affect Width presentation 
        like Width or and represent sizes in a human readable form like ''10pt'', ''3in''.Uses 
        AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.WidthAsText
        """
        pass

    @WidthAsText.setter
    def WidthAsText(
      self,
      _value: str
    ) -> None: 
        """
        Width. Grouping as a text property all properties that affect Width presentation 
        like Width or and represent sizes in a human readable form like ''10pt'', ''3in''.Uses 
        AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLine.WidthAsText
        """
        pass

class TGIS_ParamsArea( TGIS_ParamsFeature ):
    """
    Parameters that are common for Areas.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance with default values. Default: gray fill, outline black, 1 twips 
        width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.Create_void
        """
        pass

    @property
    def OutlineSymbol(
      self
    ) -> TGIS_SymbolAbstract: 
        """
        Symbol used for drawing an outline.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.OutlineSymbol
        """
        pass

    @OutlineSymbol.setter
    def OutlineSymbol(
      self,
      _value: TGIS_SymbolAbstract
    ) -> None: 
        """
        Symbol used for drawing an outline.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.OutlineSymbol
        """
        pass

    @property
    def OutlineSymbolGap(
      self
    ) -> int: 
        """
        Symbol gap (spacing) used for drawing an outline.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.OutlineSymbolGap
        """
        pass

    @OutlineSymbolGap.setter
    def OutlineSymbolGap(
      self,
      _value: int
    ) -> None: 
        """
        Symbol gap (spacing) used for drawing an outline.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.OutlineSymbolGap
        """
        pass

    @property
    def OutlineSymbolGapAsText(
      self
    ) -> str: 
        """
        OutlineSymbolGap. Grouping as a text property all properties that affect OutlineSymbolGap 
        presentation and represent sizes in a human readable form like ''10pt'', ''3in''.Uses 
        AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.OutlineSymbolGapAsText
        """
        pass

    @OutlineSymbolGapAsText.setter
    def OutlineSymbolGapAsText(
      self,
      _value: str
    ) -> None: 
        """
        OutlineSymbolGap. Grouping as a text property all properties that affect OutlineSymbolGap 
        presentation and represent sizes in a human readable form like ''10pt'', ''3in''.Uses 
        AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.OutlineSymbolGapAsText
        """
        pass

    @property
    def OutlineSymbolRotate(
      self
    ) -> float: 
        """
        Symbol rotation, in radians, used for drawing an outline.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.OutlineSymbolRotate
        """
        pass

    @OutlineSymbolRotate.setter
    def OutlineSymbolRotate(
      self,
      _value: float
    ) -> None: 
        """
        Symbol rotation, in radians, used for drawing an outline.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.OutlineSymbolRotate
        """
        pass

    @property
    def OutlineSymbolRotateAsText(
      self
    ) -> str: 
        """
        OutlineSymbolRotate. Grouping as a text property all properties that affect SymbolSize 
        presentation like OutlineSymbolRotate or OutlineSymbolRotateEx and represent rotation 
        in a human readable form like ''45deg'', ''0.5rad''.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.OutlineSymbolRotateAsText
        """
        pass

    @OutlineSymbolRotateAsText.setter
    def OutlineSymbolRotateAsText(
      self,
      _value: str
    ) -> None: 
        """
        OutlineSymbolRotate. Grouping as a text property all properties that affect SymbolSize 
        presentation like OutlineSymbolRotate or OutlineSymbolRotateEx and represent rotation 
        in a human readable form like ''45deg'', ''0.5rad''.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.OutlineSymbolRotateAsText
        """
        pass

    @property
    def Symbol(
      self
    ) -> TGIS_SymbolAbstract: 
        """
        Symbol used for drawing an interior.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.Symbol
        """
        pass

    @Symbol.setter
    def Symbol(
      self,
      _value: TGIS_SymbolAbstract
    ) -> None: 
        """
        Symbol used for drawing an interior.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.Symbol
        """
        pass

    @property
    def SymbolGap(
      self
    ) -> int: 
        """
        Symbol gap (spacing) used for drawing an interior.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.SymbolGap
        """
        pass

    @SymbolGap.setter
    def SymbolGap(
      self,
      _value: int
    ) -> None: 
        """
        Symbol gap (spacing) used for drawing an interior.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.SymbolGap
        """
        pass

    @property
    def SymbolGapAsText(
      self
    ) -> str: 
        """
        SymbolGap. Grouping as a text property all properties that affect SymbolGap presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.SymbolGapAsText
        """
        pass

    @SymbolGapAsText.setter
    def SymbolGapAsText(
      self,
      _value: str
    ) -> None: 
        """
        SymbolGap. Grouping as a text property all properties that affect SymbolGap presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.SymbolGapAsText
        """
        pass

    @property
    def SymbolRotate(
      self
    ) -> float: 
        """
        Symbol rotation, in radians, used for drawing an interior.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.SymbolRotate
        """
        pass

    @SymbolRotate.setter
    def SymbolRotate(
      self,
      _value: float
    ) -> None: 
        """
        Symbol rotation, in radians, used for drawing an interior.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.SymbolRotate
        """
        pass

    @property
    def SymbolRotateAsText(
      self
    ) -> str: 
        """
        SymbolRotate. Grouping as a text property all properties that affect SymbolRotate 
        presentation like SymbolRotate or SymbolRotateEx and represent rotation in a human 
        readable form like ''45deg'', ''0.5rad''.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.SymbolRotateAsText
        """
        pass

    @SymbolRotateAsText.setter
    def SymbolRotateAsText(
      self,
      _value: str
    ) -> None: 
        """
        SymbolRotate. Grouping as a text property all properties that affect SymbolRotate 
        presentation like SymbolRotate or SymbolRotateEx and represent rotation in a human 
        readable form like ''45deg'', ''0.5rad''.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.SymbolRotateAsText
        """
        pass

    @property
    def SymbolSize(
      self
    ) -> int: 
        """
        Symbol size used for drawing an interior.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.SymbolSize
        """
        pass

    @SymbolSize.setter
    def SymbolSize(
      self,
      _value: int
    ) -> None: 
        """
        Symbol size used for drawing an interior.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.SymbolSize
        """
        pass

    @property
    def SymbolSizeAsText(
      self
    ) -> str: 
        """
        SymbolSize. Grouping as a text property all properties that affect SymbolSize presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.SymbolSizeAsText
        """
        pass

    @SymbolSizeAsText.setter
    def SymbolSizeAsText(
      self,
      _value: str
    ) -> None: 
        """
        SymbolSize. Grouping as a text property all properties that affect SymbolSize presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsArea.SymbolSizeAsText
        """
        pass

class TGIS_ParamsMarker( TGIS_ParamsFeature ):
    """
    Parameters that are common for Markers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance with default values. Default: red gmsBox, size 150 twips, no outline.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker.Create_void
        """
        pass

    @property
    def Size(
      self
    ) -> int: 
        """
        Marker size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker.Size
        """
        pass

    @Size.setter
    def Size(
      self,
      _value: int
    ) -> None: 
        """
        Marker size.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker.Size
        """
        pass

    @property
    def SizeAsText(
      self
    ) -> str: 
        """
        Size. Grouping as a text property all properties that affect Size presentation like 
        Size or SizeEx and represent sizes in a human readable form like ''10pt'', ''3in''.Uses 
        AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker.SizeAsText
        """
        pass

    @SizeAsText.setter
    def SizeAsText(
      self,
      _value: str
    ) -> None: 
        """
        Size. Grouping as a text property all properties that affect Size presentation like 
        Size or SizeEx and represent sizes in a human readable form like ''10pt'', ''3in''.Uses 
        AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker.SizeAsText
        """
        pass

    @property
    def Style(
      self
    ) -> TGIS_MarkerStyle: 
        """
        Marker style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker.Style
        """
        pass

    @Style.setter
    def Style(
      self,
      _value: TGIS_MarkerStyle
    ) -> None: 
        """
        Marker style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker.Style
        """
        pass

    @property
    def StyleAsText(
      self
    ) -> str: 
        """
        Style. Grouping as a text property all properties that affect Style presentation 
        like Symbol or Style.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker.StyleAsText
        """
        pass

    @StyleAsText.setter
    def StyleAsText(
      self,
      _value: str
    ) -> None: 
        """
        Style. Grouping as a text property all properties that affect Style presentation 
        like Symbol or Style.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker.StyleAsText
        """
        pass

    @property
    def Symbol(
      self
    ) -> TGIS_SymbolAbstract: 
        """
        Symbol used for drawing a marker.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker.Symbol
        """
        pass

    @Symbol.setter
    def Symbol(
      self,
      _value: TGIS_SymbolAbstract
    ) -> None: 
        """
        Symbol used for drawing a marker.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker.Symbol
        """
        pass

    @property
    def SymbolRotate(
      self
    ) -> float: 
        """
        Symbol rotation in radians used for drawing a marker.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker.SymbolRotate
        """
        pass

    @SymbolRotate.setter
    def SymbolRotate(
      self,
      _value: float
    ) -> None: 
        """
        Symbol rotation in radians used for drawing a marker.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker.SymbolRotate
        """
        pass

    @property
    def SymbolRotateAsText(
      self
    ) -> str: 
        """
        SymbolRotate. Grouping as a text property all properties that affect SymbolSize presentation 
        like SymbolRotate or SymbolRotateEx and represent rotation in a human readable form 
        like ''45deg'', ''0.5rad''.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker.SymbolRotateAsText
        """
        pass

    @SymbolRotateAsText.setter
    def SymbolRotateAsText(
      self,
      _value: str
    ) -> None: 
        """
        SymbolRotate. Grouping as a text property all properties that affect SymbolSize presentation 
        like SymbolRotate or SymbolRotateEx and represent rotation in a human readable form 
        like ''45deg'', ''0.5rad''.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker.SymbolRotateAsText
        """
        pass

    @property
    def SymbolRotateIndirect(
      self
    ) -> bool: 
        """
        True if marker is rotated by attribute field.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsMarker.SymbolRotateIndirect
        """
        pass

class TGIS_ParamsLabelFont:
    """
    Helper object for deprecated TGIS_ParamsLabel.Font property.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabelFont
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabelFont.Create_void
        """
        pass

    def Assign(
      self,
      _source: TGIS_Font
    ) -> None: 
        """
        Assign value form font object

        Args:
            _source: source font object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabelFont.Assign_TGIS_Font
        """
        pass

    def FontSizeToPt(
      self,
      _value: int
    ) -> int: 
        """
        Convert font size in internal units to points.

        Args:
            _value: font size

        Returns:
            Font size expressed in points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabelFont.FontSizeToPt_Integer
        """
        pass

    def PtToFontSize(
      self,
      _value: int
    ) -> int: 
        """
        Convert points to font size.

        Args:
            _value: value in points

        Returns:
            Font size in internal units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabelFont.PtToFontSize_Integer
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Set/Get TGIS_ParamsLabel.FontColor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabelFont.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Set/Get TGIS_ParamsLabel.FontColor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabelFont.Color
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Set/Get TGIS_ParamsLabel.FontName.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabelFont.Name
        """
        pass

    @Name.setter
    def Name(
      self,
      _value: str
    ) -> None: 
        """
        Set/Get TGIS_ParamsLabel.FontName.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabelFont.Name
        """
        pass

    @property
    def Size(
      self
    ) -> int: 
        """
        Set/Get TGIS_ParamsLabel.FontSize with converting from point (as expected by TGIS_Font.Size) 
        to twips (as expected by TGIS_ParamsLabel.FontSize).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabelFont.Size
        """
        pass

    @Size.setter
    def Size(
      self,
      _value: int
    ) -> None: 
        """
        Set/Get TGIS_ParamsLabel.FontSize with converting from point (as expected by TGIS_Font.Size) 
        to twips (as expected by TGIS_ParamsLabel.FontSize).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabelFont.Size
        """
        pass

    @property
    def Style(
      self
    ) -> typing.Sequence[TGIS_FontStyle]: 
        """
        Set/Get TGIS_ParamsLabel.FontStyle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabelFont.Style
        """
        pass

    @Style.setter
    def Style(
      self,
      _value: typing.Sequence[TGIS_FontStyle]
    ) -> None: 
        """
        Set/Get TGIS_ParamsLabel.FontStyle

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabelFont.Style
        """
        pass

class TGIS_ParamsLabel( TGIS_ParamsFeature ):
    """
    Parameters that are common for Labels.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance with default values. Default: yellow background, outline of 1 
        twip, black, Arial 8pt, single line, located glpUpRight, maximum size of 100x800 
        twips.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Create_void
        """
        pass

    @property
    def Alignment(
      self
    ) -> TGIS_LabelAlignment: 
        """
        Alignment of text within a label.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Alignment
        """
        pass

    @Alignment.setter
    def Alignment(
      self,
      _value: TGIS_LabelAlignment
    ) -> None: 
        """
        Alignment of text within a label.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Alignment
        """
        pass

    @property
    def Allocator(
      self
    ) -> bool: 
        """
        Use allocator to avoid overlapping.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Allocator
        """
        pass

    @Allocator.setter
    def Allocator(
      self,
      _value: bool
    ) -> None: 
        """
        Use allocator to avoid overlapping.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Allocator
        """
        pass

    @property
    def Duplicates(
      self
    ) -> bool: 
        """
        If False then duplicated label will not be visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Duplicates
        """
        pass

    @Duplicates.setter
    def Duplicates(
      self,
      _value: bool
    ) -> None: 
        """
        If False then duplicated label will not be visible.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Duplicates
        """
        pass

    @property
    def Field(
      self
    ) -> str: 
        """
        Database field from which a label can be retrieved.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Field
        """
        pass

    @Field.setter
    def Field(
      self,
      _value: str
    ) -> None: 
        """
        Database field from which a label can be retrieved.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Field
        """
        pass

    @property
    def Font(
      self
    ) -> TGIS_ParamsLabelFont: 
        """
        Font for label. Assigning a new value will destroy existing one and call Assign for 
        a new value on a newly created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Font
        """
        pass

    @property
    def FontColor(
      self
    ) -> TGIS_Color: 
        """
        Font color for label.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.FontColor
        """
        pass

    @FontColor.setter
    def FontColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Font color for label.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.FontColor
        """
        pass

    @property
    def FontColorAsText(
      self
    ) -> str: 
        """
        Font.Color. Grouping as a text property all properties that affect Font.Color presentation.Uses 
        AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.FontColorAsText
        """
        pass

    @FontColorAsText.setter
    def FontColorAsText(
      self,
      _value: str
    ) -> None: 
        """
        Font.Color. Grouping as a text property all properties that affect Font.Color presentation.Uses 
        AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.FontColorAsText
        """
        pass

    @property
    def FontName(
      self
    ) -> str: 
        """
        Font name for label.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.FontName
        """
        pass

    @FontName.setter
    def FontName(
      self,
      _value: str
    ) -> None: 
        """
        Font name for label.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.FontName
        """
        pass

    @property
    def FontSize(
      self
    ) -> int: 
        """
        Font size for label.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.FontSize
        """
        pass

    @FontSize.setter
    def FontSize(
      self,
      _value: int
    ) -> None: 
        """
        Font size for label.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.FontSize
        """
        pass

    @property
    def FontSizeAsText(
      self
    ) -> str: 
        """
        FontSize. Grouping as a text property all properties that affect Font.Size presentation.Uses 
        AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.FontSizeAsText
        """
        pass

    @FontSizeAsText.setter
    def FontSizeAsText(
      self,
      _value: str
    ) -> None: 
        """
        FontSize. Grouping as a text property all properties that affect Font.Size presentation.Uses 
        AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.FontSizeAsText
        """
        pass

    @property
    def FontStyle(
      self
    ) -> typing.Sequence[TGIS_FontStyle]: 
        """
        Font style for label.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.FontStyle
        """
        pass

    @FontStyle.setter
    def FontStyle(
      self,
      _value: typing.Sequence[TGIS_FontStyle]
    ) -> None: 
        """
        Font style for label.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.FontStyle
        """
        pass

    @property
    def Height(
      self
    ) -> int: 
        """
        Maximum height of label.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Height
        """
        pass

    @Height.setter
    def Height(
      self,
      _value: int
    ) -> None: 
        """
        Maximum height of label.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Height
        """
        pass

    @property
    def HeightAsText(
      self
    ) -> str: 
        """
        Height. Grouping as a text property all properties that affect Height presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.HeightAsText
        """
        pass

    @HeightAsText.setter
    def HeightAsText(
      self,
      _value: str
    ) -> None: 
        """
        Height. Grouping as a text property all properties that affect Height presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.HeightAsText
        """
        pass

    @property
    def Position(
      self
    ) -> typing.Sequence[TGIS_LabelPosition]: 
        """
        Position of Label.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Position
        """
        pass

    @Position.setter
    def Position(
      self,
      _value: typing.Sequence[TGIS_LabelPosition]
    ) -> None: 
        """
        Position of Label.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Position
        """
        pass

    @property
    def PositionAsText(
      self
    ) -> str: 
        """
        Position. Grouping as a text property all properties that affect Position presentation.Uses 
        AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.PositionAsText
        """
        pass

    @PositionAsText.setter
    def PositionAsText(
      self,
      _value: str
    ) -> None: 
        """
        Position. Grouping as a text property all properties that affect Position presentation.Uses 
        AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.PositionAsText
        """
        pass

    @property
    def Rotate(
      self
    ) -> float: 
        """
        Rotation angle in radians.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Rotate
        """
        pass

    @Rotate.setter
    def Rotate(
      self,
      _value: float
    ) -> None: 
        """
        Rotation angle in radians.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Rotate
        """
        pass

    @property
    def RotateAsText(
      self
    ) -> str: 
        """
        Rotate. Grouping as a text property all properties that affect Rotate presentation 
        like Rotate or RotateEx and represent rotation in a human readable form like ''45deg'', 
        ''0.5rad''.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.RotateAsText
        """
        pass

    @RotateAsText.setter
    def RotateAsText(
      self,
      _value: str
    ) -> None: 
        """
        Rotate. Grouping as a text property all properties that affect Rotate presentation 
        like Rotate or RotateEx and represent rotation in a human readable form like ''45deg'', 
        ''0.5rad''.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.RotateAsText
        """
        pass

    @property
    def RotateIndirect(
      self
    ) -> bool: 
        """
        True if label is rotated by attribute field.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.RotateIndirect
        """
        pass

    @property
    def Shield(
      self
    ) -> TGIS_SymbolAbstract: 
        """
        Label shield.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Shield
        """
        pass

    @Shield.setter
    def Shield(
      self,
      _value: TGIS_SymbolAbstract
    ) -> None: 
        """
        Label shield.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Shield
        """
        pass

    @property
    def ShieldAsText(
      self
    ) -> str: 
        """
        Label shield. Grouping as a text property all properties that affect Label.Shield 
        presentation.Uses AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.ShieldAsText
        """
        pass

    @ShieldAsText.setter
    def ShieldAsText(
      self,
      _value: str
    ) -> None: 
        """
        Label shield. Grouping as a text property all properties that affect Label.Shield 
        presentation.Uses AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.ShieldAsText
        """
        pass

    @property
    def Value(
      self
    ) -> str: 
        """
        Label format String in a form ''{FIELD_NAME} html text''.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Value
        """
        pass

    @Value.setter
    def Value(
      self,
      _value: str
    ) -> None: 
        """
        Label format String in a form ''{FIELD_NAME} html text''.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Value
        """
        pass

    @property
    def Visible(
      self
    ) -> bool: 
        """
        If False, then label will not be visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Visible
        """
        pass

    @Visible.setter
    def Visible(
      self,
      _value: bool
    ) -> None: 
        """
        If False, then label will not be visible.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Visible
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        Maximum width of label.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Width
        """
        pass

    @Width.setter
    def Width(
      self,
      _value: int
    ) -> None: 
        """
        Maximum width of label.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.Width
        """
        pass

    @property
    def WidthAsText(
      self
    ) -> str: 
        """
        Width. Grouping as a text property all properties that affect Width presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.WidthAsText
        """
        pass

    @WidthAsText.setter
    def WidthAsText(
      self,
      _value: str
    ) -> None: 
        """
        Width. Grouping as a text property all properties that affect Width presentation 
        and represent sizes in a human readable form like ''10pt'', ''3in''.Uses AsText parameter 
        syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsLabel.WidthAsText
        """
        pass

class TGIS_ParamsChart( TGIS_ParamsFeature ):
    """
    Parameters that are common for Charts.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance with default values. Default: size 0, type PIE.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.Create_void
        """
        pass

    @property
    def ColorsInternal(
      self
    ) -> TGIS_ColorArray: 
        """
        Internal color storage.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.ColorsInternal
        """
        pass

    @ColorsInternal.setter
    def ColorsInternal(
      self,
      _value: TGIS_ColorArray
    ) -> None: 
        """
        Internal color storage.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.ColorsInternal
        """
        pass

    @property
    def ValuesInternal(
      self
    ) -> TGIS_DoubleArray: 
        """
        Internal values storage.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.ValuesInternal
        """
        pass

    @ValuesInternal.setter
    def ValuesInternal(
      self,
      _value: TGIS_DoubleArray
    ) -> None: 
        """
        Internal values storage.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.ValuesInternal
        """
        pass

    @property
    def Colors(
      self
    ) -> str: 
        """
        Color of the chart elements.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.Colors
        """
        pass

    @Colors.setter
    def Colors(
      self,
      _value: str
    ) -> None: 
        """
        Color of the chart elements.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.Colors
        """
        pass

    @property
    def Legend(
      self
    ) -> str: 
        """
        Legend text.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.Legend
        """
        pass

    @Legend.setter
    def Legend(
      self,
      _value: str
    ) -> None: 
        """
        Legend text.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.Legend
        """
        pass

    @property
    def Size(
      self
    ) -> int: 
        """
        Size of the chart.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.Size
        """
        pass

    @Size.setter
    def Size(
      self,
      _value: int
    ) -> None: 
        """
        Size of the chart.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.Size
        """
        pass

    @property
    def SizeAsText(
      self
    ) -> str: 
        """
        Size of the chart. Grouping as a text property all properties that affect Size presentation 
        like Size or SizeEx and represent sizes in a human readable form like ''10pt'', ''3in''.Uses 
        AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.SizeAsText
        """
        pass

    @SizeAsText.setter
    def SizeAsText(
      self,
      _value: str
    ) -> None: 
        """
        Size of the chart. Grouping as a text property all properties that affect Size presentation 
        like Size or SizeEx and represent sizes in a human readable form like ''10pt'', ''3in''.Uses 
        AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.SizeAsText
        """
        pass

    @property
    def Style(
      self
    ) -> TGIS_ChartStyle: 
        """
        Style of the chart.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.Style
        """
        pass

    @Style.setter
    def Style(
      self,
      _value: TGIS_ChartStyle
    ) -> None: 
        """
        Style of the chart.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.Style
        """
        pass

    @property
    def Values(
      self
    ) -> str: 
        """
        Chart values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.Values
        """
        pass

    @Values.setter
    def Values(
      self,
      _value: str
    ) -> None: 
        """
        Chart values.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsChart.Values
        """
        pass

class TGIS_ParamsSection( TGIS_ParamsAbstract ):
    """
    Grouped parameters.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.Create_void
        """
        pass

    @property
    def InternalIndex(
      self
    ) -> int: 
        """
        Only for internal use of TatukGIS.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.InternalIndex
        """
        pass

    @InternalIndex.setter
    def InternalIndex(
      self,
      _value: int
    ) -> None: 
        """
        Only for internal use of TatukGIS.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.InternalIndex
        """
        pass

    @property
    def FalseZ(
      self
    ) -> float: 
        """
        Z coordinate offset (for 3D mode); Default is 0.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.FalseZ
        """
        pass

    @FalseZ.setter
    def FalseZ(
      self,
      _value: float
    ) -> None: 
        """
        Z coordinate offset (for 3D mode); Default is 0.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.FalseZ
        """
        pass

    @property
    def FalseZAsText(
      self
    ) -> str: 
        """
        FalseZ. Grouping as a text property all properties that affect FalseZ presentation.Uses 
        AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.FalseZAsText
        """
        pass

    @FalseZAsText.setter
    def FalseZAsText(
      self,
      _value: str
    ) -> None: 
        """
        FalseZ. Grouping as a text property all properties that affect FalseZ presentation.Uses 
        AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.FalseZAsText
        """
        pass

    @property
    def Legend(
      self
    ) -> str: 
        """
        Text for caption in legend component.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.Legend
        """
        pass

    @Legend.setter
    def Legend(
      self,
      _value: str
    ) -> None: 
        """
        Text for caption in legend component.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.Legend
        """
        pass

    @property
    def MaxLevel(
      self
    ) -> float: 
        """
        Ending visibility level. If not in range -128..128 then used instead of MaxScale 
        or MaxZoom.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.MaxLevel
        """
        pass

    @MaxLevel.setter
    def MaxLevel(
      self,
      _value: float
    ) -> None: 
        """
        Ending visibility level. If not in range -128..128 then used instead of MaxScale 
        or MaxZoom.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.MaxLevel
        """
        pass

    @property
    def MaxScale(
      self
    ) -> float: 
        """
        Ending visibility zoom. If &lt;&gt; 0 then used instead of MinLevel or MaxZoom.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.MaxScale
        """
        pass

    @MaxScale.setter
    def MaxScale(
      self,
      _value: float
    ) -> None: 
        """
        Ending visibility zoom. If &lt;&gt; 0 then used instead of MinLevel or MaxZoom.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.MaxScale
        """
        pass

    @property
    def MaxZoom(
      self
    ) -> float: 
        """
        Ending visibility zoom; if positive, then value refers to pixels; If negative then 
        value refers to twips (1/1440 of inch). Zoom must be in MinZoom..MaxZoom to make 
        the layer visible. See also MaxLevel or MaxScale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.MaxZoom
        """
        pass

    @MaxZoom.setter
    def MaxZoom(
      self,
      _value: float
    ) -> None: 
        """
        Ending visibility zoom; if positive, then value refers to pixels; If negative then 
        value refers to twips (1/1440 of inch). Zoom must be in MinZoom..MaxZoom to make 
        the layer visible. See also MaxLevel or MaxScale.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.MaxZoom
        """
        pass

    @property
    def MinLevel(
      self
    ) -> float: 
        """
        Starting visibility level. If not in range -128..128 then used instead of MinScale 
        or MinZoom.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.MinLevel
        """
        pass

    @MinLevel.setter
    def MinLevel(
      self,
      _value: float
    ) -> None: 
        """
        Starting visibility level. If not in range -128..128 then used instead of MinScale 
        or MinZoom.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.MinLevel
        """
        pass

    @property
    def MinScale(
      self
    ) -> float: 
        """
        Starting visibility zoom. If &lt;&gt; 0 then used instead of MinLevel or MinZoom.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.MinScale
        """
        pass

    @MinScale.setter
    def MinScale(
      self,
      _value: float
    ) -> None: 
        """
        Starting visibility zoom. If &lt;&gt; 0 then used instead of MinLevel or MinZoom.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.MinScale
        """
        pass

    @property
    def MinZoom(
      self
    ) -> float: 
        """
        Starting visibility zoom; if positive, then value refers to pixels; If negative then 
        value refers to twips (1/1440 of inch). Zoom must be in MinZoom..MaxZoom to make 
        the layer visible. See also MaxLevel or MaxScale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.MinZoom
        """
        pass

    @MinZoom.setter
    def MinZoom(
      self,
      _value: float
    ) -> None: 
        """
        Starting visibility zoom; if positive, then value refers to pixels; If negative then 
        value refers to twips (1/1440 of inch). Zoom must be in MinZoom..MaxZoom to make 
        the layer visible. See also MaxLevel or MaxScale.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.MinZoom
        """
        pass

    @property
    def NormalizedZ(
      self
    ) -> TGIS_3DNormalizationType: 
        """
        If not Off then Z coordinated scaling should be normalized according to viewer size. 
        Useful for data which Z coordinate does not represent heights. Default is Off.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.NormalizedZ
        """
        pass

    @NormalizedZ.setter
    def NormalizedZ(
      self,
      _value: TGIS_3DNormalizationType
    ) -> None: 
        """
        If not Off then Z coordinated scaling should be normalized according to viewer size. 
        Useful for data which Z coordinate does not represent heights. Default is Off.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.NormalizedZ
        """
        pass

    @property
    def ScaleZ(
      self
    ) -> float: 
        """
        Z coordinate scaling (for 3D mode); Default is 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.ScaleZ
        """
        pass

    @ScaleZ.setter
    def ScaleZ(
      self,
      _value: float
    ) -> None: 
        """
        Z coordinate scaling (for 3D mode); Default is 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.ScaleZ
        """
        pass

    @property
    def Shape(
      self
    ) -> TObject: 
        """
        assigned shape if parameter is on a shape level; nil if parameter is on a layer level.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.Shape
        """
        pass

    @Shape.setter
    def Shape(
      self,
      _value: TObject
    ) -> None: 
        """
        assigned shape if parameter is on a shape level; nil if parameter is on a layer level.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.Shape
        """
        pass

    @property
    def Style(
      self
    ) -> str: 
        """
        Style name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.Style
        """
        pass

    @Style.setter
    def Style(
      self,
      _value: str
    ) -> None: 
        """
        Style name.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.Style
        """
        pass

    @property
    def Visible(
      self
    ) -> bool: 
        """
        Checks whether a layer section is visible. Combined with other properties like MinLevel 
        / MaxLevel or MinScale / MaxScale can define a rule that determinates the layer visibility.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.Visible
        """
        pass

    @Visible.setter
    def Visible(
      self,
      _value: bool
    ) -> None: 
        """
        Checks whether a layer section is visible. Combined with other properties like MinLevel 
        / MaxLevel or MinScale / MaxScale can define a rule that determinates the layer visibility.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSection.Visible
        """
        pass

class TGIS_ParamsSectionVector( TGIS_ParamsSection ):
    """
    Section parameters for vectors.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance with default values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.Create_void
        """
        pass

    @property
    def Area(
      self
    ) -> TGIS_ParamsArea: 
        """
        Area parameters object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.Area
        """
        pass

    @property
    def Basement(
      self
    ) -> TGIS_3DBasementType: 
        """
        Basement enforcement (for 3D mode).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.Basement
        """
        pass

    @Basement.setter
    def Basement(
      self,
      _value: TGIS_3DBasementType
    ) -> None: 
        """
        Basement enforcement (for 3D mode).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.Basement
        """
        pass

    @property
    def Chart(
      self
    ) -> TGIS_ParamsChart: 
        """
        Chart parameters object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.Chart
        """
        pass

    @property
    def FalseM(
      self
    ) -> float: 
        """
        M coordinate offset (for 3D mode); Default is 0.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.FalseM
        """
        pass

    @FalseM.setter
    def FalseM(
      self,
      _value: float
    ) -> None: 
        """
        M coordinate offset (for 3D mode); Default is 0.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.FalseM
        """
        pass

    @property
    def FalseMAsText(
      self
    ) -> str: 
        """
        FalseM. Grouping as a text property all properties that affect FalseM presentation.Uses 
        AsText parameter syntax.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.FalseMAsText
        """
        pass

    @FalseMAsText.setter
    def FalseMAsText(
      self,
      _value: str
    ) -> None: 
        """
        FalseM. Grouping as a text property all properties that affect FalseM presentation.Uses 
        AsText parameter syntax.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.FalseMAsText
        """
        pass

    @property
    def Ground(
      self
    ) -> TGIS_3DGroundType: 
        """
        Ground relation mode (for 3D mode).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.Ground
        """
        pass

    @Ground.setter
    def Ground(
      self,
      _value: TGIS_3DGroundType
    ) -> None: 
        """
        Ground relation mode (for 3D mode).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.Ground
        """
        pass

    @property
    def Labels(
      self
    ) -> TGIS_ParamsLabel: 
        """
        Labels parameters object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.Labels
        """
        pass

    @property
    def Line(
      self
    ) -> TGIS_ParamsLine: 
        """
        Line parameters object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.Line
        """
        pass

    @property
    def Marker(
      self
    ) -> TGIS_ParamsMarker: 
        """
        Marker parameters object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.Marker
        """
        pass

    @property
    def NormalizedM(
      self
    ) -> TGIS_3DNormalizationType: 
        """
        If no Off then M coordinated scaling should be normalized according to viewer size. 
        Useful for data which M coordinate does not represent heights. Default is False.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.NormalizedM
        """
        pass

    @NormalizedM.setter
    def NormalizedM(
      self,
      _value: TGIS_3DNormalizationType
    ) -> None: 
        """
        If no Off then M coordinated scaling should be normalized according to viewer size. 
        Useful for data which M coordinate does not represent heights. Default is False.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.NormalizedM
        """
        pass

    @property
    def Query(
      self
    ) -> str: 
        """
        Expression which describes when the section is active. Expression must return a boolean 
        value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.Query
        """
        pass

    @Query.setter
    def Query(
      self,
      _value: str
    ) -> None: 
        """
        Expression which describes when the section is active. Expression must return a boolean 
        value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.Query
        """
        pass

    @property
    def Render(
      self
    ) -> TGIS_ParamsRender: 
        """
        Render parameters object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.Render
        """
        pass

    @property
    def ScaleM(
      self
    ) -> float: 
        """
        M coordinate scaling (for 3D mode); Default is 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.ScaleM
        """
        pass

    @ScaleM.setter
    def ScaleM(
      self,
      _value: float
    ) -> None: 
        """
        M coordinate scaling (for 3D mode); Default is 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionVector.ScaleM
        """
        pass

class TGIS_ParamsSectionPixel( TGIS_ParamsSection ):
    """
    Section parameters for pixels.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionPixel
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance with default values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionPixel.Create_void
        """
        pass

    @property
    def Pixel(
      self
    ) -> TGIS_ParamsPixel: 
        """
        Pixel parameters set which belongs to the section.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsSectionPixel.Pixel
        """
        pass

class TGIS_ParamsList( TObject ):
    """
    List of parameters (sections).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.Create_void
        """
        pass

    def Add(
      self
    ) -> None: 
        """
        Add a new empty section to the tail.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.Add_void
        """
        pass

    def Assign(
      self,
      _params: TGIS_ParamsList
    ) -> None: 
        """
        Assign another TGIS_ParamsList to the current object.

        Args:
            _params: list to be assigned from

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.Assign_TGIS_ParamsList
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list. Delete all items except the first one (main section).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.Clear_void
        """
        pass

    def ClearAndSetDefaults(
      self
    ) -> None: 
        """
        Clear the list and set default parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.ClearAndSetDefaults_void
        """
        pass

    def Delete(
      self
    ) -> None: 
        """
        Delete selected section.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.Delete_void
        """
        pass

    def Exchange(
      self,
      _index1: int,
      _index2: int
    ) -> None: 
        """
        Swaps the position of two items on the list.

        Args:
            _index1: first item
            _index2: second item

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.Exchange_Integer_Integer
        """
        pass

    def IsModified(
      self
    ) -> bool: 
        """
        Indicates whether the initial serial was modified (Params was touched).

        Returns:
            True if modified.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.IsModified_void
        """
        pass

    @overload
    def LoadFromConfig(
      self,
      _cfg: TGIS_ConfigAbstract
    ) -> None: 
        """
        Load parameters from the configuration file.

        Args:
            _cfg: source configuration file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.LoadFromConfig_TGIS_ConfigAbstract
        """
        pass

    @overload
    def LoadFromConfig(
      self,
      _cfg: TGIS_ConfigAbstract,
      _subLayer: bool
    ) -> None: 
        """
        Load parameters from the configuration file.

        Args:
            _cfg: source configuration file
            _subLayer: True if load sublayers

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.LoadFromConfig_TGIS_ConfigAbstract_Boolean
        """
        pass

    @overload
    def LoadFromConfig(
      self,
      _cfg: TGIS_ConfigAbstract,
      _subLayer: bool,
      _groups: bool
    ) -> None: 
        """
        Load parameters from the configuration file.

        Args:
            _cfg: source configuration file
            _subLayer: True if load sublayers
            _groups: True if load groups

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.LoadFromConfig_TGIS_ConfigAbstract_Boolean_Boolean
        """
        pass

    def LoadFromFile(
      self,
      _path: str
    ) -> None: 
        """
        Load parameters from the configuration file.

        Args:
            _path: source configuration file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.LoadFromFile_String
        """
        pass

    def LoadFromStrings(
      self,
      _str: TGIS_StringList
    ) -> None: 
        """
        Load parameters from a list of strings.

        Args:
            _str: source list of strings

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.LoadFromStrings_TStrings
        """
        pass

    def ResetSerial(
      self
    ) -> None: 
        """
        Reset serial numer conter.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.ResetSerial_void
        """
        pass

    @overload
    def SaveToConfig(
      self,
      _cfg: TGIS_ConfigAbstract
    ) -> None: 
        """
        Save parameters into the configuration file.

        Args:
            _cfg: destination configuration file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.SaveToConfig_TGIS_ConfigAbstract
        """
        pass

    @overload
    def SaveToConfig(
      self,
      _cfg: TGIS_ConfigAbstract,
      _subLayer: bool
    ) -> None: 
        """
        Save parameters into the configuration file.

        Args:
            _cfg: destination configuration file
            _subLayer: True if save sublayers

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.SaveToConfig_TGIS_ConfigAbstract_Boolean
        """
        pass

    @overload
    def SaveToConfig(
      self,
      _cfg: TGIS_ConfigAbstract,
      _subLayer: bool,
      _groups: bool
    ) -> None: 
        """
        Save parameters into the configuration file.

        Args:
            _cfg: destination configuration file
            _subLayer: True if save sublayers
            _groups: True if save groups

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.SaveToConfig_TGIS_ConfigAbstract_Boolean_Boolean
        """
        pass

    def SaveToFile(
      self,
      _path: str
    ) -> None: 
        """
        Save parameters into the configuration file.

        Args:
            _path: destination configuration file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.SaveToFile_String
        """
        pass

    def SaveToStrings(
      self,
      _str: TGIS_StringList
    ) -> None: 
        """
        Save parameters into a list of strings.

        Args:
            _str: destination list of strings

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.SaveToStrings_TStrings
        """
        pass

    def SetUp(
      self,
      _params: TGIS_ParamsSection
    ) -> None: 
        """
        Prepare list by assigning a main section.

        Args:
            _params: main section to be assigned

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.SetUp_TGIS_ParamsSection
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Count of sections on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.Count
        """
        pass

    
    def Items(
      self,
      _idx: int
    ) -> TGIS_ParamsSection: 
        """
        Direct access to the item by using array like operations.

        Args:
            _idx: index of item

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.Items
        """
        pass

    
    def Items(
      self,
      _idx: int,
      _value: TGIS_ParamsSection
    ) -> None: 
        """
        Direct access to the item by using array like operations.

        Args:
            _idx: index of item

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.Items
        """
        pass

    @property
    def Layer(
      self
    ) -> TObject: 
        """
        Layer associated with this list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.Layer
        """
        pass

    @Layer.setter
    def Layer(
      self,
      _value: TObject
    ) -> None: 
        """
        Layer associated with this list.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.Layer
        """
        pass

    @property
    def Selected(
      self
    ) -> int: 
        """
        Index of selected (active) item.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.Selected
        """
        pass

    @Selected.setter
    def Selected(
      self,
      _value: int
    ) -> None: 
        """
        Index of selected (active) item.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.Selected
        """
        pass

    @property
    def SelectedObj(
      self
    ) -> TGIS_ParamsSection: 
        """
        Select (active) object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.SelectedObj
        """
        pass

    @SelectedObj.setter
    def SelectedObj(
      self,
      _value: TGIS_ParamsSection
    ) -> None: 
        """
        Select (active) object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.SelectedObj
        """
        pass

    @property
    def Serial(
      self
    ) -> int: 
        """
        Serial number updated after any property change. Used to identify if object was changed. 
        Used by legend control for smart updates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ParamsList.Serial
        """
        pass

class TGIS_PipelineParameterType:
    pass

class TGIS_PipelineParameterType:
    """
    Types of pipeline parameters

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameterType
    """

    @property
    def String(
      self
    ) -> TGIS_PipelineParameterType: 
        """
        string value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameterType.String
        """
        pass

    @property
    def Int(
      self
    ) -> TGIS_PipelineParameterType: 
        """
        integer values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameterType.Int
        """
        pass

    @property
    def Float(
      self
    ) -> TGIS_PipelineParameterType: 
        """
        float value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameterType.Float
        """
        pass

    @property
    def Boolean(
      self
    ) -> TGIS_PipelineParameterType: 
        """
        boolean value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameterType.Boolean
        """
        pass

class TGIS_PipelineParameterList:
    """
    List of TGIS_PipelineParameter objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameterList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_PipelineParameter:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_PipelineParameter
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameterList.Create_void
        """
        pass

    def Add(
      self,
      _item: TGIS_PipelineParameter
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameterList.Add_TGIS_PipelineParameter
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameterList.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameterList.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameterList.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> TGIS_PipelineParameter: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameterList.Item
        """
        pass

class TGIS_PipelineParameter:
    """
    Pipeline parameter encapsulation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameter
    """

    @overload
    def __init__(
      self,
      _name: str,
      _type: TGIS_PipelineParameterType,
      _min: float,
      _max: float,
      _required: bool,
      _default: str,
      _predefined: str
    ) -> None: 
        """
        Define pipeline parameter.

        Args:
            _name: name of the parameter
            _type: type of the parameter
            _min: minimum value of the parameter; NaN if undefined
            _max: maximum value of the parameter; NaN if undefined
            _required: True if parameter is obligatory
            _default: default value of the parameter used, empty string if not defined
            _predefined: list of predefined values to be selected from, separated by ''|''; if 
              the list starts from ''!'' character then list is strict - only only provided values 
              are supported

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameter.Create_String_TGIS_PipelineParameterType_Double_Double_Boolean_String_String
        """
        pass

    @property
    def Default(
      self
    ) -> str: 
        """
        Default value for the parameter.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameter.Default
        """
        pass

    @property
    def Max(
      self
    ) -> float: 
        """
        Maximum allowed value for numeric parameters. If NaN hen undefined.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameter.Max
        """
        pass

    @property
    def Min(
      self
    ) -> float: 
        """
        Minimum allowed value for numeric parameters. If NaN hen undefined.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameter.Min
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Parameter name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameter.Name
        """
        pass

    @property
    def Predefined(
      self
    ) -> str: 
        """
        Value of the parameter.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameter.Predefined
        """
        pass

    @property
    def Required(
      self
    ) -> bool: 
        """
        If true, then parameter is required.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameter.Required
        """
        pass

    @property
    def Type(
      self
    ) -> TGIS_PipelineParameterType: 
        """
        Parameter type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameter.Type
        """
        pass

    @property
    def Value(
      self
    ) -> str: 
        """
        Value of the parameter.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameter.Value
        """
        pass

    @Value.setter
    def Value(
      self,
      _value: str
    ) -> None: 
        """
        Value of the parameter.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineParameter.Value
        """
        pass

class TGIS_PipelineOperationAbstract( TObject ):
    """
    Single pipeline operation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineOperationAbstract
    """

    @overload
    def __init__(
      self,
      _pipeline: TGIS_Pipeline,
      _name: str,
      _line: int
    ) -> None: 
        """
        Standard constructor

        Args:
            _pipeline: pipeline engine on which operation will be performed
            _name: unique name of the operation
            _line: source code line number

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineOperationAbstract.Create_TGIS_Pipeline_String_Integer
        """
        pass

    def AsText(
      self
    ) -> str: 
        """
        Show operation as a command line text (with all parameters).

        Returns:
            Complete command line with parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineOperationAbstract.AsText_void
        """
        pass

    def Execute(
      self
    ) -> None: 
        """
        Execute operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineOperationAbstract.Execute_void
        """
        pass

    def Parse(
      self,
      _command: str
    ) -> None: 
        """
        Parse command

        Args:
            _command: command line including operation name and parameters

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineOperationAbstract.Parse_String
        """
        pass

    def ShowForm(
      self
    ) -> None: 
        """
        Lunch UI form with all parameters to allow interactive operation definition.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineOperationAbstract.ShowForm_void
        """
        pass

    @property
    def Line(
      self
    ) -> int: 
        """
        Executing line in TGIS_Pipeline

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineOperationAbstract.Line
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Name of operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineOperationAbstract.Name
        """
        pass

    @property
    def Params(
      self
    ) -> TGIS_PipelineParameterList: 
        """
        List of all parameters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineOperationAbstract.Params
        """
        pass

    @property
    def Parent(
      self
    ) -> TGIS_Pipeline: 
        """
        Attached pipeline engine

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineOperationAbstract.Parent
        """
        pass

    @property
    def Result(
      self
    ) -> bool: 
        """
        True if execution was successful.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineOperationAbstract.Result
        """
        pass

    @Result.setter
    def Result(
      self,
      _value: bool
    ) -> None: 
        """
        True if execution was successful.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineOperationAbstract.Result
        """
        pass

class TGIS_PipelineOperationExtendedAbstract( TGIS_PipelineOperationAbstract ):
    """
    Pipeline base process operation that provides: * defining 3 params: "Source", "Destination" 
    and "Save" * destination layer saving if needed.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineOperationExtendedAbstract
    """

class TGIS_PipelineOperations( TObject ):
    """
    Registration list of all pipeline operations.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineOperations
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineOperations.Create_void
        """
        pass

    @property
    def Names(
      self
    ) -> TGIS_StringList: 
        """
        List of all pipeline operations names.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PipelineOperations.Names
        """
        pass

class TGIS_Pipeline( TObject ):
    """
    Pipeline engine.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.Create_void
        """
        pass

    @overload
    def Execute(
      self
    ) -> bool: 
        """
        Execute pipeline operations.

        Returns:
            True if pipeline execution was completed successfully; False otherwise.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.Execute_void
        """
        pass

    @overload
    def Execute(
      self,
      _command: str,
      _line: int
    ) -> bool: 
        """
        Execute a single pipeline operation.

        Args:
            _command: full command line for the pipeline operation
            _line: line number in a source code; used for reference purposes

        Returns:
            True if pipeline execution was completed successfully; False otherwise/

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.Execute_String_Integer
        """
        pass

    def GetVar(
      self,
      _name: str
    ) -> TObject: 
        """
        Get global variable

        Args:
            _name: _name of the variable (case insensitive)

        Returns:
            value of the variable or nil if variable does not exists

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.GetVar_String
        """
        pass

    def Parse(
      self,
      _command: str,
      _line: int
    ) -> TGIS_PipelineOperationAbstract: 
        """
        Parse text command and create an operation.

        Args:
            _command: full command line for the pipeline operation
            _line: line number in a source code; used for reference purposes

        Returns:
            Create pipeline operation object or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.Parse_String_Integer
        """
        pass

    def SetVar(
      self,
      _name: str,
      _obj: TObject
    ) -> None: 
        """
        Set a global variable

        Args:
            _name: _name of the variable (case insensitive)
            _obj: value of the variable

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.SetVar_String_TObject
        """
        pass

    @overload
    def ShowForm(
      self,
      _line: int
    ) -> None: 
        """
        Lunch UI form with all parameters to allow interactive operation definition.

        Args:
            _line: line number in a source code for which form must be presented

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.ShowForm_Integer
        """
        pass

    @overload
    def ShowForm(
      self,
      _command: str,
      _line: int
    ) -> None: 
        """
        Lunch UI form with all parameters to allow interactive operation definition.

        Args:
            _command: full command line for the pipeline operation
            _line: line number in a source code; used for reference purposes

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.ShowForm_String_Integer
        """
        pass

    @property
    def GIS(
      self
    ) -> IGIS_Viewer: 
        """
        GIS Viewer on which pipeline operations will be performed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.GIS
        """
        pass

    @GIS.setter
    def GIS(
      self,
      _value: IGIS_Viewer
    ) -> None: 
        """
        GIS Viewer on which pipeline operations will be performed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.GIS
        """
        pass

    @property
    def SourceCode(
      self
    ) -> str: 
        """
        Source code of pipeline operations separated by CR LF.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.SourceCode
        """
        pass

    @SourceCode.setter
    def SourceCode(
      self,
      _value: str
    ) -> None: 
        """
        Source code of pipeline operations separated by CR LF.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.SourceCode
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.BusyEvent
        """
        pass

    @property
    def LogErrorEvent(
      self
    ) -> typing.Callable[[String], None]: 
        """
        Event to be raised upon error.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.LogErrorEvent
        """
        pass

    @LogErrorEvent.setter
    def LogErrorEvent(
      self,
      _value: typing.Callable[[String], None]
    ) -> None: 
        """
        Event to be raised upon error.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.LogErrorEvent
        """
        pass

    @property
    def LogWarningEvent(
      self
    ) -> typing.Callable[[String], None]: 
        """
        Event to be raised upon warning.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.LogWarningEvent
        """
        pass

    @LogWarningEvent.setter
    def LogWarningEvent(
      self,
      _value: typing.Callable[[String], None]
    ) -> None: 
        """
        Event to be raised upon warning.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.LogWarningEvent
        """
        pass

    @property
    def ProgressEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        (Deprecated) Event to be raised upon execution to report which line is currently 
        executed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.ProgressEvent
        """
        pass

    @ProgressEvent.setter
    def ProgressEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        (Deprecated) Event to be raised upon execution to report which line is currently 
        executed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.ProgressEvent
        """
        pass

    @property
    def ShowFormEvent(
      self
    ) -> typing.Callable[[TGIS_PipelineOperationAbstract], None]: 
        """
        Event to be raised upon ShowForm execution.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.ShowFormEvent
        """
        pass

    @ShowFormEvent.setter
    def ShowFormEvent(
      self,
      _value: typing.Callable[[TGIS_PipelineOperationAbstract], None]
    ) -> None: 
        """
        Event to be raised upon ShowForm execution.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.ShowFormEvent
        """
        pass

    @property
    def ShowMessageEvent(
      self
    ) -> typing.Callable[[String], None]: 
        """
        Event to be raised upon ''Say'' like operations.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.ShowMessageEvent
        """
        pass

    @ShowMessageEvent.setter
    def ShowMessageEvent(
      self,
      _value: typing.Callable[[String], None]
    ) -> None: 
        """
        Event to be raised upon ''Say'' like operations.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pipeline.ShowMessageEvent
        """
        pass

class TGIS_PixelExportManager( TObject ):
    """
    Pixel export manager.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager
    """

    @overload
    def __init__(
      self,
      _lp: TGIS_LayerPixel
    ) -> None: 
        """
        Create an instance.

        Args:
            _lp: destination pixel layer to export data

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.Create_TGIS_LayerPixel
        """
        pass

    @overload
    def ExportFrom(
      self,
      _viewer: IGIS_Viewer,
      _drawer: IGIS_ViewerBmp,
      _extent: TGIS_Extent,
      _ppi: int
    ) -> None: 
        """
        Export a map given by the viewer using tiles.

        Args:
            _viewer: viewer with a map to export
            _drawer: helper native bitmap viewer for drawing on during export
            _extent: viewer extent to export
            _ppi: density of output image; will be used to calculate feature size and will be 
              embedded into final image whenever possible

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.ExportFrom_IGIS_Viewer_IGIS_ViewerBmp_TGIS_Extent_Integer
        """
        pass

    @overload
    def ExportFrom(
      self,
      _viewer: IGIS_Viewer,
      _drawer: IGIS_ViewerBmp,
      _extent: TGIS_Extent,
      _width: int,
      _height: int,
      _ppi: int
    ) -> None: 
        """
        Export a map given by the viewer using tiles.

        Args:
            _viewer: viewer with a map to export
            _drawer: helper native bitmap viewer for drawing on during export
            _extent: viewer extent to export
            _width: parameter not used
            _height: parameter not used
            _ppi: density of output image; will be used to calculate feature size and will be 
              embedded into final image whenever possible

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.ExportFrom_IGIS_Viewer_IGIS_ViewerBmp_TGIS_Extent_Integer_Integer_Integer
        """
        pass

    @property
    def Fill(
      self
    ) -> bool: 
        """
        If True, space beyond export extent and drawer background will be filled with FillColor. 
        Use to enable transparency upon export.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.Fill
        """
        pass

    @Fill.setter
    def Fill(
      self,
      _value: bool
    ) -> None: 
        """
        If True, space beyond export extent and drawer background will be filled with FillColor. 
        Use to enable transparency upon export.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.Fill
        """
        pass

    @property
    def FillColor(
      self
    ) -> TGIS_Color: 
        """
        Color of the fill. Default is TGIS_Color.None (transparent).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.FillColor
        """
        pass

    @FillColor.setter
    def FillColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Color of the fill. Default is TGIS_Color.None (transparent).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.FillColor
        """
        pass

    @property
    def FillValue(
      self
    ) -> float: 
        """
        Value of the fill (grid layers only).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.FillValue
        """
        pass

    @FillValue.setter
    def FillValue(
      self,
      _value: float
    ) -> None: 
        """
        Value of the fill (grid layers only).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.FillValue
        """
        pass

    @property
    def OverlappedExtentMargin(
      self
    ) -> int: 
        """
        Margin (in pixels) to scan around an exported tile.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.OverlappedExtentMargin
        """
        pass

    @OverlappedExtentMargin.setter
    def OverlappedExtentMargin(
      self,
      _value: int
    ) -> None: 
        """
        Margin (in pixels) to scan around an exported tile.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.OverlappedExtentMargin
        """
        pass

    @property
    def TemporaryVisibleExtent(
      self
    ) -> TGIS_Extent: 
        """
        Area for rendered labels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.TemporaryVisibleExtent
        """
        pass

    @TemporaryVisibleExtent.setter
    def TemporaryVisibleExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Area for rendered labels.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.TemporaryVisibleExtent
        """
        pass

    @property
    def TileSize(
      self
    ) -> int: 
        """
        Size of exported tile.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.TileSize
        """
        pass

    @TileSize.setter
    def TileSize(
      self,
      _value: int
    ) -> None: 
        """
        Size of exported tile.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.TileSize
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        Busy event handler. Will be fired regularly during long-drawn operations. If end 
        value will be zero, the meaning is: long-drawn with unknown end time. Close long-drawn 
        operation by calling with parameters (-1,-1).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        Busy event handler. Will be fired regularly during long-drawn operations. If end 
        value will be zero, the meaning is: long-drawn with unknown end time. Close long-drawn 
        operation by calling with parameters (-1,-1).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelExportManager.BusyEvent
        """
        pass

class TGIS_PixelFilterColorSpace:
    pass

class TGIS_PixelFilterColorSpace:
    """
    Defines the color space in which the filter is to operate.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterColorSpace
    """

    @property
    def RGB(
      self
    ) -> TGIS_PixelFilterColorSpace: 
        """
        Each color band of the image is processed separately.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterColorSpace.RGB
        """
        pass

    @property
    def HSL(
      self
    ) -> TGIS_PixelFilterColorSpace: 
        """
        Lightness is computed from the RGB bands, processed and transformed back to RGB.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterColorSpace.HSL
        """
        pass

class TGIS_PixelFilterMaskType:
    pass

class TGIS_PixelFilterMaskType:
    """
    Predefined mask filters.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType
    """

    @property
    def LowPass3x3(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Low-pass blur filter (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.LowPass3x3
        """
        pass

    @property
    def LowPass5x5(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Low-pass blur filter (5x5 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.LowPass5x5
        """
        pass

    @property
    def LowPass7x7(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Low-pass blur filter (7x7 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.LowPass7x7
        """
        pass

    @property
    def HighPass3x3(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        High-pass sharpen filter (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.HighPass3x3
        """
        pass

    @property
    def HighPass5x5(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        High-pass sharpen filter (5x5 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.HighPass5x5
        """
        pass

    @property
    def HighPass7x7(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        High-pass sharpen filter (7x7 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.HighPass7x7
        """
        pass

    @property
    def Gaussian3x3(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Gaussian blur filter (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.Gaussian3x3
        """
        pass

    @property
    def Gaussian5x5(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Gaussian blur filter (5x5 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.Gaussian5x5
        """
        pass

    @property
    def Gaussian7x7(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Gaussian blur filter (7x7 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.Gaussian7x7
        """
        pass

    @property
    def Laplacian3x3(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Laplacian filter (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.Laplacian3x3
        """
        pass

    @property
    def Laplacian5x5(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Laplacian filter (5x5 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.Laplacian5x5
        """
        pass

    @property
    def GradientNorth(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        North gradient filter (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.GradientNorth
        """
        pass

    @property
    def GradientEast(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        East gradient filter (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.GradientEast
        """
        pass

    @property
    def GradientSouth(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        South gradient filter (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.GradientSouth
        """
        pass

    @property
    def GradientWest(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        West gradient filter (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.GradientWest
        """
        pass

    @property
    def GradientNorthwest(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Northwest gradient filter (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.GradientNorthwest
        """
        pass

    @property
    def GradientNortheast(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Northeast gradient filter (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.GradientNortheast
        """
        pass

    @property
    def GradientSouthwest(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Southwest gradient filter (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.GradientSouthwest
        """
        pass

    @property
    def GradientSoutheast(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Southeast gradient filter (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.GradientSoutheast
        """
        pass

    @property
    def PointDetector(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Point (discontinuity) detector (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.PointDetector
        """
        pass

    @property
    def LineDetectorHorizontal(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Horizontal line detector (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.LineDetectorHorizontal
        """
        pass

    @property
    def LineDetectorVertical(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Vertical line detector (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.LineDetectorVertical
        """
        pass

    @property
    def LineDetectorLeftDiagonal(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Left diagonal line detector (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.LineDetectorLeftDiagonal
        """
        pass

    @property
    def LineDetectorRightDiagonal(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Right diagonal line detector (3x3 mask size).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.LineDetectorRightDiagonal
        """
        pass

    @property
    def Custom(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Custom (user-defined) filter.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaskType.Custom
        """
        pass

class TGIS_PixelFilterStructuringElementType:
    pass

class TGIS_PixelFilterStructuringElementType:
    """
    Predefined structuring element types.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterStructuringElementType
    """

    @property
    def Square(
      self
    ) -> TGIS_PixelFilterStructuringElementType: 
        """
        Flat square.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterStructuringElementType.Square
        """
        pass

    @property
    def Diamond(
      self
    ) -> TGIS_PixelFilterStructuringElementType: 
        """
        Flat diamond.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterStructuringElementType.Diamond
        """
        pass

    @property
    def Disk(
      self
    ) -> TGIS_PixelFilterStructuringElementType: 
        """
        Flat disk.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterStructuringElementType.Disk
        """
        pass

    @property
    def LineHorizontal(
      self
    ) -> TGIS_PixelFilterStructuringElementType: 
        """
        Flat horizontal line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterStructuringElementType.LineHorizontal
        """
        pass

    @property
    def LineVertical(
      self
    ) -> TGIS_PixelFilterStructuringElementType: 
        """
        Flat vertical line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterStructuringElementType.LineVertical
        """
        pass

    @property
    def LineLeftDiagonal(
      self
    ) -> TGIS_PixelFilterStructuringElementType: 
        """
        Flat left diagonal line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterStructuringElementType.LineLeftDiagonal
        """
        pass

    @property
    def LineRightDiagonal(
      self
    ) -> TGIS_PixelFilterStructuringElementType: 
        """
        Flat right diagonal line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterStructuringElementType.LineRightDiagonal
        """
        pass

    @property
    def Custom(
      self
    ) -> TGIS_PixelFilterStructuringElementType: 
        """
        Custom (user-defined) element.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterStructuringElementType.Custom
        """
        pass

class TGIS_PixelFilterAbstract( TObject ):
    """
    Abstract class for all pixel layer filters.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAbstract.Create_void
        """
        pass

    def Execute(
      self
    ) -> None: 
        """
        Applies the filter on the source layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAbstract.Execute_void
        """
        pass

    @property
    def Band(
      self
    ) -> int: 
        """
        Defines the band to be processed; if set to zero then all bands will be processed; 
        default is 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAbstract.Band
        """
        pass

    @Band.setter
    def Band(
      self,
      _value: int
    ) -> None: 
        """
        Defines the band to be processed; if set to zero then all bands will be processed; 
        default is 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAbstract.Band
        """
        pass

    @property
    def ColorSpace(
      self
    ) -> TGIS_PixelFilterColorSpace: 
        """
        Defines the color space in which the image will be processed; default is HSL.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAbstract.ColorSpace
        """
        pass

    @ColorSpace.setter
    def ColorSpace(
      self,
      _value: TGIS_PixelFilterColorSpace
    ) -> None: 
        """
        Defines the color space in which the image will be processed; default is HSL.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAbstract.ColorSpace
        """
        pass

    @property
    def DestinationLayer(
      self
    ) -> TGIS_LayerPixel: 
        """
        Destination layer, pixel (image or grid); if nil then the source layer will be altered.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAbstract.DestinationLayer
        """
        pass

    @DestinationLayer.setter
    def DestinationLayer(
      self,
      _value: TGIS_LayerPixel
    ) -> None: 
        """
        Destination layer, pixel (image or grid); if nil then the source layer will be altered.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAbstract.DestinationLayer
        """
        pass

    @property
    def SourceLayer(
      self
    ) -> TGIS_LayerPixel: 
        """
        Source layer, pixel (image or grid).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAbstract.SourceLayer
        """
        pass

    @SourceLayer.setter
    def SourceLayer(
      self,
      _value: TGIS_LayerPixel
    ) -> None: 
        """
        Source layer, pixel (image or grid).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAbstract.SourceLayer
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAbstract.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAbstract.BusyEvent
        """
        pass

class TGIS_PixelFilterThreshold( TGIS_PixelFilterAbstract ):
    """
    Threshold filter for pixel layers - if the pixel value is smaller than the threshold 
    then it is set to the smallest value in the layer, otherwise to the largest.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterThreshold
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterThreshold.Create_void
        """
        pass

    @property
    def Threshold(
      self
    ) -> float: 
        """
        Value of the threshold.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterThreshold.Threshold
        """
        pass

    @Threshold.setter
    def Threshold(
      self,
      _value: float
    ) -> None: 
        """
        Value of the threshold.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterThreshold.Threshold
        """
        pass

class TGIS_PixelFilterNoise( TGIS_PixelFilterAbstract ):
    """
    Abstract class for all noise pixel layer filters.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterNoise
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterNoise.Create_void
        """
        pass

    @property
    def Amount(
      self
    ) -> float: 
        """
        Percentage amount of noise in the output image; varies from 0 to 100.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterNoise.Amount
        """
        pass

    @Amount.setter
    def Amount(
      self,
      _value: float
    ) -> None: 
        """
        Percentage amount of noise in the output image; varies from 0 to 100.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterNoise.Amount
        """
        pass

class TGIS_PixelFilterNoiseSaltPepper( TGIS_PixelFilterNoise ):
    """
    Salt-And-Pepper noise filter for pixel layers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterNoiseSaltPepper
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterNoiseSaltPepper.Create_void
        """
        pass

class TGIS_PixelFilterNoiseGaussian( TGIS_PixelFilterNoise ):
    """
    Gaussian noise filter for pixel layers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterNoiseGaussian
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterNoiseGaussian.Create_void
        """
        pass

class TGIS_PixelFilterConvolution( TGIS_PixelFilterAbstract ):
    """
    Applies mask filters to pixel layers by convolution.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterConvolution
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterConvolution.Create_void
        """
        pass

    @property
    def CustomMask(
      self
    ) -> str: 
        """
        Custom mask definition as a comma-separated list of integer values; the square root 
        of the number of values must be an odd integer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterConvolution.CustomMask
        """
        pass

    @CustomMask.setter
    def CustomMask(
      self,
      _value: str
    ) -> None: 
        """
        Custom mask definition as a comma-separated list of integer values; the square root 
        of the number of values must be an odd integer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterConvolution.CustomMask
        """
        pass

    @property
    def MaskType(
      self
    ) -> TGIS_PixelFilterMaskType: 
        """
        Predefined or custom mask to be applied.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterConvolution.MaskType
        """
        pass

    @MaskType.setter
    def MaskType(
      self,
      _value: TGIS_PixelFilterMaskType
    ) -> None: 
        """
        Predefined or custom mask to be applied.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterConvolution.MaskType
        """
        pass

class TGIS_PixelFilterBlockStats( TGIS_PixelFilterAbstract ):
    """
    Abstract class for all pixel layer block filters.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterBlockStats
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterBlockStats.Create_void
        """
        pass

    @property
    def BlockSize(
      self
    ) -> int: 
        """
        Size of the moving block (number of columns/rows); default is 3 (for a 3x3 block).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterBlockStats.BlockSize
        """
        pass

    @BlockSize.setter
    def BlockSize(
      self,
      _value: int
    ) -> None: 
        """
        Size of the moving block (number of columns/rows); default is 3 (for a 3x3 block).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterBlockStats.BlockSize
        """
        pass

class TGIS_PixelFilterSobelMagnitude( TGIS_PixelFilterBlockStats ):
    """
    Sobel magnitude filter for pixel layers - performs edge detection, the pixel value 
    is proportional to the value difference at the edge.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterSobelMagnitude
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterSobelMagnitude.Create_void
        """
        pass

class TGIS_PixelFilterRange( TGIS_PixelFilterBlockStats ):
    """
    Range filter for pixel layers - transforms the pixel value to the difference between 
    the maximum and the minimum value in the block.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterRange
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterRange.Create_void
        """
        pass

class TGIS_PixelFilterMidpoint( TGIS_PixelFilterBlockStats ):
    """
    Midpoint filter for pixel layers - transforms the pixel value to the average between 
    the maximum and the minimum value in the block.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMidpoint
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMidpoint.Create_void
        """
        pass

class TGIS_PixelFilterMinimum( TGIS_PixelFilterBlockStats ):
    """
    Minimum filter for pixel layers - transforms the pixel value to the smallest value 
    in the block.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMinimum
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMinimum.Create_void
        """
        pass

class TGIS_PixelFilterMaximum( TGIS_PixelFilterBlockStats ):
    """
    Maximum filter for pixel layers - transforms the pixel value to the greatest value 
    in the block.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaximum
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMaximum.Create_void
        """
        pass

class TGIS_PixelFilterArithmeticMean( TGIS_PixelFilterBlockStats ):
    """
    Arithmetic mean filter for pixel layers - transforms the pixel value to the arithmetic 
    mean of the values within the block.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterArithmeticMean
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterArithmeticMean.Create_void
        """
        pass

class TGIS_PixelFilterAlphaTrimmedMean( TGIS_PixelFilterBlockStats ):
    """
    Alpha-trimmed mean filter for pixel layers - transforms the pixel value to the alpha-trimmed 
    mean of the values within the block.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAlphaTrimmedMean
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAlphaTrimmedMean.Create_void
        """
        pass

    @property
    def Alpha(
      self
    ) -> int: 
        """
        Number of values to be trimmed from the top and the bottom of the ordered block values 
        list before the mean calculation; default is 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAlphaTrimmedMean.Alpha
        """
        pass

    @Alpha.setter
    def Alpha(
      self,
      _value: int
    ) -> None: 
        """
        Number of values to be trimmed from the top and the bottom of the ordered block values 
        list before the mean calculation; default is 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterAlphaTrimmedMean.Alpha
        """
        pass

class TGIS_PixelFilterContraHarmonicMean( TGIS_PixelFilterBlockStats ):
    """
    Contra-harmonic mean filter for pixel layers - transforms the pixel value to the 
    contra-harmonic mean of the values within the block.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterContraHarmonicMean
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterContraHarmonicMean.Create_void
        """
        pass

    @property
    def Order(
      self
    ) -> int: 
        """
        Order (exponent) of the mean calculation; default is 2.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterContraHarmonicMean.Order
        """
        pass

    @Order.setter
    def Order(
      self,
      _value: int
    ) -> None: 
        """
        Order (exponent) of the mean calculation; default is 2.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterContraHarmonicMean.Order
        """
        pass

class TGIS_PixelFilterGeometricMean( TGIS_PixelFilterBlockStats ):
    """
    Geometric mean filter for pixel layers - transforms the pixel value to the geometric 
    mean of the values within the block.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterGeometricMean
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterGeometricMean.Create_void
        """
        pass

class TGIS_PixelFilterHarmonicMean( TGIS_PixelFilterBlockStats ):
    """
    Harmonic mean filter for pixel layers - transforms the pixel value to the harmonic 
    mean of the values within the block.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterHarmonicMean
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterHarmonicMean.Create_void
        """
        pass

class TGIS_PixelFilterWeightedMean( TGIS_PixelFilterBlockStats ):
    """
    Weighted mean filter for pixel layers - transforms the pixel value to the weighted 
    mean of the values within the block.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterWeightedMean
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterWeightedMean.Create_void
        """
        pass

    @property
    def WeightMask(
      self
    ) -> str: 
        """
        Weight mask definition as a comma-separated list of integer values; the square root 
        of the number of values must be an odd integer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterWeightedMean.WeightMask
        """
        pass

    @WeightMask.setter
    def WeightMask(
      self,
      _value: str
    ) -> None: 
        """
        Weight mask definition as a comma-separated list of integer values; the square root 
        of the number of values must be an odd integer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterWeightedMean.WeightMask
        """
        pass

class TGIS_PixelFilterYpMean( TGIS_PixelFilterBlockStats ):
    """
    Yp mean filter for pixel layers - transforms the pixel value to the Yp mean of the 
    values within the block.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterYpMean
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterYpMean.Create_void
        """
        pass

    @property
    def Order(
      self
    ) -> int: 
        """
        Order (exponent) of the mean calculation; default is -2.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterYpMean.Order
        """
        pass

    @Order.setter
    def Order(
      self,
      _value: int
    ) -> None: 
        """
        Order (exponent) of the mean calculation; default is -2.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterYpMean.Order
        """
        pass

class TGIS_PixelFilterMajority( TGIS_PixelFilterBlockStats ):
    """
    Majority filter for pixel layers - transforms the pixel value to the most frequent 
    value in the block (if exists).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMajority
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMajority.Create_void
        """
        pass

class TGIS_PixelFilterMinority( TGIS_PixelFilterBlockStats ):
    """
    Minority filter for pixel layers- transforms the pixel value to the least frequent 
    value in the block (if exists).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMinority
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMinority.Create_void
        """
        pass

class TGIS_PixelFilterMedian( TGIS_PixelFilterBlockStats ):
    """
    Median filter for pixel layers - transforms the pixel value to the median of the 
    values within the block.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMedian
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMedian.Create_void
        """
        pass

class TGIS_PixelFilterWeightedMedian( TGIS_PixelFilterBlockStats ):
    """
    Weighted median filter for pixel layers - transforms the pixel value to the weighted 
    median of the values within the block.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterWeightedMedian
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterWeightedMedian.Create_void
        """
        pass

    @property
    def WeightMask(
      self
    ) -> str: 
        """
        Weight mask definition as a comma-separated list of integer values; the square root 
        of the number of values must be an odd integer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterWeightedMedian.WeightMask
        """
        pass

    @WeightMask.setter
    def WeightMask(
      self,
      _value: str
    ) -> None: 
        """
        Weight mask definition as a comma-separated list of integer values; the square root 
        of the number of values must be an odd integer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterWeightedMedian.WeightMask
        """
        pass

class TGIS_PixelFilterSum( TGIS_PixelFilterBlockStats ):
    """
    Sum filter for pixel layers - transforms the pixel value to the sum of the values 
    within the block.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterSum
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterSum.Create_void
        """
        pass

class TGIS_PixelFilterStandardDeviation( TGIS_PixelFilterBlockStats ):
    """
    Standard deviation filter for pixel layers - transforms the pixel value to the standard 
    deviation of the values within the block.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterStandardDeviation
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterStandardDeviation.Create_void
        """
        pass

class TGIS_PixelFilterUniqueCount( TGIS_PixelFilterBlockStats ):
    """
    Unique value count filter for pixel layers - transforms the pixel value to the number 
    of unique values within the block.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterUniqueCount
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterUniqueCount.Create_void
        """
        pass

class TGIS_PixelFilterMorphological( TGIS_PixelFilterBlockStats ):
    """
    Abstract class for all pixel layer morphological filters.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMorphological
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMorphological.Create_void
        """
        pass

    @property
    def CustomStructuringElement(
      self
    ) -> str: 
        """
        Custom structuring element definition as a comma-separated list of zeros and ones; 
        the square root of the number of values must be an odd integer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMorphological.CustomStructuringElement
        """
        pass

    @CustomStructuringElement.setter
    def CustomStructuringElement(
      self,
      _value: str
    ) -> None: 
        """
        Custom structuring element definition as a comma-separated list of zeros and ones; 
        the square root of the number of values must be an odd integer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMorphological.CustomStructuringElement
        """
        pass

    @property
    def StructuringElementType(
      self
    ) -> TGIS_PixelFilterStructuringElementType: 
        """
        Predefined or custom structuring element type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMorphological.StructuringElementType
        """
        pass

    @StructuringElementType.setter
    def StructuringElementType(
      self,
      _value: TGIS_PixelFilterStructuringElementType
    ) -> None: 
        """
        Predefined or custom structuring element type.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterMorphological.StructuringElementType
        """
        pass

class TGIS_PixelFilterErosion( TGIS_PixelFilterMorphological ):
    """
    Erosion filter for pixel layers - transforms the pixel value to the smallest difference 
    of the value in the block and the mask value.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterErosion
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterErosion.Create_void
        """
        pass

class TGIS_PixelFilterDilation( TGIS_PixelFilterMorphological ):
    """
    Dilation filter for pixel layers - transforms the pixel value to the greatest sum 
    of the value in the block and the mask value.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterDilation
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterDilation.Create_void
        """
        pass

class TGIS_PixelFilterOpening( TGIS_PixelFilterMorphological ):
    """
    Opening filter for pixel layers - two-stage filter, applies erosion followed by dilation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterOpening
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterOpening.Create_void
        """
        pass

class TGIS_PixelFilterClosing( TGIS_PixelFilterMorphological ):
    """
    Closing filter for pixel layers - two-stage filter, applies dilation followed by 
    erosion.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterClosing
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterClosing.Create_void
        """
        pass

class TGIS_PixelFilterTopHat( TGIS_PixelFilterMorphological ):
    """
    Top-hat filter for pixel layers - three-stage filter, computes the difference of 
    the original image with its opening (erosion followed by dilation).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterTopHat
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterTopHat.Create_void
        """
        pass

class TGIS_PixelFilterBottomHat( TGIS_PixelFilterMorphological ):
    """
    Bottom-hat filter for pixel layers - three-stage filter, computes the difference 
    of the closing (dilation followed by erosion) of the image with the original image.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterBottomHat
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFilterBottomHat.Create_void
        """
        pass

class TGIS_PrintLayoutElementType:
    pass

class TGIS_PrintLayoutElementType:
    """
    Print layout element types.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElementType
    """

    @property
    def Box(
      self
    ) -> TGIS_PrintLayoutElementType: 
        """
        box element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElementType.Box
        """
        pass

    @property
    def Map(
      self
    ) -> TGIS_PrintLayoutElementType: 
        """
        map element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElementType.Map
        """
        pass

    @property
    def Legend(
      self
    ) -> TGIS_PrintLayoutElementType: 
        """
        legend element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElementType.Legend
        """
        pass

    @property
    def Scale(
      self
    ) -> TGIS_PrintLayoutElementType: 
        """
        scale element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElementType.Scale
        """
        pass

    @property
    def NorthArrow(
      self
    ) -> TGIS_PrintLayoutElementType: 
        """
        north arrow element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElementType.NorthArrow
        """
        pass

    @property
    def Graphic(
      self
    ) -> TGIS_PrintLayoutElementType: 
        """
        graphic element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElementType.Graphic
        """
        pass

    @property
    def Text(
      self
    ) -> TGIS_PrintLayoutElementType: 
        """
        text element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElementType.Text
        """
        pass

    @property
    def Frame(
      self
    ) -> TGIS_PrintLayoutElementType: 
        """
        frame element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElementType.Frame
        """
        pass

    @property
    def Page(
      self
    ) -> TGIS_PrintLayoutElementType: 
        """
        page element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElementType.Page
        """
        pass

class TGIS_PrintLayoutControlType:
    pass

class TGIS_PrintLayoutControlType:
    """
    Print layout control types.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutControlType
    """

    @property
    def Scale(
      self
    ) -> TGIS_PrintLayoutControlType: 
        """
        scale control

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutControlType.Scale
        """
        pass

    @property
    def NorthArrow(
      self
    ) -> TGIS_PrintLayoutControlType: 
        """
        north arrow control

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutControlType.NorthArrow
        """
        pass

    @property
    def Legend(
      self
    ) -> TGIS_PrintLayoutControlType: 
        """
        legend control

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutControlType.Legend
        """
        pass

class TGIS_PrintLayoutUnits:
    pass

class TGIS_PrintLayoutUnits:
    """
    Print layout units.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutUnits
    """

    @property
    def uCm(
      self
    ) -> TGIS_PrintLayoutUnits: 
        """
        cm unit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutUnits.uCm
        """
        pass

    @property
    def uMm(
      self
    ) -> TGIS_PrintLayoutUnits: 
        """
        nn unit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutUnits.uMm
        """
        pass

    @property
    def uIn(
      self
    ) -> TGIS_PrintLayoutUnits: 
        """
        in unit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutUnits.uIn
        """
        pass

    @property
    def uPt(
      self
    ) -> TGIS_PrintLayoutUnits: 
        """
        pt unit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutUnits.uPt
        """
        pass

    @property
    def uPx(
      self
    ) -> TGIS_PrintLayoutUnits: 
        """
        px unit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutUnits.uPx
        """
        pass

class TGIS_PrintLayoutAnchor:
    pass

class TGIS_PrintLayoutAnchor:
    """
    Print layout anchor types.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutAnchor
    """

    @property
    def aLeftMargin(
      self
    ) -> TGIS_PrintLayoutAnchor: 
        """
        left margin

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutAnchor.aLeftMargin
        """
        pass

    @property
    def aTopMargin(
      self
    ) -> TGIS_PrintLayoutAnchor: 
        """
        top margin

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutAnchor.aTopMargin
        """
        pass

    @property
    def aRightMargin(
      self
    ) -> TGIS_PrintLayoutAnchor: 
        """
        right margin

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutAnchor.aRightMargin
        """
        pass

    @property
    def aBottomMargin(
      self
    ) -> TGIS_PrintLayoutAnchor: 
        """
        bottom margin

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutAnchor.aBottomMargin
        """
        pass

    @property
    def aLeftBorder(
      self
    ) -> TGIS_PrintLayoutAnchor: 
        """
        left border

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutAnchor.aLeftBorder
        """
        pass

    @property
    def aTopBorder(
      self
    ) -> TGIS_PrintLayoutAnchor: 
        """
        top border

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutAnchor.aTopBorder
        """
        pass

    @property
    def aRightBorder(
      self
    ) -> TGIS_PrintLayoutAnchor: 
        """
        right border

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutAnchor.aRightBorder
        """
        pass

    @property
    def aBottomBorder(
      self
    ) -> TGIS_PrintLayoutAnchor: 
        """
        bottom border

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutAnchor.aBottomBorder
        """
        pass

class TGIS_PrintLayoutElement:
    """
    Print layout base element type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElement
    """

    @overload
    def __init__(
      self,
      _location: TGIS_PrintLayoutLocation,
      _elementType: TGIS_PrintLayoutElementType,
      _index: int
    ) -> None: 
        """
        Constructor.

        Args:
            _location: element location
            _elementType: element type
            _index: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElement.Create_TGIS_PrintLayoutLocation_TGIS_PrintLayoutElementType_Integer
        """
        pass

    def CreateDefault(
      self
    ) -> TGIS_PrintLayoutElement: 
        """
        Create element with default parameters.

        Returns:
            default element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElement.CreateDefault_void
        """
        pass

    @property
    def ElementType(
      self
    ) -> TGIS_PrintLayoutElementType: 
        """
        element type

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElement.ElementType
        """
        pass

    @property
    def Index(
      self
    ) -> int: 
        """
        Element index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElement.Index
        """
        pass

    @Index.setter
    def Index(
      self,
      _value: int
    ) -> None: 
        """
        Element index

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElement.Index
        """
        pass

    @property
    def Location(
      self
    ) -> TGIS_PrintLayoutLocation: 
        """
        element location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElement.Location
        """
        pass

    @Location.setter
    def Location(
      self,
      _value: TGIS_PrintLayoutLocation
    ) -> None: 
        """
        element location

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElement.Location
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        element name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElement.Name
        """
        pass

    @Name.setter
    def Name(
      self,
      _value: str
    ) -> None: 
        """
        element name

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutElement.Name
        """
        pass

class TGIS_PrintLayoutBox( TGIS_PrintLayoutElement ):
    """
    Print layout box element type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutBox
    """

    @overload
    def __init__(
      self,
      _location: TGIS_PrintLayoutLocation,
      _color: TGIS_Color,
      _frame: TGIS_Color,
      _width: TGIS_PrintLayoutWidth,
      _index: int
    ) -> None: 
        """
        Constructor.

        Args:
            _location: element location
            _color: element color
            _frame: frame color
            _width: frame width
            _index: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutBox.Create_TGIS_PrintLayoutLocation_TGIS_Color_TGIS_Color_TGIS_PrintLayoutWidth_Integer
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Fill color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutBox.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Fill color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutBox.Color
        """
        pass

    @property
    def FrameColor(
      self
    ) -> TGIS_Color: 
        """
        Frame color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutBox.FrameColor
        """
        pass

    @FrameColor.setter
    def FrameColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Frame color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutBox.FrameColor
        """
        pass

    @property
    def FrameWidth(
      self
    ) -> TGIS_PrintLayoutWidth: 
        """
        Frame width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutBox.FrameWidth
        """
        pass

    @FrameWidth.setter
    def FrameWidth(
      self,
      _value: TGIS_PrintLayoutWidth
    ) -> None: 
        """
        Frame width.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutBox.FrameWidth
        """
        pass

class TGIS_PrintLayoutMap( TGIS_PrintLayoutElement ):
    """
    Print layout map element type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutMap
    """

    @overload
    def __init__(
      self,
      _location: TGIS_PrintLayoutLocation,
      _viewer: IGIS_Viewer,
      _extent: TGIS_Extent,
      _background: bool,
      _scale: float,
      _index: int
    ) -> None: 
        """
        Constructor.

        Args:
            _location: element location
            _viewer: control handle
            _extent: viewer extent
            _background: background flag
            _scale: viewer scale
            _index: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutMap.Create_TGIS_PrintLayoutLocation_IGIS_Viewer_TGIS_Extent_Boolean_Double_Integer
        """
        pass

    @property
    def Background(
      self
    ) -> bool: 
        """
        background flag.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutMap.Background
        """
        pass

    @Background.setter
    def Background(
      self,
      _value: bool
    ) -> None: 
        """
        background flag.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutMap.Background
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Extent: 
        """
        viewer extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutMap.Extent
        """
        pass

    @Extent.setter
    def Extent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        viewer extent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutMap.Extent
        """
        pass

    @property
    def RealExtent(
      self
    ) -> TGIS_Extent: 
        """
        real extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutMap.RealExtent
        """
        pass

    @RealExtent.setter
    def RealExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        real extent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutMap.RealExtent
        """
        pass

    @property
    def Scale(
      self
    ) -> float: 
        """
        viewer scale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutMap.Scale
        """
        pass

    @Scale.setter
    def Scale(
      self,
      _value: float
    ) -> None: 
        """
        viewer scale.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutMap.Scale
        """
        pass

    @property
    def Viewer(
      self
    ) -> IGIS_Viewer: 
        """
        control handle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutMap.Viewer
        """
        pass

class TGIS_PrintLayoutLegend( TGIS_PrintLayoutElement ):
    """
    Print layout legend element type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend
    """

    @overload
    def __init__(
      self,
      _location: TGIS_PrintLayoutLocation,
      _control: IGIS_PrintableControl,
      _scale: float,
      _index: int
    ) -> None: 
        """
        Constructor.

        Args:
            _location: element location
            _control: control handle
            _scale: control scale
            _index: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.Create_TGIS_PrintLayoutLocation_IGIS_PrintableControl_Double_Integer
        """
        pass

    @property
    def CompactView(
      self
    ) -> bool: 
        """
        compact view.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.CompactView
        """
        pass

    @CompactView.setter
    def CompactView(
      self,
      _value: bool
    ) -> None: 
        """
        compact view.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.CompactView
        """
        pass

    @property
    def CompactViewStr(
      self
    ) -> str: 
        """
        compact view (string).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.CompactViewStr
        """
        pass

    @CompactViewStr.setter
    def CompactViewStr(
      self,
      _value: str
    ) -> None: 
        """
        compact view (string).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.CompactViewStr
        """
        pass

    @property
    def Control(
      self
    ) -> IGIS_PrintableControl: 
        """
        control handle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.Control
        """
        pass

    @property
    def CType(
      self
    ) -> TGIS_PrintLayoutControlType: 
        """
        control type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.CType
        """
        pass

    @property
    def DrawIconStyle(
      self
    ) -> TGIS_LegendIconStyle: 
        """
        legend icon style

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.DrawIconStyle
        """
        pass

    @DrawIconStyle.setter
    def DrawIconStyle(
      self,
      _value: TGIS_LegendIconStyle
    ) -> None: 
        """
        legend icon style

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.DrawIconStyle
        """
        pass

    @property
    def DrawIconStyleStr(
      self
    ) -> str: 
        """
        legend icon style

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.DrawIconStyleStr
        """
        pass

    @DrawIconStyleStr.setter
    def DrawIconStyleStr(
      self,
      _value: str
    ) -> None: 
        """
        legend icon style

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.DrawIconStyleStr
        """
        pass

    @property
    def Font(
      self
    ) -> str: 
        """
        font name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.Font
        """
        pass

    @Font.setter
    def Font(
      self,
      _value: str
    ) -> None: 
        """
        font name.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.Font
        """
        pass

    @property
    def FontColor(
      self
    ) -> TGIS_Color: 
        """
        font color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.FontColor
        """
        pass

    @FontColor.setter
    def FontColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        font color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.FontColor
        """
        pass

    @property
    def FontColorStr(
      self
    ) -> str: 
        """
        font color (string).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.FontColorStr
        """
        pass

    @FontColorStr.setter
    def FontColorStr(
      self,
      _value: str
    ) -> None: 
        """
        font color (string).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.FontColorStr
        """
        pass

    @property
    def FontSize(
      self
    ) -> int: 
        """
        font size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.FontSize
        """
        pass

    @FontSize.setter
    def FontSize(
      self,
      _value: int
    ) -> None: 
        """
        font size.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.FontSize
        """
        pass

    @property
    def FontSizeStr(
      self
    ) -> str: 
        """
        font size (string).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.FontSizeStr
        """
        pass

    @FontSizeStr.setter
    def FontSizeStr(
      self,
      _value: str
    ) -> None: 
        """
        font size (string).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.FontSizeStr
        """
        pass

    @property
    def FontStr(
      self
    ) -> str: 
        """
        font name (string).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.FontStr
        """
        pass

    @FontStr.setter
    def FontStr(
      self,
      _value: str
    ) -> None: 
        """
        font name (string).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.FontStr
        """
        pass

    @property
    def ReverseOrder(
      self
    ) -> bool: 
        """
        reverse order.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.ReverseOrder
        """
        pass

    @ReverseOrder.setter
    def ReverseOrder(
      self,
      _value: bool
    ) -> None: 
        """
        reverse order.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.ReverseOrder
        """
        pass

    @property
    def ReverseOrderStr(
      self
    ) -> str: 
        """
        reverse order (string).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.ReverseOrderStr
        """
        pass

    @ReverseOrderStr.setter
    def ReverseOrderStr(
      self,
      _value: str
    ) -> None: 
        """
        reverse order (string).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.ReverseOrderStr
        """
        pass

    @property
    def Scale(
      self
    ) -> float: 
        """
        control scale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.Scale
        """
        pass

    @Scale.setter
    def Scale(
      self,
      _value: float
    ) -> None: 
        """
        control scale.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLegend.Scale
        """
        pass

class TGIS_PrintLayoutScale( TGIS_PrintLayoutElement ):
    """
    Print layout scale element type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale
    """

    @overload
    def __init__(
      self,
      _location: TGIS_PrintLayoutLocation,
      _control: IGIS_PrintableControl,
      _scale: float,
      _index: int
    ) -> None: 
        """
        Constructor.

        Args:
            _location: element location
            _control: control handle
            _scale: control scale
            _index: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.Create_TGIS_PrintLayoutLocation_IGIS_PrintableControl_Double_Integer
        """
        pass

    @property
    def Control(
      self
    ) -> IGIS_PrintableControl: 
        """
        control handle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.Control
        """
        pass

    @property
    def CType(
      self
    ) -> TGIS_PrintLayoutControlType: 
        """
        control type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.CType
        """
        pass

    @property
    def DividerColor1(
      self
    ) -> TGIS_Color: 
        """
        divider color 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.DividerColor1
        """
        pass

    @DividerColor1.setter
    def DividerColor1(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        divider color 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.DividerColor1
        """
        pass

    @property
    def DividerColor1Str(
      self
    ) -> str: 
        """
        divider color 1 (string).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.DividerColor1Str
        """
        pass

    @DividerColor1Str.setter
    def DividerColor1Str(
      self,
      _value: str
    ) -> None: 
        """
        divider color 1 (string).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.DividerColor1Str
        """
        pass

    @property
    def DividerColor2(
      self
    ) -> TGIS_Color: 
        """
        divider color 2.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.DividerColor2
        """
        pass

    @DividerColor2.setter
    def DividerColor2(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        divider color 2.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.DividerColor2
        """
        pass

    @property
    def DividerColor2Str(
      self
    ) -> str: 
        """
        divider color 2 (string).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.DividerColor2Str
        """
        pass

    @DividerColor2Str.setter
    def DividerColor2Str(
      self,
      _value: str
    ) -> None: 
        """
        divider color 2 (string).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.DividerColor2Str
        """
        pass

    @property
    def Dividers(
      self
    ) -> int: 
        """
        dividers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.Dividers
        """
        pass

    @Dividers.setter
    def Dividers(
      self,
      _value: int
    ) -> None: 
        """
        dividers.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.Dividers
        """
        pass

    @property
    def DividersStr(
      self
    ) -> str: 
        """
        dividers (string).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.DividersStr
        """
        pass

    @DividersStr.setter
    def DividersStr(
      self,
      _value: str
    ) -> None: 
        """
        dividers (string).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.DividersStr
        """
        pass

    @property
    def Font(
      self
    ) -> str: 
        """
        font.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.Font
        """
        pass

    @Font.setter
    def Font(
      self,
      _value: str
    ) -> None: 
        """
        font.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.Font
        """
        pass

    @property
    def FontColor(
      self
    ) -> TGIS_Color: 
        """
        font color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.FontColor
        """
        pass

    @FontColor.setter
    def FontColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        font color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.FontColor
        """
        pass

    @property
    def FontColorStr(
      self
    ) -> str: 
        """
        font color (string).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.FontColorStr
        """
        pass

    @FontColorStr.setter
    def FontColorStr(
      self,
      _value: str
    ) -> None: 
        """
        font color (string).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.FontColorStr
        """
        pass

    @property
    def FontSize(
      self
    ) -> int: 
        """
        font size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.FontSize
        """
        pass

    @FontSize.setter
    def FontSize(
      self,
      _value: int
    ) -> None: 
        """
        font size.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.FontSize
        """
        pass

    @property
    def FontSizeStr(
      self
    ) -> str: 
        """
        font size (string).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.FontSizeStr
        """
        pass

    @FontSizeStr.setter
    def FontSizeStr(
      self,
      _value: str
    ) -> None: 
        """
        font size (string).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.FontSizeStr
        """
        pass

    @property
    def FontStr(
      self
    ) -> str: 
        """
        font (string).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.FontStr
        """
        pass

    @FontStr.setter
    def FontStr(
      self,
      _value: str
    ) -> None: 
        """
        font (string).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.FontStr
        """
        pass

    @property
    def Scale(
      self
    ) -> float: 
        """
        control scale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.Scale
        """
        pass

    @Scale.setter
    def Scale(
      self,
      _value: float
    ) -> None: 
        """
        control scale.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutScale.Scale
        """
        pass

class TGIS_PrintLayoutNorthArrow( TGIS_PrintLayoutElement ):
    """
    Print layout northarrow element type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow
    """

    @overload
    def __init__(
      self,
      _location: TGIS_PrintLayoutLocation,
      _control: IGIS_PrintableControl,
      _scale: float,
      _index: int
    ) -> None: 
        """
        Constructor.

        Args:
            _location: element location
            _control: control handle
            _scale: control scale
            _index: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.Create_TGIS_PrintLayoutLocation_IGIS_PrintableControl_Double_Integer
        """
        pass

    @property
    def Color1(
      self
    ) -> TGIS_Color: 
        """
        fill color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.Color1
        """
        pass

    @Color1.setter
    def Color1(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        fill color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.Color1
        """
        pass

    @property
    def Color1Str(
      self
    ) -> str: 
        """
        fill color (string).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.Color1Str
        """
        pass

    @Color1Str.setter
    def Color1Str(
      self,
      _value: str
    ) -> None: 
        """
        fill color (string).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.Color1Str
        """
        pass

    @property
    def Color2(
      self
    ) -> TGIS_Color: 
        """
        outline color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.Color2
        """
        pass

    @Color2.setter
    def Color2(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        outline color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.Color2
        """
        pass

    @property
    def Color2Str(
      self
    ) -> str: 
        """
        outline color (string).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.Color2Str
        """
        pass

    @Color2Str.setter
    def Color2Str(
      self,
      _value: str
    ) -> None: 
        """
        outline color (string).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.Color2Str
        """
        pass

    @property
    def Control(
      self
    ) -> IGIS_PrintableControl: 
        """
        control handle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.Control
        """
        pass

    @property
    def CType(
      self
    ) -> TGIS_PrintLayoutControlType: 
        """
        control type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.CType
        """
        pass

    @property
    def Path(
      self
    ) -> str: 
        """
        Symbol path. If empty then Style property is used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.Path
        """
        pass

    @Path.setter
    def Path(
      self,
      _value: str
    ) -> None: 
        """
        Symbol path. If empty then Style property is used.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.Path
        """
        pass

    @property
    def PathStr(
      self
    ) -> str: 
        """
        Symbol path. If empty then Style property is used (string).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.PathStr
        """
        pass

    @PathStr.setter
    def PathStr(
      self,
      _value: str
    ) -> None: 
        """
        Symbol path. If empty then Style property is used (string).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.PathStr
        """
        pass

    @property
    def Scale(
      self
    ) -> float: 
        """
        control scale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.Scale
        """
        pass

    @Scale.setter
    def Scale(
      self,
      _value: float
    ) -> None: 
        """
        control scale.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.Scale
        """
        pass

    @property
    def Style(
      self
    ) -> TGIS_ControlNorthArrowStyle: 
        """
        symbol style, used if Path is empty.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.Style
        """
        pass

    @Style.setter
    def Style(
      self,
      _value: TGIS_ControlNorthArrowStyle
    ) -> None: 
        """
        symbol style, used if Path is empty.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.Style
        """
        pass

    @property
    def StyleStr(
      self
    ) -> str: 
        """
        symbol style, used if Path is empty (string).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.StyleStr
        """
        pass

    @StyleStr.setter
    def StyleStr(
      self,
      _value: str
    ) -> None: 
        """
        symbol style, used if Path is empty (string).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutNorthArrow.StyleStr
        """
        pass

class TGIS_PrintLayoutGraphic( TGIS_PrintLayoutElement ):
    """
    Print layout graphic element type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutGraphic
    """

    @overload
    def __init__(
      self,
      _location: TGIS_PrintLayoutLocation,
      _graphic: TGIS_TemplateGraphic,
      _path: str,
      _index: int
    ) -> None: 
        """
        Constructor.

        Args:
            _location: element location
            _graphic: graphic object
            _path: symbol path; relative to template
            _index: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutGraphic.Create_TGIS_PrintLayoutLocation_TGIS_TemplateGraphic_String_Integer
        """
        pass

    @property
    def Graphic(
      self
    ) -> TGIS_TemplateGraphic: 
        """
        Graphic object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutGraphic.Graphic
        """
        pass

    @Graphic.setter
    def Graphic(
      self,
      _value: TGIS_TemplateGraphic
    ) -> None: 
        """
        Graphic object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutGraphic.Graphic
        """
        pass

    @property
    def Path(
      self
    ) -> str: 
        """
        full path.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutGraphic.Path
        """
        pass

    @Path.setter
    def Path(
      self,
      _value: str
    ) -> None: 
        """
        full path.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutGraphic.Path
        """
        pass

class TGIS_PrintLayoutText( TGIS_PrintLayoutElement ):
    """
    Print layout text element type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText
    """

    @overload
    def __init__(
      self,
      _location: TGIS_PrintLayoutLocation,
      _text: str,
      _font: str,
      _style: typing.Sequence[TGIS_FontStyle],
      _size: int,
      _color: TGIS_Color,
      _align: TGIS_LabelAlignment,
      _bgColor: TGIS_Color,
      _bgWidth: TGIS_PrintLayoutWidth,
      _index: int
    ) -> None: 
        """
        Constructor.

        Args:
            _location: element type
            _text: element location
            _font: text font name
            _style: text style
            _size: text size
            _color: text color
            _align: text align
            _bgColor: background color, use None for transparent
            _bgWidth: background border width
            _index: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.Create_TGIS_PrintLayoutLocation_String_String_TGIS_FontStyles_Integer_745AB7DACEC05CC0E81262D9F358C880
        """
        pass

    @property
    def Align(
      self
    ) -> TGIS_LabelAlignment: 
        """
        text align.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.Align
        """
        pass

    @Align.setter
    def Align(
      self,
      _value: TGIS_LabelAlignment
    ) -> None: 
        """
        text align.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.Align
        """
        pass

    @property
    def BackgroundColor(
      self
    ) -> TGIS_Color: 
        """
        text background color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.BackgroundColor
        """
        pass

    @BackgroundColor.setter
    def BackgroundColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        text background color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.BackgroundColor
        """
        pass

    @property
    def BackgroundWidth(
      self
    ) -> TGIS_PrintLayoutWidth: 
        """
        text border width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.BackgroundWidth
        """
        pass

    @BackgroundWidth.setter
    def BackgroundWidth(
      self,
      _value: TGIS_PrintLayoutWidth
    ) -> None: 
        """
        text border width.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.BackgroundWidth
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        text color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        text color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.Color
        """
        pass

    @property
    def Font(
      self
    ) -> str: 
        """
        text font name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.Font
        """
        pass

    @Font.setter
    def Font(
      self,
      _value: str
    ) -> None: 
        """
        text font name.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.Font
        """
        pass

    @property
    def Size(
      self
    ) -> int: 
        """
        text size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.Size
        """
        pass

    @Size.setter
    def Size(
      self,
      _value: int
    ) -> None: 
        """
        text size.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.Size
        """
        pass

    @property
    def Style(
      self
    ) -> typing.Sequence[TGIS_FontStyle]: 
        """
        text style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.Style
        """
        pass

    @Style.setter
    def Style(
      self,
      _value: typing.Sequence[TGIS_FontStyle]
    ) -> None: 
        """
        text style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.Style
        """
        pass

    @property
    def Text(
      self
    ) -> str: 
        """
        text string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.Text
        """
        pass

    @Text.setter
    def Text(
      self,
      _value: str
    ) -> None: 
        """
        text string.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutText.Text
        """
        pass

class TGIS_PrintLayoutFrame( TGIS_PrintLayoutElement ):
    """
    Print layout frame element type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutFrame
    """

    @overload
    def __init__(
      self,
      _location: TGIS_PrintLayoutLocation,
      _color: TGIS_Color,
      _width: TGIS_PrintLayoutWidth,
      _index: int
    ) -> None: 
        """
        Constructor.

        Args:
            _location: element location
            _color: element color
            _width: element width
            _index: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutFrame.Create_TGIS_PrintLayoutLocation_TGIS_Color_TGIS_PrintLayoutWidth_Integer
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        frame color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutFrame.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        frame color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutFrame.Color
        """
        pass

    @property
    def Width(
      self
    ) -> TGIS_PrintLayoutWidth: 
        """
        frame width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutFrame.Width
        """
        pass

    @Width.setter
    def Width(
      self,
      _value: TGIS_PrintLayoutWidth
    ) -> None: 
        """
        frame width.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutFrame.Width
        """
        pass

class TGIS_PrintLayoutPage( TGIS_PrintLayoutElement ):
    """
    Print layout page element type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPage
    """

    @overload
    def __init__(
      self,
      _location: TGIS_PrintLayoutLocation,
      _width: TGIS_PrintLayoutWidth,
      _height: TGIS_PrintLayoutWidth
    ) -> None: 
        """
        Constructor.

        Args:
            _location: element location
            _width: element width
            _height: element height

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPage.Create_TGIS_PrintLayoutLocation_TGIS_PrintLayoutWidth_TGIS_PrintLayoutWidth
        """
        pass

    @property
    def Height(
      self
    ) -> TGIS_PrintLayoutWidth: 
        """
        Page height.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPage.Height
        """
        pass

    @Height.setter
    def Height(
      self,
      _value: TGIS_PrintLayoutWidth
    ) -> None: 
        """
        Page height.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPage.Height
        """
        pass

    @property
    def Width(
      self
    ) -> TGIS_PrintLayoutWidth: 
        """
        Page width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPage.Width
        """
        pass

    @Width.setter
    def Width(
      self,
      _value: TGIS_PrintLayoutWidth
    ) -> None: 
        """
        Page width.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPage.Width
        """
        pass

class TGIS_TemplatePrintBuilder( TObject ):
    """
    Encapsulation of print template builder.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder
    """

    @overload
    def __init__(
      self,
      _template: TGIS_TemplatePrint
    ) -> None: 
        """
        Create an instance.

        Args:
            _template: template print object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.Create_TGIS_TemplatePrint
        """
        pass

    def AddElement(
      self,
      _elm: TGIS_PrintLayoutElement
    ) -> None: 
        """
        Add element to list.

        Args:
            _elm: element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.AddElement_TGIS_PrintLayoutElement
        """
        pass

    def ClearElements(
      self
    ) -> None: 
        """
        Clear all element from list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.ClearElements_void
        """
        pass

    def CopyTemplateFile(
      self,
      _oldPath: str,
      _newPath: str,
      _copyFiles: bool
    ) -> None: 
        """
        Copy a template file. Guarantee proper paths to files.

        Args:
            _oldPath: source path to file
            _newPath: destination path to file
            _copyFiles: if True, files are copied according to relative paths if False, files 
              are not copied; relative paths are properly changed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.CopyTemplateFile_String_String_Boolean
        """
        pass

    def MoveElement(
      self,
      _index: int,
      _step: int
    ) -> None: 
        """
        Move element on list.

        Args:
            _index: element index
            _step: offset to move relative to current position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.MoveElement_Integer_Integer
        """
        pass

    def NewElement(
      self,
      _type: TGIS_PrintLayoutElementType
    ) -> TGIS_PrintLayoutElement: 
        """
        Create new element.

        Args:
            _type: element type

        Returns:
            element object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.NewElement_TGIS_PrintLayoutElementType
        """
        pass

    def ProcessTemplate(
      self,
      _dpi: int,
      _print_area: TRect,
      _page_width: int,
      _page_height: int
    ) -> None: 
        """
        Process a page according to defined template.

        Args:
            _dpi: printer resolution
            _print_area: print area
            _page_width: page width
            _page_height: page height

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.ProcessTemplate_Integer_TRect_Integer_Integer
        """
        pass

    def RemoveElement(
      self,
      _index: int
    ) -> None: 
        """
        Remove element from list.

        Args:
            _index: element index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.RemoveElement_Integer
        """
        pass

    def SaveToFile(
      self,
      _path: str
    ) -> None: 
        """
        Save template to file.

        Args:
            _path: path to file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.SaveToFile_String
        """
        pass

    def UpdateLocation(
      self,
      _elm: TGIS_PrintLayoutElement,
      _bounds: TRect
    ) -> None: 
        """
        Update element location.

        Args:
            _elm: element
            _bounds: new pixel bounds

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.UpdateLocation_TGIS_PrintLayoutElement_TRect
        """
        pass

    def UpdateLocationEx(
      self,
      _elm: TGIS_PrintLayoutElement,
      _bounds: TRect,
      _ratio: float,
      _print_area: TRect,
      _page_width: int,
      _page_height: int,
      _dpi: int
    ) -> None: 
        """
        Update element location.

        Args:
            _elm: element
            _bounds: new element bounds
            _ratio: element size ratio
            _print_area: print area pixel bounds
            _page_width: page width
            _page_height: page height
            _dpi: printer ppi

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.UpdateLocationEx_TGIS_PrintLayoutElement_TRect_Double_TRect_Integer_Integer_Integer
        """
        pass

    def UpdateRectangle(
      self,
      _elm: TGIS_PrintLayoutElement
    ) -> None: 
        """
        Update element pixel rectangle in location.

        Args:
            _elm: element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.UpdateRectangle_TGIS_PrintLayoutElement
        """
        pass

    def UpdateRectangleEx(
      self,
      _elm: TGIS_PrintLayoutElement,
      _print_area: TRect,
      _page_width: int,
      _page_height: int,
      _dpi: int
    ) -> None: 
        """
        Update element pixel rectangle in location.

        Args:
            _elm: element
            _print_area: print area pixel bounds
            _page_width: page width
            _page_height: page height
            _dpi: printer ppi

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.UpdateRectangleEx_TGIS_PrintLayoutElement_TRect_Integer_Integer_Integer
        """
        pass

    def UpdateTemplate(
      self,
      _dpi: int,
      _print_area: TRect,
      _page_width: int,
      _page_height: int
    ) -> None: 
        """
        Update template processing parameters. Call after printer change.

        Args:
            _dpi: printer resolution
            _print_area: print area
            _page_width: page width
            _page_height: page height

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.UpdateTemplate_Integer_TRect_Integer_Integer
        """
        pass

    
    def Elements(
      self,
      _index: int
    ) -> TGIS_PrintLayoutElement: 
        """
        Element object accessed by index from internal list.

        Args:
            _index: element index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.Elements
        """
        pass

    @property
    def ElementsCount(
      self
    ) -> int: 
        """
        Number of elements in template.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.ElementsCount
        """
        pass

    @property
    def Template(
      self
    ) -> TGIS_TemplatePrint: 
        """
        Print template object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.Template
        """
        pass

    @property
    def ElementEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_PrintLayoutElement], None]: 
        """
        Event called for each found element in template. If not assigned, all elements will 
        be stored in the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.ElementEvent
        """
        pass

    @ElementEvent.setter
    def ElementEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_PrintLayoutElement], None]
    ) -> None: 
        """
        Event called for each found element in template. If not assigned, all elements will 
        be stored in the list.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.ElementEvent
        """
        pass

    @property
    def InitElementEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_PrintLayoutElement], None]: 
        """
        Event called for each found element in template for initialization.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.InitElementEvent
        """
        pass

    @InitElementEvent.setter
    def InitElementEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_PrintLayoutElement], None]
    ) -> None: 
        """
        Event called for each found element in template for initialization.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrintBuilder.InitElementEvent
        """
        pass

class TGIS_PrintLayoutSnap:
    """
    Snap parameters encapsulation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutSnap
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutSnap.Create_void
        """
        pass

    def AsText(
      self
    ) -> str: 
        """
        Get current snap as text.

        Returns:
            snap as text

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutSnap.AsText_void
        """
        pass

    @classmethod
    def CreateDefault(
      cls
    ) -> TGIS_PrintLayoutSnap: 
        """
        Get default location.

        Returns:
            default location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutSnap.CreateDefault_void
        """
        pass

    def Round(
      self,
      _v: float,
      _u: TGIS_PrintLayoutUnits,
      _a: TGIS_PrintLayoutAnchor,
      _print_area: TRect,
      _page_width: int,
      _page_height: int,
      _dpi: int
    ) -> float: 
        """
        Snaps according to Value and Units.

        Args:
            _v: value to snap
            _u: unit of the value
            _a: layout anchor
            _print_area: print area
            _page_width: page width
            _page_height: page height
            _dpi: printer ppi

        Returns:
            snapped value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutSnap.Round_Single_TGIS_PrintLayoutUnits_TGIS_PrintLayoutAnchor_TRect_Integer_Integer_Integer
        """
        pass

    def SetValues(
      self,
      _values: str
    ) -> None: 
        """
        Set new value.

        Args:
            _values: new values in text form

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutSnap.SetValues_String
        """
        pass

    @property
    def Value(
      self
    ) -> float: 
        """
        snap value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutSnap.Value
        """
        pass

    @Value.setter
    def Value(
      self,
      _value: float
    ) -> None: 
        """
        snap value

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutSnap.Value
        """
        pass

    @property
    def Units(
      self
    ) -> TGIS_PrintLayoutUnits: 
        """
        snap unit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutSnap.Units
        """
        pass

    @Units.setter
    def Units(
      self,
      _value: TGIS_PrintLayoutUnits
    ) -> None: 
        """
        snap unit

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutSnap.Units
        """
        pass

class TGIS_PrintLayoutPosition:
    """
    Print layout element position type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPosition
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPosition.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _value: float,
      _units: TGIS_PrintLayoutUnits,
      _anchor: TGIS_PrintLayoutAnchor
    ) -> None: 
        """
        Constructor.

        Args:
            _value: position value
            _units: position unit
            _anchor: position anchor

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPosition.Create_Double_TGIS_PrintLayoutUnits_TGIS_PrintLayoutAnchor
        """
        pass

    def AsText(
      self
    ) -> str: 
        """
        Get position value as text.

        Returns:
            position as text

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPosition.AsText_void
        """
        pass

    def AsTplText(
      self
    ) -> str: 
        """
        Get position value as text used in tpl file.

        Returns:
            position as text

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPosition.AsTplText_void
        """
        pass

    def SetValues(
      self,
      _value: float,
      _units: str,
      _anchor: TGIS_PrintLayoutAnchor
    ) -> None: 
        """
        Set position values.

        Args:
            _value: position value
            _units: position unit
            _anchor: position anchor

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPosition.SetValues_Double_String_TGIS_PrintLayoutAnchor
        """
        pass

    @property
    def Value(
      self
    ) -> float: 
        """
        position value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPosition.Value
        """
        pass

    @Value.setter
    def Value(
      self,
      _value: float
    ) -> None: 
        """
        position value

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPosition.Value
        """
        pass

    @property
    def Units(
      self
    ) -> TGIS_PrintLayoutUnits: 
        """
        position unit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPosition.Units
        """
        pass

    @Units.setter
    def Units(
      self,
      _value: TGIS_PrintLayoutUnits
    ) -> None: 
        """
        position unit

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPosition.Units
        """
        pass

    @property
    def Anchor(
      self
    ) -> TGIS_PrintLayoutAnchor: 
        """
        position anchor

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPosition.Anchor
        """
        pass

    @Anchor.setter
    def Anchor(
      self,
      _value: TGIS_PrintLayoutAnchor
    ) -> None: 
        """
        position anchor

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutPosition.Anchor
        """
        pass

class TGIS_PrintLayoutWidth:
    """
    Print layout element width type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutWidth
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutWidth.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _value: float,
      _units: TGIS_PrintLayoutUnits
    ) -> None: 
        """
        Constructor.

        Args:
            _value: width value
            _units: width unit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutWidth.Create_Double_TGIS_PrintLayoutUnits
        """
        pass

    def AsText(
      self
    ) -> str: 
        """
        Get width value as text.

        Returns:
            width as text

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutWidth.AsText_void
        """
        pass

    def SetValues(
      self,
      _value: float,
      _units: str
    ) -> None: 
        """
        Set position values.

        Args:
            _value: position value
            _units: position unit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutWidth.SetValues_Double_String
        """
        pass

    @property
    def Value(
      self
    ) -> float: 
        """
        width value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutWidth.Value
        """
        pass

    @Value.setter
    def Value(
      self,
      _value: float
    ) -> None: 
        """
        width value

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutWidth.Value
        """
        pass

    @property
    def Units(
      self
    ) -> TGIS_PrintLayoutUnits: 
        """
        width unit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutWidth.Units
        """
        pass

    @Units.setter
    def Units(
      self,
      _value: TGIS_PrintLayoutUnits
    ) -> None: 
        """
        width unit

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutWidth.Units
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        width in pixels

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutWidth.Width
        """
        pass

    @Width.setter
    def Width(
      self,
      _value: int
    ) -> None: 
        """
        width in pixels

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutWidth.Width
        """
        pass

class TGIS_PrintLayoutLocation:
    """
    Print layout element location type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.Create_void
        """
        pass

    @classmethod
    def CreateDefault(
      cls
    ) -> TGIS_PrintLayoutLocation: 
        """
        Get default location.

        Returns:
            default location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.CreateDefault_void
        """
        pass

    @overload
    def UpdateRectangle(
      self,
      _print_area: TRect,
      _page_width: int,
      _page_height: int,
      _dpi: int
    ) -> None: 
        """
        Calculate Rectangle property according to current coordinates.

        Args:
            _print_area: print area
            _page_width: page width
            _page_height: page height
            _dpi: dpi value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.UpdateRectangle_TRect_Integer_Integer_Integer
        """
        pass

    @overload
    def UpdateRectangle(
      self,
      _bounds: TRect,
      _left: bool,
      _top: bool,
      _right: bool,
      _bottom: bool,
      _snap: TGIS_PrintLayoutSnap,
      _print_area: TRect,
      _page_width: int,
      _page_height: int,
      _dpi: int
    ) -> None: 
        """
        Update location from pixel bounds.

        Args:
            _bounds: new bounds
            _left: if change the left coordinate
            _top: if change the top coordinate
            _right: if change the right coordinate
            _bottom: if change the bottom coordinate
            _snap: snap value
            _print_area: print area
            _page_width: page width
            _page_height: page height
            _dpi: dpi value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.UpdateRectangle_TRect_Boolean_Boolean_Boolean_Boolean_82C64F3632B9879DC146035F01BE7816
        """
        pass

    @overload
    def UpdateRectangle(
      self,
      _delta_left: float,
      _delta_top: float,
      _delta_right: float,
      _delta_bottom: float,
      _snap: TGIS_PrintLayoutSnap,
      _print_area: TRect,
      _page_width: int,
      _page_height: int,
      _dpi: int
    ) -> None: 
        """
        Update location from pixel bounds.

        Args:
            _delta_left: change of the left coordinate
            _delta_top: change of the top coordinate
            _delta_right: change of the right coordinate
            _delta_bottom: change of the bottom coordinate
            _snap: snap value
            _print_area: print area
            _page_width: page width
            _page_height: page height
            _dpi: dpi value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.UpdateRectangle_Double_Double_Double_Double_TGIS_PrintLayoutSnap_TRect_Integer_Integer_Integer
        """
        pass

    def UpdateRectangleEx(
      self,
      _print_area: TRect,
      _page_width: int,
      _page_height: int,
      _dpi: int
    ) -> None: 
        """
        Update pixel rectangle after printer change.

        Args:
            _print_area: print area
            _page_width: page width
            _page_height: page height
            _dpi: dpi value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.UpdateRectangleEx_TRect_Integer_Integer_Integer
        """
        pass

    def UpdateToRectangle(
      self,
      _bounds: TRect,
      _print_area: TRect,
      _page_width: int,
      _page_height: int,
      _dpi: int
    ) -> None: 
        """
        Update location from pixel bounds.

        Args:
            _bounds: new bounds
            _print_area: print area
            _page_width: page width
            _page_height: page height
            _dpi: dpi value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.UpdateToRectangle_TRect_TRect_Integer_Integer_Integer
        """
        pass

    def UpdateToRectangleEx(
      self,
      _bounds: TRect,
      _print_area: TRect,
      _page_width: int,
      _page_height: int,
      _dpi: int
    ) -> None: 
        """
        Update location from pixel bounds.

        Args:
            _bounds: new bounds
            _print_area: print area
            _page_width: page width
            _page_height: page height
            _dpi: dpi value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.UpdateToRectangleEx_TRect_TRect_Integer_Integer_Integer
        """
        pass

    @property
    def Left(
      self
    ) -> TGIS_PrintLayoutPosition: 
        """
        Position of left corner.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.Left
        """
        pass

    @Left.setter
    def Left(
      self,
      _value: TGIS_PrintLayoutPosition
    ) -> None: 
        """
        Position of left corner.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.Left
        """
        pass

    @property
    def Right(
      self
    ) -> TGIS_PrintLayoutPosition: 
        """
        Position of right corner.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.Right
        """
        pass

    @Right.setter
    def Right(
      self,
      _value: TGIS_PrintLayoutPosition
    ) -> None: 
        """
        Position of right corner.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.Right
        """
        pass

    @property
    def Top(
      self
    ) -> TGIS_PrintLayoutPosition: 
        """
        Position of top corner.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.Top
        """
        pass

    @Top.setter
    def Top(
      self,
      _value: TGIS_PrintLayoutPosition
    ) -> None: 
        """
        Position of top corner.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.Top
        """
        pass

    @property
    def Bottom(
      self
    ) -> TGIS_PrintLayoutPosition: 
        """
        Position of bottom corner.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.Bottom
        """
        pass

    @Bottom.setter
    def Bottom(
      self,
      _value: TGIS_PrintLayoutPosition
    ) -> None: 
        """
        Position of bottom corner.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.Bottom
        """
        pass

    @property
    def Rectangle(
      self
    ) -> TRect: 
        """
        Rectangle in pixels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.Rectangle
        """
        pass

    @Rectangle.setter
    def Rectangle(
      self,
      _value: TRect
    ) -> None: 
        """
        Rectangle in pixels.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintLayoutLocation.Rectangle
        """
        pass

class TGIS_PrintManagerAbstract( TObject ):
    """
    Basic print manager class to be used as a base class for print managers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.Create_void
        """
        pass

    @overload
    def DrawControl(
      self,
      _control: IGIS_PrintableControl,
      _rect: TRect
    ) -> None: 
        """
        Print a control.

        Args:
            _control: control to be printed
            _rect: rectangle to be printed (area of print on paper)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.DrawControl_IGIS_PrintableControl_TRect
        """
        pass

    @overload
    def DrawControl(
      self,
      _control: IGIS_PrintableControl,
      _rect: TRect,
      _scale: float
    ) -> None: 
        """
        Print a control.

        Args:
            _control: control to be printed
            _rect: rectangle to be printed (area of print on paper)
            _scale: scale factor used during printing;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.DrawControl_IGIS_PrintableControl_TRect_Double
        """
        pass

    @overload
    def DrawGraphic(
      self,
      _path: str,
      _rect: TRect
    ) -> None: 
        """
        Print a graphic.

        Args:
            _path: path to the graphic
            _rect: rectangle to be printed (area of print on paper)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.DrawGraphic_String_TRect
        """
        pass

    @overload
    def DrawGraphic(
      self,
      _graphic: TGIS_TemplateGraphic,
      _rect: TRect
    ) -> None: 
        """
        Print a graphic.

        Args:
            _graphic: graphic to print
            _rect: rectangle to be printed (area of print on paper)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.DrawGraphic_TGIS_TemplateGraphic_TRect
        """
        pass

    @overload
    def DrawMap(
      self,
      _viewer: IGIS_Viewer,
      _extent: TGIS_Extent,
      _rect: TRect,
      _scale: VarParameter
    ) -> None: 
        """
        Print a map given by the viewer using passed _printer.

        Args:
            _viewer: map to print
            _extent: map extent to be used
            _rect: rectangle to be printed (area of print on paper)
            _scale: scale factor used during printing (for printing scale etc); if scale=0 then 
              scale will be calculated automatically to fit the _extent; the value (in/out) is 
              passed as float in _scale.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.DrawMap_IGIS_Viewer_TGIS_Extent_TRect_Double
        """
        pass

    @overload
    def DrawMap(
      self,
      _viewer: IGIS_Viewer,
      _extent: TGIS_Extent,
      _rect: TRect,
      _scale: VarParameter,
      _rextent: VarParameter
    ) -> None: 
        """
        Print a map given by the viewer.

        Args:
            _viewer: map to print
            _extent: map extent to be used
            _rect: rectangle to be printed (area of print on paper)
            _scale: scale factor used during printing (for printing scale etc); if scale=0 then 
              scale will be calculated automatically to fit the _extent; the value (in/out) is 
              passed as float in _scale.Value property
            _rextent: real printed map extent; the value (in/out) is passed as TGIS_Extent in 
              _rextent.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.DrawMap_IGIS_Viewer_TGIS_Extent_TRect_Double_TGIS_Extent
        """
        pass

    def GetDrawingParams(
      self,
      _viewer: IGIS_Viewer,
      _extent: TGIS_Extent,
      _rect: TRect,
      _scale: VarParameter
    ) -> None: 
        """
        Get the actual scale of the map to be printed. It can be used as an input parameter 
        in DrawControl method.

        Args:
            _viewer: map to print
            _extent: map extent to be used
            _rect: rectangle to be printed (area of print on paper)
            _scale: calculated scale of the map scale factor used during printing (for printing 
              scale etc); if scale=0 then scale will be calculated automatically to fit the _extent; 
              the value (in/out) is passed as float in _scale.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.GetDrawingParams_IGIS_Viewer_TGIS_Extent_TRect_Double
        """
        pass

    @overload
    def Print(
      self,
      _viewer: IGIS_Viewer
    ) -> None: 
        """
        Print a map given by the viewer using default printer.

        Args:
            _viewer: viewer with a map to print

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.Print_IGIS_Viewer
        """
        pass

    @overload
    def Print(
      self,
      _viewer: IGIS_Viewer,
      _printer: TObject
    ) -> None: 
        """
        Print a map given by the viewer using passed _printer.

        Args:
            _viewer: viewer with a map to print
            _printer: printer to be used

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.Print_IGIS_Viewer_TObject
        """
        pass

    @overload
    def Print(
      self,
      _viewer: IGIS_Viewer,
      _printer: TObject,
      _scale: VarParameter
    ) -> None: 
        """
        Print a map given by the viewer using passed _printer.

        Args:
            _viewer: viewer with a map to print
            _printer: printer to be used
            _scale: scale factor used during print (for printing scale etc); if scale=0 then 
              scale will be calculated automatically to fit the _extent; the value (in/out) is 
              passed as float in _scale.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.Print_IGIS_Viewer_TObject_Double
        """
        pass

    @property
    def Footer(
      self
    ) -> str: 
        """
        Text for the footer that will appear on a printed page.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.Footer
        """
        pass

    @Footer.setter
    def Footer(
      self,
      _value: str
    ) -> None: 
        """
        Text for the footer that will appear on a printed page.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.Footer
        """
        pass

    @property
    def FooterFont(
      self
    ) -> TGIS_Font: 
        """
        Font for the header that will appear on a printed page. DefaultValue: Arial, 10pt, 
        Black.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.FooterFont
        """
        pass

    @FooterFont.setter
    def FooterFont(
      self,
      _value: TGIS_Font
    ) -> None: 
        """
        Font for the header that will appear on a printed page. DefaultValue: Arial, 10pt, 
        Black.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.FooterFont
        """
        pass

    @property
    def OverlappedExtentMargin(
      self
    ) -> int: 
        """
        Margin (in pixels) to scan around a printed tile.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.OverlappedExtentMargin
        """
        pass

    @OverlappedExtentMargin.setter
    def OverlappedExtentMargin(
      self,
      _value: int
    ) -> None: 
        """
        Margin (in pixels) to scan around a printed tile.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.OverlappedExtentMargin
        """
        pass

    @property
    def Subtitle(
      self
    ) -> str: 
        """
        Text for the subtitle that will appear on a printed page.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.Subtitle
        """
        pass

    @Subtitle.setter
    def Subtitle(
      self,
      _value: str
    ) -> None: 
        """
        Text for the subtitle that will appear on a printed page.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.Subtitle
        """
        pass

    @property
    def SubtitleFont(
      self
    ) -> TGIS_Font: 
        """
        Font for the subtitle that will appear on a printed page. DefaultValue: Arial, 10pt, 
        Bold, Black.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.SubtitleFont
        """
        pass

    @SubtitleFont.setter
    def SubtitleFont(
      self,
      _value: TGIS_Font
    ) -> None: 
        """
        Font for the subtitle that will appear on a printed page. DefaultValue: Arial, 10pt, 
        Bold, Black.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.SubtitleFont
        """
        pass

    @property
    def Template(
      self
    ) -> TGIS_TemplatePrint: 
        """
        Print template object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.Template
        """
        pass

    @Template.setter
    def Template(
      self,
      _value: TGIS_TemplatePrint
    ) -> None: 
        """
        Print template object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.Template
        """
        pass

    @property
    def TemporaryVisibleExtent(
      self
    ) -> TGIS_Extent: 
        """
        Area for rendered labels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.TemporaryVisibleExtent
        """
        pass

    @TemporaryVisibleExtent.setter
    def TemporaryVisibleExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Area for rendered labels.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.TemporaryVisibleExtent
        """
        pass

    @property
    def TileSize(
      self
    ) -> int: 
        """
        Size of tile (in pixels) used when printing semitransparent layers. Minimum=128; 
        Maximum=8192; Default is optimized for A4 single pass print.
        
        Increase the size if you want to speed-up the printing. But be aware that bigger 
        size can cause memory printer problems.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.TileSize
        """
        pass

    @TileSize.setter
    def TileSize(
      self,
      _value: int
    ) -> None: 
        """
        Size of tile (in pixels) used when printing semitransparent layers. Minimum=128; 
        Maximum=8192; Default is optimized for A4 single pass print.
        
        Increase the size if you want to speed-up the printing. But be aware that bigger 
        size can cause memory printer problems.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.TileSize
        """
        pass

    @property
    def Title(
      self
    ) -> str: 
        """
        Text for the title that will appear on a printed page.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.Title
        """
        pass

    @Title.setter
    def Title(
      self,
      _value: str
    ) -> None: 
        """
        Text for the title that will appear on a printed page.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.Title
        """
        pass

    @property
    def TitleFont(
      self
    ) -> TGIS_Font: 
        """
        Font for the title that will appear on a printed page. DefaultValue: Arial, 18pt, 
        Bold, Black.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.TitleFont
        """
        pass

    @TitleFont.setter
    def TitleFont(
      self,
      _value: TGIS_Font
    ) -> None: 
        """
        Font for the title that will appear on a printed page. DefaultValue: Arial, 18pt, 
        Bold, Black.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PrintManagerAbstract.TitleFont
        """
        pass

class TGIS_ProjectQgis:
    """
    Class for importing Qgis projects (version 2.x).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProjectQgis
    """

    @overload
    def __init__(
      self,
      _viewer: TGIS_Viewer
    ) -> None: 
        """
        Construct an instance based on provided viewer object.

        Args:
            _viewer: viewer which will be associated with this object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProjectQgis.Create_TGIS_Viewer
        """
        pass

    def Import(
      self,
      _path: str
    ) -> None: 
        """
        Import project form Qgis projects.

        Args:
            _path: project file to be opened

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ProjectQgis.Import_String
        """
        pass

class TGIS_QuadTreeNode( TObject ):
    """
    Quad tree node class.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTreeNode
    """

    @overload
    def __init__(
      self,
      _extent: TGIS_Extent
    ) -> None: 
        """
        Constructor.

        Args:
            _extent: quad tree node extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTreeNode.Create_TGIS_Extent
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear node.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTreeNode.Clear_void
        """
        pass

    def ForEach(
      self,
      _callback: typing.Callable[[TGIS_QuadTreeItem, TObject, Boolean], None],
      _data: TObject
    ) -> None: 
        """
        For each item in tree call an event.

        Args:
            _callback: event callback function that will be fired for each item; the value is 
              a callback to a method with parameters defined by TGIS_QuadTreeForEachItemEvent
            _data: user data

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTreeNode.ForEach_TGIS_QuadTreeForEachItemEvent_TObject
        """
        pass

class TGIS_QuadTree( TObject ):
    """
    Quad tree class.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree
    """

    @overload
    def __init__(
      self,
      _path: str
    ) -> None: 
        """
        Constructor of file based tree.

        Args:
            _path: path to file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree.Create_String
        """
        pass

    @overload
    def __init__(
      self,
      _extent: TGIS_Extent
    ) -> None: 
        """
        Constructor of in memory tree.

        Args:
            _extent: quad tree extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree.Create_TGIS_Extent
        """
        pass

    def CleanUp(
      self
    ) -> None: 
        """
        Clean up tree removing empty nodes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree.CleanUp_void
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear tree.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree.Clear_void
        """
        pass

    def EstimateMaxDepth(
      self,
      _maxFeatures: int
    ) -> None: 
        """
        Calculate max depth of a tree based on features count.

        Args:
            _maxFeatures: number of features to store

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree.EstimateMaxDepth_Integer
        """
        pass

    def ForEach(
      self,
      _callback: typing.Callable[[TGIS_QuadTreeItem, TObject, Boolean], None],
      _data: TObject
    ) -> None: 
        """
        For each item in tree call an event.

        Args:
            _callback: event callback function that will be fired for each item; the value is 
              a callback to a method with parameters defined by TGIS_QuadTreeForEachItemEvent
            _data: user data

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree.ForEach_TGIS_QuadTreeForEachItemEvent_TObject
        """
        pass

    def Insert(
      self,
      _id: int,
      _extent: TGIS_Extent
    ) -> None: 
        """
        Insert a feature into the tree.

        Args:
            _id: feature id
            _extent: feature extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree.Insert_Integer_TGIS_Extent
        """
        pass

    def SaveToFile(
      self,
      _fileName: str
    ) -> None: 
        """
        Save a tree on disc.

        Args:
            _fileName: file name to write

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree.SaveToFile_String
        """
        pass

    def Search(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_ListOfIntegers: 
        """
        Search a tree within given extent and return a list with feature id. If the tree 
        is file based, results will be estimated and must be filtered withint extent.

        Args:
            _extent: extent to search

        Returns:
            list of features found within the extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree.Search_TGIS_Extent
        """
        pass

    @property
    def BucketCapacity(
      self
    ) -> int: 
        """
        Maximum number of features stored within a single node. Default is 8.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree.BucketCapacity
        """
        pass

    @BucketCapacity.setter
    def BucketCapacity(
      self,
      _value: int
    ) -> None: 
        """
        Maximum number of features stored within a single node. Default is 8.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree.BucketCapacity
        """
        pass

    @property
    def FeaturesCount(
      self
    ) -> int: 
        """
        Total number of stored features.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree.FeaturesCount
        """
        pass

    @property
    def MaxDepth(
      self
    ) -> int: 
        """
        Maximum depth of the quad tree. Default is 0. Maximum is 12. EstimateMaxDepth method 
        can be used to calculate proper value based on features count.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree.MaxDepth
        """
        pass

    @MaxDepth.setter
    def MaxDepth(
      self,
      _value: int
    ) -> None: 
        """
        Maximum depth of the quad tree. Default is 0. Maximum is 12. EstimateMaxDepth method 
        can be used to calculate proper value based on features count.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree.MaxDepth
        """
        pass

    @property
    def SplitRatio(
      self
    ) -> float: 
        """
        Ratio between extents resulting from splitting. 0.5 - split in half 0.55 - each node 
        will contain 55% of the parent node, with 20% overlap. this can prevent shifting 
        high small object on the boundary.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree.SplitRatio
        """
        pass

    @SplitRatio.setter
    def SplitRatio(
      self,
      _value: float
    ) -> None: 
        """
        Ratio between extents resulting from splitting. 0.5 - split in half 0.55 - each node 
        will contain 55% of the parent node, with 20% overlap. this can prevent shifting 
        high small object on the boundary.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTree.SplitRatio
        """
        pass

class TGIS_QuadTreeItem:
    """
    Quad tree item stored in nodes.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTreeItem
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTreeItem.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _uid: int,
      _ext: TGIS_Extent
    ) -> None: 
        """
        Constructor.

        Args:
            _uid: feature id
            _ext: feature extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTreeItem.Create_Integer_TGIS_Extent
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Extent: 
        """
        Feature extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTreeItem.Extent
        """
        pass

    @property
    def Uid(
      self
    ) -> int: 
        """
        Feature id.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_QuadTreeItem.Uid
        """
        pass

class TGIS_RasterAlgebra( TObject ):
    """
    Engine for manipulating raster layers using algebraic expressions.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RasterAlgebra
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RasterAlgebra.Create_void
        """
        pass

    def AddLayer(
      self,
      _layer: TGIS_Layer
    ) -> None: 
        """
        Registers the layer for use in the engine.

        Args:
            _layer: layer object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RasterAlgebra.AddLayer_TGIS_Layer
        """
        pass

    def Execute(
      self,
      _expression: str
    ) -> None: 
        """
        Calculates the result of the algebraic expression.

        Args:
            _expression: algebraic expression as a string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RasterAlgebra.Execute_String
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RasterAlgebra.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RasterAlgebra.BusyEvent
        """
        pass

class TGIS_RendererContext( TObject ):
    """
    Object to store all canvases on rendering context

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.Create_void
        """
        pass

    def AssignBaseMap(
      self,
      _bitmap: TObject,
      _own: bool
    ) -> None: 
        """
        Assign BaseMap bitmap. Free owned one if necessary.

        Args:
            _bitmap: bitmap to be assigned
            _own: True if context own bitmap (is responsible to free it)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.AssignBaseMap_TObject_Boolean
        """
        pass

    def AssignCharts(
      self,
      _bitmap: TObject,
      _own: bool
    ) -> None: 
        """
        Assign Charts bitmap. Free owned one if necessary.

        Args:
            _bitmap: bitmap to be assigned
            _own: True if context own bitmap (is responsible to free it)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.AssignCharts_TObject_Boolean
        """
        pass

    def AssignDrawContext(
      self,
      _factory: TObject,
      _nativeContext: TObject,
      _sourceContext: TObject
    ) -> None: 
        """
        Assign draw context objects.

        Args:
            _factory: draw context factory
            _nativeContext: draw context to draw directly to
            _sourceContext: source draw context factory

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.AssignDrawContext_TObject_TObject_TObject
        """
        pass

    def AssignLabels(
      self,
      _bitmap: TObject,
      _own: bool
    ) -> None: 
        """
        Assign Labels bitmap. Free owned one if necessary.

        Args:
            _bitmap: bitmap to be assigned
            _own: True if context own bitmap (is responsible to free it)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.AssignLabels_TObject_Boolean
        """
        pass

    def AssignSelection(
      self,
      _bitmap: TObject,
      _own: bool
    ) -> None: 
        """
        Assign Selection bitmap. Free existing one if necessary.

        Args:
            _bitmap: bitmap to be assigned
            _own: True if context own bitmap (is responsible to free it)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.AssignSelection_TObject_Boolean
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear context status. Free all owned bitmaps.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.Clear_void
        """
        pass

    def ClearDrawContext(
      self
    ) -> None: 
        """
        Clear draw context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.ClearDrawContext_void
        """
        pass

    def DoProgressiveUpdate(
      self
    ) -> None: 
        """
        If ProgressiveHelper is assigned then perform TGIS_ViewerWndHelperRun.DoSynchronize( 
        False ) in this context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.DoProgressiveUpdate_void
        """
        pass

    @property
    def BaseMap(
      self
    ) -> TObject: 
        """
        Canvas used to draw base map (common content).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.BaseMap
        """
        pass

    @property
    def BaseMapOnDemand(
      self
    ) -> bool: 
        """
        True if underlying bitmap should be created on-demand.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.BaseMapOnDemand
        """
        pass

    @property
    def Charts(
      self
    ) -> TObject: 
        """
        Canvas used to draw charts.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.Charts
        """
        pass

    @property
    def ChartsOnDemand(
      self
    ) -> bool: 
        """
        True if underlying bitmap should be created on-demand.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.ChartsOnDemand
        """
        pass

    @property
    def DrawContextFactory(
      self
    ) -> TObject: 
        """
        Draw context factory.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.DrawContextFactory
        """
        pass

    @property
    def Labels(
      self
    ) -> TObject: 
        """
        Canvas used to draw labels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.Labels
        """
        pass

    @property
    def LabelsOnDemand(
      self
    ) -> bool: 
        """
        True if underlying bitmap should be created on-demand.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.LabelsOnDemand
        """
        pass

    @property
    def NativeDrawContext(
      self
    ) -> TObject: 
        """
        Native draw context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.NativeDrawContext
        """
        pass

    @property
    def ProgressiveHelper(
      self
    ) -> TObject: 
        """
        Helper for progressive, thread safely. updates if any.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.ProgressiveHelper
        """
        pass

    @ProgressiveHelper.setter
    def ProgressiveHelper(
      self,
      _value: TObject
    ) -> None: 
        """
        Helper for progressive, thread safely. updates if any.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.ProgressiveHelper
        """
        pass

    @property
    def Selection(
      self
    ) -> TObject: 
        """
        Canvas used to draw selected objects.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.Selection
        """
        pass

    @property
    def SelectionOnDemand(
      self
    ) -> bool: 
        """
        True if underlying bitmap should be created on-demand.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.SelectionOnDemand
        """
        pass

    @property
    def SourceDrawContext(
      self
    ) -> TObject: 
        """
        Source draw context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererContext.SourceDrawContext
        """
        pass

class TGIS_RendererAbstract( TObject ):
    """
    Basic renderer class to be used as a parent for customer map renderers for VCL, FireMonkey, 
    WPF etc.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor. Creates bitmap 320x240.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.Create_void
        """
        pass

    def AfterDraw(
      self
    ) -> None: 
        """
        Receive notification about pending renderer update.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.AfterDraw_void
        """
        pass

    def AfterDrawCharts(
      self
    ) -> None: 
        """
        Restore context after PaintShapeChartEvent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.AfterDrawCharts_void
        """
        pass

    def AfterDrawLabels(
      self
    ) -> None: 
        """
        Restore context after PaintShapeLabelEvent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.AfterDrawLabels_void
        """
        pass

    def BeforeDraw(
      self
    ) -> None: 
        """
        Preparation of the draw state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.BeforeDraw_void
        """
        pass

    def CanvasClearTransformation(
      self
    ) -> None: 
        """
        Reset any transformation on the Canvas object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasClearTransformation_void
        """
        pass

    @overload
    def CanvasDrawArc(
      self,
      _x: int,
      _y: int,
      _width: int,
      _height: int,
      _startX: int,
      _startY: int,
      _endX: int,
      _endY: int
    ) -> None: 
        """
        Draw an arc on the Canvas object.

        Args:
            _x: x-coordinate of the upper-left corner of the bounding rectangle (in pixels)
            _y: y-coordinate of the upper-left corner of the bounding rectangle (in pixels)
            _width: width of the ellipse that contains the arc (in pixels)
            _height: height of the ellipse that contains the arc (in pixels)
            _startX: x-coordinate of starting point defined by the intersection of the ellipse 
              and a line defined by the center (in pixels)
            _startY: y-coordinate of starting point defined by the intersection of the ellipse 
              and a line defined by the center (in pixels)
            _endX: x-coordinate of ending point defined by the intersection of the ellipse and 
              a line defined by the center (in pixels)
            _endY: y-coordinate of ending point defined by the intersection of the ellipse and 
              a line defined by the center (in pixels)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawArc_Integer_Integer_Integer_Integer_Integer_Integer_Integer_Integer
        """
        pass

    @overload
    def CanvasDrawArc(
      self,
      _x: int,
      _y: int,
      _radius: int,
      _startAngle: float,
      _sweepAngle: float
    ) -> None: 
        """
        Draw an arc on the Canvas object.

        Args:
            _x: x-coordinate of the center of the ellipse that contains the arc (in pixels)
            _y: y-coordinate of the center of the ellipse that contains the arc (in pixels)
            _radius: radius of the ellipse that contains the arc
            _startAngle: angle between the x-axis and the starting point of the arc
            _sweepAngle: angle between the starting and ending points of the arc

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawArc_Integer_Integer_Integer_Single_Single
        """
        pass

    @overload
    def CanvasDrawBitmap(
      self,
      _bmp: TGIS_Pixels,
      _size: TPoint,
      _dst: TRect,
      _format: TGIS_BitmapFormat,
      _order: TGIS_BitmapLinesOrder
    ) -> None: 
        """
        Draw bitmap on the Canvas object.

        Args:
            _bmp: array of bitmap pixels
            _size: width/height of _bmp (in pixels)
            _dst: destination rectangle (in pixels); scaling will apply if required
            _format: pixel format of _bmp array
            _order: line order of _bmp array

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawBitmap_TGIS_Pixels_TPoint_TRect_TGIS_BitmapFormat_TGIS_BitmapLinesOrder
        """
        pass

    @overload
    def CanvasDrawBitmap(
      self,
      _bmp: TGIS_Bitmap,
      _dst: TRect
    ) -> None: 
        """
        Draw bitmap on the Canvas object.

        Args:
            _bmp: bitmap to be drawn
            _dst: destination rectangle (in pixels); scaling will apply if required

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawBitmap_TGIS_Bitmap_TRect
        """
        pass

    def CanvasDrawEllipse(
      self,
      _x: int,
      _y: int,
      _width: int,
      _height: int
    ) -> None: 
        """
        Draw an ellipse on the Canvas object.

        Args:
            _x: x-coordinate of the upper-left corner of the bounding rectangle (in pixels)
            _y: y-coordinate of the upper-left corner of the bounding rectangle (in pixels)
            _width: ellipse width (in pixels)
            _height: ellipse height (in pixels)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawEllipse_Integer_Integer_Integer_Integer
        """
        pass

    def CanvasDrawLine(
      self,
      _x1: int,
      _y1: int,
      _x2: int,
      _y2: int
    ) -> None: 
        """
        Draw a line on the Canvas object.

        Args:
            _x1: x of staring point (in pixels)
            _y1: y of staring point (in pixels)
            _x2: x of ending point (in pixels)
            _y2: y of ending point (in pixels)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawLine_Integer_Integer_Integer_Integer
        """
        pass

    def CanvasDrawPie(
      self,
      _angle_0: float,
      _angle_1: float,
      _radius: int,
      _origin_x: int,
      _origin_y: int
    ) -> None: 
        """
        Draw a pie on the Canvas object.

        Args:
            _angle_0: starting angle clockwise from the x-axis to the first side of the pipe 
              (in radians)
            _angle_1: ending angle from the first side to the second side of the pipe (in radians)
            _radius: pie radius (in radians)
            _origin_x: x origin point of pie center (in pixels)
            _origin_y: y origin point of pie center (in pixels)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawPie_Double_Double_Integer_Integer_Integer
        """
        pass

    @overload
    def CanvasDrawPolygon(
      self,
      _points: TGIS_DrawBuf
    ) -> None: 
        """
        Draw a polygon on the Canvas object.

        Args:
            _points: array of all points (in pixels)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawPolygon_TGIS_DrawBuf
        """
        pass

    @overload
    def CanvasDrawPolygon(
      self,
      _points: TGIS_DrawBufF
    ) -> None: 
        """
        Draw a polygon on the Canvas object.

        Args:
            _points: array of all points (in pixels)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawPolygon_TGIS_DrawBufF
        """
        pass

    @overload
    def CanvasDrawPolygon(
      self,
      _points: TGIS_DrawBuf,
      _count: int
    ) -> None: 
        """
        Draw a polygon on the Canvas object.

        Args:
            _points: array of all points (in pixels)
            _count: number of points to be drawn from the _points array

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawPolygon_TGIS_DrawBuf_Integer
        """
        pass

    @overload
    def CanvasDrawPolygon(
      self,
      _points: TGIS_DrawBufF,
      _count: int
    ) -> None: 
        """
        Draw a polygon on the Canvas object.

        Args:
            _points: array of all points (in pixels)
            _count: number of points to be drawn from the _points array

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawPolygon_TGIS_DrawBufF_Integer
        """
        pass

    @overload
    def CanvasDrawPolygon(
      self,
      _points: TGIS_DrawBuf,
      _parts: TGIS_IntegerArray
    ) -> None: 
        """
        Draw a polygon on the Canvas object.

        Args:
            _points: array of all points (in pixels)
            _parts: array of all parts; each entry is a part index starting offset

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawPolygon_TGIS_DrawBuf_TGIS_IntegerArray
        """
        pass

    @overload
    def CanvasDrawPolygon(
      self,
      _points: TGIS_DrawBufF,
      _parts: TGIS_IntegerArray
    ) -> None: 
        """
        Draw a polygon on the Canvas object.

        Args:
            _points: array of all points (in pixels)
            _parts: array of all parts; each entry is a part index starting offset

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawPolygon_TGIS_DrawBufF_TGIS_IntegerArray
        """
        pass

    @overload
    def CanvasDrawPolyLine(
      self,
      _points: TGIS_DrawBuf
    ) -> None: 
        """
        Draw a poly-line on the Canvas object.

        Args:
            _points: array of all points (in pixels)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawPolyLine_TGIS_DrawBuf
        """
        pass

    @overload
    def CanvasDrawPolyLine(
      self,
      _points: TGIS_DrawBufF
    ) -> None: 
        """
        Draw a poly-line on the Canvas object.

        Args:
            _points: array of all points (in pixels)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawPolyLine_TGIS_DrawBufF
        """
        pass

    @overload
    def CanvasDrawPolyLine(
      self,
      _points: TGIS_DrawBuf,
      _count: int
    ) -> None: 
        """
        Draw a poly-line on the Canvas object.

        Args:
            _points: array of all points (in pixels)
            _count: number of points to be drawn from the _points array

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawPolyLine_TGIS_DrawBuf_Integer
        """
        pass

    @overload
    def CanvasDrawPolyLine(
      self,
      _points: TGIS_DrawBufF,
      _count: int
    ) -> None: 
        """
        Draw a poly-line on the Canvas object.

        Args:
            _points: array of all points (in pixels)
            _count: number of points to be drawn from the _points array

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawPolyLine_TGIS_DrawBufF_Integer
        """
        pass

    @overload
    def CanvasDrawPolyLine(
      self,
      _points: TGIS_DrawBuf,
      _parts: TGIS_IntegerArray
    ) -> None: 
        """
        Draw a poly-line on the Canvas object.

        Args:
            _points: array of all points (in pixels)
            _parts: array of all parts; each entry is a part index starting offset

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawPolyLine_TGIS_DrawBuf_TGIS_IntegerArray
        """
        pass

    @overload
    def CanvasDrawPolyLine(
      self,
      _points: TGIS_DrawBufF,
      _parts: TGIS_IntegerArray
    ) -> None: 
        """
        Draw a poly-line on the Canvas object.

        Args:
            _points: array of all points (in pixels)
            _parts: array of all parts; each entry is a part index starting offset

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawPolyLine_TGIS_DrawBufF_TGIS_IntegerArray
        """
        pass

    def CanvasDrawRectangle(
      self,
      _rect: TRect
    ) -> None: 
        """
        Draw a rectangle on the Canvas object.

        Args:
            _rect: rectangle (in pixels)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawRectangle_TRect
        """
        pass

    def CanvasDrawText(
      self,
      _rect: TRect,
      _text: str
    ) -> None: 
        """
        Draw a text on the Canvas object.

        Args:
            _rect: rectangle (in pixels)
            _text: text to be drawn

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasDrawText_TRect_String
        """
        pass

    def CanvasFontMetrics(
      self,
      _break_char: VarParameter,
      _height: VarParameter,
      _ascent: VarParameter,
      _true_type: VarParameter
    ) -> None: 
        """
        Provide basing metric for a currently selected CanvasFont.

        Args:
            _break_char: character treated as a break character (space); the value (in/out) is 
              passed as char in _break_char.Value property
            _height: font height in pixels; the value (in/out) is passed as int in _height.Value 
              property
            _ascent: font ascent size in pixels; the value (in/out) is passed as int in _ascent.Value 
              property
            _true_type: True if font is TrueType or equivalent (scalable as vector); the value 
              (in/out) is passed as bool in _true_type.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasFontMetrics_Char_Integer_Integer_Boolean
        """
        pass

    def CanvasNative(
      self
    ) -> TObject: 
        """
        Return rendering context native to current renderer.

        Returns:
            Canvas object specific for current renderer object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasNative_void
        """
        pass

    def CanvasSetTransformation(
      self,
      _angle: float,
      _origin_x: int,
      _origin_y: int
    ) -> None: 
        """
        Set a transformation on the Canvas object.

        Args:
            _angle: rotation angle in radians
            _origin_x: rotation angle x origin point (in pixels)
            _origin_y: rotation angle y origin point (in pixels)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasSetTransformation_Double_Integer_Integer
        """
        pass

    def CanvasTextBaseline(
      self,
      _text: str
    ) -> float: 
        """
        Provide a baseline for the passed text and a currently selected CanvasFont.

        Args:
            _text: text for which we set a baseline

        Returns:
            Baseline for text or -1 if the calculation is not possible

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasTextBaseline_String
        """
        pass

    def CanvasTextEm(
      self,
      _em: float
    ) -> int: 
        """
        Calculate text EM value for a currently selected CanvasFont.

        Args:
            _em: number of em

        Returns:
            Calculated values in pixels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasTextEm_Double
        """
        pass

    def CanvasTextExtent(
      self,
      _text: str
    ) -> TPoint: 
        """
        Calculate text EM value for a currently selected CanvasFont.

        Args:
            _text: text for which extent will be calculated

        Returns:
            Text extent in pixels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasTextExtent_String
        """
        pass

    @overload
    def CreateContext(
      self,
      _parent: IGIS_ViewerParent,
      _viewer: IGIS_Viewer,
      _context: TGIS_RendererContext,
      _shift: TPoint,
      _width: int,
      _height: int,
      _ppi: int,
      _fontscale: int
    ) -> None: 
        """
        Initiate context for the renderer.

        Args:
            _parent: viewer parented interface; for Control* like methods
            _viewer: viewer object
            _context: drawing context
            _shift: left and upper margins for the drawing surface
            _width: width of the drawing surface
            _height: height of the drawing surface
            _ppi: resolution for the drawing surface
            _fontscale: font scaling factor in percents

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CreateContext_IGIS_ViewerParent_IGIS_Viewer_TGIS_RendererContext_TPoint_Integer_Integer_Integer_Integer
        """
        pass

    @overload
    def CreateContext(
      self,
      _parent: IGIS_ViewerParent,
      _viewer: IGIS_Viewer,
      _context: TGIS_RendererContext,
      _shift: TPoint,
      _width: int,
      _height: int,
      _ppi: int,
      _fontscale: int,
      _tilerect: TRect
    ) -> None: 
        """
        Initiate context for the renderer.

        Args:
            _parent: viewer parented interface; for Control* like methods
            _viewer: viewer object
            _context: drawing context
            _shift: left and upper margins for the drawing surface
            _width: width of the drawing surface
            _height: height of the drawing surface
            _ppi: resolution for the drawing surface
            _fontscale: font scaling factor in percents
            _tilerect: rendering context location; used upon rendering tiles

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CreateContext_IGIS_ViewerParent_IGIS_Viewer_TGIS_RendererContext_TPoint_Integer_Integer_Integer_Integer_TRect
        """
        pass

    def CreateInstance(
      self
    ) -> TGIS_RendererAbstract: 
        """
        Create an instance of object of the same type as current one.

        Returns:
            Newly created object or null if the renderer is not allowed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CreateInstance_void
        """
        pass

    def CreatePrinterContext(
      self,
      _canvas: TObject,
      _width: int,
      _height: int,
      _ppi: int,
      _fontscale: int
    ) -> None: 
        """
        Initiate context for the printer.

        Args:
            _canvas: drawing context; in most cases canvas object
            _width: width of the drawing surface
            _height: height of the drawing surface
            _ppi: resolution for the drawing surface
            _fontscale: font scaling factor in percents

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CreatePrinterContext_TObject_Integer_Integer_Integer_Integer
        """
        pass

    def Flush(
      self
    ) -> None: 
        """
        Update BaseMap of the context .

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.Flush_void
        """
        pass

    def FriendlyName(
      self
    ) -> str: 
        """
        Get user-friendly name of the renderer. Can be used to expose the renderer in the 
        user interface.

        Returns:
            User-friendly name of the renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.FriendlyName_void
        """
        pass

    def LockTransparent(
      self,
      _transparency: int
    ) -> None: 
        """
        Begin of drawing in a layer transparency mode.

        Args:
            _transparency: 0.100 where 0 means fully transparent and 100 solid

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.LockTransparent_Integer
        """
        pass

    def MeasureShieldTexture(
      self,
      _shp: TObject,
      _size: VarParameter
    ) -> TObject: 
        """
        Measure shield size

        Args:
            _shp: shape for which shield must be rendered
            _size: actual active size of shield; the value (in/out) is passed as TPoint in _size.Value 
              property

        Returns:
            Newly create label layout. Must be free directly or will be free indirectly upon 
            RenderShieldTexture call.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.MeasureShieldTexture_TObject_TPoint
        """
        pass

    def OptimizeBitmapCache(
      self
    ) -> None: 
        """
        Check the content of bitmap cache and optimize it.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.OptimizeBitmapCache_void
        """
        pass

    def PixelsToTwips(
      self,
      _size: int
    ) -> int: 
        """
        Convert size from device dependent pixels to device independent Twips (1/1440 inch). 
        Used to make map device independent.

        Args:
            _size: size in pixels; absolute value will be taken

        Returns:
            Size in twips.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.PixelsToTwips_Integer
        """
        pass

    def PrepareBitmapCache(
      self,
      _bmp: TGIS_Pixels,
      _extent: TGIS_Extent,
      _size: TPoint,
      _serial: int,
      _format: TGIS_BitmapFormat,
      _order: TGIS_BitmapLinesOrder
    ) -> TGIS_RendererAbstractCache: 
        """
        Prepare renderer cache for topmost bitmap layers.

        Args:
            _bmp: array of bitmap pixels
            _extent: extent of _bmp
            _size: width/height of _bmp (in pixels)
            _serial: serial number of layer.Params; to keep track of layer rendering parameters 
              change
            _format: pixel format of _bmp array
            _order: line order of _bmp array

        Returns:
            returns cached object or nil, if cache is not supported by renderer; time live of 
            the object is maintained by TGIS_ViewerWnd

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.PrepareBitmapCache_TGIS_Pixels_TGIS_Extent_TPoint_Integer_TGIS_BitmapFormat_TGIS_BitmapLinesOrder
        """
        pass

    def PrepareDraw(
      self
    ) -> None: 
        """
        Preparation of the draw state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.PrepareDraw_void
        """
        pass

    def PrepareDrawCharts(
      self
    ) -> None: 
        """
        Prepare context for PaintShapeChartEvent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.PrepareDrawCharts_void
        """
        pass

    def PrepareDrawLabels(
      self
    ) -> None: 
        """
        Prepare context for PaintShapeLabelEvent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.PrepareDrawLabels_void
        """
        pass

    def PrepareHourglassContext(
      self
    ) -> None: 
        """
        Allow busy indicator upon rendering process.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.PrepareHourglassContext_void
        """
        pass

    def ReleaseContext(
      self
    ) -> None: 
        """
        Release an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.ReleaseContext_void
        """
        pass

    @overload
    def RenderBitmap(
      self,
      _handle: TObject,
      _bmp: TGIS_Pixels,
      _size: TPoint,
      _dst: TRect,
      _format: TGIS_BitmapFormat,
      _order: TGIS_BitmapLinesOrder
    ) -> None: 
        """
        Render bitmap on a current canvas.

        Args:
            _handle: handle to the context obtained by RenderBitmapBegin; cam be nil for non 
              progressive display
            _bmp: array of bitmap pixels
            _size: width/height of _bmp (in pixels)
            _dst: destination rectangle (in pixels); scaling will apply if required
            _format: pixel format of _bmp array
            _order: line order of _bmp array

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.RenderBitmap_TObject_TGIS_Pixels_TPoint_TRect_TGIS_BitmapFormat_TGIS_BitmapLinesOrder
        """
        pass

    @overload
    def RenderBitmap(
      self,
      _handle: TObject,
      _bmp: TGIS_Bitmap,
      _dst: TRect,
      _antialias: bool
    ) -> None: 
        """
        Render bitmap on a current canvas with scaling.

        Args:
            _handle: handle to progressive layer context or nil
            _bmp: bitmap to be drawn
            _dst: destination rectangle (to which bitmap should be rendered)
            _antialias: if True, rendering is anti-aliased if the framework gives such a possibility

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.RenderBitmap_TObject_TGIS_Bitmap_TRect_Boolean
        """
        pass

    def RenderBitmapBegin(
      self
    ) -> TObject: 
        """
        Prepare custom rendering context for lengthy bitmap drawing. Use for example to display 
        progressive update of ECW files.

        Returns:
            Handle to the context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.RenderBitmapBegin_void
        """
        pass

    def RenderBitmapCache(
      self,
      _handle: TObject,
      _cache: TGIS_RendererAbstractCache,
      _dst: TRect
    ) -> None: 
        """
        Render bitmap cache for topmost pixel layers.

        Args:
            _handle: handle to the context obtained by RenderBitmapBegin; cam be nil for non 
              progressive display
            _cache: cache obtained via PrepareBitmapCache
            _dst: destination rectangle (in pixels); scaling will apply if required

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.RenderBitmapCache_TObject_TGIS_RendererAbstractCache_TRect
        """
        pass

    def RenderBitmapEnd(
      self,
      _handle: TObject
    ) -> None: 
        """
        Finalize custom rendering context.

        Args:
            _handle: handle to the context

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.RenderBitmapEnd_TObject
        """
        pass

    def RenderChart(
      self,
      _shp: TObject
    ) -> None: 
        """
        Render a chart for a single shape in a current context.

        Args:
            _shp: shape to be rendered

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.RenderChart_TObject
        """
        pass

    def RenderEditor(
      self,
      _context: TObject
    ) -> None: 
        """
        Render an editor (if any).

        Args:
            _context: Rendering context (Canvas) of a final device.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.RenderEditor_TObject
        """
        pass

    @overload
    def RenderLabel(
      self,
      _shp: TObject
    ) -> None: 
        """
        Render a label for a single shape in a current context.

        Args:
            _shp: shape to be rendered

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.RenderLabel_TObject
        """
        pass

    @overload
    def RenderLabel(
      self,
      _shp: TObject,
      _points: VarParameter
    ) -> None: 
        """
        Render a label for a single shape in a current context.

        Args:
            _shp: shape to be rendered
            _points: list of points delimiting label area; the value (in/out) is passed as TGIS_DrawBuf 
              in _points.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.RenderLabel_TObject_TGIS_DrawBuf
        """
        pass

    @overload
    def RenderShape(
      self,
      _shp: TObject,
      _selectionOnly: bool,
      _outlineMode: TGIS_RendererMultipassMode
    ) -> None: 
        """
        Render a single shape in a current context.

        Args:
            _shp: shape to be rendered
            _selectionOnly: if True only the shape selection is rendered
            _outlineMode: outline drawing mode; valid only for lines; used to drawing nice line 
              junctions in multipass mode;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.RenderShape_TObject_Boolean_TGIS_RendererMultipassMode
        """
        pass

    @overload
    def RenderShape(
      self,
      _shp: TObject,
      _source: TObject,
      _selectionOnly: bool,
      _outlineMode: TGIS_RendererMultipassMode
    ) -> None: 
        """
        Render a single shape in a current context.

        Args:
            _shp: shape to be rendered
            _source: original shape for proper drawing fills when _shp is truncated
            _selectionOnly: if True only the shape selection is rendered
            _outlineMode: outline drawing mode; valid only for lines; used to drawing nice line 
              junctions in multipass mode;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.RenderShape_TObject_TObject_Boolean_TGIS_RendererMultipassMode
        """
        pass

    def RenderShapeFlashed(
      self,
      _shp: TObject
    ) -> None: 
        """
        Render shape in a flush state

        Args:
            _shp: shape to be rendered

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.RenderShapeFlashed_TObject
        """
        pass

    @overload
    def RenderShieldTexture(
      self,
      _shp: TObject,
      _force_pow2: bool,
      _size: TPoint,
      _layout: TObject
    ) -> TGIS_Bitmap: 
        """
        Render texture shield (label + chart + whatever) for 3D viewer purposes

        Args:
            _shp: shape for which shield must be rendered
            _force_pow2: If true size of resulting bitmaps is always power of 2 because some 
              3D engine requires it
            _size: actual active size of shield within bitmap which can be power 2 sized
            _layout: label layout allocated by MeasureShieldTexture; this method will release 
              this object

        Returns:
            Newly created bitmap or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.RenderShieldTexture_TObject_Boolean_TPoint_TObject
        """
        pass

    @overload
    def RenderShieldTexture(
      self,
      _shp: TObject,
      _force_pow2: bool,
      _size: VarParameter
    ) -> TGIS_Bitmap: 
        """
        Render texture shield (label + chart + whatever) for 3D viewer purposes

        Args:
            _shp: shape for which shield must be rendered
            _force_pow2: If true size of resulting bitmaps is always power of 2 because some 
              3D engine requires it
            _size: actual active size of shield within bitmap which can be power 2 sized; the 
              value (in/out) is passed as TPoint in _size.Value property

        Returns:
            Newly created bitmap or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.RenderShieldTexture_TObject_Boolean_TPoint
        """
        pass

    def RestoreContext(
      self
    ) -> None: 
        """
        Restore context using same data as used by CreateContext.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.RestoreContext_void
        """
        pass

    def Setup(
      self,
      _parent: IGIS_ViewerParent,
      _viewer: IGIS_Viewer,
      _shift: TPoint,
      _width: int,
      _height: int,
      _ppi: int,
      _fontscale: int
    ) -> None: 
        """
        Setup renderer if CreateContext are not in use.

        Args:
            _parent: viewer parented interface; for Control* like methods
            _viewer: viewer object
            _shift: left and upper margins for the drawing surface
            _width: width of the drawing surface
            _height: height of the drawing surface
            _ppi: resolution for the drawing surface
            _fontscale: font scaling factor in percents

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.Setup_IGIS_ViewerParent_IGIS_Viewer_TPoint_Integer_Integer_Integer_Integer
        """
        pass

    @overload
    def TwipsToPixels(
      self,
      _size: int
    ) -> int: 
        """
        Convert the size from to device independent Twips (1/1440 inch) to device dependent 
        pixels. Used to make map device independent.

        Args:
            _size: size in twips; if negative then treated as pixels

        Returns:
            Size in twips.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.TwipsToPixels_Integer
        """
        pass

    @overload
    def TwipsToPixels(
      self,
      _size: int,
      _maxValue: int
    ) -> int: 
        """
        Convert the size from to device independent Twips (1/1440 inch) to device dependent 
        pixels. Used to make map device independent.

        Args:
            _size: size in twips; if negative then treated as pixels
            _maxValue: maximal value

        Returns:
            Size in twips.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.TwipsToPixels_Integer_Integer
        """
        pass

    def TwipsToPoints(
      self,
      _size: int
    ) -> int: 
        """
        Convert the size from to device independent Twips (1/1440 inch) to device points. 
        Used for advanced font sizing.

        Args:
            _size: size in twips; if negative then treated as pixels

        Returns:
            Size in points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.TwipsToPoints_Integer
        """
        pass

    def UnlockTransparent(
      self
    ) -> None: 
        """
        End of drawing in a layer transparency mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.UnlockTransparent_void
        """
        pass

    def Update(
      self
    ) -> None: 
        """
        Receive notification about pending renderer update.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.Update_void
        """
        pass

    @property
    def Context(
      self
    ) -> TGIS_RendererContext: 
        """
        Renderer context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.Context
        """
        pass

    @Context.setter
    def Context(
      self,
      _value: TGIS_RendererContext
    ) -> None: 
        """
        Renderer context.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.Context
        """
        pass

    @property
    def Parent(
      self
    ) -> IGIS_ViewerParent: 
        """
        Viewer (parented interface) which owns renderer. For Control* like operations

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.Parent
        """
        pass

    @Parent.setter
    def Parent(
      self,
      _value: IGIS_ViewerParent
    ) -> None: 
        """
        Viewer (parented interface) which owns renderer. For Control* like operations

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.Parent
        """
        pass

    @property
    def Viewer(
      self
    ) -> IGIS_Viewer: 
        """
        Viewer which owns renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.Viewer
        """
        pass

    @Viewer.setter
    def Viewer(
      self,
      _value: IGIS_Viewer
    ) -> None: 
        """
        Viewer which owns renderer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.Viewer
        """
        pass

    @property
    def BitmapFactory(
      self
    ) -> TGIS_BitmapFactory: 
        """
        Returns a bitmap factory which produces bitmaps compatible with the renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.BitmapFactory
        """
        pass

    @property
    def CanvasBrush(
      self
    ) -> TGIS_Brush: 
        """
        Brush of the Canvas object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasBrush
        """
        pass

    @CanvasBrush.setter
    def CanvasBrush(
      self,
      _value: TGIS_Brush
    ) -> None: 
        """
        Brush of the Canvas object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasBrush
        """
        pass

    @property
    def CanvasExtent(
      self
    ) -> TGIS_Extent: 
        """
        Return extent taken in account by label allocator.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasExtent
        """
        pass

    @property
    def CanvasFont(
      self
    ) -> TGIS_Font: 
        """
        Font of the Canvas object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasFont
        """
        pass

    @CanvasFont.setter
    def CanvasFont(
      self,
      _value: TGIS_Font
    ) -> None: 
        """
        Font of the Canvas object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasFont
        """
        pass

    @property
    def CanvasPen(
      self
    ) -> TGIS_Pen: 
        """
        Pen of the Canvas object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasPen
        """
        pass

    @CanvasPen.setter
    def CanvasPen(
      self,
      _value: TGIS_Pen
    ) -> None: 
        """
        Pen of the Canvas object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.CanvasPen
        """
        pass

    @property
    def FontScale(
      self
    ) -> int: 
        """
        Fonts scaling factor of the rendering context (in percents).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.FontScale
        """
        pass

    @property
    def Height(
      self
    ) -> int: 
        """
        Height of the rendering context (in pixels).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.Height
        """
        pass

    @property
    def Info(
      self
    ) -> str: 
        """
        Provide basic info about renderer like underlying technology used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.Info
        """
        pass

    @property
    def PPI(
      self
    ) -> int: 
        """
        Point-Per-Inch of the rendering context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.PPI
        """
        pass

    @property
    def Shift(
      self
    ) -> TPoint: 
        """
        Offset of the rendering rectangle (in pixels).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.Shift
        """
        pass

    @property
    def TileRect(
      self
    ) -> TRect: 
        """
        Rectangle of the rendering context (in pixels).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.TileRect
        """
        pass

    @property
    def ViewRect(
      self
    ) -> TRect: 
        """
        Viewing rectangle of the rendering context (in pixels). It is computed as Shift+Width 
        and Shift+Height

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.ViewRect
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        Width of the rendering context (in pixels).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstract.Width
        """
        pass

class TGIS_RendererAbstractCache( TObject ):
    """
    Cached topmost pixel layer bitmap object to be used with PrepareBitmapCache and RenderBitmapCache.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstractCache
    """

    @overload
    def __init__(
      self,
      _extent: TGIS_Extent,
      _size: TPoint,
      _serial: int
    ) -> None: 
        """
        Constructor.

        Args:
            _extent: extent of the cached bitmap
            _size: size of of the cached bitmap
            _serial: layer.Params serial value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstractCache.Create_TGIS_Extent_TPoint_Integer
        """
        pass

    def ResetSerial(
      self
    ) -> None: 
        """
        Reset serial number to force cache recreation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstractCache.ResetSerial_void
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Extent: 
        """
        Extent of the cached bitmap.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstractCache.Extent
        """
        pass

    @property
    def Serial(
      self
    ) -> int: 
        """
        Layer.Params serial value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstractCache.Serial
        """
        pass

    @property
    def Size(
      self
    ) -> TPoint: 
        """
        Size of of the cached bitmap.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererAbstractCache.Size
        """
        pass

class TGIS_RendererManager( TObject ):
    """
    Registration list of all renderers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererManager
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererManager.Create_void
        """
        pass

    def CreateInstance(
      self,
      _name: str
    ) -> TGIS_RendererAbstract: 
        """
        Create new instance of renderer.

        Args:
            _name: name of the renderer; name is case insensitive

        Returns:
            new instance

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererManager.CreateInstance_String
        """
        pass

    def IsRegistered(
      self,
      _name: str
    ) -> bool: 
        """
        Check if the renderer is registered.

        Args:
            _name: unique operation name; name is case insensitive

        Returns:
            value indicated if the renderer is registered

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererManager.IsRegistered_String
        """
        pass

    @property
    def Names(
      self
    ) -> TGIS_StringList: 
        """
        List of all renderers names.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererManager.Names
        """
        pass

class TGIS_LocalizedNotification:
    """
    Notification class. Will manage localization change notifications

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LocalizedNotification
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LocalizedNotification.Create_void
        """
        pass

    def Subscribe(
      self,
      _prc: typing.Callable[[], None]
    ) -> None: 
        """
        Add a procedure to the notification list. Procedure should be unsubscribed on Unsubscribe 
        method.

        Args:
            _prc: procedure to be subscribed; the value is a callback to a method with parameters 
              defined by TGIS_LocalizedNotificationProc

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LocalizedNotification.Subscribe_TGIS_LocalizedNotificationProc
        """
        pass

    def UnSubscribe(
      self,
      _prc: typing.Callable[[], None]
    ) -> None: 
        """
        Remove a procedure form the notification list.

        Args:
            _prc: procedure to be unsubscribed; the value is a callback to a method with parameters 
              defined by TGIS_LocalizedNotificationProc

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LocalizedNotification.UnSubscribe_TGIS_LocalizedNotificationProc
        """
        pass

    def Update(
      self
    ) -> None: 
        """
        Send a notification to all subscribers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LocalizedNotification.Update_void
        """
        pass

class TGIS_ArcGISFeatureServerLayerList:
    """
    List of TGIS_ArcGISFeatureServerLayer objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayerList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_ArcGISFeatureServerLayer:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_ArcGISFeatureServerLayer
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayerList.Create_void
        """
        pass

    def Add(
      self,
      _item: TGIS_ArcGISFeatureServerLayer
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayerList.Add_TGIS_ArcGISFeatureServerLayer
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayerList.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayerList.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayerList.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> TGIS_ArcGISFeatureServerLayer: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayerList.Item
        """
        pass

class TGIS_ArcGISFeatureServerLayer( TObject ):
    """
    Feature Service info.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.Create_void
        """
        pass

    @property
    def Description(
      self
    ) -> str: 
        """
        Feature Layer description.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.Description
        """
        pass

    @Description.setter
    def Description(
      self,
      _value: str
    ) -> None: 
        """
        Feature Layer description.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.Description
        """
        pass

    @property
    def DrawingInfo(
      self
    ) -> TGIS_ParamsList: 
        """
        Feature Layer drawing info.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.DrawingInfo
        """
        pass

    @DrawingInfo.setter
    def DrawingInfo(
      self,
      _value: TGIS_ParamsList
    ) -> None: 
        """
        Feature Layer drawing info.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.DrawingInfo
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Extent: 
        """
        Feature Layer bounding box.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.Extent
        """
        pass

    @Extent.setter
    def Extent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Feature Layer bounding box.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.Extent
        """
        pass

    @property
    def GeometryType(
      self
    ) -> str: 
        """
        Feature Layer geometry type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.GeometryType
        """
        pass

    @GeometryType.setter
    def GeometryType(
      self,
      _value: str
    ) -> None: 
        """
        Feature Layer geometry type.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.GeometryType
        """
        pass

    @property
    def Id(
      self
    ) -> int: 
        """
        Feature Layer id.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.Id
        """
        pass

    @Id.setter
    def Id(
      self,
      _value: int
    ) -> None: 
        """
        Feature Layer id.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.Id
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Feature Layer name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.Name
        """
        pass

    @Name.setter
    def Name(
      self,
      _value: str
    ) -> None: 
        """
        Feature Layer name.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.Name
        """
        pass

    @property
    def Path(
      self
    ) -> str: 
        """
        Feature Layer path.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.Path
        """
        pass

    @Path.setter
    def Path(
      self,
      _value: str
    ) -> None: 
        """
        Feature Layer path.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.Path
        """
        pass

    @property
    def Wkid(
      self
    ) -> str: 
        """
        Feature Layer coordinate system id.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.Wkid
        """
        pass

    @Wkid.setter
    def Wkid(
      self,
      _value: str
    ) -> None: 
        """
        Feature Layer coordinate system id.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServerLayer.Wkid
        """
        pass

class TGIS_ArcGISFeatureServer( TObject ):
    """
    Encapsulation of ArcGIS feature server.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServer
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServer.Create_void
        """
        pass

    def Open(
      self,
      _url: str
    ) -> None: 
        """
        Open a service from url.

        Args:
            _url: service url

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServer.Open_String
        """
        pass

    @property
    def Layers(
      self
    ) -> TGIS_ArcGISFeatureServerLayerList: 
        """
        List of available layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ArcGISFeatureServer.Layers
        """
        pass

class TGIS_ShapePointCloud( TGIS_ShapeMultiPoint ):
    """
    Encapsulation of PointCloud.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePointCloud
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create a shape instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePointCloud.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _dim: Dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePointCloud.Create_TGIS_DimensionType
        """
        pass

    @overload
    def __init__(
      self,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: TGIS_Uid,
      _layer: TGIS_LayerVector,
      _dim: TGIS_DimensionType
    ) -> None: 
        """
        Create a shape instance.

        Args:
            _source: If not nil then base shape will be based on this shape. Otherwise _prt, 
              _mapped, _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: Id _ptr from mapped file or from memory.
            _uid: Unique identity for shape.
            _layer: Reference to the layer on which shape will be created.
            _dim: Dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePointCloud.Create_TGIS_Shape_Pointer_Boolean_TGIS_Uid_TGIS_LayerVector_TGIS_DimensionType
        """
        pass

    def AddVertex(
      self,
      _ptg: TGIS_Point3D,
      _color: TGIS_Color
    ) -> None: 
        """
        Add a vertex.

        Args:
            _ptg: vertex coordinate
            _color: vertex color

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePointCloud.AddVertex_TGIS_Point3D_TGIS_Color
        """
        pass

    @property
    def VertexColors(
      self
    ) -> TGIS_Pixels: 
        """
        Array of vertex colors

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapePointCloud.VertexColors
        """
        pass

class TGIS_HeuristicMode:
    pass

class TGIS_HeuristicMode:
    """
    Heuristic mode for path calculations

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HeuristicMode
    """

    @property
    def Distance(
      self
    ) -> TGIS_HeuristicMode: 
        """
        Heuristic based on simple closest distance approach.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HeuristicMode.Distance
        """
        pass

    @property
    def Adaptive(
      self
    ) -> TGIS_HeuristicMode: 
        """
        Heuristic based on assumption that cost of achieving destination node depends on 
        a cost of the current link.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HeuristicMode.Adaptive
        """
        pass

class TGIS_ShortestPathLink:
    """
    The shortest path link.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPathLink
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPathLink.Create_void
        """
        pass

    @property
    def Compass(
      self
    ) -> int: 
        """
        Compass segment, see TGIS_ShortestPath.CompassBlocks.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPathLink.Compass
        """
        pass

    @property
    def Cost(
      self
    ) -> float: 
        """
        Cost value for the segment.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPathLink.Cost
        """
        pass

    @property
    def Course(
      self
    ) -> float: 
        """
        Absolute course (in radians).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPathLink.Course
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_LayerVector: 
        """
        Layer to which the link belongs.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPathLink.Layer
        """
        pass

    @property
    def Length(
      self
    ) -> float: 
        """
        Length of the segment.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPathLink.Length
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Name of the segment (street name, etc.).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPathLink.Name
        """
        pass

    @property
    def Uid(
      self
    ) -> TGIS_Uid: 
        """
        Unique shape identifier.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPathLink.Uid
        """
        pass

class TGIS_ShortestPath( TObject ):
    """
    Encapsulation of shortest path algorithm.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath
    """

    @overload
    def __init__(
      self,
      _viewer: IGIS_Viewer
    ) -> None: 
        """
        Create an instance.

        Args:
            _viewer: viewer on which class will be operating.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.Create_IGIS_Viewer
        """
        pass

    def Find(
      self,
      _from: TGIS_Point,
      _to: TGIS_Point
    ) -> bool: 
        """
        Find path between two existing nodes.

        Args:
            _from: start node
            _to: end node

        Returns:
            True if a path has been found.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.Find_TGIS_Point_TGIS_Point
        """
        pass

    def LoadTheData(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Load data from the layer. Upon first run create a persistent storage (files responsible 
        to store network)

        Args:
            _layer: layer that is the source of the data

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.LoadTheData_TGIS_LayerVector
        """
        pass

    def Regenerate(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Recreate network (including network storage files).

        Args:
            _layer: layer that is the source of the data

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.Regenerate_TGIS_LayerVector
        """
        pass

    def StartPos(
      self,
      _ptg: TGIS_Point,
      _prec: float
    ) -> None: 
        """
        Set a start position for the shortest path.

        Args:
            _ptg: start position
            _prec: precision of localization

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.StartPos_TGIS_Point_Double
        """
        pass

    def StopPos(
      self,
      _ptg: TGIS_Point,
      _prec: float
    ) -> None: 
        """
        Set a stop position for the shortest path and run shortest path.

        Args:
            _ptg: start position
            _prec: precision of localization

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.StopPos_TGIS_Point_Double
        """
        pass

    def UpdateTheData(
      self
    ) -> None: 
        """
        Update the data with geocoded addresses from geocoder

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.UpdateTheData_void
        """
        pass

    @property
    def CompassBlocks(
      self
    ) -> int: 
        """
        Compass divided to a number of blocks (4 by default). It will be used for computing 
        courses like N, NE, E etc. If a value is negative, then the course will be absolute; 
        or else the course will be computed based on a link (relative). Course will be a 
        number ranging from negative to positive integers to reflect courses in the scope 
        of -Pi..Pi

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.CompassBlocks
        """
        pass

    @CompassBlocks.setter
    def CompassBlocks(
      self,
      _value: int
    ) -> None: 
        """
        Compass divided to a number of blocks (4 by default). It will be used for computing 
        courses like N, NE, E etc. If a value is negative, then the course will be absolute; 
        or else the course will be computed based on a link (relative). Course will be a 
        number ranging from negative to positive integers to reflect courses in the scope 
        of -Pi..Pi

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.CompassBlocks
        """
        pass

    
    def CostModifiers(
      self,
      _idx: int
    ) -> float: 
        """
        Cost modifier.

        Args:
            _idx: index of the modifier

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.CostModifiers
        """
        pass

    
    def CostModifiers(
      self,
      _idx: int,
      _value: float
    ) -> None: 
        """
        Cost modifier.

        Args:
            _idx: index of the modifier

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.CostModifiers
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Extent: 
        """
        Path extent. Encompasses a whole path.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.Extent
        """
        pass

    @property
    def HeuristicCostModifier(
      self
    ) -> float: 
        """
        Heuristic cost modifier.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.HeuristicCostModifier
        """
        pass

    @HeuristicCostModifier.setter
    def HeuristicCostModifier(
      self,
      _value: float
    ) -> None: 
        """
        Heuristic cost modifier.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.HeuristicCostModifier
        """
        pass

    @property
    def HeuristicMode(
      self
    ) -> TGIS_HeuristicMode: 
        """
        Mode of heuristic operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.HeuristicMode
        """
        pass

    @HeuristicMode.setter
    def HeuristicMode(
      self,
      _value: TGIS_HeuristicMode
    ) -> None: 
        """
        Mode of heuristic operation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.HeuristicMode
        """
        pass

    @property
    def HeuristicThreshold(
      self
    ) -> float: 
        """
        Threshold of starting node seeking area. Treat it as "seeking circle" for better 
        route at a staring node. It will allow to seek for better alternative paths at a 
        starting location.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.HeuristicThreshold
        """
        pass

    @HeuristicThreshold.setter
    def HeuristicThreshold(
      self,
      _value: float
    ) -> None: 
        """
        Threshold of starting node seeking area. Treat it as "seeking circle" for better 
        route at a staring node. It will allow to seek for better alternative paths at a 
        starting location.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.HeuristicThreshold
        """
        pass

    
    def Items(
      self,
      _idx: int
    ) -> TGIS_ShortestPathLink: 
        """
        Items in the shortest path.

        Args:
            _idx: index of the path

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.Items
        """
        pass

    @property
    def ItemsCount(
      self
    ) -> int: 
        """
        Number of items in the shortest path.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.ItemsCount
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_LayerVector: 
        """
        Layer assigned to the shortest path.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.Layer
        """
        pass

    @property
    def Network(
      self
    ) -> TGIS_Network: 
        """
        Instance of Network class (responsible for low level network operations)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.Network
        """
        pass

    @property
    def OSMRouting(
      self
    ) -> bool: 
        """
        If true the local routing resource is ignored and the requests are send to the TatukGIS 
        online routing service.
        
        Internally uses the TGIS_OSMRouting class.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.OSMRouting
        """
        pass

    @OSMRouting.setter
    def OSMRouting(
      self,
      _value: bool
    ) -> None: 
        """
        If true the local routing resource is ignored and the requests are send to the TatukGIS 
        online routing service.
        
        Internally uses the TGIS_OSMRouting class.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.OSMRouting
        """
        pass

    @property
    def RoadLength(
      self
    ) -> str: 
        """
        Field name used to calculate segment length. Empty means 0. Default is ''GIS_LENGTH''.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.RoadLength
        """
        pass

    @RoadLength.setter
    def RoadLength(
      self,
      _value: str
    ) -> None: 
        """
        Field name used to calculate segment length. Empty means 0. Default is ''GIS_LENGTH''.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.RoadLength
        """
        pass

    @property
    def RoadName(
      self
    ) -> str: 
        """
        Field for the feature name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.RoadName
        """
        pass

    @RoadName.setter
    def RoadName(
      self,
      _value: str
    ) -> None: 
        """
        Field for the feature name.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.RoadName
        """
        pass

    @property
    def StoragePath(
      self
    ) -> str: 
        """
        Forced storage path.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.StoragePath
        """
        pass

    @StoragePath.setter
    def StoragePath(
      self,
      _value: str
    ) -> None: 
        """
        Forced storage path.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.StoragePath
        """
        pass

    @property
    def TotalCost(
      self
    ) -> float: 
        """
        Total cost of the path.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.TotalCost
        """
        pass

    @property
    def LinkCostEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_ShapeArc, Double, Double], None]: 
        """
        Event which will be fired upon creating a network.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.LinkCostEvent
        """
        pass

    @LinkCostEvent.setter
    def LinkCostEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_ShapeArc, Double, Double], None]
    ) -> None: 
        """
        Event which will be fired upon creating a network.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.LinkCostEvent
        """
        pass

    @property
    def LinkDynamicEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Double, Double], None]: 
        """
        Event which will be fired upon traversing link.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.LinkDynamicEvent
        """
        pass

    @LinkDynamicEvent.setter
    def LinkDynamicEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Double, Double], None]
    ) -> None: 
        """
        Event which will be fired upon traversing link.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.LinkDynamicEvent
        """
        pass

    @property
    def LinkLevelEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_ShapeArc, ShortInt, ShortInt], None]: 
        """
        Event which will be fired upon getting the level of the endings of each link.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.LinkLevelEvent
        """
        pass

    @LinkLevelEvent.setter
    def LinkLevelEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_ShapeArc, ShortInt, ShortInt], None]
    ) -> None: 
        """
        Event which will be fired upon getting the level of the endings of each link.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.LinkLevelEvent
        """
        pass

    @property
    def LinkTypeEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_ShapeArc, Integer], None]: 
        """
        Event which will be fired upon getting the type of each link. Type is value between 
        0 and 255.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.LinkTypeEvent
        """
        pass

    @LinkTypeEvent.setter
    def LinkTypeEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_ShapeArc, Integer], None]
    ) -> None: 
        """
        Event which will be fired upon getting the type of each link. Type is value between 
        0 and 255.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.LinkTypeEvent
        """
        pass

    @property
    def NodeHeuristicCostEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_NetworkNode, TGIS_NetworkNode, Double], None]: 
        """
        Event which will be fired upon calculation of heuristic cost.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.NodeHeuristicCostEvent
        """
        pass

    @NodeHeuristicCostEvent.setter
    def NodeHeuristicCostEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_NetworkNode, TGIS_NetworkNode, Double], None]
    ) -> None: 
        """
        Event which will be fired upon calculation of heuristic cost.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.NodeHeuristicCostEvent
        """
        pass

    @property
    def PathEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_ShapeArc, Boolean, Boolean], None]: 
        """
        Event which will be fired on each link of the discovered shortest path. But will 
        be reported in reverse order.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.PathEvent
        """
        pass

    @PathEvent.setter
    def PathEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_ShapeArc, Boolean, Boolean], None]
    ) -> None: 
        """
        Event which will be fired on each link of the discovered shortest path. But will 
        be reported in reverse order.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShortestPath.PathEvent
        """
        pass

class TGIS_SldFile( TObject ):
    """
    Encapsulation of sld configuration file reader.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SldFile
    """

    @overload
    def __init__(
      self,
      _fileName: str
    ) -> None: 
        """
        Constructor.

        Args:
            _fileName: configuration file name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SldFile.Create_String
        """
        pass

    def ReadConfig(
      self,
      _layer: TGIS_Layer
    ) -> None: 
        """
        Read configuration from file and apply to a layer.

        Args:
            _layer: layer to which the configuration will be applied

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SldFile.ReadConfig_TGIS_Layer
        """
        pass

class TGIS_SlopeUnit:
    pass

class TGIS_SlopeUnit:
    """
    Unit in which the slope is expressed.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeUnit
    """

    @property
    def Degree(
      self
    ) -> TGIS_SlopeUnit: 
        """
        The slope is expressed in degrees.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeUnit.Degree
        """
        pass

    @property
    def Percent(
      self
    ) -> TGIS_SlopeUnit: 
        """
        The slope is expressed in percents.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeUnit.Percent
        """
        pass

class TGIS_SlopeMap( TObject ):
    """
    Slope map generator for digital terrain models.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeMap
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Default constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeMap.Create_void
        """
        pass

    @overload
    def Generate(
      self,
      _dem: TGIS_LayerPixel,
      _extent: TGIS_Extent,
      _slope_map: TGIS_LayerPixel,
      _ramp: bool
    ) -> None: 
        """
        Generates slope map based on a terrain model.

        Args:
            _dem: terrain model as a grid layer; if the layer has no CS then it is assumed that 
              the extent is expressed in meters
            _extent: extent to be processed
            _slope_map: output slope map as a grid layer; this layer must have the same extent, 
              CS, and resolution as _dem
            _ramp: if True then the standard 0-5-10-15-21-31-90 degrees color ramp is applied 
              to the slope map

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeMap.Generate_TGIS_LayerPixel_TGIS_Extent_TGIS_LayerPixel_Boolean
        """
        pass

    @overload
    def Generate(
      self
    ) -> None: 
        """
        Generates slope map based on a terrain model.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeMap.Generate_void
        """
        pass

    @property
    def ApplyRamp(
      self
    ) -> bool: 
        """
        If True then the standard 0-5-10-15-21-31-90 degrees color ramp is applied to the 
        slope map layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeMap.ApplyRamp
        """
        pass

    @ApplyRamp.setter
    def ApplyRamp(
      self,
      _value: bool
    ) -> None: 
        """
        If True then the standard 0-5-10-15-21-31-90 degrees color ramp is applied to the 
        slope map layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeMap.ApplyRamp
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Extent: 
        """
        Extent to be processed (in source layer units).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeMap.Extent
        """
        pass

    @Extent.setter
    def Extent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Extent to be processed (in source layer units).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeMap.Extent
        """
        pass

    @property
    def OutputLayer(
      self
    ) -> TGIS_LayerPixel: 
        """
        Output slope map as a grid layer; this layer must have the same extent, CS, and resolution 
        as the source layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeMap.OutputLayer
        """
        pass

    @OutputLayer.setter
    def OutputLayer(
      self,
      _value: TGIS_LayerPixel
    ) -> None: 
        """
        Output slope map as a grid layer; this layer must have the same extent, CS, and resolution 
        as the source layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeMap.OutputLayer
        """
        pass

    @property
    def SlopeUnit(
      self
    ) -> TGIS_SlopeUnit: 
        """
        Unit used to express slope values in the output grid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeMap.SlopeUnit
        """
        pass

    @SlopeUnit.setter
    def SlopeUnit(
      self,
      _value: TGIS_SlopeUnit
    ) -> None: 
        """
        Unit used to express slope values in the output grid.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeMap.SlopeUnit
        """
        pass

    @property
    def SourceLayer(
      self
    ) -> TGIS_LayerPixel: 
        """
        Terrain model as a grid layer; if the layer has no CS then it is assumed that the 
        extent is expressed in meters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeMap.SourceLayer
        """
        pass

    @SourceLayer.setter
    def SourceLayer(
      self,
      _value: TGIS_LayerPixel
    ) -> None: 
        """
        Terrain model as a grid layer; if the layer has no CS then it is assumed that the 
        extent is expressed in meters.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeMap.SourceLayer
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeMap.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SlopeMap.BusyEvent
        """
        pass

class TGIS_StatisticalFunction:
    pass

class TGIS_StatisticalFunction:
    """
    Available statistical functions

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction
    """

    @property
    def Average(
      self
    ) -> TGIS_StatisticalFunction: 
        """
        The average value (arithmetic mean) of dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction.Average
        """
        pass

    @property
    def Count(
      self
    ) -> TGIS_StatisticalFunction: 
        """
        Number of valid elements in dataset (not empty, not null).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction.Count
        """
        pass

    @property
    def CountMissings(
      self
    ) -> TGIS_StatisticalFunction: 
        """
        Number of empty or null elements in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction.CountMissings
        """
        pass

    @property
    def Max(
      self
    ) -> TGIS_StatisticalFunction: 
        """
        The maximum value in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction.Max
        """
        pass

    @property
    def Majority(
      self
    ) -> TGIS_StatisticalFunction: 
        """
        The value that occurs most often in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction.Majority
        """
        pass

    @property
    def Median(
      self
    ) -> TGIS_StatisticalFunction: 
        """
        The median (middle value) of dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction.Median
        """
        pass

    @property
    def Min(
      self
    ) -> TGIS_StatisticalFunction: 
        """
        The minimum value in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction.Min
        """
        pass

    @property
    def Minority(
      self
    ) -> TGIS_StatisticalFunction: 
        """
        The value that occurs least often in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction.Minority
        """
        pass

    @property
    def Percentile(
      self
    ) -> TGIS_StatisticalFunction: 
        """
        The value below which a percentage of data falls. Not available for strings.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction.Percentile
        """
        pass

    @property
    def Range(
      self
    ) -> TGIS_StatisticalFunction: 
        """
        The difference between maximum and minimum values in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction.Range
        """
        pass

    @property
    def StandardDeviation(
      self
    ) -> TGIS_StatisticalFunction: 
        """
        The standard deviation of dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction.StandardDeviation
        """
        pass

    @property
    def Sum(
      self
    ) -> TGIS_StatisticalFunction: 
        """
        The sum of values in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction.Sum
        """
        pass

    @property
    def Variance(
      self
    ) -> TGIS_StatisticalFunction: 
        """
        The variance of dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction.Variance
        """
        pass

    @property
    def Variety(
      self
    ) -> TGIS_StatisticalFunction: 
        """
        The number of unique values in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction.Variety
        """
        pass

    @property
    def Unique(
      self
    ) -> TGIS_StatisticalFunction: 
        """
        Extracting unique values from dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction.Unique
        """
        pass

    @property
    def Sample(
      self
    ) -> TGIS_StatisticalFunction: 
        """
        Extracting sample values from dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunction.Sample
        """
        pass

class TGIS_StatisticsItemList:
    """
    List of TGIS_StatisticsItem objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItemList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_StatisticsItem:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_StatisticsItem
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItemList.Create_void
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItemList.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> TGIS_StatisticsItem: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItemList.Item
        """
        pass

class TGIS_StatisticsItem( TObject ):
    """
    General class for storing single statistical value. Must be derived.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItem
    """

    @overload
    def __init__(
      self,
      _function: TGIS_StatisticalFunction,
      _requested: bool
    ) -> None: 
        """
        Create statistics item.

        Args:
            _function: statistical function stored in item
            _requested: True if statistical value should be calculated; False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItem.Create_TGIS_StatisticalFunction_Boolean
        """
        pass

    def ToString(
      self
    ) -> str: 
        """
        Prepare string representation of statistical value.

        Returns:
            string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItem.ToString_void
        """
        pass

    @property
    def Calculated(
      self
    ) -> bool: 
        """
        True if statistical value is calculated; False otherwise.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItem.Calculated
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Name of statistical value stored in item.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItem.Name
        """
        pass

    @property
    def Params(
      self
    ) -> TGIS_VariantArray: 
        """
        Function parameters used in calculations.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItem.Params
        """
        pass

    @Params.setter
    def Params(
      self,
      _value: TGIS_VariantArray
    ) -> None: 
        """
        Function parameters used in calculations.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItem.Params
        """
        pass

    @property
    def Requested(
      self
    ) -> bool: 
        """
        True if statistical value is requested; False otherwise.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItem.Requested
        """
        pass

class TGIS_StatisticsItemInteger( TGIS_StatisticsItem ):
    """
    Class for storing integer statistical value.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItemInteger
    """

    @overload
    def __init__(
      self,
      _function: TGIS_StatisticalFunction,
      _requested: bool
    ) -> None: 
        """
        Create statistics item.

        Args:
            _function: statistical function stored in item
            _requested: True if statistical value should be calculated; False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItemInteger.Create_TGIS_StatisticalFunction_Boolean
        """
        pass

    @property
    def Value(
      self
    ) -> int: 
        """
        Integer statistical value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItemInteger.Value
        """
        pass

class TGIS_StatisticsItemDouble( TGIS_StatisticsItem ):
    """
    Class for storing double-precision statistical value.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItemDouble
    """

    @overload
    def __init__(
      self,
      _function: TGIS_StatisticalFunction,
      _requested: bool
    ) -> None: 
        """
        Create statistics item.

        Args:
            _function: statistical function stored in item
            _requested: True if statistical value should be calculated; False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItemDouble.Create_TGIS_StatisticalFunction_Boolean
        """
        pass

    @property
    def Value(
      self
    ) -> float: 
        """
        Double-precision statistical value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItemDouble.Value
        """
        pass

class TGIS_StatisticsItemVariant( TGIS_StatisticsItem ):
    """
    Class for storing variant statistical value.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItemVariant
    """

    @overload
    def __init__(
      self,
      _function: TGIS_StatisticalFunction,
      _requested: bool
    ) -> None: 
        """
        Create statistics item.

        Args:
            _function: statistical function stored in item
            _requested: True if statistical value should be calculated; False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItemVariant.Create_TGIS_StatisticalFunction_Boolean
        """
        pass

    @property
    def Value(
      self
    ) -> Variant: 
        """
        Variant statistical result.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItemVariant.Value
        """
        pass

class TGIS_StatisticsItemVariantList( TGIS_StatisticsItem ):
    """
    Class for storing statistical result with list of variants.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItemVariantList
    """

    @overload
    def __init__(
      self,
      _function: TGIS_StatisticalFunction,
      _requested: bool
    ) -> None: 
        """
        Create statistics item.

        Args:
            _function: statistical function stored in item
            _requested: True if statistical value should be calculated; False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItemVariantList.Create_TGIS_StatisticalFunction_Boolean
        """
        pass

    @property
    def Values(
      self
    ) -> TGIS_ListOfVariants: 
        """
        List of variants.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsItemVariantList.Values
        """
        pass

class TGIS_StatisticsResult( TObject ):
    """
    Container for statistics results.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult
    """

    @overload
    def __init__(
      self,
      _dataset_type: TGIS_FieldType,
      _name: str,
      _functions: TGIS_StatisticalFunctions,
      _ignore_value: Variant
    ) -> None: 
        """
        Create an object.

        Args:
            _dataset_type: dataset type
            _name: name of statistics result
            _functions: record with defined statistical functions
            _ignore_value: value from dataset which will be ignored in statistics

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Create_TGIS_FieldType_String_TGIS_StatisticalFunctions_Variant
        """
        pass

    def Complete(
      self
    ) -> None: 
        """
        Finalize and compute all requested statistics.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Complete_void
        """
        pass

    def Update(
      self,
      _value: Variant
    ) -> None: 
        """
        Adds value to dataset from which statistics will be computed.

        Args:
            _value: value that will be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Update_Variant
        """
        pass

    @property
    def AvailableStatistics(
      self
    ) -> TGIS_StatisticsItemList: 
        """
        List of calculated statistics (only requested).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.AvailableStatistics
        """
        pass

    @property
    def Average(
      self
    ) -> TGIS_StatisticsItemDouble: 
        """
        The average value (arithmetic mean) of dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Average
        """
        pass

    @property
    def Count(
      self
    ) -> TGIS_StatisticsItemInteger: 
        """
        Number of valid elements in dataset (not empty, not null).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Count
        """
        pass

    @property
    def CountMissings(
      self
    ) -> TGIS_StatisticsItemInteger: 
        """
        Number of empty or null elements in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.CountMissings
        """
        pass

    @property
    def DatasetType(
      self
    ) -> TGIS_FieldType: 
        """
        Dataset type; read-only.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.DatasetType
        """
        pass

    @property
    def IgnoreValue(
      self
    ) -> Variant: 
        """
        Value from dataset which is ignored in statistics; read-only.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.IgnoreValue
        """
        pass

    @property
    def Majority(
      self
    ) -> TGIS_StatisticsItemVariant: 
        """
        The value that occurs most often in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Majority
        """
        pass

    @property
    def Max(
      self
    ) -> TGIS_StatisticsItemDouble: 
        """
        The maximum value in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Max
        """
        pass

    @property
    def Median(
      self
    ) -> TGIS_StatisticsItemDouble: 
        """
        The median (middle value) of dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Median
        """
        pass

    @property
    def Min(
      self
    ) -> TGIS_StatisticsItemDouble: 
        """
        The minimum value in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Min
        """
        pass

    @property
    def Minority(
      self
    ) -> TGIS_StatisticsItemVariant: 
        """
        The value that occurs least often in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Minority
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Name of statistics result; read-only.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Name
        """
        pass

    @property
    def Percentile(
      self
    ) -> TGIS_StatisticsItemVariantList: 
        """
        Percentiles calculated for requested percentages.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Percentile
        """
        pass

    @property
    def Range(
      self
    ) -> TGIS_StatisticsItemDouble: 
        """
        The difference between maximum and minimum values in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Range
        """
        pass

    @property
    def Sample(
      self
    ) -> TGIS_StatisticsItemVariantList: 
        """
        Sample values from dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Sample
        """
        pass

    @property
    def StandardDeviation(
      self
    ) -> TGIS_StatisticsItemDouble: 
        """
        The standard deviation of dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.StandardDeviation
        """
        pass

    @property
    def Sum(
      self
    ) -> TGIS_StatisticsItemDouble: 
        """
        The sum of values in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Sum
        """
        pass

    @property
    def Unique(
      self
    ) -> TGIS_StatisticsItemVariantList: 
        """
        Unique values from dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Unique
        """
        pass

    @property
    def UseBesselCorrection(
      self
    ) -> bool: 
        """
        True if statistics class uses Bessel''s correction. If layer is assigned to statistics 
        result, property is read-only.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.UseBesselCorrection
        """
        pass

    @UseBesselCorrection.setter
    def UseBesselCorrection(
      self,
      _value: bool
    ) -> None: 
        """
        True if statistics class uses Bessel''s correction. If layer is assigned to statistics 
        result, property is read-only.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.UseBesselCorrection
        """
        pass

    @property
    def Variance(
      self
    ) -> TGIS_StatisticsItemDouble: 
        """
        The variance of dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Variance
        """
        pass

    @property
    def Variety(
      self
    ) -> TGIS_StatisticsItemInteger: 
        """
        The number of unique values in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.Variety
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsResult.BusyEvent
        """
        pass

class TGIS_StatisticsLayerResult( TGIS_StatisticsResult ):
    """
    Container for layer''s statistics result.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsLayerResult
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerAbstract,
      _dataset_type: TGIS_FieldType,
      _name: str,
      _functions: TGIS_StatisticalFunctions,
      _ignore_value: Variant
    ) -> None: 
        """
        Create an object.

        Args:
            _layer: layer assigned to statistics results
            _dataset_type: dataset type
            _name: name of statistics result
            _functions: record with defined statistical functions
            _ignore_value: value from dataset which will be ignored in statistics; use Null to 
              omit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsLayerResult.Create_TGIS_LayerAbstract_TGIS_FieldType_String_TGIS_StatisticalFunctions_Variant
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_LayerAbstract: 
        """
        Layer assigned to statistics result; read-only.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsLayerResult.Layer
        """
        pass

class TGIS_StatisticsAbstract( TObject ):
    """
    General statistics class. Must be derived.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.Create_void
        """
        pass

    @overload
    def Add(
      self,
      _name: str
    ) -> None: 
        """
        Adds statistics result definition.
        
        If definition exists, requested functions will be updated.

        Args:
            _name: name of statistics result;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.Add_String
        """
        pass

    @overload
    def Add(
      self,
      _name: str,
      _functions: TGIS_StatisticalFunctions
    ) -> None: 
        """
        Adds statistics result definition.
        
        If definition exists, requested functions will be updated.

        Args:
            _name: name of statistics result;
            _functions: record with requested statistical functions

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.Add_String_TGIS_StatisticalFunctions
        """
        pass

    @overload
    def Add(
      self,
      _name: str,
      _functions: TGIS_StatisticalFunctions,
      _ignore_value: Variant
    ) -> None: 
        """
        Adds statistics result definition.
        
        If definition exists, requested functions will be updated.

        Args:
            _name: name of statistics result;
            _functions: record with requested statistical functions
            _ignore_value: value from dataset which will be ignored in statistics; use Null to 
              omit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.Add_String_TGIS_StatisticalFunctions_Variant
        """
        pass

    @overload
    def Add(
      self,
      _name: str,
      _function: TGIS_StatisticalFunction,
      _params: TGIS_VariantArray,
      _ignore_value: Variant
    ) -> None: 
        """
        Adds statistics result definition.
        
        If definition exists, requested functions will be updated.

        Args:
            _name: name of statistics result;
            _function: requested statistical function
            _params: optional parameters; if empty, assign default parameters; check the documentation 
              of a specific statistical function
            _ignore_value: value from dataset which will be ignored in statistics; use Null to 
              omit

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.Add_String_TGIS_StatisticalFunction_TGIS_VariantArray_Variant
        """
        pass

    @overload
    def AddAll(
      self
    ) -> None: 
        """
        Adds statistics result definitions for all available datasets. Resets previous definitions.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.AddAll_void
        """
        pass

    @overload
    def AddAll(
      self,
      _functions: TGIS_StatisticalFunctions
    ) -> None: 
        """
        Adds statistics result definitions for all available datasets. Resets previous definitions.

        Args:
            _functions: record with defined statistical functions

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.AddAll_TGIS_StatisticalFunctions
        """
        pass

    @overload
    def Calculate(
      self
    ) -> None: 
        """
        Calculate requested statistics from the entire layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.Calculate_void
        """
        pass

    @overload
    def Calculate(
      self,
      _extent: TGIS_Extent,
      _shape: TGIS_ShapeAbstract,
      _de9im: str,
      _fast_statistics: bool
    ) -> None: 
        """
        Calculate requested statistics from filtered elements of the layer.

        Args:
            _extent: extent on which statistics will be calculated
            _shape: if not nil, statistics will be calculated on area which matches _de9im matrix 
              with _shape
            _de9im: DE-9IM matrix of comparison
            _fast_statistics: if True, ''Fast Statistics'' will be computed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.Calculate_TGIS_Extent_TGIS_ShapeAbstract_String_Boolean
        """
        pass

    def Get(
      self,
      _name: str
    ) -> TGIS_StatisticsLayerResult: 
        """
        Get statistics result by name.

        Args:
            _name: name of statistics result

        Returns:
            container with statistics result or nil if result does not exist

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.Get_String
        """
        pass

    @overload
    def LoadFromFile(
      self
    ) -> bool: 
        """
        Parse statistics file and load all information into parent layer.

        Returns:
            True if statisticsfile was properly interpreted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.LoadFromFile_void
        """
        pass

    @overload
    def LoadFromFile(
      self,
      _path: str
    ) -> bool: 
        """
        Parse statistics file and load all information into parent layer.

        Args:
            _path: path to file

        Returns:
            True if file with ''.ttkstats'' was properly interpreted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.LoadFromFile_String
        """
        pass

    def Reset(
      self
    ) -> None: 
        """
        Resets statistics object to initial state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.Reset_void
        """
        pass

    def ResetModified(
      self
    ) -> None: 
        """
        Undo changes in requested statistics definitions.
        
        All requested but not calculated statistics definitions will be erased.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.ResetModified_void
        """
        pass

    @overload
    def SaveToFile(
      self
    ) -> None: 
        """
        Save layer statistics into auxiliary file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.SaveToFile_void
        """
        pass

    @overload
    def SaveToFile(
      self,
      _path: str
    ) -> None: 
        """
        Save layer statistics into auxiliary file.

        Args:
            _path: path to ''.ttkstats'' file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.SaveToFile_String
        """
        pass

    @property
    def Age(
      self
    ) -> TDateTime: 
        """
        Age of the statistics.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.Age
        """
        pass

    @property
    def AvailableResults(
      self
    ) -> TGIS_ListOfStrings: 
        """
        List of available results names; read-only.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.AvailableResults
        """
        pass

    @property
    def DefinedResults(
      self
    ) -> TGIS_ListOfStrings: 
        """
        List of already defined results names; read-only.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.DefinedResults
        """
        pass

    @property
    def FastStatistics(
      self
    ) -> bool: 
        """
        Determines the state if ''Fast Statistics'' was computed; read-only.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.FastStatistics
        """
        pass

    @property
    def Modified(
      self
    ) -> bool: 
        """
        True if requested statistics have changed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.Modified
        """
        pass

    @property
    def Obsolete(
      self
    ) -> bool: 
        """
        Check validity of statistics.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.Obsolete
        """
        pass

    @property
    def UseBesselCorrection(
      self
    ) -> bool: 
        """
        If True, statistics class will use Bessel''s correction.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.UseBesselCorrection
        """
        pass

    @UseBesselCorrection.setter
    def UseBesselCorrection(
      self,
      _value: bool
    ) -> None: 
        """
        If True, statistics class will use Bessel''s correction.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsAbstract.UseBesselCorrection
        """
        pass

class TGIS_StatisticsLayer( TGIS_StatisticsAbstract ):
    """
    Statistics class for vector layers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsLayer
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Create an object. Always related to layer.

        Args:
            _layer: layer to be assigned to statistics object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsLayer.Create_TGIS_LayerAbstract
        """
        pass

    @property
    def Layer(
      self
    ) -> TGIS_LayerAbstract: 
        """
        Layer assigned to statistics; read-only.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsLayer.Layer
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsLayer.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsLayer.BusyEvent
        """
        pass

class TGIS_StatisticsVector( TGIS_StatisticsLayer ):
    """
    Statistics class for vector layers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsVector
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Create an object. Always related to layer.

        Args:
            _layer: layer to be assigned to statistics object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsVector.Create_TGIS_LayerAbstract
        """
        pass

    @overload
    def AddAll(
      self
    ) -> None: 
        """
        Adds statistics result definitions for all available datasets. Resets previous definitions.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsVector.AddAll_void
        """
        pass

    @overload
    def AddAll(
      self,
      _functions: TGIS_StatisticalFunctions
    ) -> None: 
        """
        Adds statistics result definitions for all available datasets. Resets previous definitions.

        Args:
            _functions: record with defined statistical functions

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsVector.AddAll_TGIS_StatisticalFunctions
        """
        pass

    @overload
    def AddAllFields(
      self
    ) -> None: 
        """
        Adds statistics result definitions for all non-virtual fields from vector layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsVector.AddAllFields_void
        """
        pass

    @overload
    def AddAllFields(
      self,
      _functions: TGIS_StatisticalFunctions
    ) -> None: 
        """
        Adds statistics result definitions for all non-virtual fields from vector layer.

        Args:
            _functions: record with defined statistical functions

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsVector.AddAllFields_TGIS_StatisticalFunctions
        """
        pass

    def Calculate(
      self,
      _extent: TGIS_Extent,
      _shape: TGIS_ShapeAbstract,
      _de9im: str,
      _fast_statistics: bool,
      _query: str,
      _use_selected: bool
    ) -> None: 
        """
        Calculate requested statistics from filtered elements of the layer.

        Args:
            _extent: extent on which statistics will be calculated
            _shape: if not nil, statistics will be calculated on area which matches _de9im matrix 
              with _shape
            _de9im: DE-9IM matrix of comparison
            _fast_statistics: if True, ''Fast Statistics'' will be computed
            _query: query to filter shapes from vector layer to be included in statistics
            _use_selected: if True, only selected shapes will be included in statistics

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsVector.Calculate_TGIS_Extent_TGIS_ShapeAbstract_String_Boolean_String_Boolean
        """
        pass

class TGIS_StatisticsPixel( TGIS_StatisticsLayer ):
    """
    Statistics class for raster layers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsPixel
    """

    @overload
    def __init__(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Create an object. Always related to layer.

        Args:
            _layer: layer to be assigned to statistics object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsPixel.Create_TGIS_LayerAbstract
        """
        pass

    @overload
    def AddAll(
      self
    ) -> None: 
        """
        Adds statistics result definitions for all available datasets. Resets previous definitions.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsPixel.AddAll_void
        """
        pass

    @overload
    def AddAll(
      self,
      _functions: TGIS_StatisticalFunctions
    ) -> None: 
        """
        Adds statistics result definitions for all available datasets. Resets previous definitions.

        Args:
            _functions: record with defined statistical functions

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsPixel.AddAll_TGIS_StatisticalFunctions
        """
        pass

    @overload
    def AddAllBands(
      self
    ) -> None: 
        """
        Adds statistics result definitions for all bands from pixel layer;
        
        Generate definition named ''Value'' for grid layer. Generate definitions named ''A'', 
        ''R'', ''G'' and ''B'' for pixel layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsPixel.AddAllBands_void
        """
        pass

    @overload
    def AddAllBands(
      self,
      _functions: TGIS_StatisticalFunctions
    ) -> None: 
        """
        Adds statistics result definitions for all bands from pixel layer;
        
        Generate definition named ''Value'' for grid layer. Generate definitions named ''A'', 
        ''R'', ''G'' and ''B'' for pixel layer.

        Args:
            _functions: record with defined statistical functions

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsPixel.AddAllBands_TGIS_StatisticalFunctions
        """
        pass

    @overload
    def LoadFromFile(
      self
    ) -> bool: 
        """
        Parse statistics file and load all information into parent layer.

        Returns:
            True if statisticsfile was properly interpreted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsPixel.LoadFromFile_void
        """
        pass

    @overload
    def LoadFromFile(
      self,
      _path: str
    ) -> bool: 
        """
        Parse statistics file and load all information into parent layer.

        Args:
            _path: path to file

        Returns:
            True if file with ''.ttkstats'' was properly interpreted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsPixel.LoadFromFile_String
        """
        pass

class TGIS_StatisticsFactory:
    """
    Class for creating statistics objects depending on a layer type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsFactory
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsFactory.Create_void
        """
        pass

    @classmethod
    def CreateStatistics(
      cls,
      _layer: TGIS_LayerAbstract
    ) -> TGIS_StatisticsAbstract: 
        """
        Create a TGIS_StatisticsAbstract object based on a layer type.

        Args:
            _layer: layer to be assigned to statistics object

        Returns:
            new instance of statistics class or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticsFactory.CreateStatistics_TGIS_LayerAbstract
        """
        pass

class TGIS_StatisticalFunctions:
    """
    Record with all statistical functions.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _calculate: bool
    ) -> None: 
        """
        Create a record and set all statistical functions.

        Args:
            _calculate: boolean value to be set for all statistical functions

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Create_Boolean
        """
        pass

    @overload
    def __init__(
      self,
      _function: TGIS_StatisticalFunction
    ) -> None: 
        """
        Create a record with active one statistical function.

        Args:
            _function: statistical function to be set to True in record.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Create_TGIS_StatisticalFunction
        """
        pass

    @classmethod
    def AllStatistics(
      cls
    ) -> TGIS_StatisticalFunctions: 
        """
        Prepare a record with active all available statistical functions.

        Returns:
            predefined record with active all available statistical functions

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.AllStatistics_void
        """
        pass

    @classmethod
    def BasicStatistics(
      cls
    ) -> TGIS_StatisticalFunctions: 
        """
        Prepare a record with active basic statistical functions.

        Returns:
            predefined record with active basic statistical functions

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.BasicStatistics_void
        """
        pass

    @classmethod
    def EmptyStatistics(
      cls
    ) -> TGIS_StatisticalFunctions: 
        """
        Prepare a record with deactivate all statistical functions.

        Returns:
            record with deactivate all statistical functions

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.EmptyStatistics_void
        """
        pass

    @classmethod
    def StandardStatistics(
      cls
    ) -> TGIS_StatisticalFunctions: 
        """
        Prepare a record with active most common statistical functions.

        Returns:
            predefined record with active most common statistical functions

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.StandardStatistics_void
        """
        pass

    @property
    def Average(
      self
    ) -> bool: 
        """
        The average value (arithmetic mean) of dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Average
        """
        pass

    @Average.setter
    def Average(
      self,
      _value: bool
    ) -> None: 
        """
        The average value (arithmetic mean) of dataset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Average
        """
        pass

    @property
    def Count(
      self
    ) -> bool: 
        """
        Number of valid elements in dataset (not empty, not null).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Count
        """
        pass

    @Count.setter
    def Count(
      self,
      _value: bool
    ) -> None: 
        """
        Number of valid elements in dataset (not empty, not null).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Count
        """
        pass

    @property
    def CountMissings(
      self
    ) -> bool: 
        """
        Number of empty or null elements in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.CountMissings
        """
        pass

    @CountMissings.setter
    def CountMissings(
      self,
      _value: bool
    ) -> None: 
        """
        Number of empty or null elements in dataset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.CountMissings
        """
        pass

    @property
    def Max(
      self
    ) -> bool: 
        """
        The maximum value in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Max
        """
        pass

    @Max.setter
    def Max(
      self,
      _value: bool
    ) -> None: 
        """
        The maximum value in dataset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Max
        """
        pass

    @property
    def Majority(
      self
    ) -> bool: 
        """
        The value that occurs most often in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Majority
        """
        pass

    @Majority.setter
    def Majority(
      self,
      _value: bool
    ) -> None: 
        """
        The value that occurs most often in dataset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Majority
        """
        pass

    @property
    def Median(
      self
    ) -> bool: 
        """
        The median (middle value) of dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Median
        """
        pass

    @Median.setter
    def Median(
      self,
      _value: bool
    ) -> None: 
        """
        The median (middle value) of dataset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Median
        """
        pass

    @property
    def Min(
      self
    ) -> bool: 
        """
        The minimum value in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Min
        """
        pass

    @Min.setter
    def Min(
      self,
      _value: bool
    ) -> None: 
        """
        The minimum value in dataset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Min
        """
        pass

    @property
    def Minority(
      self
    ) -> bool: 
        """
        The value that occurs least often in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Minority
        """
        pass

    @Minority.setter
    def Minority(
      self,
      _value: bool
    ) -> None: 
        """
        The value that occurs least often in dataset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Minority
        """
        pass

    @property
    def Percentile(
      self
    ) -> bool: 
        """
        The value below which a percentage of data falls. Not available for strings.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Percentile
        """
        pass

    @Percentile.setter
    def Percentile(
      self,
      _value: bool
    ) -> None: 
        """
        The value below which a percentage of data falls. Not available for strings.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Percentile
        """
        pass

    @property
    def Range(
      self
    ) -> bool: 
        """
        The difference between maximum and minimum values in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Range
        """
        pass

    @Range.setter
    def Range(
      self,
      _value: bool
    ) -> None: 
        """
        The difference between maximum and minimum values in dataset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Range
        """
        pass

    @property
    def Sample(
      self
    ) -> bool: 
        """
        Extracting sample values from dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Sample
        """
        pass

    @Sample.setter
    def Sample(
      self,
      _value: bool
    ) -> None: 
        """
        Extracting sample values from dataset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Sample
        """
        pass

    @property
    def StandardDeviation(
      self
    ) -> bool: 
        """
        The standard deviation of dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.StandardDeviation
        """
        pass

    @StandardDeviation.setter
    def StandardDeviation(
      self,
      _value: bool
    ) -> None: 
        """
        The standard deviation of dataset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.StandardDeviation
        """
        pass

    @property
    def Sum(
      self
    ) -> bool: 
        """
        The sum of values in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Sum
        """
        pass

    @Sum.setter
    def Sum(
      self,
      _value: bool
    ) -> None: 
        """
        The sum of values in dataset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Sum
        """
        pass

    @property
    def Variance(
      self
    ) -> bool: 
        """
        The variance of dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Variance
        """
        pass

    @Variance.setter
    def Variance(
      self,
      _value: bool
    ) -> None: 
        """
        The variance of dataset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Variance
        """
        pass

    @property
    def Variety(
      self
    ) -> bool: 
        """
        The number of unique values in dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Variety
        """
        pass

    @Variety.setter
    def Variety(
      self,
      _value: bool
    ) -> None: 
        """
        The number of unique values in dataset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Variety
        """
        pass

    @property
    def Unique(
      self
    ) -> bool: 
        """
        Extracting unique values from dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Unique
        """
        pass

    @Unique.setter
    def Unique(
      self,
      _value: bool
    ) -> None: 
        """
        Extracting unique values from dataset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StatisticalFunctions.Unique
        """
        pass

class TGIS_StringFormat:
    """
    String formatting utilities.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringFormat
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringFormat.Create_void
        """
        pass

    def Format(
      self,
      _format: str,
      _value: Variant
    ) -> str: 
        """
        Format provided value according to a format string.

        Args:
            _format: format string
            _value: value to be formatted

        Returns:
            Formatted string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringFormat.Format_String_Variant
        """
        pass

class TGIS_SymbolList( TGIS_ThreadClass ):
    """
    Encapsulation of the symbol list (cache). Use it to efficiently manage symbols.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolList
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolList.Create_void
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the whole list (remove all items from list).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolList.Clear_void
        """
        pass

    def ClearCache(
      self
    ) -> None: 
        """
        Clear the whole cache (all symbol will persist but the cached version will be destroyed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolList.ClearCache_void
        """
        pass

    @overload
    def InternalDelete(
      self,
      _name: str
    ) -> None: 
        """
        Delete a symbol from the list (for internal purposes).

        Args:
            _name: name of the symbol

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolList.InternalDelete_String
        """
        pass

    @overload
    def InternalDelete(
      self,
      _symbol: TGIS_SymbolAbstract
    ) -> None: 
        """
        Delete a symbol from the list (for internal purposes).

        Args:
            _symbol: symbol to delete

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolList.InternalDelete_TGIS_SymbolAbstract
        """
        pass

    @overload
    def Prepare(
      self,
      _name: str
    ) -> TGIS_SymbolAbstract: 
        """
        Prepare a new symbol.

        Args:
            _name: name of the symbol; see comment for TGIS_SymbolFont.Create and TGIS_SymbolPicture.Create 
              and TGIS_SymbolLine.Create

        Returns:
            symbol object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolList.Prepare_String
        """
        pass

    @overload
    def Prepare(
      self,
      _name: str,
      _stream: TStream
    ) -> TGIS_SymbolAbstract: 
        """
        Prepare a new symbol.

        Args:
            _name: name of the symbol; see comment for TGIS_SymbolFont.Create and TGIS_SymbolPicture.Create 
              and TGIS_SymbolLine.Create
            _stream: graphics stream for bitmap, for non\-file symbols

        Returns:
            symbol object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolList.Prepare_String_TStream
        """
        pass

class TGIS_SymbolAbstract( TObject ):
    """
    Encapsulation of symbols.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract
    """

    @overload
    def __init__(
      self,
      _name: str
    ) -> None: 
        """
        Create a symbol.

        Args:
            _name: symbol name; see comment for TGIS_SymbolFont.Create and TGIS_SymbolPicture.Create

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.Create_String
        """
        pass

    def ClearCache(
      self
    ) -> None: 
        """
        Clear the internal representation of a symbol. If this symbol is used in a future, 
        then it will reloaded automatically.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.ClearCache_void
        """
        pass

    @overload
    def Draw(
      self,
      _x: int,
      _y: int
    ) -> None: 
        """
        Draw the symbol.

        Args:
            _x: draw origin
            _y: draw origin

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.Draw_Integer_Integer
        """
        pass

    @overload
    def Draw(
      self,
      _x: float,
      _y: float
    ) -> None: 
        """
        Draw the symbol.

        Args:
            _x: draw origin
            _y: draw origin

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.Draw_Single_Single
        """
        pass

    @overload
    def Prepare(
      self,
      _viewer: IGIS_Viewer,
      _size: int,
      _color1: TGIS_Color,
      _color2: TGIS_Color,
      _angle: float,
      _gap: int,
      _position: TGIS_SymbolPosition,
      _marker: bool
    ) -> None: 
        """
        Prepare symbol

        Args:
            _viewer: pointer to the viewer
            _size: desired size
            _color1: color to be used as the main color for the symbol; if GIS_RENDER_COLOR is 
              used, then original symbol color will be used
            _color2: color to be used as the secondary color for the symbol; if GIS_RENDER_COLOR 
              is used, then original symbol color will be used
            _angle: rotation angle in radians (clockwise)
            _gap: gap between symbols
            _position: symbol position
            _marker: if True the symbol is a marker symbol; symbols connected to markers are 
              not rotated with the viewer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.Prepare_IGIS_Viewer_Integer_TGIS_Color_TGIS_Color_Double_Integer_TGIS_SymbolPosition_Boolean
        """
        pass

    @overload
    def Prepare(
      self,
      _viewer: IGIS_Viewer,
      _size: int,
      _color1: TGIS_Color,
      _color2: TGIS_Color,
      _angle: float,
      _gap: int,
      _position: TGIS_SymbolPosition,
      _marker: bool,
      _renderer2: TObject
    ) -> None: 
        """
        Prepare symbol

        Args:
            _viewer: pointer to the viewer
            _size: desired size
            _color1: color to be used as the main color for the symbol; if GIS_RENDER_COLOR is 
              used, then original symbol color will be used
            _color2: color to be used as the secondary color for the symbol; if GIS_RENDER_COLOR 
              is used, then original symbol color will be used
            _angle: rotation angle in radians (clockwise)
            _gap: gap between symbols
            _position: symbol position
            _marker: if True the symbol is a marker symbol; symbols connected to markers are 
              not rotated with the viewer
            _renderer2: if not nil then symbol will be drawn on provided renderer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.Prepare_IGIS_Viewer_Integer_TGIS_Color_TGIS_Color_Double_Integer_TGIS_SymbolPosition_Boolean_TObject
        """
        pass

    @overload
    def Prepare(
      self,
      _viewer: IGIS_Viewer,
      _size: int,
      _scaleX: float,
      _color1: TGIS_Color,
      _color2: TGIS_Color,
      _angle: float,
      _gap: int,
      _position: TGIS_SymbolPosition,
      _marker: bool,
      _renderer2: TObject
    ) -> None: 
        """
        Prepare symbol

        Args:
            _viewer: pointer to the viewer
            _size: desired size
            _scaleX: extra width scaling
            _color1: color to be used as the main color for the symbol; if GIS_RENDER_COLOR is 
              used, then original symbol color will be used
            _color2: color to be used as the secondary color for the symbol; if GIS_RENDER_COLOR 
              is used, then original symbol color will be used
            _angle: rotation angle in radians (clockwise)
            _gap: gap between symbols
            _position: symbol position
            _marker: if True the symbol is a marker symbol; symbols connected to markers are 
              not rotated with the viewer
            _renderer2: if not nil then symbol will be drawn on provided renderer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.Prepare_IGIS_Viewer_Integer_Double_TGIS_Color_TGIS_Color_0CAB5412182C8F36E71805CC30EBFCB8
        """
        pass

    def Unprepare(
      self
    ) -> None: 
        """
        Unprepare symbol.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.Unprepare_void
        """
        pass

    @property
    def AutoCenter(
      self
    ) -> bool: 
        """
        Autocentering symbol in 50% of the size. Used for autocentering of the symbol (mostly 
        for corrupted CGM''s).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.AutoCenter
        """
        pass

    @AutoCenter.setter
    def AutoCenter(
      self,
      _value: bool
    ) -> None: 
        """
        Autocentering symbol in 50% of the size. Used for autocentering of the symbol (mostly 
        for corrupted CGM''s).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.AutoCenter
        """
        pass

    @property
    def Center(
      self
    ) -> TPointF: 
        """
        Center point of the symbol in percent of the size. Used for modifying center of the 
        symbol (mostly for corrupted CGM''s).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.Center
        """
        pass

    @Center.setter
    def Center(
      self,
      _value: TPointF
    ) -> None: 
        """
        Center point of the symbol in percent of the size. Used for modifying center of the 
        symbol (mostly for corrupted CGM''s).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.Center
        """
        pass

    @property
    def Height(
      self
    ) -> int: 
        """
        Height of symbol in pixels. Can be more than the real height.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.Height
        """
        pass

    @property
    def IsFileBased(
      self
    ) -> bool: 
        """
        If True, then symbol is file based - name is same as path.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.IsFileBased
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Name of the symbol.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.Name
        """
        pass

    @property
    def NativeHeight(
      self
    ) -> float: 
        """
        Height of the symbol in original symbol units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.NativeHeight
        """
        pass

    @property
    def NativeSize(
      self
    ) -> float: 
        """
        Size of the symbol in original symbol units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.NativeSize
        """
        pass

    @property
    def NativeWidth(
      self
    ) -> float: 
        """
        Width of the symbol in original symbol units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.NativeWidth
        """
        pass

    @property
    def ShieldBounds(
      self
    ) -> TRectF: 
        """
        Rectangle in original symbol units representing part of a symbol that represent actual 
        symbols. Used to avoid symbol white margins to be used in labels overlapping aluclations, 
        Used mostly for SVG Shields. If not defined in symbol then represents whole symbol 
        area.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.ShieldBounds
        """
        pass

    @property
    def ShieldLabel(
      self
    ) -> TRectF: 
        """
        Rectangle in original symbol units reserved for labels in a shield symbols. Used 
        mostly for SVG Shields. If not defined in symbol then represents whole symbol area.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.ShieldLabel
        """
        pass

    @property
    def Size(
      self
    ) -> int: 
        """
        Size of the symbol in pixels. Can be more than the real size because it is maximum 
        size related to a center point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.Size
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        Width of the symbol in pixels. Can be more than the real width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolAbstract.Width
        """
        pass

class TGIS_SymbolPicture( TGIS_SymbolAbstract ):
    """
    Encapsulation of picture symbols.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolPicture
    """

    @overload
    def __init__(
      self,
      _name: str
    ) -> None: 
        """
        Create a picture symbol.

        Args:
            _name: symbol name; Transparent by default; can be override by providing name?FALSE 
              Picture name and transparency in the form of: path?[TRUE|FALSE]. Transparent by default.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolPicture.Create_String
        """
        pass

    @overload
    def __init__(
      self,
      _name: str,
      _stream: TStream
    ) -> None: 
        """
        Create a picture symbol from a file or the stream.

        Args:
            _name: symbol name; Transparent by default; can be override by providing name?FALSE 
              Picture name and transparency in the form of: path?[TRUE|FALSE]. Transparent by default.
            _stream: graphics stream for picture bitmap.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolPicture.Create_String_TStream
        """
        pass

class TGIS_SymbolFont( TGIS_SymbolAbstract ):
    """
    Encapsulation of font symbols.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolFont
    """

    @overload
    def __init__(
      self,
      _name: str
    ) -> None: 
        """
        Create a symbol.

        Args:
            _name: Font name and attributes in the form of: font_name:char_character_code[:bold][:italic][:underline] 
              default is ''Arial:?''

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolFont.Create_String
        """
        pass

    @property
    def Char(
      self
    ) -> char: 
        """
        assigned character.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolFont.Char
        """
        pass

    @property
    def Font(
      self
    ) -> TGIS_Font: 
        """
        assigned font.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolFont.Font
        """
        pass

class TGIS_SymbolCGM( TGIS_SymbolAbstract ):
    """
    Encapsulation of CGM symbols.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolCGM
    """

    @overload
    def __init__(
      self,
      _name: str
    ) -> None: 
        """
        Create a CGM symbol.

        Args:
            _name: symbol name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolCGM.Create_String
        """
        pass

    @overload
    def __init__(
      self,
      _name: str,
      _stream: TStream
    ) -> None: 
        """
        Create a CGM symbol.

        Args:
            _name: symbol name or path
            _stream: symbol stream to parse

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolCGM.Create_String_TStream
        """
        pass

    @property
    def Binary(
      self
    ) -> bool: 
        """
        True if CGM is in binary format; False if CGM is in text format.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolCGM.Binary
        """
        pass

class TGIS_SymbolLine( TGIS_SymbolAbstract ):
    """
    Encapsulation of line symbols.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLine
    """

    @overload
    def __init__(
      self,
      _name: str
    ) -> None: 
        """
        Create a CGM symbol.

        Args:
            _name: symbol name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLine.Create_String
        """
        pass

class TGIS_SymbolLineEx( TGIS_SymbolAbstract ):
    """
    Encapsulation of extended line symbols.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLineEx
    """

    @overload
    def __init__(
      self,
      _name: str
    ) -> None: 
        """
        Create a Line symbol.

        Args:
            _name: line symbol name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLineEx.Create_String
        """
        pass

class TGIS_SymbolSVG( TGIS_SymbolAbstract ):
    """
    Encapsulation of SVG symbols.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolSVG
    """

    @overload
    def __init__(
      self,
      _name: str
    ) -> None: 
        """
        Create a SVG symbol.

        Args:
            _name: symbol name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolSVG.Create_String
        """
        pass

    @overload
    def __init__(
      self,
      _name: str,
      _stream: TStream
    ) -> None: 
        """
        Create a SVG symbol.

        Args:
            _name: symbol name or file
            _stream: symbol stream to parse

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolSVG.Create_String_TStream
        """
        pass

    @overload
    def Draw(
      self,
      _x: int,
      _y: int
    ) -> None: 
        """
        Draw the symbol.

        Args:
            _x: draw origin
            _y: draw origin

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolSVG.Draw_Integer_Integer
        """
        pass

    @overload
    def Draw(
      self,
      _x: float,
      _y: float
    ) -> None: 
        """
        Draw the symbol.

        Args:
            _x: draw origin
            _y: draw origin

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolSVG.Draw_Single_Single
        """
        pass

class TGIS_SymbolHatch( TGIS_SymbolAbstract ):
    """
    Encapsulation of hatch fill symbol.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolHatch
    """

    @overload
    def __init__(
      self,
      _name: str
    ) -> None: 
        """
        Create a hatch symbol.

        Args:
            _name: hatch definition

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolHatch.Create_String
        """
        pass

class TGIS_SymbolLineHelper:
    """
    Internal use only. Helper for drawing line advanced symbology

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLineHelper
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLineHelper.Create_void
        """
        pass

    def DrawLine(
      self,
      _viewer: IGIS_Viewer,
      _drawbuf: TGIS_DrawBufF,
      _sym: TGIS_SymbolAbstract,
      _cnt: int
    ) -> None: 
        """
        Draw a line on the canvas. To be used internally by TatukGIS.

        Args:
            _viewer: viewer object
            _drawbuf: line representation
            _sym: symbol to be drawn
            _cnt: number of parts in Viewer.DrawBuf

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SymbolLineHelper.DrawLine_IGIS_Viewer_TGIS_DrawBufF_TGIS_SymbolAbstract_Integer
        """
        pass

class TGIS_HatchDefinition:
    """
    Encapsulation of hatch definition.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HatchDefinition
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HatchDefinition.Create_void
        """
        pass

    @property
    def Angle(
      self
    ) -> float: 
        """
        Hatch rotation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HatchDefinition.Angle
        """
        pass

    @Angle.setter
    def Angle(
      self,
      _value: float
    ) -> None: 
        """
        Hatch rotation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HatchDefinition.Angle
        """
        pass

    @property
    def Base(
      self
    ) -> TPointF: 
        """
        Base point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HatchDefinition.Base
        """
        pass

    @Base.setter
    def Base(
      self,
      _value: TPointF
    ) -> None: 
        """
        Base point.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HatchDefinition.Base
        """
        pass

    @property
    def Offset(
      self
    ) -> TPointF: 
        """
        Offset point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HatchDefinition.Offset
        """
        pass

    @Offset.setter
    def Offset(
      self,
      _value: TPointF
    ) -> None: 
        """
        Offset point.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HatchDefinition.Offset
        """
        pass

    @property
    def Dash(
      self
    ) -> TGIS_SingleArray: 
        """
        Dash line array.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HatchDefinition.Dash
        """
        pass

    @Dash.setter
    def Dash(
      self,
      _value: TGIS_SingleArray
    ) -> None: 
        """
        Dash line array.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HatchDefinition.Dash
        """
        pass

class TGIS_TemplateGraphic( TObject ):
    """
    Contains graphic data used when printing templates.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplateGraphic
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplateGraphic.Create_void
        """
        pass

    def Draw(
      self,
      _renderer: TGIS_RendererAbstract,
      _rect: TRect
    ) -> bool: 
        """
        Draws the graphic using given renderer.

        Args:
            _renderer: drawing renderer
            _rect: rectangle for the graphic

        Returns:
            if true, the graphic has been drawn if false, for some reason the graphic has not 
            been drawn

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplateGraphic.Draw_TGIS_RendererAbstract_TRect
        """
        pass

    def LoadFromBitmap(
      self,
      _bitmap: TGIS_Bitmap
    ) -> None: 
        """
        Loads a graphic from given bitmap.

        Args:
            _bitmap: bitmap to load

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplateGraphic.LoadFromBitmap_TGIS_Bitmap
        """
        pass

    def LoadFromFile(
      self,
      _path: str
    ) -> None: 
        """
        Loads a graphic from file.

        Args:
            _path: path to file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplateGraphic.LoadFromFile_String
        """
        pass

    def LoadFromStream(
      self,
      _stream: TStream
    ) -> None: 
        """
        Loads a graphic from platform stream.

        Args:
            _stream: platform specific stream (like TStream for VCL)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplateGraphic.LoadFromStream_TStream
        """
        pass

class TGIS_TemplatePrint( TObject ):
    """
    Encapsulation of template based printing according to *.tpl or *.ttktemplate file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _ownsGraphics: bool
    ) -> None: 
        """
        Create an instance.

        Args:
            _ownsGraphics: If True, graphic objects will be freed in the destructor and when 
              overwritten

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.Create_Boolean
        """
        pass

    def GetField(
      self,
      _name: str
    ) -> Variant: 
        """
        Resolve text macros used in printed texts.

        Args:
            _name: macro name

        Returns:
            resolved text

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GetField_String
        """
        pass

    def MakeCopy(
      self
    ) -> TGIS_TemplatePrint: 
        """
        Create a new object and copy values to it .

        Returns:
            new created object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.MakeCopy_void
        """
        pass

    def Reset(
      self
    ) -> None: 
        """
        Clear all object and texts assigned to template.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.Reset_void
        """
        pass

    def SaveCopy(
      self,
      _copy: TGIS_TemplatePrint
    ) -> None: 
        """
        Save values from a copy created by MakeCopy .

        Args:
            _copy: object to free

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.SaveCopy_TGIS_TemplatePrint
        """
        pass

    
    def GIS_Legend(
      self,
      _idx: int
    ) -> IGIS_PrintableControl: 
        """
        The TGIS_ControlLegend object attached to the template.

        Args:
            _idx: index on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_Legend
        """
        pass

    
    def GIS_Legend(
      self,
      _idx: int,
      _value: IGIS_PrintableControl
    ) -> None: 
        """
        The TGIS_ControlLegend object attached to the template.

        Args:
            _idx: index on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_Legend
        """
        pass

    @property
    def GIS_LegendCount(
      self
    ) -> int: 
        """
        Count of GIS_Legend elements (counting from 1).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_LegendCount
        """
        pass

    
    def GIS_NorthArrow(
      self,
      _idx: int
    ) -> IGIS_PrintableControl: 
        """
        The TGIS_ControlNorthArrow object attached to the template.

        Args:
            _idx: index on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_NorthArrow
        """
        pass

    
    def GIS_NorthArrow(
      self,
      _idx: int,
      _value: IGIS_PrintableControl
    ) -> None: 
        """
        The TGIS_ControlNorthArrow object attached to the template.

        Args:
            _idx: index on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_NorthArrow
        """
        pass

    @property
    def GIS_NorthArrowCount(
      self
    ) -> int: 
        """
        Count of GIS_NorthArrow elements.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_NorthArrowCount
        """
        pass

    
    def GIS_Scale(
      self,
      _idx: int
    ) -> IGIS_PrintableControl: 
        """
        The TGIS_ControlScale object attached to the template.

        Args:
            _idx: index on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_Scale
        """
        pass

    
    def GIS_Scale(
      self,
      _idx: int,
      _value: IGIS_PrintableControl
    ) -> None: 
        """
        The TGIS_ControlScale object attached to the template.

        Args:
            _idx: index on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_Scale
        """
        pass

    @property
    def GIS_ScaleCount(
      self
    ) -> int: 
        """
        Count of GIS_Scale elements (counting from 1).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_ScaleCount
        """
        pass

    
    def GIS_UseViewerColor(
      self,
      _idx: int
    ) -> bool: 
        """
        If Yes then viewer Color will be used as a background color, otherwise there will 
        be no background.

        Args:
            _idx: index on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_UseViewerColor
        """
        pass

    
    def GIS_UseViewerColor(
      self,
      _idx: int,
      _value: bool
    ) -> None: 
        """
        If Yes then viewer Color will be used as a background color, otherwise there will 
        be no background.

        Args:
            _idx: index on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_UseViewerColor
        """
        pass

    @property
    def GIS_UseViewerColorCount(
      self
    ) -> int: 
        """
        Count of GIS_UseViewerColor elements (counting from 1).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_UseViewerColorCount
        """
        pass

    
    def GIS_Viewer(
      self,
      _idx: int
    ) -> IGIS_Viewer: 
        """
        The TGIS_Viewer object attached to the template.

        Args:
            _idx: index on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_Viewer
        """
        pass

    
    def GIS_Viewer(
      self,
      _idx: int,
      _value: IGIS_Viewer
    ) -> None: 
        """
        The TGIS_Viewer object attached to the template.

        Args:
            _idx: index on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_Viewer
        """
        pass

    @property
    def GIS_ViewerCount(
      self
    ) -> int: 
        """
        Count of GIS_Viewer elements (counting from 1).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_ViewerCount
        """
        pass

    
    def GIS_ViewerExtent(
      self,
      _idx: int
    ) -> TGIS_Extent: 
        """
        Map Extent to be used for printing. After printing it contains the real used extent.

        Args:
            _idx: index on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_ViewerExtent
        """
        pass

    
    def GIS_ViewerExtent(
      self,
      _idx: int,
      _value: TGIS_Extent
    ) -> None: 
        """
        Map Extent to be used for printing. After printing it contains the real used extent.

        Args:
            _idx: index on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_ViewerExtent
        """
        pass

    @property
    def GIS_ViewerExtentCount(
      self
    ) -> int: 
        """
        Count of GIS_ViewerExtent elements (counting from 1).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_ViewerExtentCount
        """
        pass

    
    def GIS_ViewerName(
      self,
      _idx: int
    ) -> str: 
        """
        Customized viewer names which are used by the template designer. If the names are 
        empty or undefined, the designer takes names from GIS_Viewer objects.

        Args:
            _idx: index on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_ViewerName
        """
        pass

    
    def GIS_ViewerName(
      self,
      _idx: int,
      _value: str
    ) -> None: 
        """
        Customized viewer names which are used by the template designer. If the names are 
        empty or undefined, the designer takes names from GIS_Viewer objects.

        Args:
            _idx: index on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_ViewerName
        """
        pass

    @property
    def GIS_ViewerNameCount(
      self
    ) -> int: 
        """
        Count of GIS_ViewerName elements (counting from 1).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_ViewerNameCount
        """
        pass

    
    def GIS_ViewerScale(
      self,
      _idx: int
    ) -> float: 
        """
        Map Scale to be used for printing.

        Args:
            _idx: index on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_ViewerScale
        """
        pass

    
    def GIS_ViewerScale(
      self,
      _idx: int,
      _value: float
    ) -> None: 
        """
        Map Scale to be used for printing.

        Args:
            _idx: index on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_ViewerScale
        """
        pass

    @property
    def GIS_ViewerScaleCount(
      self
    ) -> int: 
        """
        Count of GIS_ViewerScale elements (counting from 1).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GIS_ViewerScaleCount
        """
        pass

    
    def Graphic(
      self,
      _idx: int
    ) -> TGIS_TemplateGraphic: 
        """
        The graphic attached to the template.

        Args:
            _idx: index on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.Graphic
        """
        pass

    
    def Graphic(
      self,
      _idx: int,
      _value: TGIS_TemplateGraphic
    ) -> None: 
        """
        The graphic attached to the template.

        Args:
            _idx: index on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.Graphic
        """
        pass

    @property
    def GraphicCount(
      self
    ) -> int: 
        """
        Count of Graphic elements.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.GraphicCount
        """
        pass

    @property
    def TemplatePath(
      self
    ) -> str: 
        """
        Path to the template file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.TemplatePath
        """
        pass

    @TemplatePath.setter
    def TemplatePath(
      self,
      _value: str
    ) -> None: 
        """
        Path to the template file.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.TemplatePath
        """
        pass

    @property
    def TemplateStream(
      self
    ) -> TStream: 
        """
        Stream with the template file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.TemplateStream
        """
        pass

    @TemplateStream.setter
    def TemplateStream(
      self,
      _value: TStream
    ) -> None: 
        """
        Stream with the template file.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.TemplateStream
        """
        pass

    @property
    def TemplateText(
      self
    ) -> str: 
        """
        Text with the template file content. Text lines must be CRLF separated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.TemplateText
        """
        pass

    @TemplateText.setter
    def TemplateText(
      self,
      _value: str
    ) -> None: 
        """
        Text with the template file content. Text lines must be CRLF separated.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.TemplateText
        """
        pass

    
    def Text(
      self,
      _idx: int
    ) -> str: 
        """
        The text attached to the template.

        Args:
            _idx: index on the list

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.Text
        """
        pass

    
    def Text(
      self,
      _idx: int,
      _value: str
    ) -> None: 
        """
        The text attached to the template.

        Args:
            _idx: index on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.Text
        """
        pass

    @property
    def TextCount(
      self
    ) -> int: 
        """
        Count of Text elements.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TemplatePrint.TextCount
        """
        pass

class TGIS_JoinType:
    pass

class TGIS_JoinType:
    """
    Types of section conections for offset line.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_JoinType
    """

    @property
    def Round(
      self
    ) -> TGIS_JoinType: 
        """
        Connection is part of a circle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_JoinType.Round
        """
        pass

    @property
    def Trapeze(
      self
    ) -> TGIS_JoinType: 
        """
        Connection maintains a shape based on a trapezoid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_JoinType.Trapeze
        """
        pass

    @property
    def Miter(
      self
    ) -> TGIS_JoinType: 
        """
        Connection maintains ntersecting sections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_JoinType.Miter
        """
        pass

    @property
    def Bevel(
      self
    ) -> TGIS_JoinType: 
        """
        Connection like a rectangle with a cut corner.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_JoinType.Bevel
        """
        pass

class TGIS_Topology( TObject ):
    """
    Encapsulation of basic topological operations.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Create_void
        """
        pass

    def ArcFind(
      self,
      _arc: TGIS_ShapeArc,
      _shplist: TGIS_ObjectList,
      _idx: VarParameter
    ) -> bool: 
        """
        Find on the list arc with duplicated geometry.

        Args:
            _arc: arc to be found
            _shplist: list of arcs
            _idx: found position; the value (in/out) is passed as int in _idx.Value property

        Returns:
            returns true if finds arc with duplicated geometry

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.ArcFind_TGIS_ShapeArc_TGIS_ObjectList_Integer
        """
        pass

    def ArcMakeConnected(
      self,
      _arc: TGIS_ShapeArc,
      _shplist: TGIS_ObjectList
    ) -> TGIS_ShapeArc: 
        """
        Connect the current unconnected shape.

        Args:
            _arc: given shape
            _shplist: arc list to which the shape must be connected

        Returns:
            returns connected shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.ArcMakeConnected_TGIS_ShapeArc_TGIS_ObjectList
        """
        pass

    def ArcSplitOnCross(
      self,
      _shp: TGIS_ShapeArc,
      _shplist: TGIS_ObjectList
    ) -> TGIS_ShapeArc: 
        """
        Return a copy of _shp divided into parts in crossing points with shapes from the 
        list. Ensure proper order and orientation of sections (last point of previous is 
        first of next one).

        Args:
            _shp: shape to divide
            _shplist: a list of Arcs or Polygons

        Returns:
            returns copy of _shp divided into parts in crossing points with shapes from the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.ArcSplitOnCross_TGIS_ShapeArc_TGIS_ObjectList
        """
        pass

    def CheckShape(
      self,
      _shp: TGIS_Shape
    ) -> bool: 
        """
        Checks whether a shape is valid.

        Args:
            _shp: shape to be checked

        Returns:
            True if a _shp is valid

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.CheckShape_TGIS_Shape
        """
        pass

    @overload
    def ClearShape(
      self,
      _shp: TGIS_Shape
    ) -> TGIS_Shape: 
        """
        Make a copy of the shape with removal of redundant (overlapped) points.

        Args:
            _shp: shape to be copied

        Returns:
            returns copy of shape without redundant points

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.ClearShape_TGIS_Shape
        """
        pass

    @overload
    def ClearShape(
      self,
      _shp: TGIS_Shape,
      _returnnewobj: bool
    ) -> TGIS_Shape: 
        """
        Make a copy of the shape with removal of redundant (overlapped) points.

        Args:
            _shp: shape to be copied
            _returnnewobj: if True, then result will be returned in a newly created object; if 
              False, then self object will be returned

        Returns:
            returns copy of shape without redundant points

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.ClearShape_TGIS_Shape_Boolean
        """
        pass

    @overload
    def Combine(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape,
      _operation: TGIS_TopologyCombineType
    ) -> TGIS_Shape: 
        """
        Compute a new shape from the two shapes provided, based on a given operation.

        Args:
            _shpA: first shape
            _shpB: second shape
            _operation: operation code; what kind of operation should be perform between (_shpA) 
              and (_shpB)

        Returns:
            returns new shape combined out of two others based on given type of operation

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Combine_TGIS_Shape_TGIS_Shape_TGIS_TopologyCombineType
        """
        pass

    @overload
    def Combine(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape,
      _operation: TGIS_TopologyCombineType,
      _fixshape: bool
    ) -> TGIS_Shape: 
        """
        Compute a new shape from the two shapes provided, based on a given operation.

        Args:
            _shpA: first shape
            _shpB: second shape
            _operation: operation code; what kind of operation should be perform between (_shpA) 
              and (_shpB)
            _fixshape: if True, then checks and eventually fixes the input shapes for common 
              topological problems, like self-crossings, overlapped parts etc.

        Returns:
            returns new shape combined out of two others based on given type of operation

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Combine_TGIS_Shape_TGIS_Shape_TGIS_TopologyCombineType_Boolean
        """
        pass

    @overload
    def ConcaveHull(
      self,
      _layer: TGIS_LayerVector,
      _alpha: float
    ) -> TGIS_ShapePolygon: 
        """
        Creates a concave hull based on the provided layer and edge length.

        Args:
            _layer: source layer
            _alpha: maximum edge length

        Returns:
            concave hull as a polygon

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.ConcaveHull_TGIS_LayerVector_Double
        """
        pass

    @overload
    def ConcaveHull(
      self,
      _shape: TGIS_Shape,
      _alpha: float
    ) -> TGIS_ShapePolygon: 
        """
        Creates a concave hull based on the provided shape and edge length.

        Args:
            _shape: source shape
            _alpha: maximum edge length

        Returns:
            concave hull as a polygon

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.ConcaveHull_TGIS_Shape_Double
        """
        pass

    @overload
    def ConcaveHull(
      self,
      _shape1: TGIS_Shape,
      _shape2: TGIS_Shape,
      _alpha: float
    ) -> TGIS_ShapePolygon: 
        """
        Creates a concave hull based on the two provided shapes and edge length.

        Args:
            _shape1: first source shape
            _shape2: second source shape; if nil only _shape1 will be used
            _alpha: maximum edge length

        Returns:
            concave hull as a polygon

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.ConcaveHull_TGIS_Shape_TGIS_Shape_Double
        """
        pass

    @overload
    def ConcaveHull(
      self,
      _shape1: TGIS_Shape,
      _shape2: TGIS_Shape,
      _alpha: float,
      _fix: bool
    ) -> TGIS_ShapePolygon: 
        """
        Creates a concave hull based on the two provided shapes and edge length.

        Args:
            _shape1: first source shape
            _shape2: second source shape; if nil only _shape1 will be used
            _alpha: maximum edge length
            _fix: if True, then checks and, if necessary, fixes the input shapes for common topological 
              errors, like self-crossings, overlapping parts etc.

        Returns:
            concave hull as a polygon

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.ConcaveHull_TGIS_Shape_TGIS_Shape_Double_Boolean
        """
        pass

    def Contains(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape
    ) -> bool: 
        """
        Tests contains relationship for given shapes

        Args:
            _shpA: given shape
            _shpB: second given shape

        Returns:
            returns true if shapes contains each other

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Contains_TGIS_Shape_TGIS_Shape
        """
        pass

    @overload
    def ConvexHull(
      self,
      _layer: TGIS_LayerVector
    ) -> TGIS_ShapePolygon: 
        """
        Creates a convex hull based on the provided layer.

        Args:
            _layer: source layer

        Returns:
            convex hull as a polygon

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.ConvexHull_TGIS_LayerVector
        """
        pass

    @overload
    def ConvexHull(
      self,
      _shape: TGIS_Shape
    ) -> TGIS_ShapePolygon: 
        """
        Creates a convex hull based on the provided shape.

        Args:
            _shape: source shape

        Returns:
            convex hull as a polygon

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.ConvexHull_TGIS_Shape
        """
        pass

    @overload
    def ConvexHull(
      self,
      _shape1: TGIS_Shape,
      _shape2: TGIS_Shape
    ) -> TGIS_ShapePolygon: 
        """
        Creates a convex hull based on the two provided shapes.

        Args:
            _shape1: first source shape
            _shape2: second source shape; if nil only _shape1 will be used

        Returns:
            convex hull as a polygon

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.ConvexHull_TGIS_Shape_TGIS_Shape
        """
        pass

    @overload
    def ConvexHull(
      self,
      _shape1: TGIS_Shape,
      _shape2: TGIS_Shape,
      _fix: bool
    ) -> TGIS_ShapePolygon: 
        """
        Creates a convex hull based on the two provided shapes.

        Args:
            _shape1: first source shape
            _shape2: second source shape; if nil only _shape1 will be used
            _fix: if True, then checks and, if necessary, fixes the input shapes for common topological 
              errors, like self-crossings, overlapping parts etc.

        Returns:
            convex hull as a polygon

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.ConvexHull_TGIS_Shape_TGIS_Shape_Boolean
        """
        pass

    def Cross(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape
    ) -> bool: 
        """
        Tests cross relationship for given shapes

        Args:
            _shpA: given shape
            _shpB: second given shape

        Returns:
            returns true if shapes are crossing

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Cross_TGIS_Shape_TGIS_Shape
        """
        pass

    @overload
    def Difference(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape
    ) -> TGIS_Shape: 
        """
        Compute a new shape as a difference of two shapes provided.

        Args:
            _shpA: first shape
            _shpB: second shape

        Returns:
            returns new shape as difference of two shapes

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Difference_TGIS_Shape_TGIS_Shape
        """
        pass

    @overload
    def Difference(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape,
      _fixshape: bool
    ) -> TGIS_Shape: 
        """
        Compute a new shape as a difference of two shapes provided.

        Args:
            _shpA: first shape
            _shpB: second shape
            _fixshape: if True, then checks and eventually fixes the input shapes for common 
              topological problems, like self-crossings, overlapped parts etc.

        Returns:
            returns new shape as difference of two shapes

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Difference_TGIS_Shape_TGIS_Shape_Boolean
        """
        pass

    def Disjoint(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape
    ) -> bool: 
        """
        Tests disjoint relationship for given shapes

        Args:
            _shpA: given shape
            _shpB: second given shape

        Returns:
            returns true if shapes are disjoining

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Disjoint_TGIS_Shape_TGIS_Shape
        """
        pass

    def Equality(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape
    ) -> bool: 
        """
        Tests equality relationship for given shapes

        Args:
            _shpA: given shape
            _shpB: second given shape

        Returns:
            returns true if shapes are equal

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Equality_TGIS_Shape_TGIS_Shape
        """
        pass

    @overload
    def FindAndDeleteLoops(
      self,
      _shp: TGIS_Shape
    ) -> TGIS_Shape: 
        """
        Delete any loop which is smaller than the tolerance.

        Args:
            _shp: shape to be cleared

        Returns:
            returns shape without loops which are smaller than tolerance

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.FindAndDeleteLoops_TGIS_Shape
        """
        pass

    @overload
    def FindAndDeleteLoops(
      self,
      _shp: TGIS_Shape,
      _returnnewobj: bool
    ) -> TGIS_Shape: 
        """
        Delete any loop which is smaller than the tolerance.

        Args:
            _shp: shape to be cleared
            _returnnewobj: if True, then result will be returned in a newly created object; if 
              False, then self object will be returned

        Returns:
            returns shape without loops which are smaller than tolerance

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.FindAndDeleteLoops_TGIS_Shape_Boolean
        """
        pass

    def FindSameOnList(
      self,
      _list: TGIS_ObjectList,
      _shp: TGIS_Shape
    ) -> int: 
        """
        Check, if the current shape has an exactly similar counter partner on a given list.

        Args:
            _list: list to be checked
            _shp: shape to be compared

        Returns:
            number of shapes with exactly similar counter partner on given list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.FindSameOnList_TGIS_ObjectList_TGIS_Shape
        """
        pass

    @overload
    def FixShape(
      self,
      _shp: TGIS_Shape
    ) -> TGIS_Shape: 
        """
        Computes a shape without self-crossings (loops) for arcs and polygons, and with a 
        proper winding for polygon (clockwise, and opposite for holes).

        Args:
            _shp: polygon, or arc to be fixed

        Returns:
            returns the computed shape (self)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.FixShape_TGIS_Shape
        """
        pass

    @overload
    def FixShape(
      self,
      _shp: TGIS_Shape,
      _returnnewobj: bool
    ) -> TGIS_Shape: 
        """
        Computes a shape without self-crossings (loops) for arcs and polygons, and with a 
        proper winding for polygon (clockwise, and opposite for holes).

        Args:
            _shp: polygon, or arc to be fixed
            _returnnewobj: if True, the result is a newly created shape; if False, the self object 
              is returned

        Returns:
            returns the computed shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.FixShape_TGIS_Shape_Boolean
        """
        pass

    @overload
    def FixShapeEx(
      self,
      _shp: TGIS_Shape,
      _returnnewobj: bool,
      _wasfixed: VarParameter
    ) -> TGIS_Shape: 
        """
        Computes a shape without self-crossings (loops) for arcs and polygons, and with a 
        proper winding for polygon (clockwise, and opposite for holes).

        Args:
            _shp: polygon, or arc to be fixed
            _returnnewobj: if True, the result is a newly created shape; if False, the self object 
              is returned
            _wasfixed: indicates whether the shape was modified to fix errors; the value (in/out) 
              is passed as bool in _wasfixed.Value property

        Returns:
            returns the computed shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.FixShapeEx_TGIS_Shape_Boolean_Boolean
        """
        pass

    @overload
    def FixShapeEx(
      self,
      _shp: TGIS_Shape,
      _returnnewobj: bool,
      _forceFix: bool,
      _wasfixed: VarParameter
    ) -> TGIS_Shape: 
        """
        Computes a shape without self-crossings (loops) for arcs and polygons, and with a 
        proper winding for polygon (clockwise, and opposite for holes).

        Args:
            _shp: polygon, or arc to be fixed
            _returnnewobj: if True, the result is a newly created shape; if False, the self object 
              is returned
            _forceFix: fix invalid geometry that does not have enough distinct points by adding 
              missing points
            _wasfixed: indicates whether the shape was modified to fix errors; the value (in/out) 
              is passed as bool in _wasfixed.Value property

        Returns:
            returns the computed shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.FixShapeEx_TGIS_Shape_Boolean_Boolean_Boolean
        """
        pass

    def GetCrossings(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape
    ) -> TGIS_PointList: 
        """
        Get all crossing points between given shapes.

        Args:
            _shpA: given shape
            _shpB: second given shape

        Returns:
            returns list of crossing points

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.GetCrossings_TGIS_Shape_TGIS_Shape
        """
        pass

    def GetCrossings3D(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape
    ) -> TGIS_Point3DList: 
        """
        Get all crossing points between given shapes.

        Args:
            _shpA: given shape
            _shpB: second given shape

        Returns:
            returns list of crossing points

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.GetCrossings3D_TGIS_Shape_TGIS_Shape
        """
        pass

    def Intersect(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape
    ) -> bool: 
        """
        Test intersects relationship for given shapes

        Args:
            _shpA: given shape
            _shpB: second given shape

        Returns:
            returns true if shapes are intersecting

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Intersect_TGIS_Shape_TGIS_Shape
        """
        pass

    @overload
    def Intersection(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape
    ) -> TGIS_Shape: 
        """
        Compute a new shape as an intersection of two shapes provided.

        Args:
            _shpA: first shape
            _shpB: second shape

        Returns:
            returns new shape as intersection of two shapes

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Intersection_TGIS_Shape_TGIS_Shape
        """
        pass

    @overload
    def Intersection(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape,
      _fixshape: bool
    ) -> TGIS_Shape: 
        """
        Compute a new shape as an intersection of two shapes provided.

        Args:
            _shpA: first shape
            _shpB: second shape
            _fixshape: if True, then checks and eventually fixes the input shapes for common 
              topological problems, like self-crossings, overlapped parts etc.

        Returns:
            returns new shape as intersection of two shapes

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Intersection_TGIS_Shape_TGIS_Shape_Boolean
        """
        pass

    @overload
    def MakeBuffer(
      self,
      _shp: TGIS_Shape,
      _dist: float
    ) -> TGIS_Shape: 
        """
        Compute a buffer around a shape to a given distance. Uses 9 vertices to create a 
        curve.

        Args:
            _shp: shape to which a buffer must be constructed
            _dist: distance

        Returns:
            returns new shape with buffer around given shape within given distance

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.MakeBuffer_TGIS_Shape_Double
        """
        pass

    @overload
    def MakeBuffer(
      self,
      _shp: TGIS_Shape,
      _dist: float,
      _pi2_points: int,
      _fixshape: bool
    ) -> TGIS_Shape: 
        """
        Compute a buffer around a shape to a given distance.

        Args:
            _shp: shape to which a buffer must be constructed
            _dist: distance
            _pi2_points: number of vertices used to create a curve;
            _fixshape: if True, then checks and eventually fixes the input shapes for common 
              topological problems, like self-crossings, overlapped parts etc.

        Returns:
            returns new shape with buffer around given shape within given distance

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.MakeBuffer_TGIS_Shape_Double_Integer_Boolean
        """
        pass

    @overload
    def MakeOffsetLine(
      self,
      _shp: TGIS_Shape,
      _dist: float
    ) -> TGIS_Shape: 
        """
        Compute a shifted line for a shape to a given distance.

        Args:
            _shp: shape to which a shifted line must be constructed
            _dist: distance ( &lt; 0 for line on right, &gt; 0 on left)

        Returns:
            returns new shifted shape with given distance

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.MakeOffsetLine_TGIS_Shape_Double
        """
        pass

    @overload
    def MakeOffsetLine(
      self,
      _shp: TGIS_Shape,
      _dist: float,
      _jointype: TGIS_JoinType
    ) -> TGIS_Shape: 
        """
        Compute a shifted line for a shape to a given distance.

        Args:
            _shp: shape to which a shifted line must be constructed
            _dist: distance ( &lt; 0 for line on right, &gt; 0 on left)
            _jointype: way of connecting sections

        Returns:
            returns new shifted shape with given distance

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.MakeOffsetLine_TGIS_Shape_Double_TGIS_JoinType
        """
        pass

    def Overlap(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape
    ) -> bool: 
        """
        Tests overlap relationship for given shapes

        Args:
            _shpA: given shape
            _shpB: second given shape

        Returns:
            returns true if shapes are overlapping

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Overlap_TGIS_Shape_TGIS_Shape
        """
        pass

    def PartStatus(
      self,
      _shp: TGIS_ShapePolygon,
      _part: int,
      _parentPart: VarParameter
    ) -> int: 
        """
        Verifies if provided part is an island/hole

        Args:
            _shp: source polygon,
            _part: part number
            _parentPart: return parent part number for given part, for main part will be -1, 
              for islands/holes &gt;=0; the value (in/out) is passed as int in _parentPart.Value 
              property

        Returns:
            1 if island (on hole), -1 if hole; 0 if main part (also in multipolygon)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.PartStatus_TGIS_ShapePolygon_Integer_Integer
        """
        pass

    def Relate(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape,
      _de9im: str
    ) -> bool: 
        """
        Checks nine-intersection matrix for given shapes.

        Args:
            _shpA: given shape
            _shpB: second given shape
            _de9im: intersection matrix

        Returns:
            returns true if shapes are related

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Relate_TGIS_Shape_TGIS_Shape_String
        """
        pass

    def RelatePrepare(
      self,
      _shp: TGIS_Shape
    ) -> None: 
        """
        Mark given shape as a main shape for subsequent Relate operations.

        Args:
            _shp: shape to be optimized

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.RelatePrepare_TGIS_Shape
        """
        pass

    @overload
    def SplitByArc(
      self,
      _shape: TGIS_Shape,
      _arc: TGIS_ShapeArc
    ) -> TGIS_ObjectList: 
        """
        Divide an input shape (polygon, arc or multipoint) into a row of shapes along a given 
        line.

        Args:
            _shape: a shape to divide
            _arc: dividing line

        Returns:
            List of shapes divided by line. List will contain original shape if dividing was 
            not possible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.SplitByArc_TGIS_Shape_TGIS_ShapeArc
        """
        pass

    @overload
    def SplitByArc(
      self,
      _shape: TGIS_Shape,
      _arc: TGIS_ShapeArc,
      _fixshape: bool
    ) -> TGIS_ObjectList: 
        """
        Divide an input shape (polygon, arc or multipoint) into a row of shapes along a given 
        line, otherwise return a copy of the shape when the line doesn''t divide it.

        Args:
            _shape: a shape to divide
            _arc: dividing line
            _fixshape: if True, then checks and eventually fixes the input shape for common topological 
              problems, like self-crossings, overlapped parts etc.

        Returns:
            returns list of shapes divided by arc

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.SplitByArc_TGIS_Shape_TGIS_ShapeArc_Boolean
        """
        pass

    @overload
    def SymmetricalDifference(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape
    ) -> TGIS_Shape: 
        """
        Compute a new shape as a symmetrical difference of two shapes provided.

        Args:
            _shpA: first shape
            _shpB: second shape

        Returns:
            returns new shape as symmetrical difference of two shapes

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.SymmetricalDifference_TGIS_Shape_TGIS_Shape
        """
        pass

    @overload
    def SymmetricalDifference(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape,
      _fixshape: bool
    ) -> TGIS_Shape: 
        """
        Compute a new shape as a symmetrical difference of two shapes provided.

        Args:
            _shpA: first shape
            _shpB: second shape
            _fixshape: if True, then checks and eventually fixes the input shapes for common 
              topological problems, like self-crossings, overlapped parts etc.

        Returns:
            returns new shape as symmetrical difference of two shapes

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.SymmetricalDifference_TGIS_Shape_TGIS_Shape_Boolean
        """
        pass

    def Touch(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape
    ) -> bool: 
        """
        Tests touch relationship for given shapes

        Args:
            _shpA: given shape
            _shpB: second given shape

        Returns:
            returns true if shapes are touching

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Touch_TGIS_Shape_TGIS_Shape
        """
        pass

    @overload
    def Union(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape
    ) -> TGIS_Shape: 
        """
        Compute a new shape as an union of two shapes provided.

        Args:
            _shpA: first shape
            _shpB: second shape

        Returns:
            returns new shape as union of two others

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Union_TGIS_Shape_TGIS_Shape
        """
        pass

    @overload
    def Union(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape,
      _fixshape: bool
    ) -> TGIS_Shape: 
        """
        Compute a new shape as an union of two shapes provided.

        Args:
            _shpA: first shape
            _shpB: second shape
            _fixshape: if True, then checks and eventually fixes the input shapes for common 
              topological problems, like self-crossings, overlapped parts etc.

        Returns:
            returns new shape as union of two others

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Union_TGIS_Shape_TGIS_Shape_Boolean
        """
        pass

    @overload
    def UnionOnList(
      self,
      _shpList: TGIS_ShapeList
    ) -> TGIS_Shape: 
        """
        Compute a union from the list of shapes.

        Args:
            _shpList: list of shapes

        Returns:
            returns new shape as union of shapes from list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.UnionOnList_TGIS_ShapeList
        """
        pass

    @overload
    def UnionOnList(
      self,
      _shpList: TGIS_ShapeList,
      _fixshape: bool
    ) -> TGIS_Shape: 
        """
        Compute a union form the list of shapes.

        Args:
            _shpList: list of shapes
            _fixshape: if True, then checks and eventually fixes the input shapes for common 
              topological problems, like self-crossings, overlapped parts etc.

        Returns:
            returns new shape as union of shapes from list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.UnionOnList_TGIS_ShapeList_Boolean
        """
        pass

    def Within(
      self,
      _shpA: TGIS_Shape,
      _shpB: TGIS_Shape
    ) -> bool: 
        """
        Tests within relationship for given shapes

        Args:
            _shpA: given shape
            _shpB: second given shape

        Returns:
            returns true if shape is within

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Within_TGIS_Shape_TGIS_Shape
        """
        pass

    @property
    def ForceShapeFixing(
      self
    ) -> bool: 
        """
        If True then topological operations will force shape fixing. True will slow down 
        any polygonal operations due to the fact that shape fixing will ensure proper winding 
        and overlapping issues. Global default (which is False) can be set using GisTopologyForceShapeFixing().

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.ForceShapeFixing
        """
        pass

    @ForceShapeFixing.setter
    def ForceShapeFixing(
      self,
      _value: bool
    ) -> None: 
        """
        If True then topological operations will force shape fixing. True will slow down 
        any polygonal operations due to the fact that shape fixing will ensure proper winding 
        and overlapping issues. Global default (which is False) can be set using GisTopologyForceShapeFixing().

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.ForceShapeFixing
        """
        pass

    @property
    def Tolerance(
      self
    ) -> float: 
        """
        Tolerance of operations. Things below this level of tolerance will be snapped, removed 
        etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Tolerance
        """
        pass

    @Tolerance.setter
    def Tolerance(
      self,
      _value: float
    ) -> None: 
        """
        Tolerance of operations. Things below this level of tolerance will be snapped, removed 
        etc.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.Tolerance
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        Busy event. Will be fired regularly during long-drawn operations.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        Busy event. Will be fired regularly during long-drawn operations.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Topology.BusyEvent
        """
        pass

class TGIS_PolynomialOrder:
    pass

class TGIS_PolynomialOrder:
    """
    Polynomial order.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PolynomialOrder
    """

    @property
    def First(
      self
    ) -> TGIS_PolynomialOrder: 
        """
        First polynomial order; at least 3 GCPs required.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PolynomialOrder.First
        """
        pass

    @property
    def Second(
      self
    ) -> TGIS_PolynomialOrder: 
        """
        Second polynomial order; at least 6 GCPs required.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PolynomialOrder.Second
        """
        pass

    @property
    def Third(
      self
    ) -> TGIS_PolynomialOrder: 
        """
        Third polynomial order; at least 10 GCPs required.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PolynomialOrder.Third
        """
        pass

class TGIS_Transform( TObject ):
    """
    Base class for layer transformations. A sample class that can inherits form TGIS_Transform 
    is polynomial transformation which can transform layer according to GCP points.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Transform
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Transform.Create_void
        """
        pass

    def LoadFromFile(
      self,
      _path: str
    ) -> None: 
        """
        Load transformation definitions from the file. By default TGIS_Layer save/load transformation 
        to/from file named: file_name.ext.trn

        Args:
            _path: - path to the file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Transform.LoadFromFile_String
        """
        pass

    def MustSave(
      self
    ) -> bool: 
        """
        Check if transformation was modified by editing.

        Returns:
            true if transformation was modified

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Transform.MustSave_void
        """
        pass

    def SaveToFile(
      self,
      _path: str
    ) -> None: 
        """
        Save transformation definitions to the file. By default TGIS_Layer save/load transformation 
        to/from file named: file_name.ext.trn

        Args:
            _path: - path to the file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Transform.SaveToFile_String
        """
        pass

    def Transform(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        Transform point.

        Args:
            _ptg: point to be transformed

        Returns:
            transformed point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Transform.Transform_TGIS_Point
        """
        pass

    def Transform3D_Ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Transform point 3D by reference.

        Args:
            _ptg: point to be transformed; the value (in/out) is passed as TGIS_Point3D in _ptg.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Transform.Transform3D_Ref_TGIS_Point3D
        """
        pass

    def Untransform(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        Untransform point.

        Args:
            _ptg: point to be untransformed

        Returns:
            untransformed point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Transform.Untransform_TGIS_Point
        """
        pass

    def Untransform3D_Ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Untransform point 3D by reference.

        Args:
            _ptg: point to be transformed; the value (in/out) is passed as TGIS_Point3D in _ptg.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Transform.Untransform3D_Ref_TGIS_Point3D
        """
        pass

    @property
    def Active(
      self
    ) -> bool: 
        """
        True if transformation is active.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Transform.Active
        """
        pass

    @Active.setter
    def Active(
      self,
      _value: bool
    ) -> None: 
        """
        True if transformation is active.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Transform.Active
        """
        pass

    @property
    def CuttingPolygon(
      self
    ) -> str: 
        """
        WKT of cutting polygon. Polygon vertices should be in untransformed units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Transform.CuttingPolygon
        """
        pass

    @CuttingPolygon.setter
    def CuttingPolygon(
      self,
      _value: str
    ) -> None: 
        """
        WKT of cutting polygon. Polygon vertices should be in untransformed units.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Transform.CuttingPolygon
        """
        pass

class TGIS_TransformGCP( TGIS_Transform ):
    """
    Base class for layer transformations based on GCP (Ground Control Points). A sample 
    class that can inherits from TGIS_TransformGCP is a polynomial transformation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformGCP
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformGCP.Create_void
        """
        pass

    @overload
    def AddPoint(
      self,
      _src: TGIS_Point,
      _dst: TGIS_Point,
      _uid: int
    ) -> None: 
        """
        Add Ground Control Point (GCP) will be used by Prepare method to compute transformation 
        matrix. Added point is marked as active.

        Args:
            _src: source point (in a source coordinates)
            _dst: destination point (matching point in a destination coordinates)
            _uid: point identifier (reserved for future use)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformGCP.AddPoint_TGIS_Point_TGIS_Point_Integer
        """
        pass

    @overload
    def AddPoint(
      self,
      _src: TGIS_Point,
      _dst: TGIS_Point,
      _uid: int,
      _active: bool
    ) -> None: 
        """
        Add Ground Control Point (GCP) will be used by Prepare method to compute transformation 
        matrix.

        Args:
            _src: source point (in a source coordinates)
            _dst: destination point (matching point in a destination coordinates)
            _uid: point identifier (reserved for future use)
            _active: is point active

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformGCP.AddPoint_TGIS_Point_TGIS_Point_Integer_Boolean
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear all GCP points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformGCP.Clear_void
        """
        pass

    @property
    def Error(
      self
    ) -> int: 
        """
        Error number.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformGCP.Error
        """
        pass

    
    def PointsActive(
      self,
      _index: int
    ) -> bool: 
        """
        Gives us information if point is active.

        Args:
            _index: index of the point

        Returns:
            points active

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformGCP.PointsActive
        """
        pass

    
    def PointsActive(
      self,
      _index: int,
      _value: bool
    ) -> None: 
        """
        Gives us information if point is active.

        Args:
            _index: index of the point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformGCP.PointsActive
        """
        pass

    @property
    def PointsCount(
      self
    ) -> int: 
        """
        Number of points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformGCP.PointsCount
        """
        pass

    
    def PointsDst(
      self,
      _index: int
    ) -> TGIS_Point: 
        """
        End point of the transformation.

        Args:
            _index: index of the point

        Returns:
            points dst

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformGCP.PointsDst
        """
        pass

    
    def PointsDst(
      self,
      _index: int,
      _value: TGIS_Point
    ) -> None: 
        """
        End point of the transformation.

        Args:
            _index: index of the point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformGCP.PointsDst
        """
        pass

    
    def PointsSrc(
      self,
      _index: int
    ) -> TGIS_Point: 
        """
        Source point of transformation.

        Args:
            _index: index of the point

        Returns:
            points src

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformGCP.PointsSrc
        """
        pass

    
    def PointsSrc(
      self,
      _index: int,
      _value: TGIS_Point
    ) -> None: 
        """
        Source point of transformation.

        Args:
            _index: index of the point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformGCP.PointsSrc
        """
        pass

    
    def PointsUid(
      self,
      _index: int
    ) -> int: 
        """
        Gives us Uid of the point.

        Args:
            _index: index of the point

        Returns:
            points uid

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformGCP.PointsUid
        """
        pass

    
    def PointsUid(
      self,
      _index: int,
      _value: int
    ) -> None: 
        """
        Gives us Uid of the point.

        Args:
            _index: index of the point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformGCP.PointsUid
        """
        pass

    @property
    def RMS(
      self
    ) -> float: 
        """
        RMS error for current transformation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformGCP.RMS
        """
        pass

class TGIS_TransformPolynomial( TGIS_TransformGCP ):
    """
    Ground control point (GCP) computations involving polynomial.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformPolynomial
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformPolynomial.Create_void
        """
        pass

    def Prepare(
      self,
      _order: TGIS_PolynomialOrder
    ) -> bool: 
        """
        Prepare transformation based on current set of GCP points.

        Args:
            _order: polynomial order; first order requires at least 3 point; second order requires 
              at least 6 points; third order requires at least 10 points;

        Returns:
            True if prepared

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformPolynomial.Prepare_TGIS_PolynomialOrder
        """
        pass

    @property
    def PolynomialOrder(
      self
    ) -> TGIS_PolynomialOrder: 
        """
        Polynomial order.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformPolynomial.PolynomialOrder
        """
        pass

class TGIS_TransformCustom( TGIS_Transform ):
    """
    Custom transform.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformCustom
    """

    @property
    def CustomTransformEvent(
      self
    ) -> typing.Callable[[Boolean, TGIS_Point3D], None]: 
        """
        Event for custom transformation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformCustom.CustomTransformEvent
        """
        pass

    @CustomTransformEvent.setter
    def CustomTransformEvent(
      self,
      _value: typing.Callable[[Boolean, TGIS_Point3D], None]
    ) -> None: 
        """
        Event for custom transformation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TransformCustom.CustomTransformEvent
        """
        pass

class TGIS_LayerVoronoi( TGIS_LayerVector ):
    """
    Encapsulation of Voronoi layer. It can keep polygons as Voronoi cells or Delaunay 
    triangles (see Triangulate property)

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVoronoi
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerVoronoi.Create_void
        """
        pass

class TGIS_LayerDelaunay( TGIS_LayerVector ):
    """
    Encapsulation of Delaunay layer. It can keep polygons as Voronoi cells or Delaunay 
    triangles (see Triangulate property)

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDelaunay
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDelaunay.Create_void
        """
        pass

    def PointAltitude(
      self,
      _pt: TGIS_Point
    ) -> float: 
        """
        Approximation point elevation from Delaunay triangulation net

        Args:
            _pt: given point

        Returns:
            returns point elevation

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDelaunay.PointAltitude_TGIS_Point
        """
        pass

    @overload
    def PrepareAltitudeData(
      self,
      _layer: TGIS_LayerVector,
      _extent: TGIS_Extent,
      _type: TGIS_ShapeType,
      _scope: str,
      _truncated: bool
    ) -> None: 
        """
        Prepares Delaunay triangles from an existing layer.

        Args:
            _layer: layer to be imported
            _extent: start extent of layer - can''t be zero sized
            _type: shape type supported by the layer; if Unknown is used then Export will try 
              to recognize the shape type on its own;
            _scope: SQL query for which the shape will be exported
            _truncated: if True, then all shapes will be truncated in _extent; if False, only 
              shape visible in _extent will be exported ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDelaunay.PrepareAltitudeData_TGIS_LayerVector_TGIS_Extent_TGIS_ShapeType_String_Boolean
        """
        pass

    @overload
    def PrepareAltitudeData(
      self,
      _layer: TGIS_LayerVector,
      _extent: TGIS_Extent,
      _type: TGIS_ShapeType,
      _scope: str,
      _shape: TGIS_Shape,
      _de9im: str,
      _truncated: bool
    ) -> None: 
        """
        Prepares Delaunay triangles from an existing layer.

        Args:
            _layer: layer to be imported
            _extent: start extent of layer - can''t be zero sized
            _type: shape type supported by the layer; if Unknown is used then Export will try 
              to recognize the shape type on its own;
            _scope: SQL query for which the shape will be exported
            _shape: shape use to check relationship using DE9IM model
            _de9im: DE9IM model to check relationship to provided shape
            _truncated: if True, then all shapes will be truncated in _extent; if False, only 
              shape visible in _extent will be exported ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDelaunay.PrepareAltitudeData_TGIS_LayerVector_TGIS_Extent_TGIS_ShapeType_String_TGIS_Shape_String_Boolean
        """
        pass

class TGIS_InterpolationMethod:
    pass

class TGIS_InterpolationMethod:
    """
    Defines an interpolation method.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationMethod
    """

    @property
    def Exponential(
      self
    ) -> TGIS_InterpolationMethod: 
        """
        Exponential interpolation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationMethod.Exponential
        """
        pass

    @property
    def Linear(
      self
    ) -> TGIS_InterpolationMethod: 
        """
        Linear interpolation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationMethod.Linear
        """
        pass

    @property
    def Logarithmic(
      self
    ) -> TGIS_InterpolationMethod: 
        """
        Logarithmic interpolation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InterpolationMethod.Logarithmic
        """
        pass

class TGIS_DrawMode:
    pass

class TGIS_DrawMode:
    """
    Shows what scope of the layers must be drawn.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawMode
    """

    @property
    def All(
      self
    ) -> TGIS_DrawMode: 
        """
        Draw all layers; also draw selection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawMode.All
        """
        pass

    @property
    def AllExceptTop(
      self
    ) -> TGIS_DrawMode: 
        """
        Draw all layers except top non-cached layers (for example GPS tracking layers); also 
        draw selections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawMode.AllExceptTop
        """
        pass

    @property
    def Top(
      self
    ) -> TGIS_DrawMode: 
        """
        Draw only top non-cached layers (for example GPS tracking layers).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawMode.Top
        """
        pass

    @property
    def OnlySelectedAll(
      self
    ) -> TGIS_DrawMode: 
        """
        Draw only selected shapes for all layers; also draw selection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawMode.OnlySelectedAll
        """
        pass

    @property
    def OnlySelectedAllExceptTop(
      self
    ) -> TGIS_DrawMode: 
        """
        Draw only selected shapes all layers except top non-cached layers (for example GPS 
        tracking layers); also draw selections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawMode.OnlySelectedAllExceptTop
        """
        pass

    @property
    def OnlySelectedTop(
      self
    ) -> TGIS_DrawMode: 
        """
        Draw only selected shapes for top non-cached layers (for example GPS tracking layers).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawMode.OnlySelectedTop
        """
        pass

    @property
    def Flash(
      self
    ) -> TGIS_DrawMode: 
        """
        Draw flashing shapes

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawMode.Flash
        """
        pass

    @property
    def AllExcept3D(
      self
    ) -> TGIS_DrawMode: 
        """
        Draw all layer except 3d features

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawMode.AllExcept3D
        """
        pass

class TGIS_CompressionType:
    pass

class TGIS_CompressionType:
    """
    Compression types.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CompressionType
    """

    @property
    def None_(
      self
    ) -> TGIS_CompressionType: 
        """
        No compression, in BGR format.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CompressionType.None
        """
        pass

    @property
    def JPEG(
      self
    ) -> TGIS_CompressionType: 
        """
        JPEG compression.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CompressionType.JPEG
        """
        pass

    @property
    def PNG(
      self
    ) -> TGIS_CompressionType: 
        """
        PNG compression.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CompressionType.PNG
        """
        pass

    @property
    def PackBits(
      self
    ) -> TGIS_CompressionType: 
        """
        Pack Bits compression.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CompressionType.PackBits
        """
        pass

    @property
    def RLE(
      self
    ) -> TGIS_CompressionType: 
        """
        RLE (Run Length Encoding) compression.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CompressionType.RLE
        """
        pass

    @property
    def CCITTHuffmanRLE(
      self
    ) -> TGIS_CompressionType: 
        """
        CCITT Huffman-RLE compression.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CompressionType.CCITTHuffmanRLE
        """
        pass

    @property
    def LZW(
      self
    ) -> TGIS_CompressionType: 
        """
        LZW (Lempel-Ziv-Welch) compression.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CompressionType.LZW
        """
        pass

    @property
    def CCITTFaxGroup3(
      self
    ) -> TGIS_CompressionType: 
        """
        CCITT Fax Group 3 compression.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CompressionType.CCITTFaxGroup3
        """
        pass

    @property
    def CCITTFaxGroup4(
      self
    ) -> TGIS_CompressionType: 
        """
        CCITT Fax Group 4 compression.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CompressionType.CCITTFaxGroup4
        """
        pass

    @property
    def ZLIB(
      self
    ) -> TGIS_CompressionType: 
        """
        ZLIB compression.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CompressionType.ZLIB
        """
        pass

    @property
    def LZ77(
      self
    ) -> TGIS_CompressionType: 
        """
        LZ77 compression.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CompressionType.LZ77
        """
        pass

    @property
    def JP2(
      self
    ) -> TGIS_CompressionType: 
        """
        JPEG 2000 compression.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CompressionType.JP2
        """
        pass

    @property
    def JPEGPlus(
      self
    ) -> TGIS_CompressionType: 
        """
        JPEG Plus compression.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CompressionType.JPEGPlus
        """
        pass

    @property
    def ARGB(
      self
    ) -> TGIS_CompressionType: 
        """
        No compression, in ARGB format.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CompressionType.ARGB
        """
        pass

class TGIS_ViewerMode:
    pass

class TGIS_ViewerMode:
    """
    Basic modes of TGIS_ViewerWnd operations:

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerMode
    """

    @property
    def Select(
      self
    ) -> TGIS_ViewerMode: 
        """
        Mouse is in selecting mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerMode.Select
        """
        pass

    @property
    def Drag(
      self
    ) -> TGIS_ViewerMode: 
        """
        Mouse is in dragging mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerMode.Drag
        """
        pass

    @property
    def Zoom(
      self
    ) -> TGIS_ViewerMode: 
        """
        Mouse is in zooming mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerMode.Zoom
        """
        pass

    @property
    def Edit(
      self
    ) -> TGIS_ViewerMode: 
        """
        Mouse is in editing mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerMode.Edit
        """
        pass

    @property
    def ZoomEx(
      self
    ) -> TGIS_ViewerMode: 
        """
        Mouse is in zooming mode (visual effect).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerMode.ZoomEx
        """
        pass

    @property
    def UserDefined(
      self
    ) -> TGIS_ViewerMode: 
        """
        User defined mode - without any built-in action.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerMode.UserDefined
        """
        pass

class TGIS_PointerMode:
    pass

class TGIS_PointerMode:
    """
    Pointer mode for operations.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointerMode
    """

    @property
    def Mouse(
      self
    ) -> TGIS_PointerMode: 
        """
        Mouse operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointerMode.Mouse
        """
        pass

    @property
    def Pen(
      self
    ) -> TGIS_PointerMode: 
        """
        Pen touch operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointerMode.Pen
        """
        pass

    @property
    def Touch(
      self
    ) -> TGIS_PointerMode: 
        """
        Finger touch operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointerMode.Touch
        """
        pass

class TGIS_ControlNorthArrowStyle:
    pass

class TGIS_ControlNorthArrowStyle:
    """
    North arrow stock styles

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlNorthArrowStyle
    """

    @property
    def Arrow1(
      self
    ) -> TGIS_ControlNorthArrowStyle: 
        """
        north arrow symbol

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlNorthArrowStyle.Arrow1
        """
        pass

    @property
    def Arrow2(
      self
    ) -> TGIS_ControlNorthArrowStyle: 
        """
        north arrow symbol

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlNorthArrowStyle.Arrow2
        """
        pass

    @property
    def Needle1(
      self
    ) -> TGIS_ControlNorthArrowStyle: 
        """
        north arrow symbol

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlNorthArrowStyle.Needle1
        """
        pass

    @property
    def Needle2(
      self
    ) -> TGIS_ControlNorthArrowStyle: 
        """
        north arrow symbol

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlNorthArrowStyle.Needle2
        """
        pass

    @property
    def Needle3(
      self
    ) -> TGIS_ControlNorthArrowStyle: 
        """
        north arrow symbol

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlNorthArrowStyle.Needle3
        """
        pass

    @property
    def Rose1(
      self
    ) -> TGIS_ControlNorthArrowStyle: 
        """
        north arrow symbol

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlNorthArrowStyle.Rose1
        """
        pass

    @property
    def Rose2(
      self
    ) -> TGIS_ControlNorthArrowStyle: 
        """
        north arrow symbol

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlNorthArrowStyle.Rose2
        """
        pass

    @property
    def Rose3(
      self
    ) -> TGIS_ControlNorthArrowStyle: 
        """
        north arrow symbol

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlNorthArrowStyle.Rose3
        """
        pass

    @property
    def Disk1(
      self
    ) -> TGIS_ControlNorthArrowStyle: 
        """
        north arrow symbol

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlNorthArrowStyle.Disk1
        """
        pass

    @property
    def Disk2(
      self
    ) -> TGIS_ControlNorthArrowStyle: 
        """
        north arrow symbol

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlNorthArrowStyle.Disk2
        """
        pass

    @property
    def Disk3(
      self
    ) -> TGIS_ControlNorthArrowStyle: 
        """
        north arrow symbol

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlNorthArrowStyle.Disk3
        """
        pass

    @property
    def Triangle1(
      self
    ) -> TGIS_ControlNorthArrowStyle: 
        """
        north arrow symbol

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlNorthArrowStyle.Triangle1
        """
        pass

class TGIS_MultiUser:
    pass

class TGIS_MultiUser:
    """
    Type for multi-user work mode.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MultiUser
    """

    @property
    def Default(
      self
    ) -> TGIS_MultiUser: 
        """
        Default mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MultiUser.Default
        """
        pass

    @property
    def SingleUser(
      self
    ) -> TGIS_MultiUser: 
        """
        Single user mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MultiUser.SingleUser
        """
        pass

    @property
    def MultiUser(
      self
    ) -> TGIS_MultiUser: 
        """
        Multi-user mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MultiUser.MultiUser
        """
        pass

class TGIS_ShapeType:
    pass

class TGIS_ShapeType:
    """
    Types of GIS shapes.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeType
    """

    @property
    def Unknown(
      self
    ) -> TGIS_ShapeType: 
        """
        undefined shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeType.Unknown
        """
        pass

    @property
    def Deleted(
      self
    ) -> TGIS_ShapeType: 
        """
        shape marked as a deleted item

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeType.Deleted
        """
        pass

    @property
    def Point(
      self
    ) -> TGIS_ShapeType: 
        """
        single point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeType.Point
        """
        pass

    @property
    def MultiPoint(
      self
    ) -> TGIS_ShapeType: 
        """
        multiple point shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeType.MultiPoint
        """
        pass

    @property
    def Arc(
      self
    ) -> TGIS_ShapeType: 
        """
        line shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeType.Arc
        """
        pass

    @property
    def Polygon(
      self
    ) -> TGIS_ShapeType: 
        """
        area shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeType.Polygon
        """
        pass

    @property
    def Complex(
      self
    ) -> TGIS_ShapeType: 
        """
        complex

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeType.Complex
        """
        pass

    @property
    def MultiPatch(
      self
    ) -> TGIS_ShapeType: 
        """
        multipatch

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeType.MultiPatch
        """
        pass

    @property
    def Null(
      self
    ) -> TGIS_ShapeType: 
        """
        null shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ShapeType.Null
        """
        pass

class TGIS_PartType:
    pass

class TGIS_PartType:
    """
    Types of shape parts.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartType
    """

    @property
    def TriangleStrip(
      self
    ) -> TGIS_PartType: 
        """
        A linked strip of triangles

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartType.TriangleStrip
        """
        pass

    @property
    def TriangleFan(
      self
    ) -> TGIS_PartType: 
        """
        A linked fan of triangles

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartType.TriangleFan
        """
        pass

    @property
    def OuterRing(
      self
    ) -> TGIS_PartType: 
        """
        The outer ring of a polygon

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartType.OuterRing
        """
        pass

    @property
    def InnerRing(
      self
    ) -> TGIS_PartType: 
        """
        A hole of a polygon.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartType.InnerRing
        """
        pass

    @property
    def FirstRing(
      self
    ) -> TGIS_PartType: 
        """
        The first ring of a polygon of an unspecified type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartType.FirstRing
        """
        pass

    @property
    def Ring(
      self
    ) -> TGIS_PartType: 
        """
        A ring of a polygon of an unspecified type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartType.Ring
        """
        pass

    @property
    def Triangle(
      self
    ) -> TGIS_PartType: 
        """
        Triangle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartType.Triangle
        """
        pass

class TGIS_DimensionType:
    pass

class TGIS_DimensionType:
    """
    Types of dimension.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DimensionType
    """

    @property
    def Unknown(
      self
    ) -> TGIS_DimensionType: 
        """
        has undefined dimension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DimensionType.Unknown
        """
        pass

    @property
    def XY(
      self
    ) -> TGIS_DimensionType: 
        """
        has 2D coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DimensionType.XY
        """
        pass

    @property
    def XYZ(
      self
    ) -> TGIS_DimensionType: 
        """
        has Z coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DimensionType.XYZ
        """
        pass

    @property
    def XYM(
      self
    ) -> TGIS_DimensionType: 
        """
        has M measure

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DimensionType.XYM
        """
        pass

    @property
    def XYZM(
      self
    ) -> TGIS_DimensionType: 
        """
        has Z coordinate and M measure

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DimensionType.XYZM
        """
        pass

class TGIS_VirtualField:
    pass

class TGIS_VirtualField:
    """
    Virtual fields.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField
    """

    @property
    def GisUid(
      self
    ) -> TGIS_VirtualField: 
        """
        a shape identifier

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisUid
        """
        pass

    @property
    def GisSelected(
      self
    ) -> TGIS_VirtualField: 
        """
        the selected state indicator

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisSelected
        """
        pass

    @property
    def GisHidden(
      self
    ) -> TGIS_VirtualField: 
        """
        the hidden state indicator

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisHidden
        """
        pass

    @property
    def GisArea(
      self
    ) -> TGIS_VirtualField: 
        """
        the area of the shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisArea
        """
        pass

    @property
    def GisLength(
      self
    ) -> TGIS_VirtualField: 
        """
        the length of the shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisLength
        """
        pass

    @property
    def GisCoordZ(
      self
    ) -> TGIS_VirtualField: 
        """
        the first Z-coordinate of the shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisCoordZ
        """
        pass

    @property
    def GisCoordM(
      self
    ) -> TGIS_VirtualField: 
        """
        the first M-value of the shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisCoordM
        """
        pass

    @property
    def GisNow(
      self
    ) -> TGIS_VirtualField: 
        """
        the current date and time

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisNow
        """
        pass

    @property
    def GisMinX(
      self
    ) -> TGIS_VirtualField: 
        """
        the minimum X-coordinate of the shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisMinX
        """
        pass

    @property
    def GisMinY(
      self
    ) -> TGIS_VirtualField: 
        """
        the minimum Y-coordinate of the shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisMinY
        """
        pass

    @property
    def GisMinZ(
      self
    ) -> TGIS_VirtualField: 
        """
        the minimum Z-coordinate of the shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisMinZ
        """
        pass

    @property
    def GisMinM(
      self
    ) -> TGIS_VirtualField: 
        """
        the minimum M-value of the shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisMinM
        """
        pass

    @property
    def GisMaxX(
      self
    ) -> TGIS_VirtualField: 
        """
        the maximum X-coordinate of the shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisMaxX
        """
        pass

    @property
    def GisMaxY(
      self
    ) -> TGIS_VirtualField: 
        """
        the maximum Y-coordinate of the shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisMaxY
        """
        pass

    @property
    def GisMaxZ(
      self
    ) -> TGIS_VirtualField: 
        """
        the maximum Z-coordinate of the shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisMaxZ
        """
        pass

    @property
    def GisMaxM(
      self
    ) -> TGIS_VirtualField: 
        """
        the maximum M-value of the shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisMaxM
        """
        pass

    @property
    def GisCenterX(
      self
    ) -> TGIS_VirtualField: 
        """
        the center X-coordinate of the shape''s extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisCenterX
        """
        pass

    @property
    def GisCenterY(
      self
    ) -> TGIS_VirtualField: 
        """
        the center Y-coordinate of the shape''s extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisCenterY
        """
        pass

    @property
    def GisCenterZ(
      self
    ) -> TGIS_VirtualField: 
        """
        the center Z-coordinate of the shape''s extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisCenterZ
        """
        pass

    @property
    def GisCenterM(
      self
    ) -> TGIS_VirtualField: 
        """
        the center M-value of the shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisCenterM
        """
        pass

    @property
    def GixCentroidX(
      self
    ) -> TGIS_VirtualField: 
        """
        the centeroid X-coordinate of the shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GixCentroidX
        """
        pass

    @property
    def GixCentroidY(
      self
    ) -> TGIS_VirtualField: 
        """
        the centeroid Y-coordinate of the shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GixCentroidY
        """
        pass

    @property
    def GisNumPoints(
      self
    ) -> TGIS_VirtualField: 
        """
        the number of points in a shape''s geometry

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisNumPoints
        """
        pass

    @property
    def GisNumParts(
      self
    ) -> TGIS_VirtualField: 
        """
        the number of parts in a shape''s geometry

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisNumParts
        """
        pass

    @property
    def GisAggregatedCount(
      self
    ) -> TGIS_VirtualField: 
        """
        the aggregator count (for internal use)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisAggregatedCount
        """
        pass

    @property
    def GisAggregatedValue(
      self
    ) -> TGIS_VirtualField: 
        """
        the aggregator value (for internal use)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisAggregatedValue
        """
        pass

    @property
    def GisShapeType(
      self
    ) -> TGIS_VirtualField: 
        """
        the shape''s type

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisShapeType
        """
        pass

    @property
    def GisViewerScale(
      self
    ) -> TGIS_VirtualField: 
        """
        the scale in which the shape is currently displayed in a viewer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisViewerScale
        """
        pass

    @property
    def GisViewerLevel(
      self
    ) -> TGIS_VirtualField: 
        """
        the level in which the shape is currently displayed in a viewer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VirtualField.GisViewerLevel
        """
        pass

class TGIS_OperationType:
    pass

class TGIS_OperationType:
    """
    Types of operations.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OperationType
    """

    @property
    def Select(
      self
    ) -> TGIS_OperationType: 
        """
        select a layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OperationType.Select
        """
        pass

    @property
    def Edit(
      self
    ) -> TGIS_OperationType: 
        """
        edit a layer

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OperationType.Edit
        """
        pass

class TGIS_LayerSubType:
    pass

class TGIS_LayerSubType:
    """
    Layer subtype. For handling additional information about layer type etc.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSubType
    """

    @property
    def Persistent(
      self
    ) -> TGIS_LayerSubType: 
        """
        layer is persistent - is not temporary, has file representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSubType.Persistent
        """
        pass

    @property
    def Exportable(
      self
    ) -> TGIS_LayerSubType: 
        """
        layer content can be exported (saved).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSubType.Exportable
        """
        pass

    @property
    def InMemory(
      self
    ) -> TGIS_LayerSubType: 
        """
        whole layer resides in memory.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSubType.InMemory
        """
        pass

class TGIS_LayerDormantMode:
    pass

class TGIS_LayerDormantMode:
    """
    Basic modes of layer Dormant operations:

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDormantMode
    """

    @property
    def Off(
      self
    ) -> TGIS_LayerDormantMode: 
        """
        layer will not become dormant.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDormantMode.Off
        """
        pass

    @property
    def Standard(
      self
    ) -> TGIS_LayerDormantMode: 
        """
        layer will become dormant if it is not visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDormantMode.Standard
        """
        pass

    @property
    def Agressive(
      self
    ) -> TGIS_LayerDormantMode: 
        """
        layer will become dormant just after pain operations (can slow down the viewer).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerDormantMode.Agressive
        """
        pass

class TGIS_LabelAlignment:
    pass

class TGIS_LabelAlignment:
    """
    Alignment within label.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelAlignment
    """

    @property
    def Single(
      self
    ) -> TGIS_LabelAlignment: 
        """
        No alignment; single line label.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelAlignment.Single
        """
        pass

    @property
    def LeftJustify(
      self
    ) -> TGIS_LabelAlignment: 
        """
        Align to left; multi-line allowed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelAlignment.LeftJustify
        """
        pass

    @property
    def Center(
      self
    ) -> TGIS_LabelAlignment: 
        """
        Center text; multi-line allowed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelAlignment.Center
        """
        pass

    @property
    def RightJustify(
      self
    ) -> TGIS_LabelAlignment: 
        """
        Align to right; multi-line allowed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelAlignment.RightJustify
        """
        pass

    @property
    def Follow(
      self
    ) -> TGIS_LabelAlignment: 
        """
        label will follow the flow of shape; valid only for Arcs; ideal for river and streets 
        labeling; any position will be tested for fitting with 10% tolerance; to place a 
        label on a top of the shape set TGIS_ParamsLabel.Position to TGIS_LabelPosition.MiddleCenter; 
        to force a label to display on arcs shorter than a label width set TGIS_ParamsLabel.Position 
        to TGIS_LabelPosition.Flow.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelAlignment.Follow
        """
        pass

class TGIS_LabelPosition:
    pass

class TGIS_LabelPosition:
    """
    Position of a label.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelPosition
    """

    @property
    def Undefined(
      self
    ) -> TGIS_LabelPosition: 
        """
        Undefined.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelPosition.Undefined
        """
        pass

    @property
    def UpLeft(
      self
    ) -> TGIS_LabelPosition: 
        """
        up-left to the insertion point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelPosition.UpLeft
        """
        pass

    @property
    def UpCenter(
      self
    ) -> TGIS_LabelPosition: 
        """
        Up-center to the insertion point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelPosition.UpCenter
        """
        pass

    @property
    def UpRight(
      self
    ) -> TGIS_LabelPosition: 
        """
        Up-right to the insertion point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelPosition.UpRight
        """
        pass

    @property
    def MiddleLeft(
      self
    ) -> TGIS_LabelPosition: 
        """
        Middle-left to the insertion point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelPosition.MiddleLeft
        """
        pass

    @property
    def MiddleCenter(
      self
    ) -> TGIS_LabelPosition: 
        """
        Middle-center to the insertion point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelPosition.MiddleCenter
        """
        pass

    @property
    def MiddleRight(
      self
    ) -> TGIS_LabelPosition: 
        """
        Middle-right to the insertion point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelPosition.MiddleRight
        """
        pass

    @property
    def DownLeft(
      self
    ) -> TGIS_LabelPosition: 
        """
        down-left to the insertion point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelPosition.DownLeft
        """
        pass

    @property
    def DownCenter(
      self
    ) -> TGIS_LabelPosition: 
        """
        Down-center to the insertion point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelPosition.DownCenter
        """
        pass

    @property
    def DownRight(
      self
    ) -> TGIS_LabelPosition: 
        """
        down-right to the insertion point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelPosition.DownRight
        """
        pass

    @property
    def Flow(
      self
    ) -> TGIS_LabelPosition: 
        """
        Labels will be positioned based on the visible part of extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LabelPosition.Flow
        """
        pass

class TGIS_OffsetPosition:
    pass

class TGIS_OffsetPosition:
    """
    Position of offset.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OffsetPosition
    """

    @property
    def UpLeft(
      self
    ) -> TGIS_OffsetPosition: 
        """
        up-left to the original position.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OffsetPosition.UpLeft
        """
        pass

    @property
    def UpRight(
      self
    ) -> TGIS_OffsetPosition: 
        """
        Up-right to the original position.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OffsetPosition.UpRight
        """
        pass

    @property
    def DownLeft(
      self
    ) -> TGIS_OffsetPosition: 
        """
        down-left to the original position.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OffsetPosition.DownLeft
        """
        pass

    @property
    def DownRight(
      self
    ) -> TGIS_OffsetPosition: 
        """
        down-right to the original position.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_OffsetPosition.DownRight
        """
        pass

class TGIS_Lock:
    pass

class TGIS_Lock:
    """
    Types of shape locking.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Lock
    """

    @property
    def None_(
      self
    ) -> TGIS_Lock: 
        """
        Unlocked.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Lock.None
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Lock: 
        """
        Extent locked.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Lock.Extent
        """
        pass

    @property
    def Projection(
      self
    ) -> TGIS_Lock: 
        """
        Extent locked and projections turn off.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Lock.Projection
        """
        pass

    @property
    def Internal(
      self
    ) -> TGIS_Lock: 
        """
        Only for internal use.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Lock.Internal
        """
        pass

    @property
    def Internal2(
      self
    ) -> TGIS_Lock: 
        """
        Only for internal use.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Lock.Internal2
        """
        pass

class TGIS_TopologyCombineType:
    pass

class TGIS_TopologyCombineType:
    """
    Type of operation for combining shapes.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TopologyCombineType
    """

    @property
    def Union(
      self
    ) -> TGIS_TopologyCombineType: 
        """
        ShapeA + ShapeB.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TopologyCombineType.Union
        """
        pass

    @property
    def Intersection(
      self
    ) -> TGIS_TopologyCombineType: 
        """
        ShapeA and ShapeB.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TopologyCombineType.Intersection
        """
        pass

    @property
    def Difference(
      self
    ) -> TGIS_TopologyCombineType: 
        """
        ShapeA - ShapeB

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TopologyCombineType.Difference
        """
        pass

    @property
    def SymmetricalDifference(
      self
    ) -> TGIS_TopologyCombineType: 
        """
        ShapeA xor ShapeB.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_TopologyCombineType.SymmetricalDifference
        """
        pass

class TGIS_InsideType:
    pass

class TGIS_InsideType:
    """
    Types of IsInside checking.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InsideType
    """

    @property
    def Full(
      self
    ) -> TGIS_InsideType: 
        """
        Shape must be totally covered.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InsideType.Full
        """
        pass

    @property
    def Centroid(
      self
    ) -> TGIS_InsideType: 
        """
        Only centroid must be covered.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InsideType.Centroid
        """
        pass

    @property
    def partial(
      self
    ) -> TGIS_InsideType: 
        """
        Any part must be covered.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_InsideType.partial
        """
        pass

class TGIS_MarkerStyle:
    pass

class TGIS_MarkerStyle:
    """
    Style of markers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MarkerStyle
    """

    @property
    def Box(
      self
    ) -> TGIS_MarkerStyle: 
        """
        Marker is box.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MarkerStyle.Box
        """
        pass

    @property
    def Circle(
      self
    ) -> TGIS_MarkerStyle: 
        """
        Marker is circle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MarkerStyle.Circle
        """
        pass

    @property
    def Cross(
      self
    ) -> TGIS_MarkerStyle: 
        """
        Marker is cross.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MarkerStyle.Cross
        """
        pass

    @property
    def DiagCross(
      self
    ) -> TGIS_MarkerStyle: 
        """
        Marker is box.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MarkerStyle.DiagCross
        """
        pass

    @property
    def TriangleUp(
      self
    ) -> TGIS_MarkerStyle: 
        """
        Marker is triangle headed up.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MarkerStyle.TriangleUp
        """
        pass

    @property
    def TriangleDown(
      self
    ) -> TGIS_MarkerStyle: 
        """
        Marker is triangle headed down.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MarkerStyle.TriangleDown
        """
        pass

    @property
    def TriangleLeft(
      self
    ) -> TGIS_MarkerStyle: 
        """
        Marker is triangle headed left.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MarkerStyle.TriangleLeft
        """
        pass

    @property
    def TriangleRight(
      self
    ) -> TGIS_MarkerStyle: 
        """
        Marker is triangle headed right.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_MarkerStyle.TriangleRight
        """
        pass

class TGIS_ChartStyle:
    pass

class TGIS_ChartStyle:
    """
    Style of charts.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ChartStyle
    """

    @property
    def Pie(
      self
    ) -> TGIS_ChartStyle: 
        """
        Pie-chart.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ChartStyle.Pie
        """
        pass

    @property
    def Bar(
      self
    ) -> TGIS_ChartStyle: 
        """
        Bar-chart.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ChartStyle.Bar
        """
        pass

class TGIS_ContentType:
    pass

class TGIS_ContentType:
    """
    Content type types.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContentType
    """

    @property
    def Unknown(
      self
    ) -> TGIS_ContentType: 
        """
        Unknown content.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContentType.Unknown
        """
        pass

    @property
    def Gif(
      self
    ) -> TGIS_ContentType: 
        """
        Gif image.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContentType.Gif
        """
        pass

    @property
    def Jpg(
      self
    ) -> TGIS_ContentType: 
        """
        Jpg image.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContentType.Jpg
        """
        pass

    @property
    def Png(
      self
    ) -> TGIS_ContentType: 
        """
        Png image.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContentType.Png
        """
        pass

    @property
    def Png24(
      self
    ) -> TGIS_ContentType: 
        """
        Png24 image.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContentType.Png24
        """
        pass

    @property
    def Binary(
      self
    ) -> TGIS_ContentType: 
        """
        Binary.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ContentType.Binary
        """
        pass

class TGIS_VariantType:
    pass

class TGIS_VariantType:
    """
    Simplified variant types. Used by to GetVariantType() to simplify variant test by 
    grouping similar types.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantType
    """

    @property
    def Unknown(
      self
    ) -> TGIS_VariantType: 
        """
        

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantType.Unknown
        """
        pass

    @property
    def Unsupported(
      self
    ) -> TGIS_VariantType: 
        """
        

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantType.Unsupported
        """
        pass

    @property
    def Nothing(
      self
    ) -> TGIS_VariantType: 
        """
        

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantType.Nothing
        """
        pass

    @property
    def Int(
      self
    ) -> TGIS_VariantType: 
        """
        

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantType.Int
        """
        pass

    @property
    def UInt(
      self
    ) -> TGIS_VariantType: 
        """
        

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantType.UInt
        """
        pass

    @property
    def Int64(
      self
    ) -> TGIS_VariantType: 
        """
        

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantType.Int64
        """
        pass

    @property
    def UInt64(
      self
    ) -> TGIS_VariantType: 
        """
        

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantType.UInt64
        """
        pass

    @property
    def Float(
      self
    ) -> TGIS_VariantType: 
        """
        

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantType.Float
        """
        pass

    @property
    def Fixed(
      self
    ) -> TGIS_VariantType: 
        """
        

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantType.Fixed
        """
        pass

    @property
    def DateTime(
      self
    ) -> TGIS_VariantType: 
        """
        

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantType.DateTime
        """
        pass

    @property
    def Boolean(
      self
    ) -> TGIS_VariantType: 
        """
        

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantType.Boolean
        """
        pass

    @property
    def AnsiString(
      self
    ) -> TGIS_VariantType: 
        """
        

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantType.AnsiString
        """
        pass

    @property
    def WideString(
      self
    ) -> TGIS_VariantType: 
        """
        

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantType.WideString
        """
        pass

class TGIS_DeveloperKernelTypes:
    pass

class TGIS_DeveloperKernelTypes:
    """
    Type of DK compilation - for internal use mainly.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DeveloperKernelTypes
    """

    @property
    def DELPHI(
      self
    ) -> TGIS_DeveloperKernelTypes: 
        """
        DK was compiled as Embarcadero Delphi/C++ Builder.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DeveloperKernelTypes.DELPHI
        """
        pass

    @property
    def ACTIVEX(
      self
    ) -> TGIS_DeveloperKernelTypes: 
        """
        DK was compiled as ActiveX.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DeveloperKernelTypes.ACTIVEX
        """
        pass

    @property
    def NET(
      self
    ) -> TGIS_DeveloperKernelTypes: 
        """
        DK was compiled as CLR.NET

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DeveloperKernelTypes.NET
        """
        pass

    @property
    def JAVA(
      self
    ) -> TGIS_DeveloperKernelTypes: 
        """
        DK was compiled as Java bytecode

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DeveloperKernelTypes.JAVA
        """
        pass

    @property
    def SERVER(
      self
    ) -> TGIS_DeveloperKernelTypes: 
        """
        DK was compiled as a Server Application.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DeveloperKernelTypes.SERVER
        """
        pass

class TGIS_FileType:
    pass

class TGIS_FileType:
    """
    Supported files types.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileType
    """

    @property
    def All(
      self
    ) -> TGIS_FileType: 
        """
        All supported files.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileType.All
        """
        pass

    @property
    def Project(
      self
    ) -> TGIS_FileType: 
        """
        Project files (.ttkproject, .ttkgp, etc.)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileType.Project
        """
        pass

    @property
    def Vector(
      self
    ) -> TGIS_FileType: 
        """
        Vector files (.shp etc.)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileType.Vector
        """
        pass

    @property
    def Pixel(
      self
    ) -> TGIS_FileType: 
        """
        Pixel files (.bmp etc.)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileType.Pixel
        """
        pass

    @property
    def Grid(
      self
    ) -> TGIS_FileType: 
        """
        Grid files (.grd etc.)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileType.Grid
        """
        pass

    @property
    def Vector3D(
      self
    ) -> TGIS_FileType: 
        """
        Vector 3D layer (.ply etc.)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FileType.Vector3D
        """
        pass

class TGIS_FieldType:
    pass

class TGIS_FieldType:
    """
    Supported field types.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldType
    """

    @property
    def String(
      self
    ) -> TGIS_FieldType: 
        """
        Field is a String.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldType.String
        """
        pass

    @property
    def Number(
      self
    ) -> TGIS_FieldType: 
        """
        Field is a number.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldType.Number
        """
        pass

    @property
    def Float(
      self
    ) -> TGIS_FieldType: 
        """
        Field is a float.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldType.Float
        """
        pass

    @property
    def Boolean(
      self
    ) -> TGIS_FieldType: 
        """
        Field is a boolean.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldType.Boolean
        """
        pass

    @property
    def Date(
      self
    ) -> TGIS_FieldType: 
        """
        Field is a date.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldType.Date
        """
        pass

class TGIS_FieldFlags:
    pass

class TGIS_FieldFlags:
    """
    Supported field flags.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldFlags
    """

    @property
    def Exportable(
      self
    ) -> TGIS_FieldFlags: 
        """
        Is field exportable.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldFlags.Exportable
        """
        pass

    @property
    def Saveable(
      self
    ) -> TGIS_FieldFlags: 
        """
        Is field saveable.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldFlags.Saveable
        """
        pass

    @property
    def ReadOnly(
      self
    ) -> TGIS_FieldFlags: 
        """
        Is field read only.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldFlags.ReadOnly
        """
        pass

    @property
    def Visible(
      self
    ) -> TGIS_FieldFlags: 
        """
        Is field visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldFlags.Visible
        """
        pass

    @property
    def Required(
      self
    ) -> TGIS_FieldFlags: 
        """
        Is field required.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FieldFlags.Required
        """
        pass

class TGIS_LayerSaveOptions:
    pass

class TGIS_LayerSaveOptions:
    """
    Layer save options.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSaveOptions
    """

    @property
    def ParamsAsAttributes(
      self
    ) -> TGIS_LayerSaveOptions: 
        """
        save to field attributes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSaveOptions.ParamsAsAttributes
        """
        pass

    @property
    def ParamsWithShape(
      self
    ) -> TGIS_LayerSaveOptions: 
        """
        save to a shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSaveOptions.ParamsWithShape
        """
        pass

    @property
    def TextLabelsForce(
      self
    ) -> TGIS_LayerSaveOptions: 
        """
        text labels always as text.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSaveOptions.TextLabelsForce
        """
        pass

    @property
    def TextLabelsSmart(
      self
    ) -> TGIS_LayerSaveOptions: 
        """
        text labels as text if labels not empty.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSaveOptions.TextLabelsSmart
        """
        pass

    @property
    def TextLabelsAsPoints(
      self
    ) -> TGIS_LayerSaveOptions: 
        """
        text labels always as points/markers .

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerSaveOptions.TextLabelsAsPoints
        """
        pass

class TGIS_Viewer3DMode:
    pass

class TGIS_Viewer3DMode:
    """
    Basic modes of TGIS_Viewer3D operations:

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DMode
    """

    @property
    def CameraPosition(
      self
    ) -> TGIS_Viewer3DMode: 
        """
        Mouse is in camera positioning mode (scene rotation).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DMode.CameraPosition
        """
        pass

    @property
    def CameraXYZ(
      self
    ) -> TGIS_Viewer3DMode: 
        """
        Mouse is in dragging mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DMode.CameraXYZ
        """
        pass

    @property
    def CameraXY(
      self
    ) -> TGIS_Viewer3DMode: 
        """
        Mouse is in dragging mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DMode.CameraXY
        """
        pass

    @property
    def CameraRotation(
      self
    ) -> TGIS_Viewer3DMode: 
        """
        Mouse is in camera rotating mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DMode.CameraRotation
        """
        pass

    @property
    def SunPosition(
      self
    ) -> TGIS_Viewer3DMode: 
        """
        Mouse is in sun positioning mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DMode.SunPosition
        """
        pass

    @property
    def Zoom(
      self
    ) -> TGIS_Viewer3DMode: 
        """
        Mouse is in zooming mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DMode.Zoom
        """
        pass

    @property
    def Select(
      self
    ) -> TGIS_Viewer3DMode: 
        """
        Mouse is in select mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DMode.Select
        """
        pass

class TGIS_3DLayerType:
    pass

class TGIS_3DLayerType:
    """
    3D interpretation mode for layer (for 3D mode only).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DLayerType
    """

    @property
    def Off(
      self
    ) -> TGIS_3DLayerType: 
        """
        Layer does not represent 3D content.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DLayerType.Off
        """
        pass

    @property
    def Dem(
      self
    ) -> TGIS_3DLayerType: 
        """
        Layer should be interpreted as terrain model.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DLayerType.Dem
        """
        pass

    @property
    def Shapes(
      self
    ) -> TGIS_3DLayerType: 
        """
        Layer should be interpreted as 3D objects.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DLayerType.Shapes
        """
        pass

class TGIS_3DGroundType:
    pass

class TGIS_3DGroundType:
    """
    Z value relations enforcement (for 3D mode only).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DGroundType
    """

    @property
    def AboveZero(
      self
    ) -> TGIS_3DGroundType: 
        """
        3D objects should be presented as relative to 0.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DGroundType.AboveZero
        """
        pass

    @property
    def AboveDem(
      self
    ) -> TGIS_3DGroundType: 
        """
        3D objects should be offset by an actual terrain model value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DGroundType.AboveDem
        """
        pass

    @property
    def OnDem(
      self
    ) -> TGIS_3DGroundType: 
        """
        3D objects should be laid on terrain (Z values will be ignored).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DGroundType.OnDem
        """
        pass

class TGIS_3DBasementType:
    pass

class TGIS_3DBasementType:
    """
    Shape on DEM basement enforcement (for 3D mode only).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DBasementType
    """

    @property
    def Off(
      self
    ) -> TGIS_3DBasementType: 
        """
        3D objects basement will take Z value from DEM.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DBasementType.Off
        """
        pass

    @property
    def Lowest(
      self
    ) -> TGIS_3DBasementType: 
        """
        3D objects basement level will have Z equal to the lowest value of object basement.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DBasementType.Lowest
        """
        pass

class TGIS_3DNormalizationType:
    pass

class TGIS_3DNormalizationType:
    """
    Types of 3D Normalization.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DNormalizationType
    """

    @property
    def Off(
      self
    ) -> TGIS_3DNormalizationType: 
        """
        No normalization.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DNormalizationType.Off
        """
        pass

    @property
    def Max(
      self
    ) -> TGIS_3DNormalizationType: 
        """
        Normalization to max layer value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DNormalizationType.Max
        """
        pass

    @property
    def Range(
      self
    ) -> TGIS_3DNormalizationType: 
        """
        Normalization to layer range value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DNormalizationType.Range
        """
        pass

class TGIS_LayerPixelInterpretation:
    pass

class TGIS_LayerPixelInterpretation:
    """
    Definition of layer interpretation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelInterpretation
    """

    @property
    def Default(
      self
    ) -> TGIS_LayerPixelInterpretation: 
        """
        Image as recognized (pixel or grid)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelInterpretation.Default
        """
        pass

    @property
    def Pixel(
      self
    ) -> TGIS_LayerPixelInterpretation: 
        """
        Forced to ARGB image

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelInterpretation.Pixel
        """
        pass

    @property
    def Grid(
      self
    ) -> TGIS_LayerPixelInterpretation: 
        """
        Forced to grid (DEM) image.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelInterpretation.Grid
        """
        pass

class TGIS_RegisteredLayerType:
    pass

class TGIS_RegisteredLayerType:
    """
    Registered layer type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RegisteredLayerType
    """

    @property
    def Vector(
      self
    ) -> TGIS_RegisteredLayerType: 
        """
        vector layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RegisteredLayerType.Vector
        """
        pass

    @property
    def Pixel(
      self
    ) -> TGIS_RegisteredLayerType: 
        """
        pixel layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RegisteredLayerType.Pixel
        """
        pass

    @property
    def Grid(
      self
    ) -> TGIS_RegisteredLayerType: 
        """
        grid layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RegisteredLayerType.Grid
        """
        pass

    @property
    def Project(
      self
    ) -> TGIS_RegisteredLayerType: 
        """
        project layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RegisteredLayerType.Project
        """
        pass

    @property
    def Vector3D(
      self
    ) -> TGIS_RegisteredLayerType: 
        """
        Vector 3D layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RegisteredLayerType.Vector3D
        """
        pass

class TGIS_RendererMultipassMode:
    pass

class TGIS_RendererMultipassMode:
    """
    Mode of multipass shape rendering. Used for nice street junction drawing. Used by 
    TGIS_Shape.Draw.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererMultipassMode
    """

    @property
    def Line(
      self
    ) -> TGIS_RendererMultipassMode: 
        """
        Draw only line itself.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererMultipassMode.Line
        """
        pass

    @property
    def Outline(
      self
    ) -> TGIS_RendererMultipassMode: 
        """
        Draw only outline .

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererMultipassMode.Outline
        """
        pass

    @property
    def Single(
      self
    ) -> TGIS_RendererMultipassMode: 
        """
        Draw shape line single step.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RendererMultipassMode.Single
        """
        pass

class TGIS_ListOfIntegers:
    """
    Alias for TList&lt;Integer&gt;.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfIntegers
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfIntegers.Create_void
        """
        pass

    def Add(
      self,
      _item: int
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfIntegers.Add_Integer
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfIntegers.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfIntegers.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfIntegers.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> int: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfIntegers.Item
        """
        pass

class TGIS_ListOfDoubles:
    """
    Alias for TList&lt;Double&gt;.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfDoubles
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfDoubles.Create_void
        """
        pass

    def Add(
      self,
      _item: float
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfDoubles.Add_Double
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfDoubles.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfDoubles.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfDoubles.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> float: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfDoubles.Item
        """
        pass

class TGIS_ListOfStrings:
    """
    Alias for TList&lt;String&gt;.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfStrings
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfStrings.Create_void
        """
        pass

    def Add(
      self,
      _item: str
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfStrings.Add_String
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfStrings.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfStrings.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfStrings.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> str: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfStrings.Item
        """
        pass

class TGIS_ListOfVariants:
    """
    Alias for TList&lt;Variant&gt;.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfVariants
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfVariants.Create_void
        """
        pass

    def Add(
      self,
      _item: Variant
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfVariants.Add_Variant
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfVariants.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfVariants.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfVariants.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> Variant: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ListOfVariants.Item
        """
        pass

class TGIS_Strings:
    """
    Alias for TListStrings.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Strings
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Strings.Create_void
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Strings.Clear_void
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Strings.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> str: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Strings.Item
        """
        pass

class TGIS_StringList( TGIS_Strings ):
    """
    List of Strings.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> String:
        pass

    def __setitem__(
      self,
      index : int,
      value : String
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Create_void
        """
        pass

    def Add(
      self,
      _item: str
    ) -> int: 
        """
        Add a text to the list.

        Args:
            _item: text to be added

        Returns:
            position on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Add_String
        """
        pass

    def AddObject(
      self,
      _item: str,
      _object: TObject
    ) -> int: 
        """
        Add an objet to the list.

        Args:
            _item: text to be added
            _object: object to be added

        Returns:
            position on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.AddObject_String_TObject
        """
        pass

    def AddStrings(
      self,
      _list: TGIS_StringList
    ) -> None: 
        """
        Add string list to the list

        Args:
            _list: list to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.AddStrings_TGIS_StringList
        """
        pass

    def Append(
      self,
      _item: str
    ) -> None: 
        """
        Append element to the list

        Args:
            _item: text to be appended

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Append_String
        """
        pass

    def Assign(
      self,
      _list: TGIS_StringList
    ) -> None: 
        """
        Assign elements for outher list.

        Args:
            _list: list to be assigned.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Assign_TGIS_StringList
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Delete_Integer
        """
        pass

    def Exchange(
      self,
      _index1: int,
      _index2: int
    ) -> None: 
        """
        Swap two items on the list.

        Args:
            _index1: index of the first item
            _index2: index of the second item

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Exchange_Integer_Integer
        """
        pass

    def IndexOf(
      self,
      _item: str
    ) -> int: 
        """
        Find element on the list.

        Args:
            _item: text to be found

        Returns:
            position on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.IndexOf_String
        """
        pass

    def IndexOfName(
      self,
      _item: str
    ) -> int: 
        """
        Find element on the list.

        Args:
            _item: name to be found (as name-value)

        Returns:
            position on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.IndexOfName_String
        """
        pass

    def Insert(
      self,
      _index: int,
      _item: str
    ) -> None: 
        """
        Insrt a text to the list.

        Args:
            _index: pssition at which new leemnet should be added.
            _item: text to be inserted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Insert_Integer_String
        """
        pass

    def LoadFromFile(
      self,
      _path: str
    ) -> None: 
        """
        Load the list from a file.

        Args:
            _path: file path

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.LoadFromFile_String
        """
        pass

    def LoadFromStream(
      self,
      _stream: TStream
    ) -> None: 
        """
        Load the list from a stream.

        Args:
            _stream: stream object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.LoadFromStream_TStream
        """
        pass

    def SaveToFile(
      self,
      _path: str
    ) -> None: 
        """
        Save the list to a file.

        Args:
            _path: file path

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.SaveToFile_String
        """
        pass

    def SaveToStream(
      self,
      _stream: TStream
    ) -> None: 
        """
        Save the list to a stream.

        Args:
            _stream: stream object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.SaveToStream_TStream
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Count
        """
        pass

    @property
    def DelimitedText(
      self
    ) -> str: 
        """
        List as a delimited text.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.DelimitedText
        """
        pass

    @DelimitedText.setter
    def DelimitedText(
      self,
      _value: str
    ) -> None: 
        """
        List as a delimited text.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.DelimitedText
        """
        pass

    @property
    def Delimiter(
      self
    ) -> char: 
        """
        Default name=value delimiter character.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Delimiter
        """
        pass

    @Delimiter.setter
    def Delimiter(
      self,
      _value: char
    ) -> None: 
        """
        Default name=value delimiter character.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Delimiter
        """
        pass

    @property
    def Duplicates(
      self
    ) -> TDuplicates: 
        """
        Allows duuplicated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Duplicates
        """
        pass

    @Duplicates.setter
    def Duplicates(
      self,
      _value: TDuplicates
    ) -> None: 
        """
        Allows duuplicated.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Duplicates
        """
        pass

    
    def Names(
      self,
      _index: int
    ) -> str: 
        """
        Names on the list.

        Args:
            _index: item index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Names
        """
        pass

    
    def Objects(
      self,
      _index: int
    ) -> TObject: 
        """
        Objects on the list.

        Args:
            _index: item index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Objects
        """
        pass

    
    def Objects(
      self,
      _index: int,
      _value: TObject
    ) -> None: 
        """
        Objects on the list.

        Args:
            _index: item index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Objects
        """
        pass

    @property
    def QuoteChar(
      self
    ) -> char: 
        """
        Default quate character.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.QuoteChar
        """
        pass

    @property
    def Sorted(
      self
    ) -> bool: 
        """
        Auto sort a list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Sorted
        """
        pass

    @Sorted.setter
    def Sorted(
      self,
      _value: bool
    ) -> None: 
        """
        Auto sort a list.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Sorted
        """
        pass

    @property
    def StrictDelimiter(
      self
    ) -> bool: 
        """
        Strict delimter treatment.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.StrictDelimiter
        """
        pass

    @StrictDelimiter.setter
    def StrictDelimiter(
      self,
      _value: bool
    ) -> None: 
        """
        Strict delimter treatment.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.StrictDelimiter
        """
        pass

    
    def Strings(
      self,
      _index: int
    ) -> str: 
        """
        Strings on the list.

        Args:
            _index: item index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Strings
        """
        pass

    
    def Strings(
      self,
      _index: int,
      _value: str
    ) -> None: 
        """
        Strings on the list.

        Args:
            _index: item index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Strings
        """
        pass

    @property
    def Text(
      self
    ) -> str: 
        """
        List as a text.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Text
        """
        pass

    @Text.setter
    def Text(
      self,
      _value: str
    ) -> None: 
        """
        List as a text.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Text
        """
        pass

    
    def ValueFromIndex(
      self,
      _index: int
    ) -> str: 
        """
        Values on the list.

        Args:
            _index: item index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.ValueFromIndex
        """
        pass

    
    def Values(
      self,
      _name: str
    ) -> str: 
        """
        Values on the list.

        Args:
            _name: name index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Values
        """
        pass

    
    def Values(
      self,
      _name: str,
      _value: str
    ) -> None: 
        """
        Values on the list.

        Args:
            _name: name index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_StringList.Values
        """
        pass

class TGIS_ObjectList:
    """
    List of generic objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ObjectList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TObject:
        pass

    def __setitem__(
      self,
      index : int,
      value : TObject
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ObjectList.Create_void
        """
        pass

    def Add(
      self,
      _item: TObject
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ObjectList.Add_TObject
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ObjectList.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ObjectList.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ObjectList.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> TObject: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ObjectList.Item
        """
        pass

class TGIS_LayerInfoList:
    """
    List of TGIS_LayerInfo objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfoList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_LayerInfo:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_LayerInfo
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfoList.Create_void
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfoList.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> TGIS_LayerInfo: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfoList.Item
        """
        pass

class TGIS_LayerPixelSubFormatList:
    """
    List of TGIS_LayerPixelSubFormat objects.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSubFormatList
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_LayerPixelSubFormat:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_LayerPixelSubFormat
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSubFormatList.Create_void
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSubFormatList.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> TGIS_LayerPixelSubFormat: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSubFormatList.Item
        """
        pass

class TGIS_LayerInfo:
    """
    Class storing a basic layer information.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo
    """

    @overload
    def __init__(
      self,
      _name: str,
      _caption: str,
      _layerType: TGIS_RegisteredLayerType,
      _shapeType: TGIS_ShapeType,
      _pixelType: TGIS_PixelSubFormat,
      _extended: TObject
    ) -> None: 
        """
        Constructor.

        Args:
            _name: Layer name.
            _caption: Layer caption.
            _layerType: Layer type.
            _shapeType: Shape type of a layer, if is vector.
            _pixelType: Image type of a layer, if is pixel.
            _extended: Extended data object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.Create_String_String_TGIS_RegisteredLayerType_TGIS_ShapeType_TGIS_PixelSubFormat_TObject
        """
        pass

    @overload
    def __init__(
      self,
      _name: str,
      _caption: str,
      _layerType: TGIS_RegisteredLayerType,
      _shapeType: TGIS_ShapeType,
      _pixelType: TGIS_PixelSubFormat,
      _extended: TObject,
      _featureCount: TGIS_Uid
    ) -> None: 
        """
        Constructor.

        Args:
            _name: Layer name.
            _caption: Layer caption.
            _layerType: Layer type.
            _shapeType: Shape type of a layer, if is vector.
            _pixelType: Image type of a layer, if is pixel.
            _extended: Extended data object.
            _featureCount: Number of features, if is vector.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.Create_String_String_TGIS_RegisteredLayerType_TGIS_ShapeType_TGIS_PixelSubFormat_TObject_TGIS_Uid
        """
        pass

    @overload
    def __init__(
      self,
      _name: str,
      _layerType: TGIS_RegisteredLayerType,
      _shapeType: TGIS_ShapeType
    ) -> None: 
        """
        Constructor.

        Args:
            _name: Layer name.
            _layerType: Layer type.
            _shapeType: Shape type of a layer, if is vector.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.Create_String_TGIS_RegisteredLayerType_TGIS_ShapeType
        """
        pass

    @overload
    def __init__(
      self,
      _name: str,
      _layerType: TGIS_RegisteredLayerType,
      _shapeType: TGIS_ShapeType,
      _featureCount: TGIS_Uid
    ) -> None: 
        """
        Constructor.

        Args:
            _name: Layer name.
            _layerType: Layer type.
            _shapeType: Shape type of a layer, if is vector.
            _featureCount: Number of features, if is vector.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.Create_String_TGIS_RegisteredLayerType_TGIS_ShapeType_TGIS_Uid
        """
        pass

    @property
    def Caption(
      self
    ) -> str: 
        """
        Layer caption

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.Caption
        """
        pass

    @Caption.setter
    def Caption(
      self,
      _value: str
    ) -> None: 
        """
        Layer caption

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.Caption
        """
        pass

    @property
    def ExtendedTag(
      self
    ) -> TObject: 
        """
        Extended data object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.ExtendedTag
        """
        pass

    @ExtendedTag.setter
    def ExtendedTag(
      self,
      _value: TObject
    ) -> None: 
        """
        Extended data object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.ExtendedTag
        """
        pass

    @property
    def FeatureCount(
      self
    ) -> TGIS_Uid: 
        """
        Number of vector features. if unknown then -1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.FeatureCount
        """
        pass

    @FeatureCount.setter
    def FeatureCount(
      self,
      _value: TGIS_Uid
    ) -> None: 
        """
        Number of vector features. if unknown then -1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.FeatureCount
        """
        pass

    @property
    def LayerType(
      self
    ) -> TGIS_RegisteredLayerType: 
        """
        Layer type (vector or pixel).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.LayerType
        """
        pass

    @LayerType.setter
    def LayerType(
      self,
      _value: TGIS_RegisteredLayerType
    ) -> None: 
        """
        Layer type (vector or pixel).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.LayerType
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Layer name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.Name
        """
        pass

    @Name.setter
    def Name(
      self,
      _value: str
    ) -> None: 
        """
        Layer name.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.Name
        """
        pass

    @property
    def PixelType(
      self
    ) -> TGIS_PixelSubFormat: 
        """
        Image type of a layer, if is pixel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.PixelType
        """
        pass

    @PixelType.setter
    def PixelType(
      self,
      _value: TGIS_PixelSubFormat
    ) -> None: 
        """
        Image type of a layer, if is pixel.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.PixelType
        """
        pass

    @property
    def ShapeType(
      self
    ) -> TGIS_ShapeType: 
        """
        Shape type of a layer, if is vector.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.ShapeType
        """
        pass

    @ShapeType.setter
    def ShapeType(
      self,
      _value: TGIS_ShapeType
    ) -> None: 
        """
        Shape type of a layer, if is vector.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerInfo.ShapeType
        """
        pass

class TGIS_Point:
    """
    Like TPoint, but based on doubles instead of integers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point.Create_void
        """
        pass

    @property
    def X(
      self
    ) -> float: 
        """
        horizontal position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point.X
        """
        pass

    @X.setter
    def X(
      self,
      _value: float
    ) -> None: 
        """
        horizontal position

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point.X
        """
        pass

    @property
    def Y(
      self
    ) -> float: 
        """
        vertical position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point.Y
        """
        pass

    @Y.setter
    def Y(
      self,
      _value: float
    ) -> None: 
        """
        vertical position

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point.Y
        """
        pass

class TGIS_Point3D:
    """
    Like TGIS_Point, but 3rd dimension (Z) and measure (M) added.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3D
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3D.Create_void
        """
        pass

    @property
    def X(
      self
    ) -> float: 
        """
        horizontal position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3D.X
        """
        pass

    @X.setter
    def X(
      self,
      _value: float
    ) -> None: 
        """
        horizontal position

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3D.X
        """
        pass

    @property
    def Y(
      self
    ) -> float: 
        """
        vertical position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3D.Y
        """
        pass

    @Y.setter
    def Y(
      self,
      _value: float
    ) -> None: 
        """
        vertical position

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3D.Y
        """
        pass

    @property
    def Z(
      self
    ) -> float: 
        """
        altitude

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3D.Z
        """
        pass

    @Z.setter
    def Z(
      self,
      _value: float
    ) -> None: 
        """
        altitude

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3D.Z
        """
        pass

    @property
    def M(
      self
    ) -> float: 
        """
        measure

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3D.M
        """
        pass

    @M.setter
    def M(
      self,
      _value: float
    ) -> None: 
        """
        measure

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3D.M
        """
        pass

class TGIS_Extent:
    """
    Like TRect, but based on doubles instead of integers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent.Create_void
        """
        pass

    @property
    def XMin(
      self
    ) -> float: 
        """
        left border

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent.XMin
        """
        pass

    @XMin.setter
    def XMin(
      self,
      _value: float
    ) -> None: 
        """
        left border

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent.XMin
        """
        pass

    @property
    def YMin(
      self
    ) -> float: 
        """
        bottom border

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent.YMin
        """
        pass

    @YMin.setter
    def YMin(
      self,
      _value: float
    ) -> None: 
        """
        bottom border

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent.YMin
        """
        pass

    @property
    def XMax(
      self
    ) -> float: 
        """
        right border

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent.XMax
        """
        pass

    @XMax.setter
    def XMax(
      self,
      _value: float
    ) -> None: 
        """
        right border

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent.XMax
        """
        pass

    @property
    def YMax(
      self
    ) -> float: 
        """
        top border

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent.YMax
        """
        pass

    @YMax.setter
    def YMax(
      self,
      _value: float
    ) -> None: 
        """
        top border

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent.YMax
        """
        pass

class TGIS_Extent3D:
    """
    Like TGIS_Extent, but 3rd dimension added.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.Create_void
        """
        pass

    @property
    def XMin(
      self
    ) -> float: 
        """
        left border

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.XMin
        """
        pass

    @XMin.setter
    def XMin(
      self,
      _value: float
    ) -> None: 
        """
        left border

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.XMin
        """
        pass

    @property
    def YMin(
      self
    ) -> float: 
        """
        bottom border

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.YMin
        """
        pass

    @YMin.setter
    def YMin(
      self,
      _value: float
    ) -> None: 
        """
        bottom border

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.YMin
        """
        pass

    @property
    def ZMin(
      self
    ) -> float: 
        """
        height border

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.ZMin
        """
        pass

    @ZMin.setter
    def ZMin(
      self,
      _value: float
    ) -> None: 
        """
        height border

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.ZMin
        """
        pass

    @property
    def MMin(
      self
    ) -> float: 
        """
        value border

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.MMin
        """
        pass

    @MMin.setter
    def MMin(
      self,
      _value: float
    ) -> None: 
        """
        value border

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.MMin
        """
        pass

    @property
    def XMax(
      self
    ) -> float: 
        """
        right border

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.XMax
        """
        pass

    @XMax.setter
    def XMax(
      self,
      _value: float
    ) -> None: 
        """
        right border

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.XMax
        """
        pass

    @property
    def YMax(
      self
    ) -> float: 
        """
        top border

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.YMax
        """
        pass

    @YMax.setter
    def YMax(
      self,
      _value: float
    ) -> None: 
        """
        top border

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.YMax
        """
        pass

    @property
    def ZMax(
      self
    ) -> float: 
        """
        height border

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.ZMax
        """
        pass

    @ZMax.setter
    def ZMax(
      self,
      _value: float
    ) -> None: 
        """
        height border

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.ZMax
        """
        pass

    @property
    def MMax(
      self
    ) -> float: 
        """
        value border

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.MMax
        """
        pass

    @MMax.setter
    def MMax(
      self,
      _value: float
    ) -> None: 
        """
        value border

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Extent3D.MMax
        """
        pass

class TGIS_Line:
    """
    Line between two points.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Line
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Line.Create_void
        """
        pass

    @property
    def A(
      self
    ) -> TGIS_Point: 
        """
        begin point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Line.A
        """
        pass

    @A.setter
    def A(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        begin point

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Line.A
        """
        pass

    @property
    def B(
      self
    ) -> TGIS_Point: 
        """
        end point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Line.B
        """
        pass

    @B.setter
    def B(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        end point

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Line.B
        """
        pass

class TGIS_Line3D:
    """
    Line between two 3D points.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Line3D
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Line3D.Create_void
        """
        pass

    @property
    def A(
      self
    ) -> TGIS_Point3D: 
        """
        begin point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Line3D.A
        """
        pass

    @A.setter
    def A(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        begin point

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Line3D.A
        """
        pass

    @property
    def B(
      self
    ) -> TGIS_Point3D: 
        """
        end point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Line3D.B
        """
        pass

    @B.setter
    def B(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        end point

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Line3D.B
        """
        pass

class TGIS_RGBTriple:
    """
    RGB color representation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RGBTriple
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RGBTriple.Create_void
        """
        pass

    @property
    def rgbtBlue(
      self
    ) -> int: 
        """
        Blue value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RGBTriple.rgbtBlue
        """
        pass

    @rgbtBlue.setter
    def rgbtBlue(
      self,
      _value: int
    ) -> None: 
        """
        Blue value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RGBTriple.rgbtBlue
        """
        pass

    @property
    def rgbtGreen(
      self
    ) -> int: 
        """
        Green value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RGBTriple.rgbtGreen
        """
        pass

    @rgbtGreen.setter
    def rgbtGreen(
      self,
      _value: int
    ) -> None: 
        """
        Green value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RGBTriple.rgbtGreen
        """
        pass

    @property
    def rgbtRed(
      self
    ) -> int: 
        """
        Red value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RGBTriple.rgbtRed
        """
        pass

    @rgbtRed.setter
    def rgbtRed(
      self,
      _value: int
    ) -> None: 
        """
        Red value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_RGBTriple.rgbtRed
        """
        pass

class TGIS_DrawBuf:
    """
    Array of Points for drawing purposes,

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawBuf
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TPoint:
        pass

    def __setitem__(
      self,
      index : int,
      value : TPoint
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawBuf.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawBuf.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawBuf.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> TPoint: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawBuf.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: TPoint
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawBuf.Value
        """
        pass

class TGIS_DrawBufF:
    """
    Array of PointsF for drawing purposes,

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawBufF
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TPointF:
        pass

    def __setitem__(
      self,
      index : int,
      value : TPointF
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawBufF.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawBufF.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawBufF.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> TPointF: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawBufF.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: TPointF
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DrawBufF.Value
        """
        pass

class TGIS_SingleArray:
    """
    Array of Single.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> Single:
        pass

    def __setitem__(
      self,
      index : int,
      value : Single
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleArray.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleArray.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleArray.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> float: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleArray.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: float
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleArray.Value
        """
        pass

class TGIS_DoubleArray:
    """
    Array of Double.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DoubleArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> Double:
        pass

    def __setitem__(
      self,
      index : int,
      value : Double
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DoubleArray.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DoubleArray.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DoubleArray.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> float: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DoubleArray.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: float
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DoubleArray.Value
        """
        pass

class TGIS_CardinalArray:
    """
    Array of Cardinal.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CardinalArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> Cardinal:
        pass

    def __setitem__(
      self,
      index : int,
      value : Cardinal
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CardinalArray.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CardinalArray.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CardinalArray.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> int: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CardinalArray.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: int
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CardinalArray.Value
        """
        pass

class TGIS_IntegerArray:
    """
    Array of Integer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IntegerArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> Integer:
        pass

    def __setitem__(
      self,
      index : int,
      value : Integer
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IntegerArray.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IntegerArray.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IntegerArray.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> int: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IntegerArray.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: int
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IntegerArray.Value
        """
        pass

class TGIS_ByteArray:
    """
    Array of Byte.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ByteArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> Byte:
        pass

    def __setitem__(
      self,
      index : int,
      value : Byte
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ByteArray.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ByteArray.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ByteArray.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> int: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ByteArray.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: int
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ByteArray.Value
        """
        pass

class TGIS_VariantArray:
    """
    Array of Variant.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> Variant:
        pass

    def __setitem__(
      self,
      index : int,
      value : Variant
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantArray.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantArray.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantArray.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> Variant: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantArray.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: Variant
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_VariantArray.Value
        """
        pass

class TGIS_CharArray:
    """
    Array of Chars.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CharArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> Char:
        pass

    def __setitem__(
      self,
      index : int,
      value : Char
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CharArray.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CharArray.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CharArray.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> char: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CharArray.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: char
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_CharArray.Value
        """
        pass

class TGIS_PointArray:
    """
    Array of TGIS_Point2D

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_Point:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_Point
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointArray.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointArray.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointArray.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> TGIS_Point: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointArray.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: TGIS_Point
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PointArray.Value
        """
        pass

class TGIS_Point3DArray:
    """
    Array of TGIS_Point3D

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3DArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_Point3D:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_Point3D
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3DArray.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3DArray.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3DArray.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> TGIS_Point3D: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3DArray.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: TGIS_Point3D
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Point3DArray.Value
        """
        pass

class TGIS_IntegerGridArray:
    """
    Array of Array of Integer

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IntegerGridArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_IntegerArray:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_IntegerArray
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IntegerGridArray.Create_void
        """
        pass

    def SetSize(
      self,
      _rows: int,
      _columns: int
    ) -> None: 
        """
        Set array size.

        Args:
            _rows: number of rows
            _columns: number of columns

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IntegerGridArray.SetSize_Integer_Integer
        """
        pass

    @property
    def Columns(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IntegerGridArray.Columns
        """
        pass

    @property
    def Rows(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IntegerGridArray.Rows
        """
        pass

    
    def Value(
      self,
      _row: int,
      _col: int
    ) -> int: 
        """
        Array element value.

        Args:
            _row: row index
            _col: column index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IntegerGridArray.Value
        """
        pass

    
    def Value(
      self,
      _row: int,
      _col: int,
      _value: int
    ) -> None: 
        """
        Array element value.

        Args:
            _row: row index
            _col: column index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_IntegerGridArray.Value
        """
        pass

class TGIS_GridArray:
    """
    Array of Array of Single (array of grid image lines- point[row][column]).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_SingleArray:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_SingleArray
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridArray.Create_void
        """
        pass

    def SetSize(
      self,
      _rows: int,
      _columns: int
    ) -> None: 
        """
        Set array size.

        Args:
            _rows: number of rows
            _columns: number of columns

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridArray.SetSize_Integer_Integer
        """
        pass

    @property
    def Columns(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridArray.Columns
        """
        pass

    @property
    def Rows(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridArray.Rows
        """
        pass

    
    def Value(
      self,
      _row: int,
      _col: int
    ) -> float: 
        """
        Array element value.

        Args:
            _row: 
            _col: raw index

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridArray.Value
        """
        pass

    
    def Value(
      self,
      _row: int,
      _col: int,
      _value: float
    ) -> None: 
        """
        Array element value.

        Args:
            _row: 
            _col: raw index

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridArray.Value
        """
        pass

class TGIS_UidArray:
    """
    Array of Uids

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_UidArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_Uid:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_Uid
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_UidArray.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_UidArray.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_UidArray.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> TGIS_Uid: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_UidArray.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: TGIS_Uid
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_UidArray.Value
        """
        pass

class TGIS_Matrix3x3:
    """
    Matrix type.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Matrix3x3
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_DoubleArray:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_DoubleArray
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Matrix3x3.Create_void
        """
        pass

    
    def Value(
      self,
      _col: int,
      _row: int
    ) -> float: 
        """
        Array element value.

        Args:
            _col: index of the element
            _row: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Matrix3x3.Value
        """
        pass

    
    def Value(
      self,
      _col: int,
      _row: int,
      _value: float
    ) -> None: 
        """
        Array element value.

        Args:
            _col: index of the element
            _row: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Matrix3x3.Value
        """
        pass

class TGIS_Complex:
    """
    Complex number.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Complex
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Complex.Create_void
        """
        pass

    @property
    def r(
      self
    ) -> float: 
        """
        real part.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Complex.r
        """
        pass

    @r.setter
    def r(
      self,
      _value: float
    ) -> None: 
        """
        real part.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Complex.r
        """
        pass

    @property
    def i(
      self
    ) -> float: 
        """
        imaginary part.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Complex.i
        """
        pass

    @i.setter
    def i(
      self,
      _value: float
    ) -> None: 
        """
        imaginary part.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Complex.i
        """
        pass

class TGIS_SingleVector:
    """
    Single type vector.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleVector
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleVector.Create_void
        """
        pass

    @property
    def X(
      self
    ) -> float: 
        """
        X value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleVector.X
        """
        pass

    @X.setter
    def X(
      self,
      _value: float
    ) -> None: 
        """
        X value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleVector.X
        """
        pass

    @property
    def Y(
      self
    ) -> float: 
        """
        Y value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleVector.Y
        """
        pass

    @Y.setter
    def Y(
      self,
      _value: float
    ) -> None: 
        """
        Y value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleVector.Y
        """
        pass

    @property
    def Z(
      self
    ) -> float: 
        """
        Z value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleVector.Z
        """
        pass

    @Z.setter
    def Z(
      self,
      _value: float
    ) -> None: 
        """
        Z value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleVector.Z
        """
        pass

class TGIS_SingleColor:
    """
    Single type color.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleColor
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleColor.Create_void
        """
        pass

    @property
    def r(
      self
    ) -> float: 
        """
        Red value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleColor.r
        """
        pass

    @r.setter
    def r(
      self,
      _value: float
    ) -> None: 
        """
        Red value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleColor.r
        """
        pass

    @property
    def g(
      self
    ) -> float: 
        """
        Green value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleColor.g
        """
        pass

    @g.setter
    def g(
      self,
      _value: float
    ) -> None: 
        """
        Green value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleColor.g
        """
        pass

    @property
    def b(
      self
    ) -> float: 
        """
        Blue value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleColor.b
        """
        pass

    @b.setter
    def b(
      self,
      _value: float
    ) -> None: 
        """
        Blue value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleColor.b
        """
        pass

    @property
    def a(
      self
    ) -> float: 
        """
        Alpha value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleColor.a
        """
        pass

    @a.setter
    def a(
      self,
      _value: float
    ) -> None: 
        """
        Alpha value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleColor.a
        """
        pass

class TGIS_SingleVectorArray:
    """
    Single type vector array.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleVectorArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_SingleVector:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_SingleVector
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleVectorArray.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleVectorArray.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleVectorArray.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> TGIS_SingleVector: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleVectorArray.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: TGIS_SingleVector
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleVectorArray.Value
        """
        pass

class TGIS_SingleColorArray:
    """
    Single type color array.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleColorArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_SingleColor:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_SingleColor
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleColorArray.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleColorArray.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleColorArray.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> TGIS_SingleColor: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleColorArray.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: TGIS_SingleColor
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_SingleColorArray.Value
        """
        pass

class TGIS_Material:
    """
    Material.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Create_void
        """
        pass

    @property
    def CompressionType(
      self
    ) -> TGIS_CompressionType: 
        """
        Type of material compression.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.CompressionType
        """
        pass

    @CompressionType.setter
    def CompressionType(
      self,
      _value: TGIS_CompressionType
    ) -> None: 
        """
        Type of material compression.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.CompressionType
        """
        pass

    @property
    def HasColor(
      self
    ) -> bool: 
        """
        True if material has defined color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasColor
        """
        pass

    @HasColor.setter
    def HasColor(
      self,
      _value: bool
    ) -> None: 
        """
        True if material has defined color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasColor
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Fill Color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Fill Color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Color
        """
        pass

    @property
    def HasEdgeColor(
      self
    ) -> bool: 
        """
        True if material has defined edge color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasEdgeColor
        """
        pass

    @HasEdgeColor.setter
    def HasEdgeColor(
      self,
      _value: bool
    ) -> None: 
        """
        True if material has defined edge color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasEdgeColor
        """
        pass

    @property
    def EdgeColor(
      self
    ) -> TGIS_Color: 
        """
        Edge color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.EdgeColor
        """
        pass

    @EdgeColor.setter
    def EdgeColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Edge color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.EdgeColor
        """
        pass

    @property
    def HasEdgeWidth(
      self
    ) -> bool: 
        """
        True if material has defined edge width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasEdgeWidth
        """
        pass

    @HasEdgeWidth.setter
    def HasEdgeWidth(
      self,
      _value: bool
    ) -> None: 
        """
        True if material has defined edge width.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasEdgeWidth
        """
        pass

    @property
    def EdgeWidth(
      self
    ) -> int: 
        """
        Edge width [0-255].

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.EdgeWidth
        """
        pass

    @EdgeWidth.setter
    def EdgeWidth(
      self,
      _value: int
    ) -> None: 
        """
        Edge width [0-255].

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.EdgeWidth
        """
        pass

    @property
    def HasTransparency(
      self
    ) -> bool: 
        """
        True if material has defined transparency.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasTransparency
        """
        pass

    @HasTransparency.setter
    def HasTransparency(
      self,
      _value: bool
    ) -> None: 
        """
        True if material has defined transparency.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasTransparency
        """
        pass

    @property
    def Transparency(
      self
    ) -> int: 
        """
        Percent transparency [0-100].

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Transparency
        """
        pass

    @Transparency.setter
    def Transparency(
      self,
      _value: int
    ) -> None: 
        """
        Percent transparency [0-100].

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Transparency
        """
        pass

    @property
    def HasShininess(
      self
    ) -> bool: 
        """
        True if material has defined shininess.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasShininess
        """
        pass

    @HasShininess.setter
    def HasShininess(
      self,
      _value: bool
    ) -> None: 
        """
        True if material has defined shininess.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasShininess
        """
        pass

    @property
    def Shininess(
      self
    ) -> int: 
        """
        Percent shininess [0-100].

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Shininess
        """
        pass

    @Shininess.setter
    def Shininess(
      self,
      _value: int
    ) -> None: 
        """
        Percent shininess [0-100].

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Shininess
        """
        pass

    @property
    def HasTextureMap(
      self
    ) -> bool: 
        """
        True if material has defined texture map.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasTextureMap
        """
        pass

    @HasTextureMap.setter
    def HasTextureMap(
      self,
      _value: bool
    ) -> None: 
        """
        True if material has defined texture map.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasTextureMap
        """
        pass

    @property
    def Bpp(
      self
    ) -> int: 
        """
        Texture bytes per pixel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Bpp
        """
        pass

    @Bpp.setter
    def Bpp(
      self,
      _value: int
    ) -> None: 
        """
        Texture bytes per pixel.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Bpp
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        Texture width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Width
        """
        pass

    @Width.setter
    def Width(
      self,
      _value: int
    ) -> None: 
        """
        Texture width.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Width
        """
        pass

    @property
    def Height(
      self
    ) -> int: 
        """
        Texture height.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Height
        """
        pass

    @Height.setter
    def Height(
      self,
      _value: int
    ) -> None: 
        """
        Texture height.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Height
        """
        pass

    @property
    def Size(
      self
    ) -> int: 
        """
        Texture buffer size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Size
        """
        pass

    @Size.setter
    def Size(
      self,
      _value: int
    ) -> None: 
        """
        Texture buffer size.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Size
        """
        pass

    @property
    def Buffer(
      self
    ) -> TBytes: 
        """
        Texture buffer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Buffer
        """
        pass

    @Buffer.setter
    def Buffer(
      self,
      _value: TBytes
    ) -> None: 
        """
        Texture buffer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.Buffer
        """
        pass

    @property
    def HasSharedTexture(
      self
    ) -> bool: 
        """
        True if material has shared texture.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasSharedTexture
        """
        pass

    @HasSharedTexture.setter
    def HasSharedTexture(
      self,
      _value: bool
    ) -> None: 
        """
        True if material has shared texture.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasSharedTexture
        """
        pass

    @property
    def SharedTextureIndex(
      self
    ) -> int: 
        """
        Index of shared texture map.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.SharedTextureIndex
        """
        pass

    @SharedTextureIndex.setter
    def SharedTextureIndex(
      self,
      _value: int
    ) -> None: 
        """
        Index of shared texture map.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.SharedTextureIndex
        """
        pass

    @property
    def HasCullBackFaces(
      self
    ) -> bool: 
        """
        True if CullBackFaces.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasCullBackFaces
        """
        pass

    @HasCullBackFaces.setter
    def HasCullBackFaces(
      self,
      _value: bool
    ) -> None: 
        """
        True if CullBackFaces.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasCullBackFaces
        """
        pass

    @property
    def HasMaterialColor(
      self
    ) -> bool: 
        """
        True if material has defined colors in MaterialColors.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasMaterialColor
        """
        pass

    @HasMaterialColor.setter
    def HasMaterialColor(
      self,
      _value: bool
    ) -> None: 
        """
        True if material has defined colors in MaterialColors.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.HasMaterialColor
        """
        pass

    @property
    def MaterialColors(
      self
    ) -> TGIS_SingleColorArray: 
        """
        Material colors [index : type] : 0 : diffuse, 1 : ambient, 2 : specular, 3 : emissive, 
        4 : transparent, 5 : reflective

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.MaterialColors
        """
        pass

    @MaterialColors.setter
    def MaterialColors(
      self,
      _value: TGIS_SingleColorArray
    ) -> None: 
        """
        Material colors [index : type] : 0 : diffuse, 1 : ambient, 2 : specular, 3 : emissive, 
        4 : transparent, 5 : reflective

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Material.MaterialColors
        """
        pass

class TGIS_PartDescriptor:
    """
    Part descriptor.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptor
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptor.Create_void
        """
        pass

    @property
    def PartType(
      self
    ) -> int: 
        """
        Type of part. Look at TGIS_PartType for values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptor.PartType
        """
        pass

    @PartType.setter
    def PartType(
      self,
      _value: int
    ) -> None: 
        """
        Type of part. Look at TGIS_PartType for values.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptor.PartType
        """
        pass

    @property
    def LevelOfDetail(
      self
    ) -> int: 
        """
        Level of detail.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptor.LevelOfDetail
        """
        pass

    @LevelOfDetail.setter
    def LevelOfDetail(
      self,
      _value: int
    ) -> None: 
        """
        Level of detail.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptor.LevelOfDetail
        """
        pass

    @property
    def Priority(
      self
    ) -> int: 
        """
        Priority.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptor.Priority
        """
        pass

    @Priority.setter
    def Priority(
      self,
      _value: int
    ) -> None: 
        """
        Priority.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptor.Priority
        """
        pass

    @property
    def Material(
      self
    ) -> int: 
        """
        Material ID.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptor.Material
        """
        pass

    @Material.setter
    def Material(
      self,
      _value: int
    ) -> None: 
        """
        Material ID.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PartDescriptor.Material
        """
        pass

class TGIS_HttpResponse:
    """
    Http response.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HttpResponse
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HttpResponse.Create_void
        """
        pass

    @property
    def Status(
      self
    ) -> int: 
        """
        Response status.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HttpResponse.Status
        """
        pass

    @Status.setter
    def Status(
      self,
      _value: int
    ) -> None: 
        """
        Response status.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HttpResponse.Status
        """
        pass

    @property
    def ContentLength(
      self
    ) -> int: 
        """
        Content length.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HttpResponse.ContentLength
        """
        pass

    @ContentLength.setter
    def ContentLength(
      self,
      _value: int
    ) -> None: 
        """
        Content length.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HttpResponse.ContentLength
        """
        pass

    @property
    def ContentType(
      self
    ) -> str: 
        """
        Content type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HttpResponse.ContentType
        """
        pass

    @ContentType.setter
    def ContentType(
      self,
      _value: str
    ) -> None: 
        """
        Content type.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HttpResponse.ContentType
        """
        pass

    @property
    def ContentExpires(
      self
    ) -> TDateTime: 
        """
        Content expires date in UTC.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HttpResponse.ContentExpires
        """
        pass

    @ContentExpires.setter
    def ContentExpires(
      self,
      _value: TDateTime
    ) -> None: 
        """
        Content expires date in UTC.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HttpResponse.ContentExpires
        """
        pass

    @property
    def Stream(
      self
    ) -> TStream: 
        """
        Stream with data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HttpResponse.Stream
        """
        pass

    @Stream.setter
    def Stream(
      self,
      _value: TStream
    ) -> None: 
        """
        Stream with data.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HttpResponse.Stream
        """
        pass

    @property
    def Headers(
      self
    ) -> str: 
        """
        All headers CRLF separated

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HttpResponse.Headers
        """
        pass

    @Headers.setter
    def Headers(
      self,
      _value: str
    ) -> None: 
        """
        All headers CRLF separated

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_HttpResponse.Headers
        """
        pass

class TGIS_LayerPixelSubFormat:
    """
    Pixel file capabilities.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSubFormat
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSubFormat.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _pixelformat: TGIS_PixelFormat,
      _grayscale: bool,
      _subformat: TGIS_PixelSubFormat,
      _compression: TGIS_CompressionType,
      _level: int
    ) -> None: 
        """
        Constructor.

        Args:
            _pixelformat: Format of pixel files (number of bits per pixel).
            _grayscale: True if file is grayscale.
            _subformat: Sub-format used.
            _compression: Compression type.
            _level: Compression level.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSubFormat.Create_TGIS_PixelFormat_Boolean_TGIS_PixelSubFormat_TGIS_CompressionType_Integer
        """
        pass

    def CreateCopy(
      self
    ) -> TGIS_LayerPixelSubFormat: 
        """
        Clone object.

        Returns:
            New cloned object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSubFormat.CreateCopy_void
        """
        pass

    @classmethod
    def DefaultSubFormat(
      cls
    ) -> TGIS_LayerPixelSubFormat: 
        """
        Get default subformat.

        Returns:
            subformat.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSubFormat.DefaultSubFormat_void
        """
        pass

    def ToString(
      self
    ) -> str: 
        """
        Get text description.

        Returns:
            Description.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSubFormat.ToString_void
        """
        pass

    @property
    def Compression(
      self
    ) -> TGIS_CompressionType: 
        """
        Supported compression type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSubFormat.Compression
        """
        pass

    @property
    def CompressionLevel(
      self
    ) -> int: 
        """
        Compression level.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSubFormat.CompressionLevel
        """
        pass

    @property
    def GrayScale(
      self
    ) -> bool: 
        """
        True if file is grayscale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSubFormat.GrayScale
        """
        pass

    @property
    def PixelFormat(
      self
    ) -> TGIS_PixelFormat: 
        """
        Format of pixel files (number of bits per pixel).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSubFormat.PixelFormat
        """
        pass

    @property
    def Subformat(
      self
    ) -> TGIS_PixelSubFormat: 
        """
        Sub-format used. For files capable to support more the one underlying formats (like 
        PixelsStore: PNG and JPEG).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LayerPixelSubFormat.Subformat
        """
        pass

class TGIS_Viewer3DReferenceMode:
    pass

class TGIS_Viewer3DReferenceMode:
    """
    Types of reference level mode ( Z value of rotation point).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DReferenceMode
    """

    @property
    def Base(
      self
    ) -> TGIS_Viewer3DReferenceMode: 
        """
        reference level at default level ie. min Z value among DEMs

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DReferenceMode.Base
        """
        pass

    @property
    def Zero(
      self
    ) -> TGIS_Viewer3DReferenceMode: 
        """
        reference level at 0

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DReferenceMode.Zero
        """
        pass

    @property
    def OnDem(
      self
    ) -> TGIS_Viewer3DReferenceMode: 
        """
        reference level on DEM surface

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DReferenceMode.OnDem
        """
        pass

    @property
    def Lowest(
      self
    ) -> TGIS_Viewer3DReferenceMode: 
        """
        reference level equal to lowest value of DEMs&amp;Vectors in currently displayed 
        project

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DReferenceMode.Lowest
        """
        pass

    @property
    def Highest(
      self
    ) -> TGIS_Viewer3DReferenceMode: 
        """
        reference level equal to highest value of DEMs&amp;Vectors in currently displayed 
        project

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DReferenceMode.Highest
        """
        pass

    @property
    def FlyOnDem(
      self
    ) -> TGIS_Viewer3DReferenceMode: 
        """
        reference level will follow DEM surface

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DReferenceMode.FlyOnDem
        """
        pass

class TGIS_Viewer3DDemWall:
    pass

class TGIS_Viewer3DDemWall:
    """
    Types of DEM walls.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DDemWall
    """

    @property
    def Texture(
      self
    ) -> TGIS_Viewer3DDemWall: 
        """
        texture wall

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DDemWall.Texture
        """
        pass

    @property
    def Invisible(
      self
    ) -> TGIS_Viewer3DDemWall: 
        """
        invisible wall

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DDemWall.Invisible
        """
        pass

    @property
    def Solid(
      self
    ) -> TGIS_Viewer3DDemWall: 
        """
        solid color wall

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DDemWall.Solid
        """
        pass

class TGIS_Viewer3DViewRestriction:
    pass

class TGIS_Viewer3DViewRestriction:
    """
    Types of camera position restriction.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DViewRestriction
    """

    @property
    def None_(
      self
    ) -> TGIS_Viewer3DViewRestriction: 
        """
        no restrictions, camera can be placed anywhere

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DViewRestriction.None
        """
        pass

    @property
    def AboveHorizon(
      self
    ) -> TGIS_Viewer3DViewRestriction: 
        """
        camera can be placed only above horizon

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DViewRestriction.AboveHorizon
        """
        pass

class TGIS_Viewer3DDemCacheSize:
    pass

class TGIS_Viewer3DDemCacheSize:
    """
    Grid size used to display regular DEMs &amp; IMAGEs.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DDemCacheSize
    """

    @property
    def Medium(
      self
    ) -> TGIS_Viewer3DDemCacheSize: 
        """
        Medium = 512 x 512

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DDemCacheSize.Medium
        """
        pass

    @property
    def Window(
      self
    ) -> TGIS_Viewer3DDemCacheSize: 
        """
        Window = window size based

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DDemCacheSize.Window
        """
        pass

class TGIS_Viewer3DReferenceLevelMode:
    pass

class TGIS_Viewer3DReferenceLevelMode:
    """
    Types of reference level (Z value of rotation point)

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DReferenceLevelMode
    """

    @property
    def AboveZero(
      self
    ) -> TGIS_Viewer3DReferenceLevelMode: 
        """
        Rotation point relative to 0 (const value)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DReferenceLevelMode.AboveZero
        """
        pass

    @property
    def AboveDem(
      self
    ) -> TGIS_Viewer3DReferenceLevelMode: 
        """
        Rotation point will follow DEM surface

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DReferenceLevelMode.AboveDem
        """
        pass

    @property
    def Default(
      self
    ) -> TGIS_Viewer3DReferenceLevelMode: 
        """
        Rotation point at default level ie. min Z value in DEM

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DReferenceLevelMode.Default
        """
        pass

class TGIS_Viewer3DTransparencyPriority:
    pass

class TGIS_Viewer3DTransparencyPriority:
    """
    Types of transparency priority in case that both DEM &amp; vector are transparent.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DTransparencyPriority
    """

    @property
    def Auto(
      self
    ) -> TGIS_Viewer3DTransparencyPriority: 
        """
        if DEM not transparent, then if vector is transparent, user will see DEM through 
        the vector; if DEM is transparent, then user will see vector laying below the DEM

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DTransparencyPriority.Auto
        """
        pass

    @property
    def Vector(
      self
    ) -> TGIS_Viewer3DTransparencyPriority: 
        """
        transparent vector - user will see DEM through the vector; Dem will be rendered first

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DTransparencyPriority.Vector
        """
        pass

    @property
    def Dem(
      self
    ) -> TGIS_Viewer3DTransparencyPriority: 
        """
        transparent DEM - user will see vector laying below the DEM; vector will be rendered 
        first

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DTransparencyPriority.Dem
        """
        pass

class TGIS_3DCamera:
    """
    Definition of a camera for the 3D view.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DCamera
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DCamera.Create_void
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Name of the camera.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DCamera.Name
        """
        pass

    @Name.setter
    def Name(
      self,
      _value: str
    ) -> None: 
        """
        Name of the camera.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DCamera.Name
        """
        pass

    @property
    def Active(
      self
    ) -> bool: 
        """
        True if the camera is active.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DCamera.Active
        """
        pass

    @Active.setter
    def Active(
      self,
      _value: bool
    ) -> None: 
        """
        True if the camera is active.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DCamera.Active
        """
        pass

    @property
    def Position(
      self
    ) -> TGIS_Point3D: 
        """
        Position of the camera.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DCamera.Position
        """
        pass

    @Position.setter
    def Position(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        Position of the camera.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DCamera.Position
        """
        pass

    @property
    def PositionEx(
      self
    ) -> TGIS_Point3D: 
        """
        Location of the camera.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DCamera.PositionEx
        """
        pass

    @PositionEx.setter
    def PositionEx(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        Location of the camera.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DCamera.PositionEx
        """
        pass

    @property
    def Rotation(
      self
    ) -> TGIS_Point3D: 
        """
        Rotation of the camera.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DCamera.Rotation
        """
        pass

    @Rotation.setter
    def Rotation(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        Rotation of the camera.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DCamera.Rotation
        """
        pass

    @property
    def Reference(
      self
    ) -> TGIS_Point3D: 
        """
        Reference point of the camera.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DCamera.Reference
        """
        pass

    @Reference.setter
    def Reference(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        Reference point of the camera.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_3DCamera.Reference
        """
        pass

class TGIS_Viewer3DFlood:
    """
    Structure for flood management.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DFlood
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DFlood.Create_void
        """
        pass

    @property
    def Active(
      self
    ) -> bool: 
        """
        Flood on/off switch, default is off.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DFlood.Active
        """
        pass

    @Active.setter
    def Active(
      self,
      _value: bool
    ) -> None: 
        """
        Flood on/off switch, default is off.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DFlood.Active
        """
        pass

    @property
    def Level(
      self
    ) -> float: 
        """
        Flood level.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DFlood.Level
        """
        pass

    @Level.setter
    def Level(
      self,
      _value: float
    ) -> None: 
        """
        Flood level.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DFlood.Level
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Flood color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DFlood.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Flood color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DFlood.Color
        """
        pass

    @property
    def Transparency(
      self
    ) -> int: 
        """
        Flood transparency 0%-100% .

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DFlood.Transparency
        """
        pass

    @Transparency.setter
    def Transparency(
      self,
      _value: int
    ) -> None: 
        """
        Flood transparency 0%-100% .

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DFlood.Transparency
        """
        pass

class TGIS_Viewer3DBasePlane:
    """
    Structure for BasePlane management.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBasePlane
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBasePlane.Create_void
        """
        pass

    @property
    def Active(
      self
    ) -> bool: 
        """
        BasePlane on/off switch, default is on.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBasePlane.Active
        """
        pass

    @Active.setter
    def Active(
      self,
      _value: bool
    ) -> None: 
        """
        BasePlane on/off switch, default is on.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBasePlane.Active
        """
        pass

    @property
    def Level(
      self
    ) -> float: 
        """
        BasePlane level.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBasePlane.Level
        """
        pass

    @Level.setter
    def Level(
      self,
      _value: float
    ) -> None: 
        """
        BasePlane level.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBasePlane.Level
        """
        pass

    @property
    def Transparency(
      self
    ) -> int: 
        """
        BasePlane transparency 0%-100% .

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBasePlane.Transparency
        """
        pass

    @Transparency.setter
    def Transparency(
      self,
      _value: int
    ) -> None: 
        """
        BasePlane transparency 0%-100% .

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBasePlane.Transparency
        """
        pass

    @property
    def BackgroundColor(
      self
    ) -> TGIS_Color: 
        """
        BasePlane background color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBasePlane.BackgroundColor
        """
        pass

    @BackgroundColor.setter
    def BackgroundColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        BasePlane background color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBasePlane.BackgroundColor
        """
        pass

    @property
    def GridColor(
      self
    ) -> TGIS_Color: 
        """
        BasePlane grid color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBasePlane.GridColor
        """
        pass

    @GridColor.setter
    def GridColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        BasePlane grid color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBasePlane.GridColor
        """
        pass

class TGIS_ColorInterpolationMode:
    pass

class TGIS_ColorInterpolationMode:
    """
    Defines color interpolation method.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorInterpolationMode
    """

    @property
    def RGB(
      self
    ) -> TGIS_ColorInterpolationMode: 
        """
        Alpha, red, green and blue components interpolation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorInterpolationMode.RGB
        """
        pass

    @property
    def HSL(
      self
    ) -> TGIS_ColorInterpolationMode: 
        """
        Alpha, hue, saturation and lightness components interpolation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorInterpolationMode.HSL
        """
        pass

    @property
    def None_(
      self
    ) -> TGIS_ColorInterpolationMode: 
        """
        No interpolation, discrete colors are used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorInterpolationMode.None
        """
        pass

    @property
    def HSL360(
      self
    ) -> TGIS_ColorInterpolationMode: 
        """
        Alpha, hue, saturation and lightness components interpolation. This method forcess 
        the hue for the color to go through 360.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorInterpolationMode.HSL360
        """
        pass

    @property
    def HCL(
      self
    ) -> TGIS_ColorInterpolationMode: 
        """
        Alpha, Hue, Chroma, Luminance components interpolation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorInterpolationMode.HCL
        """
        pass

class TGIS_ColorMapMode:
    pass

class TGIS_ColorMapMode:
    """
    Defines colormap mode.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapMode
    """

    @property
    def Continuous(
      self
    ) -> TGIS_ColorMapMode: 
        """
        Continuous colormap.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapMode.Continuous
        """
        pass

    @property
    def Discrete(
      self
    ) -> TGIS_ColorMapMode: 
        """
        Discrete colormap.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapMode.Discrete
        """
        pass

class TGIS_PixelFormat:
    pass

class TGIS_PixelFormat:
    """
    Platform independent pixel format specification

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFormat
    """

    @property
    def Bit1(
      self
    ) -> TGIS_PixelFormat: 
        """
        1 bit per pixel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFormat.Bit1
        """
        pass

    @property
    def Bit4(
      self
    ) -> TGIS_PixelFormat: 
        """
        4 bit per pixel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFormat.Bit4
        """
        pass

    @property
    def Bit8(
      self
    ) -> TGIS_PixelFormat: 
        """
        8 bit per pixel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFormat.Bit8
        """
        pass

    @property
    def RGB(
      self
    ) -> TGIS_PixelFormat: 
        """
        24 bit per pixel in RGB.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFormat.RGB
        """
        pass

    @property
    def ARGB(
      self
    ) -> TGIS_PixelFormat: 
        """
        32 bit per pixels in ARGB.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFormat.ARGB
        """
        pass

    @property
    def Custom(
      self
    ) -> TGIS_PixelFormat: 
        """
        Custom for special use.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelFormat.Custom
        """
        pass

class TGIS_PixelSubFormat:
    pass

class TGIS_PixelSubFormat:
    """
    Platform independent pixel storage format definition.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelSubFormat
    """

    @property
    def None_(
      self
    ) -> TGIS_PixelSubFormat: 
        """
        Raw bytes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelSubFormat.None
        """
        pass

    @property
    def BMP(
      self
    ) -> TGIS_PixelSubFormat: 
        """
        BMP image format.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelSubFormat.BMP
        """
        pass

    @property
    def JPEG(
      self
    ) -> TGIS_PixelSubFormat: 
        """
        JPEG image format.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelSubFormat.JPEG
        """
        pass

    @property
    def PNG(
      self
    ) -> TGIS_PixelSubFormat: 
        """
        PNG image format.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelSubFormat.PNG
        """
        pass

    @property
    def JP2(
      self
    ) -> TGIS_PixelSubFormat: 
        """
        JPEG 2000 image format.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelSubFormat.JP2
        """
        pass

    @property
    def GRID(
      self
    ) -> TGIS_PixelSubFormat: 
        """
        GRID data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PixelSubFormat.GRID
        """
        pass

class TGIS_FontStyle:
    pass

class TGIS_FontStyle:
    """
    Platform independent font style definition.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FontStyle
    """

    @property
    def Bold(
      self
    ) -> TGIS_FontStyle: 
        """
        Bold font

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FontStyle.Bold
        """
        pass

    @property
    def Italic(
      self
    ) -> TGIS_FontStyle: 
        """
        Italic font

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FontStyle.Italic
        """
        pass

    @property
    def Underline(
      self
    ) -> TGIS_FontStyle: 
        """
        Underline font

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FontStyle.Underline
        """
        pass

    @property
    def StrikeOut(
      self
    ) -> TGIS_FontStyle: 
        """
        Strikeout font

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FontStyle.StrikeOut
        """
        pass

class TGIS_BrushStyle:
    pass

class TGIS_BrushStyle:
    """
    Platform independent brush style definition.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BrushStyle
    """

    @property
    def Solid(
      self
    ) -> TGIS_BrushStyle: 
        """
        Brush is solid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BrushStyle.Solid
        """
        pass

    @property
    def Clear(
      self
    ) -> TGIS_BrushStyle: 
        """
        Brush is invisible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BrushStyle.Clear
        """
        pass

    @property
    def Horizontal(
      self
    ) -> TGIS_BrushStyle: 
        """
        Brush is horizontal.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BrushStyle.Horizontal
        """
        pass

    @property
    def Vertical(
      self
    ) -> TGIS_BrushStyle: 
        """
        Brush is vertical.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BrushStyle.Vertical
        """
        pass

    @property
    def FDiagonal(
      self
    ) -> TGIS_BrushStyle: 
        """
        Brush is forward diagonal.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BrushStyle.FDiagonal
        """
        pass

    @property
    def BDiagonal(
      self
    ) -> TGIS_BrushStyle: 
        """
        Brush is backward diagonal.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BrushStyle.BDiagonal
        """
        pass

    @property
    def Cross(
      self
    ) -> TGIS_BrushStyle: 
        """
        Brush is cross.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BrushStyle.Cross
        """
        pass

    @property
    def DiagCross(
      self
    ) -> TGIS_BrushStyle: 
        """
        Brush is diagonal cross.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BrushStyle.DiagCross
        """
        pass

class TGIS_PenStyle:
    pass

class TGIS_PenStyle:
    """
    Platform independent pen style definition.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PenStyle
    """

    @property
    def Solid(
      self
    ) -> TGIS_PenStyle: 
        """
        Solid line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PenStyle.Solid
        """
        pass

    @property
    def Dash(
      self
    ) -> TGIS_PenStyle: 
        """
        Pen is dashed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PenStyle.Dash
        """
        pass

    @property
    def Dot(
      self
    ) -> TGIS_PenStyle: 
        """
        Pen is doted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PenStyle.Dot
        """
        pass

    @property
    def DashDot(
      self
    ) -> TGIS_PenStyle: 
        """
        Pen has alternating dashes and dots.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PenStyle.DashDot
        """
        pass

    @property
    def DashDotDot(
      self
    ) -> TGIS_PenStyle: 
        """
        Pen has alternating dashes and double dots.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PenStyle.DashDotDot
        """
        pass

    @property
    def Clear(
      self
    ) -> TGIS_PenStyle: 
        """
        Pen is invisible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PenStyle.Clear
        """
        pass

class TGIS_LineCap:
    pass

class TGIS_LineCap:
    """
    Platform independent pen cap style.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LineCap
    """

    @property
    def Flat(
      self
    ) -> TGIS_LineCap: 
        """
        End caps are flat.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LineCap.Flat
        """
        pass

    @property
    def Square(
      self
    ) -> TGIS_LineCap: 
        """
        End caps are square.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LineCap.Square
        """
        pass

    @property
    def Round(
      self
    ) -> TGIS_LineCap: 
        """
        End caps are round.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LineCap.Round
        """
        pass

class TGIS_LineJoin:
    pass

class TGIS_LineJoin:
    """
    Platform independent pen join style.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LineJoin
    """

    @property
    def Bevel(
      self
    ) -> TGIS_LineJoin: 
        """
        Joins are beveled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LineJoin.Bevel
        """
        pass

    @property
    def Miter(
      self
    ) -> TGIS_LineJoin: 
        """
        Joins are mittered within a limit; if it exceeds this limit, the join is beveled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LineJoin.Miter
        """
        pass

    @property
    def Round(
      self
    ) -> TGIS_LineJoin: 
        """
        Joins are round.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LineJoin.Round
        """
        pass

class TGIS_BitmapFormat:
    pass

class TGIS_BitmapFormat:
    """
    TGIS_Bitmap supported formats

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapFormat
    """

    @property
    def Native(
      self
    ) -> TGIS_BitmapFormat: 
        """
        System native format.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapFormat.Native
        """
        pass

    @property
    def ARGB(
      self
    ) -> TGIS_BitmapFormat: 
        """
        ARGB order.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapFormat.ARGB
        """
        pass

    @property
    def ABGR(
      self
    ) -> TGIS_BitmapFormat: 
        """
        ABGR order.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapFormat.ABGR
        """
        pass

class TGIS_BitmapLinesOrder:
    pass

class TGIS_BitmapLinesOrder:
    """
    TGIS_Bitmap lines order

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapLinesOrder
    """

    @property
    def Native(
      self
    ) -> TGIS_BitmapLinesOrder: 
        """
        System native order.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapLinesOrder.Native
        """
        pass

    @property
    def Down(
      self
    ) -> TGIS_BitmapLinesOrder: 
        """
        top-bottom order.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapLinesOrder.Down
        """
        pass

    @property
    def Up(
      self
    ) -> TGIS_BitmapLinesOrder: 
        """
        bottom-top order.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapLinesOrder.Up
        """
        pass

class TGIS_ScalingFilter:
    pass

class TGIS_ScalingFilter:
    """
    Bitmap scaling filtering type

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ScalingFilter
    """

    @property
    def Linear(
      self
    ) -> TGIS_ScalingFilter: 
        """
        Linear (Triangle) resampling.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ScalingFilter.Linear
        """
        pass

    @property
    def Lanczos3(
      self
    ) -> TGIS_ScalingFilter: 
        """
        Lanczos3 resampling.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ScalingFilter.Lanczos3
        """
        pass

class TGIS_ColorSchema:
    pass

class TGIS_ColorSchema:
    """
    Color schema types.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorSchema
    """

    @property
    def Diverging(
      self
    ) -> TGIS_ColorSchema: 
        """
        Diverging type put equal emphasis on mid-range critical values and extremes at both 
        ends of the data range.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorSchema.Diverging
        """
        pass

    @property
    def Qualitative(
      self
    ) -> TGIS_ColorSchema: 
        """
        Qualitative type is suited to representing nominal or categorical data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorSchema.Qualitative
        """
        pass

    @property
    def Sequential(
      self
    ) -> TGIS_ColorSchema: 
        """
        Sequential type is suited to ordered data that progress from low to high.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorSchema.Sequential
        """
        pass

    @property
    def Miscellaneous(
      self
    ) -> TGIS_ColorSchema: 
        """
        Other color ramps not matching the main categories.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorSchema.Miscellaneous
        """
        pass

class TGIS_LegendIconStyle:
    pass

class TGIS_LegendIconStyle:
    """
    Style of legend icons.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconStyle
    """

    @property
    def Default(
      self
    ) -> TGIS_LegendIconStyle: 
        """
        Default style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconStyle.Default
        """
        pass

    @property
    def Rectangular(
      self
    ) -> TGIS_LegendIconStyle: 
        """
        Area is drawn as a rectangle instead of triangle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_LegendIconStyle.Rectangular
        """
        pass

class TGIS_Font:
    """
    Platform independent font class.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Font
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Font.Create_void
        """
        pass

    def Assign(
      self,
      _source: TGIS_Font
    ) -> None: 
        """
        Assign font definition from other instance.

        Args:
            _source: source font definition

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Font.Assign_TGIS_Font
        """
        pass

    def LoadFromFont(
      self,
      _font: TObject
    ) -> None: 
        """
        Load definition from platform specific object

        Args:
            _font: platform specific object (like TFont for VCL)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Font.LoadFromFont_TObject
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Font color

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Font.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Font color

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Font.Color
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Font name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Font.Name
        """
        pass

    @Name.setter
    def Name(
      self,
      _value: str
    ) -> None: 
        """
        Font name

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Font.Name
        """
        pass

    @property
    def Size(
      self
    ) -> int: 
        """
        Font size expressed in points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Font.Size
        """
        pass

    @Size.setter
    def Size(
      self,
      _value: int
    ) -> None: 
        """
        Font size expressed in points.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Font.Size
        """
        pass

    @property
    def Style(
      self
    ) -> typing.Sequence[TGIS_FontStyle]: 
        """
        Font styles ( bold, italic etc.)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Font.Style
        """
        pass

    @Style.setter
    def Style(
      self,
      _value: typing.Sequence[TGIS_FontStyle]
    ) -> None: 
        """
        Font styles ( bold, italic etc.)

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Font.Style
        """
        pass

class TGIS_Pen:
    """
    Platform independent pen class.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pen
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pen.Create_void
        """
        pass

    def Assign(
      self,
      _source: TGIS_Pen
    ) -> None: 
        """
        Assign pen definition from other instance.

        Args:
            _source: source pen definition

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pen.Assign_TGIS_Pen
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Pen color

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pen.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Pen color

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pen.Color
        """
        pass

    @property
    def LineCap(
      self
    ) -> TGIS_LineCap: 
        """
        End cap style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pen.LineCap
        """
        pass

    @LineCap.setter
    def LineCap(
      self,
      _value: TGIS_LineCap
    ) -> None: 
        """
        End cap style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pen.LineCap
        """
        pass

    @property
    def LineDash(
      self
    ) -> TGIS_DashArray: 
        """
        End cap style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pen.LineDash
        """
        pass

    @LineDash.setter
    def LineDash(
      self,
      _value: TGIS_DashArray
    ) -> None: 
        """
        End cap style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pen.LineDash
        """
        pass

    @property
    def LineJoin(
      self
    ) -> TGIS_LineJoin: 
        """
        Join style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pen.LineJoin
        """
        pass

    @LineJoin.setter
    def LineJoin(
      self,
      _value: TGIS_LineJoin
    ) -> None: 
        """
        Join style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pen.LineJoin
        """
        pass

    @property
    def Style(
      self
    ) -> TGIS_PenStyle: 
        """
        Pen style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pen.Style
        """
        pass

    @Style.setter
    def Style(
      self,
      _value: TGIS_PenStyle
    ) -> None: 
        """
        Pen style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pen.Style
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        Pen width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pen.Width
        """
        pass

    @Width.setter
    def Width(
      self,
      _value: int
    ) -> None: 
        """
        Pen width.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pen.Width
        """
        pass

class TGIS_Brush:
    """
    Platform independent brush class.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Brush
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Brush.Create_void
        """
        pass

    def Assign(
      self,
      _source: TGIS_Brush
    ) -> None: 
        """
        Assign brush from other instance.

        Args:
            _source: source brush definition

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Brush.Assign_TGIS_Brush
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Brush color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Brush.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Brush color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Brush.Color
        """
        pass

    @property
    def Style(
      self
    ) -> TGIS_BrushStyle: 
        """
        Brush style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Brush.Style
        """
        pass

    @Style.setter
    def Style(
      self,
      _value: TGIS_BrushStyle
    ) -> None: 
        """
        Brush style.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Brush.Style
        """
        pass

class TGIS_BitmapAbstract( TObject ):
    """
    Platform dependent Bitmap implementation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.Create_void
        """
        pass

    def CreateViewer(
      self
    ) -> IInterface: 
        """
        Create a bitmap viewer

        Returns:
            viewer interface

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.CreateViewer_void
        """
        pass

    def DrawGlyph(
      self,
      _symbo: TObject,
      _ppi: int,
      _color: TGIS_Color,
      _enabled: bool
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.DrawGlyph_TObject_Integer_TGIS_Color_Boolean
        """
        pass

    @overload
    def DrawShape(
      self,
      _shape: TObject,
      _outline: bool,
      _scale: VarParameter,
      _offset: VarParameter
    ) -> None: 
        """
        Draw a shape on a bitmap. Used for internal purposes of TGIS_Shape.PrepareContourInternal.

        Args:
            _shape: TGIS_Shape object
            _outline: if _true then polygonal shape will be drawn with black outline, otherwise 
              only internal will be drawn.
            _scale: pixels/unit scale of a shape; the value (in/out) is passed as float in _scale.Value 
              property
            _offset: margin between left-up corner of the bitmap and left-up corner of shape 
              extent (expressed in pixels); the value (in/out) is passed as TPoint in _offset.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.DrawShape_TObject_Boolean_Double_TPoint
        """
        pass

    @overload
    def DrawShape(
      self,
      _shape: TObject,
      _ppi: int,
      _outline: bool,
      _scale: VarParameter,
      _offset: VarParameter
    ) -> None: 
        """
        Draw a shape on a bitmap (for internal TGIS_Shape.PrepareContourInternal purposes).

        Args:
            _shape: shape to be drawn
            _ppi: pixels per inch; us3ed to calculate proper line sizes etc.
            _outline: if True then outline of polygonal object will be drawn; otherwise only 
              interiors will be drawn
            _scale: shape size in pixels divided by the shape size in map units; the value (in/out) 
              is passed as float in _scale.Value property
            _offset: offset of shape within bitmap caused by map placement, margins etc.; the 
              value (in/out) is passed as TPoint in _offset.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.DrawShape_TObject_Integer_Boolean_Double_TPoint
        """
        pass

    @overload
    def DrawShape(
      self,
      _shape: TObject,
      _ppi: int,
      _outline: bool,
      _areacolor: TGIS_Color,
      _linecolor: TGIS_Color,
      _scale: VarParameter,
      _offset: VarParameter
    ) -> None: 
        """
        Draw a shape on a bitmap (for internal TGIS_Shape.PrepareContourInternal purposes).

        Args:
            _shape: shape to be drawn
            _ppi: pixels per inch; us3ed to calculate proper line sizes etc.
            _outline: if True then outline of polygonal object will be drawn; otherwise only 
              interiors will be drawn
            _areacolor: color for interiors
            _linecolor: color for lines and outlines
            _scale: pixels/unit scale of a shape; the value (in/out) is passed as float in _scale.Value 
              property
            _offset: offset of shape within bitmap caused by map placement, margins etc.; the 
              value (in/out) is passed as TPoint in _offset.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.DrawShape_TObject_Integer_Boolean_TGIS_Color_TGIS_Color_Double_TPoint
        """
        pass

    @overload
    def DrawSymbol(
      self,
      _name: str
    ) -> None: 
        """
        Draws symbol

        Args:
            _name: symbol name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.DrawSymbol_String
        """
        pass

    @overload
    def DrawSymbol(
      self,
      _name: str,
      _ppi: int
    ) -> None: 
        """
        Draws symbol

        Args:
            _name: symbol name
            _ppi: pixels per inch; us3ed to calculate proper line sizes etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.DrawSymbol_String_Integer
        """
        pass

    @overload
    def DrawSymbol(
      self,
      _name: str,
      _ppi: int,
      _areacolor: TGIS_Color,
      _linecolor: TGIS_Color
    ) -> None: 
        """
        Draws symbol

        Args:
            _name: symbol name
            _ppi: pixels per inch; us3ed to calculate proper line sizes etc.
            _areacolor: color for interiors
            _linecolor: color for lines and outlines

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.DrawSymbol_String_Integer_TGIS_Color_TGIS_Color
        """
        pass

    def FromBitmap(
      self,
      _bmp: TObject
    ) -> TGIS_BitmapAbstract: 
        """
        Create bitmap from platform specific object.

        Args:
            _bmp: platform specific object (like TBitmap for VCL)

        Returns:
            created bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.FromBitmap_TObject
        """
        pass

    def FromFile(
      self,
      _path: str
    ) -> TGIS_BitmapAbstract: 
        """
        Create bitmap from file.

        Args:
            _path: path to file

        Returns:
            created bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.FromFile_String
        """
        pass

    def FromStream(
      self,
      _stream: TObject
    ) -> TGIS_BitmapAbstract: 
        """
        Create bitmap from stream.

        Args:
            _stream: platform specific stream (like TStream for VCL)

        Returns:
            created bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.FromStream_TObject
        """
        pass

    def GetData(
      self,
      _target: IInterface
    ) -> TObject: 
        """
        Return platform specific bitmap object (like TBitmap for VCL).

        Args:
            _target: optional platform specific object which modifies returned data

        Returns:
            bitmap object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.GetData_IInterface
        """
        pass

    def LockPixels(
      self,
      _pixels: VarParameter,
      _writable: bool,
      _format: TGIS_BitmapFormat,
      _order: TGIS_BitmapLinesOrder
    ) -> None: 
        """
        Prepare bitmap for direct pixel access operation.

        Args:
            _pixels: pixel buffer (allocated and maintained by LockPixels .. UnlockPixels; the 
              value (in/out) is passed as TGIS_Pixels in _pixels.Value property
            _writable: True if pixels will be modified
            _format: desired format of locked pixels; on some platforms some system level operation 
              required different pixel format then default
            _order: desired line order of locked pixels; on some platforms some system level 
              operation required different order then default

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.LockPixels_TGIS_Pixels_Boolean_TGIS_BitmapFormat_TGIS_BitmapLinesOrder
        """
        pass

    def MakeTransparent(
      self
    ) -> None: 
        """
        Make bitmap transparent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.MakeTransparent_void
        """
        pass

    @overload
    def ToFile(
      self,
      _path: str
    ) -> None: 
        """
        Save bitmap to file.

        Args:
            _path: path to file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.ToFile_String
        """
        pass

    @overload
    def ToFile(
      self,
      _path: str,
      _format: TGIS_PixelFormat,
      _subformat: TGIS_PixelSubFormat,
      _compression: int
    ) -> None: 
        """
        Save bitmap to file.

        Args:
            _path: path to file
            _format: output pixel format type
            _subformat: output pixel subformat type
            _compression: compression level

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.ToFile_String_TGIS_PixelFormat_TGIS_PixelSubFormat_Integer
        """
        pass

    @overload
    def ToStream(
      self,
      _stream: TObject
    ) -> None: 
        """
        Save bitmap to stream.

        Args:
            _stream: platform specific stream (like TStream for VCL)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.ToStream_TObject
        """
        pass

    @overload
    def ToStream(
      self,
      _stream: TObject,
      _format: TGIS_PixelFormat,
      _subformat: TGIS_PixelSubFormat,
      _compression: int
    ) -> None: 
        """
        Save bitmap to stream.

        Args:
            _stream: platform specific stream (like TStream for VCL)
            _format: output pixel format type
            _subformat: output pixel subformat type
            _compression: compression level

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.ToStream_TObject_TGIS_PixelFormat_TGIS_PixelSubFormat_Integer
        """
        pass

    def UnlockPixels(
      self
    ) -> None: 
        """
        Finalize pixel access operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.UnlockPixels_void
        """
        pass

    @property
    def Master(
      self
    ) -> TGIS_Bitmap: 
        """
        Master TGIS_Bitmap object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.Master
        """
        pass

    @Master.setter
    def Master(
      self,
      _value: TGIS_Bitmap
    ) -> None: 
        """
        Master TGIS_Bitmap object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.Master
        """
        pass

    @property
    def Data(
      self
    ) -> TObject: 
        """
        Platform specific bitmap object (like TBitmap for VCL).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.Data
        """
        pass

    @Data.setter
    def Data(
      self,
      _value: TObject
    ) -> None: 
        """
        Platform specific bitmap object (like TBitmap for VCL).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.Data
        """
        pass

    @property
    def Height(
      self
    ) -> int: 
        """
        Bitmap height in pixels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.Height
        """
        pass

    @property
    def Premultiplied(
      self
    ) -> bool: 
        """
        True if bitmap should be treated as premultipied. Important only on some platforms.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.Premultiplied
        """
        pass

    @Premultiplied.setter
    def Premultiplied(
      self,
      _value: bool
    ) -> None: 
        """
        True if bitmap should be treated as premultipied. Important only on some platforms.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.Premultiplied
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        Bitmap width in pixels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapAbstract.Width
        """
        pass

class TGIS_BitmapFactory:
    """
    Platform independent factory for platform dependent TGIS_Bitmap object.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapFactory
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapFactory.Create_void
        """
        pass

    def DoCreate(
      self,
      _parent: TGIS_Bitmap,
      _width: int,
      _height: int
    ) -> TGIS_BitmapAbstract: 
        """
        Create bitmap with a given size.

        Args:
            _parent: master TGIS_Bitmap object
            _width: width of bitmap in pixels
            _height: height of bitmap in pixels

        Returns:
            created bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapFactory.DoCreate_TGIS_Bitmap_Integer_Integer
        """
        pass

    def DoCreateFromBitmap(
      self,
      _parent: TGIS_Bitmap,
      _bmp: TObject
    ) -> TGIS_BitmapAbstract: 
        """
        Create bitmap from platform specific bitmap object.

        Args:
            _parent: master TGIS_Bitmap object
            _bmp: platform specific bitmap (like TBitmap for VCL)

        Returns:
            created bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapFactory.DoCreateFromBitmap_TGIS_Bitmap_TObject
        """
        pass

    def DoCreateFromFile(
      self,
      _parent: TGIS_Bitmap,
      _path: str
    ) -> TGIS_BitmapAbstract: 
        """
        Create bitmap from file.

        Args:
            _parent: master TGIS_Bitmap object
            _path: path to file

        Returns:
            created bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapFactory.DoCreateFromFile_TGIS_Bitmap_String
        """
        pass

    def DoCreateFromResource(
      self,
      _parent: TGIS_Bitmap,
      _ref: IntPtr,
      _name: str
    ) -> TGIS_BitmapAbstract: 
        """
        Create bitmap from resource.

        Args:
            _parent: master TGIS_Bitmap object
            _ref: module handle; to load DK standard resource use 0; see remarks for TGIS_Bitmap.LoadFromResourceName 
              for more
            _name: name of the resource

        Returns:
            created bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapFactory.DoCreateFromResource_TGIS_Bitmap_IntPtr_String
        """
        pass

    def DoCreateFromStream(
      self,
      _parent: TGIS_Bitmap,
      _stream: TObject
    ) -> TGIS_BitmapAbstract: 
        """
        Create bitmap from platform stream.

        Args:
            _parent: master TGIS_Bitmap object
            _stream: platform specific stream (like TStream for VCL)

        Returns:
            created bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapFactory.DoCreateFromStream_TGIS_Bitmap_TObject
        """
        pass

    def NativeFormat(
      self
    ) -> TGIS_BitmapFormat: 
        """
        Provides platform specific bitmap format.

        Returns:
            bitmap format

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapFactory.NativeFormat_void
        """
        pass

    def NativeLineOrder(
      self
    ) -> TGIS_BitmapLinesOrder: 
        """
        Provides platform specific bitmap''s line order.

        Returns:
            bitmap line order

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_BitmapFactory.NativeLineOrder_void
        """
        pass

class TGIS_Bitmap( TObject ):
    """
    Platform independent Bitmap (same object for all platforms).

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Create an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _width: int,
      _height: int
    ) -> None: 
        """
        Create an instance with a given size.

        Args:
            _width: width of bitmap in pixels
            _height: height of bitmap in pixels

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.Create_Integer_Integer
        """
        pass

    @overload
    def __init__(
      self,
      _width: int,
      _height: int,
      _premult: bool
    ) -> None: 
        """
        Create an instance with a given size.

        Args:
            _width: width of bitmap in pixels
            _height: height of bitmap in pixels
            _premult: create a bitmap premutiplied; required and supported only on selected platforms

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.Create_Integer_Integer_Boolean
        """
        pass

    @overload
    def __init__(
      self,
      _width: int,
      _height: int,
      _factory: TGIS_BitmapFactory
    ) -> None: 
        """
        Create an instance with a given size with a given bitmap factory.

        Args:
            _width: width of bitmap in pixels
            _height: height of bitmap in pixels
            _factory: bitmap data factory; if null then default one will be used

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.Create_Integer_Integer_TGIS_BitmapFactory
        """
        pass

    @overload
    def __init__(
      self,
      _bmp: TGIS_Bitmap
    ) -> None: 
        """
        Create an instance from exiting bitmap.

        Args:
            _bmp: source bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.Create_TGIS_Bitmap
        """
        pass

    @overload
    def __init__(
      self,
      _factory: TGIS_BitmapFactory
    ) -> None: 
        """
        Create an instance with a given size with a given bitmap factory.

        Args:
            _factory: bitmap data factory; if null then default one will be used

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.Create_TGIS_BitmapFactory
        """
        pass

    def AsPng(
      self
    ) -> TBytes: 
        """
        Export png as ready as arry of bytes in PNG format.

        Returns:
            Arrya of bytes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.AsPng_void
        """
        pass

    def Assign(
      self,
      _source: TGIS_Bitmap
    ) -> None: 
        """
        Assign bitmap from other instance.

        Args:
            _source: source bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.Assign_TGIS_Bitmap
        """
        pass

    def CreateViewer(
      self
    ) -> IInterface: 
        """
        Create a bitmap viewer

        Returns:
            viewer interface

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.CreateViewer_void
        """
        pass

    @overload
    def DrawBitmap(
      self,
      _bmp: TGIS_Bitmap,
      _bmprect: TRect,
      _drawrect: TRect
    ) -> None: 
        """
        Draw rectangle part of a bitmap on a part of a bitmap

        Args:
            _bmp: bitmap to be drawn
            _bmprect: defines part of _bmp to be drawn
            _drawrect: part in this rectangle of original bitmap will be overwrite

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.DrawBitmap_TGIS_Bitmap_TRect_TRect
        """
        pass

    @overload
    def DrawBitmap(
      self,
      _bmp: TGIS_Bitmap,
      _bmppix: TGIS_Pixels,
      _bmprect: TRect,
      _drawrect: TRect
    ) -> None: 
        """
        Draw rectangle part of a bitmap on a part of a bitmap

        Args:
            _bmp: bitmap to be drawn
            _bmppix: pixels buffer from lock to be drawn
            _bmprect: defines part of _bmp to be drawn
            _drawrect: part in this rectangle of original bitmap will be overwrite

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.DrawBitmap_TGIS_Bitmap_TGIS_Pixels_TRect_TRect
        """
        pass

    def DrawGlyph(
      self,
      _symbol: TObject,
      _ppi: int,
      _color: TGIS_Color,
      _enabled: bool
    ) -> None: 
        """
        Draws symbolk optimized to be used by a buttn glyph

        Args:
            _symbol: symbol to be drawn
            _ppi: pixels per inch; us3ed to calculate proper line sizes etc.
            _color: symbol color
            _enabled: if false draw glyph as disabled

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.DrawGlyph_TObject_Integer_TGIS_Color_Boolean
        """
        pass

    @overload
    def DrawShape(
      self,
      _shape: TObject,
      _outline: bool,
      _scale: VarParameter,
      _offset: VarParameter
    ) -> None: 
        """
        Draw a shape on a bitmap (for internal TGIS_Shape.PrepareContourInternal purposes).

        Args:
            _shape: shape to be drawn
            _outline: if True then outline of polygonal object will be drawn; otherwise only 
              interiors will be drawn
            _scale: shape size in pixels divided by the shape size in map units; the value (in/out) 
              is passed as float in _scale.Value property
            _offset: offset of shape within bitmap caused by map placement, margins etc.; the 
              value (in/out) is passed as TPoint in _offset.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.DrawShape_TObject_Boolean_Double_TPoint
        """
        pass

    @overload
    def DrawShape(
      self,
      _shape: TObject,
      _ppi: int,
      _outline: bool,
      _scale: VarParameter,
      _offset: VarParameter
    ) -> None: 
        """
        Draw a shape on a bitmap (for internal TGIS_Shape.PrepareContourInternal purposes).

        Args:
            _shape: shape to be drawn
            _ppi: pixels per inch; us3ed to calculate proper line sizes etc.
            _outline: if True then outline of polygonal object will be drawn; otherwise only 
              interiors will be drawn
            _scale: shape size in pixels divided by the shape size in map units; the value (in/out) 
              is passed as float in _scale.Value property
            _offset: offset of shape within bitmap caused by map placement, margins etc.; the 
              value (in/out) is passed as TPoint in _offset.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.DrawShape_TObject_Integer_Boolean_Double_TPoint
        """
        pass

    @overload
    def DrawShape(
      self,
      _shape: TObject,
      _ppi: int,
      _outline: bool,
      _areacolor: TGIS_Color,
      _linecolor: TGIS_Color,
      _scale: VarParameter,
      _offset: VarParameter
    ) -> None: 
        """
        Draw a shape on a bitmap (for internal TGIS_Shape.PrepareContourInternal purposes).

        Args:
            _shape: shape to be drawn
            _ppi: pixels per inch; us3ed to calculate proper line sizes etc.
            _outline: if True then outline of polygonal object will be drawn; otherwise only 
              interiors will be drawn
            _areacolor: color for interiors
            _linecolor: color for lines and outlines
            _scale: pixels/unit scale of a shape; the value (in/out) is passed as float in _scale.Value 
              property
            _offset: offset of shape within bitmap caused by map placement, margins etc.; the 
              value (in/out) is passed as TPoint in _offset.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.DrawShape_TObject_Integer_Boolean_TGIS_Color_TGIS_Color_Double_TPoint
        """
        pass

    @overload
    def DrawSymbol(
      self,
      _name: str
    ) -> None: 
        """
        Draws symbol

        Args:
            _name: symbol name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.DrawSymbol_String
        """
        pass

    @overload
    def DrawSymbol(
      self,
      _name: str,
      _ppi: int
    ) -> None: 
        """
        Draws symbol

        Args:
            _name: symbol name
            _ppi: pixels per inch

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.DrawSymbol_String_Integer
        """
        pass

    @overload
    def DrawSymbol(
      self,
      _name: str,
      _ppi: int,
      _areacolor: TGIS_Color,
      _linecolor: TGIS_Color
    ) -> None: 
        """
        Draws symbol

        Args:
            _name: symbol name
            _ppi: pixels per inch; us3ed to calculate proper line sizes etc.
            _areacolor: color for interiors
            _linecolor: color for lines and outlines

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.DrawSymbol_String_Integer_TGIS_Color_TGIS_Color
        """
        pass

    def IsNilOrEmpty(
      self,
      _bmp: TGIS_Bitmap
    ) -> bool: 
        """
        Test if bitmap is emptyt or nil

        Args:
            _bmp: bitmap to test

        Returns:
            True if bitmap is not allocated or is empty.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.IsNilOrEmpty_TGIS_Bitmap
        """
        pass

    def LoadFromBitmap(
      self,
      _bitmap: TObject,
      _path: str
    ) -> None: 
        """
        Load bitmap from platform specific bitmap object.

        Args:
            _bitmap: platform specific bitmap (like TBitmap for VCL)
            _path: path to be embedded into bitmap (to be treated as a unique name)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.LoadFromBitmap_TObject_String
        """
        pass

    def LoadFromFile(
      self,
      _path: str
    ) -> None: 
        """
        Load bitmap from file.

        Args:
            _path: path to file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.LoadFromFile_String
        """
        pass

    @overload
    def LoadFromResourceName(
      self,
      _name: str
    ) -> None: 
        """
        Load bitmap from DK standard resource.

        Args:
            _name: resource name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.LoadFromResourceName_String
        """
        pass

    @overload
    def LoadFromResourceName(
      self,
      _ref: IntPtr,
      _name: str
    ) -> None: 
        """
        Load bitmap from resource from specific module.

        Args:
            _ref: module handle; to load DK standard resource use 0; see remarks for more
            _name: resource name

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.LoadFromResourceName_IntPtr_String
        """
        pass

    def LoadFromStream(
      self,
      _stream: TObject
    ) -> None: 
        """
        Load bitmap from platform stream.

        Args:
            _stream: platform specific stream (like TStream for VCL)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.LoadFromStream_TObject
        """
        pass

    @overload
    def LockPixels(
      self,
      _pixels: VarParameter,
      _writable: bool,
      _format: TGIS_BitmapFormat,
      _order: TGIS_BitmapLinesOrder
    ) -> None: 
        """
        Return raw pixels

        Args:
            _pixels: array of pixels to be returned; the value (in/out) is passed as TGIS_Pixels 
              in _pixels.Value property
            _writable: if true then upon Unlock changes in locked pixel array will be populated 
              back to bitmap
            _format: format of locked pixel array; ARGB or BGRA
            _order: rows order: bottom-up or top-bottom

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.LockPixels_TGIS_Pixels_Boolean_TGIS_BitmapFormat_TGIS_BitmapLinesOrder
        """
        pass

    @overload
    def LockPixels(
      self,
      _pixels: VarParameter
    ) -> None: 
        """
        Return read only raw pixels in native system format and native system line order,

        Args:
            _pixels: array of pixels to be returned; the value (in/out) is passed as TGIS_Pixels 
              in _pixels.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.LockPixels_TGIS_Pixels
        """
        pass

    @overload
    def LockPixels(
      self,
      _pixels: VarParameter,
      _writable: bool
    ) -> None: 
        """
        Return raw pixels in native system format and native system line order.

        Args:
            _pixels: array of pixels to be returned; the value (in/out) is passed as TGIS_Pixels 
              in _pixels.Value property
            _writable: if true then upon Unlock changes in locked pixel array will be populated 
              back to bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.LockPixels_TGIS_Pixels_Boolean
        """
        pass

    def MakeGlowing(
      self,
      _color: TGIS_Color,
      _size: int
    ) -> None: 
        """
        Add semitransparent "glowing" shadow to the bitmap.

        Args:
            _color: color of the glow; is semitransparent color provide, then glow will start 
              from semitransparency.
            _size: pixels with of the glow

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.MakeGlowing_TGIS_Color_Integer
        """
        pass

    def MakeTransparent(
      self
    ) -> None: 
        """
        Make bitmap transparent by replacing all pixels with same color as left-up corner 
        with TGIS_Color.None color (full ARGB transparency)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.MakeTransparent_void
        """
        pass

    def NativeFormat(
      self
    ) -> TGIS_BitmapFormat: 
        """
        Native format of bitmaps (ARGB or ABGR) for current platform

        Returns:
            format value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.NativeFormat_void
        """
        pass

    def NativeLineOrder(
      self
    ) -> TGIS_BitmapLinesOrder: 
        """
        Native line order of bitmaps (up-down or down-up) for current platform.

        Returns:
            line order value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.NativeLineOrder_void
        """
        pass

    def SaveToFile(
      self,
      _path: str
    ) -> None: 
        """
        Save bitmap to file.

        Args:
            _path: path to file

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.SaveToFile_String
        """
        pass

    @overload
    def SaveToStream(
      self,
      _stream: TObject
    ) -> None: 
        """
        Save bitmap to stream.

        Args:
            _stream: platform specific stream (like TStream for VCL)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.SaveToStream_TObject
        """
        pass

    @overload
    def SaveToStream(
      self,
      _stream: TObject,
      _format: TGIS_PixelFormat,
      _subformat: TGIS_PixelSubFormat,
      _compression: int
    ) -> None: 
        """
        Save bitmap to stream.

        Args:
            _stream: platform specific stream (like TStream for VCL)
            _format: pixel format
            _subformat: pixel subformat
            _compression: compression level

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.SaveToStream_TObject_TGIS_PixelFormat_TGIS_PixelSubFormat_Integer
        """
        pass

    def ScaleBitmap(
      self,
      _srcBmp: TGIS_Pixels,
      _srcWidth: int,
      _srcHeight: int,
      _dstBmp: TGIS_Pixels,
      _dstWidth: int,
      _dstHeight: int,
      _filtering: TGIS_ScalingFilter
    ) -> None: 
        """
        Scales bitmap using filtering

        Args:
            _srcBmp: source bitmap
            _srcWidth: with of bitmap in _srcBmp
            _srcHeight: height of bitmap in _srcBmp
            _dstBmp: destination bitmap
            _dstWidth: with of output bitmap in _dstBmp
            _dstHeight: height of output bitmap in _dstBmp
            _filtering: scaling resampling (filtering) method

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.ScaleBitmap_TGIS_Pixels_Integer_Integer_TGIS_Pixels_Integer_Integer_TGIS_ScalingFilter
        """
        pass

    def UnlockPixels(
      self
    ) -> None: 
        """
        Unlock pixels obtained by Lock() method. Post back any changes if Lock was writable.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.UnlockPixels_void
        """
        pass

    @property
    def BitmapFactory(
      self
    ) -> TGIS_BitmapFactory: 
        """
        Bitmap factory used to produce the bitmap data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.BitmapFactory
        """
        pass

    @property
    def Height(
      self
    ) -> int: 
        """
        Bitmap height in pixels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.Height
        """
        pass

    @property
    def IsEmpty(
      self
    ) -> bool: 
        """
        True if bitmap is empty (has no NativeBitmap attached.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.IsEmpty
        """
        pass

    @property
    def NativeBitmap(
      self
    ) -> TObject: 
        """
        Platform specific bitmap object (like TBitmap for VCL).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.NativeBitmap
        """
        pass

    @NativeBitmap.setter
    def NativeBitmap(
      self,
      _value: TObject
    ) -> None: 
        """
        Platform specific bitmap object (like TBitmap for VCL).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.NativeBitmap
        """
        pass

    @property
    def Path(
      self
    ) -> str: 
        """
        Path to bitmap (exits always for bitmap created form files).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.Path
        """
        pass

    @property
    def Premultiplied(
      self
    ) -> bool: 
        """
        True if bitmap should be treated as premultipied. Important only on some platforms.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.Premultiplied
        """
        pass

    @Premultiplied.setter
    def Premultiplied(
      self,
      _value: bool
    ) -> None: 
        """
        True if bitmap should be treated as premultipied. Important only on some platforms.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.Premultiplied
        """
        pass

    @property
    def Transparent(
      self
    ) -> bool: 
        """
        True if bitmap is transparent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.Transparent
        """
        pass

    @Transparent.setter
    def Transparent(
      self,
      _value: bool
    ) -> None: 
        """
        True if bitmap is transparent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.Transparent
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        Bitmap width in pixels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Bitmap.Width
        """
        pass

class TGIS_FontFactory:
    """
    Platform independent factory for platform dependent TGIS_Font object.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FontFactory
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FontFactory.Create_void
        """
        pass

    def DoCreate(
      self,
      _name: str,
      _size: int,
      _style: typing.Sequence[TGIS_FontStyle],
      _color: TGIS_Color
    ) -> TGIS_Font: 
        """
        Create font with a given specification.

        Args:
            _name: name of the font
            _size: size of the font in points
            _style: style of the font
            _color: color of the font

        Returns:
            created font

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FontFactory.DoCreate_String_Integer_TGIS_FontStyles_TGIS_Color
        """
        pass

    def DoCreateFromFont(
      self,
      _font: TObject
    ) -> TGIS_Font: 
        """
        Create font from platform specific font object.

        Args:
            _font: platform specific font (like TFont for VCL)

        Returns:
            created font

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_FontFactory.DoCreateFromFont_TObject
        """
        pass

class TGIS_GradientMap:
    """
    Structure of a gradient color ramp.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMap
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates a new color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMap.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _name: str,
      _map: TGIS_ColorMapArray,
      _submap: TGIS_ColorMapExArray,
      _mapType: TGIS_ColorSchema
    ) -> None: 
        """
        Creates a new color ramp.

        Args:
            _name: name of the map
            _map: array of ramp map (index-color)
            _submap: array of ramp map (class-colors)
            _mapType: type of color map

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMap.Create_String_TGIS_ColorMapArray_TGIS_ColorMapExArray_TGIS_ColorSchema
        """
        pass

    def NextColor(
      self
    ) -> TGIS_Color: 
        """
        Generates the next color from a default color ramp.

        Returns:
            color

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMap.NextColor_void
        """
        pass

    def RealizeColorMap(
      self,
      _mode: TGIS_ColorMapMode,
      _subClass: int,
      _reverse: bool
    ) -> TGIS_ColorMapArray: 
        """
        Prepares a colormap as requested.

        Args:
            _mode: colormap mode (continuous by default or discrete)
            _subClass: if available, gets subclass of a ramp with specified, or the possible 
              nearest to specified, number of colors; if 0, gets default colormap (this is the 
              default parameter);
            _reverse: if True, reverses colors from colormap (False is the default parameter);

        Returns:
            Array of a colormap.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMap.RealizeColorMap_TGIS_ColorMapMode_Integer_Boolean
        """
        pass

    def Reset(
      self
    ) -> None: 
        """
        Resets the internal color index.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMap.Reset_void
        """
        pass

    @property
    def Map(
      self
    ) -> TGIS_ColorMapArray: 
        """
        Assigned color array (range-color).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMap.Map
        """
        pass

    @property
    def MapType(
      self
    ) -> TGIS_ColorSchema: 
        """
        Map type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMap.MapType
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Unique name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMap.Name
        """
        pass

    @property
    def SubMap(
      self
    ) -> TGIS_ColorMapExArray: 
        """
        Assigned color array (class-colors).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMap.SubMap
        """
        pass

class TGIS_GradientMapUnique( TGIS_GradientMap ):
    """
    Structure of a gradient color ramp.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates a new color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _name: str,
      _mapType: TGIS_ColorSchema,
      _hMin: float,
      _hMax: float,
      _sMin: float,
      _sMax: float,
      _lMin: float,
      _lMax: float
    ) -> None: 
        """
        Creates a new dynamic color ramp in HSL color space.

        Args:
            _name: name of the map
            _mapType: type of color map
            _hMin: minimum hue, varies from 0 to 1
            _hMax: maximum hue, varies from 0 to 1
            _sMin: minimum saturation, varies from 0 to 1
            _sMax: maximum saturation, varies from 0 to 1
            _lMin: minimum lightness, varies from 0 to 1
            _lMax: maximum lightness, varies from 0 to 1

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.Create_String_TGIS_ColorSchema_Double_Double_Double_Double_Double_Double
        """
        pass

    @overload
    def __init__(
      self,
      _name: str,
      _mapType: TGIS_ColorSchema,
      _aMin: float,
      _aMax: float,
      _bMin: float,
      _bMax: float,
      _cMin: float,
      _cMax: float,
      _colorSpace: TGIS_ColorInterpolationMode
    ) -> None: 
        """
        Creates a new dynamic color ramp in specified color space.

        Args:
            _name: name of the map
            _mapType: type of color map
            _aMin: minimum value of the first color component
            _aMax: maximum value of the first color component
            _bMin: minimum value of the second color component
            _bMax: maximum value of the second color component
            _cMin: minimum value of the third color component
            _cMax: maximum value of the third color component
            _colorSpace: color space

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.Create_String_TGIS_ColorSchema_Double_Double_Double_Double_Double_Double_TGIS_ColorInterpolationMode
        """
        pass

    def CreateColorFromHue(
      self,
      _hue: float
    ) -> TGIS_Color: 
        """
        Creates a color based on the specified hue value.

        Args:
            _hue: hue; expected value: 0..1

        Returns:
            resulting color

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.CreateColorFromHue_Double
        """
        pass

    @property
    def BMax(
      self
    ) -> int: 
        """
        Maximum lightness, varies from 0 to 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.BMax
        """
        pass

    @property
    def BMin(
      self
    ) -> int: 
        """
        Minimum lightness, varies from 0 to 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.BMin
        """
        pass

    @property
    def CMax(
      self
    ) -> float: 
        """
        Maximum chroma, varies from 0 to 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.CMax
        """
        pass

    @property
    def CMin(
      self
    ) -> float: 
        """
        Minimum chroma, varies from 0 to 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.CMin
        """
        pass

    @property
    def GMax(
      self
    ) -> int: 
        """
        Maximum lightness, varies from 0 to 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.GMax
        """
        pass

    @property
    def GMin(
      self
    ) -> int: 
        """
        Minimum lightness, varies from 0 to 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.GMin
        """
        pass

    @property
    def HMax(
      self
    ) -> float: 
        """
        Maximum hue, varies from 0 to 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.HMax
        """
        pass

    @property
    def HMin(
      self
    ) -> float: 
        """
        Minimum hue, varies from 0 to 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.HMin
        """
        pass

    @property
    def LMax(
      self
    ) -> float: 
        """
        Maximum lightness, varies from 0 to 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.LMax
        """
        pass

    @property
    def LMin(
      self
    ) -> float: 
        """
        Minimum lightness, varies from 0 to 1 in HSL color space, or Minimum Luminance, varies 
        from 0 to 100 in HCL color space.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.LMin
        """
        pass

    @property
    def RMax(
      self
    ) -> int: 
        """
        Maximum lightness, varies from 0 to 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.RMax
        """
        pass

    @property
    def RMin(
      self
    ) -> int: 
        """
        Minimum lightness, varies from 0 to 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.RMin
        """
        pass

    @property
    def SMax(
      self
    ) -> float: 
        """
        Maximum saturation, varies from 0 to 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.SMax
        """
        pass

    @property
    def SMin(
      self
    ) -> float: 
        """
        Minimum saturation, varies from 0 to 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GradientMapUnique.SMin
        """
        pass

class TGIS_Color:
    """
    Platform independent color declaration.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Create_void
        """
        pass

    @classmethod
    def FromABGR(
      cls,
      _value: int
    ) -> TGIS_Color: 
        """
        Creates a transparent color using the BGR color model.

        Args:
            _value: color value as 4 byte little endian integer; bytes from most significant 
              are: Alpha, Blue, Green, Blue

        Returns:
            Created color

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.FromABGR_Cardinal
        """
        pass

    @classmethod
    def FromACMYK(
      cls,
      _a: float,
      _c: float,
      _m: float,
      _y: float,
      _k: float
    ) -> TGIS_Color: 
        """
        Creates a transparent color with alpha using the CMYK color model.

        Args:
            _a: alpha; expected value: 0..1
            _c: cyan; expected value: 0..1
            _m: magenta; expected value: 0..1
            _y: yellow; expected value: 0..1
            _k: key (black); expected value: 0..1

        Returns:
            Created color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.FromACMYK_Single_Single_Single_Single_Single
        """
        pass

    @classmethod
    def FromAHCL(
      cls,
      _a: float,
      _h: float,
      _c: float,
      _l: float
    ) -> TGIS_Color: 
        """
        Creates a transparent color using the HCL color model.

        Args:
            _a: alpha; expected value: 0..1
            _h: hue; expected value: 0..1
            _c: chroma; expected value: 0..1.5
            _l: luminance; expected value: 0..1

        Returns:
            Created color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.FromAHCL_Double_Double_Double_Double
        """
        pass

    @classmethod
    def FromAHSL(
      cls,
      _a: float,
      _h: float,
      _s: float,
      _l: float
    ) -> TGIS_Color: 
        """
        Creates a transparent color using the HSL color model.

        Args:
            _a: alpha; expected value: 0..1
            _h: hue; expected value: 0..1
            _s: saturation; expected value: 0..1
            _l: luminance; expected value: 0..1

        Returns:
            Created color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.FromAHSL_Single_Single_Single_Single
        """
        pass

    @classmethod
    def FromAHSV(
      cls,
      _a: float,
      _h: float,
      _s: float,
      _v: float
    ) -> TGIS_Color: 
        """
        Creates a transparent color using the HSV color model.

        Args:
            _a: alpha; expected value: 0..1
            _h: hue; expected value: 0..1
            _s: saturation; expected value: 0..1
            _v: value (brightness); expected value: 0..1

        Returns:
            Created color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.FromAHSV_Single_Single_Single_Single
        """
        pass

    @overload
    @classmethod
    def FromARGB(
      cls,
      _a: int,
      _r: int,
      _g: int,
      _b: int
    ) -> TGIS_Color: 
        """
        Creates a transparent color using the RGB color model.

        Args:
            _a: alpha; expected value: 0..255
            _r: red; expected value: 0..255
            _g: green; expected value: 0..255
            _b: blue; expected value: 0..255

        Returns:
            Created color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.FromARGB_Byte_Byte_Byte_Byte
        """
        pass

    @overload
    @classmethod
    def FromARGB(
      cls,
      _value: int
    ) -> TGIS_Color: 
        """
        Creates a transparent color using RGB color model.

        Args:
            _value: color value as 4 byte little endian integer; bytes from most significant 
              are: alpha, red, green, blue

        Returns:
            Created color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.FromARGB_Cardinal
        """
        pass

    @overload
    @classmethod
    def FromBGR(
      cls,
      _value: int
    ) -> TGIS_Color: 
        """
        Creates a color using the BGR color model.

        Args:
            _value: color value as 4 byte little endian integer; bytes from most significant 
              are: Ignored, Blue, Green, Red

        Returns:
            Created color

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.FromBGR_Cardinal
        """
        pass

    @overload
    @classmethod
    def FromBGR(
      cls,
      _b: int,
      _g: int,
      _r: int
    ) -> TGIS_Color: 
        """
        Creates a color using the BGR color model.

        Args:
            _b: blue; expected value: 0..255
            _g: green; expected value: 0..255
            _r: red; expected value: 0..255

        Returns:
            Created color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.FromBGR_Byte_Byte_Byte
        """
        pass

    @classmethod
    def FromCMYK(
      cls,
      _c: float,
      _m: float,
      _y: float,
      _k: float
    ) -> TGIS_Color: 
        """
        Creates a color using the CMYK color model.

        Args:
            _c: cyan; expected value: 0..1
            _m: magenta; expected value: 0..1
            _y: yellow; expected value: 0..1
            _k: key (black); expected value: 0..1

        Returns:
            Created color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.FromCMYK_Single_Single_Single_Single
        """
        pass

    @classmethod
    def FromHCL(
      cls,
      _h: float,
      _c: float,
      _l: float
    ) -> TGIS_Color: 
        """
        Creates a color using the HCL color model.

        Args:
            _h: hue; expected value: 0..1
            _c: chroma; expected value: 0..1.5
            _l: luminance; expected value: 0..1

        Returns:
            Created color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.FromHCL_Double_Double_Double
        """
        pass

    @classmethod
    def FromHSL(
      cls,
      _h: float,
      _s: float,
      _l: float
    ) -> TGIS_Color: 
        """
        Creates a color using the HSL color model.

        Args:
            _h: hue; expected value: 0..1
            _s: saturation; expected value: 0..1
            _l: luminance; expected value: 0..1

        Returns:
            Created color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.FromHSL_Single_Single_Single
        """
        pass

    @classmethod
    def FromHSV(
      cls,
      _h: float,
      _s: float,
      _v: float
    ) -> TGIS_Color: 
        """
        Creates a color using the HSV color model.

        Args:
            _h: hue; expected value: 0..1
            _s: saturation; expected value: 0..1
            _v: value (brightness); expected value: 0..1

        Returns:
            Created color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.FromHSV_Single_Single_Single
        """
        pass

    @overload
    @classmethod
    def FromRGB(
      cls,
      _r: int,
      _g: int,
      _b: int
    ) -> TGIS_Color: 
        """
        Creates a color using the RGB color model.

        Args:
            _r: red; expected value: 0..255
            _g: green; expected value: 0..255
            _b: blue; expected value: 0..255

        Returns:
            Created color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.FromRGB_Byte_Byte_Byte
        """
        pass

    @overload
    @classmethod
    def FromRGB(
      cls,
      _value: int
    ) -> TGIS_Color: 
        """
        Creates a color using the RGB color model.

        Args:
            _value: color value as 4 byte little endian integer; bytes from most significant 
              are: ignored, red, green, nlue

        Returns:
            Created color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.FromRGB_Cardinal
        """
        pass

    @classmethod
    def FromString(
      cls,
      _value: str
    ) -> TGIS_Color: 
        """
        Creates a color using the hex string.

        Args:
            _value: a CSS string representation of a color; see remarks:

        Returns:
            Created color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.FromString_String
        """
        pass

    def ToABGR(
      self
    ) -> int: 
        """
        Converts a color to an integer in the ABGR form.

        Returns:
            Color value as 4 byte little endian integer; bytes from most significant are: Alpha, 
            Blue, Green, Blue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.ToABGR_void
        """
        pass

    def ToACMYK(
      self,
      _a: VarParameter,
      _c: VarParameter,
      _m: VarParameter,
      _y: VarParameter,
      _k: VarParameter
    ) -> None: 
        """
        Retrieves the alpha (A), cyan (C), magenta (M), yellow (Y), and black (K) components 
        of the current color.

        Args:
            _a: alpha, varies from 0 to 1; the value (in/out) is passed as float in _a.Value 
              property
            _c: cyan; expected value: 0..1; the value (in/out) is passed as float in _c.Value 
              property
            _m: magenta; expected value: 0..1; the value (in/out) is passed as float in _m.Value 
              property
            _y: yellow; expected value: 0..1; the value (in/out) is passed as float in _y.Value 
              property
            _k: key (black); expected value: 0..1; the value (in/out) is passed as float in _k.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.ToACMYK_Double_Double_Double_Double_Double
        """
        pass

    def ToAHCL(
      self,
      _a: VarParameter,
      _h: VarParameter,
      _c: VarParameter,
      _l: VarParameter
    ) -> None: 
        """
        Retrieves the alpha (A), hue (H), chroma (C) and luminance (L) components of the 
        current color.

        Args:
            _a: alpha, varies from 0 to 1; the value (in/out) is passed as float in _a.Value 
              property
            _h: hue, varies from 0 to 1; the value (in/out) is passed as float in _h.Value property
            _c: chroma, varies from 0 to 1.5; the value (in/out) is passed as float in _c.Value 
              property
            _l: luminance, varies from 0 to 1; the value (in/out) is passed as float in _l.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.ToAHCL_Double_Double_Double_Double
        """
        pass

    def ToAHSL(
      self,
      _a: VarParameter,
      _h: VarParameter,
      _s: VarParameter,
      _l: VarParameter
    ) -> None: 
        """
        Retrieves the alpha (A), hue (H), saturation (S) and lightness (L) components of 
        the current color.

        Args:
            _a: alpha, varies from 0 to 1; the value (in/out) is passed as float in _a.Value 
              property
            _h: hue, varies from 0 to 1; the value (in/out) is passed as float in _h.Value property
            _s: saturation, varies from 0 to 1; the value (in/out) is passed as float in _s.Value 
              property
            _l: lightness, varies from 0 to 1; the value (in/out) is passed as float in _l.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.ToAHSL_Double_Double_Double_Double
        """
        pass

    def ToAHSV(
      self,
      _a: VarParameter,
      _h: VarParameter,
      _s: VarParameter,
      _v: VarParameter
    ) -> None: 
        """
        Retrieves the alpha (A), hue (H), saturation (S) and value (V) components of the 
        current color.

        Args:
            _a: alpha, varies from 0 to 1; the value (in/out) is passed as float in _a.Value 
              property
            _h: hue, varies from 0 to 1; the value (in/out) is passed as float in _h.Value property
            _s: saturation, varies from 0 to 1; the value (in/out) is passed as float in _s.Value 
              property
            _v: value (brightness), varies from 0 to 1; the value (in/out) is passed as float 
              in _v.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.ToAHSV_Double_Double_Double_Double
        """
        pass

    def ToARGB(
      self
    ) -> int: 
        """
        Converts a color to an integer in the ABGR form.

        Returns:
            Color value as 4 byte little endian integer; bytes from most significant are: alpha, 
            red, green, blue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.ToARGB_void
        """
        pass

    def ToBGR(
      self
    ) -> int: 
        """
        Converts a color to an integer in the BGR form.

        Returns:
            Color value as 4 byte little endian integer; bytes from most significant are: 0, 
            Blue, Green, Red.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.ToBGR_void
        """
        pass

    def ToCMYK(
      self,
      _c: VarParameter,
      _m: VarParameter,
      _y: VarParameter,
      _k: VarParameter
    ) -> None: 
        """
        Retrieves the cyan (C), magenta (M), yellow (Y), and black (K) components of the 
        current color.

        Args:
            _c: cyan; expected value: 0..1; the value (in/out) is passed as float in _c.Value 
              property
            _m: magenta; expected value: 0..1; the value (in/out) is passed as float in _m.Value 
              property
            _y: yellow; expected value: 0..1; the value (in/out) is passed as float in _y.Value 
              property
            _k: key (black); expected value: 0..1; the value (in/out) is passed as float in _k.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.ToCMYK_Double_Double_Double_Double
        """
        pass

    def ToHCL(
      self,
      _h: VarParameter,
      _c: VarParameter,
      _l: VarParameter
    ) -> None: 
        """
        Retrieves the alpha (A), hue (H), chroma (C) and luminance (L) components of the 
        current color.

        Args:
            _h: hue, varies from 0 to 1; the value (in/out) is passed as float in _h.Value property
            _c: chroma, varies from 0 to 1.5; the value (in/out) is passed as float in _c.Value 
              property
            _l: luminance, varies from 0 to 1; the value (in/out) is passed as float in _l.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.ToHCL_Double_Double_Double
        """
        pass

    def ToHSL(
      self,
      _h: VarParameter,
      _s: VarParameter,
      _l: VarParameter
    ) -> None: 
        """
        Retrieves the hue (H), saturation (S) and lightness (L) components of the current 
        color.

        Args:
            _h: hue, varies from 0 to 1; the value (in/out) is passed as float in _h.Value property
            _s: saturation, varies from 0 to 1; the value (in/out) is passed as float in _s.Value 
              property
            _l: lightness, varies from 0 to 1; the value (in/out) is passed as float in _l.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.ToHSL_Double_Double_Double
        """
        pass

    def ToHSV(
      self,
      _h: VarParameter,
      _s: VarParameter,
      _v: VarParameter
    ) -> None: 
        """
        Retrieves the hue (H), saturation (S) and value (V) components of the current color.

        Args:
            _h: hue, varies from 0 to 1; the value (in/out) is passed as float in _h.Value property
            _s: saturation, varies from 0 to 1; the value (in/out) is passed as float in _s.Value 
              property
            _v: value/brightness, varies from 0 to 1; the value (in/out) is passed as float in 
              _v.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.ToHSV_Double_Double_Double
        """
        pass

    def ToRGB(
      self
    ) -> int: 
        """
        Converts a color to an integer in the RGB form.

        Returns:
            Color value as 4 byte little endian integer; bytes from most significant are: 0, 
            red, green, blue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.ToRGB_void
        """
        pass

    def ToString(
      self,
      _addAlpha: bool,
      _addHash: bool
    ) -> str: 
        """
        Converts the color to a hexadecimal string.

        Args:
            _addAlpha: if true, the result string will contain an alpha value (this is default); 
              otherwise only RGB values will be returned
            _addHash: if True, the result string will contain the hash (#) symbol at the beginning; 
              False is default value

        Returns:
            Hexadecimal color representation as a string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.ToString_Boolean_Boolean
        """
        pass

    @classmethod
    def TryFromString(
      cls,
      _value: str,
      _color: VarParameter
    ) -> bool: 
        """
        Tries to create a color using the hex string.

        Args:
            _value: a CSS string representation of a color; see remarks:
            _color: a variable to assign a created color; the value (in/out) is passed as TGIS_Color 
              in _color.Value property

        Returns:
            True if _hexString represents a valid color; otherwise False

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.TryFromString_String_TGIS_Color
        """
        pass

    @property
    def ARGB(
      self
    ) -> int: 
        """
        Internal representation as little endian ARGB integer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.ARGB
        """
        pass

    @ARGB.setter
    def ARGB(
      self,
      _value: int
    ) -> None: 
        """
        Internal representation as little endian ARGB integer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.ARGB
        """
        pass

    @property
    def A(
      self
    ) -> int: 
        """
        Extracts Alpha part of color ARGB definition.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.A
        """
        pass

    @property
    def Aqua(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ff00ffff.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Aqua
        """
        pass

    @property
    def B(
      self
    ) -> int: 
        """
        Extracts Blue part of ARGB color definition.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.B
        """
        pass

    @property
    def Black(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ff000000.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Black
        """
        pass

    @property
    def Blue(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ff0000ff.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Blue
        """
        pass

    @property
    def Crazy(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $00010816.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Crazy
        """
        pass

    @property
    def DimGray(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ff696969.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.DimGray
        """
        pass

    @property
    def Fuchsia(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ffff00ff.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Fuchsia
        """
        pass

    @property
    def G(
      self
    ) -> int: 
        """
        Extracts Green part of ARGB color definition.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.G
        """
        pass

    @property
    def Gray(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ff808080.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Gray
        """
        pass

    @property
    def Green(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ff008000.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Green
        """
        pass

    @property
    def H(
      self
    ) -> float: 
        """
        Extracts Hue part of HSL color definition.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.H
        """
        pass

    @property
    def L(
      self
    ) -> float: 
        """
        Extracts Luminescence part of HSL color definition.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.L
        """
        pass

    @property
    def LightGray(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ffd3d3d3.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.LightGray
        """
        pass

    @property
    def Lime(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ff00ff00.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Lime
        """
        pass

    @property
    def Maroon(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ff800000.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Maroon
        """
        pass

    @property
    def Navy(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ff000080.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Navy
        """
        pass

    @property
    def None_(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color.
        
        Use this color as "not defined" color (it constitute transparent color).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.None
        """
        pass

    @property
    def Olive(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ff808000.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Olive
        """
        pass

    @property
    def Purple(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ff800080.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Purple
        """
        pass

    @property
    def R(
      self
    ) -> int: 
        """
        Extracts Red part of ARGB color definition.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.R
        """
        pass

    @property
    def Red(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ffff0000.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Red
        """
        pass

    @property
    def RenderColor(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $00ff9933.
        
        Use this color to mark feature that render must be used to color it.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.RenderColor
        """
        pass

    @property
    def S(
      self
    ) -> float: 
        """
        Extracts Saturation part of HSL color definition.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.S
        """
        pass

    @property
    def Silver(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ffc0c0c0.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Silver
        """
        pass

    @property
    def Teal(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ff008080.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Teal
        """
        pass

    @property
    def White(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ffffffff.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.White
        """
        pass

    @property
    def Yellow(
      self
    ) -> TGIS_Color: 
        """
        Constructs a standard color - $ffffff00.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Color.Yellow
        """
        pass

class TGIS_Pixels:
    """
    Platform independent storage for pixels as 32bit array (for ARGB support)

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pixels
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> Cardinal:
        pass

    def __setitem__(
      self,
      index : int,
      value : Cardinal
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pixels.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pixels.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pixels.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> int: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pixels.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: int
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Pixels.Value
        """
        pass

class TGIS_ColorArray:
    """
    Array of TGIS_Color.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_Color:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_Color
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorArray.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorArray.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorArray.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> TGIS_Color: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorArray.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: TGIS_Color
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorArray.Value
        """
        pass

class TGIS_DashArray:
    """
    Array of Single.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DashArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> Single:
        pass

    def __setitem__(
      self,
      index : int,
      value : Single
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DashArray.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DashArray.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DashArray.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> float: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DashArray.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: float
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_DashArray.Value
        """
        pass

class TGIS_ColorMap:
    """
    Array of color map for ramps.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMap
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMap.Create_void
        """
        pass

    @property
    def Index(
      self
    ) -> float: 
        """
        Range value related with RGB color, normalized to 0-100.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMap.Index
        """
        pass

    @Index.setter
    def Index(
      self,
      _value: float
    ) -> None: 
        """
        Range value related with RGB color, normalized to 0-100.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMap.Index
        """
        pass

    @property
    def RGB(
      self
    ) -> TGIS_Color: 
        """
        Color assigned to given range.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMap.RGB
        """
        pass

    @RGB.setter
    def RGB(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Color assigned to given range.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMap.RGB
        """
        pass

class TGIS_ColorMapEx:
    """
    Array of color map for ramps.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapEx
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapEx.Create_void
        """
        pass

    @property
    def Index(
      self
    ) -> int: 
        """
        Class value related with ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapEx.Index
        """
        pass

    @Index.setter
    def Index(
      self,
      _value: int
    ) -> None: 
        """
        Class value related with ramp.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapEx.Index
        """
        pass

    @property
    def Colors(
      self
    ) -> TGIS_ColorArray: 
        """
        Colors assigned to given class.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapEx.Colors
        """
        pass

    @Colors.setter
    def Colors(
      self,
      _value: TGIS_ColorArray
    ) -> None: 
        """
        Colors assigned to given class.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapEx.Colors
        """
        pass

class TGIS_ColorMapArray:
    """
    Array of TGIS_ColorMap.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_ColorMap:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_ColorMap
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapArray.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapArray.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapArray.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> TGIS_ColorMap: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapArray.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: TGIS_ColorMap
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapArray.Value
        """
        pass

class TGIS_ColorMapExArray:
    """
    Array of TGIS_ColorMap.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapExArray
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_ColorMapEx:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_ColorMapEx
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapExArray.Create_void
        """
        pass

    def SetLength(
      self,
      _size: int
    ) -> None: 
        """
        Set array size.

        Args:
            _size: array size

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapExArray.SetLength_Integer
        """
        pass

    @property
    def Length(
      self
    ) -> int: 
        """
        Array size.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapExArray.Length
        """
        pass

    
    def Value(
      self,
      _idx: int
    ) -> TGIS_ColorMapEx: 
        """
        Array element value.

        Args:
            _idx: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapExArray.Value
        """
        pass

    
    def Value(
      self,
      _idx: int,
      _value: TGIS_ColorMapEx
    ) -> None: 
        """
        Array element value.

        Args:
            _idx: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorMapExArray.Value
        """
        pass

class TGIS_ColorRampNames:
    """
    Represents a collection of predefined color ramp names. This class provides a list 
    of color ramp names to be used with TGIS_Utils.GisColorRampList.ByName method.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Create_void
        """
        pass

    @property
    def Accent(
      self
    ) -> str: 
        """
        ''Accent'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Accent
        """
        pass

    @property
    def Arctic(
      self
    ) -> str: 
        """
        ''Arctic'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Arctic
        """
        pass

    @property
    def Aspect(
      self
    ) -> str: 
        """
        ''Aspect'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Aspect
        """
        pass

    @property
    def Autumn(
      self
    ) -> str: 
        """
        ''Autumn'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Autumn
        """
        pass

    @property
    def Bathymetry1(
      self
    ) -> str: 
        """
        ''Bathymetry1'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Bathymetry1
        """
        pass

    @property
    def Bathymetry2(
      self
    ) -> str: 
        """
        ''Bathymetry2'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Bathymetry2
        """
        pass

    @property
    def BathymetryWarm(
      self
    ) -> str: 
        """
        ''BathymetryWarm'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.BathymetryWarm
        """
        pass

    @property
    def BlackWhite(
      self
    ) -> str: 
        """
        ''BlackWhite'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.BlackWhite
        """
        pass

    @property
    def BlueGreen(
      self
    ) -> str: 
        """
        ''BlueGreen'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.BlueGreen
        """
        pass

    @property
    def BluePurple(
      self
    ) -> str: 
        """
        ''BluePurple'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.BluePurple
        """
        pass

    @property
    def BlueRed(
      self
    ) -> str: 
        """
        ''BlueRed'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.BlueRed
        """
        pass

    @property
    def Blues1(
      self
    ) -> str: 
        """
        ''Blues1'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Blues1
        """
        pass

    @property
    def Blues2(
      self
    ) -> str: 
        """
        ''Blues2'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Blues2
        """
        pass

    @property
    def BlueSteel(
      self
    ) -> str: 
        """
        ''BlueSteel'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.BlueSteel
        """
        pass

    @property
    def BrownBlue(
      self
    ) -> str: 
        """
        ''BrownBlue'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.BrownBlue
        """
        pass

    @property
    def BrownGreen(
      self
    ) -> str: 
        """
        ''BrownGreen'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.BrownGreen
        """
        pass

    @property
    def BrownYellow(
      self
    ) -> str: 
        """
        ''BrownYellow'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.BrownYellow
        """
        pass

    @property
    def Carnival(
      self
    ) -> str: 
        """
        ''Carnival'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Carnival
        """
        pass

    @property
    def CBF_Bright(
      self
    ) -> str: 
        """
        ''CBF-Bright'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_Bright
        """
        pass

    @property
    def CBF_Dark(
      self
    ) -> str: 
        """
        ''CBF-Dark'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_Dark
        """
        pass

    @property
    def CBF_Deuteranopia12(
      self
    ) -> str: 
        """
        ''CBF-Deuteranopia12'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_Deuteranopia12
        """
        pass

    @property
    def CBF_Deuteranopia15(
      self
    ) -> str: 
        """
        ''CBF-Deuteranopia15'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_Deuteranopia15
        """
        pass

    @property
    def CBF_Deuteranopia8(
      self
    ) -> str: 
        """
        ''CBF-Deuteranopia8'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_Deuteranopia8
        """
        pass

    @property
    def CBF_HighContrast(
      self
    ) -> str: 
        """
        ''CBF-HighContrast'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_HighContrast
        """
        pass

    @property
    def CBF_IBM(
      self
    ) -> str: 
        """
        ''CBF-IBM'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_IBM
        """
        pass

    @property
    def CBF_Incandescent(
      self
    ) -> str: 
        """
        ''CBF-Incandescent'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_Incandescent
        """
        pass

    @property
    def CBF_Iridescent(
      self
    ) -> str: 
        """
        ''CBF-Iridescent'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_Iridescent
        """
        pass

    @property
    def CBF_LandCover(
      self
    ) -> str: 
        """
        ''CBF-LandCover'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_LandCover
        """
        pass

    @property
    def CBF_Light(
      self
    ) -> str: 
        """
        ''CBF-Light'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_Light
        """
        pass

    @property
    def CBF_MediumContrast(
      self
    ) -> str: 
        """
        ''CBF-MediumContrast'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_MediumContrast
        """
        pass

    @property
    def CBF_Muted(
      self
    ) -> str: 
        """
        ''CBF-Muted'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_Muted
        """
        pass

    @property
    def CBF_OkabeIto(
      self
    ) -> str: 
        """
        ''CBF-OkabeIto'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_OkabeIto
        """
        pass

    @property
    def CBF_Pale(
      self
    ) -> str: 
        """
        ''CBF-Pale'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_Pale
        """
        pass

    @property
    def CBF_RainbowDiscrete14(
      self
    ) -> str: 
        """
        ''CBF-RainbowDiscrete14'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_RainbowDiscrete14
        """
        pass

    @property
    def CBF_RainbowDiscrete29(
      self
    ) -> str: 
        """
        ''CBF-RainbowDiscrete29'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_RainbowDiscrete29
        """
        pass

    @property
    def CBF_RainbowSmooth(
      self
    ) -> str: 
        """
        ''CBF-RainbowSmooth'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_RainbowSmooth
        """
        pass

    @property
    def CBF_Sunset(
      self
    ) -> str: 
        """
        ''CBF-Sunset'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_Sunset
        """
        pass

    @property
    def CBF_Vibrant(
      self
    ) -> str: 
        """
        ''CBF-Vibrant'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CBF_Vibrant
        """
        pass

    @property
    def ChromaDepth(
      self
    ) -> str: 
        """
        ''ChromaDepth'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.ChromaDepth
        """
        pass

    @property
    def Cividis(
      self
    ) -> str: 
        """
        ''Cividis'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Cividis
        """
        pass

    @property
    def Cold(
      self
    ) -> str: 
        """
        ''Cold'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Cold
        """
        pass

    @property
    def CoolWarm(
      self
    ) -> str: 
        """
        ''CoolWarm'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CoolWarm
        """
        pass

    @property
    def Copper(
      self
    ) -> str: 
        """
        ''Copper'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Copper
        """
        pass

    @property
    def CottonCandy(
      self
    ) -> str: 
        """
        ''CottonCandy'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CottonCandy
        """
        pass

    @property
    def Cubehelix(
      self
    ) -> str: 
        """
        ''Cubehelix'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Cubehelix
        """
        pass

    @property
    def CurrentDir(
      self
    ) -> str: 
        """
        ''CurrentDir'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CurrentDir
        """
        pass

    @property
    def CurrentVelocity(
      self
    ) -> str: 
        """
        ''CurrentVelocity'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.CurrentVelocity
        """
        pass

    @property
    def Curvature(
      self
    ) -> str: 
        """
        ''Curvature'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Curvature
        """
        pass

    @property
    def Dark(
      self
    ) -> str: 
        """
        ''Dark'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Dark
        """
        pass

    @property
    def DEMPrint(
      self
    ) -> str: 
        """
        ''DEMPrint'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.DEMPrint
        """
        pass

    @property
    def DEMScreen(
      self
    ) -> str: 
        """
        ''DEMScreen'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.DEMScreen
        """
        pass

    @property
    def Desert(
      self
    ) -> str: 
        """
        ''Desert'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Desert
        """
        pass

    @property
    def Desertification(
      self
    ) -> str: 
        """
        ''Desertification'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Desertification
        """
        pass

    @property
    def DireActive(
      self
    ) -> str: 
        """
        ''DireActive'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.DireActive
        """
        pass

    @property
    def Dirt(
      self
    ) -> str: 
        """
        ''Dirt'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Dirt
        """
        pass

    @property
    def DryWet(
      self
    ) -> str: 
        """
        ''DryWet'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.DryWet
        """
        pass

    @property
    def Earth(
      self
    ) -> str: 
        """
        ''Earth'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Earth
        """
        pass

    @property
    def Elevation1(
      self
    ) -> str: 
        """
        ''Elevation1'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Elevation1
        """
        pass

    @property
    def Elevation2(
      self
    ) -> str: 
        """
        ''Elevation2'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Elevation2
        """
        pass

    @property
    def Elevation3(
      self
    ) -> str: 
        """
        ''Elevation3'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Elevation3
        """
        pass

    @property
    def ElevationDark(
      self
    ) -> str: 
        """
        ''ElevationDark'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.ElevationDark
        """
        pass

    @property
    def EqualMixed(
      self
    ) -> str: 
        """
        ''EqualMixed'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.EqualMixed
        """
        pass

    @property
    def Exploration(
      self
    ) -> str: 
        """
        ''Exploration'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Exploration
        """
        pass

    @property
    def Flag(
      self
    ) -> str: 
        """
        ''Flag'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Flag
        """
        pass

    @property
    def Forecast(
      self
    ) -> str: 
        """
        ''Forecast'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Forecast
        """
        pass

    @property
    def Forest(
      self
    ) -> str: 
        """
        ''Forest'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Forest
        """
        pass

    @property
    def Geology(
      self
    ) -> str: 
        """
        ''Geology'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Geology
        """
        pass

    @property
    def GlobalWarming(
      self
    ) -> str: 
        """
        ''GlobalWarming'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.GlobalWarming
        """
        pass

    @property
    def Globe(
      self
    ) -> str: 
        """
        ''Globe'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Globe
        """
        pass

    @property
    def Gnuplot(
      self
    ) -> str: 
        """
        ''Gnuplot'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Gnuplot
        """
        pass

    @property
    def Gravity1(
      self
    ) -> str: 
        """
        ''Gravity1'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Gravity1
        """
        pass

    @property
    def Gravity2(
      self
    ) -> str: 
        """
        ''Gravity2'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Gravity2
        """
        pass

    @property
    def GreenBlue(
      self
    ) -> str: 
        """
        ''GreenBlue'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.GreenBlue
        """
        pass

    @property
    def Greens1(
      self
    ) -> str: 
        """
        ''Greens1'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Greens1
        """
        pass

    @property
    def Greens2(
      self
    ) -> str: 
        """
        ''Greens2'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Greens2
        """
        pass

    @property
    def Greys(
      self
    ) -> str: 
        """
        ''Greys'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Greys
        """
        pass

    @property
    def Heat(
      self
    ) -> str: 
        """
        ''Heat'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Heat
        """
        pass

    @property
    def HighPoints1(
      self
    ) -> str: 
        """
        ''HighPoints1'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.HighPoints1
        """
        pass

    @property
    def HighPoints2(
      self
    ) -> str: 
        """
        ''HighPoints2'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.HighPoints2
        """
        pass

    @property
    def Hot(
      self
    ) -> str: 
        """
        ''Hot'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Hot
        """
        pass

    @property
    def Humidity(
      self
    ) -> str: 
        """
        ''Humidity'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Humidity
        """
        pass

    @property
    def Ice1(
      self
    ) -> str: 
        """
        ''Ice1'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Ice1
        """
        pass

    @property
    def Ice2(
      self
    ) -> str: 
        """
        ''Ice2'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Ice2
        """
        pass

    @property
    def Icefire(
      self
    ) -> str: 
        """
        ''Icefire'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Icefire
        """
        pass

    @property
    def Inferno(
      self
    ) -> str: 
        """
        ''Inferno'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Inferno
        """
        pass

    @property
    def Jet(
      self
    ) -> str: 
        """
        ''Jet'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Jet
        """
        pass

    @property
    def Land1(
      self
    ) -> str: 
        """
        ''Land1'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Land1
        """
        pass

    @property
    def Land2(
      self
    ) -> str: 
        """
        ''Land2'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Land2
        """
        pass

    @property
    def LandAmerica(
      self
    ) -> str: 
        """
        ''LandAmerica'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.LandAmerica
        """
        pass

    @property
    def LandArid(
      self
    ) -> str: 
        """
        ''LandArid'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.LandArid
        """
        pass

    @property
    def LandEurope(
      self
    ) -> str: 
        """
        ''LandEurope'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.LandEurope
        """
        pass

    @property
    def LandSea(
      self
    ) -> str: 
        """
        ''LandSea'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.LandSea
        """
        pass

    @property
    def Magma(
      self
    ) -> str: 
        """
        ''Magma'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Magma
        """
        pass

    @property
    def Mako(
      self
    ) -> str: 
        """
        ''Mako'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Mako
        """
        pass

    @property
    def Ocean1(
      self
    ) -> str: 
        """
        ''Ocean1'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Ocean1
        """
        pass

    @property
    def Ocean2(
      self
    ) -> str: 
        """
        ''Ocean2'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Ocean2
        """
        pass

    @property
    def OrangePurple(
      self
    ) -> str: 
        """
        ''OrangePurple'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.OrangePurple
        """
        pass

    @property
    def OrangeRed(
      self
    ) -> str: 
        """
        ''OrangeRed'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.OrangeRed
        """
        pass

    @property
    def Oranges(
      self
    ) -> str: 
        """
        ''Oranges'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Oranges
        """
        pass

    @property
    def Paired(
      self
    ) -> str: 
        """
        ''Paired'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Paired
        """
        pass

    @property
    def Pastel1(
      self
    ) -> str: 
        """
        ''Pastel1'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Pastel1
        """
        pass

    @property
    def Pastel2(
      self
    ) -> str: 
        """
        ''Pastel2'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Pastel2
        """
        pass

    @property
    def Pastel3(
      self
    ) -> str: 
        """
        ''Pastel3'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Pastel3
        """
        pass

    @property
    def Pastel4(
      self
    ) -> str: 
        """
        ''Pastel4'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Pastel4
        """
        pass

    @property
    def Pink(
      self
    ) -> str: 
        """
        ''Pink'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Pink
        """
        pass

    @property
    def PinkGreen(
      self
    ) -> str: 
        """
        ''PinkGreen'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.PinkGreen
        """
        pass

    @property
    def Plasma(
      self
    ) -> str: 
        """
        ''Plasma'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Plasma
        """
        pass

    @property
    def Prism(
      self
    ) -> str: 
        """
        ''Prism'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Prism
        """
        pass

    @property
    def PurpleBlue(
      self
    ) -> str: 
        """
        ''PurpleBlue'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.PurpleBlue
        """
        pass

    @property
    def PurpleBlueGreen(
      self
    ) -> str: 
        """
        ''PurpleBlueGreen'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.PurpleBlueGreen
        """
        pass

    @property
    def PurpleGreen1(
      self
    ) -> str: 
        """
        ''PurpleGreen1'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.PurpleGreen1
        """
        pass

    @property
    def PurpleGreen2(
      self
    ) -> str: 
        """
        ''PurpleGreen2'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.PurpleGreen2
        """
        pass

    @property
    def PurpleRed(
      self
    ) -> str: 
        """
        ''PurpleRed'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.PurpleRed
        """
        pass

    @property
    def Purples(
      self
    ) -> str: 
        """
        ''Purples'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Purples
        """
        pass

    @property
    def Rainbow1(
      self
    ) -> str: 
        """
        ''Rainbow1'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Rainbow1
        """
        pass

    @property
    def Rainbow2(
      self
    ) -> str: 
        """
        ''Rainbow2'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Rainbow2
        """
        pass

    @property
    def Rainbow3(
      self
    ) -> str: 
        """
        ''Rainbow3'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Rainbow3
        """
        pass

    @property
    def Rainbow4(
      self
    ) -> str: 
        """
        ''Rainbow4'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Rainbow4
        """
        pass

    @property
    def Rainbow5(
      self
    ) -> str: 
        """
        ''Rainbow5'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Rainbow5
        """
        pass

    @property
    def RainbowLight(
      self
    ) -> str: 
        """
        ''RainbowLight'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.RainbowLight
        """
        pass

    @property
    def RainbowPastel(
      self
    ) -> str: 
        """
        ''RainbowPastel'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.RainbowPastel
        """
        pass

    @property
    def RedBlue(
      self
    ) -> str: 
        """
        ''RedBlue'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.RedBlue
        """
        pass

    @property
    def RedGray(
      self
    ) -> str: 
        """
        ''RedGray'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.RedGray
        """
        pass

    @property
    def RedHot(
      self
    ) -> str: 
        """
        ''RedHot'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.RedHot
        """
        pass

    @property
    def RedPurple(
      self
    ) -> str: 
        """
        ''RedPurple'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.RedPurple
        """
        pass

    @property
    def Reds(
      self
    ) -> str: 
        """
        ''Reds'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Reds
        """
        pass

    @property
    def RedYellowBlue(
      self
    ) -> str: 
        """
        ''RedYellowBlue'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.RedYellowBlue
        """
        pass

    @property
    def RedYellowGreen(
      self
    ) -> str: 
        """
        ''RedYellowGreen'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.RedYellowGreen
        """
        pass

    @property
    def Rocket(
      self
    ) -> str: 
        """
        ''Rocket'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Rocket
        """
        pass

    @property
    def Sea(
      self
    ) -> str: 
        """
        ''Sea'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Sea
        """
        pass

    @property
    def Sealand(
      self
    ) -> str: 
        """
        ''Sealand'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Sealand
        """
        pass

    @property
    def Seismic(
      self
    ) -> str: 
        """
        ''Seismic'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Seismic
        """
        pass

    @property
    def Set1(
      self
    ) -> str: 
        """
        ''Set1'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Set1
        """
        pass

    @property
    def Set2(
      self
    ) -> str: 
        """
        ''Set2'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Set2
        """
        pass

    @property
    def Set3(
      self
    ) -> str: 
        """
        ''Set3'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Set3
        """
        pass

    @property
    def Soil(
      self
    ) -> str: 
        """
        ''Soil'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Soil
        """
        pass

    @property
    def Spectral(
      self
    ) -> str: 
        """
        ''Spectral'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Spectral
        """
        pass

    @property
    def Spice(
      self
    ) -> str: 
        """
        ''Spice'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Spice
        """
        pass

    @property
    def Spring(
      self
    ) -> str: 
        """
        ''Spring'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Spring
        """
        pass

    @property
    def Stern(
      self
    ) -> str: 
        """
        ''Stern'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Stern
        """
        pass

    @property
    def Summer(
      self
    ) -> str: 
        """
        ''Summer'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Summer
        """
        pass

    @property
    def Sunset(
      self
    ) -> str: 
        """
        ''Sunset'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Sunset
        """
        pass

    @property
    def Tab10(
      self
    ) -> str: 
        """
        ''Tab10'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Tab10
        """
        pass

    @property
    def Tab20(
      self
    ) -> str: 
        """
        ''Tab20'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Tab20
        """
        pass

    @property
    def Tab20b(
      self
    ) -> str: 
        """
        ''Tab20b'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Tab20b
        """
        pass

    @property
    def Tab20c(
      self
    ) -> str: 
        """
        ''Tab20c'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Tab20c
        """
        pass

    @property
    def Temperature(
      self
    ) -> str: 
        """
        ''Temperature'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Temperature
        """
        pass

    @property
    def Terrain(
      self
    ) -> str: 
        """
        ''Terrain'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Terrain
        """
        pass

    @property
    def Topo1(
      self
    ) -> str: 
        """
        ''Topo1'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Topo1
        """
        pass

    @property
    def Topo2(
      self
    ) -> str: 
        """
        ''Topo2'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Topo2
        """
        pass

    @property
    def Turbo(
      self
    ) -> str: 
        """
        ''Turbo'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Turbo
        """
        pass

    @property
    def Twilight(
      self
    ) -> str: 
        """
        ''Twilight'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Twilight
        """
        pass

    @property
    def TwilightShifted(
      self
    ) -> str: 
        """
        ''TwilightShifted'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.TwilightShifted
        """
        pass

    @property
    def Unique(
      self
    ) -> str: 
        """
        ''Unique'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Unique
        """
        pass

    @property
    def UniqueBright(
      self
    ) -> str: 
        """
        ''UniqueBright'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.UniqueBright
        """
        pass

    @property
    def UniqueDark(
      self
    ) -> str: 
        """
        ''UniqueDark'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.UniqueDark
        """
        pass

    @property
    def UniqueDeep(
      self
    ) -> str: 
        """
        ''UniqueDeep'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.UniqueDeep
        """
        pass

    @property
    def UniqueDeepDark(
      self
    ) -> str: 
        """
        ''UniqueDeepDark'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.UniqueDeepDark
        """
        pass

    @property
    def UniqueLight(
      self
    ) -> str: 
        """
        ''UniqueLight'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.UniqueLight
        """
        pass

    @property
    def UniquePastel(
      self
    ) -> str: 
        """
        ''UniquePastel'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.UniquePastel
        """
        pass

    @property
    def Viridis(
      self
    ) -> str: 
        """
        ''Viridis'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Viridis
        """
        pass

    @property
    def Winter(
      self
    ) -> str: 
        """
        ''Winter'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Winter
        """
        pass

    @property
    def Wistia(
      self
    ) -> str: 
        """
        ''Wistia'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.Wistia
        """
        pass

    @property
    def YellowGreen(
      self
    ) -> str: 
        """
        ''YellowGreen'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.YellowGreen
        """
        pass

    @property
    def YellowGreenBlue(
      self
    ) -> str: 
        """
        ''YellowGreenBlue'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.YellowGreenBlue
        """
        pass

    @property
    def YellowHigh(
      self
    ) -> str: 
        """
        ''YellowHigh'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.YellowHigh
        """
        pass

    @property
    def YellowJacket(
      self
    ) -> str: 
        """
        ''YellowJacket'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.YellowJacket
        """
        pass

    @property
    def YellowOrangeBrown(
      self
    ) -> str: 
        """
        ''YellowOrangeBrown'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.YellowOrangeBrown
        """
        pass

    @property
    def YellowOrangeRed(
      self
    ) -> str: 
        """
        ''YellowOrangeRed'' color ramp.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ColorRampNames.YellowOrangeRed
        """
        pass

class TGIS_GestureState:
    """
    Platform independent gesture state.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Create_void
        """
        pass

    @property
    def Shift(
      self
    ) -> bool: 
        """
        Keyboard special key status.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Shift
        """
        pass

    @Shift.setter
    def Shift(
      self,
      _value: bool
    ) -> None: 
        """
        Keyboard special key status.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Shift
        """
        pass

    @property
    def Alt(
      self
    ) -> bool: 
        """
        Keyboard special key status.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Alt
        """
        pass

    @Alt.setter
    def Alt(
      self,
      _value: bool
    ) -> None: 
        """
        Keyboard special key status.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Alt
        """
        pass

    @property
    def Ctrl(
      self
    ) -> bool: 
        """
        Keyboard special key status.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Ctrl
        """
        pass

    @Ctrl.setter
    def Ctrl(
      self,
      _value: bool
    ) -> None: 
        """
        Keyboard special key status.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Ctrl
        """
        pass

    @property
    def Left(
      self
    ) -> bool: 
        """
        Mouse button status.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Left
        """
        pass

    @Left.setter
    def Left(
      self,
      _value: bool
    ) -> None: 
        """
        Mouse button status.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Left
        """
        pass

    @property
    def Right(
      self
    ) -> bool: 
        """
        Mouse button status.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Right
        """
        pass

    @Right.setter
    def Right(
      self,
      _value: bool
    ) -> None: 
        """
        Mouse button status.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Right
        """
        pass

    @property
    def Middle(
      self
    ) -> bool: 
        """
        Mouse button status.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Middle
        """
        pass

    @Middle.setter
    def Middle(
      self,
      _value: bool
    ) -> None: 
        """
        Mouse button status.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Middle
        """
        pass

    @property
    def Touch(
      self
    ) -> bool: 
        """
        Finger touch source.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Touch
        """
        pass

    @Touch.setter
    def Touch(
      self,
      _value: bool
    ) -> None: 
        """
        Finger touch source.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Touch
        """
        pass

    @property
    def Pen(
      self
    ) -> bool: 
        """
        Pen touch source.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Pen
        """
        pass

    @Pen.setter
    def Pen(
      self,
      _value: bool
    ) -> None: 
        """
        Pen touch source.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.Pen
        """
        pass

    @property
    def DownX(
      self
    ) -> float: 
        """
        Position upon taping.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.DownX
        """
        pass

    @DownX.setter
    def DownX(
      self,
      _value: float
    ) -> None: 
        """
        Position upon taping.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.DownX
        """
        pass

    @property
    def DownY(
      self
    ) -> float: 
        """
        Position upon taping.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.DownY
        """
        pass

    @DownY.setter
    def DownY(
      self,
      _value: float
    ) -> None: 
        """
        Position upon taping.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.DownY
        """
        pass

    @property
    def DownTime(
      self
    ) -> int: 
        """
        Tracking tap duration.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.DownTime
        """
        pass

    @DownTime.setter
    def DownTime(
      self,
      _value: int
    ) -> None: 
        """
        Tracking tap duration.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.DownTime
        """
        pass

    @property
    def DownCount(
      self
    ) -> int: 
        """
        Tracking number of taps.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.DownCount
        """
        pass

    @DownCount.setter
    def DownCount(
      self,
      _value: int
    ) -> None: 
        """
        Tracking number of taps.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.DownCount
        """
        pass

    @property
    def MoveDelta(
      self
    ) -> float: 
        """
        Movement tracking displacement.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.MoveDelta
        """
        pass

    @MoveDelta.setter
    def MoveDelta(
      self,
      _value: float
    ) -> None: 
        """
        Movement tracking displacement.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.MoveDelta
        """
        pass

    @property
    def GestureCnt(
      self
    ) -> int: 
        """
        Gesture state tracking.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.GestureCnt
        """
        pass

    @GestureCnt.setter
    def GestureCnt(
      self,
      _value: int
    ) -> None: 
        """
        Gesture state tracking.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GestureState.GestureCnt
        """
        pass

class TGIS_Utils:
    """
    A class that groups public defines, functions and properties.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.Create_void
        """
        pass

    @classmethod
    def ConstructParamAlignment(
      cls,
      _value: TGIS_LabelAlignment
    ) -> str: 
        """
        Convert an internal representation of a value into the literal representation.

        Args:
            _value: value to translate;

        Returns:
            Literal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ConstructParamAlignment_TGIS_LabelAlignment
        """
        pass

    @classmethod
    def ConstructParamBoolean(
      cls,
      _value: bool
    ) -> str: 
        """
        Convert an internal representation of a value into the literal representation.

        Args:
            _value: value to translate

        Returns:
            Literal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ConstructParamBoolean_Boolean
        """
        pass

    @classmethod
    def ConstructParamChart(
      cls,
      _value: TGIS_ChartStyle
    ) -> str: 
        """
        Convert an internal representation of a value into the literal representation.

        Args:
            _value: value to translate

        Returns:
            Literal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ConstructParamChart_TGIS_ChartStyle
        """
        pass

    @classmethod
    def ConstructParamColor(
      cls,
      _value: TGIS_Color
    ) -> str: 
        """
        Convert an internal representation of a value into the literal representation.

        Args:
            _value: value to translate

        Returns:
            Literal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ConstructParamColor_TGIS_Color
        """
        pass

    @classmethod
    def ConstructParamDormant(
      cls,
      _value: TGIS_LayerDormantMode
    ) -> str: 
        """
        Convert an internal representation of a value into the literal representation.

        Args:
            _value: value to translate

        Returns:
            Literal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ConstructParamDormant_TGIS_LayerDormantMode
        """
        pass

    @classmethod
    def ConstructParamFloat(
      cls,
      _value: float
    ) -> str: 
        """
        Convert an internal representation of a value into the literal representation.

        Args:
            _value: value to translate

        Returns:
            Literal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ConstructParamFloat_Double
        """
        pass

    @classmethod
    def ConstructParamFontStyle(
      cls,
      _value: typing.Sequence[TGIS_FontStyle]
    ) -> str: 
        """
        Convert an internal representation of a value into the literal representation.

        Args:
            _value: value to translate

        Returns:
            Literal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ConstructParamFontStyle_TGIS_FontStyles
        """
        pass

    @classmethod
    def ConstructParamInteger(
      cls,
      _value: int
    ) -> str: 
        """
        Convert an internal representation of a value into the literal representation.

        Args:
            _value: value to translate

        Returns:
            Literal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ConstructParamInteger_Integer
        """
        pass

    @classmethod
    def ConstructParamMarker(
      cls,
      _value: TGIS_MarkerStyle
    ) -> str: 
        """
        Convert an internal representation of a value into the literal representation.

        Args:
            _value: value to translate;

        Returns:
            Literal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ConstructParamMarker_TGIS_MarkerStyle
        """
        pass

    @classmethod
    def ConstructParamPattern(
      cls,
      _value: TGIS_BrushStyle
    ) -> str: 
        """
        Convert an internal representation of a value into the literal representation.

        Args:
            _value: value to translate

        Returns:
            Literal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ConstructParamPattern_TGIS_BrushStyle
        """
        pass

    @classmethod
    def ConstructParamPen(
      cls,
      _value: TGIS_PenStyle
    ) -> str: 
        """
        Convert an internal representation of a value into the literal representation.

        Args:
            _value: value to translate

        Returns:
            Literal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ConstructParamPen_TGIS_PenStyle
        """
        pass

    @classmethod
    def ConstructParamPosition(
      cls,
      _value: typing.Sequence[TGIS_LabelPosition]
    ) -> str: 
        """
        Convert an internal representation of a value into the literal representation.

        Args:
            _value: value to translate

        Returns:
            Literal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ConstructParamPosition_TGIS_LabelPositions
        """
        pass

    @classmethod
    def ConstructParamString(
      cls,
      _value: str
    ) -> str: 
        """
        Convert an internal representation of a value into the literal representation.

        Args:
            _value: value to translate

        Returns:
            Literal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ConstructParamString_String
        """
        pass

    def DotFloatToStr(
      self,
      _val: float
    ) -> str: 
        """
        Convert an extended to String. DecimalSeparator will be a dot.

        Args:
            _val: value to be converted

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.DotFloatToStr_Double
        """
        pass

    def DotStrToFloat(
      self,
      _val: str
    ) -> float: 
        """
        Convert a String to extended.

        Args:
            _val: value to be converted

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.DotStrToFloat_String
        """
        pass

    def ExecutingFolder(
      self
    ) -> str: 
        """
        Get location of executable file.

        Returns:
            Path to the calling process.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ExecutingFolder_void
        """
        pass

    @overload
    @classmethod
    def GisAngleToStr(
      cls,
      _val: float
    ) -> str: 
        """
        Convert a angle in radians to a string representation.

        Args:
            _val: angle in radians

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisAngleToStr_Double
        """
        pass

    @overload
    @classmethod
    def GisAngleToStr(
      cls,
      _val: float,
      _spaces: bool
    ) -> str: 
        """
        Convert a angle in radians to a string representation.

        Args:
            _val: angle in radians
            _spaces: if True, then text will be space separated

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisAngleToStr_Double_Boolean
        """
        pass

    @overload
    @classmethod
    def GisAngleToStr(
      cls,
      _val: float,
      _spaces: bool,
      _prec: int
    ) -> str: 
        """
        Convert a angle in radians to a string representation.

        Args:
            _val: angle in radians
            _spaces: if True, then text will be space separated
            _prec: number of precise digits

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisAngleToStr_Double_Boolean_Integer
        """
        pass

    @classmethod
    def GisArcFrom3Points(
      cls,
      _ptg1: TGIS_Point,
      _ptg2: TGIS_Point,
      _ptg3: TGIS_Point,
      _center: VarParameter,
      _radius: VarParameter,
      _start: VarParameter,
      _stop: VarParameter
    ) -> bool: 
        """
        Calculate arc based on any three points from the circle outline.

        Args:
            _ptg1: first provided point
            _ptg2: second provided point
            _ptg3: second provided point
            _center: center of the calculated string; the value (in/out) is passed as TGIS_Point 
              in _center.Value property
            _radius: radius of the calculated string; the value (in/out) is passed as float in 
              _radius.Value property
            _start: start angle for pie; the value (in/out) is passed as float in _start.Value 
              property
            _stop: stop angle for pie; the value (in/out) is passed as float in _stop.Value property

        Returns:
            True if constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisArcFrom3Points_TGIS_Point_TGIS_Point_TGIS_Point_TGIS_Point_Double_Double_Double
        """
        pass

    @classmethod
    def GisArcFrom3Points3D(
      cls,
      _ptg1: TGIS_Point3D,
      _ptg2: TGIS_Point3D,
      _ptg3: TGIS_Point3D,
      _center: VarParameter,
      _radius: VarParameter,
      _start: VarParameter,
      _stop: VarParameter
    ) -> bool: 
        """
        Calculate arc based on any three 3D points from the circle outline.

        Args:
            _ptg1: first provided point
            _ptg2: second provided point
            _ptg3: second provided point
            _center: center of the calculated string; the value (in/out) is passed as TGIS_Point3D 
              in _center.Value property
            _radius: radius of the calculated string; the value (in/out) is passed as float in 
              _radius.Value property
            _start: start angle for pie; the value (in/out) is passed as float in _start.Value 
              property
            _stop: stop angle for pie; the value (in/out) is passed as float in _stop.Value property

        Returns:
            True if constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisArcFrom3Points3D_TGIS_Point3D_TGIS_Point3D_TGIS_Point3D_TGIS_Point3D_Double_Double_Double
        """
        pass

    @classmethod
    def GisBuildLineStringFromEdges(
      cls,
      _edges: TGIS_ObjectList,
      _tolerance: float,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: int,
      _layer: TGIS_LayerVector,
      _fixShape: bool
    ) -> TGIS_Shape: 
        """
        Build a line string from a list of non complex edges.

        Args:
            _edges: list of non complex edges of TGIS_ShapeArc type
            _tolerance: tolerance into which two arcs are close enough to be joined
            _source: If not nil, then the base shape will be based on this shape. Otherwise _ptr, 
              _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: True if pointer is mapped to the file
            _uid: Unique identifier for shape.
            _layer: Reference to the layer on which the shape will be created.
            _fixShape: if True, the newly created shape topology will be fixed.

        Returns:
            Constructed shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisBuildLineStringFromEdges_TGIS_ObjectList_Double_TGIS_Shape_Pointer_Boolean_Integer_TGIS_LayerVector_Boolean
        """
        pass

    @classmethod
    def GisBuildPolygonFromEdges(
      cls,
      _edges: TGIS_ObjectList,
      _tolerance: float,
      _source: TGIS_Shape,
      _ptr: Pointer,
      _mapped: bool,
      _uid: int,
      _layer: TGIS_LayerVector,
      _fixShape: bool
    ) -> TGIS_Shape: 
        """
        Build a polygon from a list of non complex edges.

        Args:
            _edges: list of non complex edges of TGIS_ShapeArc type
            _tolerance: tolerance into which two arcs are close enough to be joined
            _source: If not nil, then the base shape will be based on this shape. Otherwise _ptr, 
              _uid and _layer will be used.
            _ptr: Address in memory where shape data exists.
            _mapped: True if pointer is mapped to the file
            _uid: Unique identifier for shape.
            _layer: Reference to the layer on which the shape will be created.
            _fixShape: if True, the newly created shape will be fixed using TGIS_Topology.FixShape

        Returns:
            Constructed polygon.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisBuildPolygonFromEdges_TGIS_ObjectList_Double_TGIS_Shape_Pointer_Boolean_Integer_TGIS_LayerVector_Boolean
        """
        pass

    @overload
    def GisCanonicalSQLName(
      self,
      _name: str
    ) -> str: 
        """
        Returns canonical SQL name.

        Args:
            _name: name to be canonized

        Returns:
            Canonical SQL name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisCanonicalSQLName_String
        """
        pass

    @overload
    def GisCanonicalSQLName(
      self,
      _name: str,
      _template: str
    ) -> str: 
        """
        Returns canonical SQL name.

        Args:
            _name: name to be canonized
            _template: templates for name which can not be canonized

        Returns:
            Canonical SQL name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisCanonicalSQLName_String_String
        """
        pass

    @classmethod
    def GisCenterPoint(
      cls,
      _extent: TGIS_Extent
    ) -> TGIS_Point: 
        """
        Calculates center point of given extent.

        Args:
            _extent: given extent

        Returns:
            Center point of given extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisCenterPoint_TGIS_Extent
        """
        pass

    @classmethod
    def GisCircleFrom3Points(
      cls,
      _ptg1: TGIS_Point,
      _ptg2: TGIS_Point,
      _ptg3: TGIS_Point,
      _center: VarParameter,
      _radius: VarParameter,
      _start: VarParameter,
      _stop: VarParameter
    ) -> bool: 
        """
        Calculate circle based on any three points from the circle outline.

        Args:
            _ptg1: first provided point
            _ptg2: second provided point
            _ptg3: second provided point
            _center: center of the calculated string; the value (in/out) is passed as TGIS_Point 
              in _center.Value property
            _radius: radius of the calculated string; the value (in/out) is passed as float in 
              _radius.Value property
            _start: start angle for pie (currently always 0); the value (in/out) is passed as 
              float in _start.Value property
            _stop: stop angle for pie (currently always 2Pi); the value (in/out) is passed as 
              float in _stop.Value property

        Returns:
            True if constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisCircleFrom3Points_TGIS_Point_TGIS_Point_TGIS_Point_TGIS_Point_Double_Double_Double
        """
        pass

    @classmethod
    def GisCircleFrom3Points3D(
      cls,
      _ptg1: TGIS_Point3D,
      _ptg2: TGIS_Point3D,
      _ptg3: TGIS_Point3D,
      _center: VarParameter,
      _radius: VarParameter,
      _start: VarParameter,
      _stop: VarParameter
    ) -> bool: 
        """
        Calculate circle based on any three 3D points from the circle outline.

        Args:
            _ptg1: first provided point
            _ptg2: second provided point
            _ptg3: second provided point
            _center: center of the calculated string; the value (in/out) is passed as TGIS_Point3D 
              in _center.Value property
            _radius: radius of the calculated string; the value (in/out) is passed as float in 
              _radius.Value property
            _start: start angle for pie (currently always 0); the value (in/out) is passed as 
              float in _start.Value property
            _stop: stop angle for pie (currently always 2Pi); the value (in/out) is passed as 
              float in _stop.Value property

        Returns:
            True if constructed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisCircleFrom3Points3D_TGIS_Point3D_TGIS_Point3D_TGIS_Point3D_TGIS_Point3D_Double_Double_Double
        """
        pass

    def GisColorMap(
      self,
      _index: float,
      _color: TGIS_Color
    ) -> TGIS_ColorMap: 
        """
        Create a color map for ramps.

        Args:
            _index: Range value related with RGB color, normalized to 0-100
            _color: Color assigned to given range.

        Returns:
            color map

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisColorMap_Double_TGIS_Color
        """
        pass

    def GisColorMapEx(
      self,
      _class: int,
      _colors: TGIS_ColorArray
    ) -> TGIS_ColorMapEx: 
        """
        Create extended color map for ramps.

        Args:
            _class: Class value related with ramp
            _colors: Array of colors assigned to given class.

        Returns:
            extended color map

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisColorMapEx_Integer_TGIS_ColorArray
        """
        pass

    @classmethod
    def GisCommonExtent(
      cls,
      _extent1: TGIS_Extent,
      _extent2: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Common area of two extents.

        Args:
            _extent1: area to compare
            _extent2: area to compare

        Returns:
            New extent as common area of two extents.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisCommonExtent_TGIS_Extent_TGIS_Extent
        """
        pass

    @classmethod
    def GisCommonExtent3D(
      cls,
      _extent1: TGIS_Extent3D,
      _extent2: TGIS_Extent3D
    ) -> TGIS_Extent3D: 
        """
        Common area of two 3D extents.

        Args:
            _extent1: area to compare
            _extent2: area to compare

        Returns:
            New 3D extent as common area of two 3D extents.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisCommonExtent3D_TGIS_Extent3D_TGIS_Extent3D
        """
        pass

    @classmethod
    def GisContainExtent(
      cls,
      _extent1: TGIS_Extent,
      _extent2: TGIS_Extent
    ) -> bool: 
        """
        Is _extent2 wholly encompass by _extent1.

        Args:
            _extent1: extent to compare
            _extent2: extent to compare

        Returns:
            True if _extent2 is wholly encompass by _extent1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisContainExtent_TGIS_Extent_TGIS_Extent
        """
        pass

    @classmethod
    def GisCreateLayer(
      cls,
      _name: str,
      _path: str
    ) -> TGIS_Layer: 
        """
        Create a layer given by a name.

        Args:
            _name: the name under which the layer will be recognized; if empty, then the default 
              name will be assigned (same as path)
            _path: path (with extension)

        Returns:
            Created layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisCreateLayer_String_String
        """
        pass

    @classmethod
    def GisCreateReprojectedShape(
      cls,
      _shp: TGIS_Shape,
      _src_cs: TGIS_CSCoordinateSystem,
      _dst_cs: TGIS_CSCoordinateSystem
    ) -> TGIS_Shape: 
        """
        Create a reprojected shape.

        Args:
            _shp: source shape to reproject
            _src_cs: source coordinate system
            _dst_cs: destination coordinate system

        Returns:
            Reprojected shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisCreateReprojectedShape_TGIS_Shape_TGIS_CSCoordinateSystem_TGIS_CSCoordinateSystem
        """
        pass

    @classmethod
    def GisCreateShapeFromGDO(
      cls,
      _gdo: Variant
    ) -> TGIS_Shape: 
        """
        Create the shape from GeoMedia Database Object (GDO).

        Args:
            _gdo: GDO array

        Returns:
            Shape created from GDO.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisCreateShapeFromGDO_Variant
        """
        pass

    @classmethod
    def GisCreateShapeFromGML(
      cls,
      _gml: str
    ) -> TGIS_Shape: 
        """
        Create the shape from GML.

        Args:
            _gml: JSON text

        Returns:
            Created shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisCreateShapeFromGML_String
        """
        pass

    @classmethod
    def GisCreateShapeFromJSON(
      cls,
      _json: str
    ) -> TGIS_Shape: 
        """
        Create the shape from JSON.

        Args:
            _json: JSON text

        Returns:
            Created shape.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisCreateShapeFromJSON_String
        """
        pass

    @classmethod
    def GisCreateShapeFromWKB(
      cls,
      _wkb: Variant
    ) -> TGIS_Shape: 
        """
        Create the shape from Well Known Binary (see: www.opengis.org).

        Args:
            _wkb: WKB array

        Returns:
            Shape created from WKB.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisCreateShapeFromWKB_Variant
        """
        pass

    @classmethod
    def GisCreateShapeFromWKT(
      cls,
      _wkt: str
    ) -> TGIS_Shape: 
        """
        Create the shape from a Well Known Text (see: www.opengis.org).

        Args:
            _wkt: WKT text

        Returns:
            Shape created from WKT.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisCreateShapeFromWKT_String
        """
        pass

    def GisCUDAEngine(
      self
    ) -> TGIS_CUDAEngine: 
        """
        Returns a global OpenCL engine object.

        Returns:
            OpenCL engine object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisCUDAEngine_void
        """
        pass

    @overload
    @classmethod
    def GisDecodeAngle(
      cls,
      _val: float,
      _deg: VarParameter,
      _min: VarParameter,
      _sec: VarParameter,
      _frac: VarParameter,
      _sign: VarParameter
    ) -> None: 
        """
        Decode angle value into degrees, minutes, seconds. If you want to construct your 
        own string based on such values keep in mind rounding problem. So we recommend to 
        use truncated values of degrees and minutes.

        Args:
            _val: latitude to be decoded (in radians)
            _deg: degrees; the value (in/out) is passed as int in _deg.Value property
            _min: minutes; the value (in/out) is passed as int in _min.Value property
            _sec: seconds; the value (in/out) is passed as int in _sec.Value property
            _frac: fraction of seconds; the value (in/out) is passed as int in _frac.Value property
            _sign: if &gt;= 0, then treated as East; if &lt; 0, then treated as West; the value 
              (in/out) is passed as int in _sign.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisDecodeAngle_Double_Integer_Integer_Integer_Integer_Integer
        """
        pass

    @overload
    @classmethod
    def GisDecodeAngle(
      cls,
      _val: float,
      _deg: VarParameter,
      _min: VarParameter,
      _sec: VarParameter,
      _frac: VarParameter,
      _sign: VarParameter,
      _prec: int
    ) -> None: 
        """
        Decode angle value into degrees, minutes, seconds. If you want to construct your 
        own string based on such values keep in mind rounding problem. So we recommend to 
        use truncated values of degrees and minutes.

        Args:
            _val: latitude to be decoded (in radians)
            _deg: degrees; the value (in/out) is passed as int in _deg.Value property
            _min: minutes; the value (in/out) is passed as int in _min.Value property
            _sec: seconds; the value (in/out) is passed as int in _sec.Value property
            _frac: fraction of seconds; the value (in/out) is passed as int in _frac.Value property
            _sign: if &gt;= 0, then treated as East; if &lt; 0, then treated as West; the value 
              (in/out) is passed as int in _sign.Value property
            _prec: precision - number of digits after decimal point measured on seconds (0..15) 
              ; default is 2

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisDecodeAngle_Double_Integer_Integer_Integer_Integer_Integer_Integer
        """
        pass

    @overload
    @classmethod
    def GisDecodeLatitude(
      cls,
      _val: float,
      _deg: VarParameter,
      _min: VarParameter,
      _sec: VarParameter,
      _frac: VarParameter,
      _sign: VarParameter
    ) -> None: 
        """
        Decode latitude value into degrees, minutes, seconds. If you want to construct your 
        own String based on such values keep in mind rounding problem. So we recommend to 
        use truncated values of degrees and minutes.

        Args:
            _val: latitude to be decoded (in radians)
            _deg: degrees; the value (in/out) is passed as int in _deg.Value property
            _min: minutes; the value (in/out) is passed as int in _min.Value property
            _sec: seconds; the value (in/out) is passed as int in _sec.Value property
            _frac: fraction of seconds; the value (in/out) is passed as int in _frac.Value property
            _sign: if &gt;= 0, then treated as East; if &lt; 0, then treated as West; the value 
              (in/out) is passed as int in _sign.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisDecodeLatitude_Double_Integer_Integer_Integer_Integer_Integer
        """
        pass

    @overload
    @classmethod
    def GisDecodeLatitude(
      cls,
      _val: float,
      _deg: VarParameter,
      _min: VarParameter,
      _sec: VarParameter,
      _frac: VarParameter,
      _sign: VarParameter,
      _prec: int
    ) -> None: 
        """
        Decode latitude value into degrees, minutes, seconds. If you want to construct your 
        own String based on such values keep in mind rounding problem. So we recommend to 
        use truncated values of degrees and minutes.

        Args:
            _val: latitude to be decoded (in radians)
            _deg: degrees; the value (in/out) is passed as int in _deg.Value property
            _min: minutes; the value (in/out) is passed as int in _min.Value property
            _sec: seconds; the value (in/out) is passed as int in _sec.Value property
            _frac: fraction of seconds; the value (in/out) is passed as int in _frac.Value property
            _sign: if &gt;= 0, then treated as East; if &lt; 0, then treated as West; the value 
              (in/out) is passed as int in _sign.Value property
            _prec: precision - number of digits after decimal point measured on seconds (0..15) 
              ; default is 2

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisDecodeLatitude_Double_Integer_Integer_Integer_Integer_Integer_Integer
        """
        pass

    @overload
    @classmethod
    def GisDecodeLongitude(
      cls,
      _val: float,
      _deg: VarParameter,
      _min: VarParameter,
      _sec: VarParameter,
      _frac: VarParameter,
      _sign: VarParameter
    ) -> None: 
        """
        Decode longitude value into degrees, minutes, seconds. If you want to construct your 
        own String based on such values keep in mind rounding problem. So we recommend to 
        use truncated values of degrees and minutes.

        Args:
            _val: longitude to be decoded (in radians)
            _deg: degrees; the value (in/out) is passed as int in _deg.Value property
            _min: minutes; the value (in/out) is passed as int in _min.Value property
            _sec: seconds; the value (in/out) is passed as int in _sec.Value property
            _frac: fraction of seconds; the value (in/out) is passed as int in _frac.Value property
            _sign: if &gt;= 0, then treated as East; if &lt; 0, then treated as West; the value 
              (in/out) is passed as int in _sign.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisDecodeLongitude_Double_Integer_Integer_Integer_Integer_Integer
        """
        pass

    @overload
    @classmethod
    def GisDecodeLongitude(
      cls,
      _val: float,
      _deg: VarParameter,
      _min: VarParameter,
      _sec: VarParameter,
      _frac: VarParameter,
      _sign: VarParameter,
      _prec: int
    ) -> None: 
        """
        Decode longitude value into degrees, minutes, seconds. If you want to construct your 
        own String based on such values keep in mind rounding problem. So we recommend to 
        use truncated values of degrees and minutes.

        Args:
            _val: longitude to be decoded (in radians)
            _deg: degrees; the value (in/out) is passed as int in _deg.Value property
            _min: minutes; the value (in/out) is passed as int in _min.Value property
            _sec: seconds; the value (in/out) is passed as int in _sec.Value property
            _frac: fraction of seconds; the value (in/out) is passed as int in _frac.Value property
            _sign: if &gt;= 0, then treated as East; if &lt; 0, then treated as West; the value 
              (in/out) is passed as int in _sign.Value property
            _prec: precision - number of digits after decimal point measured on seconds (0..15) 
              ; default is 2

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisDecodeLongitude_Double_Integer_Integer_Integer_Integer_Integer_Integer
        """
        pass

    @classmethod
    def GisDefaultField(
      cls,
      _type: TGIS_FieldType
    ) -> Variant: 
        """
        Get default value for selected field type

        Args:
            _type: field type

        Returns:
            Default value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisDefaultField_TGIS_FieldType
        """
        pass

    def GisDeNormalizedSQLName(
      self,
      _name: str
    ) -> str: 
        """
        Prepare de-normalized version of a field name.

        Args:
            _name: field name to be de-normalized

        Returns:
            De-normalized version of a field name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisDeNormalizedSQLName_String
        """
        pass

    @classmethod
    def GisDMax(
      cls,
      _val1: float,
      _val2: float
    ) -> float: 
        """
        Maximum of two doubles.

        Args:
            _val1: value to compare
            _val2: value to compare

        Returns:
            Maximum value computed out of two doubles.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisDMax_Double_Double
        """
        pass

    @classmethod
    def GisDMin(
      cls,
      _val1: float,
      _val2: float
    ) -> float: 
        """
        Minimum of two doubles.

        Args:
            _val1: values to compare
            _val2: values to compare

        Returns:
            Minimum value computed out of two doubles.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisDMin_Double_Double
        """
        pass

    @overload
    @classmethod
    def GisEncodeAngle(
      cls,
      _deg: float
    ) -> float: 
        """
        Encode angle value from the values specified as the degrees, minutes, seconds.
        
        You can call ( 18, 54.5, 0, 1 ) or ( 18, 54, 30, 1 ) to achieve the same result. 
        If you provide ( 18, 54,5, 30, 1 ) it will be the same as ( 19, 0, 0, 1 )

        Args:
            _deg: degrees; absolute value; if &lt;0 then force sign of result regardless off 
              _sign value

        Returns:
            Encoded angle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisEncodeAngle_Double
        """
        pass

    @overload
    @classmethod
    def GisEncodeAngle(
      cls,
      _deg: float,
      _min: float
    ) -> float: 
        """
        Encode angle value from the values specified as the degrees, minutes, seconds.
        
        You can call ( 18, 54.5, 0, 1 ) or ( 18, 54, 30, 1 ) to achieve the same result. 
        If you provide ( 18, 54,5, 30, 1 ) it will be the same as ( 19, 0, 0, 1 )

        Args:
            _deg: degrees; absolute value; if &lt;0 then force sign of result regardless off 
              _sign value
            _min: minutes; absolute value

        Returns:
            Encoded angle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisEncodeAngle_Double_Double
        """
        pass

    @overload
    @classmethod
    def GisEncodeAngle(
      cls,
      _deg: float,
      _min: float,
      _sec: float
    ) -> float: 
        """
        Encode angle value from the values specified as the degrees, minutes, seconds.
        
        You can call ( 18, 54.5, 0, 1 ) or ( 18, 54, 30, 1 ) to achieve the same result. 
        If you provide ( 18, 54,5, 30, 1 ) it will be the same as ( 19, 0, 0, 1 )

        Args:
            _deg: degrees; absolute value; if &lt;0 then force sign of result regardless off 
              _sign value
            _min: minutes; absolute value
            _sec: seconds; absolute value

        Returns:
            Encoded angle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisEncodeAngle_Double_Double_Double
        """
        pass

    @overload
    @classmethod
    def GisEncodeAngle(
      cls,
      _deg: float,
      _min: float,
      _sec: float,
      _sign: int
    ) -> float: 
        """
        Encode angle value from the values specified as the degrees, minutes, seconds.
        
        You can call ( 18, 54.5, 0, 1 ) or ( 18, 54, 30, 1 ) to achieve the same result. 
        If you provide ( 18, 54,5, 30, 1 ) it will be the same as ( 19, 0, 0, 1 )

        Args:
            _deg: degrees; absolute value; if &lt;0 then force sign of result regardless off 
              _sign value
            _min: minutes; absolute value
            _sec: seconds; absolute value
            _sign: if &gt;= 0, then treated as &lt;0; if &lt; 0, then treated as &gt;0

        Returns:
            Encoded angle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisEncodeAngle_Double_Double_Double_Integer
        """
        pass

    @overload
    @classmethod
    def GisEncodeLatitude(
      cls,
      _deg: float
    ) -> float: 
        """
        Encode longitude value from the values specified as the degrees, minutes, seconds.
        
        You can call ( 18, 54.5, 0, 1 ) or ( 18, 54, 30, 1 ) to achieve the same result. 
        If you provide ( 18, 54,5, 30, 1 ) it will be the same as ( 19, 0, 0, 1 )

        Args:
            _deg: degrees; absolute value

        Returns:
            Encoded latitude.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisEncodeLatitude_Double
        """
        pass

    @overload
    @classmethod
    def GisEncodeLatitude(
      cls,
      _deg: float,
      _min: float
    ) -> float: 
        """
        Encode longitude value from the values specified as the degrees, minutes, seconds.
        
        You can call ( 18, 54.5, 0, 1 ) or ( 18, 54, 30, 1 ) to achieve the same result. 
        If you provide ( 18, 54,5, 30, 1 ) it will be the same as ( 19, 0, 0, 1 )

        Args:
            _deg: degrees; absolute value
            _min: minutes; absolute value

        Returns:
            Encoded latitude.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisEncodeLatitude_Double_Double
        """
        pass

    @overload
    @classmethod
    def GisEncodeLatitude(
      cls,
      _deg: float,
      _min: float,
      _sec: float
    ) -> float: 
        """
        Encode longitude value from the values specified as the degrees, minutes, seconds.
        
        You can call ( 18, 54.5, 0, 1 ) or ( 18, 54, 30, 1 ) to achieve the same result. 
        If you provide ( 18, 54,5, 30, 1 ) it will be the same as ( 19, 0, 0, 1 )

        Args:
            _deg: degrees; absolute value
            _min: minutes; absolute value
            _sec: seconds; absolute value

        Returns:
            Encoded latitude.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisEncodeLatitude_Double_Double_Double
        """
        pass

    @overload
    @classmethod
    def GisEncodeLatitude(
      cls,
      _deg: float,
      _min: float,
      _sec: float,
      _sign: int
    ) -> float: 
        """
        Encode longitude value from the values specified as the degrees, minutes, seconds.
        
        You can call ( 18, 54.5, 0, 1 ) or ( 18, 54, 30, 1 ) to achieve the same result. 
        If you provide ( 18, 54,5, 30, 1 ) it will be the same as ( 19, 0, 0, 1 )

        Args:
            _deg: degrees; absolute value
            _min: minutes; absolute value
            _sec: seconds; absolute value
            _sign: if &gt;= 0, then treated as North; if &lt; 0, then treated as South

        Returns:
            Encoded latitude.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisEncodeLatitude_Double_Double_Double_Integer
        """
        pass

    @overload
    @classmethod
    def GisEncodeLongitude(
      cls,
      _deg: float
    ) -> float: 
        """
        Encode longitude value from the values specified as the degrees, minutes, seconds.
        
        You can call ( 18, 54.5, 0, 1 ) or ( 18, 54, 30, 1 ) to achieve the same result. 
        If you provide ( 18, 54,5, 30, 1 ) it will be the same as ( 19, 0, 0, 1 )

        Args:
            _deg: degrees; absolute value

        Returns:
            Encoded longitude.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisEncodeLongitude_Double
        """
        pass

    @overload
    @classmethod
    def GisEncodeLongitude(
      cls,
      _deg: float,
      _min: float
    ) -> float: 
        """
        Encode longitude value from the values specified as the degrees, minutes, seconds.
        
        You can call ( 18, 54.5, 0, 1 ) or ( 18, 54, 30, 1 ) to achieve the same result. 
        If you provide ( 18, 54,5, 30, 1 ) it will be the same as ( 19, 0, 0, 1 )

        Args:
            _deg: degrees; absolute value
            _min: minutes; absolute value

        Returns:
            Encoded longitude.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisEncodeLongitude_Double_Double
        """
        pass

    @overload
    @classmethod
    def GisEncodeLongitude(
      cls,
      _deg: float,
      _min: float,
      _sec: float
    ) -> float: 
        """
        Encode longitude value from the values specified as the degrees, minutes, seconds.
        
        You can call ( 18, 54.5, 0, 1 ) or ( 18, 54, 30, 1 ) to achieve the same result. 
        If you provide ( 18, 54,5, 30, 1 ) it will be the same as ( 19, 0, 0, 1 )

        Args:
            _deg: degrees; absolute value
            _min: minutes; absolute value
            _sec: seconds; absolute value

        Returns:
            Encoded longitude.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisEncodeLongitude_Double_Double_Double
        """
        pass

    @overload
    @classmethod
    def GisEncodeLongitude(
      cls,
      _deg: float,
      _min: float,
      _sec: float,
      _sign: int
    ) -> float: 
        """
        Encode longitude value from the values specified as the degrees, minutes, seconds.
        
        You can call ( 18, 54.5, 0, 1 ) or ( 18, 54, 30, 1 ) to achieve the same result. 
        If you provide ( 18, 54,5, 30, 1 ) it will be the same as ( 19, 0, 0, 1 )

        Args:
            _deg: degrees; absolute value
            _min: minutes; absolute value
            _sec: seconds; absolute value
            _sign: if &gt;= 0, then treated as East; if &lt; 0, then treated as West

        Returns:
            Encoded longitude.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisEncodeLongitude_Double_Double_Double_Integer
        """
        pass

    @classmethod
    def GisExportArcToGDO(
      cls,
      _shp: TGIS_Shape,
      _gdo: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a GeoMedia Database Object (GDO).

        Args:
            _shp: shape to export
            _gdo: exported GDO array; the value (in/out) is passed as OleVariant in _gdo.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportArcToGDO_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportArcToGML(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GML (see www.opengis.org).

        Args:
            _shp: shape to export

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportArcToGML_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportArcToJSON(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GeoJSON (see www.geojson.org).

        Args:
            _shp: shape to export

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportArcToJSON_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportArcToVAR(
      cls,
      _shp: TGIS_Shape,
      _var: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an internal SHP format.

        Args:
            _shp: shape to export
            _var: exported VAR array; the value (in/out) is passed as OleVariant in _var.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportArcToVAR_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportArcToWKB(
      cls,
      _shp: TGIS_Shape,
      _wkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a Well Known Binary (see www.opengis.org).

        Args:
            _shp: shape to export
            _wkb: exported WKB array; the value (in/out) is passed as OleVariant in _wkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportArcToWKB_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportArcToWKT(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a Well Known Text (see www.opengis.org).

        Args:
            _shp: shape to export

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportArcToWKT_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportComplexToGDO(
      cls,
      _shp: TGIS_Shape,
      _gdo: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a GeoMedia Database Object (GDO).

        Args:
            _shp: shape to export
            _gdo: exported GDO array; the value (in/out) is passed as OleVariant in _gdo.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportComplexToGDO_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportComplexToGML(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GML (see www.opengis.org).

        Args:
            _shp: shape to export

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportComplexToGML_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportComplexToJSON(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GeoJSON (see www.geojson.org).

        Args:
            _shp: shape to export

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportComplexToJSON_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportComplexToVAR(
      cls,
      _shp: TGIS_Shape,
      _var: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an internal SHP format.

        Args:
            _shp: shape to export
            _var: exported VAR array; the value (in/out) is passed as OleVariant in _var.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportComplexToVAR_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportComplexToWKB(
      cls,
      _shp: TGIS_Shape,
      _wkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a Well Known Binary (see www.opengis.org).

        Args:
            _shp: shape to export
            _wkb: exported WKB array; the value (in/out) is passed as OleVariant in _wkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportComplexToWKB_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportComplexToWKT(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a Well Known Text (see www.opengis.org).

        Args:
            _shp: shape to export

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportComplexToWKT_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportGeometry2Hex(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into variant geometry. For PostgeSQL ODBC driver purposes

        Args:
            _shp: exported Shape

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportGeometry2Hex_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportMultiPointToGDO(
      cls,
      _shp: TGIS_Shape,
      _gdo: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a GeoMedia Database Object (GDO).

        Args:
            _shp: shape to export
            _gdo: exported GDO array; the value (in/out) is passed as OleVariant in _gdo.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportMultiPointToGDO_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportMultiPointToGML(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GML (see www.opengis.org).

        Args:
            _shp: shape to export

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportMultiPointToGML_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportMultiPointToJSON(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GeoJSON (see www.geojson.org).

        Args:
            _shp: shape to export

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportMultiPointToJSON_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportMultiPointToVAR(
      cls,
      _shp: TGIS_Shape,
      _var: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an internal SHP format.

        Args:
            _shp: shape to export
            _var: exported VAR array; the value (in/out) is passed as OleVariant in _var.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportMultiPointToVAR_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportMultiPointToWKB(
      cls,
      _shp: TGIS_Shape,
      _wkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a Well Known Binary (see www.opengis.org).

        Args:
            _shp: shape to export
            _wkb: exported WKB array; the value (in/out) is passed as OleVariant in _wkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportMultiPointToWKB_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportMultiPointToWKT(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a Well Known Text (see www.opengis.org).

        Args:
            _shp: shape to export

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportMultiPointToWKT_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportPointToGDO(
      cls,
      _shp: TGIS_Shape,
      _gdo: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a GeoMedia Database Object (GDO).

        Args:
            _shp: shape to export
            _gdo: exported GDO array; the value (in/out) is passed as OleVariant in _gdo.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportPointToGDO_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportPointToGML(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GML (see www.opengis.org).

        Args:
            _shp: shape to export

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportPointToGML_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportPointToJSON(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GeoJSON (see www.geojson.org).

        Args:
            _shp: shape to export

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportPointToJSON_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportPointToVAR(
      cls,
      _shp: TGIS_Shape,
      _var: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an internal SHP format.

        Args:
            _shp: shape to export
            _var: exported VAR array; the value (in/out) is passed as OleVariant in _var.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportPointToVAR_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportPointToWKB(
      cls,
      _shp: TGIS_Shape,
      _wkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a Well Known Binary (see www.opengis.org).

        Args:
            _shp: shape to export
            _wkb: exported WKB array; the value (in/out) is passed as OleVariant in _wkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportPointToWKB_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportPointToWKT(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a Well Known Text (see www.opengis.org).

        Args:
            _shp: shape to export

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportPointToWKT_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportPolygonToGDO(
      cls,
      _shp: TGIS_Shape,
      _gdo: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a GeoMedia Database Object (GDO).

        Args:
            _shp: shape to export
            _gdo: exported GDO array; the value (in/out) is passed as OleVariant in _gdo.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportPolygonToGDO_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportPolygonToGML(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GML (see www.opengis.org).

        Args:
            _shp: shape to export

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportPolygonToGML_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportPolygonToJSON(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a GeoJSON (see www.geojson.org).

        Args:
            _shp: shape to export

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportPolygonToJSON_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportPolygonToVAR(
      cls,
      _shp: TGIS_Shape,
      _var: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into an internal SHP format.

        Args:
            _shp: shape to export
            _var: exported VAR array; the value (in/out) is passed as OleVariant in _var.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportPolygonToVAR_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportPolygonToWKB(
      cls,
      _shp: TGIS_Shape,
      _wkb: VarParameter
    ) -> None: 
        """
        Export the Shape geometry into a Well Known Binary (see www.opengis.org).

        Args:
            _shp: shape to export
            _wkb: exported WKB array; the value (in/out) is passed as OleVariant in _wkb.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportPolygonToWKB_TGIS_Shape_OleVariant
        """
        pass

    @classmethod
    def GisExportPolygonToWKT(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a Well Known Text (see www.opengis.org).

        Args:
            _shp: shape to export

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportPolygonToWKT_TGIS_Shape
        """
        pass

    @classmethod
    def GisExportWKB2Hex(
      cls,
      _shp: TGIS_Shape
    ) -> str: 
        """
        Export the Shape geometry into a Well Known Binary (see www.opengis.org).

        Args:
            _shp: exported Shape

        Returns:
            Shape geometry as string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExportWKB2Hex_TGIS_Shape
        """
        pass

    @classmethod
    def GisExtent(
      cls,
      _xmin: float,
      _ymin: float,
      _xmax: float,
      _ymax: float
    ) -> TGIS_Extent: 
        """
        Create new extent.

        Args:
            _xmin: coordinate
            _ymin: coordinate
            _xmax: coordinate
            _ymax: coordinate

        Returns:
            New extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExtent_Double_Double_Double_Double
        """
        pass

    @classmethod
    def GisExtent2DFrom3D(
      cls,
      _ext: TGIS_Extent3D
    ) -> TGIS_Extent: 
        """
        Convert 3D extent into 2D extent.

        Args:
            _ext: extent to be converted

        Returns:
            New extent converted from 3D.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExtent2DFrom3D_TGIS_Extent3D
        """
        pass

    @classmethod
    def GisExtent3D(
      cls,
      _xmin: float,
      _ymin: float,
      _zmin: float,
      _xmax: float,
      _ymax: float,
      _zmax: float
    ) -> TGIS_Extent3D: 
        """
        Create new extent.

        Args:
            _xmin: coordinate
            _ymin: coordinate
            _zmin: coordinate
            _xmax: coordinate
            _ymax: coordinate
            _zmax: coordinate

        Returns:
            New 3D extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExtent3D_Double_Double_Double_Double_Double_Double
        """
        pass

    @classmethod
    def GisExtent3DFrom2D(
      cls,
      _ext: TGIS_Extent
    ) -> TGIS_Extent3D: 
        """
        Convert 3D point into 2D point.

        Args:
            _ext: point to be converted

        Returns:
            New 3D extent converted from 2D.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExtent3DFrom2D_TGIS_Extent
        """
        pass

    @classmethod
    def GisExtentArea(
      cls,
      _extent: TGIS_Extent
    ) -> float: 
        """
        Calculate area of extent.

        Args:
            _extent: given extent

        Returns:
            Area of the extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExtentArea_TGIS_Extent
        """
        pass

    @classmethod
    def GisExtentArea3D(
      cls,
      _extent: TGIS_Extent3D
    ) -> float: 
        """
        Calculate area of 3D extent.

        Args:
            _extent: given extent

        Returns:
            Area of the 3D extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExtentArea3D_TGIS_Extent3D
        """
        pass

    @classmethod
    def GisExtentCubature(
      cls,
      _extent: TGIS_Extent
    ) -> float: 
        """
        Calculate cubature of extent.

        Args:
            _extent: given extent

        Returns:
            Cubature of the extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExtentCubature_TGIS_Extent
        """
        pass

    @classmethod
    def GisExtentCubature3D(
      cls,
      _extent: TGIS_Extent3D
    ) -> float: 
        """
        Calculate cubature of 3D extent.

        Args:
            _extent: given extent

        Returns:
            Cubature of the 3D extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisExtentCubature3D_TGIS_Extent3D
        """
        pass

    def GisFilePath(
      self,
      _path: str
    ) -> str: 
        """
        Returns path part of a given path.

        Args:
            _path: given path

        Returns:
            Path part of a given path.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisFilePath_String
        """
        pass

    @classmethod
    def GisGetLinesCrossing(
      cls,
      _line1: TGIS_Line,
      _line2: TGIS_Line,
      _ptg: VarParameter
    ) -> bool: 
        """
        Get any common line point. Be certain to free result.

        Args:
            _line1: first line
            _line2: second line
            _ptg: crossing point; the value (in/out) is passed as TGIS_Point in _ptg.Value property

        Returns:
            True if lines are crossing each other.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisGetLinesCrossing_TGIS_Line_TGIS_Line_TGIS_Point
        """
        pass

    def GisGridArray(
      self,
      _height: int,
      _width: int
    ) -> TGIS_GridArray: 
        """
        Initialize grid array and set values to NODATA

        Args:
            _height: height of the grid
            _width: width of the grid

        Returns:
            Initialized grid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisGridArray_Integer_Integer
        """
        pass

    @classmethod
    def GisIsCommonExtent(
      cls,
      _extent1: TGIS_Extent,
      _extent2: TGIS_Extent
    ) -> bool: 
        """
        Have two extents a common part?.

        Args:
            _extent1: area to compare
            _extent2: area to compare

        Returns:
            True if two extents have common part.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsCommonExtent_TGIS_Extent_TGIS_Extent
        """
        pass

    @classmethod
    def GisIsCommonExtent3D(
      cls,
      _extent1: TGIS_Extent3D,
      _extent2: TGIS_Extent3D
    ) -> bool: 
        """
        Have two 3D extents a common part?.

        Args:
            _extent1: area to compare
            _extent2: area to compare

        Returns:
            True if two 3D extents have common part.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsCommonExtent3D_TGIS_Extent3D_TGIS_Extent3D
        """
        pass

    @classmethod
    def GisIsContainExtent(
      cls,
      _extent1: TGIS_Extent,
      _extent2: TGIS_Extent
    ) -> bool: 
        """
        True if _extent2 fully covers _extent1.

        Args:
            _extent1: area to compare
            _extent2: area to compare

        Returns:
            True if _extent2 fully covers _extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsContainExtent_TGIS_Extent_TGIS_Extent
        """
        pass

    @classmethod
    def GisIsContainExtent3D(
      cls,
      _extent1: TGIS_Extent3D,
      _extent2: TGIS_Extent3D
    ) -> bool: 
        """
        True if _extent2 fully covers _extent1 in 3D.

        Args:
            _extent1: area to compare
            _extent2: area to compare

        Returns:
            True if _extent2 fully covers _extent1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsContainExtent3D_TGIS_Extent3D_TGIS_Extent3D
        """
        pass

    @classmethod
    def GisIsEmptyExtent(
      cls,
      _extent: TGIS_Extent
    ) -> bool: 
        """
        Is extent empty? Extent is empty if (XMin&gt;=XMax) or (YMin&gt;=YMax)

        Args:
            _extent: extent to be verified

        Returns:
            True if extent is empty.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsEmptyExtent_TGIS_Extent
        """
        pass

    @classmethod
    def GisIsEmptyExtent3D(
      cls,
      _extent: TGIS_Extent3D
    ) -> bool: 
        """
        Is extent empty? Extent is empty if (XMin&gt;=XMax) or (YMin&gt;=YMax) or (ZMin&gt;=ZMax)

        Args:
            _extent: extent to be verified

        Returns:
            True if 3D extent is empty.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsEmptyExtent3D_TGIS_Extent3D
        """
        pass

    @classmethod
    def GisIsLinesCommonPoint(
      cls,
      _line1: TGIS_Line,
      _line2: TGIS_Line
    ) -> bool: 
        """
        Test if given set of lines have a common point.

        Args:
            _line1: first line
            _line2: second line

        Returns:
            True if two lines have common point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsLinesCommonPoint_TGIS_Line_TGIS_Line
        """
        pass

    @classmethod
    def GisIsNoWorld(
      cls,
      _extent: TGIS_Extent
    ) -> bool: 
        """
        Is extent same as no world (non existing extent)?

        Args:
            _extent: extent to compare

        Returns:
            True if extent is the same as no world.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsNoWorld_TGIS_Extent
        """
        pass

    @classmethod
    def GisIsNoWorld3D(
      cls,
      _extent: TGIS_Extent3D
    ) -> bool: 
        """
        Is 3D extent same as no world (non existing extent)?

        Args:
            _extent: extent to compare

        Returns:
            True if 3D extent is the same as no world.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsNoWorld3D_TGIS_Extent3D
        """
        pass

    @classmethod
    def GisIsPointInsideExtent(
      cls,
      _ptg: TGIS_Point,
      _extent: TGIS_Extent
    ) -> bool: 
        """
        Test if a given point is inside a given extent.

        Args:
            _ptg: point to test
            _extent: polygon to test

        Returns:
            True if point is located inside of the extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsPointInsideExtent_TGIS_Point_TGIS_Extent
        """
        pass

    @classmethod
    def GisIsPointInsidePolygon(
      cls,
      _ptg: TGIS_Point,
      _shape: TGIS_ShapePolygon
    ) -> bool: 
        """
        Test if a given point is inside a given polygon.

        Args:
            _ptg: point to test
            _shape: polygon to test

        Returns:
            True if point is inside of polygon.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsPointInsidePolygon_TGIS_Point_TGIS_ShapePolygon
        """
        pass

    @overload
    @classmethod
    def GisIsSameExtent(
      cls,
      _extent1: TGIS_Extent,
      _extent2: TGIS_Extent
    ) -> bool: 
        """
        Are two extents equal?

        Args:
            _extent1: extent to compare
            _extent2: extent to compare

        Returns:
            True if extents are equal.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsSameExtent_TGIS_Extent_TGIS_Extent
        """
        pass

    @overload
    @classmethod
    def GisIsSameExtent(
      cls,
      _extent1: TGIS_Extent,
      _extent2: TGIS_Extent,
      _tol: float
    ) -> bool: 
        """
        Are two extents equal?

        Args:
            _extent1: extent to compare
            _extent2: extent to compare
            _tol: tolerance of comparison

        Returns:
            True if are equal

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsSameExtent_TGIS_Extent_TGIS_Extent_Double
        """
        pass

    @overload
    @classmethod
    def GisIsSameExtent3D(
      cls,
      _extent1: TGIS_Extent3D,
      _extent2: TGIS_Extent3D,
      _tol: float
    ) -> bool: 
        """
        Are two 3D extents equal?

        Args:
            _extent1: extent to compare
            _extent2: extent to compare
            _tol: tolerance of comparison

        Returns:
            True if are equal

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsSameExtent3D_TGIS_Extent3D_TGIS_Extent3D_Double
        """
        pass

    @overload
    @classmethod
    def GisIsSameExtent3D(
      cls,
      _extent1: TGIS_Extent3D,
      _extent2: TGIS_Extent3D
    ) -> bool: 
        """
        Are two 3D extents equal?

        Args:
            _extent1: extent to compare
            _extent2: extent to compare

        Returns:
            True if 3D extents are equal.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsSameExtent3D_TGIS_Extent3D_TGIS_Extent3D
        """
        pass

    @overload
    @classmethod
    def GisIsSameExtent3DM(
      cls,
      _extent1: TGIS_Extent3D,
      _extent2: TGIS_Extent3D
    ) -> bool: 
        """
        Are two 3D extents equal?

        Args:
            _extent1: extent to compare
            _extent2: extent to compare

        Returns:
            True if are equal

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsSameExtent3DM_TGIS_Extent3D_TGIS_Extent3D
        """
        pass

    @overload
    def GisIsSameExtent3DM(
      self,
      _extent1: TGIS_Extent3D,
      _extent2: TGIS_Extent3D,
      _tol: float
    ) -> bool: 
        """
        Are two 3D extents equal?

        Args:
            _extent1: extent to compare
            _extent2: extent to compare
            _tol: tolerance of comparison

        Returns:
            True if are equal

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsSameExtent3DM_TGIS_Extent3D_TGIS_Extent3D_Double
        """
        pass

    @overload
    @classmethod
    def GisIsSamePoint(
      cls,
      _ptg1: TGIS_Point,
      _ptg2: TGIS_Point
    ) -> bool: 
        """
        Are two points equal?

        Args:
            _ptg1: point to compare
            _ptg2: point to compare

        Returns:
            True if points are equal.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsSamePoint_TGIS_Point_TGIS_Point
        """
        pass

    @overload
    @classmethod
    def GisIsSamePoint(
      cls,
      _ptg1: TGIS_Point,
      _ptg2: TGIS_Point,
      _tol: float
    ) -> bool: 
        """
        Are two points equal?

        Args:
            _ptg1: point to compare
            _ptg2: point to compare
            _tol: tolerance of comparison

        Returns:
            True if are equal

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsSamePoint_TGIS_Point_TGIS_Point_Double
        """
        pass

    @overload
    @classmethod
    def GisIsSamePoint3D(
      cls,
      _ptg1: TGIS_Point3D,
      _ptg2: TGIS_Point3D
    ) -> bool: 
        """
        Are two 3D points equal in 3D?

        Args:
            _ptg1: point to compare
            _ptg2: point to compare

        Returns:
            True if points are equal.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsSamePoint3D_TGIS_Point3D_TGIS_Point3D
        """
        pass

    @overload
    @classmethod
    def GisIsSamePoint3D(
      cls,
      _ptg1: TGIS_Point3D,
      _ptg2: TGIS_Point3D,
      _tol: float
    ) -> bool: 
        """
        Are two 3D points equal in 3D?

        Args:
            _ptg1: point to compare
            _ptg2: point to compare
            _tol: tolerance of comparison

        Returns:
            True if are equal

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsSamePoint3D_TGIS_Point3D_TGIS_Point3D_Double
        """
        pass

    @overload
    @classmethod
    def GisIsSamePoint3DM(
      cls,
      _ptg1: TGIS_Point3D,
      _ptg2: TGIS_Point3D
    ) -> bool: 
        """
        Are two 3D points equal in 3D?

        Args:
            _ptg1: point to compare
            _ptg2: point to compare

        Returns:
            True if are equal

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsSamePoint3DM_TGIS_Point3D_TGIS_Point3D
        """
        pass

    @overload
    def GisIsSamePoint3DM(
      self,
      _ptg1: TGIS_Point3D,
      _ptg2: TGIS_Point3D,
      _tol: float
    ) -> bool: 
        """
        Are two 3D points equal in 3D?

        Args:
            _ptg1: point to compare
            _ptg2: point to compare
            _tol: tolerance of comparison

        Returns:
            True if are equal

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsSamePoint3DM_TGIS_Point3D_TGIS_Point3D_Double
        """
        pass

    @classmethod
    def GisIsWholeWorld(
      cls,
      _extent: TGIS_Extent
    ) -> bool: 
        """
        Is extent same as whole world?

        Args:
            _extent: extent to compare

        Returns:
            True if extent is the same as extent of whole world.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsWholeWorld_TGIS_Extent
        """
        pass

    @classmethod
    def GisIsWholeWorld3D(
      cls,
      _extent: TGIS_Extent3D
    ) -> bool: 
        """
        Is 3D extent same as whole world?

        Args:
            _extent: extent to compare

        Returns:
            True if 3D extent is the same as extent of whole world.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisIsWholeWorld3D_TGIS_Extent3D
        """
        pass

    @overload
    @classmethod
    def GisLatitudeToStr(
      cls,
      _val: float
    ) -> str: 
        """
        Convert latitude in radians to a string representation.

        Args:
            _val: latitude in radians

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLatitudeToStr_Double
        """
        pass

    @overload
    @classmethod
    def GisLatitudeToStr(
      cls,
      _val: float,
      _spaces: bool
    ) -> str: 
        """
        Convert latitude in radians to a string representation.

        Args:
            _val: latitude in radians
            _spaces: if True, then text will be space separated

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLatitudeToStr_Double_Boolean
        """
        pass

    @overload
    @classmethod
    def GisLatitudeToStr(
      cls,
      _val: float,
      _spaces: bool,
      _prec: int
    ) -> str: 
        """
        Convert latitude in radians to a string representation.

        Args:
            _val: latitude in radians
            _spaces: if True, then text will be space separated
            _prec: number of precise digits

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLatitudeToStr_Double_Boolean_Integer
        """
        pass

    @overload
    @classmethod
    def GisLatitudeToStr(
      cls,
      _val: float,
      _spaces: bool,
      _prec: int,
      _leading: bool
    ) -> str: 
        """
        Convert latitude in radians to a string representation.

        Args:
            _val: latitude in radians
            _spaces: if True, then text will be space separated
            _prec: number of precise digits
            _leading: if True, then leading zeros will be presented

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLatitudeToStr_Double_Boolean_Integer_Boolean
        """
        pass

    @overload
    @classmethod
    def GisLine(
      cls,
      _a: TGIS_Point,
      _b: TGIS_Point
    ) -> TGIS_Line: 
        """
        Create a new line.

        Args:
            _a: beginning of a line
            _b: end of line

        Returns:
            New line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLine_TGIS_Point_TGIS_Point
        """
        pass

    @overload
    @classmethod
    def GisLine(
      cls,
      _ax: float,
      _ay: float,
      _bx: float,
      _by: float
    ) -> TGIS_Line: 
        """
        Create a new line.

        Args:
            _ax: beginning of a line, x coordinate
            _ay: beginning of a line, y coordinate
            _bx: end of line, x coordinate
            _by: end of line, y coordinate

        Returns:
            New line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLine_Double_Double_Double_Double
        """
        pass

    @classmethod
    def GisLine2Line(
      cls,
      _line1A: TGIS_Point,
      _line1B: TGIS_Point,
      _line2A: TGIS_Point,
      _line2B: TGIS_Point
    ) -> float: 
        """
        Calculates line to line distance.

        Args:
            _line1A: beginning of line 1
            _line1B: ending of line 1
            _line2A: beginning of line 2
            _line2B: ending of line 2

        Returns:
            Distance between two lines.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLine2Line_TGIS_Point_TGIS_Point_TGIS_Point_TGIS_Point
        """
        pass

    @classmethod
    def GisLine2Line3D(
      cls,
      _line1A: TGIS_Point3D,
      _line1B: TGIS_Point3D,
      _line2A: TGIS_Point3D,
      _line2B: TGIS_Point3D
    ) -> float: 
        """
        Calculates line to line distance in 3D.

        Args:
            _line1A: beginning of line 1
            _line1B: ending of line 1
            _line2A: beginning of line 2
            _line2B: ending of line 2

        Returns:
            Distance between two 3D lines.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLine2Line3D_TGIS_Point3D_TGIS_Point3D_TGIS_Point3D_TGIS_Point3D
        """
        pass

    @classmethod
    def GisLine2Point(
      cls,
      _lineA: TGIS_Point,
      _lineB: TGIS_Point,
      _ptg: TGIS_Point
    ) -> float: 
        """
        Calculates line to point distance.

        Args:
            _lineA: beginning of line
            _lineB: ending of line
            _ptg: point

        Returns:
            Distance between point and line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLine2Point_TGIS_Point_TGIS_Point_TGIS_Point
        """
        pass

    @classmethod
    def GisLine2Point3D(
      cls,
      _lineA: TGIS_Point3D,
      _lineB: TGIS_Point3D,
      _ptg: TGIS_Point3D
    ) -> float: 
        """
        Calculates line to point distance in 3D.

        Args:
            _lineA: beginning of line
            _lineB: ending of line
            _ptg: point

        Returns:
            Distance between 3D point and 3D line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLine2Point3D_TGIS_Point3D_TGIS_Point3D_TGIS_Point3D
        """
        pass

    @classmethod
    def GisLine2Point3DFuzzy(
      cls,
      _lineA: TGIS_Point3D,
      _lineB: TGIS_Point3D,
      _ptg: TGIS_Point3D
    ) -> float: 
        """
        Calculates line to point distance.

        Args:
            _lineA: beginning of line
            _lineB: ending of line
            _ptg: point

        Returns:
            Distance between 3D point and 3D line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLine2Point3DFuzzy_TGIS_Point3D_TGIS_Point3D_TGIS_Point3D
        """
        pass

    @classmethod
    def GisLine2PointFuzzy(
      cls,
      _lineA: TGIS_Point,
      _lineB: TGIS_Point,
      _ptg: TGIS_Point
    ) -> float: 
        """
        Calculates line to point distance.

        Args:
            _lineA: beginning of line
            _lineB: ending of line
            _ptg: point

        Returns:
            Distance between point and line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLine2PointFuzzy_TGIS_Point_TGIS_Point_TGIS_Point
        """
        pass

    @classmethod
    def GisLine3D(
      cls,
      _a: TGIS_Point3D,
      _b: TGIS_Point3D
    ) -> TGIS_Line3D: 
        """
        Create a new line.

        Args:
            _a: beginning of a line
            _b: end of line

        Returns:
            New line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLine3D_TGIS_Point3D_TGIS_Point3D
        """
        pass

    @classmethod
    def GisLineLength(
      cls,
      _lineA: TGIS_Point,
      _lineB: TGIS_Point
    ) -> float: 
        """
        Calculates line length.

        Args:
            _lineA: beginning of line
            _lineB: ending of line

        Returns:
            Length of the line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLineLength_TGIS_Point_TGIS_Point
        """
        pass

    @classmethod
    def GisLocalizedStringsFromFile(
      cls,
      _path: str,
      _language: str,
      _errpath: str
    ) -> None: 
        """
        Updates resource string variables with the localized content loaded from file

        Args:
            _path: name of the file with localization strings
            _language: name of the language
            _errpath: if not empty then missed symbols will be saved to the file named _errpath

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLocalizedStringsFromFile_String_String_String
        """
        pass

    @classmethod
    def GisLocalizedStringsFromString(
      cls,
      _localization: str,
      _errpath: str
    ) -> None: 
        """
        Updates resource string variables with the localized content loaded from string.

        Args:
            _localization: string with localization KEY=TRANSLATION pairs
            _errpath: if not empty then missed symbols will be saved to the file named _errpath

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLocalizedStringsFromString_String_String
        """
        pass

    @overload
    @classmethod
    def GisLongitudeToStr(
      cls,
      _val: float
    ) -> str: 
        """
        Convert a longitude in radians to a string representation.

        Args:
            _val: longitude in radians

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLongitudeToStr_Double
        """
        pass

    @overload
    @classmethod
    def GisLongitudeToStr(
      cls,
      _val: float,
      _spaces: bool
    ) -> str: 
        """
        Convert a longitude in radians to a string representation.

        Args:
            _val: longitude in radians
            _spaces: if True, then text will be space separated

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLongitudeToStr_Double_Boolean
        """
        pass

    @overload
    @classmethod
    def GisLongitudeToStr(
      cls,
      _val: float,
      _spaces: bool,
      _prec: int
    ) -> str: 
        """
        Convert a longitude in radians to a string representation.

        Args:
            _val: longitude in radians
            _spaces: if True, then text will be space separated
            _prec: number of precise digits

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLongitudeToStr_Double_Boolean_Integer
        """
        pass

    @overload
    @classmethod
    def GisLongitudeToStr(
      cls,
      _val: float,
      _spaces: bool,
      _prec: int,
      _leading: bool
    ) -> str: 
        """
        Convert a longitude in radians to a string representation.

        Args:
            _val: longitude in radians
            _spaces: if True, then text will be space separated
            _prec: number of precise digits
            _leading: if True, then leading zeros will be presented

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisLongitudeToStr_Double_Boolean_Integer_Boolean
        """
        pass

    @classmethod
    def GisMaxExtent(
      cls,
      _extent1: TGIS_Extent,
      _extent2: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Maximum of two extents.

        Args:
            _extent1: area to compare
            _extent2: area to compare

        Returns:
            Maximum extent computed out of two extents.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisMaxExtent_TGIS_Extent_TGIS_Extent
        """
        pass

    @classmethod
    def GisMaxExtent3D(
      cls,
      _extent1: TGIS_Extent3D,
      _extent2: TGIS_Extent3D
    ) -> TGIS_Extent3D: 
        """
        Maximum of two 3D extents.

        Args:
            _extent1: area to compare
            _extent2: area to compare

        Returns:
            Maximum 3D extent computed out of two extents.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisMaxExtent3D_TGIS_Extent3D_TGIS_Extent3D
        """
        pass

    @classmethod
    def GisMetadata(
      cls
    ) -> TGIS_StringList: 
        """
        Access function for a general purpose data container.

        Returns:
            Metadata object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisMetadata_void
        """
        pass

    def GisMetadataAsBoolean(
      self,
      _name: str,
      _default: bool
    ) -> bool: 
        """
        Read global metadata value

        Args:
            _name: _name of the value
            _default: default value to be used if value does not exist

        Returns:
            Read value or default.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisMetadataAsBoolean_String_Boolean
        """
        pass

    def GisMetadataAsFloat(
      self,
      _name: str,
      _default: float
    ) -> float: 
        """
        Read global metadata value

        Args:
            _name: _name of the value
            _default: default value to be used if value does not exist

        Returns:
            Read value or default.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisMetadataAsFloat_String_Double
        """
        pass

    def GisMetadataAsInteger(
      self,
      _name: str,
      _default: int
    ) -> int: 
        """
        Read global metadata value

        Args:
            _name: _name of the value
            _default: default value to be used if value does not exist

        Returns:
            Read value or default.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisMetadataAsInteger_String_Integer
        """
        pass

    def GisMetadataAsString(
      self,
      _name: str,
      _default: str
    ) -> str: 
        """
        Read global metadata value

        Args:
            _name: _name of the value
            _default: default value to be used if value does not exist

        Returns:
            Read value or default.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisMetadataAsString_String_String
        """
        pass

    @classmethod
    def GisMovePoint(
      cls,
      _ptg: TGIS_Point,
      _delta: TGIS_Point
    ) -> TGIS_Point: 
        """
        Move point by a given delta value.

        Args:
            _ptg: point to move
            _delta: movement

        Returns:
            Moved point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisMovePoint_TGIS_Point_TGIS_Point
        """
        pass

    @classmethod
    def GisMovePoint3D(
      cls,
      _ptg: TGIS_Point3D,
      _delta: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Move point by a given delta value in 3D.

        Args:
            _ptg: point to move
            _delta: movement

        Returns:
            Moved 3D point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisMovePoint3D_TGIS_Point3D_TGIS_Point3D
        """
        pass

    def GisNormalizedSQLName(
      self,
      _name: str
    ) -> str: 
        """
        Prepare normalized version of a field name.

        Args:
            _name: field name to be normalized

        Returns:
            Normalized version of a field name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisNormalizedSQLName_String
        """
        pass

    @classmethod
    def GisNoWorld(
      cls
    ) -> TGIS_Extent: 
        """
        Returns an nil extent.

        Returns:
            Nil extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisNoWorld_void
        """
        pass

    @classmethod
    def GisNoWorld3D(
      cls
    ) -> TGIS_Extent3D: 
        """
        Returns an nil 3D extent.

        Returns:
            Nil 3D extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisNoWorld3D_void
        """
        pass

    def GisOpenCLEngine(
      self
    ) -> TGIS_OpenCLEngine: 
        """
        Returns a global OpenCL engine object.

        Returns:
            OpenCL engine object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisOpenCLEngine_void
        """
        pass

    def GisPathRelative(
      self,
      _dir: str,
      _path: str
    ) -> str: 
        """
        Returns a path given by _path but relative to directory given by _dir. Path recognized 
        as URL and path with CE delimited strings will not be altered.

        Args:
            _dir: reference directory
            _path: given path

        Returns:
            Path given by _path but relative to directory given by _dir.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisPathRelative_String_String
        """
        pass

    @classmethod
    def GisPoint(
      cls,
      _x: float,
      _y: float
    ) -> TGIS_Point: 
        """
        Create a new point.

        Args:
            _x: coordinate
            _y: coordinate

        Returns:
            New point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisPoint_Double_Double
        """
        pass

    @classmethod
    def GisPoint2DFrom3D(
      cls,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point: 
        """
        Convert 3D point into 2D point.

        Args:
            _ptg: point to be converted

        Returns:
            New point converted from 3D.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisPoint2DFrom3D_TGIS_Point3D
        """
        pass

    @classmethod
    def GisPoint2Point(
      cls,
      _ptg1: TGIS_Point,
      _ptg2: TGIS_Point
    ) -> float: 
        """
        Calculates point-to-point distance.

        Args:
            _ptg1: first point
            _ptg2: second point

        Returns:
            Distance between two points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisPoint2Point_TGIS_Point_TGIS_Point
        """
        pass

    @classmethod
    def GisPoint2Point3D(
      cls,
      _ptg1: TGIS_Point3D,
      _ptg2: TGIS_Point3D
    ) -> float: 
        """
        Calculates point-to-point distance in 3D.

        Args:
            _ptg1: first point
            _ptg2: second point

        Returns:
            Distance between two 3D points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisPoint2Point3D_TGIS_Point3D_TGIS_Point3D
        """
        pass

    @overload
    @classmethod
    def GisPoint3D(
      cls,
      _x: float,
      _y: float,
      _z: float
    ) -> TGIS_Point3D: 
        """
        Create a new 3D point.

        Args:
            _x: coordinate
            _y: coordinate
            _z: coordinate

        Returns:
            New 3D point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisPoint3D_Double_Double_Double
        """
        pass

    @overload
    @classmethod
    def GisPoint3D(
      cls,
      _x: float,
      _y: float,
      _z: float,
      _m: float
    ) -> TGIS_Point3D: 
        """
        Create a new 3D point.

        Args:
            _x: coordinate
            _y: coordinate
            _z: coordinate
            _m: measure

        Returns:
            New 3D point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisPoint3D_Double_Double_Double_Double
        """
        pass

    @classmethod
    def GisPoint3DFrom2D(
      cls,
      _ptg: TGIS_Point
    ) -> TGIS_Point3D: 
        """
        Convert 2D point into 3D point.

        Args:
            _ptg: point to be converted

        Returns:
            New 3D point converted from 2D.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisPoint3DFrom2D_TGIS_Point
        """
        pass

    @classmethod
    def GisPointOnLine(
      cls,
      _lineA: TGIS_Point,
      _lineB: TGIS_Point,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        Calculates a projection of a point into the line.

        Args:
            _lineA: begin of line
            _lineB: end of line
            _ptg: point

        Returns:
            Projection of a point into the line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisPointOnLine_TGIS_Point_TGIS_Point_TGIS_Point
        """
        pass

    @classmethod
    def GisPointOnLine3D(
      cls,
      _lineA: TGIS_Point3D,
      _lineB: TGIS_Point3D,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Calculates a projection of a point into the line in 3D.

        Args:
            _lineA: begin of line
            _lineB: end of line
            _ptg: point

        Returns:
            Projection of a 3D point into the 3D line.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisPointOnLine3D_TGIS_Point3D_TGIS_Point3D_TGIS_Point3D
        """
        pass

    @classmethod
    def GisPointsDelta(
      cls,
      _pt1: TGIS_Point,
      _pt2: TGIS_Point
    ) -> TGIS_Point: 
        """
        Calculates delta between two points.

        Args:
            _pt1: point to comparison
            _pt2: point to comparison

        Returns:
            Delta between two points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisPointsDelta_TGIS_Point_TGIS_Point
        """
        pass

    @classmethod
    def GisPointsDelta3D(
      cls,
      _pt1: TGIS_Point3D,
      _pt2: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Calculates delta between two points in 3D.

        Args:
            _pt1: point to comparison
            _pt2: point to comparison

        Returns:
            Delta between two 3D points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisPointsDelta3D_TGIS_Point3D_TGIS_Point3D
        """
        pass

    @classmethod
    def GisRadToCompass(
      cls,
      _angle: float
    ) -> str: 
        """
        Converts an angle in radians to compass (NW, SW etc) representation.

        Args:
            _angle: angle in radians

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisRadToCompass_Double
        """
        pass

    @classmethod
    def GisRotatePoint(
      cls,
      _ref: TGIS_Point,
      _ptg: TGIS_Point,
      _angle: float
    ) -> TGIS_Point: 
        """
        Rotate point by a given angle.

        Args:
            _ref: reference point (origin )
            _ptg: point to rotate
            _angle: angle (in radians)

        Returns:
            Rotated point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisRotatePoint_TGIS_Point_TGIS_Point_Double
        """
        pass

    @classmethod
    def GisSamplesDataDir(
      cls
    ) -> str: 
        """
        Returns directory in which samples data was installed.

        Returns:
            Directory path.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisSamplesDataDir_void
        """
        pass

    @classmethod
    def GisSamplesDataDirDownload(
      cls
    ) -> str: 
        """
        Download if necessary and returns directory in which samples data was installed.

        Returns:
            full path

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisSamplesDataDirDownload_void
        """
        pass

    @classmethod
    def GisScalePoint(
      cls,
      _ref: TGIS_Point,
      _ptg: TGIS_Point,
      _scale: float
    ) -> TGIS_Point: 
        """
        Scale point by a given delta value.

        Args:
            _ref: reference point (origin )
            _ptg: point to scale
            _scale: movement

        Returns:
            Scaled point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisScalePoint_TGIS_Point_TGIS_Point_Double
        """
        pass

    @classmethod
    def GisScalePoint3D(
      cls,
      _ref: TGIS_Point3D,
      _ptg: TGIS_Point3D,
      _scale: float
    ) -> TGIS_Point3D: 
        """
        Scale point by a given delta value in 3D.

        Args:
            _ref: reference point (origin )
            _ptg: point to scale
            _scale: movement

        Returns:
            Scaled 3D point.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisScalePoint3D_TGIS_Point3D_TGIS_Point3D_Double
        """
        pass

    @classmethod
    def GisSetProxySettings(
      cls,
      _server: str,
      _port: int,
      _user: str,
      _pass: str,
      _domain: str
    ) -> None: 
        """
        Set global proxy settings.

        Args:
            _server: Host to be used as a proxy
            _port: Port used to communicate to the proxy
            _user: UserName needed to be authenticated to the proxy
            _pass: PassWord needed to be authenticated to the proxy
            _domain: Domain to be used with the proxy

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisSetProxySettings_String_Integer_String_String_String
        """
        pass

    @classmethod
    def GisStrToAngle(
      cls,
      _txt: str
    ) -> float: 
        """
        Convert a angle in a string representation into value in radians.

        Args:
            _txt: angle in a string format; must be in range -180..360

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisStrToAngle_String
        """
        pass

    @classmethod
    def GisStrToLatitude(
      cls,
      _txt: str
    ) -> float: 
        """
        Convert longitude in a string representation into value in radians.

        Args:
            _txt: latitude in a string format; must be in range -180..360

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisStrToLatitude_String
        """
        pass

    @classmethod
    def GisStrToLongitude(
      cls,
      _txt: str
    ) -> float: 
        """
        Convert a latitude in a string representation into value in radians.

        Args:
            _txt: latitude in a string format; must be in range -90..90

        Returns:
            Converted value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisStrToLongitude_String
        """
        pass

    @overload
    def GisSunPosition(
      self,
      _ptg: TGIS_Point,
      _utc_time: TDateTime,
      _altitude: VarParameter,
      _azimuth: VarParameter
    ) -> None: 
        """
        Calculate sun''s position based on time, date, and location on Earth

        Args:
            _ptg: observer''s location in geographic coordinate system expressed in radians
            _utc_time: observer''s time given in UTC (Coordinated Universal Time);
            _altitude: angular height in radians of the sun in the sky measured from the horizontal; 
              values from 0 at sunrise and sunset to Pi/2 at solar noon (also known as an elevation 
              angle); the value (in/out) is passed as float in _altitude.Value property
            _azimuth: angle in radians in the horizontal plane measured clockwise from north 
              to the horizontal projection of the sun''s rays; values from 0 to 2*Pi; the value 
              (in/out) is passed as float in _azimuth.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisSunPosition_TGIS_Point_TDateTime_Double_Double
        """
        pass

    @overload
    def GisSunPosition(
      self,
      _ptg: TGIS_Point,
      _local_time: TDateTime,
      _utc_offset: float,
      _altitude: VarParameter,
      _azimuth: VarParameter
    ) -> None: 
        """
        Calculate sun''s position based on time, date, and location on Earth

        Args:
            _ptg: observer''s location in geographic coordinate system expressed in radians
            _local_time: observer''s local time
            _utc_offset: time difference in hours between UTC and local time for a particular 
              place and date; Daylight Saving Time must be taken into account.
            _altitude: angular height in radians of the sun in the sky measured from the horizontal; 
              values from 0 at sunrise and sunset to 90 at solar noon (also known as an elevation 
              angle); the value (in/out) is passed as float in _altitude.Value property
            _azimuth: angle in radians in the horizontal plane measured clockwise from north 
              to the horizontal projection of the sun''s rays; values from 0 to 2*Pi; the value 
              (in/out) is passed as float in _azimuth.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisSunPosition_TGIS_Point_TDateTime_Double_Double_Double
        """
        pass

    @classmethod
    def GisSupportedFiles(
      cls,
      _mode: typing.Sequence[TGIS_FileType],
      _save: bool
    ) -> str: 
        """
        Prepare the list of supported files for use by open/save dialog box.

        Args:
            _mode: mode of query (only vector files, all files etc.)
            _save: if true, the string for save dialog box context will be prepared; if false 
              then string for open dialog box context will be prepared;

        Returns:
            Supported files.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisSupportedFiles_TGIS_FileTypes_Boolean
        """
        pass

    @classmethod
    def GisSystemCodePage(
      cls
    ) -> int: 
        """
        Get charset for system (current).

        Returns:
            Charset value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisSystemCodePage_void
        """
        pass

    @classmethod
    def GisTopologyForceShapeFixing(
      cls,
      _mode: bool
    ) -> None: 
        """
        Set default topological operation mode.

        Args:
            _mode: If True then topological operations will force shape fixing. See TGIS_Topology.ForceShapeFixing 
              for details.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisTopologyForceShapeFixing_Boolean
        """
        pass

    @classmethod
    def GisWholeWorld(
      cls
    ) -> TGIS_Extent: 
        """
        Returns an infinite extent

        Returns:
            Infinite extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisWholeWorld_void
        """
        pass

    @classmethod
    def GisWholeWorld3D(
      cls
    ) -> TGIS_Extent3D: 
        """
        Returns an infinite 3D extent

        Returns:
            Infinite extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisWholeWorld3D_void
        """
        pass

    @classmethod
    def GIS_RELATE_CONTAINS(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_CONTAINS_void
        """
        pass

    @classmethod
    def GIS_RELATE_CROSS(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_CROSS_void
        """
        pass

    @classmethod
    def GIS_RELATE_CROSS_LINE(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_CROSS_LINE_void
        """
        pass

    @classmethod
    def GIS_RELATE_DISJOINT(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_DISJOINT_void
        """
        pass

    @classmethod
    def GIS_RELATE_EQUALITY(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_EQUALITY_void
        """
        pass

    @classmethod
    def GIS_RELATE_INTERSECT(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_INTERSECT_void
        """
        pass

    @classmethod
    def GIS_RELATE_INTERSECT1(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_INTERSECT1_void
        """
        pass

    @classmethod
    def GIS_RELATE_INTERSECT2(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_INTERSECT2_void
        """
        pass

    @classmethod
    def GIS_RELATE_INTERSECT3(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_INTERSECT3_void
        """
        pass

    @classmethod
    def GIS_RELATE_INTERSECT_BOUNDARY_BOUNDARY(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_INTERSECT_BOUNDARY_BOUNDARY_void
        """
        pass

    @classmethod
    def GIS_RELATE_INTERSECT_BOUNDARY_INTERIOR(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_INTERSECT_BOUNDARY_INTERIOR_void
        """
        pass

    @classmethod
    def GIS_RELATE_INTERSECT_INTERIOR_BOUNDARY(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_INTERSECT_INTERIOR_BOUNDARY_void
        """
        pass

    @classmethod
    def GIS_RELATE_INTERSECT_INTERIOR_INTERIOR(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_INTERSECT_INTERIOR_INTERIOR_void
        """
        pass

    @classmethod
    def GIS_RELATE_LINE_CROSSTRAVERS_POLYGON(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_LINE_CROSSTRAVERS_POLYGON_void
        """
        pass

    @classmethod
    def GIS_RELATE_LINE_CROSS_LINE(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_LINE_CROSS_LINE_void
        """
        pass

    @classmethod
    def GIS_RELATE_LINE_CROSS_POLYGON(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_LINE_CROSS_POLYGON_void
        """
        pass

    @classmethod
    def GIS_RELATE_LINE_TRAVERS_POLYGON(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_LINE_TRAVERS_POLYGON_void
        """
        pass

    @classmethod
    def GIS_RELATE_OVERLAP(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_OVERLAP_void
        """
        pass

    @classmethod
    def GIS_RELATE_OVERLAP_LINE(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_OVERLAP_LINE_void
        """
        pass

    @classmethod
    def GIS_RELATE_POLYGON_CROSSED_BY_LINE(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_POLYGON_CROSSED_BY_LINE_void
        """
        pass

    @classmethod
    def GIS_RELATE_POLYGON_CROSSTRAVERSED_BY_LINE(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_POLYGON_CROSSTRAVERSED_BY_LINE_void
        """
        pass

    @classmethod
    def GIS_RELATE_POLYGON_TRAVERSED_BY_LINE(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_POLYGON_TRAVERSED_BY_LINE_void
        """
        pass

    @classmethod
    def GIS_RELATE_TOUCH(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_TOUCH_void
        """
        pass

    @classmethod
    def GIS_RELATE_TOUCH_BOUNDARY_BOUNDARY(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_TOUCH_BOUNDARY_BOUNDARY_void
        """
        pass

    @classmethod
    def GIS_RELATE_TOUCH_BOUNDARY_INTERIOR(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_TOUCH_BOUNDARY_INTERIOR_void
        """
        pass

    @classmethod
    def GIS_RELATE_TOUCH_INTERIOR(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_TOUCH_INTERIOR_void
        """
        pass

    @classmethod
    def GIS_RELATE_TOUCH_INTERIOR_BOUNDARY(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_TOUCH_INTERIOR_BOUNDARY_void
        """
        pass

    @classmethod
    def GIS_RELATE_WITHIN(
      cls
    ) -> str: 
        """
        Predefine DE-9IM array.

        Returns:
            DE-9IM matrix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RELATE_WITHIN_void
        """
        pass

    @classmethod
    def GIS_RENDER_SIZE(
      cls
    ) -> int: 
        """
        Size which indicates that renderer must be used.

        Returns:
            Size to be used by renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GIS_RENDER_SIZE_void
        """
        pass

    @classmethod
    def ParamAlignment(
      cls,
      _value: str,
      _default: TGIS_LabelAlignment
    ) -> TGIS_LabelAlignment: 
        """
        Convert a literal value into an internal representation.

        Args:
            _value: value to translate; can be: SINGLE, LEFTJUSTIFY, CENTER, RIGHTJUSTIFY, FOLLOW
            _default: default value

        Returns:
            Internal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ParamAlignment_String_TGIS_LabelAlignment
        """
        pass

    @classmethod
    def ParamBitmap(
      cls,
      _value: str,
      _default: TGIS_Bitmap
    ) -> TGIS_Bitmap: 
        """
        Convert a literal value into an internal representation.

        Args:
            _value: value to translate; bitmap will be loaded into memory; please remember to 
              free it on your own;
            _default: default value

        Returns:
            Internal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ParamBitmap_String_TGIS_Bitmap
        """
        pass

    @classmethod
    def ParamBoolean(
      cls,
      _value: str,
      _default: bool
    ) -> bool: 
        """
        Convert a literal value into an internal representation.

        Args:
            _value: value to translate
            _default: default value

        Returns:
            Internal representation

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ParamBoolean_String_Boolean
        """
        pass

    @classmethod
    def ParamChart(
      cls,
      _value: str,
      _default: TGIS_ChartStyle
    ) -> TGIS_ChartStyle: 
        """
        Convert a literal value into an internal representation.

        Args:
            _value: value to translate; can be: PIE, BAR
            _default: default value

        Returns:
            Internal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ParamChart_String_TGIS_ChartStyle
        """
        pass

    @classmethod
    def ParamColor(
      cls,
      _value: str,
      _default: TGIS_Color
    ) -> TGIS_Color: 
        """
        Convert a literal value into an internal representation.

        Args:
            _value: : value to translate; can be\: * hexadecimal BGR color ($0000FF for red) 
              * integer BGR color (255 for red ) * red\:green\:blue (255\:0\:0 for red) * color 
              names:\ * AQUA * BLACK * BLUE, * FUCHSIA, * GRAY * GREEN * LIME, * MAROON, * NAVY 
              * OLIVE, * PURPLE, * RED, * SILVER * TEAL * WHITE, * YELLOW if value RENDER, then 
              predefined value for renderer will be assigned.
            _default: : default value

        Returns:
            Internal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ParamColor_String_TGIS_Color
        """
        pass

    @classmethod
    def ParamDormant(
      cls,
      _value: str,
      _default: TGIS_LayerDormantMode
    ) -> TGIS_LayerDormantMode: 
        """
        Convert a literal value into an internal representation.

        Args:
            _value: value to translate; can be: OFF, STANDARD, AGGRESSIVE
            _default: default value

        Returns:
            Internal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ParamDormant_String_TGIS_LayerDormantMode
        """
        pass

    @classmethod
    def ParamFloat(
      cls,
      _value: str,
      _default: float
    ) -> float: 
        """
        Convert a literal value into an internal representation.

        Args:
            _value: value to translate
            _default: default value

        Returns:
            Internal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ParamFloat_String_Double
        """
        pass

    @classmethod
    def ParamFontStyle(
      cls,
      _value: str,
      _default: typing.Sequence[TGIS_FontStyle]
    ) -> typing.Sequence[TGIS_FontStyle]: 
        """
        Convert a literal value into an internal representation.

        Args:
            _value: value to translate; can be: val1:val2:...:valN (BOLD:ITALIC) from set of 
              NORMAL, BOLD, ITALIC, UNDERLINE, STRIKEOUT;
            _default: default value

        Returns:
            Internal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ParamFontStyle_String_TGIS_FontStyles
        """
        pass

    @classmethod
    def ParamInteger(
      cls,
      _value: str,
      _default: int
    ) -> int: 
        """
        Convert a literal value into an internal representation.

        Args:
            _value: value to translate; if value RENDER then predefined value for renderer will 
              be assigned.
            _default: default value

        Returns:
            Internal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ParamInteger_String_Integer
        """
        pass

    @classmethod
    def ParamMarker(
      cls,
      _value: str,
      _default: TGIS_MarkerStyle
    ) -> TGIS_MarkerStyle: 
        """
        Convert a literal value into an internal representation.

        Args:
            _value: value to translate; can be: BOX, CIRCLE, CROSS, DIAGCROSS, TRIANGLEUP, TRIANGLEDOWN, 
              TRIANGLELEFT, TRIANGLERIGHT
            _default: default value

        Returns:
            Internal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ParamMarker_String_TGIS_MarkerStyle
        """
        pass

    @classmethod
    def ParamPattern(
      cls,
      _value: str,
      _default: TGIS_BrushStyle
    ) -> TGIS_BrushStyle: 
        """
        Convert a literal value into an internal representation.

        Args:
            _value: value to translate; can be: SOLID, BDIAGONAL, FDIAGONAL, CROSS, DIAGCROSS, 
              HORIZONTAL, VERTICAL, TRANSPARENT
            _default: default value

        Returns:
            Internal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ParamPattern_String_TGIS_BrushStyle
        """
        pass

    @classmethod
    def ParamPen(
      cls,
      _value: str,
      _default: TGIS_PenStyle
    ) -> TGIS_PenStyle: 
        """
        Convert a literal value into an internal representation.

        Args:
            _value: value to translate; can be: SOLID, DASH, DOT, DASHDOT, DASHDOTDOT, CLEAR
            _default: default value

        Returns:
            Internal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ParamPen_String_TGIS_PenStyle
        """
        pass

    @classmethod
    def ParamPosition(
      cls,
      _value: str,
      _default: typing.Sequence[TGIS_LabelPosition]
    ) -> typing.Sequence[TGIS_LabelPosition]: 
        """
        Convert a literal value into an internal representation.

        Args:
            _value: value to translate; can be: UPLEFT, UPCENTER, UPRIGHT, MIDDLELEFT, MIDDLECENTER, 
              MIDDLERIGHT, DOWNLEFT, DOWNCENTER, DOWNRIGHT, UPRRIGHTFIRST, UPLEFTFIRST, MIDDLEFIRST, 
              FLOW, ANY
            _default: default value

        Returns:
            Internal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ParamPosition_String_TGIS_LabelPositions
        """
        pass

    @classmethod
    def ParamString(
      cls,
      _value: str,
      _default: str
    ) -> str: 
        """
        Convert a literal value into an internal representation.

        Args:
            _value: value to translate; _value string is expected to be in C/C# format: so ''\\'' 
              will be converted to ''\'' and ''\n'' to CRLF (new line - codes 13+10); if value 
              starts with ''
            _default: default value

        Returns:
            Internal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ParamString_String_String
        """
        pass

    @classmethod
    def ParamSymbol(
      cls,
      _value: str,
      _default: TGIS_SymbolAbstract
    ) -> TGIS_SymbolAbstract: 
        """
        Convert a literal value into an internal representation.

        Args:
            _value: value to translate; can be: SOLID, BDIAGONAL, FDIAGONAL, CROSS, DIAGCROSS, 
              HORIZONTAL, VERTICAL, TRANSPARENT
            _default: default value

        Returns:
            Internal representation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ParamSymbol_String_TGIS_SymbolAbstract
        """
        pass

    def SetLicense(
      self,
      _code: str
    ) -> None: 
        """
        Set license code.

        Args:
            _code: license code

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.SetLicense_String
        """
        pass

    @property
    def CSAreaList(
      self
    ) -> TGIS_CSAreaList: 
        """
        Global Instance of list of all areas.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.CSAreaList
        """
        pass

    @property
    def CSDatumList(
      self
    ) -> TGIS_CSDatumList: 
        """
        Global Instance of list of all datums.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.CSDatumList
        """
        pass

    @property
    def CSEllipsoidList(
      self
    ) -> TGIS_CSEllipsoidList: 
        """
        Global Instance of list of all ellipsoids.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.CSEllipsoidList
        """
        pass

    @property
    def CSGeographicCoordinateSystemList(
      self
    ) -> TGIS_CSGeographicCoordinateSystemList: 
        """
        Global Instance of list of all GCS.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.CSGeographicCoordinateSystemList
        """
        pass

    @property
    def CSPrimeMeridianList(
      self
    ) -> TGIS_CSPrimeMeridianList: 
        """
        Global Instance of list of all prime meridians.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.CSPrimeMeridianList
        """
        pass

    @property
    def CSProjectedCoordinateSystemList(
      self
    ) -> TGIS_CSProjectedCoordinateSystemList: 
        """
        Global Instance of list of all PCS.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.CSProjectedCoordinateSystemList
        """
        pass

    @property
    def CSProjList(
      self
    ) -> TGIS_CSProjList: 
        """
        Global Instance of list of all projections.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.CSProjList
        """
        pass

    @property
    def CSTransformList(
      self
    ) -> TGIS_CSTransformList: 
        """
        Global Instance of list of all transformations.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.CSTransformList
        """
        pass

    @property
    def CSUnitsList(
      self
    ) -> TGIS_CSUnitsList: 
        """
        Global Instance of list of all units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.CSUnitsList
        """
        pass

    @property
    def CSUnknownCoordinateSystem(
      self
    ) -> TGIS_CSUnknownCoordinateSystem: 
        """
        Global Instance of UNKNOWN cs (1 object only).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.CSUnknownCoordinateSystem
        """
        pass

    @property
    def ForcedRTreePath(
      self
    ) -> str: 
        """
        Forced RTree Path.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ForcedRTreePath
        """
        pass

    @ForcedRTreePath.setter
    def ForcedRTreePath(
      self,
      _value: str
    ) -> None: 
        """
        Forced RTree Path.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.ForcedRTreePath
        """
        pass

    @property
    def GisAliasList(
      self
    ) -> TGIS_AliasList: 
        """
        AliasList storage.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisAliasList
        """
        pass

    @property
    def GisColorRampList(
      self
    ) -> TGIS_ColorRampList: 
        """
        Color ramps list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisColorRampList
        """
        pass

    @property
    def GisEnvironmentInfo(
      self
    ) -> TGIS_EnvironmentInfo: 
        """
        Runtime environment info.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisEnvironmentInfo
        """
        pass

    @property
    def GisKeyList(
      self
    ) -> TGIS_PasswordList: 
        """
        KeyList storage.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisKeyList
        """
        pass

    @property
    def GisPasswordList(
      self
    ) -> TGIS_PasswordList: 
        """
        PasswordList storage.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisPasswordList
        """
        pass

    @property
    def GisProxySettings(
      self
    ) -> TGIS_ProxySettings: 
        """
        Proxy Settings.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.GisProxySettings
        """
        pass

    @property
    def PipelineOperations(
      self
    ) -> TGIS_PipelineOperations: 
        """
        Global list of all defined pipeline''s operations.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.PipelineOperations
        """
        pass

    @property
    def RendererManager(
      self
    ) -> TGIS_RendererManager: 
        """
        List of registered renderers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.RendererManager
        """
        pass

    @property
    def SymbolList(
      self
    ) -> TGIS_SymbolList: 
        """
        List of symbols.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Utils.SymbolList
        """
        pass

class TGIS_GridToVectorAbstract( TObject ):
    """
    Abstract class for all classes which implement vector generation from grid layers.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToVectorAbstract
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToVectorAbstract.Create_void
        """
        pass

    def Generate(
      self,
      _grid: TGIS_LayerPixel,
      _vector: TGIS_LayerVector,
      _field: str
    ) -> None: 
        """
        Creates vector shapes from a grid layer.

        Args:
            _grid: the input grid layer
            _vector: the output vector layer
            _field: if not empty, the field of the specified name will be populated with the 
              grid value to the created shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToVectorAbstract.Generate_TGIS_LayerPixel_TGIS_LayerVector_String
        """
        pass

    @property
    def IgnoreNoData(
      self
    ) -> bool: 
        """
        If true (default), cells of NoData is ommitted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToVectorAbstract.IgnoreNoData
        """
        pass

    @IgnoreNoData.setter
    def IgnoreNoData(
      self,
      _value: bool
    ) -> None: 
        """
        If true (default), cells of NoData is ommitted.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToVectorAbstract.IgnoreNoData
        """
        pass

    @property
    def Tolerance(
      self
    ) -> float: 
        """
        A minimum distinguishing value of the grid cells.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToVectorAbstract.Tolerance
        """
        pass

    @Tolerance.setter
    def Tolerance(
      self,
      _value: float
    ) -> None: 
        """
        A minimum distinguishing value of the grid cells.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToVectorAbstract.Tolerance
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToVectorAbstract.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToVectorAbstract.BusyEvent
        """
        pass

class TGIS_GridToPoint( TGIS_GridToVectorAbstract ):
    """
    Class that enables grid to vector (point) conversion.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToPoint
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToPoint.Create_void
        """
        pass

    @property
    def PointSpacing(
      self
    ) -> float: 
        """
        Poins spacing in layer''s CS units for sampling grid. PointSpacing=0 (default) means 
        that points are generated at each grid cell.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToPoint.PointSpacing
        """
        pass

    @PointSpacing.setter
    def PointSpacing(
      self,
      _value: float
    ) -> None: 
        """
        Poins spacing in layer''s CS units for sampling grid. PointSpacing=0 (default) means 
        that points are generated at each grid cell.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToPoint.PointSpacing
        """
        pass

class TGIS_GridToPolygon( TGIS_GridToVectorAbstract ):
    """
    Class that enables grid to vector (polygon) conversion.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToPolygon
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToPolygon.Create_void
        """
        pass

    @property
    def SplitShapes(
      self
    ) -> bool: 
        """
        If True (default), single-part polygon shapes are created; otherwise multipart shapes 
        are created.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToPolygon.SplitShapes
        """
        pass

    @SplitShapes.setter
    def SplitShapes(
      self,
      _value: bool
    ) -> None: 
        """
        If True (default), single-part polygon shapes are created; otherwise multipart shapes 
        are created.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_GridToPolygon.SplitShapes
        """
        pass

class TGIS_Viewer( TObject, IGIS_Viewer ):
    """
    Encapsulation of the generic viewer. This viewer will not be accessed directly. Instead 
    you can use TGIS_ViewerWnd, TGIS_ViewerBmp, or any future successors.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer
    """

    @overload
    def __init__(
      self,
      _owner: IGIS_ViewerParent
    ) -> None: 
        """
        Standard constructor.

        Args:
            _owner: object owner

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Create_IGIS_ViewerParent
        """
        pass

    def Add(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Add a layer to the Viewer.

        Args:
            _layer: layer to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Add_TGIS_LayerAbstract
        """
        pass

    def AddHierarchy(
      self
    ) -> None: 
        """
        Read hierarchy and build groups with layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.AddHierarchy_void
        """
        pass

    def AttachLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> IGIS_Viewer: 
        """
        Attach layer to the viewer by re-parenting.

        Args:
            _layer: layer to be attached

        Returns:
            Previous parent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.AttachLayer_TGIS_LayerAbstract
        """
        pass

    def BeginPaintInternal(
      self
    ) -> None: 
        """
        Notify viewer about entering of a paint mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.BeginPaintInternal_void
        """
        pass

    def BusyPrepare(
      self,
      _sender: TObject,
      _text: str
    ) -> None: 
        """
        Prepare BusyEvent for long-term operation.

        Args:
            _sender: component which is causing long-term operations
            _text: text to appear in a BusyText property; predefined GIS_BUSY_NOEVENTS and GIS_BUSY_NOHOURGLASS 
              could be used to define "silent" busy state; in such state BusyEvent will not be 
              called and, in a case of GIS_BUSY_NOHOURGLASS, hourglass will not be displayed and 
              check for interrupt as well.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.BusyPrepare_TObject_String
        """
        pass

    def BusyRelease(
      self,
      _sender: TObject
    ) -> None: 
        """
        Release Busy state.

        Args:
            _sender: component which is causing long-term operations

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.BusyRelease_TObject
        """
        pass

    def BusyShake(
      self,
      _sender: TObject,
      _pos: int,
      _end: int,
      _abort: VarParameter
    ) -> None: 
        """
        Shake Busy state.

        Args:
            _sender: component which is causing long-term operations
            _pos: current progress
            _end: maximal progress value
            _abort: if set to True inside message handler then an abort request.; the value (in/out) 
              is passed as bool in _abort.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.BusyShake_TObject_Int64_Int64_Boolean
        """
        pass

    def CenterViewport(
      self,
      _ptg: TGIS_Point
    ) -> None: 
        """
        Set viewport to the vale when _ptg will be visible on the center of the screen. Same 
        as property Center

        Args:
            _ptg: coordinates in map units

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.CenterViewport_TGIS_Point
        """
        pass

    def ChangeHash(
      self
    ) -> int: 
        """
        Change hash. Uses to verify if order of layers, params, etc. has been modified. Used 
        mainly by TGIS_ControlLegend.

        Returns:
            Calculated hash value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ChangeHash_void
        """
        pass

    def Close(
      self
    ) -> None: 
        """
        Close a project.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Close_void
        """
        pass

    def Delete(
      self,
      _name: str
    ) -> None: 
        """
        Delete the layer identified by a name.

        Args:
            _name: name of layer to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Delete_String
        """
        pass

    def Draw(
      self,
      _renderer: TObject,
      _mode: TGIS_DrawMode
    ) -> None: 
        """
        Draw all layers on a current renderer.

        Args:
            _renderer: renderer context
            _mode: drawing mode: which set of layers should be rendered

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Draw_TObject_TGIS_DrawMode
        """
        pass

    def EndPaintInternal(
      self
    ) -> None: 
        """
        Notify viewer about leaving of a paint mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.EndPaintInternal_void
        """
        pass

    def FullExtent(
      self
    ) -> None: 
        """
        Calculate the screen origin, zoom, and viewport to place the whole map in the window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.FullExtent_void
        """
        pass

    def FullExtentZoom(
      self
    ) -> float: 
        """
        Calculates a zoom which places the whole map inside the window

        Returns:
            Zoom value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.FullExtentZoom_void
        """
        pass

    def Get(
      self,
      _name: str
    ) -> TGIS_LayerAbstract: 
        """
        Retrieve the layer identified by a name. Sublayer or compund layers can be found 
        by do notation like ''name.sublyer''

        Args:
            _name: name of layer to be found

        Returns:
            Found layer or nil if not found.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Get_String
        """
        pass

    def GetGrid(
      self,
      _extent: TGIS_Extent,
      _grid: TGIS_GridArray
    ) -> bool: 
        """
        Fills provided _grid array with values defined by _extent. If extent is not fully 
        covered by the gird layers then values outside the layers scope will be left untouched.

        Args:
            _extent: extent of the _grid
            _grid: allocated array (with/height ratio of the _grid should be the same as width/height 
              ration of the _extent)

        Returns:
            True if success.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.GetGrid_TGIS_Extent_TGIS_GridArray
        """
        pass

    def GetRenderContext(
      self
    ) -> TObject: 
        """
        Return current context object.

        Returns:
            Current renderer context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.GetRenderContext_void
        """
        pass

    def HourglassActive(
      self
    ) -> bool: 
        """
        Test is hourglass is active.

        Returns:
            True is Hourglass is visible and Interrupt can be called.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.HourglassActive_void
        """
        pass

    def HourglassPrepare(
      self
    ) -> None: 
        """
        Prepare Hourglass cursor for timely operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.HourglassPrepare_void
        """
        pass

    def HourglassRelease(
      self
    ) -> None: 
        """
        Release Hourglass.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.HourglassRelease_void
        """
        pass

    def HourglassRestart(
      self
    ) -> None: 
        """
        Restart hourglass timing used for progressive updates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.HourglassRestart_void
        """
        pass

    def HourglassShake(
      self
    ) -> bool: 
        """
        Shake Hourglass.

        Returns:
            If True then current operation should be interrupted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.HourglassShake_void
        """
        pass

    def Interrupt(
      self
    ) -> None: 
        """
        Will terminate timely operation as soon as possible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Interrupt_void
        """
        pass

    def Interrupted(
      self
    ) -> bool: 
        """
        Test if any pending operation must be aborted.

        Returns:
            True is if any lengy;lu operation must be aborted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Interrupted_void
        """
        pass

    def InvalidateBasemap(
      self
    ) -> None: 
        """
        Invalidate only basemap layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.InvalidateBasemap_void
        """
        pass

    def InvalidateEditor(
      self,
      _final: bool
    ) -> None: 
        """
        Invalidate editor. To mark viewer after editor change to redraw state.

        Args:
            _final: True if map must updated at the end of editing process; otherwise a normal 
              "shallow" screen refresh to be performed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.InvalidateEditor_Boolean
        """
        pass

    @overload
    def InvalidateExtent(
      self,
      _extent: TGIS_Extent
    ) -> None: 
        """
        Invalidate an extent for full map redraw

        Args:
            _extent: extent to redraw

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.InvalidateExtent_TGIS_Extent
        """
        pass

    @overload
    def InvalidateExtent(
      self,
      _extent: TGIS_Extent,
      _deep: bool
    ) -> None: 
        """
        Invalidate an extent.

        Args:
            _extent: extent to redraw
            _deep: True if whole map must marked for update; if False then only shallow repaint 
              will be issued (only topmost layers)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.InvalidateExtent_TGIS_Extent_Boolean
        """
        pass

    def InvalidateSelection(
      self
    ) -> None: 
        """
        Invalidate selection. To mark viewer after selection change to redraw state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.InvalidateSelection_void
        """
        pass

    def InvalidateTopmost(
      self
    ) -> None: 
        """
        Invalidate only topmost layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.InvalidateTopmost_void
        """
        pass

    def InvalidateWholeMap(
      self
    ) -> None: 
        """
        Invalidate whole map. All layers must be updated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.InvalidateWholeMap_void
        """
        pass

    @overload
    def Locate(
      self,
      _ptg: TGIS_Point,
      _prec: float
    ) -> TGIS_ShapeAbstract: 
        """
        Locate a shape that is near _ptg, but is closer than _prec distance.

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in map units

        Returns:
            Located shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Locate_TGIS_Point_Double
        """
        pass

    @overload
    def Locate(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _visible: bool
    ) -> TGIS_ShapeAbstract: 
        """
        Locate a shape that is near _ptg, but is closer than _prec distance.

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in map units
            _visible: if true the only visible shapes will be evaluated; shapes turned of by 
              query of hidden will be ignored

        Returns:
            Located shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Locate_TGIS_Point_Double_Boolean
        """
        pass

    @overload
    def Locate(
      self,
      _pt: TPoint,
      _prec: int
    ) -> TGIS_ShapeAbstract: 
        """
        Locate a shape that is near _pt, but is closer than _prec distance.

        Args:
            _pt: reference point /searching point/ in pixels
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in pixels

        Returns:
            Located shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Locate_TPoint_Integer
        """
        pass

    def LocateEx(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _visible: bool
    ) -> TGIS_ShapeAbstractList: 
        """
        Locate shapes on layers that are near _ptg, but closer than _prec distance. Still 
        only the best one candidate is chosen from each layer.

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in map units
            _visible: if true the only visible shapes will be evaluated; shapes turned of by 
              query of hidden will be ignored

        Returns:
            Allocated list of shapes from all viewer layers

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.LocateEx_TGIS_Point_Double_Boolean
        """
        pass

    def Lock(
      self
    ) -> None: 
        """
        Lock viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Lock_void
        """
        pass

    def MapToScreen(
      self,
      _ptg: TGIS_Point
    ) -> TPoint: 
        """
        Converts point coordinates from map related to screen related.

        Args:
            _ptg: coordinate in map units

        Returns:
            Map coordinates converted to screen coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.MapToScreen_TGIS_Point
        """
        pass

    def MapToScreen3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TPoint: 
        """
        Converts 3D point coordinates from map related to screen related.

        Args:
            _ptg: coordinate in map units

        Returns:
            Map coordinates converted to screen coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.MapToScreen3D_TGIS_Point3D
        """
        pass

    def MapToScreenEx(
      self,
      _pt: TGIS_Point
    ) -> TGIS_Point: 
        """
        Converts point coordinates from map related to screen related, but result will be 
        in TGIS_Point.

        Args:
            _pt: coordinate in map units

        Returns:
            map coordinates converted to screen coordinates

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.MapToScreenEx_TGIS_Point
        """
        pass

    def MapToScreenRect(
      self,
      _rct: TGIS_Extent
    ) -> TRect: 
        """
        Converts rectangle coordinates from map related to screen related.

        Args:
            _rct: coordinate in map units

        Returns:
            Calculated screen rectangle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.MapToScreenRect_TGIS_Extent
        """
        pass

    def MarkModified(
      self
    ) -> None: 
        """
        Mark viewer upon some modifications.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.MarkModified_void
        """
        pass

    def MoveViewport(
      self,
      _dx: VarParameter,
      _dy: VarParameter
    ) -> None: 
        """
        Move the screen origin of the map by delta values.

        Args:
            _dx: x delta in pixels; the value (in/out) is passed as int in _dx.Value property
            _dy: y delta in pixels; the value (in/out) is passed as int in _dy.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.MoveViewport_Integer_Integer
        """
        pass

    def MoveViewportEx(
      self,
      _dx: VarParameter,
      _dy: VarParameter
    ) -> None: 
        """
        Move the screen origin of the map by delta values.

        Args:
            _dx: x delta in map units; the value (in/out) is passed as float in _dx.Value property
            _dy: y delta in map units; the value (in/out) is passed as float in _dy.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.MoveViewportEx_Double_Double
        """
        pass

    def MustSave(
      self
    ) -> bool: 
        """
        Check if any layer or the project file was modified by editing.

        Returns:
            True if project should be saved.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.MustSave_void
        """
        pass

    def NotifySubscribers(
      self,
      _event: int,
      _context: TObject
    ) -> None: 
        """
        Send notification to subscribers.

        Args:
            _event: event identifying number
            _context: control context; what is expected depends on _event; it can be canvas, 
              control itself.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.NotifySubscribers_Integer_TObject
        """
        pass

    @overload
    def Open(
      self,
      _path: str
    ) -> None: 
        """
        Open project.

        Args:
            _path: project path (or layer)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Open_String
        """
        pass

    @overload
    def Open(
      self,
      _path: str,
      _strict: bool
    ) -> None: 
        """
        Open project.

        Args:
            _path: project path (or layer)
            _strict: if False then non existing layers will be ignored (only while opening project 
              files); default is True ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Open_String_Boolean
        """
        pass

    @overload
    def OpenEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str
    ) -> None: 
        """
        Open project file from the memory.

        Args:
            _configFile: project file
            _path: project path (or layer)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.OpenEx_TGIS_ConfigAbstract_String
        """
        pass

    @overload
    def OpenEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str,
      _strict: bool
    ) -> None: 
        """
        Open project file from the memory.

        Args:
            _configFile: project file
            _path: project path (or layer)
            _strict: if False then non existing layers will be ignored (only while opening project 
              files); default is True ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.OpenEx_TGIS_ConfigAbstract_String_Boolean
        """
        pass

    def PixelsToTwips(
      self,
      _size: int
    ) -> int: 
        """
        Convert size from device dependent pixels to device independent Twips (1/1440 inch). 
        Used to make map device independent.

        Args:
            _size: size in pixels; absolute value will be taken

        Returns:
            Size in twips.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.PixelsToTwips_Integer
        """
        pass

    def RaiseBusyEvent(
      self,
      _sender: TObject,
      _pos: int,
      _end: int,
      _abort: VarParameter
    ) -> None: 
        """
        Fire Busy event of a viewer.

        Args:
            _sender: component which is causing long-term operations
            _pos: current progress
            _end: maximal progress value
            _abort: if set to True inside message handler then an abort request.; the value (in/out) 
              is passed as bool in _abort.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RaiseBusyEvent_TObject_Int64_Int64_Boolean
        """
        pass

    def RaiseHelpEvent(
      self,
      _sender: TObject,
      _name: str
    ) -> None: 
        """
        Fire Busy event of a viewer.

        Args:
            _sender: component asking for help
            _name: help context

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RaiseHelpEvent_TObject_String
        """
        pass

    def ReadConfig(
      self
    ) -> None: 
        """
        Read all configuration data from project.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ReadConfig_void
        """
        pass

    def RecalcExtent(
      self
    ) -> None: 
        """
        Calculates a common extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RecalcExtent_void
        """
        pass

    def ReParent(
      self,
      _parent: IGIS_ViewerParent
    ) -> IGIS_ViewerParent: 
        """
        Set a new parent for the viewer.

        Args:
            _parent: new parent object

        Returns:
            Previous parent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ReParent_IGIS_ViewerParent
        """
        pass

    def Reposition(
      self
    ) -> None: 
        """
        Reposition the map within the component window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Reposition_void
        """
        pass

    def RereadConfig(
      self
    ) -> None: 
        """
        Reread all configuration data from project and layer configuration files.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RereadConfig_void
        """
        pass

    def ResetPPI(
      self
    ) -> None: 
        """
        Allow PPI recalculation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ResetPPI_void
        """
        pass

    def RestorePaintState(
      self,
      _state: VarParameter
    ) -> None: 
        """
        Restore and free the current paint state.

        Args:
            _state: paint state to be restored; the value (in/out) is passed as TObject in _state.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RestorePaintState_TObject
        """
        pass

    def RevertAll(
      self
    ) -> None: 
        """
        Revert all layers to a file-based original.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RevertAll_void
        """
        pass

    def RotatedExtent(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Compute extent (encompassing area of the extent) after the viewer rotation.

        Args:
            _extent: extent to be rotated

        Returns:
            Rotated extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RotatedExtent_TGIS_Extent
        """
        pass

    def RotatedPoint(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        Compute position of the point after the viewer rotation.

        Args:
            _ptg: point in to be rotated

        Returns:
            Rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RotatedPoint_TGIS_Point
        """
        pass

    def RotatedPoint3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Compute position of the 3D point after the viewer rotation.

        Args:
            _ptg: point to be rotated

        Returns:
            Rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RotatedPoint3D_TGIS_Point3D
        """
        pass

    def RotatedPoint3D_ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Compute position of the 3D point after the viewer rotation.

        Args:
            _ptg: point to be rotated; the value (in/out) is passed as TGIS_Point3D in _ptg.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RotatedPoint3D_ref_TGIS_Point3D
        """
        pass

    def SaveAll(
      self
    ) -> None: 
        """
        Save all layers (parameters and data)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SaveAll_void
        """
        pass

    def SaveData(
      self
    ) -> None: 
        """
        Save all changes to the data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SaveData_void
        """
        pass

    @overload
    def SaveProject(
      self
    ) -> None: 
        """
        Save current project.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SaveProject_void
        """
        pass

    @overload
    def SaveProject(
      self,
      _relativepath: bool
    ) -> None: 
        """
        Save current project.

        Args:
            _relativepath: if True (default) then project will be saved using paths relative 
              to project file location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SaveProject_Boolean
        """
        pass

    @overload
    def SaveProjectAs(
      self,
      _path: str
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SaveProjectAs_String
        """
        pass

    @overload
    def SaveProjectAs(
      self,
      _path: str,
      _relativepath: bool
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension
            _relativepath: if True (default) then project will be saved using paths relative 
              to project file location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SaveProjectAs_String_Boolean
        """
        pass

    @overload
    def SaveProjectAsEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _configFile: existing project file
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SaveProjectAsEx_TGIS_ConfigAbstract_String
        """
        pass

    @overload
    def SaveProjectAsEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str,
      _relativepath: bool
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _configFile: existing project file
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension
            _relativepath: if True (default) then project will be saved using paths relative 
              to project file location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SaveProjectAsEx_TGIS_ConfigAbstract_String_Boolean
        """
        pass

    def ScreenToMap(
      self,
      _pt: TPoint
    ) -> TGIS_Point: 
        """
        Converts point coordinates from screen related to map related.

        Args:
            _pt: coordinate in screen units

        Returns:
            Screen coordinates converted to map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ScreenToMap_TPoint
        """
        pass

    def ScreenToMap3D(
      self,
      _pt: TPoint
    ) -> TGIS_Point3D: 
        """
        Converts point coordinates from screen related to map related.

        Args:
            _pt: coordinate in screen units

        Returns:
            Screen coordinates converted to map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ScreenToMap3D_TPoint
        """
        pass

    def ScreenToMapEx(
      self,
      _pt: TGIS_Point
    ) -> TGIS_Point: 
        """
        Converts point coordinates from screen related to map related, but source will be 
        in TGIS_Point.

        Args:
            _pt: coordinate in screen units

        Returns:
            screen coordinates converted to map coordinates

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ScreenToMapEx_TGIS_Point
        """
        pass

    @overload
    def ScreenToMapRect(
      self,
      _rct: TRect
    ) -> TGIS_Extent: 
        """
        Converts rectangle coordinates from screen related to map related.

        Args:
            _rct: coordinate in screen units

        Returns:
            Calculated extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ScreenToMapRect_TRect
        """
        pass

    @overload
    def ScreenToMapRect(
      self,
      _left: int,
      _top: int,
      _right: int,
      _bottom: int
    ) -> TGIS_Extent: 
        """
        Converts point coordinates from screen related to map related.

        Args:
            _left: rectangle coordinate in screen units
            _top: rectangle coordinate in screen units
            _right: rectangle coordinate in screen units
            _bottom: rectangle coordinate in screen units

        Returns:
            Screen coordinates converted to map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ScreenToMapRect_Integer_Integer_Integer_Integer
        """
        pass

    def SetCSByEPSG(
      self,
      _epsg: int
    ) -> None: 
        """
        Setup Coordinate System to a coordinate system provided by EPSG code.

        Args:
            _epsg: EPSG code

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SetCSByEPSG_Integer
        """
        pass

    def SetCSByWKT(
      self,
      _wkt: str
    ) -> None: 
        """
        Setup Coordinate System to a coordinate system provided by WKT string (GEOGCS or 
        PROJCS). If provided WKT string is empty then coordinate system will be turn off.

        Args:
            _wkt: WKT string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SetCSByWKT_String
        """
        pass

    def SetCSByWKTFile(
      self,
      _path: str
    ) -> None: 
        """
        Setup Coordinate System to a coordinate system provided by file which contains WKT 
        string (GEOGCS or PROJCS). If file does not exist or provided WKT string is empty 
        then coordinate system will be turned off.

        Args:
            _path: path with WKT string (for example shapefile .PRJ)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SetCSByWKTFile_String
        """
        pass

    def SetViewport(
      self,
      _x: VarParameter,
      _y: VarParameter
    ) -> None: 
        """
        Set viewport to a given position.

        Args:
            _x: x coordinate; the value (in/out) is passed as float in _x.Value property
            _y: y coordinate; the value (in/out) is passed as float in _y.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SetViewport_Double_Double
        """
        pass

    def StorePaintState(
      self
    ) -> TObject: 
        """
        Store the current paint state.

        Returns:
            Stored paint state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.StorePaintState_void
        """
        pass

    def Subscribe(
      self,
      _control: IGIS_Subscribe
    ) -> None: 
        """
        Add provided control to the notification subscription list.

        Args:
            _control: - control which should become a subscriber

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Subscribe_IGIS_Subscribe
        """
        pass

    def SynchronizePaint(
      self,
      _interrupt: bool
    ) -> bool: 
        """
        Wait for pending paint operation to be finalized.

        Args:
            _interrupt: interrupts any pending operation

        Returns:
            True if operation were synchronized; False if synchronization is not possible and 
            current operation should not continue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SynchronizePaint_Boolean
        """
        pass

    def TwipsToPixels(
      self,
      _size: int
    ) -> int: 
        """
        Convert the size from to device independent Twips (1/1440 inch) to device dependent 
        pixels. Used to make map device independent.

        Args:
            _size: size in twips; if negative then treated as pixels

        Returns:
            Size in twips.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.TwipsToPixels_Integer
        """
        pass

    def TwipsToPoints(
      self,
      _size: int
    ) -> int: 
        """
        Convert the size from to device independent Twips (1/1440 inch) to device points. 
        Used for advanced font sizing.

        Args:
            _size: size in twips; if negative then treated as pixels

        Returns:
            Size in points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.TwipsToPoints_Integer
        """
        pass

    @overload
    def Unlock(
      self
    ) -> None: 
        """
        Unlock viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Unlock_void
        """
        pass

    @overload
    def Unlock(
      self,
      _redraw: bool
    ) -> None: 
        """
        Unlock the viewer but do not redraw

        Args:
            _redraw: If true then map should be redraw upon unlock; if false then redraw should 
              be issued.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Unlock_Boolean
        """
        pass

    def UnrotatedExtent(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Compute original extent of the rotated extent.

        Args:
            _extent: rotated extent

        Returns:
            Original un-rotated extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.UnrotatedExtent_TGIS_Extent
        """
        pass

    def UnrotatedPoint(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        Compute original position of the rotated point.

        Args:
            _ptg: rotated point

        Returns:
            Original un-rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.UnrotatedPoint_TGIS_Point
        """
        pass

    def UnrotatedPoint3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Compute original position of the rotated 3D point.

        Args:
            _ptg: rotated point

        Returns:
            Original un-rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.UnrotatedPoint3D_TGIS_Point3D
        """
        pass

    def UnrotatedPoint3D_ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Compute original position of the rotated 3D point.

        Args:
            _ptg: rotated point; the value (in/out) is passed as TGIS_Point3D in _ptg.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.UnrotatedPoint3D_ref_TGIS_Point3D
        """
        pass

    def UnSubscribe(
      self,
      _control: IGIS_Subscribe
    ) -> None: 
        """
        Remove provided control from the notification subscription list.

        Args:
            _control: control which subscription should be canceled

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.UnSubscribe_IGIS_Subscribe
        """
        pass

    def WaitForBackgroundProcesses(
      self
    ) -> None: 
        """
        Wait for any pending background processes that must be finalized before app can continue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.WaitForBackgroundProcesses_void
        """
        pass

    def WriteConfig(
      self
    ) -> None: 
        """
        Write all configuration data to the project or layer ini file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.WriteConfig_void
        """
        pass

    @property
    def AutoStyle(
      self
    ) -> bool: 
        """
        If True, layers added to the viewer will have a unique style applied; Default is 
        False.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.AutoStyle
        """
        pass

    @AutoStyle.setter
    def AutoStyle(
      self,
      _value: bool
    ) -> None: 
        """
        If True, layers added to the viewer will have a unique style applied; Default is 
        False.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.AutoStyle
        """
        pass

    @property
    def BigExtent(
      self
    ) -> TGIS_Extent: 
        """
        Map extent. Encompassing the collective extents of all layers and a border defined 
        by BigExtentMargin. Is depending on current scale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.BigExtent
        """
        pass

    @property
    def BigExtentMargin(
      self
    ) -> int: 
        """
        Map extent margin.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.BigExtentMargin
        """
        pass

    @BigExtentMargin.setter
    def BigExtentMargin(
      self,
      _value: int
    ) -> None: 
        """
        Map extent margin.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.BigExtentMargin
        """
        pass

    @property
    def BusyLevel(
      self
    ) -> int: 
        """
        Level of current busy state. If 1 then most significant busy is active; if 2 then 
        subsequent etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.BusyLevel
        """
        pass

    @property
    def BusyText(
      self
    ) -> str: 
        """
        Text related to current busy state. Text could be set upon BusyPrepare() call. If 
        IsBusy is not true then text will be an empty string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.BusyText
        """
        pass

    @property
    def Center(
      self
    ) -> TGIS_Point: 
        """
        Center the screen based on given point. Useful for "Center on Click". See property 
        CenterPtg.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Center
        """
        pass

    @Center.setter
    def Center(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Center the screen based on given point. Useful for "Center on Click". See property 
        CenterPtg.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Center
        """
        pass

    @property
    def CenterPtg(
      self
    ) -> TGIS_Point: 
        """
        Point on which Viewer will be centered during Zoom. Will not modify the Viewport. 
        Will set up the point without re centering the screen. See property Center.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.CenterPtg
        """
        pass

    @CenterPtg.setter
    def CenterPtg(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Point on which Viewer will be centered during Zoom. Will not modify the Viewport. 
        Will set up the point without re centering the screen. See property Center.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.CenterPtg
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Background color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Background color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Color
        """
        pass

    @property
    def Copyright(
      self
    ) -> str: 
        """
        Legal notice and product version.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Copyright
        """
        pass

    @property
    def CS(
      self
    ) -> TGIS_CSCoordinateSystem: 
        """
        Coordinate System assigned to the viewer. If set to nil the Coordinate System will 
        be turned off. Default is turned off.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.CS
        """
        pass

    @CS.setter
    def CS(
      self,
      _value: TGIS_CSCoordinateSystem
    ) -> None: 
        """
        Coordinate System assigned to the viewer. If set to nil the Coordinate System will 
        be turned off. Default is turned off.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.CS
        """
        pass

    @property
    def CustomData(
      self
    ) -> TGIS_StringList: 
        """
        List of custom, user-defined data. List is save/restored witch config/project files.
        
        List is in a form of "name=value".

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.CustomData
        """
        pass

    @property
    def CustomPPI(
      self
    ) -> int: 
        """
        Custom resolution in pixels-per-inch. If &lt;&gt; 0 then used instead of SystemPPI

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.CustomPPI
        """
        pass

    @CustomPPI.setter
    def CustomPPI(
      self,
      _value: int
    ) -> None: 
        """
        Custom resolution in pixels-per-inch. If &lt;&gt; 0 then used instead of SystemPPI

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.CustomPPI
        """
        pass

    @property
    def DelayedUpdate(
      self
    ) -> int: 
        """
        Delayed update threshold in milliseconds. If &gt;0 then map will be updated after 
        a while allowing for example subsequent draw operation before full map redraw. Default 
        value is 700.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.DelayedUpdate
        """
        pass

    @DelayedUpdate.setter
    def DelayedUpdate(
      self,
      _value: int
    ) -> None: 
        """
        Delayed update threshold in milliseconds. If &gt;0 then map will be updated after 
        a while allowing for example subsequent draw operation before full map redraw. Default 
        value is 700.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.DelayedUpdate
        """
        pass

    @property
    def Editor(
      self
    ) -> IGIS_Editor: 
        """
        Editor context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Editor
        """
        pass

    @Editor.setter
    def Editor(
      self,
      _value: IGIS_Editor
    ) -> None: 
        """
        Editor context.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Editor
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Extent: 
        """
        Map extent. Encompassing the collective extents of all layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Extent
        """
        pass

    @property
    def FileCopyrights(
      self
    ) -> str: 
        """
        List Copyrights

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.FileCopyrights
        """
        pass

    @property
    def FontScale(
      self
    ) -> int: 
        """
        Font magnifying factor in percents. To make fonts more readable without changing 
        PPI.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.FontScale
        """
        pass

    @FontScale.setter
    def FontScale(
      self,
      _value: int
    ) -> None: 
        """
        Font magnifying factor in percents. To make fonts more readable without changing 
        PPI.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.FontScale
        """
        pass

    @property
    def FullDrawExtent(
      self
    ) -> TGIS_Extent: 
        """
        Extent of full current/last drawing area including margin and w/o tiling.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.FullDrawExtent
        """
        pass

    @property
    def Hierarchy(
      self
    ) -> IGIS_HierarchyManager: 
        """
        Hierarchy list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Hierarchy
        """
        pass

    @property
    def IncrementalPaint(
      self
    ) -> bool: 
        """
        Is partial drawing to screen done in incremental mode?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.IncrementalPaint
        """
        pass

    @IncrementalPaint.setter
    def IncrementalPaint(
      self,
      _value: bool
    ) -> None: 
        """
        Is partial drawing to screen done in incremental mode?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.IncrementalPaint
        """
        pass

    @property
    def InPaint(
      self
    ) -> bool: 
        """
        True if Viewer is busy in Paint procedure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.InPaint
        """
        pass

    @property
    def IsBusy(
      self
    ) -> bool: 
        """
        True if Viewer is busy.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.IsBusy
        """
        pass

    @property
    def IsEmpty(
      self
    ) -> bool: 
        """
        True if Viewer is empty (no layers).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.IsEmpty
        """
        pass

    @property
    def IsLocked(
      self
    ) -> bool: 
        """
        True if Viewer is in locked state Lock.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.IsLocked
        """
        pass

    @property
    def IsTopmost(
      self
    ) -> bool: 
        """
        True if Viewer has a topmost layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.IsTopmost
        """
        pass

    @property
    def Items(
      self
    ) -> TGIS_LayerAbstractList: 
        """
        All layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Items
        """
        pass

    @property
    def KeepScale(
      self
    ) -> bool: 
        """
        True if a viewer should maintain scale upon resize.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.KeepScale
        """
        pass

    @KeepScale.setter
    def KeepScale(
      self,
      _value: bool
    ) -> None: 
        """
        True if a viewer should maintain scale upon resize.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.KeepScale
        """
        pass

    @property
    def LabelsReg(
      self
    ) -> TGIS_LabelsAreaAbstract: 
        """
        Labels position allocator object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.LabelsReg
        """
        pass

    @property
    def Level(
      self
    ) -> float: 
        """
        Sets and gets zoom level for a viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Level
        """
        pass

    @Level.setter
    def Level(
      self,
      _value: float
    ) -> None: 
        """
        Sets and gets zoom level for a viewer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Level
        """
        pass

    @property
    def MasterViewer(
      self
    ) -> IGIS_Viewer: 
        """
        Master Viewer reference. To be used only by TiledPaint.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.MasterViewer
        """
        pass

    @MasterViewer.setter
    def MasterViewer(
      self,
      _value: IGIS_Viewer
    ) -> None: 
        """
        Master Viewer reference. To be used only by TiledPaint.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.MasterViewer
        """
        pass

    @property
    def MultiUserMode(
      self
    ) -> TGIS_MultiUser: 
        """
        Multiuser mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.MultiUserMode
        """
        pass

    @MultiUserMode.setter
    def MultiUserMode(
      self,
      _value: TGIS_MultiUser
    ) -> None: 
        """
        Multiuser mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.MultiUserMode
        """
        pass

    @property
    def OverlappedExtentMargin(
      self
    ) -> int: 
        """
        Overlapped extent margin (in pixels).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.OverlappedExtentMargin
        """
        pass

    @OverlappedExtentMargin.setter
    def OverlappedExtentMargin(
      self,
      _value: int
    ) -> None: 
        """
        Overlapped extent margin (in pixels).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.OverlappedExtentMargin
        """
        pass

    @property
    def Parent(
      self
    ) -> IGIS_ViewerParent: 
        """
        Parent viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Parent
        """
        pass

    @property
    def PPI(
      self
    ) -> int: 
        """
        Rendering resolution in pixels-per-inch. Returns SystemPPI value or CustomPPI (if 
        &lt;&gt; 0) multiplied by ControlCanvasScale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.PPI
        """
        pass

    @property
    def ProgressiveUpdate(
      self
    ) -> int: 
        """
        Progressive update threshold in milliseconds. If &gt;0 then map will be updated on 
        a time consuming updates every provided period. Default value is 2500.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ProgressiveUpdate
        """
        pass

    @ProgressiveUpdate.setter
    def ProgressiveUpdate(
      self,
      _value: int
    ) -> None: 
        """
        Progressive update threshold in milliseconds. If &gt;0 then map will be updated on 
        a time consuming updates every provided period. Default value is 2500.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ProgressiveUpdate
        """
        pass

    @property
    def ProjectFile(
      self
    ) -> TGIS_ConfigAbstract: 
        """
        Project file itself as opened in Open procedure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ProjectFile
        """
        pass

    @ProjectFile.setter
    def ProjectFile(
      self,
      _value: TGIS_ConfigAbstract
    ) -> None: 
        """
        Project file itself as opened in Open procedure.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ProjectFile
        """
        pass

    @property
    def ProjectName(
      self
    ) -> str: 
        """
        Project file name as opened in Open procedure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ProjectName
        """
        pass

    @property
    def RestrictedDrag(
      self
    ) -> bool: 
        """
        If true, then you can not drag outside the map Extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RestrictedDrag
        """
        pass

    @RestrictedDrag.setter
    def RestrictedDrag(
      self,
      _value: bool
    ) -> None: 
        """
        If true, then you can not drag outside the map Extent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RestrictedDrag
        """
        pass

    @property
    def RestrictedExtent(
      self
    ) -> TGIS_Extent: 
        """
        Restricted Map extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RestrictedExtent
        """
        pass

    @RestrictedExtent.setter
    def RestrictedExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Restricted Map extent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RestrictedExtent
        """
        pass

    @property
    def RotationAngle(
      self
    ) -> float: 
        """
        Angle of viewer rotation in radians.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RotationAngle
        """
        pass

    @RotationAngle.setter
    def RotationAngle(
      self,
      _value: float
    ) -> None: 
        """
        Angle of viewer rotation in radians.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RotationAngle
        """
        pass

    @property
    def RotationPoint(
      self
    ) -> TGIS_Point: 
        """
        Point of viewer rotation in map units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RotationPoint
        """
        pass

    @RotationPoint.setter
    def RotationPoint(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Point of viewer rotation in map units.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.RotationPoint
        """
        pass

    @property
    def Scale(
      self
    ) -> float: 
        """
        Setting up and reading the scale factor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Scale
        """
        pass

    @Scale.setter
    def Scale(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the scale factor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Scale
        """
        pass

    @property
    def ScaleAsFloat(
      self
    ) -> float: 
        """
        Setting up and reading the scale factor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ScaleAsFloat
        """
        pass

    @ScaleAsFloat.setter
    def ScaleAsFloat(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the scale factor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ScaleAsFloat
        """
        pass

    @property
    def ScaleAsText(
      self
    ) -> str: 
        """
        Setting up and reading the scale factor as text in format ''1:10000''.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ScaleAsText
        """
        pass

    @ScaleAsText.setter
    def ScaleAsText(
      self,
      _value: str
    ) -> None: 
        """
        Setting up and reading the scale factor as text in format ''1:10000''.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ScaleAsText
        """
        pass

    @property
    def SelectionGisColor(
      self
    ) -> TGIS_Color: 
        """
        Color used for selecting object. See also SelectionTransparency.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SelectionGisColor
        """
        pass

    @SelectionGisColor.setter
    def SelectionGisColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Color used for selecting object. See also SelectionTransparency.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SelectionGisColor
        """
        pass

    @property
    def SelectionOutlineOnly(
      self
    ) -> bool: 
        """
        If true then polygons will be marked only with outline not a full fill.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SelectionOutlineOnly
        """
        pass

    @SelectionOutlineOnly.setter
    def SelectionOutlineOnly(
      self,
      _value: bool
    ) -> None: 
        """
        If true then polygons will be marked only with outline not a full fill.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SelectionOutlineOnly
        """
        pass

    @property
    def SelectionTransparency(
      self
    ) -> int: 
        """
        Transparency value for selection; if 100 SelectionGisColor will not be transparent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SelectionTransparency
        """
        pass

    @SelectionTransparency.setter
    def SelectionTransparency(
      self,
      _value: int
    ) -> None: 
        """
        Transparency value for selection; if 100 SelectionGisColor will not be transparent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SelectionTransparency
        """
        pass

    @property
    def SelectionWidth(
      self
    ) -> int: 
        """
        Outline width of selection area (&gt;0 in twips, &lt;0 in pixels).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SelectionWidth
        """
        pass

    @SelectionWidth.setter
    def SelectionWidth(
      self,
      _value: int
    ) -> None: 
        """
        Outline width of selection area (&gt;0 in twips, &lt;0 in pixels).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SelectionWidth
        """
        pass

    @property
    def SystemPPI(
      self
    ) -> int: 
        """
        System resolution in pixels-per-inch.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.SystemPPI
        """
        pass

    @property
    def TemporaryScaleInternal(
      self
    ) -> float: 
        """
        Used to force rendering in a different scale then actual.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.TemporaryScaleInternal
        """
        pass

    @TemporaryScaleInternal.setter
    def TemporaryScaleInternal(
      self,
      _value: float
    ) -> None: 
        """
        Used to force rendering in a different scale then actual.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.TemporaryScaleInternal
        """
        pass

    @property
    def TemporaryVisibleExtent(
      self
    ) -> TGIS_Extent: 
        """
        Used to force rendering labels while drawing with tiles.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.TemporaryVisibleExtent
        """
        pass

    @TemporaryVisibleExtent.setter
    def TemporaryVisibleExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Used to force rendering labels while drawing with tiles.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.TemporaryVisibleExtent
        """
        pass

    @property
    def TiledPaint(
      self
    ) -> bool: 
        """
        Is partial drawing to screen done in tiled mode?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.TiledPaint
        """
        pass

    @TiledPaint.setter
    def TiledPaint(
      self,
      _value: bool
    ) -> None: 
        """
        Is partial drawing to screen done in tiled mode?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.TiledPaint
        """
        pass

    @property
    def UponDestroy(
      self
    ) -> bool: 
        """
        True if viewer is upon destruction so some operations (like screen updates) should 
        not be performed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.UponDestroy
        """
        pass

    @property
    def UseAnimations(
      self
    ) -> bool: 
        """
        True if animation upon zooming are allowed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.UseAnimations
        """
        pass

    @UseAnimations.setter
    def UseAnimations(
      self,
      _value: bool
    ) -> None: 
        """
        True if animation upon zooming are allowed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.UseAnimations
        """
        pass

    @property
    def UseRTree(
      self
    ) -> bool: 
        """
        True if RTree will be used by default upon creation of any layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.UseRTree
        """
        pass

    @UseRTree.setter
    def UseRTree(
      self,
      _value: bool
    ) -> None: 
        """
        True if RTree will be used by default upon creation of any layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.UseRTree
        """
        pass

    @property
    def ViewerParent(
      self
    ) -> IGIS_ViewerParent: 
        """
        Parent for the current IGIS_Viewer object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ViewerParent
        """
        pass

    @property
    def ViewerParentRoot(
      self
    ) -> IGIS_ViewerParent: 
        """
        Parent for the current IGIS_Viewer object. If object is reparented then root parent 
        object will be returned.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ViewerParentRoot
        """
        pass

    @property
    def Viewport(
      self
    ) -> TGIS_Point: 
        """
        Setting an upper left corner position of the components window within the map.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Viewport
        """
        pass

    @Viewport.setter
    def Viewport(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Setting an upper left corner position of the components window within the map.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Viewport
        """
        pass

    @property
    def VisibleExtent(
      self
    ) -> TGIS_Extent: 
        """
        Extent of the map that is visible in the window. On setting an optimal zoom will 
        be calculated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.VisibleExtent
        """
        pass

    @VisibleExtent.setter
    def VisibleExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Extent of the map that is visible in the window. On setting an optimal zoom will 
        be calculated.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.VisibleExtent
        """
        pass

    @property
    def Zoom(
      self
    ) -> float: 
        """
        Setting up and reading the related zoom factor. If one map unit = one pixel, then 
        Zoom = 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Zoom
        """
        pass

    @Zoom.setter
    def Zoom(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the related zoom factor. If one map unit = one pixel, then 
        Zoom = 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.Zoom
        """
        pass

    @property
    def ZoomEx(
      self
    ) -> float: 
        """
        Setting up and reading the absolute zoom factor. If one map unit = one twips, then 
        Zoom = 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ZoomEx
        """
        pass

    @ZoomEx.setter
    def ZoomEx(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the absolute zoom factor. If one map unit = one twips, then 
        Zoom = 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ZoomEx
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        Busy event handler. Will be fired regularly during long-drawn operations. If end 
        value will be zero, the meaning is: long-drawn with unknown end time. Close long-drawn 
        operation by calling with parameters (-1,-1).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        Busy event handler. Will be fired regularly during long-drawn operations. If end 
        value will be zero, the meaning is: long-drawn with unknown end time. Close long-drawn 
        operation by calling with parameters (-1,-1).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.BusyEvent
        """
        pass

    @property
    def EditorPointChangeEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Point3D, TGIS_EditorOperation, TGIS_Point3D], None]: 
        """
        EditorPointChangeEvent event. Will be fired upon changing a point in the editor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.EditorPointChangeEvent
        """
        pass

    @EditorPointChangeEvent.setter
    def EditorPointChangeEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Point3D, TGIS_EditorOperation, TGIS_Point3D], None]
    ) -> None: 
        """
        EditorPointChangeEvent event. Will be fired upon changing a point in the editor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.EditorPointChangeEvent
        """
        pass

    @property
    def EditorPointMoveEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Point3D, TPoint], None]: 
        """
        EditorPointMoveEvent event. Will be fired upon editing a point in the editor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.EditorPointMoveEvent
        """
        pass

    @EditorPointMoveEvent.setter
    def EditorPointMoveEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Point3D, TPoint], None]
    ) -> None: 
        """
        EditorPointMoveEvent event. Will be fired upon editing a point in the editor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.EditorPointMoveEvent
        """
        pass

    @property
    def EditorSnapPointEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Point3D, Double, TGIS_Point3D, Double], None]: 
        """
        EditorSnapPoint event. Will be fired upon snapping a point in the editor in custom 
        snapping mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.EditorSnapPointEvent
        """
        pass

    @EditorSnapPointEvent.setter
    def EditorSnapPointEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Point3D, Double, TGIS_Point3D, Double], None]
    ) -> None: 
        """
        EditorSnapPoint event. Will be fired upon snapping a point in the editor in custom 
        snapping mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.EditorSnapPointEvent
        """
        pass

    @property
    def ExtentChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        ExtentChanged event. Will be fired on TGIS_Viewer.Extent change.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ExtentChangeEvent
        """
        pass

    @ExtentChangeEvent.setter
    def ExtentChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        ExtentChanged event. Will be fired on TGIS_Viewer.Extent change.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ExtentChangeEvent
        """
        pass

    @property
    def HelpEvent(
      self
    ) -> typing.Callable[[TObject, String], None]: 
        """
        Help event. If attached, all dialog boxes will have a help button, and clicking on 
        this button will raise an event.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.HelpEvent
        """
        pass

    @HelpEvent.setter
    def HelpEvent(
      self,
      _value: typing.Callable[[TObject, String], None]
    ) -> None: 
        """
        Help event. If attached, all dialog boxes will have a help button, and clicking on 
        this button will raise an event.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.HelpEvent
        """
        pass

    @property
    def LayerAddEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Layer], None]: 
        """
        LayerAdd event. Will be fired upon adding layer to the viewer: after creation but 
        before opening.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.LayerAddEvent
        """
        pass

    @LayerAddEvent.setter
    def LayerAddEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Layer], None]
    ) -> None: 
        """
        LayerAdd event. Will be fired upon adding layer to the viewer: after creation but 
        before opening.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.LayerAddEvent
        """
        pass

    @property
    def LayerDeleteEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Layer], None]: 
        """
        LayerDelete event. Will be fired upon deleting layer to the viewer: just before destructing 
        the layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.LayerDeleteEvent
        """
        pass

    @LayerDeleteEvent.setter
    def LayerDeleteEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Layer], None]
    ) -> None: 
        """
        LayerDelete event. Will be fired upon deleting layer to the viewer: just before destructing 
        the layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.LayerDeleteEvent
        """
        pass

    @property
    def PaintExceptionEvent(
      self
    ) -> typing.Callable[[TObject, EGIS_PaintException], None]: 
        """
        PaintException event. Will be fired when Paint rises an exception. If not assigned 
        a regular exception will be raised.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.PaintExceptionEvent
        """
        pass

    @PaintExceptionEvent.setter
    def PaintExceptionEvent(
      self,
      _value: typing.Callable[[TObject, EGIS_PaintException], None]
    ) -> None: 
        """
        PaintException event. Will be fired when Paint rises an exception. If not assigned 
        a regular exception will be raised.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.PaintExceptionEvent
        """
        pass

    @property
    def PasswordEvent(
      self
    ) -> typing.Callable[[TObject, String], str]: 
        """
        Password event. Will be fired upon opening layer to resolve any username/password 
        as a key/value pair. Supported only on selected layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.PasswordEvent
        """
        pass

    @PasswordEvent.setter
    def PasswordEvent(
      self,
      _value: typing.Callable[[TObject, String], str]
    ) -> None: 
        """
        Password event. Will be fired upon opening layer to resolve any username/password 
        as a key/value pair. Supported only on selected layers.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.PasswordEvent
        """
        pass

    @property
    def ProjectCloseEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        ProjectClose event. Will be fired on TGIS_Viewer.Close.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ProjectCloseEvent
        """
        pass

    @ProjectCloseEvent.setter
    def ProjectCloseEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        ProjectClose event. Will be fired on TGIS_Viewer.Close.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ProjectCloseEvent
        """
        pass

    @property
    def ProjectOpenEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        ProjectOpen event. Will be fired on TGIS_Viewer.Open.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ProjectOpenEvent
        """
        pass

    @ProjectOpenEvent.setter
    def ProjectOpenEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        ProjectOpen event. Will be fired on TGIS_Viewer.Open.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ProjectOpenEvent
        """
        pass

    @property
    def VisibleExtentChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        ExtentChanged event. Will be fired on TGIS_Viewer.Extent change. }

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.VisibleExtentChangeEvent
        """
        pass

    @VisibleExtentChangeEvent.setter
    def VisibleExtentChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        ExtentChanged event. Will be fired on TGIS_Viewer.Extent change. }

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.VisibleExtentChangeEvent
        """
        pass

    @property
    def ZoomChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        ZoomChange event. Will be fired before OnBeforePaint if Viewer.Zoom was changed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ZoomChangeEvent
        """
        pass

    @ZoomChangeEvent.setter
    def ZoomChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        ZoomChange event. Will be fired before OnBeforePaint if Viewer.Zoom was changed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer.ZoomChangeEvent
        """
        pass

class TGIS_ViewerNonVisual( TComponent, IGIS_Viewer, IGIS_ViewerParent ):
    """
    Encapsulation of the viewer w/o any kind of visual implementation. This viewer can 
    be used to manipulate project files, etc.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor. Creates bitmap 320x240.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Create_void
        """
        pass

    def Add(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Add a layer to the Viewer.

        Args:
            _layer: layer to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Add_TGIS_LayerAbstract
        """
        pass

    def AddHierarchy(
      self
    ) -> None: 
        """
        Read hierarchy and build groups with layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.AddHierarchy_void
        """
        pass

    def AttachLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> IGIS_Viewer: 
        """
        Attach layer to the viewer by re-parenting.

        Args:
            _layer: layer to be attached

        Returns:
            Previous parent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.AttachLayer_TGIS_LayerAbstract
        """
        pass

    def BeginPaintInternal(
      self
    ) -> None: 
        """
        Notify viewer about entering of a paint mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.BeginPaintInternal_void
        """
        pass

    def BusyPrepare(
      self,
      _sender: TObject,
      _text: str
    ) -> None: 
        """
        Prepare BusyEvent for long-term operation.

        Args:
            _sender: component which is causing long-term operations
            _text: text to appear in a BusyText property; predefined GIS_BUSY_NOEVENTS and GIS_BUSY_NOHOURGLASS 
              could be used to define "silent" busy state; in such state BusyEvent will not be 
              called and, in a case of GIS_BUSY_NOHOURGLASS, hourglass will not be displayed and 
              check for interrupt as well.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.BusyPrepare_TObject_String
        """
        pass

    def BusyRelease(
      self,
      _sender: TObject
    ) -> None: 
        """
        Release Busy state.

        Args:
            _sender: component which is causing long-term operations

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.BusyRelease_TObject
        """
        pass

    def BusyShake(
      self,
      _sender: TObject,
      _pos: int,
      _end: int,
      _abort: VarParameter
    ) -> None: 
        """
        Shake Busy state.

        Args:
            _sender: component which is causing long-term operations
            _pos: current progress
            _end: maximal progress value
            _abort: if set to True inside message handler then an abort request.; the value (in/out) 
              is passed as bool in _abort.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.BusyShake_TObject_Int64_Int64_Boolean
        """
        pass

    def CenterViewport(
      self,
      _ptg: TGIS_Point
    ) -> None: 
        """
        Set viewport to the vale when _ptg will be visible on the center of the screen. Same 
        as property Center

        Args:
            _ptg: coordinates in map units

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.CenterViewport_TGIS_Point
        """
        pass

    def ChangeHash(
      self
    ) -> int: 
        """
        Change hash. Uses to verify if order of layers, params, etc. has been modified. Used 
        mainly by TGIS_ControlLegend.

        Returns:
            Calculated hash value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ChangeHash_void
        """
        pass

    def Close(
      self
    ) -> None: 
        """
        Close a project.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Close_void
        """
        pass

    def ControlAutoCenterViewport(
      self,
      _dx: float,
      _dy: float
    ) -> None: 
        """
        Move the screen origin of the map by delta values.

        Args:
            _dx: x delta
            _dy: y delta

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlAutoCenterViewport_Double_Double
        """
        pass

    def ControlCanvasHeight(
      self
    ) -> int: 
        """
        Get canvas height.

        Returns:
            height.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlCanvasHeight_void
        """
        pass

    def ControlCanvasScale(
      self
    ) -> float: 
        """
        Get canvas scale.

        Returns:
            scale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlCanvasScale_void
        """
        pass

    def ControlCanvasWidth(
      self
    ) -> int: 
        """
        Get canvas width.

        Returns:
            width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlCanvasWidth_void
        """
        pass

    def ControlClose(
      self
    ) -> None: 
        """
        Notify control that is map is going to be closed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlClose_void
        """
        pass

    @overload
    def ControlDrawTexture(
      self,
      _bmp: TObject,
      _extent: TGIS_Extent,
      _ppi: int
    ) -> None: 
        """
        Draw texture.

        Args:
            _bmp: bitmap
            _extent: extent
            _ppi: PPI value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlDrawTexture_TObject_TGIS_Extent_Integer
        """
        pass

    @overload
    def ControlDrawTexture(
      self,
      _bmp: TObject,
      _layer: TGIS_LayerAbstract,
      _extent: TGIS_Extent,
      _ppi: int
    ) -> None: 
        """
        Draw texture.

        Args:
            _bmp: bitmap
            _layer: layer to be drawn; if nil then all non 3d layers will be rendered
            _extent: extent
            _ppi: PPI value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlDrawTexture_TObject_TGIS_LayerAbstract_TGIS_Extent_Integer
        """
        pass

    def ControlExtentChanged(
      self
    ) -> None: 
        """
        Notify control that is map extent was changed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlExtentChanged_void
        """
        pass

    def ControlFlash(
      self,
      _times: int,
      _delay: int
    ) -> None: 
        """
        Do flash.

        Args:
            _times: how many times
            _delay: delay between each flash

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlFlash_Integer_Integer
        """
        pass

    def ControlHourglassHide(
      self
    ) -> None: 
        """
        Do Hourglass hide.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlHourglassHide_void
        """
        pass

    def ControlHourglassShake(
      self
    ) -> bool: 
        """
        Do Hourglass shake.

        Returns:
            True if shake was made.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlHourglassShake_void
        """
        pass

    def ControlHourglassShow(
      self
    ) -> None: 
        """
        Do Hourglass show.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlHourglassShow_void
        """
        pass

    def ControlPPI(
      self
    ) -> int: 
        """
        Get current PPI.

        Returns:
            PPI value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlPPI_void
        """
        pass

    def ControlProcessMessages(
      self
    ) -> None: 
        """
        Do process messages.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlProcessMessages_void
        """
        pass

    def ControlRaiseEditorChangeEvent(
      self,
      _sender: TObject
    ) -> None: 
        """
        Raise event on editor change.

        Args:
            _sender: sender object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlRaiseEditorChangeEvent_TObject
        """
        pass

    def ControlRenderer(
      self
    ) -> TObject: 
        """
        Get renderer instance.

        Returns:
            renderer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlRenderer_void
        """
        pass

    def ControlRepaint(
      self
    ) -> None: 
        """
        Repaint control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlRepaint_void
        """
        pass

    def ControlSet3DMode(
      self,
      _mode: TGIS_Viewer3DMode
    ) -> None: 
        """
        Set current 3D mode.

        Args:
            _mode: 3D mode

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlSet3DMode_TGIS_Viewer3DMode
        """
        pass

    def ControlSystemPPI(
      self
    ) -> int: 
        """
        Get system PPI.

        Returns:
            PPI value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlSystemPPI_void
        """
        pass

    def ControlUpdateBasemap(
      self
    ) -> None: 
        """
        Update basemap.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlUpdateBasemap_void
        """
        pass

    def ControlUpdateEditor(
      self,
      _final: bool
    ) -> None: 
        """
        Update the editor.

        Args:
            _final: Is this final update

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlUpdateEditor_Boolean
        """
        pass

    def ControlUpdateProgressive(
      self
    ) -> None: 
        """
        Progressive update.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlUpdateProgressive_void
        """
        pass

    def ControlUpdateSelection(
      self
    ) -> None: 
        """
        Update Selection layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlUpdateSelection_void
        """
        pass

    def ControlUpdateSynchronize(
      self,
      _interrupt: bool
    ) -> bool: 
        """
        Wait for pending paint operation to be finalized.

        Args:
            _interrupt: interrupt any pending operation

        Returns:
            True if operation were synchronized; False if synchronization is not possible and 
            current operation should not continue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlUpdateSynchronize_Boolean
        """
        pass

    def ControlUpdateTopmost(
      self
    ) -> None: 
        """
        Update Topmost layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlUpdateTopmost_void
        """
        pass

    def ControlUpdateWholeMap(
      self
    ) -> None: 
        """
        Update whole map.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ControlUpdateWholeMap_void
        """
        pass

    def Delete(
      self,
      _name: str
    ) -> None: 
        """
        Delete the layer identified by a name.

        Args:
            _name: name of layer to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Delete_String
        """
        pass

    def Draw(
      self,
      _renderer: TObject,
      _mode: TGIS_DrawMode
    ) -> None: 
        """
        Draw all layers on a current renderer.

        Args:
            _renderer: renderer context
            _mode: drawing mode: which set of layers should be rendered

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Draw_TObject_TGIS_DrawMode
        """
        pass

    def EndPaintInternal(
      self
    ) -> None: 
        """
        Notify viewer about leaving of a paint mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.EndPaintInternal_void
        """
        pass

    def FullExtent(
      self
    ) -> None: 
        """
        Calculate the screen origin, zoom, and viewport to place the whole map in the window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.FullExtent_void
        """
        pass

    def FullExtentZoom(
      self
    ) -> float: 
        """
        Calculates a zoom which places the whole map inside the window

        Returns:
            Zoom value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.FullExtentZoom_void
        """
        pass

    def Get(
      self,
      _name: str
    ) -> TGIS_LayerAbstract: 
        """
        Retrieve the layer identified by a name. Sublayer or compund layers can be found 
        by do notation like ''name.sublyer''

        Args:
            _name: name of layer to be found

        Returns:
            Found layer or nil if not found.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Get_String
        """
        pass

    def GetGrid(
      self,
      _extent: TGIS_Extent,
      _grid: TGIS_GridArray
    ) -> bool: 
        """
        Fills provided _grid array with values defined by _extent. If extent is not fully 
        covered by the gird layers then values outside the layers scope will be left untouched.

        Args:
            _extent: extent of the _grid
            _grid: allocated array (with/height ratio of the _grid should be the same as width/height 
              ration of the _extent)

        Returns:
            True if success.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.GetGrid_TGIS_Extent_TGIS_GridArray
        """
        pass

    def GetRenderContext(
      self
    ) -> TObject: 
        """
        Return current context object.

        Returns:
            Current renderer context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.GetRenderContext_void
        """
        pass

    def GetViewer(
      self
    ) -> TObject: 
        """
        Get internal viewer handle.

        Returns:
            current viewer object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.GetViewer_void
        """
        pass

    def HourglassActive(
      self
    ) -> bool: 
        """
        Test is hourglass is active.

        Returns:
            True is Hourglass is visible and Interrupt can be called.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.HourglassActive_void
        """
        pass

    def HourglassPrepare(
      self
    ) -> None: 
        """
        Prepare Hourglass cursor for timely operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.HourglassPrepare_void
        """
        pass

    def HourglassRelease(
      self
    ) -> None: 
        """
        Release Hourglass.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.HourglassRelease_void
        """
        pass

    def HourglassRestart(
      self
    ) -> None: 
        """
        Restart hourglass timing used for progressive updates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.HourglassRestart_void
        """
        pass

    def HourglassShake(
      self
    ) -> bool: 
        """
        Shake Hourglass.

        Returns:
            If True then current operation should be interrupted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.HourglassShake_void
        """
        pass

    def Interrupt(
      self
    ) -> None: 
        """
        Will terminate timely operation as soon as possible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Interrupt_void
        """
        pass

    def Interrupted(
      self
    ) -> bool: 
        """
        Test if any pending operation must be aborted.

        Returns:
            True is if any lengy;lu operation must be aborted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Interrupted_void
        """
        pass

    def InvalidateBasemap(
      self
    ) -> None: 
        """
        Invalidate only basemap layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.InvalidateBasemap_void
        """
        pass

    def InvalidateEditor(
      self,
      _final: bool
    ) -> None: 
        """
        Invalidate editor. To mark viewer after editor change to redraw state.

        Args:
            _final: True if map must updated at the end of editing process; otherwise a normal 
              "shallow" screen refresh to be performed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.InvalidateEditor_Boolean
        """
        pass

    @overload
    def InvalidateExtent(
      self,
      _extent: TGIS_Extent
    ) -> None: 
        """
        Invalidate an extent for full map redraw

        Args:
            _extent: extent to redraw

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.InvalidateExtent_TGIS_Extent
        """
        pass

    @overload
    def InvalidateExtent(
      self,
      _extent: TGIS_Extent,
      _deep: bool
    ) -> None: 
        """
        Invalidate an extent.

        Args:
            _extent: extent to redraw
            _deep: True if whole map must marked for update; if False then only shallow repaint 
              will be issued (only topmost layers)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.InvalidateExtent_TGIS_Extent_Boolean
        """
        pass

    def InvalidateSelection(
      self
    ) -> None: 
        """
        Invalidate selection. To mark viewer after selection change to redraw state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.InvalidateSelection_void
        """
        pass

    def InvalidateTopmost(
      self
    ) -> None: 
        """
        Invalidate only topmost layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.InvalidateTopmost_void
        """
        pass

    def InvalidateWholeMap(
      self
    ) -> None: 
        """
        Invalidate whole map. All layers must be updated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.InvalidateWholeMap_void
        """
        pass

    @overload
    def Locate(
      self,
      _ptg: TGIS_Point,
      _prec: float
    ) -> TGIS_ShapeAbstract: 
        """
        Locate a shape that is near _ptg, but is closer than _prec distance.

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in map units

        Returns:
            Located shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Locate_TGIS_Point_Double
        """
        pass

    @overload
    def Locate(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _visible: bool
    ) -> TGIS_ShapeAbstract: 
        """
        Locate a shape that is near _ptg, but is closer than _prec distance.

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in map units
            _visible: if true the only visible shapes will be evaluated; shapes turned of by 
              query of hidden will be ignored

        Returns:
            Located shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Locate_TGIS_Point_Double_Boolean
        """
        pass

    @overload
    def Locate(
      self,
      _pt: TPoint,
      _prec: int
    ) -> TGIS_ShapeAbstract: 
        """
        Locate a shape that is near _pt, but is closer than _prec distance.

        Args:
            _pt: reference point /searching point/ in pixels
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in pixels

        Returns:
            Located shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Locate_TPoint_Integer
        """
        pass

    def LocateEx(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _visible: bool
    ) -> TGIS_ShapeAbstractList: 
        """
        Locate shapes on layers that are near _ptg, but closer than _prec distance. Still 
        only the best one candidate is chosen from each layer.

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in map units
            _visible: if true the only visible shapes will be evaluated; shapes turned of by 
              query of hidden will be ignored

        Returns:
            Allocated list of shapes from all viewer layers

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.LocateEx_TGIS_Point_Double_Boolean
        """
        pass

    def Lock(
      self
    ) -> None: 
        """
        Lock viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Lock_void
        """
        pass

    def MapToScreen(
      self,
      _ptg: TGIS_Point
    ) -> TPoint: 
        """
        Converts point coordinates from map related to screen related.

        Args:
            _ptg: coordinate in map units

        Returns:
            Map coordinates converted to screen coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.MapToScreen_TGIS_Point
        """
        pass

    def MapToScreen3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TPoint: 
        """
        Converts 3D point coordinates from map related to screen related.

        Args:
            _ptg: coordinate in map units

        Returns:
            Map coordinates converted to screen coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.MapToScreen3D_TGIS_Point3D
        """
        pass

    def MapToScreenEx(
      self,
      _pt: TGIS_Point
    ) -> TGIS_Point: 
        """
        Converts point coordinates from map related to screen related, but result will be 
        in TGIS_Point.

        Args:
            _pt: coordinate in map units

        Returns:
            map coordinates converted to screen coordinates

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.MapToScreenEx_TGIS_Point
        """
        pass

    def MapToScreenRect(
      self,
      _rct: TGIS_Extent
    ) -> TRect: 
        """
        Converts rectangle coordinates from map related to screen related.

        Args:
            _rct: coordinate in map units

        Returns:
            Calculated screen rectangle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.MapToScreenRect_TGIS_Extent
        """
        pass

    def MarkModified(
      self
    ) -> None: 
        """
        Mark viewer upon some modifications.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.MarkModified_void
        """
        pass

    def MoveViewport(
      self,
      _dx: VarParameter,
      _dy: VarParameter
    ) -> None: 
        """
        Move the screen origin of the map by delta values.

        Args:
            _dx: x delta in pixels; the value (in/out) is passed as int in _dx.Value property
            _dy: y delta in pixels; the value (in/out) is passed as int in _dy.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.MoveViewport_Integer_Integer
        """
        pass

    def MoveViewportEx(
      self,
      _dx: VarParameter,
      _dy: VarParameter
    ) -> None: 
        """
        Move the screen origin of the map by delta values.

        Args:
            _dx: x delta in map units; the value (in/out) is passed as float in _dx.Value property
            _dy: y delta in map units; the value (in/out) is passed as float in _dy.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.MoveViewportEx_Double_Double
        """
        pass

    def MustSave(
      self
    ) -> bool: 
        """
        Check if any layer or the project file was modified by editing.

        Returns:
            True if project should be saved.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.MustSave_void
        """
        pass

    def NotifySubscribers(
      self,
      _event: int,
      _context: TObject
    ) -> None: 
        """
        Send notification to subscribers.

        Args:
            _event: event identifying number
            _context: control context; what is expected depends on _event; it can be canvas, 
              control itself.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.NotifySubscribers_Integer_TObject
        """
        pass

    @overload
    def Open(
      self,
      _path: str
    ) -> None: 
        """
        Open project.

        Args:
            _path: project path (or layer)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Open_String
        """
        pass

    @overload
    def Open(
      self,
      _path: str,
      _strict: bool
    ) -> None: 
        """
        Open project.

        Args:
            _path: project path (or layer)
            _strict: if False then non existing layers will be ignored (only while opening project 
              files); default is True ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Open_String_Boolean
        """
        pass

    @overload
    def OpenEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str
    ) -> None: 
        """
        Open project file from the memory.

        Args:
            _configFile: project file
            _path: project path (or layer)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.OpenEx_TGIS_ConfigAbstract_String
        """
        pass

    @overload
    def OpenEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str,
      _strict: bool
    ) -> None: 
        """
        Open project file from the memory.

        Args:
            _configFile: project file
            _path: project path (or layer)
            _strict: if False then non existing layers will be ignored (only while opening project 
              files); default is True ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.OpenEx_TGIS_ConfigAbstract_String_Boolean
        """
        pass

    def PixelsToTwips(
      self,
      _size: int
    ) -> int: 
        """
        Convert size from device dependent pixels to device independent Twips (1/1440 inch). 
        Used to make map device independent.

        Args:
            _size: size in pixels; absolute value will be taken

        Returns:
            Size in twips.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.PixelsToTwips_Integer
        """
        pass

    def RaiseBusyEvent(
      self,
      _sender: TObject,
      _pos: int,
      _end: int,
      _abort: VarParameter
    ) -> None: 
        """
        Fire Busy event of a viewer.

        Args:
            _sender: component which is causing long-term operations
            _pos: current progress
            _end: maximal progress value
            _abort: if set to True inside message handler then an abort request.; the value (in/out) 
              is passed as bool in _abort.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RaiseBusyEvent_TObject_Int64_Int64_Boolean
        """
        pass

    def RaiseHelpEvent(
      self,
      _sender: TObject,
      _name: str
    ) -> None: 
        """
        Fire Busy event of a viewer.

        Args:
            _sender: component asking for help
            _name: help context

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RaiseHelpEvent_TObject_String
        """
        pass

    def ReadConfig(
      self
    ) -> None: 
        """
        Read all configuration data from project.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ReadConfig_void
        """
        pass

    def RecalcExtent(
      self
    ) -> None: 
        """
        Calculates a common extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RecalcExtent_void
        """
        pass

    def ReParent(
      self,
      _parent: IGIS_ViewerParent
    ) -> IGIS_ViewerParent: 
        """
        Set a new parent for the viewer.

        Args:
            _parent: new parent object

        Returns:
            Previous parent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ReParent_IGIS_ViewerParent
        """
        pass

    def Reposition(
      self
    ) -> None: 
        """
        Reposition the map within the component window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Reposition_void
        """
        pass

    def RereadConfig(
      self
    ) -> None: 
        """
        Reread all configuration data from project and layer configuration files.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RereadConfig_void
        """
        pass

    def RestorePaintState(
      self,
      _state: VarParameter
    ) -> None: 
        """
        Restore and free the current paint state.

        Args:
            _state: paint state to be restored; the value (in/out) is passed as TObject in _state.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RestorePaintState_TObject
        """
        pass

    def RevertAll(
      self
    ) -> None: 
        """
        Revert all layers to a file-based original.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RevertAll_void
        """
        pass

    def RotatedExtent(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Compute extent (encompassing area of the extent) after the viewer rotation.

        Args:
            _extent: extent to be rotated

        Returns:
            Rotated extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RotatedExtent_TGIS_Extent
        """
        pass

    def RotatedPoint(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        Compute position of the point after the viewer rotation.

        Args:
            _ptg: point in to be rotated

        Returns:
            Rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RotatedPoint_TGIS_Point
        """
        pass

    def RotatedPoint3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Compute position of the 3D point after the viewer rotation.

        Args:
            _ptg: point to be rotated

        Returns:
            Rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RotatedPoint3D_TGIS_Point3D
        """
        pass

    def RotatedPoint3D_ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Compute position of the 3D point after the viewer rotation.

        Args:
            _ptg: point to be rotated; the value (in/out) is passed as TGIS_Point3D in _ptg.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RotatedPoint3D_ref_TGIS_Point3D
        """
        pass

    def SaveAll(
      self
    ) -> None: 
        """
        Save all layers (parameters and data)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SaveAll_void
        """
        pass

    def SaveData(
      self
    ) -> None: 
        """
        Save all changes to the data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SaveData_void
        """
        pass

    @overload
    def SaveProject(
      self
    ) -> None: 
        """
        Save current project.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SaveProject_void
        """
        pass

    @overload
    def SaveProject(
      self,
      _relativepath: bool
    ) -> None: 
        """
        Save current project.

        Args:
            _relativepath: if True (default) then project will be saved using paths relative 
              to project file location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SaveProject_Boolean
        """
        pass

    @overload
    def SaveProjectAs(
      self,
      _path: str
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SaveProjectAs_String
        """
        pass

    @overload
    def SaveProjectAs(
      self,
      _path: str,
      _relativepath: bool
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension
            _relativepath: if True (default) then project will be saved using paths relative 
              to project file location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SaveProjectAs_String_Boolean
        """
        pass

    @overload
    def SaveProjectAsEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _configFile: existing project file
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SaveProjectAsEx_TGIS_ConfigAbstract_String
        """
        pass

    @overload
    def SaveProjectAsEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str,
      _relativepath: bool
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _configFile: existing project file
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension
            _relativepath: if True (default) then project will be saved using paths relative 
              to project file location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SaveProjectAsEx_TGIS_ConfigAbstract_String_Boolean
        """
        pass

    def ScreenToMap(
      self,
      _pt: TPoint
    ) -> TGIS_Point: 
        """
        Converts point coordinates from screen related to map related.

        Args:
            _pt: coordinate in screen units

        Returns:
            Screen coordinates converted to map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ScreenToMap_TPoint
        """
        pass

    def ScreenToMap3D(
      self,
      _pt: TPoint
    ) -> TGIS_Point3D: 
        """
        Converts point coordinates from screen related to map related.

        Args:
            _pt: coordinate in screen units

        Returns:
            Screen coordinates converted to map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ScreenToMap3D_TPoint
        """
        pass

    def ScreenToMapEx(
      self,
      _pt: TGIS_Point
    ) -> TGIS_Point: 
        """
        Converts point coordinates from screen related to map related, but source will be 
        in TGIS_Point.

        Args:
            _pt: coordinate in screen units

        Returns:
            screen coordinates converted to map coordinates

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ScreenToMapEx_TGIS_Point
        """
        pass

    def ScreenToMapRect(
      self,
      _rct: TRect
    ) -> TGIS_Extent: 
        """
        Converts rectangle coordinates from screen related to map related.

        Args:
            _rct: coordinate in screen units

        Returns:
            Calculated extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ScreenToMapRect_TRect
        """
        pass

    def SetCSByEPSG(
      self,
      _epsg: int
    ) -> None: 
        """
        Setup Coordinate System to a coordinate system provided by EPSG code.

        Args:
            _epsg: EPSG code

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SetCSByEPSG_Integer
        """
        pass

    def SetCSByWKT(
      self,
      _wkt: str
    ) -> None: 
        """
        Setup Coordinate System to a coordinate system provided by WKT string (GEOGCS or 
        PROJCS). If provided WKT string is empty then coordinate system will be turn off.

        Args:
            _wkt: WKT string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SetCSByWKT_String
        """
        pass

    def SetCSByWKTFile(
      self,
      _path: str
    ) -> None: 
        """
        Setup Coordinate System to a coordinate system provided by file which contains WKT 
        string (GEOGCS or PROJCS). If file does not exist or provided WKT string is empty 
        then coordinate system will be turned off.

        Args:
            _path: path with WKT string (for example shapefile .PRJ)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SetCSByWKTFile_String
        """
        pass

    def SetViewer(
      self,
      _viewer: TObject
    ) -> TObject: 
        """
        Set internal viewer handle.

        Args:
            _viewer: new viewer object

        Returns:
            old viewer object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SetViewer_TObject
        """
        pass

    def SetViewport(
      self,
      _x: VarParameter,
      _y: VarParameter
    ) -> None: 
        """
        Set viewport to a given position.

        Args:
            _x: x coordinate; the value (in/out) is passed as float in _x.Value property
            _y: y coordinate; the value (in/out) is passed as float in _y.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SetViewport_Double_Double
        """
        pass

    def StorePaintState(
      self
    ) -> TObject: 
        """
        Store the current paint state.

        Returns:
            Stored paint state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.StorePaintState_void
        """
        pass

    def Subscribe(
      self,
      _control: IGIS_Subscribe
    ) -> None: 
        """
        Add provided control to the notification subscription list.

        Args:
            _control: - control which should become a subscriber

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Subscribe_IGIS_Subscribe
        """
        pass

    def SynchronizePaint(
      self,
      _interrupt: bool
    ) -> bool: 
        """
        Wait for pending paint operation to be finalized.

        Args:
            _interrupt: interrupts any pending operation

        Returns:
            True if operation were synchronized; False if synchronization is not possible and 
            current operation should not continue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SynchronizePaint_Boolean
        """
        pass

    def TwipsToPixels(
      self,
      _size: int
    ) -> int: 
        """
        Convert the size from to device independent Twips (1/1440 inch) to device dependent 
        pixels. Used to make map device independent.

        Args:
            _size: size in twips; if negative then treated as pixels

        Returns:
            Size in twips.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.TwipsToPixels_Integer
        """
        pass

    def TwipsToPoints(
      self,
      _size: int
    ) -> int: 
        """
        Convert the size from to device independent Twips (1/1440 inch) to device points. 
        Used for advanced font sizing.

        Args:
            _size: size in twips; if negative then treated as pixels

        Returns:
            Size in points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.TwipsToPoints_Integer
        """
        pass

    @overload
    def Unlock(
      self
    ) -> None: 
        """
        Unlock viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Unlock_void
        """
        pass

    @overload
    def Unlock(
      self,
      _redraw: bool
    ) -> None: 
        """
        Unlock the viewer but do not redraw

        Args:
            _redraw: If true then map should be redraw upon unlock; if false then redraw should 
              be issued.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Unlock_Boolean
        """
        pass

    def UnrotatedExtent(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Compute original extent of the rotated extent.

        Args:
            _extent: rotated extent

        Returns:
            Original un-rotated extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.UnrotatedExtent_TGIS_Extent
        """
        pass

    def UnrotatedPoint(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        Compute original position of the rotated point.

        Args:
            _ptg: rotated point

        Returns:
            Original un-rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.UnrotatedPoint_TGIS_Point
        """
        pass

    def UnrotatedPoint3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Compute original position of the rotated 3D point.

        Args:
            _ptg: rotated point

        Returns:
            Original un-rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.UnrotatedPoint3D_TGIS_Point3D
        """
        pass

    def UnrotatedPoint3D_ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Compute original position of the rotated 3D point.

        Args:
            _ptg: rotated point; the value (in/out) is passed as TGIS_Point3D in _ptg.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.UnrotatedPoint3D_ref_TGIS_Point3D
        """
        pass

    def UnSubscribe(
      self,
      _control: IGIS_Subscribe
    ) -> None: 
        """
        Remove provided control from the notification subscription list.

        Args:
            _control: control which subscription should be canceled

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.UnSubscribe_IGIS_Subscribe
        """
        pass

    def WaitForBackgroundProcesses(
      self
    ) -> None: 
        """
        Wait for any pending background processes that must be finalized before app can continue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.WaitForBackgroundProcesses_void
        """
        pass

    def WriteConfig(
      self
    ) -> None: 
        """
        Write all configuration data to the project or layer ini file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.WriteConfig_void
        """
        pass

    @property
    def AutoStyle(
      self
    ) -> bool: 
        """
        If True, layers added to the viewer will have a unique style applied; Default is 
        False.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.AutoStyle
        """
        pass

    @AutoStyle.setter
    def AutoStyle(
      self,
      _value: bool
    ) -> None: 
        """
        If True, layers added to the viewer will have a unique style applied; Default is 
        False.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.AutoStyle
        """
        pass

    @property
    def BigExtent(
      self
    ) -> TGIS_Extent: 
        """
        Map extent. Encompassing the collective extents of all layers and a border defined 
        by BigExtentMargin. Is depending on current scale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.BigExtent
        """
        pass

    @property
    def BigExtentMargin(
      self
    ) -> int: 
        """
        Map extent margin.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.BigExtentMargin
        """
        pass

    @BigExtentMargin.setter
    def BigExtentMargin(
      self,
      _value: int
    ) -> None: 
        """
        Map extent margin.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.BigExtentMargin
        """
        pass

    @property
    def BusyLevel(
      self
    ) -> int: 
        """
        Level of current busy state. If 1 then most significant busy is active; if 2 then 
        subsequent etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.BusyLevel
        """
        pass

    @property
    def BusyText(
      self
    ) -> str: 
        """
        Text related to current busy state. Text could be set upon BusyPrepare() call. If 
        IsBusy is not true then text will be an empty string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.BusyText
        """
        pass

    @property
    def Center(
      self
    ) -> TGIS_Point: 
        """
        Center the screen based on given point. Useful for "Center on Click". See property 
        CenterPtg.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Center
        """
        pass

    @Center.setter
    def Center(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Center the screen based on given point. Useful for "Center on Click". See property 
        CenterPtg.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Center
        """
        pass

    @property
    def CenterPtg(
      self
    ) -> TGIS_Point: 
        """
        Point on which Viewer will be centered during Zoom. Will not modify the Viewport. 
        Will set up the point without re centering the screen. See property Center.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.CenterPtg
        """
        pass

    @CenterPtg.setter
    def CenterPtg(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Point on which Viewer will be centered during Zoom. Will not modify the Viewport. 
        Will set up the point without re centering the screen. See property Center.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.CenterPtg
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Background color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Background color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Color
        """
        pass

    @property
    def Copyright(
      self
    ) -> str: 
        """
        Legal notice and product version.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Copyright
        """
        pass

    @property
    def CS(
      self
    ) -> TGIS_CSCoordinateSystem: 
        """
        Coordinate System assigned to the viewer. If set to nil the Coordinate System will 
        be turned off. Default is turned off.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.CS
        """
        pass

    @CS.setter
    def CS(
      self,
      _value: TGIS_CSCoordinateSystem
    ) -> None: 
        """
        Coordinate System assigned to the viewer. If set to nil the Coordinate System will 
        be turned off. Default is turned off.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.CS
        """
        pass

    @property
    def CustomData(
      self
    ) -> TGIS_StringList: 
        """
        List of custom, user-defined data. List is save/restored witch config/project files.
        
        List is in a form of "name=value".

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.CustomData
        """
        pass

    @property
    def CustomPPI(
      self
    ) -> int: 
        """
        Custom resolution in pixels-per-inch. If &lt;&gt; 0 then used instead of SystemPPI

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.CustomPPI
        """
        pass

    @CustomPPI.setter
    def CustomPPI(
      self,
      _value: int
    ) -> None: 
        """
        Custom resolution in pixels-per-inch. If &lt;&gt; 0 then used instead of SystemPPI

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.CustomPPI
        """
        pass

    @property
    def Editor(
      self
    ) -> IGIS_Editor: 
        """
        Editor context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Editor
        """
        pass

    @Editor.setter
    def Editor(
      self,
      _value: IGIS_Editor
    ) -> None: 
        """
        Editor context.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Editor
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Extent: 
        """
        Map extent. Encompassing the collective extents of all layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Extent
        """
        pass

    @property
    def FileCopyrights(
      self
    ) -> str: 
        """
        List Copyrights

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.FileCopyrights
        """
        pass

    @property
    def FontScale(
      self
    ) -> int: 
        """
        Font magnifying factor in percents. To make fonts more readable without changing 
        PPI.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.FontScale
        """
        pass

    @FontScale.setter
    def FontScale(
      self,
      _value: int
    ) -> None: 
        """
        Font magnifying factor in percents. To make fonts more readable without changing 
        PPI.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.FontScale
        """
        pass

    @property
    def FullDrawExtent(
      self
    ) -> TGIS_Extent: 
        """
        Extent of full current/last drawing area including margin and w/o tiling.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.FullDrawExtent
        """
        pass

    @property
    def Hierarchy(
      self
    ) -> IGIS_HierarchyManager: 
        """
        Hierarchy list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Hierarchy
        """
        pass

    @property
    def IncrementalPaint(
      self
    ) -> bool: 
        """
        Is partial drawing to screen done in incremental mode?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.IncrementalPaint
        """
        pass

    @IncrementalPaint.setter
    def IncrementalPaint(
      self,
      _value: bool
    ) -> None: 
        """
        Is partial drawing to screen done in incremental mode?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.IncrementalPaint
        """
        pass

    @property
    def InPaint(
      self
    ) -> bool: 
        """
        True if Viewer is busy in Paint procedure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.InPaint
        """
        pass

    @property
    def IsBusy(
      self
    ) -> bool: 
        """
        True if Viewer is busy.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.IsBusy
        """
        pass

    @property
    def IsEmpty(
      self
    ) -> bool: 
        """
        True if Viewer is empty (no layers).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.IsEmpty
        """
        pass

    @property
    def IsLocked(
      self
    ) -> bool: 
        """
        True if Viewer is in locked state Lock.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.IsLocked
        """
        pass

    @property
    def IsTopmost(
      self
    ) -> bool: 
        """
        True if Viewer has a topmost layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.IsTopmost
        """
        pass

    @property
    def Items(
      self
    ) -> TGIS_LayerAbstractList: 
        """
        All layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Items
        """
        pass

    @property
    def LabelsReg(
      self
    ) -> TGIS_LabelsAreaAbstract: 
        """
        Labels position allocator object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.LabelsReg
        """
        pass

    @property
    def Level(
      self
    ) -> float: 
        """
        Sets and gets zoom level for a viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Level
        """
        pass

    @Level.setter
    def Level(
      self,
      _value: float
    ) -> None: 
        """
        Sets and gets zoom level for a viewer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Level
        """
        pass

    @property
    def MasterViewer(
      self
    ) -> IGIS_Viewer: 
        """
        Master Viewer reference. To be used only by TiledPaint.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.MasterViewer
        """
        pass

    @MasterViewer.setter
    def MasterViewer(
      self,
      _value: IGIS_Viewer
    ) -> None: 
        """
        Master Viewer reference. To be used only by TiledPaint.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.MasterViewer
        """
        pass

    @property
    def MultiUserMode(
      self
    ) -> TGIS_MultiUser: 
        """
        Multiuser mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.MultiUserMode
        """
        pass

    @MultiUserMode.setter
    def MultiUserMode(
      self,
      _value: TGIS_MultiUser
    ) -> None: 
        """
        Multiuser mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.MultiUserMode
        """
        pass

    @property
    def OverlappedExtentMargin(
      self
    ) -> int: 
        """
        Overlapped extent margin (in pixels).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.OverlappedExtentMargin
        """
        pass

    @OverlappedExtentMargin.setter
    def OverlappedExtentMargin(
      self,
      _value: int
    ) -> None: 
        """
        Overlapped extent margin (in pixels).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.OverlappedExtentMargin
        """
        pass

    @property
    def PPI(
      self
    ) -> int: 
        """
        Rendering resolution in pixels-per-inch. Returns SystemPPI value or CustomPPI (if 
        &lt;&gt; 0) multiplied by ControlCanvasScale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.PPI
        """
        pass

    @property
    def ProjectFile(
      self
    ) -> TGIS_ConfigAbstract: 
        """
        Project file itself as opened in Open procedure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ProjectFile
        """
        pass

    @property
    def ProjectName(
      self
    ) -> str: 
        """
        Project file name as opened in Open procedure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ProjectName
        """
        pass

    @property
    def RestrictedDrag(
      self
    ) -> bool: 
        """
        If true, then you can not drag outside the map Extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RestrictedDrag
        """
        pass

    @RestrictedDrag.setter
    def RestrictedDrag(
      self,
      _value: bool
    ) -> None: 
        """
        If true, then you can not drag outside the map Extent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RestrictedDrag
        """
        pass

    @property
    def RestrictedExtent(
      self
    ) -> TGIS_Extent: 
        """
        Restricted Map extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RestrictedExtent
        """
        pass

    @RestrictedExtent.setter
    def RestrictedExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Restricted Map extent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RestrictedExtent
        """
        pass

    @property
    def RotationAngle(
      self
    ) -> float: 
        """
        Angle of viewer rotation in radians.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RotationAngle
        """
        pass

    @RotationAngle.setter
    def RotationAngle(
      self,
      _value: float
    ) -> None: 
        """
        Angle of viewer rotation in radians.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RotationAngle
        """
        pass

    @property
    def RotationPoint(
      self
    ) -> TGIS_Point: 
        """
        Point of viewer rotation in map units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RotationPoint
        """
        pass

    @RotationPoint.setter
    def RotationPoint(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Point of viewer rotation in map units.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.RotationPoint
        """
        pass

    @property
    def Scale(
      self
    ) -> float: 
        """
        Setting up and reading the scale factor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Scale
        """
        pass

    @Scale.setter
    def Scale(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the scale factor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Scale
        """
        pass

    @property
    def ScaleAsFloat(
      self
    ) -> float: 
        """
        Setting up and reading the scale factor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ScaleAsFloat
        """
        pass

    @ScaleAsFloat.setter
    def ScaleAsFloat(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the scale factor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ScaleAsFloat
        """
        pass

    @property
    def ScaleAsText(
      self
    ) -> str: 
        """
        Setting up and reading the scale factor as text in format ''1:10000''.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ScaleAsText
        """
        pass

    @ScaleAsText.setter
    def ScaleAsText(
      self,
      _value: str
    ) -> None: 
        """
        Setting up and reading the scale factor as text in format ''1:10000''.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ScaleAsText
        """
        pass

    @property
    def SelectionGisColor(
      self
    ) -> TGIS_Color: 
        """
        Color used for selecting object. See also SelectionTransparency.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SelectionGisColor
        """
        pass

    @SelectionGisColor.setter
    def SelectionGisColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Color used for selecting object. See also SelectionTransparency.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SelectionGisColor
        """
        pass

    @property
    def SelectionOutlineOnly(
      self
    ) -> bool: 
        """
        If true then polygons will be marked only with outline not a full fill.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SelectionOutlineOnly
        """
        pass

    @SelectionOutlineOnly.setter
    def SelectionOutlineOnly(
      self,
      _value: bool
    ) -> None: 
        """
        If true then polygons will be marked only with outline not a full fill.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SelectionOutlineOnly
        """
        pass

    @property
    def SelectionTransparency(
      self
    ) -> int: 
        """
        Transparency value for selection; if 100 SelectionGisColor will not be transparent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SelectionTransparency
        """
        pass

    @SelectionTransparency.setter
    def SelectionTransparency(
      self,
      _value: int
    ) -> None: 
        """
        Transparency value for selection; if 100 SelectionGisColor will not be transparent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SelectionTransparency
        """
        pass

    @property
    def SelectionWidth(
      self
    ) -> int: 
        """
        Outline width of selection area (&gt;0 in twips, &lt;0 in pixels).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SelectionWidth
        """
        pass

    @SelectionWidth.setter
    def SelectionWidth(
      self,
      _value: int
    ) -> None: 
        """
        Outline width of selection area (&gt;0 in twips, &lt;0 in pixels).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SelectionWidth
        """
        pass

    @property
    def SystemPPI(
      self
    ) -> int: 
        """
        System resolution in pixels-per-inch.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.SystemPPI
        """
        pass

    @property
    def TemporaryScaleInternal(
      self
    ) -> float: 
        """
        Used to force rendering in a different scale then actual.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.TemporaryScaleInternal
        """
        pass

    @TemporaryScaleInternal.setter
    def TemporaryScaleInternal(
      self,
      _value: float
    ) -> None: 
        """
        Used to force rendering in a different scale then actual.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.TemporaryScaleInternal
        """
        pass

    @property
    def TemporaryVisibleExtent(
      self
    ) -> TGIS_Extent: 
        """
        Used to force rendering labels while drawing with tiles.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.TemporaryVisibleExtent
        """
        pass

    @TemporaryVisibleExtent.setter
    def TemporaryVisibleExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Used to force rendering labels while drawing with tiles.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.TemporaryVisibleExtent
        """
        pass

    @property
    def TiledPaint(
      self
    ) -> bool: 
        """
        Is partial drawing to screen done in tiled mode?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.TiledPaint
        """
        pass

    @TiledPaint.setter
    def TiledPaint(
      self,
      _value: bool
    ) -> None: 
        """
        Is partial drawing to screen done in tiled mode?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.TiledPaint
        """
        pass

    @property
    def UponDestroy(
      self
    ) -> bool: 
        """
        True if viewer is upon destruction so some operations (like screen updates) should 
        not be performed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.UponDestroy
        """
        pass

    @property
    def UseRTree(
      self
    ) -> bool: 
        """
        True if RTree will be used by default upon creation of any layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.UseRTree
        """
        pass

    @UseRTree.setter
    def UseRTree(
      self,
      _value: bool
    ) -> None: 
        """
        True if RTree will be used by default upon creation of any layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.UseRTree
        """
        pass

    @property
    def ViewerParent(
      self
    ) -> IGIS_ViewerParent: 
        """
        Parent for the current IGIS_Viewer object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ViewerParent
        """
        pass

    @property
    def ViewerParentRoot(
      self
    ) -> IGIS_ViewerParent: 
        """
        Parent for the current IGIS_Viewer object. If object is reparented then root parent 
        object will be returned.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ViewerParentRoot
        """
        pass

    @property
    def Viewport(
      self
    ) -> TGIS_Point: 
        """
        Setting an upper left corner position of the components window within the map.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Viewport
        """
        pass

    @Viewport.setter
    def Viewport(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Setting an upper left corner position of the components window within the map.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Viewport
        """
        pass

    @property
    def VisibleExtent(
      self
    ) -> TGIS_Extent: 
        """
        Extent of the map that is visible in the window. On setting an optimal zoom will 
        be calculated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.VisibleExtent
        """
        pass

    @VisibleExtent.setter
    def VisibleExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Extent of the map that is visible in the window. On setting an optimal zoom will 
        be calculated.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.VisibleExtent
        """
        pass

    @property
    def Zoom(
      self
    ) -> float: 
        """
        Setting up and reading the related zoom factor. If one map unit = one pixel, then 
        Zoom = 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Zoom
        """
        pass

    @Zoom.setter
    def Zoom(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the related zoom factor. If one map unit = one pixel, then 
        Zoom = 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.Zoom
        """
        pass

    @property
    def ZoomEx(
      self
    ) -> float: 
        """
        Setting up and reading the absolute zoom factor. If one map unit = one twips, then 
        Zoom = 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ZoomEx
        """
        pass

    @ZoomEx.setter
    def ZoomEx(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the absolute zoom factor. If one map unit = one twips, then 
        Zoom = 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ZoomEx
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        Busy event. Will be fired regularly during long-drawn operations. If end value will 
        be zero, the meaning is: long-drawn with unknown end time. Close long-drawn operation 
        by calling with parameters (-1,-1).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        Busy event. Will be fired regularly during long-drawn operations. If end value will 
        be zero, the meaning is: long-drawn with unknown end time. Close long-drawn operation 
        by calling with parameters (-1,-1).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.BusyEvent
        """
        pass

    @property
    def ExtentChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        ExtentChange event. Will be fired on TGIS_Viewer.Extent change.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ExtentChangeEvent
        """
        pass

    @ExtentChangeEvent.setter
    def ExtentChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        ExtentChange event. Will be fired on TGIS_Viewer.Extent change.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ExtentChangeEvent
        """
        pass

    @property
    def VisibleExtentChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        VisibleExtentChange event. Will be fired before BeforePaint if TGIS_Viewer.VisibleExtent 
        was changed. Will not be fired if TGIS_Viewer.VisibleExtent was changed based on 
        changed Zoom - in such situation only ZoomChange will be fired.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.VisibleExtentChangeEvent
        """
        pass

    @VisibleExtentChangeEvent.setter
    def VisibleExtentChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        VisibleExtentChange event. Will be fired before BeforePaint if TGIS_Viewer.VisibleExtent 
        was changed. Will not be fired if TGIS_Viewer.VisibleExtent was changed based on 
        changed Zoom - in such situation only ZoomChange will be fired.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.VisibleExtentChangeEvent
        """
        pass

    @property
    def ZoomChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        ZoomChange event. Will be fired before OnBeforePaint if Viewer.Zoom was changed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ZoomChangeEvent
        """
        pass

    @ZoomChangeEvent.setter
    def ZoomChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        ZoomChange event. Will be fired before OnBeforePaint if Viewer.Zoom was changed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerNonVisual.ZoomChangeEvent
        """
        pass

class TGIS_Viewer3DBase( TObject, IGIS_Viewer3D ):
    """
    Encapsulation of the 3D viewer.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase
    """

    @overload
    def __init__(
      self,
      _hwnd: THandle,
      _viewer: IGIS_Viewer,
      _extent: TGIS_Extent,
      _initdraw: bool
    ) -> None: 
        """
        Construct an instance of 3D Viewer

        Args:
            _hwnd: handle to a window in which viewer should be constructed; if 0 then object 
              will be created on _viewer
            _viewer: master viewer window
            _extent: extent restriction (all objects outside will be cut off)
            _initdraw: draw initial view if True, do not draw if False

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.Create_THandle_IGIS_Viewer_TGIS_Extent_Boolean
        """
        pass

    def ControlRepaint(
      self
    ) -> None: 
        """
        Issue control repainting action (shallow refresh).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ControlRepaint_void
        """
        pass

    def DoGesture(
      self,
      _dragdx: short,
      _dragdy: short,
      _zoomxpos: short,
      _zoomypos: short,
      _zoomdistance: float,
      _camerapositiondx: short,
      _camerapositiondy: short,
      _paramex: float
    ) -> None: 
        """
        Do gesture.

        Args:
            _dragdx: change of x coordinate for dragging
            _dragdy: change of y coordinate for dragging
            _zoomxpos: x coordinate of zoom center position
            _zoomypos: y coordinate of zoom center position
            _zoomdistance: zoom distance; if set to 1 then nothing is done
            _camerapositiondx: change of x coordinate for camera position mode
            _camerapositiondy: change of y coordinate for camera position mode
            _paramex: not used

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DoGesture_SmallInt_SmallInt_SmallInt_SmallInt_Double_SmallInt_SmallInt_Double
        """
        pass

    def DoMouseDown(
      self,
      _xpos: short,
      _ypos: short
    ) -> None: 
        """
        Perform interactive action on mouse message defined by current Mode.

        Args:
            _xpos: x mouse position
            _ypos: y mouse position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DoMouseDown_SmallInt_SmallInt
        """
        pass

    def DoMouseMove(
      self,
      _xpos: short,
      _ypos: short
    ) -> None: 
        """
        Perform interactive action on mouse message defined by current Mode.

        Args:
            _xpos: x mouse position
            _ypos: y mouse position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DoMouseMove_SmallInt_SmallInt
        """
        pass

    def DoMouseUp(
      self
    ) -> None: 
        """
        Perform interactive action on mouse message defined by current Mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DoMouseUp_void
        """
        pass

    def Drag(
      self,
      _delta: TGIS_Point3D
    ) -> None: 
        """
        Drag scene left, right, forward or backward by delta in map units

        Args:
            _delta: delta values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.Drag_TGIS_Point3D
        """
        pass

    def DragEx(
      self,
      _delta: TGIS_Point3D
    ) -> None: 
        """
        Drag scene left, right, forward+up or backward+down by delta in map units

        Args:
            _delta: delta values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DragEx_TGIS_Point3D
        """
        pass

    def Draw(
      self
    ) -> None: 
        """
        Draw scene

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.Draw_void
        """
        pass

    def FullExtent(
      self
    ) -> None: 
        """
        Set view to initial state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.FullExtent_void
        """
        pass

    def GestureBegin(
      self
    ) -> None: 
        """
        Start gesture.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.GestureBegin_void
        """
        pass

    def GestureEnd(
      self
    ) -> None: 
        """
        Finish gesture.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.GestureEnd_void
        """
        pass

    def GetDemLevelAtReferencePointer(
      self
    ) -> float: 
        """
        Get height where reference pointer crosses DEM

        Returns:
            Height in vertical units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.GetDemLevelAtReferencePointer_void
        """
        pass

    def GetFps(
      self
    ) -> int: 
        """
        Get rendering speed in frames-per-second

        Returns:
            Frame per seconds.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.GetFps_void
        """
        pass

    def InitialRedraw(
      self,
      _extent: TGIS_Extent,
      _initdraw: bool
    ) -> bool: 
        """
        Construct an instance of 3D Viewer

        Args:
            _extent: extent restriction (all objects outside will be cut off)
            _initdraw: draw initial view if True, do not draw if False

        Returns:
            True if success

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.InitialRedraw_TGIS_Extent_Boolean
        """
        pass

    def Locate(
      self,
      _pt: TPoint,
      _prec: int
    ) -> TGIS_ShapeAbstract: 
        """
        Select object in 3D (as in 2D mode)

        Args:
            _pt: screen coordinate
            _prec: precision in pixels (must be &gt;= 0)

        Returns:
            Shape itself or nil,

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.Locate_TPoint_Integer
        """
        pass

    def Locate3D(
      self,
      _pt: TPoint,
      _prec: int,
      _layer: VarParameter,
      _ptg: VarParameter,
      _shp: VarParameter,
      _part: VarParameter
    ) -> bool: 
        """
        Select object in 3D

        Args:
            _pt: screen coordinate
            _prec: precision in pixels (must be &gt;= 0)
            _layer: input : layer to be searched, if nil all layers will be searched output : 
              layer contained located object, if nil no object located; the value (in/out) is passed 
              as TGIS_LayerAbstract in _layer.Value property
            _ptg: hitting point; the value (in/out) is passed as TGIS_Point3D in _ptg.Value property
            _shp: located shape or nil; the value (in/out) is passed as TGIS_ShapeAbstract in 
              _shp.Value property
            _part: located shape part number; the value (in/out) is passed as int in _part.Value 
              property

        Returns:
            True if shape was found

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.Locate3D_TPoint_Integer_TGIS_LayerAbstract_TGIS_Point3D_TGIS_ShapeAbstract_Integer
        """
        pass

    def Lock(
      self
    ) -> None: 
        """
        Stop rendering and wait for GeneralUnlock Must be paired with Unlock.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.Lock_void
        """
        pass

    def LockUpdates(
      self
    ) -> None: 
        """
        Prepare navigate operation - for example set draft mode. Must be paired with UnlockUpdates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.LockUpdates_void
        """
        pass

    def MarkShape(
      self,
      _layer: TGIS_LayerAbstract,
      _shpid: int,
      _part: int,
      _color: TGIS_Color,
      _update: bool
    ) -> None: 
        """
        Mark shape with color

        Args:
            _layer: layer contained shape
            _shpid: shape to be marked
            _part: shape part to be marked, -1 if entire shape
            _color: color used to mark shape
            _update: if True redraw scene after mark, do not redraw if False

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.MarkShape_TGIS_LayerAbstract_Integer_Integer_TGIS_Color_Boolean
        """
        pass

    def Move(
      self,
      _delta: TGIS_Point3D
    ) -> None: 
        """
        Move scene along XY axis by delta values expressed in map units

        Args:
            _delta: delta values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.Move_TGIS_Point3D
        """
        pass

    def PrintBegin(
      self,
      _width: int,
      _height: int
    ) -> TPoint: 
        """
        Get size of tile used while tiling.

        Args:
            _width: output bitmap width
            _height: output bitmap height

        Returns:
            Tile size to be used as a param in PrintTile method

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.PrintBegin_Integer_Integer
        """
        pass

    def PrintBmp(
      self,
      _rect: TRect,
      _bmp: TGIS_Bitmap
    ) -> None: 
        """
        Dump required screen rectangle to a bitmap

        Args:
            _rect: required screen rectangle to be returned as TGIS_Bitmap
            _bmp: 32 bits TBitmap returned as a result

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.PrintBmp_TRect_TGIS_Bitmap
        """
        pass

    def PrintEnd(
      self
    ) -> None: 
        """
        Close printing using tiles.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.PrintEnd_void
        """
        pass

    def PrintTile(
      self,
      _bmp: TGIS_Bitmap,
      _offsetx: int,
      _offsety: int
    ) -> None: 
        """
        Dump visible screen rectangle to a bitmap

        Args:
            _bmp: 32 bits TBitmap filled with tile data
            _offsetx: offset in x direction (in pixels)
            _offsety: offset in x direction (in pixels)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.PrintTile_TGIS_Bitmap_Integer_Integer
        """
        pass

    def RayIntersectDem(
      self,
      _orig: TGIS_Point3D,
      _dir: TGIS_Point3D,
      _ptg: VarParameter
    ) -> bool: 
        """
        Get intersection point between a ray and a DEM

        Args:
            _orig: ray origin coordinates in map units
            _dir: ray direction
            _ptg: intersection point between a ray and a DEM if Result = True; the value (in/out) 
              is passed as TGIS_Point3D in _ptg.Value property

        Returns:
            True if ray intersects DEM, False if not

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.RayIntersectDem_TGIS_Point3D_TGIS_Point3D_TGIS_Point3D
        """
        pass

    def ResetView(
      self
    ) -> None: 
        """
        Set view to initial state (like FullExtent in 2D).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ResetView_void
        """
        pass

    def Rotate(
      self,
      _delta: TGIS_Point3D
    ) -> None: 
        """
        Rotate view by delta values expressed in radians

        Args:
            _delta: delta values

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.Rotate_TGIS_Point3D
        """
        pass

    def ScreenToMap(
      self,
      _pt: TPoint
    ) -> TGIS_Point: 
        """
        Get the mouse position on ReferenceLevel in map units

        Args:
            _pt: screen pixel position

        Returns:
            screen coordinates converted to map coordinates

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ScreenToMap_TPoint
        """
        pass

    def ScreenToMap3D(
      self,
      _pt: TPoint
    ) -> TGIS_Point3D: 
        """
        Get map coordinates of screen pixel

        Args:
            _pt: screen pixel position

        Returns:
            screen coordinates converted to map coordinates

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ScreenToMap3D_TPoint
        """
        pass

    def StoreMousePos(
      self,
      _value: TPoint
    ) -> None: 
        """
        Mouse position (necessary in ZoomMode only)

        Args:
            _value: last mouseDown position

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.StoreMousePos_TPoint
        """
        pass

    def Unlock(
      self
    ) -> None: 
        """
        Cancels GeneralLock, continue rendering Must be paired with Lock.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.Unlock_void
        """
        pass

    def UnlockUpdates(
      self
    ) -> None: 
        """
        Finalize navigate operation. Must be paired with LockUpdates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.UnlockUpdates_void
        """
        pass

    def UnMarkShape(
      self,
      _layer: TGIS_LayerAbstract,
      _shpid: int,
      _update: bool
    ) -> None: 
        """
        Cancel previously marked shape with color

        Args:
            _layer: layer contained shape
            _shpid: shape to be unmarked
            _update: if True redraw scene after mark, do not redraw if False

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.UnMarkShape_TGIS_LayerAbstract_Integer_Boolean
        """
        pass

    def UpdateAllSelectedObjects(
      self
    ) -> None: 
        """
        Redraw all selected objects.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.UpdateAllSelectedObjects_void
        """
        pass

    def UpdateTopmost(
      self
    ) -> None: 
        """
        Issue control update action (topmost refresh).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.UpdateTopmost_void
        """
        pass

    def UpdateWholeMap(
      self
    ) -> None: 
        """
        Issue control update action (deep refresh).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.UpdateWholeMap_void
        """
        pass

    def ZoomBy(
      self,
      _value: float,
      _x: int,
      _y: int
    ) -> None: 
        """
        Zoom view by factor (screen center if AdvNavigation = False, mouse position if AdvNavigation 
        = True.

        Args:
            _value: zoom multiplier to multiply current zoom value
            _x: center point x coordinate
            _y: center point y coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ZoomBy_Double_Integer_Integer
        """
        pass

    @property
    def AdvNavigation(
      self
    ) -> bool: 
        """
        Standard / AdvanceNavigation switch if True mouse location become a rotation point 
        if False screen center is a rotation point

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.AdvNavigation
        """
        pass

    @AdvNavigation.setter
    def AdvNavigation(
      self,
      _value: bool
    ) -> None: 
        """
        Standard / AdvanceNavigation switch if True mouse location become a rotation point 
        if False screen center is a rotation point

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.AdvNavigation
        """
        pass

    @property
    def AllowDemTransparency(
      self
    ) -> bool: 
        """
        Get AllowDemTransparency status. True allows DEM to be transparent, False will follow 
        DEM layer property settings

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.AllowDemTransparency
        """
        pass

    @AllowDemTransparency.setter
    def AllowDemTransparency(
      self,
      _value: bool
    ) -> None: 
        """
        Get AllowDemTransparency status. True allows DEM to be transparent, False will follow 
        DEM layer property settings

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.AllowDemTransparency
        """
        pass

    @property
    def BasePlane(
      self
    ) -> TGIS_Viewer3DBasePlane: 
        """
        BasePlane parameters, active, level &amp; colors

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.BasePlane
        """
        pass

    @BasePlane.setter
    def BasePlane(
      self,
      _value: TGIS_Viewer3DBasePlane
    ) -> None: 
        """
        BasePlane parameters, active, level &amp; colors

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.BasePlane
        """
        pass

    @property
    def CameraPosition(
      self
    ) -> TGIS_Point3D: 
        """
        Camera position in radians; Changes of CameraPosition settings change CameraRotation 
        settings; Camera always points to the central point of the visible area; * X height 
        of the camera above horizon, range 0 - Pi/2 rad; * Y azimuth to the camera from natural 
        north, range 0 - 2Pi rad; * Z distance to the camera in map units; * M optional parameter, 
        for future use.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.CameraPosition
        """
        pass

    @CameraPosition.setter
    def CameraPosition(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        Camera position in radians; Changes of CameraPosition settings change CameraRotation 
        settings; Camera always points to the central point of the visible area; * X height 
        of the camera above horizon, range 0 - Pi/2 rad; * Y azimuth to the camera from natural 
        north, range 0 - 2Pi rad; * Z distance to the camera in map units; * M optional parameter, 
        for future use.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.CameraPosition
        """
        pass

    @property
    def CameraPositionEx(
      self
    ) -> TGIS_Point3D: 
        """
        Camera position in XYZ in map units Changes of CameraPositionEx settings do not change 
        CameraRotation settings; * X x coordinate; * Y y coordinate; * Z z coordinate; * 
        M optional parameter, for future use.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.CameraPositionEx
        """
        pass

    @CameraPositionEx.setter
    def CameraPositionEx(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        Camera position in XYZ in map units Changes of CameraPositionEx settings do not change 
        CameraRotation settings; * X x coordinate; * Y y coordinate; * Z z coordinate; * 
        M optional parameter, for future use.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.CameraPositionEx
        """
        pass

    @property
    def CameraRotation(
      self
    ) -> TGIS_Point3D: 
        """
        Camera rotation in radians; * X x rotation, vertical , range +- Pi/2 rad; * Y y rotation, 
        inclination, range +- Pi/2 rad; * Z z rotation, horizontal , range 0 - 2Pi rad; * 
        M camera focal length in millimeters, range 20 - 500 mm (default 50).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.CameraRotation
        """
        pass

    @CameraRotation.setter
    def CameraRotation(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        Camera rotation in radians; * X x rotation, vertical , range +- Pi/2 rad; * Y y rotation, 
        inclination, range +- Pi/2 rad; * Z z rotation, horizontal , range 0 - 2Pi rad; * 
        M camera focal length in millimeters, range 20 - 500 mm (default 50).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.CameraRotation
        """
        pass

    @property
    def CutAbove(
      self
    ) -> float: 
        """
        Set CutAbove value for DEM cells with z &gt; CutAbove

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.CutAbove
        """
        pass

    @CutAbove.setter
    def CutAbove(
      self,
      _value: float
    ) -> None: 
        """
        Set CutAbove value for DEM cells with z &gt; CutAbove

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.CutAbove
        """
        pass

    @property
    def CutBelow(
      self
    ) -> float: 
        """
        Set CutBelow value for DEM cells with z &lt; CutBelow

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.CutBelow
        """
        pass

    @CutBelow.setter
    def CutBelow(
      self,
      _value: float
    ) -> None: 
        """
        Set CutBelow value for DEM cells with z &lt; CutBelow

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.CutBelow
        """
        pass

    @property
    def DemCachedSize(
      self
    ) -> TGIS_Viewer3DDemCacheSize: 
        """
        Grid size used to display regular DEMs &amp; IMAGEs

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DemCachedSize
        """
        pass

    @DemCachedSize.setter
    def DemCachedSize(
      self,
      _value: TGIS_Viewer3DDemCacheSize
    ) -> None: 
        """
        Grid size used to display regular DEMs &amp; IMAGEs

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DemCachedSize
        """
        pass

    @property
    def DemDetailExtentFactor(
      self
    ) -> float: 
        """
        Extent in which DEM is displayed in max LevelOfDetail (must be &gt;= 0.5, 1 means 
        screen width).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DemDetailExtentFactor
        """
        pass

    @DemDetailExtentFactor.setter
    def DemDetailExtentFactor(
      self,
      _value: float
    ) -> None: 
        """
        Extent in which DEM is displayed in max LevelOfDetail (must be &gt;= 0.5, 1 means 
        screen width).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DemDetailExtentFactor
        """
        pass

    @property
    def DemDraftExtentFactor(
      self
    ) -> float: 
        """
        Extent in which DEM is displayed in lower LevelOfDetail (must be &gt;= 1.0, 4 means 
        4 times screen width).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DemDraftExtentFactor
        """
        pass

    @DemDraftExtentFactor.setter
    def DemDraftExtentFactor(
      self,
      _value: float
    ) -> None: 
        """
        Extent in which DEM is displayed in lower LevelOfDetail (must be &gt;= 1.0, 4 means 
        4 times screen width).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DemDraftExtentFactor
        """
        pass

    @property
    def DemGridSize(
      self
    ) -> int: 
        """
        Current grid size setting.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DemGridSize
        """
        pass

    @property
    def DemIsolineColor(
      self
    ) -> TGIS_Color: 
        """
        Isoline color

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DemIsolineColor
        """
        pass

    @DemIsolineColor.setter
    def DemIsolineColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Isoline color

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DemIsolineColor
        """
        pass

    @property
    def DemIsolineGap(
      self
    ) -> float: 
        """
        Isoline gap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DemIsolineGap
        """
        pass

    @DemIsolineGap.setter
    def DemIsolineGap(
      self,
      _value: float
    ) -> None: 
        """
        Isoline gap

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DemIsolineGap
        """
        pass

    @property
    def DemWalls(
      self
    ) -> TGIS_Viewer3DDemWall: 
        """
        DEM wall types

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DemWalls
        """
        pass

    @DemWalls.setter
    def DemWalls(
      self,
      _value: TGIS_Viewer3DDemWall
    ) -> None: 
        """
        DEM wall types

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.DemWalls
        """
        pass

    @property
    def EdgesColor(
      self
    ) -> TGIS_Color: 
        """
        Vector edges color

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.EdgesColor
        """
        pass

    @EdgesColor.setter
    def EdgesColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Vector edges color

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.EdgesColor
        """
        pass

    @property
    def ErrorMessage(
      self
    ) -> str: 
        """
        Get error message String.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ErrorMessage
        """
        pass

    @property
    def FastMode(
      self
    ) -> bool: 
        """
        Block scene redrawing when set to True, immediately redraws scene when set to False

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.FastMode
        """
        pass

    @FastMode.setter
    def FastMode(
      self,
      _value: bool
    ) -> None: 
        """
        Block scene redrawing when set to True, immediately redraws scene when set to False

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.FastMode
        """
        pass

    @property
    def Flood(
      self
    ) -> TGIS_Viewer3DFlood: 
        """
        Flood parameters, active, level &amp; color, transparency

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.Flood
        """
        pass

    @Flood.setter
    def Flood(
      self,
      _value: TGIS_Viewer3DFlood
    ) -> None: 
        """
        Flood parameters, active, level &amp; color, transparency

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.Flood
        """
        pass

    @property
    def HideLabelsUponNavigation(
      self
    ) -> bool: 
        """
        Labels not drawn during scene navigation etc. Default is off what means display labels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.HideLabelsUponNavigation
        """
        pass

    @HideLabelsUponNavigation.setter
    def HideLabelsUponNavigation(
      self,
      _value: bool
    ) -> None: 
        """
        Labels not drawn during scene navigation etc. Default is off what means display labels.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.HideLabelsUponNavigation
        """
        pass

    @property
    def IgnoreAbove(
      self
    ) -> float: 
        """
        Set noDataValue for DEM cells with z &gt; IgnoreAbove value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.IgnoreAbove
        """
        pass

    @IgnoreAbove.setter
    def IgnoreAbove(
      self,
      _value: float
    ) -> None: 
        """
        Set noDataValue for DEM cells with z &gt; IgnoreAbove value

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.IgnoreAbove
        """
        pass

    @property
    def IgnoreBelow(
      self
    ) -> float: 
        """
        Set noDataValue for DEM cells with z &lt; IgnoreBelow value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.IgnoreBelow
        """
        pass

    @IgnoreBelow.setter
    def IgnoreBelow(
      self,
      _value: float
    ) -> None: 
        """
        Set noDataValue for DEM cells with z &lt; IgnoreBelow value

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.IgnoreBelow
        """
        pass

    @property
    def IgnoreEllipsoidHeight(
      self
    ) -> bool: 
        """
        If set to True, differences in Z value caused by different ellipsoids will be ignored

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.IgnoreEllipsoidHeight
        """
        pass

    @IgnoreEllipsoidHeight.setter
    def IgnoreEllipsoidHeight(
      self,
      _value: bool
    ) -> None: 
        """
        If set to True, differences in Z value caused by different ellipsoids will be ignored

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.IgnoreEllipsoidHeight
        """
        pass

    @property
    def IsBusy(
      self
    ) -> bool: 
        """
        Flag. If True, Viewer is busy in painting.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.IsBusy
        """
        pass

    @property
    def KeepSunCamera(
      self
    ) -> bool: 
        """
        Check for keeping sun and camera positions relative.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.KeepSunCamera
        """
        pass

    @KeepSunCamera.setter
    def KeepSunCamera(
      self,
      _value: bool
    ) -> None: 
        """
        Check for keeping sun and camera positions relative.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.KeepSunCamera
        """
        pass

    @property
    def LightVector(
      self
    ) -> bool: 
        """
        Revers Light normal Vector

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.LightVector
        """
        pass

    @LightVector.setter
    def LightVector(
      self,
      _value: bool
    ) -> None: 
        """
        Revers Light normal Vector

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.LightVector
        """
        pass

    @property
    def Mode(
      self
    ) -> TGIS_Viewer3DMode: 
        """
        Viewer3D mode working mode (camera mode, sun, zoom, select ...).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.Mode
        """
        pass

    @Mode.setter
    def Mode(
      self,
      _value: TGIS_Viewer3DMode
    ) -> None: 
        """
        Viewer3D mode working mode (camera mode, sun, zoom, select ...).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.Mode
        """
        pass

    @property
    def OrthoView(
      self
    ) -> bool: 
        """
        Orthogonal View switch, if, True camera looks orthogonally, camera can be moved only 
        in XY plane, zoom is allowed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.OrthoView
        """
        pass

    @OrthoView.setter
    def OrthoView(
      self,
      _value: bool
    ) -> None: 
        """
        Orthogonal View switch, if, True camera looks orthogonally, camera can be moved only 
        in XY plane, zoom is allowed

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.OrthoView
        """
        pass

    @property
    def PixelSize(
      self
    ) -> TGIS_Point: 
        """
        Get the pixel size (xsize &amp; ysize) at reference point in map units

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.PixelSize
        """
        pass

    @property
    def ReferencePoint(
      self
    ) -> TGIS_Point3D: 
        """
        ReferencePoint in map units, usually screen center. Use ReferencePointMode/ReferencePointOffsetZ 
        properties to set.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ReferencePoint
        """
        pass

    @ReferencePoint.setter
    def ReferencePoint(
      self,
      _value: TGIS_Point3D
    ) -> None: 
        """
        ReferencePoint in map units, usually screen center. Use ReferencePointMode/ReferencePointOffsetZ 
        properties to set.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ReferencePoint
        """
        pass

    @property
    def ReferencePointMode(
      self
    ) -> TGIS_Viewer3DReferenceMode: 
        """
        Set reference (rotation) point to one of GIS_3DReferencePoint type: Base, Zero, OnDem, 
        Lowest, Highest, FlyOnDem

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ReferencePointMode
        """
        pass

    @ReferencePointMode.setter
    def ReferencePointMode(
      self,
      _value: TGIS_Viewer3DReferenceMode
    ) -> None: 
        """
        Set reference (rotation) point to one of GIS_3DReferencePoint type: Base, Zero, OnDem, 
        Lowest, Highest, FlyOnDem

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ReferencePointMode
        """
        pass

    @property
    def ReferencePointOffsetZ(
      self
    ) -> float: 
        """
        Set reference (rotation) point Z value offset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ReferencePointOffsetZ
        """
        pass

    @ReferencePointOffsetZ.setter
    def ReferencePointOffsetZ(
      self,
      _value: float
    ) -> None: 
        """
        Set reference (rotation) point Z value offset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ReferencePointOffsetZ
        """
        pass

    @property
    def Scale(
      self
    ) -> float: 
        """
        Setting up and reading the 3D scale factor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.Scale
        """
        pass

    @Scale.setter
    def Scale(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the 3D scale factor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.Scale
        """
        pass

    @property
    def ScaleAsText(
      self
    ) -> str: 
        """
        Setting up and reading the 3D scale factor as text in format ''1:10000''.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ScaleAsText
        """
        pass

    @ScaleAsText.setter
    def ScaleAsText(
      self,
      _value: str
    ) -> None: 
        """
        Setting up and reading the 3D scale factor as text in format ''1:10000''.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ScaleAsText
        """
        pass

    @property
    def ScaleM(
      self
    ) -> float: 
        """
        M scaling; default is 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ScaleM
        """
        pass

    @ScaleM.setter
    def ScaleM(
      self,
      _value: float
    ) -> None: 
        """
        M scaling; default is 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ScaleM
        """
        pass

    @property
    def ScaleZ(
      self
    ) -> float: 
        """
        Z scaling; default is 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ScaleZ
        """
        pass

    @ScaleZ.setter
    def ScaleZ(
      self,
      _value: float
    ) -> None: 
        """
        Z scaling; default is 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ScaleZ
        """
        pass

    @property
    def ShadowsLevel(
      self
    ) -> int: 
        """
        Shadows level; 0..100; 0-deep shadows, 100-light shadows

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ShadowsLevel
        """
        pass

    @ShadowsLevel.setter
    def ShadowsLevel(
      self,
      _value: int
    ) -> None: 
        """
        Shadows level; 0..100; 0-deep shadows, 100-light shadows

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ShadowsLevel
        """
        pass

    @property
    def ShowDemTexture(
      self
    ) -> bool: 
        """
        Turn Texture on/off. Default is on

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ShowDemTexture
        """
        pass

    @ShowDemTexture.setter
    def ShowDemTexture(
      self,
      _value: bool
    ) -> None: 
        """
        Turn Texture on/off. Default is on

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ShowDemTexture
        """
        pass

    @property
    def ShowLabels(
      self
    ) -> bool: 
        """
        Labels mode on/off. Default is on what means display labels.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ShowLabels
        """
        pass

    @ShowLabels.setter
    def ShowLabels(
      self,
      _value: bool
    ) -> None: 
        """
        Labels mode on/off. Default is on what means display labels.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ShowLabels
        """
        pass

    @property
    def ShowLights(
      self
    ) -> bool: 
        """
        Turn Lights on/off. Default is off (what means perfectly diffused light). On means 
        that scene lights like sun etc are turned on.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ShowLights
        """
        pass

    @ShowLights.setter
    def ShowLights(
      self,
      _value: bool
    ) -> None: 
        """
        Turn Lights on/off. Default is off (what means perfectly diffused light). On means 
        that scene lights like sun etc are turned on.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ShowLights
        """
        pass

    @property
    def ShowReferencePoint(
      self
    ) -> bool: 
        """
        Turn ReferencePoint drawing on/off. Default is on (what means that ReferencePoint 
        is drawn). ReferencePoint is an arrow pointing from ReferencePoint to a "natural" 
        north.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ShowReferencePoint
        """
        pass

    @ShowReferencePoint.setter
    def ShowReferencePoint(
      self,
      _value: bool
    ) -> None: 
        """
        Turn ReferencePoint drawing on/off. Default is on (what means that ReferencePoint 
        is drawn). ReferencePoint is an arrow pointing from ReferencePoint to a "natural" 
        north.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ShowReferencePoint
        """
        pass

    @property
    def ShowVectorEdges(
      self
    ) -> bool: 
        """
        Turn VectorEdges drawing on/off. Default is on when Lights are off (what means that 
        VectorEdges are drawn). When Lights are on default setting for VectorEdges is off.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ShowVectorEdges
        """
        pass

    @ShowVectorEdges.setter
    def ShowVectorEdges(
      self,
      _value: bool
    ) -> None: 
        """
        Turn VectorEdges drawing on/off. Default is on when Lights are off (what means that 
        VectorEdges are drawn). When Lights are on default setting for VectorEdges is off.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ShowVectorEdges
        """
        pass

    @property
    def ShowWireframe(
      self
    ) -> bool: 
        """
        Wire frame mode on/off. Default is off what means solid models.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ShowWireframe
        """
        pass

    @ShowWireframe.setter
    def ShowWireframe(
      self,
      _value: bool
    ) -> None: 
        """
        Wire frame mode on/off. Default is off what means solid models.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ShowWireframe
        """
        pass

    @property
    def SunPosition(
      self
    ) -> TGIS_Point: 
        """
        Sun position in radian; natural north * X height of the sun above horizon, range 
        +- Pi/2 rad; initial Pi/4 (45 deg) * Y azimuth to the sun from natural north, range 
        0 - 2Pi rad; initial 3Pi/4 (225 deg)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.SunPosition
        """
        pass

    @SunPosition.setter
    def SunPosition(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Sun position in radian; natural north * X height of the sun above horizon, range 
        +- Pi/2 rad; initial Pi/4 (45 deg) * Y azimuth to the sun from natural north, range 
        0 - 2Pi rad; initial 3Pi/4 (225 deg)

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.SunPosition
        """
        pass

    @property
    def TransparencyPriority(
      self
    ) -> TGIS_Viewer3DTransparencyPriority: 
        """
        Transparency priority. Order of DEM/vector rendering. Types of transparency priority 
        in case that both DEM &amp; vector are transparent (default is Auto)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.TransparencyPriority
        """
        pass

    @TransparencyPriority.setter
    def TransparencyPriority(
      self,
      _value: TGIS_Viewer3DTransparencyPriority
    ) -> None: 
        """
        Transparency priority. Order of DEM/vector rendering. Types of transparency priority 
        in case that both DEM &amp; vector are transparent (default is Auto)

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.TransparencyPriority
        """
        pass

    @property
    def UniverseColor(
      self
    ) -> TGIS_Color: 
        """
        3D viewer color of area which exceeds map extent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.UniverseColor
        """
        pass

    @UniverseColor.setter
    def UniverseColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        3D viewer color of area which exceeds map extent

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.UniverseColor
        """
        pass

    @property
    def VectorExtentFactor(
      self
    ) -> float: 
        """
        Extent from which vector is displayed (must be &gt;= 1.0, 2 means 2 times screen 
        width).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.VectorExtentFactor
        """
        pass

    @VectorExtentFactor.setter
    def VectorExtentFactor(
      self,
      _value: float
    ) -> None: 
        """
        Extent from which vector is displayed (must be &gt;= 1.0, 2 means 2 times screen 
        width).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.VectorExtentFactor
        """
        pass

    @property
    def VectorSimplification(
      self
    ) -> bool: 
        """
        Enable/disable vector simplification process.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.VectorSimplification
        """
        pass

    @VectorSimplification.setter
    def VectorSimplification(
      self,
      _value: bool
    ) -> None: 
        """
        Enable/disable vector simplification process.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.VectorSimplification
        """
        pass

    @property
    def VectorSmartSize(
      self
    ) -> int: 
        """
        Shape size in pixels, less or equal will not be displayed ( must be &gt;= 0 )

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.VectorSmartSize
        """
        pass

    @VectorSmartSize.setter
    def VectorSmartSize(
      self,
      _value: int
    ) -> None: 
        """
        Shape size in pixels, less or equal will not be displayed ( must be &gt;= 0 )

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.VectorSmartSize
        """
        pass

    @property
    def ViewRestriction(
      self
    ) -> TGIS_Viewer3DViewRestriction: 
        """
        Current 3D view restrictions.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ViewRestriction
        """
        pass

    @ViewRestriction.setter
    def ViewRestriction(
      self,
      _value: TGIS_Viewer3DViewRestriction
    ) -> None: 
        """
        Current 3D view restrictions.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.ViewRestriction
        """
        pass

    @property
    def VisibleExtent(
      self
    ) -> TGIS_Extent: 
        """
        Get/set 2D extent visible in 3D window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.VisibleExtent
        """
        pass

    @VisibleExtent.setter
    def VisibleExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Get/set 2D extent visible in 3D window.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.VisibleExtent
        """
        pass

    @property
    def VisibleExtent3D(
      self
    ) -> TGIS_Extent3D: 
        """
        Get 3D extent visible in 3D window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.VisibleExtent3D
        """
        pass

    @WallsColor.setter
    def WallsColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        DEM wall color

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.WallsColor
        """
        pass

    @property
    def Zoom(
      self
    ) -> float: 
        """
        Get 3D zoom, same as TGIS_Viewer.Zoom

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.Zoom
        """
        pass

    @property
    def UpdateEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.UpdateEvent
        """
        pass

    @UpdateEvent.setter
    def UpdateEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewer3DBase.UpdateEvent
        """
        pass

class TGIS_ViewshedObserverElevation:
    pass

class TGIS_ViewshedObserverElevation:
    """
    Specifies what is used as elevation of the observers in the viewshed or Fresnel zone 
    clearance analysis. Elevation can be modified with an offset attribute field/value.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewshedObserverElevation
    """

    @property
    def Z(
      self
    ) -> TGIS_ViewshedObserverElevation: 
        """
        Elevation is the Z coordinate.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewshedObserverElevation.Z
        """
        pass

    @property
    def M(
      self
    ) -> TGIS_ViewshedObserverElevation: 
        """
        Elevation is the M coordinate.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewshedObserverElevation.M
        """
        pass

    @property
    def ZM(
      self
    ) -> TGIS_ViewshedObserverElevation: 
        """
        Elevation is the sum of the Z and the M coordinate.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewshedObserverElevation.ZM
        """
        pass

    @property
    def OnDem(
      self
    ) -> TGIS_ViewshedObserverElevation: 
        """
        Elevation is read from the underlying Digital Elevation Model (DEM).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewshedObserverElevation.OnDem
        """
        pass

    @property
    def OnDemPlusM(
      self
    ) -> TGIS_ViewshedObserverElevation: 
        """
        Elevation is read from the underlying Digital Elevation Model (DEM) plus the M coordinate.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewshedObserverElevation.OnDemPlusM
        """
        pass

    @property
    def Zero(
      self
    ) -> TGIS_ViewshedObserverElevation: 
        """
        Elevation is zero; useful if elevation should be offset-based.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewshedObserverElevation.Zero
        """
        pass

class TGIS_ViewshedOutput:
    pass

class TGIS_ViewshedOutput:
    """
    Specifies output values of the viewshed analysis.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewshedOutput
    """

    @property
    def Visibility(
      self
    ) -> TGIS_ViewshedOutput: 
        """
        Values are: 0 or no data - not visible, 1 - visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewshedOutput.Visibility
        """
        pass

    @property
    def NumberOfObservers(
      self
    ) -> TGIS_ViewshedOutput: 
        """
        Values are: 0 or no data - not visible, greater than 0 - number of visible observers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewshedOutput.NumberOfObservers
        """
        pass

class TGIS_Viewshed( TObject ):
    """
    Viewshed, above-ground-level (AGL), and Fresnel zone clearance generator.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Creates an instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.Create_void
        """
        pass

    @overload
    def Generate(
      self,
      _dem: TGIS_LayerPixel,
      _observers: TGIS_LayerVector,
      _viewshed: TGIS_LayerPixel,
      _above_ground_level: TGIS_LayerPixel,
      _offset_dem: float,
      _offset_field: str,
      _offset_observer: float
    ) -> None: 
        """
        Generates viewshed (and, optionally, above-ground-level (AGL) raster) as a grid/Digital 
        Elevation Model (DEM).
        
        The values on the viewshed layer indicate the number of observers which can see each 
        cell. The values on the above-ground-level layer indicate the minimum height that 
        must be added to a nonvisible cell to make it visible by at least one observer.

        Args:
            _dem: terrain model as a grid layer
            _observers: layer containing observers; layer is expected to contain one or more 
              points; only first 50 points will be used.
            _viewshed: output layer containing the viewshed analysis; values are set according 
              to the ViewshedOutput property; the layer is initially filled according to the FillWithZeros 
              property; the layer must be constructed before calling this method
            _above_ground_level: output layer containing values of how many meters should be 
              added to a particular point to be visible from at least one observer; this layer 
              must have the same extent, CS, and resolution as _viewshed; if NULL this analysis 
              will be skipped; layer is initially filled according to FillWithZeros property
            _offset_dem: fixed terrain (_dem) elevation offset in meters to e.g. add forest level
            _offset_field: attribute field defining observers elevation offset; field value must 
              be expressed in meters
            _offset_observer: fixed observers elevation offset in meters

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.Generate_TGIS_LayerPixel_TGIS_LayerVector_TGIS_LayerPixel_TGIS_LayerPixel_Single_String_Single
        """
        pass

    @overload
    def Generate(
      self,
      _dem: TGIS_LayerPixel,
      _observers: TGIS_LayerVector,
      _viewshed: TGIS_LayerPixel,
      _offset_dem: float,
      _offset_field: str,
      _offset_observer: float
    ) -> None: 
        """
        Generates viewshed as a grid/Digital Elevation Model (DEM).
        
        The values on the viewshed layer indicate the number of observers which can see each 
        cell.

        Args:
            _dem: terrain model as a grid layer
            _observers: layer containing observer locations; layer is expected to contain one 
              or more points; only first 50 points will be used.
            _viewshed: output layer containing the viewshed analysis; values are set according 
              to the ViewshedOutput property; the layer is initially filled according to the FillWithZeros 
              property; the layer must be constructed before calling this method
            _offset_dem: fixed terrain (_dem) elevation offset in meters to e.g. add forest level
            _offset_field: attribute field defining observers elevation offset; field value must 
              be expressed in meters
            _offset_observer: fixed observers elevation offset in meters

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.Generate_TGIS_LayerPixel_TGIS_LayerVector_TGIS_LayerPixel_Single_String_Single
        """
        pass

    @overload
    def Generate(
      self
    ) -> None: 
        """
        Generates viewshed (and, optionally, above-ground-level (AGL) raster) as a grid/Digital 
        Elevation Model (DEM).
        
        The values on the viewshed layer indicate the number of observers which can see each 
        cell. The values on the above-ground-level layer indicate the minimum height that 
        must be added to a nonvisible cell to make it visible by at least one observer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.Generate_void
        """
        pass

    @overload
    def GenerateFresnel(
      self,
      _dem: TGIS_LayerPixel,
      _transmitters: TGIS_LayerVector,
      _clearance: TGIS_LayerPixel,
      _zone_number: int,
      _offset_dem: float,
      _offset_field: str,
      _offset_transmitter: float
    ) -> None: 
        """
        Generates n-th Fresnel Zone clearance map as a grid/Digital Elevation Model (DEM).
        
        The values of the clearance map represent the biggest (based on the signal from all 
        the transmitters) among the smallest percentages of unobstructed cross section of 
        the Fresnel Zone along the line of sight between the transmitter and the receiver 
        where 0 means that the Fresnel Zone is completely blocked and 100 that it is free 
        of obstructions.

        Args:
            _dem: terrain model as a grid layer
            _transmitters: layer containing transmitters; layer is expected to contain one or 
              more points; only first 50 points will be used.
            _clearance: output layer containing the clearance map; the values vary from 0 (zone 
              is completely obstructed) to 100 (zone is unobstructed); the layer is initially filled 
              according to FillWithZeros property; the layer must be constructed before calling 
              this method
            _zone_number: number of the Fresnel Zone to calculate
            _offset_dem: fixed terrain (_dem) elevation offset in meters to e.g. add forest level
            _offset_field: attribute field defining transmitters elevation offset; field value 
              must be expressed in meters
            _offset_transmitter: fixed transmitters elevation offset in meters

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.GenerateFresnel_TGIS_LayerPixel_TGIS_LayerVector_TGIS_LayerPixel_Integer_Single_String_Single
        """
        pass

    @overload
    def GenerateFresnel(
      self
    ) -> None: 
        """
        Generates n-th Fresnel Zone clearance map as a grid/Digital Elevation Model (DEM).
        
        The values of the clearance map represent the biggest (based on the signal from all 
        the transmitters) among the smallest percentages of unobstructed cross section of 
        the Fresnel Zone along the line of sight between the transmitter and the receiver 
        where 0 means that the Fresnel Zone is completely blocked and 100 that it is free 
        of obstructions.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.GenerateFresnel_void
        """
        pass

    @property
    def AboveGroundLevelLayer(
      self
    ) -> TGIS_LayerPixel: 
        """
        Output layer containing values of how many meters should be added to a particular 
        point to be visible from at least one observer; this layer must have the same extent, 
        CS, and resolution as the OutputLayer; if NULL, this analysis will be skipped; layer 
        is initially filled according to the FillWithZeros property.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.AboveGroundLevelLayer
        """
        pass

    @AboveGroundLevelLayer.setter
    def AboveGroundLevelLayer(
      self,
      _value: TGIS_LayerPixel
    ) -> None: 
        """
        Output layer containing values of how many meters should be added to a particular 
        point to be visible from at least one observer; this layer must have the same extent, 
        CS, and resolution as the OutputLayer; if NULL, this analysis will be skipped; layer 
        is initially filled according to the FillWithZeros property.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.AboveGroundLevelLayer
        """
        pass

    @property
    def CurvedEarth(
      self
    ) -> bool: 
        """
        If True then the elevation of input data will be corrected for Earth curvature and 
        refraction.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.CurvedEarth
        """
        pass

    @CurvedEarth.setter
    def CurvedEarth(
      self,
      _value: bool
    ) -> None: 
        """
        If True then the elevation of input data will be corrected for Earth curvature and 
        refraction.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.CurvedEarth
        """
        pass

    @property
    def FillWithZeros(
      self
    ) -> bool: 
        """
        If True then output is initially filled with zeros instead of NoData (default).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.FillWithZeros
        """
        pass

    @FillWithZeros.setter
    def FillWithZeros(
      self,
      _value: bool
    ) -> None: 
        """
        If True then output is initially filled with zeros instead of NoData (default).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.FillWithZeros
        """
        pass

    @property
    def Frequency(
      self
    ) -> float: 
        """
        Radio frequency for Fresnel Zone analysis; default is 100 MHz.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.Frequency
        """
        pass

    @Frequency.setter
    def Frequency(
      self,
      _value: float
    ) -> None: 
        """
        Radio frequency for Fresnel Zone analysis; default is 100 MHz.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.Frequency
        """
        pass

    @property
    def FresnelZoneNumber(
      self
    ) -> int: 
        """
        Number of the Fresnel zone for clearance calculation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.FresnelZoneNumber
        """
        pass

    @FresnelZoneNumber.setter
    def FresnelZoneNumber(
      self,
      _value: int
    ) -> None: 
        """
        Number of the Fresnel zone for clearance calculation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.FresnelZoneNumber
        """
        pass

    @property
    def ObserverElevation(
      self
    ) -> TGIS_ViewshedObserverElevation: 
        """
        Specifies coordinate used as the elevation of the observers; default is DEM.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.ObserverElevation
        """
        pass

    @ObserverElevation.setter
    def ObserverElevation(
      self,
      _value: TGIS_ViewshedObserverElevation
    ) -> None: 
        """
        Specifies coordinate used as the elevation of the observers; default is DEM.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.ObserverElevation
        """
        pass

    @property
    def ObserversLayer(
      self
    ) -> TGIS_LayerVector: 
        """
        Layer containing observer locations; layer is expected to contain one or more points; 
        only first 50 points will be used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.ObserversLayer
        """
        pass

    @ObserversLayer.setter
    def ObserversLayer(
      self,
      _value: TGIS_LayerVector
    ) -> None: 
        """
        Layer containing observer locations; layer is expected to contain one or more points; 
        only first 50 points will be used.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.ObserversLayer
        """
        pass

    @property
    def ObserversOffset(
      self
    ) -> float: 
        """
        Fixed observers elevation offset in meters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.ObserversOffset
        """
        pass

    @ObserversOffset.setter
    def ObserversOffset(
      self,
      _value: float
    ) -> None: 
        """
        Fixed observers elevation offset in meters.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.ObserversOffset
        """
        pass

    @property
    def ObserversOffsetField(
      self
    ) -> str: 
        """
        Attribute field defining observers elevation offset in meters.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.ObserversOffsetField
        """
        pass

    @ObserversOffsetField.setter
    def ObserversOffsetField(
      self,
      _value: str
    ) -> None: 
        """
        Attribute field defining observers elevation offset in meters.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.ObserversOffsetField
        """
        pass

    @property
    def OutputLayer(
      self
    ) -> TGIS_LayerPixel: 
        """
        Output layer containing the viewshed analysis; values are set according to the ViewshedOutput 
        property; the layer is initially filled according to the FillWithZeros property.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.OutputLayer
        """
        pass

    @OutputLayer.setter
    def OutputLayer(
      self,
      _value: TGIS_LayerPixel
    ) -> None: 
        """
        Output layer containing the viewshed analysis; values are set according to the ViewshedOutput 
        property; the layer is initially filled according to the FillWithZeros property.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.OutputLayer
        """
        pass

    @property
    def Radius(
      self
    ) -> int: 
        """
        Specifies the maximum distance (in meters) between the observer and the cell for 
        the analysis to be performed; greater distance implies no visibility; default is 
        20 km.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.Radius
        """
        pass

    @Radius.setter
    def Radius(
      self,
      _value: int
    ) -> None: 
        """
        Specifies the maximum distance (in meters) between the observer and the cell for 
        the analysis to be performed; greater distance implies no visibility; default is 
        20 km.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.Radius
        """
        pass

    @property
    def Refractivity(
      self
    ) -> float: 
        """
        Specifies the refractivity coefficient of light; default is 0.13.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.Refractivity
        """
        pass

    @Refractivity.setter
    def Refractivity(
      self,
      _value: float
    ) -> None: 
        """
        Specifies the refractivity coefficient of light; default is 0.13.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.Refractivity
        """
        pass

    @property
    def TerrainLayer(
      self
    ) -> TGIS_LayerPixel: 
        """
        Terrain model as a grid layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.TerrainLayer
        """
        pass

    @TerrainLayer.setter
    def TerrainLayer(
      self,
      _value: TGIS_LayerPixel
    ) -> None: 
        """
        Terrain model as a grid layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.TerrainLayer
        """
        pass

    @property
    def TerrainOffset(
      self
    ) -> float: 
        """
        Fixed terrain elevation offset in meters to for example add forest level.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.TerrainOffset
        """
        pass

    @TerrainOffset.setter
    def TerrainOffset(
      self,
      _value: float
    ) -> None: 
        """
        Fixed terrain elevation offset in meters to for example add forest level.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.TerrainOffset
        """
        pass

    @property
    def ViewshedOutput(
      self
    ) -> TGIS_ViewshedOutput: 
        """
        Specifies output values of the viewshed analysis.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.ViewshedOutput
        """
        pass

    @ViewshedOutput.setter
    def ViewshedOutput(
      self,
      _value: TGIS_ViewshedOutput
    ) -> None: 
        """
        Specifies output values of the viewshed analysis.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.ViewshedOutput
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Viewshed.BusyEvent
        """
        pass

class IGIS_PvlControl3D( IGIS_Subscribe ):
    """
    PVL Control3D intraface

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControl3D
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControl3D.Create_void
        """
        pass

class TGIS_PvlControl3DOption:
    pass

class TGIS_PvlControl3DOption:
    """
    Defines which controls are to be displayed within the component.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3DOption
    """

    @property
    def NoOptions(
      self
    ) -> TGIS_PvlControl3DOption: 
        """
        No options enabled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3DOption.NoOptions
        """
        pass

    @property
    def ShowNavigation(
      self
    ) -> TGIS_PvlControl3DOption: 
        """
        Navigation option visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3DOption.ShowNavigation
        """
        pass

    @property
    def ShowCoordinates(
      self
    ) -> TGIS_PvlControl3DOption: 
        """
        Coordinates option visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3DOption.ShowCoordinates
        """
        pass

    @property
    def ShowReferencePoint(
      self
    ) -> TGIS_PvlControl3DOption: 
        """
        Reference Point option visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3DOption.ShowReferencePoint
        """
        pass

    @property
    def ShowLights(
      self
    ) -> TGIS_PvlControl3DOption: 
        """
        Lights option visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3DOption.ShowLights
        """
        pass

    @property
    def ShowFrameModes(
      self
    ) -> TGIS_PvlControl3DOption: 
        """
        Frame Modes option visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3DOption.ShowFrameModes
        """
        pass

    @property
    def ShowScalings(
      self
    ) -> TGIS_PvlControl3DOption: 
        """
        Scalings option visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3DOption.ShowScalings
        """
        pass

    @property
    def ShowFloods(
      self
    ) -> TGIS_PvlControl3DOption: 
        """
        Floods option visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3DOption.ShowFloods
        """
        pass

    @property
    def ShowWalls(
      self
    ) -> TGIS_PvlControl3DOption: 
        """
        Walls option visible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3DOption.ShowWalls
        """
        pass

class TGIS_PvlControl3D( TGIS_PvlControl, IGIS_PvlControl3D ):
    """
    PVL GIS Viewer control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3D
    """

    def SubscribedEvent(
      self,
      _sender: TObject,
      _event: int,
      _context: TObject
    ) -> None: 
        """
        Subscriber notification event.

        Args:
            _sender: sender object
            _event: event identifier
            _context: context object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3D.SubscribedEvent_TObject_Integer_TObject
        """
        pass

    @property
    def AutoSize(
      self
    ) -> bool: 
        """
        If true the size of the component is being automatically adjusted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3D.AutoSize
        """
        pass

    @AutoSize.setter
    def AutoSize(
      self,
      _value: bool
    ) -> None: 
        """
        If true the size of the component is being automatically adjusted.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3D.AutoSize
        """
        pass

    @property
    def BiDiModeFromTranslation(
      self
    ) -> bool: 
        """
        Defines which BiDi we are using the one from property or the one from translation

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3D.BiDiModeFromTranslation
        """
        pass

    @BiDiModeFromTranslation.setter
    def BiDiModeFromTranslation(
      self,
      _value: bool
    ) -> None: 
        """
        Defines which BiDi we are using the one from property or the one from translation

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3D.BiDiModeFromTranslation
        """
        pass

    @property
    def GIS_Viewer(
      self
    ) -> TGIS_PvlViewerWnd: 
        """
        Attached TGIS_ViewerWnd component instance.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3D.GIS_Viewer
        """
        pass

    @GIS_Viewer.setter
    def GIS_Viewer(
      self,
      _value: TGIS_PvlViewerWnd
    ) -> None: 
        """
        Attached TGIS_ViewerWnd component instance.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3D.GIS_Viewer
        """
        pass

    @property
    def Mode(
      self
    ) -> TGIS_Viewer3DMode: 
        """
        Defines the purpose of mouse actions.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3D.Mode
        """
        pass

    @Mode.setter
    def Mode(
      self,
      _value: TGIS_Viewer3DMode
    ) -> None: 
        """
        Defines the purpose of mouse actions.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3D.Mode
        """
        pass

    @property
    def Options(
      self
    ) -> typing.Sequence[TGIS_PvlControl3DOption]: 
        """
        Defines which controls are to be displayed within the component.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3D.Options
        """
        pass

    @Options.setter
    def Options(
      self,
      _value: typing.Sequence[TGIS_PvlControl3DOption]
    ) -> None: 
        """
        Defines which controls are to be displayed within the component.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl3D.Options
        """
        pass

class IGIS_PvlControlAttributes( IGIS_Subscribe ):
    """
    PVL control attributes intraface

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlAttributes
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlAttributes.Create_void
        """
        pass

    def CancelChanges(
      self
    ) -> None: 
        """
        Cancel changes made in the control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlAttributes.CancelChanges_void
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear attributes display. To avoid errors you should call this before removing shapes, 
        layer and closing viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlAttributes.Clear_void
        """
        pass

    def CopyToClipboard(
      self
    ) -> None: 
        """
        Copy information from the control to clipboard.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlAttributes.CopyToClipboard_void
        """
        pass

    def Invalidate(
      self
    ) -> None: 
        """
        Rebuild attributes display. TGIS_ControlAttributes does not detect changing of layer 
        structure, so after it call Invalidate to rebuild data structure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlAttributes.Invalidate_void
        """
        pass

    def NewShape(
      self,
      _shape: TGIS_Shape
    ) -> None: 
        """
        Show attributes for a new shape.

        Args:
            _shape: new shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlAttributes.NewShape_TGIS_Shape
        """
        pass

    def SaveChanges(
      self
    ) -> bool: 
        """
        Save changes made in the control.

        Returns:
            True if layer updated successfully.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlAttributes.SaveChanges_void
        """
        pass

    def ShowSelected(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Show statistics for selected shapes.

        Args:
            _layer: layer taken into account

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlAttributes.ShowSelected_TGIS_LayerVector
        """
        pass

    def ShowShape(
      self,
      _shape: TGIS_Shape
    ) -> None: 
        """
        Show attributes for given _shape.

        Args:
            _shape: Shape object to display attribute filed for shape; nil to clear the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlAttributes.ShowShape_TGIS_Shape
        """
        pass

    def SubscribedEvent(
      self,
      _sender: TObject,
      _event: int,
      _context: TObject
    ) -> None: 
        """
        Subscriber notification event.

        Args:
            _sender: sender object
            _event: event identifier
            _context: context object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlAttributes.SubscribedEvent_TObject_Integer_TObject
        """
        pass

class TGIS_PvlAttibutesLayoutType:
    pass

class TGIS_PvlAttibutesLayoutType:
    """
    Two layout types for attributes control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlAttibutesLayoutType
    """

    @property
    def OneColumn(
      self
    ) -> TGIS_PvlAttibutesLayoutType: 
        """
        Attributes names and values in one column.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlAttibutesLayoutType.OneColumn
        """
        pass

    @property
    def TwoColumns(
      self
    ) -> TGIS_PvlAttibutesLayoutType: 
        """
        Attributes names on left, attributes values on right.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlAttibutesLayoutType.TwoColumns
        """
        pass

class TGIS_PvlControlAttributes( TGIS_PvlControl, IGIS_PvlControlAttributes ):
    """
    PVL attributes control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlAttributes
    """

    def CancelChanges(
      self
    ) -> None: 
        """
        Cancel changes made in the control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlAttributes.CancelChanges_void
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear attributes display. To avoid errors you should call this before removing shapes, 
        layer and closing viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlAttributes.Clear_void
        """
        pass

    def Invalidate(
      self
    ) -> None: 
        """
        Rebuild attributes display. TGIS_ControlAttributes does not detect changing of layer 
        structure, so after it call Invalidate to rebuild data structure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlAttributes.Invalidate_void
        """
        pass

    def NewShape(
      self,
      _shape: TGIS_Shape
    ) -> None: 
        """
        Show attributes for a new shape.

        Args:
            _shape: new shape

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlAttributes.NewShape_TGIS_Shape
        """
        pass

    def SaveChanges(
      self
    ) -> bool: 
        """
        Save changes made in the control.

        Returns:
            True if layer updated successfully.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlAttributes.SaveChanges_void
        """
        pass

    def ShowSelected(
      self,
      _layer: TGIS_LayerVector
    ) -> None: 
        """
        Show statistics for selected shapes.

        Args:
            _layer: layer taken into account

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlAttributes.ShowSelected_TGIS_LayerVector
        """
        pass

    def ShowShape(
      self,
      _shape: TGIS_Shape
    ) -> None: 
        """
        Show attributes for given _shape.

        Args:
            _shape: Shape object to display attribute filed for shape; nil to clear the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlAttributes.ShowShape_TGIS_Shape
        """
        pass

class TGIS_ControlColor( TGIS_PvlModalForm ):
    """
    Visual form for managing bitmaps.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlColor
    """

    @overload
    def Execute(
      self
    ) -> TGIS_PvlModalResult: 
        """
        Execute dialog.

        Returns:
            Modal result.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlColor.Execute_void
        """
        pass

    @overload
    def Execute(
      self,
      _proc: typing.Callable[[TGIS_PvlModalResult], None]
    ) -> TGIS_PvlModalResult: 
        """
        Execute dialog on a bitmap given by path.

        Args:
            _proc: Action to be performed after closing modal form or nil.; the value is a callback 
              to a method with parameters defined by TGIS_Proc

        Returns:
            Modal result.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlColor.Execute_TGIS_Proc
        """
        pass

    @overload
    def Execute(
      self,
      _color: TGIS_Color,
      _proc: typing.Callable[[TGIS_PvlModalResult], None]
    ) -> TGIS_PvlModalResult: 
        """
        Execute dialog on a bitmap given by path.

        Args:
            _color: Color property
            _proc: Action to be performed after closing modal form or nil.; the value is a callback 
              to a method with parameters defined by TGIS_Proc

        Returns:
            Modal result,

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlColor.Execute_TGIS_Color_TGIS_Proc
        """
        pass

    @overload
    def Execute(
      self,
      _color: TGIS_Color
    ) -> TGIS_PvlModalResult: 
        """
        Execute dialog on a bitmap given by path.

        Args:
            _color: Color property

        Returns:
            Modal result,

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlColor.Execute_TGIS_Color
        """
        pass

    @overload
    def Execute(
      self,
      _color: TGIS_Color,
      _onhelp: typing.Callable[[TObject, String], None],
      _proc: typing.Callable[[TGIS_PvlModalResult], None]
    ) -> TGIS_PvlModalResult: 
        """
        Execute dialog on a bitmap given by path.

        Args:
            _color: Color property
            _onhelp: help notification function; if assigned the help button will be visible 
              and help support will be enabled; the value is a callback to a method with parameters 
              defined by TGIS_HelpEvent
            _proc: Action to be performed after closing modal form or nil.; the value is a callback 
              to a method with parameters defined by TGIS_Proc

        Returns:
            Modal result

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlColor.Execute_TGIS_Color_TGIS_HelpEvent_TGIS_Proc
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Chosen color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlColor.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Chosen color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlColor.Color
        """
        pass

class TGIS_ControlFont( TGIS_PvlModalForm ):
    """
    Visual form for managing font symbols.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlFont
    """

    @overload
    def Execute(
      self
    ) -> TGIS_PvlModalResult: 
        """
        Execute dialog.

        Returns:
            Modal result.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlFont.Execute_void
        """
        pass

    @overload
    def Execute(
      self,
      _proc: typing.Callable[[TGIS_PvlModalResult], None]
    ) -> TGIS_PvlModalResult: 
        """
        Execute dialog.

        Args:
            _proc: Action to be performed after closing modal form or nil.; the value is a callback 
              to a method with parameters defined by TGIS_Proc

        Returns:
            Modal result.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlFont.Execute_TGIS_Proc
        """
        pass

    @overload
    def Execute(
      self,
      _symbol: TGIS_SymbolFont,
      _proc: typing.Callable[[TGIS_PvlModalResult], None]
    ) -> TGIS_PvlModalResult: 
        """
        Execute dialog on a given symbol.

        Args:
            _symbol: base symbol.
            _proc: Action to be performed after closing modal form or nil.; the value is a callback 
              to a method with parameters defined by TGIS_Proc

        Returns:
            Modal result.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlFont.Execute_TGIS_SymbolFont_TGIS_Proc
        """
        pass

    @overload
    def Execute(
      self,
      _font: TGIS_Font,
      _proc: typing.Callable[[TGIS_PvlModalResult], None]
    ) -> TGIS_PvlModalResult: 
        """
        Execute dialog on a given symbol.

        Args:
            _font: base font.
            _proc: Action to be performed after closing modal form or nil.; the value is a callback 
              to a method with parameters defined by TGIS_Proc

        Returns:
            Modal result.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlFont.Execute_TGIS_Font_TGIS_Proc
        """
        pass

    @overload
    def Execute(
      self,
      _symbol: TGIS_SymbolFont,
      _onhelp: typing.Callable[[TObject, String], None],
      _proc: typing.Callable[[TGIS_PvlModalResult], None]
    ) -> TGIS_PvlModalResult: 
        """
        Execute dialog on a given symbol.

        Args:
            _symbol: base symbol.
            _onhelp: help notification function; if assigned the help button will be visible 
              and help support will be enabled; the value is a callback to a method with parameters 
              defined by TGIS_HelpEvent
            _proc: Action to be performed after closing modal form or nil.; the value is a callback 
              to a method with parameters defined by TGIS_Proc

        Returns:
            Modal result.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlFont.Execute_TGIS_SymbolFont_TGIS_HelpEvent_TGIS_Proc
        """
        pass

    @property
    def Symbol(
      self
    ) -> TGIS_SymbolFont: 
        """
        Selected Symbol or nil.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlFont.Symbol
        """
        pass

class IGIS_PvlControlLegend:
    """
    PVL control legend intraface

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlLegend
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlLegend.Create_void
        """
        pass

    @overload
    def Collapse(
      self,
      _layer: TGIS_Layer
    ) -> None: 
        """
        Collapses a legend item corresponding to a layer.

        Args:
            _layer: the layer to be collapsed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlLegend.Collapse_TGIS_Layer
        """
        pass

    @overload
    def Collapse(
      self,
      _group: IGIS_HierarchyGroup
    ) -> None: 
        """
        Collapses a legend item corresponding to a hierarchy group.

        Args:
            _group: the group to be collapsed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlLegend.Collapse_IGIS_HierarchyGroup
        """
        pass

    @overload
    def Collapse(
      self,
      _group: IGIS_HierarchyGroup,
      _deep: bool,
      _layers: bool
    ) -> None: 
        """
        Collapses a legend item corresponding to a hierarchy group.

        Args:
            _group: the group to be collapsed
            _deep: if True the subitems will be collapsed as well
            _layers: if True and _deep is True the layer items will be collapsed as well

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlLegend.Collapse_IGIS_HierarchyGroup_Boolean_Boolean
        """
        pass

    def DrawBmp(
      self,
      _bitmap: TGIS_Bitmap,
      _scale: float,
      _ppi: int
    ) -> TGIS_Bitmap: 
        """
        Draw control on a provided bitmap.

        Args:
            _bitmap: bitmap on which the drawing will be performed; if null then bitmap will 
              be created based on control size and returned by function
            _scale: scale of the map; if 0 then map scale will be used
            _ppi: force PPI resolution; if 0 then set by corresponding GIS_Viewer object

        Returns:
            Bitmap (newly create bitmap if _bmp is nil)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlLegend.DrawBmp_TGIS_Bitmap_Double_Integer
        """
        pass

    @overload
    def Expand(
      self,
      _layer: TGIS_Layer
    ) -> None: 
        """
        Expands a legend item associated with the specific layer.

        Args:
            _layer: the layer to be expanded

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlLegend.Expand_TGIS_Layer
        """
        pass

    @overload
    def Expand(
      self,
      _group: IGIS_HierarchyGroup
    ) -> None: 
        """
        Expands of a legend item associated with the specific hierarchy group.

        Args:
            _group: the group to be expanded

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlLegend.Expand_IGIS_HierarchyGroup
        """
        pass

    @overload
    def Expand(
      self,
      _group: IGIS_HierarchyGroup,
      _deep: bool,
      _layers: bool
    ) -> None: 
        """
        Expands a legend item corresponding to a hierarchy group.

        Args:
            _group: the group to be expanded
            _deep: if True the subitems will be expanded as well
            _layers: if True and _deep is True the layer items will be expanded as well

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlLegend.Expand_IGIS_HierarchyGroup_Boolean_Boolean
        """
        pass

    def GetNodeAt(
      self,
      _x: int,
      _y: int
    ) -> TGIS_TreeNode: 
        """
        Retrieves the node at a given position.

        Args:
            _x: X coordinate
            _y: Y coordinate

        Returns:
            rectangle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlLegend.GetNodeAt_Integer_Integer
        """
        pass

    def InvalidateItems(
      self
    ) -> None: 
        """
        Forces invalidation of all the legend items.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlLegend.InvalidateItems_void
        """
        pass

    @overload
    def IsExpanded(
      self,
      _layer: TGIS_Layer
    ) -> bool: 
        """
        Checks if the legend item is associated with the specific layer is expanded.

        Args:
            _layer: the layer to be checked

        Returns:
            True if the item is expanded, False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlLegend.IsExpanded_TGIS_Layer
        """
        pass

    @overload
    def IsExpanded(
      self,
      _group: IGIS_HierarchyGroup
    ) -> bool: 
        """
        Checks if the legend item is associated with the specific hierarchy group is expanded.

        Args:
            _group: the group to be checked

        Returns:
            True if the item is expanded, False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlLegend.IsExpanded_IGIS_HierarchyGroup
        """
        pass

    def PrintClipboard(
      self
    ) -> None: 
        """
        Prints the current state of the legend to the clipboard as a bitmap.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlLegend.PrintClipboard_void
        """
        pass

class TGIS_PvlControlLegend( TGIS_PvlControl, IGIS_PvlControlLegend, IGIS_PrintableControl ):
    """
    PVL GIS Legend control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend
    """

    @overload
    def Collapse(
      self,
      _layer: TGIS_Layer
    ) -> None: 
        """
        Collapses a legend item corresponding to a layer.

        Args:
            _layer: the layer to be collapsed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.Collapse_TGIS_Layer
        """
        pass

    @overload
    def Collapse(
      self,
      _group: IGIS_HierarchyGroup
    ) -> None: 
        """
        Collapses a legend item corresponding to a hierarchy group.

        Args:
            _group: the group to be collapsed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.Collapse_IGIS_HierarchyGroup
        """
        pass

    @overload
    def Collapse(
      self,
      _group: IGIS_HierarchyGroup,
      _deep: bool,
      _layers: bool
    ) -> None: 
        """
        Collapses a legend item corresponding to a hierarchy group.

        Args:
            _group: the group to be collapsed
            _deep: if True the subitems will be collapsed as well
            _layers: if True and _deep is True the layer items will be collapsed as well

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.Collapse_IGIS_HierarchyGroup_Boolean_Boolean
        """
        pass

    def CreateCopy(
      self
    ) -> IGIS_PrintableControl: 
        """
        Prepare a copy of the control for printing. It prevents for making changes to the 
        original control during printing.

        Returns:
            created copy object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.CreateCopy_void
        """
        pass

    def DrawBmp(
      self,
      _bitmap: TGIS_Bitmap,
      _scale: float,
      _ppi: int
    ) -> TGIS_Bitmap: 
        """
        Draw control on a provided bitmap.

        Args:
            _bitmap: bitmap on which the drawing will be performed; if null then bitmap will 
              be created based on control size and returned by function
            _scale: scale of the map; if 0 then map scale will be used
            _ppi: force PPI resolution; if 0 then set by corresponding GIS_Viewer object

        Returns:
            Bitmap (newly create bitmap if _bmp is nil)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.DrawBmp_TGIS_Bitmap_Double_Integer
        """
        pass

    @overload
    def Expand(
      self,
      _layer: TGIS_Layer
    ) -> None: 
        """
        Expands a legend item associated with the specific layer.

        Args:
            _layer: the layer to be expanded

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.Expand_TGIS_Layer
        """
        pass

    @overload
    def Expand(
      self,
      _group: IGIS_HierarchyGroup
    ) -> None: 
        """
        Expands of a legend item associated with the specific hierarchy group.

        Args:
            _group: the group to be expanded

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.Expand_IGIS_HierarchyGroup
        """
        pass

    @overload
    def Expand(
      self,
      _group: IGIS_HierarchyGroup,
      _deep: bool,
      _layers: bool
    ) -> None: 
        """
        Expands a legend item corresponding to a hierarchy group.

        Args:
            _group: the group to be expanded
            _deep: if True the subitems will be expanded as well
            _layers: if True and _deep is True the layer items will be expanded as well

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.Expand_IGIS_HierarchyGroup_Boolean_Boolean
        """
        pass

    def FreeCopy(
      self,
      _control: IGIS_PrintableControl
    ) -> None: 
        """
        Release the copy of the control.

        Args:
            _control: copy to free

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.FreeCopy_IGIS_PrintableControl
        """
        pass

    def GetNodeAt(
      self,
      _x: int,
      _y: int
    ) -> TGIS_TreeNode: 
        """
        Retrieves the node at a given position.

        Args:
            _x: X coordinate
            _y: Y coordinate

        Returns:
            rectangle

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.GetNodeAt_Integer_Integer
        """
        pass

    def InvalidateItems(
      self
    ) -> None: 
        """
        Forces invalidation of all the legend items.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.InvalidateItems_void
        """
        pass

    @overload
    def IsExpanded(
      self,
      _layer: TGIS_Layer
    ) -> bool: 
        """
        Checks if the legend item is associated with the specific layer is expanded.

        Args:
            _layer: the layer to be checked

        Returns:
            True if the item is expanded, False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.IsExpanded_TGIS_Layer
        """
        pass

    @overload
    def IsExpanded(
      self,
      _group: IGIS_HierarchyGroup
    ) -> bool: 
        """
        Checks if the legend item is associated with the specific hierarchy group is expanded.

        Args:
            _group: the group to be checked

        Returns:
            True if the item is expanded, False otherwise

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.IsExpanded_IGIS_HierarchyGroup
        """
        pass

    def PrintBmp(
      self,
      _bitmap: TGIS_Bitmap
    ) -> None: 
        """
        Print the control on the given bitmap.

        Args:
            _bitmap: bitmap to print on

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.PrintBmp_TGIS_Bitmap
        """
        pass

    def PrintClipboard(
      self
    ) -> None: 
        """
        Prints the current state of the legend to the clipboard as a bitmap.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.PrintClipboard_void
        """
        pass

    @property
    def BackgroundColor(
      self
    ) -> TGIS_Color: 
        """
        Background color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.BackgroundColor
        """
        pass

    @BackgroundColor.setter
    def BackgroundColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Background color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.BackgroundColor
        """
        pass

    @property
    def CompactView(
      self
    ) -> bool: 
        """
        If True then the legend view is compacted - icons are smaller.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.CompactView
        """
        pass

    @CompactView.setter
    def CompactView(
      self,
      _value: bool
    ) -> None: 
        """
        If True then the legend view is compacted - icons are smaller.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.CompactView
        """
        pass

    @property
    def DialogOptions(
      self
    ) -> TGIS_ControlLegendDialogOptions: 
        """
        Options defining dialogs behavior.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.DialogOptions
        """
        pass

    @DialogOptions.setter
    def DialogOptions(
      self,
      _value: TGIS_ControlLegendDialogOptions
    ) -> None: 
        """
        Options defining dialogs behavior.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.DialogOptions
        """
        pass

    @property
    def DrawIconStyle(
      self
    ) -> TGIS_LegendIconStyle: 
        """
        Draw style of legend icons.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.DrawIconStyle
        """
        pass

    @DrawIconStyle.setter
    def DrawIconStyle(
      self,
      _value: TGIS_LegendIconStyle
    ) -> None: 
        """
        Draw style of legend icons.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.DrawIconStyle
        """
        pass

    @property
    def Font(
      self
    ) -> TGIS_Font: 
        """
        Display font.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.Font
        """
        pass

    @property
    def FontColor(
      self
    ) -> TGIS_Color: 
        """
        Display font.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.FontColor
        """
        pass

    @FontColor.setter
    def FontColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Display font.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.FontColor
        """
        pass

    @property
    def GIS_Group(
      self
    ) -> IGIS_HierarchyGroup: 
        """
        Selected group.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.GIS_Group
        """
        pass

    @GIS_Group.setter
    def GIS_Group(
      self,
      _value: IGIS_HierarchyGroup
    ) -> None: 
        """
        Selected group.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.GIS_Group
        """
        pass

    @property
    def GIS_Layer(
      self
    ) -> TGIS_Layer: 
        """
        Selected layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.GIS_Layer
        """
        pass

    @GIS_Layer.setter
    def GIS_Layer(
      self,
      _value: TGIS_Layer
    ) -> None: 
        """
        Selected layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.GIS_Layer
        """
        pass

    @property
    def GIS_Layers(
      self
    ) -> TGIS_LayerAbstractList: 
        """
        Selected layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.GIS_Layers
        """
        pass

    @GIS_Layers.setter
    def GIS_Layers(
      self,
      _value: TGIS_LayerAbstractList
    ) -> None: 
        """
        Selected layers.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.GIS_Layers
        """
        pass

    @property
    def GIS_Viewer(
      self
    ) -> IGIS_Viewer: 
        """
        Attached IGIS_Viewer object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.GIS_Viewer
        """
        pass

    @GIS_Viewer.setter
    def GIS_Viewer(
      self,
      _value: IGIS_Viewer
    ) -> None: 
        """
        Attached IGIS_Viewer object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.GIS_Viewer
        """
        pass

    @property
    def InternalName(
      self
    ) -> str: 
        """
        Used for internal use of TatukGIS.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.InternalName
        """
        pass

    @InternalName.setter
    def InternalName(
      self,
      _value: str
    ) -> None: 
        """
        Used for internal use of TatukGIS.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.InternalName
        """
        pass

    @property
    def Mode(
      self
    ) -> TGIS_ControlLegendMode: 
        """
        Mode of the legend - list of layers or grouped tree view.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.Mode
        """
        pass

    @Mode.setter
    def Mode(
      self,
      _value: TGIS_ControlLegendMode
    ) -> None: 
        """
        Mode of the legend - list of layers or grouped tree view.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.Mode
        """
        pass

    @property
    def Options(
      self
    ) -> typing.Sequence[TGIS_ControlLegendOption]: 
        """
        Options of the legend.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.Options
        """
        pass

    @Options.setter
    def Options(
      self,
      _value: typing.Sequence[TGIS_ControlLegendOption]
    ) -> None: 
        """
        Options of the legend.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.Options
        """
        pass

    @property
    def ReverseOrder(
      self
    ) -> bool: 
        """
        True if the order of legend entries in the Layer mode should be reverse, i.e. the 
        topmost layer in the attached IGIS_Viewer is bottommost in the legend.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.ReverseOrder
        """
        pass

    @ReverseOrder.setter
    def ReverseOrder(
      self,
      _value: bool
    ) -> None: 
        """
        True if the order of legend entries in the Layer mode should be reverse, i.e. the 
        topmost layer in the attached IGIS_Viewer is bottommost in the legend.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.ReverseOrder
        """
        pass

    @property
    def RightToLeft(
      self
    ) -> bool: 
        """
        BiDi value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.RightToLeft
        """
        pass

    @RightToLeft.setter
    def RightToLeft(
      self,
      _value: bool
    ) -> None: 
        """
        BiDi value.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.RightToLeft
        """
        pass

    @property
    def RightToLeftFromTranslation(
      self
    ) -> bool: 
        """
        Defines which BiDi will be used: the one from property or the one from translation

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.RightToLeftFromTranslation
        """
        pass

    @RightToLeftFromTranslation.setter
    def RightToLeftFromTranslation(
      self,
      _value: bool
    ) -> None: 
        """
        Defines which BiDi will be used: the one from property or the one from translation

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.RightToLeftFromTranslation
        """
        pass

    @property
    def SelectedNode(
      self
    ) -> TGIS_TreeNode: 
        """
        Selected node.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.SelectedNode
        """
        pass

    @property
    def GroupActiveChangeEvent(
      self
    ) -> typing.Callable[[TObject, IGIS_HierarchyGroup], None]: 
        """
        Event fired when a group is activated/deactivated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.GroupActiveChangeEvent
        """
        pass

    @GroupActiveChangeEvent.setter
    def GroupActiveChangeEvent(
      self,
      _value: typing.Callable[[TObject, IGIS_HierarchyGroup], None]
    ) -> None: 
        """
        Event fired when a group is activated/deactivated.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.GroupActiveChangeEvent
        """
        pass

    @property
    def GroupSelectEvent(
      self
    ) -> typing.Callable[[TObject, IGIS_HierarchyGroup], None]: 
        """
        Event fired upon group selection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.GroupSelectEvent
        """
        pass

    @GroupSelectEvent.setter
    def GroupSelectEvent(
      self,
      _value: typing.Callable[[TObject, IGIS_HierarchyGroup], None]
    ) -> None: 
        """
        Event fired upon group selection.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.GroupSelectEvent
        """
        pass

    @property
    def LayerActiveChangeEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Layer], None]: 
        """
        Event fired when a layer is activated/deactivated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.LayerActiveChangeEvent
        """
        pass

    @LayerActiveChangeEvent.setter
    def LayerActiveChangeEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Layer], None]
    ) -> None: 
        """
        Event fired when a layer is activated/deactivated.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.LayerActiveChangeEvent
        """
        pass

    @property
    def LayerParamsChangeEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Layer], None]: 
        """
        Event fired when a layer parameters get changed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.LayerParamsChangeEvent
        """
        pass

    @LayerParamsChangeEvent.setter
    def LayerParamsChangeEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Layer], None]
    ) -> None: 
        """
        Event fired when a layer parameters get changed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.LayerParamsChangeEvent
        """
        pass

    @property
    def LayerSelectEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Layer], None]: 
        """
        Event fired upon layer selection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.LayerSelectEvent
        """
        pass

    @LayerSelectEvent.setter
    def LayerSelectEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Layer], None]
    ) -> None: 
        """
        Event fired upon layer selection.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.LayerSelectEvent
        """
        pass

    @property
    def OpenDialogEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_Layer], None]: 
        """
        Event fired upon opening of the layer properties dialog box.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.OpenDialogEvent
        """
        pass

    @OpenDialogEvent.setter
    def OpenDialogEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_Layer], None]
    ) -> None: 
        """
        Event fired upon opening of the layer properties dialog box.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.OpenDialogEvent
        """
        pass

    @property
    def OrderChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Event fired upon a change of the order of layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.OrderChangeEvent
        """
        pass

    @OrderChangeEvent.setter
    def OrderChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Event fired upon a change of the order of layers.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.OrderChangeEvent
        """
        pass

    @property
    def TapDoubleEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_PvlMouseButton, TGIS_PvlShiftState, Single, Single], None]: 
        """
        TapDouble event. Will be fired upon double press down/up.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.TapDoubleEvent
        """
        pass

    @TapDoubleEvent.setter
    def TapDoubleEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_PvlMouseButton, TGIS_PvlShiftState, Single, Single], None]
    ) -> None: 
        """
        TapDouble event. Will be fired upon double press down/up.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.TapDoubleEvent
        """
        pass

    @property
    def TapLongEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_PvlMouseButton, TGIS_PvlShiftState, Single, Single], None]: 
        """
        TapLong event. Will be fired upon longer press down.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.TapLongEvent
        """
        pass

    @TapLongEvent.setter
    def TapLongEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_PvlMouseButton, TGIS_PvlShiftState, Single, Single], None]
    ) -> None: 
        """
        TapLong event. Will be fired upon longer press down.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.TapLongEvent
        """
        pass

    @property
    def TapSimpleEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_PvlMouseButton, TGIS_PvlShiftState, Single, Single], None]: 
        """
        TapSimple event. Will be fired upon press down/up.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.TapSimpleEvent
        """
        pass

    @TapSimpleEvent.setter
    def TapSimpleEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_PvlMouseButton, TGIS_PvlShiftState, Single, Single], None]
    ) -> None: 
        """
        TapSimple event. Will be fired upon press down/up.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlLegend.TapSimpleEvent
        """
        pass

class IGIS_PvlControlNorthArrow( IGIS_Subscribe ):
    """
    PVL control north arrow intraface

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlNorthArrow
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlNorthArrow.Create_void
        """
        pass

class TGIS_PvlControlNorthArrow( TGIS_PvlControl, IGIS_PvlControlNorthArrow, IGIS_PrintableControl ):
    """
    PVL north arrow control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow
    """

    def CreateCopy(
      self
    ) -> IGIS_PrintableControl: 
        """
        Prepare a copy of the control for printing. It prevents for making changes to the 
        original control during printing.

        Returns:
            created copy object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.CreateCopy_void
        """
        pass

    def FreeCopy(
      self,
      _control: IGIS_PrintableControl
    ) -> None: 
        """
        Release the copy of the control.

        Args:
            _control: copy to free

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.FreeCopy_IGIS_PrintableControl
        """
        pass

    def PrintBmp(
      self,
      _bitmap: TGIS_Bitmap
    ) -> None: 
        """
        Print the control on the given bitmap.

        Args:
            _bitmap: bitmap to print on

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.PrintBmp_TGIS_Bitmap
        """
        pass

    def SubscribedEvent(
      self,
      _sender: TObject,
      _event: int,
      _context: TObject
    ) -> None: 
        """
        Subscriber notification event.

        Args:
            _sender: sender object
            _event: event identifier
            _context: context object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.SubscribedEvent_TObject_Integer_TObject
        """
        pass

    @property
    def Color1(
      self
    ) -> TGIS_Color: 
        """
        First color used for drawing.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.Color1
        """
        pass

    @Color1.setter
    def Color1(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        First color used for drawing.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.Color1
        """
        pass

    @property
    def Color2(
      self
    ) -> TGIS_Color: 
        """
        Second color used for drawing

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.Color2
        """
        pass

    @Color2.setter
    def Color2(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Second color used for drawing

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.Color2
        """
        pass

    @property
    def GIS_Viewer(
      self
    ) -> TGIS_PvlViewerWnd: 
        """
        Attached viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.GIS_Viewer
        """
        pass

    @GIS_Viewer.setter
    def GIS_Viewer(
      self,
      _value: TGIS_PvlViewerWnd
    ) -> None: 
        """
        Attached viewer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.GIS_Viewer
        """
        pass

    @property
    def Glow(
      self
    ) -> bool: 
        """
        Draw "glowing" shadow around scale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.Glow
        """
        pass

    @Glow.setter
    def Glow(
      self,
      _value: bool
    ) -> None: 
        """
        Draw "glowing" shadow around scale.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.Glow
        """
        pass

    @property
    def InternalName(
      self
    ) -> str: 
        """
        Used for internal use of TatukGIS.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.InternalName
        """
        pass

    @InternalName.setter
    def InternalName(
      self,
      _value: str
    ) -> None: 
        """
        Used for internal use of TatukGIS.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.InternalName
        """
        pass

    @property
    def Path(
      self
    ) -> str: 
        """
        Symbol path. If empty then Style property is used.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.Path
        """
        pass

    @Path.setter
    def Path(
      self,
      _value: str
    ) -> None: 
        """
        Symbol path. If empty then Style property is used.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.Path
        """
        pass

    @property
    def Style(
      self
    ) -> TGIS_ControlNorthArrowStyle: 
        """
        Symbol style, used if Path is empty.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.Style
        """
        pass

    @Style.setter
    def Style(
      self,
      _value: TGIS_ControlNorthArrowStyle
    ) -> None: 
        """
        Symbol style, used if Path is empty.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlNorthArrow.Style
        """
        pass

class IGIS_PvlControlPrintPreview( IGIS_Subscribe ):
    """
    PVL control attributes intraface

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlPrintPreview
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlPrintPreview.Create_void
        """
        pass

    @overload
    def Preview(
      self,
      _pageNumber: int,
      _printer: TObject,
      _printManager: TGIS_PrintManagerAbstract
    ) -> str: 
        """
        Preview selected page.

        Args:
            _pageNumber: page number to be previewed (1 means the first page)
            _printer: printer object
            _printManager: print manager object or nil

        Returns:
            title string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlPrintPreview.Preview_Integer_TObject_TGIS_PrintManagerAbstract
        """
        pass

    @overload
    def Preview(
      self,
      _pageNumber: int,
      _printer: TObject,
      _printManager: TGIS_PrintManagerAbstract,
      _scale: VarParameter
    ) -> str: 
        """
        Preview selected page.

        Args:
            _pageNumber: page number to be previewed (1 means the first page)
            _printer: printer object
            _printManager: print manager object or nil
            _scale: scale factor used during print (for printing scale etc); if scale=0 then 
              scale will be calculated automatically to fit the _extent; the value (in/out) is 
              passed as float in _scale.Value property

        Returns:
            title string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlPrintPreview.Preview_Integer_TObject_TGIS_PrintManagerAbstract_Double
        """
        pass

    @overload
    def Preview(
      self,
      _pageNumber: int,
      _printer: TObject,
      _printManager: TGIS_PrintManagerAbstract,
      _customPage: str,
      _scale: VarParameter
    ) -> str: 
        """
        Preview selected page.

        Args:
            _pageNumber: page number to be previewed (1 means the first page)
            _printer: printer object
            _printManager: print manager object or nil
            _customPage: default page orientation: "Landscape" or "Portrait"
            _scale: scale factor used during print (for printing scale etc); if scale=0 then 
              scale will be calculated automatically to fit the _extent; the value (in/out) is 
              passed as float in _scale.Value property

        Returns:
            title string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlPrintPreview.Preview_Integer_TObject_TGIS_PrintManagerAbstract_String_Double
        """
        pass

    @overload
    def Print(
      self,
      _printer: TObject
    ) -> None: 
        """
        Print document.

        Args:
            _printer: printer object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlPrintPreview.Print_TObject
        """
        pass

    @overload
    def Print(
      self
    ) -> None: 
        """
        Print document.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlPrintPreview.Print_void
        """
        pass

    def SubscribedEvent(
      self,
      _sender: TObject,
      _event: int,
      _context: TObject
    ) -> None: 
        """
        Subscriber notification event.

        Args:
            _sender: sender object
            _event: event identifier
            _context: context object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlPrintPreview.SubscribedEvent_TObject_Integer_TObject
        """
        pass

class TGIS_PvlControlPrintPreview( TGIS_PvlControl, IGIS_PvlControlPrintPreview ):
    """
    PVL attributes control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreview
    """

    @overload
    def Preview(
      self,
      _pageNumber: int,
      _printer: TObject,
      _printManager: TGIS_PrintManagerAbstract
    ) -> str: 
        """
        Preview selected page.

        Args:
            _pageNumber: page number to be previewed (1 means the first page)
            _printer: printer object
            _printManager: print manager object or nil

        Returns:
            title string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreview.Preview_Integer_TObject_TGIS_PrintManagerAbstract
        """
        pass

    @overload
    def Preview(
      self,
      _pageNumber: int,
      _printer: TObject,
      _printManager: TGIS_PrintManagerAbstract,
      _scale: VarParameter
    ) -> str: 
        """
        Preview selected page.

        Args:
            _pageNumber: page number to be previewed (1 means the first page)
            _printer: printer object
            _printManager: print manager object or nil
            _scale: scale factor used during print (for printing scale etc); if scale=0 then 
              scale will be calculated automatically to fit the _extent; the value (in/out) is 
              passed as float in _scale.Value property

        Returns:
            title string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreview.Preview_Integer_TObject_TGIS_PrintManagerAbstract_Double
        """
        pass

    @overload
    def Preview(
      self,
      _pageNumber: int,
      _printer: TObject,
      _printManager: TGIS_PrintManagerAbstract,
      _customPage: str,
      _scale: VarParameter
    ) -> str: 
        """
        Preview selected page.

        Args:
            _pageNumber: page number to be previewed (1 means the first page)
            _printer: printer object
            _printManager: print manager object or nil
            _customPage: default page orientation: "Landscape" or "Portrait"
            _scale: scale factor used during print (for printing scale etc); if scale=0 then 
              scale will be calculated automatically to fit the _extent; the value (in/out) is 
              passed as float in _scale.Value property

        Returns:
            title string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreview.Preview_Integer_TObject_TGIS_PrintManagerAbstract_String_Double
        """
        pass

    @overload
    def Print(
      self,
      _printer: TObject
    ) -> None: 
        """
        Print document.

        Args:
            _printer: printer object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreview.Print_TObject
        """
        pass

    @overload
    def Print(
      self
    ) -> None: 
        """
        Print document.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreview.Print_void
        """
        pass

    @property
    def GIS_Viewer(
      self
    ) -> TGIS_PvlViewerWnd: 
        """
        Viewer to which Print Preview will be attached.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreview.GIS_Viewer
        """
        pass

    @GIS_Viewer.setter
    def GIS_Viewer(
      self,
      _value: TGIS_PvlViewerWnd
    ) -> None: 
        """
        Viewer to which Print Preview will be attached.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreview.GIS_Viewer
        """
        pass

    @property
    def IsLast(
      self
    ) -> bool: 
        """
        True, if last page in preview was reached.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreview.IsLast
        """
        pass

    @property
    def IsPrinter(
      self
    ) -> bool: 
        """
        True, if any printer exists.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreview.IsPrinter
        """
        pass

class IGIS_PvlControlScale( IGIS_Subscribe ):
    """
    PVL control scale intraface

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlScale
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControlScale.Create_void
        """
        pass

class TGIS_PvlControlScale( TGIS_PvlControl, IGIS_PvlControlScale, IGIS_PrintableControl ):
    """
    PVL scale control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale
    """

    def CreateCopy(
      self
    ) -> IGIS_PrintableControl: 
        """
        Prepare a copy of the control for printing. It prevents for making changes to the 
        original control during printing.

        Returns:
            created copy object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.CreateCopy_void
        """
        pass

    def FreeCopy(
      self,
      _control: IGIS_PrintableControl
    ) -> None: 
        """
        Release the copy of the control.

        Args:
            _control: copy to free

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.FreeCopy_IGIS_PrintableControl
        """
        pass

    def PrintBmp(
      self,
      _bitmap: TGIS_Bitmap
    ) -> None: 
        """
        Print the control on the given bitmap.

        Args:
            _bitmap: bitmap to print on

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.PrintBmp_TGIS_Bitmap
        """
        pass

    def SubscribedEvent(
      self,
      _sender: TObject,
      _event: int,
      _context: TObject
    ) -> None: 
        """
        Subscriber notification event.

        Args:
            _sender: sender object
            _event: event identifier
            _context: context object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.SubscribedEvent_TObject_Integer_TObject
        """
        pass

    @property
    def DividerColor1(
      self
    ) -> TGIS_Color: 
        """
        Color of the first divider.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.DividerColor1
        """
        pass

    @DividerColor1.setter
    def DividerColor1(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Color of the first divider.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.DividerColor1
        """
        pass

    @property
    def DividerColor2(
      self
    ) -> TGIS_Color: 
        """
        Color of the second divider.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.DividerColor2
        """
        pass

    @DividerColor2.setter
    def DividerColor2(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Color of the second divider.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.DividerColor2
        """
        pass

    @property
    def Dividers(
      self
    ) -> int: 
        """
        Number of dividers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.Dividers
        """
        pass

    @Dividers.setter
    def Dividers(
      self,
      _value: int
    ) -> None: 
        """
        Number of dividers.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.Dividers
        """
        pass

    @property
    def Font(
      self
    ) -> TGIS_Font: 
        """
        Font of the text.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.Font
        """
        pass

    @Font.setter
    def Font(
      self,
      _value: TGIS_Font
    ) -> None: 
        """
        Font of the text.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.Font
        """
        pass

    @property
    def GIS_Viewer(
      self
    ) -> TGIS_PvlViewerWnd: 
        """
        Attached viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.GIS_Viewer
        """
        pass

    @GIS_Viewer.setter
    def GIS_Viewer(
      self,
      _value: TGIS_PvlViewerWnd
    ) -> None: 
        """
        Attached viewer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.GIS_Viewer
        """
        pass

    @property
    def Glow(
      self
    ) -> bool: 
        """
        Draw "glowing" shadow around scale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.Glow
        """
        pass

    @Glow.setter
    def Glow(
      self,
      _value: bool
    ) -> None: 
        """
        Draw "glowing" shadow around scale.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.Glow
        """
        pass

    @property
    def InternalName(
      self
    ) -> str: 
        """
        Used for internal use of TatukGIS.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.InternalName
        """
        pass

    @InternalName.setter
    def InternalName(
      self,
      _value: str
    ) -> None: 
        """
        Used for internal use of TatukGIS.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.InternalName
        """
        pass

    @property
    def ShadowColor(
      self
    ) -> TGIS_Color: 
        """
        Color of the text shadow. Drawn if different from TextColor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.ShadowColor
        """
        pass

    @ShadowColor.setter
    def ShadowColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Color of the text shadow. Drawn if different from TextColor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.ShadowColor
        """
        pass

    @property
    def TextColor(
      self
    ) -> TGIS_Color: 
        """
        Color of the text.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.TextColor
        """
        pass

    @TextColor.setter
    def TextColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Color of the text.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.TextColor
        """
        pass

    @property
    def UnitsEPSG(
      self
    ) -> int: 
        """
        Units EPSG code for scale output. If set to 0 then automatic Matric or Imperial system 
        will be used based on location.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.UnitsEPSG
        """
        pass

    @UnitsEPSG.setter
    def UnitsEPSG(
      self,
      _value: int
    ) -> None: 
        """
        Units EPSG code for scale output. If set to 0 then automatic Matric or Imperial system 
        will be used based on location.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.UnitsEPSG
        """
        pass

    @property
    def PrepareEvent(
      self
    ) -> typing.Callable[[TGIS_Point, TGIS_Point, Double, String], None]: 
        """
        Event fired before calculating scale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.PrepareEvent
        """
        pass

    @PrepareEvent.setter
    def PrepareEvent(
      self,
      _value: typing.Callable[[TGIS_Point, TGIS_Point, Double, String], None]
    ) -> None: 
        """
        Event fired before calculating scale.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlScale.PrepareEvent
        """
        pass

class IGIS_PvlGrid( IGIS_PvlControl ):
    """
    PVL Grid interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlGrid
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlGrid.Create_void
        """
        pass

    def BeginEdit(
      self,
      _txt: str,
      _char: char
    ) -> None: 
        """
        Realign control - recalvulate srollbars etc.

        Args:
            _txt: content to be edited
            _char: key char taht started editing or #0; if editing is tarted by pressing a char 
              key it will put editor into proper state

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlGrid.BeginEdit_String_Char
        """
        pass

    def DrawAll(
      self,
      _canvas: TObject
    ) -> None: 
        """
        Draw whole content.

        Args:
            _canvas: canvas object to be drawn on

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlGrid.DrawAll_TObject
        """
        pass

    def DrawCell(
      self,
      _col: int,
      _row: int,
      _txt: str,
      _canvas: TObject
    ) -> None: 
        """
        Draw a cell.

        Args:
            _col: cell column
            _row: cell row
            _txt: text to be drawn
            _canvas: canvas object to be drawn on

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlGrid.DrawCell_Integer_Integer_String_TObject
        """
        pass

    def EndEdit(
      self,
      _commit: bool
    ) -> None: 
        """
        Finalize cell editing.

        Args:
            _commit: if true, then edited text will be applied; otherwise editing is canceled

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlGrid.EndEdit_Boolean
        """
        pass

    def First(
      self
    ) -> None: 
        """
        Moves to the first record in the associated dataset if one is present.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlGrid.First_void
        """
        pass

    def InvalidateControl(
      self
    ) -> None: 
        """
        Invalidate control - mark for redraw.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlGrid.InvalidateControl_void
        """
        pass

    def MeasureText(
      self,
      _txt: str
    ) -> TPoint: 
        """
        Measure text size.

        Args:
            _txt: text to be meausred

        Returns:
            Measued text width/height in devic3e independent units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlGrid.MeasureText_String
        """
        pass

    def MoveBy(
      self,
      _dist: int
    ) -> None: 
        """
        Moves to another record relative to the active record in the associated dataset if 
        one is present.

        Args:
            _dist: A positive value for Distance indicates forward progress through the dataset, 
              while a negative value indicates backward progress

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlGrid.MoveBy_Integer
        """
        pass

    def RealignControl(
      self
    ) -> None: 
        """
        Realign control - recalvulate srollbars etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlGrid.RealignControl_void
        """
        pass

class TGIS_PVlGridHeader:
    pass

class TGIS_PVlGridHeader:
    """
    Style of rows/colums header.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridHeader
    """

    @property
    def None_(
      self
    ) -> TGIS_PVlGridHeader: 
        """
        No header.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridHeader.None
        """
        pass

    @property
    def Auto(
      self
    ) -> TGIS_PVlGridHeader: 
        """
        Header is automatic: for rows row number; for columns columns name from data set 
        or specified by Ca[ption property.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridHeader.Auto
        """
        pass

    @property
    def First(
      self
    ) -> TGIS_PVlGridHeader: 
        """
        Header represnets forst row/column.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridHeader.First
        """
        pass

class TGIS_PvlGridCellAlignment:
    pass

class TGIS_PvlGridCellAlignment:
    """
    Cell alignement.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGridCellAlignment
    """

    @property
    def Left(
      self
    ) -> TGIS_PvlGridCellAlignment: 
        """
        Left justified.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGridCellAlignment.Left
        """
        pass

    @property
    def Center(
      self
    ) -> TGIS_PvlGridCellAlignment: 
        """
        Centered..

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGridCellAlignment.Center
        """
        pass

    @property
    def Right(
      self
    ) -> TGIS_PvlGridCellAlignment: 
        """
        Right justified.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGridCellAlignment.Right
        """
        pass

class TGIS_PVlGridColumn:
    """
    Grid''s column representation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn
    """

    @overload
    def __init__(
      self,
      _parent: TGIS_PvlGrid
    ) -> None: 
        """
        Create a column and assign it to the grid.

        Args:
            _parent: parent grid

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.Create_TGIS_PvlGrid
        """
        pass

    def Validate(
      self,
      _text: str
    ) -> bool: 
        """
        Validaty if text matches column format.

        Args:
            _text: text to be validated

        Returns:
            True, if provided text matches column formats

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.Validate_String
        """
        pass

    @property
    def Align(
      self
    ) -> TGIS_PvlGridCellAlignment: 
        """
        Column alignment.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.Align
        """
        pass

    @Align.setter
    def Align(
      self,
      _value: TGIS_PvlGridCellAlignment
    ) -> None: 
        """
        Column alignment.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.Align
        """
        pass

    @property
    def AllowNulls(
      self
    ) -> bool: 
        """
        Are nulls/empty values allowed?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.AllowNulls
        """
        pass

    @AllowNulls.setter
    def AllowNulls(
      self,
      _value: bool
    ) -> None: 
        """
        Are nulls/empty values allowed?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.AllowNulls
        """
        pass

    @property
    def Caption(
      self
    ) -> str: 
        """
        Column caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.Caption
        """
        pass

    @Caption.setter
    def Caption(
      self,
      _value: str
    ) -> None: 
        """
        Column caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.Caption
        """
        pass

    @property
    def FieldDecimal(
      self
    ) -> int: 
        """
        Column field decimal points. Important for number and floatd fields.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.FieldDecimal
        """
        pass

    @FieldDecimal.setter
    def FieldDecimal(
      self,
      _value: int
    ) -> None: 
        """
        Column field decimal points. Important for number and floatd fields.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.FieldDecimal
        """
        pass

    @property
    def FieldType(
      self
    ) -> TGIS_FieldType: 
        """
        Column field type?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.FieldType
        """
        pass

    @FieldType.setter
    def FieldType(
      self,
      _value: TGIS_FieldType
    ) -> None: 
        """
        Column field type?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.FieldType
        """
        pass

    @property
    def FieldWidth(
      self
    ) -> int: 
        """
        Column field width. Important for number and string fields.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.FieldWidth
        """
        pass

    @FieldWidth.setter
    def FieldWidth(
      self,
      _value: int
    ) -> None: 
        """
        Column field width. Important for number and string fields.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.FieldWidth
        """
        pass

    @property
    def FitWidth(
      self
    ) -> bool: 
        """
        If colunt shpould be expanded to perfeclty fill grid wdith. Onnly frst such columnn 
        will be expanded accrodingly.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.FitWidth
        """
        pass

    @FitWidth.setter
    def FitWidth(
      self,
      _value: bool
    ) -> None: 
        """
        If colunt shpould be expanded to perfeclty fill grid wdith. Onnly frst such columnn 
        will be expanded accrodingly.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.FitWidth
        """
        pass

    @property
    def Format(
      self
    ) -> str: 
        """
        Column format specifier. Same syntax as TGIS_StringFormat.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.Format
        """
        pass

    @Format.setter
    def Format(
      self,
      _value: str
    ) -> None: 
        """
        Column format specifier. Same syntax as TGIS_StringFormat.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.Format
        """
        pass

    @property
    def ReadOnly(
      self
    ) -> bool: 
        """
        Is column read-only?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.ReadOnly
        """
        pass

    @ReadOnly.setter
    def ReadOnly(
      self,
      _value: bool
    ) -> None: 
        """
        Is column read-only?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.ReadOnly
        """
        pass

    @property
    def Regex(
      self
    ) -> str: 
        """
        Regex expression to be used to validate conent upon editing.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.Regex
        """
        pass

    @Regex.setter
    def Regex(
      self,
      _value: str
    ) -> None: 
        """
        Regex expression to be used to validate conent upon editing.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.Regex
        """
        pass

    @property
    def Visible(
      self
    ) -> bool: 
        """
        Is column visible?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.Visible
        """
        pass

    @Visible.setter
    def Visible(
      self,
      _value: bool
    ) -> None: 
        """
        Is column visible?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.Visible
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        Column width expressed in device independent units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.Width
        """
        pass

    @Width.setter
    def Width(
      self,
      _value: int
    ) -> None: 
        """
        Column width expressed in device independent units.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridColumn.Width
        """
        pass

class TGIS_PVlGridRow( TObject ):
    """
    Grid''s row representation.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridRow
    """

    @overload
    def __init__(
      self,
      _parent: TGIS_PvlGrid
    ) -> None: 
        """
        Create a row and assign it to the grid.

        Args:
            _parent: parent grid

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridRow.Create_TGIS_PvlGrid
        """
        pass

    
    def Column(
      self,
      _index: int
    ) -> Variant: 
        """
        Access comulnt by number. Columns ar numbered from 1.

        Args:
            _index: column number; column=0 is a row header column

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridRow.Column
        """
        pass

    
    def Column(
      self,
      _index: int,
      _value: Variant
    ) -> None: 
        """
        Access comulnt by number. Columns ar numbered from 1.

        Args:
            _index: column number; column=0 is a row header column

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PVlGridRow.Column
        """
        pass

class TGIS_PvlGrid( TGIS_PvlControl, IGIS_PvlGrid ):
    """
    PVL grid component.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid
    """

    def AddColumn(
      self
    ) -> TGIS_PVlGridColumn: 
        """
        Add a new Column.

        Returns:
            Newly created column.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.AddColumn_void
        """
        pass

    def AddRow(
      self
    ) -> TGIS_PVlGridRow: 
        """
        Add a new row.

        Returns:
            Newly created row.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.AddRow_void
        """
        pass

    def AutoSize(
      self
    ) -> None: 
        """
        Resize grid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.AutoSize_void
        """
        pass

    def BeginEdit(
      self,
      _txt: str,
      _char: char
    ) -> None: 
        """
        Realign control - recalvulate srollbars etc.

        Args:
            _txt: content to be edited
            _char: key char taht started editing or #0; if editing is tarted by pressing a char 
              key it will put editor into proper state

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.BeginEdit_String_Char
        """
        pass

    def BeginUpdate(
      self
    ) -> None: 
        """
        Begin update with large data. Locks visual update of the grid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.BeginUpdate_void
        """
        pass

    def CellByLocation(
      self,
      _x: int,
      _y: int
    ) -> TPoint: 
        """
        Find cell (col/row).

        Args:
            _x: x postion related to left-up corner expressed in screen coordinates
            _y: y postion related to left-up corner expressed in screen coordinates

        Returns:
            Cell corridinate in a meaning cof col/row.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.CellByLocation_Integer_Integer
        """
        pass

    def CellEditRect(
      self
    ) -> TRect: 
        """
        Find screen rectangle occupied by a cell editor for active cell.

        Returns:
            Cell rectangle related to left-up corner expressed in screen units..

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.CellEditRect_void
        """
        pass

    def CellRect(
      self,
      _col: int,
      _row: int
    ) -> TRect: 
        """
        Find screen rectangle occupied by a cell.

        Args:
            _col: column corrdinate of the cell
            _row: row corrdinate of the cell

        Returns:
            Cell rectangle related to left-up corner expressed in screen units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.CellRect_Integer_Integer
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear whole grid. Disconnect dataset if attached.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.Clear_void
        """
        pass

    def DeleteRow(
      self,
      _row: int
    ) -> None: 
        """
        Delete a row.

        Args:
            _row: number of the roww to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.DeleteRow_Integer
        """
        pass

    def DrawAll(
      self,
      _canvas: TObject
    ) -> None: 
        """
        Draw whole content.

        Args:
            _canvas: canvas object to be drawn on

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.DrawAll_TObject
        """
        pass

    def DrawCell(
      self,
      _col: int,
      _row: int,
      _txt: str,
      _canvas: TObject
    ) -> None: 
        """
        Draw a cell.

        Args:
            _col: cell column
            _row: cell row
            _txt: text to be drawn
            _canvas: canvas object to be drawn on

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.DrawCell_Integer_Integer_String_TObject
        """
        pass

    def EndEdit(
      self,
      _commit: bool
    ) -> None: 
        """
        Finalize cell editing.

        Args:
            _commit: if true, then edited text will be applied; otherwise editing is canceled

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.EndEdit_Boolean
        """
        pass

    def EndUpdate(
      self
    ) -> None: 
        """
        End update with large data. Unlocks visual update of the grid.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.EndUpdate_void
        """
        pass

    def First(
      self
    ) -> None: 
        """
        Moves to the first record in the associated dataset if one is present.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.First_void
        """
        pass

    def InvalidateControl(
      self
    ) -> None: 
        """
        Invalidate control - mark for redraw.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.InvalidateControl_void
        """
        pass

    def MeasureText(
      self,
      _txt: str
    ) -> TPoint: 
        """
        Measure text size.

        Args:
            _txt: text to be meausred

        Returns:
            Measued text width/height in devic3e independent units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.MeasureText_String
        """
        pass

    def MoveBy(
      self,
      _dist: int
    ) -> None: 
        """
        Moves to another record relative to the active record in the associated dataset if 
        one is present.

        Args:
            _dist: A positive value for Distance indicates forward progress through the dataset, 
              while a negative value indicates backward progress

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.MoveBy_Integer
        """
        pass

    def RealignControl(
      self
    ) -> None: 
        """
        Realign control - recalvulate srollbars etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.RealignControl_void
        """
        pass

    def ScrollBottom(
      self
    ) -> bool: 
        """
        Scroll to the last row.

        Returns:
            True if the view was scrolled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollBottom_void
        """
        pass

    def ScrollBy(
      self,
      _x: int,
      _y: int
    ) -> None: 
        """
        Scroll view by delta. Cooridinates are expressed in width/height of entire grid in 
        in screen coordinates.

        Args:
            _x: horizontal scroll
            _y: vertical scroll

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollBy_Integer_Integer
        """
        pass

    def ScrollDown(
      self
    ) -> bool: 
        """
        Scroll to next line.

        Returns:
            True if the view was scrolled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollDown_void
        """
        pass

    def ScrollEnd(
      self
    ) -> bool: 
        """
        Scroll to the last column.

        Returns:
            True if the view was scrolled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollEnd_void
        """
        pass

    def ScrollHome(
      self
    ) -> bool: 
        """
        Scroll to the first column.

        Returns:
            True if the view was scrolled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollHome_void
        """
        pass

    def ScrollLeft(
      self
    ) -> bool: 
        """
        Scroll left by one column.

        Returns:
            True if the view was scrolled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollLeft_void
        """
        pass

    def ScrollNext(
      self
    ) -> bool: 
        """
        Scroll to the next column; if column is last one, then scroll to the first column 
        of the next row.

        Returns:
            True if the view was scrolled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollNext_void
        """
        pass

    def ScrollPageDown(
      self
    ) -> bool: 
        """
        Scroll one page down.

        Returns:
            True if the view was scrolled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollPageDown_void
        """
        pass

    def ScrollPageUp(
      self
    ) -> bool: 
        """
        Scroll one page up.

        Returns:
            True if the view was scrolled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollPageUp_void
        """
        pass

    def ScrollPrevious(
      self
    ) -> bool: 
        """
        Scroll to the previous colun; if column is the first one, then scroll scroll to the 
        last column of the previous row.

        Returns:
            True if the view was scrolled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollPrevious_void
        """
        pass

    def ScrollRight(
      self
    ) -> bool: 
        """
        Scroll right by one column.

        Returns:
            True if the view was scrolled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollRight_void
        """
        pass

    def ScrollTo(
      self,
      _x: int,
      _y: int
    ) -> None: 
        """
        Scroll view to absolute position. Cooridinates are expressed in width/height of entire 
        grid in screen coordinates.

        Args:
            _x: horizontal scroll
            _y: vertical scroll

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollTo_Integer_Integer
        """
        pass

    def ScrollToActiveCell(
      self
    ) -> bool: 
        """
        Ensure that active cell is visible in the view (screen).

        Returns:
            True if the view was scrolled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollToActiveCell_void
        """
        pass

    def ScrollTop(
      self
    ) -> bool: 
        """
        Scroll to the first row.

        Returns:
            True if the view was scrolled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollTop_void
        """
        pass

    def ScrollUp(
      self
    ) -> bool: 
        """
        Scroll to previous line.

        Returns:
            True if the view was scrolled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollUp_void
        """
        pass

    def SetSize(
      self,
      _cols: int,
      _rows: int
    ) -> None: 
        """
        Set size of the grid. Setting DataSet will verride this.

        Args:
            _cols: number of columns
            _rows: number of rows

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.SetSize_Integer_Integer
        """
        pass

    @property
    def ActiveCell(
      self
    ) -> TPoint: 
        """
        Active cell.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ActiveCell
        """
        pass

    @ActiveCell.setter
    def ActiveCell(
      self,
      _value: TPoint
    ) -> None: 
        """
        Active cell.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ActiveCell
        """
        pass

    @property
    def ActiveEditor(
      self
    ) -> bool: 
        """
        True if editor is active

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ActiveEditor
        """
        pass

    
    def Cell(
      self,
      _col: int,
      _row: int
    ) -> Variant: 
        """
        Access cell.

        Args:
            _col: column number ; counted from 1
            _row: row number ; counted from 1

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.Cell
        """
        pass

    
    def Cell(
      self,
      _col: int,
      _row: int,
      _value: Variant
    ) -> None: 
        """
        Access cell.

        Args:
            _col: column number ; counted from 1
            _row: row number ; counted from 1

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.Cell
        """
        pass

    
    def Column(
      self,
      _index: int
    ) -> TGIS_PVlGridColumn: 
        """
        Access column object.

        Args:
            _index: column number; column=0 is a row header column

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.Column
        """
        pass

    @property
    def ColumnsCount(
      self
    ) -> int: 
        """
        Number of columns.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ColumnsCount
        """
        pass

    @property
    def ColumnsHeader(
      self
    ) -> TGIS_PVlGridHeader: 
        """
        Defines columns header mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ColumnsHeader
        """
        pass

    @ColumnsHeader.setter
    def ColumnsHeader(
      self,
      _value: TGIS_PVlGridHeader
    ) -> None: 
        """
        Defines columns header mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ColumnsHeader
        """
        pass

    @property
    def DataSet(
      self
    ) -> TObject: 
        """
        Connect to dataset.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.DataSet
        """
        pass

    @DataSet.setter
    def DataSet(
      self,
      _value: TObject
    ) -> None: 
        """
        Connect to dataset.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.DataSet
        """
        pass

    @property
    def DefaultColumnsWidth(
      self
    ) -> int: 
        """
        Default column width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.DefaultColumnsWidth
        """
        pass

    @DefaultColumnsWidth.setter
    def DefaultColumnsWidth(
      self,
      _value: int
    ) -> None: 
        """
        Default column width.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.DefaultColumnsWidth
        """
        pass

    @property
    def ReadOnly(
      self
    ) -> bool: 
        """
        Is grid read-only?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ReadOnly
        """
        pass

    @ReadOnly.setter
    def ReadOnly(
      self,
      _value: bool
    ) -> None: 
        """
        Is grid read-only?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ReadOnly
        """
        pass

    
    def Row(
      self,
      _index: int
    ) -> TGIS_PVlGridRow: 
        """
        Access row object.

        Args:
            _index: rown number; counted from 1

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.Row
        """
        pass

    @property
    def RowsCount(
      self
    ) -> int: 
        """
        Number of rows.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.RowsCount
        """
        pass

    @property
    def RowSelect(
      self
    ) -> bool: 
        """
        If true, then slection will selct whole row.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.RowSelect
        """
        pass

    @RowSelect.setter
    def RowSelect(
      self,
      _value: bool
    ) -> None: 
        """
        If true, then slection will selct whole row.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.RowSelect
        """
        pass

    @property
    def RowsHeader(
      self
    ) -> TGIS_PVlGridHeader: 
        """
        Defines rows header mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.RowsHeader
        """
        pass

    @RowsHeader.setter
    def RowsHeader(
      self,
      _value: TGIS_PVlGridHeader
    ) -> None: 
        """
        Defines rows header mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.RowsHeader
        """
        pass

    @property
    def RowsHeight(
      self
    ) -> int: 
        """
        Rows height expressed in device independent units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.RowsHeight
        """
        pass

    @RowsHeight.setter
    def RowsHeight(
      self,
      _value: int
    ) -> None: 
        """
        Rows height expressed in device independent units.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.RowsHeight
        """
        pass

    @property
    def ScrollMax(
      self
    ) -> TPoint: 
        """
        Maximum scrolling distance. Calulated by countingg visible columns/row width and 
        columns/rows header.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollMax
        """
        pass

    @property
    def ScrollPos(
      self
    ) -> TPoint: 
        """
        Position of scrollbars.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollPos
        """
        pass

    @property
    def ScrollRect(
      self
    ) -> TRect: 
        """
        Area of control that can be scrolled. Calulated by removing area occupied by columns/rows 
        header.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.ScrollRect
        """
        pass

    @property
    def BeginEditEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Event to be fired upon begin of cell editing.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.BeginEditEvent
        """
        pass

    @BeginEditEvent.setter
    def BeginEditEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Event to be fired upon begin of cell editing.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.BeginEditEvent
        """
        pass

    @property
    def EndEditEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Event to be fired upon end of cell editing.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.EndEditEvent
        """
        pass

    @EndEditEvent.setter
    def EndEditEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Event to be fired upon end of cell editing.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.EndEditEvent
        """
        pass

    @property
    def SelectEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Event to be fired upon end cell celection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.SelectEvent
        """
        pass

    @SelectEvent.setter
    def SelectEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Event to be fired upon end cell celection.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGrid.SelectEvent
        """
        pass

class IGIS_PvlBase:
    """
    PVL Base control interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlBase
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlBase.Create_void
        """
        pass

class IGIS_PvlObject( IGIS_PvlBase ):
    """
    PVL Obbject interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlObject
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlObject.Create_void
        """
        pass

class IGIS_PvlControl( IGIS_PvlObject ):
    """
    PVL Control interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControl
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControl.Create_void
        """
        pass

    def DoRedraw(
      self
    ) -> None: 
        """
        Should be called by parent to enforce any specific Style updated or PPI change

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControl.DoRedraw_void
        """
        pass

    def ProcessMessages(
      self
    ) -> None: 
        """
        Interrupts the execution of an application so that it can process the message queue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControl.ProcessMessages_void
        """
        pass

    def SetFocus(
      self
    ) -> None: 
        """
        Put focus on the control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlControl.SetFocus_void
        """
        pass

class IGIS_PvlLabel( IGIS_PvlControl ):
    """
    PVL Label interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlLabel
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlLabel.Create_void
        """
        pass

class IGIS_PvlIconButton( IGIS_PvlControl ):
    """
    PVL Icon Button interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlIconButton
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlIconButton.Create_void
        """
        pass

class IGIS_PvlButton( IGIS_PvlControl ):
    """
    PVL Button interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlButton
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlButton.Create_void
        """
        pass

class IGIS_PvlModalButton( IGIS_PvlButton ):
    """
    PVL Modal Button interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlModalButton
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlModalButton.Create_void
        """
        pass

class IGIS_PvlEdit( IGIS_PvlControl ):
    """
    PVL Edit interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlEdit
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlEdit.Create_void
        """
        pass

    def SetAsHyperlink(
      self
    ) -> None: 
        """
        Set control style to hyperlink.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlEdit.SetAsHyperlink_void
        """
        pass

    def SetBackgroundAlarm(
      self
    ) -> None: 
        """
        Set background style when validation process fails.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlEdit.SetBackgroundAlarm_void
        """
        pass

    def SetBackgroundDefault(
      self
    ) -> None: 
        """
        Set default background style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlEdit.SetBackgroundDefault_void
        """
        pass

    def SetFontAlarm(
      self
    ) -> None: 
        """
        Set font style when validation process fails.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlEdit.SetFontAlarm_void
        """
        pass

    def SetFontDefault(
      self
    ) -> None: 
        """
        Set default font style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlEdit.SetFontDefault_void
        """
        pass

class IGIS_PvlMemo( IGIS_PvlControl ):
    """
    PVL Memo interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlMemo
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlMemo.Create_void
        """
        pass

    def AppendLine(
      self,
      _value: str
    ) -> None: 
        """
        Append text to the end of memo content as a new line.

        Args:
            _value: text to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlMemo.AppendLine_String
        """
        pass

    def AppendText(
      self,
      _value: str
    ) -> None: 
        """
        Append text to the end of memo content.

        Args:
            _value: text to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlMemo.AppendText_String
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear memo content.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlMemo.Clear_void
        """
        pass

    def SetFontAlarm(
      self
    ) -> None: 
        """
        Set font style when validation process fails.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlMemo.SetFontAlarm_void
        """
        pass

    def SetFontDefault(
      self
    ) -> None: 
        """
        Set default font style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlMemo.SetFontDefault_void
        """
        pass

class IGIS_PvlTrackBar( IGIS_PvlControl ):
    """
    PVL Trackbar interface

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlTrackBar
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlTrackBar.Create_void
        """
        pass

class IGIS_PvlListBox( IGIS_PvlControl ):
    """
    PVL List Box interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlListBox
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlListBox.Create_void
        """
        pass

    def BeginUpdate(
      self
    ) -> None: 
        """
        Begin updating list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlListBox.BeginUpdate_void
        """
        pass

    def EndUpdate(
      self
    ) -> None: 
        """
        End updating list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlListBox.EndUpdate_void
        """
        pass

    def ItemsAdd(
      self,
      _item: str
    ) -> None: 
        """
        Add item to the list.

        Args:
            _item: Item to be added to the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlListBox.ItemsAdd_String
        """
        pass

    def ItemsClear(
      self
    ) -> None: 
        """
        Clear all items from the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlListBox.ItemsClear_void
        """
        pass

class IGIS_PvlSVGList( IGIS_PvlListBox ):
    """
    PVL SVG List interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlSVGList
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlSVGList.Create_void
        """
        pass

class IGIS_PvlColorPreview( IGIS_PvlControl ):
    """
    PVL Color Preview interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorPreview
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorPreview.Create_void
        """
        pass

class IGIS_PvlColorWheel( IGIS_PvlControl ):
    """
    PVL Color Wheel interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorWheel
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorWheel.Create_void
        """
        pass

    def HueToRGB(
      self,
      _hue: float
    ) -> TGIS_PvlRGBVal: 
        """
        Converts Hue to RGB

        Args:
            _hue: Hue to be converted

        Returns:
            RGB value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorWheel.HueToRGB_Double
        """
        pass

class IGIS_PvlColorBar( IGIS_PvlControl ):
    """
    PVL Color Bar interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorBar
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorBar.Create_void
        """
        pass

class IGIS_PvlComboBox( IGIS_PvlControl ):
    """
    PVL ComboBox interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlComboBox
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlComboBox.Create_void
        """
        pass

    def BeginUpdate(
      self
    ) -> None: 
        """
        Begin updating list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlComboBox.BeginUpdate_void
        """
        pass

    def EndUpdate(
      self
    ) -> None: 
        """
        End updating list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlComboBox.EndUpdate_void
        """
        pass

    def IndexOf(
      self,
      _item: str
    ) -> int: 
        """
        Gets index of given item.

        Args:
            _item: Given item

        Returns:
            Index on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlComboBox.IndexOf_String
        """
        pass

    def ItemsAdd(
      self,
      _item: str
    ) -> None: 
        """
        Add item to the list.

        Args:
            _item: Item to be added to the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlComboBox.ItemsAdd_String
        """
        pass

    def ItemsClear(
      self
    ) -> None: 
        """
        Clear all items from the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlComboBox.ItemsClear_void
        """
        pass

class IGIS_PvlComboEdit( IGIS_PvlComboBox ):
    """
    PVL ComboEdit interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlComboEdit
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlComboEdit.Create_void
        """
        pass

    def SetBackgroundAlarm(
      self
    ) -> None: 
        """
        Set background style when validation process fails.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlComboEdit.SetBackgroundAlarm_void
        """
        pass

    def SetBackgroundDefault(
      self
    ) -> None: 
        """
        Set default background style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlComboEdit.SetBackgroundDefault_void
        """
        pass

    def SetFontAlarm(
      self
    ) -> None: 
        """
        Set font style when validation process fails.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlComboEdit.SetFontAlarm_void
        """
        pass

    def SetFontDefault(
      self
    ) -> None: 
        """
        Set default font style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlComboEdit.SetFontDefault_void
        """
        pass

class IGIS_PvlSearchBox( IGIS_PvlControl ):
    """
    PVL ComboBox interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlSearchBox
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlSearchBox.Create_void
        """
        pass

    def IndexOf(
      self,
      _item: str
    ) -> int: 
        """
        Gets index of given item.

        Args:
            _item: Given item

        Returns:
            Index on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlSearchBox.IndexOf_String
        """
        pass

    def ItemsAdd(
      self,
      _item: str
    ) -> None: 
        """
        Add item to the list.

        Args:
            _item: Item to be added to the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlSearchBox.ItemsAdd_String
        """
        pass

    def ItemsClear(
      self
    ) -> None: 
        """
        Clear all items from the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlSearchBox.ItemsClear_void
        """
        pass

    def SetBackgroundAlarm(
      self
    ) -> None: 
        """
        Set background style when validation process fails.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlSearchBox.SetBackgroundAlarm_void
        """
        pass

    def SetBackgroundDefault(
      self
    ) -> None: 
        """
        Set default background style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlSearchBox.SetBackgroundDefault_void
        """
        pass

    def SetFontAlarm(
      self
    ) -> None: 
        """
        Set font style when validation process fails.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlSearchBox.SetFontAlarm_void
        """
        pass

    def SetFontDefault(
      self
    ) -> None: 
        """
        Set default font style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlSearchBox.SetFontDefault_void
        """
        pass

class IGIS_PvlCustomComboBox( IGIS_PvlControl ):
    """
    PVL Custom ComboBox interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlCustomComboBox
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlCustomComboBox.Create_void
        """
        pass

class IGIS_PvlSizeComboBox( IGIS_PvlCustomComboBox ):
    """
    PVL Size ComboBox interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlSizeComboBox
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlSizeComboBox.Create_void
        """
        pass

    def Fill(
      self,
      _forSymbol: bool,
      _forLine: bool,
      _field: bool,
      _renderer: bool
    ) -> None: 
        """
        Fill the list.

        Args:
            _forSymbol: if units for symbol size
            _forLine: if units for symbol size
            _field: if values from fields
            _renderer: if renderer value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlSizeComboBox.Fill_Boolean_Boolean_Boolean_Boolean
        """
        pass

    def FillAggregation(
      self
    ) -> None: 
        """
        Fill the list with aggregation sizes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlSizeComboBox.FillAggregation_void
        """
        pass

    def FillRealWorldUnits(
      self,
      _field: bool
    ) -> None: 
        """
        Fill the list with measure units.

        Args:
            _field: if values from fields

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlSizeComboBox.FillRealWorldUnits_Boolean
        """
        pass

class IGIS_PvlColorComboBox( IGIS_PvlCustomComboBox ):
    """
    PVL Color ComboBox interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorComboBox
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorComboBox.Create_void
        """
        pass

    @overload
    def Fill(
      self,
      _field: bool,
      _renderer: bool
    ) -> None: 
        """
        Populates the ComboBox with items.

        Args:
            _field: If values from fields
            _renderer: If renderer value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorComboBox.Fill_Boolean_Boolean
        """
        pass

    @overload
    def Fill(
      self,
      _field: bool,
      _renderer: bool,
      _values: TGIS_StringList
    ) -> None: 
        """
        Populates the ComboBox with items from the list. Place method has to be used first.

        Args:
            _field: If values from fields
            _renderer: If renderer value
            _values: List of colors to fill combobox ( eg. ''FFFFFFFF'' ).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorComboBox.Fill_Boolean_Boolean_TStringList
        """
        pass

class IGIS_PvlCustomBitmapComboBox( IGIS_PvlCustomComboBox ):
    """
    PVL Custom Bitmap ComboBox interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlCustomBitmapComboBox
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlCustomBitmapComboBox.Create_void
        """
        pass

    def FillMarker(
      self,
      _hasSymbol: bool
    ) -> None: 
        """
        Populates the marker ComboBox with items.

        Args:
            _hasSymbol: If symbols component can be invoked

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlCustomBitmapComboBox.FillMarker_Boolean
        """
        pass

    def FillPattern(
      self,
      _hasSymbol: bool
    ) -> None: 
        """
        Populates the pattern fill ComboBox with items.

        Args:
            _hasSymbol: If symbols component can be invoked

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlCustomBitmapComboBox.FillPattern_Boolean
        """
        pass

    def FillShield(
      self
    ) -> None: 
        """
        Populates the shield ComboBox with items.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlCustomBitmapComboBox.FillShield_void
        """
        pass

    def FillStyle(
      self,
      _hasSymbol: bool
    ) -> None: 
        """
        Populates the outline style ComboBox with items.

        Args:
            _hasSymbol: If symbols component can be invoked

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlCustomBitmapComboBox.FillStyle_Boolean
        """
        pass

class IGIS_PvlColorRampComboBox( IGIS_PvlControl ):
    """
    PVL Color Ramp ComboBox interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorRampComboBox
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorRampComboBox.Create_void
        """
        pass

    def Fill(
      self
    ) -> None: 
        """
        Fill the control with data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorRampComboBox.Fill_void
        """
        pass

    def Lock(
      self
    ) -> None: 
        """
        Locks control from filling its values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorRampComboBox.Lock_void
        """
        pass

    def Unlock(
      self
    ) -> None: 
        """
        Unlocks control from filling its values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorRampComboBox.Unlock_void
        """
        pass

    def Value(
      self,
      _subClass: int
    ) -> TGIS_ColorMapArray: 
        """
        Color map value.

        Args:
            _subClass: get subclass of a ramp with specified number of colors, if available; 
              if 0, get default colormap; if -1, get subclass with maximum number of colors;

        Returns:
            Array of colormap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlColorRampComboBox.Value_Integer
        """
        pass

class IGIS_PvlCheckBox( IGIS_PvlControl ):
    """
    PVL CheckBox interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlCheckBox
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlCheckBox.Create_void
        """
        pass

class IGIS_PvlRadioButton( IGIS_PvlCheckBox ):
    """
    PVL Radio Button interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlRadioButton
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlRadioButton.Create_void
        """
        pass

    def UncheckGroup(
      self,
      _button: TGIS_PvlRadioButton
    ) -> None: 
        """
        Un cjchek all memmebers of the same group as provideded button.

        Args:
            _button: reference radio button

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlRadioButton.UncheckGroup_TGIS_PvlRadioButton
        """
        pass

class IGIS_PvlPanel( IGIS_PvlControl ):
    """
    PVL Panel intraface

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlPanel
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlPanel.Create_void
        """
        pass

    def RemoveAllComponents(
      self
    ) -> None: 
        """
        Remove all components from the panel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlPanel.RemoveAllComponents_void
        """
        pass

class IGIS_PvlCanvas( IGIS_PvlControl ):
    """
    PVL Canvas interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlCanvas
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlCanvas.Create_void
        """
        pass

class IGIS_PvlPreviewPanel( IGIS_PvlControl ):
    """
    PVL Preview Panel interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlPreviewPanel
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlPreviewPanel.Create_void
        """
        pass

    def Invalidate(
      self
    ) -> None: 
        """
        Invalidate preview panel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlPreviewPanel.Invalidate_void
        """
        pass

class IGIS_PvlTree( IGIS_PvlControl ):
    """
    PVL Tree interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlTree
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlTree.Create_void
        """
        pass

    def CreateRoot(
      self
    ) -> None: 
        """
        Create a root even. Only for internal use/

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlTree.CreateRoot_void
        """
        pass

class IGIS_PvlTreeNode:
    """
    PVL Tree Node interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlTreeNode
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlTreeNode.Create_void
        """
        pass

    def doCreateNode(
      self,
      _node: TGIS_PvlTreeNode,
      _caption: str,
      _index: int
    ) -> None: 
        """
        Additional creation procedure

        Args:
            _node: \ Created node
            _caption: Caption of created node
            _index: Index on which it should be placed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlTreeNode.doCreateNode_TGIS_PvlTreeNode_String_Integer
        """
        pass

    def doDeleteNode(
      self,
      _node: TGIS_PvlTreeNode
    ) -> None: 
        """
        Additional deletation procedure

        Args:
            _node: Node to be removed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlTreeNode.doDeleteNode_TGIS_PvlTreeNode
        """
        pass

    def doMoveNode(
      self,
      _node: TGIS_PvlTreeNode,
      _newParent: TGIS_PvlTreeNode,
      _index: int
    ) -> None: 
        """
        Additional move procedure

        Args:
            _node: Node to be moved
            _newParent: New parent node
            _index: Index on which it should be placed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlTreeNode.doMoveNode_TGIS_PvlTreeNode_TGIS_PvlTreeNode_Integer
        """
        pass

    def doRemoveNode(
      self,
      _node: TGIS_PvlTreeNode
    ) -> None: 
        """
        Additional removal procedure

        Args:
            _node: Node to be removed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlTreeNode.doRemoveNode_TGIS_PvlTreeNode
        """
        pass

class IGIS_PvlGroupBox( IGIS_PvlControl ):
    """
    PVL Group Box interface.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlGroupBox
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlGroupBox.Create_void
        """
        pass

class IGIS_PvlContext:
    """
    class of TGIS_PvlContextBase.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlContext
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlContext.Create_void
        """
        pass

    def ClientWidth(
      self
    ) -> int: 
        """
        Gets the width of the client area.

        Returns:
            Width of the client area

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlContext.ClientWidth_void
        """
        pass

    def CreateObject(
      self,
      _parent: TGIS_PvlBase,
      _name: str
    ) -> IGIS_PvlBase: 
        """
        Create PVL Object.

        Args:
            _parent: Parent object.
            _name: Name of the class object.

        Returns:
            Created object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlContext.CreateObject_TGIS_PvlBase_String
        """
        pass

    def FreeContext(
      self
    ) -> None: 
        """
        A safe way to free context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlContext.FreeContext_void
        """
        pass

    def GetAllFonts(
      self
    ) -> TGIS_StringList: 
        """
        Function to get all available and supported fonts for the platform.

        Returns:
            List of fonts names

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlContext.GetAllFonts_void
        """
        pass

class TGIS_PvlMouseButton:
    pass

class TGIS_PvlMouseButton:
    """
    Mouse button.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMouseButton
    """

    @property
    def Left(
      self
    ) -> TGIS_PvlMouseButton: 
        """
        Left mouse button.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMouseButton.Left
        """
        pass

    @property
    def Right(
      self
    ) -> TGIS_PvlMouseButton: 
        """
        Right mouse button.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMouseButton.Right
        """
        pass

    @property
    def Middle(
      self
    ) -> TGIS_PvlMouseButton: 
        """
        Middle mouse button.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMouseButton.Middle
        """
        pass

class TGIS_PvlShiftStateItem:
    pass

class TGIS_PvlShiftStateItem:
    """
    Indicates the state of the modifier keys, the mouse buttons, or the touch devices.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlShiftStateItem
    """

    @property
    def Shift(
      self
    ) -> TGIS_PvlShiftStateItem: 
        """
        The SHIFT key is held down.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlShiftStateItem.Shift
        """
        pass

    @property
    def Alt(
      self
    ) -> TGIS_PvlShiftStateItem: 
        """
        The ALT key is held down.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlShiftStateItem.Alt
        """
        pass

    @property
    def Ctrl(
      self
    ) -> TGIS_PvlShiftStateItem: 
        """
        The CTRL key is held down.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlShiftStateItem.Ctrl
        """
        pass

    @property
    def Left(
      self
    ) -> TGIS_PvlShiftStateItem: 
        """
        The left mouse button is held down.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlShiftStateItem.Left
        """
        pass

    @property
    def Right(
      self
    ) -> TGIS_PvlShiftStateItem: 
        """
        The right mouse button is held down.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlShiftStateItem.Right
        """
        pass

    @property
    def Middle(
      self
    ) -> TGIS_PvlShiftStateItem: 
        """
        The wheel mouse button is held down.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlShiftStateItem.Middle
        """
        pass

    @property
    def Double(
      self
    ) -> TGIS_PvlShiftStateItem: 
        """
        The mouse button was double-clicked.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlShiftStateItem.Double
        """
        pass

    @property
    def Touch(
      self
    ) -> TGIS_PvlShiftStateItem: 
        """
        The user is holding a finger on the touch surface.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlShiftStateItem.Touch
        """
        pass

    @property
    def Pen(
      self
    ) -> TGIS_PvlShiftStateItem: 
        """
        The pen is touching the surface of a tablet.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlShiftStateItem.Pen
        """
        pass

    @property
    def Command(
      self
    ) -> TGIS_PvlShiftStateItem: 
        """
        The CMD key is held down (only on Mac).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlShiftStateItem.Command
        """
        pass

    @property
    def Horizontal(
      self
    ) -> TGIS_PvlShiftStateItem: 
        """
        The user is moving a finger horizontally on the touch surface or is rolling the mouse 
        wheel to produce a horizontal displacement.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlShiftStateItem.Horizontal
        """
        pass

class TGIS_PvlAnchor:
    pass

class TGIS_PvlAnchor:
    """
    Layout anchors.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlAnchor
    """

    @property
    def Top(
      self
    ) -> TGIS_PvlAnchor: 
        """
        Top anchor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlAnchor.Top
        """
        pass

    @property
    def Left(
      self
    ) -> TGIS_PvlAnchor: 
        """
        Left anchor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlAnchor.Left
        """
        pass

    @property
    def Bottom(
      self
    ) -> TGIS_PvlAnchor: 
        """
        Bottom anchor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlAnchor.Bottom
        """
        pass

    @property
    def Right(
      self
    ) -> TGIS_PvlAnchor: 
        """
        Right anchor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlAnchor.Right
        """
        pass

class TGIS_PvlResourceExtension:
    pass

class TGIS_PvlResourceExtension:
    """
    Extension of the resource file.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlResourceExtension
    """

    @property
    def PNG(
      self
    ) -> TGIS_PvlResourceExtension: 
        """
        PNG file type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlResourceExtension.PNG
        """
        pass

    @property
    def JPG(
      self
    ) -> TGIS_PvlResourceExtension: 
        """
        JPG file type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlResourceExtension.JPG
        """
        pass

    @property
    def BMP(
      self
    ) -> TGIS_PvlResourceExtension: 
        """
        BMP file type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlResourceExtension.BMP
        """
        pass

    @property
    def CGM(
      self
    ) -> TGIS_PvlResourceExtension: 
        """
        CGM file type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlResourceExtension.CGM
        """
        pass

    @property
    def SVG(
      self
    ) -> TGIS_PvlResourceExtension: 
        """
        SVG file type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlResourceExtension.SVG
        """
        pass

class TGIS_PvlAlign:
    pass

class TGIS_PvlAlign:
    """
    Layout align.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlAlign
    """

    @property
    def None_(
      self
    ) -> TGIS_PvlAlign: 
        """
        None align.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlAlign.None
        """
        pass

    @property
    def Client(
      self
    ) -> TGIS_PvlAlign: 
        """
        Client align.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlAlign.Client
        """
        pass

    @property
    def Top(
      self
    ) -> TGIS_PvlAlign: 
        """
        Top align.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlAlign.Top
        """
        pass

    @property
    def Left(
      self
    ) -> TGIS_PvlAlign: 
        """
        Left align.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlAlign.Left
        """
        pass

    @property
    def Bottom(
      self
    ) -> TGIS_PvlAlign: 
        """
        Bottom align.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlAlign.Bottom
        """
        pass

    @property
    def Right(
      self
    ) -> TGIS_PvlAlign: 
        """
        Right align.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlAlign.Right
        """
        pass

class TGIS_PvlModalResult:
    pass

class TGIS_PvlModalResult:
    """
    Result type of TGIS_PvlInternalFormAbstract.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalResult
    """

    @property
    def None_(
      self
    ) -> TGIS_PvlModalResult: 
        """
        None result of the ModalForm.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalResult.None
        """
        pass

    @property
    def OK(
      self
    ) -> TGIS_PvlModalResult: 
        """
        OK result of the ModalForm.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalResult.OK
        """
        pass

    @property
    def Cancel(
      self
    ) -> TGIS_PvlModalResult: 
        """
        Cancel result of the ModalForm.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalResult.Cancel
        """
        pass

    @property
    def Abort(
      self
    ) -> TGIS_PvlModalResult: 
        """
        Abort result of the ModalForm.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalResult.Abort
        """
        pass

    @property
    def No(
      self
    ) -> TGIS_PvlModalResult: 
        """
        No result of the ModalForm.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalResult.No
        """
        pass

    @property
    def Yes(
      self
    ) -> TGIS_PvlModalResult: 
        """
        Yes result of the ModalForm.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalResult.Yes
        """
        pass

class TGIS_PvlComboBoxHelperPosition:
    pass

class TGIS_PvlComboBoxHelperPosition:
    """
    Item placement within Combo Box

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBoxHelperPosition
    """

    @property
    def Top(
      self
    ) -> TGIS_PvlComboBoxHelperPosition: 
        """
        item to be placed at the top (for standard predefined values)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBoxHelperPosition.Top
        """
        pass

    @property
    def Lru(
      self
    ) -> TGIS_PvlComboBoxHelperPosition: 
        """
        item should be placed within LRU zone (below standard top items)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBoxHelperPosition.Lru
        """
        pass

    @property
    def Custom(
      self
    ) -> TGIS_PvlComboBoxHelperPosition: 
        """
        item (only one at a time) to be place above bottom items)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBoxHelperPosition.Custom
        """
        pass

    @property
    def Bottom(
      self
    ) -> TGIS_PvlComboBoxHelperPosition: 
        """
        item should be placed at the bottom

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBoxHelperPosition.Bottom
        """
        pass

class TGIS_PvlCustomBitmapType:
    pass

class TGIS_PvlCustomBitmapType:
    """
    Type of the custom bitmap combobox.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomBitmapType
    """

    @property
    def Fill(
      self
    ) -> TGIS_PvlCustomBitmapType: 
        """
        Fill style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomBitmapType.Fill
        """
        pass

    @property
    def Marker(
      self
    ) -> TGIS_PvlCustomBitmapType: 
        """
        Marker style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomBitmapType.Marker
        """
        pass

    @property
    def Outline(
      self
    ) -> TGIS_PvlCustomBitmapType: 
        """
        Outline style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomBitmapType.Outline
        """
        pass

    @property
    def Shield(
      self
    ) -> TGIS_PvlCustomBitmapType: 
        """
        Shield style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomBitmapType.Shield
        """
        pass

class TGIS_PvlItemListType:
    pass

class TGIS_PvlItemListType:
    """
    Type of items on the TGIS_PvlItemList.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlItemListType
    """

    @property
    def Text(
      self
    ) -> TGIS_PvlItemListType: 
        """
        Text type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlItemListType.Text
        """
        pass

    @property
    def SVG(
      self
    ) -> TGIS_PvlItemListType: 
        """
        SVG type.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlItemListType.SVG
        """
        pass

class TGIS_PvlLabelTextAlignment:
    pass

class TGIS_PvlLabelTextAlignment:
    """
    Alignment of the text in the label.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabelTextAlignment
    """

    @property
    def Left(
      self
    ) -> TGIS_PvlLabelTextAlignment: 
        """
        Left alignment.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabelTextAlignment.Left
        """
        pass

    @property
    def Center(
      self
    ) -> TGIS_PvlLabelTextAlignment: 
        """
        Center alignment.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabelTextAlignment.Center
        """
        pass

    @property
    def Right(
      self
    ) -> TGIS_PvlLabelTextAlignment: 
        """
        Right alignment.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabelTextAlignment.Right
        """
        pass

class TGIS_PvlListOfElements:
    """
    List of PVL elements;

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListOfElements
    """

    def __len__(
      self
    ) -> int:
        pass

    def __getitem__(
      self,
      index : int
    ) -> TGIS_PvlBase:
        pass

    def __setitem__(
      self,
      index : int,
      value : TGIS_PvlBase
    ) -> None:
        pass

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListOfElements.Create_void
        """
        pass

    def Add(
      self,
      _item: TGIS_PvlBase
    ) -> None: 
        """
        Add a new element to the list.

        Args:
            _item: element to be added.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListOfElements.Add_TGIS_PvlBase
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListOfElements.Clear_void
        """
        pass

    def Delete(
      self,
      _index: int
    ) -> None: 
        """
        Delete and item for the list.

        Args:
            _index: index of the item to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListOfElements.Delete_Integer
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of elements on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListOfElements.Count
        """
        pass

    
    def Item(
      self,
      _index: int
    ) -> TGIS_PvlBase: 
        """
        Get item form the list.

        Args:
            _index: index of the item to be retrieved.

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListOfElements.Item
        """
        pass

class TGIS_PvlComboBoxHelperGetBitmapEventArgs:
    """
    Event argument for TGIS_ComboBoxHelperGetBitmapEvent.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBoxHelperGetBitmapEventArgs
    """

    @overload
    def __init__(
      self,
      _value: str,
      _forecolor: TGIS_Color,
      _font: TGIS_Font,
      _width: int,
      _height: int
    ) -> None: 
        """
        Create an instance.

        Args:
            _value: event identifier
            _forecolor: foreground color
            _font: font to be used
            _width: set bitmap width
            _height: set bitmap height

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBoxHelperGetBitmapEventArgs.Create_String_TGIS_Color_TGIS_Font_Integer_Integer
        """
        pass

    @property
    def Font(
      self
    ) -> TGIS_Font: 
        """
        same as JComboBox.DrawItem

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBoxHelperGetBitmapEventArgs.Font
        """
        pass

    @property
    def ForeColor(
      self
    ) -> TGIS_Color: 
        """
        same as JComboBox.DrawItem

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBoxHelperGetBitmapEventArgs.ForeColor
        """
        pass

    @property
    def Height(
      self
    ) -> int: 
        """
        bitmap height

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBoxHelperGetBitmapEventArgs.Height
        """
        pass

    @property
    def Value(
      self
    ) -> str: 
        """
        custom event identifier

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBoxHelperGetBitmapEventArgs.Value
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        bitmap width

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBoxHelperGetBitmapEventArgs.Width
        """
        pass

class TGIS_PvlBase( TObject, IGIS_PvlBase ):
    """
    Base PVL class.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBase
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBase.Create_void
        """
        pass

    @property
    def NativeControl(
      self
    ) -> TObject: 
        """
        Native control, need to be cast to platform control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBase.NativeControl
        """
        pass

class TGIS_PvlSystemForm( TGIS_PvlBase ):
    """
    Base PVL class for system forms.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSystemForm
    """

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSystemForm.Create_TGIS_PvlContext
        """
        pass

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlSystemForm
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form
            _self: Reference to the TGIS_PvlSystemForm

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSystemForm.Create_TGIS_PvlContext_TGIS_PvlSystemForm
        """
        pass

    @property
    def oForm(
      self
    ) -> TObject: 
        """
        Underlying platform specific form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSystemForm.oForm
        """
        pass

    @oForm.setter
    def oForm(
      self,
      _value: TObject
    ) -> None: 
        """
        Underlying platform specific form.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSystemForm.oForm
        """
        pass

class TGIS_PvlObject( TGIS_PvlBase, IGIS_PvlObject ):
    """
    Basic PVL Object.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlObject
    """

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Create a PVL object.

        Args:
            _context: Context

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlObject.Create_TGIS_PvlContext
        """
        pass

    @property
    def Platform(
      self
    ) -> IGIS_PvlBase: 
        """
        Underlying platform specific control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlObject.Platform
        """
        pass

    @Platform.setter
    def Platform(
      self,
      _value: IGIS_PvlBase
    ) -> None: 
        """
        Underlying platform specific control.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlObject.Platform
        """
        pass

class TGIS_PvlControl( TGIS_PvlObject, IGIS_PvlControl ):
    """
    Basic PVL control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl
    """

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Create a PVL control.

        Args:
            _context: Context

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Create_TGIS_PvlContext
        """
        pass

    def DoRedraw(
      self
    ) -> None: 
        """
        Should be called by parent to enforce any specific Style updated or PPI change

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.DoRedraw_void
        """
        pass

    def Place(
      self,
      _width: int,
      _height: int,
      _xsibling: TGIS_PvlControl,
      _xdistance: int,
      _ysibling: TGIS_PvlControl,
      _ydistance: int
    ) -> None: 
        """
        Place control on the PVL form.

        Args:
            _width: Width of the control
            _height: Height of the control
            _xsibling: Horizontal sibling you want to relate in placement process
            _xdistance: Distance in x axis related to 0 point or sibling if defined
            _ysibling: Vertical sibling you want to relate in placement process
            _ydistance: Distance in y axis related to 0 point or sibling if defined. If set to 
              -1 then put control on the same y axis with sibling. If set to 0 then put control 
              below sibling.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Place_Integer_Integer_TGIS_PvlControl_Integer_TGIS_PvlControl_Integer
        """
        pass

    def ProcessMessages(
      self
    ) -> None: 
        """
        Interrupts the execution of an application so that it can process the message queue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.ProcessMessages_void
        """
        pass

    def SetFocus(
      self
    ) -> None: 
        """
        Put focus on the control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.SetFocus_void
        """
        pass

    @property
    def Align(
      self
    ) -> TGIS_PvlAlign: 
        """
        Align of the control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Align
        """
        pass

    @Align.setter
    def Align(
      self,
      _value: TGIS_PvlAlign
    ) -> None: 
        """
        Align of the control.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Align
        """
        pass

    @property
    def Anchors(
      self
    ) -> typing.Sequence[TGIS_PvlAnchor]: 
        """
        Anchors of the control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Anchors
        """
        pass

    @Anchors.setter
    def Anchors(
      self,
      _value: typing.Sequence[TGIS_PvlAnchor]
    ) -> None: 
        """
        Anchors of the control.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Anchors
        """
        pass

    @property
    def Context(
      self
    ) -> TGIS_PvlContext: 
        """
        Context of the control, platform related.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Context
        """
        pass

    @Context.setter
    def Context(
      self,
      _value: TGIS_PvlContext
    ) -> None: 
        """
        Context of the control, platform related.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Context
        """
        pass

    @property
    def Enabled(
      self
    ) -> bool: 
        """
        If control is enabled.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Enabled
        """
        pass

    @Enabled.setter
    def Enabled(
      self,
      _value: bool
    ) -> None: 
        """
        If control is enabled.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Enabled
        """
        pass

    @property
    def Height(
      self
    ) -> int: 
        """
        Height of the control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Height
        """
        pass

    @Height.setter
    def Height(
      self,
      _value: int
    ) -> None: 
        """
        Height of the control.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Height
        """
        pass

    @property
    def Hint(
      self
    ) -> str: 
        """
        Hint for the control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Hint
        """
        pass

    @Hint.setter
    def Hint(
      self,
      _value: str
    ) -> None: 
        """
        Hint for the control.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Hint
        """
        pass

    @property
    def IsStyled(
      self
    ) -> bool: 
        """
        Does component use styles for colors?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.IsStyled
        """
        pass

    @property
    def Left(
      self
    ) -> int: 
        """
        Position of left margin.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Left
        """
        pass

    @Left.setter
    def Left(
      self,
      _value: int
    ) -> None: 
        """
        Position of left margin.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Left
        """
        pass

    @property
    def TabOrder(
      self
    ) -> int: 
        """
        Order of control when pressing Tab key.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.TabOrder
        """
        pass

    @TabOrder.setter
    def TabOrder(
      self,
      _value: int
    ) -> None: 
        """
        Order of control when pressing Tab key.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.TabOrder
        """
        pass

    @property
    def Top(
      self
    ) -> int: 
        """
        Top of left margin.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Top
        """
        pass

    @Top.setter
    def Top(
      self,
      _value: int
    ) -> None: 
        """
        Top of left margin.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Top
        """
        pass

    @property
    def Visible(
      self
    ) -> bool: 
        """
        Visibility of the control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Visible
        """
        pass

    @Visible.setter
    def Visible(
      self,
      _value: bool
    ) -> None: 
        """
        Visibility of the control.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Visible
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        Width of the control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Width
        """
        pass

    @Width.setter
    def Width(
      self,
      _value: int
    ) -> None: 
        """
        Width of the control.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.Width
        """
        pass

    @property
    def OnClick(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Occurs when the control is clicked.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.OnClick
        """
        pass

    @OnClick.setter
    def OnClick(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Occurs when the control is clicked.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.OnClick
        """
        pass

    @property
    def OnDblClick(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Occurs when the left mouse button is double-clicked with the pointer over the control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.OnDblClick
        """
        pass

    @OnDblClick.setter
    def OnDblClick(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Occurs when the left mouse button is double-clicked with the pointer over the control.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.OnDblClick
        """
        pass

    @property
    def OnMouseDown(
      self
    ) -> typing.Callable[[TObject, TGIS_PvlMouseButton, TGIS_PvlShiftState, Single, Single], None]: 
        """
        Occurs when the user presses a mouse button with the mouse pointer over a control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.OnMouseDown
        """
        pass

    @OnMouseDown.setter
    def OnMouseDown(
      self,
      _value: typing.Callable[[TObject, TGIS_PvlMouseButton, TGIS_PvlShiftState, Single, Single], None]
    ) -> None: 
        """
        Occurs when the user presses a mouse button with the mouse pointer over a control.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.OnMouseDown
        """
        pass

    @property
    def OnMouseEnter(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Occurs when the mouse cursor enters the area of the control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.OnMouseEnter
        """
        pass

    @OnMouseEnter.setter
    def OnMouseEnter(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Occurs when the mouse cursor enters the area of the control.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.OnMouseEnter
        """
        pass

    @property
    def OnMouseLeave(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Occurs when the mouse cursor leaves the control area.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.OnMouseLeave
        """
        pass

    @OnMouseLeave.setter
    def OnMouseLeave(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Occurs when the mouse cursor leaves the control area.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.OnMouseLeave
        """
        pass

    @property
    def OnMouseMove(
      self
    ) -> typing.Callable[[TObject, TGIS_PvlShiftState, Single, Single], None]: 
        """
        Occurs when the user moves the mouse pointer while the mouse pointer is over a control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.OnMouseMove
        """
        pass

    @OnMouseMove.setter
    def OnMouseMove(
      self,
      _value: typing.Callable[[TObject, TGIS_PvlShiftState, Single, Single], None]
    ) -> None: 
        """
        Occurs when the user moves the mouse pointer while the mouse pointer is over a control.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.OnMouseMove
        """
        pass

    @property
    def OnMouseUp(
      self
    ) -> typing.Callable[[TObject, TGIS_PvlMouseButton, TGIS_PvlShiftState, Single, Single], None]: 
        """
        Occurs when the user releases a mouse button that was pressed with the mouse pointer 
        over a component.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.OnMouseUp
        """
        pass

    @OnMouseUp.setter
    def OnMouseUp(
      self,
      _value: typing.Callable[[TObject, TGIS_PvlMouseButton, TGIS_PvlShiftState, Single, Single], None]
    ) -> None: 
        """
        Occurs when the user releases a mouse button that was pressed with the mouse pointer 
        over a component.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.OnMouseUp
        """
        pass

    @property
    def OnMouseWheel(
      self
    ) -> typing.Callable[[TObject, TGIS_PvlShiftState, Integer, Boolean], None]: 
        """
        Occurs when the mouse wheel moves while the control has focus.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.OnMouseWheel
        """
        pass

    @OnMouseWheel.setter
    def OnMouseWheel(
      self,
      _value: typing.Callable[[TObject, TGIS_PvlShiftState, Integer, Boolean], None]
    ) -> None: 
        """
        Occurs when the mouse wheel moves while the control has focus.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControl.OnMouseWheel
        """
        pass

class TGIS_PvlIconsList( TGIS_PvlControl ):
    """
    PVL symbol list to provide glyphs based on images abd SVG.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlIconsList
    """

    def Add(
      self,
      _path: str
    ) -> int: 
        """
        Add file to the list of icons.

        Args:
            _path: path to file

        Returns:
            Position on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlIconsList.Add_String
        """
        pass

    def AddFromResource(
      self,
      _name: str,
      _extension: TGIS_PvlResourceExtension
    ) -> int: 
        """
        Add file to the list of icons.

        Args:
            _name: name of the file in resources
            _extension: extension of the file in resources

        Returns:
            Position on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlIconsList.AddFromResource_String_TGIS_PvlResourceExtension
        """
        pass

    
    def Icon(
      self,
      _index: int
    ) -> TGIS_SymbolAbstract: 
        """
        Access icon symbol object.

        Args:
            _index: position of the icon; if outside the scope then nil returned

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlIconsList.Icon
        """
        pass

class TGIS_PvlPanel( TGIS_PvlControl, IGIS_PvlPanel ):
    """
    PVL panel control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPanel
    """

    def RemoveAllComponents(
      self
    ) -> None: 
        """
        Remove all components from the panel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPanel.RemoveAllComponents_void
        """
        pass

    @property
    def Border(
      self
    ) -> bool: 
        """
        If true then show border.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPanel.Border
        """
        pass

    @Border.setter
    def Border(
      self,
      _value: bool
    ) -> None: 
        """
        If true then show border.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPanel.Border
        """
        pass

    @property
    def Scrollable(
      self
    ) -> bool: 
        """
        If panel is scrollable.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPanel.Scrollable
        """
        pass

    @Scrollable.setter
    def Scrollable(
      self,
      _value: bool
    ) -> None: 
        """
        If panel is scrollable.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPanel.Scrollable
        """
        pass

class TGIS_PvlPage:
    """
    PVL Page

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage
    """

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Constructor for the pages instance

        Args:
            _context: Context in which it should be created

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Create_TGIS_PvlContext
        """
        pass

    def Activate(
      self,
      _sender: TObject
    ) -> None: 
        """
        Activate page

        Args:
            _sender: Object that called the action

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Activate_TObject
        """
        pass

    def Deactivate(
      self,
      _sender: TObject
    ) -> None: 
        """
        Deactivate page

        Args:
            _sender: Object that called the action

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Deactivate_TObject
        """
        pass

    @property
    def Context(
      self
    ) -> TGIS_PvlContext: 
        """
        Context of the page

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Context
        """
        pass

    @property
    def Height(
      self
    ) -> int: 
        """
        Height of the page

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Height
        """
        pass

    @Height.setter
    def Height(
      self,
      _value: int
    ) -> None: 
        """
        Height of the page

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Height
        """
        pass

    @property
    def Left(
      self
    ) -> int: 
        """
        Left of the page

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Left
        """
        pass

    @Left.setter
    def Left(
      self,
      _value: int
    ) -> None: 
        """
        Left of the page

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Left
        """
        pass

    @property
    def Next(
      self
    ) -> TGIS_PvlPage: 
        """
        Next page object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Next
        """
        pass

    @Next.setter
    def Next(
      self,
      _value: TGIS_PvlPage
    ) -> None: 
        """
        Next page object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Next
        """
        pass

    @property
    def Page(
      self
    ) -> TGIS_PvlPanel: 
        """
        Underlying page accessor

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Page
        """
        pass

    @Page.setter
    def Page(
      self,
      _value: TGIS_PvlPanel
    ) -> None: 
        """
        Underlying page accessor

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Page
        """
        pass

    @property
    def PageNumber(
      self
    ) -> int: 
        """
        Number of a page

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.PageNumber
        """
        pass

    @PageNumber.setter
    def PageNumber(
      self,
      _value: int
    ) -> None: 
        """
        Number of a page

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.PageNumber
        """
        pass

    @property
    def Previous(
      self
    ) -> TGIS_PvlPage: 
        """
        Previous page object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Previous
        """
        pass

    @Previous.setter
    def Previous(
      self,
      _value: TGIS_PvlPage
    ) -> None: 
        """
        Previous page object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Previous
        """
        pass

    @property
    def Top(
      self
    ) -> int: 
        """
        Top of the page

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Top
        """
        pass

    @Top.setter
    def Top(
      self,
      _value: int
    ) -> None: 
        """
        Top of the page

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Top
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        Width of the page

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Width
        """
        pass

    @Width.setter
    def Width(
      self,
      _value: int
    ) -> None: 
        """
        Width of the page

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.Width
        """
        pass

    @property
    def BeforeExit(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnExit event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.BeforeExit
        """
        pass

    @BeforeExit.setter
    def BeforeExit(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnExit event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.BeforeExit
        """
        pass

    @property
    def OnEnter(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnEnter event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.OnEnter
        """
        pass

    @OnEnter.setter
    def OnEnter(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnEnter event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.OnEnter
        """
        pass

    @property
    def OnExit(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnExit event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.OnExit
        """
        pass

    @OnExit.setter
    def OnExit(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnExit event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPage.OnExit
        """
        pass

class TGIS_PvlPages( TGIS_PvlControl ):
    """
    PVL pages

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPages
    """

    def Abort(
      self
    ) -> None: 
        """
        Abort changing pages. Has to be uses in pair with BeforeExit event.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPages.Abort_void
        """
        pass

    def Activate(
      self,
      _pageNr: int,
      _sender: TObject
    ) -> None: 
        """
        Activate page with specific number

        Args:
            _pageNr: Index / Number of the page to be activated
            _sender: Object that called activation

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPages.Activate_Integer_TObject
        """
        pass

    def AddPage(
      self
    ) -> TGIS_PvlPage: 
        """
        Add another page

        Returns:
            New page

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPages.AddPage_void
        """
        pass

    def GetActivePageNumber(
      self
    ) -> int: 
        """
        Provied active page.

        Returns:
            Active page.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPages.GetActivePageNumber_void
        """
        pass

    def IsFirst(
      self
    ) -> bool: 
        """
        True if currently active page is the first one

        Returns:
            True if active page is first

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPages.IsFirst_void
        """
        pass

    def IsLast(
      self
    ) -> bool: 
        """
        True if currently active page is the last one

        Returns:
            True if active page is last

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPages.IsLast_void
        """
        pass

    def Next(
      self,
      _sender: TObject
    ) -> None: 
        """
        Move to the next page

        Args:
            _sender: Object that called the action

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPages.Next_TObject
        """
        pass

    def Previous(
      self,
      _sender: TObject
    ) -> None: 
        """
        Move to the previous page

        Args:
            _sender: Object that called the action

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPages.Previous_TObject
        """
        pass

    @property
    def OnPageChange(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnPageChange event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPages.OnPageChange
        """
        pass

    @OnPageChange.setter
    def OnPageChange(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnPageChange event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPages.OnPageChange
        """
        pass

class TGIS_PvlCanvas( TGIS_PvlControl, IGIS_PvlCanvas ):
    """
    PVL canvas.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCanvas
    """

    @property
    def OnRender(
      self
    ) -> typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]: 
        """
        Renderer on which we can draw.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCanvas.OnRender
        """
        pass

    @OnRender.setter
    def OnRender(
      self,
      _value: typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]
    ) -> None: 
        """
        Renderer on which we can draw.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCanvas.OnRender
        """
        pass

class TGIS_PvlPreviewPanel( TGIS_PvlControl, IGIS_PvlPreviewPanel ):
    """
    PVL preview panel control with ability to show text, images or GIS elements.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel
    """

    def Invalidate(
      self
    ) -> None: 
        """
        Invalidate preview panel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel.Invalidate_void
        """
        pass

    @property
    def Bitmap(
      self
    ) -> TGIS_Bitmap: 
        """
        Image to be shown on the panel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel.Bitmap
        """
        pass

    @Bitmap.setter
    def Bitmap(
      self,
      _value: TGIS_Bitmap
    ) -> None: 
        """
        Image to be shown on the panel.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel.Bitmap
        """
        pass

    @property
    def Border(
      self
    ) -> bool: 
        """
        Border of the control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel.Border
        """
        pass

    @Border.setter
    def Border(
      self,
      _value: bool
    ) -> None: 
        """
        Border of the control.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel.Border
        """
        pass

    @property
    def Caption(
      self
    ) -> str: 
        """
        Caption in the middle of a control.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel.Caption
        """
        pass

    @Caption.setter
    def Caption(
      self,
      _value: str
    ) -> None: 
        """
        Caption in the middle of a control.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel.Caption
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Color of the background of the panel.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Color of the background of the panel.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel.Color
        """
        pass

    @property
    def FontFamily(
      self
    ) -> str: 
        """
        Font family to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel.FontFamily
        """
        pass

    @FontFamily.setter
    def FontFamily(
      self,
      _value: str
    ) -> None: 
        """
        Font family to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel.FontFamily
        """
        pass

    @property
    def FontSize(
      self
    ) -> int: 
        """
        Font size to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel.FontSize
        """
        pass

    @FontSize.setter
    def FontSize(
      self,
      _value: int
    ) -> None: 
        """
        Font size to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel.FontSize
        """
        pass

    @property
    def FontStyle(
      self
    ) -> typing.Sequence[TGIS_FontStyle]: 
        """
        Font style to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel.FontStyle
        """
        pass

    @FontStyle.setter
    def FontStyle(
      self,
      _value: typing.Sequence[TGIS_FontStyle]
    ) -> None: 
        """
        Font style to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel.FontStyle
        """
        pass

    @property
    def StyledAreaColor(
      self
    ) -> TGIS_Color: 
        """
        Styled symbol color. Valid only if IsStyled is True.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlPreviewPanel.StyledAreaColor
        """
        pass

class TGIS_PvlGroupBox( TGIS_PvlControl, IGIS_PvlGroupBox ):
    """
    PVL group box component.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGroupBox
    """

    @property
    def Caption(
      self
    ) -> str: 
        """
        Title of the group box.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGroupBox.Caption
        """
        pass

    @Caption.setter
    def Caption(
      self,
      _value: str
    ) -> None: 
        """
        Title of the group box.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlGroupBox.Caption
        """
        pass

class TGIS_PvlTrackBar( TGIS_PvlControl, IGIS_PvlTrackBar ):
    """
    PVL trackbar component.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTrackBar
    """

    @property
    def Maximum(
      self
    ) -> int: 
        """
        Maximum value of the trackbar

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTrackBar.Maximum
        """
        pass

    @Maximum.setter
    def Maximum(
      self,
      _value: int
    ) -> None: 
        """
        Maximum value of the trackbar

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTrackBar.Maximum
        """
        pass

    @property
    def Minimum(
      self
    ) -> int: 
        """
        Minimum value of the trackbar

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTrackBar.Minimum
        """
        pass

    @Minimum.setter
    def Minimum(
      self,
      _value: int
    ) -> None: 
        """
        Minimum value of the trackbar

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTrackBar.Minimum
        """
        pass

    @property
    def Position(
      self
    ) -> int: 
        """
        Current value of the trackbar

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTrackBar.Position
        """
        pass

    @Position.setter
    def Position(
      self,
      _value: int
    ) -> None: 
        """
        Current value of the trackbar

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTrackBar.Position
        """
        pass

    @property
    def OnChange(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        On change event of the trackbar

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTrackBar.OnChange
        """
        pass

    @OnChange.setter
    def OnChange(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        On change event of the trackbar

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTrackBar.OnChange
        """
        pass

class TGIS_PvlListBox( TGIS_PvlControl, IGIS_PvlListBox ):
    """
    PVL list component.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox
    """

    def BeginUpdate(
      self
    ) -> None: 
        """
        Begin updating list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox.BeginUpdate_void
        """
        pass

    def EndUpdate(
      self
    ) -> None: 
        """
        End updating list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox.EndUpdate_void
        """
        pass

    def ItemsAdd(
      self,
      _item: str
    ) -> None: 
        """
        Add item to the list.

        Args:
            _item: Item to be added to the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox.ItemsAdd_String
        """
        pass

    def ItemsClear(
      self
    ) -> None: 
        """
        Clear all items from the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox.ItemsClear_void
        """
        pass

    
    def Item(
      self,
      _idx: int
    ) -> str: 
        """
        Item accessor.

        Args:
            _idx: ID of the item you want to get

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox.Item
        """
        pass

    @property
    def ItemIndex(
      self
    ) -> int: 
        """
        Current index of item on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox.ItemIndex
        """
        pass

    @ItemIndex.setter
    def ItemIndex(
      self,
      _value: int
    ) -> None: 
        """
        Current index of item on the list.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox.ItemIndex
        """
        pass

    @property
    def ItemList(
      self
    ) -> TGIS_ListOfStrings: 
        """
        List of the items in the component.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox.ItemList
        """
        pass

    @property
    def ItemsCount(
      self
    ) -> int: 
        """
        Count of all items on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox.ItemsCount
        """
        pass

    @property
    def Multiselect(
      self
    ) -> bool: 
        """
        Ability to select multiple items.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox.Multiselect
        """
        pass

    @Multiselect.setter
    def Multiselect(
      self,
      _value: bool
    ) -> None: 
        """
        Ability to select multiple items.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox.Multiselect
        """
        pass

    
    def Selected(
      self,
      _index: int
    ) -> bool: 
        """
        State of given by index item.

        Args:
            _index: index of the element

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox.Selected
        """
        pass

    
    def Selected(
      self,
      _index: int,
      _value: bool
    ) -> None: 
        """
        State of given by index item.

        Args:
            _index: index of the element

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox.Selected
        """
        pass

    @property
    def SelectedItems(
      self
    ) -> TGIS_ListOfStrings: 
        """
        All selected items when using multiselect mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox.SelectedItems
        """
        pass

    @property
    def OnChange(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnChange event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox.OnChange
        """
        pass

    @OnChange.setter
    def OnChange(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnChange event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlListBox.OnChange
        """
        pass

class TGIS_PvlSVGList( TGIS_PvlControl, IGIS_PvlSVGList ):
    """
    PVL svg list component.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSVGList
    """

    def BeginUpdate(
      self
    ) -> None: 
        """
        Begin updating list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSVGList.BeginUpdate_void
        """
        pass

    def EndUpdate(
      self
    ) -> None: 
        """
        End updating list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSVGList.EndUpdate_void
        """
        pass

    def ItemsAdd(
      self,
      _item: str
    ) -> None: 
        """
        Add item to the list.

        Args:
            _item: Item to be added to the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSVGList.ItemsAdd_String
        """
        pass

    def ItemsClear(
      self
    ) -> None: 
        """
        Clear all items from the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSVGList.ItemsClear_void
        """
        pass

    
    def Item(
      self,
      _idx: int
    ) -> str: 
        """
        Item accessor.

        Args:
            _idx: ID of the item you want to get

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSVGList.Item
        """
        pass

    @property
    def ItemIndex(
      self
    ) -> int: 
        """
        Current index of item on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSVGList.ItemIndex
        """
        pass

    @ItemIndex.setter
    def ItemIndex(
      self,
      _value: int
    ) -> None: 
        """
        Current index of item on the list.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSVGList.ItemIndex
        """
        pass

    @property
    def ItemList(
      self
    ) -> TGIS_ListOfStrings: 
        """
        List of the items in the component.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSVGList.ItemList
        """
        pass

    @property
    def ItemsCount(
      self
    ) -> int: 
        """
        Count of all items on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSVGList.ItemsCount
        """
        pass

    @property
    def OnChange(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnChange event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSVGList.OnChange
        """
        pass

    @OnChange.setter
    def OnChange(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnChange event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSVGList.OnChange
        """
        pass

class TGIS_PvlLabel( TGIS_PvlControl, IGIS_PvlLabel ):
    """
    PVL label control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabel
    """

    @property
    def Alignment(
      self
    ) -> TGIS_PvlLabelTextAlignment: 
        """
        Alignment of the text in the label.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabel.Alignment
        """
        pass

    @Alignment.setter
    def Alignment(
      self,
      _value: TGIS_PvlLabelTextAlignment
    ) -> None: 
        """
        Alignment of the text in the label.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabel.Alignment
        """
        pass

    @property
    def Caption(
      self
    ) -> str: 
        """
        Caption of the label.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabel.Caption
        """
        pass

    @Caption.setter
    def Caption(
      self,
      _value: str
    ) -> None: 
        """
        Caption of the label.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabel.Caption
        """
        pass

    @property
    def FocusControl(
      self
    ) -> TGIS_PvlControl: 
        """
        Control to be focused upon selecting label.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabel.FocusControl
        """
        pass

    @FocusControl.setter
    def FocusControl(
      self,
      _value: TGIS_PvlControl
    ) -> None: 
        """
        Control to be focused upon selecting label.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabel.FocusControl
        """
        pass

    @property
    def FontColor(
      self
    ) -> TGIS_Color: 
        """
        Font family to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabel.FontColor
        """
        pass

    @FontColor.setter
    def FontColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Font family to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabel.FontColor
        """
        pass

    @property
    def FontFamily(
      self
    ) -> str: 
        """
        Font family to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabel.FontFamily
        """
        pass

    @FontFamily.setter
    def FontFamily(
      self,
      _value: str
    ) -> None: 
        """
        Font family to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabel.FontFamily
        """
        pass

    @property
    def FontSize(
      self
    ) -> int: 
        """
        Font size to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabel.FontSize
        """
        pass

    @FontSize.setter
    def FontSize(
      self,
      _value: int
    ) -> None: 
        """
        Font size to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabel.FontSize
        """
        pass

    @property
    def FontStyle(
      self
    ) -> typing.Sequence[TGIS_FontStyle]: 
        """
        Font style to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabel.FontStyle
        """
        pass

    @FontStyle.setter
    def FontStyle(
      self,
      _value: typing.Sequence[TGIS_FontStyle]
    ) -> None: 
        """
        Font style to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabel.FontStyle
        """
        pass

class TGIS_PvlIconButton( TGIS_PvlControl, IGIS_PvlIconButton ):
    """
    PVL icon button control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlIconButton
    """

    @property
    def IconIndex(
      self
    ) -> int: 
        """
        Index withib IconsList.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlIconButton.IconIndex
        """
        pass

    @IconIndex.setter
    def IconIndex(
      self,
      _value: int
    ) -> None: 
        """
        Index withib IconsList.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlIconButton.IconIndex
        """
        pass

    @property
    def IconSize(
      self
    ) -> int: 
        """
        Size of icon. Default is 16.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlIconButton.IconSize
        """
        pass

    @IconSize.setter
    def IconSize(
      self,
      _value: int
    ) -> None: 
        """
        Size of icon. Default is 16.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlIconButton.IconSize
        """
        pass

    @property
    def IconsList(
      self
    ) -> TGIS_PvlIconsList: 
        """
        Icon drawn on the button. Icon has to be in the PNG format.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlIconButton.IconsList
        """
        pass

    @IconsList.setter
    def IconsList(
      self,
      _value: TGIS_PvlIconsList
    ) -> None: 
        """
        Icon drawn on the button. Icon has to be in the PNG format.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlIconButton.IconsList
        """
        pass

    @property
    def Pushed(
      self
    ) -> bool: 
        """
        True if button is pushed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlIconButton.Pushed
        """
        pass

    @Pushed.setter
    def Pushed(
      self,
      _value: bool
    ) -> None: 
        """
        True if button is pushed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlIconButton.Pushed
        """
        pass

    @property
    def StayPressed(
      self
    ) -> bool: 
        """
        Property that allows button to be pushed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlIconButton.StayPressed
        """
        pass

    @StayPressed.setter
    def StayPressed(
      self,
      _value: bool
    ) -> None: 
        """
        Property that allows button to be pushed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlIconButton.StayPressed
        """
        pass

class TGIS_PvlButton( TGIS_PvlControl, IGIS_PvlButton ):
    """
    PVL button control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlButton
    """

    @property
    def Caption(
      self
    ) -> str: 
        """
        Caption of the button.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlButton.Caption
        """
        pass

    @Caption.setter
    def Caption(
      self,
      _value: str
    ) -> None: 
        """
        Caption of the button.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlButton.Caption
        """
        pass

    @property
    def Default(
      self
    ) -> bool: 
        """
        If upon clicking enter it is clicked too.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlButton.Default
        """
        pass

    @Default.setter
    def Default(
      self,
      _value: bool
    ) -> None: 
        """
        If upon clicking enter it is clicked too.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlButton.Default
        """
        pass

class TGIS_PvlModalButton( TGIS_PvlControl, IGIS_PvlModalButton ):
    """
    Another PVL button control but was defined as another component due to some platform 
    issues. To be used specificaly for modal form buttons like OK, Cancel, Help.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalButton
    """

    @property
    def Caption(
      self
    ) -> str: 
        """
        Caption of the button.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalButton.Caption
        """
        pass

    @Caption.setter
    def Caption(
      self,
      _value: str
    ) -> None: 
        """
        Caption of the button.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalButton.Caption
        """
        pass

    @property
    def Default(
      self
    ) -> bool: 
        """
        If upon clicking enter it is clicked too.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalButton.Default
        """
        pass

    @Default.setter
    def Default(
      self,
      _value: bool
    ) -> None: 
        """
        If upon clicking enter it is clicked too.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalButton.Default
        """
        pass

class TGIS_PvlEdit( TGIS_PvlControl, IGIS_PvlEdit ):
    """
    PVL editbox control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit
    """

    def SetAsHyperlink(
      self
    ) -> None: 
        """
        Set control style to hyperlink.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.SetAsHyperlink_void
        """
        pass

    def SetBackgroundAlarm(
      self
    ) -> None: 
        """
        Set background style when validation process fails.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.SetBackgroundAlarm_void
        """
        pass

    def SetBackgroundDefault(
      self
    ) -> None: 
        """
        Set default background style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.SetBackgroundDefault_void
        """
        pass

    def SetFontAlarm(
      self
    ) -> None: 
        """
        Set font style when validation process fails.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.SetFontAlarm_void
        """
        pass

    def SetFontDefault(
      self
    ) -> None: 
        """
        Set default font style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.SetFontDefault_void
        """
        pass

    @property
    def Editable(
      self
    ) -> bool: 
        """
        Is EditBox editable?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.Editable
        """
        pass

    @Editable.setter
    def Editable(
      self,
      _value: bool
    ) -> None: 
        """
        Is EditBox editable?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.Editable
        """
        pass

    @property
    def FontFamily(
      self
    ) -> str: 
        """
        Font family to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.FontFamily
        """
        pass

    @FontFamily.setter
    def FontFamily(
      self,
      _value: str
    ) -> None: 
        """
        Font family to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.FontFamily
        """
        pass

    @property
    def FontSize(
      self
    ) -> int: 
        """
        Font size to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.FontSize
        """
        pass

    @FontSize.setter
    def FontSize(
      self,
      _value: int
    ) -> None: 
        """
        Font size to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.FontSize
        """
        pass

    @property
    def FontStyle(
      self
    ) -> typing.Sequence[TGIS_FontStyle]: 
        """
        Font style to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.FontStyle
        """
        pass

    @FontStyle.setter
    def FontStyle(
      self,
      _value: typing.Sequence[TGIS_FontStyle]
    ) -> None: 
        """
        Font style to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.FontStyle
        """
        pass

    @property
    def SelectedText(
      self
    ) -> str: 
        """
        Selected text content.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.SelectedText
        """
        pass

    @property
    def SelectionLength(
      self
    ) -> int: 
        """
        Indicates how many letters should be selected starting with SelectionStart one.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.SelectionLength
        """
        pass

    @SelectionLength.setter
    def SelectionLength(
      self,
      _value: int
    ) -> None: 
        """
        Indicates how many letters should be selected starting with SelectionStart one.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.SelectionLength
        """
        pass

    @property
    def SelectionStart(
      self
    ) -> int: 
        """
        Index of the first letter of the selection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.SelectionStart
        """
        pass

    @SelectionStart.setter
    def SelectionStart(
      self,
      _value: int
    ) -> None: 
        """
        Index of the first letter of the selection.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.SelectionStart
        """
        pass

    @property
    def Text(
      self
    ) -> str: 
        """
        Text in the EditBox.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.Text
        """
        pass

    @Text.setter
    def Text(
      self,
      _value: str
    ) -> None: 
        """
        Text in the EditBox.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.Text
        """
        pass

    @property
    def OnChange(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnChange event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.OnChange
        """
        pass

    @OnChange.setter
    def OnChange(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnChange event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.OnChange
        """
        pass

    @property
    def OnKeyDown(
      self
    ) -> typing.Callable[[TObject, Word], None]: 
        """
        OnKeyDown event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.OnKeyDown
        """
        pass

    @OnKeyDown.setter
    def OnKeyDown(
      self,
      _value: typing.Callable[[TObject, Word], None]
    ) -> None: 
        """
        OnKeyDown event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.OnKeyDown
        """
        pass

    @property
    def OnKeyPress(
      self
    ) -> typing.Callable[[TObject, Char], None]: 
        """
        OnKeyPress event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.OnKeyPress
        """
        pass

    @OnKeyPress.setter
    def OnKeyPress(
      self,
      _value: typing.Callable[[TObject, Char], None]
    ) -> None: 
        """
        OnKeyPress event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlEdit.OnKeyPress
        """
        pass

class TGIS_PvlMemo( TGIS_PvlControl, IGIS_PvlMemo ):
    """
    PVL memo control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo
    """

    def AppendLine(
      self,
      _value: str
    ) -> None: 
        """
        Append text to the end of memo content as a new line.

        Args:
            _value: text to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.AppendLine_String
        """
        pass

    def AppendText(
      self,
      _value: str
    ) -> None: 
        """
        Append text to the end of memo content.

        Args:
            _value: text to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.AppendText_String
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear memo content.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.Clear_void
        """
        pass

    def SetFontAlarm(
      self
    ) -> None: 
        """
        Set font style when validation process fails.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.SetFontAlarm_void
        """
        pass

    def SetFontDefault(
      self
    ) -> None: 
        """
        Set default font style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.SetFontDefault_void
        """
        pass

    @property
    def CursorPos(
      self
    ) -> TPoint: 
        """
        Cursor position.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.CursorPos
        """
        pass

    @CursorPos.setter
    def CursorPos(
      self,
      _value: TPoint
    ) -> None: 
        """
        Cursor position.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.CursorPos
        """
        pass

    @property
    def Editable(
      self
    ) -> bool: 
        """
        Is Memo editable?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.Editable
        """
        pass

    @Editable.setter
    def Editable(
      self,
      _value: bool
    ) -> None: 
        """
        Is Memo editable?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.Editable
        """
        pass

    @property
    def SelectedText(
      self
    ) -> str: 
        """
        Selected text content.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.SelectedText
        """
        pass

    @property
    def SelectionLength(
      self
    ) -> int: 
        """
        Indicates how many letters should be selected starting with SelectionStart one.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.SelectionLength
        """
        pass

    @SelectionLength.setter
    def SelectionLength(
      self,
      _value: int
    ) -> None: 
        """
        Indicates how many letters should be selected starting with SelectionStart one.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.SelectionLength
        """
        pass

    @property
    def SelectionStart(
      self
    ) -> int: 
        """
        Index of the first letter of the selection.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.SelectionStart
        """
        pass

    @SelectionStart.setter
    def SelectionStart(
      self,
      _value: int
    ) -> None: 
        """
        Index of the first letter of the selection.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.SelectionStart
        """
        pass

    @property
    def Text(
      self
    ) -> str: 
        """
        Text in the EditBox.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.Text
        """
        pass

    @Text.setter
    def Text(
      self,
      _value: str
    ) -> None: 
        """
        Text in the EditBox.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.Text
        """
        pass

    @property
    def WordWrap(
      self
    ) -> bool: 
        """
        Is Memo word-wrapped?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.WordWrap
        """
        pass

    @WordWrap.setter
    def WordWrap(
      self,
      _value: bool
    ) -> None: 
        """
        Is Memo word-wrapped?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.WordWrap
        """
        pass

    @property
    def OnChange(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnChange event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.OnChange
        """
        pass

    @OnChange.setter
    def OnChange(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnChange event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.OnChange
        """
        pass

    @property
    def OnKeyDown(
      self
    ) -> typing.Callable[[TObject, Word], None]: 
        """
        OnKeyDown event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.OnKeyDown
        """
        pass

    @OnKeyDown.setter
    def OnKeyDown(
      self,
      _value: typing.Callable[[TObject, Word], None]
    ) -> None: 
        """
        OnKeyDown event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.OnKeyDown
        """
        pass

    @property
    def OnKeyPress(
      self
    ) -> typing.Callable[[TObject, Char], None]: 
        """
        OnKeyPress event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.OnKeyPress
        """
        pass

    @OnKeyPress.setter
    def OnKeyPress(
      self,
      _value: typing.Callable[[TObject, Char], None]
    ) -> None: 
        """
        OnKeyPress event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMemo.OnKeyPress
        """
        pass

class TGIS_PvlComboBox( TGIS_PvlControl, IGIS_PvlComboBox ):
    """
    PVL combobox control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox
    """

    def BeginUpdate(
      self
    ) -> None: 
        """
        Begin updating list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.BeginUpdate_void
        """
        pass

    def EndUpdate(
      self
    ) -> None: 
        """
        End updating list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.EndUpdate_void
        """
        pass

    def IndexOf(
      self,
      _item: str
    ) -> int: 
        """
        Gets index of given item.

        Args:
            _item: Given item

        Returns:
            Index on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.IndexOf_String
        """
        pass

    def ItemsAdd(
      self,
      _item: str
    ) -> None: 
        """
        Add item to the list.

        Args:
            _item: Item to be added to the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.ItemsAdd_String
        """
        pass

    def ItemsClear(
      self
    ) -> None: 
        """
        Clear all items from the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.ItemsClear_void
        """
        pass

    @property
    def DropDownCount(
      self
    ) -> int: 
        """
        Number of combo items showed in the dropdown.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.DropDownCount
        """
        pass

    @DropDownCount.setter
    def DropDownCount(
      self,
      _value: int
    ) -> None: 
        """
        Number of combo items showed in the dropdown.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.DropDownCount
        """
        pass

    @property
    def FontFamily(
      self
    ) -> str: 
        """
        Font family to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.FontFamily
        """
        pass

    @FontFamily.setter
    def FontFamily(
      self,
      _value: str
    ) -> None: 
        """
        Font family to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.FontFamily
        """
        pass

    @property
    def FontSize(
      self
    ) -> int: 
        """
        Font size to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.FontSize
        """
        pass

    @FontSize.setter
    def FontSize(
      self,
      _value: int
    ) -> None: 
        """
        Font size to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.FontSize
        """
        pass

    @property
    def FontStyle(
      self
    ) -> typing.Sequence[TGIS_FontStyle]: 
        """
        Font style to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.FontStyle
        """
        pass

    @FontStyle.setter
    def FontStyle(
      self,
      _value: typing.Sequence[TGIS_FontStyle]
    ) -> None: 
        """
        Font style to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.FontStyle
        """
        pass

    
    def Item(
      self,
      _idx: int
    ) -> str: 
        """
        Item accessor.

        Args:
            _idx: ID of the item you want to get

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.Item
        """
        pass

    @property
    def ItemIndex(
      self
    ) -> int: 
        """
        Current index of item on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.ItemIndex
        """
        pass

    @ItemIndex.setter
    def ItemIndex(
      self,
      _value: int
    ) -> None: 
        """
        Current index of item on the list.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.ItemIndex
        """
        pass

    @property
    def ItemsCount(
      self
    ) -> int: 
        """
        Count of all items on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.ItemsCount
        """
        pass

    @property
    def Sorted(
      self
    ) -> bool: 
        """
        If combobox is sorted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.Sorted
        """
        pass

    @Sorted.setter
    def Sorted(
      self,
      _value: bool
    ) -> None: 
        """
        If combobox is sorted.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.Sorted
        """
        pass

    @property
    def Tag(
      self
    ) -> NativeInt: 
        """
        Stores a NativeInt integral value as a part of a component.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.Tag
        """
        pass

    @Tag.setter
    def Tag(
      self,
      _value: NativeInt
    ) -> None: 
        """
        Stores a NativeInt integral value as a part of a component.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.Tag
        """
        pass

    @property
    def Text(
      self
    ) -> str: 
        """
        Text inside of the combobox.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.Text
        """
        pass

    @Text.setter
    def Text(
      self,
      _value: str
    ) -> None: 
        """
        Text inside of the combobox.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.Text
        """
        pass

    @property
    def OnChange(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnChange event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.OnChange
        """
        pass

    @OnChange.setter
    def OnChange(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnChange event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboBox.OnChange
        """
        pass

class TGIS_PvlComboEdit( TGIS_PvlComboBox, IGIS_PvlComboEdit ):
    """
    PVL comboedit control defined as separate component due some platform limitations.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboEdit
    """

    def SetBackgroundAlarm(
      self
    ) -> None: 
        """
        Set background style when validation process fails.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboEdit.SetBackgroundAlarm_void
        """
        pass

    def SetBackgroundDefault(
      self
    ) -> None: 
        """
        Set default background style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboEdit.SetBackgroundDefault_void
        """
        pass

    def SetFontAlarm(
      self
    ) -> None: 
        """
        Set font style when validation process fails.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboEdit.SetFontAlarm_void
        """
        pass

    def SetFontDefault(
      self
    ) -> None: 
        """
        Set default font style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboEdit.SetFontDefault_void
        """
        pass

    @property
    def OnKeyPress(
      self
    ) -> typing.Callable[[TObject, Char], None]: 
        """
        OnKeyPress event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboEdit.OnKeyPress
        """
        pass

    @OnKeyPress.setter
    def OnKeyPress(
      self,
      _value: typing.Callable[[TObject, Char], None]
    ) -> None: 
        """
        OnKeyPress event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlComboEdit.OnKeyPress
        """
        pass

class TGIS_PvlSearchBox( TGIS_PvlControl, IGIS_PvlSearchBox ):
    """
    PVL searchbox control

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox
    """

    def IndexOf(
      self,
      _item: str
    ) -> int: 
        """
        Gets index of given item.

        Args:
            _item: Given item

        Returns:
            Index on the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.IndexOf_String
        """
        pass

    def ItemsAdd(
      self,
      _item: str
    ) -> None: 
        """
        Add item to the list.

        Args:
            _item: Item to be added to the list

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.ItemsAdd_String
        """
        pass

    def ItemsClear(
      self
    ) -> None: 
        """
        Clear all items from the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.ItemsClear_void
        """
        pass

    def SetBackgroundAlarm(
      self
    ) -> None: 
        """
        Set background style when validation process fails.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.SetBackgroundAlarm_void
        """
        pass

    def SetBackgroundDefault(
      self
    ) -> None: 
        """
        Set default background style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.SetBackgroundDefault_void
        """
        pass

    def SetFontAlarm(
      self
    ) -> None: 
        """
        Set font style when validation process fails.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.SetFontAlarm_void
        """
        pass

    def SetFontDefault(
      self
    ) -> None: 
        """
        Set default font style.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.SetFontDefault_void
        """
        pass

    @property
    def DropDownCount(
      self
    ) -> int: 
        """
        Number of combo items showed in the dropdown.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.DropDownCount
        """
        pass

    @DropDownCount.setter
    def DropDownCount(
      self,
      _value: int
    ) -> None: 
        """
        Number of combo items showed in the dropdown.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.DropDownCount
        """
        pass

    @property
    def FontFamily(
      self
    ) -> str: 
        """
        Font family to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.FontFamily
        """
        pass

    @FontFamily.setter
    def FontFamily(
      self,
      _value: str
    ) -> None: 
        """
        Font family to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.FontFamily
        """
        pass

    @property
    def FontSize(
      self
    ) -> int: 
        """
        Font size to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.FontSize
        """
        pass

    @FontSize.setter
    def FontSize(
      self,
      _value: int
    ) -> None: 
        """
        Font size to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.FontSize
        """
        pass

    @property
    def FontStyle(
      self
    ) -> typing.Sequence[TGIS_FontStyle]: 
        """
        Font style to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.FontStyle
        """
        pass

    @FontStyle.setter
    def FontStyle(
      self,
      _value: typing.Sequence[TGIS_FontStyle]
    ) -> None: 
        """
        Font style to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.FontStyle
        """
        pass

    
    def Item(
      self,
      _idx: int
    ) -> str: 
        """
        Item accessor.

        Args:
            _idx: ID of the item you want to get

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.Item
        """
        pass

    @property
    def ItemIndex(
      self
    ) -> int: 
        """
        Current index of item on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.ItemIndex
        """
        pass

    @ItemIndex.setter
    def ItemIndex(
      self,
      _value: int
    ) -> None: 
        """
        Current index of item on the list.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.ItemIndex
        """
        pass

    @property
    def ItemsCount(
      self
    ) -> int: 
        """
        Count of all items on the list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.ItemsCount
        """
        pass

    @property
    def Sorted(
      self
    ) -> bool: 
        """
        If combobox is sorted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.Sorted
        """
        pass

    @Sorted.setter
    def Sorted(
      self,
      _value: bool
    ) -> None: 
        """
        If combobox is sorted.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.Sorted
        """
        pass

    @property
    def Text(
      self
    ) -> str: 
        """
        Text inside of the combobox.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.Text
        """
        pass

    @Text.setter
    def Text(
      self,
      _value: str
    ) -> None: 
        """
        Text inside of the combobox.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.Text
        """
        pass

    @property
    def OnChange(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnChange event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.OnChange
        """
        pass

    @OnChange.setter
    def OnChange(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnChange event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.OnChange
        """
        pass

    @property
    def OnKeyPress(
      self
    ) -> typing.Callable[[TObject, Char], None]: 
        """
        OnKeyPress event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.OnKeyPress
        """
        pass

    @OnKeyPress.setter
    def OnKeyPress(
      self,
      _value: typing.Callable[[TObject, Char], None]
    ) -> None: 
        """
        OnKeyPress event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSearchBox.OnKeyPress
        """
        pass

class TGIS_PvlColorPreview( TGIS_PvlControl, IGIS_PvlColorPreview ):
    """
    PVL color preview panel.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorPreview
    """

    @property
    def Border(
      self
    ) -> bool: 
        """
        If true then show border.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorPreview.Border
        """
        pass

    @Border.setter
    def Border(
      self,
      _value: bool
    ) -> None: 
        """
        If true then show border.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorPreview.Border
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Selected color property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorPreview.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Selected color property

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorPreview.Color
        """
        pass

class TGIS_PvlColorWheel( TGIS_PvlControl, IGIS_PvlColorWheel ):
    """
    PVL color wheel picker.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorWheel
    """

    def HueToRGB(
      self,
      _hue: float
    ) -> TGIS_PvlRGBVal: 
        """
        Converts Hue to RGB

        Args:
            _hue: Hue to be converted

        Returns:
            RGB value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorWheel.HueToRGB_Double
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Selected color property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorWheel.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Selected color property

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorWheel.Color
        """
        pass

    @property
    def OnChange(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnChange event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorWheel.OnChange
        """
        pass

    @OnChange.setter
    def OnChange(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnChange event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorWheel.OnChange
        """
        pass

class TGIS_PvlColorBar( TGIS_PvlControl, IGIS_PvlColorBar ):
    """
    PVL Color slider

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorBar
    """

    @property
    def Alpha(
      self
    ) -> bool: 
        """
        If slider operates in alpha channel

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorBar.Alpha
        """
        pass

    @Alpha.setter
    def Alpha(
      self,
      _value: bool
    ) -> None: 
        """
        If slider operates in alpha channel

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorBar.Alpha
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Selected color property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorBar.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Selected color property

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorBar.Color
        """
        pass

    @property
    def Value(
      self
    ) -> float: 
        """
        Position of the slider

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorBar.Value
        """
        pass

    @Value.setter
    def Value(
      self,
      _value: float
    ) -> None: 
        """
        Position of the slider

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorBar.Value
        """
        pass

    @property
    def OnChange(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnChange event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorBar.OnChange
        """
        pass

    @OnChange.setter
    def OnChange(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnChange event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorBar.OnChange
        """
        pass

class TGIS_PvlCustomComboBox( TGIS_PvlControl, IGIS_PvlCustomComboBox ):
    """
    PVL custom combobox control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomComboBox
    """

    @property
    def Fields(
      self
    ) -> TGIS_StringList: 
        """
        Fields of the ComboBox.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomComboBox.Fields
        """
        pass

    @Fields.setter
    def Fields(
      self,
      _value: TGIS_StringList
    ) -> None: 
        """
        Fields of the ComboBox.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomComboBox.Fields
        """
        pass

    @property
    def Value(
      self
    ) -> str: 
        """
        Value of the ComboBox.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomComboBox.Value
        """
        pass

    @Value.setter
    def Value(
      self,
      _value: str
    ) -> None: 
        """
        Value of the ComboBox.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomComboBox.Value
        """
        pass

    @property
    def OnChange(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnChange event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomComboBox.OnChange
        """
        pass

    @OnChange.setter
    def OnChange(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnChange event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomComboBox.OnChange
        """
        pass

class TGIS_PvlSizeComboBox( TGIS_PvlCustomComboBox, IGIS_PvlSizeComboBox ):
    """
    PVL size combobox control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSizeComboBox
    """

    def Fill(
      self,
      _forSymbol: bool,
      _forLine: bool,
      _field: bool,
      _renderer: bool
    ) -> None: 
        """
        Fill the list.

        Args:
            _forSymbol: if units for symbol size
            _forLine: if units for symbol size
            _field: if values from fields
            _renderer: if renderer value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSizeComboBox.Fill_Boolean_Boolean_Boolean_Boolean
        """
        pass

    def FillAggregation(
      self
    ) -> None: 
        """
        Fill the list with aggregation sizes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSizeComboBox.FillAggregation_void
        """
        pass

    def FillRealWorldUnits(
      self,
      _field: bool
    ) -> None: 
        """
        Fill the list with measure units.

        Args:
            _field: if values from fields

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSizeComboBox.FillRealWorldUnits_Boolean
        """
        pass

    @property
    def Fields(
      self
    ) -> TGIS_StringList: 
        """
        Property with fields to be used in field factor form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSizeComboBox.Fields
        """
        pass

    @Fields.setter
    def Fields(
      self,
      _value: TGIS_StringList
    ) -> None: 
        """
        Property with fields to be used in field factor form.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSizeComboBox.Fields
        """
        pass

class TGIS_PvlColorComboBox( TGIS_PvlCustomComboBox, IGIS_PvlColorComboBox ):
    """
    PVL color combobox control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorComboBox
    """

    @overload
    def Fill(
      self,
      _field: bool,
      _renderer: bool
    ) -> None: 
        """
        Populates the ComboBox with items.

        Args:
            _field: If values from fields
            _renderer: If renderer value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorComboBox.Fill_Boolean_Boolean
        """
        pass

    @overload
    def Fill(
      self,
      _field: bool,
      _renderer: bool,
      _values: TGIS_StringList
    ) -> None: 
        """
        Populates the ComboBox with items from the list. Place method has to be used first.

        Args:
            _field: If values from fields
            _renderer: If renderer value
            _values: List of colors to fill combobox ( eg. ''FFFFFFFF'' ).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorComboBox.Fill_Boolean_Boolean_TStringList
        """
        pass

    @property
    def Fields(
      self
    ) -> TGIS_StringList: 
        """
        Property with fields to be used in field factor form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorComboBox.Fields
        """
        pass

    @Fields.setter
    def Fields(
      self,
      _value: TGIS_StringList
    ) -> None: 
        """
        Property with fields to be used in field factor form.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorComboBox.Fields
        """
        pass

class TGIS_PvlCustomBitmapComboBox( TGIS_PvlCustomComboBox, IGIS_PvlCustomBitmapComboBox ):
    """
    PVL custom bitmap combobox control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomBitmapComboBox
    """

    def FillMarker(
      self,
      _hasSymbol: bool
    ) -> None: 
        """
        Populates the marker ComboBox with items.

        Args:
            _hasSymbol: If symbols component can be invoked

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomBitmapComboBox.FillMarker_Boolean
        """
        pass

    def FillPattern(
      self,
      _hasSymbol: bool
    ) -> None: 
        """
        Populates the pattern fill ComboBox with items.

        Args:
            _hasSymbol: If symbols component can be invoked

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomBitmapComboBox.FillPattern_Boolean
        """
        pass

    def FillShield(
      self
    ) -> None: 
        """
        Populates the shield ComboBox with items.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomBitmapComboBox.FillShield_void
        """
        pass

    def FillStyle(
      self,
      _hasSymbol: bool
    ) -> None: 
        """
        Populates the outline style ComboBox with items.

        Args:
            _hasSymbol: If symbols component can be invoked

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomBitmapComboBox.FillStyle_Boolean
        """
        pass

    @property
    def Fields(
      self
    ) -> TGIS_StringList: 
        """
        Property with fields to be used in field factor form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomBitmapComboBox.Fields
        """
        pass

    @Fields.setter
    def Fields(
      self,
      _value: TGIS_StringList
    ) -> None: 
        """
        Property with fields to be used in field factor form.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomBitmapComboBox.Fields
        """
        pass

    @property
    def Type(
      self
    ) -> TGIS_PvlCustomBitmapType: 
        """
        Property which determins type of custom bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomBitmapComboBox.Type
        """
        pass

    @property
    def GetBitmapEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_PvlComboBoxHelperGetBitmapEventArgs], TGIS_Bitmap]: 
        """
        Event for getting bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomBitmapComboBox.GetBitmapEvent
        """
        pass

    @GetBitmapEvent.setter
    def GetBitmapEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_PvlComboBoxHelperGetBitmapEventArgs], TGIS_Bitmap]
    ) -> None: 
        """
        Event for getting bitmap

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCustomBitmapComboBox.GetBitmapEvent
        """
        pass

class TGIS_PvlCheckBox( TGIS_PvlControl, IGIS_PvlCheckBox ):
    """
    PVL combobox control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCheckBox
    """

    @property
    def Caption(
      self
    ) -> str: 
        """
        Caption of the checkbox.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCheckBox.Caption
        """
        pass

    @Caption.setter
    def Caption(
      self,
      _value: str
    ) -> None: 
        """
        Caption of the checkbox.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCheckBox.Caption
        """
        pass

    @property
    def Checked(
      self
    ) -> bool: 
        """
        If checkbox is checked.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCheckBox.Checked
        """
        pass

    @Checked.setter
    def Checked(
      self,
      _value: bool
    ) -> None: 
        """
        If checkbox is checked.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCheckBox.Checked
        """
        pass

    @property
    def FontFamily(
      self
    ) -> str: 
        """
        Font family to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCheckBox.FontFamily
        """
        pass

    @FontFamily.setter
    def FontFamily(
      self,
      _value: str
    ) -> None: 
        """
        Font family to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCheckBox.FontFamily
        """
        pass

    @property
    def FontSize(
      self
    ) -> int: 
        """
        Font size to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCheckBox.FontSize
        """
        pass

    @FontSize.setter
    def FontSize(
      self,
      _value: int
    ) -> None: 
        """
        Font size to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCheckBox.FontSize
        """
        pass

    @property
    def FontStyle(
      self
    ) -> typing.Sequence[TGIS_FontStyle]: 
        """
        Font style to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCheckBox.FontStyle
        """
        pass

    @FontStyle.setter
    def FontStyle(
      self,
      _value: typing.Sequence[TGIS_FontStyle]
    ) -> None: 
        """
        Font style to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCheckBox.FontStyle
        """
        pass

    @property
    def OnChange(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        On change event of the trackbar

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCheckBox.OnChange
        """
        pass

    @OnChange.setter
    def OnChange(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        On change event of the trackbar

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlCheckBox.OnChange
        """
        pass

class TGIS_PvlRadioButton( TGIS_PvlControl, IGIS_PvlRadioButton ):
    """
    PVL radiobutton control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRadioButton
    """

    def UncheckGroup(
      self,
      _button: TGIS_PvlRadioButton
    ) -> None: 
        """
        Un cjchek all memmebers of the same group as provideded button.

        Args:
            _button: reference radio button

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRadioButton.UncheckGroup_TGIS_PvlRadioButton
        """
        pass

    @property
    def Caption(
      self
    ) -> str: 
        """
        Caption of the checkbox.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRadioButton.Caption
        """
        pass

    @Caption.setter
    def Caption(
      self,
      _value: str
    ) -> None: 
        """
        Caption of the checkbox.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRadioButton.Caption
        """
        pass

    @property
    def Checked(
      self
    ) -> bool: 
        """
        If checkbox is checked.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRadioButton.Checked
        """
        pass

    @Checked.setter
    def Checked(
      self,
      _value: bool
    ) -> None: 
        """
        If checkbox is checked.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRadioButton.Checked
        """
        pass

    @property
    def FontFamily(
      self
    ) -> str: 
        """
        Font family to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRadioButton.FontFamily
        """
        pass

    @FontFamily.setter
    def FontFamily(
      self,
      _value: str
    ) -> None: 
        """
        Font family to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRadioButton.FontFamily
        """
        pass

    @property
    def FontSize(
      self
    ) -> int: 
        """
        Font size to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRadioButton.FontSize
        """
        pass

    @FontSize.setter
    def FontSize(
      self,
      _value: int
    ) -> None: 
        """
        Font size to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRadioButton.FontSize
        """
        pass

    @property
    def FontStyle(
      self
    ) -> typing.Sequence[TGIS_FontStyle]: 
        """
        Font style to be used in the caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRadioButton.FontStyle
        """
        pass

    @FontStyle.setter
    def FontStyle(
      self,
      _value: typing.Sequence[TGIS_FontStyle]
    ) -> None: 
        """
        Font style to be used in the caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRadioButton.FontStyle
        """
        pass

    @property
    def Group(
      self
    ) -> str: 
        """
        Group of the radio button.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRadioButton.Group
        """
        pass

    @Group.setter
    def Group(
      self,
      _value: str
    ) -> None: 
        """
        Group of the radio button.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRadioButton.Group
        """
        pass

    @property
    def OnChange(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnChange event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRadioButton.OnChange
        """
        pass

    @OnChange.setter
    def OnChange(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnChange event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRadioButton.OnChange
        """
        pass

class TGIS_PvlColorRampComboBox( TGIS_PvlControl, IGIS_PvlColorRampComboBox ):
    """
    PVL color ramp combo-box control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox
    """

    def Fill(
      self
    ) -> None: 
        """
        Fill the control with data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.Fill_void
        """
        pass

    def Lock(
      self
    ) -> None: 
        """
        Locks control from filling its values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.Lock_void
        """
        pass

    def Unlock(
      self
    ) -> None: 
        """
        Unlocks control from filling its values.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.Unlock_void
        """
        pass

    def Value(
      self,
      _subClass: int
    ) -> TGIS_ColorMapArray: 
        """
        Color map value.

        Args:
            _subClass: get subclass of a ramp with specified number of colors, if available; 
              if 0, get default colormap; if -1, get subclass with maximum number of colors;

        Returns:
            Array of colormap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.Value_Integer
        """
        pass

    @property
    def ColorSchemas(
      self
    ) -> typing.Sequence[TGIS_ColorSchema]: 
        """
        Color schema filter.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.ColorSchemas
        """
        pass

    @ColorSchemas.setter
    def ColorSchemas(
      self,
      _value: typing.Sequence[TGIS_ColorSchema]
    ) -> None: 
        """
        Color schema filter.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.ColorSchemas
        """
        pass

    @property
    def Index(
      self
    ) -> int: 
        """
        Index of the selected item.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.Index
        """
        pass

    @Index.setter
    def Index(
      self,
      _value: int
    ) -> None: 
        """
        Index of the selected item.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.Index
        """
        pass

    @property
    def ItemCount(
      self
    ) -> int: 
        """
        Ramp count.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.ItemCount
        """
        pass

    
    def Items(
      self,
      _idx: int
    ) -> str: 
        """
        Item accessor.

        Args:
            _idx: ID of the item you want to get

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.Items
        """
        pass

    @property
    def Mode(
      self
    ) -> TGIS_ColorMapMode: 
        """
        ColorMap mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.Mode
        """
        pass

    @Mode.setter
    def Mode(
      self,
      _value: TGIS_ColorMapMode
    ) -> None: 
        """
        ColorMap mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.Mode
        """
        pass

    @property
    def Reverse(
      self
    ) -> bool: 
        """
        Reverse colormap.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.Reverse
        """
        pass

    @Reverse.setter
    def Reverse(
      self,
      _value: bool
    ) -> None: 
        """
        Reverse colormap.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.Reverse
        """
        pass

    @property
    def ShowNames(
      self
    ) -> bool: 
        """
        Show captions for ramps.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.ShowNames
        """
        pass

    @ShowNames.setter
    def ShowNames(
      self,
      _value: bool
    ) -> None: 
        """
        Show captions for ramps.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.ShowNames
        """
        pass

    @property
    def OnChange(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnChange event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.OnChange
        """
        pass

    @OnChange.setter
    def OnChange(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnChange event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampComboBox.OnChange
        """
        pass

class TGIS_PvlTreeNode( TGIS_PvlBase, IGIS_PvlTreeNode ):
    """
    PVL TreeNode control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode
    """

    @overload
    def __init__(
      self,
      _parent: TGIS_PvlTree
    ) -> None: 
        """
        Create Node.

        Args:
            _parent: tree control

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.Create_TGIS_PvlTree
        """
        pass

    @overload
    def __init__(
      self,
      _parent: TGIS_PvlTreeNode
    ) -> None: 
        """
        Create Node.

        Args:
            _parent: parent of the node

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.Create_TGIS_PvlTreeNode
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.Clear_void
        """
        pass

    @overload
    def CreateNode(
      self,
      _caption: str
    ) -> TGIS_PvlTreeNode: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.CreateNode_String
        """
        pass

    @overload
    def CreateNode(
      self,
      _caption: str,
      _index: int
    ) -> TGIS_PvlTreeNode: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.CreateNode_String_Integer
        """
        pass

    def DeleteNode(
      self
    ) -> None: 
        """
        Delete this node from the parent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.DeleteNode_void
        """
        pass

    def doCreateNode(
      self,
      _node: TGIS_PvlTreeNode,
      _caption: str,
      _index: int
    ) -> None: 
        """
        Additional creation procedure

        Args:
            _node: \ Created node
            _caption: Caption of created node
            _index: Index on which it should be placed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.doCreateNode_TGIS_PvlTreeNode_String_Integer
        """
        pass

    def doDeleteNode(
      self,
      _node: TGIS_PvlTreeNode
    ) -> None: 
        """
        Additional deletation procedure

        Args:
            _node: Node to be removed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.doDeleteNode_TGIS_PvlTreeNode
        """
        pass

    def doMoveNode(
      self,
      _node: TGIS_PvlTreeNode,
      _newParent: TGIS_PvlTreeNode,
      _index: int
    ) -> None: 
        """
        Additional move procedure

        Args:
            _node: Node to be moved
            _newParent: New parent node
            _index: Index on which it should be placed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.doMoveNode_TGIS_PvlTreeNode_TGIS_PvlTreeNode_Integer
        """
        pass

    def doRemoveNode(
      self,
      _node: TGIS_PvlTreeNode
    ) -> None: 
        """
        Additional removal procedure

        Args:
            _node: Node to be removed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.doRemoveNode_TGIS_PvlTreeNode
        """
        pass

    def InternalRemove(
      self
    ) -> None: 
        """
        Remove this node. FOR INTERNAL USE ONLY !!!!

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.InternalRemove_void
        """
        pass

    @overload
    def MoveNode(
      self,
      _newParent: TGIS_PvlTreeNode,
      _index: int
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.MoveNode_TGIS_PvlTreeNode_Integer
        """
        pass

    @overload
    def MoveNode(
      self,
      _newParent: TGIS_PvlTreeNode
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.MoveNode_TGIS_PvlTreeNode
        """
        pass

    @property
    def Caption(
      self
    ) -> str: 
        """
        Node caption.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.Caption
        """
        pass

    @Caption.setter
    def Caption(
      self,
      _value: str
    ) -> None: 
        """
        Node caption.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.Caption
        """
        pass

    @property
    def Count(
      self
    ) -> int: 
        """
        Number of child nodes.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.Count
        """
        pass

    @property
    def Expanded(
      self
    ) -> bool: 
        """
        If node is expanded or not.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.Expanded
        """
        pass

    @Expanded.setter
    def Expanded(
      self,
      _value: bool
    ) -> None: 
        """
        If node is expanded or not.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.Expanded
        """
        pass

    @property
    def NativeControl(
      self
    ) -> TObject: 
        """
        Native platform node object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.NativeControl
        """
        pass

    @NativeControl.setter
    def NativeControl(
      self,
      _value: TObject
    ) -> None: 
        """
        Native platform node object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.NativeControl
        """
        pass

    
    def Node(
      self,
      _index: int
    ) -> TGIS_PvlTreeNode: 
        """
        Node at the index

        Args:
            _index: index of the node

        Returns:
            Node or nil if _index is out of the range.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.Node
        """
        pass

    @property
    def Nodes(
      self
    ) -> TListTGIS_PvlTreeNode: 
        """
        List of all children nodes

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.Nodes
        """
        pass

    @property
    def Parent(
      self
    ) -> TGIS_PvlTreeNode: 
        """
        Node parent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.Parent
        """
        pass

    @property
    def TreeControl(
      self
    ) -> TGIS_PvlTree: 
        """
        Tree control that owns a node.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTreeNode.TreeControl
        """
        pass

class TGIS_PvlTree( TGIS_PvlControl, IGIS_PvlTree ):
    """
    PVL Tree control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTree
    """

    def CreateRoot(
      self
    ) -> None: 
        """
        Create a root even. Only for internal use/

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTree.CreateRoot_void
        """
        pass

    @property
    def Root(
      self
    ) -> TGIS_PvlTreeNode: 
        """
        Root node.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTree.Root
        """
        pass

    @property
    def Selected(
      self
    ) -> TGIS_PvlTreeNode: 
        """
        Selected node.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTree.Selected
        """
        pass

    @Selected.setter
    def Selected(
      self,
      _value: TGIS_PvlTreeNode
    ) -> None: 
        """
        Selected node.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTree.Selected
        """
        pass

    @property
    def SelectedIndex(
      self
    ) -> int: 
        """
        Index of the selected node in the parent node.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTree.SelectedIndex
        """
        pass

    @property
    def OnSelectChange(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnSelectChange event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTree.OnSelectChange
        """
        pass

    @OnSelectChange.setter
    def OnSelectChange(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnSelectChange event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlTree.OnSelectChange
        """
        pass

class TGIS_PvlOptionDialog( TGIS_PvlSystemForm ):
    """
    PVL option dialog control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlOptionDialog
    """

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlOptionDialog.Create_TGIS_PvlContext
        """
        pass

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlSystemForm
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form
            _self: Reference to the TGIS_PvlSystemForm

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlOptionDialog.Create_TGIS_PvlContext_TGIS_PvlSystemForm
        """
        pass

    def Execute(
      self
    ) -> TGIS_PvlModalResult: 
        """
        Invoke Dialog Form and execute it.

        Returns:
            Returns result of the Execute operation

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlOptionDialog.Execute_void
        """
        pass

    @property
    def Text(
      self
    ) -> str: 
        """
        Message of the dialog.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlOptionDialog.Text
        """
        pass

    @Text.setter
    def Text(
      self,
      _value: str
    ) -> None: 
        """
        Message of the dialog.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlOptionDialog.Text
        """
        pass

class TGIS_PvlMessageDialog( TGIS_PvlSystemForm ):
    """
    PVL message dialog control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessageDialog
    """

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessageDialog.Create_TGIS_PvlContext
        """
        pass

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlSystemForm
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form
            _self: Reference to the TGIS_PvlSystemForm

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessageDialog.Create_TGIS_PvlContext_TGIS_PvlSystemForm
        """
        pass

    def Execute(
      self
    ) -> None: 
        """
        Invoke Dialog Form and execute it.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessageDialog.Execute_void
        """
        pass

    @property
    def Text(
      self
    ) -> str: 
        """
        Message of the dialog.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessageDialog.Text
        """
        pass

    @Text.setter
    def Text(
      self,
      _value: str
    ) -> None: 
        """
        Message of the dialog.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessageDialog.Text
        """
        pass

    @property
    def Title(
      self
    ) -> str: 
        """
        Title of the dialog.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessageDialog.Title
        """
        pass

    @Title.setter
    def Title(
      self,
      _value: str
    ) -> None: 
        """
        Title of the dialog.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessageDialog.Title
        """
        pass

class TGIS_PvlInfoDialog( TGIS_PvlMessageDialog ):
    """
    PVL info dialog control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlInfoDialog
    """

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlInfoDialog.Create_TGIS_PvlContext
        """
        pass

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlSystemForm
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form
            _self: Reference to the TGIS_PvlSystemForm

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlInfoDialog.Create_TGIS_PvlContext_TGIS_PvlSystemForm
        """
        pass

class TGIS_PvlWarningDialog( TGIS_PvlMessageDialog ):
    """
    PVL warning dialog control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlWarningDialog
    """

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlWarningDialog.Create_TGIS_PvlContext
        """
        pass

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlSystemForm
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form
            _self: Reference to the TGIS_PvlSystemForm

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlWarningDialog.Create_TGIS_PvlContext_TGIS_PvlSystemForm
        """
        pass

class TGIS_PvlErrorDialog( TGIS_PvlMessageDialog ):
    """
    PVL error dialog control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlErrorDialog
    """

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlErrorDialog.Create_TGIS_PvlContext
        """
        pass

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlSystemForm
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form
            _self: Reference to the TGIS_PvlSystemForm

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlErrorDialog.Create_TGIS_PvlContext_TGIS_PvlSystemForm
        """
        pass

class TGIS_PvlMessages:
    """
    Class for static execution of the message dialogs in PVL

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessages
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessages.Create_void
        """
        pass

    @overload
    def ShowError(
      self,
      _title: str,
      _message: str,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Static procedure to show error dialog.

        Args:
            _title: Title of the error dialog
            _message: Message to be shown in the error dialog
            _context: Context on which dialog is supposed to be shown

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessages.ShowError_String_String_TGIS_PvlContext
        """
        pass

    @overload
    def ShowError(
      self,
      _message: str,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Static procedure to show error dialog.

        Args:
            _message: Message to be shown in the error dialog
            _context: Context on which dialog is supposed to be shown

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessages.ShowError_String_TGIS_PvlContext
        """
        pass

    @overload
    def ShowInfo(
      self,
      _title: str,
      _message: str,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Static procedure to show info dialog.

        Args:
            _title: Title of the info dialog
            _message: Message to be shown in the info dialog
            _context: Context on which dialog is supposed to be shown

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessages.ShowInfo_String_String_TGIS_PvlContext
        """
        pass

    @overload
    def ShowInfo(
      self,
      _message: str,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Static procedure to show info dialog.

        Args:
            _message: Message to be shown in the info dialog
            _context: Context on which dialog is supposed to be shown

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessages.ShowInfo_String_TGIS_PvlContext
        """
        pass

    def ShowOption(
      self,
      _message: str,
      _context: TGIS_PvlContext
    ) -> TGIS_PvlModalResult: 
        """
        Static procedure to show option dialog.

        Args:
            _message: Message to be shown in the error dialog
            _context: Context on which dialog is supposed to be shown

        Returns:
            Returns result of the Execute operation

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessages.ShowOption_String_TGIS_PvlContext
        """
        pass

    @overload
    def ShowWarning(
      self,
      _title: str,
      _message: str,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Static procedure to show warning dialog.

        Args:
            _title: Title of the warning dialog
            _message: Message to be shown in the warning dialog
            _context: Context on which dialog is supposed to be shown

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessages.ShowWarning_String_String_TGIS_PvlContext
        """
        pass

    @overload
    def ShowWarning(
      self,
      _message: str,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Static procedure to show warning dialog.

        Args:
            _message: Message to be shown in the warning dialog
            _context: Context on which dialog is supposed to be shown

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlMessages.ShowWarning_String_TGIS_PvlContext
        """
        pass

class TGIS_PvlOpenSaveDialog( TGIS_PvlSystemForm ):
    """
    PVL open dialog control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlOpenSaveDialog
    """

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlOpenSaveDialog.Create_TGIS_PvlContext
        """
        pass

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlSystemForm
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form
            _self: Reference to the TGIS_PvlSystemForm

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlOpenSaveDialog.Create_TGIS_PvlContext_TGIS_PvlSystemForm
        """
        pass

    def Execute(
      self
    ) -> TGIS_PvlModalResult: 
        """
        Invoke Dialog Form and execute it.

        Returns:
            Returns result of the Execute operation

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlOpenSaveDialog.Execute_void
        """
        pass

    @property
    def FileName(
      self
    ) -> str: 
        """
        Selected file name.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlOpenSaveDialog.FileName
        """
        pass

    @FileName.setter
    def FileName(
      self,
      _value: str
    ) -> None: 
        """
        Selected file name.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlOpenSaveDialog.FileName
        """
        pass

    @property
    def Filter(
      self
    ) -> str: 
        """
        String to filter out extenstions.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlOpenSaveDialog.Filter
        """
        pass

    @Filter.setter
    def Filter(
      self,
      _value: str
    ) -> None: 
        """
        String to filter out extenstions.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlOpenSaveDialog.Filter
        """
        pass

class TGIS_PvlOpenDialog( TGIS_PvlOpenSaveDialog ):
    """
    PVL open dialog control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlOpenDialog
    """

class TGIS_PvlSaveDialog( TGIS_PvlOpenSaveDialog ):
    """
    PVL save dialog control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSaveDialog
    """

class TGIS_PvlSelectFolderDialog( TGIS_PvlSystemForm ):
    """
    PVL select folder dialog control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSelectFolderDialog
    """

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSelectFolderDialog.Create_TGIS_PvlContext
        """
        pass

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlSystemForm
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form
            _self: Reference to the TGIS_PvlSystemForm

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSelectFolderDialog.Create_TGIS_PvlContext_TGIS_PvlSystemForm
        """
        pass

    def Execute(
      self
    ) -> TGIS_PvlModalResult: 
        """
        Invoke Dialog Form and execute it.

        Returns:
            Returns result of the Execute operation

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSelectFolderDialog.Execute_void
        """
        pass

    @property
    def Directory(
      self
    ) -> str: 
        """
        String with directory path. If set before execute the dialog is going to start in 
        that directory.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSelectFolderDialog.Directory
        """
        pass

    @Directory.setter
    def Directory(
      self,
      _value: str
    ) -> None: 
        """
        String with directory path. If set before execute the dialog is going to start in 
        that directory.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlSelectFolderDialog.Directory
        """
        pass

class TGIS_PvlControlPrintPreviewSimple( TGIS_PvlSystemForm ):
    """
    PVL proxy for TGIS_ControlPrintPreview.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreviewSimple
    """

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreviewSimple.Create_TGIS_PvlContext
        """
        pass

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlSystemForm
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form
            _self: Reference to the TGIS_PvlSystemForm

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreviewSimple.Create_TGIS_PvlContext_TGIS_PvlSystemForm
        """
        pass

    @overload
    def Preview(
      self
    ) -> None: 
        """
        Execute print preview with default layout.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreviewSimple.Preview_void
        """
        pass

    @overload
    def Preview(
      self,
      _scale: VarParameter
    ) -> None: 
        """
        Execute print preview with default layout.

        Args:
            _scale: scale factor used during print (for printing scale etc); if scale=0 then 
              scale will be calculated automatically to fit the _extent; the value (in/out) is 
              passed as float in _scale.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreviewSimple.Preview_Double
        """
        pass

    @overload
    def Preview(
      self,
      _printManager: TGIS_PrintManagerAbstract
    ) -> None: 
        """
        Execute print preview with layout defined by print manager object.

        Args:
            _printManager: print manager object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreviewSimple.Preview_TGIS_PrintManagerAbstract
        """
        pass

    @overload
    def Preview(
      self,
      _printManager: TGIS_PrintManagerAbstract,
      _scale: VarParameter
    ) -> None: 
        """
        Execute print preview with layout defined by print manager object.

        Args:
            _printManager: print manager object
            _scale: scale factor used during print (for printing scale etc); if scale=0 then 
              scale will be calculated automatically to fit the _extent; the value (in/out) is 
              passed as float in _scale.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreviewSimple.Preview_TGIS_PrintManagerAbstract_Double
        """
        pass

    @overload
    def Preview(
      self,
      _printManager: TGIS_PrintManagerAbstract,
      _customPage: str,
      _scale: VarParameter
    ) -> None: 
        """
        Execute print preview with layout defined by print manager object.

        Args:
            _printManager: print manager object
            _customPage: custom page format; see TGIS_ControlPrintPreview.Preview for more information
            _scale: scale factor used during print (for printing scale etc); if scale=0 then 
              scale will be calculated automatically to fit the _extent; the value (in/out) is 
              passed as float in _scale.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreviewSimple.Preview_TGIS_PrintManagerAbstract_String_Double
        """
        pass

    @property
    def GIS_Viewer(
      self
    ) -> IGIS_Viewer: 
        """
        Viewer to which Print Preview will be attached.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreviewSimple.GIS_Viewer
        """
        pass

    @GIS_Viewer.setter
    def GIS_Viewer(
      self,
      _value: IGIS_Viewer
    ) -> None: 
        """
        Viewer to which Print Preview will be attached.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlPrintPreviewSimple.GIS_Viewer
        """
        pass

class TGIS_PvlLineSymbolEditor( TGIS_PvlSystemForm ):
    """
    PVL proxy for TGIS_LineSymbolEditor.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLineSymbolEditor
    """

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLineSymbolEditor.Create_TGIS_PvlContext
        """
        pass

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlSystemForm
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form
            _self: Reference to the TGIS_PvlSystemForm

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLineSymbolEditor.Create_TGIS_PvlContext_TGIS_PvlSystemForm
        """
        pass

    @overload
    def Execute(
      self,
      _path: str,
      _proc: typing.Callable[[TGIS_PvlModalResult], None]
    ) -> TGIS_PvlModalResult: 
        """
        Execute dialog on a line symbol given by path.

        Args:
            _path: path to the symbol.
            _proc: Action to be taken upon closing modal; the value is a callback to a method 
              with parameters defined by TGIS_Proc

        Returns:
            Dialog result on a given by path symbol

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLineSymbolEditor.Execute_String_TGIS_Proc
        """
        pass

    @overload
    def Execute(
      self,
      _path: str,
      _onhelp: typing.Callable[[TObject, String], None],
      _proc: typing.Callable[[TGIS_PvlModalResult], None]
    ) -> TGIS_PvlModalResult: 
        """
        Execute dialog on a line symbol given by path.

        Args:
            _path: path to the symbol.
            _onhelp: help notification function; if assigned the help button will be visible 
              and help support will be enabled; the value is a callback to a method with parameters 
              defined by TGIS_HelpEvent
            _proc: Action to be taken upon closing modal; the value is a callback to a method 
              with parameters defined by TGIS_Proc

        Returns:
            Dialog result on a given by path symbol

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLineSymbolEditor.Execute_String_TGIS_HelpEvent_TGIS_Proc
        """
        pass

    @property
    def Symbol(
      self
    ) -> str: 
        """
        Symbol defining string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLineSymbolEditor.Symbol
        """
        pass

    @Symbol.setter
    def Symbol(
      self,
      _value: str
    ) -> None: 
        """
        Symbol defining string.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLineSymbolEditor.Symbol
        """
        pass

class TGIS_PvlControlCSSystem( TGIS_PvlSystemForm ):
    """
    PVL proxy for TGIS_ControlCSSystem.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlCSSystem
    """

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlCSSystem.Create_TGIS_PvlContext
        """
        pass

    @overload
    def __init__(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlSystemForm
    ) -> None: 
        """
        Create Modal form with parent.

        Args:
            _context: Context owner of the system Form
            _self: Reference to the TGIS_PvlSystemForm

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlCSSystem.Create_TGIS_PvlContext_TGIS_PvlSystemForm
        """
        pass

    @overload
    def Execute(
      self,
      _cs: TGIS_CSCoordinateSystem,
      _proc: typing.Callable[[TGIS_PvlModalResult], None]
    ) -> TGIS_PvlModalResult: 
        """
        Execute dialog on a given Coordinate System.

        Args:
            _cs: Coordinate System.
            _proc: Action to be taken upon closing modal; the value is a callback to a method 
              with parameters defined by TGIS_Proc

        Returns:
            Dialog result on a given coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlCSSystem.Execute_TGIS_CSCoordinateSystem_TGIS_Proc
        """
        pass

    @overload
    def Execute(
      self,
      _cs: TGIS_CSCoordinateSystem,
      _onhelp: typing.Callable[[TObject, String], None],
      _proc: typing.Callable[[TGIS_PvlModalResult], None]
    ) -> TGIS_PvlModalResult: 
        """
        Execute dialog on a given Coordinate System.

        Args:
            _cs: Coordinate System.
            _onhelp: help notification function; if assigned the help button will be visible 
              and help support will be enabled; the value is a callback to a method with parameters 
              defined by TGIS_HelpEvent
            _proc: Action to be taken upon closing modal; the value is a callback to a method 
              with parameters defined by TGIS_Proc

        Returns:
            Dialog result on a given coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlCSSystem.Execute_TGIS_CSCoordinateSystem_TGIS_HelpEvent_TGIS_Proc
        """
        pass

    @overload
    def Execute(
      self,
      _cs: TGIS_CSCoordinateSystem,
      _area_epsg: int,
      _area_extent: TGIS_Extent,
      _onhelp: typing.Callable[[TObject, String], None],
      _proc: typing.Callable[[TGIS_PvlModalResult], None]
    ) -> TGIS_PvlModalResult: 
        """
        Execute dialog on a given coordinate system.

        Args:
            _cs: coordinate system
            _area_epsg: epsg area specification
            _area_extent: if _area_epsg is 0 or 1 then extent will be used to present systems 
              with matching area of use
            _onhelp: help notification function; if assigned the help button will be visible 
              and help support will be enabled; the value is a callback to a method with parameters 
              defined by TGIS_HelpEvent
            _proc: Action to be taken upon closing modal; the value is a callback to a method 
              with parameters defined by TGIS_Proc

        Returns:
            Dialog result on a given coordinate system

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlCSSystem.Execute_TGIS_CSCoordinateSystem_Integer_TGIS_Extent_TGIS_HelpEvent_TGIS_Proc
        """
        pass

    @property
    def CS(
      self
    ) -> TGIS_CSCoordinateSystem: 
        """
        Coordinate System assigned to the viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlControlCSSystem.CS
        """
        pass

class TGIS_PvlContextBase( TObject ):
    """
    Platform dependant context in which we operate.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContextBase
    """

    @overload
    def __init__(
      self,
      _parent: TObject,
      _ppi: int,
      _ppifix: float,
      _canvasscale: float,
      _righttoleft: bool,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Construct context.

        Args:
            _parent: Parent of the context
            _ppi: PPI parameter.
            _ppifix: Fix between HiRes and LoRes form size/pos calculations.
            _canvasscale: Canvas scale for proper rendering.
            _righttoleft: BiDi parameter to save RightToLeft pReferences to the context.
            _context: Context

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContextBase.Create_TObject_Integer_Single_Single_Boolean_TGIS_PvlContext
        """
        pass

    @overload
    def __init__(
      self,
      _parent: TObject,
      _context: TGIS_PvlContext
    ) -> None: 
        """
        Construct context.

        Args:
            _parent: parent of the context; form or a parent control
            _context: Context

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContextBase.Create_TObject_TGIS_PvlContext
        """
        pass

    @overload
    def __init__(
      self,
      _parent: TObject,
      _context: TGIS_PvlContext,
      _refcontext: TGIS_PvlContext
    ) -> None: 
        """
        Construct context.

        Args:
            _parent: parent of the context; form or a parent control
            _context: Context
            _refcontext: Context used to create this one

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContextBase.Create_TObject_TGIS_PvlContext_TGIS_PvlContext
        """
        pass

    def CreateCSDialog(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlControlCSSystem
    ) -> TGIS_PvlControlCSSystem: 
        """
        Create platform independent CS dialog.

        Args:
            _context: Parent context
            _self: Context

        Returns:
            Created CS dialog

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContextBase.CreateCSDialog_TGIS_PvlContext_TGIS_PvlControlCSSystem
        """
        pass

    def CreateErrorDialog(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlErrorDialog
    ) -> TGIS_PvlErrorDialog: 
        """
        Create platform independent error dialog.

        Args:
            _context: Parent context
            _self: Context

        Returns:
            Created error dialog

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContextBase.CreateErrorDialog_TGIS_PvlContext_TGIS_PvlErrorDialog
        """
        pass

    def CreateInfoDialog(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlInfoDialog
    ) -> TGIS_PvlInfoDialog: 
        """
        Create platform independent info dialog.

        Args:
            _context: Parent context
            _self: Context

        Returns:
            Created info dialog

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContextBase.CreateInfoDialog_TGIS_PvlContext_TGIS_PvlInfoDialog
        """
        pass

    def CreateLineSymbologyDialog(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlLineSymbolEditor
    ) -> TGIS_PvlLineSymbolEditor: 
        """
        Create platform independent Line Symbology dialog.

        Args:
            _context: Parent context
            _self: Context

        Returns:
            Created Line Symbology dialog

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContextBase.CreateLineSymbologyDialog_TGIS_PvlContext_TGIS_PvlLineSymbolEditor
        """
        pass

    def CreateOpenDialog(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlOpenDialog
    ) -> TGIS_PvlOpenDialog: 
        """
        Create platform independent open dialog.

        Args:
            _context: Parent context
            _self: Context

        Returns:
            Created open dialog

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContextBase.CreateOpenDialog_TGIS_PvlContext_TGIS_PvlOpenDialog
        """
        pass

    def CreateOptionDialog(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlOptionDialog
    ) -> TGIS_PvlOptionDialog: 
        """
        Create platform independent option dialog.

        Args:
            _context: Parent context
            _self: Context

        Returns:
            Created option dialog

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContextBase.CreateOptionDialog_TGIS_PvlContext_TGIS_PvlOptionDialog
        """
        pass

    def CreatePrintPreviewSimpleDialog(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlControlPrintPreviewSimple
    ) -> TGIS_PvlControlPrintPreviewSimple: 
        """
        Create platform independent Line Symbology dialog.

        Args:
            _context: Parent context
            _self: Context

        Returns:
            Created Line Symbology dialog

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContextBase.CreatePrintPreviewSimpleDialog_TGIS_PvlContext_TGIS_PvlControlPrintPreviewSimple
        """
        pass

    def CreateSaveDialog(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlSaveDialog
    ) -> TGIS_PvlSaveDialog: 
        """
        Create platform independent save dialog.

        Args:
            _context: Parent context
            _self: Context

        Returns:
            Created save dialog

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContextBase.CreateSaveDialog_TGIS_PvlContext_TGIS_PvlSaveDialog
        """
        pass

    def CreateSelectFolderDialog(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlSelectFolderDialog
    ) -> TGIS_PvlSelectFolderDialog: 
        """
        Create platform independent select folder dialog.

        Args:
            _context: Parent context
            _self: Context

        Returns:
            Created select folder dialog

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContextBase.CreateSelectFolderDialog_TGIS_PvlContext_TGIS_PvlSelectFolderDialog
        """
        pass

    def CreateWarningDialog(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlWarningDialog
    ) -> TGIS_PvlWarningDialog: 
        """
        Create platform independent warning dialog.

        Args:
            _context: Parent context
            _self: Context

        Returns:
            Created warning dialog

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContextBase.CreateWarningDialog_TGIS_PvlContext_TGIS_PvlWarningDialog
        """
        pass

    def Support(
      self,
      _parent: TObject
    ) -> bool: 
        """
        Check if object is supported by current context platform.

        Args:
            _parent: Object to be checked

        Returns:
            Returns True if supported

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContextBase.Support_TObject
        """
        pass

class TGIS_PvlContext( TGIS_PvlContextBase, IGIS_PvlContext ):
    """
    Platform dependant context in which we operate.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext
    """

    def ClientWidth(
      self
    ) -> int: 
        """
        Gets the width of the client area.

        Returns:
            Width of the client area

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.ClientWidth_void
        """
        pass

    def FreeContext(
      self
    ) -> None: 
        """
        A safe way to free context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.FreeContext_void
        """
        pass

    def GetAllFonts(
      self
    ) -> TGIS_StringList: 
        """
        Function to get all available and supported fonts for the platform.

        Returns:
            List of fonts names

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.GetAllFonts_void
        """
        pass

    def InitializeSystemForm(
      self,
      _context: TGIS_PvlContext,
      _self: TGIS_PvlSystemForm
    ) -> TGIS_PvlSystemForm: 
        """
        Initialize ModalForm.

        Args:
            _context: Parent context for the modal form
            _self: Context

        Returns:
            New form

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.InitializeSystemForm_TGIS_PvlContext_TGIS_PvlSystemForm
        """
        pass

    def Redraw(
      self
    ) -> None: 
        """
        Redraws all elements which are created on this context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.Redraw_void
        """
        pass

    def Refresh(
      self
    ) -> bool: 
        """
        Refresh the context.

        Returns:
            True if context has been refreshed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.Refresh_void
        """
        pass

    def UpdatePPI(
      self,
      _ppi: int,
      _ppiFix: float,
      _canvasScale: float
    ) -> None: 
        """
        Update PPI within this context

        Args:
            _ppi: New PPI.
            _ppiFix: New PPIFix.
            _canvasScale: New CanvasScale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.UpdatePPI_Integer_Single_Single
        """
        pass

    def UpdateRightToLeft(
      self,
      _rightToLeft: bool
    ) -> None: 
        """
        Update RightToLeft within this context

        Args:
            _rightToLeft: New RightToLeft.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.UpdateRightToLeft_Boolean
        """
        pass

    @property
    def SelfDelete(
      self
    ) -> bool: 
        """
        Delete self if true.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.SelfDelete
        """
        pass

    @SelfDelete.setter
    def SelfDelete(
      self,
      _value: bool
    ) -> None: 
        """
        Delete self if true.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.SelfDelete
        """
        pass

    @property
    def CanvasScale(
      self
    ) -> float: 
        """
        Canvas scale factor to create overrsized bitmaps like in FMX.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.CanvasScale
        """
        pass

    @property
    def Controls(
      self
    ) -> TGIS_PvlListOfElements: 
        """
        List of PVL controls which belongs to this context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.Controls
        """
        pass

    @property
    def HMargin(
      self
    ) -> int: 
        """
        Horizontal margin.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.HMargin
        """
        pass

    @HMargin.setter
    def HMargin(
      self,
      _value: int
    ) -> None: 
        """
        Horizontal margin.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.HMargin
        """
        pass

    @property
    def HSpace(
      self
    ) -> int: 
        """
        Horizontal space between controls.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.HSpace
        """
        pass

    @property
    def LSpace(
      self
    ) -> int: 
        """
        Horizontal space between labels and controls.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.LSpace
        """
        pass

    @property
    def NativeParent(
      self
    ) -> TObject: 
        """
        Parent of the context class.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.NativeParent
        """
        pass

    @property
    def Parent(
      self
    ) -> TGIS_PvlBase: 
        """
        Parent of the context class.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.Parent
        """
        pass

    @property
    def Platform(
      self
    ) -> IGIS_PvlContext: 
        """
        Underlying platform specific context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.Platform
        """
        pass

    @property
    def PPI(
      self
    ) -> int: 
        """
        Context Pixels Per Inch.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.PPI
        """
        pass

    @property
    def PPIFix(
      self
    ) -> float: 
        """
        Fix to match design units to actual form PPI like required in VCL.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.PPIFix
        """
        pass

    @property
    def RightToLeft(
      self
    ) -> bool: 
        """
        BiDi mode, Right to left if True.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.RightToLeft
        """
        pass

    @property
    def VMargin(
      self
    ) -> int: 
        """
        Vertical margin.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.VMargin
        """
        pass

    @VMargin.setter
    def VMargin(
      self,
      _value: int
    ) -> None: 
        """
        Vertical margin.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.VMargin
        """
        pass

    @property
    def VSpace(
      self
    ) -> int: 
        """
        Vertical space between controls.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlContext.VSpace
        """
        pass

class TGIS_PvlRGBVal:
    """
    RGB value

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRGBVal
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRGBVal.Create_void
        """
        pass

    @property
    def R(
      self
    ) -> int: 
        """
        Red value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRGBVal.R
        """
        pass

    @R.setter
    def R(
      self,
      _value: int
    ) -> None: 
        """
        Red value

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRGBVal.R
        """
        pass

    @property
    def G(
      self
    ) -> int: 
        """
        Green value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRGBVal.G
        """
        pass

    @G.setter
    def G(
      self,
      _value: int
    ) -> None: 
        """
        Green value

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRGBVal.G
        """
        pass

    @property
    def B(
      self
    ) -> int: 
        """
        Blue value

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRGBVal.B
        """
        pass

    @B.setter
    def B(
      self,
      _value: int
    ) -> None: 
        """
        Blue value

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlRGBVal.B
        """
        pass

class IGIS_PvlForm( IGIS_PvlBase ):
    """
    Basic interface for PVL forms.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.Create_void
        """
        pass

    def Close(
      self
    ) -> None: 
        """
        Close form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.Close_void
        """
        pass

    def doAfterPPIChanged(
      self
    ) -> None: 
        """
        Override this method to react if monitor PPI was changed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.doAfterPPIChanged_void
        """
        pass

    def doInitButtons(
      self
    ) -> None: 
        """
        Create standard form buttons.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.doInitButtons_void
        """
        pass

    def doPlaceButtons(
      self
    ) -> None: 
        """
        Place standard form buttons.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.doPlaceButtons_void
        """
        pass

    def DoRedraw(
      self
    ) -> None: 
        """
        Executed whenever GUI or DPI style is updated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.DoRedraw_void
        """
        pass

    def DoResize(
      self
    ) -> None: 
        """
        Executed whenever Form is resized.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.DoResize_void
        """
        pass

    def doShowForm(
      self
    ) -> None: 
        """
        Override this method to provide any special functionality upon form show.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.doShowForm_void
        """
        pass

    def doUpdateGUI(
      self
    ) -> None: 
        """
        Override this method to provide custom GUI updates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.doUpdateGUI_void
        """
        pass

    def FreeForm(
      self
    ) -> None: 
        """
        Dispose form

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.FreeForm_void
        """
        pass

    def Hide(
      self
    ) -> None: 
        """
        Hides in the app.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.Hide_void
        """
        pass

    def IsLocked(
      self
    ) -> bool: 
        """
        Recognizes the state of the window.

        Returns:
            True if window is locked from rendering.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.IsLocked_void
        """
        pass

    def LockWindow(
      self
    ) -> None: 
        """
        Locks window from rendering.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.LockWindow_void
        """
        pass

    def ProcessMessages(
      self
    ) -> None: 
        """
        Interrupts the execution of an application so that it can process the message queue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.ProcessMessages_void
        """
        pass

    @overload
    def Show(
      self
    ) -> None: 
        """
        Shows in the app.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.Show_void
        """
        pass

    @overload
    def Show(
      self,
      _free: bool
    ) -> None: 
        """
        Shows modal in the app.

        Args:
            _free: True, if dialog should be free upon close (same as Show() overload)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.Show_Boolean
        """
        pass

    def ShowModal(
      self
    ) -> TGIS_PvlModalResult: 
        """
        Shows modal in the app.

        Returns:
            Modal result.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.ShowModal_void
        """
        pass

    def UnlockWindow(
      self
    ) -> None: 
        """
        Unlocks window from rendering.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlForm.UnlockWindow_void
        """
        pass

class IGIS_PvlModalForm( IGIS_PvlForm ):
    """
    Interface for PVL modal forms.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlModalForm
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlModalForm.Create_void
        """
        pass

class IGIS_PvlModalWizard( IGIS_PvlModalForm ):
    """
    Interface for modal wizards.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlModalWizard
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlModalWizard.Create_void
        """
        pass

class TGIS_PvlBorderStyle:
    pass

class TGIS_PvlBorderStyle:
    """
    Style of border withing PVL Forms.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBorderStyle
    """

    @property
    def None_(
      self
    ) -> TGIS_PvlBorderStyle: 
        """
        No border.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBorderStyle.None
        """
        pass

    @property
    def Fixed(
      self
    ) -> TGIS_PvlBorderStyle: 
        """
        Fixed border.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBorderStyle.Fixed
        """
        pass

    @property
    def Sizeable(
      self
    ) -> TGIS_PvlBorderStyle: 
        """
        Sizeable border.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBorderStyle.Sizeable
        """
        pass

    @property
    def ToolWindow(
      self
    ) -> TGIS_PvlBorderStyle: 
        """
        Tollwindow border.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBorderStyle.ToolWindow
        """
        pass

    @property
    def ToolWindowSizeable(
      self
    ) -> TGIS_PvlBorderStyle: 
        """
        Sizeable toolwindow border.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBorderStyle.ToolWindowSizeable
        """
        pass

class TGIS_PvlBorderIcon:
    pass

class TGIS_PvlBorderIcon:
    """
    Style of icons withing PVL Forms.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBorderIcon
    """

    @property
    def SystemMenu(
      self
    ) -> TGIS_PvlBorderIcon: 
        """
        System menu icon.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBorderIcon.SystemMenu
        """
        pass

    @property
    def Minimize(
      self
    ) -> TGIS_PvlBorderIcon: 
        """
        Minimize icon.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBorderIcon.Minimize
        """
        pass

    @property
    def Maximize(
      self
    ) -> TGIS_PvlBorderIcon: 
        """
        Maximize icon.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBorderIcon.Maximize
        """
        pass

class TGIS_PvlBaseForm( TGIS_PvlBase, IGIS_PvlForm ):
    """
    Base PVL form from which we inherit in our forms.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm
    """

    @overload
    def __init__(
      self,
      _parent: TObject
    ) -> None: 
        """
        Constructor for the form with default border style and border icons.

        Args:
            _parent: Parent of the form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Create_TObject
        """
        pass

    @overload
    def __init__(
      self,
      _parent: TObject,
      _style: TGIS_PvlBorderStyle,
      _icons: typing.Sequence[TGIS_PvlBorderIcon]
    ) -> None: 
        """
        Constructor for the form.

        Args:
            _parent: Parent of the form.
            _style: Style of the border.
            _icons: Icons of the form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Create_TObject_TGIS_PvlBorderStyle_TGIS_PvlBorderIcons
        """
        pass

    def Close(
      self
    ) -> None: 
        """
        Close form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Close_void
        """
        pass

    def doShowForm(
      self
    ) -> None: 
        """
        Override this method to provide any special functionality upon form show.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.doShowForm_void
        """
        pass

    def FreeForm(
      self
    ) -> None: 
        """
        Dispose form

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.FreeForm_void
        """
        pass

    def Hide(
      self
    ) -> None: 
        """
        Hides in the app.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Hide_void
        """
        pass

    def IsLocked(
      self
    ) -> bool: 
        """
        Recognizes the state of the window.

        Returns:
            True if window is locked from rendering.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.IsLocked_void
        """
        pass

    def LockWindow(
      self
    ) -> None: 
        """
        Locks window from rendering.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.LockWindow_void
        """
        pass

    def ProcessMessages(
      self
    ) -> None: 
        """
        Interrupts the execution of an application so that it can process the message queue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.ProcessMessages_void
        """
        pass

    @overload
    def Show(
      self
    ) -> None: 
        """
        Shows in the app.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Show_void
        """
        pass

    @overload
    def Show(
      self,
      _free: bool
    ) -> None: 
        """
        Shows modal in the app.

        Args:
            _free: True, if dialog should be free upon close (same as Show() overload)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Show_Boolean
        """
        pass

    @overload
    def ShowModal(
      self,
      _proc: typing.Callable[[TGIS_PvlModalResult], None],
      _free: bool
    ) -> TGIS_PvlModalResult: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.ShowModal_TGIS_Proc_Boolean
        """
        pass

    @overload
    def ShowModal(
      self
    ) -> TGIS_PvlModalResult: 
        """
        Shows modal in the app.

        Returns:
            Modal result.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.ShowModal_void
        """
        pass

    def UnlockWindow(
      self
    ) -> None: 
        """
        Unlocks window from rendering.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.UnlockWindow_void
        """
        pass

    @property
    def BorderIcons(
      self
    ) -> typing.Sequence[TGIS_PvlBorderIcon]: 
        """
        BorderIcons of the form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.BorderIcons
        """
        pass

    @property
    def BorderStyle(
      self
    ) -> TGIS_PvlBorderStyle: 
        """
        BorderStyle of the form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.BorderStyle
        """
        pass

    @property
    def CanvasScale(
      self
    ) -> float: 
        """
        Form Canvas scale,

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.CanvasScale
        """
        pass

    @property
    def Caption(
      self
    ) -> str: 
        """
        Title caption of the form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Caption
        """
        pass

    @Caption.setter
    def Caption(
      self,
      _value: str
    ) -> None: 
        """
        Title caption of the form.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Caption
        """
        pass

    @property
    def ClientHeight(
      self
    ) -> int: 
        """
        Form client height.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.ClientHeight
        """
        pass

    @ClientHeight.setter
    def ClientHeight(
      self,
      _value: int
    ) -> None: 
        """
        Form client height.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.ClientHeight
        """
        pass

    @property
    def ClientWidth(
      self
    ) -> int: 
        """
        Form client width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.ClientWidth
        """
        pass

    @ClientWidth.setter
    def ClientWidth(
      self,
      _value: int
    ) -> None: 
        """
        Form client width.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.ClientWidth
        """
        pass

    @property
    def Context(
      self
    ) -> TGIS_PvlContext: 
        """
        Context of the form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Context
        """
        pass

    @property
    def Height(
      self
    ) -> int: 
        """
        Form height.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Height
        """
        pass

    @Height.setter
    def Height(
      self,
      _value: int
    ) -> None: 
        """
        Form height.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Height
        """
        pass

    @property
    def Left(
      self
    ) -> int: 
        """
        Form left coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Left
        """
        pass

    @Left.setter
    def Left(
      self,
      _value: int
    ) -> None: 
        """
        Form left coordinates.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Left
        """
        pass

    @property
    def MinHeight(
      self
    ) -> int: 
        """
        Form min client height.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.MinHeight
        """
        pass

    @MinHeight.setter
    def MinHeight(
      self,
      _value: int
    ) -> None: 
        """
        Form min client height.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.MinHeight
        """
        pass

    @property
    def MinWidth(
      self
    ) -> int: 
        """
        Form min client width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.MinWidth
        """
        pass

    @MinWidth.setter
    def MinWidth(
      self,
      _value: int
    ) -> None: 
        """
        Form min client width.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.MinWidth
        """
        pass

    @property
    def ModalResult(
      self
    ) -> TGIS_PvlModalResult: 
        """
        Result of the modal form show operation

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.ModalResult
        """
        pass

    @ModalResult.setter
    def ModalResult(
      self,
      _value: TGIS_PvlModalResult
    ) -> None: 
        """
        Result of the modal form show operation

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.ModalResult
        """
        pass

    @property
    def Name(
      self
    ) -> str: 
        """
        Nameof the form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Name
        """
        pass

    @Name.setter
    def Name(
      self,
      _value: str
    ) -> None: 
        """
        Nameof the form.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Name
        """
        pass

    @property
    def PPI(
      self
    ) -> int: 
        """
        Form PPI.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.PPI
        """
        pass

    @property
    def PPIFix(
      self
    ) -> float: 
        """
        Form PPI fix.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.PPIFix
        """
        pass

    @property
    def RightToLeft(
      self
    ) -> bool: 
        """
        Form component orientation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.RightToLeft
        """
        pass

    @property
    def StayOnTop(
      self
    ) -> bool: 
        """
        True if form should always stay on top.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.StayOnTop
        """
        pass

    @StayOnTop.setter
    def StayOnTop(
      self,
      _value: bool
    ) -> None: 
        """
        True if form should always stay on top.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.StayOnTop
        """
        pass

    @property
    def Top(
      self
    ) -> int: 
        """
        Form right coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Top
        """
        pass

    @Top.setter
    def Top(
      self,
      _value: int
    ) -> None: 
        """
        Form right coordinates.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Top
        """
        pass

    @property
    def Visible(
      self
    ) -> bool: 
        """
        Form visibility.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Visible
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        Form width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Width
        """
        pass

    @Width.setter
    def Width(
      self,
      _value: int
    ) -> None: 
        """
        Form width.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.Width
        """
        pass

    @property
    def OnClose(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Event to bi fired upon form close.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.OnClose
        """
        pass

    @OnClose.setter
    def OnClose(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Event to bi fired upon form close.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.OnClose
        """
        pass

    @property
    def OnShow(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Event to bi fired upon form show.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.OnShow
        """
        pass

    @OnShow.setter
    def OnShow(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Event to bi fired upon form show.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlBaseForm.OnShow
        """
        pass

class TGIS_PvlForm( TGIS_PvlBaseForm ):
    """
    General use form made in PVL.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlForm
    """

    @overload
    def __init__(
      self,
      _parent: TObject
    ) -> None: 
        """
        Constructor for the form with default border style and border icons.

        Args:
            _parent: Parent of the form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlForm.Create_TObject
        """
        pass

    @overload
    def __init__(
      self,
      _parent: TObject,
      _style: TGIS_PvlBorderStyle,
      _icons: typing.Sequence[TGIS_PvlBorderIcon]
    ) -> None: 
        """
        Constructor for the form.

        Args:
            _parent: Parent of the form.
            _style: Style of the border.
            _icons: Icons of the form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlForm.Create_TObject_TGIS_PvlBorderStyle_TGIS_PvlBorderIcons
        """
        pass

class TGIS_PvlModalForm( TGIS_PvlBaseForm, IGIS_PvlModalForm ):
    """
    Modal form made in PVL.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalForm
    """

    @overload
    def __init__(
      self,
      _parent: TObject
    ) -> None: 
        """
        Constructor for the form with default border style and border icons.

        Args:
            _parent: Parent of the form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalForm.Create_TObject
        """
        pass

    @property
    def BtnCancel(
      self
    ) -> TGIS_PvlModalButton: 
        """
        Accessor for the Cancel button.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalForm.BtnCancel
        """
        pass

    @property
    def BtnHelp(
      self
    ) -> TGIS_PvlModalButton: 
        """
        Accessor for the help button.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalForm.BtnHelp
        """
        pass

    @property
    def BtnOK(
      self
    ) -> TGIS_PvlModalButton: 
        """
        Accessor for the OK button.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalForm.BtnOK
        """
        pass

    @property
    def OnHelpEvent(
      self
    ) -> typing.Callable[[TObject, String], None]: 
        """
        Accessor for the help event.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalForm.OnHelpEvent
        """
        pass

    @OnHelpEvent.setter
    def OnHelpEvent(
      self,
      _value: typing.Callable[[TObject, String], None]
    ) -> None: 
        """
        Accessor for the help event.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalForm.OnHelpEvent
        """
        pass

class TGIS_PvlModalWizard( TGIS_PvlBaseForm, IGIS_PvlModalWizard ):
    """
    Modal wizard made in PVL.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalWizard
    """

    @overload
    def __init__(
      self,
      _parent: TObject
    ) -> None: 
        """
        Constructor for the form with default border style and border icons.

        Args:
            _parent: Parent of the form.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalWizard.Create_TObject
        """
        pass

    @property
    def BtnCancel(
      self
    ) -> TGIS_PvlModalButton: 
        """
        Accessor for the Cancel button.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalWizard.BtnCancel
        """
        pass

    @property
    def BtnHelp(
      self
    ) -> TGIS_PvlModalButton: 
        """
        Accessor for the Help button.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalWizard.BtnHelp
        """
        pass

    @property
    def BtnNext(
      self
    ) -> TGIS_PvlModalButton: 
        """
        Accessor for the Next button.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalWizard.BtnNext
        """
        pass

    @property
    def BtnOK(
      self
    ) -> TGIS_PvlModalButton: 
        """
        Accessor for the OK button.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalWizard.BtnOK
        """
        pass

    @property
    def BtnPrevious(
      self
    ) -> TGIS_PvlModalButton: 
        """
        Accessor for the Previous button.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalWizard.BtnPrevious
        """
        pass

    @property
    def Pages(
      self
    ) -> TGIS_PvlPages: 
        """
        Pages acessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalWizard.Pages
        """
        pass

    @property
    def OnHelpEvent(
      self
    ) -> typing.Callable[[TObject, String], None]: 
        """
        Accessor for the Help event.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalWizard.OnHelpEvent
        """
        pass

    @OnHelpEvent.setter
    def OnHelpEvent(
      self,
      _value: typing.Callable[[TObject, String], None]
    ) -> None: 
        """
        Accessor for the Help event.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlModalWizard.OnHelpEvent
        """
        pass

class TGIS_PvlLabeledEdit( TGIS_PvlControl, IGIS_PvlControl ):
    """
    PVL labeled edit widget

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledEdit
    """

    @property
    def Edit(
      self
    ) -> TGIS_PvlEdit: 
        """
        Label property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledEdit.Edit
        """
        pass

    @Edit.setter
    def Edit(
      self,
      _value: TGIS_PvlEdit
    ) -> None: 
        """
        Label property

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledEdit.Edit
        """
        pass

    @property
    def Label(
      self
    ) -> TGIS_PvlLabel: 
        """
        Label property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledEdit.Label
        """
        pass

    @Label.setter
    def Label(
      self,
      _value: TGIS_PvlLabel
    ) -> None: 
        """
        Label property

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledEdit.Label
        """
        pass

class TGIS_PvlLabeledSelectCombo( TGIS_PvlControl, IGIS_PvlControl ):
    """
    PVL labeled combobox widget

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledSelectCombo
    """

    @property
    def ComboBox(
      self
    ) -> TGIS_PvlComboBox: 
        """
        Label property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledSelectCombo.ComboBox
        """
        pass

    @ComboBox.setter
    def ComboBox(
      self,
      _value: TGIS_PvlComboBox
    ) -> None: 
        """
        Label property

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledSelectCombo.ComboBox
        """
        pass

    @property
    def Label(
      self
    ) -> TGIS_PvlLabel: 
        """
        Label property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledSelectCombo.Label
        """
        pass

    @Label.setter
    def Label(
      self,
      _value: TGIS_PvlLabel
    ) -> None: 
        """
        Label property

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledSelectCombo.Label
        """
        pass

class TGIS_PvlLabeledEditCombo( TGIS_PvlControl, IGIS_PvlControl ):
    """
    PVL labeled editable combobox widget

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledEditCombo
    """

    @property
    def ComboBox(
      self
    ) -> TGIS_PvlComboEdit: 
        """
        Label property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledEditCombo.ComboBox
        """
        pass

    @ComboBox.setter
    def ComboBox(
      self,
      _value: TGIS_PvlComboEdit
    ) -> None: 
        """
        Label property

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledEditCombo.ComboBox
        """
        pass

    @property
    def Label(
      self
    ) -> TGIS_PvlLabel: 
        """
        Label property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledEditCombo.Label
        """
        pass

    @Label.setter
    def Label(
      self,
      _value: TGIS_PvlLabel
    ) -> None: 
        """
        Label property

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledEditCombo.Label
        """
        pass

class TGIS_PvlLabeledColorCombo( TGIS_PvlControl, IGIS_PvlControl ):
    """
    PVL labeled editable combobox widget

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledColorCombo
    """

    @property
    def ComboBox(
      self
    ) -> TGIS_PvlColorComboBox: 
        """
        Label property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledColorCombo.ComboBox
        """
        pass

    @ComboBox.setter
    def ComboBox(
      self,
      _value: TGIS_PvlColorComboBox
    ) -> None: 
        """
        Label property

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledColorCombo.ComboBox
        """
        pass

    @property
    def Label(
      self
    ) -> TGIS_PvlLabel: 
        """
        Label property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledColorCombo.Label
        """
        pass

    @Label.setter
    def Label(
      self,
      _value: TGIS_PvlLabel
    ) -> None: 
        """
        Label property

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlLabeledColorCombo.Label
        """
        pass

class TGIS_PvlColorRampWidget( TGIS_PvlControl, IGIS_PvlControl ):
    """
    PVL color ramp widget.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget
    """

    def Fill(
      self
    ) -> None: 
        """
        Fill the control with data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.Fill_void
        """
        pass

    def Lock(
      self
    ) -> None: 
        """
        Locks combobox from updates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.Lock_void
        """
        pass

    def Unlock(
      self
    ) -> None: 
        """
        Unlocks combobox from updates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.Unlock_void
        """
        pass

    def Value(
      self,
      _subClass: int
    ) -> TGIS_ColorMapArray: 
        """
        Color map value.

        Args:
            _subClass: get subclass of a ramp with specified number of colors, if available; 
              if 0, get default colormap; if -1, get subclass with maximum number of colors;

        Returns:
            Array of colormap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.Value_Integer
        """
        pass

    @property
    def ColorSchemas(
      self
    ) -> typing.Sequence[TGIS_ColorSchema]: 
        """
        Color schema filter.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.ColorSchemas
        """
        pass

    @ColorSchemas.setter
    def ColorSchemas(
      self,
      _value: typing.Sequence[TGIS_ColorSchema]
    ) -> None: 
        """
        Color schema filter.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.ColorSchemas
        """
        pass

    @ComboHeight.setter
    def ComboHeight(
      self,
      _value: int
    ) -> None: 
        """
        Height of the ramp combobox, has to be set before place method.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.ComboHeight
        """
        pass

    @property
    def Discrete(
      self
    ) -> bool: 
        """
        Discrete ramps.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.Discrete
        """
        pass

    @Discrete.setter
    def Discrete(
      self,
      _value: bool
    ) -> None: 
        """
        Discrete ramps.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.Discrete
        """
        pass

    @property
    def DiscreteVisible(
      self
    ) -> bool: 
        """
        If true then show Discrete checkbox

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.DiscreteVisible
        """
        pass

    @DiscreteVisible.setter
    def DiscreteVisible(
      self,
      _value: bool
    ) -> None: 
        """
        If true then show Discrete checkbox

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.DiscreteVisible
        """
        pass

    @property
    def ItemCount(
      self
    ) -> int: 
        """
        Ramp count.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.ItemCount
        """
        pass

    @property
    def ItemIndex(
      self
    ) -> int: 
        """
        Ramp index.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.ItemIndex
        """
        pass

    @ItemIndex.setter
    def ItemIndex(
      self,
      _value: int
    ) -> None: 
        """
        Ramp index.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.ItemIndex
        """
        pass

    
    def Items(
      self,
      _idx: int
    ) -> str: 
        """
        Item accessor.

        Args:
            _idx: ID of the item you want to get

        Returns:
            

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.Items
        """
        pass

    @property
    def Mode(
      self
    ) -> TGIS_ColorMapMode: 
        """
        ColorMap mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.Mode
        """
        pass

    @Mode.setter
    def Mode(
      self,
      _value: TGIS_ColorMapMode
    ) -> None: 
        """
        ColorMap mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.Mode
        """
        pass

    @property
    def Reverse(
      self
    ) -> bool: 
        """
        Reverse colormap.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.Reverse
        """
        pass

    @Reverse.setter
    def Reverse(
      self,
      _value: bool
    ) -> None: 
        """
        Reverse colormap.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.Reverse
        """
        pass

    @property
    def ReverseVisible(
      self
    ) -> bool: 
        """
        If true then show Reverse checkbox

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.ReverseVisible
        """
        pass

    @ReverseVisible.setter
    def ReverseVisible(
      self,
      _value: bool
    ) -> None: 
        """
        If true then show Reverse checkbox

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.ReverseVisible
        """
        pass

    @property
    def ShowAll(
      self
    ) -> bool: 
        """
        Show all ramps.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.ShowAll
        """
        pass

    @ShowAll.setter
    def ShowAll(
      self,
      _value: bool
    ) -> None: 
        """
        Show all ramps.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.ShowAll
        """
        pass

    @property
    def ShowAllVisible(
      self
    ) -> bool: 
        """
        If true then show ShowAll checkbox

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.ShowAllVisible
        """
        pass

    @ShowAllVisible.setter
    def ShowAllVisible(
      self,
      _value: bool
    ) -> None: 
        """
        If true then show ShowAll checkbox

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.ShowAllVisible
        """
        pass

    @property
    def ShowNames(
      self
    ) -> bool: 
        """
        Show captions for ramps.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.ShowNames
        """
        pass

    @ShowNames.setter
    def ShowNames(
      self,
      _value: bool
    ) -> None: 
        """
        Show captions for ramps.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.ShowNames
        """
        pass

    @property
    def ShowNamesVisible(
      self
    ) -> bool: 
        """
        If true then show ShowNames checkbox

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.ShowNamesVisible
        """
        pass

    @ShowNamesVisible.setter
    def ShowNamesVisible(
      self,
      _value: bool
    ) -> None: 
        """
        If true then show ShowNames checkbox

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.ShowNamesVisible
        """
        pass

    @property
    def TwoColumns(
      self
    ) -> bool: 
        """
        If true, then checkboxes are placed in two columns, has to be set before place method.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.TwoColumns
        """
        pass

    @TwoColumns.setter
    def TwoColumns(
      self,
      _value: bool
    ) -> None: 
        """
        If true, then checkboxes are placed in two columns, has to be set before place method.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.TwoColumns
        """
        pass

    @property
    def OnChange(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        OnChange event accessor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.OnChange
        """
        pass

    @OnChange.setter
    def OnChange(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        OnChange event accessor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlColorRampWidget.OnChange
        """
        pass

class IGIS_PvlViewerBmp( IGIS_PvlObject ):
    """
    PVL BMP Viewer intraface

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlViewerBmp
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlViewerBmp.Create_void
        """
        pass

    @overload
    def PrintBmp(
      self,
      _bmp: VarParameter
    ) -> None: 
        """
        Print the current content on a bitmap. Print area will match the current VisibleExtent 
        of the control.

        Args:
            _bmp: bitmap on which the drawing will be performed; the value (in/out) is passed 
              as TGIS_Bitmap in _bmp.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlViewerBmp.PrintBmp_TGIS_Bitmap
        """
        pass

    @overload
    def PrintBmp(
      self,
      _bmp: VarParameter,
      _full: bool
    ) -> None: 
        """
        Print the current content on a bitmap. Print area will match the current VisibleExtent 
        of the control.

        Args:
            _bmp: bitmap on which the drawing will be performed; the value (in/out) is passed 
              as TGIS_Bitmap in _bmp.Value property
            _full: if yes, all paint events are triggered

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlViewerBmp.PrintBmp_TGIS_Bitmap_Boolean
        """
        pass

class TGIS_PvlViewerBmp( TGIS_PvlObject, IGIS_PvlViewerBmp, IGIS_Viewer, IGIS_ViewerBmp ):
    """
    PVL GIS BMP Viewer control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        Standard constructor. Creates bitmap 320x240.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Create_void
        """
        pass

    @overload
    def __init__(
      self,
      _width: int,
      _height: int
    ) -> None: 
        """
        Create an instance based on provided dimensions.

        Args:
            _width: bitmap width in pixels
            _height: bitmap height in pixels

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Create_Integer_Integer
        """
        pass

    def Add(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Add a layer to the Viewer.

        Args:
            _layer: layer to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Add_TGIS_LayerAbstract
        """
        pass

    def AddHierarchy(
      self
    ) -> None: 
        """
        Read hierarchy and build groups with layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.AddHierarchy_void
        """
        pass

    def AttachLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> IGIS_Viewer: 
        """
        Attach layer to the viewer by re-parenting.

        Args:
            _layer: layer to be attached

        Returns:
            Previous parent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.AttachLayer_TGIS_LayerAbstract
        """
        pass

    def BeginPaintInternal(
      self
    ) -> None: 
        """
        Notify viewer about entering of a paint mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BeginPaintInternal_void
        """
        pass

    def BusyPrepare(
      self,
      _sender: TObject,
      _text: str
    ) -> None: 
        """
        Prepare BusyEvent for long-term operation.

        Args:
            _sender: component which is causing long-term operations
            _text: text to appear in a BusyText property; predefined GIS_BUSY_NOEVENTS and GIS_BUSY_NOHOURGLASS 
              could be used to define "silent" busy state; in such state BusyEvent will not be 
              called and, in a case of GIS_BUSY_NOHOURGLASS, hourglass will not be displayed and 
              check for interrupt as well.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BusyPrepare_TObject_String
        """
        pass

    def BusyRelease(
      self,
      _sender: TObject
    ) -> None: 
        """
        Release Busy state.

        Args:
            _sender: component which is causing long-term operations

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BusyRelease_TObject
        """
        pass

    def BusyShake(
      self,
      _sender: TObject,
      _pos: int,
      _end: int,
      _abort: VarParameter
    ) -> None: 
        """
        Shake Busy state.

        Args:
            _sender: component which is causing long-term operations
            _pos: current progress
            _end: maximal progress value
            _abort: if set to True inside message handler then an abort request.; the value (in/out) 
              is passed as bool in _abort.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BusyShake_TObject_Int64_Int64_Boolean
        """
        pass

    def CenterViewport(
      self,
      _ptg: TGIS_Point
    ) -> None: 
        """
        Set viewport to the vale when _ptg will be visible on the center of the screen. Same 
        as property Center

        Args:
            _ptg: coordinates in map units

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.CenterViewport_TGIS_Point
        """
        pass

    def ChangeHash(
      self
    ) -> int: 
        """
        Change hash. Uses to verify if order of layers, params, etc. has been modified. Used 
        mainly by TGIS_ControlLegend.

        Returns:
            Calculated hash value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ChangeHash_void
        """
        pass

    def Clear(
      self
    ) -> None: 
        """
        Clear a bitmap and prepare background color and picture.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Clear_void
        """
        pass

    def Close(
      self
    ) -> None: 
        """
        Close a project.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Close_void
        """
        pass

    def Delete(
      self,
      _name: str
    ) -> None: 
        """
        Delete the layer identified by a name.

        Args:
            _name: name of layer to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Delete_String
        """
        pass

    @overload
    def Draw(
      self,
      _renderer: TObject,
      _mode: TGIS_DrawMode
    ) -> None: 
        """
        Draw all layers on a current renderer.

        Args:
            _renderer: renderer context
            _mode: drawing mode: which set of layers should be rendered

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Draw_TObject_TGIS_DrawMode
        """
        pass

    @overload
    def Draw(
      self
    ) -> None: 
        """
        Draw a current extent on a bitmap.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Draw_void
        """
        pass

    def EndPaintInternal(
      self
    ) -> None: 
        """
        Notify viewer about leaving of a paint mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.EndPaintInternal_void
        """
        pass

    def FullExtent(
      self
    ) -> None: 
        """
        Calculate the screen origin, zoom, and viewport to place the whole map in the window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.FullExtent_void
        """
        pass

    def FullExtentZoom(
      self
    ) -> float: 
        """
        Calculates a zoom which places the whole map inside the window

        Returns:
            Zoom value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.FullExtentZoom_void
        """
        pass

    def Get(
      self,
      _name: str
    ) -> TGIS_LayerAbstract: 
        """
        Retrieve the layer identified by a name. Sublayer or compund layers can be found 
        by do notation like ''name.sublyer''

        Args:
            _name: name of layer to be found

        Returns:
            Found layer or nil if not found.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Get_String
        """
        pass

    def GetGrid(
      self,
      _extent: TGIS_Extent,
      _grid: TGIS_GridArray
    ) -> bool: 
        """
        Fills provided _grid array with values defined by _extent. If extent is not fully 
        covered by the gird layers then values outside the layers scope will be left untouched.

        Args:
            _extent: extent of the _grid
            _grid: allocated array (with/height ratio of the _grid should be the same as width/height 
              ration of the _extent)

        Returns:
            True if success.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.GetGrid_TGIS_Extent_TGIS_GridArray
        """
        pass

    def GetRenderContext(
      self
    ) -> TObject: 
        """
        Return current context object.

        Returns:
            Current renderer context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.GetRenderContext_void
        """
        pass

    def HourglassActive(
      self
    ) -> bool: 
        """
        Test is hourglass is active.

        Returns:
            True is Hourglass is visible and Interrupt can be called.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.HourglassActive_void
        """
        pass

    def HourglassPrepare(
      self
    ) -> None: 
        """
        Prepare Hourglass cursor for timely operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.HourglassPrepare_void
        """
        pass

    def HourglassRelease(
      self
    ) -> None: 
        """
        Release Hourglass.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.HourglassRelease_void
        """
        pass

    def HourglassRestart(
      self
    ) -> None: 
        """
        Restart hourglass timing used for progressive updates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.HourglassRestart_void
        """
        pass

    def HourglassShake(
      self
    ) -> bool: 
        """
        Shake Hourglass.

        Returns:
            If True then current operation should be interrupted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.HourglassShake_void
        """
        pass

    def Interrupt(
      self
    ) -> None: 
        """
        Will terminate timely operation as soon as possible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Interrupt_void
        """
        pass

    def Interrupted(
      self
    ) -> bool: 
        """
        Test if any pending operation must be aborted.

        Returns:
            True is if any lengy;lu operation must be aborted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Interrupted_void
        """
        pass

    def InvalidateBasemap(
      self
    ) -> None: 
        """
        Invalidate only basemap layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.InvalidateBasemap_void
        """
        pass

    def InvalidateEditor(
      self,
      _final: bool
    ) -> None: 
        """
        Invalidate editor. To mark viewer after editor change to redraw state.

        Args:
            _final: True if map must updated at the end of editing process; otherwise a normal 
              "shallow" screen refresh to be performed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.InvalidateEditor_Boolean
        """
        pass

    @overload
    def InvalidateExtent(
      self,
      _extent: TGIS_Extent
    ) -> None: 
        """
        Invalidate an extent for full map redraw

        Args:
            _extent: extent to redraw

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.InvalidateExtent_TGIS_Extent
        """
        pass

    @overload
    def InvalidateExtent(
      self,
      _extent: TGIS_Extent,
      _deep: bool
    ) -> None: 
        """
        Invalidate an extent.

        Args:
            _extent: extent to redraw
            _deep: True if whole map must marked for update; if False then only shallow repaint 
              will be issued (only topmost layers)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.InvalidateExtent_TGIS_Extent_Boolean
        """
        pass

    def InvalidateSelection(
      self
    ) -> None: 
        """
        Invalidate selection. To mark viewer after selection change to redraw state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.InvalidateSelection_void
        """
        pass

    def InvalidateTopmost(
      self
    ) -> None: 
        """
        Invalidate only topmost layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.InvalidateTopmost_void
        """
        pass

    def InvalidateWholeMap(
      self
    ) -> None: 
        """
        Invalidate whole map. All layers must be updated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.InvalidateWholeMap_void
        """
        pass

    @overload
    def Locate(
      self,
      _ptg: TGIS_Point,
      _prec: float
    ) -> TGIS_ShapeAbstract: 
        """
        Locate a shape that is near _ptg, but is closer than _prec distance.

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in map units

        Returns:
            Located shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Locate_TGIS_Point_Double
        """
        pass

    @overload
    def Locate(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _visible: bool
    ) -> TGIS_ShapeAbstract: 
        """
        Locate a shape that is near _ptg, but is closer than _prec distance.

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in map units
            _visible: if true the only visible shapes will be evaluated; shapes turned of by 
              query of hidden will be ignored

        Returns:
            Located shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Locate_TGIS_Point_Double_Boolean
        """
        pass

    @overload
    def Locate(
      self,
      _pt: TPoint,
      _prec: int
    ) -> TGIS_ShapeAbstract: 
        """
        Locate a shape that is near _pt, but is closer than _prec distance.

        Args:
            _pt: reference point /searching point/ in pixels
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in pixels

        Returns:
            Located shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Locate_TPoint_Integer
        """
        pass

    def LocateEx(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _visible: bool
    ) -> TGIS_ShapeAbstractList: 
        """
        Locate shapes on layers that are near _ptg, but closer than _prec distance. Still 
        only the best one candidate is chosen from each layer.

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in map units
            _visible: if true the only visible shapes will be evaluated; shapes turned of by 
              query of hidden will be ignored

        Returns:
            Allocated list of shapes from all viewer layers

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.LocateEx_TGIS_Point_Double_Boolean
        """
        pass

    def Lock(
      self
    ) -> None: 
        """
        Lock viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Lock_void
        """
        pass

    def MapToScreen(
      self,
      _ptg: TGIS_Point
    ) -> TPoint: 
        """
        Converts point coordinates from map related to screen related.

        Args:
            _ptg: coordinate in map units

        Returns:
            Map coordinates converted to screen coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.MapToScreen_TGIS_Point
        """
        pass

    def MapToScreen3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TPoint: 
        """
        Converts 3D point coordinates from map related to screen related.

        Args:
            _ptg: coordinate in map units

        Returns:
            Map coordinates converted to screen coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.MapToScreen3D_TGIS_Point3D
        """
        pass

    def MapToScreenEx(
      self,
      _pt: TGIS_Point
    ) -> TGIS_Point: 
        """
        Converts point coordinates from map related to screen related, but result will be 
        in TGIS_Point.

        Args:
            _pt: coordinate in map units

        Returns:
            map coordinates converted to screen coordinates

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.MapToScreenEx_TGIS_Point
        """
        pass

    def MapToScreenRect(
      self,
      _rct: TGIS_Extent
    ) -> TRect: 
        """
        Converts rectangle coordinates from map related to screen related.

        Args:
            _rct: coordinate in map units

        Returns:
            Calculated screen rectangle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.MapToScreenRect_TGIS_Extent
        """
        pass

    def MarkModified(
      self
    ) -> None: 
        """
        Mark viewer upon some modifications.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.MarkModified_void
        """
        pass

    def MoveViewport(
      self,
      _dx: VarParameter,
      _dy: VarParameter
    ) -> None: 
        """
        Move the screen origin of the map by delta values.

        Args:
            _dx: x delta in pixels; the value (in/out) is passed as int in _dx.Value property
            _dy: y delta in pixels; the value (in/out) is passed as int in _dy.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.MoveViewport_Integer_Integer
        """
        pass

    def MoveViewportEx(
      self,
      _dx: VarParameter,
      _dy: VarParameter
    ) -> None: 
        """
        Move the screen origin of the map by delta values.

        Args:
            _dx: x delta in map units; the value (in/out) is passed as float in _dx.Value property
            _dy: y delta in map units; the value (in/out) is passed as float in _dy.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.MoveViewportEx_Double_Double
        """
        pass

    def MustSave(
      self
    ) -> bool: 
        """
        Check if any layer or the project file was modified by editing.

        Returns:
            True if project should be saved.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.MustSave_void
        """
        pass

    def NotifySubscribers(
      self,
      _event: int,
      _context: TObject
    ) -> None: 
        """
        Send notification to subscribers.

        Args:
            _event: event identifying number
            _context: control context; what is expected depends on _event; it can be canvas, 
              control itself.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.NotifySubscribers_Integer_TObject
        """
        pass

    @overload
    def Open(
      self,
      _path: str
    ) -> None: 
        """
        Open project.

        Args:
            _path: project path (or layer)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Open_String
        """
        pass

    @overload
    def Open(
      self,
      _path: str,
      _strict: bool
    ) -> None: 
        """
        Open project.

        Args:
            _path: project path (or layer)
            _strict: if False then non existing layers will be ignored (only while opening project 
              files); default is True ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Open_String_Boolean
        """
        pass

    @overload
    def OpenEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str
    ) -> None: 
        """
        Open project file from the memory.

        Args:
            _configFile: project file
            _path: project path (or layer)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.OpenEx_TGIS_ConfigAbstract_String
        """
        pass

    @overload
    def OpenEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str,
      _strict: bool
    ) -> None: 
        """
        Open project file from the memory.

        Args:
            _configFile: project file
            _path: project path (or layer)
            _strict: if False then non existing layers will be ignored (only while opening project 
              files); default is True ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.OpenEx_TGIS_ConfigAbstract_String_Boolean
        """
        pass

    def PixelsToTwips(
      self,
      _size: int
    ) -> int: 
        """
        Convert size from device dependent pixels to device independent Twips (1/1440 inch). 
        Used to make map device independent.

        Args:
            _size: size in pixels; absolute value will be taken

        Returns:
            Size in twips.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.PixelsToTwips_Integer
        """
        pass

    @overload
    def PrintBmp(
      self,
      _bmp: VarParameter
    ) -> None: 
        """
        Print the current content on a bitmap. Print area will match the current VisibleExtent 
        of the control.

        Args:
            _bmp: bitmap on which the drawing will be performed; the value (in/out) is passed 
              as TGIS_Bitmap in _bmp.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.PrintBmp_TGIS_Bitmap
        """
        pass

    @overload
    def PrintBmp(
      self,
      _bmp: VarParameter,
      _full: bool
    ) -> None: 
        """
        Print the current content on a bitmap. Print area will match the current VisibleExtent 
        of the control.

        Args:
            _bmp: bitmap on which the drawing will be performed; the value (in/out) is passed 
              as TGIS_Bitmap in _bmp.Value property
            _full: if yes, all paint events are triggered

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.PrintBmp_TGIS_Bitmap_Boolean
        """
        pass

    def RaiseBusyEvent(
      self,
      _sender: TObject,
      _pos: int,
      _end: int,
      _abort: VarParameter
    ) -> None: 
        """
        Fire Busy event of a viewer.

        Args:
            _sender: component which is causing long-term operations
            _pos: current progress
            _end: maximal progress value
            _abort: if set to True inside message handler then an abort request.; the value (in/out) 
              is passed as bool in _abort.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RaiseBusyEvent_TObject_Int64_Int64_Boolean
        """
        pass

    def RaiseHelpEvent(
      self,
      _sender: TObject,
      _name: str
    ) -> None: 
        """
        Fire Busy event of a viewer.

        Args:
            _sender: component asking for help
            _name: help context

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RaiseHelpEvent_TObject_String
        """
        pass

    def ReadConfig(
      self
    ) -> None: 
        """
        Read all configuration data from project.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ReadConfig_void
        """
        pass

    def RecalcExtent(
      self
    ) -> None: 
        """
        Calculates a common extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RecalcExtent_void
        """
        pass

    def ReParent(
      self,
      _parent: IGIS_ViewerParent
    ) -> IGIS_ViewerParent: 
        """
        Set a new parent for the viewer.

        Args:
            _parent: new parent object

        Returns:
            Previous parent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ReParent_IGIS_ViewerParent
        """
        pass

    def Reposition(
      self
    ) -> None: 
        """
        Reposition the map within the component window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Reposition_void
        """
        pass

    def RereadConfig(
      self
    ) -> None: 
        """
        Reread all configuration data from project and layer configuration files.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RereadConfig_void
        """
        pass

    def RestorePaintState(
      self,
      _state: VarParameter
    ) -> None: 
        """
        Restore and free the current paint state.

        Args:
            _state: paint state to be restored; the value (in/out) is passed as TObject in _state.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RestorePaintState_TObject
        """
        pass

    def RevertAll(
      self
    ) -> None: 
        """
        Revert all layers to a file-based original.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RevertAll_void
        """
        pass

    def RotatedExtent(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Compute extent (encompassing area of the extent) after the viewer rotation.

        Args:
            _extent: extent to be rotated

        Returns:
            Rotated extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RotatedExtent_TGIS_Extent
        """
        pass

    def RotatedPoint(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        Compute position of the point after the viewer rotation.

        Args:
            _ptg: point in to be rotated

        Returns:
            Rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RotatedPoint_TGIS_Point
        """
        pass

    def RotatedPoint3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Compute position of the 3D point after the viewer rotation.

        Args:
            _ptg: point to be rotated

        Returns:
            Rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RotatedPoint3D_TGIS_Point3D
        """
        pass

    def RotatedPoint3D_ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Compute position of the 3D point after the viewer rotation.

        Args:
            _ptg: point to be rotated; the value (in/out) is passed as TGIS_Point3D in _ptg.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RotatedPoint3D_ref_TGIS_Point3D
        """
        pass

    def SaveAll(
      self
    ) -> None: 
        """
        Save all layers (parameters and data)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SaveAll_void
        """
        pass

    def SaveData(
      self
    ) -> None: 
        """
        Save all changes to the data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SaveData_void
        """
        pass

    @overload
    def SaveProject(
      self
    ) -> None: 
        """
        Save current project.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SaveProject_void
        """
        pass

    @overload
    def SaveProject(
      self,
      _relativepath: bool
    ) -> None: 
        """
        Save current project.

        Args:
            _relativepath: if True (default) then project will be saved using paths relative 
              to project file location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SaveProject_Boolean
        """
        pass

    @overload
    def SaveProjectAs(
      self,
      _path: str
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SaveProjectAs_String
        """
        pass

    @overload
    def SaveProjectAs(
      self,
      _path: str,
      _relativepath: bool
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension
            _relativepath: if True (default) then project will be saved using paths relative 
              to project file location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SaveProjectAs_String_Boolean
        """
        pass

    @overload
    def SaveProjectAsEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _configFile: existing project file
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SaveProjectAsEx_TGIS_ConfigAbstract_String
        """
        pass

    @overload
    def SaveProjectAsEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str,
      _relativepath: bool
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _configFile: existing project file
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension
            _relativepath: if True (default) then project will be saved using paths relative 
              to project file location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SaveProjectAsEx_TGIS_ConfigAbstract_String_Boolean
        """
        pass

    def ScreenToMap(
      self,
      _pt: TPoint
    ) -> TGIS_Point: 
        """
        Converts point coordinates from screen related to map related.

        Args:
            _pt: coordinate in screen units

        Returns:
            Screen coordinates converted to map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ScreenToMap_TPoint
        """
        pass

    def ScreenToMap3D(
      self,
      _pt: TPoint
    ) -> TGIS_Point3D: 
        """
        Converts point coordinates from screen related to map related.

        Args:
            _pt: coordinate in screen units

        Returns:
            Screen coordinates converted to map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ScreenToMap3D_TPoint
        """
        pass

    def ScreenToMapEx(
      self,
      _pt: TGIS_Point
    ) -> TGIS_Point: 
        """
        Converts point coordinates from screen related to map related, but source will be 
        in TGIS_Point.

        Args:
            _pt: coordinate in screen units

        Returns:
            screen coordinates converted to map coordinates

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ScreenToMapEx_TGIS_Point
        """
        pass

    def ScreenToMapRect(
      self,
      _rct: TRect
    ) -> TGIS_Extent: 
        """
        Converts rectangle coordinates from screen related to map related.

        Args:
            _rct: coordinate in screen units

        Returns:
            Calculated extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ScreenToMapRect_TRect
        """
        pass

    def ScrollDn(
      self
    ) -> None: 
        """
        Do scrolling down.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ScrollDn_void
        """
        pass

    def ScrollLeft(
      self
    ) -> None: 
        """
        Do scrolling left.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ScrollLeft_void
        """
        pass

    def ScrollPgDn(
      self
    ) -> None: 
        """
        Do scrolling page down.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ScrollPgDn_void
        """
        pass

    def ScrollPgLeft(
      self
    ) -> None: 
        """
        Do scrolling page left.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ScrollPgLeft_void
        """
        pass

    def ScrollPgRight(
      self
    ) -> None: 
        """
        Do scrolling page right.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ScrollPgRight_void
        """
        pass

    def ScrollPgUp(
      self
    ) -> None: 
        """
        Do scrolling page up.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ScrollPgUp_void
        """
        pass

    def ScrollRight(
      self
    ) -> None: 
        """
        Do scrolling right.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ScrollRight_void
        """
        pass

    def ScrollUp(
      self
    ) -> None: 
        """
        Do scrolling up.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ScrollUp_void
        """
        pass

    def SetCSByEPSG(
      self,
      _epsg: int
    ) -> None: 
        """
        Setup Coordinate System to a coordinate system provided by EPSG code.

        Args:
            _epsg: EPSG code

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SetCSByEPSG_Integer
        """
        pass

    def SetCSByWKT(
      self,
      _wkt: str
    ) -> None: 
        """
        Setup Coordinate System to a coordinate system provided by WKT string (GEOGCS or 
        PROJCS). If provided WKT string is empty then coordinate system will be turn off.

        Args:
            _wkt: WKT string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SetCSByWKT_String
        """
        pass

    def SetCSByWKTFile(
      self,
      _path: str
    ) -> None: 
        """
        Setup Coordinate System to a coordinate system provided by file which contains WKT 
        string (GEOGCS or PROJCS). If file does not exist or provided WKT string is empty 
        then coordinate system will be turned off.

        Args:
            _path: path with WKT string (for example shapefile .PRJ)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SetCSByWKTFile_String
        """
        pass

    def SetSize(
      self,
      _width: int,
      _height: int
    ) -> None: 
        """
        Set bitmap new size.

        Args:
            _width: bitmap width
            _height: bitmap height

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SetSize_Integer_Integer
        """
        pass

    def SetViewport(
      self,
      _x: VarParameter,
      _y: VarParameter
    ) -> None: 
        """
        Set viewport to a given position.

        Args:
            _x: x coordinate; the value (in/out) is passed as float in _x.Value property
            _y: y coordinate; the value (in/out) is passed as float in _y.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SetViewport_Double_Double
        """
        pass

    def StorePaintState(
      self
    ) -> TObject: 
        """
        Store the current paint state.

        Returns:
            Stored paint state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.StorePaintState_void
        """
        pass

    def Subscribe(
      self,
      _control: IGIS_Subscribe
    ) -> None: 
        """
        Add provided control to the notification subscription list.

        Args:
            _control: - control which should become a subscriber

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Subscribe_IGIS_Subscribe
        """
        pass

    def SynchronizePaint(
      self,
      _interrupt: bool
    ) -> bool: 
        """
        Wait for pending paint operation to be finalized.

        Args:
            _interrupt: interrupts any pending operation

        Returns:
            True if operation were synchronized; False if synchronization is not possible and 
            current operation should not continue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SynchronizePaint_Boolean
        """
        pass

    def TwipsToPixels(
      self,
      _size: int
    ) -> int: 
        """
        Convert the size from to device independent Twips (1/1440 inch) to device dependent 
        pixels. Used to make map device independent.

        Args:
            _size: size in twips; if negative then treated as pixels

        Returns:
            Size in twips.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.TwipsToPixels_Integer
        """
        pass

    def TwipsToPoints(
      self,
      _size: int
    ) -> int: 
        """
        Convert the size from to device independent Twips (1/1440 inch) to device points. 
        Used for advanced font sizing.

        Args:
            _size: size in twips; if negative then treated as pixels

        Returns:
            Size in points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.TwipsToPoints_Integer
        """
        pass

    @overload
    def Unlock(
      self
    ) -> None: 
        """
        Unlock viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Unlock_void
        """
        pass

    @overload
    def Unlock(
      self,
      _redraw: bool
    ) -> None: 
        """
        Unlock the viewer but do not redraw

        Args:
            _redraw: If true then map should be redraw upon unlock; if false then redraw should 
              be issued.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Unlock_Boolean
        """
        pass

    def UnrotatedExtent(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Compute original extent of the rotated extent.

        Args:
            _extent: rotated extent

        Returns:
            Original un-rotated extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.UnrotatedExtent_TGIS_Extent
        """
        pass

    def UnrotatedPoint(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        Compute original position of the rotated point.

        Args:
            _ptg: rotated point

        Returns:
            Original un-rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.UnrotatedPoint_TGIS_Point
        """
        pass

    def UnrotatedPoint3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Compute original position of the rotated 3D point.

        Args:
            _ptg: rotated point

        Returns:
            Original un-rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.UnrotatedPoint3D_TGIS_Point3D
        """
        pass

    def UnrotatedPoint3D_ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Compute original position of the rotated 3D point.

        Args:
            _ptg: rotated point; the value (in/out) is passed as TGIS_Point3D in _ptg.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.UnrotatedPoint3D_ref_TGIS_Point3D
        """
        pass

    def UnSubscribe(
      self,
      _control: IGIS_Subscribe
    ) -> None: 
        """
        Remove provided control from the notification subscription list.

        Args:
            _control: control which subscription should be canceled

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.UnSubscribe_IGIS_Subscribe
        """
        pass

    def WaitForBackgroundProcesses(
      self
    ) -> None: 
        """
        Wait for any pending background processes that must be finalized before app can continue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.WaitForBackgroundProcesses_void
        """
        pass

    def WaitForNotBusy(
      self,
      _sender: TObject,
      _proc: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Call _proc when viewer will fully end painting procees.

        Args:
            _sender: sender object
            _proc: procedure to be executed; the value is a callback to a method with parameters 
              defined by TGIS_WaitForNotBusyProc

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.WaitForNotBusy_TObject_TGIS_WaitForNotBusyProc
        """
        pass

    def WriteConfig(
      self
    ) -> None: 
        """
        Write all configuration data to the project or layer ini file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.WriteConfig_void
        """
        pass

    def ZoomIn(
      self
    ) -> None: 
        """
        Zoom in slightly.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ZoomIn_void
        """
        pass

    def ZoomOut(
      self
    ) -> None: 
        """
        Zoom out slightly.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ZoomOut_void
        """
        pass

    @property
    def AutoStyle(
      self
    ) -> bool: 
        """
        If True, layers added to the viewer will have a unique style applied; Default is 
        False.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.AutoStyle
        """
        pass

    @AutoStyle.setter
    def AutoStyle(
      self,
      _value: bool
    ) -> None: 
        """
        If True, layers added to the viewer will have a unique style applied; Default is 
        False.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.AutoStyle
        """
        pass

    @property
    def BigExtent(
      self
    ) -> TGIS_Extent: 
        """
        Map extent. Encompassing the collective extents of all layers and a border defined 
        by BigExtentMargin. Is depending on current scale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BigExtent
        """
        pass

    @property
    def BigExtentMargin(
      self
    ) -> int: 
        """
        Map extent margin.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BigExtentMargin
        """
        pass

    @BigExtentMargin.setter
    def BigExtentMargin(
      self,
      _value: int
    ) -> None: 
        """
        Map extent margin.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BigExtentMargin
        """
        pass

    @property
    def Bitmap(
      self
    ) -> TObject: 
        """
        Underlying bitmap as a native, platform dependent object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Bitmap
        """
        pass

    @property
    def BusyLevel(
      self
    ) -> int: 
        """
        Level of current busy state. If 1 then most significant busy is active; if 2 then 
        subsequent etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BusyLevel
        """
        pass

    @property
    def BusyText(
      self
    ) -> str: 
        """
        Text related to current busy state. Text could be set upon BusyPrepare() call. If 
        IsBusy is not true then text will be an empty string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BusyText
        """
        pass

    @property
    def Center(
      self
    ) -> TGIS_Point: 
        """
        Center the screen based on given point. Useful for "Center on Click". See property 
        CenterPtg.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Center
        """
        pass

    @Center.setter
    def Center(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Center the screen based on given point. Useful for "Center on Click". See property 
        CenterPtg.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Center
        """
        pass

    @property
    def CenterPtg(
      self
    ) -> TGIS_Point: 
        """
        Point on which Viewer will be centered during Zoom. Will not modify the Viewport. 
        Will set up the point without re centering the screen. See property Center.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.CenterPtg
        """
        pass

    @CenterPtg.setter
    def CenterPtg(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Point on which Viewer will be centered during Zoom. Will not modify the Viewport. 
        Will set up the point without re centering the screen. See property Center.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.CenterPtg
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Background color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Background color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Color
        """
        pass

    @property
    def Copyright(
      self
    ) -> str: 
        """
        Legal notice and product version.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Copyright
        """
        pass

    @property
    def CS(
      self
    ) -> TGIS_CSCoordinateSystem: 
        """
        Coordinate System assigned to the viewer. If set to nil the Coordinate System will 
        be turned off. Default is turned off.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.CS
        """
        pass

    @CS.setter
    def CS(
      self,
      _value: TGIS_CSCoordinateSystem
    ) -> None: 
        """
        Coordinate System assigned to the viewer. If set to nil the Coordinate System will 
        be turned off. Default is turned off.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.CS
        """
        pass

    @property
    def CustomData(
      self
    ) -> TGIS_StringList: 
        """
        List of custom, user-defined data. List is save/restored witch config/project files.
        
        List is in a form of "name=value".

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.CustomData
        """
        pass

    @property
    def CustomPPI(
      self
    ) -> int: 
        """
        Custom resolution in pixels-per-inch. If &lt;&gt; 0 then used instead of SystemPPI

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.CustomPPI
        """
        pass

    @CustomPPI.setter
    def CustomPPI(
      self,
      _value: int
    ) -> None: 
        """
        Custom resolution in pixels-per-inch. If &lt;&gt; 0 then used instead of SystemPPI

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.CustomPPI
        """
        pass

    @property
    def DrawBasemapOnly(
      self
    ) -> bool: 
        """
        If yes only base map will be drawn (without selection, labels and charts).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.DrawBasemapOnly
        """
        pass

    @DrawBasemapOnly.setter
    def DrawBasemapOnly(
      self,
      _value: bool
    ) -> None: 
        """
        If yes only base map will be drawn (without selection, labels and charts).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.DrawBasemapOnly
        """
        pass

    @property
    def Editor(
      self
    ) -> IGIS_Editor: 
        """
        Editor context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Editor
        """
        pass

    @Editor.setter
    def Editor(
      self,
      _value: IGIS_Editor
    ) -> None: 
        """
        Editor context.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Editor
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Extent: 
        """
        Map extent. Encompassing the collective extents of all layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Extent
        """
        pass

    @property
    def FileCopyrights(
      self
    ) -> str: 
        """
        List Copyrights

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.FileCopyrights
        """
        pass

    @property
    def FontScale(
      self
    ) -> int: 
        """
        Font magnifying factor in percents. To make fonts more readable without changing 
        PPI.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.FontScale
        """
        pass

    @FontScale.setter
    def FontScale(
      self,
      _value: int
    ) -> None: 
        """
        Font magnifying factor in percents. To make fonts more readable without changing 
        PPI.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.FontScale
        """
        pass

    @property
    def FullDrawExtent(
      self
    ) -> TGIS_Extent: 
        """
        Extent of full current/last drawing area including margin and w/o tiling.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.FullDrawExtent
        """
        pass

    @property
    def GIS_Bitmap(
      self
    ) -> TGIS_Bitmap: 
        """
        Underlying bitmap

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.GIS_Bitmap
        """
        pass

    @property
    def Height(
      self
    ) -> int: 
        """
        Underlying bitmap height.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Height
        """
        pass

    @property
    def Hierarchy(
      self
    ) -> IGIS_HierarchyManager: 
        """
        Hierarchy list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Hierarchy
        """
        pass

    @property
    def IncrementalPaint(
      self
    ) -> bool: 
        """
        Is partial drawing to screen done in incremental mode?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.IncrementalPaint
        """
        pass

    @IncrementalPaint.setter
    def IncrementalPaint(
      self,
      _value: bool
    ) -> None: 
        """
        Is partial drawing to screen done in incremental mode?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.IncrementalPaint
        """
        pass

    @property
    def InPaint(
      self
    ) -> bool: 
        """
        True if Viewer is busy in Paint procedure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.InPaint
        """
        pass

    @property
    def IsBusy(
      self
    ) -> bool: 
        """
        True if Viewer is busy.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.IsBusy
        """
        pass

    @property
    def IsEmpty(
      self
    ) -> bool: 
        """
        True if Viewer is empty (no layers).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.IsEmpty
        """
        pass

    @property
    def IsLocked(
      self
    ) -> bool: 
        """
        True if Viewer is in locked state Lock.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.IsLocked
        """
        pass

    @property
    def IsTopmost(
      self
    ) -> bool: 
        """
        True if Viewer has a topmost layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.IsTopmost
        """
        pass

    @property
    def Items(
      self
    ) -> TGIS_LayerAbstractList: 
        """
        All layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Items
        """
        pass

    @property
    def LabelsReg(
      self
    ) -> TGIS_LabelsAreaAbstract: 
        """
        Labels position allocator object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.LabelsReg
        """
        pass

    @property
    def Level(
      self
    ) -> float: 
        """
        Sets and gets zoom level for a viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Level
        """
        pass

    @Level.setter
    def Level(
      self,
      _value: float
    ) -> None: 
        """
        Sets and gets zoom level for a viewer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Level
        """
        pass

    @property
    def MasterViewer(
      self
    ) -> IGIS_Viewer: 
        """
        Master Viewer reference. To be used only by TiledPaint.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.MasterViewer
        """
        pass

    @MasterViewer.setter
    def MasterViewer(
      self,
      _value: IGIS_Viewer
    ) -> None: 
        """
        Master Viewer reference. To be used only by TiledPaint.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.MasterViewer
        """
        pass

    @property
    def MultiUserMode(
      self
    ) -> TGIS_MultiUser: 
        """
        Multiuser mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.MultiUserMode
        """
        pass

    @MultiUserMode.setter
    def MultiUserMode(
      self,
      _value: TGIS_MultiUser
    ) -> None: 
        """
        Multiuser mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.MultiUserMode
        """
        pass

    @property
    def OverlappedExtentMargin(
      self
    ) -> int: 
        """
        Overlapped extent margin (in pixels).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.OverlappedExtentMargin
        """
        pass

    @OverlappedExtentMargin.setter
    def OverlappedExtentMargin(
      self,
      _value: int
    ) -> None: 
        """
        Overlapped extent margin (in pixels).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.OverlappedExtentMargin
        """
        pass

    @property
    def PPI(
      self
    ) -> int: 
        """
        Rendering resolution in pixels-per-inch. Returns SystemPPI value or CustomPPI (if 
        &lt;&gt; 0) multiplied by ControlCanvasScale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.PPI
        """
        pass

    @property
    def ProjectFile(
      self
    ) -> TGIS_ConfigAbstract: 
        """
        Project file itself as opened in Open procedure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ProjectFile
        """
        pass

    @ProjectFile.setter
    def ProjectFile(
      self,
      _value: TGIS_ConfigAbstract
    ) -> None: 
        """
        Project file itself as opened in Open procedure.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ProjectFile
        """
        pass

    @property
    def ProjectName(
      self
    ) -> str: 
        """
        Project file name as opened in Open procedure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ProjectName
        """
        pass

    @property
    def Renderer(
      self
    ) -> TGIS_RendererAbstract: 
        """
        Currently operating renderer. By assigning a new a different rendering engine a rendering 
        will be switched to a new engine .

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Renderer
        """
        pass

    @Renderer.setter
    def Renderer(
      self,
      _value: TGIS_RendererAbstract
    ) -> None: 
        """
        Currently operating renderer. By assigning a new a different rendering engine a rendering 
        will be switched to a new engine .

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Renderer
        """
        pass

    @property
    def RestrictedDrag(
      self
    ) -> bool: 
        """
        If true, then you can not drag outside the map Extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RestrictedDrag
        """
        pass

    @RestrictedDrag.setter
    def RestrictedDrag(
      self,
      _value: bool
    ) -> None: 
        """
        If true, then you can not drag outside the map Extent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RestrictedDrag
        """
        pass

    @property
    def RestrictedExtent(
      self
    ) -> TGIS_Extent: 
        """
        Restricted Map extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RestrictedExtent
        """
        pass

    @RestrictedExtent.setter
    def RestrictedExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Restricted Map extent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RestrictedExtent
        """
        pass

    @property
    def RotationAngle(
      self
    ) -> float: 
        """
        Angle of viewer rotation in radians.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RotationAngle
        """
        pass

    @RotationAngle.setter
    def RotationAngle(
      self,
      _value: float
    ) -> None: 
        """
        Angle of viewer rotation in radians.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RotationAngle
        """
        pass

    @property
    def RotationPoint(
      self
    ) -> TGIS_Point: 
        """
        Point of viewer rotation in map units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RotationPoint
        """
        pass

    @RotationPoint.setter
    def RotationPoint(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Point of viewer rotation in map units.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.RotationPoint
        """
        pass

    @property
    def Scale(
      self
    ) -> float: 
        """
        Setting up and reading the scale factor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Scale
        """
        pass

    @Scale.setter
    def Scale(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the scale factor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Scale
        """
        pass

    @property
    def ScaleAsFloat(
      self
    ) -> float: 
        """
        Setting up and reading the scale factor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ScaleAsFloat
        """
        pass

    @ScaleAsFloat.setter
    def ScaleAsFloat(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the scale factor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ScaleAsFloat
        """
        pass

    @property
    def ScaleAsText(
      self
    ) -> str: 
        """
        Setting up and reading the scale factor as text in format ''1:10000''.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ScaleAsText
        """
        pass

    @ScaleAsText.setter
    def ScaleAsText(
      self,
      _value: str
    ) -> None: 
        """
        Setting up and reading the scale factor as text in format ''1:10000''.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ScaleAsText
        """
        pass

    @property
    def SelectionGisColor(
      self
    ) -> TGIS_Color: 
        """
        Color used for selecting object. See also SelectionTransparency.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SelectionGisColor
        """
        pass

    @SelectionGisColor.setter
    def SelectionGisColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Color used for selecting object. See also SelectionTransparency.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SelectionGisColor
        """
        pass

    @property
    def SelectionOutlineOnly(
      self
    ) -> bool: 
        """
        If true then polygons will be marked only with outline not a full fill.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SelectionOutlineOnly
        """
        pass

    @SelectionOutlineOnly.setter
    def SelectionOutlineOnly(
      self,
      _value: bool
    ) -> None: 
        """
        If true then polygons will be marked only with outline not a full fill.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SelectionOutlineOnly
        """
        pass

    @property
    def SelectionTransparency(
      self
    ) -> int: 
        """
        Transparency value for selection; if 100 SelectionGisColor will not be transparent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SelectionTransparency
        """
        pass

    @SelectionTransparency.setter
    def SelectionTransparency(
      self,
      _value: int
    ) -> None: 
        """
        Transparency value for selection; if 100 SelectionGisColor will not be transparent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SelectionTransparency
        """
        pass

    @property
    def SelectionWidth(
      self
    ) -> int: 
        """
        Outline width of selection area (&gt;0 in twips, &lt;0 in pixels).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SelectionWidth
        """
        pass

    @SelectionWidth.setter
    def SelectionWidth(
      self,
      _value: int
    ) -> None: 
        """
        Outline width of selection area (&gt;0 in twips, &lt;0 in pixels).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SelectionWidth
        """
        pass

    @property
    def SystemPPI(
      self
    ) -> int: 
        """
        System resolution in pixels-per-inch.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.SystemPPI
        """
        pass

    @property
    def TemporaryScaleInternal(
      self
    ) -> float: 
        """
        Used to force rendering in a different scale then actual.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.TemporaryScaleInternal
        """
        pass

    @TemporaryScaleInternal.setter
    def TemporaryScaleInternal(
      self,
      _value: float
    ) -> None: 
        """
        Used to force rendering in a different scale then actual.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.TemporaryScaleInternal
        """
        pass

    @property
    def TemporaryVisibleExtent(
      self
    ) -> TGIS_Extent: 
        """
        Used to force rendering labels while drawing with tiles.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.TemporaryVisibleExtent
        """
        pass

    @TemporaryVisibleExtent.setter
    def TemporaryVisibleExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Used to force rendering labels while drawing with tiles.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.TemporaryVisibleExtent
        """
        pass

    @property
    def TiledPaint(
      self
    ) -> bool: 
        """
        Is partial drawing to screen done in tiled mode?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.TiledPaint
        """
        pass

    @TiledPaint.setter
    def TiledPaint(
      self,
      _value: bool
    ) -> None: 
        """
        Is partial drawing to screen done in tiled mode?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.TiledPaint
        """
        pass

    @property
    def TilePicture(
      self
    ) -> TGIS_Bitmap: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.TilePicture
        """
        pass

    @TilePicture.setter
    def TilePicture(
      self,
      _value: TGIS_Bitmap
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.TilePicture
        """
        pass

    @property
    def TileRect(
      self
    ) -> TRect: 
        """
        Location of the bitmap over the entire rendered area (in pixels).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.TileRect
        """
        pass

    @TileRect.setter
    def TileRect(
      self,
      _value: TRect
    ) -> None: 
        """
        Location of the bitmap over the entire rendered area (in pixels).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.TileRect
        """
        pass

    @property
    def UponDestroy(
      self
    ) -> bool: 
        """
        True if viewer is upon destruction so some operations (like screen updates) should 
        not be performed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.UponDestroy
        """
        pass

    @property
    def UseRTree(
      self
    ) -> bool: 
        """
        True if RTree will be used by default upon creation of any layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.UseRTree
        """
        pass

    @UseRTree.setter
    def UseRTree(
      self,
      _value: bool
    ) -> None: 
        """
        True if RTree will be used by default upon creation of any layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.UseRTree
        """
        pass

    @property
    def ViewerParent(
      self
    ) -> IGIS_ViewerParent: 
        """
        Parent for the current IGIS_Viewer object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ViewerParent
        """
        pass

    @property
    def ViewerParentRoot(
      self
    ) -> IGIS_ViewerParent: 
        """
        Parent for the current IGIS_Viewer object. If object is reparented then root parent 
        object will be returned.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ViewerParentRoot
        """
        pass

    @property
    def Viewport(
      self
    ) -> TGIS_Point: 
        """
        Setting an upper left corner position of the components window within the map.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Viewport
        """
        pass

    @Viewport.setter
    def Viewport(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Setting an upper left corner position of the components window within the map.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Viewport
        """
        pass

    @property
    def VisibleExtent(
      self
    ) -> TGIS_Extent: 
        """
        Extent of the map that is visible in the window. On setting an optimal zoom will 
        be calculated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.VisibleExtent
        """
        pass

    @VisibleExtent.setter
    def VisibleExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Extent of the map that is visible in the window. On setting an optimal zoom will 
        be calculated.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.VisibleExtent
        """
        pass

    @property
    def Width(
      self
    ) -> int: 
        """
        Underlying bitmap width.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Width
        """
        pass

    @property
    def Zoom(
      self
    ) -> float: 
        """
        Setting up and reading the related zoom factor. If one map unit = one pixel, then 
        Zoom = 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Zoom
        """
        pass

    @Zoom.setter
    def Zoom(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the related zoom factor. If one map unit = one pixel, then 
        Zoom = 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.Zoom
        """
        pass

    @property
    def ZoomEx(
      self
    ) -> float: 
        """
        Setting up and reading the absolute zoom factor. If one map unit = one twips, then 
        Zoom = 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ZoomEx
        """
        pass

    @ZoomEx.setter
    def ZoomEx(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the absolute zoom factor. If one map unit = one twips, then 
        Zoom = 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ZoomEx
        """
        pass

    @property
    def AfterPaintEvent(
      self
    ) -> typing.Callable[[TObject, TObject], None]: 
        """
        AfterPaint event. Will be fired after any Paint operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.AfterPaintEvent
        """
        pass

    @AfterPaintEvent.setter
    def AfterPaintEvent(
      self,
      _value: typing.Callable[[TObject, TObject], None]
    ) -> None: 
        """
        AfterPaint event. Will be fired after any Paint operation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.AfterPaintEvent
        """
        pass

    @property
    def AfterPaintRendererEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]: 
        """
        AfterPaintRenderer event. Will be fired after any Paint operation. Uses renderer 
        object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.AfterPaintRendererEvent
        """
        pass

    @AfterPaintRendererEvent.setter
    def AfterPaintRendererEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]
    ) -> None: 
        """
        AfterPaintRenderer event. Will be fired after any Paint operation. Uses renderer 
        object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.AfterPaintRendererEvent
        """
        pass

    @property
    def AfterUpdateEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]: 
        """
        AfterUpdate event. Will be fired after Update operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.AfterUpdateEvent
        """
        pass

    @AfterUpdateEvent.setter
    def AfterUpdateEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]
    ) -> None: 
        """
        AfterUpdate event. Will be fired after Update operation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.AfterUpdateEvent
        """
        pass

    @property
    def BeforePaintEvent(
      self
    ) -> typing.Callable[[TObject, TObject], None]: 
        """
        BeforePaint event. Will be fired before any Paint operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BeforePaintEvent
        """
        pass

    @BeforePaintEvent.setter
    def BeforePaintEvent(
      self,
      _value: typing.Callable[[TObject, TObject], None]
    ) -> None: 
        """
        BeforePaint event. Will be fired before any Paint operation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BeforePaintEvent
        """
        pass

    @property
    def BeforePaintRendererEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]: 
        """
        BeforePaintRenderer event. Will be fired before any Paint operation. Uses renderer 
        object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BeforePaintRendererEvent
        """
        pass

    @BeforePaintRendererEvent.setter
    def BeforePaintRendererEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]
    ) -> None: 
        """
        BeforePaintRenderer event. Will be fired before any Paint operation. Uses renderer 
        object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BeforePaintRendererEvent
        """
        pass

    @property
    def BeforeUpdateEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]: 
        """
        BeforeUpdate event. Will be fired before Update operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BeforeUpdateEvent
        """
        pass

    @BeforeUpdateEvent.setter
    def BeforeUpdateEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]
    ) -> None: 
        """
        BeforeUpdate event. Will be fired before Update operation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BeforeUpdateEvent
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        Busy event. Will be fired regularly during long-drawn operations. If end value will 
        be zero, the meaning is: long-drawn with unknown end time. Close long-drawn operation 
        by calling with parameters (-1,-1).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        Busy event. Will be fired regularly during long-drawn operations. If end value will 
        be zero, the meaning is: long-drawn with unknown end time. Close long-drawn operation 
        by calling with parameters (-1,-1).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.BusyEvent
        """
        pass

    @property
    def ExtentChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        ExtentChange event. Will be fired on TGIS_Viewer.Extent change.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ExtentChangeEvent
        """
        pass

    @ExtentChangeEvent.setter
    def ExtentChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        ExtentChange event. Will be fired on TGIS_Viewer.Extent change.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ExtentChangeEvent
        """
        pass

    @property
    def PaintExtraEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]: 
        """
        PaintExtra event. Called after renderer.PaintExtra() method.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.PaintExtraEvent
        """
        pass

    @PaintExtraEvent.setter
    def PaintExtraEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]
    ) -> None: 
        """
        PaintExtra event. Called after renderer.PaintExtra() method.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.PaintExtraEvent
        """
        pass

    @property
    def VisibleExtentChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        VisibleExtentChange event. Will be fired before BeforePaint if TGIS_Viewer.VisibleExtent 
        was changed. Will not be fired if TGIS_Viewer.VisibleExtent was changed based on 
        changed Zoom - in such situation only ZoomChange will be fired.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.VisibleExtentChangeEvent
        """
        pass

    @VisibleExtentChangeEvent.setter
    def VisibleExtentChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        VisibleExtentChange event. Will be fired before BeforePaint if TGIS_Viewer.VisibleExtent 
        was changed. Will not be fired if TGIS_Viewer.VisibleExtent was changed based on 
        changed Zoom - in such situation only ZoomChange will be fired.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.VisibleExtentChangeEvent
        """
        pass

    @property
    def ZoomChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        ZoomChange event. Will be fired before OnBeforePaint if Viewer.Zoom was changed.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ZoomChangeEvent
        """
        pass

    @ZoomChangeEvent.setter
    def ZoomChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        ZoomChange event. Will be fired before OnBeforePaint if Viewer.Zoom was changed.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerBmp.ZoomChangeEvent
        """
        pass

class IGIS_PvlViewerWnd( IGIS_PvlControl ):
    """
    PVL viewer intraface

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlViewerWnd
    """

    @overload
    def __init__(
      self
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.IGIS_PvlViewerWnd.Create_void
        """
        pass

class TGIS_PvlViewerWnd( TGIS_PvlControl, IGIS_PvlViewerWnd, IGIS_Viewer, IGIS_ViewerWnd ):
    """
    PVL GIS Viewer control.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd
    """

    def Add(
      self,
      _layer: TGIS_LayerAbstract
    ) -> None: 
        """
        Add a layer to the Viewer.

        Args:
            _layer: layer to be added

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Add_TGIS_LayerAbstract
        """
        pass

    def AddHierarchy(
      self
    ) -> None: 
        """
        Read hierarchy and build groups with layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.AddHierarchy_void
        """
        pass

    def AttachLayer(
      self,
      _layer: TGIS_LayerAbstract
    ) -> IGIS_Viewer: 
        """
        Attach layer to the viewer by re-parenting.

        Args:
            _layer: layer to be attached

        Returns:
            Previous parent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.AttachLayer_TGIS_LayerAbstract
        """
        pass

    def BeginPaintInternal(
      self
    ) -> None: 
        """
        Notify viewer about entering of a paint mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BeginPaintInternal_void
        """
        pass

    def BusyPrepare(
      self,
      _sender: TObject,
      _text: str
    ) -> None: 
        """
        Prepare BusyEvent for long-term operation.

        Args:
            _sender: component which is causing long-term operations
            _text: text to appear in a BusyText property; predefined GIS_BUSY_NOEVENTS and GIS_BUSY_NOHOURGLASS 
              could be used to define "silent" busy state; in such state BusyEvent will not be 
              called and, in a case of GIS_BUSY_NOHOURGLASS, hourglass will not be displayed and 
              check for interrupt as well.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BusyPrepare_TObject_String
        """
        pass

    def BusyRelease(
      self,
      _sender: TObject
    ) -> None: 
        """
        Release Busy state.

        Args:
            _sender: component which is causing long-term operations

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BusyRelease_TObject
        """
        pass

    def BusyShake(
      self,
      _sender: TObject,
      _pos: int,
      _end: int,
      _abort: VarParameter
    ) -> None: 
        """
        Shake Busy state.

        Args:
            _sender: component which is causing long-term operations
            _pos: current progress
            _end: maximal progress value
            _abort: if set to True inside message handler then an abort request.; the value (in/out) 
              is passed as bool in _abort.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BusyShake_TObject_Int64_Int64_Boolean
        """
        pass

    def CenterViewport(
      self,
      _ptg: TGIS_Point
    ) -> None: 
        """
        Set viewport to the vale when _ptg will be visible on the center of the screen. Same 
        as property Center

        Args:
            _ptg: coordinates in map units

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.CenterViewport_TGIS_Point
        """
        pass

    def ChangeHash(
      self
    ) -> int: 
        """
        Change hash. Uses to verify if order of layers, params, etc. has been modified. Used 
        mainly by TGIS_ControlLegend.

        Returns:
            Calculated hash value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ChangeHash_void
        """
        pass

    def Close(
      self
    ) -> None: 
        """
        Close a project.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Close_void
        """
        pass

    def ControlSet3DMode(
      self,
      _mode: TGIS_Viewer3DMode
    ) -> None: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ControlSet3DMode_TGIS_Viewer3DMode
        """
        pass

    def Delete(
      self,
      _name: str
    ) -> None: 
        """
        Delete the layer identified by a name.

        Args:
            _name: name of layer to be deleted

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Delete_String
        """
        pass

    def Draw(
      self,
      _renderer: TObject,
      _mode: TGIS_DrawMode
    ) -> None: 
        """
        Draw all layers on a current renderer.

        Args:
            _renderer: renderer context
            _mode: drawing mode: which set of layers should be rendered

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Draw_TObject_TGIS_DrawMode
        """
        pass

    def EndPaintInternal(
      self
    ) -> None: 
        """
        Notify viewer about leaving of a paint mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.EndPaintInternal_void
        """
        pass

    def FullExtent(
      self
    ) -> None: 
        """
        Calculate the screen origin, zoom, and viewport to place the whole map in the window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.FullExtent_void
        """
        pass

    def FullExtentZoom(
      self
    ) -> float: 
        """
        Calculates a zoom which places the whole map inside the window

        Returns:
            Zoom value.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.FullExtentZoom_void
        """
        pass

    def Get(
      self,
      _name: str
    ) -> TGIS_LayerAbstract: 
        """
        Retrieve the layer identified by a name. Sublayer or compund layers can be found 
        by do notation like ''name.sublyer''

        Args:
            _name: name of layer to be found

        Returns:
            Found layer or nil if not found.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Get_String
        """
        pass

    def GetGrid(
      self,
      _extent: TGIS_Extent,
      _grid: TGIS_GridArray
    ) -> bool: 
        """
        Fills provided _grid array with values defined by _extent. If extent is not fully 
        covered by the gird layers then values outside the layers scope will be left untouched.

        Args:
            _extent: extent of the _grid
            _grid: allocated array (with/height ratio of the _grid should be the same as width/height 
              ration of the _extent)

        Returns:
            True if success.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.GetGrid_TGIS_Extent_TGIS_GridArray
        """
        pass

    def GetRenderContext(
      self
    ) -> TObject: 
        """
        Return current context object.

        Returns:
            Current renderer context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.GetRenderContext_void
        """
        pass

    def HourglassActive(
      self
    ) -> bool: 
        """
        Test is hourglass is active.

        Returns:
            True is Hourglass is visible and Interrupt can be called.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.HourglassActive_void
        """
        pass

    def HourglassPrepare(
      self
    ) -> None: 
        """
        Prepare Hourglass cursor for timely operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.HourglassPrepare_void
        """
        pass

    def HourglassRelease(
      self
    ) -> None: 
        """
        Release Hourglass.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.HourglassRelease_void
        """
        pass

    def HourglassRestart(
      self
    ) -> None: 
        """
        Restart hourglass timing used for progressive updates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.HourglassRestart_void
        """
        pass

    def HourglassShake(
      self
    ) -> bool: 
        """
        Shake Hourglass.

        Returns:
            If True then current operation should be interrupted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.HourglassShake_void
        """
        pass

    def Interrupt(
      self
    ) -> None: 
        """
        Will terminate timely operation as soon as possible.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Interrupt_void
        """
        pass

    def Interrupted(
      self
    ) -> bool: 
        """
        Test if any pending operation must be aborted.

        Returns:
            True is if any lengy;lu operation must be aborted.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Interrupted_void
        """
        pass

    def InvalidateBasemap(
      self
    ) -> None: 
        """
        Invalidate only basemap layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.InvalidateBasemap_void
        """
        pass

    def InvalidateEditor(
      self,
      _final: bool
    ) -> None: 
        """
        Invalidate editor. To mark viewer after editor change to redraw state.

        Args:
            _final: True if map must updated at the end of editing process; otherwise a normal 
              "shallow" screen refresh to be performed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.InvalidateEditor_Boolean
        """
        pass

    @overload
    def InvalidateExtent(
      self,
      _extent: TGIS_Extent
    ) -> None: 
        """
        Invalidate an extent for full map redraw

        Args:
            _extent: extent to redraw

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.InvalidateExtent_TGIS_Extent
        """
        pass

    @overload
    def InvalidateExtent(
      self,
      _extent: TGIS_Extent,
      _deep: bool
    ) -> None: 
        """
        Invalidate an extent.

        Args:
            _extent: extent to redraw
            _deep: True if whole map must marked for update; if False then only shallow repaint 
              will be issued (only topmost layers)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.InvalidateExtent_TGIS_Extent_Boolean
        """
        pass

    def InvalidateSelection(
      self
    ) -> None: 
        """
        Invalidate selection. To mark viewer after selection change to redraw state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.InvalidateSelection_void
        """
        pass

    def InvalidateTopmost(
      self
    ) -> None: 
        """
        Invalidate only topmost layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.InvalidateTopmost_void
        """
        pass

    def InvalidateWholeMap(
      self
    ) -> None: 
        """
        Invalidate whole map. All layers must be updated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.InvalidateWholeMap_void
        """
        pass

    @overload
    def Locate(
      self,
      _ptg: TGIS_Point,
      _prec: float
    ) -> TGIS_ShapeAbstract: 
        """
        Locate a shape that is near _ptg, but is closer than _prec distance.

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in map units

        Returns:
            Located shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Locate_TGIS_Point_Double
        """
        pass

    @overload
    def Locate(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _visible: bool
    ) -> TGIS_ShapeAbstract: 
        """
        Locate a shape that is near _ptg, but is closer than _prec distance.

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in map units
            _visible: if true the only visible shapes will be evaluated; shapes turned of by 
              query of hidden will be ignored

        Returns:
            Located shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Locate_TGIS_Point_Double_Boolean
        """
        pass

    @overload
    def Locate(
      self,
      _pt: TPoint,
      _prec: int
    ) -> TGIS_ShapeAbstract: 
        """
        Locate a shape that is near _pt, but is closer than _prec distance.

        Args:
            _pt: reference point /searching point/ in pixels
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in pixels

        Returns:
            Located shape or nil

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Locate_TPoint_Integer
        """
        pass

    def LocateEx(
      self,
      _ptg: TGIS_Point,
      _prec: float,
      _visible: bool
    ) -> TGIS_ShapeAbstractList: 
        """
        Locate shapes on layers that are near _ptg, but closer than _prec distance. Still 
        only the best one candidate is chosen from each layer.

        Args:
            _ptg: reference point /searching point/
            _prec: precision /not a longer distance than/; for points inside the polygon (if 
              _prec &gt;= 0) the distance will be multiply by 0.95 (to prefer points inside the 
              polygon) but will not be bigger then _prec; for point distance will be multiplied 
              by 0.9 to prefer points over lines and polygons; precision is express in map units
            _visible: if true the only visible shapes will be evaluated; shapes turned of by 
              query of hidden will be ignored

        Returns:
            Allocated list of shapes from all viewer layers

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.LocateEx_TGIS_Point_Double_Boolean
        """
        pass

    def Lock(
      self
    ) -> None: 
        """
        Lock viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Lock_void
        """
        pass

    def MapToScreen(
      self,
      _ptg: TGIS_Point
    ) -> TPoint: 
        """
        Converts point coordinates from map related to screen related.

        Args:
            _ptg: coordinate in map units

        Returns:
            Map coordinates converted to screen coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.MapToScreen_TGIS_Point
        """
        pass

    def MapToScreen3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TPoint: 
        """
        Converts 3D point coordinates from map related to screen related.

        Args:
            _ptg: coordinate in map units

        Returns:
            Map coordinates converted to screen coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.MapToScreen3D_TGIS_Point3D
        """
        pass

    def MapToScreenEx(
      self,
      _pt: TGIS_Point
    ) -> TGIS_Point: 
        """
        Converts point coordinates from map related to screen related, but result will be 
        in TGIS_Point.

        Args:
            _pt: coordinate in map units

        Returns:
            map coordinates converted to screen coordinates

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.MapToScreenEx_TGIS_Point
        """
        pass

    def MapToScreenRect(
      self,
      _rct: TGIS_Extent
    ) -> TRect: 
        """
        Converts rectangle coordinates from map related to screen related.

        Args:
            _rct: coordinate in map units

        Returns:
            Calculated screen rectangle.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.MapToScreenRect_TGIS_Extent
        """
        pass

    def MarkModified(
      self
    ) -> None: 
        """
        Mark viewer upon some modifications.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.MarkModified_void
        """
        pass

    def MoveViewport(
      self,
      _dx: VarParameter,
      _dy: VarParameter
    ) -> None: 
        """
        Move the screen origin of the map by delta values.

        Args:
            _dx: x delta in pixels; the value (in/out) is passed as int in _dx.Value property
            _dy: y delta in pixels; the value (in/out) is passed as int in _dy.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.MoveViewport_Integer_Integer
        """
        pass

    def MoveViewportEx(
      self,
      _dx: VarParameter,
      _dy: VarParameter
    ) -> None: 
        """
        Move the screen origin of the map by delta values.

        Args:
            _dx: x delta in map units; the value (in/out) is passed as float in _dx.Value property
            _dy: y delta in map units; the value (in/out) is passed as float in _dy.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.MoveViewportEx_Double_Double
        """
        pass

    def MustSave(
      self
    ) -> bool: 
        """
        Check if any layer or the project file was modified by editing.

        Returns:
            True if project should be saved.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.MustSave_void
        """
        pass

    def NotifySubscribers(
      self,
      _event: int,
      _context: TObject
    ) -> None: 
        """
        Send notification to subscribers.

        Args:
            _event: event identifying number
            _context: control context; what is expected depends on _event; it can be canvas, 
              control itself.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.NotifySubscribers_Integer_TObject
        """
        pass

    @overload
    def Open(
      self,
      _path: str
    ) -> None: 
        """
        Open project.

        Args:
            _path: project path (or layer)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Open_String
        """
        pass

    @overload
    def Open(
      self,
      _path: str,
      _strict: bool
    ) -> None: 
        """
        Open project.

        Args:
            _path: project path (or layer)
            _strict: if False then non existing layers will be ignored (only while opening project 
              files); default is True ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Open_String_Boolean
        """
        pass

    @overload
    def OpenEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str
    ) -> None: 
        """
        Open project file from the memory.

        Args:
            _configFile: project file
            _path: project path (or layer)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.OpenEx_TGIS_ConfigAbstract_String
        """
        pass

    @overload
    def OpenEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str,
      _strict: bool
    ) -> None: 
        """
        Open project file from the memory.

        Args:
            _configFile: project file
            _path: project path (or layer)
            _strict: if False then non existing layers will be ignored (only while opening project 
              files); default is True ;

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.OpenEx_TGIS_ConfigAbstract_String_Boolean
        """
        pass

    def PixelsToTwips(
      self,
      _size: int
    ) -> int: 
        """
        Convert size from device dependent pixels to device independent Twips (1/1440 inch). 
        Used to make map device independent.

        Args:
            _size: size in pixels; absolute value will be taken

        Returns:
            Size in twips.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.PixelsToTwips_Integer
        """
        pass

    @overload
    def Print(
      self
    ) -> None: 
        """
        Print the current viewer content using the default printer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Print_void
        """
        pass

    @overload
    def Print(
      self,
      _printer: IGIS_Printer
    ) -> None: 
        """
        Print the current viewer content using the given printer.

        Args:
            _printer: printer object

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Print_IGIS_Printer
        """
        pass

    @overload
    def PrintBmp(
      self,
      _bmp: VarParameter
    ) -> None: 
        """
        Print the current content on a bitmap. Print area will match the current VisibleExtent 
        of the control.

        Args:
            _bmp: bitmap on which the drawing will be performed; the value (in/out) is passed 
              as TGIS_Bitmap in _bmp.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.PrintBmp_TGIS_Bitmap
        """
        pass

    @overload
    def PrintBmp(
      self,
      _bmp: VarParameter,
      _full: bool
    ) -> None: 
        """
        Print the current content on a bitmap. Print area will match the current VisibleExtent 
        of the control.

        Args:
            _bmp: bitmap on which the drawing will be performed; the value (in/out) is passed 
              as TGIS_Bitmap in _bmp.Value property
            _full: if yes, all paint events are triggered

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.PrintBmp_TGIS_Bitmap_Boolean
        """
        pass

    def RaiseBusyEvent(
      self,
      _sender: TObject,
      _pos: int,
      _end: int,
      _abort: VarParameter
    ) -> None: 
        """
        Fire Busy event of a viewer.

        Args:
            _sender: component which is causing long-term operations
            _pos: current progress
            _end: maximal progress value
            _abort: if set to True inside message handler then an abort request.; the value (in/out) 
              is passed as bool in _abort.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RaiseBusyEvent_TObject_Int64_Int64_Boolean
        """
        pass

    def RaiseHelpEvent(
      self,
      _sender: TObject,
      _name: str
    ) -> None: 
        """
        Fire Busy event of a viewer.

        Args:
            _sender: component asking for help
            _name: help context

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RaiseHelpEvent_TObject_String
        """
        pass

    def ReadConfig(
      self
    ) -> None: 
        """
        Read all configuration data from project.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ReadConfig_void
        """
        pass

    def RecalcExtent(
      self
    ) -> None: 
        """
        Calculates a common extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RecalcExtent_void
        """
        pass

    def ReParent(
      self,
      _parent: IGIS_ViewerParent
    ) -> IGIS_ViewerParent: 
        """
        Set a new parent for the viewer.

        Args:
            _parent: new parent object

        Returns:
            Previous parent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ReParent_IGIS_ViewerParent
        """
        pass

    def Reposition(
      self
    ) -> None: 
        """
        Reposition the map within the component window.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Reposition_void
        """
        pass

    def RereadConfig(
      self
    ) -> None: 
        """
        Reread all configuration data from project and layer configuration files.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RereadConfig_void
        """
        pass

    def RestorePaintState(
      self,
      _state: VarParameter
    ) -> None: 
        """
        Restore and free the current paint state.

        Args:
            _state: paint state to be restored; the value (in/out) is passed as TObject in _state.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RestorePaintState_TObject
        """
        pass

    def RevertAll(
      self
    ) -> None: 
        """
        Revert all layers to a file-based original.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RevertAll_void
        """
        pass

    def RotatedExtent(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Compute extent (encompassing area of the extent) after the viewer rotation.

        Args:
            _extent: extent to be rotated

        Returns:
            Rotated extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RotatedExtent_TGIS_Extent
        """
        pass

    def RotatedPoint(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        Compute position of the point after the viewer rotation.

        Args:
            _ptg: point in to be rotated

        Returns:
            Rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RotatedPoint_TGIS_Point
        """
        pass

    def RotatedPoint3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Compute position of the 3D point after the viewer rotation.

        Args:
            _ptg: point to be rotated

        Returns:
            Rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RotatedPoint3D_TGIS_Point3D
        """
        pass

    def RotatedPoint3D_ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Compute position of the 3D point after the viewer rotation.

        Args:
            _ptg: point to be rotated; the value (in/out) is passed as TGIS_Point3D in _ptg.Value 
              property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RotatedPoint3D_ref_TGIS_Point3D
        """
        pass

    def SaveAll(
      self
    ) -> None: 
        """
        Save all layers (parameters and data)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SaveAll_void
        """
        pass

    def SaveData(
      self
    ) -> None: 
        """
        Save all changes to the data.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SaveData_void
        """
        pass

    @overload
    def SaveProject(
      self
    ) -> None: 
        """
        Save current project.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SaveProject_void
        """
        pass

    @overload
    def SaveProject(
      self,
      _relativepath: bool
    ) -> None: 
        """
        Save current project.

        Args:
            _relativepath: if True (default) then project will be saved using paths relative 
              to project file location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SaveProject_Boolean
        """
        pass

    @overload
    def SaveProjectAs(
      self,
      _path: str
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SaveProjectAs_String
        """
        pass

    @overload
    def SaveProjectAs(
      self,
      _path: str,
      _relativepath: bool
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension
            _relativepath: if True (default) then project will be saved using paths relative 
              to project file location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SaveProjectAs_String_Boolean
        """
        pass

    @overload
    def SaveProjectAsEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _configFile: existing project file
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SaveProjectAsEx_TGIS_ConfigAbstract_String
        """
        pass

    @overload
    def SaveProjectAsEx(
      self,
      _configFile: TGIS_ConfigAbstract,
      _path: str,
      _relativepath: bool
    ) -> None: 
        """
        Save current project under new name.

        Args:
            _configFile: existing project file
            _path: path to the new project file; should have ''.ttkproject'' (or obsolete ''.ttkgp'') 
              extension
            _relativepath: if True (default) then project will be saved using paths relative 
              to project file location

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SaveProjectAsEx_TGIS_ConfigAbstract_String_Boolean
        """
        pass

    def ScreenToMap(
      self,
      _pt: TPoint
    ) -> TGIS_Point: 
        """
        Converts point coordinates from screen related to map related.

        Args:
            _pt: coordinate in screen units

        Returns:
            Screen coordinates converted to map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ScreenToMap_TPoint
        """
        pass

    def ScreenToMap3D(
      self,
      _pt: TPoint
    ) -> TGIS_Point3D: 
        """
        Converts point coordinates from screen related to map related.

        Args:
            _pt: coordinate in screen units

        Returns:
            Screen coordinates converted to map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ScreenToMap3D_TPoint
        """
        pass

    def ScreenToMapEx(
      self,
      _pt: TGIS_Point
    ) -> TGIS_Point: 
        """
        Converts point coordinates from screen related to map related, but source will be 
        in TGIS_Point.

        Args:
            _pt: coordinate in screen units

        Returns:
            screen coordinates converted to map coordinates

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ScreenToMapEx_TGIS_Point
        """
        pass

    def ScreenToMapRect(
      self,
      _rct: TRect
    ) -> TGIS_Extent: 
        """
        Converts rectangle coordinates from screen related to map related.

        Args:
            _rct: coordinate in screen units

        Returns:
            Calculated extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ScreenToMapRect_TRect
        """
        pass

    def SetCSByEPSG(
      self,
      _epsg: int
    ) -> None: 
        """
        Setup Coordinate System to a coordinate system provided by EPSG code.

        Args:
            _epsg: EPSG code

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SetCSByEPSG_Integer
        """
        pass

    def SetCSByWKT(
      self,
      _wkt: str
    ) -> None: 
        """
        Setup Coordinate System to a coordinate system provided by WKT string (GEOGCS or 
        PROJCS). If provided WKT string is empty then coordinate system will be turn off.

        Args:
            _wkt: WKT string

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SetCSByWKT_String
        """
        pass

    def SetCSByWKTFile(
      self,
      _path: str
    ) -> None: 
        """
        Setup Coordinate System to a coordinate system provided by file which contains WKT 
        string (GEOGCS or PROJCS). If file does not exist or provided WKT string is empty 
        then coordinate system will be turned off.

        Args:
            _path: path with WKT string (for example shapefile .PRJ)

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SetCSByWKTFile_String
        """
        pass

    def SetViewport(
      self,
      _x: VarParameter,
      _y: VarParameter
    ) -> None: 
        """
        Set viewport to a given position.

        Args:
            _x: x coordinate; the value (in/out) is passed as float in _x.Value property
            _y: y coordinate; the value (in/out) is passed as float in _y.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SetViewport_Double_Double
        """
        pass

    def StorePaintState(
      self
    ) -> TObject: 
        """
        Store the current paint state.

        Returns:
            Stored paint state.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.StorePaintState_void
        """
        pass

    def Subscribe(
      self,
      _control: IGIS_Subscribe
    ) -> None: 
        """
        Add provided control to the notification subscription list.

        Args:
            _control: - control which should become a subscriber

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Subscribe_IGIS_Subscribe
        """
        pass

    def SynchronizePaint(
      self,
      _interrupt: bool
    ) -> bool: 
        """
        Wait for pending paint operation to be finalized.

        Args:
            _interrupt: interrupts any pending operation

        Returns:
            True if operation were synchronized; False if synchronization is not possible and 
            current operation should not continue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SynchronizePaint_Boolean
        """
        pass

    def TwipsToPixels(
      self,
      _size: int
    ) -> int: 
        """
        Convert the size from to device independent Twips (1/1440 inch) to device dependent 
        pixels. Used to make map device independent.

        Args:
            _size: size in twips; if negative then treated as pixels

        Returns:
            Size in twips.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.TwipsToPixels_Integer
        """
        pass

    def TwipsToPoints(
      self,
      _size: int
    ) -> int: 
        """
        Convert the size from to device independent Twips (1/1440 inch) to device points. 
        Used for advanced font sizing.

        Args:
            _size: size in twips; if negative then treated as pixels

        Returns:
            Size in points.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.TwipsToPoints_Integer
        """
        pass

    @overload
    def Unlock(
      self
    ) -> None: 
        """
        Unlock viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Unlock_void
        """
        pass

    @overload
    def Unlock(
      self,
      _redraw: bool
    ) -> None: 
        """
        Unlock the viewer but do not redraw

        Args:
            _redraw: If true then map should be redraw upon unlock; if false then redraw should 
              be issued.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Unlock_Boolean
        """
        pass

    def UnrotatedExtent(
      self,
      _extent: TGIS_Extent
    ) -> TGIS_Extent: 
        """
        Compute original extent of the rotated extent.

        Args:
            _extent: rotated extent

        Returns:
            Original un-rotated extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.UnrotatedExtent_TGIS_Extent
        """
        pass

    def UnrotatedPoint(
      self,
      _ptg: TGIS_Point
    ) -> TGIS_Point: 
        """
        Compute original position of the rotated point.

        Args:
            _ptg: rotated point

        Returns:
            Original un-rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.UnrotatedPoint_TGIS_Point
        """
        pass

    def UnrotatedPoint3D(
      self,
      _ptg: TGIS_Point3D
    ) -> TGIS_Point3D: 
        """
        Compute original position of the rotated 3D point.

        Args:
            _ptg: rotated point

        Returns:
            Original un-rotated map coordinates.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.UnrotatedPoint3D_TGIS_Point3D
        """
        pass

    def UnrotatedPoint3D_ref(
      self,
      _ptg: VarParameter
    ) -> None: 
        """
        Compute original position of the rotated 3D point.

        Args:
            _ptg: rotated point; the value (in/out) is passed as TGIS_Point3D in _ptg.Value property

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.UnrotatedPoint3D_ref_TGIS_Point3D
        """
        pass

    def UnSubscribe(
      self,
      _control: IGIS_Subscribe
    ) -> None: 
        """
        Remove provided control from the notification subscription list.

        Args:
            _control: control which subscription should be canceled

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.UnSubscribe_IGIS_Subscribe
        """
        pass

    def WaitForBackgroundProcesses(
      self
    ) -> None: 
        """
        Wait for any pending background processes that must be finalized before app can continue.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.WaitForBackgroundProcesses_void
        """
        pass

    def WriteConfig(
      self
    ) -> None: 
        """
        Write all configuration data to the project or layer ini file.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.WriteConfig_void
        """
        pass

    def ZoomBy(
      self,
      _zm: float,
      _x: int,
      _y: int
    ) -> None: 
        """
        Zoom the viewer.

        Args:
            _zm: zoom value
            _x: center point x coordinate
            _y: center point y coordinate

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ZoomBy_Double_Integer_Integer
        """
        pass

    @property
    def AutoStyle(
      self
    ) -> bool: 
        """
        If True, layers added to the viewer will have a unique style applied; Default is 
        False.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.AutoStyle
        """
        pass

    @AutoStyle.setter
    def AutoStyle(
      self,
      _value: bool
    ) -> None: 
        """
        If True, layers added to the viewer will have a unique style applied; Default is 
        False.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.AutoStyle
        """
        pass

    @property
    def BigExtent(
      self
    ) -> TGIS_Extent: 
        """
        Map extent. Encompassing the collective extents of all layers and a border defined 
        by BigExtentMargin. Is depending on current scale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BigExtent
        """
        pass

    @property
    def BigExtentMargin(
      self
    ) -> int: 
        """
        Map extent margin.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BigExtentMargin
        """
        pass

    @BigExtentMargin.setter
    def BigExtentMargin(
      self,
      _value: int
    ) -> None: 
        """
        Map extent margin.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BigExtentMargin
        """
        pass

    @property
    def BusyLevel(
      self
    ) -> int: 
        """
        Level of current busy state. If 1 then most significant busy is active; if 2 then 
        subsequent etc.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BusyLevel
        """
        pass

    @property
    def BusyText(
      self
    ) -> str: 
        """
        Text related to current busy state. Text could be set upon BusyPrepare() call. If 
        IsBusy is not true then text will be an empty string.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BusyText
        """
        pass

    @property
    def Center(
      self
    ) -> TGIS_Point: 
        """
        Center the screen based on given point. Useful for "Center on Click". See property 
        CenterPtg.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Center
        """
        pass

    @Center.setter
    def Center(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Center the screen based on given point. Useful for "Center on Click". See property 
        CenterPtg.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Center
        """
        pass

    @property
    def CenterPtg(
      self
    ) -> TGIS_Point: 
        """
        Point on which Viewer will be centered during Zoom. Will not modify the Viewport. 
        Will set up the point without re centering the screen. See property Center.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.CenterPtg
        """
        pass

    @CenterPtg.setter
    def CenterPtg(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Point on which Viewer will be centered during Zoom. Will not modify the Viewport. 
        Will set up the point without re centering the screen. See property Center.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.CenterPtg
        """
        pass

    @property
    def Color(
      self
    ) -> TGIS_Color: 
        """
        Background color.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Color
        """
        pass

    @Color.setter
    def Color(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Background color.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Color
        """
        pass

    @property
    def Copyright(
      self
    ) -> str: 
        """
        Legal notice and product version.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Copyright
        """
        pass

    @property
    def CS(
      self
    ) -> TGIS_CSCoordinateSystem: 
        """
        Coordinate System assigned to the viewer. If set to nil the Coordinate System will 
        be turned off. Default is turned off.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.CS
        """
        pass

    @CS.setter
    def CS(
      self,
      _value: TGIS_CSCoordinateSystem
    ) -> None: 
        """
        Coordinate System assigned to the viewer. If set to nil the Coordinate System will 
        be turned off. Default is turned off.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.CS
        """
        pass

    @property
    def CustomData(
      self
    ) -> TGIS_StringList: 
        """
        List of custom, user-defined data. List is save/restored witch config/project files.
        
        List is in a form of "name=value".

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.CustomData
        """
        pass

    @property
    def CustomPPI(
      self
    ) -> int: 
        """
        Custom resolution in pixels-per-inch. If &lt;&gt; 0 then used instead of SystemPPI

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.CustomPPI
        """
        pass

    @CustomPPI.setter
    def CustomPPI(
      self,
      _value: int
    ) -> None: 
        """
        Custom resolution in pixels-per-inch. If &lt;&gt; 0 then used instead of SystemPPI

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.CustomPPI
        """
        pass

    @property
    def Editor(
      self
    ) -> IGIS_Editor: 
        """
        Editor context.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Editor
        """
        pass

    @Editor.setter
    def Editor(
      self,
      _value: IGIS_Editor
    ) -> None: 
        """
        Editor context.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Editor
        """
        pass

    @property
    def Extent(
      self
    ) -> TGIS_Extent: 
        """
        Map extent. Encompassing the collective extents of all layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Extent
        """
        pass

    @property
    def FileCopyrights(
      self
    ) -> str: 
        """
        List Copyrights

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.FileCopyrights
        """
        pass

    @property
    def FontScale(
      self
    ) -> int: 
        """
        Font magnifying factor in percents. To make fonts more readable without changing 
        PPI.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.FontScale
        """
        pass

    @FontScale.setter
    def FontScale(
      self,
      _value: int
    ) -> None: 
        """
        Font magnifying factor in percents. To make fonts more readable without changing 
        PPI.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.FontScale
        """
        pass

    @property
    def FullDrawExtent(
      self
    ) -> TGIS_Extent: 
        """
        Extent of full current/last drawing area including margin and w/o tiling.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.FullDrawExtent
        """
        pass

    @property
    def Graticule(
      self
    ) -> TGIS_Graticule: 
        """
        Graticule object. Set Graticule.Enabled to turn on/off.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Graticule
        """
        pass

    @property
    def Hierarchy(
      self
    ) -> IGIS_HierarchyManager: 
        """
        Hierarchy list.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Hierarchy
        """
        pass

    @property
    def IncrementalPaint(
      self
    ) -> bool: 
        """
        Is partial drawing to screen done in incremental mode?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.IncrementalPaint
        """
        pass

    @IncrementalPaint.setter
    def IncrementalPaint(
      self,
      _value: bool
    ) -> None: 
        """
        Is partial drawing to screen done in incremental mode?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.IncrementalPaint
        """
        pass

    @property
    def InPaint(
      self
    ) -> bool: 
        """
        True if Viewer is busy in Paint procedure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.InPaint
        """
        pass

    @property
    def IsBusy(
      self
    ) -> bool: 
        """
        True if Viewer is busy.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.IsBusy
        """
        pass

    @property
    def IsEmpty(
      self
    ) -> bool: 
        """
        True if Viewer is empty (no layers).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.IsEmpty
        """
        pass

    @property
    def IsLocked(
      self
    ) -> bool: 
        """
        True if Viewer is in locked state Lock.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.IsLocked
        """
        pass

    @property
    def IsTopmost(
      self
    ) -> bool: 
        """
        True if Viewer has a topmost layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.IsTopmost
        """
        pass

    @property
    def Items(
      self
    ) -> TGIS_LayerAbstractList: 
        """
        All layers.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Items
        """
        pass

    @property
    def LabelsReg(
      self
    ) -> TGIS_LabelsAreaAbstract: 
        """
        Labels position allocator object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.LabelsReg
        """
        pass

    @property
    def Level(
      self
    ) -> float: 
        """
        Sets and gets zoom level for a viewer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Level
        """
        pass

    @Level.setter
    def Level(
      self,
      _value: float
    ) -> None: 
        """
        Sets and gets zoom level for a viewer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Level
        """
        pass

    @property
    def MasterViewer(
      self
    ) -> IGIS_Viewer: 
        """
        Master Viewer reference. To be used only by TiledPaint.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.MasterViewer
        """
        pass

    @MasterViewer.setter
    def MasterViewer(
      self,
      _value: IGIS_Viewer
    ) -> None: 
        """
        Master Viewer reference. To be used only by TiledPaint.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.MasterViewer
        """
        pass

    @property
    def Mode(
      self
    ) -> TGIS_ViewerMode: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Mode
        """
        pass

    @Mode.setter
    def Mode(
      self,
      _value: TGIS_ViewerMode
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Mode
        """
        pass

    @property
    def MultiUserMode(
      self
    ) -> TGIS_MultiUser: 
        """
        Multiuser mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.MultiUserMode
        """
        pass

    @MultiUserMode.setter
    def MultiUserMode(
      self,
      _value: TGIS_MultiUser
    ) -> None: 
        """
        Multiuser mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.MultiUserMode
        """
        pass

    @property
    def OverlappedExtentMargin(
      self
    ) -> int: 
        """
        Overlapped extent margin (in pixels).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.OverlappedExtentMargin
        """
        pass

    @OverlappedExtentMargin.setter
    def OverlappedExtentMargin(
      self,
      _value: int
    ) -> None: 
        """
        Overlapped extent margin (in pixels).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.OverlappedExtentMargin
        """
        pass

    @property
    def PPI(
      self
    ) -> int: 
        """
        Rendering resolution in pixels-per-inch. Returns SystemPPI value or CustomPPI (if 
        &lt;&gt; 0) multiplied by ControlCanvasScale.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.PPI
        """
        pass

    @property
    def ProjectFile(
      self
    ) -> TGIS_ConfigAbstract: 
        """
        Project file itself as opened in Open procedure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ProjectFile
        """
        pass

    @ProjectFile.setter
    def ProjectFile(
      self,
      _value: TGIS_ConfigAbstract
    ) -> None: 
        """
        Project file itself as opened in Open procedure.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ProjectFile
        """
        pass

    @property
    def ProjectName(
      self
    ) -> str: 
        """
        Project file name as opened in Open procedure.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ProjectName
        """
        pass

    @property
    def RestrictedDrag(
      self
    ) -> bool: 
        """
        If true, then you can not drag outside the map Extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RestrictedDrag
        """
        pass

    @RestrictedDrag.setter
    def RestrictedDrag(
      self,
      _value: bool
    ) -> None: 
        """
        If true, then you can not drag outside the map Extent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RestrictedDrag
        """
        pass

    @property
    def RestrictedExtent(
      self
    ) -> TGIS_Extent: 
        """
        Restricted Map extent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RestrictedExtent
        """
        pass

    @RestrictedExtent.setter
    def RestrictedExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Restricted Map extent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RestrictedExtent
        """
        pass

    @property
    def RotationAngle(
      self
    ) -> float: 
        """
        Angle of viewer rotation in radians.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RotationAngle
        """
        pass

    @RotationAngle.setter
    def RotationAngle(
      self,
      _value: float
    ) -> None: 
        """
        Angle of viewer rotation in radians.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RotationAngle
        """
        pass

    @property
    def RotationPoint(
      self
    ) -> TGIS_Point: 
        """
        Point of viewer rotation in map units.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RotationPoint
        """
        pass

    @RotationPoint.setter
    def RotationPoint(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Point of viewer rotation in map units.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.RotationPoint
        """
        pass

    @property
    def Scale(
      self
    ) -> float: 
        """
        Setting up and reading the scale factor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Scale
        """
        pass

    @Scale.setter
    def Scale(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the scale factor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Scale
        """
        pass

    @property
    def ScaleAsFloat(
      self
    ) -> float: 
        """
        Setting up and reading the scale factor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ScaleAsFloat
        """
        pass

    @ScaleAsFloat.setter
    def ScaleAsFloat(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the scale factor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ScaleAsFloat
        """
        pass

    @property
    def ScaleAsText(
      self
    ) -> str: 
        """
        Setting up and reading the scale factor as text in format ''1:10000''.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ScaleAsText
        """
        pass

    @ScaleAsText.setter
    def ScaleAsText(
      self,
      _value: str
    ) -> None: 
        """
        Setting up and reading the scale factor as text in format ''1:10000''.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ScaleAsText
        """
        pass

    @property
    def SelectionGisColor(
      self
    ) -> TGIS_Color: 
        """
        Color used for selecting object. See also SelectionTransparency.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SelectionGisColor
        """
        pass

    @SelectionGisColor.setter
    def SelectionGisColor(
      self,
      _value: TGIS_Color
    ) -> None: 
        """
        Color used for selecting object. See also SelectionTransparency.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SelectionGisColor
        """
        pass

    @property
    def SelectionOutlineOnly(
      self
    ) -> bool: 
        """
        If true then polygons will be marked only with outline not a full fill.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SelectionOutlineOnly
        """
        pass

    @SelectionOutlineOnly.setter
    def SelectionOutlineOnly(
      self,
      _value: bool
    ) -> None: 
        """
        If true then polygons will be marked only with outline not a full fill.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SelectionOutlineOnly
        """
        pass

    @property
    def SelectionTransparency(
      self
    ) -> int: 
        """
        Transparency value for selection; if 100 SelectionGisColor will not be transparent.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SelectionTransparency
        """
        pass

    @SelectionTransparency.setter
    def SelectionTransparency(
      self,
      _value: int
    ) -> None: 
        """
        Transparency value for selection; if 100 SelectionGisColor will not be transparent.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SelectionTransparency
        """
        pass

    @property
    def SelectionWidth(
      self
    ) -> int: 
        """
        Outline width of selection area (&gt;0 in twips, &lt;0 in pixels).

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SelectionWidth
        """
        pass

    @SelectionWidth.setter
    def SelectionWidth(
      self,
      _value: int
    ) -> None: 
        """
        Outline width of selection area (&gt;0 in twips, &lt;0 in pixels).

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SelectionWidth
        """
        pass

    @property
    def SystemPPI(
      self
    ) -> int: 
        """
        System resolution in pixels-per-inch.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.SystemPPI
        """
        pass

    @property
    def TemporaryScaleInternal(
      self
    ) -> float: 
        """
        Used to force rendering in a different scale then actual.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.TemporaryScaleInternal
        """
        pass

    @TemporaryScaleInternal.setter
    def TemporaryScaleInternal(
      self,
      _value: float
    ) -> None: 
        """
        Used to force rendering in a different scale then actual.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.TemporaryScaleInternal
        """
        pass

    @property
    def TemporaryVisibleExtent(
      self
    ) -> TGIS_Extent: 
        """
        Used to force rendering labels while drawing with tiles.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.TemporaryVisibleExtent
        """
        pass

    @TemporaryVisibleExtent.setter
    def TemporaryVisibleExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Used to force rendering labels while drawing with tiles.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.TemporaryVisibleExtent
        """
        pass

    @property
    def TiledPaint(
      self
    ) -> bool: 
        """
        Is partial drawing to screen done in tiled mode?

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.TiledPaint
        """
        pass

    @TiledPaint.setter
    def TiledPaint(
      self,
      _value: bool
    ) -> None: 
        """
        Is partial drawing to screen done in tiled mode?

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.TiledPaint
        """
        pass

    @property
    def UponDestroy(
      self
    ) -> bool: 
        """
        True if viewer is upon destruction so some operations (like screen updates) should 
        not be performed

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.UponDestroy
        """
        pass

    @property
    def UseRTree(
      self
    ) -> bool: 
        """
        True if RTree will be used by default upon creation of any layer.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.UseRTree
        """
        pass

    @UseRTree.setter
    def UseRTree(
      self,
      _value: bool
    ) -> None: 
        """
        True if RTree will be used by default upon creation of any layer.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.UseRTree
        """
        pass

    @property
    def View3D(
      self
    ) -> bool: 
        """
        3D state; If set to true them Viewer is in a 3D mode.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.View3D
        """
        pass

    @View3D.setter
    def View3D(
      self,
      _value: bool
    ) -> None: 
        """
        3D state; If set to true them Viewer is in a 3D mode.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.View3D
        """
        pass

    @property
    def Viewer3D(
      self
    ) -> IGIS_Viewer3D: 
        """
        3D Viewer object. Nil if 3D mode is off.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Viewer3D
        """
        pass

    @Viewer3D.setter
    def Viewer3D(
      self,
      _value: IGIS_Viewer3D
    ) -> None: 
        """
        3D Viewer object. Nil if 3D mode is off.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Viewer3D
        """
        pass

    @property
    def ViewerParent(
      self
    ) -> IGIS_ViewerParent: 
        """
        Parent for the current IGIS_Viewer object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ViewerParent
        """
        pass

    @property
    def ViewerParentRoot(
      self
    ) -> IGIS_ViewerParent: 
        """
        Parent for the current IGIS_Viewer object. If object is reparented then root parent 
        object will be returned.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ViewerParentRoot
        """
        pass

    @property
    def Viewport(
      self
    ) -> TGIS_Point: 
        """
        Setting an upper left corner position of the components window within the map.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Viewport
        """
        pass

    @Viewport.setter
    def Viewport(
      self,
      _value: TGIS_Point
    ) -> None: 
        """
        Setting an upper left corner position of the components window within the map.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Viewport
        """
        pass

    @property
    def VisibleExtent(
      self
    ) -> TGIS_Extent: 
        """
        Extent of the map that is visible in the window. On setting an optimal zoom will 
        be calculated.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.VisibleExtent
        """
        pass

    @VisibleExtent.setter
    def VisibleExtent(
      self,
      _value: TGIS_Extent
    ) -> None: 
        """
        Extent of the map that is visible in the window. On setting an optimal zoom will 
        be calculated.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.VisibleExtent
        """
        pass

    @property
    def Zoom(
      self
    ) -> float: 
        """
        Setting up and reading the related zoom factor. If one map unit = one pixel, then 
        Zoom = 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Zoom
        """
        pass

    @Zoom.setter
    def Zoom(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the related zoom factor. If one map unit = one pixel, then 
        Zoom = 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.Zoom
        """
        pass

    @property
    def ZoomEx(
      self
    ) -> float: 
        """
        Setting up and reading the absolute zoom factor. If one map unit = one twips, then 
        Zoom = 1.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ZoomEx
        """
        pass

    @ZoomEx.setter
    def ZoomEx(
      self,
      _value: float
    ) -> None: 
        """
        Setting up and reading the absolute zoom factor. If one map unit = one twips, then 
        Zoom = 1.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ZoomEx
        """
        pass

    @property
    def AfterPaintEvent(
      self
    ) -> typing.Callable[[TObject, TObject], None]: 
        """
        AfterPaint event. Will be fired after any Paint operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.AfterPaintEvent
        """
        pass

    @AfterPaintEvent.setter
    def AfterPaintEvent(
      self,
      _value: typing.Callable[[TObject, TObject], None]
    ) -> None: 
        """
        AfterPaint event. Will be fired after any Paint operation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.AfterPaintEvent
        """
        pass

    @property
    def AfterPaintRendererEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]: 
        """
        AfterPaintRenderer event. Will be fired after any Paint operation. Uses renderer 
        object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.AfterPaintRendererEvent
        """
        pass

    @AfterPaintRendererEvent.setter
    def AfterPaintRendererEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]
    ) -> None: 
        """
        AfterPaintRenderer event. Will be fired after any Paint operation. Uses renderer 
        object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.AfterPaintRendererEvent
        """
        pass

    @property
    def AfterUpdateEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]: 
        """
        AfterUpdate event. Will be fired after Update operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.AfterUpdateEvent
        """
        pass

    @AfterUpdateEvent.setter
    def AfterUpdateEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]
    ) -> None: 
        """
        AfterUpdate event. Will be fired after Update operation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.AfterUpdateEvent
        """
        pass

    @property
    def BeforePaintEvent(
      self
    ) -> typing.Callable[[TObject, TObject], None]: 
        """
        BeforePaint event. Will be fired before any Paint operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BeforePaintEvent
        """
        pass

    @BeforePaintEvent.setter
    def BeforePaintEvent(
      self,
      _value: typing.Callable[[TObject, TObject], None]
    ) -> None: 
        """
        BeforePaint event. Will be fired before any Paint operation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BeforePaintEvent
        """
        pass

    @property
    def BeforePaintRendererEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]: 
        """
        BeforePaintRenderer event. Will be fired before any Paint operation. Uses renderer 
        object.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BeforePaintRendererEvent
        """
        pass

    @BeforePaintRendererEvent.setter
    def BeforePaintRendererEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]
    ) -> None: 
        """
        BeforePaintRenderer event. Will be fired before any Paint operation. Uses renderer 
        object.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BeforePaintRendererEvent
        """
        pass

    @property
    def BeforeUpdateEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]: 
        """
        BeforeUpdate event. Will be fired before Update operation.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BeforeUpdateEvent
        """
        pass

    @BeforeUpdateEvent.setter
    def BeforeUpdateEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]
    ) -> None: 
        """
        BeforeUpdate event. Will be fired before Update operation.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BeforeUpdateEvent
        """
        pass

    @property
    def BusyEvent(
      self
    ) -> typing.Callable[[TObject, Integer, Integer, Boolean], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BusyEvent
        """
        pass

    @BusyEvent.setter
    def BusyEvent(
      self,
      _value: typing.Callable[[TObject, Integer, Integer, Boolean], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.BusyEvent
        """
        pass

    @property
    def EditorChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Will be fired after any change made by editor.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.EditorChangeEvent
        """
        pass

    @EditorChangeEvent.setter
    def EditorChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Will be fired after any change made by editor.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.EditorChangeEvent
        """
        pass

    @property
    def ExtentChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ExtentChangeEvent
        """
        pass

    @ExtentChangeEvent.setter
    def ExtentChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ExtentChangeEvent
        """
        pass

    @property
    def ModeChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        Will be fired on viewer mode change.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ModeChangeEvent
        """
        pass

    @ModeChangeEvent.setter
    def ModeChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        Will be fired on viewer mode change.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ModeChangeEvent
        """
        pass

    @property
    def PaintExtraEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]: 
        """
        PaintExtra event. Called after renderer.PaintExtra() method.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.PaintExtraEvent
        """
        pass

    @PaintExtraEvent.setter
    def PaintExtraEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_RendererAbstract, TGIS_DrawMode], None]
    ) -> None: 
        """
        PaintExtra event. Called after renderer.PaintExtra() method.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.PaintExtraEvent
        """
        pass

    @property
    def TapDoubleEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_PvlMouseButton, TGIS_PvlShiftState, Single, Single], None]: 
        """
        TapDouble event. Will be fired upon double press down/up.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.TapDoubleEvent
        """
        pass

    @TapDoubleEvent.setter
    def TapDoubleEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_PvlMouseButton, TGIS_PvlShiftState, Single, Single], None]
    ) -> None: 
        """
        TapDouble event. Will be fired upon double press down/up.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.TapDoubleEvent
        """
        pass

    @property
    def TapLongEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_PvlMouseButton, TGIS_PvlShiftState, Single, Single], None]: 
        """
        TapLong event. Will be fired upon longer press down.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.TapLongEvent
        """
        pass

    @TapLongEvent.setter
    def TapLongEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_PvlMouseButton, TGIS_PvlShiftState, Single, Single], None]
    ) -> None: 
        """
        TapLong event. Will be fired upon longer press down.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.TapLongEvent
        """
        pass

    @property
    def TapSimpleEvent(
      self
    ) -> typing.Callable[[TObject, TGIS_PvlMouseButton, TGIS_PvlShiftState, Single, Single], None]: 
        """
        TapSimple event. Will be fired upon press down/up.

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.TapSimpleEvent
        """
        pass

    @TapSimpleEvent.setter
    def TapSimpleEvent(
      self,
      _value: typing.Callable[[TObject, TGIS_PvlMouseButton, TGIS_PvlShiftState, Single, Single], None]
    ) -> None: 
        """
        TapSimple event. Will be fired upon press down/up.

        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.TapSimpleEvent
        """
        pass

    @property
    def VisibleExtentChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.VisibleExtentChangeEvent
        """
        pass

    @VisibleExtentChangeEvent.setter
    def VisibleExtentChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.VisibleExtentChangeEvent
        """
        pass

    @property
    def ZoomChangeEvent(
      self
    ) -> typing.Callable[[TObject], None]: 
        """
        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ZoomChangeEvent
        """
        pass

    @ZoomChangeEvent.setter
    def ZoomChangeEvent(
      self,
      _value: typing.Callable[[TObject], None]
    ) -> None: 
        """
        See doc <https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_PvlViewerWnd.ZoomChangeEvent
        """
        pass

class TGIS_ViewerBmp( TGIS_PvlViewerBmp ):
    """
    Class responsible for map presentation on bitmap. Mapper for TGIS_PvlViewerBmp.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerBmp
    """

class TGIS_ViewerWnd( TGIS_PvlViewerWnd ):
    """
    Main visual control responsible for map presentation on window. Mapper for TGIS_PvlViewerWnd.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ViewerWnd
    """

class TGIS_ControlLegend( TGIS_PvlControlLegend ):
    """
    Visual Legend component. Mapper for TGIS_PvlControlLegend.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlLegend
    """

class TGIS_ControlScale( TGIS_PvlControlScale ):
    """
    Visual control for displaying map scale. Mapper for TGIS_PvlControlScale.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlScale
    """

class TGIS_ControlNorthArrow( TGIS_PvlControlNorthArrow ):
    """
    Visual control for displaying map North Arrow. Mapper for TGIS_PvlControlNorthArrow.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlNorthArrow
    """

class TGIS_ControlPrintPreview( TGIS_PvlControlPrintPreview ):
    """
    Control for managing print preview. Mapper for TGIS_PvlControlPrintPreview.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlPrintPreview
    """

class TGIS_Control3D( TGIS_PvlControl3D ):
    """
    A component which allows easy control of the 3D view inside a TGIS_ViewerWnd component 
    instance. Mapper for TGIS_PvlControl3D.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_Control3D
    """

class TGIS_ControlAttributes( TGIS_PvlControlAttributes ):
    """
    Visual Shape attributes component. Mapper for TIGIS_PvlControlAttributes.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.TGIS_ControlAttributes
    """

class RunPvl:
    """
    Methods to make quick binding possible.

    See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.RunPvl
    """

    @overload
    def __init__(
      self,
      _form: TGIS_PvlForm,
      _callback: typing.Callable[[], bool]
    ) -> None: 
        """
        Create an instance.

        Args:
            _form: form which should keep applicaion loop
            _callback: callback function; the value is a callback to a method with parameters 
              defined by TBreakEvent

        See doc: https://docs.tatukgis.com/DK11/api:dk11:python:tatukgis_pdk.RunPvl.Create_TGIS_PvlForm_TBreakEvent
        """
        pass

